/*!
 * Stockfish.js (http://github.com/nmrugg/stockfish.js)
 * License: GPL
 */
/**
 * Copyright (C) 2004-2008 Tord Romstad (Glaurung author)
 * Copyright (C) 2008-2014 Marco Costalba, Joona Kiiski, Tord Romstad (Stockfish authors)
 * Copyright (C) Nathan Rugg (Stockfish.js)
 *
 * Stockfish is free, and distributed under the GNU General Public License
 * (GPL). Essentially, this means that you are free to do almost exactly
 * what you want with the program, including distributing it among your
 * friends, making it available for download from your web site, selling
 * it (either by itself or as part of some bigger software package), or
 * using it as the starting point for a software project of your own.
 *
 * The only real limitation is that whenever you distribute Stockfish in
 * some way, you must always include the full source code, or a pointer
 * to where the source code can be found. If you make any changes to the
 * source code, these changes must also be made available under the GPL.
 *
 * The source code for this emscripten port of stockfish can be found
 * at http://github.com/nmrugg/stockfish.js.
 */
var STOCKFISH = (function ()
{
function load_stockfish(console)
{
var Module;if(!Module)Module=(typeof Module!=="undefined"?Module:null)||{};var moduleOverrides={};for(var key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function";var ENVIRONMENT_IS_WEB=typeof window==="object";var ENVIRONMENT_IS_WORKER=typeof importScripts==="function";var ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER;if(ENVIRONMENT_IS_NODE){if(!Module["print"])Module["print"]=function print(x){process["stdout"].write(x+"\n")};if(!Module["printErr"])Module["printErr"]=function printErr(x){process["stderr"].write(x+"\n")};var nodeFS=require("fs");var nodePath=require("path");Module["read"]=function read(filename,binary){filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);if(!ret&&filename!=nodePath["resolve"](filename)){filename=path.join(__dirname,"..","src",filename);ret=nodeFS["readFileSync"](filename)}if(ret&&!binary)ret=ret.toString();return ret};Module["readBinary"]=function readBinary(filename){return Module["read"](filename,true)};Module["load"]=function load(f){globalEval(read(f))};if(!Module["thisProgram"]){if(process["argv"].length>1){Module["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{Module["thisProgram"]="unknown-program"}}Module["arguments"]=process["argv"].slice(2);if(typeof module!=="undefined"){module["exports"]=Module}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}))}else if(ENVIRONMENT_IS_SHELL){if(!Module["print"])Module["print"]=print;if(typeof printErr!="undefined")Module["printErr"]=printErr;if(typeof read!="undefined"){Module["read"]=read}else{Module["read"]=function read(){throw"no read() available (jsc?)"}}Module["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){Module["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){Module["arguments"]=arguments}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){Module["read"]=function read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof console!=="undefined"){if(!Module["print"])Module["print"]=function print(x){console.log(x)};if(!Module["printErr"])Module["printErr"]=function printErr(x){console.log(x)}}else{var TRY_USE_DUMP=false;if(!Module["print"])Module["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){Module["load"]=importScripts}if(typeof Module["setWindowTitle"]==="undefined"){Module["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){eval.call(null,x)}if(!Module["load"]&&Module["read"]){Module["load"]=function load(f){globalEval(Module["read"](f))}}if(!Module["print"]){Module["print"]=(function(){})}if(!Module["printErr"]){Module["printErr"]=Module["print"]}if(!Module["arguments"]){Module["arguments"]=[]}if(!Module["thisProgram"]){Module["thisProgram"]="./this.program"}Module.print=Module["print"];Module.printErr=Module["printErr"];Module["preRun"]=[];Module["postRun"]=[];for(var key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}var Runtime={setTempRet0:(function(value){tempRet0=value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){if(!args.splice)args=Array.prototype.slice.call(args);args.splice(0,0,ptr);return Module["dynCall_"+sig].apply(null,args)}else{return Module["dynCall_"+sig].call(null,ptr)}}),functionPointers:[],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 2*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-2)/2]=null}),getAsmConst:(function(code,numArgs){if(!Runtime.asmConstCache)Runtime.asmConstCache={};var func=Runtime.asmConstCache[code];if(func)return func;var args=[];for(var i=0;i<numArgs;i++){args.push(String.fromCharCode(36)+i)}var source=Pointer_stringify(code);if(source[0]==='"'){if(source.indexOf('"',1)===source.length-1){source=source.substr(1,source.length-2)}else{abort("invalid EM_ASM input |"+source+"|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)")}}try{var evalled=eval("(function(Module, FS) { return function("+args.join(",")+"){ "+source+" } })")(Module,typeof FS!=="undefined"?FS:null)}catch(e){Module.printErr("error in executing inline EM_ASM code: "+e+" on: \n\n"+source+"\n\nwith args |"+args+"| (make sure to use the right one out of EM_ASM, EM_ASM_ARGS, etc.)");throw e}return Runtime.asmConstCache[code]=evalled}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;Module.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,arguments)}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=DYNAMICTOP;DYNAMICTOP=DYNAMICTOP+size|0;DYNAMICTOP=DYNAMICTOP+15&-16;if(DYNAMICTOP>=TOTAL_MEMORY){var success=enlargeMemory();if(!success)return 0}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module["Runtime"]=Runtime;var __THREW__=0;var ABORT=false;var EXITSTATUS=0;var undef=0;var tempValue,tempInt,tempBigInt,tempInt2,tempBigInt2,tempPair,tempBigIntI,tempBigIntR,tempBigIntS,tempBigIntP,tempBigIntD,tempDouble,tempFloat;var tempI64,tempI64b;var tempRet0,tempRet1,tempRet2,tempRet3,tempRet4,tempRet5,tempRet6,tempRet7,tempRet8,tempRet9;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}var globalScope=this;function getCFunc(ident){var func=Module["_"+ident];if(!func){try{func=eval("_"+ident)}catch(e){}}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){ret=Runtime.stackAlloc((str.length<<2)+1);writeStringToMemory(str,ret)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0)Runtime.stackRestore(stack);return ret};var sourceRegex=/^function\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;function parseJSFunc(jsfunc){var parsed=jsfunc.toString().match(sourceRegex).slice(1);return{arguments:parsed[0],body:parsed[1],returnValue:parsed[2]}}var JSsource={};for(var fun in JSfuncs){if(JSfuncs.hasOwnProperty(fun)){JSsource[fun]=parseJSFunc(JSfuncs[fun])}}cwrap=function cwrap(ident,returnType,argTypes){argTypes=argTypes||[];var cfunc=getCFunc(ident);var numericArgs=argTypes.every((function(type){return type==="number"}));var numericRet=returnType!=="string";if(numericRet&&numericArgs){return cfunc}var argNames=argTypes.map((function(x,i){return"$"+i}));var funcstr="(function("+argNames.join(",")+") {";var nargs=argTypes.length;if(!numericArgs){funcstr+="var stack = "+JSsource["stackSave"].body+";";for(var i=0;i<nargs;i++){var arg=argNames[i],type=argTypes[i];if(type==="number")continue;var convertCode=JSsource[type+"ToC"];funcstr+="var "+convertCode.arguments+" = "+arg+";";funcstr+=convertCode.body+";";funcstr+=arg+"="+convertCode.returnValue+";"}}var cfuncname=parseJSFunc((function(){return cfunc})).returnValue;funcstr+="var ret = "+cfuncname+"("+argNames.join(",")+");";if(!numericRet){var strgfy=parseJSFunc((function(){return Pointer_stringify})).returnValue;funcstr+="ret = "+strgfy+"(ret);"}if(!numericArgs){funcstr+=JSsource["stackRestore"].body.replace("()","(stack)")+";"}funcstr+="return ret})";return eval(funcstr)}}))();Module["cwrap"]=cwrap;Module["ccall"]=ccall;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}Module["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;Module["ALLOC_NORMAL"]=ALLOC_NORMAL;Module["ALLOC_STACK"]=ALLOC_STACK;Module["ALLOC_STATIC"]=ALLOC_STATIC;Module["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;Module["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[_malloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}Module["allocate"]=allocate;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return Module["UTF8ToString"](ptr)}Module["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}Module["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}Module["stringToAscii"]=stringToAscii;function UTF8ArrayToString(u8Array,idx){var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}Module["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}Module["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}Module["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}Module["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}Module["lengthBytesUTF8"]=lengthBytesUTF8;function UTF16ToString(ptr){var i=0;var str="";while(1){var codeUnit=HEAP16[ptr+i*2>>1];if(codeUnit==0)return str;++i;str+=String.fromCharCode(codeUnit)}}Module["UTF16ToString"]=UTF16ToString;function stringToUTF16(str,outPtr,maxBytesToWrite){if(maxBytesToWrite===undefined){maxBytesToWrite=2147483647}if(maxBytesToWrite<2)return 0;maxBytesToWrite-=2;var startPtr=outPtr;var numCharsToWrite=maxBytesToWrite<str.length*2?maxBytesToWrite/2:str.length;for(var i=0;i<numCharsToWrite;++i){var codeUnit=str.charCodeAt(i);HEAP16[outPtr>>1]=codeUnit;outPtr+=2}HEAP16[outPtr>>1]=0;return outPtr-startPtr}Module["stringToUTF16"]=stringToUTF16;function lengthBytesUTF16(str){return str.length*2}Module["lengthBytesUTF16"]=lengthBytesUTF16;function UTF32ToString(ptr){var i=0;var str="";while(1){var utf32=HEAP32[ptr+i*4>>2];if(utf32==0)return str;++i;if(utf32>=65536){var ch=utf32-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}else{str+=String.fromCharCode(utf32)}}}Module["UTF32ToString"]=UTF32ToString;function stringToUTF32(str,outPtr,maxBytesToWrite){if(maxBytesToWrite===undefined){maxBytesToWrite=2147483647}if(maxBytesToWrite<4)return 0;var startPtr=outPtr;var endPtr=startPtr+maxBytesToWrite-4;for(var i=0;i<str.length;++i){var codeUnit=str.charCodeAt(i);if(codeUnit>=55296&&codeUnit<=57343){var trailSurrogate=str.charCodeAt(++i);codeUnit=65536+((codeUnit&1023)<<10)|trailSurrogate&1023}HEAP32[outPtr>>2]=codeUnit;outPtr+=4;if(outPtr+4>endPtr)break}HEAP32[outPtr>>2]=0;return outPtr-startPtr}Module["stringToUTF32"]=stringToUTF32;function lengthBytesUTF32(str){var len=0;for(var i=0;i<str.length;++i){var codeUnit=str.charCodeAt(i);if(codeUnit>=55296&&codeUnit<=57343)++i;len+=4}return len}Module["lengthBytesUTF32"]=lengthBytesUTF32;function demangle(func){var hasLibcxxabi=!!Module["___cxa_demangle"];if(hasLibcxxabi){try{var buf=_malloc(func.length);writeStringToMemory(func.substr(1),buf);var status=_malloc(4);var ret=Module["___cxa_demangle"](buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}}var i=3;var basicTypes={"v":"void","b":"bool","c":"char","s":"short","i":"int","l":"long","f":"float","d":"double","w":"wchar_t","a":"signed char","h":"unsigned char","t":"unsigned short","j":"unsigned int","m":"unsigned long","x":"long long","y":"unsigned long long","z":"..."};var subs=[];var first=true;function dump(x){if(x)Module.print(x);Module.print(func);var pre="";for(var a=0;a<i;a++)pre+=" ";Module.print(pre+"^")}function parseNested(){i++;if(func[i]==="K")i++;var parts=[];while(func[i]!=="E"){if(func[i]==="S"){i++;var next=func.indexOf("_",i);var num=func.substring(i,next)||0;parts.push(subs[num]||"?");i=next+1;continue}if(func[i]==="C"){parts.push(parts[parts.length-1]);i+=2;continue}var size=parseInt(func.substr(i));var pre=size.toString().length;if(!size||!pre){i--;break}var curr=func.substr(i+pre,size);parts.push(curr);subs.push(curr);i+=pre+size}i++;return parts}function parse(rawList,limit,allowVoid){limit=limit||Infinity;var ret="",list=[];function flushList(){return"("+list.join(", ")+")"}var name;if(func[i]==="N"){name=parseNested().join("::");limit--;if(limit===0)return rawList?[name]:name}else{if(func[i]==="K"||first&&func[i]==="L")i++;var size=parseInt(func.substr(i));if(size){var pre=size.toString().length;name=func.substr(i+pre,size);i+=pre+size}}first=false;if(func[i]==="I"){i++;var iList=parse(true);var iRet=parse(true,1,true);ret+=iRet[0]+" "+name+"<"+iList.join(", ")+">"}else{ret=name}paramLoop:while(i<func.length&&limit-->0){var c=func[i++];if(c in basicTypes){list.push(basicTypes[c])}else{switch(c){case"P":list.push(parse(true,1,true)[0]+"*");break;case"R":list.push(parse(true,1,true)[0]+"&");break;case"L":{i++;var end=func.indexOf("E",i);var size=end-i;list.push(func.substr(i,size));i+=size+2;break};case"A":{var size=parseInt(func.substr(i));i+=size.toString().length;if(func[i]!=="_")throw"?";i++;list.push(parse(true,1,true)[0]+" ["+size+"]");break};case"E":break paramLoop;default:ret+="?"+c;break paramLoop}}}if(!allowVoid&&list.length===1&&list[0]==="void")list=[];if(rawList){if(ret){list.push(ret+"?")}return list}else{return ret+flushList()}}var parsed=func;try{if(func=="Object._main"||func=="_main"){return"main()"}if(typeof func==="number")func=Pointer_stringify(func);if(func[0]!=="_")return func;if(func[1]!=="_")return func;if(func[2]!=="Z")return func;switch(func[3]){case"n":return"operator new()";case"d":return"operator delete()"}parsed=parse()}catch(e){parsed+="?"}if(parsed.indexOf("?")>=0&&!hasLibcxxabi){Runtime.warnOnce("warning: a problem occurred in builtin C++ name demangling; build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling")}return parsed}function demangleAll(text){return text.replace(/__Z[\w\d_]+/g,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){return demangleAll(jsStackTrace())}Module["stackTrace"]=stackTrace;var PAGE_SIZE=4096;function alignMemoryPage(x){if(x%4096>0){x+=4096-x%4096}return x}var HEAP;var HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;var STATIC_BASE=0,STATICTOP=0,staticSealed=false;var STACK_BASE=0,STACKTOP=0,STACK_MAX=0;var DYNAMIC_BASE=0,DYNAMICTOP=0;function enlargeMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value "+TOTAL_MEMORY+", (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.")}var TOTAL_STACK=Module["TOTAL_STACK"]||5242880;var TOTAL_MEMORY=Module["TOTAL_MEMORY"]||67108864;var totalMemory=64*1024;while(totalMemory<TOTAL_MEMORY||totalMemory<2*TOTAL_STACK){if(totalMemory<16*1024*1024){totalMemory*=2}else{totalMemory+=16*1024*1024}}if(totalMemory!==TOTAL_MEMORY){Module.printErr("increasing TOTAL_MEMORY to "+totalMemory+" to be compliant with the asm.js spec (and given that TOTAL_STACK="+TOTAL_STACK+")");TOTAL_MEMORY=totalMemory}assert(typeof Int32Array!=="undefined"&&typeof Float64Array!=="undefined"&&!!(new Int32Array(1))["subarray"]&&!!(new Int32Array(1))["set"],"JS engine does not provide full typed array support");var buffer=new ArrayBuffer(TOTAL_MEMORY);HEAP8=new Int8Array(buffer);HEAP16=new Int16Array(buffer);HEAP32=new Int32Array(buffer);HEAPU8=new Uint8Array(buffer);HEAPU16=new Uint16Array(buffer);HEAPU32=new Uint32Array(buffer);HEAPF32=new Float32Array(buffer);HEAPF64=new Float64Array(buffer);HEAP32[0]=255;assert(HEAPU8[0]===255&&HEAPU8[3]===0,"Typed arrays 2 must be run on a little-endian system");Module["HEAP"]=HEAP;Module["buffer"]=buffer;Module["HEAP8"]=HEAP8;Module["HEAP16"]=HEAP16;Module["HEAP32"]=HEAP32;Module["HEAPU8"]=HEAPU8;Module["HEAPU16"]=HEAPU16;Module["HEAPU32"]=HEAPU32;Module["HEAPF32"]=HEAPF32;Module["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Runtime.dynCall("v",func)}else{Runtime.dynCall("vi",func,[callback.arg])}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}Module["addOnPreRun"]=Module.addOnPreRun=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}Module["addOnInit"]=Module.addOnInit=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}Module["addOnPreMain"]=Module.addOnPreMain=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}Module["addOnExit"]=Module.addOnExit=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}Module["addOnPostRun"]=Module.addOnPostRun=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}Module["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){var array=intArrayFromString(string,dontAddNull);var i=0;while(i<array.length){var chr=array[i];HEAP8[buffer+i>>0]=chr;i=i+1}}Module["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){for(var i=0;i<array.length;i++){HEAP8[buffer++>>0]=array[i]}}Module["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;function unSign(value,bits,ignore){if(value>=0){return value}return bits<=32?2*Math.abs(1<<bits-1)+value:Math.pow(2,bits)+value}function reSign(value,bits,ignore){if(value<=0){return value}var half=bits<=32?Math.abs(1<<bits-1):Math.pow(2,bits-1);if(value>=half&&(bits<=32||value>half)){value=-2*half+value}return value}if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_min=Math.min;var Math_clz32=Math.clz32;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}Module["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["removeRunDependency"]=removeRunDependency;Module["preloadedImages"]={};Module["preloadedAudios"]={};var memoryInitializer=null;STATIC_BASE=8;STATICTOP=STATIC_BASE+1088496;__ATINIT__.push({func:(function(){__GLOBAL__sub_I_evaluate_cpp()})},{func:(function(){__GLOBAL__sub_I_misc_cpp()})},{func:(function(){__GLOBAL__sub_I_position_cpp()})},{func:(function(){__GLOBAL__sub_I_search_cpp()})},{func:(function(){__GLOBAL__sub_I_iostream_cpp()})});allocate([49,54,0,0,0,0,0,0,49,0,0,0,0,0,0,0,49,51,0,0,0,0,0,0,100,101,102,97,117,108,116,0,116,105,109,101,0,0,0,0,96,94,16,0,8,2,0,0,80,2,0,0,128,2,0,0,192,2,0,0,0,3,0,0,72,3,0,0,136,3,0,0,200,3,0,0,8,4,0,0,72,4,0,0,144,4,0,0,216,4,0,0,24,5,0,0,88,5,0,0,152,5,0,0,216,5,0,0,16,6,0,0,72,6,0,0,112,6,0,0,160,6,0,0,200,6,0,0,248,6,0,0,40,7,0,0,96,7,0,0,152,7,0,0,192,7,0,0,240,7,0,0,40,8,0,0,96,8,0,0,136,8,0,0,176,8,0,0,216,8,0,0,0,9,0,0,40,9,0,0,80,9,0,0,120,9,0,0,0,0,0,0,99,117,114,114,101,110,116,0,85,110,97,98,108,101,32,116,111,32,111,112,101,110,32,102,105,108,101,32,0,0,0,0,10,80,111,115,105,116,105,111,110,58,32,0,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,10,84,111,116,97,108,32,116,105,109,101,32,40,109,115,41,32,58,32,0,0,0,0,0,10,78,111,100,101,115,32,115,101,97,114,99,104,101,100,32,32,58,32,0,0,0,0,0,10,78,111,100,101,115,47,115,101,99,111,110,100,32,32,32,32,58,32,0,0,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,148,255,255,255,148,255,255,255,0,0,0,0,3,0,0,0,4,0,0,0,108,1,0,0,164,1,0,0,184,1,0,0,128,1,0,0,108,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,6,0,0,0,148,255,255,255,148,255,255,255,0,0,0,0,7,0,0,0,8,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,10,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,114,51,107,50,114,47,112,49,112,112,113,112,98,49,47,98,110,50,112,110,112,49,47,51,80,78,51,47,49,112,50,80,51,47,50,78,50,81,49,112,47,80,80,80,66,66,80,80,80,47,82,51,75,50,82,32,119,32,75,81,107,113,32,45,32,48,32,49,48,0,0,0,56,47,50,112,53,47,51,112,52,47,75,80,53,114,47,49,82,51,112,49,107,47,56,47,52,80,49,80,49,47,56,32,119,32,45,32,45,32,48,32,49,49,0,0,0,0,0,0,52,114,114,107,49,47,112,112,49,110,51,112,47,51,113,50,112,81,47,50,112,49,112,98,50,47,50,80,80,52,47,50,80,51,78,49,47,80,50,66,50,80,80,47,52,82,82,75,49,32,98,32,45,32,45,32,55,32,49,57,0,0,0,0,114,113,51,114,107,49,47,112,112,112,50,112,112,112,47,49,98,110,112,98,51,47,51,78,50,66,49,47,51,78,80,51,47,55,80,47,80,80,80,81,49,80,80,49,47,50,75,82,51,82,32,119,32,45,32,45,32,55,32,49,52,0,0,0,114,49,98,113,49,114,49,107,47,49,112,112,49,110,49,112,112,47,49,112,49,112,52,47,52,112,50,81,47,52,80,112,50,47,49,66,78,80,52,47,80,80,80,50,80,80,80,47,51,82,49,82,75,49,32,119,32,45,32,45,32,50,32,49,52,0,0,0,0,0,0,0,114,51,114,49,107,49,47,50,112,50,112,112,112,47,112,49,112,49,98,110,50,47,56,47,49,113,50,80,51,47,50,78,80,81,78,50,47,80,80,80,51,80,80,47,82,52,82,75,49,32,98,32,45,32,45,32,50,32,49,53,0,0,0,0,114,49,98,98,107,49,110,114,47,112,112,51,112,49,112,47,50,110,53,47,49,78,52,112,49,47,50,78,112,49,66,50,47,56,47,80,80,80,50,80,80,80,47,50,75,82,49,66,49,82,32,119,32,107,113,32,45,32,48,32,49,51,0,0,114,49,98,113,49,114,107,49,47,112,112,112,49,110,112,112,112,47,52,110,51,47,51,112,51,81,47,51,80,52,47,49,66,80,49,66,51,47,80,80,49,78,50,80,80,47,82,52,82,75,49,32,119,32,45,32,45,32,49,32,49,54,0,0,52,114,49,107,49,47,114,49,113,50,112,112,112,47,112,112,112,50,110,50,47,52,80,51,47,53,82,98,49,47,49,78,49,66,81,51,47,80,80,80,51,80,80,47,82,53,75,49,32,119,32,45,32,45,32,49,32,49,55,0,0,0,0,0,50,114,113,107,98,49,114,47,112,112,112,50,112,50,47,50,110,112,98,49,112,49,47,49,78,49,78,110,50,112,47,50,80,49,80,80,50,47,56,47,80,80,50,66,49,80,80,47,82,49,66,81,75,50,82,32,98,32,75,81,32,45,32,48,32,49,49,0,0,0,0,0,114,49,98,113,49,114,49,107,47,98,49,112,49,110,112,112,49,47,112,50,112,51,112,47,49,112,54,47,51,80,80,51,47,49,66,50,78,78,50,47,80,80,51,80,80,80,47,82,50,81,49,82,75,49,32,119,32,45,32,45,32,49,32,49,54,0,0,0,0,0,0,0,51,114,49,114,107,49,47,112,53,112,112,47,98,112,112,49,112,112,50,47,56,47,113,49,80,80,49,80,50,47,98,51,80,51,47,80,50,78,81,82,80,80,47,49,82,50,66,49,75,49,32,98,32,45,32,45,32,54,32,50,50,0,0,0,114,49,113,50,114,107,49,47,50,112,49,98,112,112,112,47,50,80,112,52,47,112,54,98,47,81,49,80,78,112,51,47,52,66,51,47,80,80,49,82,49,80,80,80,47,50,75,52,82,32,119,32,45,32,45,32,50,32,49,56,0,0,0,0,52,107,50,114,47,49,112,98,50,112,112,112,47,49,112,50,112,51,47,49,82,49,112,52,47,51,80,52,47,50,114,49,80,78,50,47,80,52,80,80,80,47,49,82,52,75,49,32,98,32,45,32,45,32,51,32,50,50,0,0,0,0,0,0,51,113,50,107,49,47,112,98,51,112,49,112,47,52,112,98,112,49,47,50,114,53,47,80,112,78,50,78,50,47,49,80,50,80,50,80,47,53,80,80,49,47,81,50,82,50,75,49,32,98,32,45,32,45,32,52,32,50,54,0,0,0,0,0,54,107,49,47,54,112,49,47,54,80,112,47,112,112,112,53,47,51,112,110,50,80,47,49,80,51,75,50,47,49,80,80,50,80,50,47,51,78,52,32,98,32,45,32,45,32,48,32,49,0,0,0,0,0,0,0,51,98,52,47,53,107,112,49,47,49,112,49,112,49,112,49,112,47,112,80,49,80,112,80,49,80,47,80,49,80,49,80,51,47,51,75,78,51,47,56,47,56,32,119,32,45,32,45,32,48,32,49,0,0,0,0,50,75,53,47,112,55,47,55,80,47,53,112,82,49,47,56,47,53,107,50,47,114,55,47,56,32,119,32,45,32,45,32,48,32,49,0,0,0,0,0,56,47,54,112,107,47,49,112,54,47,56,47,80,80,51,112,49,112,47,53,80,50,47,52,75,80,49,113,47,51,81,52,32,119,32,45,32,45,32,48,32,49,0,0,0,0,0,0,55,107,47,51,112,50,112,112,47,52,113,51,47,56,47,52,81,51,47,53,75,112,49,47,80,54,98,47,56,32,119,32,45,32,45,32,48,32,49,0,56,47,50,112,53,47,56,47,50,107,80,75,112,49,112,47,50,112,52,80,47,50,80,53,47,51,80,52,47,56,32,119,32,45,32,45,32,48,32,49,0,0,0,0,0,0,0,0,56,47,49,112,51,112,112,49,47,55,112,47,53,80,49,80,47,50,107,51,80,49,47,56,47,50,75,50,80,50,47,56,32,119,32,45,32,45,32,48,32,49,0,0,0,0,0,0,56,47,112,112,50,114,49,107,49,47,50,112,49,112,51,47,51,112,80,50,112,47,49,80,49,80,49,80,49,80,47,80,53,75,82,47,56,47,56,32,119,32,45,32,45,32,48,32,49,0,0,0,0,0,0,0,56,47,51,112,52,47,112,49,98,107,51,112,47,80,112,54,47,49,75,112,49,80,112,80,112,47,50,80,50,80,49,80,47,50,80,53,47,53,66,50,32,98,32,45,32,45,32,48,32,49,0,0,0,0,0,0,53,107,50,47,55,82,47,52,80,50,112,47,53,75,50,47,112,49,114,50,80,49,112,47,56,47,56,47,56,32,98,32,45,32,45,32,48,32,49,0,54,107,49,47,54,112,49,47,80,54,112,47,114,49,78,53,47,53,112,50,47,55,80,47,49,98,51,80,80,49,47,52,82,49,75,49,32,119,32,45,32,45,32,48,32,49,0,0,49,114,51,107,50,47,52,113,51,47,50,80,112,51,98,47,51,66,112,51,47,50,81,50,112,50,47,49,112,49,80,50,80,49,47,49,80,50,75,80,50,47,51,78,52,32,119,32,45,32,45,32,48,32,49,0,54,107,49,47,52,112,112,49,112,47,51,112,50,112,49,47,80,49,112,80,98,51,47,82,55,47,49,114,50,80,49,80,80,47,51,66,49,80,50,47,54,75,49,32,119,32,45,32,45,32,48,32,49,0,0,0,56,47,51,112,51,66,47,53,112,50,47,53,80,50,47,112,55,47,80,80,53,98,47,107,55,47,54,75,49,32,119,32,45,32,45,32,48,32,49,0,56,47,56,47,56,47,56,47,53,107,112,49,47,80,55,47,56,47,49,75,49,78,52,32,119,32,45,32,45,32,48,32,49,0,0,0,0,0,0,0,56,47,56,47,56,47,53,78,50,47,56,47,112,55,47,56,47,50,78,75,51,107,32,119,32,45,32,45,32,48,32,49,0,0,0,0,0,0,0,0,56,47,51,107,52,47,56,47,56,47,56,47,52,66,51,47,52,75,66,50,47,50,66,53,32,119,32,45,32,45,32,48,32,49,0,0,0,0,0,0,56,47,56,47,49,80,54,47,53,112,114,49,47,56,47,52,82,51,47,55,107,47,50,75,53,32,119,32,45,32,45,32,48,32,49,0,0,0,0,0,56,47,50,112,52,80,47,56,47,107,114,54,47,54,82,49,47,56,47,56,47,49,75,54,32,119,32,45,32,45,32,48,32,49,0,0,0,0,0,0,56,47,56,47,51,80,51,107,47,56,47,49,112,54,47,56,47,49,80,54,47,49,75,51,110,50,32,98,32,45,32,45,32,48,32,49,0,0,0,0,56,47,82,55,47,50,113,53,47,56,47,54,107,49,47,56,47,49,80,53,112,47,75,54,82,32,119,32,45,32,45,32,48,32,49,50,52,0,0,0,252,252,255,255,255,255,254,255,248,248,255,255,255,255,254,255,241,241,255,255,255,255,254,255,227,227,255,255,255,255,254,255,199,199,255,255,255,255,254,255,143,143,255,255,255,255,254,255,31,31,255,255,255,255,254,255,63,63,255,255,255,255,254,255,252,252,252,255,255,255,254,255,248,248,248,255,255,255,254,255,241,241,241,255,255,255,254,255,227,227,227,255,255,255,254,255,199,199,199,255,255,255,254,255,143,143,143,255,255,255,254,255,31,31,31,255,255,255,254,255,63,63,63,255,255,255,254,255,255,252,252,252,255,255,254,255,255,248,248,248,255,255,254,255,255,241,241,241,255,255,254,255,255,227,227,227,255,255,254,255,255,199,199,199,255,255,254,255,255,143,143,143,255,255,254,255,255,31,31,31,255,255,254,255,255,63,63,63,255,255,254,255,255,255,252,252,252,255,254,255,255,255,248,248,248,255,254,255,255,255,241,241,241,255,254,255,255,255,227,227,227,255,254,255,255,255,199,199,199,255,254,255,255,255,143,143,143,255,254,255,255,255,31,31,31,255,254,255,255,255,63,63,63,255,254,255,255,255,255,252,252,252,254,255,255,255,255,248,248,248,254,255,255,255,255,241,241,241,254,255,255,255,255,227,227,227,254,255,255,255,255,199,199,199,254,255,255,255,255,143,143,143,254,255,255,255,255,31,31,31,254,255,255,255,255,63,63,63,254,255,255,255,255,255,252,252,252,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,240,255,255,255,255,255,227,227,226,255,255,255,255,255,199,199,198,255,255,255,255,255,143,143,142,255,255,255,255,255,31,31,30,255,255,255,255,255,63,63,62,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,241,240,240,255,255,255,255,255,227,226,227,255,255,255,255,255,199,198,199,255,255,255,255,255,143,142,143,255,255,255,255,255,31,30,31,255,255,255,255,255,63,62,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,240,240,255,255,255,255,255,255,226,227,255,255,255,255,255,255,198,199,255,255,255,255,255,255,142,143,255,255,255,255,255,255,30,31,255,255,255,255,255,255,62,63,252,252,255,255,255,255,254,255,248,248,255,255,255,255,254,255,241,241,255,255,255,255,254,255,227,227,255,255,255,255,254,255,199,199,255,255,255,255,254,255,143,143,255,255,255,255,254,255,31,31,255,255,255,255,254,255,63,63,255,255,255,255,254,255,252,252,252,255,255,255,254,255,248,248,248,255,255,255,254,255,241,241,241,255,255,255,254,255,227,227,227,255,255,255,254,255,199,199,199,255,255,255,254,255,143,143,143,255,255,255,254,255,31,31,31,255,255,255,254,255,63,63,63,255,255,255,254,255,255,252,252,252,255,255,254,255,255,248,248,248,255,255,254,255,255,241,241,241,255,255,254,255,255,227,227,227,255,255,254,255,255,199,199,199,255,255,254,255,255,143,143,143,255,255,254,255,255,31,31,31,255,255,254,255,255,63,63,63,255,255,254,255,255,255,252,252,252,255,254,255,255,255,248,248,248,255,254,255,255,255,241,241,241,255,254,255,255,255,227,227,227,255,254,255,255,255,199,199,199,255,254,255,255,255,143,143,143,255,254,255,255,255,31,31,31,255,254,255,255,255,63,63,63,255,254,255,255,255,255,252,252,252,254,255,255,255,255,248,248,248,254,255,255,255,255,241,241,241,254,255,255,255,255,227,227,227,254,255,255,255,255,199,199,199,254,255,255,255,255,143,143,143,254,255,255,255,255,31,31,31,254,255,255,255,255,63,63,63,254,255,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,1,0,6,255,255,255,255,227,227,226,254,255,255,255,255,199,199,198,255,255,255,255,255,143,143,142,255,255,255,255,255,31,31,30,255,255,255,255,255,63,63,62,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,255,255,255,255,255,227,226,226,255,255,255,255,255,199,198,199,255,255,255,255,255,143,142,143,255,255,255,255,255,31,30,31,255,255,255,255,255,63,62,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,255,255,255,255,255,255,226,226,255,255,255,255,255,255,198,199,255,255,255,255,255,255,142,143,255,255,255,255,255,255,30,31,255,255,255,255,255,255,62,63,252,252,255,255,255,255,253,255,248,248,255,255,255,255,253,255,241,241,255,255,255,255,253,255,227,227,255,255,255,255,253,255,199,199,255,255,255,255,253,255,143,143,255,255,255,255,253,255,31,31,255,255,255,255,253,255,63,63,255,255,255,255,253,255,252,252,252,255,255,255,253,255,248,248,248,255,255,255,253,255,241,241,241,255,255,255,253,255,227,227,227,255,255,255,253,255,199,199,199,255,255,255,253,255,143,143,143,255,255,255,253,255,31,31,31,255,255,255,253,255,63,63,63,255,255,255,253,255,255,252,252,252,255,255,253,255,255,248,248,248,255,255,253,255,255,241,241,241,255,255,253,255,255,227,227,227,255,255,253,255,255,199,199,199,255,255,253,255,255,143,143,143,255,255,253,255,255,31,31,31,255,255,253,255,255,63,63,63,255,255,253,255,255,255,252,252,252,255,253,255,255,255,248,248,248,255,253,255,255,255,241,241,241,255,253,255,255,255,227,227,227,255,253,255,255,255,199,199,199,255,253,255,255,255,143,143,143,255,253,255,255,255,31,31,31,255,253,255,255,255,63,63,63,255,253,255,255,255,255,252,252,252,253,255,255,255,255,248,248,248,253,255,255,255,255,241,241,241,253,255,255,255,255,227,227,227,253,255,255,255,255,199,199,199,253,255,255,255,255,143,143,143,253,255,255,255,255,31,31,31,253,255,255,255,255,63,63,63,253,255,255,255,255,255,252,252,252,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,225,255,255,255,255,255,199,199,197,255,255,255,255,255,143,143,141,255,255,255,255,255,31,31,29,255,255,255,255,255,63,63,61,255,0,0,0,0,0,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,255,255,255,255,255,227,225,227,255,255,255,255,255,199,197,199,255,255,255,255,255,143,141,143,255,255,255,255,255,31,29,31,255,255,255,255,255,63,61,63,0,0,0,0,0,0,0,0,0,0,0,0,15,10,8,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,225,227,255,255,255,255,255,255,197,199,255,255,255,255,255,255,141,143,255,255,255,255,255,255,29,31,255,255,255,255,255,255,61,63,252,252,255,255,255,255,253,255,248,248,255,255,255,255,253,255,241,241,255,255,255,255,253,255,227,227,255,255,255,255,253,255,199,199,255,255,255,255,253,255,143,143,255,255,255,255,253,255,31,31,255,255,255,255,253,255,63,63,255,255,255,255,253,255,252,252,252,255,255,255,253,255,248,248,248,255,255,255,253,255,241,241,241,255,255,255,253,255,227,227,227,255,255,255,253,255,199,199,199,255,255,255,253,255,143,143,143,255,255,255,253,255,31,31,31,255,255,255,253,255,63,63,63,255,255,255,253,255,255,252,252,252,255,255,253,255,255,248,248,248,255,255,253,255,255,241,241,241,255,255,253,255,255,227,227,227,255,255,253,255,255,199,199,199,255,255,253,255,255,143,143,143,255,255,253,255,255,31,31,31,255,255,253,255,255,63,63,63,255,255,253,255,255,255,252,252,252,255,253,255,255,255,248,248,248,255,253,255,255,255,241,241,241,255,253,255,255,255,227,227,227,255,253,255,255,255,199,199,199,255,253,255,255,255,143,143,143,255,253,255,255,255,31,31,31,255,253,255,255,255,63,63,63,255,253,255,255,255,255,252,252,252,253,255,255,255,255,248,248,248,253,255,255,255,255,241,241,241,253,255,255,255,255,227,227,227,253,255,255,255,255,199,199,199,253,255,255,255,255,143,143,143,253,255,255,255,255,31,31,31,253,255,255,255,255,63,63,63,253,255,0,0,0,0,0,4,4,7,0,0,0,0,0,0,0,7,0,0,0,0,0,1,1,7,0,0,0,0,0,3,1,15,255,255,255,255,199,199,197,255,255,255,255,255,143,143,141,255,255,255,255,255,31,31,29,255,255,255,255,255,63,63,61,255,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,3,1,3,255,255,255,255,255,199,197,199,255,255,255,255,255,143,141,143,255,255,255,255,255,31,29,31,255,255,255,255,255,63,61,63,0,0,0,0,0,2,4,4,0,0,0,0,0,5,0,0,0,0,0,0,0,2,1,1,0,0,0,0,0,15,1,3,255,255,255,255,255,255,197,199,255,255,255,255,255,255,141,143,255,255,255,255,255,255,29,31,255,255,255,255,255,255,61,63,252,252,255,255,255,255,251,255,248,248,255,255,255,255,251,255,241,241,255,255,255,255,251,255,227,227,255,255,255,255,251,255,199,199,255,255,255,255,251,255,143,143,255,255,255,255,251,255,31,31,255,255,255,255,251,255,63,63,255,255,255,255,251,255,252,252,252,255,255,255,251,255,248,248,248,255,255,255,251,255,241,241,241,255,255,255,251,255,227,227,227,255,255,255,251,255,199,199,199,255,255,255,251,255,143,143,143,255,255,255,251,255,31,31,31,255,255,255,251,255,63,63,63,255,255,255,251,255,255,252,252,252,255,255,251,255,255,248,248,248,255,255,251,255,255,241,241,241,255,255,251,255,255,227,227,227,255,255,251,255,255,199,199,199,255,255,251,255,255,143,143,143,255,255,251,255,255,31,31,31,255,255,251,255,255,63,63,63,255,255,251,255,255,255,252,252,252,255,251,255,255,255,248,248,248,255,251,255,255,255,241,241,241,255,251,255,255,255,227,227,227,255,251,255,255,255,199,199,199,255,251,255,255,255,143,143,143,255,251,255,255,255,31,31,31,255,251,255,255,255,63,63,63,255,251,255,255,255,255,252,252,252,251,255,255,255,255,248,248,248,251,255,255,255,255,241,241,241,251,255,255,255,255,227,227,227,251,255,255,255,255,199,199,199,251,255,255,255,255,143,143,143,251,255,255,255,255,31,31,31,251,255,255,255,255,63,63,63,251,255,255,255,255,255,252,252,248,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,227,255,255,255,255,255,199,199,195,255,255,255,255,255,143,143,139,255,255,255,255,255,31,31,27,255,255,255,255,255,63,63,59,255,255,255,255,255,255,252,248,252,0,0,0,0,0,24,24,24,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,255,255,255,255,255,199,195,199,255,255,255,255,255,143,139,143,255,255,255,255,255,31,27,31,255,255,255,255,255,63,59,63,255,255,255,255,255,255,248,252,0,0,0,0,0,0,0,0,0,0,0,0,31,21,17,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,195,199,255,255,255,255,255,255,139,143,255,255,255,255,255,255,27,31,255,255,255,255,255,255,59,63,252,252,255,255,255,255,251,255,248,248,255,255,255,255,251,255,241,241,255,255,255,255,251,255,227,227,255,255,255,255,251,255,199,199,255,255,255,255,251,255,143,143,255,255,255,255,251,255,31,31,255,255,255,255,251,255,63,63,255,255,255,255,251,255,252,252,252,255,255,255,251,255,248,248,248,255,255,255,251,255,241,241,241,255,255,255,251,255,227,227,227,255,255,255,251,255,199,199,199,255,255,255,251,255,143,143,143,255,255,255,251,255,31,31,31,255,255,255,251,255,63,63,63,255,255,255,251,255,255,252,252,252,255,255,251,255,255,248,248,248,255,255,251,255,255,241,241,241,255,255,251,255,255,227,227,227,255,255,251,255,255,199,199,199,255,255,251,255,255,143,143,143,255,255,251,255,255,31,31,31,255,255,251,255,255,63,63,63,255,255,251,255,255,255,252,252,252,255,251,255,255,255,248,248,248,255,251,255,255,255,241,241,241,255,251,255,255,255,227,227,227,255,251,255,255,255,199,199,199,255,251,255,255,255,143,143,143,255,251,255,255,255,31,31,31,255,251,255,255,255,63,63,63,255,251,255,255,255,255,252,252,252,251,255,255,255,255,248,248,248,251,255,255,255,255,241,241,241,251,255,255,255,255,227,227,227,251,255,255,255,255,199,199,199,251,255,255,255,255,143,143,143,251,255,255,255,255,31,31,31,251,255,255,255,255,63,63,63,251,255,0,0,0,0,0,28,24,31,0,0,0,0,0,8,8,14,0,0,0,0,0,0,0,14,0,0,0,0,0,2,2,14,0,0,0,0,0,7,3,31,255,255,255,255,143,143,139,255,255,255,255,255,31,31,27,255,255,255,255,255,63,63,59,255,0,0,0,0,0,28,24,28,0,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,3,7,255,255,255,255,255,143,139,143,255,255,255,255,255,31,27,31,255,255,255,255,255,63,59,63,0,0,0,0,0,28,24,28,0,0,0,0,0,4,8,8,0,0,0,0,0,10,0,0,0,0,0,0,0,4,2,2,0,0,0,0,0,31,3,7,255,255,255,255,255,255,139,143,255,255,255,255,255,255,27,31,255,255,255,255,255,255,59,63,252,252,255,255,255,255,247,255,248,248,255,255,255,255,247,255,241,241,255,255,255,255,247,255,227,227,255,255,255,255,247,255,199,199,255,255,255,255,247,255,143,143,255,255,255,255,247,255,31,31,255,255,255,255,247,255,63,63,255,255,255,255,247,255,252,252,252,255,255,255,247,255,248,248,248,255,255,255,247,255,241,241,241,255,255,255,247,255,227,227,227,255,255,255,247,255,199,199,199,255,255,255,247,255,143,143,143,255,255,255,247,255,31,31,31,255,255,255,247,255,63,63,63,255,255,255,247,255,255,252,252,252,255,255,247,255,255,248,248,248,255,255,247,255,255,241,241,241,255,255,247,255,255,227,227,227,255,255,247,255,255,199,199,199,255,255,247,255,255,143,143,143,255,255,247,255,255,31,31,31,255,255,247,255,255,63,63,63,255,255,247,255,255,255,252,252,252,255,247,255,255,255,248,248,248,255,247,255,255,255,241,241,241,255,247,255,255,255,227,227,227,255,247,255,255,255,199,199,199,255,247,255,255,255,143,143,143,255,247,255,255,255,31,31,31,255,247,255,255,255,63,63,63,255,247,255,255,255,255,252,252,252,247,255,255,255,255,248,248,248,247,255,255,255,255,241,241,241,247,255,255,255,255,227,227,227,247,255,255,255,255,199,199,199,247,255,255,255,255,143,143,143,247,255,255,255,255,31,31,31,247,255,255,255,255,63,63,63,247,255,255,255,255,255,252,252,244,255,255,255,255,255,248,248,240,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,227,255,255,255,255,255,199,199,199,255,255,255,255,255,143,143,135,255,255,255,255,255,31,31,23,255,255,255,255,255,63,63,55,255,255,255,255,255,255,252,244,252,255,255,255,255,255,248,240,248,0,0,0,0,0,48,48,48,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,255,255,255,255,255,143,135,143,255,255,255,255,255,31,23,31,255,255,255,255,255,63,55,63,255,255,255,255,255,255,244,252,255,255,255,255,255,255,240,248,0,0,0,0,0,0,0,0,0,0,0,0,62,42,34,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,135,143,255,255,255,255,255,255,23,31,255,255,255,255,255,255,55,63,252,252,255,255,255,255,247,255,248,248,255,255,255,255,247,255,241,241,255,255,255,255,247,255,227,227,255,255,255,255,247,255,199,199,255,255,255,255,247,255,143,143,255,255,255,255,247,255,31,31,255,255,255,255,247,255,63,63,255,255,255,255,247,255,252,252,252,255,255,255,247,255,248,248,248,255,255,255,247,255,241,241,241,255,255,255,247,255,227,227,227,255,255,255,247,255,199,199,199,255,255,255,247,255,143,143,143,255,255,255,247,255,31,31,31,255,255,255,247,255,63,63,63,255,255,255,247,255,255,252,252,252,255,255,247,255,255,248,248,248,255,255,247,255,255,241,241,241,255,255,247,255,255,227,227,227,255,255,247,255,255,199,199,199,255,255,247,255,255,143,143,143,255,255,247,255,255,31,31,31,255,255,247,255,255,63,63,63,255,255,247,255,255,255,252,252,252,255,247,255,255,255,248,248,248,255,247,255,255,255,241,241,241,255,247,255,255,255,227,227,227,255,247,255,255,255,199,199,199,255,247,255,255,255,143,143,143,255,247,255,255,255,31,31,31,255,247,255,255,255,63,63,63,255,247,255,255,255,255,252,252,252,247,255,255,255,255,248,248,248,247,255,255,255,255,241,241,241,247,255,255,255,255,227,227,227,247,255,255,255,255,199,199,199,247,255,255,255,255,143,143,143,247,255,255,255,255,31,31,31,247,255,255,255,255,63,63,63,247,255,255,255,255,255,252,252,244,255,0,0,0,0,0,56,48,62,0,0,0,0,0,16,16,28,0,0,0,0,0,0,0,28,0,0,0,0,0,4,4,28,0,0,0,0,0,14,6,62,255,255,255,255,31,31,23,255,255,255,255,255,63,63,55,255,255,255,255,255,255,252,244,252,0,0,0,0,0,56,48,56,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,14,6,14,255,255,255,255,255,31,23,31,255,255,255,255,255,63,55,63,255,255,255,255,255,255,244,252,0,0,0,0,0,62,48,56,0,0,0,0,0,8,16,16,0,0,0,0,0,20,0,0,0,0,0,0,0,8,4,4,0,0,0,0,0,62,6,14,255,255,255,255,255,255,23,31,255,255,255,255,255,255,55,63,252,252,255,255,255,254,255,255,248,248,255,255,255,254,255,255,241,241,255,255,255,254,255,255,227,227,255,255,255,254,255,255,199,199,255,255,255,254,255,255,143,143,255,255,255,254,255,255,31,31,255,255,255,254,255,255,63,63,255,255,255,254,255,255,252,252,252,255,255,254,255,255,248,248,248,255,255,254,255,255,241,241,241,255,255,254,255,255,227,227,227,255,255,254,255,255,199,199,199,255,255,254,255,255,143,143,143,255,255,254,255,255,31,31,31,255,255,254,255,255,63,63,63,255,255,254,255,255,255,252,252,252,255,254,255,255,255,248,248,248,255,254,255,255,255,241,241,241,255,254,255,255,255,227,227,227,255,254,255,255,255,199,199,199,255,254,255,255,255,143,143,143,255,254,255,255,255,31,31,31,255,254,255,255,255,63,63,63,255,254,255,255,255,255,252,252,252,254,255,255,255,255,248,248,248,254,255,255,255,255,241,241,241,254,255,255,255,255,227,227,227,254,255,255,255,255,199,199,199,254,255,255,255,255,143,143,143,254,255,255,255,255,31,31,31,254,255,255,255,255,63,63,63,254,255,255,255,255,255,252,252,252,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,240,255,255,255,255,255,227,227,226,255,255,255,255,255,199,199,198,255,255,255,255,255,143,143,142,255,255,255,255,255,31,31,30,255,255,255,255,255,63,63,62,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,1,7,255,255,255,255,227,226,227,255,255,255,255,255,199,198,199,255,255,255,255,255,143,142,143,255,255,255,255,255,31,30,31,255,255,255,255,255,63,62,63,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,226,227,227,255,255,255,255,255,198,199,199,255,255,255,255,255,142,143,143,255,255,255,255,255,30,31,31,255,255,255,255,255,62,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,255,255,255,255,255,254,227,227,255,255,255,255,255,254,199,199,255,255,255,255,255,254,143,143,255,255,255,255,255,254,31,31,255,255,255,255,255,254,63,63,252,252,255,255,255,254,255,255,248,248,255,255,255,254,255,255,241,241,255,255,255,254,255,255,227,227,255,255,255,254,255,255,199,199,255,255,255,254,255,255,143,143,255,255,255,254,255,255,31,31,255,255,255,254,255,255,63,63,255,255,255,254,255,255,252,252,252,255,255,254,255,255,248,248,248,255,255,254,255,255,241,241,241,255,255,254,255,255,227,227,227,255,255,254,255,255,199,199,199,255,255,254,255,255,143,143,143,255,255,254,255,255,31,31,31,255,255,254,255,255,63,63,63,255,255,254,255,255,255,252,252,252,255,254,255,255,255,248,248,248,255,254,255,255,255,241,241,241,255,254,255,255,255,227,227,227,255,254,255,255,255,199,199,199,255,254,255,255,255,143,143,143,255,254,255,255,255,31,31,31,255,254,255,255,255,63,63,63,255,254,255,255,255,255,252,252,252,254,255,255,255,255,248,248,248,254,255,255,255,255,241,241,241,254,255,255,255,255,227,227,227,254,255,255,255,255,199,199,199,254,255,255,255,255,143,143,143,254,255,255,255,255,31,31,31,254,255,255,255,255,63,63,63,254,255,255,0,0,0,0,0,0,3,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,7,2,0,0,0,0,2,2,15,7,255,255,255,199,199,198,255,255,255,255,255,143,143,142,255,255,255,255,255,31,31,30,255,255,255,255,255,63,63,62,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,2,6,255,255,255,255,199,198,199,255,255,255,255,255,143,142,143,255,255,255,255,255,31,30,31,255,255,255,255,255,63,62,63,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,255,255,255,255,255,198,199,199,255,255,255,255,255,142,143,143,255,255,255,255,255,30,31,31,255,255,255,255,255,62,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,2,2,255,255,255,255,255,254,199,199,255,255,255,255,255,254,143,143,255,255,255,255,255,254,31,31,255,255,255,255,255,254,63,63,252,252,255,255,255,253,255,255,248,248,255,255,255,253,255,255,241,241,255,255,255,253,255,255,227,227,255,255,255,253,255,255,199,199,255,255,255,253,255,255,143,143,255,255,255,253,255,255,31,31,255,255,255,253,255,255,63,63,255,255,255,253,255,255,252,252,252,255,255,253,255,255,248,248,248,255,255,253,255,255,241,241,241,255,255,253,255,255,227,227,227,255,255,253,255,255,199,199,199,255,255,253,255,255,143,143,143,255,255,253,255,255,31,31,31,255,255,253,255,255,63,63,63,255,255,253,255,255,255,252,252,252,255,253,255,255,255,248,248,248,255,253,255,255,255,241,241,241,255,253,255,255,255,227,227,227,255,253,255,255,255,199,199,199,255,253,255,255,255,143,143,143,255,253,255,255,255,31,31,31,255,253,255,255,255,63,63,63,255,253,255,255,255,255,252,252,252,253,255,255,255,255,248,248,248,253,255,255,255,255,241,241,241,253,255,255,255,255,227,227,227,253,255,255,255,255,199,199,199,253,255,255,255,255,143,143,143,253,255,255,255,255,31,31,31,253,255,255,255,255,63,63,63,253,255,255,255,255,255,252,252,252,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,225,255,255,255,255,255,199,199,197,255,255,255,255,255,143,143,141,255,255,255,255,255,31,31,29,255,255,255,255,255,63,63,61,255,255,0,0,0,0,12,12,12,15,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,7,0,0,0,7,3,1,3,15,255,255,255,255,199,197,199,255,255,255,255,255,143,141,143,255,255,255,255,255,31,29,31,255,255,255,255,255,63,61,63,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,31,1,3,3,255,255,255,255,255,197,199,199,255,255,255,255,255,141,143,143,255,255,255,255,255,29,31,31,255,255,255,255,255,61,63,63,0,0,0,0,15,8,12,4,0,0,0,0,0,5,0,0,0,0,0,0,15,9,1,1,0,0,0,31,31,29,3,3,255,255,255,255,255,253,199,199,255,255,255,255,255,253,143,143,255,255,255,255,255,253,31,31,255,255,255,255,255,253,63,63,252,252,255,255,255,253,255,255,248,248,255,255,255,253,255,255,241,241,255,255,255,253,255,255,227,227,255,255,255,253,255,255,199,199,255,255,255,253,255,255,143,143,255,255,255,253,255,255,31,31,255,255,255,253,255,255,63,63,255,255,255,253,255,255,252,252,252,255,255,253,255,255,248,248,248,255,255,253,255,255,241,241,241,255,255,253,255,255,227,227,227,255,255,253,255,255,199,199,199,255,255,253,255,255,143,143,143,255,255,253,255,255,31,31,31,255,255,253,255,255,63,63,63,255,255,253,255,255,255,252,252,252,255,253,255,255,255,248,248,248,255,253,255,255,255,241,241,241,255,253,255,255,255,227,227,227,255,253,255,255,255,199,199,199,255,253,255,255,255,143,143,143,255,253,255,255,255,31,31,31,255,253,255,255,255,63,63,63,255,253,255,255,255,255,252,252,252,253,255,255,255,255,248,248,248,253,255,255,255,255,241,241,241,253,255,255,255,255,227,227,227,253,255,255,255,255,199,199,199,253,255,255,255,255,143,143,143,253,255,255,255,255,31,31,31,253,255,255,255,255,63,63,63,253,255,255,0,0,0,0,4,4,7,0,0,0,0,0,0,0,7,0,0,0,0,0,1,1,7,0,0,0,0,0,3,1,15,7,0,0,0,7,7,5,31,15,255,255,255,143,143,141,255,255,255,255,255,31,31,29,255,255,255,255,255,63,63,61,255,255,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,3,1,3,7,0,0,0,7,7,5,7,15,255,255,255,255,143,141,143,255,255,255,255,255,31,29,31,255,255,255,255,255,63,61,63,255,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,15,1,3,3,0,0,0,7,31,5,7,7,255,255,255,255,255,141,143,143,255,255,255,255,255,29,31,31,255,255,255,255,255,61,63,63,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,1,1,0,0,0,0,15,9,3,3,0,0,0,31,31,29,7,7,255,255,255,255,255,253,143,143,255,255,255,255,255,253,31,31,255,255,255,255,255,253,63,63,252,252,255,255,255,251,255,255,248,248,255,255,255,251,255,255,241,241,255,255,255,251,255,255,227,227,255,255,255,251,255,255,199,199,255,255,255,251,255,255,143,143,255,255,255,251,255,255,31,31,255,255,255,251,255,255,63,63,255,255,255,251,255,255,252,252,252,255,255,251,255,255,248,248,248,255,255,251,255,255,241,241,241,255,255,251,255,255,227,227,227,255,255,251,255,255,199,199,199,255,255,251,255,255,143,143,143,255,255,251,255,255,31,31,31,255,255,251,255,255,63,63,63,255,255,251,255,255,255,252,252,252,255,251,255,255,255,248,248,248,255,251,255,255,255,241,241,241,255,251,255,255,255,227,227,227,255,251,255,255,255,199,199,199,255,251,255,255,255,143,143,143,255,251,255,255,255,31,31,31,255,251,255,255,255,63,63,63,255,251,255,255,255,255,252,252,252,251,255,255,255,255,248,248,248,251,255,255,255,255,241,241,241,251,255,255,255,255,227,227,227,251,255,255,255,255,199,199,199,251,255,255,255,255,143,143,143,251,255,255,255,255,31,31,31,251,255,255,255,255,63,63,63,251,255,255,255,255,255,252,252,248,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,227,255,255,255,255,255,199,199,195,255,255,255,255,255,143,143,139,255,255,255,255,255,31,31,27,255,255,255,255,255,63,63,59,255,255,0,0,0,62,60,56,60,63,0,0,0,0,24,24,24,30,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,15,0,0,0,15,7,3,7,31,255,255,255,255,143,139,143,255,255,255,255,255,31,27,31,255,255,255,255,255,63,59,63,255,0,0,0,63,63,56,60,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,63,63,3,7,7,255,255,255,255,255,139,143,143,255,255,255,255,255,27,31,31,255,255,255,255,255,59,63,63,0,0,0,63,63,59,60,60,0,0,0,0,31,25,24,24,0,0,0,0,0,10,0,0,0,0,0,0,31,19,3,3,0,0,0,63,63,59,7,7,255,255,255,255,255,251,143,143,255,255,255,255,255,251,31,31,255,255,255,255,255,251,63,63,252,252,255,255,255,251,255,255,248,248,255,255,255,251,255,255,241,241,255,255,255,251,255,255,227,227,255,255,255,251,255,255,199,199,255,255,255,251,255,255,143,143,255,255,255,251,255,255,31,31,255,255,255,251,255,255,63,63,255,255,255,251,255,255,252,252,252,255,255,251,255,255,248,248,248,255,255,251,255,255,241,241,241,255,255,251,255,255,227,227,227,255,255,251,255,255,199,199,199,255,255,251,255,255,143,143,143,255,255,251,255,255,31,31,31,255,255,251,255,255,63,63,63,255,255,251,255,255,255,252,252,252,255,251,255,255,255,248,248,248,255,251,255,255,255,241,241,241,255,251,255,255,255,227,227,227,255,251,255,255,255,199,199,199,255,251,255,255,255,143,143,143,255,251,255,255,255,31,31,31,255,251,255,255,255,63,63,63,255,251,255,255,255,255,252,252,252,251,255,255,255,255,248,248,248,251,255,255,255,255,241,241,241,251,255,255,255,255,227,227,227,251,255,255,255,255,199,199,199,251,255,255,255,255,143,143,143,251,255,255,255,255,31,31,31,251,255,255,255,255,63,63,63,251,255,255,0,0,0,0,28,24,31,30,0,0,0,0,8,8,14,0,0,0,0,0,0,0,14,0,0,0,0,0,2,2,14,0,0,0,0,0,7,3,31,15,0,0,0,15,15,11,63,31,255,255,255,31,31,27,255,255,255,255,255,63,63,59,255,255,0,0,0,0,28,24,28,30,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,3,7,15,0,0,0,15,15,11,15,31,255,255,255,255,31,27,31,255,255,255,255,255,63,59,63,255,0,0,0,0,31,24,28,28,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,31,3,7,7,0,0,0,15,63,11,15,15,255,255,255,255,255,27,31,31,255,255,255,255,255,59,63,63,0,0,0,0,31,25,28,28,0,0,0,0,0,10,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,10,2,2,0,0,0,0,31,19,7,7,0,0,0,63,63,59,15,15,255,255,255,255,255,251,31,31,255,255,255,255,255,251,63,63,252,252,255,255,255,247,255,255,248,248,255,255,255,247,255,255,241,241,255,255,255,247,255,255,227,227,255,255,255,247,255,255,199,199,255,255,255,247,255,255,143,143,255,255,255,247,255,255,31,31,255,255,255,247,255,255,63,63,255,255,255,247,255,255,252,252,252,255,255,247,255,255,248,248,248,255,255,247,255,255,241,241,241,255,255,247,255,255,227,227,227,255,255,247,255,255,199,199,199,255,255,247,255,255,143,143,143,255,255,247,255,255,31,31,31,255,255,247,255,255,63,63,63,255,255,247,255,255,255,252,252,252,255,247,255,255,255,248,248,248,255,247,255,255,255,241,241,241,255,247,255,255,255,227,227,227,255,247,255,255,255,199,199,199,255,247,255,255,255,143,143,143,255,247,255,255,255,31,31,31,255,247,255,255,255,63,63,63,255,247,255,255,255,255,252,252,252,247,255,255,255,255,248,248,248,247,255,255,255,255,241,241,241,247,255,255,255,255,227,227,227,247,255,255,255,255,199,199,199,247,255,255,255,255,143,143,143,247,255,255,255,255,31,31,31,247,255,255,255,255,63,63,63,247,255,255,255,255,255,252,252,244,255,255,255,255,255,248,248,240,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,227,255,255,255,255,255,199,199,199,255,255,255,255,255,143,143,135,255,255,255,255,255,31,31,23,255,255,255,255,255,63,63,55,255,255,255,255,255,255,252,244,252,255,0,0,0,124,120,112,120,126,0,0,0,0,48,48,48,60,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,30,0,0,0,31,15,7,15,63,255,255,255,255,31,23,31,255,255,255,255,255,63,55,63,255,255,255,255,255,255,244,252,252,0,0,0,127,127,112,120,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,7,15,15,255,255,255,255,255,23,31,31,255,255,255,255,255,55,63,63,255,255,255,255,255,247,252,252,0,0,0,127,127,119,120,120,0,0,0,0,62,50,48,48,0,0,0,0,0,20,0,0,0,0,0,0,62,38,6,6,0,0,0,127,127,119,15,15,255,255,255,255,255,247,31,31,255,255,255,255,255,247,63,63,252,252,255,255,255,247,255,255,248,248,255,255,255,247,255,255,241,241,255,255,255,247,255,255,227,227,255,255,255,247,255,255,199,199,255,255,255,247,255,255,143,143,255,255,255,247,255,255,31,31,255,255,255,247,255,255,63,63,255,255,255,247,255,255,252,252,252,255,255,247,255,255,248,248,248,255,255,247,255,255,241,241,241,255,255,247,255,255,227,227,227,255,255,247,255,255,199,199,199,255,255,247,255,255],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE);allocate([143,143,143,255,255,247,255,255,31,31,31,255,255,247,255,255,63,63,63,255,255,247,255,255,255,252,252,252,255,247,255,255,255,248,248,248,255,247,255,255,255,241,241,241,255,247,255,255,255,227,227,227,255,247,255,255,255,199,199,199,255,247,255,255,255,143,143,143,255,247,255,255,255,31,31,31,255,247,255,255,255,63,63,63,255,247,255,255,255,255,252,252,252,247,255,255,255,255,248,248,248,247,255,255,255,255,241,241,241,247,255,255,255,255,227,227,227,247,255,255,255,255,199,199,199,247,255,255,255,255,143,143,143,247,255,255,255,255,31,31,31,247,255,255,255,255,63,63,63,247,255,255,0,0,0,124,124,116,127,126,0,0,0,0,56,48,62,60,0,0,0,0,16,16,28,0,0,0,0,0,0,0,28,0,0,0,0,0,4,4,28,0,0,0,0,0,14,6,62,30,0,0,0,31,31,23,127,63,255,255,255,63,63,55,255,255,0,0,0,124,124,116,124,126,0,0,0,0,56,48,56,60,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,14,6,14,30,0,0,0,31,31,23,31,63,255,255,255,255,63,55,63,255,0,0,0,124,127,116,124,124,0,0,0,0,62,48,56,56,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,62,6,14,14,0,0,0,31,127,23,31,31,255,255,255,255,255,55,63,63,0,0,0,127,127,119,124,124,0,0,0,0,62,50,56,56,0,0,0,0,0,20,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,20,4,4,0,0,0,0,62,38,14,14,0,0,0,127,127,119,31,31,255,255,255,255,255,247,63,63,252,252,255,255,254,255,255,255,248,248,255,255,254,255,255,255,241,241,255,255,254,255,255,255,227,227,255,255,254,255,255,255,199,199,255,255,254,255,255,255,143,143,255,255,254,255,255,255,31,31,255,255,254,255,255,255,63,63,255,255,254,255,255,255,252,252,252,255,254,255,255,255,248,248,248,255,254,255,255,255,241,241,241,255,254,255,255,255,227,227,227,255,254,255,255,255,199,199,199,255,254,255,255,255,143,143,143,255,254,255,255,255,31,31,31,255,254,255,255,255,63,63,63,255,254,255,255,255,255,252,252,252,254,255,255,255,255,248,248,248,254,255,255,255,255,241,241,241,254,255,255,255,255,227,227,227,254,255,255,255,255,199,199,199,254,255,255,255,255,143,143,143,254,255,255,255,255,31,31,31,254,255,255,255,255,63,63,63,254,255,255,255,255,255,252,252,252,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,240,255,255,255,255,255,227,227,226,255,255,255,255,255,199,199,198,255,255,255,255,255,143,143,142,255,255,255,255,255,31,31,30,255,255,255,255,255,63,63,62,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,1,7,7,0,0,0,3,2,3,15,15,255,255,255,199,198,199,255,255,255,255,255,143,142,143,255,255,255,255,255,31,30,31,255,255,255,255,255,63,62,63,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,2,3,3,7,255,255,255,255,198,199,199,255,255,255,255,255,142,143,143,255,255,255,255,255,30,31,31,255,255,255,255,255,62,63,63,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,255,255,255,255,254,199,199,199,255,255,255,255,254,143,143,143,255,255,255,255,254,31,31,31,255,255,255,255,254,63,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,3,3,255,255,255,255,254,255,199,199,255,255,255,255,254,255,143,143,255,255,255,255,254,255,31,31,255,255,255,255,254,255,63,63,252,252,255,255,254,255,255,255,248,248,255,255,254,255,255,255,241,241,255,255,254,255,255,255,227,227,255,255,254,255,255,255,199,199,255,255,254,255,255,255,143,143,255,255,254,255,255,255,31,31,255,255,254,255,255,255,63,63,255,255,254,255,255,255,252,252,252,255,254,255,255,255,248,248,248,255,254,255,255,255,241,241,241,255,254,255,255,255,227,227,227,255,254,255,255,255,199,199,199,255,254,255,255,255,143,143,143,255,254,255,255,255,31,31,31,255,254,255,255,255,63,63,63,255,254,255,255,255,255,252,252,252,254,255,255,255,255,248,248,248,254,255,255,255,255,241,241,241,254,255,255,255,255,227,227,227,254,255,255,255,255,199,199,199,254,255,255,255,255,143,143,143,254,255,255,255,255,31,31,31,254,255,255,255,255,63,63,63,254,255,255,255,0,0,0,0,0,3,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,7,3,0,0,0,0,2,2,15,7,7,0,0,0,7,6,31,15,15,255,255,143,143,142,255,255,255,255,255,31,31,30,255,255,255,255,255,63,63,62,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,2,6,2,0,0,0,0,6,7,15,7,255,255,255,143,142,143,255,255,255,255,255,31,30,31,255,255,255,255,255,63,62,63,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,7,7,7,255,255,255,255,142,143,143,255,255,255,255,255,30,31,31,255,255,255,255,255,62,63,63,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,7,7,255,255,255,255,254,143,143,143,255,255,255,255,254,31,31,31,255,255,255,255,254,63,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,7,7,255,255,255,255,254,255,143,143,255,255,255,255,254,255,31,31,255,255,255,255,254,255,63,63,252,252,255,255,253,255,255,255,248,248,255,255,253,255,255,255,241,241,255,255,253,255,255,255,227,227,255,255,253,255,255,255,199,199,255,255,253,255,255,255,143,143,255,255,253,255,255,255,31,31,255,255,253,255,255,255,63,63,255,255,253,255,255,255,252,252,252,255,253,255,255,255,248,248,248,255,253,255,255,255,241,241,241,255,253,255,255,255,227,227,227,255,253,255,255,255,199,199,199,255,253,255,255,255,143,143,143,255,253,255,255,255,31,31,31,255,253,255,255,255,63,63,63,255,253,255,255,255,255,252,252,252,253,255,255,255,255,248,248,248,253,255,255,255,255,241,241,241,253,255,255,255,255,227,227,227,253,255,255,255,255,199,199,199,253,255,255,255,255,143,143,143,253,255,255,255,255,31,31,31,253,255,255,255,255,63,63,63,253,255,255,255,255,255,252,252,252,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,225,255,255,255,255,255,199,199,197,255,255,255,255,255,143,143,141,255,255,255,255,255,31,31,29,255,255,255,255,255,63,63,61,255,255,255,0,0,0,12,12,12,15,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,7,0,0,0,7,3,1,3,15,15,0,0,7,7,5,7,31,31,255,255,255,143,141,143,255,255,255,255,255,31,29,31,255,255,255,255,255,63,61,63,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,1,3,3,7,0,0,7,15,5,7,7,15,255,255,255,255,141,143,143,255,255,255,255,255,29,31,31,255,255,255,255,255,61,63,63,255,0,0,0,0,12,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,3,13,3,3,3,0,0,7,31,29,7,7,7,255,255,255,255,253,143,143,143,255,255,255,255,253,31,31,31,255,255,255,255,253,63,63,63,0,0,0,0,13,15,12,12,0,0,0,0,13,15,8,0,0,0,0,0,13,15,1,1,0,0,0,3,29,31,3,3,0,0,7,31,61,63,7,7,255,255,255,255,253,255,143,143,255,255,255,255,253,255,31,31,255,255,255,255,253,255,63,63,252,252,255,255,253,255,255,255,248,248,255,255,253,255,255,255,241,241,255,255,253,255,255,255,227,227,255,255,253,255,255,255,199,199,255,255,253,255,255,255,143,143,255,255,253,255,255,255,31,31,255,255,253,255,255,255,63,63,255,255,253,255,255,255,252,252,252,255,253,255,255,255,248,248,248,255,253,255,255,255,241,241,241,255,253,255,255,255,227,227,227,255,253,255,255,255,199,199,199,255,253,255,255,255,143,143,143,255,253,255,255,255,31,31,31,255,253,255,255,255,63,63,63,255,253,255,255,255,255,252,252,252,253,255,255,255,255,248,248,248,253,255,255,255,255,241,241,241,253,255,255,255,255,227,227,227,253,255,255,255,255,199,199,199,253,255,255,255,255,143,143,143,253,255,255,255,255,31,31,31,253,255,255,255,255,63,63,63,253,255,255,255,0,0,0,4,4,7,0,0,0,0,0,0,0,7,0,0,0,0,0,1,1,7,0,0,0,0,0,3,1,15,7,0,0,0,7,7,5,31,15,15,0,0,7,15,13,63,31,31,255,255,31,31,29,255,255,255,255,255,63,63,61,255,255,255,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,3,1,3,7,0,0,0,0,3,5,7,15,7,0,0,7,15,13,15,31,15,255,255,255,31,29,31,255,255,255,255,255,63,61,63,255,255,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,3,3,0,0,0,0,3,5,7,7,7,0,0,7,15,13,15,15,15,255,255,255,255,29,31,31,255,255,255,255,255,61,63,63,255,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,3,3,3,0,0,0,3,13,7,7,7,0,0,7,15,29,15,15,15,255,255,255,255,253,31,31,31,255,255,255,255,253,63,63,63,0,0,0,0,0,7,4,4,0,0,0,0,0,7,0,0,0,0,0,0,0,7,1,1,0,0,0,0,1,15,3,3,0,0,0,3,13,31,7,7,0,0,7,31,29,63,15,15,255,255,255,255,253,255,31,31,255,255,255,255,253,255,63,63,252,252,255,255,251,255,255,255,248,248,255,255,251,255,255,255,241,241,255,255,251,255,255,255,227,227,255,255,251,255,255,255,199,199,255,255,251,255,255,255,143,143,255,255,251,255,255,255,31,31,255,255,251,255,255,255,63,63,255,255,251,255,255,255,252,252,252,255,251,255,255,255,248,248,248,255,251,255,255,255,241,241,241,255,251,255,255,255,227,227,227,255,251,255,255,255,199,199,199,255,251,255,255,255,143,143,143,255,251,255,255,255,31,31,31,255,251,255,255,255,63,63,63,255,251,255,255,255,255,252,252,252,251,255,255,255,255,248,248,248,251,255,255,255,255,241,241,241,251,255,255,255,255,227,227,227,251,255,255,255,255,199,199,199,251,255,255,255,255,143,143,143,251,255,255,255,255,31,31,31,251,255,255,255,255,63,63,63,251,255,255,255,255,255,252,252,248,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,227,255,255,255,255,255,199,199,195,255,255,255,255,255,143,143,139,255,255,255,255,255,31,31,27,255,255,255,255,255,63,63,59,255,255,255,0,0,62,60,56,60,63,63,0,0,0,24,24,24,30,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,15,0,0,0,15,7,3,7,31,31,0,0,15,15,11,15,63,63,255,255,255,31,27,31,255,255,255,255,255,63,59,63,255,255,0,0,0,60,56,60,60,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,3,7,7,15,0,0,15,31,11,15,15,31,255,255,255,255,27,31,31,255,255,255,255,255,59,63,63,255,0,0,0,60,59,60,60,60,0,0,0,0,24,24,24,24,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,0,0,0,7,27,7,7,7,0,0,15,63,59,15,15,15,255,255,255,255,251,31,31,31,255,255,255,255,251,63,63,63,0,0,0,60,59,63,60,60,0,0,0,0,27,31,24,24,0,0,0,0,27,31,17,0,0,0,0,0,27,31,3,3,0,0,0,7,59,63,7,7,0,0,15,63,123,127,15,15,255,255,255,255,251,255,31,31,255,255,255,255,251,255,63,63,252,252,255,255,251,255,255,255,248,248,255,255,251,255,255,255,241,241,255,255,251,255,255,255,227,227,255,255,251,255,255,255,199,199,255,255,251,255,255,255,143,143,255,255,251,255,255,255,31,31,255,255,251,255,255,255,63,63,255,255,251,255,255,255,252,252,252,255,251,255,255,255,248,248,248,255,251,255,255,255,241,241,241,255,251,255,255,255,227,227,227,255,251,255,255,255,199,199,199,255,251,255,255,255,143,143,143,255,251,255,255,255,31,31,31,255,251,255,255,255,63,63,63,255,251,255,255,255,255,252,252,252,251,255,255,255,255,248,248,248,251,255,255,255,255,241,241,241,251,255,255,255,255,227,227,227,251,255,255,255,255,199,199,199,251,255,255,255,255,143,143,143,251,255,255,255,255,31,31,31,251,255,255,255,255,63,63,63,251,255,255,255,0,0,0,28,24,31,30,0,0,0,0,8,8,14,0,0,0,0,0,0,0,14,0,0,0,0,0,2,2,14,0,0,0,0,0,7,3,31,15,0,0,0,15,15,11,63,31,31,0,0,15,31,27,127,63,63,255,255,63,63,59,255,255,255,0,0,0,28,24,28,30,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,3,7,15,0,0,0,0,7,11,15,31,15,0,0,15,31,27,31,63,31,255,255,255,63,59,63,255,255,0,0,0,0,24,28,28,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,3,7,7,0,0,0,0,7,11,15,15,15,0,0,15,31,27,31,31,31,255,255,255,255,59,63,63,255,0,0,0,0,24,28,28,28,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,3,7,7,7,0,0,0,7,27,15,15,15,0,0,15,31,59,31,31,31,255,255,255,255,251,63,63,63,0,0,0,0,24,31,28,28,0,0,0,0,0,14,8,8,0,0,0,0,0,14,0,0,0,0,0,0,0,14,2,2,0,0,0,0,3,31,7,7,0,0,0,7,27,63,15,15,0,0,15,63,59,127,31,31,255,255,255,255,251,255,63,63,252,252,255,255,247,255,255,255,248,248,255,255,247,255,255,255,241,241,255,255,247,255,255,255,227,227,255,255,247,255,255,255,199,199,255,255,247,255,255,255,143,143,255,255,247,255,255,255,31,31,255,255,247,255,255,255,63,63,255,255,247,255,255,255,252,252,252,255,247,255,255,255,248,248,248,255,247,255,255,255,241,241,241,255,247,255,255,255,227,227,227,255,247,255,255,255,199,199,199,255,247,255,255,255,143,143,143,255,247,255,255,255,31,31,31,255,247,255,255,255,63,63,63,255,247,255,255,255,255,252,252,252,247,255,255,255,255,248,248,248,247,255,255,255,255,241,241,241,247,255,255,255,255,227,227,227,247,255,255,255,255,199,199,199,247,255,255,255,255,143,143,143,247,255,255,255,255,31,31,31,247,255,255,255,255,63,63,63,247,255,255,255,255,255,252,252,244,255,255,255,255,255,248,248,240,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,227,255,255,255,255,255,199,199,199,255,255,255,255,255,143,143,135,255,255,255,255,255,31,31,23,255,255,255,255,255,63,63,55,255,255,255,0,0,252,252,244,252,255,255,0,0,124,120,112,120,126,126,0,0,0,48,48,48,60,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,30,0,0,0,31,15,7,15,63,63,0,0,31,31,23,31,127,127,255,255,255,63,55,63,255,255,0,0,252,254,244,252,252,254,0,0,0,120,112,120,120,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,7,15,15,31,0,0,31,63,23,31,31,63,255,255,255,255,55,63,63,255,0,0,252,255,247,252,252,252,0,0,0,120,118,120,120,120,0,0,0,0,48,48,48,48,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,6,0,0,0,15,55,15,15,15,0,0,31,127,119,31,31,31,255,255,255,255,247,63,63,63,0,0,252,255,247,255,252,252,0,0,0,120,119,127,120,120,0,0,0,0,54,62,48,48,0,0,0,0,54,62,34,0,0,0,0,0,54,62,6,6,0,0,0,15,119,127,15,15,0,0,31,127,247,255,31,31,255,255,255,255,247,255,63,63,252,252,255,255,247,255,255,255,248,248,255,255,247,255,255,255,241,241,255,255,247,255,255,255,227,227,255,255,247,255,255,255,199,199,255,255,247,255,255,255,143,143,255,255,247,255,255,255,31,31,255,255,247,255,255,255,63,63,255,255,247,255,255,255,252,252,252,255,247,255,255,255,248,248,248,255,247,255,255,255,241,241,241,255,247,255,255,255,227,227,227,255,247,255,255,255,199,199,199,255,247,255,255,255,143,143,143,255,247,255,255,255,31,31,31,255,247,255,255,255,63,63,63,255,247,255,255,255,255,252,252,252,247,255,255,255,255,248,248,248,247,255,255,255,255,241,241,241,247,255,255,255,255,227,227,227,247,255,255,255,255,199,199,199,247,255,255,255,255,143,143,143,247,255,255,255,255,31,31,31,247,255,255,255,255,63,63,63,247,255,255,255,0,0,124,124,116,127,126,126,0,0,0,56,48,62,60,0,0,0,0,16,16,28,0,0,0,0,0,0,0,28,0,0,0,0,0,4,4,28,0,0,0,0,0,14,6,62,30,0,0,0,31,31,23,127,63,63,0,0,31,63,55,255,127,127,0,0,0,120,116,124,126,124,0,0,0,56,48,56,60,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,14,6,14,30,0,0,0,0,15,23,31,63,31,0,0,31,63,55,63,127,63,0,0,0,120,116,124,124,124,0,0,0,0,48,56,56,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,6,14,14,0,0,0,0,15,23,31,31,31,0,0,31,63,55,63,63,63,0,0,0,120,118,124,124,124,0,0,0,0,48,56,56,56,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,6,14,14,14,0,0,0,15,55,31,31,31,0,0,31,63,119,63,63,63,0,0,0,120,118,127,124,124,0,0,0,0,48,62,56,56,0,0,0,0,0,28,16,16,0,0,0,0,0,28,0,0,0,0,0,0,0,28,4,4,0,0,0,0,6,62,14,14,0,0,0,15,55,127,31,31,0,0,31,127,119,255,63,63,252,252,255,254,255,255,255,255,248,248,255,254,255,255,255,255,241,241,255,254,255,255,255,255,227,227,255,254,255,255,255,255,199,199,255,254,255,255,255,255,143,143,255,254,255,255,255,255,31,31,255,254,255,255,255,255,63,63,255,254,255,255,255,255,252,252,252,254,255,255,255,255,248,248,248,254,255,255,255,255,241,241,241,254,255,255,255,255,227,227,227,254,255,255,255,255,199,199,199,254,255,255,255,255,143,143,143,254,255,255,255,255,31,31,31,254,255,255,255,255,63,63,63,254,255,255,255,255,255,252,252,252,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,240,255,255,255,255,255,227,227,226,255,255,255,255,255,199,199,198,255,255,255,255,255,143,143,142,255,255,255,255,255,31,31,30,255,255,255,255,255,63,63,62,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,1,7,7,0,0,0,3,2,3,15,15,7,0,0,7,6,7,31,31,15,255,255,143,142,143,255,255,255,255,255,31,30,31,255,255,255,255,255,63,62,63,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,2,3,3,7,7,0,0,0,6,7,7,15,15,255,255,255,142,143,143,255,255,255,255,255,30,31,31,255,255,255,255,255,62,63,63,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,7,0,0,0,0,7,7,7,15,255,255,255,254,143,143,143,255,255,255,255,254,31,31,31,255,255,255,255,254,63,63,63,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,0,0,0,0,15,7,7,7,255,255,255,254,255,143,143,143,255,255,255,254,255,31,31,31,255,255,255,254,255,63,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,3,3,0,0,0,0,15,15,7,7,255,255,255,254,255,255,143,143,255,255,255,254,255,255,31,31,255,255,255,254,255,255,63,63,252,252,255,254,255,255,255,255,248,248,255,254,255,255,255,255,241,241,255,254,255,255,255,255,227,227,255,254,255,255,255,255,199,199,255,254,255,255,255,255,143,143,255,254,255,255,255,255,31,31,255,254,255,255,255,255,63,63,255,254,255,255,255,255,252,252,252,254,255,255,255,255,248,248,248,254,255,255,255,255,241,241,241,254,255,255,255,255,227,227,227,254,255,255,255,255,199,199,199,254,255,255,255,255,143,143,143,254,255,255,255,255,31,31,31,254,255,255,255,255,63,63,63,254,255,255,255,255,0,0,0,0,3,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,7,3,0,0,0,0,2,2,15,7,7,0,0,0,7,6,31,15,15,7,0,0,15,14,63,31,31,15,255,31,31,30,255,255,255,255,255,63,63,62,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,2,6,2,0,0,0,0,6,7,15,7,7,0,0,0,14,15,31,15,15,255,255,31,30,31,255,255,255,255,255,63,62,63,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,7,7,7,7,0,0,0,0,15,15,15,15,255,255,255,30,31,31,255,255,255,255,255,62,63,63,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,7,7,7,0,0,0,0,15,15,15,15,255,255,255,254,31,31,31,255,255,255,255,254,63,63,63,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,7,7,7,0,0,0,0,15,15,15,15,255,255,255,254,255,31,31,31,255,255,255,254,255,63,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,7,7,0,0,0,0,15,15,15,15,255,255,255,254,255,255,31,31,255,255,255,254,255,255,63,63,252,252,255,253,255,255,255,255,248,248,255,253,255,255,255,255,241,241,255,253,255,255,255,255,227,227,255,253,255,255,255,255,199,199,255,253,255,255,255,255,143,143,255,253,255,255,255,255,31,31,255,253,255,255,255,255,63,63,255,253,255,255,255,255,252,252,252,253,255,255,255,255,248,248,248,253,255,255,255,255,241,241,241,253,255,255,255,255,227,227,227,253,255,255,255,255,199,199,199,253,255,255,255,255,143,143,143,253,255,255,255,255,31,31,31,253,255,255,255,255,63,63,63,253,255,255,255,255,255,252,252,252,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,225,255,255,255,255,255,199,199,197,255,255,255,255,255,143,143,141,255,255,255,255,255,31,31,29,255,255,255,255,255,63,63,61,255,255,255,255,0,0,12,12,12,15,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,7,0,0,0,7,3,1,3,15,15,0,0,7,7,5,7,31,31,15,15,31,15,13,15,63,63,31,255,255,31,29,31,255,255,255,255,255,63,61,63,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,1,3,3,7,0,0,7,15,5,7,7,15,15,15,31,31,13,15,15,31,31,255,255,255,29,31,31,255,255,255,255,255,61,63,63,255,255,0,0,0,12,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,3,5,3,3,3,7,0,7,15,13,7,7,7,15,15,31,31,29,15,15,15,31,255,255,255,253,31,31,31,255,255,255,255,253,63,63,63,255,0,0,0,13,14,12,12,12,0,0,0,5,5,0,0,0,0,0,0,13,11,1,1,1,0,0,3,29,23,3,3,3,0,7,15,61,47,7,7,7,15,31,31,125,95,15,15,15,255,255,255,253,255,31,31,31,255,255,255,253,255,63,63,63,0,0,0,12,15,15,12,12,0,0,0,0,15,15,8,0,0,0,0,1,15,15,1,1,0,0,3,5,31,31,3,3,0,7,15,13,63,63,7,7,15,31,31,29,127,127,15,15,255,255,255,253,255,255,31,31,255,255,255,253,255,255,63,63,252,252,255,253,255,255,255,255,248,248,255,253,255,255,255,255,241,241,255,253,255,255,255,255,227,227,255,253,255,255,255,255,199,199,255,253,255,255,255,255,143,143,255,253,255,255,255,255,31,31,255,253,255,255,255,255,63,63,255,253,255,255,255,255,252,252,252,253,255,255,255,255,248,248,248,253,255,255,255,255,241,241,241,253,255,255,255,255,227,227,227,253,255,255,255,255,199,199,199,253,255,255,255,255,143,143,143,253,255,255,255,255,31,31,31,253,255,255,255,255,63,63,63,253,255,255,255,255,0,0,4,4,7,0,0,0,0,0,0,0,7,0,0,0,0,0,1,1,7,0,0,0,0,0,3,1,15,7,0,0,0,7,7,5,31,15,15,0,0,7,15,13,63,31,31,15,15,31,31,29,127,63,63,31,255,63,63,61,255,255,255,255,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,3,1,3,7,0,0,0,0,3,5,7,15,7,0,0,7,15,13,15,31,15,15,15,31,31,29,31,63,31,31,255,255,63,61,63,255,255,255,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,3,3,0,0,0,0,3,5,7,7,7,0,0,7,15,13,15,15,15,15,15,31,31,29,31,31,31,31,255,255,255,61,63,63,255,255,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,3,3,3,0,0,0,3,5,7,7,7,0,0,7,15,13,15,15,15,15,15,31,31,29,31,31,31,31,255,255,255,253,63,63,63,255,0,0,0,0,5,4,4,0,0,0,0,0,2,0,0,0,0,0,0,0,5,1,1,0,0,0,0,1,11,3,3,0,0,0,3,5,23,7,7,7,0,7,15,13,47,15,15,15,15,31,31,29,95,31,31,31,255,255,255,253,255,63,63,63,0,0,0,0,4,7,4,4,0,0,0,0,0,7,0,0,0,0,0,0,1,7,1,1,0,0,0,1,3,15,3,3,0,0,3,5,7,31,7,7,0,7,15,13,15,63,15,15,15,31,31,29,95,127,31,31,255,255,255,253,255,255,63,63,252,252,255,251,255,255,255,255,248,248,255,251,255,255,255,255,241,241,255,251,255,255,255,255,227,227,255,251,255,255,255,255,199,199,255,251,255,255,255,255,143,143,255,251,255,255,255,255,31,31,255,251,255,255,255,255,63,63,255,251,255,255,255,255,252,252,252,251,255,255,255,255,248,248,248,251,255,255,255,255,241,241,241,251,255,255,255,255,227,227,227,251,255,255,255,255,199,199,199,251,255,255,255,255,143,143,143,251,255,255,255,255,31,31,31,251,255,255,255,255,63,63,63,251,255,255,255,255,255,252,252,248,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,227,255,255,255,255,255,199,199,195,255,255,255,255,255,143,143,139,255,255,255,255,255,31,31,27,255,255,255,255,255,63,63,59,255,255,255,255,0,62,60,56,60,63,63,0,0,0,24,24,24,30,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,15,0,0,0,15,7,3,7,31,31,0,0,15,15,11,15,63,63,31,31,63,31,27,31,127,127,63,255,255,63,59,63,255,255,255,0,0,60,56,60,60,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,3,7,7,15,0,0,15,31,11,15,15,31,31,31,63,63,27,31,31,63,63,255,255,255,59,63,63,255,255,0,0,60,58,60,60,60,62,0,0,0,24,24,24,24,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,0,0,0,7,11,7,7,7,15,0,15,31,27,15,15,15,31,31,63,63,59,31,31,31,63,255,255,255,251,63,63,63,255,0,0,60,59,62,60,60,60,0,0,0,27,29,24,24,24,0,0,0,10,10,0,0,0,0,0,0,27,23,3,3,3,0,0,7,59,47,7,7,7,0,15,31,123,95,15,15,15,31,63,63,251,191,31,31,31,255,255,255,251,255,63,63,63,0,0,60,58,63,63,60,60,0,0,0,24,31,31,24,24,0,0,0,0,31,31,17,0,0,0,0,3,31,31,3,3,0,0,7,11,63,63,7,7,0,15,31,27,127,127,15,15,31,63,63,59,255,255,31,31,255,255,255,251,255,255,63,63,252,252,255,251,255,255,255,255,248,248,255,251,255,255,255,255,241,241,255,251,255,255,255,255,227,227,255,251,255,255,255,255,199,199,255,251,255,255,255,255,143,143,255,251,255,255,255,255,31,31,255,251,255,255,255,255,63,63,255,251,255,255,255,255,252,252,252,251,255,255,255,255,248,248,248,251,255,255,255,255,241,241,241,251,255,255,255,255,227,227,227,251,255,255,255,255,199,199,199,251,255,255,255,255,143,143,143,251,255,255,255,255,31,31,31,251,255,255,255,255,63,63,63,251,255,255,255,255,0,0,28,24,31,30,0,0,0,0,8,8,14,0,0,0,0,0,0,0,14,0,0,0,0,0,2,2,14,0,0,0,0,0,7,3,31,15,0,0,0,15,15,11,63,31,31,0,0,15,31,27,127,63,63,31,31,63,63,59,255,127,127,63,0,0,28,24,28,30,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,3,7,15,0,0,0,0,7,11,15,31,15,0,0,15,31,27,31,63,31,31,31,63,63,59,63,127,63,63,0,0,0,24,28,28,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,3,7,7,0,0,0,0,7,11,15,15,15,0,0,15,31,27,31,31,31,31,31,63,63,59,63,63,63,63,0,0,0,24,28,28,28,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,3,7,7,7,0,0,0,7,11,15,15,15,0,0,15,31,27,31,31,31,31,31,63,63,59,63,63,63,63,0,0,0,24,29,28,28,0,0,0,0,0,10,8,8,0,0,0,0,0,4,0,0,0,0,0,0,0,10,2,2,0,0,0,0,3,23,7,7,0,0,0,7,11,47,15,15,15,0,15,31,27,95,31,31,31,31,63,63,59,191,63,63,63,0,0,0,24,28,31,28,28,0,0,0,0,8,14,8,8,0,0,0,0,0,14,0,0,0,0,0,0,2,14,2,2,0,0,0,3,7,31,7,7,0,0,7,11,15,63,15,15,0,15,31,27,31,127,31,31,31,63,63,59,191,255,63,63,252,252,255,247,255,255,255,255,248,248,255,247,255,255,255,255,241,241,255,247,255,255,255,255,227,227,255,247,255,255,255,255,199,199,255,247,255,255,255,255,143,143,255,247,255,255,255,255,31,31,255,247,255,255,255,255,63,63,255,247,255,255,255,255,252,252,252,247,255,255,255,255,248,248,248,247,255,255,255,255,241,241,241,247,255,255,255,255,227,227,227,247,255,255,255,255,199,199,199,247,255,255,255,255,143,143,143,247,255,255,255,255,31,31,31,247,255,255,255,255,63,63,63,247,255,255,255,255,255,252,252,244,255,255,255,255,255,248,248,240,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,227,255,255,255,255,255,199,199,199,255,255,255,255,255,143,143,135,255,255,255,255,255,31,31,23,255,255,255,255,255,63,63,55,255,255,255,255,0,252,252,244,252,255,255,254,0,124,120,112,120,126,126,0,0,0,48,48,48,60,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,30,0,0,0,31,15,7,15,63,63,0,0,31,31,23,31,127,127,63,63,127,63,55,63,255,255,127,0,252,254,244,252,252,254,254,0,0,120,112,120,120,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,7,15,15,31,0,0,31,63,23,31,31,63,63,63,127,127,55,63,63,127,127,0,252,254,246,252,252,252,254,0,0,120,116,120,120,120,124,0,0,0,48,48,48,48,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,6,0,0,0,15,23,15,15,15,31,0,31,63,55,31,31,31,63,63,127,127,119,63,63,63,127,0,252,254,247,254,252,252,252,0,0,120,119,125,120,120,120,0,0,0,54,58,48,48,48,0,0,0,20,20,0,0,0,0,0,0,54,46,6,6,6,0,0,15,119,95,15,15,15,0,31,63,247,191,31,31,31,63,127,127,247,127,63,63,63,0,252,254,246,255,255,252,252,0,0,120,116,127,127,120,120,0,0,0,48,62,62,48,48,0,0,0,0,62,62,34,0,0,0,0,6,62,62,6,6,0,0,15,23,127,127,15,15,0,31,63,55,255,255,31,31,63,127,127,119,255,255,63,63,252,252,255,247,255,255,255,255,248,248,255,247,255,255,255,255,241,241,255,247,255,255,255,255,227,227,255,247,255,255,255,255,199,199,255,247,255,255,255,255,143,143,255,247,255,255,255,255,31,31,255,247,255,255,255,255,63,63,255,247,255,255,255,255,252,252,252,247,255,255,255,255,248,248,248,247,255,255,255,255,241,241,241,247,255,255,255,255,227,227,227,247,255,255,255,255,199,199,199,247,255,255,255,255,143,143,143,247,255,255,255,255,31,31,31,247,255,255,255,255,63,63,63,247,255,255,255,255,0,124,124,116,127,126,126,0,0,0,56,48,62,60,0,0,0,0,16,16,28,0,0,0,0,0,0,0,28,0,0,0,0,0,4,4,28,0,0,0,0,0,14,6,62,30,0,0,0,31,31,23,127,63,63,0,0,31,63,55,255,127,127,63,0,0,120,116,124,126,124,0,0,0,56,48,56,60,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,14,6,14,30,0,0,0,0,15,23,31,63,31,0,0,31,63,55,63,127,63,63,0,0,120,116,124,124,124,0,0,0,0,48,56,56,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,6,14,14,0,0,0,0,15,23,31,31,31,0,0,31,63,55,63,63,63,63,0,0,120,116,124,124,124,0,0,0,0,48,56,56,56,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,6,14,14,14,0,0,0,15,23,31,31,31,0,0,31,63,55,63,63,63,63,0,0,120,116,125,124,124,124,0,0,0,48,58,56,56,0,0,0,0,0,20,16,16,0,0,0,0,0,8,0,0,0,0,0,0,0,20,4,4,0,0,0,0,6,46,14,14,0,0,0,15,23,95,31,31,31,0,31,63,55,191,63,63,63,0,0,120,116,124,127,124,124,0,0,0,48,56,62,56,56,0,0,0,0,16,28,16,16,0,0,0,0,0,28,0,0,0,0,0,0,4,28,4,4,0,0,0,6,14,62,14,14,0,0,15,23,31,127,31,31,0,31,63,55,63,255,63,63,252,252,254,255,255,255,255,255,248,248,254,255,255,255,255,255,241,241,254,255,255,255,255,255,227,227,254,255,255,255,255,255,199,199,254,255,255,255,255,255,143,143,254,255,255,255,255,255,31,31,254,255,255,255,255,255,63,63,254,255,255,255,255,255,252,252,252,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,240,255,255,255,255,255,227,227,226,255,255,255,255,255,199,199,198,255,255,255,255,255,143,143,142,255,255,255,255,255,31,31,30,255,255,255,255,255,63,63,62,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,1,7,7,0,0,0,3,2,3,15,15,7,0,0,7,6,7,31,31,15,15,0,15,14,15,63,63,31,31,255,31,30,31,255,255,255,255,255,63,62,63,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,2,3,3,7,7,0,0,0,6,7,7,15,15,15,0,0,14,15,15,31,31,31,255,255,30,31,31,255,255,255,255,255,62,63,63,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,7,0,0,0,0,7,7,7,15,15,0,0,0,15,15,15,31,31,255,255,254,31,31,31,255,255,255,255,254,63,63,63,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,0,0,0,0,0,7,7,7,15,0,0,0,31,15,15,15,31,255,255,254,255,31,31,31,255,255,255,254,255,63,63,63,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,0,0,0,0,15,7,7,7,0,0,0,31,31,15,15,15,255,255,254,255,255,31,31,31,255,255,254,255,255,63,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,3,3,0,0,0,0,15,15,7,7,0,0,0,31,31,31,15,15,255,255,254,255,255,255,31,31,255,255,254,255,255,255,63,63,252,252,254,255,255,255,255,255,248,248,254,255,255,255,255,255,241,241,254,255,255,255,255,255,227,227,254,255,255,255,255,255,199,199,254,255,255,255,255,255,143,143,254,255,255,255,255,255,31,31,254,255,255,255,255,255,63,63,254,255,255,255,255,255,0,0,0,3,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,7,3,0,0,0,0,2,2,15,7,7,0,0,0,7,6,31,15,15,7,0,0,15,14,63,31,31,15,15,0,31,30,127,63,63,31,31,63,63,62,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,2,6,2,0,0,0,0,6,7,15,7,7,0,0,0,14,15,31,15,15,15,0,0,30,31,63,31,31,31,255,63,62,63,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,7,7,7,7,0,0,0,0,15,15,15,15,15,0,0,0,31,31,31,31,31,255,255,62,63,63,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,7,7,7,0,0,0,0,0,15,15,15,15,0,0,0,31,31,31,31,31,255,255,254,63,63,63,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,7,7,0,0,0,0,0,15,15,15,15,0,0,0,31,31,31,31,31,255,255,254,255,63,63,63,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,7,7,0,0,0,0,0,15,15,15,15,0,0,0,31,31,31,31,31,255,255,254,255,255,63,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,7,7,0,0,0,0,15,15,15,15,0,0,0,31,31,31,31,31,255,255,254,255,255,255,63,63,252,252,253,255,255,255,255,255,248,248,253,255,255,255,255,255,241,241,253,255,255,255,255,255,227,227,253,255,255,255,255,255,199,199,253,255,255,255,255,255,143,143,253,255,255,255,255,255,31,31,253,255,255,255,255,255,63,63,253,255,255,255,255,255,252,252,252,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,225,255,255,255,255,255,199,199,197,255,255,255,255,255,143,143,141,255,255,255,255,255,31,31,29,255,255,255,255,255,63,63,61,255,255,255,255,255,0,12,12,12,15,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,7,0,0,0,7,3,1,3,15,15,0,0,7,7,5,7,31,31,15,0,31,15,13,15,63,63,31,31,63,31,29,31,127,127,63,63,255,63,61,63,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,1,3,3,7,0,0,7,15,5,7,7,15,15,0,31,31,13,15,15,31,31,31,63,63,29,31,31,63,63,63,255,255,61,63,63,255,255,255,0,0,12,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,3,5,3,3,3,7,0,7,15,13,7,7,7,15,0,31,31,29,15,15,15,31,31,63,63,61,31,31,31,63,63,255,255,253,63,63,63,255,255,0,0,13,14,12,12,12,0,0,0,5,5,0,0,0,0,0,0,13,11,1,1,1,0,0,3,29,23,3,3,3,0,7,15,61,47,7,7,7,15,31,31,125,95,15,15,15,31,63,63,253,191,31,31,31,63,255,255,253,255,63,63,63,255,0,0,12,15,15,12,12,12,0,0,0,15,15,8,0,0,0,0,1,15,15,1,1,1,0,3,5,31,31,3,3,3,7,15,13,63,63,7,7,7,31,31,29,127,127,15,15,15,63,63,61,255,255,31,31,31,255,255,253,255,255,63,63,63,0,0,29,31,31,31,28,12,0,0,29,31,31,31,24,0,0,0,29,31,31,31,17,1,0,3,29,31,31,31,3,3,7,15,61,63,63,63,7,7,31,31,125,127,127,127,15,15,63,63,253,255,255,255,31,31,255,255,253,255,255,255,63,63,252,252,253,255,255,255,255,255,248,248,253,255,255,255,255,255,241,241,253,255,255,255,255,255,227,227,253,255,255,255,255,255,199,199,253,255,255,255,255,255,143,143,253,255,255,255,255,255,31,31,253,255,255,255,255,255,63,63,253,255,255,255,255,255,0,4,4,7,0,0,0,0,0,0,0,7,0,0,0,0,0,1,1,7,0,0,0,0,0,3,1,15,7,0,0,0,7,7,5,31,15,15],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+10240);allocate([7,15,13,63,31,31,15,0,31,31,29,127,63,63,31,31,63,63,61,255,127,127,63,63,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,3,1,3,7,0,0,0,0,3,5,7,15,7,0,0,7,15,13,15,31,15,15,0,31,31,29,31,63,31,31,31,63,63,61,63,127,63,63,63,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,3,3,0,0,0,0,3,5,7,7,7,0,0,7,15,13,15,15,15,15,0,31,31,29,31,31,31,31,31,63,63,61,63,63,63,63,63,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,3,3,3,0,0,0,3,5,7,7,7,0,0,7,15,13,15,15,15,15,0,31,31,29,31,31,31,31,31,63,63,61,63,63,63,63,63,0,0,0,5,4,4,0,0,0,0,0,2,0,0,0,0,0,0,0,5,1,1,0,0,0,0,1,11,3,3,0,0,0,3,5,23,7,7,7,0,7,15,13,47,15,15,15,0,31,31,29,95,31,31,31,31,63,63,61,191,63,63,63,63,0,0,0,4,7,4,4,0,0,0,0,0,7,0,0,0,0,0,0,1,7,1,1,0,0,0,1,3,15,3,3,0,0,3,5,7,31,7,7,0,7,15,13,15,63,15,15,15,31,31,29,31,127,31,31,31,63,63,61,191,255,63,63,63,0,0,0,15,15,15,4,4,0,0,0,15,15,15,0,0,0,0,0,15,15,15,1,1,0,0,1,15,15,15,3,3,0,3,5,31,31,31,7,7,7,15,13,63,63,63,15,15,31,31,29,127,127,127,31,31,63,63,61,255,255,255,63,63,252,252,251,255,255,255,255,255,248,248,251,255,255,255,255,255,241,241,251,255,255,255,255,255,227,227,251,255,255,255,255,255,199,199,251,255,255,255,255,255,143,143,251,255,255,255,255,255,31,31,251,255,255,255,255,255,63,63,251,255,255,255,255,255,252,252,248,255,255,255,255,255,248,248,248,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,227,255,255,255,255,255,199,199,195,255,255,255,255,255,143,143,139,255,255,255,255,255,31,31,27,255,255,255,255,255,63,63,59,255,255,255,255,255,62,60,56,60,63,63,0,0,0,24,24,24,30,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,15,0,0,0,15,7,3,7,31,31,0,0,15,15,11,15,63,63,31,0,63,31,27,31,127,127,63,63,127,63,59,63,255,255,127,127,0,60,56,60,60,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,3,7,7,15,0,0,15,31,11,15,15,31,31,0,63,63,27,31,31,63,63,63,127,127,59,63,63,127,127,127,0,60,58,60,60,60,62,0,0,0,24,24,24,24,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,0,0,0,7,11,7,7,7,15,0,15,31,27,15,15,15,31,0,63,63,59,31,31,31,63,63,127,127,123,63,63,63,127,127,0,60,59,62,60,60,60,0,0,0,27,29,24,24,24,0,0,0,10,10,0,0,0,0,0,0,27,23,3,3,3,0,0,7,59,47,7,7,7,0,15,31,123,95,15,15,15,31,63,63,251,191,31,31,31,63,127,127,251,127,63,63,63,127,0,60,58,63,63,60,60,60,0,0,24,31,31,24,24,24,0,0,0,31,31,17,0,0,0,0,3,31,31,3,3,3,0,7,11,63,63,7,7,7,15,31,27,127,127,15,15,15,63,63,59,255,255,31,31,31,127,127,123,255,255,63,63,63,0,60,59,63,63,63,60,60,0,0,59,63,63,63,56,24,0,0,59,63,63,63,49,0,0,0,59,63,63,63,35,3,0,7,59,63,63,63,7,7,15,31,123,127,127,127,15,15,63,63,251,255,255,255,31,31,127,127,251,255,255,255,63,63,252,252,251,255,255,255,255,255,248,248,251,255,255,255,255,255,241,241,251,255,255,255,255,255,227,227,251,255,255,255,255,255,199,199,251,255,255,255,255,255,143,143,251,255,255,255,255,255,31,31,251,255,255,255,255,255,63,63,251,255,255,255,255,255,0,28,24,31,30,0,0,0,0,8,8,14,0,0,0,0,0,0,0,14,0,0,0,0,0,2,2,14,0,0,0,0,0,7,3,31,15,0,0,0,15,15,11,63,31,31,0,0,15,31,27,127,63,63,31,0,63,63,59,255,127,127,63,63,0,28,24,28,30,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,3,7,15,0,0,0,0,7,11,15,31,15,0,0,15,31,27,31,63,31,31,0,63,63,59,63,127,63,63,63,0,0,24,28,28,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,3,7,7,0,0,0,0,7,11,15,15,15,0,0,15,31,27,31,31,31,31,0,63,63,59,63,63,63,63,63,0,0,24,28,28,28,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,3,7,7,7,0,0,0,7,11,15,15,15,0,0,15,31,27,31,31,31,31,0,63,63,59,63,63,63,63,63,0,0,24,29,28,28,0,0,0,0,0,10,8,8,0,0,0,0,0,4,0,0,0,0,0,0,0,10,2,2,0,0,0,0,3,23,7,7,0,0,0,7,11,47,15,15,15,0,15,31,27,95,31,31,31,0,63,63,59,191,63,63,63,63,0,0,24,28,31,28,28,0,0,0,0,8,14,8,8,0,0,0,0,0,14,0,0,0,0,0,0,2,14,2,2,0,0,0,3,7,31,7,7,0,0,7,11,15,63,15,15,0,15,31,27,31,127,31,31,31,63,63,59,63,255,63,63,63,0,0,24,31,31,31,28,28,0,0,0,31,31,31,8,8,0,0,0,31,31,31,0,0,0,0,0,31,31,31,2,2,0,0,3,31,31,31,7,7,0,7,11,63,63,63,15,15,15,31,27,127,127,127,31,31,63,63,59,255,255,255,63,63,252,252,247,255,255,255,255,255,248,248,247,255,255,255,255,255,241,241,247,255,255,255,255,255,227,227,247,255,255,255,255,255,199,199,247,255,255,255,255,255,143,143,247,255,255,255,255,255,31,31,247,255,255,255,255,255,63,63,247,255,255,255,255,255,252,252,244,255,255,255,255,255,248,248,240,255,255,255,255,255,241,241,241,255,255,255,255,255,227,227,227,255,255,255,255,255,199,199,199,255,255,255,255,255,143,143,135,255,255,255,255,255,31,31,23,255,255,255,255,255,63,63,55,255,255,255,255,255,252,252,244,252,255,255,254,0,124,120,112,120,126,126,0,0,0,48,48,48,60,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,30,0,0,0,31,15,7,15,63,63,0,0,31,31,23,31,127,127,63,0,127,63,55,63,255,255,127,127,252,254,244,252,252,254,254,0,0,120,112,120,120,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,7,15,15,31,0,0,31,63,23,31,31,63,63,0,127,127,55,63,63,127,127,127,252,254,246,252,252,252,254,0,0,120,116,120,120,120,124,0,0,0,48,48,48,48,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,6,0,0,0,15,23,15,15,15,31,0,31,63,55,31,31,31,63,0,127,127,119,63,63,63,127,127,252,254,247,254,252,252,252,254,0,120,119,125,120,120,120,0,0,0,54,58,48,48,48,0,0,0,20,20,0,0,0,0,0,0,54,46,6,6,6,0,0,15,119,95,15,15,15,0,31,63,247,191,31,31,31,63,127,127,247,127,63,63,63,127,252,254,246,255,255,252,252,252,0,120,116,127,127,120,120,120,0,0,48,62,62,48,48,48,0,0,0,62,62,34,0,0,0,0,6,62,62,6,6,6,0,15,23,127,127,15,15,15,31,63,55,255,255,31,31,31,127,127,119,255,255,63,63,63,252,254,247,255,255,255,252,252,0,120,119,127,127,127,120,120,0,0,119,127,127,127,113,48,0,0,119,127,127,127,99,0,0,0,119,127,127,127,71,6,0,15,119,127,127,127,15,15,31,63,247,255,255,255,31,31,127,127,247,255,255,255,63,63,252,252,247,255,255,255,255,255,248,248,247,255,255,255,255,255,241,241,247,255,255,255,255,255,227,227,247,255,255,255,255,255,199,199,247,255,255,255,255,255,143,143,247,255,255,255,255,255,31,31,247,255,255,255,255,255,63,63,247,255,255,255,255,255,124,124,116,127,126,126,0,0,0,56,48,62,60,0,0,0,0,16,16,28,0,0,0,0,0,0,0,28,0,0,0,0,0,4,4,28,0,0,0,0,0,14,6,62,30,0,0,0,31,31,23,127,63,63,0,0,31,63,55,255,127,127,63,0,0,120,116,124,126,124,0,0,0,56,48,56,60,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,14,6,14,30,0,0,0,0,15,23,31,63,31,0,0,31,63,55,63,127,63,63,0,0,120,116,124,124,124,0,0,0,0,48,56,56,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,6,14,14,0,0,0,0,15,23,31,31,31,0,0,31,63,55,63,63,63,63,0,0,120,116,124,124,124,0,0,0,0,48,56,56,56,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,6,14,14,14,0,0,0,15,23,31,31,31,0,0,31,63,55,63,63,63,63,0,0,120,116,125,124,124,124,0,0,0,48,58,56,56,0,0,0,0,0,20,16,16,0,0,0,0,0,8,0,0,0,0,0,0,0,20,4,4,0,0,0,0,6,46,14,14,0,0,0,15,23,95,31,31,31,0,31,63,55,191,63,63,63,0,0,120,116,124,127,124,124,0,0,0,48,56,62,56,56,0,0,0,0,16,28,16,16,0,0,0,0,0,28,0,0,0,0,0,0,4,28,4,4,0,0,0,6,14,62,14,14,0,0,15,23,31,127,31,31,0,31,63,55,63,255,63,63,63,0,120,116,127,127,127,124,124,0,0,48,62,62,62,56,56,0,0,0,62,62,62,16,16,0,0,0,62,62,62,0,0,0,0,0,62,62,62,4,4,0,0,6,62,62,62,14,14,0,15,23,127,127,127,31,31,31,63,55,255,255,255,63,63,252,252,255,255,255,255,255,255,248,248,255,255,255,255,255,255,241,240,255,255,255,255,255,255,227,226,255,255,255,255,255,255,199,198,255,255,255,255,255,255,143,142,255,255,255,255,255,255,31,30,255,255,255,255,255,255,63,62,255,255,255,255,255,255,0,0,0,0,0,0,0,0,248,248,248,255,255,255,255,255,241,240,241,255,255,255,255,255,227,226,227,255,255,255,255,255,199,198,199,255,255,255,255,255,143,142,143,255,255,255,255,255,31,30,31,255,255,255,255,255,63,62,63,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,15,15,0,0,0,2,3,3,31,31,7,0,0,6,7,7,63,63,15,15,0,14,15,15,127,127,31,31,255,30,31,31,255,255,255,255,255,62,63,63,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,3,3,3,7,7,0,0,0,7,7,7,15,15,15,0,0,15,15,15,31,31,31,255,254,31,31,31,255,255,255,255,254,63,63,63,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,7,0,0,0,0,7,7,7,15,15,0,0,0,15,15,15,31,31,255,254,255,31,31,31,255,255,255,254,255,63,63,63,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,0,0,0,0,0,7,7,7,15,0,0,0,31,15,15,15,31,255,254,255,255,31,31,31,255,255,254,255,255,63,63,63,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,0,0,0,0,15,7,7,7,0,0,0,31,31,15,15,15,255,254,255,255,255,31,31,31,255,254,255,255,255,63,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,3,3,0,0,0,0,15,15,7,7,0,0,0,31,31,31,15,15,255,254,255,255,255,255,31,31,255,254,255,255,255,255,63,63,0,0,3,0,0,0,0,0,0,0,3,0,0,0,0,0,241,240,255,255,255,255,255,255,227,226,255,255,255,255,255,255,199,198,255,255,255,255,255,255,143,142,255,255,255,255,255,255,31,30,255,255,255,255,255,255,63,62,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,15,15,0,0,0,2,2,15,15,15,0,0,0,6,7,31,31,31,7,0,0,14,15,63,63,63,15,15,0,30,31,127,127,127,31,31,63,62,63,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,2,2,14,2,0,0,0,0,7,7,31,7,7,0,0,0,15,15,63,15,15,15,0,0,31,31,127,31,31,31,255,62,63,63,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,7,7,7,7,0,0,0,0,15,15,15,15,15,0,0,0,31,31,31,31,31,255,254,63,63,63,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,7,7,7,0,0,0,0,0,15,15,15,15,0,0,0,31,31,31,31,31,255,254,255,63,63,63,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,7,7,0,0,0,0,0,15,15,15,15,0,0,0,31,31,31,31,31,255,254,255,255,63,63,63,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,7,7,0,0,0,0,0,15,15,15,15,0,0,0,31,31,31,31,31,255,254,255,255,255,63,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,7,7,0,0,0,0,15,15,15,15,0,0,0,31,31,31,31,31,255,254,255,255,255,255,63,63,252,252,255,255,255,255,255,255,248,248,255,255,255,255,255,255,241,241,255,255,255,255,255,255,227,225,255,255,255,255,255,255,199,197,255,255,255,255,255,255,143,141,255,255,255,255,255,255,31,29,255,255,255,255,255,255,63,61,255,255,255,255,255,255,252,252,252,255,255,255,255,255,0,0,0,0,0,0,0,0,241,241,241,255,255,255,255,255,227,225,227,255,255,255,255,255,199,197,199,255,255,255,255,255,143,141,143,255,255,255,255,255,31,29,31,255,255,255,255,255,63,61,63,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,1,3,3,31,31,0,0,15,5,7,7,63,63,15,0,31,13,15,15,127,127,31,31,63,29,31,31,255,255,63,63,255,61,63,63,255,255,255,255,0,12,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,3,5,3,3,3,7,0,0,15,13,7,7,7,15,15,0,31,29,15,15,15,31,31,31,63,61,31,31,31,63,63,63,255,253,63,63,63,255,255,255,0,13,14,12,12,12,0,0,0,5,5,0,0,0,0,0,0,13,11,1,1,1,0,0,3,29,23,3,3,3,0,0,15,61,47,7,7,7,15,0,31,125,95,15,15,15,31,31,63,253,191,31,31,31,63,63,255,253,255,63,63,63,255,255,0,12,15,15,12,12,12,0,0,0,15,15,8,0,0,0,0,1,15,15,1,1,1,0,3,5,31,31,3,3,3,0,15,13,63,63,7,7,7,0,31,29,127,127,15,15,15,31,63,61,255,255,31,31,31,63,255,253,255,255,63,63,63,255,0,29,31,31,31,28,12,12,0,29,31,31,31,24,0,0,0,29,31,31,31,17,1,1,3,29,31,31,31,3,3,3,15,61,63,63,63,7,7,7,31,125,127,127,127,15,15,15,63,253,255,255,255,31,31,31,255,253,255,255,255,63,63,63,63,61,63,63,63,63,60,12,63,61,63,63,63,63,56,0,63,61,63,63,63,63,49,1,63,61,63,63,63,63,35,3,63,61,63,63,63,63,7,7,127,125,127,127,127,127,15,15,255,253,255,255,255,255,31,31,255,253,255,255,255,255,63,63,4,4,7,0,0,0,0,0,0,0,7,0,0,0,0,0,1,1,7,0,0,0,0,0,227,225,255,255,255,255,255,255,199,197,255,255,255,255,255,255,143,141,255,255,255,255,255,255,31,29,255,255,255,255,255,255,63,61,255,255,255,255,255,255,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,3,1,3,31,31,31,0,0,3,5,7,31,31,31,0,0,15,13,15,63,63,63,15,0,31,29,31,127,127,127,31,31,63,61,63,255,255,255,63,63,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,3,3,15,0,0,0,3,5,7,7,31,7,0,0,15,13,15,15,63,15,15,0,31,29,31,31,127,31,31,31,63,61,63,63,255,63,63,63,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,3,3,3,0,0,0,3,5,7,7,7,7,0,0,15,13,15,15,15,15,15,0,31,29,31,31,31,31,31,31,63,61,63,63,63,63,63,63,0,0,5,4,4,0,0,0,0,0,2,0,0,0,0,0,0,0,5,1,1,0,0,0,0,1,11,3,3,0,0,0,3,5,23,7,7,7,0,0,15,13,47,15,15,15,15,0,31,29,95,31,31,31,31,31,63,61,191,63,63,63,63,63,0,0,4,7,4,4,0,0,0,0,0,7,0,0,0,0,0,0,1,7,1,1,0,0,0,1,3,15,3,3,0,0,3,5,7,31,7,7,0,0,15,13,15,63,15,15,15,0,31,29,31,127,31,31,31,31,63,61,191,255,63,63,63,63,0,0,15,15,15,4,4,0,0,0,15,15,15,0,0,0,0,0,15,15,15,1,1,0,0,1,15,15,15,3,3,0,3,5,31,31,31,7,7,0,15,13,63,63,63,15,15,0,31,29,127,127,127,31,31,31,63,61,255,255,255,63,63,63,0,29,31,31,31,31,4,4,0,29,31,31,31,31,0,0,0,29,31,31,31,31,1,1,0,29,31,31,31,31,3,3,3,29,31,31,31,31,7,7,15,61,63,63,63,63,15,15,31,125,127,127,127,127,31,31,63,253,255,255,255,255,63,63,252,248,255,255,255,255,255,255,248,248,255,255,255,255,255,255,241,241,255,255,255,255,255,255,227,227,255,255,255,255,255,255,199,195,255,255,255,255,255,255,143,139,255,255,255,255,255,255,31,27,255,255,255,255,255,255,63,59,255,255,255,255,255,255,252,248,252,255,255,255,255,255,248,248,248,255,255,255,255,255,0,0,0,0,0,0,0,0,227,227,227,255,255,255,255,255,199,195,199,255,255,255,255,255,143,139,143,255,255,255,255,255,31,27,31,255,255,255,255,255,63,59,63,255,255,255,255,255,60,56,60,60,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,3,7,7,63,63,0,0,31,11,15,15,127,127,31,0,63,27,31,31,255,255,63,63,127,59,63,63,255,255,127,127,60,58,60,60,60,62,0,0,0,24,24,24,24,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,0,0,0,7,11,7,7,7,15,0,0,31,27,15,15,15,31,31,0,63,59,31,31,31,63,63,63,127,123,63,63,63,127,127,127,60,59,62,60,60,60,0,0,0,27,29,24,24,24,0,0,0,10,10,0,0,0,0,0,0,27,23,3,3,3,0,0,7,59,47,7,7,7,0,0,31,123,95,15,15,15,31,0,63,251,191,31,31,31,63,63,127,251,127,63,63,63,127,127,60,58,63,63,60,60,60,0,0,24,31,31,24,24,24,0,0,0,31,31,17,0,0,0,0,3,31,31,3,3,3,0,7,11,63,63,7,7,7,0,31,27,127,127,15,15,15,0,63,59,255,255,31,31,31,63,127,123,255,255,63,63,63,127,60,59,63,63,63,60,60,60,0,59,63,63,63,56,24,24,0,59,63,63,63,49,0,0,0,59,63,63,63,35,3,3,7,59,63,63,63,7,7,7,31,123,127,127,127,15,15,15,63,251,255,255,255,31,31,31,127,251,255,255,255,63,63,63,127,123,127,127,127,127,124,60,127,123,127,127,127,127,120,24,127,123,127,127,127,127,113,0,127,123,127,127,127,127,99,3,127,123,127,127,127,127,71,7,127,123,127,127,127,127,15,15,255,251,255,255,255,255,31,31,255,251,255,255,255,255,63,63,252,248,255,255,255,255,255,255,8,8,14,0,0,0,0,0,0,0,14,0,0,0,0,0,2,2,14,0,0,0,0,0,199,195,255,255,255,255,255,255,143,139,255,255,255,255,255,255,31,27,255,255,255,255,255,255,63,59,255,255,255,255,255,255,60,56,60,63,63,63,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,3,7,63,63,63,0,0,7,11,15,63,63,63,0,0,31,27,31,127,127,127,31,0,63,59,63,255,255,255,63,63,0,24,28,28,31,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,3,7,7,31,0,0,0,7,11,15,15,63,15,0,0,31,27,31,31,127,31,31,0,63,59,63,63,255,63,63,63,0,24,28,28,28,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,3,7,7,7,0,0,0,7,11,15,15,15,15,0,0,31,27,31,31,31,31,31,0,63,59,63,63,63,63,63,63,0,24,29,28,28,0,0,0,0,0,10,8,8,0,0,0,0,0,4,0,0,0,0,0,0,0,10,2,2,0,0,0,0,3,23,7,7,0,0,0,7,11,47,15,15,15,0,0,31,27,95,31,31,31,31,0,63,59,191,63,63,63,63,63,0,24,28,31,28,28,0,0,0,0,8,14,8,8,0,0,0,0,0,14,0,0,0,0,0,0,2,14,2,2,0,0,0,3,7,31,7,7,0,0,7,11,15,63,15,15,0,0,31,27,31,127,31,31,31,0,63,59,63,255,63,63,63,63,0,24,31,31,31,28,28,0,0,0,31,31,31,8,8,0,0,0,31,31,31,0,0,0,0,0,31,31,31,2,2,0,0,3,31,31,31,7,7,0,7,11,63,63,63,15,15,0,31,27,127,127,127,31,31,0,63,59,255,255,255,63,63,63,0,59,63,63,63,63,28,28,0,59,63,63,63,63,8,8,0,59,63,63,63,63,0,0,0,59,63,63,63,63,2,2,0,59,63,63,63,63,7,7,7,59,63,63,63,63,15,15,31,123,127,127,127,127,31,31,63,251,255,255,255,255,63,63,252,244,255,255,255,255,255,255,248,240,255,255,255,255,255,255,241,241,255,255,255,255,255,255,227,227,255,255,255,255,255,255,199,199,255,255,255,255,255,255,143,135,255,255,255,255,255,255,31,23,255,255,255,255,255,255,63,55,255,255,255,255,255,255,252,244,252,255,255,255,255,255,248,240,248,255,255,255,255,255,241,241,241,255,255,255,255,255,0,0,0,0,0,0,0,0,199,199,199,255,255,255,255,255,143,135,143,255,255,255,255,255,31,23,31,255,255,255,255,255,63,55,63,255,255,255,255,255,254,244,252,252,255,255,254,0,120,112,120,120,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,7,15,15,127,127,0,0,63,23,31,31,255,255,63,0,127,55,63,63,255,255,127,127,254,246,252,252,252,254,254,0,120,116,120,120,120,124,0,0,0,48,48,48,48,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,6,0,0,0,15,23,15,15,15,31,0,0,63,55,31,31,31,63,63,0,127,119,63,63,63,127,127,127,254,247,254,252,252,252,254,0,120,119,125,120,120,120,0,0,0,54,58,48,48,48,0,0,0,20,20,0,0,0,0,0,0,54,46,6,6,6,0,0,15,119,95,15,15,15,0,0,63,247,191,31,31,31,63,0,127,247,127,63,63,63,127,127,254,246,255,255,252,252,252,0,120,116,127,127,120,120,120,0,0,48,62,62,48,48,48,0,0,0,62,62,34,0,0,0,0,6,62,62,6,6,6,0,15,23,127,127,15,15,15,0,63,55,255,255,31,31,31,0,127,119,255,255,63,63,63,127,254,247,255,255,255,252,252,252,120,119,127,127,127,120,120,120,0,119,127,127,127,113,48,48,0,119,127,127,127,99,0,0,0,119,127,127,127,71,6,6,15,119,127,127,127,15,15,15,63,247,255,255,255,31,31,31,127,247,255,255,255,63,63,63,255,247,255,255,255,255,252,252,255,247,255,255,255,255,248,120,255,247,255,255,255,255,241,48,255,247,255,255,255,255,227,0,255,247,255,255,255,255,199,6,255,247,255,255,255,255,143,15,255,247,255,255,255,255,31,31,255,247,255,255,255,255,63,63,252,244,255,255,255,255,255,255,248,240,255,255,255,255,255,255,16,16,28,0,0,0,0,0,0,0,28,0,0,0,0,0,4,4,28,0,0,0,0,0,143,135,255,255,255,255,255,255,31,23,255,255,255,255,255,255,63,55,255,255,255,255,255,255,120,116,124,127,127,127,0,0,120,112,120,127,127,127,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,15,7,15,127,127,127,0,0,15,23,31,127,127,127,0,0,63,55,63,255,255,255,63,0,120,116,124,124,127,124,0,0,0,48,56,56,62,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,6,14,14,62,0,0,0,15,23,31,31,127,31,0,0,63,55,63,63,255,63,63,0,120,116,124,124,124,124,0,0,0,48,56,56,56,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,6,14,14,14,0,0,0,15,23,31,31,31,31,0,0,63,55,63,63,63,63,63,0,120,116,125,124,124,124,0,0,0,48,58,56,56,0,0,0,0,0,20,16,16,0,0,0,0,0,8,0,0,0,0,0,0,0,20,4,4,0,0,0,0,6,46,14,14,0,0,0,15,23,95,31,31,31,0,0,63,55,191,63,63,63,63,0,120,116,124,127,124,124,0,0,0,48,56,62,56,56,0,0,0,0,16,28,16,16,0,0,0,0,0,28,0,0,0,0,0,0,4,28,4,4,0,0,0,6,14,62,14,14,0,0,15,23,31,127,31,31,0,0,63,55,63,255,63,63,63,0,120,116,127,127,127,124,124,0,0,48,62,62,62,56,56,0,0,0,62,62,62,16,16,0,0,0,62,62,62,0,0,0,0,0,62,62,62,4,4,0,0,6,62,62,62,14,14,0,15,23,127,127,127,31,31,0,63,55,255,255,255,63,63,0,120,119,127,127,127,127,124,124,0,119,127,127,127,127,56,56,0,119,127,127,127,127,16,16,0,119,127,127,127,127,0,0,0,119,127,127,127,127,4,4,0,119,127,127,127,127,14,14,15,119,127,127,127,127,31,31,63,247,255,255,255,255,63,63],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+20480);allocate([32,128,128,0,0,64,0,17,32,128,128,0,0,64,0,17,144,8,128,224,16,10,32,0,16,4,128,0,192,0,10,1,4,4,129,128,64,8,128,144,1,2,0,129,4,26,8,4,161,8,32,16,128,4,96,72,73,18,128,128,128,34,1,130,4,2,68,0,0,80,0,1,4,8,32,0,16,3,32,16,8,32,8,0,32,128,16,32,8,32,8,0,32,128,16,32,34,0,26,128,6,8,80,32,34,0,26,128,6,8,80,32,34,128,0,10,0,33,132,3,17,8,32,2,32,68,8,1,2,2,1,9,32,192,2,128,64,0,16,65,4,32,65,32,32,68,0,0,1,48,0,36,66,64,0,16,2,9,0,4,2,1,8,0,8,16,128,5,2,2,2,32,0,12,16,3,1,1,130,72,0,2,5,0,1,2,0,0,1,4,145,36,33,64,66,0,2,1,128,16,34,128,144,128,0,5,66,48,18,2,2,44,128,32,72,0,33,9,0,32,100,0,16,16,1,152,34,8,0,5,204,88,1,137,64,0,2,64,20,0,4,1,104,48,66,16,8,192,65,0,56,1,130,4,0,13,35,8,144,64,80,16,64,0,35,8,144,64,80,16,64,0,16,134,0,0,6,34,128,0,137,130,0,16,32,80,128,0,8,0,18,17,0,4,64,22,2,17,164,0,128,4,128,0,74,140,2,0,0,1,64,0,1,150,0,0,64,0,129,0,80,144,4,0,0,128,32,0,9,144,64,2,8,32,32,32,65,4,8,0,34,32,132,1,16,0,33,0,8,0,33,8,8,98,0,1,2,4,2,3,2,67,5,32,34,64,0,4,1,224,0,130,128,32,64,0,129,0,17,48,64,64,0,4,128,0,144,0,32,48,64,0,65,105,8,192,128,128,16,96,6,33,0,12,32,16,16,4,10,64,16,8,128,128,17,128,6,33,0,12,32,16,16,4,4,32,0,1,4,200,144,8,130,64,16,0,16,32,176,17,113,8,128,144,128,2,128,1,19,64,48,4,97,0,128,2,33,2,4,64,81,64,161,0,5,96,8,32,37,72,17,32,34,24,136,144,82,64,4,4,130,4,100,10,34,140,80,18,2,4,0,96,18,33,24,8,133,10,0,4,129,0,18,0,193,0,128,1,35,144,0,32,126,1,1,1,1,1,1,0,124,2,2,2,2,2,2,0,122,4,4,4,4,4,4,0,118,8,8,8,8,8,8,0,110,16,16,16,16,16,16,0,94,32,32,32,32,32,32,0,62,64,64,64,64,64,64,0,126,128,128,128,128,128,128,0,0,126,1,1,1,1,1,0,0,124,2,2,2,2,2,0,0,122,4,4,4,4,4,0,0,118,8,8,8,8,8,0,0,110,16,16,16,16,16,0,0,94,32,32,32,32,32,0,0,62,64,64,64,64,64,0,0,126,128,128,128,128,128,0,0,1,126,1,1,1,1,0,0,2,124,2,2,2,2,0,0,4,122,4,4,4,4,0,0,8,118,8,8,8,8,0,0,16,110,16,16,16,16,0,0,32,94,32,32,32,32,0,0,64,62,64,64,64,64,0,0,128,126,128,128,128,128,0,0,1,1,126,1,1,1,0,0,2,2,124,2,2,2,0,0,4,4,122,4,4,4,0,0,8,8,118,8,8,8,0,0,16,16,110,16,16,16,0,0,32,32,94,32,32,32,0,0,64,64,62,64,64,64,0,0,128,128,126,128,128,128,0,0,1,1,1,126,1,1,0,0,2,2,2,124,2,2,0,0,4,4,4,122,4,4,0,0,8,8,8,118,8,8,0,0,16,16,16,110,16,16,0,0,32,32,32,94,32,32,0,0,64,64,64,62,64,64,0,0,128,128,128,126,128,128,0,0,1,1,1,1,126,1,0,0,2,2,2,2,124,2,0,0,4,4,4,4,122,4,0,0,8,8,8,8,118,8,0,0,16,16,16,16,110,16,0,0,32,32,32,32,94,32,0,0,64,64,64,64,62,64,0,0,128,128,128,128,126,128,0,0,1,1,1,1,1,126,0,0,2,2,2,2,2,124,0,0,4,4,4,4,4,122,0,0,8,8,8,8,8,118,0,0,16,16,16,16,16,110,0,0,32,32,32,32,32,94,0,0,64,64,64,64,64,62,0,0,128,128,128,128,128,126,0,0,1,1,1,1,1,1,126,0,2,2,2,2,2,2,124,0,4,4,4,4,4,4,122,0,8,8,8,8,8,8,118,0,16,16,16,16,16,16,110,0,32,32,32,32,32,32,94,0,64,64,64,64,64,64,62,0,128,128,128,128,128,128,126,20,0,0,0,21,0,0,0,21,0,0,0,21,0,0,0,21,0,0,0,21,0,0,0,21,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,21,0,0,0,21,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,21,0,0,0,21,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,21,0,0,0,21,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,21,0,0,0,21,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,21,0,0,0,21,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,22,0,0,0,21,0,0,0,20,0,0,0,21,0,0,0,21,0,0,0,21,0,0,0,21,0,0,0,21,0,0,0,21,0,0,0,20,0,0,0,33,21,2,68,0,10,1,49,2,16,48,16,7,32,128,0,34,145,4,128,0,8,33,66,129,5,8,64,70,18,0,16,192,80,20,0,16,68,8,132,4,1,6,10,2,8,8,144,8,216,192,4,28,64,72,8,40,133,128,195,64,10,16,1,39,48,128,64,68,48,1,72,27,144,6,32,32,129,64,2,1,4,0,2,0,18,6,134,4,36,168,145,32,16,128,8,50,10,3,32,42,0,64,16,145,16,2,96,1,26,32,68,68,34,64,4,1,8,8,16,9,9,69,0,49,32,130,1,16,0,40,2,67,12,16,18,23,0,88,18,2,65,88,154,9,32,16,0,136,5,66,1,4,129,0,0,4,160,32,6,2,0,1,0,130,20,1,3,38,64,32,0,8,144,0,137,2,66,2,8,1,32,5,1,146,64,128,16,4,10,66,0,1,18,96,35,96,8,2,72,0,6,176,64,8,4,17,24,0,16,3,4,0,194,0,9,0,68,0,64,24,32,16,32,64,20,16,8,80,128,128,0,0,97,0,17,12,160,128,0,4,73,17,0,6,1,36,4,4,73,17,0,6,1,36,4,4,24,2,2,8,32,32,18,2,81,1,0,0,4,20,8,4,12,4,128,1,193,6,0,8,2,0,0,160,128,24,64,66,0,130,131,8,72,18,8,17,144,20,37,128,128,128,0,4,12,4,128,1,193,6,0,42,129,0,112,0,194,1,1,2,2,136,0,2,18,2,36,8,65,0,48,66,36,99,8,8,65,17,0,0,130,32,1,153,0,64,34,0,17,144,32,2,2,0,64,2,2,16,20,1,16,65,1,32,130,64,176,42,1,4,2,0,49,0,2,193,1,144,16,0,5,66,129,5,1,4,120,0,0,40,8,36,68,8,36,54,6,2,4,73,0,36,36,1,0,176,64,82,2,4,12,0,0,68,80,146,0,136,2,1,5,10,2,4,160,48,1,0,32,2,16,43,48,81,0,84,8,129,0,68,16,141,0,162,40,128,112,1,1,10,0,1,4,148,16,33,40,0,36,64,36,24,1,33,18,68,0,32,6,6,132,8,1,3,0,0,2,10,2,160,2,1,32,37,2,2,16,32,1,64,32,0,34,198,2,68,65,16,0,8,145,14,8,41,33,152,10,128,0,194,80,0,2,4,8,16,32,64,0,0,4,8,16,32,64,0,0,0,10,16,32,64,0,0,0,0,20,34,64,0,0,0,0,0,40,68,2,0,0,0,0,0,80,8,4,2,0,0,0,0,32,16,8,4,2,0,0,0,64,32,16,8,4,2,0,0,0,2,4,8,16,32,0,0,0,4,8,16,32,64,0,0,0,10,16,32,64,0,0,0,0,20,34,64,0,0,0,0,0,40,68,2,0,0,0,0,0,80,8,4,2,0,0,0,0,32,16,8,4,2,0,0,0,64,32,16,8,4,0,0,2,0,2,4,8,16,0,0,4,0,4,8,16,32,0,0,10,0,10,16,32,64,0,0,20,0,20,34,64,0,0,0,40,0,40,68,2,0,0,0,80,0,80,8,4,2,0,0,32,0,32,16,8,4,0,0,64,0,64,32,16,8,0,0,4,2,0,2,4,8,0,0,8,4,0,4,8,16,0,0,16,10,0,10,16,32,0,0,34,20,0,20,34,64,0,0,68,40,0,40,68,2,0,0,8,80,0,80,8,4,0,0,16,32,0,32,16,8,0,0,32,64,0,64,32,16,0,0,8,4,2,0,2,4,0,0,16,8,4,0,4,8,0,0,32,16,10,0,10,16,0,0,64,34,20,0,20,34,0,0,2,68,40,0,40,68,0,0,4,8,80,0,80,8,0,0,8,16,32,0,32,16,0,0,16,32,64,0,64,32,0,0,16,8,4,2,0,2,0,0,32,16,8,4,0,4,0,0,64,32,16,10,0,10,0,0,0,64,34,20,0,20,0,0,0,2,68,40,0,40,0,0,2,4,8,80,0,80,0,0,4,8,16,32,0,32,0,0,8,16,32,64,0,64,0,0,32,16,8,4,2,0,0,0,64,32,16,8,4,0,0,0,0,64,32,16,10,0,0,0,0,0,64,34,20,0,0,0,0,0,2,68,40,0,0,0,0,2,4,8,80,0,0,0,2,4,8,16,32,0,0,0,4,8,16,32,64,0,0,0,64,32,16,8,4,2,0,0,0,64,32,16,8,4,0,0,0,0,64,32,16,10,0,0,0,0,0,64,34,20,0,0,0,0,0,2,68,40,0,0,0,0,2,4,8,80,0,0,0,2,4,8,16,32,0,0,2,4,8,16,32,64,0,26,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,26,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,25,0,0,0,25,0,0,0,25,0,0,0,25,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,25,0,0,0,23,0,0,0,23,0,0,0,25,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,25,0,0,0,23,0,0,0,23,0,0,0,25,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,25,0,0,0,25,0,0,0,25,0,0,0,25,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,26,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,27,0,0,0,26],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+43928);allocate([2,4,8,16,32,64,128,0,5,8,16,32,64,128,0,0,10,17,32,64,128,0,0,0,20,34,65,128,0,0,0,0,40,68,130,1,0,0,0,0,80,136,4,2,1,0,0,0,160,16,8,4,2,1,0,0,64,32,16,8,4,2,1,2,0,2,4,8,16,32,64,5,0,5,8,16,32,64,128,10,0,10,17,32,64,128,0,20,0,20,34,65,128,0,0,40,0,40,68,130,1,0,0,80,0,80,136,4,2,1,0,160,0,160,16,8,4,2,1,64,0,64,32,16,8,4,2,4,2,0,2,4,8,16,32,8,5,0,5,8,16,32,64,17,10,0,10,17,32,64,128,34,20,0,20,34,65,128,0,68,40,0,40,68,130,1,0,136,80,0,80,136,4,2,1,16,160,0,160,16,8,4,2,32,64,0,64,32,16,8,4,8,4,2,0,2,4,8,16,16,8,5,0,5,8,16,32,32,17,10,0,10,17,32,64,65,34,20,0,20,34,65,128,130,68,40,0,40,68,130,1,4,136,80,0,80,136,4,2,8,16,160,0,160,16,8,4,16,32,64,0,64,32,16,8,16,8,4,2,0,2,4,8,32,16,8,5,0,5,8,16,64,32,17,10,0,10,17,32,128,65,34,20,0,20,34,65,1,130,68,40,0,40,68,130,2,4,136,80,0,80,136,4,4,8,16,160,0,160,16,8,8,16,32,64,0,64,32,16,32,16,8,4,2,0,2,4,64,32,16,8,5,0,5,8,128,64,32,17,10,0,10,17,0,128,65,34,20,0,20,34,0,1,130,68,40,0,40,68,1,2,4,136,80,0,80,136,2,4,8,16,160,0,160,16,4,8,16,32,64,0,64,32,64,32,16,8,4,2,0,2,128,64,32,16,8,5,0,5,0,128,64,32,17,10,0,10,0,0,128,65,34,20,0,20,0,0,1,130,68,40,0,40,0,1,2,4,136,80,0,80,1,2,4,8,16,160,0,160,2,4,8,16,32,64,0,64,128,64,32,16,8,4,2,0,0,128,64,32,16,8,5,0,0,0,128,64,32,17,10,0,0,0,0,128,65,34,20,0,0,0,0,1,130,68,40,0,0,0,1,2,4,136,80,0,0,1,2,4,8,16,160,0,1,2,4,8,16,32,64,0,254,1,1,1,1,1,1,1,253,2,2,2,2,2,2,2,251,4,4,4,4,4,4,4,247,8,8,8,8,8,8,8,239,16,16,16,16,16,16,16,223,32,32,32,32,32,32,32,191,64,64,64,64,64,64,64,127,128,128,128,128,128,128,128,1,254,1,1,1,1,1,1,2,253,2,2,2,2,2,2,4,251,4,4,4,4,4,4,8,247,8,8,8,8,8,8,16,239,16,16,16,16,16,16,32,223,32,32,32,32,32,32,64,191,64,64,64,64,64,64,128,127,128,128,128,128,128,128,1,1,254,1,1,1,1,1,2,2,253,2,2,2,2,2,4,4,251,4,4,4,4,4,8,8,247,8,8,8,8,8,16,16,239,16,16,16,16,16,32,32,223,32,32,32,32,32,64,64,191,64,64,64,64,64,128,128,127,128,128,128,128,128,1,1,1,254,1,1,1,1,2,2,2,253,2,2,2,2,4,4,4,251,4,4,4,4,8,8,8,247,8,8,8,8,16,16,16,239,16,16,16,16,32,32,32,223,32,32,32,32,64,64,64,191,64,64,64,64,128,128,128,127,128,128,128,128,1,1,1,1,254,1,1,1,2,2,2,2,253,2,2,2,4,4,4,4,251,4,4,4,8,8,8,8,247,8,8,8,16,16,16,16,239,16,16,16,32,32,32,32,223,32,32,32,64,64,64,64,191,64,64,64,128,128,128,128,127,128,128,128,1,1,1,1,1,254,1,1,2,2,2,2,2,253,2,2,4,4,4,4,4,251,4,4,8,8,8,8,8,247,8,8,16,16,16,16,16,239,16,16,32,32,32,32,32,223,32,32,64,64,64,64,64,191,64,64,128,128,128,128,128,127,128,128,1,1,1,1,1,1,254,1,2,2,2,2,2,2,253,2,4,4,4,4,4,4,251,4,8,8,8,8,8,8,247,8,16,16,16,16,16,16,239,16,32,32,32,32,32,32,223,32,64,64,64,64,64,64,191,64,128,128,128,128,128,128,127,128,1,1,1,1,1,1,1,254,2,2,2,2,2,2,2,253,4,4,4,4,4,4,4,251,8,8,8,8,8,8,8,247,16,16,16,16,16,16,16,239,32,32,32,32,32,32,32,223,64,64,64,64,64,64,64,191,128,128,128,128,128,128,128,127,254,3,5,9,17,33,65,129,253,7,10,18,34,66,130,2,251,14,21,36,68,132,4,4,247,28,42,73,136,8,8,8,239,56,84,146,17,16,16,16,223,112,168,36,34,33,32,32,191,224,80,72,68,66,65,64,127,192,160,144,136,132,130,129,3,254,3,5,9,17,33,65,7,253,7,10,18,34,66,130,14,251,14,21,36,68,132,4,28,247,28,42,73,136,8,8,56,239,56,84,146,17,16,16,112,223,112,168,36,34,33,32,224,191,224,80,72,68,66,65,192,127,192,160,144,136,132,130,5,3,254,3,5,9,17,33,10,7,253,7,10,18,34,66,21,14,251,14,21,36,68,132,42,28,247,28,42,73,136,8,84,56,239,56,84,146,17,16,168,112,223,112,168,36,34,33,80,224,191,224,80,72,68,66,160,192,127,192,160,144,136,132,9,5,3,254,3,5,9,17,18,10,7,253,7,10,18,34,36,21,14,251,14,21,36,68,73,42,28,247,28,42,73,136,146,84,56,239,56,84,146,17,36,168,112,223,112,168,36,34,72,80,224,191,224,80,72,68,144,160,192,127,192,160,144,136,17,9,5,3,254,3,5,9,34,18,10,7,253,7,10,18,68,36,21,14,251,14,21,36,136,73,42,28,247,28,42,73,17,146,84,56,239,56,84,146,34,36,168,112,223,112,168,36,68,72,80,224,191,224,80,72,136,144,160,192,127,192,160,144,33,17,9,5,3,254,3,5,66,34,18,10,7,253,7,10,132,68,36,21,14,251,14,21,8,136,73,42,28,247,28,42,16,17,146,84,56,239,56,84,33,34,36,168,112,223,112,168,66,68,72,80,224,191,224,80,132,136,144,160,192,127,192,160,65,33,17,9,5,3,254,3,130,66,34,18,10,7,253,7,4,132,68,36,21,14,251,14,8,8,136,73,42,28,247,28,16,16,17,146,84,56,239,56,32,33,34,36,168,112,223,112,65,66,68,72,80,224,191,224,130,132,136,144,160,192,127,192,129,65,33,17,9,5,3,254,2,130,66,34,18,10,7,253,4,4,132,68,36,21,14,251,8,8,8,136,73,42,28,247,16,16,16,17,146,84,56,239,32,32,33,34,36,168,112,223,64,65,66,68,72,80,224,191,129,130,132,136,144,160,192,127],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+64217);allocate([255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,1,0,0,0,0,0,4,4,4,4,4,4,4,4,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,2,1,0,0,0,0,8,8,8,8,8,8,8,8,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,16,16,16,16,16,16,16,16,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,128,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,32,32,32,32,32,32,32,32,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,64,64,64,64,64,64,64,64,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,1,1,1,1,1,1,1,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,2,2,2,2,2,2,2,2,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,4,2,1,0,0,0,0,0,2,2,2,2,2,2,2,2,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,4,4,4,4,4,4,4,4,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,2,1,0,0,0,0,4,4,4,4,4,4,4,4,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,8,8,8,8,8,8,8,8,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,8,8,8,8,8,8,8,8,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,16,16,16,16,16,16,16,16,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,16,16,16,16,16,16,16,16,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,128,0,0,0,0,32,32,32,32,32,32,32,32,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,32,32,32,32,32,32,32,32,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,128,0,0,0,0,0,64,64,64,64,64,64,64,64,128,64,32,16,8,4,2,1,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,64,64,64,64,64,64,64,64,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,128,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,2,2,2,2,2,2,2,2,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,8,4,2,1,0,0,0,0,2,2,2,2,2,2,2,2,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,4,4,4,4,4,4,4,4,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,4,4,4,4,4,4,4,4,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,8,8,8,8,8,8,8,8,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,8,8,8,8,8,8,8,8,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+66784);allocate([4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,16,16,16,16,16,16,16,16,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,16,16,16,16,16,16,16,16,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,32,32,32,32,32,32,32,32,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,32,32,32,32,32,32,32,32,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,128,0,0,0,0,64,64,64,64,64,64,64,64,0,128,64,32,16,8,4,2,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,64,64,64,64,64,64,64,64,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,128,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,2,2,2,2,2,2,2,2,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,16,8,4,2,1,0,0,0,2,2,2,2,2,2,2,2,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,4,4,4,4,4,4,4,4,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,4,4,4,4,4,4,4,4,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,8,8,8,8,8,8,8,8,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,8,8,8,8,8,8,8,8,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,16,16,16,16,16,16,16,16,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,16,16,16,16,16,16,16,16,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,32,32,32,32,32,32,32,32,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,32,32,32,32,32,32,32,32,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,64,64,64,64,64,64,64,64,0,0,128,64,32,16,8,4,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,64,64,64,64,64,64,64,64,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,128,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,2,2,2,2,2,2,2,2,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,32,16,8,4,2,1,0,0,2,2,2,2,2,2,2,2,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,4,4,4,4,4,4,4,4,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,4,4,4,4,4,4,4,4,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,8,8,8,8,8,8,8,8,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,8,8,8,8,8,8,8,8,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,16,16,16,16,16,16,16,16,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,16,16,16,16,16,16,16,16,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,32,32,32,32,32,32,32,32,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,32,32,32,32,32,32,32,32,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,64,64,64,64,64,64,64,64,0,0,0,128,64,32,16,8,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,64,64,64,64,64,64,64,64,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,128,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,1,1,1,1,1,1,1,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+77032);allocate([32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,2,2,2,2,2,2,2,2,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,64,32,16,8,4,2,1,0,2,2,2,2,2,2,2,2,0,0,0,0,1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,4,4,4,4,4,4,4,4,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,4,4,4,4,4,4,4,4,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,8,8,8,8,8,8,8,8,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,8,8,8,8,8,8,8,8,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,16,16,16,16,16,16,16,16,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,16,16,16,16,16,16,16,16,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,32,32,32,32,32,32,32,32,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,32,32,32,32,32,32,32,32,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,64,64,64,64,64,64,64,64,0,0,0,0,128,64,32,16,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,64,64,64,64,64,64,64,64,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,128,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,2,2,2,2,2,2,2,2,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,128,64,32,16,8,4,2,1,2,2,2,2,2,2,2,2,0,0,0,0,0,1,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,4,4,4,4,4,4,4,4,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,4,4,4,4,4,4,4,4,0,0,0,0,1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,8,8,8,8,8,8,8,8,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,8,8,8,8,8,8,8,8,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,16,16,16,16,16,16,16,16,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,16,16,16,16,16,16,16,16,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,32,32,32,32,32,32,32,32,0,0,0,0,128,64,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,32,32,32,32,32,32,32,32,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,64,64,64,64,64,64,64,64,0,0,0,0,0,128,64,32,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,64,64,64,64,64,64,64,64,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,128,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,128,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,128,64,32,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,2,2,2,0,128,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,4,4,4,4,4,4,4,4,0,0,128,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,8,8,8,8,8,8,8,8,0,0,0,128,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+87296);allocate([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,0,0,0,0,0,0,0,0,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,16,16,16,16,16,16,16,16,0,0,0,0,128,64,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,128,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,32,32,32,32,32,32,32,32,0,0,0,0,0,128,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,0,0,0,0,0,0,0,0,64,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,64,64,64,64,64,64,64,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,0,0,0,0,0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,16,32,64,128,128,128,128,128,128,128,128,128,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,0,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,0,0,0,64,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,0,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+97536);allocate([2,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,0,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,0,0,0,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,0,0,0,0,0,0,0,0,0,0,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,0,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,0,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,0,0,0,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+107882);allocate([8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,0,0,0,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,0,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,0,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,2,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+118123);allocate([16,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,0,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,4,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,64],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+128387);allocate([7,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,15,0,0,0,10,0,0,0,6,0,0,0,250,255,255,255,246,255,255,255,241,255,255,255,239,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,7,0,0,0,249,255,255,255,247,255,255,255,8,0,0,0,1,0,0,0,255,255,255,255,248,255,255,255,0,0,0,0,0,0,0,0,254,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,126,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,254,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,126,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,1,62,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,62,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,1,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,30,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,1,30,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,30,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,1,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,62,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,62,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,254,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,126,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,254,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,126,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,30,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,30,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,30,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,254,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,1,1,1,62,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,62,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,1,1,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,1,1,1,30,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,30,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,1,1,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,62,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,62,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,254,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,254,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,30,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,30,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,1,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,1,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,126,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,254,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,126,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,0,62,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,62,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,0,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,30,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,0,30,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,30,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,0,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+133628);allocate([1,1,0,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,62,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,62,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,254,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,126,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,254,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,126,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,30,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,30,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,30,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,254,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,1,1,0,62,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,62,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,1,0,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,1,1,0,30,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,30,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,1,0,14,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,14,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,1,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,1,0,0,2,1,1,1,1,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,1,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,1,0,0,6,1,1,1,1,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,62,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,62,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,62,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,254,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,254,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,126,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,30,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,30,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,30,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,30,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,14,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,14,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,14,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,1,0,2,1,1,1,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,1,0,0,0,6,1,1,1,1,1,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,1,0,6,1,1,1,0,0,0,0,2,1,1,1,0,0,0,0,6,1,1,1,1,0,0,0,2,1,1,1,1,1,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+143868);allocate([6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+154112);allocate([2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,62,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,62,1,0,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,126,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,254,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,126,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,30,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,14,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,1,0,0,0,0,0,2,1,1,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,6,1,0,0,0,0,0,0,2,1,0,0,0,0,0,0,253,2,2,2,2,2,2,2,5,2,2,2,2,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,2,125,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,125,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,13,2,2,2,2,2,2,2,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,2,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,29,2,2,2,2,2,2,2,5,2,2,2,2,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,2,29,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,29,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,13,2,2,2,2,2,2,2,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,2,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,61,2,2,2,2,2,2,2,5,2,2,2,2,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,2,61,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,61,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,13,2,2,2,2,2,2,2,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,2,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,29,2,2,2,2,2,2,2,5,2,2,2,2,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,2,29,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,29,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,13,2,2,2,2,2,2,2,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,2,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,125,2,2,2,2,2,2,2,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,125,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,253,2,2,2,2,0,0,0,5,2,2,2,2,2,2,2,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,2,2,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,2,2,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,29,2,2,2,2,2,2,2,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,29,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,29,2,2,2,2,0,0,0,5,2,2,2,2,2,2,2,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,2,2,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,2,2,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,61,2,2,2,2,2,2,2,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,61,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,61,2,2,2,2,0,0,0,5,2,2,2,2,2,2,2,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,2,2,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,2,2,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,29,2,2,2,2,2,2,2,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,29,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,29,2,2,2,2,0,0,0,5,2,2,2,2,2,2,2,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,2,2,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,2,2,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,125,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,125,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,125,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,125,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,253,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+164352);allocate([13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,2,2,2,2,2,0,5,2,2,2,2,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,0,125,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,125,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,13,2,2,2,2,2,2,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,29,2,2,2,2,2,2,0,5,2,2,2,2,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,0,29,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,29,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,13,2,2,2,2,2,2,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,61,2,2,2,2,2,2,0,5,2,2,2,2,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,0,61,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,61,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,13,2,2,2,2,2,2,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,29,2,2,2,2,2,2,0,5,2,2,2,2,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,0,29,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,29,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,13,2,2,2,2,2,2,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,2,0,0,5,2,2,2,2,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,2,2,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,2,0,0,13,2,2,2,2,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,125,2,2,2,2,2,2,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,125,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,253,2,2,2,2,0,0,0,5,2,2,2,2,2,2,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,2,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,2,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,29,2,2,2,2,2,2,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,29,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,29,2,2,2,2,0,0,0,5,2,2,2,2,2,2,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,2,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,2,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,61,2,2,2,2,2,2,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,61,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,61,2,2,2,2,0,0,0,5,2,2,2,2,2,2,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,2,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,2,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,29,2,2,2,2,2,2,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,29,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,29,2,2,2,2,0,0,0,5,2,2,2,2,2,2,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,2,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,2,0,0,0,13,2,2,2,2,2,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,2,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,2,0,0,0,5,2,2,2,2,2,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,125,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,125,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,125,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,125,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,125,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,125,2,0,0,0,0,0,0,253,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,253,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,253,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,61,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,61,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,29,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,29,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,2,2,0,0,0,0,5,2,2,2,0,0,0,0,13,2,2,0,0,0,0,0,5,2,2,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,13,2,0,0,0,0,0,0,5,2,0,0,0,0,0,0,251,4,4,4,4,4,4,4,251,4,0,0,0,0,0,0,27,4,4,4,4,4,4,0,27,4,0,0,0,0,0,0,251,4,4,4,4,0,0,0,251,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,250,4,4,4,0,0,0,0,250,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,250,4,4,4,0,0,0,0,250,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,0,11,4,4,4,4,4,4,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,27,4,4,4,4,4,4,4,27,4,0,0,0,0,0,0,123,4,4,4,4,4,4,0,123,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,123,4,4,4,4,0,0,0,123,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,122,4,4,4,0,0,0,0,122,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,122,4,4,4,0,0,0,0,122,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,251,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,250,4,4,0,0,0,0,0,250,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,250,4,4,0,0,0,0,0,250,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,0,11,4,4,4,4,4,4,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,59,4,4,4,4,4,4,4,59,4,0,0,0,0,0,0,27,4,4,4,4,4,4,0,27,4,0,0,0,0,0,0,59,4,4,4,4,0,0,0,59,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,0,11,4,4,4,4,4,4,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,27,4,4,4,4,4,4,4,27,4,0,0,0,0,0,0,59,4,4,4,4,4,4,0,59,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,59,4,4,4,4,0,0,0,59,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,0,11,4,4,4,4,4,4,0,11,4,0,0,0,0,0,0,11,4,4,4,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+174592);allocate([11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,123,4,4,4,4,4,4,4,123,4,0,0,0,0,0,0,27,4,4,4,4,4,4,0,27,4,0,0,0,0,0,0,123,4,4,4,4,0,0,0,123,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,122,4,4,4,0,0,0,0,122,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,122,4,4,4,0,0,0,0,122,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,251,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,251,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,250,4,4,0,0,0,0,0,250,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,250,4,4,0,0,0,0,0,250,4,0,0,0,0,0,0,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,0,11,4,4,4,4,4,4,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,27,4,4,4,4,4,4,4,27,4,0,0,0,0,0,0,251,4,4,4,4,4,4,0,251,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,251,4,4,4,4,0,0,0,251,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,250,4,4,4,0,0,0,0,250,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,250,4,4,4,0,0,0,0,250,4,0,0,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,0,11,4,4,4,4,4,4,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,59,4,4,4,4,4,4,4,59,4,0,0,0,0,0,0,27,4,4,4,4,4,4,0,27,4,0,0,0,0,0,0,59,4,4,4,4,0,0,0,59,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,0,11,4,4,4,4,4,4,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,27,4,4,4,4,4,4,4,27,4,0,0,0,0,0,0,59,4,4,4,4,4,4,0,59,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,59,4,4,4,4,0,0,0,59,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,0,11,4,4,4,4,4,4,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,251,4,4,4,0,0,0,0,251,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,251,4,4,4,0,0,0,0,251,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,4,4,4,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,4,0,0,250,4,0,0,0,0,0,0,250,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,123,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,123,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,122,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,122,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,123,4,4,4,0,0,0,0,123,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,123,4,4,4,0,0,0,0,123,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,4,0,0,122,4,0,0,0,0,0,0,122,4,4,4,4,4,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,122,4,0,0,0,0,0,0,122,4,4,4,4,0,0,0,251,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,4,4,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,4,0,0,58,4,0,0,0,0,0,0,58,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,4,0,0,58,4,0,0,0,0,0,0,58,4,4,4,4,4,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,4,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,123,4,4,4,0,0,0,0,123,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,123,4,4,4,0,0,0,0,123,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,4,4,4,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,4,0,0,122,4,0,0,0,0,0,0,122,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,251,4,4,4,0,0,0,0,251,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,251,4,4,4,0,0,0,0,251,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,4,0,0,250,4,0,0,0,0,0,0,250,4,4,4,4,4,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,250,4,0,0,0,0,0,0,250,4,4,4,4,0,0,0,123,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,123,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,122,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,59,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,4,4,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,4,0,0,58,4,0,0,0,0,0,0,58,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,4,0,0,58,4,0,0,0,0,0,0,58,4,4,4,4,4,0,0,26,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,4,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,4,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,4,4,4,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,4,0,0,251,4,0,0,0,0,0,0,251,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,250,4,0,0,0,0,0,0,250,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,123,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,123,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,4,0,0,123,4,0,0,0,0,0,0,123,4,4,4,4,4,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,123,4,0,0,0,0,0,0,123,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,4,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,4,4,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,4,0,0,59,4,0,0,0,0,0,0,59,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,4,0,0,59,4,0,0,0,0,0,0,59,4,4,4,4,4,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,4,4,4,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,4,0,0,123,4,0,0,0,0,0,0,123,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,122,4,0,0,0,0,0,0,122,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,4,0,0,251,4,0,0,0,0,0,0,251,4,4,4,4,4,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,251,4,0,0,0,0,0,0,251,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,250,4,0,0,0,0,0,0,250,4,4,4,0,0,0,0,123,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,123,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,4,4,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,4,0,0,59,4,0,0,0,0,0,0,59,4,4,4,4,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,4,0,0,59,4,0,0,0,0,0,0,59,4,4,4,4,4,0,0,27,4,0,0,0,0,0,0,27,4,4,4,4,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,4,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,4,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,4,0,0,11,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+184832);allocate([11,4,4,4,4,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,250,4,4,4,4,4,4,4,250,4,0,0,0,0,0,0,26,4,4,4,4,4,4,0,26,4,0,0,0,0,0,0,250,4,4,4,4,0,0,0,250,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,0,10,4,4,4,4,4,4,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,4,0,0,0,0,26,4,4,4,4,4,4,4,26,4,0,0,0,0,0,0,122,4,4,4,4,4,4,0,122,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,122,4,4,4,4,0,0,0,122,4,0,0,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,250,4,4,0,0,0,0,0,250,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,250,4,4,0,0,0,0,0,250,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,0,10,4,4,4,4,4,4,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,58,4,4,4,4,4,4,4,58,4,0,0,0,0,0,0,26,4,4,4,4,4,4,0,26,4,0,0,0,0,0,0,58,4,4,4,4,0,0,0,58,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,0,10,4,4,4,4,4,4,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,26,4,4,4,4,4,4,4,26,4,0,0,0,0,0,0,58,4,4,4,4,4,4,0,58,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,58,4,4,4,4,0,0,0,58,4,0,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,0,10,4,4,4,4,4,4,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,122,4,4,4,4,4,4,4,122,4,0,0,0,0,0,0,26,4,4,4,4,4,4,0,26,4,0,0,0,0,0,0,122,4,4,4,4,0,0,0,122,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,250,4,4,0,0,0,0,0,250,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,250,4,4,0,0,0,0,0,250,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,0,10,4,4,4,4,4,4,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,251,4,0,0,0,0,0,0,251,4,4,4,0,0,0,0,26,4,4,4,4,4,4,4,26,4,0,0,0,0,0,0,250,4,4,4,4,4,4,0,250,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,250,4,4,4,4,0,0,0,250,4,0,0,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,123,4,0,0,0,0,0,0,123,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,122,4,0,0,0,0,0,0,122,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,0,10,4,4,4,4,4,4,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,58,4,4,4,4,4,4,4,58,4,0,0,0,0,0,0,26,4,4,4,4,4,4,0,26,4,0,0,0,0,0,0,58,4,4,4,4,0,0,0,58,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,26,4,0,0,0,0,0,0,26,4,4,0,0,0,0,0,58,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,0,10,4,4,4,4,4,4,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,4,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,4,0,0,0,0,26,4,4,4,4,4,4,4,26,4,0,0,0,0,0,0,58,4,4,4,4,4,4,0,58,4,0,0,0,0,0,0,26,4,4,4,4,0,0,0,26,4,0,0,0,0,0,0,58,4,4,4,4,0,0,0,58,4,0,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,59,4,0,0,0,0,0,0,59,4,4,0,0,0,0,0,27,4,0,0,0,0,0,0,27,4,4,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,58,4,0,0,0,0,0,0,58,4,4,0,0,0,0,0,26,4,4,0,0,0,0,0,26,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,4,0,0,0,0,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,0,10,4,4,4,4,4,4,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,10,4,4,4,4,0,0,0,10,4,0,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,11,4,0,0,0,0,0,0,11,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,0,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,4,0,0,0,0,0,10,4,0,0,0,0,0,0,247,8,8,8,8,8,8,8,247,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,246,8,8,8,8,8,8,8,246,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,244,8,8,8,8,8,8,8,244,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,8,8,8,8,244,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,8,8,8,0,244,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,8,8,8,0,244,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,247,8,8,8,8,8,8,0,247,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,246,8,8,8,8,8,8,0,246,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,8,8,8,8,23,8,0,0,0,0,0,0,247,8,8,8,8,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,8,8,8,8,22,8,0,0,0,0,0,0,246,8,8,8,8,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,0,244,8,8,8,8,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,0,244,8,8,8,8,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,8,0,20,8,0,0,0,0,0,0,244,8,8,8,8,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,8,0,20,8,0,0,0,0,0,0,244,8,8,8,8,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,23,8,8,8,8,8,8,0,23,8,0,0,0,0,0,0,247,8,8,8,8,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,8,8,8,0,22,8,0,0,0,0,0,0,246,8,8,8,8,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,55,8,8,8,8,8,8,8,55,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,8,8,8,8,54,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,52,8,8,8,8,8,8,8,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,8,8,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,8,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,8,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,55,8,8,8,8,8,8,0,55,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,8,8,8,0,54,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,8,8,8,8,23,8,0,0,0,0,0,0,55,8,8,8,8,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,22,8,8,8,8,8,8,8,22,8,0,0,0,0,0,0,54,8,8,8,8,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,8,8,8,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,8,8,8,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,23,8,8,8,8,8,8,0,23,8,0,0,0,0,0,0,55,8,8,8,8,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,22,8,8,8,8,8,8,0,22,8,0,0,0,0,0,0,54,8,8,8,8,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,119,8,8,8,8,8,8,8,119,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,118,8,8,8,8,8,8,8,118,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,116,8,8,8,8,8,8,8,116,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,8,8,8,8,116,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,8,8,8,0,116,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,8,8,8,0,116,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,119,8,8,8,8,8,8,0,119,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,118,8,8,8,8,8,8,0,118,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,8,8,8,8,23,8,0,0,0,0,0,0,119,8,8,8,8,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,22,8,8,8,8,8,8,8,22,8,0,0,0,0,0,0,118,8,8,8,8,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,0,116,8,8,8,8,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,0,116,8,8,8,8,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,8,8,8,0,20,8,0,0,0,0,0,0,116,8,8,8,8,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,8,8,8,0,20,8,0,0,0,0,0,0,116,8,8,8,8,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,23,8,8,8,8,8,8,0,23,8,0,0,0,0,0,0,119,8,8,8,8,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,22,8,8,8,8,8,8,0,22,8,0,0,0,0,0,0,118,8,8,8,8,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,55,8,8,8,8,8,8,8,55,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,8,8,8,8,54,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,52,8,8,8,8,8,8,8,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,8,8,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,8,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,8,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,55,8,8,8,8,8,8,0,55,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,8,8,8,0,54,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,8,8,8,8,23,8,0,0,0,0,0,0,55,8,8,8,8,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,8,8,8,8,22,8,0,0,0,0,0,0,54,8,8,8,8,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,8,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,8,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,23,8,8,8,8,8,8,0,23,8,0,0,0,0,0,0,55,8,8,8,8,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,8,8,8,0,22,8,0,0,0,0,0,0,54,8,8,8,8,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,55,8,8,8,8,8,0,0,55,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,8,8,0,0,54,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,52,8,8,8,8,8,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,55,8,8,8,8,8,0,0,55,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,8,8,0,0,54,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,8,8,0,0,23,8,0,0,0,0,0,0,55,8,8,8,8,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,22,8,8,8,8,8,0,0,22,8,0,0,0,0,0,0,54,8,8,8,8,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,23,8,8,8,8,8,0,0,23,8,0,0,0,0,0,0,55,8,8,8,8,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,22,8,8,8,8,8,0,0,22,8,0,0,0,0,0,0,54,8,8,8,8,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,247,8,8,8,8,8,0,0,247,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,246,8,8,8,8,8,0,0,246,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,244,8,8,8,8,8,0,0,244,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,8,8,0,0,244,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,8,8,0,0,244,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,8,8,0,0,244,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,247,8,8,8,8,8,0,0,247,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,246,8,8,8,8,8,0,0,246,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,8,8,0,0,23,8,0,0,0,0,0,0,247,8,8,8,8,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,8,8,0,0,22,8,0,0,0,0,0,0,246,8,8,8,8,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,244,8,8,8,8,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,244,8,8,8,8,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,244,8,8,8,8,0,0,0,244,8,0,0,0,0,0,0,20,8,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+195072);allocate([20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,244,8,8,8,8,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,23,8,8,8,8,8,0,0,23,8,0,0,0,0,0,0,247,8,8,8,8,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,8,8,0,0,22,8,0,0,0,0,0,0,246,8,8,8,8,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,55,8,8,8,8,8,0,0,55,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,8,8,0,0,54,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,52,8,8,8,8,8,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,8,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,55,8,8,8,8,8,0,0,55,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,8,8,0,0,54,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,8,8,0,0,23,8,0,0,0,0,0,0,55,8,8,8,8,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,8,8,0,0,22,8,0,0,0,0,0,0,54,8,8,8,8,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,52,8,8,8,8,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,23,8,8,8,8,8,0,0,23,8,0,0,0,0,0,0,55,8,8,8,8,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,8,8,0,0,22,8,0,0,0,0,0,0,54,8,8,8,8,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,119,8,8,8,8,8,0,0,119,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,118,8,8,8,8,8,0,0,118,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,116,8,8,8,8,8,0,0,116,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,8,8,0,0,116,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,8,8,0,0,116,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,8,8,0,0,116,8,0,0,0,0,0,0,20,8,8,8,8,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,119,8,8,8,8,8,0,0,119,8,0,0,0,0,0,0,23,8,8,8,8,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,118,8,8,8,8,8,0,0,118,8,0,0,0,0,0,0,22,8,8,8,8,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,8,8,0,0,23,8,0,0,0,0,0,0,119,8,8,8,8,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,22,8,8,8,8,8,0,0,22,8,0,0,0,0,0,0,118,8,8,8,8,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,116,8,8,8,8,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,116,8,8,8,8,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,116,8,8,8,8,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,8,8,0,0,20,8,0,0,0,0,0,0,116,8,8,8,8,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,23,8,8,8,8,8,0,0,23,8,0,0,0,0,0,0,119,8,8,8,8,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,22,8,8,8,8,8,0,0,22,8,0,0,0,0,0,0,118,8,8,8,8,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,247,8,8,8,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,246,8,8,8,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,247,8,8,8,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,246,8,8,8,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,8,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,8,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,8,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,8,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,119,8,8,8,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,118,8,8,8,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,119,8,8,8,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,118,8,8,8,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,8,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,8,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,8,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,8,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,0,0,0,0,0,116,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,0,0,0,0,0,119,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,0,0,0,0,0,118,8,0,0,0,0,0,0,247,8,8,8,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,246,8,8,8,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,247,8,8,8,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,246,8,8,8,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,8,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,8,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,8,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,8,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,8,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,8,0,0,0,0,52,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,52,8,8,0,0,0,0,0,52,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,8,0,0,0,0,55,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,55,8,8,0,0,0,0,0,55,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,8,0,0,0,0,54,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,54,8,8,0,0,0,0,0,54,8,0,0,0,0,0,0,119,8,8,8,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,118,8,8,8,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,119,8,8,8,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,118,8,8,8,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,8,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,8,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+205312);allocate([20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,20,8,8,8,0,0,0,0,20,8,0,0,0,0,0,0,116,8,8,8,0,0,0,0,116,8,0,0,0,0,0,0,20,8,8,0,0,0,0,0,20,8,0,0,0,0,0,0,244,8,8,0,0,0,0,0,244,8,0,0,0,0,0,0,23,8,8,8,0,0,0,0,23,8,0,0,0,0,0,0,119,8,8,8,0,0,0,0,119,8,0,0,0,0,0,0,23,8,8,0,0,0,0,0,23,8,0,0,0,0,0,0,247,8,8,0,0,0,0,0,247,8,0,0,0,0,0,0,22,8,8,8,0,0,0,0,22,8,0,0,0,0,0,0,118,8,8,8,0,0,0,0,118,8,0,0,0,0,0,0,22,8,8,0,0,0,0,0,22,8,0,0,0,0,0,0,246,8,8,0,0,0,0,0,246,8,0,0,0,0,0,0,239,16,16,16,16,16,16,16,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,239,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,16,16,16,16,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,16,16,16,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,16,16,16,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,16,16,16,16,16,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,16,16,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,16,16,16,16,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,16,16,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,16,16,16,16,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,16,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,16,16,16,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,16,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,239,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,239,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,0,0,0,0,0,0,47,16,16,16,16,16,16,16,239,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,47,16,16,16,16,16,0,0,239,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,46,16,16,16,16,16,16,16,238,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,46,16,16,16,16,16,0,0,238,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,16,16,16,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,16,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,16,16,16,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,16,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,40,16,16,16,16,16,16,16,232,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,232,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,40,16,16,16,16,16,16,16,232,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,232,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,16,16,16,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,16,16,16,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,47,16,16,16,16,0,0,0,239,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,47,16,16,16,16,0,0,0,239,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,46,16,16,16,16,0,0,0,238,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,46,16,16,16,16,0,0,0,238,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,111,16,16,16,16,16,16,16,47,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,111,16,16,16,16,16,0,0,47,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,110,16,16,16,16,16,16,16,46,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,110,16,16,16,16,16,0,0,46,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,16,16,16,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,16,0,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,16,16,16,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,16,0,0,44,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,104,16,16,16,16,16,16,16,40,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,104,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,104,16,16,16,16,16,16,16,40,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,104,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,16,16,16,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,16,16,16,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,111,16,16,16,16,0,0,0,47,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,111,16,16,16,16,0,0,0,47,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,110,16,16,16,16,0,0,0,46,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,110,16,16,16,16,0,0,0,46,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,111,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,47,16,16,16,16,16,16,16,111,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,47,16,16,16,16,16,0,0,110,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,46,16,16,16,16,16,16,16,110,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,46,16,16,16,16,16,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,16,16,16,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,16,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,16,16,16,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,16,0,0,104,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,40,16,16,16,16,16,16,16,104,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,104,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,40,16,16,16,16,16,16,16,104,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,16,16,16,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,16,16,16,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,111,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,47,16,16,16,16,0,0,0,111,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,47,16,16,16,16,0,0,0,110,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,46,16,16,16,16,0,0,0,110,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,46,16,16,16,16,0,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,239,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,239,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,239,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,239,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,16,16,16,16,16,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,16,16,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,16,16,16,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,16,16,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,16,16,16,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,16,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,16,16,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,16,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,239,16,16,16,16,16,16,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,239,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,16,16,16,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,16,16,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,16,16,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,239,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,239,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,239,16,0,0,0,0,0,0,40,16,16,16,16,16,16,0,232,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,232,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,40,16,16,16,16,16,16,0,232,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,232,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,16,16,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,16,16,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,47,16,16,16,16,16,16,0,239,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,47,16,16,16,16,16,0,0,239,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,46,16,16,16,16,16,16,0,238,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,46,16,16,16,16,16,0,0,238,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,16,16,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,16,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,16,16,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,16,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,232,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,47,16,16,16,16,0,0,0,239,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+215552);allocate([47,16,16,16,16,0,0,0,239,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,46,16,16,16,16,0,0,0,238,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,46,16,16,16,16,0,0,0,238,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,236,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,104,16,16,16,16,16,16,0,40,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,104,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,104,16,16,16,16,16,16,0,40,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,104,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,16,16,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,16,16,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,16,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,111,16,16,16,16,16,16,0,47,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,111,16,16,16,16,16,0,0,47,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,110,16,16,16,16,16,16,0,46,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,110,16,16,16,16,16,0,0,46,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,16,16,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,16,0,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,16,16,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,16,0,0,44,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,16,16,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,111,16,16,16,16,0,0,0,47,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,111,16,16,16,16,0,0,0,47,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,110,16,16,16,16,0,0,0,46,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,110,16,16,16,16,0,0,0,46,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,108,16,16,16,16,0,0,0,44,16,0,0,0,0,0,0,104,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,40,16,16,16,16,16,16,0,104,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,104,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,40,16,16,16,16,16,16,0,104,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,16,16,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,16,16,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,16,0,0,111,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,47,16,16,16,16,16,16,0,111,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,47,16,16,16,16,16,0,0,110,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,46,16,16,16,16,16,16,0,110,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,46,16,16,16,16,16,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,16,16,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,16,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,16,16,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,16,0,0,104,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,104,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,40,16,16,16,16,0,0,0,111,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,47,16,16,16,16,0,0,0,111,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,47,16,16,16,16,0,0,0,110,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,46,16,16,16,16,0,0,0,110,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,46,16,16,16,16,0,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,108,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,44,16,16,16,16,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,239,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,239,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,232,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,232,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,239,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,239,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,239,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,238,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,238,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,236,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,236,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,232,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,239,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,238,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,236,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,0,0,0,0,0,40,16,0,0,0,0,0,0,104,16,16,16,0,0,0,0,40,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,0,0,0,0,0,47,16,0,0,0,0,0,0,111,16,16,16,0,0,0,0,47,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,0,0,0,0,0,46,16,0,0,0,0,0,0,110,16,16,16,0,0,0,0,46,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,0,0,0,0,0,44,16,0,0,0,0,0,0,108,16,16,16,0,0,0,0,44,16,0,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,0,0,0,0,0,104,16,0,0,0,0,0,0,40,16,16,16,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,0,0,0,0,0,111,16,0,0,0,0,0,0,47,16,16,16,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,0,0,0,0,0,110,16,0,0,0,0,0,0,46,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,0,0,0,0,0,108,16,0,0,0,0,0,0,44,16,16,16,0,0,0,0,223,32,32,32,32,32,32,32,92,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,95,32,32,32,32,32,32,0,223,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,222,32,32,32,32,32,0,0,95,32,0,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,94,32,32,32,32,32,0,0,222,32,32,0,0,0,0,0,222,32,32,32,32,32,32,32,92,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,94,32,32,32,32,32,32,0,222,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,223,32,32,32,32,32,0,0,94,32,0,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,95,32,32,32,32,32,0,0,223,32,32,0,0,0,0,0,220,32,32,32,32,32,32,32,95,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,92,32,32,32,32,32,32,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,220,32,32,32,32,32,0,0,92,32,0,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,32,32,0,0,220,32,32,0,0,0,0,0,220,32,32,32,32,32,32,32,94,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,92,32,32,32,32,32,32,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,220,32,32,32,32,32,0,0,92,32,0,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,32,32,0,0,220,32,32,0,0,0,0,0,216,32,32,32,32,32,32,32,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,32,32,32,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,32,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,32,0,0,216,32,32,0,0,0,0,0,216,32,32,32,32,32,32,32,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,32,32,32,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,32,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,32,0,0,216,32,32,0,0,0,0,0,216,32,32,32,32,32,32,32,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,32,32,32,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,32,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,32,0,0,216,32,32,0,0,0,0,0,216,32,32,32,32,32,32,32,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,32,32,32,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,32,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,32,0,0,216,32,32,0,0,0,0,0,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,32,32,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,32,32,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,32,32,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,32,32,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,32,32,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,32,32,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,32,32,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,32,32,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,223,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,95,32,32,32,0,0,0,0,223,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,222,32,32,32,0,0,0,0,95,32,0,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,94,32,32,32,0,0,0,0,222,32,32,0,0,0,0,0,222,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,94,32,32,32,0,0,0,0,222,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,223,32,32,32,0,0,0,0,94,32,0,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,95,32,32,32,0,0,0,0,223,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,95,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,94,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+225792);allocate([208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,95,32,32,32,32,32,32,32,223,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,223,32,32,32,32,32,32,0,92,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,94,32,32,32,32,32,0,0,222,32,32,0,0,0,0,0,222,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,222,32,32,32,32,32,0,0,95,32,0,0,0,0,0,0,94,32,32,32,32,32,32,32,222,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,222,32,32,32,32,32,32,0,92,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,95,32,32,32,32,32,0,0,223,32,32,0,0,0,0,0,223,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,223,32,32,32,32,32,0,0,94,32,0,0,0,0,0,0,92,32,32,32,32,32,32,32,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,32,32,32,32,32,0,95,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,32,32,0,0,220,32,32,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,220,32,32,32,32,32,0,0,92,32,0,0,0,0,0,0,92,32,32,32,32,32,32,32,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,32,32,32,32,32,0,94,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,32,32,0,0,220,32,32,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,220,32,32,32,32,32,0,0,92,32,0,0,0,0,0,0,88,32,32,32,32,32,32,32,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,32,32,32,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,32,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,32,0,0,88,32,0,0,0,0,0,0,88,32,32,32,32,32,32,32,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,32,32,32,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,32,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,32,0,0,88,32,0,0,0,0,0,0,88,32,32,32,32,32,32,32,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,32,32,32,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,32,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,32,0,0,88,32,0,0,0,0,0,0,88,32,32,32,32,32,32,32,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,32,32,32,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,32,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,32,0,0,88,32,0,0,0,0,0,0,80,32,32,32,32,32,32,32,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,32,32,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,32,32,32,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,32,32,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,32,32,32,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,32,32,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,32,32,32,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,32,32,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,32,32,32,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,32,32,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,32,32,32,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,32,32,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,32,32,32,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,32,32,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,32,32,32,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,32,32,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,32,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,32,0,0,80,32,0,0,0,0,0,0,95,32,32,32,0,0,0,0,223,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,223,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,94,32,32,32,0,0,0,0,222,32,32,0,0,0,0,0,222,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,222,32,32,32,0,0,0,0,95,32,0,0,0,0,0,0,94,32,32,32,0,0,0,0,222,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,222,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,95,32,32,32,0,0,0,0,223,32,32,0,0,0,0,0,223,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,223,32,32,32,0,0,0,0,94,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,32,32,0,0,0,0,95,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,32,32,0,0,0,0,94,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,220,32,32,32,32,0,0,0,95,32,0,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,32,0,0,0,220,32,32,0,0,0,0,0,223,32,32,32,32,0,0,0,94,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,95,32,32,32,32,0,0,0,223,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,220,32,32,32,32,0,0,0,94,32,0,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,32,0,0,0,220,32,32,0,0,0,0,0,222,32,32,32,32,0,0,0,95,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,94,32,32,32,32,0,0,0,222,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,223,32,32,32,32,0,0,0,92,32,0,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,95,32,32,32,32,0,0,0,223,32,32,0,0,0,0,0,220,32,32,32,32,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,92,32,32,32,32,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,222,32,32,32,32,0,0,0,92,32,0,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,94,32,32,32,32,0,0,0,222,32,32,0,0,0,0,0,220,32,32,32,32,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,92,32,32,32,32,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,95,32,0,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,223,32,32,32,0,0,0,0,94,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,95,32,32,32,0,0,0,0,223,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,94,32,0,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,222,32,32,32,0,0,0,0,95,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,94,32,32,32,0,0,0,0,222,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,223,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,95,32,32,32,0,0,0,0,223,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,222,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,94,32,32,32,0,0,0,0,222,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,32,0,0,0,220,32,32,0,0,0,0,0,220,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,220,32,32,32,32,0,0,0,95,32,0,0,0,0,0,0,95,32,32,32,32,0,0,0,223,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,223,32,32,32,32,0,0,0,94,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,32,0,0,0,220,32,32,0,0,0,0,0,220,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,220,32,32,32,32,0,0,0,94,32,0,0,0,0,0,0,94,32,32,32,32,0,0,0,222,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,222,32,32,32,32,0,0,0,95,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,95,32,32,32,32,0,0,0,223,32,32,0,0,0,0,0,223,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,223,32,32,32,32,0,0,0,92,32,0,0,0,0,0,0,92,32,32,32,32,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,32,32,32,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,94,32,32,32,32,0,0,0,222,32,32,0,0,0,0,0,222,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,222,32,32,32,32,0,0,0,92,32,0,0,0,0,0,0,92,32,32,32,32,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,32,32,32,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,88,32,32,32,32,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,32,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+236032);allocate([80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,32,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,32,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,220,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,95,32,0,0,0,0,0,0,95,32,32,32,0,0,0,0,223,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,223,32,32,32,0,0,0,0,94,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,220,32,0,0,0,0,0,0,94,32,32,0,0,0,0,0,220,32,32,32,0,0,0,0,94,32,0,0,0,0,0,0,94,32,32,32,0,0,0,0,222,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,222,32,32,32,0,0,0,0,95,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,95,32,32,0,0,0,0,0,95,32,0,0,0,0,0,0,223,32,0,0,0,0,0,0,95,32,32,32,0,0,0,0,223,32,32,0,0,0,0,0,223,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,223,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,94,32,0,0,0,0,0,0,222,32,0,0,0,0,0,0,94,32,32,32,0,0,0,0,222,32,32,0,0,0,0,0,222,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,222,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,92,32,32,32,0,0,0,0,220,32,32,0,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,220,32,32,32,0,0,0,0,92,32,0,0,0,0,0,0,220,32,0,0,0,0,0,0,92,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,88,32,32,32,0,0,0,0,216,32,32,0,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,216,32,32,32,0,0,0,0,88,32,0,0,0,0,0,0,216,32,0,0,0,0,0,0,88,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,80,32,32,32,0,0,0,0,208,32,32,0,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,208,32,32,32,0,0,0,0,80,32,0,0,0,0,0,0,208,32,0,0,0,0,0,0,80,32,32,0,0,0,0,0,191,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,190,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,191,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,190,64,64,64,64,64,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,176,64,64,64,64,64,64,64,191,64,0,0,0,0,0,0,176,64,64,64,64,64,64,0,190,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,190,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,191,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,64,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,176,64,64,64,64,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,190,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,190,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,190,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,191,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,190,64,64,64,64,64,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,176,64,64,64,64,64,64,0,191,64,0,0,0,0,0,0,176,64,64,64,64,64,64,64,190,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,190,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,191,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,64,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,176,64,64,64,64,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,190,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,190,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,188,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,191,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,64,0,0,176,64,64,64,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,64,64,64,64,64,188,64,0,0,0,0,0,0,176,64,64,64,64,64,64,0,188,64,0,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,191,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,191,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,0,0,0,176,64,64,64,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,188,64,0,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,191,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,188,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,191,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,64,0,0,176,64,64,64,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,64,64,64,64,0,188,64,0,0,0,0,0,0,176,64,64,64,64,64,64,64,188,64,0,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,191,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,191,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,191,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,190,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,64,0,0,0,176,64,64,64,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,188,64,0,0,0,0,0,0,191,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+246272);allocate([176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,184,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,64,64,64,184,64,0,0,0,0,0,0,176,64,64,64,64,64,64,0,184,64,0,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,64,64,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,64,64,184,64,0,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,190,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,190,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,188,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,184,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,64,64,184,64,0,0,0,0,0,0,176,64,64,64,64,64,64,0,184,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,176,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,64,0,0,0,0,0,0,0,0,0,184,64,64,64,64,64,64,64,0,0,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,64,0,184,64,0,0,0,0,0,0,176,64,64,64,64,64,64,64,184,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,176,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,176,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,0,160,64,0,0,0,0,0,0,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,188,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,184,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,176,64,64,0,0,0,0,0,188,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,0,0,0,0,0,160,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,0,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,184,64,64,64,64,0,0,0,0,0,0,0,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,0,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,176,64,64,64,64,0,0,0,184,64,0,0,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,176,64,0,0,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,0,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,160,64,64,64,64,0,0,0,160,64,0,0,0,0,0,0,127,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,127,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,126,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,126,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,124,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+256512);allocate([64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,126,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,127,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,127,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,127,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,126,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,126,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,120,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,127,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,126,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,126,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,127,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,127,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,128,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,126,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,127,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,126,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,126,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,124,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,126,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,127,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+266752);allocate([64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,127,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,127,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,126,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,126,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,120,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,127,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,126,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,126,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,127,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,127,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,128,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,126,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,127,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,126,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,126,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,126,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,127,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,127,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,127,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,126,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,126,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,127,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,64,128,128,128,128,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+276992);allocate([96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,126,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,126,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,127,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,120,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,127,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,126,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,127,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,126,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,126,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,126,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,127,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,124,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,120,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,96,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,112,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,127,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,127,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,126,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,126,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,127,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,126,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,64,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,126,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,120,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,127,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,124,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,120,128,128,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,120,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,120,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,127,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,112,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,127,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,64,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+287232);allocate([112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,124,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,124,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,96,128,0,0,0,0,0,0,64,128,128,128,128,128,0,0,112,128,128,0,0,0,0,0,64,128,0,0,0,0,0,0,126,128,0,0,0,0,0,0,96,128,128,0,0,0,0,0,64,128,128,128,0,0,0,0,96,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,112,128,128,0,0,0,0,0,64,128,128,128,128,0,0,0,126,128,0,0,0,0,0,0,64,128,0,0,0,0,0,0,1,254,1,1,1,1,1,1,1,6,1,1,1,1,1,0,1,254,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,126,1,1,1,1,1,1,1,6,1,1,1,1,1,0,1,126,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,254,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,254,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,126,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,126,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,254,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,126,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,126,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,254,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,254,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,126,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,126,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,30,1,1,1,1,1,0,1,6,1,1,1,1,0,0,1,30,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,30,1,1,1,1,1,0,1,6,1,1,1,1,0,0,1,30,1,1,1,1,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,1,1,1,1,1,1,6,1,1,1,1,1,0,1,14,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,14,1,1,1,1,1,1,1,6,1,1,1,1,1,0,1,14,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,14,1,1,1,1,1,0,1,6,1,1,1,1,0,0,1,14,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,14,1,1,1,1,1,0,1,6,1,1,1,1,0,0,1,14,1,1,1,1,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,1,1,1,1,0,1,30,1,1,1,1,1,1,1,6,1,1,1,1,0,0,1,30,1,1,1,1,0,0,1,6,1,1,1,1,1,0,1,30,1,1,1,1,1,1,1,6,1,1,1,1,0,0,1,30,1,1,1,1,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,254,1,1,1,1,1,0,1,6,1,1,1,1,1,1,1,254,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,126,1,1,1,1,1,0,1,6,1,1,1,1,1,1,1,126,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,254,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,254,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,126,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,126,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,254,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,126,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,126,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,254,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,254,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,126,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,126,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,1,1,1,1,0,1,14,1,1,1,1,1,1,1,6,1,1,1,1,0,0,1,14,1,1,1,1,0,0,1,6,1,1,1,1,1,0,1,14,1,1,1,1,1,1,1,6,1,1,1,1,0,0,1,14,1,1,1,1,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,1,1,1,1,0,1,6,1,1,1,1,1,1,1,14,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,14,1,1,1,1,1,0,1,6,1,1,1,1,1,1,1,14,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,62,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,62,1,1,1,1,1,1,1,6,1,1,1,1,1,0,1,62,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,62,1,1,1,1,1,1,1,6,1,1,1,1,1,0,1,62,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,62,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,62,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,62,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,1,1,1,0,0,1,30,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,30,1,1,1,1,1,0,1,6,1,1,1,1,0,0,1,30,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,30,1,1,1,1,1,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+297472);allocate([1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,14,1,1,1,1,1,1,1,6,1,1,1,1,1,0,1,14,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,14,1,1,1,1,1,1,1,6,1,1,1,1,1,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,6,1,1,1,1,0,0,1,14,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,14,1,1,1,1,1,0,1,6,1,1,1,1,0,0,1,14,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,14,1,1,1,1,1,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,1,1,1,0,0,1,30,1,1,1,1,0,0,1,6,1,1,1,1,1,0,1,30,1,1,1,1,1,1,1,6,1,1,1,1,0,0,1,30,1,1,1,1,0,0,1,6,1,1,1,1,1,0,1,30,1,1,1,1,1,1,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,62,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,62,1,1,1,1,1,0,1,6,1,1,1,1,1,1,1,62,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,62,1,1,1,1,1,0,1,6,1,1,1,1,1,1,1,62,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,62,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,62,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,62,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,1,1,1,0,0,1,14,1,1,1,1,0,0,1,6,1,1,1,1,1,0,1,14,1,1,1,1,1,1,1,6,1,1,1,1,0,0,1,14,1,1,1,1,0,0,1,6,1,1,1,1,1,0,1,14,1,1,1,1,1,1,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,14,1,1,1,1,1,0,1,6,1,1,1,1,1,1,1,14,1,1,1,1,0,0,1,6,1,1,1,1,0,0,1,14,1,1,1,1,1,0,1,6,1,1,1,1,1,1,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,2,253,2,2,2,2,2,2,2,13,2,2,2,2,2,2,2,29,2,2,2,2,2,2,2,13,2,2,2,2,2,2,2,61,2,2,2,2,2,2,2,13,2,2,2,2,2,2,2,29,2,2,2,2,2,2,2,13,2,2,2,2,2,2,2,125,2,2,2,2,2,2,2,13,2,2,2,2,2,2,2,29,2,2,2,2,2,2,2,13,2,2,2,2,2,2,2,61,2,2,2,2,2,2,2,13,2,2,2,2,2,2,2,29,2,2,2,2,2,2,2,13,2,2,2,2,2,2,2,125,2,2,2,2,2,0,2,13,2,2,2,2,2,0,2,29,2,2,2,2,2,0,2,13,2,2,2,2,2,0,2,61,2,2,2,2,2,0,2,13,2,2,2,2,2,0,2,29,2,2,2,2,2,0,2,13,2,2,2,2,2,0,2,253,2,2,2,2,2,0,2,13,2,2,2,2,2,0,2,29,2,2,2,2,2,0,2,13,2,2,2,2,2,0,2,61,2,2,2,2,2,0,2,13,2,2,2,2,2,0,2,29,2,2,2,2,2,0,2,13,2,2,2,2,2,0,2,253,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,125,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,125,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,253,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,253,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,125,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,125,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,253,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,253,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,125,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,125,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,253,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,253,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,29,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,61,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,29,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,125,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,29,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,61,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,29,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,125,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,29,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,61,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,29,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,253,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,29,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,61,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,29,2,2,2,2,0,0,2,13,2,2,2,2,0,0,2,253,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,125,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,125,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,253,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,253,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,125,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,125,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,253,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,253,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,125,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,125,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,253,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+307712);allocate([2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,2,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,2,2,2,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,4,251,4,4,4,4,4,4,4,251,4,0,0,0,0,0,4,251,4,4,4,4,4,0,4,251,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,59,4,4,4,4,4,4,4,59,4,0,0,0,0,0,4,59,4,4,4,4,4,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,123,4,4,4,4,4,4,4,123,4,0,0,0,0,0,4,123,4,4,4,4,4,0,4,123,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,59,4,4,4,4,4,4,4,59,4,0,0,0,0,0,4,59,4,4,4,4,4,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,250,4,4,4,4,4,4,4,250,4,0,0,0,0,0,4,250,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,58,4,0,0,0,0,0,4,58,4,4,4,4,4,4,4,58,4,0,0,0,0,0,4,58,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,122,4,0,0,0,0,0,4,122,4,4,4,4,4,4,4,122,4,0,0,0,0,0,4,122,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,58,4,0,0,0,0,0,4,58,4,4,4,4,4,4,4,58,4,0,0,0,0,0,4,58,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,251,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,250,4,4,0,0,0,0,4,250,4,0,0,0,0,0,4,250,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,122,4,0,0,0,0,0,4,122,4,4,0,0,0,0,4,122,4,0,0,0,0,0,4,122,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,4,11,4,4,4,4,4,0,4,11,4,0,0,0,0,0,4,251,4,4,4,4,0,0,4,251,4,0,0,0,0,0,4,251,4,4,4,4,0,0,4,251,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,4,11,4,4,4,4,4,0,4,11,4,0,0,0,0,0,4,59,4,4,4,4,0,0,4,59,4,0,0,0,0,0,4,59,4,4,4,4,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,4,11,4,4,4,4,4,0,4,11,4,0,0,0,0,0,4,123,4,4,4,4,0,0,4,123,4,0,0,0,0,0,4,123,4,4,4,4,0,0,4,123,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,4,11,4,4,4,4,4,0,4,11,4,0,0,0,0,0,4,59,4,4,4,4,0,0,4,59,4,0,0,0,0,0,4,59,4,4,4,4,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,250,4,0,0,0,0,0,4,250,4,4,4,4,0,0,4,250,4,0,0,0,0,0,4,250,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,58,4,0,0,0,0,0,4,58,4,4,4,4,0,0,4,58,4,0,0,0,0,0,4,58,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,122,4,0,0,0,0,0,4,122,4,4,4,4,0,0,4,122,4,0,0,0,0,0,4,122,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,58,4,0,0,0,0,0,4,58,4,4,4,4,0,0,4,58,4,0,0,0,0,0,4,58,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,250,4,0,0,0,0,0,4,250,4,4,0,0,0,0,4,250,4,0,0,0,0,0,4,250,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,122,4,0,0,0,0,0,4,122,4,4,0,0,0,0,4,122,4,0,0,0,0,0,4,122,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,251,4,4,4,0,0,0,4,251,4,0,0,0,0,0,4,251,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,27,4,4,4,4,4,4,4,27,4,0,0,0,0,0,4,27,4,4,4,4,4,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,27,4,4,4,4,4,4,4,27,4,0,0,0,0,0,4,27,4,4,4,4,4,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,123,4,0,0,0,0,0,4,123,4,4,4,0,0,0,4,123,4,0,0,0,0,0,4,123,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,27,4,4,4,4,4,4,4,27,4,0,0,0,0,0,4,27,4,4,4,4,4,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,4,0,0,4,11,4,0,0,0,0,0,4,27,4,4,4,4,4,4,4,27,4,0,0,0,0,0,4,27,4,4,4,4,4,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,250,4,4,4,0,0,0,4,250,4,0,0,0,0,0,4,250,4,4,4,0,0,0,4,250,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,4,4,4,26,4,0,0,0,0,0,4,26,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,4,4,4,26,4,0,0,0,0,0,4,26,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,122,4,4,4,0,0,0,4,122,4,0,0,0,0,0,4,122,4,4,4,0,0,0,4,122,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,4,4,4,26,4,0,0,0,0,0,4,26,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,4,4,4,26,4,0,0,0,0,0,4,26,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,250,4,0,0,0,0,0,4,250,4,4,0,0,0,0,4,250,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,122,4,4,0,0,0,0,4,122,4,0,0,0,0,0,4,122,4,4,0,0,0,0,4,122,4,0,0,0,0,0,4,10,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+317952);allocate([4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,4,4,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,4,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,251,4,0,0,0,0,0,4,251,4,4,4,0,0,0,4,251,4,0,0,0,0,0,4,251,4,4,4,0,0,0,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,4,11,4,4,4,4,4,0,4,11,4,0,0,0,0,0,4,27,4,4,4,4,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,4,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,4,11,4,4,4,4,4,0,4,11,4,0,0,0,0,0,4,27,4,4,4,4,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,4,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,123,4,0,0,0,0,0,4,123,4,4,4,0,0,0,4,123,4,0,0,0,0,0,4,123,4,4,4,0,0,0,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,4,11,4,4,4,4,4,0,4,11,4,0,0,0,0,0,4,27,4,4,4,4,0,0,4,27,4,0,0,0,0,0,4,27,4,4,4,4,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,0,4,11,4,4,4,4,4,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,250,4,4,4,0,0,0,4,250,4,0,0,0,0,0,4,250,4,4,4,0,0,0,4,250,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,122,4,4,4,0,0,0,4,122,4,0,0,0,0,0,4,122,4,4,4,0,0,0,4,122,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,0,0,4,26,4,0,0,0,0,0,4,26,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,250,4,4,0,0,0,0,4,250,4,0,0,0,0,0,4,250,4,4,0,0,0,0,4,250,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,122,4,4,0,0,0,0,4,122,4,0,0,0,0,0,4,122,4,4,0,0,0,0,4,122,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,4,0,0,0,0,8,247,8,8,8,8,8,8,8,247,8,0,0,0,0,0,8,247,8,8,8,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,8,8,8,0,8,247,8,0,0,0,0,0,8,247,8,8,8,0,0,0,8,247,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,55,8,8,8,8,8,8,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,8,8,0,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,119,8,8,8,8,8,8,8,119,8,0,0,0,0,0,8,119,8,8,8,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,8,8,8,0,8,119,8,0,0,0,0,0,8,119,8,8,8,0,0,0,8,119,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,55,8,8,8,8,8,8,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,8,8,0,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,8,8,8,8,8,246,8,0,0,0,0,0,8,246,8,8,8,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,8,8,8,0,8,246,8,0,0,0,0,0,8,246,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,8,8,8,8,54,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,8,8,0,8,54,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,8,8,8,8,8,118,8,0,0,0,0,0,8,118,8,8,8,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,8,8,8,0,8,118,8,0,0,0,0,0,8,118,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,8,8,8,8,54,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,8,8,0,8,54,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,244,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,8,8,8,8,244,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,8,8,0,8,244,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,8,8,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,8,0,8,52,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,8,8,8,8,116,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,8,8,0,8,116,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,8,8,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,8,0,8,52,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,8,8,8,8,244,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,8,8,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,8,8,8,8,116,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,8,8,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,55,8,8,8,8,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,8,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,23,8,8,8,8,8,8,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,8,8,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,247,8,8,8,8,0,0,8,247,8,0,0,0,0,0,8,247,8,8,8,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,8,8,0,0,8,247,8,0,0,0,0,0,8,247,8,8,8,0,0,0,8,247,8,0,0,0,0,0,8,23,8,8,8,8,8,8,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,8,8,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,55,8,8,8,8,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,8,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,23,8,8,8,8,8,8,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,8,8,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,119,8,8,8,8,0,0,8,119,8,0,0,0,0,0,8,119,8,8,8,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,8,8,0,0,8,119,8,0,0,0,0,0,8,119,8,8,8,0,0,0,8,119,8,0,0,0,0,0,8,23,8,8,8,8,8,8,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,8,8,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,8,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,8,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,8,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,8,8,0,0,8,246,8,0,0,0,0,0,8,246,8,8,8,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,8,8,0,0,8,246,8,0,0,0,0,0,8,246,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,8,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,8,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,8,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,8,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,8,8,0,0,8,118,8,0,0,0,0,0,8,118,8,8,8,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,8,8,0,0,8,118,8,0,0,0,0,0,8,118,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,8,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,8,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,8,0,0,8,244,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,8,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,8,0,0,8,116,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,244,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,8,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,116,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,8,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+328192);allocate([8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,16,239,16,16,16,16,16,16,16,111,16,16,16,16,16,0,16,239,16,16,16,16,0,0,16,111,16,16,16,16,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,104,16,16,16,16,16,0,16,232,16,16,16,16,0,0,16,104,16,16,16,16,0,0,16,239,16,16,16,0,0,0,16,111,16,16,16,0,0,0,16,239,16,16,16,0,0,0,16,111,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,16,16,16,0,16,40,16,16,16,16,0,0,16,40,16,16,16,16,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,108,16,16,16,0,0,0,16,236,16,16,16,0,0,0,16,108,16,16,16,0,0,0,16,236,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,16,16,16,16,16,16,236,16,16,16,16,16,0,16,108,16,16,16,16,0,0,16,236,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,239,16,16,0,0,0,0,16,111,16,16,0,0,0,0,16,239,16,16,0,0,0,0,16,111,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,239,16,16,0,0,0,0,16,111,16,16,0,0,0,0,16,239,16,16,0,0,0,0,16,111,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,44,16,16,16,16,16,16,16,44,16,16,16,16,16,0,16,44,16,16,16,16,0,0,16,44,16,16,16,16,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,16,16,16,0,16,40,16,16,16,16,0,0,16,40,16,16,16,16,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,238,16,16,16,0,0,0,16,110,16,16,16,0,0,0,16,238,16,16,16,0,0,0,16,110,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,16,16,16,16,16,16,110,16,16,16,16,16,0,16,238,16,16,16,16,0,0,16,110,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,104,16,16,16,16,16,0,16,232,16,16,16,16,0,0,16,104,16,16,16,16,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,47,16,16,16,16,16,16,16,47,16,16,16,16,16,0,16,47,16,16,16,16,0,0,16,47,16,16,16,16,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,16,16,16,0,16,40,16,16,16,16,0,0,16,40,16,16,16,16,0,0,16,47,16,16,16,0,0,0,16,47,16,16,16,0,0,0,16,47,16,16,16,0,0,0,16,47,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,104,16,16,16,16,16,16,16,232,16,16,16,16,16,0,16,104,16,16,16,16,0,0,16,232,16,16,16,16,0,0,16,238,16,16,0,0,0,0,16,110,16,16,0,0,0,0,16,238,16,16,0,0,0,0,16,110,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,16,0,0,0,0,16,110,16,16,0,0,0,0,16,238,16,16,0,0,0,0,16,110,16,16,0,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,16,16,16,16,16,44,16,16,16,16,16,0,16,44,16,16,16,16,0,0,16,44,16,16,16,16,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,236,16,16,16,16,16,16,16,108,16,16,16,16,16,0,16,236,16,16,16,16,0,0,16,108,16,16,16,16,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,104,16,16,16,16,16,0,16,232,16,16,16,16,0,0,16,104,16,16,16,16,0,0,16,236,16,16,16,0,0,0,16,108,16,16,16,0,0,0,16,236,16,16,16,0,0,0,16,108,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,16,16,0,0,0,16,46,16,16,16,0,0,0,16,46,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,16,16,16,16,16,46,16,16,16,16,16,0,16,46,16,16,16,16,0,0,16,46,16,16,16,16,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,16,16,16,0,16,40,16,16,16,16,0,0,16,40,16,16,16,16,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,111,16,16,16,16,16,16,16,239,16,16,16,16,16,0,16,111,16,16,16,16,0,0,16,239,16,16,16,16,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,16,16,16,16,16,16,232,16,16,16,16,16,0,16,104,16,16,16,16,0,0,16,232,16,16,16,16,0,0,16,111,16,16,16,0,0,0,16,239,16,16,16,0,0,0,16,111,16,16,16,0,0,0,16,239,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,16,16,16,0,16,40,16,16,16,16,0,0,16,40,16,16,16,16,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,236,16,16,16,0,0,0,16,108,16,16,16,0,0,0,16,236,16,16,16,0,0,0,16,108,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,16,16,16,16,16,16,108,16,16,16,16,16,0,16,236,16,16,16,16,0,0,16,108,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,111,16,16,0,0,0,0,16,239,16,16,0,0,0,0,16,111,16,16,0,0,0,0,16,239,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,111,16,16,0,0,0,0,16,239,16,16,0,0,0,0,16,111,16,16,0,0,0,0,16,239,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,44,16,16,16,16,16,16,16,44,16,16,16,16,16,0,16,44,16,16,16,16,0,0,16,44,16,16,16,16,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,16,16,16,0,16,40,16,16,16,16,0,0,16,40,16,16,16,16,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,110,16,16,16,0,0,0,16,238,16,16,16,0,0,0,16,110,16,16,16,0,0,0,16,238,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,16,16,16,16,16,16,238,16,16,16,16,16,0,16,110,16,16,16,16,0,0,16,238,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,16,16,16,16,232,16,16,16,16,16,0,16,104,16,16,16,16,0,0,16,232,16,16,16,16,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,236,16,16,0,0,0,0,16,108,16,16,0,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,47,16,16,16,16,16,16,16,47,16,16,16,16,16,0,16,47,16,16,16,16,0,0,16,47,16,16,16,16,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,16,16,16,0,16,40,16,16,16,16,0,0,16,40,16,16,16,16,0,0,16,47,16,16,16,0,0,0,16,47,16,16,16,0,0,0,16,47,16,16,16,0,0,0,16,47,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,104,16,16,16,16,16,0,16,232,16,16,16,16,0,0,16,104,16,16,16,16,0,0,16,110,16,16,0,0,0,0,16,238,16,16,0,0,0,0,16,110,16,16,0,0,0,0,16,238,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,16,0,0,0,0,16,238,16,16,0,0,0,0,16,110,16,16,0,0,0,0,16,238,16,16,0,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,16,16,16,16,16,44,16,16,16,16,16,0,16,44,16,16,16,16,0,0,16,44,16,16,16,16,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,108,16,16,16,16,16,16,16,236,16,16,16,16,16,0,16,108,16,16,16,16,0,0,16,236,16,16,16,16,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,16,16,16,16,16,16,232,16,16,16,16,16,0,16,104,16,16,16,16,0,0,16,232,16,16,16,16,0,0,16,108,16,16,16,0,0,0,16,236,16,16,16,0,0,0,16,108,16,16,16,0,0,0,16,236,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,16,16,0,0,0,16,46,16,16,16,0,0,0,16,46,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,16,16,16,16,16,46,16,16,16,16,16,0,16,46,16,16,16,16,0,0,16,46,16,16,16,16,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,232,16,16,0,0,0,0,16,104,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,16,16,16,0,16,40,16,16,16,16,0,0,16,40,16,16,16,16,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,32,223,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,223,32,32,32,32,32,0,32,223,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,223,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,216,32,32,32,32,32,32,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,216,32,32,32,32,32,0,32,216,32,32,32,32,0,0,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,216,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,32,32,32,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,32,0,32,208,32,32,32,32,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,223,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,223,32,32,32,0,0,0,32,223,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,223,32,32,32,0,0,0,32,208,32,32,32,32,32,32,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,32,32,0,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,216,32,32,32,0,0,0,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,92,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,32,32,0,0,0,32,92,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,32,32,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,92,32,32,32,32,32,32,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,32,32,32,32,0,32,92,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,32,32,32,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,32,32,32,32,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,32,32,32,0,32,80,32,32,32,32,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,32,32,0,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,88,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,32,32,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,88,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,216,32,32,32,0,0,0,32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,222,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,32,32,32,32,0,32,222,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,216,32,32,32,32,32,32,32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,216,32,32,32,32,32,0,32,216,32,32,32,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+338432);allocate([32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,216,32,32,32,32,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,32,32,32,32,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,32,0,32,208,32,32,32,32,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,222,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,32,32,0,0,0,32,222,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,32,32,0,0,0,32,223,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,223,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,223,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,223,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,32,32,32,32,32,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,32,32,32,32,0,32,88,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,32,32,0,32,80,32,32,32,32,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,32,32,0,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,88,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,220,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,32,32,0,0,0,32,220,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,32,32,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,216,32,32,32,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,220,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,32,32,32,32,0,32,220,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,32,32,32,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,216,32,32,32,32,32,32,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,216,32,32,32,32,32,0,32,216,32,32,32,32,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,216,32,32,32,32,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,32,32,32,32,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,32,0,32,208,32,32,32,32,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,216,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,222,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,222,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,222,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,222,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,95,32,32,32,32,32,32,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,95,32,32,32,32,32,0,32,95,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,95,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,88,32,32,32,32,32,32,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,88,32,32,32,32,32,0,32,88,32,32,32,32,0,0,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,88,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,32,32,0,32,80,32,32,32,32,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,95,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,95,32,32,32,0,0,0,32,95,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,95,32,32,32,0,0,0,32,80,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,32,32,0,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,88,32,32,32,0,0,0,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,220,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,32,32,0,0,0,32,220,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,32,32,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,220,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,32,32,32,32,0,32,220,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,32,32,32,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,32,32,32,32,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,32,32,32,0,32,208,32,32,32,32,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,32,32,32,32,32,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,32,32,0,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,216,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,32,32,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,216,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,88,32,32,32,0,0,0,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,94,32,32,32,32,32,32,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,94,32,32,32,32,32,0,32,94,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,94,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,88,32,32,32,32,32,32,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,88,32,32,32,32,32,0,32,88,32,32,32,32,0,0,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,88,32,32,32,32,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,32,32,0,32,80,32,32,32,32,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,94,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,94,32,32,32,0,0,0,32,94,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,94,32,32,32,0,0,0,32,95,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,95,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,95,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,95,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,32,32,32,32,0,32,216,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,32,32,32,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,32,0,32,208,32,32,32,32,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,32,32,32,32,32,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,32,32,0,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,216,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,92,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,32,32,0,0,0,32,92,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,32,32,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,88,32,32,32,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,92,32,32,32,32,32,32,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,32,32,32,32,0,32,92,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,32,32,32,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,88,32,32,32,32,32,32,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,88,32,32,32,32,32,0,32,88,32,32,32,32,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,88,32,32,32,32,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,32,32,0,32,80,32,32,32,32,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,88,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,94,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,94,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,94,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,94,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,32,0,0,0,0,64,191,64,64,64,64,64,64,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,190,64,64,64,64,64,64,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,64,64,64,64,64,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,64,64,64,64,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,64,64,64,64,64,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,64,64,64,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,64,64,64,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,64,64,64,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,64,64,64,64,64,64,191,64,64,64,64,0,0,64,191,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,64,64,190,64,64,64,64,0,0,64,190,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,64,64,188,64,64,64,64,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,64,64,188,64,64,64,64,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,64,64,184,64,64,64,64,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,64,64,184,64,64,64,64,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,64,64,184,64,64,64,64,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,64,64,184,64,64,64,64,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,64,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,190,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,191,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,190,64,64,64,0,0,0,64,190,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,191,64,64,64,0,0,0,64,191,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,191,64,64,64,64,64,0,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,190,64,64,64,64,64,0,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,64,64,64,64,0,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,64,64,64,0,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,64,64,64,64,0,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,64,64,0,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,64,64,0,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,64,64,0,64,176,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,64,64,64,64,0,64,191,64,64,64,64,0,0,64,191,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,0,64,190,64,64,64,64,0,0,64,190,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,0,64,188,64,64,64,64,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,0,64,188,64,64,64,64,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,0,64,184,64,64,64,64,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,0,64,184,64,64,64,64,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,0,64,184,64,64,64,64,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,64,64,0,64,184,64,64,64,64,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+348672);allocate([64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,190,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,191,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,190,64,64,64,0,0,0,64,190,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,191,64,64,64,0,0,0,64,191,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,128,127,128,128,128,128,128,128,128,124,128,128,0,0,0,0,128,120,128,128,128,128,128,128,128,120,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,124,128,128,128,0,0,0,128,127,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,128,128,128,128,0,128,124,128,128,0,0,0,0,128,120,128,128,128,128,128,0,128,120,128,128,0,0,0,0,128,112,128,128,128,128,128,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,124,128,128,128,0,0,0,128,127,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,127,128,128,128,128,0,0,128,124,128,128,0,0,0,0,128,120,128,128,128,128,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,124,128,128,128,0,0,0,128,127,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,127,128,128,128,128,0,0,128,124,128,128,0,0,0,0,128,120,128,128,128,128,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,124,128,128,128,0,0,0,128,127,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,126,128,128,128,128,128,128,128,124,128,128,0,0,0,0,128,120,128,128,128,128,128,128,128,120,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,124,128,128,128,0,0,0,128,126,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,128,128,128,128,0,128,124,128,128,0,0,0,0,128,120,128,128,128,128,128,0,128,120,128,128,0,0,0,0,128,112,128,128,128,128,128,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,124,128,128,128,0,0,0,128,126,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+358912);allocate([128,126,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,126,128,128,128,128,0,0,128,124,128,128,0,0,0,0,128,120,128,128,128,128,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,124,128,128,128,0,0,0,128,126,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,126,128,128,128,128,0,0,128,124,128,128,0,0,0,0,128,120,128,128,128,128,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,124,128,128,128,0,0,0,128,126,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,127,128,128,0,0,0,0,128,124,128,128,128,128,128,128,128,120,128,128,0,0,0,0,128,120,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,124,128,128,0,0,0,0,128,127,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,128,0,0,0,0,128,124,128,128,128,128,128,0,128,120,128,128,0,0,0,0,128,120,128,128,128,128,128,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,124,128,128,0,0,0,0,128,127,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,127,128,128,0,0,0,0,128,124,128,128,128,128,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,124,128,128,0,0,0,0,128,127,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,127,128,128,0,0,0,0,128,124,128,128,128,128,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,124,128,128,0,0,0,0,128,127,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,126,128,128,0,0,0,0,128,124,128,128,128,128,128,128,128,120,128,128,0,0,0,0,128,120,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,124,128,128,0,0,0,0,128,126,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,128,0,0,0,0,128,124,128,128,128,128,128,0,128,120,128,128,0,0,0,0,128,120,128,128,128,128,128,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,124,128,128,0,0,0,0,128,126,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,126,128,128,0,0,0,0,128,124,128,128,128,128,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,124,128,128,0,0,0,0,128,126,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,126,128,128,0,0,0,0,128,124,128,128,128,128,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,124,128,128,0,0,0,0,128,126,128,128,128,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+369152);allocate([128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,1,1,254,1,1,1,1,1,1,1,62,1,0,0,0,0,1,1,126,1,0,0,0,0,1,1,62,1,1,0,0,0,1,1,126,1,1,0,0,0,1,1,62,1,0,0,0,0,1,1,254,1,0,0,0,0,1,1,62,1,1,1,1,0,0,1,254,1,1,1,1,1,0,1,62,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,1,0,0,0,0,1,126,1,1,0,0,0,0,1,62,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,62,1,1,1,1,0,1,1,254,1,0,0,0,0,1,1,62,1,1,1,0,0,1,1,126,1,1,0,0,0,1,1,62,1,0,0,0,0,1,1,126,1,0,0,0,0,1,1,62,1,1,0,0,0,1,1,254,1,1,1,0,0,1,1,62,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,62,1,1,1,0,0,0,1,126,1,1,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,1,0,0,0,0,1,254,1,1,1,0,0,0,1,62,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,1,1,14,1,1,1,1,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,1,0,0,1,14,1,1,1,1,1,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,1,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,1,1,1,1,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,1,1,30,1,1,1,1,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,1,1,1,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,1,1,0,0,1,30,1,0,0,0,0,1,1,30,1,1,1,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,1,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,1,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,0,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,1,1,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,1,1,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,1,1,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,1,1,0,0,1,14,1,0,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,1,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,0,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,1,1,62,1,0,0,0,0,1,1,254,1,1,0,0,0,1,1,62,1,1,1,1,1,1,1,126,1,0,0,0,0,1,1,62,1,0,0,0,0,1,1,126,1,1,1,1,0,1,1,62,1,1,0,0,0,1,1,254,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,254,1,1,0,0,0,0,1,62,1,1,1,1,1,0,1,126,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,1,1,1,0,0,1,62,1,1,0,0,0,0,1,254,1,0,0,0,0,1,1,62,1,1,0,0,0,1,1,254,1,0,0,0,0,1,1,62,1,0,0,0,0,1,1,126,1,1,1,0,0,1,1,62,1,1,1,0,0,1,1,126,1,0,0,0,0,1,1,62,1,0,0,0,0,1,1,254,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,254,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,1,1,0,0,0,1,62,1,1,1,0,0,0,1,126,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,254,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,1,1,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,1,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,1,1,1,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,1,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,1,1,1,1,1,30,1,1,1,1,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,1,1,1,0,1,30,1,1,1,1,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,1,1,30,1,1,1,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,1,0,0,1,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,1,1,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,1,0,1,6,1,1,1,1,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,1,1,1,1,14,1,1,1,1,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,1,1,0,1,14,1,1,1,1,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,1,1,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,1,0,1,6,1,1,1,1,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,254,1,1,0,0,0,1,1,62,1,0,0,0,0,1,1,126,1,0,0,0,0,1,1,62,1,1,1,1,0,1,1,126,1,1,1,1,1,1,1,62,1,0,0,0,0,1,1,254,1,0,0,0,0,1,1,62,1,1,0,0,0,0,1,254,1,1,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,1,1,1,0,0,1,126,1,1,1,1,1,0,1,62,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,62,1,1,0,0,0,1,1,254,1,0,0,0,0,1,1,62,1,1,0,0,0,1,1,126,1,1,1,0,0,1,1,62,1,0,0,0,0,1,1,126,1,0,0,0,0,1,1,62,1,1,1,0,0,1,1,254,1,1,0,0,0,1,1,62,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,62,1,1,0,0,0,0,1,126,1,1,1,0,0,0,1,62,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,1,1,0,0,0,1,254,1,1,0,0,0,0,1,62,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,1,1,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,1,0,1,1,14,1,1,1,1,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,1,0,0,1,14,1,1,1,1,1,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,1,1,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,1,1,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+379392);allocate([1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,1,1,30,1,1,1,1,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,1,1,1,1,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,1,1,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,1,1,1,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,1,0,0,1,1,30,1,1,1,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,1,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,1,1,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,1,1,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,1,1,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,1,1,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,1,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,62,1,0,0,0,0,1,1,254,1,1,1,1,0,1,1,62,1,1,0,0,0,1,1,126,1,0,0,0,0,1,1,62,1,0,0,0,0,1,1,126,1,1,0,0,0,1,1,62,1,1,1,1,1,1,1,254,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,254,1,1,1,1,0,0,1,62,1,1,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,1,0,0,0,0,1,62,1,1,1,1,1,0,1,254,1,0,0,0,0,1,1,62,1,1,1,0,0,1,1,254,1,0,0,0,0,1,1,62,1,0,0,0,0,1,1,126,1,1,0,0,0,1,1,62,1,1,0,0,0,1,1,126,1,0,0,0,0,1,1,62,1,0,0,0,0,1,1,254,1,1,1,0,0,0,1,62,1,1,1,0,0,0,1,254,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,254,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,0,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,1,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,1,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,1,1,1,0,1,14,1,0,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,0,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,0,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,1,1,30,1,1,1,1,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,1,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,1,1,1,0,1,30,1,1,1,1,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,1,1,1,1,1,30,1,0,0,0,0,1,1,30,1,1,1,0,0,1,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,1,1,30,1,1,1,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,1,0,1,6,1,1,1,1,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,1,1,14,1,1,1,1,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,1,1,1,0,1,14,1,1,1,1,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,1,1,1,1,14,1,0,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,1,1,14,1,1,1,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,1,1,6,1,1,1,1,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,1,1,1,0,1,6,1,1,1,1,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,6,1,0,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,1,1,6,1,1,1,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,0,0,0,0,1,1,2,1,1,1,1,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,1,1,1,0,1,2,1,1,1,1,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,1,1,2,1,1,1,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,0,0,0,0,2,2,253,2,2,2,2,2,2,2,13,2,0,0,0,0,2,2,253,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,2,2,2,2,2,2,253,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,253,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,29,2,2,2,2,2,2,2,13,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,2,2,2,2,2,2,29,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,61,2,2,2,2,2,2,2,13,2,0,0,0,0,2,2,61,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,2,2,2,2,2,2,61,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,61,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,29,2,2,2,2,2,2,2,13,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,2,2,2,2,2,2,29,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,125,2,2,2,2,2,2,2,13,2,0,0,0,0,2,2,125,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,2,2,2,2,2,2,125,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,125,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,29,2,2,2,2,2,2,2,13,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,2,2,2,2,2,2,29,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,61,2,2,2,2,2,2,2,13,2,0,0,0,0,2,2,61,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,2,2,2,2,2,2,61,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,61,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,29,2,2,2,2,2,2,2,13,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,2,2,2,2,2,2,29,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,253,2,2,2,2,2,0,2,13,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,2,2,0,2,253,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,2,2,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,2,2,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,61,2,2,2,2,2,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,2,2,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,2,2,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,2,2,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,125,2,2,2,2,2,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,2,2,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,2,2,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,2,2,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,61,2,2,2,2,2,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,2,2,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,2,2,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,2,2,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,2,2,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,253,2,2,2,2,0,2,2,13,2,0,0,0,0,2,2,253,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,2,2,2,0,2,2,253,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,253,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,29,2,2,2,2,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,2,2,2,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,61,2,2,2,2,0,2,2,13,2,0,0,0,0,2,2,61,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,2,2,2,0,2,2,61,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,61,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,29,2,2,2,2,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,2,2,2,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,125,2,2,2,2,0,2,2,13,2,0,0,0,0,2,2,125,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,2,2,2,0,2,2,125,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,125,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,29,2,2,2,2,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,2,2,2,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,61,2,2,2,2,0,2,2,13,2,0,0,0,0,2,2,61,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,2,2,2,0,2,2,61,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,61,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,29,2,2,2,2,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,2,2,2,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,253,2,2,2,2,0,0,2,13,2,0,0,0,0,0,2,253,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,0,0,2,253,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,253,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,2,2,2,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,2,2,2,0,0,2,13,2,0,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,0,0,2,61,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,2,2,2,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,125,2,2,2,2,0,0,2,13,2,0,0,0,0,0,2,125,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,0,0,2,125,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,125,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,2,2,2,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,2,2,2,0,0,2,13,2,0,0,0,0,0,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,2,2,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+389632);allocate([2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,0,0,2,61,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,2,2,2,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,2,2,2,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,253,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,253,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,253,2,2,2,0,0,2,2,13,2,2,0,0,0,2,2,253,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,29,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,2,0,0,2,2,13,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,61,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,61,2,2,2,0,0,2,2,13,2,2,0,0,0,2,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,29,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,2,0,0,2,2,13,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,125,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,125,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,125,2,2,2,0,0,2,2,13,2,2,0,0,0,2,2,125,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,29,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,2,0,0,2,2,13,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,61,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,61,2,2,2,0,0,2,2,13,2,2,0,0,0,2,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,29,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,2,0,0,2,2,13,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,253,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,253,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,125,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,125,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,253,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,253,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,253,2,2,2,0,0,2,2,13,2,0,0,0,0,2,2,253,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,2,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,61,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,61,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,61,2,2,2,0,0,2,2,13,2,0,0,0,0,2,2,61,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,2,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,125,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,125,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,125,2,2,2,0,0,2,2,13,2,0,0,0,0,2,2,125,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,2,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,61,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,61,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,61,2,2,2,0,0,2,2,13,2,0,0,0,0,2,2,61,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,2,0,0,2,2,29,2,0,0,0,0,2,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,2,0,0,2,2,13,2,0,0,0,0,2,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,253,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,253,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,253,2,2,2,0,0,0,2,13,2,0,0,0,0,0,2,253,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,2,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,61,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,2,2,0,0,0,2,13,2,0,0,0,0,0,2,61,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,2,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,125,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,2,2,0,0,0,2,13,2,0,0,0,0,0,2,125,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,2,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,61,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,2,2,0,0,0,2,13,2,0,0,0,0,0,2,61,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,2,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,2,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,4,4,251,4,4,4,4,4,4,4,122,4,4,0,0,0,4,4,122,4,4,0,0,0,4,4,251,4,4,4,0,0,0,4,251,4,4,4,4,4,0,4,122,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,251,4,4,4,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,4,4,4,0,4,4,26,4,4,0,0,0,4,4,26,4,4,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,4,0,0,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,4,4,0,0,4,4,123,4,4,4,4,4,4,4,250,4,0,0,0,0,4,4,250,4,0,0,0,0,4,4,123,4,4,4,0,0,0,4,123,4,4,4,4,4,0,4,250,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,123,4,4,4,0,0,4,4,27,4,0,0,0,0,4,4,26,4,4,4,4,0,4,4,26,4,4,4,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,4,4,4,0,0,4,26,4,4,4,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,4,4,4,4,4,4,58,4,4,4,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,4,4,4,4,0,4,58,4,4,4,0,0,0,4,59,4,0,0,0,0,4,4,27,4,4,4,4,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,4,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,4,0,0,4,4,251,4,0,0,0,0,4,4,122,4,0,0,0,0,4,4,122,4,0,0,0,0,4,4,251,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,251,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,4,4,0,4,4,26,4,4,4,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,4,4,0,0,4,26,4,4,4,0,0,0,4,27,4,4,0,0,0,4,4,59,4,4,0,0,0,4,4,58,4,4,4,4,4,4,4,58,4,4,4,0,0,4,4,59,4,4,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,4,4,4,4,0,4,58,4,4,4,0,0,0,4,59,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,123,4,0,0,0,0,4,4,250,4,4,0,0,0,4,4,250,4,4,0,0,0,4,4,123,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,123,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,4,4,59,4,4,0,0,0,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,59,4,4,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,59,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,4,0,0,0,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,4,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,4,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,4,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,4,4,10,4,4,4,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,4,4,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,4,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,0,4,4,10,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,11,4,4,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,251,4,0,0,0,0,4,4,122,4,0,0,0,0,4,4,122,4,0,0,0,0,4,4,251,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,251,4,0,0,0,0,4,4,27,4,4,4,4,4,4,4,26,4,4,0,0,0,4,4,26,4,4,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,4,4,0,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,4,4,0,0,4,4,59,4,4,4,4,0,4,4,58,4,4,0,0,0,4,4,58,4,4,0,0,0,4,4,59,4,4,4,0,0,0,4,59,4,4,4,4,0,0,4,58,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,59,4,4,4,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,123,4,0,0,0,0,4,4,250,4,4,4,4,0,4,4,250,4,4,4,0,0,4,4,123,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,4,4,4,0,0,4,250,4,4,4,0,0,0,4,123,4,0,0,0,0,4,4,27,4,4,4,4,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,4,4,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,4,0,0,4,4,59,4,4,4,4,0,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,59,4,4,4,0,0,0,4,59,4,4,4,4,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,59,4,4,4,0,0,4,4,27,4,0,0,0,0,4,4,26,4,4,4,4,4,4,4,26,4,4,4,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,4,4,4,4,0,4,26,4,4,4,0,0,0,4,27,4,0,0,0,0,4,4,251,4,4,0,0,0,4,4,122,4,4,4,4,0,4,4,122,4,4,4,0,0,4,4,251,4,4,0,0,0,0,4,251,4,4,0,0,0,0,4,122,4,4,4,4,0,0,4,122,4,4,4,0,0,0,4,251,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,4,4,4,4,4,26,4,4,4,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,4,4,4,0,4,26,4,4,4,0,0,0,4,27,4,4,0,0,0,4,4,123,4,4,0,0,0,4,4,250,4,0,0,0,0,4,4,250,4,0,0,0,0,4,4,123,4,4,0,0,0,0,4,123,4,4,0,0,0,0,4,250,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,123,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,4,0,0,0,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,4,0,0,0,4,4,58,4,4,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,4,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,4,4,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,4,4,10,4,4,4,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,4,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,4,4,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,4,4,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,0,4,4,10,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,11,4,4,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,251,4,0,0,0,0,4,4,122,4,0,0,0,0,4,4,122,4,0,0,0,0,4,4,251,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,251,4,0,0,0,0,4,4,27,4,4,4,4,0,4,4,26,4,4,0,0,0,4,4,26,4,4,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,4,0,0,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,4,4,0,0,4,4,59,4,4,4,4,4,4,4,58,4,4,0,0,0,4,4,58,4,4,0,0,0,4,4,59,4,4,4,0,0,0,4,59,4,4,4,4,4,0,4,58,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,59,4,4,4,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,123,4,0,0,0,0,4,4,250,4,4,4,4,4,4,4,250,4,4,4,0,0,4,4,123,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,4,4,4,4,0,4,250,4,4,4,0,0,0,4,123,4,0,0,0,0,4,4,27,4,4,4,4,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,4,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,4,0,0,4,4,59,4,4,4,4,4,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,59,4,4,4,0,0,0,4,59,4,4,4,4,4,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,59,4,4,4,0,0,4,4,27,4,0,0,0,0,4,4,26,4,4,4,4,0,4,4,26,4,4,4,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,4,4,4,0,0,4,26,4,4,4,0,0,0,4,27,4,0,0,0,0,4,4,251,4,4,0,0,0,4,4,122,4,4,4,4,4,4,4,122,4,4,4,0,0,4,4,251,4,4,0,0,0,0,4,251,4,4,0,0,0,0,4,122,4,4,4,4,4,0,4,122,4,4,4,0,0,0,4,251,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,4,4,0,4,4,26,4,4,4,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,4,4,0,0,4,26,4,4,4,0,0,0,4,27,4,4,0,0,0,4,4,123,4,4,0,0,0,4,4,250,4,0,0,0,0,4,4,250,4,0,0,0,0,4,4,123,4,4,0,0,0,0,4,123,4,4,0,0,0,0,4,250,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,123,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,4,0,0,0,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,4,0,0,0,4,4,58,4,4,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,4,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,4,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,4,4,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,4,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,4,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,4,4,10,4,4,4,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,0,4,4,10,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,11,4,4,0,0,0,4,4,11,4,4,0,0,0,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+399873);allocate([4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,251,4,4,4,4,0,4,4,122,4,4,0,0,0,4,4,122,4,4,0,0,0,4,4,251,4,4,4,0,0,0,4,251,4,4,4,4,0,0,4,122,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,251,4,4,4,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,4,4,4,4,4,4,26,4,4,0,0,0,4,4,26,4,4,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,4,4,0,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,4,4,0,0,4,4,123,4,4,4,4,0,4,4,250,4,0,0,0,0,4,4,250,4,0,0,0,0,4,4,123,4,4,4,0,0,0,4,123,4,4,4,4,0,0,4,250,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,123,4,4,4,0,0,4,4,27,4,0,0,0,0,4,4,26,4,4,4,4,4,4,4,26,4,4,4,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,4,4,4,4,0,4,26,4,4,4,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,4,4,4,0,4,4,58,4,4,4,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,4,4,4,0,0,4,58,4,4,4,0,0,0,4,59,4,0,0,0,0,4,4,27,4,4,4,4,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,4,4,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,4,0,0,4,4,251,4,0,0,0,0,4,4,122,4,0,0,0,0,4,4,122,4,0,0,0,0,4,4,251,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,251,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,4,4,4,4,4,26,4,4,4,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,4,4,4,0,4,26,4,4,4,0,0,0,4,27,4,4,0,0,0,4,4,59,4,4,0,0,0,4,4,58,4,4,4,4,0,4,4,58,4,4,4,0,0,4,4,59,4,4,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,4,4,4,0,0,4,58,4,4,4,0,0,0,4,59,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,123,4,0,0,0,0,4,4,250,4,4,0,0,0,4,4,250,4,4,0,0,0,4,4,123,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,123,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,4,4,59,4,4,0,0,0,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,0,4,4,59,4,4,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,59,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,4,0,0,0,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,4,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,4,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,4,4,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,4,4,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,4,4,10,4,4,4,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,4,4,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,4,4,4,0,4,10,4,4,4,0,0,0,4,11,4,4,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,0,4,4,10,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,4,4,0,0,4,10,4,4,4,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,8,8,247,8,8,8,8,8,8,8,247,8,8,8,0,0,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,0,8,8,244,8,8,8,8,8,8,8,244,8,8,8,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,247,8,8,8,8,8,0,8,247,8,8,8,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,244,8,8,8,8,8,0,8,244,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,8,8,23,8,8,8,8,8,8,8,23,8,8,8,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,20,8,8,8,8,8,8,8,20,8,8,8,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,23,8,8,8,8,8,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,55,8,8,8,0,0,8,8,55,8,8,8,8,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,52,8,8,8,0,0,8,8,52,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,8,8,8,8,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,8,8,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,8,8,23,8,8,8,0,0,8,8,23,8,8,8,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,20,8,8,8,0,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,8,8,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,0,8,8,119,8,8,8,8,8,8,8,119,8,8,8,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,116,8,8,8,8,8,8,8,116,8,8,8,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,119,8,8,8,8,8,0,8,119,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,8,8,8,0,8,116,8,8,8,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,8,8,8,8,8,23,8,8,8,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,8,8,8,8,20,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,8,8,0,8,23,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,20,8,8,8,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,8,8,0,0,8,8,55,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,8,0,0,8,8,52,8,8,8,8,8,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,8,8,8,8,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,8,0,0,8,8,23,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,0,0,8,8,20,8,8,8,8,8,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,8,8,8,8,247,8,8,0,0,0,8,8,247,8,8,0,0,0,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,8,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,0,8,8,119,8,8,0,0,0,8,8,119,8,8,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,8,8,55,8,8,8,0,0,8,8,55,8,8,8,8,0,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,52,8,8,8,0,0,8,8,52,8,8,8,8,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,8,8,8,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,8,8,23,8,8,8,0,0,8,8,23,8,8,8,8,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,20,8,8,8,0,0,8,8,20,8,8,8,8,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,247,8,8,8,8,0,8,8,247,8,8,8,0,0,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,0,8,8,244,8,8,8,8,0,8,8,244,8,8,8,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,247,8,8,8,8,0,0,8,247,8,8,8,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,244,8,8,8,8,0,0,8,244,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,8,8,23,8,8,8,8,0,8,8,23,8,8,8,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,20,8,8,8,8,0,8,8,20,8,8,8,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,8,8,0,0,8,8,55,8,8,8,8,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,8,0,0,8,8,52,8,8,8,8,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,8,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,8,0,0,8,8,23,8,8,8,8,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,0,0,8,8,20,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,8,0,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,0,8,8,119,8,8,8,8,0,8,8,119,8,8,8,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,116,8,8,8,8,0,8,8,116,8,8,8,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,119,8,8,8,8,0,0,8,119,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,8,8,0,0,8,116,8,8,8,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,8,8,0,8,8,23,8,8,8,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,8,0,8,8,20,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,0,0,8,8,55,8,8,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,247,8,8,0,0,0,8,8,247,8,8,0,0,0,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,8,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,0,8,8,119,8,8,0,0,0,8,8,119,8,8,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,8,8,246,8,8,8,8,8,8,8,246,8,8,8,0,0,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,0,8,8,244,8,8,8,8,8,8,8,244,8,8,8,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,246,8,8,8,8,8,0,8,246,8,8,8,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,244,8,8,8,8,8,0,8,244,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,8,8,22,8,8,8,8,8,8,8,22,8,8,8,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,20,8,8,8,8,8,8,8,20,8,8,8,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,8,8,8,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,54,8,8,8,0,0,8,8,54,8,8,8,8,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,52,8,8,8,0,0,8,8,52,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,54,8,8,8,8,8,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,8,8,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,8,8,22,8,8,8,0,0,8,8,22,8,8,8,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,20,8,8,8,0,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,8,8,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,118,8,8,8,8,8,8,8,118,8,8,8,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,116,8,8,8,8,8,8,8,116,8,8,8,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,118,8,8,8,8,8,0,8,118,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,8,8,8,0,8,116,8,8,8,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,8,8,8,8,8,22,8,8,8,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,8,8,8,8,20,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,0,8,22,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,8,0,8,20,8,8,8,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,8,8,0,0,8,8,54,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,8,0,0,8,8,52,8,8,8,8,8,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,54,8,8,8,8,8,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,8,0,0,8,8,22,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,0,0,8,8,20,8,8,8,8,8,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,8,8,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,8,8,8,8,246,8,8,0,0,0,8,8,246,8,8,0,0,0,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,8,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,118,8,8,0,0,0,8,8,118,8,8,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,54,8,8,8,0,0,8,8,54,8,8,8,8,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,52,8,8,8,0,0,8,8,52,8,8,8,8,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,54,8,8,8,8,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,8,8,22,8,8,8,0,0,8,8,22,8,8,8,8,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,20,8,8,8,0,0,8,8,20,8,8,8,8,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,8,8,246,8,8,8,8,0,8,8,246,8,8,8,0,0,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,0,8,8,244,8,8,8,8,0,8,8,244,8,8,8,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,246,8,8,8,8,0,0,8,246,8,8,8,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,244,8,8,8,8,0,0,8,244,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,8,8,22,8,8,8,8,0,8,8,22,8,8,8,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,20,8,8,8,8,0,8,8,20,8,8,8,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,8,8,0,0,8,8,54,8,8,8,8,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,8,0,0,8,8,52,8,8,8,8,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,54,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,8,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,8,0,0,8,8,22,8,8,8,8,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,0,0,8,8,20,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,118,8,8,8,8,0,8,8,118,8,8,8,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,116,8,8,8,8,0,8,8,116,8,8,8,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,118,8,8,8,8,0,0,8,118,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,8,8,0,0,8,116,8,8,8,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,8,8,0,8,8,22,8,8,8,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,8,0,8,8,20,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,8,0,8,8,246,8,8,0,0,0,8,8,246,8,8,0,0,0,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,8,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,118,8,8,0,0,0,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+410113);allocate([8,118,8,8,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,16,16,239,16,16,16,16,16,0,16,47,16,0,0,0,0,16,16,239,16,16,16,16,0,0,16,47,16,0,0,0,0,16,16,239,16,16,16,0,0,0,16,47,16,0,0,0,0,16,16,239,16,16,16,0,0,0,16,47,16,0,0,0,0,16,16,238,16,16,16,16,16,0,16,46,16,0,0,0,0,16,16,238,16,16,16,16,0,0,16,46,16,0,0,0,0,16,16,238,16,16,16,0,0,0,16,46,16,0,0,0,0,16,16,238,16,16,16,0,0,0,16,46,16,0,0,0,0,16,16,236,16,16,16,16,16,0,16,44,16,0,0,0,0,16,16,236,16,16,16,16,0,0,16,44,16,0,0,0,0,16,16,236,16,16,16,0,0,0,16,44,16,0,0,0,0,16,16,236,16,16,16,0,0,0,16,44,16,0,0,0,0,16,16,236,16,16,16,16,16,0,16,44,16,0,0,0,0,16,16,236,16,16,16,16,0,0,16,44,16,0,0,0,0,16,16,236,16,16,16,0,0,0,16,44,16,0,0,0,0,16,16,236,16,16,16,0,0,0,16,44,16,0,0,0,0,16,16,232,16,16,16,16,16,0,16,40,16,0,0,0,0,16,16,232,16,16,16,16,0,0,16,40,16,0,0,0,0,16,16,232,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,16,16,16,0,16,40,16,0,0,0,0,16,16,232,16,16,16,16,0,0,16,40,16,0,0,0,0,16,16,232,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,16,16,16,0,16,40,16,0,0,0,0,16,16,232,16,16,16,16,0,0,16,40,16,0,0,0,0,16,16,232,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,16,16,16,0,16,40,16,0,0,0,0,16,16,232,16,16,16,16,0,0,16,40,16,0,0,0,0,16,16,232,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,111,16,16,0,0,0,16,16,47,16,0,0,0,0,16,16,111,16,16,0,0,0,16,16,47,16,0,0,0,0,16,16,111,16,16,0,0,0,16,16,47,16,0,0,0,0,16,16,111,16,16,0,0,0,16,16,47,16,0,0,0,0,16,16,110,16,16,0,0,0,16,16,46,16,0,0,0,0,16,16,110,16,16,0,0,0,16,16,46,16,0,0,0,0,16,16,110,16,16,0,0,0,16,16,46,16,0,0,0,0,16,16,110,16,16,0,0,0,16,16,46,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,44,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,44,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,44,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,44,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,44,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,44,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,44,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,44,16,0,0,0,0,16,16,239,16,0,0,0,0,16,16,47,16,16,16,16,16,16,16,239,16,0,0,0,0,16,16,47,16,16,16,16,0,16,16,239,16,0,0,0,0,16,16,47,16,16,16,0,0,16,16,239,16,0,0,0,0,16,16,47,16,16,16,0,0,16,16,238,16,0,0,0,0,16,16,46,16,16,16,16,16,16,16,238,16,0,0,0,0,16,16,46,16,16,16,16,0,16,16,238,16,0,0,0,0,16,16,46,16,16,16,0,0,16,16,238,16,0,0,0,0,16,16,46,16,16,16,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,16,16,16,16,16,236,16,0,0,0,0,16,16,44,16,16,16,16,0,16,16,236,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,16,16,16,16,16,236,16,0,0,0,0,16,16,44,16,16,16,16,0,16,16,236,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,16,16,16,16,232,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,16,16,16,16,232,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,16,16,16,16,232,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,16,16,16,16,232,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,111,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,111,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,111,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,111,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,110,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,110,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,110,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,110,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,111,16,16,16,16,0,16,16,47,16,0,0,0,0,16,16,111,16,16,16,16,16,16,16,47,16,0,0,0,0,16,16,111,16,16,16,0,0,16,16,47,16,0,0,0,0,16,16,111,16,16,16,0,0,16,16,47,16,0,0,0,0,16,16,110,16,16,16,16,0,16,16,46,16,0,0,0,0,16,16,110,16,16,16,16,16,16,16,46,16,0,0,0,0,16,16,110,16,16,16,0,0,16,16,46,16,0,0,0,0,16,16,110,16,16,16,0,0,16,16,46,16,0,0,0,0,16,16,108,16,16,16,16,0,16,16,44,16,0,0,0,0,16,16,108,16,16,16,16,16,16,16,44,16,0,0,0,0,16,16,108,16,16,16,0,0,16,16,44,16,0,0,0,0,16,16,108,16,16,16,0,0,16,16,44,16,0,0,0,0,16,16,108,16,16,16,16,0,16,16,44,16,0,0,0,0,16,16,108,16,16,16,16,16,16,16,44,16,0,0,0,0,16,16,108,16,16,16,0,0,16,16,44,16,0,0,0,0,16,16,108,16,16,16,0,0,16,16,44,16,0,0,0,0,16,16,104,16,16,16,16,0,16,16,40,16,0,0,0,0,16,16,104,16,16,16,16,16,16,16,40,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,16,16,0,16,16,40,16,0,0,0,0,16,16,104,16,16,16,16,16,16,16,40,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,16,16,0,16,16,40,16,0,0,0,0,16,16,104,16,16,16,16,16,16,16,40,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,16,16,0,16,16,40,16,0,0,0,0,16,16,104,16,16,16,16,16,16,16,40,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,239,16,16,0,0,0,0,16,47,16,0,0,0,0,16,16,239,16,16,0,0,0,0,16,47,16,0,0,0,0,16,16,239,16,16,0,0,0,0,16,47,16,0,0,0,0,16,16,239,16,16,0,0,0,0,16,47,16,0,0,0,0,16,16,238,16,16,0,0,0,0,16,46,16,0,0,0,0,16,16,238,16,16,0,0,0,0,16,46,16,0,0,0,0,16,16,238,16,16,0,0,0,0,16,46,16,0,0,0,0,16,16,238,16,16,0,0,0,0,16,46,16,0,0,0,0,16,16,236,16,16,0,0,0,0,16,44,16,0,0,0,0,16,16,236,16,16,0,0,0,0,16,44,16,0,0,0,0,16,16,236,16,16,0,0,0,0,16,44,16,0,0,0,0,16,16,236,16,16,0,0,0,0,16,44,16,0,0,0,0,16,16,236,16,16,0,0,0,0,16,44,16,0,0,0,0,16,16,236,16,16,0,0,0,0,16,44,16,0,0,0,0,16,16,236,16,16,0,0,0,0,16,44,16,0,0,0,0,16,16,236,16,16,0,0,0,0,16,44,16,0,0,0,0,16,16,111,16,0,0,0,0,16,16,47,16,16,16,16,0,16,16,111,16,0,0,0,0,16,16,47,16,16,16,16,16,16,16,111,16,0,0,0,0,16,16,47,16,16,16,0,0,16,16,111,16,0,0,0,0,16,16,47,16,16,16,0,0,16,16,110,16,0,0,0,0,16,16,46,16,16,16,16,0,16,16,110,16,0,0,0,0,16,16,46,16,16,16,16,16,16,16,110,16,0,0,0,0,16,16,46,16,16,16,0,0,16,16,110,16,0,0,0,0,16,16,46,16,16,16,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,16,16,0,16,16,108,16,0,0,0,0,16,16,44,16,16,16,16,16,16,16,108,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,16,16,0,16,16,108,16,0,0,0,0,16,16,44,16,16,16,16,16,16,16,108,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,108,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,16,16,16,16,104,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,16,16,16,16,104,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,16,16,16,16,104,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,16,16,16,16,104,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,239,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,239,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,239,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,239,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,238,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,238,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,238,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,238,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,236,16,0,0,0,0,16,16,44,16,16,0,0,0,0,16,239,16,16,16,16,16,16,16,47,16,0,0,0,0,0,16,239,16,16,16,16,0,16,16,47,16,0,0,0,0,0,16,239,16,16,16,0,0,16,16,47,16,0,0,0,0,0,16,239,16,16,16,0,0,16,16,47,16,0,0,0,0,0,16,238,16,16,16,16,16,16,16,46,16,0,0,0,0,0,16,238,16,16,16,16,0,16,16,46,16,0,0,0,0,0,16,238,16,16,16,0,0,16,16,46,16,0,0,0,0,0,16,238,16,16,16,0,0,16,16,46,16,0,0,0,0,0,16,236,16,16,16,16,16,16,16,44,16,0,0,0,0,0,16,236,16,16,16,16,0,16,16,44,16,0,0,0,0,0,16,236,16,16,16,0,0,16,16,44,16,0,0,0,0,0,16,236,16,16,16,0,0,16,16,44,16,0,0,0,0,0,16,236,16,16,16,16,16,16,16,44,16,0,0,0,0,0,16,236,16,16,16,16,0,16,16,44,16,0,0,0,0,0,16,236,16,16,16,0,0,16,16,44,16,0,0,0,0,0,16,236,16,16,16,0,0,16,16,44,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,40,16,0,0,0,0,0,16,232,16,16,16,16,0,16,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,40,16,0,0,0,0,0,16,232,16,16,16,16,0,16,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,40,16,0,0,0,0,0,16,232,16,16,16,16,0,16,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,40,16,0,0,0,0,0,16,232,16,16,16,16,0,16,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,111,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,110,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,16,16,16,0,16,239,16,0,0,0,0,0,16,47,16,16,16,16,0,0,16,239,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,16,16,16,0,16,238,16,0,0,0,0,0,16,46,16,16,16,16,0,0,16,238,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,16,16,16,0,16,236,16,0,0,0,0,0,16,44,16,16,16,16,0,0,16,236,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,16,16,16,0,16,236,16,0,0,0,0,0,16,44,16,16,16,16,0,0,16,236,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,16,16,0,16,232,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,16,16,0,16,232,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,16,16,0,16,232,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,16,16,0,16,232,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,111,16,16,16,16,0,0,16,47,16,0,0,0,0,0,16,111,16,16,16,16,16,0,16,47,16,0,0,0,0,0,16,111,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,110,16,16,16,16,0,0,16,46,16,0,0,0,0,0,16,110,16,16,16,16,16,0,16,46,16,0,0,0,0,0,16,110,16,16,16,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,16,0,0,0,16,46,16,0,0,0,0,0,16,108,16,16,16,16,0,0,16,44,16,0,0,0,0,0,16,108,16,16,16,16,16,0,16,44,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,16,16,0,0,16,44,16,0,0,0,0,0,16,108,16,16,16,16,16,0,16,44,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,104,16,16,16,16,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,16,16,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,16,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,16,16,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,16,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,16,16,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,16,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,16,16,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,239,16,16,0,0,0,16,16,47,16,0,0,0,0,0,16,239,16,16,0,0,0,16,16,47,16,0,0,0,0,0,16,239,16,16,0,0,0,16,16,47,16,0,0,0,0,0,16,239,16,16,0,0,0,16,16,47,16,0,0,0,0,0,16,238,16,16,0,0,0,16,16,46,16,0,0,0,0,0,16,238,16,16,0,0,0,16,16,46,16,0,0,0,0,0,16,238,16,16,0,0,0,16,16,46,16,0,0,0,0,0,16,238,16,16,0,0,0,16,16,46,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,47,16,16,16,16,0,0,16,111,16,0,0,0,0,0,16,47,16,16,16,16,16,0,16,111,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,111,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,16,16,0,0,16,110,16,0,0,0,0,0,16,46,16,16,16,16,16,0,16,110,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,16,16,0,0,16,108,16,0,0,0,0,0,16,44,16,16,16,16,16,0,16,108,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,16,16,0,0,16,108,16,0,0,0,0,0,16,44,16,16,16,16,16,0,16,108,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,16,16,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,16,16,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,16,16,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,16,16,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,32,32,223,32,32,32,32,32,0,32,223,32,0,0,0,0,32,32,95,32,32,32,32,0,0,32,95,32,0,0,0,0,32,32,95,32,32,32,0,0,0,32,95,32,0,0,0,0,32,32,223,32,32,32,0,0,0,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,222,32,32,32,32,32,0,32,222,32,0,0,0,0,32,32,94,32,32,32,32,0,0,32,94,32,0,0,0,0,32,32,94,32,32,32,0,0,0,32,94,32,0,0,0,0,32,32,222,32,32,32,0,0,0,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,220,32,32,32,32,32,0,32,220,32,0,0,0,0,32,32,92,32,32,32,32,0,0,32,92,32,0,0,0,0,32,32,92,32,32,32,0,0,0,32,92,32,0,0,0,0,32,32,220,32,32,32,0,0,0,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,220,32,32,32,32,32,0,32,220,32,0,0,0,0,32,32,92,32,32,32,32,0,0,32,92,32,0,0,0,0,32,32,92,32,32,32,0,0,0,32,92,32,0,0,0,0,32,32,220,32,32,32,0,0,0,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,216,32,32,32,32,32,0,32,216,32,0,0,0,0,32,32,88,32,32,32,32,0,0,32,88,32,0,0,0,0,32,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,216,32,32,32,32,32,0,32,216,32,0,0,0,0,32,32,88,32,32,32,32,0,0,32,88,32,0,0,0,0,32,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,216,32,32,32,32,32,0,32,216,32,0,0,0,0,32,32,88,32,32,32,32,0,0,32,88,32,0,0,0,0,32,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,216,32,32,32,32,32,0,32,216,32,0,0,0,0,32,32,88,32,32,32,32,0,0,32,88,32,0,0,0,0,32,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,208,32,32,32,32,32,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,223,32,0,0,0,0,0,32,223,32,32,0,0,0,32,32,95,32,0,0,0,0,0,32,95,32,32,0,0,0,32,32,95,32,0,0,0,0,0,32,95,32,32,0,0,0,32,32,223,32,0,0,0,0,0,32,223,32,32,0,0,0,32,32,208,32,32,32,32,32,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,222,32,0,0,0,0,0,32,222,32,32,0,0,0,32,32,94,32,0,0,0,0,0,32,94,32,32,0,0,0,32,32,94,32,0,0,0,0,0,32,94,32,32,0,0,0,32,32,222,32,0,0,0,0,0,32,222,32,32,0,0,0,32,32,208,32,32,32,32,32,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,0,0,0,32,32,92,32,0,0,0,0,0,32,92,32,32,0,0,0,32,32,92,32,0,0,0,0,0,32,92,32,32,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,0,0,0,32,32,208,32,32,32,32,32,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,0,0,0,32,32,92,32,0,0,0,0,0,32,92,32,32,0,0,0,32,32,92,32,0,0,0,0,0,32,92,32,32,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,0,0,0,32,32,208,32,32,32,32,32,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,208,32,32,32,32,32,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,208,32,32,32,32,32,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,32,32,80,32,32,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+420353);allocate([32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,208,32,32,32,32,32,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,223,32,0,0,0,0,0,32,223,32,32,32,32,32,32,32,95,32,0,0,0,0,0,32,95,32,32,32,32,0,32,32,95,32,0,0,0,0,0,32,95,32,32,32,0,0,32,32,223,32,0,0,0,0,0,32,223,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,222,32,0,0,0,0,0,32,222,32,32,32,32,32,32,32,94,32,0,0,0,0,0,32,94,32,32,32,32,0,32,32,94,32,0,0,0,0,0,32,94,32,32,32,0,0,32,32,222,32,0,0,0,0,0,32,222,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,32,32,32,32,32,92,32,0,0,0,0,0,32,92,32,32,32,32,0,32,32,92,32,0,0,0,0,0,32,92,32,32,32,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,32,32,32,32,32,92,32,0,0,0,0,0,32,92,32,32,32,32,0,32,32,92,32,0,0,0,0,0,32,92,32,32,32,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,32,32,32,0,32,32,88,32,0,0,0,0,0,32,88,32,32,32,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,32,32,32,0,32,32,88,32,0,0,0,0,0,32,88,32,32,32,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,32,32,32,0,32,32,88,32,0,0,0,0,0,32,88,32,32,32,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,32,32,32,0,32,32,88,32,0,0,0,0,0,32,88,32,32,32,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,223,32,32,0,0,0,0,32,223,32,0,0,0,0,32,32,95,32,32,0,0,0,0,32,95,32,0,0,0,0,32,32,95,32,32,0,0,0,0,32,95,32,0,0,0,0,32,32,223,32,32,0,0,0,0,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,222,32,32,0,0,0,0,32,222,32,0,0,0,0,32,32,94,32,32,0,0,0,0,32,94,32,0,0,0,0,32,32,94,32,32,0,0,0,0,32,94,32,0,0,0,0,32,32,222,32,32,0,0,0,0,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,32,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,32,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,32,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,32,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,32,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,32,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,223,32,32,32,32,0,0,32,223,32,0,0,0,0,32,32,95,32,32,32,32,32,0,32,95,32,0,0,0,0,32,32,95,32,32,32,0,0,0,32,95,32,0,0,0,0,32,32,223,32,32,32,0,0,0,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,222,32,32,32,32,0,0,32,222,32,0,0,0,0,32,32,94,32,32,32,32,32,0,32,94,32,0,0,0,0,32,32,94,32,32,32,0,0,0,32,94,32,0,0,0,0,32,32,222,32,32,32,0,0,0,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,220,32,32,32,32,0,0,32,220,32,0,0,0,0,32,32,92,32,32,32,32,32,0,32,92,32,0,0,0,0,32,32,92,32,32,32,0,0,0,32,92,32,0,0,0,0,32,32,220,32,32,32,0,0,0,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,220,32,32,32,32,0,0,32,220,32,0,0,0,0,32,32,92,32,32,32,32,32,0,32,92,32,0,0,0,0,32,32,92,32,32,32,0,0,0,32,92,32,0,0,0,0,32,32,220,32,32,32,0,0,0,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,216,32,32,32,32,0,0,32,216,32,0,0,0,0,32,32,88,32,32,32,32,32,0,32,88,32,0,0,0,0,32,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,216,32,32,32,32,0,0,32,216,32,0,0,0,0,32,32,88,32,32,32,32,32,0,32,88,32,0,0,0,0,32,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,216,32,32,32,32,0,0,32,216,32,0,0,0,0,32,32,88,32,32,32,32,32,0,32,88,32,0,0,0,0,32,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,216,32,32,32,32,0,0,32,216,32,0,0,0,0,32,32,88,32,32,32,32,32,0,32,88,32,0,0,0,0,32,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,32,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,32,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,223,32,0,0,0,0,0,32,223,32,32,0,0,0,32,32,95,32,0,0,0,0,0,32,95,32,32,0,0,0,32,32,95,32,0,0,0,0,0,32,95,32,32,0,0,0,32,32,223,32,0,0,0,0,0,32,223,32,32,0,0,0,32,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,32,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,222,32,0,0,0,0,0,32,222,32,32,0,0,0,32,32,94,32,0,0,0,0,0,32,94,32,32,0,0,0,32,32,94,32,0,0,0,0,0,32,94,32,32,0,0,0,32,32,222,32,0,0,0,0,0,32,222,32,32,0,0,0,32,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,32,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,0,0,0,32,32,92,32,0,0,0,0,0,32,92,32,32,0,0,0,32,32,92,32,0,0,0,0,0,32,92,32,32,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,0,0,0,32,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,32,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,0,0,0,32,32,92,32,0,0,0,0,0,32,92,32,32,0,0,0,32,32,92,32,0,0,0,0,0,32,92,32,32,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,0,0,0,32,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,32,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,32,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,32,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,32,32,80,32,32,32,32,32,0,32,80,32,0,0,0,0,32,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,223,32,0,0,0,0,0,32,223,32,32,32,32,0,32,32,95,32,0,0,0,0,0,32,95,32,32,32,32,32,32,32,95,32,0,0,0,0,0,32,95,32,32,32,0,0,32,32,223,32,0,0,0,0,0,32,223,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,222,32,0,0,0,0,0,32,222,32,32,32,32,0,32,32,94,32,0,0,0,0,0,32,94,32,32,32,32,32,32,32,94,32,0,0,0,0,0,32,94,32,32,32,0,0,32,32,222,32,0,0,0,0,0,32,222,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,32,32,0,32,32,92,32,0,0,0,0,0,32,92,32,32,32,32,32,32,32,92,32,0,0,0,0,0,32,92,32,32,32,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,32,32,0,32,32,92,32,0,0,0,0,0,32,92,32,32,32,32,32,32,32,92,32,0,0,0,0,0,32,92,32,32,32,0,0,32,32,220,32,0,0,0,0,0,32,220,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,32,0,32,32,88,32,0,0,0,0,0,32,88,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,32,32,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,32,0,32,32,88,32,0,0,0,0,0,32,88,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,32,32,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,32,0,32,32,88,32,0,0,0,0,0,32,88,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,32,32,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,32,0,32,32,88,32,0,0,0,0,0,32,88,32,32,32,32,32,32,32,88,32,0,0,0,0,0,32,88,32,32,32,0,0,32,32,216,32,0,0,0,0,0,32,216,32,32,32,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,223,32,32,0,0,0,0,32,223,32,0,0,0,0,32,32,95,32,32,0,0,0,0,32,95,32,0,0,0,0,32,32,95,32,32,0,0,0,0,32,95,32,0,0,0,0,32,32,223,32,32,0,0,0,0,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,222,32,32,0,0,0,0,32,222,32,0,0,0,0,32,32,94,32,32,0,0,0,0,32,94,32,0,0,0,0,32,32,94,32,32,0,0,0,0,32,94,32,0,0,0,0,32,32,222,32,32,0,0,0,0,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,32,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,32,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,32,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,32,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,32,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,32,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,32,32,32,80,32,0,0,0,0,0,32,80,32,32,32,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,64,64,191,64,64,64,64,64,0,64,191,64,64,64,64,0,64,64,191,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,191,64,64,0,0,0,64,64,191,64,64,0,0,0,0,64,191,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,190,64,64,64,64,64,0,64,190,64,64,64,64,0,64,64,190,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,190,64,64,0,0,0,64,64,190,64,64,0,0,0,0,64,190,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,64,64,64,64,0,64,188,64,64,64,64,0,64,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,188,64,64,64,64,64,0,64,188,64,64,64,64,0,64,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,64,64,64,64,0,64,184,64,64,64,64,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,64,64,0,64,184,64,64,64,64,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,64,64,0,64,184,64,64,64,64,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,64,64,0,64,184,64,64,64,64,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,64,64,64,64,0,64,176,64,64,64,64,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,64,0,64,176,64,64,64,64,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,64,0,64,176,64,64,64,64,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,64,0,64,176,64,64,64,64,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,64,0,64,176,64,64,64,64,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,64,0,64,176,64,64,64,64,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,64,0,64,176,64,64,64,64,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,64,0,64,176,64,64,64,64,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,0,64,160,64,64,64,64,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,191,64,0,0,0,0,0,64,191,64,0,0,0,0,64,64,191,64,64,64,0,0,0,64,191,64,64,64,0,0,0,64,191,64,0,0,0,0,64,64,191,64,0,0,0,0,0,64,191,64,64,0,0,0,64,64,191,64,64,0,0,0,64,64,190,64,0,0,0,0,0,64,190,64,0,0,0,0,64,64,190,64,64,64,0,0,0,64,190,64,64,64,0,0,0,64,190,64,0,0,0,0,64,64,190,64,0,0,0,0,0,64,190,64,64,0,0,0,64,64,190,64,64,0,0,0,64,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,64,64,188,64,64,64,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,64,64,188,64,64,64,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+430593);allocate([64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,191,64,64,64,64,0,0,64,191,64,64,64,64,64,64,64,191,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,191,64,64,0,0,0,64,64,191,64,64,0,0,0,0,64,191,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,190,64,64,64,64,0,0,64,190,64,64,64,64,64,64,64,190,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,190,64,64,0,0,0,64,64,190,64,64,0,0,0,0,64,190,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,64,64,64,0,0,64,188,64,64,64,64,64,64,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,188,64,64,64,64,0,0,64,188,64,64,64,64,64,64,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,64,64,64,0,0,64,184,64,64,64,64,64,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,64,0,0,64,184,64,64,64,64,64,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,64,0,0,64,184,64,64,64,64,64,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,64,0,0,64,184,64,64,64,64,64,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,64,64,64,0,0,64,176,64,64,64,64,64,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,0,0,64,176,64,64,64,64,64,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,0,0,64,176,64,64,64,64,64,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,0,0,64,176,64,64,64,64,64,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,0,0,64,176,64,64,64,64,64,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,0,0,64,176,64,64,64,64,64,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,0,0,64,176,64,64,64,64,64,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,64,0,0,64,176,64,64,64,64,64,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,0,0,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,191,64,0,0,0,0,0,64,191,64,0,0,0,0,64,64,191,64,64,64,0,0,0,64,191,64,64,64,0,0,0,64,191,64,0,0,0,0,64,64,191,64,0,0,0,0,0,64,191,64,64,0,0,0,64,64,191,64,64,0,0,0,64,64,190,64,0,0,0,0,0,64,190,64,0,0,0,0,64,64,190,64,64,64,0,0,0,64,190,64,64,64,0,0,0,64,190,64,0,0,0,0,64,64,190,64,0,0,0,0,0,64,190,64,64,0,0,0,64,64,190,64,64,0,0,0,64,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,64,64,188,64,64,64,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,64,64,188,64,64,64,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,128,128,127,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,127,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,127,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,127,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,127,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,127,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,127,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,127,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,126,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,126,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,126,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,126,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,126,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,126,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,126,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,126,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,124,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,124,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,120,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,120,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,120,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,120,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,128,128,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,128,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,0,0,0,0,128,124,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,124,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,127,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,127,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,127,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,127,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,127,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,127,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,126,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,126,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,126,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,126,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,126,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,126,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,120,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,120,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,120,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,120,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+440833);allocate([128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,128,128,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,128,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,0,0,128,128,127,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,127,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,127,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,127,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,127,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,127,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,127,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,127,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,126,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,126,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,126,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,126,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,126,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,126,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,126,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,126,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,124,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,124,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,120,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,120,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,120,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,120,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,128,128,0,128,64,128,128,0,0,0,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,128,128,0,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,0,0,0,128,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,96,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,124,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,124,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,124,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,124,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,127,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,127,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,127,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,127,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,127,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,127,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,126,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,126,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,126,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,126,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,126,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,126,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,126,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,120,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,120,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,120,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,120,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,128,128,128,128,128,112,128,0,0,0,0,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+451073);allocate([128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,128,128,64,128,128,128,128,0,128,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,128,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,96,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,1,1,1,254,1,1,1,1,0,0,1,126,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,254,1,1,1,0,0,0,1,126,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,126,1,1,0,0,0,0,1,254,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,126,1,1,0,0,0,0,1,254,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,1,1,0,0,1,14,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,1,1,1,0,0,1,30,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,254,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,30,1,1,1,0,0,0,1,30,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,254,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,254,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,254,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,1,1,0,0,1,14,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,1,1,1,0,0,1,62,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,62,1,1,1,0,0,0,1,62,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,1,1,0,0,1,14,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,1,1,1,0,0,1,30,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,30,1,1,1,0,0,0,1,30,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,1,1,0,0,1,14,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,126,1,1,1,1,0,0,1,254,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,126,1,1,1,0,0,0,1,254,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,254,1,1,1,1,0,0,1,126,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,254,1,1,1,0,0,0,1,126,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,1,1,0,0,1,14,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,14,1,1,1,1,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,1,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,1,1,1,0,0,1,30,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,126,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,30,1,1,1,0,0,0,1,30,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,126,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,30,1,1,1,1,0,0,1,30,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,126,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,30,1,1,1,0,0,0,1,30,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,126,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,1,1,0,0,1,14,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,14,1,1,1,1,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,1,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,1,1,1,0,0,1,62,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,62,1,1,1,0,0,0,1,62,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,62,1,1,1,1,0,0,1,62,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,62,1,1,1,0,0,0,1,62,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,1,1,0,0,1,14,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,14,1,1,1,1,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,1,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,1,1,1,0,0,1,30,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,30,1,1,1,0,0,0,1,30,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,30,1,1,1,1,0,0,1,30,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,30,1,1,1,0,0,0,1,30,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,1,1,0,0,1,14,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,14,1,1,1,1,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,14,1,1,1,0,0,0,1,14,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,254,1,1,0,0,0,0,1,126,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,254,1,1,0,0,0,0,1,126,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,126,1,1,1,1,0,0,1,254,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,126,1,1,1,0,0,0,1,254,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,14,1,1,1,1,0,0,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,14,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,254,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,254,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,30,1,1,1,1,0,0,1,30,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,254,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,30,1,1,1,0,0,0,1,30,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,254,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,14,1,1,1,1,0,0,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,14,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,6,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+461313);allocate([1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,1,0,0,0,0,1,62,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,62,1,1,0,0,0,0,1,62,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,62,1,1,1,1,0,0,1,62,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,62,1,1,1,0,0,0,1,62,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,14,1,1,1,1,0,0,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,14,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,30,1,1,1,1,0,0,1,30,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,30,1,1,1,0,0,0,1,30,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,1,1,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,1,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,0,1,1,14,1,1,1,1,0,0,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,14,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,126,1,1,0,0,0,0,1,254,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,126,1,1,0,0,0,0,1,254,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,254,1,1,0,0,0,0,1,126,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,254,1,1,0,0,0,0,1,126,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,14,1,1,0,0,0,0,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,126,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,126,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,30,1,1,0,0,0,0,1,30,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,126,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,126,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,14,1,1,0,0,0,0,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,62,1,1,0,0,0,0,1,62,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,62,1,1,0,0,0,0,1,62,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,14,1,1,0,0,0,0,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,30,1,1,0,0,0,0,1,30,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,1,0,1,1,14,1,1,0,0,0,0,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,1,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,1,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,1,1,1,0,0,1,6,1,1,1,1,0,1,1,2,1,1,1,1,0,0,1,2,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,1,1,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,1,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,1,1,6,1,1,1,0,0,0,1,6,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,2,2,2,253,2,2,2,2,0,0,2,253,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,2,2,0,0,2,29,2,2,2,2,0,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,125,2,2,0,0,0,0,2,125,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,253,2,2,2,0,0,0,2,253,2,2,2,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,125,2,2,0,0,0,0,2,125,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,29,2,2,2,2,0,0,2,29,2,2,2,2,2,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,253,2,2,2,2,0,0,2,253,2,2,2,2,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,2,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,125,2,2,0,0,0,0,2,125,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,2,0,0,0,2,29,2,2,2,0,2,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,253,2,2,2,0,0,0,2,253,2,2,2,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,2,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,125,2,2,0,0,0,0,2,125,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,61,2,2,2,2,0,0,2,61,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,2,2,0,0,2,29,2,2,2,2,0,2,2,253,2,0,0,0,0,0,2,253,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,2,0,0,0,0,2,61,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,2,2,125,2,0,0,0,0,0,2,125,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,2,2,0,0,0,2,61,2,2,2,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,2,2,253,2,0,0,0,0,0,2,253,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,2,0,0,0,0,2,61,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,2,2,125,2,0,0,0,0,0,2,125,2,0,0,0,2,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,29,2,2,2,2,0,0,2,29,2,2,2,2,2,2,2,253,2,0,0,0,0,0,2,253,2,0,0,0,0,2,2,61,2,2,2,2,0,0,2,61,2,2,2,2,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,2,2,2,125,2,0,0,0,0,0,2,125,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,61,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,2,0,0,0,2,29,2,2,2,0,2,2,2,253,2,0,0,0,0,0,2,253,2,0,0,0,0,2,2,61,2,2,2,0,0,0,2,61,2,2,2,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,2,2,2,125,2,0,0,0,0,0,2,125,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,61,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+471554);allocate([2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,125,2,2,2,2,0,0,2,125,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,2,2,0,0,2,29,2,2,2,2,0,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,253,2,2,0,0,0,0,2,253,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,125,2,2,2,0,0,0,2,125,2,2,2,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,253,2,2,0,0,0,0,2,253,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,29,2,2,2,2,0,0,2,29,2,2,2,2,2,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,125,2,2,2,2,0,0,2,125,2,2,2,2,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,2,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,253,2,2,0,0,0,0,2,253,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,2,0,0,0,2,29,2,2,2,0,2,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,125,2,2,2,0,0,0,2,125,2,2,2,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,2,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,253,2,2,0,0,0,0,2,253,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,61,2,2,2,2,0,0,2,61,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,2,2,0,0,2,29,2,2,2,2,0,2,2,125,2,0,0,0,0,0,2,125,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,2,0,0,0,0,2,61,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,2,2,253,2,0,0,0,0,0,2,253,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,2,2,0,0,0,2,61,2,2,2,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,2,2,125,2,0,0,0,0,0,2,125,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,2,0,0,0,0,2,61,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,2,2,253,2,0,0,0,0,0,2,253,2,0,0,0,2,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,29,2,2,2,2,0,0,2,29,2,2,2,2,2,2,2,125,2,0,0,0,0,0,2,125,2,0,0,0,0,2,2,61,2,2,2,2,0,0,2,61,2,2,2,2,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,2,2,2,253,2,0,0,0,0,0,2,253,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,61,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,2,0,0,0,2,29,2,2,2,0,2,2,2,125,2,0,0,0,0,0,2,125,2,0,0,0,0,2,2,61,2,2,2,0,0,0,2,61,2,2,2,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,29,2,2,0,0,2,2,2,253,2,0,0,0,0,0,2,253,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,61,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,2,0,0,2,13,2,2,2,2,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,2,2,0,0,2,5,2,2,2,2,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,4,4,4,251,4,4,4,4,0,0,4,11,4,4,4,4,4,4,4,27,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,251,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,123,4,4,4,0,0,0,4,11,4,4,4,0,4,4,4,27,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,123,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,26,4,4,4,4,0,0,4,10,4,4,4,4,4,4,4,250,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,250,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,4,4,0,0,0,4,10,4,4,4,0,4,4,4,122,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,122,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,251,4,4,4,4,0,0,4,251,4,4,4,4,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,4,4,251,4,0,0,0,0,0,4,251,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,123,4,4,4,0,0,0,4,123,4,4,4,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,4,4,123,4,0,0,0,0,0,4,123,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,26,4,4,4,4,0,0,4,26,4,4,4,4,0,4,4,250,4,4,0,0,0,0,4,250,4,4,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,250,4,0,0,0,0,0,4,250,4,0,0,0,0,4,4,26,4,4,4,0,0,0,4,26,4,4,4,0,0,4,4,122,4,4,0,0,0,0,4,122,4,4,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,122,4,0,0,0,0,0,4,122,4,0,0,0,4,4,4,11,4,4,4,4,0,0,4,251,4,4,4,4,4,4,4,11,4,4,0,0,0,0,4,27,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,251,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,4,4,0,0,0,4,123,4,4,4,0,4,4,4,11,4,4,0,0,0,0,4,27,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,123,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,10,4,4,4,4,0,0,4,26,4,4,4,4,4,4,4,10,4,4,0,0,0,0,4,250,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,250,4,0,0,0,4,4,4,10,4,4,4,0,0,0,4,26,4,4,4,0,4,4,4,10,4,4,0,0,0,0,4,122,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,122,4,0,0,0,0,4,4,11,4,4,4,4,0,0,4,11,4,4,4,4,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,0,4,10,4,4,4,4,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,27,4,4,4,4,0,0,4,11,4,4,4,4,4,4,4,251,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,251,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,4,4,0,0,0,4,11,4,4,4,0,4,4,4,123,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,123,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,250,4,4,4,4,0,0,4,10,4,4,4,4,4,4,4,26,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,250,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,122,4,4,4,0,0,0,4,10,4,4,4,0,4,4,4,26,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,122,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,27,4,4,4,4,0,0,4,27,4,4,4,4,0,4,4,251,4,4,0,0,0,0,4,251,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,251,4,0,0,0,0,0,4,251,4,0,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,0,0,4,4,123,4,4,0,0,0,0,4,123,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,123,4,0,0,0,0,0,4,123,4,0,0,0,0,4,4,250,4,4,4,4,0,0,4,250,4,4,4,4,0,4,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,4,4,250,4,0,0,0,0,0,4,250,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,122,4,4,4,0,0,0,4,122,4,4,4,0,0,4,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,4,4,122,4,0,0,0,0,0,4,122,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,11,4,4,4,4,0,0,4,27,4,4,4,4,4,4,4,11,4,4,0,0,0,0,4,251,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,251,4,0,0,0,4,4,4,11,4,4,4,0,0,0,4,27,4,4,4,0,4,4,4,11,4,4,0,0,0,0,4,123,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,123,4,0,0,0,4,4,4,10,4,4,4,4,0,0,4,250,4,4,4,4,4,4,4,10,4,4,0,0,0,0,4,26,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,250,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,4,4,0,0,0,4,122,4,4,4,0,4,4,4,10,4,4,0,0,0,0,4,26,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,122,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,11,4,4,4,4,0,0,4,11,4,4,4,4,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,0,4,10,4,4,4,4,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,59,4,4,4,4,0,0,4,11,4,4,4,4,4,4,4,27,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,59,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,59,4,4,4,0,0,0,4,11,4,4,4,0,4,4,4,27,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,59,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,26,4,4,4,4,0,0,4,10,4,4,4,4,4,4,4,58,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,58,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,4,4,0,0,0,4,10,4,4,4,0,4,4,4,58,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,59,4,4,4,4,0,0,4,59,4,4,4,4,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,4,4,0,0,0,4,59,4,4,4,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,26,4,4,4,4,0,0,4,26,4,4,4,4,0,4,4,58,4,4,0,0,0,0,4,58,4,4,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,26,4,4,4,0,0,0,4,26,4,4,4,0,0,4,4,58,4,4,0,0,0,0,4,58,4,4,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,58,4,0,0,0,0,0,4,58,4,0,0,0,4,4,4,11,4,4,4,4,0,0,4,59,4,4,4,4,4,4,4,11,4,4,0,0,0,0,4,27,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,59,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,4,4,0,0,0,4,59,4,4,4,0,4,4,4,11,4,4,0,0,0,0,4,27,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,59,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,10,4,4,4,4,0,0,4,26,4,4,4,4,4,4,4,10,4,4,0,0,0,0,4,58,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,58,4,0,0,0,4,4,4,10,4,4,4,0,0,0,4,26,4,4,4,0,4,4,4,10,4,4,0,0,0,0,4,58,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,11,4,4,4,4,0,0,4,11,4,4,4,4,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,0,4,10,4,4,4,4,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,27,4,4,4,4,0,0,4,11,4,4,4,4,4,4,4,59,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,59,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,4,4,0,0,0,4,11,4,4,4,0,4,4,4,59,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,59,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,58,4,4,4,4,0,0,4,10,4,4,4,4,4,4,4,26,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,58,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,58,4,4,4,0,0,0,4,10,4,4,4,0,4,4,4,26,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,58,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,27,4,4,4,4,0,0,4,27,4,4,4,4,0,4,4,59,4,4,0,0,0,0,4,59,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,0,0,4,4,59,4,4,0,0,0,0,4,59,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,58,4,4,4,4,0,0,4,58,4,4,4,4,0,4,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,4,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,58,4,4,4,0,0,0,4,58,4,4,4,0,0,4,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,4,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,11,4,4,4,4,0,0,4,27,4,4,4,4,4,4,4,11,4,4,0,0,0,0,4,59,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,59,4,0,0,0,4,4,4,11,4,4,4,0,0,0,4,27,4,4,4,0,4,4,4,11,4,4,0,0,0,0,4,59,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,59,4,0,0,0,4,4,4,10,4,4,4,4,0,0,4,58,4,4,4,4,4,4,4,10,4,4,0,0,0,0,4,26,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,58,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,4,4,0,0,0,4,58,4,4,4,0,4,4,4,10,4,4,0,0,0,0,4,26,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,58,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,11,4,4,4,4,0,0,4,11,4,4,4,4,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,0,4,10,4,4,4,4,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,123,4,4,4,4,0,0,4,11,4,4,4,4,4,4,4,27,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,123,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,251,4,4,4,0,0,0,4,11,4,4,4,0,4,4,4,27,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,251,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,26,4,4,4,4,0,0,4,10,4,4,4,4,4,4,4,122,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,122,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,4,4,0,0,0,4,10,4,4,4,0,4,4,4,250,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,250,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,123,4,4,4,4,0,0,4,123,4,4,4,4,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,4,4,123,4,0,0,0,0,0,4,123,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,251,4,4,4,0,0,0,4,251,4,4,4,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,4,4,251,4,0,0,0,0,0,4,251,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,26,4,4,4,4,0,0,4,26,4,4,4,4,0,4,4,122,4,4,0,0,0,0,4,122,4,4,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,122,4,0,0,0,0,0,4,122,4,0,0,0,0,4,4,26,4,4,4,0,0,0,4,26,4,4,4,0,0,4,4,250,4,4,0,0,0,0,4,250,4,4,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,250,4,0,0,0,0,0,4,250,4,0,0,0,4,4,4,11,4,4,4,4,0,0,4,123,4,4,4,4,4,4,4,11,4,4,0,0,0,0,4,27,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,123,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,4,4,0,0,0,4,251,4,4,4,0,4,4,4,11,4,4,0,0,0,0,4,27,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,251,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,10,4,4,4,4,0,0,4,26,4,4,4,4,4,4,4,10,4,4,0,0,0,0,4,122,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,122,4,0,0,0,4,4,4,10,4,4,4,0,0,0,4,26,4,4,4,0,4,4,4,10,4,4,0,0,0,0,4,250,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,250,4,0,0,0,0,4,4,11,4,4,4,4,0,0,4,11,4,4,4,4,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,0,4,10,4,4,4,4,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,27,4,4,4,4,0,0,4,11,4,4,4,4,4,4,4,123,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,123,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,4,4,0,0,0,4,11,4,4,4,0,4,4,4,251,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,251,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,122,4,4,4,4,0,0,4,10,4,4,4,4,4,4,4,26,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,122,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,250,4,4,4,0,0,0,4,10,4,4,4,0,4,4,4,26,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,250,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,27,4,4,4,4,0,0,4,27,4,4,4,4,0,4,4,123,4,4,0,0,0,0,4,123,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,123,4,0,0,0,0,0,4,123,4,0,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,0,0,4,4,251,4,4,0,0,0,0,4,251,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,251,4,0,0,0,0,0,4,251,4,0,0,0,0,4,4,122,4,4,4,4,0,0,4,122,4,4,4,4,0,4,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,4,4,122,4,0,0,0,0,0,4,122,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,250,4,4,4,0,0,0,4,250,4,4,4,0,0,4,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,4,4,250,4,0,0,0,0,0,4,250,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,11,4,4,4,4,0,0,4,27,4,4,4,4,4,4,4,11,4,4,0,0,0,0,4,123,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,123,4,0,0,0,4,4,4,11,4,4,4,0,0,0,4,27,4,4,4,0,4,4,4,11,4,4,0,0,0,0,4,251,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,251,4,0,0,0,4,4,4,10,4,4,4,4,0,0,4,122,4,4,4,4,4,4,4,10,4,4,0,0,0,0,4,26,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,122,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,4,4,0,0,0,4,250,4,4,4,0,4,4,4,10,4,4,0,0,0,0,4,26,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,250,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,11,4,4,4,4,0,0,4,11,4,4,4,4,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+481794);allocate([4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,0,4,10,4,4,4,4,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,59,4,4,4,4,0,0,4,11,4,4,4,4,4,4,4,27,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,59,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,59,4,4,4,0,0,0,4,11,4,4,4,0,4,4,4,27,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,59,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,26,4,4,4,4,0,0,4,10,4,4,4,4,4,4,4,58,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,58,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,4,4,0,0,0,4,10,4,4,4,0,4,4,4,58,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,59,4,4,4,4,0,0,4,59,4,4,4,4,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,4,4,0,0,0,4,59,4,4,4,0,0,4,4,27,4,4,0,0,0,0,4,27,4,4,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,26,4,4,4,4,0,0,4,26,4,4,4,4,0,4,4,58,4,4,0,0,0,0,4,58,4,4,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,26,4,4,4,0,0,0,4,26,4,4,4,0,0,4,4,58,4,4,0,0,0,0,4,58,4,4,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,58,4,0,0,0,0,0,4,58,4,0,0,0,4,4,4,11,4,4,4,4,0,0,4,59,4,4,4,4,4,4,4,11,4,4,0,0,0,0,4,27,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,59,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,4,4,0,0,0,4,59,4,4,4,0,4,4,4,11,4,4,0,0,0,0,4,27,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,59,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,10,4,4,4,4,0,0,4,26,4,4,4,4,4,4,4,10,4,4,0,0,0,0,4,58,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,58,4,0,0,0,4,4,4,10,4,4,4,0,0,0,4,26,4,4,4,0,4,4,4,10,4,4,0,0,0,0,4,58,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,11,4,4,4,4,0,0,4,11,4,4,4,4,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,0,4,10,4,4,4,4,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,27,4,4,4,4,0,0,4,11,4,4,4,4,4,4,4,59,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,59,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,27,4,4,4,0,0,0,4,11,4,4,4,0,4,4,4,59,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,27,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,59,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,58,4,4,4,4,0,0,4,10,4,4,4,4,4,4,4,26,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,58,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,58,4,4,4,0,0,0,4,10,4,4,4,0,4,4,4,26,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,58,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,27,4,4,4,4,0,0,4,27,4,4,4,4,0,4,4,59,4,4,0,0,0,0,4,59,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,4,4,0,0,0,4,27,4,4,4,0,0,4,4,59,4,4,0,0,0,0,4,59,4,4,0,0,0,4,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,4,4,58,4,4,4,4,0,0,4,58,4,4,4,4,0,4,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,4,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,58,4,4,4,0,0,0,4,58,4,4,4,0,0,4,4,26,4,4,0,0,0,0,4,26,4,4,0,0,0,4,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,11,4,4,4,4,0,0,4,27,4,4,4,4,4,4,4,11,4,4,0,0,0,0,4,59,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,59,4,0,0,0,4,4,4,11,4,4,4,0,0,0,4,27,4,4,4,0,4,4,4,11,4,4,0,0,0,0,4,59,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,0,4,59,4,0,0,0,4,4,4,10,4,4,4,4,0,0,4,58,4,4,4,4,4,4,4,10,4,4,0,0,0,0,4,26,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,58,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,10,4,4,4,0,0,0,4,58,4,4,4,0,4,4,4,10,4,4,0,0,0,0,4,26,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,58,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,11,4,4,4,4,0,0,4,11,4,4,4,4,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,4,4,10,4,4,4,4,0,0,4,10,4,4,4,4,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,8,8,8,247,8,8,8,8,0,8,8,247,8,8,8,8,8,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,8,8,8,118,8,8,0,0,0,8,8,118,8,8,0,0,8,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,8,8,8,118,8,8,0,0,0,8,8,118,8,8,0,0,8,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,8,8,8,247,8,8,8,0,0,8,8,247,8,8,8,0,8,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,8,8,8,244,8,8,0,0,0,8,8,244,8,8,0,0,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,116,8,8,8,0,0,8,8,116,8,8,8,0,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,116,8,8,8,8,0,8,8,116,8,8,8,8,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,244,8,8,0,0,0,8,8,244,8,8,0,0,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,244,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,8,8,0,0,8,116,8,8,8,8,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,116,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,244,8,8,8,8,0,0,8,244,8,8,8,8,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,8,8,8,23,8,8,8,8,0,8,8,23,8,8,8,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,23,8,8,8,0,0,8,8,23,8,8,8,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,8,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,8,8,8,55,8,8,8,8,0,8,8,55,8,8,8,8,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,54,8,8,0,0,0,8,8,54,8,8,0,0,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,54,8,8,0,0,0,8,8,54,8,8,0,0,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,55,8,8,8,0,0,8,8,55,8,8,8,0,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,8,0,0,8,8,52,8,8,8,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,8,8,0,8,8,52,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,8,8,8,23,8,8,8,8,0,8,8,23,8,8,8,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,23,8,8,8,0,0,8,8,23,8,8,8,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,8,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,8,8,8,119,8,8,8,8,0,8,8,119,8,8,8,8,8,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,8,8,8,246,8,8,8,0,0,8,8,246,8,8,8,0,8,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,8,8,8,246,8,8,8,8,0,8,8,246,8,8,8,8,8,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,8,8,8,119,8,8,8,0,0,8,8,119,8,8,8,0,8,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,8,8,8,116,8,8,0,0,0,8,8,116,8,8,0,0,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,244,8,8,0,0,0,8,8,244,8,8,0,0,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,244,8,8,0,0,0,8,8,244,8,8,0,0,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,116,8,8,0,0,0,8,8,116,8,8,0,0,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,247,8,8,8,8,0,0,8,247,8,8,8,8,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,8,0,0,0,8,247,8,8,8,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,116,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,8,8,0,0,8,116,8,8,8,8,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,8,8,8,23,8,8,8,8,0,8,8,23,8,8,8,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,8,8,0,0,8,8,22,8,8,8,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,22,8,8,8,8,0,8,8,22,8,8,8,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,23,8,8,8,0,0,8,8,23,8,8,8,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,8,8,8,55,8,8,8,8,0,8,8,55,8,8,8,8,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,54,8,8,8,0,0,8,8,54,8,8,8,0,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,54,8,8,8,8,0,8,8,54,8,8,8,8,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,55,8,8,8,0,0,8,8,55,8,8,8,0,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,55,8,8,8,8,0,0,8,55,8,8,8,8,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,8,8,8,23,8,8,8,8,0,8,8,23,8,8,8,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,8,8,0,0,8,8,22,8,8,8,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,22,8,8,8,8,0,8,8,22,8,8,8,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,23,8,8,8,0,0,8,8,23,8,8,8,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,8,8,8,247,8,8,0,0,0,8,8,247,8,8,0,0,8,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,8,8,8,118,8,8,8,0,0,8,8,118,8,8,8,0,8,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,8,8,8,118,8,8,8,8,0,8,8,118,8,8,8,8,8,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,8,8,8,247,8,8,0,0,0,8,8,247,8,8,0,0,8,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,8,8,8,244,8,8,8,8,0,8,8,244,8,8,8,8,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,116,8,8,0,0,0,8,8,116,8,8,0,0,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,116,8,8,0,0,0,8,8,116,8,8,0,0,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,244,8,8,8,0,0,8,8,244,8,8,8,0,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,0,8,246,8,8,8,0,0,0,8,246,8,8,8,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,119,8,8,8,8,0,0,8,119,8,8,8,8,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,8,0,0,0,8,119,8,8,8,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,246,8,8,8,8,0,0,8,246,8,8,8,8,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,8,8,0,0,8,8,22,8,8,8,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,22,8,8,8,8,0,8,8,22,8,8,8,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,8,8,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,8,8,8,55,8,8,0,0,0,8,8,55,8,8,0,0,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,54,8,8,8,0,0,8,8,54,8,8,8,0,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,54,8,8,8,8,0,8,8,54,8,8,8,8,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,55,8,8,0,0,0,8,8,55,8,8,0,0,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,52,8,8,8,8,0,8,8,52,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,8,0,0,8,8,52,8,8,8,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,54,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,55,8,8,8,8,0,0,8,55,8,8,8,8,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,55,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,8,8,8,0,0,8,54,8,8,8,8,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,8,8,0,0,8,8,22,8,8,8,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,22,8,8,8,8,0,8,8,22,8,8,8,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,8,8,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8,8,8,0,0,8,23,8,8,8,8,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,8,8,8,119,8,8,0,0,0,8,8,119,8,8,0,0,8,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,8,8,8,246,8,8,0,0,0,8,8,246,8,8,0,0,8,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,8,8,8,246,8,8,0,0,0,8,8,246,8,8,0,0,8,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,8,8,8,119,8,8,0,0,0,8,8,119,8,8,0,0,8,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,8,8,8,116,8,8,8,8,0,8,8,116,8,8,8,8,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,244,8,8,8,0,0,8,8,244,8,8,8,0,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,244,8,8,8,8,0,8,8,244,8,8,8,8,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,116,8,8,8,0,0,8,8,116,8,8,8,0,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,118,8,8,8,0,0,0,8,118,8,8,8,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,118,8,8,8,8,0,0,8,118,8,8,8,8,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,244,8,8,8,8,0,0,8,244,8,8,8,8,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,244,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,8,8,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,8,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,8,8,8,55,8,8,0,0,0,8,8,55,8,8,0,0,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,54,8,8,0,0,0,8,8,54,8,8,0,0,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,54,8,8,0,0,0,8,8,54,8,8,0,0,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,55,8,8,0,0,0,8,8,55,8,8,0,0,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,52,8,8,8,8,0,8,8,52,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,8,0,0,8,8,52,8,8,8,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,8,8,0,8,8,52,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,8,8,0,0,8,8,52,8,8,8,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,54,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,8,8,8,0,0,8,54,8,8,8,8,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,8,0,0,8,52,8,8,8,8,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,8,8,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,8,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+492034);allocate([8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,8,8,8,0,0,8,22,8,8,8,8,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,8,0,0,8,20,8,8,8,8,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,16,16,16,239,16,16,16,16,0,0,16,111,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,16,16,0,0,0,16,40,16,16,0,0,16,16,16,238,16,16,16,16,0,0,16,110,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,16,16,0,0,0,16,40,16,16,0,0,16,16,16,236,16,16,16,16,0,0,16,108,16,16,0,0,0,16,16,47,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,104,16,0,0,0,0,16,16,47,16,0,0,0,0,16,16,40,16,16,16,0,0,0,16,40,16,16,0,0,16,16,16,236,16,16,16,16,0,0,16,108,16,16,0,0,0,16,16,46,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,104,16,0,0,0,0,16,16,46,16,0,0,0,0,16,16,40,16,16,16,0,0,0,16,40,16,16,0,0,16,16,16,232,16,16,16,16,0,0,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,236,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,16,16,16,0,0,16,47,16,16,0,0,16,16,16,232,16,16,16,16,0,0,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,236,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,16,16,16,0,0,16,46,16,16,0,0,16,16,16,232,16,16,16,16,0,0,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,239,16,0,0,0,16,16,16,111,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,16,16,16,0,0,16,44,16,16,0,0,16,16,16,232,16,16,16,16,0,0,16,104,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,238,16,0,0,0,16,16,16,110,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,16,16,16,0,0,16,44,16,16,0,0,16,16,16,111,16,16,16,0,16,16,16,239,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,40,16,16,0,0,16,16,16,110,16,16,16,0,16,16,16,238,16,16,0,0,0,16,16,44,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,40,16,16,0,0,16,16,16,108,16,16,16,0,16,16,16,236,16,16,0,0,0,16,16,47,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,40,16,16,0,0,16,16,16,108,16,16,16,0,16,16,16,236,16,16,0,0,0,16,16,46,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,40,16,16,0,0,16,16,16,104,16,16,16,0,16,16,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,16,16,0,0,0,16,47,16,16,0,0,16,16,16,104,16,16,16,0,16,16,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,16,16,0,0,0,16,46,16,16,0,0,16,16,16,104,16,16,16,0,16,16,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,44,16,16,16,0,0,0,16,44,16,16,0,0,16,16,16,104,16,16,16,0,16,16,16,232,16,16,0,0,0,16,16,40,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,44,16,16,16,0,0,0,16,44,16,16,0,0,16,16,16,47,16,16,16,16,0,0,16,47,16,16,0,0,0,16,16,108,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,236,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,232,16,16,0,0,16,16,16,46,16,16,16,16,0,0,16,46,16,16,0,0,0,16,16,108,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,236,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,232,16,16,0,0,16,16,16,44,16,16,16,16,0,0,16,44,16,16,0,0,0,16,16,111,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,239,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,232,16,16,0,0,16,16,16,44,16,16,16,16,0,0,16,44,16,16,0,0,0,16,16,110,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,238,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,232,16,16,0,0,16,16,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,44,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,239,16,16,16,16,0,0,16,111,16,16,0,0,16,16,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,44,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,238,16,16,16,16,0,0,16,110,16,16,0,0,16,16,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,47,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,236,16,16,16,16,0,0,16,108,16,16,0,0,16,16,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,46,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,236,16,16,16,16,0,0,16,108,16,16,0,0,16,16,16,47,16,16,16,0,16,16,16,47,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,108,16,0,0,0,0,16,16,232,16,16,16,16,0,0,16,104,16,16,0,0,16,16,16,46,16,16,16,0,16,16,16,46,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,108,16,0,0,0,0,16,16,232,16,16,16,16,0,0,16,104,16,16,0,0,16,16,16,44,16,16,16,0,16,16,16,44,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,111,16,0,0,0,0,16,16,232,16,16,16,16,0,0,16,104,16,16,0,0,16,16,16,44,16,16,16,0,16,16,16,44,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,110,16,0,0,0,0,16,16,232,16,16,16,16,0,0,16,104,16,16,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,111,16,16,16,0,0,16,16,239,16,16,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,110,16,16,16,0,0,16,16,238,16,16,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,108,16,16,16,0,0,16,16,236,16,16,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,108,16,16,16,0,0,16,16,236,16,16,0,0,16,16,16,111,16,16,16,16,0,0,16,239,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,0,0,16,16,40,16,16,0,0,16,16,16,110,16,16,16,16,0,0,16,238,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,0,0,16,16,40,16,16,0,0,16,16,16,108,16,16,16,16,0,0,16,236,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,40,16,16,16,0,0,16,16,40,16,16,0,0,16,16,16,108,16,16,16,16,0,0,16,236,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,40,16,16,16,0,0,16,16,40,16,16,0,0,16,16,16,104,16,16,16,16,0,0,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,108,16,0,0,0,16,16,16,236,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,16,16,16,0,16,16,47,16,16,0,0,16,16,16,104,16,16,16,16,0,0,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,108,16,0,0,0,16,16,16,236,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,16,16,16,0,16,16,46,16,16,0,0,16,16,16,104,16,16,16,16,0,0,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,111,16,0,0,0,16,16,16,239,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,44,16,16,16,16,0,16,16,44,16,16,0,0,16,16,16,104,16,16,16,16,0,0,16,232,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,110,16,0,0,0,16,16,16,238,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,44,16,16,16,16,0,16,16,44,16,16,0,0,16,16,16,239,16,16,16,0,16,16,16,111,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,40,16,16,0,0,16,16,16,238,16,16,16,0,16,16,16,110,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,40,16,16,0,0,16,16,16,236,16,16,16,0,16,16,16,108,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,47,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,40,16,16,0,0,16,16,16,236,16,16,16,0,16,16,16,108,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,46,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,40,16,16,0,0,16,16,16,232,16,16,16,0,16,16,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,16,16,0,0,16,16,47,16,16,0,0,16,16,16,232,16,16,16,0,16,16,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,16,16,0,0,16,16,46,16,16,0,0,16,16,16,232,16,16,16,0,16,16,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,16,16,0,0,16,16,44,16,16,0,0,16,16,16,232,16,16,16,0,16,16,16,104,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,16,16,0,0,16,16,44,16,16,0,0,16,16,16,47,16,16,16,16,0,0,16,47,16,16,0,0,0,16,16,236,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,108,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,104,16,16,0,0,16,16,16,46,16,16,16,16,0,0,16,46,16,16,0,0,0,16,16,236,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,108,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,104,16,16,0,0,16,16,16,44,16,16,16,16,0,0,16,44,16,16,0,0,0,16,16,239,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,111,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,104,16,16,0,0,16,16,16,44,16,16,16,16,0,0,16,44,16,16,0,0,0,16,16,238,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,110,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,104,16,16,0,0,16,16,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,44,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,111,16,16,16,16,0,0,16,239,16,16,0,0,16,16,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,44,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,110,16,16,16,16,0,0,16,238,16,16,0,0,16,16,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,47,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,108,16,16,16,16,0,0,16,236,16,16,0,0,16,16,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,46,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,108,16,16,16,16,0,0,16,236,16,16,0,0,16,16,16,47,16,16,16,0,16,16,16,47,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,236,16,0,0,0,0,16,16,104,16,16,16,16,0,0,16,232,16,16,0,0,16,16,16,46,16,16,16,0,16,16,16,46,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,236,16,0,0,0,0,16,16,104,16,16,16,16,0,0,16,232,16,16,0,0,16,16,16,44,16,16,16,0,16,16,16,44,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,239,16,0,0,0,0,16,16,104,16,16,16,16,0,0,16,232,16,16,0,0,16,16,16,44,16,16,16,0,16,16,16,44,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,238,16,0,0,0,0,16,16,104,16,16,16,16,0,0,16,232,16,16,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,239,16,16,16,0,0,16,16,111,16,16,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,238,16,16,16,0,0,16,16,110,16,16,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,236,16,16,16,0,0,16,16,108,16,16,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,236,16,16,16,0,0,16,16,108,16,16,0,0,0,0,16,239,16,16,16,16,16,16,16,111,16,16,0,0,0,0,16,44,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,0,0,16,16,40,16,16,0,0,0,0,16,238,16,16,16,16,16,16,16,110,16,16,0,0,0,0,16,44,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,0,0,16,16,40,16,16,0,0,0,0,16,236,16,16,16,16,16,16,16,108,16,16,0,0,0,0,16,47,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,40,16,16,16,0,0,16,16,40,16,16,0,0,0,0,16,236,16,16,16,16,16,16,16,108,16,16,0,0,0,0,16,46,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,40,16,16,16,0,0,16,16,40,16,16,0,0,0,0,16,232,16,16,16,16,16,16,16,104,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,16,16,16,0,16,16,47,16,16,0,0,0,0,16,232,16,16,16,16,16,16,16,104,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,108,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,16,16,16,0,16,16,46,16,16,0,0,0,0,16,232,16,16,16,16,16,16,16,104,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,239,16,0,0,0,0,0,16,111,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,44,16,16,16,16,0,16,16,44,16,16,0,0,0,0,16,232,16,16,16,16,16,16,16,104,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,238,16,0,0,0,0,0,16,110,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,44,16,16,16,16,0,16,16,44,16,16,0,0,0,0,16,111,16,16,16,0,0,0,16,239,16,16,0,0,0,0,16,44,16,0,0,0,16,16,16,104,16,0,0,0,16,16,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,40,16,16,0,0,0,0,16,110,16,16,16,0,0,0,16,238,16,16,0,0,0,0,16,44,16,0,0,0,16,16,16,104,16,0,0,0,16,16,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,40,16,16,0,0,0,0,16,108,16,16,16,0,0,0,16,236,16,16,0,0,0,0,16,47,16,0,0,0,16,16,16,104,16,0,0,0,16,16,16,232,16,0,0,0,0,16,16,47,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,40,16,16,0,0,0,0,16,108,16,16,16,0,0,0,16,236,16,16,0,0,0,0,16,46,16,0,0,0,16,16,16,104,16,0,0,0,16,16,16,232,16,0,0,0,0,16,16,46,16,0,0,0,0,16,16,40,16,16,16,16,0,16,16,40,16,16,0,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,108,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,16,16,0,0,16,16,47,16,16,0,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,108,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,16,16,0,0,16,16,46,16,16,0,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,111,16,0,0,0,16,16,16,239,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,16,16,0,0,16,16,44,16,16,0,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,110,16,0,0,0,16,16,16,238,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,16,16,0,0,16,16,44,16,16,0,0,0,0,16,47,16,16,16,16,16,16,16,47,16,16,0,0,0,0,16,108,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,0,0,0,0,16,46,16,16,16,16,16,16,16,46,16,16,0,0,0,0,16,108,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,0,0,0,0,16,44,16,16,16,16,16,16,16,44,16,16,0,0,0,0,16,111,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,0,0,0,0,16,44,16,16,16,16,16,16,16,44,16,16,0,0,0,0,16,110,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,232,16,16,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,239,16,16,16,16,0,16,16,111,16,16,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,238,16,16,16,16,0,16,16,110,16,16,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,236,16,16,16,16,0,16,16,108,16,16,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,236,16,16,16,16,0,16,16,108,16,16,0,0,0,0,16,47,16,16,16,0,0,0,16,47,16,16,0,0,0,16,16,236,16,0,0,0,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,232,16,16,16,16,0,16,16,104,16,16,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,16,0,0,0,16,16,236,16,0,0,0,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,232,16,16,16,16,0,16,16,104,16,16,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,0,0,0,16,16,239,16,0,0,0,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,232,16,16,16,16,0,16,16,104,16,16,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,0,0,0,16,16,238,16,0,0,0,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,232,16,16,16,16,0,16,16,104,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,16,16,16,44,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,111,16,16,16,0,0,0,16,239,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,16,16,16,44,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,110,16,16,16,0,0,0,16,238,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,16,16,16,47,16,0,0,0,16,16,16,47,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,236,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,104,16,0,0,0,16,16,16,46,16,0,0,0,16,16,16,46,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,236,16,16,0,0,0,0,16,111,16,16,16,16,16,16,16,239,16,16,0,0,0,16,16,44,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,110,16,16,16,16,16,16,16,238,16,16,0,0,0,16,16,44,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,108,16,16,16,16,16,16,16,236,16,16,0,0,0,16,16,47,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,47,16,0,0,0,0,16,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,108,16,16,16,16,16,16,16,236,16,16,0,0,0,16,16,46,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,46,16,0,0,0,0,16,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,104,16,16,16,16,16,16,16,232,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,16,16,16,0,0,16,47,16,16,0,0,0,0,16,104,16,16,16,16,16,16,16,232,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,16,16,16,0,0,16,46,16,16,0,0,0,0,16,104,16,16,16,16,16,16,16,232,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,111,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,16,16,16,0,0,16,44,16,16,0,0,0,0,16,104,16,16,16,16,16,16,16,232,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,110,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,16,16,16,0,0,16,44,16,16,0,0,0,0,16,239,16,16,16,0,0,0,16,111,16,16,0,0,0,16,16,44,16,0,0,0,16,16,16,232,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,238,16,16,16,0,0,0,16,110,16,16,0,0,0,16,16,44,16,0,0,0,16,16,16,232,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,236,16,16,16,0,0,0,16,108,16,16,0,0,0,16,16,47,16,0,0,0,16,16,16,232,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,236,16,16,16,0,0,0,16,108,16,16,0,0,0,16,16,46,16,0,0,0,16,16,16,232,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,40,16,16,16,16,0,0,16,40,16,16,0,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,236,16,0,0,0,16,16,16,108,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,16,16,0,0,0,16,47,16,16,0,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,236,16,0,0,0,16,16,16,108,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,16,16,0,0,0,16,46,16,16,0,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,239,16,0,0,0,16,16,16,111,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,44,16,16,16,0,0,0,16,44,16,16,0,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,238,16,0,0,0,16,16,16,110,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,44,16,16,16,0,0,0,16,44,16,16,0,0,0,0,16,47,16,16,16,16,16,16,16,47,16,16,0,0,0,0,16,236,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,0,0,0,0,16,46,16,16,16,16,16,16,16,46,16,16,0,0,0,0,16,236,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,0,0,0,0,16,44,16,16,16,16,16,16,16,44,16,16,0,0,0,0,16,239,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,0,0,0,0,16,44,16,16,16,16,16,16,16,44,16,16,0,0,0,0,16,238,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,104,16,16,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,111,16,16,16,16,0,16,16,239,16,16,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,44,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,110,16,16,16,16,0,16,16,238,16,16,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,108,16,16,16,16,0,16,16,236,16,16,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,108,16,16,16,16,0,16,16,236,16,16,0,0,0,0,16,47,16,16,16,0,0,0,16,47,16,16,0,0,0,16,16,108,16,0,0,0,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,104,16,16,16,16,0,16,16,232,16,16,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,16,0,0,0,16,16,108,16,0,0,0,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,104,16,16,16,16,0,16,16,232,16,16,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,0,0,0,16,16,111,16,0,0,0,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,104,16,16,16,16,0,16,16,232,16,16,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,16,0,0,0,16,16,110,16,0,0,0,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,104,16,16,16,16,0,16,16,232,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,44,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,239,16,16,16,0,0,0,16,111,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,44,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,238,16,16,16,0,0,0,16,110,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,47,16,0,0,0,16,16,16,47,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,236,16,16,16,0,0,0,16,108,16,16,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,46,16,0,0,0,16,16,16,46,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,236,16,16,16,0,0,0,16,108,16,16,0,0,32,32,32,223,32,32,32,32,32,32,32,223,32,32,32,0,32,32,32,222,32,0,0,0,32,32,32,222,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,222,32,32,32,32,32,32,32,222,32,32,32,0,32,32,32,223,32,0,0,0,32,32,32,223,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,220,32,32,32,32,32,32,32,220,32,32,32,0,32,32,32,220,32,0,0,0,32,32,32,220,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,220,32,32,32,32,32,32,32,220,32,32,32,0,32,32,32,220,32,0,0,0,32,32,32,220,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,216,32,32,32,0,32,32,32,216,32,0,0,0,32,32,32,216,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,216,32,32,32,0,32,32,32,216,32,0,0,0,32,32,32,216,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,216,32,32,32,0,32,32,32,216,32,0,0,0,32,32,32,216,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,216,32,32,32,0,32,32,32,216,32,0,0,0,32,32,32,216,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,208,32,32,32,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,223,32,32,32,32,0,32,32,223,32,32,32,0,0,32,32,222,32,0,0,0,0,32,32,222,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,208,32,32,32,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,222,32,32,32,32,0,32,32,222,32,32,32,0,0,32,32,223,32,0,0,0,0,32,32,223,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,208,32,32,32,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,220,32,32,32,32,0,32,32,220,32,32,32,0,0,32,32,220,32,0,0,0,0,32,32,220,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,208,32,32,32,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,220,32,32,32,32,0,32,32,220,32,32,32,0,0,32,32,220,32,0,0,0,0,32,32,220,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,208,32,32,32,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,216,32,32,32,32,0,32,32,216,32,32,32,0,0,32,32,216,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,208,32,32,32,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,216,32,32,32,32,0,32,32,216,32,32,32,0,0,32,32,216,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,208,32,32,32,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,216,32,32,32,32,0,32,32,216,32,32,32,0,0,32,32,216,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,208,32,32,32,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,216,32,32,32,32,0,32,32,216,32,32,32,0,0,32,32,216,32,0,0,0,0,32,32,216,32,0,0,0,0,0,32,223,32,32,32,32,0,0,32,223,32,32,32,0,0,0,32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,32,32,208,32,32,32,32,0,32,32,208,32,32,32,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,222,32,32,32,32,0,0,32,222,32,32,32,0,0,0,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,32,32,208,32,32,32,32,0,32,32,208,32,32,32,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,220,32,32,32,32,0,0,32,220,32,32,32,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,32,32,208,32,32,32,32,0,32,32,208,32,32,32,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,220,32,32,32,32,0,0,32,220,32,32,32,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,32,32,208,32,32,32,32,0,32,32,208,32,32,32,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,216,32,32,32,32,0,0,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,32,32,32,0,32,32,208,32,32,32,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,216,32,32,32,32,0,0,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,32,32,32,0,32,32,208,32,32,32,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,216,32,32,32,32,0,0,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,32,32,32,0,32,32,208,32,32,32,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,216,32,32,32,32,0,0,32,216,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,32,32,32,0,32,32,208,32,32,32,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,32,32,0,0,0,32,223,32,32,32,32,0,0,32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,32,32,0,0,0,32,222,32,32,32,32,0,0,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,32,0,0,0,32,220,32,32,32,32,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,32,0,0,0,32,220,32,32,32,32,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+502274);allocate([32,216,32,32,32,32,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,216,32,32,32,32,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,216,32,32,32,32,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,0,0,32,208,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,216,32,32,32,32,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,32,32,32,95,32,32,32,32,32,32,32,95,32,32,32,0,32,32,32,94,32,0,0,0,32,32,32,94,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,94,32,32,32,32,32,32,32,94,32,32,32,0,32,32,32,95,32,0,0,0,32,32,32,95,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,92,32,32,32,32,32,32,32,92,32,32,32,0,32,32,32,92,32,0,0,0,32,32,32,92,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,92,32,32,32,32,32,32,32,92,32,32,32,0,32,32,32,92,32,0,0,0,32,32,32,92,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,88,32,32,32,0,32,32,32,88,32,0,0,0,32,32,32,88,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,88,32,32,32,0,32,32,32,88,32,0,0,0,32,32,32,88,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,88,32,32,32,0,32,32,32,88,32,0,0,0,32,32,32,88,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,88,32,32,32,0,32,32,32,88,32,0,0,0,32,32,32,88,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,208,32,32,32,32,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,80,32,32,32,32,32,32,32,80,32,32,32,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,95,32,32,32,32,0,32,32,95,32,32,32,0,0,32,32,94,32,0,0,0,0,32,32,94,32,0,0,0,32,32,32,80,32,32,32,32,32,32,32,80,32,32,32,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,94,32,32,32,32,0,32,32,94,32,32,32,0,0,32,32,95,32,0,0,0,0,32,32,95,32,0,0,0,32,32,32,80,32,32,32,32,32,32,32,80,32,32,32,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,92,32,32,32,32,0,32,32,92,32,32,32,0,0,32,32,92,32,0,0,0,0,32,32,92,32,0,0,0,32,32,32,80,32,32,32,32,32,32,32,80,32,32,32,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,92,32,32,32,32,0,32,32,92,32,32,32,0,0,32,32,92,32,0,0,0,0,32,32,92,32,0,0,0,32,32,32,80,32,32,32,32,32,32,32,80,32,32,32,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,88,32,32,32,32,0,32,32,88,32,32,32,0,0,32,32,88,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,80,32,32,32,32,32,32,32,80,32,32,32,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,88,32,32,32,32,0,32,32,88,32,32,32,0,0,32,32,88,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,80,32,32,32,32,32,32,32,80,32,32,32,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,88,32,32,32,32,0,32,32,88,32,32,32,0,0,32,32,88,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,80,32,32,32,32,32,32,32,80,32,32,32,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,88,32,32,32,32,0,32,32,88,32,32,32,0,0,32,32,88,32,0,0,0,0,32,32,88,32,0,0,0,0,0,32,95,32,32,32,32,0,0,32,95,32,32,32,0,0,0,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,32,32,80,32,32,32,32,0,32,32,80,32,32,32,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,94,32,32,32,32,0,0,32,94,32,32,32,0,0,0,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,32,32,80,32,32,32,32,0,32,32,80,32,32,32,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,92,32,32,32,32,0,0,32,92,32,32,32,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,32,32,80,32,32,32,32,0,32,32,80,32,32,32,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,92,32,32,32,32,0,0,32,92,32,32,32,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,32,32,80,32,32,32,32,0,32,32,80,32,32,32,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,88,32,32,32,32,0,0,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,32,32,80,32,32,32,32,0,32,32,80,32,32,32,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,88,32,32,32,32,0,0,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,32,32,80,32,32,32,32,0,32,32,80,32,32,32,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,88,32,32,32,32,0,0,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,32,32,80,32,32,32,32,0,32,32,80,32,32,32,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,88,32,32,32,32,0,0,32,88,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,32,32,80,32,32,32,32,0,32,32,80,32,32,32,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,32,32,0,0,0,32,95,32,32,32,32,0,0,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,32,32,0,0,0,32,94,32,32,32,32,0,0,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,32,0,0,0,32,92,32,32,32,32,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,32,0,0,0,32,92,32,32,32,32,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,88,32,32,32,32,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,88,32,32,32,32,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,88,32,32,32,32,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,32,32,0,0,32,80,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,88,32,32,32,32,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,32,32,32,216,32,32,0,0,32,32,32,216,32,32,0,0,32,32,32,216,32,0,0,0,32,32,32,216,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,216,32,32,0,0,32,32,32,216,32,32,0,0,32,32,32,216,32,0,0,0,32,32,32,216,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,216,32,32,0,0,32,32,32,216,32,32,0,0,32,32,32,216,32,0,0,0,32,32,32,216,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,216,32,32,0,0,32,32,32,216,32,32,0,0,32,32,32,216,32,0,0,0,32,32,32,216,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,223,32,32,0,0,32,32,32,223,32,32,0,0,32,32,32,222,32,0,0,0,32,32,32,222,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,222,32,32,0,0,32,32,32,222,32,32,0,0,32,32,32,223,32,0,0,0,32,32,32,223,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,220,32,32,0,0,32,32,32,220,32,32,0,0,32,32,32,220,32,0,0,0,32,32,32,220,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,220,32,32,0,0,32,32,32,220,32,32,0,0,32,32,32,220,32,0,0,0,32,32,32,220,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,80,32,32,32,32,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,216,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,216,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,216,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,216,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,223,32,32,0,0,0,32,32,223,32,32,0,0,0,32,32,222,32,0,0,0,0,32,32,222,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,222,32,32,0,0,0,32,32,222,32,32,0,0,0,32,32,223,32,0,0,0,0,32,32,223,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,220,32,32,0,0,0,32,32,220,32,32,0,0,0,32,32,220,32,0,0,0,0,32,32,220,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,0,0,0,32,32,32,208,32,0,0,0,0,32,32,220,32,32,0,0,0,32,32,220,32,32,0,0,0,32,32,220,32,0,0,0,0,32,32,220,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,223,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,222,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,223,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,222,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,220,32,0,0,0,32,32,32,88,32,32,0,0,32,32,32,88,32,32,0,0,32,32,32,88,32,0,0,0,32,32,32,88,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,88,32,32,0,0,32,32,32,88,32,32,0,0,32,32,32,88,32,0,0,0,32,32,32,88,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,88,32,32,0,0,32,32,32,88,32,32,0,0,32,32,32,88,32,0,0,0,32,32,32,88,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,88,32,32,0,0,32,32,32,88,32,32,0,0,32,32,32,88,32,0,0,0,32,32,32,88,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,95,32,32,0,0,32,32,32,95,32,32,0,0,32,32,32,94,32,0,0,0,32,32,32,94,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,94,32,32,0,0,32,32,32,94,32,32,0,0,32,32,32,95,32,0,0,0,32,32,32,95,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,92,32,32,0,0,32,32,32,92,32,32,0,0,32,32,32,92,32,0,0,0,32,32,32,92,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,92,32,32,0,0,32,32,32,92,32,32,0,0,32,32,32,92,32,0,0,0,32,32,32,92,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,88,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,95,32,32,0,0,0,32,32,95,32,32,0,0,0,32,32,94,32,0,0,0,0,32,32,94,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,94,32,32,0,0,0,32,32,94,32,32,0,0,0,32,32,95,32,0,0,0,0,32,32,95,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,92,32,32,0,0,0,32,32,92,32,32,0,0,0,32,32,92,32,0,0,0,0,32,32,92,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,92,32,32,0,0,0,32,32,92,32,32,0,0,0,32,32,92,32,0,0,0,0,32,32,92,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,95,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,94,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,95,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,94,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,92,32,0,0,0,64,64,64,191,64,64,64,64,0,64,64,191,64,64,64,64,64,64,64,188,64,64,64,0,0,64,64,188,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,191,64,0,0,0,0,64,64,191,64,0,0,0,64,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,191,64,64,0,0,0,64,64,191,64,64,0,0,64,64,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,191,64,0,0,0,0,64,64,191,64,0,0,0,64,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,190,64,64,64,64,0,64,64,190,64,64,64,64,64,64,64,188,64,64,64,0,0,64,64,188,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,190,64,0,0,0,0,64,64,190,64,0,0,0,64,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,190,64,64,0,0,0,64,64,190,64,64,0,0,64,64,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,190,64,0,0,0,0,64,64,190,64,0,0,0,64,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,188,64,64,64,64,0,64,64,188,64,64,64,64,64,64,64,191,64,64,64,0,0,64,64,191,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,64,64,64,191,64,0,0,0,0,64,64,191,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,188,64,64,0,0,0,64,64,188,64,64,0,0,64,64,64,191,64,64,0,0,0,64,64,191,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,64,64,64,191,64,0,0,0,0,64,64,191,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,188,64,64,64,64,0,64,64,188,64,64,64,64,64,64,64,190,64,64,64,0,0,64,64,190,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,64,64,64,190,64,0,0,0,0,64,64,190,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,188,64,64,0,0,0,64,64,188,64,64,0,0,64,64,64,190,64,64,0,0,0,64,64,190,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,64,64,64,190,64,0,0,0,0,64,64,190,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,184,64,64,64,64,0,64,64,184,64,64,64,64,64,64,64,184,64,64,64,0,0,64,64,184,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,64,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,184,64,64,64,64,0,64,64,184,64,64,64,64,64,64,64,184,64,64,64,0,0,64,64,184,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,64,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,184,64,64,64,64,0,64,64,184,64,64,64,64,64,64,64,184,64,64,64,0,0,64,64,184,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,64,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,184,64,64,64,64,0,64,64,184,64,64,64,64,64,64,64,184,64,64,64,0,0,64,64,184,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,64,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,64,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,176,64,64,64,64,0,64,64,176,64,64,64,64,64,64,64,176,64,64,64,0,0,64,64,176,64,64,64,0,0,0,64,191,64,64,64,64,0,0,64,191,64,64,64,64,0,0,64,188,64,64,64,0,0,0,64,188,64,64,64,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,64,64,64,176,64,64,64,64,0,64,64,176,64,64,64,64,64,64,64,176,64,64,64,0,0,64,64,176,64,64,64,0,0,0,64,190,64,64,64,64,0,0,64,190,64,64,64,64,0,0,64,188,64,64,64,0,0,0,64,188,64,64,64,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,64,64,64,176,64,64,64,64,0,64,64,176,64,64,64,64,64,64,64,176,64,64,64,0,0,64,64,176,64,64,64,0,0,0,64,188,64,64,64,64,0,0,64,188,64,64,64,64,0,0,64,191,64,64,64,0,0,0,64,191,64,64,64,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,191,64,0,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,64,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,191,64,0,0,0,64,64,64,176,64,64,64,64,0,64,64,176,64,64,64,64,64,64,64,176,64,64,64,0,0,64,64,176,64,64,64,0,0,0,64,188,64,64,64,64,0,0,64,188,64,64,64,64,0,0,64,190,64,64,64,0,0,0,64,190,64,64,64,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,190,64,0,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,64,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,190,64,0,0,0,64,64,64,176,64,64,64,64,0,64,64,176,64,64,64,64,64,64,64,176,64,64,64,0,0,64,64,176,64,64,64,0,0,0,64,184,64,64,64,64,0,0,64,184,64,64,64,64,0,0,64,184,64,64,64,0,0,0,64,184,64,64,64,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,64,64,64,176,64,64,64,64,0,64,64,176,64,64,64,64,64,64,64,176,64,64,64,0,0,64,64,176,64,64,64,0,0,0,64,184,64,64,64,64,0,0,64,184,64,64,64,64,0,0,64,184,64,64,64,0,0,0,64,184,64,64,64,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,64,64,64,176,64,64,64,64,0,64,64,176,64,64,64,64,64,64,64,176,64,64,64,0,0,64,64,176,64,64,64,0,0,0,64,184,64,64,64,64,0,0,64,184,64,64,64,64,0,0,64,184,64,64,64,0,0,0,64,184,64,64,64,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,64,64,64,176,64,64,64,64,0,64,64,176,64,64,64,64,64,64,64,176,64,64,64,0,0,64,64,176,64,64,64,0,0,0,64,184,64,64,64,64],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+512514);allocate([64,184,64,64,64,64,0,0,64,184,64,64,64,0,0,0,64,184,64,64,64,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,64,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,64,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,0,0,0,64,176,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,0,0,0,64,176,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,0,0,0,64,176,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,0,0,0,64,176,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,0,0,0,64,176,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,0,0,0,64,176,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,0,0,0,64,176,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,64,0,0,64,176,64,64,64,0,0,0,64,176,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,64,64,0,64,64,160,64,64,64,64,64,64,64,160,64,64,64,0,0,64,64,160,64,64,64,0,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,64,0,0,64,160,64,64,64,0,0,0,64,160,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,128,128,128,127,128,128,128,128,0,128,128,127,128,128,128,128,128,128,128,126,128,0,0,0,0,128,128,126,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,126,128,0,0,0,0,128,128,126,128,0,0,0,128,128,128,127,128,128,0,0,0,128,128,127,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,124,128,128,128,128,0,128,128,124,128,128,128,128,128,128,128,124,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,124,128,0,0,0,0,128,128,124,128,0,0,0,128,128,128,124,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,120,128,128,128,128,0,128,128,120,128,128,128,128,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,120,128,128,128,128,0,128,128,120,128,128,128,128,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,128,128,128,0,128,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,128,128,128,0,128,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,128,128,128,0,128,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,128,128,128,0,128,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,127,128,128,128,128,0,0,128,127,128,128,128,128,0,0,128,126,128,0,0,0,0,0,128,126,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,126,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,127,128,128,0,0,0,0,128,127,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,124,128,128,128,128,0,0,128,124,128,128,128,128,0,0,128,124,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,124,128,128,0,0,0,0,128,124,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,128,128,128,0,0,128,120,128,128,128,128,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,128,128,128,0,0,128,120,128,128,128,128,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,128,128,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,128,128,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,128,128,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,128,128,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,127,128,128,128,0,0,128,128,127,128,128,128,0,128,128,128,126,128,0,0,0,0,128,128,126,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,126,128,0,0,0,0,128,128,126,128,0,0,0,128,128,128,127,128,128,0,0,0,128,128,127,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,124,128,128,128,0,0,128,128,124,128,128,128,0,128,128,128,124,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,124,128,0,0,0,0,128,128,124,128,0,0,0,128,128,128,124,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,120,128,128,128,0,0,128,128,120,128,128,128,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,120,128,128,128,0,0,128,128,120,128,128,128,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,128,128,0,0,128,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,128,128,0,0,128,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,128,128,0,0,128,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+522754);allocate([128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,128,128,0,0,128,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,127,128,128,128,0,0,0,128,127,128,128,128,0,0,0,128,126,128,0,0,0,0,0,128,126,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,126,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,127,128,128,0,0,0,0,128,127,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,124,128,128,128,0,0,0,128,124,128,128,128,0,0,0,128,124,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,124,128,128,0,0,0,0,128,124,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,127,128,0,0,0,0,128,128,127,128,0,0,0,128,128,128,126,128,128,0,0,0,128,128,126,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,126,128,128,128,128,0,128,128,126,128,128,128,128,128,128,128,127,128,0,0,0,0,128,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,124,128,0,0,0,0,128,128,124,128,0,0,0,128,128,128,124,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,124,128,128,128,128,0,128,128,124,128,128,128,128,128,128,128,124,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,120,128,128,128,128,0,128,128,120,128,128,128,128,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,120,128,128,128,128,0,128,128,120,128,128,128,128,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,128,128,128,0,128,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,128,128,128,0,128,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,128,128,128,0,128,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,128,128,128,0,128,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,0,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,127,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,126,128,128,0,0,0,0,128,126,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,126,128,128,128,128,0,0,128,126,128,128,128,128,0,0,128,127,128,0,0,0,0,0,128,127,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,124,128,128,0,0,0,0,128,124,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,124,128,128,128,128,0,0,128,124,128,128,128,128,0,0,128,124,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,128,128,128,0,0,128,120,128,128,128,128,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,128,128,128,0,0,128,120,128,128,128,128,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,128,128,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,128,128,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,128,128,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,128,128,128,0,128,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,128,0,0,128,112,128,128,128,128,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,128,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,127,128,0,0,0,0,128,128,127,128,0,0,0,128,128,128,126,128,128,0,0,0,128,128,126,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,126,128,128,128,0,0,128,128,126,128,128,128,0,128,128,128,127,128,0,0,0,0,128,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,124,128,0,0,0,0,128,128,124,128,0,0,0,128,128,128,124,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,124,128,128,128,0,0,128,128,124,128,128,128,0,128,128,128,124,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,120,128,128,128,0,0,128,128,120,128,128,128,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,120,128,128,128,0,0,128,128,120,128,128,128,0,128,128,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,128,128,0,0,128,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,128,128,0,0,128,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,128,128,0,0,128,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,64,128,128,128,0,0,0,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,0,0,128,96,128,128,128,128,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,128,128,0,0,128,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,127,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,126,128,128,0,0,0,0,128,126,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,126,128,128,128,0,0,0,128,126,128,128,128,0,0,0,128,127,128,0,0,0,0,0,128,127,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,124,128,128,0,0,0,0,128,124,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,124,128,128,128,0,0,0,128,124,128,128,128,0,0,0,128,124,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,128,128,0,0,0,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+532994);allocate([128,64,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,64,128,128,128,128,0,128,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,128,128,128,0,0,128,64,128,128,128,128,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,128,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,112,128,128,128,0,0,0,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,0,128,112,128,0,0,0,1,1,1,1,254,1,1,1,0,0,1,1,62,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,126,1,1,0,0,0,0,1,62,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,30,1,1,1,0,0,1,1,30,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,62,1,1,1,0,0,1,1,254,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,62,1,1,0,0,0,0,1,126,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,30,1,1,1,0,0,1,1,30,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,126,1,1,1,0,0,1,1,62,1,1,1,1,1,1,1,254,1,1,0,0,0,1,1,62,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,1,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,30,1,1,1,0,0,1,1,30,1,1,1,1,1,1,1,30,1,1,0,0,0,1,1,30,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,1,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,62,1,1,1,0,0,1,1,126,1,1,1,1,1,1,1,62,1,1,0,0,0,1,1,254,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,1,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,30,1,1,1,0,0,1,1,30,1,1,1,1,1,1,1,30,1,1,0,0,0,1,1,30,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,1,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,1,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,1,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,1,1,1,1,126,1,1,0,0,0,1,1,62,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,1,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,254,1,1,1,0,0,0,1,62,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,1,1,1,1,30,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,1,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,1,1,1,1,62,1,1,0,0,0,1,1,126,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,1,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,62,1,1,1,0,0,0,1,254,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,1,1,1,1,30,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,1,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,1,1,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,1,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,126,1,1,1,0,0,0,1,62,1,1,1,0,0,0,1,254,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,62,1,1,1,0,0,0,1,126,1,1,1,0,0,0,1,62,1,1,0,0,0,0,1,254,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,254,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,62,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,126,1,0,0,0,0,1,1,62,1,0,0,0,0,1,1,62,1,0,0,1,1,1,1,254,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,1,1,1,1,14,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,1,1,1,1,30,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,1,1,1,1,14,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,62,1,0,0,0,0,1,1,126,1,0,0,0,0,1,1,254,1,0,0,1,1,1,1,62,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,1,1,1,1,14,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,1,1,1,1,30,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,1,1,1,1,14,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,1,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,1,1,1,1,126,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,1,1,1,1,30,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,126,1,0,0,1,1,1,1,62,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,1,1,1,1,30,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,126,1,1,1,0,0,1,1,62,1,1,1,0,1,1,1,254,1,1,0,0,0,1,1,62,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,30,1,1,1,0,0,1,1,30,1,1,1,0,1,1,1,30,1,1,0,0,0,1,1,30,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,62,1,1,1,0,0,1,1,126,1,1,1,0,1,1,1,62,1,1,0,0,0,1,1,254,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,30,1,1,1,0,0,1,1,30,1,1,1,0,1,1,1,30,1,1,0,0,0,1,1,30,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,254,1,1,1,0,0,1,1,62,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,126,1,1,0,0,0,0,1,62,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,30,1,1,1,0,0,1,1,30,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,62,1,1,1,0,0,1,1,254,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,62,1,1,0,0,0,0,1,126,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,30,1,1,1,0,0,1,1,30,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,1,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+543234);allocate([1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,14,1,1,1,0,0,1,1,14,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,6,1,1,1,0,0,1,1,6,1,1,1,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,0,0,1,1,1,2,1,1,1,0,0,1,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,126,1,1,1,0,0,0,1,62,1,1,1,0,0,0,1,254,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,62,1,1,1,0,0,0,1,126,1,1,1,0,0,0,1,62,1,1,0,0,0,0,1,254,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,126,1,1,0,0,0,1,1,62,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,254,1,1,1,0,0,0,1,62,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,30,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,62,1,1,0,0,0,1,1,126,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,62,1,1,1,0,0,0,1,254,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,30,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,14,1,1,1,0,0,0,1,14,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,6,1,1,1,0,0,0,1,6,1,1,1,0,1,1,1,14,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,0,1,30,1,1,1,0,0,0,1,30,1,1,1,0,1,1,1,6,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,2,1,1,1,0,0,0,1,2,1,1,1,0,1,1,1,2,1,1,0,0,0,1,1,2,1,1,0,0,1,1,1,126,1,0,0,0,0,1,1,62,1,0,0,0,0,1,1,62,1,0,0,0,1,1,1,254,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,1,1,1,14,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,1,1,1,30,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,1,1,1,14,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,62,1,0,0,0,0,1,1,126,1,0,0,0,0,1,1,254,1,0,0,0,1,1,1,62,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,1,1,1,14,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,1,1,1,30,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,1,1,1,14,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,1,1,1,254,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,62,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,30,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,1,1,1,126,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,126,1,0,0,0,1,1,1,62,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,1,0,0,2,2,2,2,253,2,2,2,0,0,2,2,125,2,2,2,0,2,2,2,253,2,2,0,0,0,2,2,125,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,0,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,29,2,2,2,0,0,2,2,29,2,2,2,0,2,2,2,29,2,2,0,0,0,2,2,29,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,0,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,61,2,2,2,0,0,2,2,61,2,2,2,0,2,2,2,61,2,2,0,0,0,2,2,61,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,0,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,29,2,2,2,0,0,2,2,29,2,2,2,0,2,2,2,29,2,2,0,0,0,2,2,29,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,0,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,125,2,2,2,0,0,2,2,253,2,2,2,0,2,2,2,125,2,2,0,0,0,2,2,253,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,0,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,29,2,2,2,0,0,2,2,29,2,2,2,0,2,2,2,29,2,2,0,0,0,2,2,29,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,0,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,61,2,2,2,0,0,2,2,61,2,2,2,0,2,2,2,61,2,2,0,0,0,2,2,61,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,0,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,29,2,2,2,0,0,2,2,29,2,2,2,0,2,2,2,29,2,2,0,0,0,2,2,29,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,2,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,0,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,2,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,0,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,253,2,2,2,0,0,2,2,125,2,2,2,2,2,2,2,253,2,2,0,0,0,2,2,125,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,2,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,29,2,2,2,0,0,2,2,29,2,2,2,2,2,2,2,29,2,2,0,0,0,2,2,29,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,2,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,61,2,2,2,0,0,2,2,61,2,2,2,2,2,2,2,61,2,2,0,0,0,2,2,61,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,2,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,29,2,2,2,0,0,2,2,29,2,2,2,2,2,2,2,29,2,2,0,0,0,2,2,29,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,2,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,125,2,2,2,0,0,2,2,253,2,2,2,2,2,2,2,125,2,2,0,0,0,2,2,253,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,2,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,29,2,2,2,0,0,2,2,29,2,2,2,2,2,2,2,29,2,2,0,0,0,2,2,29,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,2,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,61,2,2,2,0,0,2,2,61,2,2,2,2,2,2,2,61,2,2,0,0,0,2,2,61,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,2,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,29,2,2,2,0,0,2,2,29,2,2,2,2,2,2,2,29,2,2,0,0,0,2,2,29,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,2,2,2,13,2,2,2,0,0,2,2,13,2,2,2,2,2,2,2,13,2,2,0,0,0,2,2,13,2,2,0,0,2,2,2,5,2,2,2,0,0,2,2,5,2,2,2,2,2,2,2,5,2,2,0,0,0,2,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,253,2,2,2,0,0,0,2,125,2,2,2,0,0,0,2,253,2,2,0,0,0,0,2,125,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,61,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,61,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,125,2,2,2,0,0,0,2,253,2,2,2,0,0,0,2,125,2,2,0,0,0,0,2,253,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,61,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,61,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,253,2,2,2,0,0,0,2,125,2,2,2,0,0,0,2,253,2,2,0,0,0,0,2,125,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,61,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,61,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,125,2,2,2,0,0,0,2,253,2,2,2,0,0,0,2,125,2,2,0,0,0,0,2,253,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+553474);allocate([2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,2,0,0,0,2,29,2,2,0,0,0,0,2,29,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,2,0,0,0,2,13,2,2,0,0,0,0,2,13,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,0,0,0,2,61,2,2,2,0,0,0,2,61,2,2,2,0,0,0,2,61,2,2,0,0,0,0,2,61,2,2,0,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,2,0,0,0,2,5,2,2,0,0,0,0,2,5,2,2,0,2,2,2,2,253,2,0,0,0,0,2,2,125,2,0,0,0,0,2,2,125,2,0,0,0,2,2,2,253,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,2,2,2,29,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,61,2,0,0,0,0,2,2,61,2,0,0,0,0,2,2,61,2,0,0,0,2,2,2,61,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,2,2,2,29,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,125,2,0,0,0,0,2,2,253,2,0,0,0,0,2,2,253,2,0,0,0,2,2,2,125,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,2,2,2,29,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,61,2,0,0,0,0,2,2,61,2,0,0,0,0,2,2,61,2,0,0,0,2,2,2,61,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,2,2,2,29,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,5,2,0,0,0,2,2,2,253,2,0,0,0,0,2,2,125,2,0,0,0,0,2,2,125,2,0,0,2,2,2,2,253,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,2,2,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,29,2,0,0,2,2,2,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,2,2,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,61,2,0,0,0,0,2,2,61,2,0,0,0,0,2,2,61,2,0,0,2,2,2,2,61,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,2,2,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,29,2,0,0,2,2,2,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,2,2,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,125,2,0,0,0,0,2,2,253,2,0,0,0,0,2,2,253,2,0,0,2,2,2,2,125,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,2,2,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,29,2,0,0,2,2,2,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,2,2,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,61,2,0,0,0,0,2,2,61,2,0,0,0,0,2,2,61,2,0,0,2,2,2,2,61,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,2,2,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,2,2,29,2,0,0,0,0,2,2,29,2,0,0,2,2,2,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,2,2,13,2,0,0,2,2,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,2,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,4,4,4,4,251,4,4,4,0,0,4,4,27,4,4,4,4,4,4,4,251,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,250,4,4,4,0,0,4,4,26,4,4,4,4,4,4,4,250,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,251,4,4,4,0,0,4,4,27,4,4,4,0,4,4,4,251,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,250,4,4,4,0,0,4,4,26,4,4,4,0,4,4,4,250,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,27,4,4,4,0,0,4,4,59,4,4,4,4,4,4,4,27,4,0,0,0,0,4,4,59,4,0,0,4,4,4,4,26,4,4,4,0,0,4,4,58,4,4,4,4,4,4,4,26,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,27,4,4,4,0,0,4,4,59,4,4,4,0,4,4,4,27,4,0,0,0,0,4,4,59,4,0,0,0,4,4,4,26,4,4,4,0,0,4,4,58,4,4,4,0,4,4,4,26,4,0,0,0,0,4,4,58,4,0,0,4,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,59,4,4,4,0,0,4,4,27,4,4,4,4,4,4,4,59,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,58,4,4,4,0,0,4,4,26,4,4,4,4,4,4,4,58,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,59,4,4,4,0,0,4,4,27,4,4,4,0,4,4,4,59,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,58,4,4,4,0,0,4,4,26,4,4,4,0,4,4,4,58,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,27,4,4,4,0,0,4,4,251,4,4,4,4,4,4,4,27,4,0,0,0,0,4,4,251,4,0,0,4,4,4,4,26,4,4,4,0,0,4,4,250,4,4,4,4,4,4,4,26,4,0,0,0,0,4,4,250,4,0,0,0,4,4,4,27,4,4,4,0,0,4,4,251,4,4,4,0,4,4,4,27,4,0,0,0,0,4,4,251,4,0,0,0,4,4,4,26,4,4,4,0,0,4,4,250,4,4,4,0,4,4,4,26,4,0,0,0,0,4,4,250,4,0,0,4,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,123,4,4,4,0,0,4,4,27,4,4,4,4,4,4,4,123,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,122,4,4,4,0,0,4,4,26,4,4,4,4,4,4,4,122,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,123,4,4,4,0,0,4,4,27,4,4,4,0,4,4,4,123,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,122,4,4,4,0,0,4,4,26,4,4,4,0,4,4,4,122,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,27,4,4,4,0,0,4,4,59,4,4,4,4,4,4,4,27,4,0,0,0,0,4,4,59,4,0,0,4,4,4,4,26,4,4,4,0,0,4,4,58,4,4,4,4,4,4,4,26,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,27,4,4,4,0,0,4,4,59,4,4,4,0,4,4,4,27,4,0,0,0,0,4,4,59,4,0,0,0,4,4,4,26,4,4,4,0,0,4,4,58,4,4,4,0,4,4,4,26,4,0,0,0,0,4,4,58,4,0,0,4,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,59,4,4,4,0,0,4,4,27,4,4,4,4,4,4,4,59,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,58,4,4,4,0,0,4,4,26,4,4,4,4,4,4,4,58,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,59,4,4,4,0,0,4,4,27,4,4,4,0,4,4,4,59,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,58,4,4,4,0,0,4,4,26,4,4,4,0,4,4,4,58,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,27,4,4,4,0,0,4,4,123,4,4,4,4,4,4,4,27,4,0,0,0,0,4,4,123,4,0,0,4,4,4,4,26,4,4,4,0,0,4,4,122,4,4,4,4,4,4,4,26,4,0,0,0,0,4,4,122,4,0,0,0,4,4,4,27,4,4,4,0,0,4,4,123,4,4,4,0,4,4,4,27,4,0,0,0,0,4,4,123,4,0,0,0,4,4,4,26,4,4,4,0,0,4,4,122,4,4,4,0,4,4,4,26,4,0,0,0,0,4,4,122,4,0,0,4,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,4,0,0,4,4,11,4,4,4,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,4,0,0,4,4,10,4,4,4,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,251,4,4,4,0,0,0,4,27,4,4,4,0,0,0,4,251,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,250,4,4,4,0,0,0,4,26,4,4,4,0,0,0,4,250,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,251,4,4,4,0,0,0,4,27,4,4,4,0,0,0,4,251,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,250,4,4,4,0,0,0,4,26,4,4,4,0,0,0,4,250,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,59,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,58,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,59,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,58,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,27,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,26,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,27,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,26,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,251,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,250,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,251,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,250,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,123,4,4,4,0,0,0,4,27,4,4,4,0,0,0,4,123,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,122,4,4,4,0,0,0,4,26,4,4,4,0,0,0,4,122,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,123,4,4,4,0,0,0,4,27,4,4,4,0,0,0,4,123,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,122,4,4,4,0,0,0,4,26,4,4,4,0,0,0,4,122,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,59,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,58,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,59,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,58,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,27,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,26,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,59,4,4,4,0,0,0,4,27,4,4,4,0,0,0,4,59,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,58,4,4,4,0,0,0,4,26,4,4,4,0,0,0,4,58,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,123,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,122,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,27,4,4,4,0,0,0,4,123,4,4,4,0,0,0,4,27,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,26,4,4,4,0,0,0,4,122,4,4,4,0,0,0,4,26,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,4,0,0,0,4,11,4,4,4,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,4,0,0,0,4,10,4,4,4,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,4,4,59,4,4,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,0,4,26,4,4,0,0,0,4,4,58,4,4,0,0,0,0,4,26,4,0,0,0,0,4,4,58,4,0,0,0,0,0,4,27,4,4,0,0,0,4,4,59,4,4,0,0,0,0,4,27,4,0,0,0,0,4,4,59,4,0,0,0,0,0,4,26,4,4,0,0,0,4,4,58,4,4,0,0,0,0,4,26,4,0,0,0,0,4,4,58,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,251,4,4,0,0,0,4,4,27,4,4,0,4,4,4,4,251,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,250,4,4,0,0,0,4,4,26,4,4,0,4,4,4,4,250,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,251,4,4,0,0,0,4,4,27,4,4,0,0,4,4,4,251,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,250,4,4,0,0,0,4,4,26,4,4,0,0,4,4,4,250,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,27,4,4,0,0,0,4,4,251,4,4,0,4,4,4,4,27,4,0,0,0,0,4,4,251,4,0,0,4,4,4,4,26,4,4,0,0,0,4,4,250,4,4,0,4,4,4,4,26,4,0,0,0,0,4,4,250,4,0,0,0,4,4,4,27,4,4,0,0,0,4,4,251,4,4,0,0,4,4,4,27,4,0,0,0,0,4,4,251,4,0,0,0,4,4,4,26,4,4,0,0,0,4,4,250,4,4,0,0,4,4,4,26,4,0,0,0,0,4,4,250,4,0,0,4,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,59,4,4,0,0,0,0,4,27,4,4,0,4,4,4,4,59,4,0,0,0,0,0,4,27,4,0,0,4,4,4,4,58,4,4,0,0,0,0,4,26,4,4,0,4,4,4,4,58,4,0,0,0,0,0,4,26,4,0,0,0,4,4,4,59,4,4,0,0,0,0,4,27,4,4,0,0,4,4,4,59,4,0,0,0,0,0,4,27,4,0,0,0,4,4,4,58,4,4,0,0,0,0,4,26,4,4,0,0,4,4,4,58,4,0,0,0,0,0,4,26,4,0,0,4,4,4,4,11,4,4,0,0,0,0,4,11,4,4,0,4,4,4,4,11,4,0,0,0,0,0,4,11,4,0,0,4,4,4,4,10,4,4,0,0,0,0,4,10,4,4,0,4,4,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,10,4,0,0,4,4,4,4,27,4,4,0,0,0,4,4,59,4,4,0,4,4,4,4,27,4,0,0,0,0,4,4,59,4,0,0,4,4,4,4,26,4,4,0,0,0,4,4,58,4,4,0,4,4,4,4,26,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,27,4,4,0,0,0,4,4,59,4,4,0,0,4,4,4,27,4,0,0,0,0,4,4,59,4,0,0,0,4,4,4,26,4,4,0,0,0,4,4,58,4,4,0,0,4,4,4,26,4,0,0,0,0,4,4,58,4,0,0,4,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,123,4,4,0,0,0,4,4,27,4,4,0,4,4,4,4,123,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,122,4,4,0,0,0,4,4,26,4,4,0,4,4,4,4,122,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,123,4,4,0,0,0,4,4,27,4,4,0,0,4,4,4,123,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,122,4,4,0,0,0,4,4,26,4,4,0,0,4,4,4,122,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,27,4,4,0,0,0,4,4,123,4,4,0,4,4,4,4,27,4,0,0,0,0,4,4,123,4,0,0,4,4,4,4,26,4,4,0,0,0,4,4,122,4,4,0,4,4,4,4,26,4,0,0,0,0,4,4,122,4,0,0,0,4,4,4,27,4,4,0,0,0,4,4,123,4,4,0,0,4,4,4,27,4,0,0,0,0,4,4,123,4,0,0,0,4,4,4,26,4,4,0,0,0,4,4,122,4,4,0,0,4,4,4,26,4,0,0,0,0,4,4,122,4,0,0,4,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,59,4,4,0,0,0,4,4,27,4,4,0,4,4,4,4,59,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,58,4,4,0,0,0,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+563715);allocate([4,26,4,4,0,4,4,4,4,58,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,59,4,4,0,0,0,4,4,27,4,4,0,0,4,4,4,59,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,58,4,4,0,0,0,4,4,26,4,4,0,0,4,4,4,58,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,11,4,4,0,0,0,4,4,11,4,4,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,10,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,27,4,4,0,0,0,0,4,59,4,4,0,4,4,4,4,27,4,0,0,0,0,0,4,59,4,0,0,4,4,4,4,26,4,4,0,0,0,0,4,58,4,4,0,4,4,4,4,26,4,0,0,0,0,0,4,58,4,0,0,0,4,4,4,27,4,4,0,0,0,0,4,59,4,4,0,0,4,4,4,27,4,0,0,0,0,0,4,59,4,0,0,0,4,4,4,26,4,4,0,0,0,0,4,58,4,4,0,0,4,4,4,26,4,0,0,0,0,0,4,58,4,0,0,4,4,4,4,11,4,4,0,0,0,0,4,11,4,4,0,4,4,4,4,11,4,0,0,0,0,0,4,11,4,0,0,4,4,4,4,10,4,4,0,0,0,0,4,10,4,4,0,4,4,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,0,0,0,0,4,11,4,4,0,0,4,4,4,11,4,0,0,0,0,0,4,11,4,0,0,0,4,4,4,10,4,4,0,0,0,0,4,10,4,4,0,0,4,4,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,250,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,250,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,250,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,250,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,251,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,251,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,4,4,27,4,4,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,58,4,4,0,0,0,4,4,26,4,4,0,0,0,0,4,58,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,59,4,4,0,0,0,4,4,27,4,4,0,0,0,0,4,59,4,0,0,0,0,4,4,27,4,0,0,0,0,0,4,58,4,4,0,0,0,4,4,26,4,4,0,0,0,0,4,58,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,4,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,4,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,59,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,59,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,122,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,122,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,122,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,122,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,123,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,123,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,26,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,26,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,27,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,58,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,58,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,8,8,8,8,247,8,8,8,0,0,8,8,23,8,8,8,0,8,8,8,244,8,0,0,0,0,8,8,52,8,0,0,8,8,8,8,246,8,8,8,0,0,8,8,22,8,8,8,0,8,8,8,244,8,0,0,0,0,8,8,52,8,0,0,8,8,8,8,244,8,8,8,0,0,8,8,20,8,8,8,8,8,8,8,247,8,0,0,0,0,8,8,23,8,0,0,8,8,8,8,244,8,8,8,0,0,8,8,20,8,8,8,8,8,8,8,246,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,247,8,8,8,0,0,8,8,55,8,8,8,8,8,8,8,244,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,246,8,8,8,0,0,8,8,54,8,8,8,8,8,8,8,244,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,244,8,8,8,0,0,8,8,52,8,8,8,0,8,8,8,247,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,244,8,8,8,0,0,8,8,52,8,8,8,0,8,8,8,246,8,0,0,0,0,8,8,54,8,0,0,8,8,8,8,23,8,8,8,0,0,8,8,55,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,22,8,8,8,0,0,8,8,54,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,20,8,8,8,0,0,8,8,52,8,8,8,8,8,8,8,23,8,0,0,0,0,8,8,55,8,0,0,8,8,8,8,20,8,8,8,0,0,8,8,52,8,8,8,8,8,8,8,22,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,23,8,8,8,0,0,8,8,23,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,22,8,8,8,0,0,8,8,22,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,8,8,8,8,55,8,8,8,0,0,8,8,23,8,8,8,0,8,8,8,52,8,0,0,0,0,8,8,244,8,0,0,8,8,8,8,54,8,8,8,0,0,8,8,22,8,8,8,0,8,8,8,52,8,0,0,0,0,8,8,244,8,0,0,8,8,8,8,52,8,8,8,0,0,8,8,20,8,8,8,8,8,8,8,55,8,0,0,0,0,8,8,23,8,0,0,8,8,8,8,52,8,8,8,0,0,8,8,20,8,8,8,8,8,8,8,54,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,55,8,8,8,0,0,8,8,247,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,54,8,8,8,0,0,8,8,246,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,52,8,8,8,0,0,8,8,244,8,8,8,0,8,8,8,55,8,0,0,0,0,8,8,247,8,0,0,0,8,8,8,52,8,8,8,0,0,8,8,244,8,8,8,0,8,8,8,54,8,0,0,0,0,8,8,246,8,0,0,8,8,8,8,23,8,8,8,0,0,8,8,247,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,22,8,8,8,0,0,8,8,246,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,20,8,8,8,0,0,8,8,244,8,8,8,8,8,8,8,23,8,0,0,0,0,8,8,247,8,0,0,8,8,8,8,20,8,8,8,0,0,8,8,244,8,8,8,8,8,8,8,22,8,0,0,0,0,8,8,246,8,0,0,0,8,8,8,23,8,8,8,0,0,8,8,23,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,22,8,8,8,0,0,8,8,22,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,8,8,8,8,119,8,8,8,0,0,8,8,23,8,8,8,0,8,8,8,116,8,0,0,0,0,8,8,52,8,0,0,8,8,8,8,118,8,8,8,0,0,8,8,22,8,8,8,0,8,8,8,116,8,0,0,0,0,8,8,52,8,0,0,8,8,8,8,116,8,8,8,0,0,8,8,20,8,8,8,8,8,8,8,119,8,0,0,0,0,8,8,23,8,0,0,8,8,8,8,116,8,8,8,0,0,8,8,20,8,8,8,8,8,8,8,118,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,119,8,8,8,0,0,8,8,55,8,8,8,8,8,8,8,116,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,118,8,8,8,0,0,8,8,54,8,8,8,8,8,8,8,116,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,116,8,8,8,0,0,8,8,52,8,8,8,0,8,8,8,119,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,116,8,8,8,0,0,8,8,52,8,8,8,0,8,8,8,118,8,0,0,0,0,8,8,54,8,0,0,8,8,8,8,23,8,8,8,0,0,8,8,55,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,22,8,8,8,0,0,8,8,54,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,20,8,8,8,0,0,8,8,52,8,8,8,8,8,8,8,23,8,0,0,0,0,8,8,55,8,0,0,8,8,8,8,20,8,8,8,0,0,8,8,52,8,8,8,8,8,8,8,22,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,23,8,8,8,0,0,8,8,23,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,22,8,8,8,0,0,8,8,22,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,8,8,8,8,55,8,8,8,0,0,8,8,23,8,8,8,0,8,8,8,52,8,0,0,0,0,8,8,116,8,0,0,8,8,8,8,54,8,8,8,0,0,8,8,22,8,8,8,0,8,8,8,52,8,0,0,0,0,8,8,116,8,0,0,8,8,8,8,52,8,8,8,0,0,8,8,20,8,8,8,8,8,8,8,55,8,0,0,0,0,8,8,23,8,0,0,8,8,8,8,52,8,8,8,0,0,8,8,20,8,8,8,8,8,8,8,54,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,55,8,8,8,0,0,8,8,119,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,54,8,8,8,0,0,8,8,118,8,8,8,8,8,8,8,52,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,52,8,8,8,0,0,8,8,116,8,8,8,0,8,8,8,55,8,0,0,0,0,8,8,119,8,0,0,0,8,8,8,52,8,8,8,0,0,8,8,116,8,8,8,0,8,8,8,54,8,0,0,0,0,8,8,118,8,0,0,8,8,8,8,23,8,8,8,0,0,8,8,119,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,22,8,8,8,0,0,8,8,118,8,8,8,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,20,8,8,8,0,0,8,8,116,8,8,8,8,8,8,8,23,8,0,0,0,0,8,8,119,8,0,0,8,8,8,8,20,8,8,8,0,0,8,8,116,8,8,8,8,8,8,8,22,8,0,0,0,0,8,8,118,8,0,0,0,8,8,8,23,8,8,8,0,0,8,8,23,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,22,8,8,8,0,0,8,8,22,8,8,8,8,8,8,8,20,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,20,8,8,8,0,0,8,8,20,8,8,8,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,119,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,118,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,116,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,116,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,247,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,246,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,247,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,246,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,247,8,8,8,0,0,0,8,55,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,246,8,8,8,0,0,0,8,54,8,8,8,0,0,0,8,244,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,247,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,244,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,246,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,55,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,54,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,247,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,246,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,244,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,244,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,247,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,246,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,244,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,244,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,119,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,118,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,119,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,118,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,119,8,8,8,0,0,0,8,55,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,118,8,8,8,0,0,0,8,54,8,8,8,0,0,0,8,116,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,119,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,116,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,118,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,55,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,54,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,52,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,23,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,22,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,20,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,23,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,22,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,20,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,55,8,8,8,0,0,0,8,119,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,54,8,8,8,0,0,0,8,118,8,8,8,0,0,0,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,116,8,8,8,0,0,0,8,55,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,52,8,8,8,0,0,0,8,116,8,8,8,0,0,0,8,54,8,0,0,0,0,0,8,118,8,0,0,0,8,8,8,244,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,246,8,0,0,0,0,8,8,54,8,0,0,8,8,8,8,247,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,244,8,0,0,0,0,8,8,52,8,0,0,8,8,8,8,246,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,244,8,0,0,0,0,8,8,52,8,0,0,8,8,8,8,244,8,8,0,0,0,8,8,20,8,8,0,8,8,8,8,247,8,0,0,0,0,8,8,23,8,0,0,8,8,8,8,244,8,8,0,0,0,8,8,20,8,8,0,8,8,8,8,246,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,247,8,8,0,0,0,8,8,55,8,8,0,8,8,8,8,244,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,246,8,8,0,0,0,8,8,54,8,8,0,8,8,8,8,244,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,244,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,247,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,8,8,8,8,23,8,8,0,0,0,8,8,55,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,22,8,8,0,0,0,8,8,54,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,20,8,8,0,0,0,8,8,52,8,8,0,8,8,8,8,23,8,0,0,0,0,8,8,55,8,0,0,8,8,8,8,20,8,8,0,0,0,8,8,52,8,8,0,8,8,8,8,22,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,8,8,8,8,20,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,8,8,8,8,20,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,244,8,8,0,0,8,8,8,54,8,0,0,0,0,8,8,246,8,0,0,8,8,8,8,55,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,244,8,0,0,8,8,8,8,54,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,244,8,0,0,8,8,8,8,52,8,8,0,0,0,8,8,20,8,8,0,8,8,8,8,55,8,0,0,0,0,8,8,23,8,0,0,8,8,8,8,52,8,8,0,0,0,8,8,20,8,8,0,8,8,8,8,54,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,55,8,8,0,0,0,8,8,247,8,8,0,8,8,8,8,52,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,54,8,8,0,0,0,8,8,246,8,8,0,8,8,8,8,52,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,244,8,8,0,0,8,8,8,55,8,0,0,0,0,8,8,247,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,8,8,8,8,23,8,8,0,0,0,8,8,247,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,22,8,8,0,0,0,8,8,246,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,20,8,8,0,0,0,8,8,244,8,8,0,8,8,8,8,23,8,0,0,0,0,8,8,247,8,0,0,8,8,8,8,20,8,8,0,0,0,8,8,244,8,8,0,8,8,8,8,22,8,0,0,0,0,8,8,246,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,8,8,8,8,20,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,8,8,8,8,20,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,116,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,118,8,0,0,0,0,8,8,54,8,0,0,8,8,8,8,119,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,116,8,0,0,0,0,8,8,52,8,0,0,8,8,8,8,118,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,116,8,0,0,0,0,8,8,52,8,0,0,8,8,8,8,116,8,8,0,0,0,8,8,20,8,8,0,8,8,8,8,119,8,0,0,0,0,8,8,23,8,0,0,8,8,8,8,116,8,8,0,0,0,8,8,20,8,8,0,8,8,8,8,118,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,119,8,8,0,0,0,8,8,55,8,8,0,8,8,8,8,116,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,118,8,8,0,0,0,8,8,54,8,8,0,8,8,8,8,116,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,116,8,8,0,0,0,8,8,52,8,8,0,0,8,8,8,119,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,8,8,8,8,23,8,8,0,0,0,8,8,55,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,22,8,8,0,0,0,8,8,54,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,20,8,8,0,0,0,8,8,52,8,8,0,8,8,8,8,23,8,0,0,0,0,8,8,55,8,0,0,8,8,8,8,20,8,8,0,0,0,8,8,52,8,8,0,8,8,8,8,22,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,8,8,8,8,20,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,8,8,8,8,20,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,116,8,8,0,0,8,8,8,54,8,0,0,0,0,8,8,118,8,0,0,8,8,8,8,55,8,8,0,0,0,8,8,23,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,116,8,0,0,8,8,8,8,54,8,8,0,0,0,8,8,22,8,8,0,0,8,8,8,52,8,0,0,0,0,8,8,116,8,0,0,8,8,8,8,52,8,8,0,0,0,8,8,20,8,8,0,8,8,8,8,55,8,0,0,0,0,8,8,23,8,0,0,8,8,8,8,52,8,8,0,0,0,8,8,20,8,8,0,8,8,8,8,54,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,55,8,8,0,0,0,8,8,119,8,8,0,8,8,8,8,52,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,54,8,8,0,0,0,8,8,118,8,8,0,8,8,8,8,52,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,52,8,8,0,0,0,8,8,116,8,8,0,0,8,8,8,55,8,0,0,0,0,8,8,119,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,8,8,8,8,23,8,8,0,0,0,8,8,119,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,22,8,8,0,0,0,8,8,118,8,8,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,8,8,8,8,20,8,8,0,0,0,8,8,116,8,8,0,8,8,8,8,23,8,0,0,0,0,8,8,119,8,0,0,8,8,8,8,20,8,8,0,0,0,8,8,116,8,8,0,8,8,8,8,22,8,0,0,0,0,8,8,118,8,0,0,0,8,8,8,23,8,8,0,0,0,8,8,23,8,8,0,8,8,8,8,20,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,22,8,8,0,0,0,8,8,22,8,8,0,8,8,8,8,20,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,20,8,8,0,0,0,8,8,20,8,8,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,119,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,118,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,116,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,116,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,247,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,246,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,247,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,246,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,244,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,55,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,54,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,52,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,116,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,55,8,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+573955);allocate([8,23,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,22,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,20,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,119,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,118,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,116,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,119,8,0,0,16,16,16,16,239,16,16,16,16,16,16,16,239,16,0,0,0,0,16,16,239,16,16,16,0,0,16,16,239,16,0,0,0,16,16,16,44,16,16,16,0,16,16,16,44,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,44,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,0,0,0,0,0,16,236,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,236,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,104,16,0,0,16,16,16,16,104,16,16,0,16,16,16,16,104,16,0,0,16,16,16,16,47,16,16,0,16,16,16,16,47,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,47,16,0,0,0,16,16,16,108,16,16,0,0,16,16,16,108,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,108,16,0,0,16,16,16,16,40,16,16,16,16,16,16,16,40,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,16,16,16,16,232,16,16,16,16,16,16,16,232,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,232,16,0,0,0,0,16,16,238,16,16,16,0,0,16,16,238,16,0,0,0,16,16,16,238,16,16,16,0,16,16,16,238,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,111,16,16,16,0,0,0,16,111,16,0,0,0,0,0,16,111,16,16,16,0,0,0,16,111,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,16,16,16,16,40,16,16,0,16,16,16,16,40,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,46,16,0,0,0,16,16,16,46,16,16,0,0,16,16,16,46,16,0,0,0,0,16,16,108,16,16,16,0,0,16,16,108,16,0,0,16,16,16,16,108,16,16,16,16,16,16,16,108,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,232,16,0,0,0,16,16,16,232,16,16,16,0,16,16,16,232,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,236,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,236,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,110,16,16,16,0,0,0,16,110,16,0,0,0,0,0,16,110,16,16,16,0,0,0,16,110,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,44,16,0,0,16,16,16,16,44,16,16,0,16,16,16,16,44,16,0,0,0,0,16,16,232,16,16,0,0,0,16,16,232,16,0,0,16,16,16,16,232,16,16,0,16,16,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,40,16,16,0,0,16,16,16,40,16,0,0,0,16,16,16,239,16,16,16,0,16,16,16,239,16,0,0,0,0,16,16,239,16,16,16,0,0,16,16,239,16,0,0,16,16,16,16,44,16,16,16,16,16,16,16,44,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,44,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,0,0,0,0,0,16,236,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,236,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,104,16,16,0,0,16,16,16,104,16,0,0,0,16,16,16,47,16,16,0,0,16,16,16,47,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,47,16,0,0,16,16,16,16,108,16,16,0,16,16,16,16,108,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,108,16,0,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,0,16,16,16,232,16,16,16,0,16,16,16,232,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,232,16,0,0,0,0,16,16,238,16,16,16,0,0,16,16,238,16,0,0,16,16,16,16,238,16,16,16,16,16,16,16,238,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,111,16,16,16,0,0,0,16,111,16,0,0,0,0,0,16,111,16,16,16,0,0,0,16,111,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,16,16,16,40,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,46,16,0,0,16,16,16,16,46,16,16,0,16,16,16,16,46,16,0,0,0,0,16,16,108,16,16,16,0,0,16,16,108,16,0,0,0,16,16,16,108,16,16,16,0,16,16,16,108,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,16,16,16,16,40,16,16,16,16,16,16,16,40,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,232,16,0,0,16,16,16,16,232,16,16,16,16,16,16,16,232,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,236,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,236,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,110,16,16,16,0,0,0,16,110,16,0,0,0,0,0,16,110,16,16,16,0,0,0,16,110,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,44,16,0,0,0,16,16,16,44,16,16,0,0,16,16,16,44,16,0,0,0,0,16,16,232,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,232,16,16,0,0,16,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,16,16,16,16,40,16,16,0,16,16,16,16,40,16,0,0,16,16,16,16,239,16,16,0,16,16,16,16,239,16,0,0,0,0,16,16,239,16,16,0,0,0,16,16,239,16,0,0,0,16,16,16,44,16,16,0,0,16,16,16,44,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,44,16,0,0,16,16,16,16,104,16,16,16,16,16,16,16,104,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,104,16,0,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,236,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,236,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,108,16,0,0,16,16,16,16,40,16,16,0,16,16,16,16,40,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,16,16,16,16,232,16,16,0,16,16,16,16,232,16,0,0,0,0,16,16,232,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,238,16,16,0,0,0,16,16,238,16,0,0,0,16,16,16,238,16,16,0,0,16,16,16,238,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,44,16,0,0,16,16,16,16,44,16,16,16,16,16,16,16,44,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,104,16,0,0,0,16,16,16,104,16,16,16,0,16,16,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,111,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,111,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,108,16,0,0,16,16,16,16,108,16,16,0,16,16,16,16,108,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,40,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,232,16,16,0,0,16,16,16,232,16,0,0,16,16,16,16,47,16,16,16,16,16,16,16,47,16,0,0,0,0,16,16,47,16,16,16,0,0,16,16,47,16,0,0,16,16,16,16,236,16,16,16,16,16,16,16,236,16,0,0,0,0,16,16,236,16,16,16,0,0,16,16,236,16,0,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,110,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,110,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,16,16,16,239,16,16,0,0,16,16,16,239,16,0,0,0,0,16,16,239,16,16,0,0,0,16,16,239,16,0,0,16,16,16,16,44,16,16,0,16,16,16,16,44,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,44,16,0,0,0,16,16,16,104,16,16,16,0,16,16,16,104,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,104,16,0,0,16,16,16,16,40,16,16,16,16,16,16,16,40,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,236,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,236,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,108,16,0,0,0,16,16,16,40,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,232,16,16,0,0,16,16,16,232,16,0,0,0,0,16,16,232,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,238,16,16,0,0,0,16,16,238,16,0,0,16,16,16,16,238,16,16,0,16,16,16,16,238,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,44,16,0,0,0,16,16,16,44,16,16,16,0,16,16,16,44,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,104,16,0,0,16,16,16,16,104,16,16,16,16,16,16,16,104,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,111,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,111,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,16,0,0,0,16,46,16,0,0,0,0,16,16,108,16,16,0,0,0,16,16,108,16,0,0,0,16,16,16,108,16,16,0,0,16,16,16,108,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,16,16,16,16,40,16,16,0,16,16,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,16,16,232,16,0,0,16,16,16,16,232,16,16,0,16,16,16,16,232,16,0,0,0,16,16,16,47,16,16,16,0,16,16,16,47,16,0,0,0,0,16,16,47,16,16,16,0,0,16,16,47,16,0,0,0,16,16,16,236,16,16,16,0,16,16,16,236,16,0,0,0,0,16,16,236,16,16,16,0,0,16,16,236,16,0,0,16,16,16,16,40,16,16,16,16,16,16,16,40,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,110,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,110,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,239,16,16,16,0,0,0,16,239,16,0,0,0,0,0,16,239,16,16,16,0,0,0,16,239,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,16,16,16,16,104,16,16,0,16,16,16,16,104,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,40,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,16,16,0,0,16,16,46,16,0,0,16,16,16,16,46,16,16,16,16,16,16,16,46,16,0,0,0,0,16,16,236,16,16,16,0,0,16,16,236,16,0,0,16,16,16,16,236,16,16,16,16,16,16,16,236,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,238,16,16,16,0,0,0,16,238,16,0,0,0,0,0,16,238,16,16,16,0,0,0,16,238,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,44,16,0,0,16,16,16,16,44,16,16,0,16,16,16,16,44,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,104,16,16,0,0,16,16,16,104,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,16,16,16,16,40,16,16,16,16,16,16,16,40,16,0,0,16,16,16,16,111,16,16,16,16,16,16,16,111,16,0,0,0,0,16,16,111,16,16,16,0,0,16,16,111,16,0,0,0,16,16,16,44,16,16,16,0,16,16,16,44,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,44,16,0,0,0,16,16,16,232,16,16,16,0,16,16,16,232,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,16,16,16,16,47,16,16,0,16,16,16,16,47,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,47,16,0,0,16,16,16,16,236,16,16,0,16,16,16,16,236,16,0,0,0,0,16,16,236,16,16,0,0,0,16,16,236,16,0,0,0,16,16,16,40,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,16,16,16,16,104,16,16,16,16,16,16,16,104,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,104,16,0,0,0,0,16,16,110,16,16,16,0,0,16,16,110,16,0,0,0,16,16,16,110,16,16,16,0,16,16,16,110,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,239,16,16,16,0,0,0,16,239,16,0,0,0,0,0,16,239,16,16,16,0,0,0,16,239,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,16,16,16,104,16,16,0,0,16,16,16,104,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,104,16,0,0,16,16,16,16,40,16,16,0,16,16,16,16,40,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,16,16,0,0,16,16,46,16,0,0,0,16,16,16,46,16,16,16,0,16,16,16,46,16,0,0,0,0,16,16,236,16,16,16,0,0,16,16,236,16,0,0,0,16,16,16,236,16,16,16,0,16,16,16,236,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,16,16,16,16,40,16,16,16,16,16,16,16,40,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,47,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,238,16,16,16,0,0,0,16,238,16,0,0,0,0,0,16,238,16,16,16,0,0,0,16,238,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,44,16,0,0,0,16,16,16,44,16,16,0,0,16,16,16,44,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,104,16,0,0,16,16,16,16,104,16,16,0,16,16,16,16,104,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,0,0,0,16,16,16,111,16,16,16,0,16,16,16,111,16,0,0,0,0,16,16,111,16,16,16,0,0,16,16,111,16,0,0,16,16,16,16,44,16,16,16,16,16,16,16,44,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,44,16,0,0,16,16,16,16,232,16,16,16,16,16,16,16,232,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,46,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,108,16,16,16,0,0,0,16,108,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,16,0,0,0,16,232,16,0,0,0,16,16,16,47,16,16,0,0,16,16,16,47,16,0,0,0,0,16,16,47,16,16,0,0,0,16,16,47,16,0,0,0,16,16,16,236,16,16,0,0,16,16,16,236,16,0,0,0,0,16,16,236,16,16,0,0,0,16,16,236,16,0,0,16,16,16,16,40,16,16,0,16,16,16,16,40,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,104,16,16,16,0,16,16,16,104,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,104,16,0,0,0,0,16,16,110,16,16,16,0,0,16,16,110,16,0,0,16,16,16,16,110,16,16,16,16,16,16,16,110,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,239,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,239,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,46,16,0,0,16,16,16,16,46,16,16,0,16,16,16,16,46,16,0,0,0,0,16,16,236,16,16,0,0,0,16,16,236,16,0,0,16,16,16,16,236,16,16,0,16,16,16,16,236,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,40,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,104,16,0,0,16,16,16,16,104,16,16,16,16,16,16,16,104,16,0,0,16,16,16,16,47,16,16,16,16,16,16,16,47,16,0,0,0,0,16,16,47,16,16,16,0,0,16,16,47,16,0,0,0,16,16,16,108,16,16,16,0,16,16,16,108,16,0,0,0,0,16,16,108,16,16,16,0,0,16,16,108,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,238,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,238,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,16,16,16,16,40,16,16,0,16,16,16,16,40,16,0,0,16,16,16,16,111,16,16,0,16,16,16,16,111,16,0,0,0,0,16,16,111,16,16,0,0,0,16,16,111,16,0,0,0,16,16,16,44,16,16,0,0,16,16,16,44,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,44,16,0,0,0,16,16,16,232,16,16,0,0,16,16,16,232,16,0,0,0,0,16,16,232,16,16,0,0,0,16,16,232,16,0,0,16,16,16,16,40,16,16,16,16,16,16,16,40,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,0,0,16,16,46,16,16,16,0,0,16,16,46,16,0,0,0,16,16,16,46,16,16,16,0,16,16,16,46,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,236,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,236,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,16,16,16,16,104,16,16,0,16,16,16,16,104,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,110,16,16,0,0,0,16,16,110,16,0,0,0,16,16,16,110,16,16,0,0,16,16,16,110,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,44,16,0,0,16,16,16,16,44,16,16,16,16,16,16,16,44,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,232,16,0,0,16,16,16,16,232,16,16,16,16,16,16,16,232,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,0,0,0,0,0,16,239,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,239,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,16,16,46,16,16,0,0,0,16,16,46,16,0,0,0,16,16,16,46,16,16,0,0,16,16,16,46,16,0,0,0,0,16,16,236,16,16,0,0,0,16,16,236,16,0,0,0,16,16,16,236,16,16,0,0,16,16,16,236,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,16,16,16,16,40,16,16,0,16,16,16,16,40,16,0,0,0,0,16,16,104,16,16,16,0,0,16,16,104,16,0,0,0,16,16,16,104,16,16,16,0,16,16,16,104,16,0,0,0,16,16,16,47,16,16,16,0,16,16,16,47,16,0,0,0,0,16,16,47,16,16,16,0,0,16,16,47,16,0,0,16,16,16,16,108,16,16,16,16,16,16,16,108,16,0,0,0,0,16,16,108,16,16,16,0,0,16,16,108,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,238,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,238,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,44,16,16,16,0,0,0,16,44,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,0,16,104,16,16,16,0,0,0,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,40,16,16,0,0,16,16,16,40,16,0,0,0,16,16,16,111,16,16,0,0,16,16,16,111,16,0,0,0,0,16,16,111,16,16,0,0,0,16,16,111,16,0,0,16,16,16,16,44,16,16,0,16,16,16,16,44,16,0,0,0,0,16,16,44,16,16,0,0,0,16,16,44,16,0,0,16,16,16,16,232,16,16,0,16,16,16,16,232,16,0,0,0,0,16,16,232,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,40,16,16,16,0,16,16,16,40,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,0,0,16,16,46,16,16,16,0,0,16,16,46,16,0,0,16,16,16,16,46,16,16,16,16,16,16,16,46,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,108,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,16,0,0,0,0,16,232,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,47,16,16,16,0,0,0,16,47,16,0,0,0,0,0,16,236,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,236,16,16,16,0,0,0,16,236,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,0,0,16,40,16,16,16,0,0,0,16,40,16,0,0,0,16,16,16,104,16,16,0,0,16,16,16,104,16,0,0,0,0,16,16,104,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,110,16,16,0,0,0,16,16,110,16,0,0,16,16,16,16,110,16,16,0,16,16,16,16,110,16,0,0,0,0,16,16,44,16,16,16,0,0,16,16,44,16,0,0,0,16,16,16,44,16,16,16,0,16,16,16,44,16,0,0,0,0,16,16,232,16,16,16,0,0,16,16,232,16,0,0,0,16,16,16,232,16,16,16,0,16,16,16,232,16,0,0,0,0,16,16,40,16,16,16,0,0,16,16,40,16,0,0,16,16,16,16,40,16,16,16,16,16,16,16,40,16,0,0,32,32,32,32,223,32,32,32,0,0,32,32,95,32,32,32,32,32,32,32,223,32,0,0,0,0,32,32,95,32,0,0,32,32,32,32,222,32,32,32,0,0,32,32,94,32,32,32,32,32,32,32,222,32,0,0,0,0,32,32,94,32,0,0,32,32,32,32,220,32,32,32,0,0,32,32,92,32,32,32,32,32,32,32,220,32,0,0,0,0,32,32,92,32,0,0,32,32,32,32,220,32,32,32,0,0,32,32,92,32,32,32,32,32,32,32,220,32,0,0,0,0,32,32,92,32,0,0,32,32,32,32,216,32,32,32,0,0,32,32,88,32,32,32,32,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,32,32,32,32,216,32,32,32,0,0,32,32,88,32,32,32,32,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,32,32,32,32,216,32,32,32,0,0,32,32,88,32,32,32,32,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,32,32,32,32,216,32,32,32,0,0,32,32,88,32,32,32,32,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,32,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,220,32,32,0,0,0,32,32,92,32,32,0,0,32,32,32,220,32,0,0,0,0,32,32,92,32,0,0,0,32,32,32,220,32,32,0,0,0,32,32,92,32,32,0,0,32,32,32,220,32,0,0,0,0,32,32,92,32,0,0,0,32,32,32,223,32,32,0,0,0,32,32,95,32,32,0,0,32,32,32,223,32,0,0,0,0,32,32,95,32,0,0,0,32,32,32,222,32,32,0,0,0,32,32,94,32,32,0,0,32,32,32,222,32,0,0,0,0,32,32,94,32,0,0,0,32,32,32,216,32,32,0,0,0,32,32,88,32,32,0,0,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,216,32,32,0,0,0,32,32,88,32,32,0,0,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,216,32,32,0,0,0,32,32,88,32,32,0,0,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,216,32,32,0,0,0,32,32,88,32,32,0,0,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,95,32,32,32,0,0,32,32,223,32,32,32,32,32,32,32,95,32,0,0,0,0,32,32,223,32,0,0,32,32,32,32,94,32,32,32,0,0,32,32,222,32,32,32,32,32,32,32,94,32,0,0,0,0,32,32,222,32,0,0,32,32,32,32,92,32,32,32,0,0,32,32,220,32,32,32,32,32,32,32,92,32,0,0,0,0,32,32,220,32,0,0,32,32,32,32,92,32,32,32,0,0,32,32,220,32,32,32,32,32,32,32,92,32,0,0,0,0,32,32,220,32,0,0,32,32,32,32,88,32,32,32,0,0,32,32,216,32,32,32,32,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,32,32,32,32,88,32,32,32,0,0,32,32,216,32,32,32,32,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,32,32,32,32,88,32,32,32,0,0,32,32,216,32,32,32,32,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,32,32,32,32,88,32,32,32,0,0,32,32,216,32,32,32,32,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,32,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,92,32,32,0,0,0,32,32,220,32,32,0,0,32,32,32,92,32,0,0,0,0,32,32,220,32,0,0,0,32,32,32,92,32,32,0,0,0,32,32,220,32,32,0,0,32,32,32,92,32,0,0,0,0,32,32,220,32,0,0,0,32,32,32,95,32,32,0,0,0,32,32,223,32,32,0,0,32,32,32,95,32,0,0,0,0,32,32,223,32,0,0,0,32,32,32,94,32,32,0,0,0,32,32,222,32,32,0,0,32,32,32,94,32,0,0,0,0,32,32,222,32,0,0,0,32,32,32,88,32,32,0,0,0,32,32,216,32,32,0,0,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,88,32,32,0,0,0,32,32,216,32,32,0,0,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,88,32,32,0,0,0,32,32,216,32,32,0,0,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,88,32,32,0,0,0,32,32,216,32,32,0,0,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,0,0,0,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+584195);allocate([32,208,32,32,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,223,32,32,32,0,0,0,32,95,32,32,32,0,0,0,32,223,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,222,32,32,32,0,0,0,32,94,32,32,32,0,0,0,32,222,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,220,32,32,32,0,0,0,32,92,32,32,32,0,0,0,32,220,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,220,32,32,32,0,0,0,32,92,32,32,32,0,0,0,32,220,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,95,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,94,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,32,32,0,0,0,32,223,32,32,32,0,0,0,32,95,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,94,32,32,32,0,0,0,32,222,32,32,32,0,0,0,32,94,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,92,32,32,32,0,0,0,32,220,32,32,32,0,0,0,32,92,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,92,32,32,32,0,0,0,32,220,32,32,32,0,0,0,32,92,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,223,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,222,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,220,32,32,32,0,0,32,32,92,32,32,32,0,32,32,32,220,32,0,0,0,0,32,32,92,32,0,0,0,32,32,32,220,32,32,32,0,0,32,32,92,32,32,32,0,32,32,32,220,32,0,0,0,0,32,32,92,32,0,0,0,32,32,32,223,32,32,32,0,0,32,32,95,32,32,32,0,32,32,32,223,32,0,0,0,0,32,32,95,32,0,0,0,32,32,32,222,32,32,32,0,0,32,32,94,32,32,32,0,32,32,32,222,32,0,0,0,0,32,32,94,32,0,0,0,32,32,32,216,32,32,32,0,0,32,32,88,32,32,32,0,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,216,32,32,32,0,0,32,32,88,32,32,32,0,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,216,32,32,32,0,0,32,32,88,32,32,32,0,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,216,32,32,32,0,0,32,32,88,32,32,32,0,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,208,32,32,32,0,0,32,32,80,32,32,32,0,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,223,32,32,0,0,0,32,32,95,32,32,0,32,32,32,32,223,32,0,0,0,0,32,32,95,32,0,0,32,32,32,32,222,32,32,0,0,0,32,32,94,32,32,0,32,32,32,32,222,32,0,0,0,0,32,32,94,32,0,0,32,32,32,32,220,32,32,0,0,0,32,32,92,32,32,0,32,32,32,32,220,32,0,0,0,0,32,32,92,32,0,0,32,32,32,32,220,32,32,0,0,0,32,32,92,32,32,0,32,32,32,32,220,32,0,0,0,0,32,32,92,32,0,0,32,32,32,32,216,32,32,0,0,0,32,32,88,32,32,0,32,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,32,32,32,32,216,32,32,0,0,0,32,32,88,32,32,0,32,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,32,32,32,32,216,32,32,0,0,0,32,32,88,32,32,0,32,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,32,32,32,32,216,32,32,0,0,0,32,32,88,32,32,0,32,32,32,32,216,32,0,0,0,0,32,32,88,32,0,0,32,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,32,32,32,32,208,32,32,0,0,0,32,32,80,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,92,32,32,32,0,0,32,32,220,32,32,32,0,32,32,32,92,32,0,0,0,0,32,32,220,32,0,0,0,32,32,32,92,32,32,32,0,0,32,32,220,32,32,32,0,32,32,32,92,32,0,0,0,0,32,32,220,32,0,0,0,32,32,32,95,32,32,32,0,0,32,32,223,32,32,32,0,32,32,32,95,32,0,0,0,0,32,32,223,32,0,0,0,32,32,32,94,32,32,32,0,0,32,32,222,32,32,32,0,32,32,32,94,32,0,0,0,0,32,32,222,32,0,0,0,32,32,32,88,32,32,32,0,0,32,32,216,32,32,32,0,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,88,32,32,32,0,0,32,32,216,32,32,32,0,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,88,32,32,32,0,0,32,32,216,32,32,32,0,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,88,32,32,32,0,0,32,32,216,32,32,32,0,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,0,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,32,32,32,80,32,32,32,0,0,32,32,208,32,32,32,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,95,32,32,0,0,0,32,32,223,32,32,0,32,32,32,32,95,32,0,0,0,0,32,32,223,32,0,0,32,32,32,32,94,32,32,0,0,0,32,32,222,32,32,0,32,32,32,32,94,32,0,0,0,0,32,32,222,32,0,0,32,32,32,32,92,32,32,0,0,0,32,32,220,32,32,0,32,32,32,32,92,32,0,0,0,0,32,32,220,32,0,0,32,32,32,32,92,32,32,0,0,0,32,32,220,32,32,0,32,32,32,32,92,32,0,0,0,0,32,32,220,32,0,0,32,32,32,32,88,32,32,0,0,0,32,32,216,32,32,0,32,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,32,32,32,32,88,32,32,0,0,0,32,32,216,32,32,0,32,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,32,32,32,32,88,32,32,0,0,0,32,32,216,32,32,0,32,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,32,32,32,32,88,32,32,0,0,0,32,32,216,32,32,0,32,32,32,32,88,32,0,0,0,0,32,32,216,32,0,0,32,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,32,32,32,32,80,32,32,0,0,0,32,32,208,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,220,32,32,32,0,0,0,32,92,32,32,32,0,0,0,32,220,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,220,32,32,32,0,0,0,32,92,32,32,32,0,0,0,32,220,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,223,32,32,32,0,0,0,32,95,32,32,32,0,0,0,32,223,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,222,32,32,32,0,0,0,32,94,32,32,32,0,0,0,32,222,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,32,0,0,0,32,88,32,32,32,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,32,0,0,0,32,80,32,32,32,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,95,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,94,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,92,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,32,0,0,0,32,220,32,32,32,0,0,0,32,92,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,92,32,32,32,0,0,0,32,220,32,32,32,0,0,0,32,92,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,95,32,32,32,0,0,0,32,223,32,32,32,0,0,0,32,95,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,94,32,32,32,0,0,0,32,222,32,32,32,0,0,0,32,94,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,32,0,0,0,32,216,32,32,32,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,32,0,0,0,32,208,32,32,32,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,223,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,222,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,220,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,216,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,64,64,64,64,191,64,64,64,64,64,64,64,191,64,0,0,64,64,64,64,190,64,64,64,64,64,64,64,190,64,0,0,64,64,64,64,188,64,64,64,64,64,64,64,188,64,0,0,64,64,64,64,188,64,64,64,64,64,64,64,188,64,0,0,64,64,64,64,184,64,64,64,64,64,64,64,184,64,0,0,64,64,64,64,184,64,64,64,64,64,64,64,184,64,0,0,64,64,64,64,184,64,64,64,64,64,64,64,184,64,0,0,64,64,64,64,184,64,64,64,64,64,64,64,184,64,0,0,64,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,64,64,184,64,64,64,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,64,64,184,64,0,0,0,0,64,64,190,64,64,64,0,0,64,64,190,64,0,0,0,0,64,64,191,64,64,64,0,0,64,64,191,64,0,0,0,0,64,64,188,64,64,64,0,0,64,64,188,64,0,0,0,0,64,64,188,64,64,64,0,0,64,64,188,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,191,64,64,64,0,0,0,64,191,64,0,0,0,0,0,64,190,64,64,64,0,0,0,64,190,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,190,64,64,64,0,0,0,64,190,64,0,0,0,0,0,64,191,64,64,64,0,0,0,64,191,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,64,64,64,64,191,64,64,0,64,64,64,64,191,64,0,0,64,64,64,64,190,64,64,0,64,64,64,64,190,64,0,0,64,64,64,64,188,64,64,0,64,64,64,64,188,64,0,0,64,64,64,64,188,64,64,0,64,64,64,64,188,64,0,0,64,64,64,64,184,64,64,0,64,64,64,64,184,64,0,0,64,64,64,64,184,64,64,0,64,64,64,64,184,64,0,0,64,64,64,64,184,64,64,0,64,64,64,64,184,64,0,0,64,64,64,64,184,64,64,0,64,64,64,64,184,64,0,0,64,64,64,64,176,64,64,0,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,0,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,0,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,0,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,0,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,0,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,0,64,64,64,64,176,64,0,0,64,64,64,64,176,64,64,0,64,64,64,64,176,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,64,64,64,64,160,64,64,0,64,64,64,64,160,64,0,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,64,64,190,64,64,0,0,0,64,64,190,64,0,0,0,0,64,64,191,64,64,0,0,0,64,64,191,64,0,0,0,0,64,64,188,64,64,0,0,0,64,64,188,64,0,0,0,0,64,64,188,64,64,0,0,0,64,64,188,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+594435);allocate([64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,191,64,64,64,0,0,0,64,191,64,0,0,0,0,0,64,190,64,64,64,0,0,0,64,190,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,64,0,0,0,64,184,64,0,0,0,0,0,64,190,64,64,64,0,0,0,64,190,64,0,0,0,0,0,64,191,64,64,64,0,0,0,64,191,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,64,0,0,0,64,188,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,64,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,64,0,0,0,64,160,64,0,0,0,64,64,64,184,64,64,64,0,64,64,64,184,64,0,0,0,64,64,64,184,64,64,64,0,64,64,64,184,64,0,0,0,64,64,64,184,64,64,64,0,64,64,64,184,64,0,0,0,64,64,64,184,64,64,64,0,64,64,64,184,64,0,0,0,64,64,64,188,64,64,64,0,64,64,64,188,64,0,0,0,64,64,64,188,64,64,64,0,64,64,64,188,64,0,0,0,64,64,64,191,64,64,64,0,64,64,64,191,64,0,0,0,64,64,64,190,64,64,64,0,64,64,64,190,64,0,0,0,64,64,64,176,64,64,64,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,0,64,64,64,176,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,0,64,64,64,160,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,64,0,0,64,64,176,64,0,0,0,0,64,64,188,64,64,64,0,0,64,64,188,64,0,0,0,0,64,64,188,64,64,64,0,0,64,64,188,64,0,0,0,0,64,64,190,64,64,64,0,0,64,64,190,64,0,0,0,0,64,64,191,64,64,64,0,0,64,64,191,64,0,0,0,0,64,64,184,64,64,64,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,64,0,0,64,64,184,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,0,0,64,64,160,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,0,0,0,64,64,64,184,64,64,0,0,64,64,64,184,64,0,0,0,64,64,64,184,64,64,0,0,64,64,64,184,64,0,0,0,64,64,64,184,64,64,0,0,64,64,64,184,64,0,0,0,64,64,64,184,64,64,0,0,64,64,64,184,64,0,0,0,64,64,64,188,64,64,0,0,64,64,64,188,64,0,0,0,64,64,64,188,64,64,0,0,64,64,64,188,64,0,0,0,64,64,64,191,64,64,0,0,64,64,64,191,64,0,0,0,64,64,64,190,64,64,0,0,64,64,64,190,64,0,0,0,64,64,64,176,64,64,0,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,0,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,0,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,0,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,0,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,0,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,0,0,64,64,64,176,64,0,0,0,64,64,64,176,64,64,0,0,64,64,64,176,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,64,64,64,160,64,64,0,0,64,64,64,160,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,0,0,0,0,64,64,188,64,64,0,0,0,64,64,188,64,0,0,0,0,64,64,188,64,64,0,0,0,64,64,188,64,0,0,0,0,64,64,190,64,64,0,0,0,64,64,190,64,0,0,0,0,64,64,191,64,64,0,0,0,64,64,191,64,0,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,0,0,128,128,128,128,127,128,128,128,0,0,0,128,127,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,127,128,128,128,0,0,0,128,127,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,126,128,128,128,0,0,0,128,126,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,126,128,128,128,0,0,0,128,126,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,124,128,128,128,0,0,0,128,124,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,128,0,0,0,128,124,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,124,128,128,128,0,0,0,128,124,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,128,0,0,0,128,124,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,128,128,128,128,127,128,128,0,0,0,0,128,127,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,127,128,128,0,0,0,0,128,127,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,126,128,128,0,0,0,0,128,126,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,126,128,128,0,0,0,0,128,126,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,124,128,128,0,0,0,0,128,124,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,124,128,128,0,0,0,0,128,124,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,120,128,128,0,0,0,0,128,120,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,120,128,128,0,0,0,0,128,120,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,120,128,128,0,0,0,0,128,120,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,120,128,128,0,0,0,0,128,120,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,128,0,0,0,128,112,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,128,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,124,128,128,128,0,0,0,128,124,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,128,0,0,0,128,124,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,124,128,128,128,0,0,0,128,124,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,128,0,0,0,128,124,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,126,128,128,128,0,0,0,128,126,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,126,128,128,128,0,0,0,128,126,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,127,128,128,128,0,0,0,128,127,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,127,128,128,128,0,0,0,128,127,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,120,128,128,128,0,0,0,128,120,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,120,128,128,128,0,0,0,128,120,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,120,128,128,128,0,0,0,128,120,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,120,128,128,128,0,0,0,128,120,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,128,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+604675);allocate([128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,128,0,0,0,128,96,128,0,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,128,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,124,128,128,0,0,0,0,128,124,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,124,128,128,0,0,0,0,128,124,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,126,128,128,0,0,0,0,128,126,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,126,128,128,0,0,0,0,128,126,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,127,128,128,0,0,0,0,128,127,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,127,128,128,0,0,0,0,128,127,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,128,128,0,0,0,128,64,128,0,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,128,128,0,0,0,128,127,128,128,128,128,128,128,128,127,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,127,128,128,128,0,0,128,128,127,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,126,128,128,128,128,128,128,128,126,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,126,128,128,128,0,0,128,128,126,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,128,128,128,128,124,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,124,128,128,128,0,0,128,128,124,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,128,128,128,128,124,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,124,128,128,128,0,0,128,128,124,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,127,128,128,0,128,128,128,128,127,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,127,128,128,0,0,0,128,128,127,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,126,128,128,0,128,128,128,128,126,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,126,128,128,0,0,0,128,128,126,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,0,128,128,128,128,124,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,124,128,128,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,0,128,128,128,128,124,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,124,128,128,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,0,128,128,128,128,120,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,0,128,128,128,128,120,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,0,128,128,128,128,120,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,0,128,128,128,128,120,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,0,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,128,128,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,0,128,128,128,124,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,124,128,128,128,0,0,128,128,124,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,128,0,128,128,128,124,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,124,128,128,128,0,0,128,128,124,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,126,128,128,128,0,128,128,128,126,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,126,128,128,128,0,0,128,128,126,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,127,128,128,128,0,128,128,128,127,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,127,128,128,128,0,0,128,128,127,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,128,128,128,120,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,128,128,128,120,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,128,128,128,120,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,128,128,128,120,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,120,128,128,128,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,128,128,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,0,0,128,128,128,124,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,124,128,128,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,124,128,128,0,0,128,128,128,124,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,124,128,128,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,126,128,128,0,0,128,128,128,126,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,126,128,128,0,0,0,128,128,126,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,127,128,128,0,0,128,128,128,127,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,127,128,128,0,0,0,128,128,127,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,128,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,128,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,128,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,128,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+614915);allocate([128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,0,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,128,128,0,128,128,128,64,128,0,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,128,128,1,1,1,1,1,254,1,1,0,0,0,0,1,254,1,1,0,0,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,254,1,1,0,0,0,0,1,254,1,1,0,0,0,0,1,62,1,0,0,0,1,1,1,62,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,1,1,1,30,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,1,1,1,254,1,0,0,0,0,0,1,254,1,0,0,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,254,1,0,0,0,1,1,1,254,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,1,1,1,30,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,126,1,1,0,0,0,0,1,126,1,1,0,0,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,126,1,1,0,0,0,0,1,126,1,1,0,0,0,0,1,62,1,0,0,0,1,1,1,62,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,1,1,1,30,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,1,1,1,126,1,0,0,0,0,0,1,126,1,0,0,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,126,1,0,0,0,1,1,1,126,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,1,1,1,30,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,1,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,0,0,0,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,0,1,1,126,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,126,1,0,0,0,0,1,1,126,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,1,1,30,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,254,1,1,0,0,0,0,1,254,1,1,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,254,1,1,0,0,0,0,1,254,1,1,0,0,0,0,1,62,1,0,0,0,0,1,1,62,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,1,1,30,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,0,1,1,254,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,0,0,1,254,1,0,0,0,0,1,1,254,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,1,1,30,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,126,1,1,0,0,0,0,1,126,1,1,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,126,1,1,0,0,0,0,1,126,1,1,0,0,0,0,1,62,1,0,0,0,0,1,1,62,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,0,1,30,1,0,0,0,0,1,1,30,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,1,1,1,1,1,254,1,0,0,0,0,0,1,254,1,0,0,0,1,1,1,62,1,1,0,0,0,0,1,62,1,1,0,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,254,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,62,1,1,0,0,1,1,1,62,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,1,1,1,30,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,254,1,1,0,0,0,0,1,254,1,1,0,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,254,1,1,0,0,1,1,1,254,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,30,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+625155);allocate([1,30,1,0,0,0,0,0,1,30,1,1,0,0,1,1,1,30,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,126,1,0,0,0,0,0,1,126,1,0,0,0,1,1,1,62,1,1,0,0,0,0,1,62,1,1,0,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,126,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,1,0,0,1,1,1,62,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,1,1,1,30,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,126,1,1,0,0,0,0,1,126,1,1,0,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,1,0,0,1,1,1,126,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,30,1,1,0,0,0,0,1,30,1,1,0,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,1,1,1,14,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,14,1,1,0,0,0,0,1,14,1,1,0,1,1,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,1,1,1,30,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,1,1,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,1,1,1,6,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,1,1,1,6,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,126,1,1,0,0,0,0,1,126,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,126,1,1,0,0,0,1,1,126,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,1,1,30,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,254,1,0,0,0,0,0,1,254,1,0,0,0,0,0,1,62,1,1,0,0,0,1,1,62,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,1,1,30,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,254,1,1,0,0,0,0,1,254,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,62,1,0,0,0,0,0,1,62,1,0,0,0,0,0,1,254,1,1,0,0,0,1,1,254,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,1,1,30,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,62,1,1,0,0,0,0,1,62,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,126,1,0,0,0,0,0,1,126,1,0,0,0,0,0,1,62,1,1,0,0,0,1,1,62,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,30,1,1,0,0,0,0,1,30,1,1,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,0,1,14,1,1,0,0,0,1,1,14,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,14,1,1,0,0,0,0,1,14,1,1,0,0,0,1,1,30,1,0,0,0,0,0,1,30,1,0,0,0,0,0,1,30,1,1,0,0,0,1,1,30,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,1,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,1,1,6,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,1,0,0,0,0,1,6,1,1,0,0,0,0,1,6,1,0,0,0,0,1,1,6,1,0,1,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,1,0,0,0,0,1,2,1,1,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,2,2,2,2,2,253,2,2,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,13,2,2,0,0,0,0,2,253,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,61,2,2,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,13,2,2,0,0,0,0,2,61,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,125,2,2,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,13,2,2,0,0,0,0,2,125,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,61,2,2,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,13,2,2,0,0,0,0,2,61,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,253,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,253,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,125,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,125,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,253,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,253,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,125,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,125,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,253,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,253,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,125,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,125,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,2,2,2,2,2,253,2,0,0,0,0,0,2,253,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,61,2,0,0,0,0,0,2,61,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,125,2,0,0,0,0,0,2,125,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,61,2,0,0,0,0,0,2,61,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,253,2,0,0,0,0,0,2,253,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,125,2,0,0,0,0,0,2,125,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,253,2,0,0,0,0,0,2,253,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,125,2,0,0,0,0,0,2,125,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,253,2,0,0,0,0,0,2,253,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+635396);allocate([2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,125,2,0,0,0,0,0,2,125,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,13,2,2,0,0,0,0,2,253,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,253,2,2,0,0,0,0,2,13,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,2,0,0,0,0,2,29,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,29,2,2,0,0,0,0,2,13,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,2,0,0,0,0,2,61,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,61,2,2,0,0,0,0,2,13,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,2,0,0,0,0,2,29,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,29,2,2,0,0,0,0,2,13,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,2,0,0,0,0,2,125,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,125,2,2,0,0,0,0,2,13,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,2,0,0,0,0,2,29,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,29,2,2,0,0,0,0,2,13,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,2,0,0,0,0,2,61,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,61,2,2,0,0,0,0,2,13,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,2,0,0,0,0,2,29,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,29,2,2,0,0,0,0,2,13,2,0,2,2,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,253,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,253,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,125,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,125,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,253,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,253,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,125,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,125,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,253,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,253,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,125,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,125,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,2,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,2,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,2,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,253,2,0,0,0,0,0,2,253,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,29,2,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,61,2,0,0,0,0,0,2,61,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,29,2,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,125,2,0,0,0,0,0,2,125,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,29,2,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,61,2,0,0,0,0,0,2,61,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,2,2,2,2,29,2,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,253,2,0,0,0,0,0,2,253,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,125,2,0,0,0,0,0,2,125,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,253,2,0,0,0,0,0,2,253,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,125,2,0,0,0,0,0,2,125,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,253,2,0,0,0,0,0,2,253,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,125,2,0,0,0,0,0,2,125,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,0,0,0,2,2,61,2,0,0,0,0,0,2,61,2,2,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,2,4,4,4,4,4,251,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,59,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,11,4,4,0,0,4,4,4,122,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,58,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,251,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,59,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,122,4,4,0,4,4,4,4,11,4,0,0,0,4,4,4,58,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,4,4,4,4,4,123,4,4,4,4,4,4,4,250,4,4,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,0,0,4,4,4,4,11,4,4,0,4,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,123,4,4,0,0,0,4,4,250,4,4,4,4,4,4,4,59,4,0,4,4,4,4,4,58,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,11,4,0,0,4,4,4,4,10,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,58,4,0,0,0,4,4,4,11,4,4,4,4,4,4,4,122,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,251,4,4,0,4,4,4,4,10,4,4,0,0,0,4,4,59,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,122,4,4,0,0,4,4,4,11,4,0,4,4,4,4,4,58,4,0,0,0,0,4,4,251,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,59,4,0,0,4,4,4,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,123,4,4,0,0,4,4,4,250,4,4,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,11,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,123,4,4,0,0,0,4,4,250,4,4,0,0,4,4,4,59,4,0,0,0,4,4,4,58,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,10,4,0,0,4,4,4,4,251,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,59,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,11,4,4,0,0,4,4,4,122,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,58,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,251,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,59,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,122,4,4,4,4,4,4,4,11,4,0,0,0,4,4,4,58,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,0,4,4,4,4,123,4,4,0,4,4,4,4,250,4,4,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,0,4,4,4,4,4,11,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,58,4,0,0,0,0,4,4,123,4,4,0,0,0,4,4,250,4,4,0,4,4,4,4,59,4,0,0,4,4,4,4,58,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,11,4,0,4,4,4,4,4,10,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,58,4,0,0,0,4,4,4,11,4,4,0,4,4,4,4,122,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,251,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,59,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,122,4,4,0,0,4,4,4,11,4,0,0,4,4,4,4,58,4,0,0,0,0,4,4,251,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,59,4,0,4,4,4,4,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,122,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,251,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,123,4,4,0,0,4,4,4,250,4,4,0,0,0,4,4,59,4,0,0,0,0,4,4,58,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,11,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,123,4,4,0,0,0,4,4,250,4,4,0,0,4,4,4,59,4,0,0,0,4,4,4,58,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,123,4,4,0,0,0,0,4,250,4,4,0,0,0,0,4,59,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,4,4,4,4,4,27,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,11,4,4,0,0,4,4,4,26,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,27,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,26,4,4,0,4,4,4,4,11,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,4,4,4,4,4,27,4,4,4,4,4,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,11,4,4,0,4,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,4,4,4,4,4,27,4,0,4,4,4,4,4,26,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,11,4,0,0,4,4,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,4,4,4,4,4,26,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,27,4,4,0,4,4,4,4,10,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,26,4,4,0,0,4,4,4,11,4,0,4,4,4,4,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,27,4,0,0,4,4,4,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,27,4,4,0,0,4,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,11,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,0,0,4,4,4,27,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,4,4,4,4,27,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,11,4,4,0,0,4,4,4,26,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,27,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,26,4,4,4,4,4,4,4,11,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,4,4,4,4,27,4,4,0,4,4,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,4,4,4,4,4,11,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,0,4,4,4,4,27,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,11,4,0,4,4,4,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,0,4,4,4,4,26,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,27,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,26,4,4,0,0,4,4,4,11,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,27,4,0,4,4,4,4,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,27,4,4,0,0,4,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,11,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,0,0,4,4,4,27,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,59,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,251,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,58,4,4,0,4,4,4,4,11,4,0,0,0,4,4,4,122,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,122,4,0,4,4,4,4,4,59,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,251,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,11,4,4,0,0,4,4,4,58,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,122,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,122,4,0,0,0,0,4,4,59,4,4,0,0,0,4,4,58,4,4,4,4,4,4,4,123,4,0,4,4,4,4,4,250,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,11,4,0,0,4,4,4,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,4,4,4,4,4,59,4,4,4,4,4,4,4,58,4,4,0,0,0,4,4,123,4,0,0,0,0,4,4,250,4,0,0,4,4,4,4,11,4,4,0,4,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,58,4,4,0,0,4,4,4,11,4,0,4,4,4,4,4,122,4,0,0,0,0,4,4,59,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,251,4,0,0,4,4,4,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,4,4,4,4,4,58,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,122,4,0,0,0,4,4,4,59,4,4,0,4,4,4,4,10,4,4,0,0,0,4,4,251,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,11,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,59,4,4,0,0,0,4,4,58,4,4,0,0,4,4,4,123,4,0,0,0,4,4,4,250,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,0,0,0,4,4,4,11,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,59,4,4,0,0,4,4,4,58,4,4,0,0,0,4,4,123,4,0,0,0,0,4,4,250,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,0,0,0,0,4,4,59,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,251,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,58,4,4,4,4,4,4,4,11,4,0,0,0,4,4,4,122,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,122,4,0,0,4,4,4,4,59,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,251,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,11,4,4,0,0,4,4,4,58,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,122,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,122,4,0,0,0,0,4,4,59,4,4,0,0,0,4,4,58,4,4,0,4,4,4,4,123,4,0,0,4,4,4,4,250,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,11,4,0,4,4,4,4,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,4,4,4,4,59,4,4,0,4,4,4,4,58,4,4,0,0,0,4,4,123,4,0,0,0,0,4,4,250,4,0,4,4,4,4,4,11,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,58,4,4,0,0,4,4,4,11,4,0,0,4,4,4,4,122,4,0,0,0,0,4,4,59,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,251,4,0,4,4,4,4,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,0,4,4,4,4,58,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,122,4,0,0,0,4,4,4,59,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,251,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,251,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,11,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,59,4,4,0,0,0,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+645636);allocate([4,58,4,4,0,0,4,4,4,123,4,0,0,0,4,4,4,250,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,0,0,0,4,4,4,11,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,59,4,4,0,0,4,4,4,58,4,4,0,0,0,4,4,123,4,0,0,0,0,4,4,250,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,58,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,59,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,123,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,27,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,26,4,4,0,4,4,4,4,11,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,4,4,4,4,4,27,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,11,4,4,0,0,4,4,4,26,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,4,4,4,4,4,27,4,0,4,4,4,4,4,26,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,11,4,0,0,4,4,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,4,4,4,4,4,27,4,4,4,4,4,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,11,4,4,0,4,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,26,4,4,0,0,4,4,4,11,4,0,4,4,4,4,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,27,4,0,0,4,4,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,4,4,4,4,4,26,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,27,4,4,0,4,4,4,4,10,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,11,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,0,0,4,4,4,27,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,27,4,4,0,0,4,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,10,4,4,0,4,4,4,4,27,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,26,4,4,4,4,4,4,4,11,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,4,4,4,4,27,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,11,4,4,0,0,4,4,4,26,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,0,4,4,4,4,27,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,4,4,4,4,4,11,4,0,4,4,4,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,4,4,4,4,27,4,4,0,4,4,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,4,4,4,4,4,11,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,26,4,4,0,0,4,4,4,11,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,27,4,0,4,4,4,4,4,10,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,0,4,4,4,4,26,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,27,4,4,4,4,4,4,4,10,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,10,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,0,4,4,11,4,4,0,0,0,4,4,10,4,4,0,0,4,4,4,11,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,27,4,4,0,0,0,4,4,26,4,4,0,0,4,4,4,27,4,0,0,0,4,4,4,26,4,0,0,0,0,0,4,11,4,4,0,0,0,0,4,26,4,4,0,0,0,0,4,11,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,27,4,4,0,0,0,0,4,10,4,4,0,0,0,0,4,27,4,0,0,0,0,0,4,10,4,0,0,0,4,4,4,11,4,4,0,0,4,4,4,10,4,4,0,0,0,4,4,11,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,27,4,4,0,0,4,4,4,26,4,4,0,0,0,4,4,27,4,0,0,0,0,4,4,26,4,0,8,8,8,8,8,247,8,8,8,8,8,8,8,247,8,0,0,0,8,8,8,247,8,8,0,0,8,8,8,247,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,8,8,118,8,8,0,0,0,8,8,118,8,0,0,0,0,8,8,118,8,8,0,0,0,8,8,118,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,8,8,8,8,8,116,8,8,8,8,8,8,8,116,8,0,0,0,8,8,8,116,8,8,0,0,8,8,8,116,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,8,8,8,8,247,8,8,0,8,8,8,8,247,8,0,0,0,8,8,8,247,8,8,0,0,8,8,8,247,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,8,8,118,8,8,0,0,0,8,8,118,8,0,0,0,0,8,8,118,8,8,0,0,0,8,8,118,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,8,8,8,8,116,8,8,0,8,8,8,8,116,8,0,0,0,8,8,8,116,8,8,0,0,8,8,8,116,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,8,8,8,8,8,23,8,8,8,8,8,8,8,23,8,0,0,0,8,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,8,8,8,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,8,8,8,8,23,8,8,0,8,8,8,8,23,8,0,0,0,8,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,8,8,8,8,20,8,8,0,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,8,8,8,8,8,55,8,8,8,8,8,8,8,55,8,0,0,0,8,8,8,55,8,8,0,0,8,8,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,8,8,8,8,8,52,8,8,8,8,8,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,8,8,8,8,55,8,8,0,8,8,8,8,55,8,0,0,0,8,8,8,55,8,8,0,0,8,8,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,8,8,8,8,52,8,8,0,8,8,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,8,8,8,8,8,23,8,8,8,8,8,8,8,23,8,0,0,0,8,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,8,8,8,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,8,8,8,8,23,8,8,0,8,8,8,8,23,8,0,0,0,8,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,8,8,8,8,20,8,8,0,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,8,8,8,8,8,119,8,8,8,8,8,8,8,119,8,0,0,0,8,8,8,119,8,8,0,0,8,8,8,119,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,8,8,8,8,8,246,8,8,8,8,8,8,8,246,8,0,0,0,8,8,8,246,8,8,0,0,8,8,8,246,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,8,8,8,8,119,8,8,0,8,8,8,8,119,8,0,0,0,8,8,8,119,8,8,0,0,8,8,8,119,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,8,8,8,8,246,8,8,0,8,8,8,8,246,8,0,0,0,8,8,8,246,8,8,0,0,8,8,8,246,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,8,0,0,0,8,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,8,8,8,8,8,23,8,8,8,8,8,8,8,23,8,0,0,0,8,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,8,8,8,8,8,22,8,8,8,8,8,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,8,8,8,8,23,8,8,0,8,8,8,8,23,8,0,0,0,8,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,8,8,8,8,22,8,8,0,8,8,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,8,8,8,8,8,55,8,8,8,8,8,8,8,55,8,0,0,0,8,8,8,55,8,8,0,0,8,8,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,8,8,8,8,8,54,8,8,8,8,8,8,8,54,8,0,0,0,8,8,8,54,8,8,0,0,8,8,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,8,8,8,8,55,8,8,0,8,8,8,8,55,8,0,0,0,8,8,8,55,8,8,0,0,8,8,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,8,8,8,8,54,8,8,0,8,8,8,8,54,8,0,0,0,8,8,8,54,8,8,0,0,8,8,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,8,8,8,8,8,23,8,8,8,8,8,8,8,23,8,0,0,0,8,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,8,8,8,8,8,22,8,8,8,8,8,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,8,8,8,8,23,8,8,0,8,8,8,8,23,8,0,0,0,8,8,8,23,8,8,0,0,8,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,8,8,8,8,22,8,8,0,8,8,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,247,8,8,0,0,0,8,8,247,8,0,0,0,0,8,8,247,8,8,0,0,0,8,8,247,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,8,8,8,8,8,118,8,8,8,8,8,8,8,118,8,0,0,0,8,8,8,118,8,8,0,0,8,8,8,118,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,8,8,8,8,8,244,8,8,8,8,8,8,8,244,8,0,0,0,8,8,8,244,8,8,0,0,8,8,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,8,8,247,8,8,0,0,0,8,8,247,8,0,0,0,0,8,8,247,8,8,0,0,0,8,8,247,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,8,0,0,0,0,8,119,8,0,0,8,8,8,8,118,8,8,0,8,8,8,8,118,8,0,0,0,8,8,8,118,8,8,0,0,8,8,8,118,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,0,0,0,0,8,246,8,0,0,8,8,8,8,244,8,8,0,8,8,8,8,244,8,0,0,0,8,8,8,244,8,8,0,0,8,8,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,8,0,0,0,8,8,116,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,8,8,8,8,8,22,8,8,8,8,8,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,8,8,8,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,8,8,8,8,22,8,8,0,8,8,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,8,8,8,8,20,8,8,0,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,8,8,8,8,8,54,8,8,8,8,8,8,8,54,8,0,0,0,8,8,8,54,8,8,0,0,8,8,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,8,8,8,8,8,52,8,8,8,8,8,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,8,8,8,8,54,8,8,0,8,8,8,8,54,8,0,0,0,8,8,8,54,8,8,0,0,8,8,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,8,8,8,8,52,8,8,0,8,8,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,0,0,0,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,8,8,8,8,8,22,8,8,8,8,8,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,8,8,8,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,8,8,8,8,22,8,8,0,8,8,8,8,22,8,0,0,0,8,8,8,22,8,8,0,0,8,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,8,8,8,8,20,8,8,0,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,0,0,0,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,119,8,8,0,0,0,8,8,119,8,0,0,0,0,8,8,119,8,8,0,0,0,8,8,119,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,8,8,246,8,8,0,0,0,8,8,246,8,0,0,0,0,8,8,246,8,8,0,0,0,8,8,246,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,8,8,8,8,8,116,8,8,8,8,8,8,8,116,8,0,0,0,8,8,8,116,8,8,0,0,8,8,8,116,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,8,8,8,8,8,244,8,8,8,8,8,8,8,244,8,0,0,0,8,8,8,244,8,8,0,0,8,8,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,8,8,119,8,8,0,0,0,8,8,119,8,0,0,0,0,8,8,119,8,8,0,0,0,8,8,119,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,8,0,0,0,0,8,247,8,0,0,0,0,8,8,246,8,8,0,0,0,8,8,246,8,0,0,0,0,8,8,246,8,8,0,0,0,8,8,246,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,0,0,0,0,8,118,8,0,0,8,8,8,8,116,8,8,0,8,8,8,8,116,8,0,0,0,8,8,8,116,8,8,0,0,8,8,8,116,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,8,0,0,0,0,8,244,8,0,0,8,8,8,8,244,8,8,0,8,8,8,8,244,8,0,0,0,8,8,8,244,8,8,0,0,8,8,8,244,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,8,0,0,0,0,8,116,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,8,8,8,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,8,8,8,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,8,8,8,8,20,8,8,0,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,8,8,8,8,20,8,8,0,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,8,8,8,8,8,52,8,8,8,8,8,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,8,8,8,8,8,52,8,8,8,8,8,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,8,0,0,0,8,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,8,0,0,0,0,8,55,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,8,0,0,0,8,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,0,0,0,0,8,54,8,0,0,8,8,8,8,52,8,8,0,8,8,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,8,8,8,8,52,8,8,0,8,8,8,8,52,8,0,0,0,8,8,8,52,8,8,0,0,8,8,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,8,0,0,0,0,8,52,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,8,8,8,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,8,8,8,8,8,20,8,8,8,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,0,0,0,8,8,23,8,0,0,0,0,0,8,23,8,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+655876);allocate([8,23,8,0,0,0,0,0,8,23,8,8,0,0,0,0,8,23,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,0,0,0,8,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,0,0,0,0,8,22,8,0,0,8,8,8,8,20,8,8,0,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,8,8,8,8,20,8,8,0,8,8,8,8,20,8,0,0,0,8,8,8,20,8,8,0,0,8,8,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,8,0,0,0,0,8,20,8,0,16,16,16,16,16,239,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,111,16,16,0,0,0,0,16,104,16,0,16,16,16,16,16,47,16,0,0,0,0,0,16,40,16,16,0,16,16,16,16,238,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,110,16,16,0,0,0,0,16,104,16,0,0,16,16,16,16,46,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,238,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,110,16,16,0,0,0,0,16,104,16,0,16,16,16,16,16,46,16,0,0,0,0,0,16,40,16,16,0,16,16,16,16,239,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,111,16,16,0,0,0,0,16,104,16,0,0,16,16,16,16,47,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,108,16,16,0,0,0,0,16,104,16,0,16,16,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,16,16,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,108,16,16,0,0,0,0,16,104,16,0,0,16,16,16,16,44,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,108,16,16,0,0,0,0,16,104,16,0,16,16,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,16,16,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,108,16,16,0,0,0,0,16,104,16,0,0,16,16,16,16,44,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,232,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,239,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,16,16,16,16,16,40,16,0,0,16,16,16,16,232,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,238,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,0,16,16,16,16,40,16,0,16,16,16,16,16,232,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,238,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,16,16,16,16,16,40,16,0,0,16,16,16,16,232,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,239,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,0,16,16,16,16,40,16,0,16,16,16,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,16,16,16,16,16,40,16,0,0,16,16,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,16,16,16,16,40,16,0,16,16,16,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,16,16,16,16,16,40,16,0,0,16,16,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,16,16,16,16,40,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,239,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,111,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,238,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,110,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,238,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,110,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,239,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,111,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,239,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,232,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,238,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,232,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,238,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,232,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,239,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,232,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,104,16,16,0,0,0,0,16,44,16,0,16,16,16,16,16,239,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,47,16,16,0,0,0,0,16,40,16,0,0,16,16,16,16,238,16,0,0,0,0,0,16,232,16,16,0,16,16,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,46,16,16,0,0,0,0,16,40,16,0,16,16,16,16,16,238,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,46,16,16,0,0,0,0,16,40,16,0,0,16,16,16,16,239,16,0,0,0,0,0,16,232,16,16,0,16,16,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,47,16,16,0,0,0,0,16,40,16,0,16,16,16,16,16,236,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,16,16,16,16,236,16,0,0,0,0,0,16,232,16,16,0,16,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,16,16,16,16,16,236,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,16,16,16,16,236,16,0,0,0,0,0,16,232,16,16,0,16,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,16,16,16,16,16,16,232,16,0,16,16,16,16,16,40,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,46,16,16,0,16,16,16,16,232,16,0,0,16,16,16,16,40,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,16,16,16,16,16,232,16,0,16,16,16,16,16,40,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,47,16,16,0,16,16,16,16,232,16,0,0,16,16,16,16,40,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,44,16,16,16,16,16,16,16,232,16,0,16,16,16,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,16,16,16,16,232,16,0,0,16,16,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,16,16,16,16,16,232,16,0,16,16,16,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,16,16,16,16,232,16,0,0,16,16,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,16,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,239,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,104,16,16,0,0,16,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,238,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,104,16,16,0,0,16,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,238,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,104,16,16,0,0,16,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,239,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,104,16,16,0,0,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,16,16,16,40,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,0,0,16,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,47,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,0,0,16,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,0,0,16,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,0,0,16,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,47,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,16,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,16,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,16,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,104,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,16,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,104,16,0,0,0,0,16,16,239,16,16,0,0,0,0,16,232,16,0,16,16,16,16,16,47,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,111,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,238,16,16,0,0,0,0,16,232,16,0,0,16,16,16,16,46,16,0,0,0,0,0,16,40,16,16,0,16,16,16,16,110,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,238,16,16,0,0,0,0,16,232,16,0,16,16,16,16,16,46,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,110,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,239,16,16,0,0,0,0,16,232,16,0,0,16,16,16,16,47,16,0,0,0,0,0,16,40,16,16,0,16,16,16,16,111,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,236,16,16,0,0,0,0,16,232,16,0,16,16,16,16,16,44,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,236,16,16,0,0,0,0,16,232,16,0,0,16,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,16,16,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,236,16,16,0,0,0,0,16,232,16,0,16,16,16,16,16,44,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,236,16,16,0,0,0,0,16,232,16,0,0,16,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,16,16,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,232,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,239,16,16,16,16,16,16,16,40,16,0,16,16,16,16,16,104,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,238,16,16,0,16,16,16,16,40,16,0,0,16,16,16,16,104,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,238,16,16,16,16,16,16,16,40,16,0,16,16,16,16,16,104,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,239,16,16,0,16,16,16,16,40,16,0,0,16,16,16,16,104,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,16,16,16,16,16,40,16,0,16,16,16,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,16,16,16,16,40,16,0,0,16,16,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,16,16,16,16,16,40,16,0,16,16,16,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,16,16,16,16,40,16,0,0,16,16,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,239,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,111,16,16,0,0,0,0,16,104,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,238,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,110,16,16,0,0,0,0,16,104,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,238,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,110,16,16,0,0,0,0,16,104,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,239,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,111,16,16,0,0,0,0,16,104,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,0,16,16,236,16,16,0,0,0,0,16,232,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,40,16,16,0,0,16,16,16,108,16,16,0,0,0,0,16,104,16,0,0,0,0,0,16,239,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,104,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,238,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,104,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,238,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,110,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,104,16,16,0,0,0,0,16,46,16,0,0,0,0,0,16,239,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,111,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,104,16,16,0,0,0,0,16,47,16,0,0,0,0,0,16,236,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,236,16,16,0,0,16,16,16,40,16,0,0,0,0,16,16,232,16,16,0,0,0,0,16,44,16,0,0,0,0,0,16,108,16,16,0,0,0,16,16,40,16,0,0,0,16,16,16,104,16,16,0,0,0,0,16,44,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,47,16,16,0,0,0,0,16,40,16,0,16,16,16,16,16,111,16,0,0,0,0,0,16,104,16,16,16,16,16,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,46,16,16,0,0,0,0,16,40,16,0,0,16,16,16,16,110,16,0,0,0,0,0,16,104,16,16,0,16,16,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,46,16,16,0,0,0,0,16,40,16,0,16,16,16,16,16,110,16,0,0,0,0,0,16,104,16,16,16,16,16,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,47,16,16,0,0,0,0,16,40,16,0,0,16,16,16,16,111,16,0,0,0,0,0,16,104,16,16,0,16,16,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,16,16,16,16,16,108,16,0,0,0,0,0,16,104,16,16,16,16,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,16,16,16,16,108,16,0,0,0,0,0,16,104,16,16,0,16,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,16,16,16,16,16,108,16,0,0,0,0,0,16,104,16,16,16,16,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,16,16,16,16,108,16,0,0,0,0,0,16,104,16,16,0,16,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,16,16,16,16,16,104,16,0,16,16,16,16,16,40,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,46,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,0,16,16,16,16,104,16,0,0,16,16,16,16,40,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,16,16,16,16,16,104,16,0,16,16,16,16,16,40,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,47,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,0,16,16,16,16,104,16,0,0,16,16,16,16,40,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,16,16,16,16,16,104,16,0,16,16,16,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,16,16,16,16,104,16,0,0,16,16,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,16,16,16,16,16,104,16,0,16,16,16,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,232,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,16,16,16,16,104,16,0,0,16,16,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,232,16,16,0,0,16,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,111,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,232,16,16,0,0,16,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,110,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,232,16,16,0,0,16,16,16,46,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,110,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,232,16,16,0,0,16,16,16,47,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,111,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,0,16,16,236,16,0,0,0,0,0,16,232,16,16,0,0,16,16,16,44,16,16,0,0,0,0,16,40,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,104,16,16,0,0,0,16,16,40,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,47,16,16,0,0,16,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,0,0,16,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,238,16,0,0,0,0,0,16,46,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,110,16,0,0,0,0,0,16,46,16,16,0,0,16,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,239,16,0,0,0,0,0,16,47,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,111,16,0,0,0,0,0,16,47,16,16,0,0,16,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,16,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,16,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,16,16,16,104,16,0,0,0,0,16,16,40,16,16,0,0,0,0,16,236,16,0,0,0,0,0,16,44,16,16,0,0,0,16,16,232,16,0,0,0,16,16,16,40,16,16,0,0,0,0,16,108,16,0,0,0,0,0,16,44,16,16,0,0,16,16,16,104,16,0,32,32,32,32,32,223,32,32,0,0,32,32,32,208,32,0,32,32,32,32,32,222,32,32,0,0,32,32,32,208,32,0,32,32,32,32,32,220,32,32,0,0,32,32,32,208,32,0,32,32,32,32,32,220,32,32,0,0,32,32,32,208,32,0,32,32,32,32,32,216,32,32,0,0,32,32,32,208,32,0,32,32,32,32,32,216,32,32,0,0,32,32,32,208,32,0,32,32,32,32,32,216,32,32,0,0,32,32,32,208,32,0,32,32,32,32,32,216,32,32,0,0,32,32,32,208,32,0,32,32,32,32,32,208,32,32,32,32,32,32,32,223,32,0,32,32,32,32,32,208,32,32,32,32,32,32,32,222,32,0,32,32,32,32,32,208,32,32,32,32,32,32,32,220,32,0,32,32,32,32,32,208,32,32,32,32,32,32,32,220,32,0,32,32,32,32,32,208,32,32,32,32,32,32,32,216,32,0,32,32,32,32,32,208,32,32,32,32,32,32,32,216,32,0,32,32,32,32,32,208,32,32,32,32,32,32,32,216,32,0,32,32,32,32,32,208,32,32,32,32,32,32,32,216,32,0,0,0,32,32,32,222,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,223,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,220,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,220,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,222,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,223,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,220,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,220,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,216,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,216,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,216,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,216,32,0,32,32,32,32,32,95,32,32,0,0,32,32,32,80,32,0,32,32,32,32,32,94,32,32,0,0,32,32,32,80,32,0,32,32,32,32,32,92,32,32,0,0,32,32,32,80,32,0,32,32,32,32,32,92,32,32,0,0,32,32,32,80,32,0,32,32,32,32,32,88,32,32,0,0,32,32,32,80,32,0,32,32,32,32,32,88,32,32,0,0,32,32,32,80,32,0,32,32,32,32,32,88,32,32,0,0,32,32,32,80,32,0,32,32,32,32,32,88,32,32,0,0,32,32,32,80,32,0,32,32,32,32,32,80,32,32,32,32,32,32,32,95,32,0,32,32,32,32,32,80,32,32,32,32,32,32,32,94,32,0,32,32,32,32,32,80,32,32,32,32,32,32,32,92,32,0,32,32,32,32,32,80,32,32,32,32,32,32,32,92,32,0,32,32,32,32,32,80,32,32,32,32,32,32,32,88,32,0,32,32,32,32,32,80,32,32,32,32,32,32,32,88,32,0,32,32,32,32,32,80,32,32,32,32,32,32,32,88,32,0,32,32,32,32,32,80,32,32,32,32,32,32,32,88,32,0,0,0,32,32,32,94,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,95,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,92,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,92,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,94,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,95,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,92,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,92,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,88,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,88,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,88,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,88,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,80,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+666116);allocate([32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,32,32,223,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,222,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,222,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,223,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,208,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,95,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,94,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,94,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,95,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,80,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,223,32,32,0,0,0,0,32,208,32,0,0,0,32,32,32,222,32,32,0,0,0,0,32,208,32,0,0,0,32,32,32,220,32,32,0,0,0,0,32,208,32,0,0,0,32,32,32,220,32,32,0,0,0,0,32,208,32,0,0,0,32,32,32,216,32,32,0,0,0,0,32,208,32,0,0,0,32,32,32,216,32,32,0,0,0,0,32,208,32,0,0,0,32,32,32,216,32,32,0,0,0,0,32,208,32,0,0,0,32,32,32,216,32,32,0,0,32,32,32,223,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,222,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,220,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,220,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,216,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,216,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,216,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,216,32,0,0,0,32,32,32,208,32,32,0,0,32,32,32,208,32,0,0,0,0,0,32,223,32,32,0,0,32,32,32,208,32,0,0,0,0,0,32,222,32,32,0,0,32,32,32,208,32,0,0,0,0,0,32,220,32,32,0,0,32,32,32,208,32,0,0,0,0,0,32,220,32,32,0,0,32,32,32,208,32,0,0,0,0,0,32,216,32,32,0,0,32,32,32,208,32,0,0,0,0,0,32,216,32,32,0,0,32,32,32,208,32,0,0,0,0,0,32,216,32,32,0,0,32,32,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,80,32,0,0,0,32,32,32,95,32,32,0,0,0,0,32,80,32,0,0,0,32,32,32,94,32,32,0,0,0,0,32,80,32,0,0,0,32,32,32,92,32,32,0,0,0,0,32,80,32,0,0,0,32,32,32,92,32,32,0,0,0,0,32,80,32,0,0,0,32,32,32,88,32,32,0,0,0,0,32,80,32,0,0,0,32,32,32,88,32,32,0,0,0,0,32,80,32,0,0,0,32,32,32,88,32,32,0,0,0,0,32,80,32,0,0,0,32,32,32,88,32,32,0,0,32,32,32,95,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,94,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,92,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,92,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,88,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,88,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,88,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,88,32,0,0,0,32,32,32,80,32,32,0,0,32,32,32,80,32,0,0,0,0,0,32,95,32,32,0,0,32,32,32,80,32,0,0,0,0,0,32,94,32,32,0,0,32,32,32,80,32,0,0,0,0,0,32,92,32,32,0,0,32,32,32,80,32,0,0,0,0,0,32,92,32,32,0,0,32,32,32,80,32,0,0,0,0,0,32,88,32,32,0,0,32,32,32,80,32,0,0,0,0,0,32,88,32,32,0,0,32,32,32,80,32,0,0,0,0,0,32,88,32,32,0,0,32,32,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,223,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,32,32,32,32,208,32,0,0,0,0,32,32,223,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,222,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,220,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,220,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,216,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,216,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,216,32,32,0,32,32,32,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,208,32,0,0,32,32,32,32,223,32,32,0,0,0,32,32,208,32,0,0,32,32,32,32,222,32,32,0,0,0,32,32,208,32,0,0,32,32,32,32,220,32,32,0,0,0,32,32,208,32,0,0,32,32,32,32,220,32,32,0,0,0,32,32,208,32,0,0,32,32,32,32,216,32,32,0,0,0,32,32,208,32,0,0,32,32,32,32,216,32,32,0,0,0,32,32,208,32,0,0,32,32,32,32,216,32,32,0,0,0,32,32,208,32,0,0,32,32,32,32,216,32,32,0,32,32,32,32,223,32,0,0,32,32,32,32,208,32,32,0,32,32,32,32,222,32,0,0,32,32,32,32,208,32,32,0,32,32,32,32,220,32,0,0,32,32,32,32,208,32,32,0,32,32,32,32,220,32,0,0,32,32,32,32,208,32,32,0,32,32,32,32,216,32,0,0,32,32,32,32,208,32,32,0,32,32,32,32,216,32,0,0,32,32,32,32,208,32,32,0,32,32,32,32,216,32,0,0,32,32,32,32,208,32,32,0,32,32,32,32,216,32,0,0,32,32,32,32,208,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,95,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,94,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,92,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,92,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,88,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,88,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,88,32,32,0,32,32,32,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,80,32,0,0,32,32,32,32,95,32,32,0,0,0,32,32,80,32,0,0,32,32,32,32,94,32,32,0,0,0,32,32,80,32,0,0,32,32,32,32,92,32,32,0,0,0,32,32,80,32,0,0,32,32,32,32,92,32,32,0,0,0,32,32,80,32,0,0,32,32,32,32,88,32,32,0,0,0,32,32,80,32,0,0,32,32,32,32,88,32,32,0,0,0,32,32,80,32,0,0,32,32,32,32,88,32,32,0,0,0,32,32,80,32,0,0,32,32,32,32,88,32,32,0,32,32,32,32,95,32,0,0,32,32,32,32,80,32,32,0,32,32,32,32,94,32,0,0,32,32,32,32,80,32,32,0,32,32,32,32,92,32,0,0,32,32,32,32,80,32,32,0,32,32,32,32,92,32,0,0,32,32,32,32,80,32,32,0,32,32,32,32,88,32,0,0,32,32,32,32,80,32,32,0,32,32,32,32,88,32,0,0,32,32,32,32,80,32,32,0,32,32,32,32,88,32,0,0,32,32,32,32,80,32,32,0,32,32,32,32,88,32,0,0,32,32,32,32,80,32,32,0,0,0,0,32,223,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,222,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,94,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,32,32,208,32,0,0,0,0,0,32,223,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,222,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,220,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,32,32,208,32,0,0,0,0,0,32,216,32,32,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,223,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,222,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,220,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,0,32,208,32,0,0,0,0,32,32,216,32,32,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,95,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,94,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,92,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,32,32,80,32,0,0,0,0,0,32,88,32,32,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,95,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,94,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,92,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,0,32,80,32,0,0,0,0,32,32,88,32,32,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,32,64,64,64,64,64,191,64,64,0,0,64,64,64,191,64,64,64,64,64,64,64,188,64,64,0,0,64,64,64,188,64,64,64,64,64,64,64,184,64,64,0,0,64,64,64,184,64,64,64,64,64,64,64,184,64,64,0,0,64,64,64,184,64,64,64,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,64,64,64,64,191,64,0,0,0,64,64,64,191,64,0,0,64,64,64,64,188,64,0,0,0,64,64,64,188,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,191,64,0,0,0,64,64,64,191,64,0,64,64,64,64,64,188,64,0,0,0,64,64,64,188,64,0,64,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,64,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,64,64,64,64,191,64,64,0,0,64,64,64,191,64,64,0,64,64,64,64,188,64,64,0,0,64,64,64,188,64,64,0,64,64,64,64,184,64,64,0,0,64,64,64,184,64,64,0,64,64,64,64,184,64,64,0,0,64,64,64,184,64,64,0,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,0,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,0,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,0,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,0,0,64,64,191,64,64,0,0,0,64,64,191,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,64,64,191,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,191,64,64,0,0,0,0,64,191,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,191,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,191,64,64,0,0,0,64,64,191,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,184,64,64,0,0,0,64],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+676356);allocate([64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,64,64,64,190,64,64,64,64,64,64,64,190,64,64,0,0,64,64,64,188,64,64,64,64,64,64,64,188,64,64,0,0,64,64,64,184,64,64,64,64,64,64,64,184,64,64,0,0,64,64,64,184,64,64,64,64,64,64,64,184,64,64,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,64,64,64,190,64,0,0,64,64,64,64,190,64,0,0,0,64,64,64,188,64,0,0,64,64,64,64,188,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,190,64,0,64,64,64,64,64,190,64,0,0,0,64,64,64,188,64,0,64,64,64,64,64,188,64,0,0,0,64,64,64,184,64,0,64,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,64,64,64,64,64,184,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,64,64,64,190,64,64,0,64,64,64,64,190,64,64,0,0,64,64,64,188,64,64,0,64,64,64,64,188,64,64,0,0,64,64,64,184,64,64,0,64,64,64,64,184,64,64,0,0,64,64,64,184,64,64,0,64,64,64,64,184,64,64,0,0,64,64,64,176,64,64,0,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,0,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,0,64,64,64,64,176,64,64,0,0,64,64,64,176,64,64,0,64,64,64,64,176,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,64,64,64,160,64,64,0,64,64,64,64,160,64,64,0,0,0,64,64,190,64,64,0,0,0,64,64,190,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,64,64,190,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,0,64,190,64,64,0,0,0,0,64,190,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,188,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,184,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,176,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,160,64,64,0,0,0,0,64,190,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,190,64,64,0,0,0,64,64,190,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,188,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,184,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,176,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,0,0,0,64,64,160,64,64,128,128,128,128,128,127,128,128,0,0,0,0,128,127,128,128,0,0,0,128,128,127,128,128,0,0,0,0,128,127,128,128,128,128,128,128,128,126,128,128,0,0,0,0,128,126,128,128,0,0,0,128,128,126,128,128,0,0,0,0,128,126,128,128,128,128,128,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,128,128,128,128,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,128,128,128,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,128,128,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,128,128,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,128,128,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,128,128,128,128,128,127,128,0,0,0,0,0,128,127,128,0,0,0,0,128,128,127,128,0,0,0,0,0,128,127,128,0,128,128,128,128,128,126,128,0,0,0,0,0,128,126,128,0,0,0,0,128,128,126,128,0,0,0,0,0,128,126,128,0,128,128,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,128,128,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,128,128,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,128,128,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,128,128,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,128,128,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,126,128,128,0,0,0,0,128,126,128,128,0,0,0,128,128,126,128,128,0,0,0,0,128,126,128,128,0,0,128,128,128,127,128,128,0,0,0,0,128,127,128,128,0,0,0,128,128,127,128,128,0,0,0,0,128,127,128,128,0,0,128,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,128,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+686596);allocate([128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,126,128,0,0,0,0,0,128,126,128,0,0,0,0,128,128,126,128,0,0,0,0,0,128,126,128,0,0,0,128,128,128,127,128,0,0,0,0,0,128,127,128,0,0,0,0,128,128,127,128,0,0,0,0,0,128,127,128,0,0,0,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,127,128,128,0,0,0,0,128,127,128,128,0,128,128,128,128,127,128,128,0,0,0,0,128,127,128,128,0,0,0,128,128,126,128,128,0,0,0,0,128,126,128,128,0,128,128,128,128,126,128,128,0,0,0,0,128,126,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,128,0,128,128,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,128,0,128,128,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,128,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,128,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,128,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,128,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,128,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,128,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,128,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,127,128,0,0,0,0,0,128,127,128,0,0,128,128,128,128,127,128,0,0,0,0,0,128,127,128,0,0,0,0,128,128,126,128,0,0,0,0,0,128,126,128,0,0,128,128,128,128,126,128,0,0,0,0,0,128,126,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,0,128,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,0,128,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,128,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,128,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,128,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,128,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,126,128,128,0,0,0,0,128,126,128,128,0,0,128,128,128,126,128,128,0,0,0,0,128,126,128,128,0,0,0,128,128,127,128,128,0,0,0,0,128,127,128,128,0,0,128,128,128,127,128,128,0,0,0,0,128,127,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,128,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,0,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,128,128,128,124,128,128,0,0,0,0,128,124,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,128,128,128,120,128,128,0,0,0,0,128,120,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,128,128,128,112,128,128,0,0,0,0,128,112,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,128,128,128,96,128,128,0,0,0,0,128,96,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,128,128,128,64,128,128,0,0,0,0,128,64,128,128,0,0,0,128,128,126,128,0,0,0,0,0,128,126,128,0,0,0,128,128,128,126,128,0,0,0,0,0,128,126,128,0,0,0,0,128,128,127,128,0,0,0,0,0,128,127,128,0,0,0,128,128,128,127,128,0,0,0,0,0,128,127,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+696836);allocate([128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,1,1,1,1,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,254,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,126,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,254,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,126,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,1,1,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,254,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,126,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,62,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+707076);allocate([1,6,1,0,0,0,0,1,1,62,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,1,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,1,1,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,30,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,1,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,14,1,0,0,0,0,0,1,6,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,254,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,126,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,1,1,1,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,254,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,254,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,126,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,126,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,62,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,62,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,1,1,1,6,1,0,0,0,0,0,1,30,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,30,1,0,0,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,1,1,1,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,6,1,0,0,0,0,0,1,14,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,1,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,1,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,1,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,1,1,2,1,0,0,0,0,0,1,2,1,0,0,0,1,1,1,2,1,0,0,0,0,0,1,2,1,2,2,2,2,2,2,253,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,61,2,0,0,0,0,0,2,125,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,253,2,0,0,0,0,2,2,61,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,125,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,253,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,253,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,61,2,0,0,0,0,0,2,253,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,253,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,125,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,253,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,125,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,2,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,2,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,125,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,253,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,253,2,0,0,0,2,2,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,125,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,125,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,253,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,253,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,61,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,125,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,253,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,125,2,0,0,0,2,2,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,253,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,125,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,253,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,125,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+717317);allocate([2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,253,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,61,2,0,0,0,0,0,2,125,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,253,2,0,0,0,0,2,2,61,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,125,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,253,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,125,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,253,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,125,2,0,0,0,0,0,2,125,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,61,2,0,0,0,0,0,2,253,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,253,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,125,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,253,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,125,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,253,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,253,2,0,0,2,2,2,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,125,2,0,0,2,2,2,2,125,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,2,2,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,253,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,61,2,0,0,2,2,2,2,253,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,61,2,0,0,2,2,2,2,61,2,0,0,0,0,0,2,125,2,0,0,0,0,0,2,125,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,2,2,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,125,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,253,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,125,2,0,0,2,2,2,2,61,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,253,2,0,0,0,0,0,2,61,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,2,2,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,61,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,125,2,0,0,0,0,0,2,61,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,253,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,61,2,0,0,2,2,2,2,125,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,61,2,0,0,0,0,0,2,253,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,29,2,0,0,0,0,0,2,29,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,29,2,0,0,2,2,2,2,29,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,29,2,0,0,0,0,0,2,29,2,0,0,0,0,0,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,5,2,0,0,0,0,2,2,13,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,5,2,0,0,0,0,0,2,5,2,0,0,0,0,0,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,13,2,0,0,2,2,2,2,13,2,0,0,0,0,2,2,5,2,0,0,0,0,0,2,5,2,0,0,2,2,2,2,13,2,0,0,0,0,0,2,13,2,0,0,0,0,0,2,5,2,4,4,4,4,4,4,251,4,0,0,0,0,4,4,123,4,0,4,4,4,4,4,251,4,0,0,0,0,4,4,123,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,4,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,59,4,0,0,0,0,4,4,59,4,0,4,4,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,4,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,123,4,0,0,0,0,4,4,251,4,0,4,4,4,4,4,123,4,0,0,0,0,4,4,251,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,4,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,59,4,0,0,0,0,4,4,59,4,0,4,4,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,4,4,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,4,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,123,4,0,0,0,0,4,4,251,4,0,0,0,4,4,4,123,4,0,0,0,0,4,4,251,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,0,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,251,4,0,0,0,0,4,4,123,4,0,0,0,4,4,4,251,4,0,0,0,0,4,4,123,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,0,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,122,4,4,4,4,4,4,4,250,4,0,0,0,0,4,4,122,4,0,4,4,4,4,4,250,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,26,4,4,4,4,4,4,4,26,4,0,0,0,0,4,4,26,4,0,4,4,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,58,4,4,4,4,4,4,4,58,4,0,0,0,0,4,4,58,4,0,4,4,4,4,4,58,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,26,4,4,4,4,4,4,4,26,4,0,0,0,0,4,4,26,4,0,4,4,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,250,4,4,4,4,4,4,4,122,4,0,0,0,0,4,4,250,4,0,4,4,4,4,4,122,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,26,4,4,4,4,4,4,4,26,4,0,0,0,0,4,4,26,4,0,4,4,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,58,4,4,4,4,4,4,4,58,4,0,0,0,0,4,4,58,4,0,4,4,4,4,4,58,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,26,4,4,4,4,4,4,4,26,4,0,0,0,0,4,4,26,4,0,4,4,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,4,4,4,4,10,4,0,0,0,0,4,4,250,4,0,0,0,4,4,4,122,4,0,0,0,0,4,4,250,4,0,0,0,4,4,4,122,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,58,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,122,4,0,0,0,4,4,4,250,4,0,0,0,0,4,4,122,4,0,0,0,4,4,4,250,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,58,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,4,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,4,4,4,4,59,4,0,0,0,0,4,4,59,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,27,4,0,0,0,0,4,4,27,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,251,4,0,0,0,0,4,4,123,4,0,0,4,4,4,4,251,4,0,0,0,0,4,4,123,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,27,4,0,0,0,0,4,4,27,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,4,4,4,4,59,4,0,0,0,0,4,4,59,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,27,4,0,0,0,0,4,4,27,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,123,4,0,0,0,0,4,4,251,4,0,0,4,4,4,4,123,4,0,0,0,0,4,4,251,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,4,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,4,4,4,4,27,4,0,0,0,0,4,4,27,4,4,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,4,4,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,0,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,123,4,0,0,0,0,4,4,251,4,0,0,0,4,4,4,123,4,0,0,0,0,4,4,251,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,0,4,4,4,59,4,0,0,0,0,4,4,59,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,251,4,0,0,0,0,4,4,123,4,0,0,0,4,4,4,251,4,0,0,0,0,4,4,123,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,27,4,0,0,0,0,4,4,27,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,4,4,4,11,4,0,0,0,0,4,4,11,4,0,0,0,0,4,4,58,4,0,0,4,4,4,4,58,4,0,0,0,0,4,4,58,4,0,0,4,4,4,4,58,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,10,4,0,0,0,0,4,4,122,4,0,0,4,4,4,4,250,4,0,0,0,0,4,4,122,4,0,0,4,4,4,4,250,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,10,4,0,0,0,0,4,4,58,4,0,0,4,4,4,4,58,4,0,0,0,0,4,4,58,4,0,0,4,4,4,4,58,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,10,4,0,0,0,0,4,4,250,4,0,0,4,4,4,4,122,4,0,0,0,0,4,4,250,4,0,0,4,4,4,4,122,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,4,4,4,4,26,4,0,0,0,0,4,4,10,4,4,4,4,4,4,4,10,4,0,0,0,0,4,4,10,4,0,4,4,4,4,4,10,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,58,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,250,4,0,0,0,4,4,4,122,4,0,0,0,0,4,4,250,4,0,0,0,4,4,4,122,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,58,4,0,0,0,0,4,4,58,4,0,0,0,4,4,4,58,4,0,0,0,0,4,4,10,4,0,0,0,4,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+727557);allocate([4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,122,4,0,0,0,4,4,4,250,4,0,0,0,0,4,4,122,4,0,0,0,4,4,4,250,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,26,4,0,0,0,4,4,4,26,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,4,4,10,4,0,0,0,4,4,4,10,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,59,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,123,4,0,0,0,0,0,4,251,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,27,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,11,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,58,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,250,4,0,0,0,0,0,4,122,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,26,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,0,0,0,0,0,4,10,4,8,8,8,8,8,8,247,8,0,0,8,8,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,0,8,8,247,8,8,8,8,8,8,8,246,8,0,0,8,8,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,246,8,8,8,8,8,8,8,244,8,0,0,8,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,8,8,8,8,8,8,244,8,0,0,8,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,23,8,0,0,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,8,8,8,8,8,22,8,0,0,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,8,8,8,8,8,8,55,8,0,0,8,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,8,8,8,8,8,8,54,8,0,0,8,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,8,8,8,8,8,8,52,8,0,0,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,8,8,8,8,8,52,8,0,0,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,8,8,23,8,0,0,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,8,8,8,8,8,22,8,0,0,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,8,8,8,8,8,8,119,8,0,0,8,8,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,0,8,8,119,8,8,8,8,8,8,8,118,8,0,0,8,8,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,0,8,8,118,8,8,8,8,8,8,8,116,8,0,0,8,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,8,8,8,8,8,8,116,8,0,0,8,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,8,8,23,8,0,0,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,8,8,8,8,8,22,8,0,0,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,8,8,8,8,8,8,55,8,0,0,8,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,8,8,8,8,8,8,54,8,0,0,8,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,8,8,8,8,8,8,52,8,0,0,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,8,8,8,8,8,8,52,8,0,0,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,8,8,8,8,8,8,23,8,0,0,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,8,8,8,8,8,8,22,8,0,0,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,8,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,8,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,8,8,8,55,8,0,0,0,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,54,8,0,0,0,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,8,8,8,23,8,0,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,0,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,8,8,8,247,8,0,0,0,8,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,8,8,8,246,8,0,0,0,8,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,8,8,8,244,8,0,0,0,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,244,8,0,0,0,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,23,8,0,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,0,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,8,8,8,55,8,0,0,0,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,54,8,0,0,0,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,8,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,8,8,8,23,8,0,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,0,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,8,8,8,119,8,0,0,0,8,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,8,8,8,118,8,0,0,0,8,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,8,8,8,116,8,0,0,0,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,116,8,0,0,0,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,8,8,8,23,8,0,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,0,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,8,8,8,8,8,244,8,0,0,8,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,8,8,8,8,8,244,8,0,0,8,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,8,8,8,8,8,247,8,0,0,8,8,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,0,8,8,247,8,0,8,8,8,8,8,246,8,0,0,8,8,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,8,8,8,8,8,23,8,0,0,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,8,8,8,8,8,22,8,0,0,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,8,8,8,8,8,52,8,0,0,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,8,8,8,8,8,52,8,0,0,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,8,8,8,8,8,55,8,0,0,8,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,8,8,8,8,8,54,8,0,0,8,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,8,8,8,8,8,23,8,0,0,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,8,8,8,8,8,22,8,0,0,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,8,8,8,8,8,116,8,0,0,8,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,8,8,8,8,8,116,8,0,0,8,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,8,8,8,8,8,119,8,0,0,8,8,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,0,8,8,119,8,0,8,8,8,8,8,118,8,0,0,8,8,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,8,8,8,8,8,23,8,0,0,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,8,8,8,8,8,22,8,0,0,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,8,8,8,8,8,52,8,0,0,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,8,8,8,8,8,52,8,0,0,8,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,8,8,8,8,8,55,8,0,0,8,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,8,8,8,8,8,54,8,0,0,8,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,8,8,8,8,8,20,8,0,0,8,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,8,8,8,8,8,23,8,0,0,8,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,8,8,8,8,8,22,8,0,0,8,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,8,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,55,8,0,0,0,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,54,8,0,0,0,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,23,8,0,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,0,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,8,8,8,244,8,0,0,0,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,244,8,0,0,0,8,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,0,8,8,244,8,0,0,0,8,8,8,247,8,0,0,0,8,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,0,8,8,247,8,0,0,0,8,8,8,246,8,0,0,0,8,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,0,8,8,246,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,23,8,0,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,0,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,247,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,246,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,0,0,8,244,8,0,0,0,8,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,8,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,0,8,8,52,8,0,0,0,8,8,8,55,8,0,0,0,8,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,0,8,8,55,8,0,0,0,8,8,8,54,8,0,0,0,8,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,8,8,54,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,23,8,0,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,0,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,55,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,54,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,0,0,8,52,8,0,0,0,8,8,8,116,8,0,0,0,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,116,8,0,0,0,8,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,0,8,8,116,8,0,0,0,8,8,8,119,8,0,0,0,8,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,0,8,8,119,8,0,0,0,8,8,8,118,8,0,0,0,8,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,0,8,8,118,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,23,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,22,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,0,0,8,20,8,0,0,0,8,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,20,8,0,0,0,8,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+737797);allocate([8,20,8,0,0,0,0,8,8,20,8,0,0,0,0,8,8,20,8,0,0,0,8,8,8,23,8,0,0,0,8,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,0,8,8,23,8,0,0,0,8,8,8,22,8,0,0,0,8,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,8,8,22,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,119,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,118,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,0,0,0,0,0,8,116,8,16,16,16,16,16,16,239,16,0,0,0,0,0,16,238,16,0,0,0,0,16,16,232,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,239,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,16,16,16,16,16,239,16,0,0,0,0,0,16,238,16,0,0,0,0,16,16,232,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,239,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,16,16,16,16,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,40,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,16,16,16,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,40,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,16,16,16,16,16,16,111,16,0,0,0,0,0,16,110,16,0,0,0,0,16,16,104,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,111,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,16,16,16,16,16,111,16,0,0,0,0,0,16,110,16,0,0,0,0,16,16,104,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,111,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,16,16,16,16,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,40,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,16,16,16,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,40,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,238,16,0,0,16,16,16,16,239,16,0,0,0,16,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,238,16,0,0,16,16,16,16,239,16,0,0,0,16,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,46,16,0,0,16,16,16,16,47,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,0,0,16,16,16,16,47,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,110,16,0,0,16,16,16,16,111,16,0,0,0,16,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,110,16,0,0,16,16,16,16,111,16,0,0,0,16,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,46,16,0,0,16,16,16,16,47,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,0,0,16,16,16,16,47,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,239,16,16,16,16,16,16,16,238,16,0,0,0,16,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,239,16,0,16,16,16,16,16,238,16,0,0,0,16,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,47,16,16,16,16,16,16,16,46,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,0,16,16,16,16,16,46,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,111,16,16,16,16,16,16,16,110,16,0,0,0,16,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,111,16,0,16,16,16,16,16,110,16,0,0,0,16,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,47,16,16,16,16,16,16,16,46,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,0,16,16,16,16,16,46,16,0,0,0,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,16,16,16,16,238,16,0,0,0,0,0,16,239,16,0,0,0,0,16,16,232,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,238,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,16,16,16,16,238,16,0,0,0,0,0,16,239,16,0,0,0,0,16,16,232,16,0,0,0,16,16,16,236,16,0,0,0,0,0,16,238,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,16,16,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,40,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,16,16,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,40,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,16,16,16,16,110,16,0,0,0,0,0,16,111,16,0,0,0,0,16,16,104,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,110,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,16,16,16,16,110,16,0,0,0,0,0,16,111,16,0,0,0,0,16,16,104,16,0,0,0,16,16,16,108,16,0,0,0,0,0,16,110,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,16,16,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,40,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,16,16,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,40,16,0,0,0,16,16,16,44,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,239,16,0,0,0,16,16,16,238,16,16,16,16,16,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,239,16,0,0,0,16,16,16,238,16,0,16,16,16,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,238,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,47,16,0,0,0,16,16,16,46,16,16,16,16,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,0,0,0,16,16,16,46,16,0,16,16,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,111,16,0,0,0,16,16,16,110,16,16,16,16,16,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,111,16,0,0,0,16,16,16,110,16,0,16,16,16,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,110,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,47,16,0,0,0,16,16,16,46,16,16,16,16,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,47,16,0,0,0,16,16,16,46,16,0,16,16,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,238,16,0,0,0,0,0,16,239,16,0,0,0,0,16,16,232,16,0,0,16,16,16,16,236,16,0,0,0,0,0,16,238,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,16,16,16,238,16,0,0,0,0,0,16,239,16,0,0,0,0,16,16,232,16,0,0,16,16,16,16,236,16,0,0,0,0,0,16,238,16,0,0,0,0,16,16,239,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,40,16,0,0,16,16,16,16,44,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,40,16,0,0,16,16,16,16,44,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,16,16,16,110,16,0,0,0,0,0,16,111,16,0,0,0,0,16,16,104,16,0,0,16,16,16,16,108,16,0,0,0,0,0,16,110,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,16,16,16,110,16,0,0,0,0,0,16,111,16,0,0,0,0,16,16,104,16,0,0,16,16,16,16,108,16,0,0,0,0,0,16,110,16,0,0,0,0,16,16,111,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,40,16,0,0,16,16,16,16,44,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,16,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,40,16,0,0,16,16,16,16,44,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,47,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,16,16,16,239,16,0,0,0,0,0,16,238,16,0,0,0,0,16,16,232,16,16,16,16,16,16,16,236,16,0,0,0,0,0,16,239,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,16,16,16,239,16,0,0,0,0,0,16,238,16,0,0,0,0,16,16,232,16,0,16,16,16,16,16,236,16,0,0,0,0,0,16,239,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,40,16,16,16,16,16,16,16,44,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,40,16,0,16,16,16,16,16,44,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,16,16,16,111,16,0,0,0,0,0,16,110,16,0,0,0,0,16,16,104,16,16,16,16,16,16,16,108,16,0,0,0,0,0,16,111,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,16,16,16,111,16,0,0,0,0,0,16,110,16,0,0,0,0,16,16,104,16,0,16,16,16,16,16,108,16,0,0,0,0,0,16,111,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,40,16,16,16,16,16,16,16,44,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,16,16,16,47,16,0,0,0,0,0,16,46,16,0,0,0,0,16,16,40,16,0,16,16,16,16,16,44,16,0,0,0,0,0,16,47,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,238,16,0,0,0,16,16,16,239,16,0,0,16,16,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,238,16,0,0,0,16,16,16,239,16,0,0,16,16,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,16,16,238,16,0,0,0,0,0,16,239,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,46,16,0,0,0,16,16,16,47,16,0,0,16,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,0,0,0,16,16,16,47,16,0,0,16,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,110,16,0,0,0,16,16,16,111,16,0,0,16,16,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,110,16,0,0,0,16,16,16,111,16,0,0,16,16,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,16,16,110,16,0,0,0,0,0,16,111,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,46,16,0,0,0,16,16,16,47,16,0,0,16,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,46,16,0,0,0,16,16,16,47,16,0,0,16,16,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,16,16,46,16,0,0,0,0,0,16,47,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,236,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,16,16,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,236,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,16,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,16,16,16,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,108,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,16,16,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,108,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,16,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,16,16,16,16,232,16,0,0,0,16,16,16,232,16,0,0,0,0,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,16,16,16,16,232,16,0,0,0,16,16,16,232,16,0,0,0,0,16,16,236,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,16,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,16,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,16,16,16,16,104,16,0,0,0,16,16,16,104,16,0,0,0,0,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,16,16,16,16,104,16,0,0,0,16,16,16,104,16,0,0,0,0,16,16,108,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,16,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,16,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,16,16,16,16,16,16,232,16,0,0,0,16,16,16,232,16,0,0,0,0,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,16,16,16,16,16,232,16,0,0,0,16,16,16,232,16,0,0,0,0,16,16,236,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,16,16,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,16,16,16,16,16,16,104,16,0,0,0,16,16,16,104,16,0,0,0,0,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,16,16,16,16,16,104,16,0,0,0,16,16,16,104,16,0,0,0,0,16,16,108,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,16,16,16,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,16,16,16,16,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,16,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,236,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,16,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,236,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,16,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,108,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,16,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,108,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,0,16,16,16,40,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,232,16,16,16,16,16,16,16,232,16,0,0,0,0,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,232,16,0,16,16,16,16,16,232,16,0,0,0,0,16,16,236,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,16,16,16,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,16,16,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,104,16,16,16,16,16,16,16,104,16,0,0,0,0,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,104,16,0,16,16,16,16,16,104,16,0,0,0,0,16,16,108,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,16,16,16,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,16,16,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,236,16,0,0,16,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,236,16,0,0,16,16,16,16,232,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,16,16,16,16,40,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,108,16,0,0,16,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,108,16,0,0,16,16,16,16,104,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,0,16,16,16,16,40,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,236,16,16,16,16,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,16,16,236,16,0,16,16,16,16,16,232,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,16,16,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,16,16,16,16,16,40,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,108,16,16,16,16,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,16,16,108,16,0,16,16,16,16,16,104,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,16,16,16,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,16,16,44,16,0,16,16,16,16,16,40,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,232,16,0,0,16,16,16,16,232,16,0,0,0,0,16,16,236,16,0,0,0,0,16,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,232,16,0,0,0,0,0,16,236,16,0,0,0,0,0,16,232,16,0,0,0,16,16,16,232,16,0,0,16,16,16,16,232,16,0,0,0,0,16,16,236,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,16,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,16,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,104,16,0,0,16,16,16,16,104,16,0,0,0,0,16,16,108,16,0,0,0,0,16,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,104,16,0,0,0,0,0,16,108,16,0,0,0,0,0,16,104,16,0,0,0,16,16,16,104,16,0,0,16,16,16,16,104,16,0,0,0,0,16,16,108,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,16,16,16,16,40,16,0,0,0,0,16,16,44,16,0,0,0,0,16,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,40,16,0,0,0,0,0,16,44,16,0,0,0,0,0,16,40,16,0,0,0,16,16,16,40,16,0,0,16,16,16,16,40,16,0,0,0,0,16,16,44,16,32,32,32,32,32,32,223,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,223,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,95,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,95,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,32,32,32,32,32,223,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,223,32,0,0,0,32,32,32,208,32,0,32,32,32,32,32,95,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,95,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,32,32,32,222,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,222,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,94,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,94,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,222,32,0,32,32,32,32,32,208,32,0,0,0,32,32,32,222,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,94,32,0,32,32,32,32,32,80,32,0,0,0,32,32,32,94,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,32,32,32,32,32,220,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,220,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,92,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,92,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,0,32,32,32,32,32,220,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,220,32,0,0,0,32,32,32,208,32,0,32,32,32,32,32,92,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,92,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,220,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,220,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,92,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,92,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,220,32,0,32,32,32,32,32,208,32,0,0,0,32,32,32,220,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,92,32,0,32,32,32,32,32,80,32,0,0,0,32,32,32,92,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+748037);allocate([32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,216,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,32,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,32,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,216,32,0,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,88,32,0,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,216,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,32,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,32,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,216,32,0,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,88,32,0,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,32,32,32,223,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,223,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,95,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,95,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,223,32,0,32,32,32,32,32,208,32,0,0,0,32,32,32,223,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,95,32,0,32,32,32,32,32,80,32,0,0,0,32,32,32,95,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,32,32,32,32,32,32,222,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,222,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,94,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,94,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,0,32,32,32,32,32,222,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,222,32,0,0,0,32,32,32,208,32,0,32,32,32,32,32,94,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,94,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,223,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,95,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,32,32,32,220,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,220,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,92,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,92,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,220,32,0,32,32,32,32,32,208,32,0,0,0,32,32,32,220,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,92,32,0,32,32,32,32,32,80,32,0,0,0,32,32,32,92,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,222,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,94,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,95,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,223,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,220,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,220,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,92,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,92,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,32,32,32,32,32,220,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,220,32,0,0,0,32,32,32,208,32,0,32,32,32,32,32,92,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,92,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,94,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,222,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,32,32,32,216,32,0,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,88,32,0,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,220,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,92,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,216,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,32,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,32,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,92,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,220,32,0,0,0,0,0,32,208,32,0,0,0,32,32,32,216,32,32,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,88,32,32,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,32,32,32,216,32,0,32,32,32,32,32,208,32,0,0,0,32,32,32,216,32,0,0,32,32,32,32,208,32,0,0,0,32,32,32,88,32,0,32,32,32,32,32,80,32,0,0,0,32,32,32,88,32,0,0,32,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,32,32,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,216,32,0,0,0,32,32,32,208,32,32,32,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,32,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,0,32,32,32,32,216,32,0,0,0,32,32,32,208,32,0,32,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,32,32,32,32,88,32,0,0,0,32,32,32,80,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,208,32,0,0,0,0,32,32,216,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,32,32,80,32,0,0,0,0,32,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,88,32,0,0,0,0,0,32,80,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,0,0,0,0,0,32,208,32,0,0,0,0,0,32,216,32,64,64,64,64,64,64,191,64,0,0,0,64,64,64,188,64,64,64,64,64,64,64,184,64,0,0,0,64,64,64,184,64,64,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,64,64,64,64,64,191,64,0,0,0,64,64,64,188,64,0,64,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,191,64,0,0,0,64,64,64,188,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,191,64,0,0,0,64,64,64,188,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,64,64,64,64,64,64,190,64,0,0,0,64,64,64,188,64,64,64,64,64,64,64,184,64,0,0,0,64,64,64,184,64,64,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,64,64,64,64,64,190,64,0,0,0,64,64,64,188,64,0,64,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,190,64,0,0,0,64,64,64,188,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,190,64,0,0,0,64,64,64,188,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+758277);allocate([64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,191,64,64,64,64,64,64,64,188,64,0,0,0,64,64,64,184,64,64,64,64,64,64,64,184,64,0,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,191,64,0,64,64,64,64,64,188,64,0,0,0,64,64,64,184,64,0,64,64,64,64,64,184,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,191,64,0,0,64,64,64,64,188,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,191,64,0,0,64,64,64,64,188,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,190,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,190,64,64,64,64,64,64,64,188,64,0,0,0,64,64,64,184,64,64,64,64,64,64,64,184,64,0,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,64,64,64,64,64,64,176,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,64,64,64,64,64,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,190,64,0,64,64,64,64,64,188,64,0,0,0,64,64,64,184,64,0,64,64,64,64,64,184,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,64,64,64,64,64,176,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,64,64,64,64,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,190,64,0,0,64,64,64,64,188,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,64,64,64,184,64,0,0,64,64,64,64,184,64,0,0,0,64,64,64,190,64,0,0,64,64,64,64,188,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,176,64,0,0,64,64,64,64,176,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,64,64,64,160,64,0,0,64,64,64,64,160,64,0,0,0,0,0,64,191,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,184,64,0,0,0,0,0,64,190,64,0,0,0,0,0,64,188,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,176,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,0,64,160,64,0,0,0,0,64,64,191,64,0,0,0,0,64,64,188,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,184,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,176,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,0,0,0,0,64,64,160,64,128,128,128,128,128,128,127,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,128,128,128,128,128,126,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,126,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,128,128,128,128,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,126,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,124,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,128,128,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,128,128,128,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,124,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,120,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,128,128,128,128,64,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,120,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,128,128,128,128,120,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,128,128,128,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,0,0,128,128,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,120,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,120,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,128,128,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,64,128,0,128,128,128,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,112,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,120,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,112,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,124,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,128,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,128,128,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,124,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,127,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,128,128,128,128,126,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,126,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,0,0,128,128,128,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,126,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,127,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,126,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,126,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,126,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,112,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,0,128,128,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,112,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,120,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,112,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+768517);allocate([128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,120,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,112,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,124,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,127,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,112,128,0,0,0,0,128,128,126,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,126,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,126,128,0,0,128,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,127,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,126,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,126,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,126,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,112,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,124,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,124,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,120,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,120,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,120,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,120,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,120,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,120,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,124,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,124,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,127,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,126,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,126,128,0,0,0,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,64,128,0,0,0,128,128,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,126,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,128,128,128,128,96,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,127,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,126,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,126,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,126,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,96,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,120,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,120,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,120,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,120,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,120,128,0,0,0,0,0,128,96,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,128,128,124,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,124,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,124,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,127,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,126,128,0,0,0,0,0,128,127,128,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,96,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,126,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,128,128,128,128,64,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,112,128,0,0,0,128,128,128,96,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,128,128,64,128,0,0,0,0,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+778757);allocate([128,127,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,96,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,0,0,0,0,128,128,126,128,0,0,0,128,128,128,112,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,127,128,0,0,0,0,128,128,64,128,0,128,128,128,128,128,64,128,0,0,0,0,0,128,96,128,0,0,0,0,0,128,64,128,0,0,0,128,128,128,112,128,0,0,0,0,128,128,96,128,0,0,0,0,0,128,126,128,0,0,0,0,0,128,112,128,128,128,128,128,128,128,64,128,0,0,0,0,128,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,0,128,64,128,0,0,0,0,128,128,96,128,0,0,128,128,128,128,64,128,0,0,0,0,0,128,112,128,0,0,0,0,0,128,96,128,1,1,1,1,1,1,1,254,0,0,1,1,1,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,1,1,1,1,1,1,30,0,0,1,1,1,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,1,1,1,126,0,0,0,0,0,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,254,0,0,0,0,1,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,1,1,1,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,1,1,1,1,126,0,0,0,0,0,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,30,0,0,1,1,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,1,1,1,1,1,1,62,0,0,1,1,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,254,0,0,0,0,1,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,1,1,1,62,0,0,0,0,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,1,1,1,1,254,0,0,0,1,1,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,62,0,0,1,1,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,1,1,1,1,1,1,30,0,0,1,1,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,1,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,62,0,0,0,0,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,1,1,1,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,1,1,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,30,0,0,1,1,1,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,1,1,1,1,1,1,254,0,0,1,1,1,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,62,0,0,0,0,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,1,1,1,254,0,0,0,0,1,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,1,1,1,1,62,0,0,0,1,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,126,0,0,1,1,1,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,1,1,1,1,1,1,30,0,0,1,1,1,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,1,1,1,254,0,0,0,0,0,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,126,0,0,0,0,1,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,1,1,1,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,1,1,1,1,254,0,0,0,0,0,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+788997);allocate([1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,30,0,0,1,1,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,1,1,1,1,1,1,62,0,0,1,1,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,126,0,0,0,0,1,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,1,1,1,62,0,0,0,0,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,1,1,1,1,126,0,0,0,1,1,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,62,0,0,1,1,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,1,1,1,1,1,1,30,0,0,1,1,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,1,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,62,0,0,0,0,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,1,1,1,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,1,1,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,30,0,0,1,1,1,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,1,1,1,1,1,1,126,0,0,1,1,1,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,62,0,0,0,0,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,1,1,1,126,0,0,0,0,1,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,1,1,1,1,62,0,0,0,1,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,1,1,1,1,1,1,14,0,0,1,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,254,0,0,0,0,0,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,0,1,1,126,0,0,0,0,1,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,254,0,0,0,0,0,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,0,1,1,126,0,0,0,1,1,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,254,0,0,0,0,0,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,254,0,0,0,0,0,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+799237);allocate([1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,62,0,0,0,0,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,62,0,0,0,1,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,0,1,1,254,0,0,0,0,0,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,0,1,1,254,0,0,0,0,0,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,126,0,0,0,0,0,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,0,1,1,254,0,0,0,0,1,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,126,0,0,0,0,0,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,254,0,0,0,0,0,0,1,126,0,0,0,0,0,1,1,254,0,0,0,1,1,1,1,126,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,126,0,0,0,0,0,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,126,0,0,0,0,0,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,62,0,0,0,0,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,62,0,0,0,1,1,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+809477);allocate([1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,0,1,1,126,0,0,0,0,0,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,0,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,30,0,0,0,0,0,1,1,30,0,0,0,0,0,0,1,126,0,0,0,0,0,0,1,254,0,0,0,0,0,1,1,126,0,0,0,0,0,1,1,254,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,62,0,0,0,0,0,1,1,62,0,0,0,0,0,0,1,30,0,0,0,0,0,0,1,30,0,0,0,0,0,1,1,30,0,0,0,1,1,1,1,30,0,0,0,0,0,0,1,62,0,0,0,0,0,0,1,62,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,1,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,1,1,1,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,14,0,0,0,1,1,1,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,0,1,14,0,0,0,0,0,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,1,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,1,1,1,1,1,1,6,0,0,1,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,1,1,1,1,2,0,0,0,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,6,0,0,0,0,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,1,1,1,1,6,0,0,0,0,0,1,1,6,0,0,0,0,0,0,1,6,0,0,0,0,0,0,1,6,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,1,1,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,1,2,2,2,2,2,2,2,2,253,0,0,0,0,0,0,2,125,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,253,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,125,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,125,0,0,0,0,2,2,2,125,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,253,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,253,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,125,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,125,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,253,0,0,0,0,0,0,2,125,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,253,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,125,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,125,0,0,0,0,2,2,2,125,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,253,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,253,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,125,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,125,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,61,0,0,0,0,0,0,2,61,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,61,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,61,0,0,0,0,0,0,2,61,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,61,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,125,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,125,0,0,0,0,2,2,2,125,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,253,0,0,0,0,0,0,2,125,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,253,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,125,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,125,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,253,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,253,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,125,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,125,0,0,0,0,2,2,2,125,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,253,0,0,0,0,0,0,2,125,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,253,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,125,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,125,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,253,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,253,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,253,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,61,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,61,0,0,0,0,0,0,2,61,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,61,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,61,0,0,0,0,0,0,2,61,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,61,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+819717);allocate([2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,29,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,253,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,253,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,2,2,2,2,2,2,2,5,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,253,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,253,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,2,2,2,2,2,2,5,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,61,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,61,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,13,0,0,0,0,0,0,2,253,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,253,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,0,0,0,0,0,0,2,253,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,253,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,125,0,0,0,0,0,0,2,125,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,253,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,13,0,0,0,0,0,0,2,61,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,0,0,0,0,0,0,2,61,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,61,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,61,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,2,2,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,2,2,2,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,2,2,2,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,2,2,2,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,29,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,5,0,0,0,0,0,0,2,5,0,0,0,2,2,2,2,13,0,0,0,0,0,0,2,13,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,2,2,2,13,0,0,0,0,0,0,2,5,0,0,0,0,2,2,2,5,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,13,0,0,0,0,0,0,2,29,0,0,0,0,0,2,2,5,0,0,0,0,0,0,2,5,4,4,4,4,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,4,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,4,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,4,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,4,4,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,4,4,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,4,4,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,4,4,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,4,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,4,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,4,4,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,4,4,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+829958);allocate([4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,4,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,4,4,4,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,251,0,0,0,0,0,0,4,27,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,4,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,4,4,4,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,4,4,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,250,4,4,4,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,4,4,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,123,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,4,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,4,4,4,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,4,4,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,4,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,122,0,0,0,0,0,0,4,26,4,4,4,4,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,4,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,4,4,4,4,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,4,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,4,4,4,4,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,4,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,4,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,4,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,4,4,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,4,4,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,4,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,4,4,4,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,123,0,0,0,0,0,0,4,27,4,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,4,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,4,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,4,4,4,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,122,0,0,4,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,4,4,4,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,251,4,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,4,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,4,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,4,4,4,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,4,4,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,4,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,250,0,0,0,0,0,0,4,26,0,0,4,4,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,4,4,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,4,4,4,4,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,4,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,4,4,4,4,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,4,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,4,4,4,4,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,4,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,4,4,4,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,4,4,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,251,0,0,0,0,0,0,4,27,4,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,4,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,4,4,4,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,250,0,0,4,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,4,4,4,4,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,123,4,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,4,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,251,0,0,0,0,0,0,4,27,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,4,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,4,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,4,4,4,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,250,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+840198);allocate([4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,4,4,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,122,0,0,0,0,0,0,4,26,0,0,4,4,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,4,4,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,4,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,4,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,4,4,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,4,4,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,4,4,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,4,4,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,4,4,4,4,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,4,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,4,4,4,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,4,4,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,123,0,0,0,0,0,0,4,27,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,4,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,4,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,4,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,4,4,4,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,4,4,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,4,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,122,4,4,4,4,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,251,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,4,4,59,0,0,4,4,4,4,4,27,0,0,0,0,0,0,4,251,0,0,0,0,4,4,4,27,0,0,0,0,0,0,4,251,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,4,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,4,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,59,0,0,0,0,0,0,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,123,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,0,0,0,4,59,0,0,0,0,0,4,4,27,0,0,0,4,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,0,4,4,4,123,0,0,0,0,0,0,4,27,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,0,4,4,10,0,0,0,4,4,4,4,10,0,0,0,0,0,0,4,10,0,0,0,0,4,4,4,10,0,0,0,0,0,0,4,10,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,4,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,4,4,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,122,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,4,4,58,0,4,4,4,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,0,4,4,4,26,0,0,0,0,0,0,4,122,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,0,4,4,11,0,0,0,4,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,0,4,4,4,11,0,0,0,0,0,0,4,11,0,0,0,4,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,58,0,0,0,0,0,0,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,250,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,0,0,0,4,58,0,0,0,0,0,4,4,26,0,0,0,4,4,4,4,250,0,0,0,0,0,0,4,26,0,0,0,0,4,4,4,250,0,0,0,0,0,0,4,26,8,8,8,8,8,8,8,247,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,8,8,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,8,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,8,8,8,8,8,247,0,0,0,0,8,8,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,247,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,119,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,8,8,8,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,8,8,8,8,8,8,22,0,0,0,0,8,8,8,118,0,0,8,8,8,8,8,22,0,0,0,0,8,8,8,246,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,8,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,8,8,118,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,246,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,8,8,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,8,8,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,8,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,8,8,8,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,8,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,8,8,8,8,247,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,247,0,0,0,0,8,8,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,247,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,119,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,118,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,246,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,8,8,118,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,246,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,8,8,8,8,8,8,8,23,0,0,0,0,8,8,8,247,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,8,8,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,8,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,8,8,8,8,8,23,0,0,0,0,8,8,8,247,0,0,0,0,0,8,8,247,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,8,8,247,0,0,0,0,0,8,8,23,8,8,8,8,8,8,8,118,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,8,8,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,8,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,8,8,8,8,8,118,0,0,0,0,8,8,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,118,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,246,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,8,8,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,8,8,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,8,8,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,8,8,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,8,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,247,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,247,0,0,0,0,0,8,8,247,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,8,8,247,0,0,0,0,0,8,8,23,0,0,0,8,8,8,8,118,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,8,8,8,8,118,0,0,0,0,8,8,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,118,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,246,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,8,8,8,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,8,8,8,8,8,8,247,0,0,0,0,8,8,8,23,0,0,8,8,8,8,8,119,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,8,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,247,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,247,8,8,8,8,8,8,8,22,0,0,0,0,8,8,8,118,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,8,8,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,8,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,8,8,8,8,8,22,0,0,0,0,8,8,8,118,0,0,0,0,0,8,8,118,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,8,8,118,0,0,0,0,0,8,8,22,8,8,8,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,8,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,8,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,8,8,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,8,8,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,247,0,0,0,0,8,8,8,23,0,0,0,8,8,8,8,119,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,247,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,247,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,118,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,118,0,0,0,0,0,8,8,118,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,8,8,118,0,0,0,0,0,8,8,22,0,0,0,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+850438);allocate([8,52,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,8,8,8,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,8,8,8,8,8,8,23,0,0,0,0,8,8,8,247,0,0,8,8,8,8,8,23,0,0,0,0,8,8,8,119,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,8,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,8,8,247,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,119,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,8,8,8,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,8,8,8,8,8,8,118,0,0,0,0,8,8,8,22,0,0,8,8,8,8,8,246,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,8,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,118,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,118,8,8,8,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,8,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,8,8,8,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,8,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,8,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,247,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,119,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,8,8,247,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,119,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,8,8,8,8,118,0,0,0,0,8,8,8,22,0,0,0,8,8,8,8,246,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,118,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,118,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,8,8,8,8,8,8,8,119,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,8,8,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,8,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,8,8,8,8,8,119,0,0,0,0,8,8,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,119,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,247,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,8,8,8,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,8,8,8,8,8,8,22,0,0,0,0,8,8,8,246,0,0,8,8,8,8,8,22,0,0,0,0,8,8,8,118,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,8,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,8,8,246,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,118,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,8,8,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,8,8,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,8,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,8,8,8,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,8,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,8,8,8,8,119,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,119,0,0,0,0,8,8,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,119,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,247,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,246,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,118,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,8,8,246,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,118,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,8,8,8,8,8,8,8,23,0,0,0,0,8,8,8,119,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,8,8,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,8,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,8,8,8,8,8,23,0,0,0,0,8,8,8,119,0,0,0,0,0,8,8,119,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,8,8,119,0,0,0,0,0,8,8,23,8,8,8,8,8,8,8,246,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,8,8,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,8,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,8,8,8,8,8,246,0,0,0,0,8,8,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,246,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,118,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,8,8,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,8,8,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,8,8,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,8,8,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,8,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,119,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,119,0,0,0,0,0,8,8,119,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,8,8,119,0,0,0,0,0,8,8,23,0,0,0,8,8,8,8,246,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,8,8,8,8,246,0,0,0,0,8,8,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,246,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,118,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,8,8,8,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,8,8,8,8,8,8,119,0,0,0,0,8,8,8,23,0,0,8,8,8,8,8,247,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,8,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,119,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,119,8,8,8,8,8,8,8,22,0,0,0,0,8,8,8,246,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,8,8,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,8,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,8,8,8,8,8,22,0,0,0,0,8,8,8,246,0,0,0,0,0,8,8,246,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,8,8,246,0,0,0,0,0,8,8,22,8,8,8,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,8,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,8,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,8,8,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,8,8,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,119,0,0,0,0,8,8,8,23,0,0,0,8,8,8,8,247,0,0,0,0,8,8,8,23,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,55,0,0,0,0,8,8,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,119,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,55,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,119,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,246,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,54,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,8,8,8,8,22,0,0,0,0,8,8,8,246,0,0,0,0,0,8,8,246,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,8,8,246,0,0,0,0,0,8,8,22,0,0,0,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,8,8,8,8,116,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,8,8,8,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,8,8,8,8,8,8,23,0,0,0,0,8,8,8,119,0,0,8,8,8,8,8,23,0,0,0,0,8,8,8,247,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,8,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,8,8,119,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,247,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,8,8,8,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,8,8,8,8,8,8,246,0,0,0,0,8,8,8,22,0,0,8,8,8,8,8,118,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,8,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,246,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,246,8,8,8,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,8,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,8,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,8,8,8,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,8,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,8,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,8,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,119,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,247,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,8,8,8,8,23,0,0,0,0,8,8,8,55,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,8,8,119,0,0,0,0,0,8,8,23,0,0,0,0,0,8,8,247,0,0,0,0,0,8,8,23,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,8,8,55,0,0,0,0,0,8,8,23,0,0,0,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,119,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,8,8,8,8,246,0,0,0,0,8,8,8,22,0,0,0,8,8,8,8,118,0,0,0,0,8,8,8,22,0,0,0,0,0,0,8,55,0,0,0,0,0,0,8,23,0,0,0,0,0,0,8,247,0,0,0,0,0,0,8,23,0,0,0,8,8,8,8,54,0,0,0,0,8,8,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,246,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,54,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,118,0,0,0,0,0,0,8,22,0,0,0,0,0,8,8,22,0,0,0,0,0,8,8,246,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,52,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,246,0,0,0,0,0,0,8,22,0,0,0,0,0,0,8,54,0,0,0,8,8,8,8,20,0,0,0,0,8,8,8,116,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,8,8,20,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,116],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+860678);allocate([8,20,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,8,8,8,8,52,0,0,0,0,8,8,8,20,0,0,0,0,0,0,8,116,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,8,8,8,8,244,0,0,0,0,8,8,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,116,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,244,0,0,0,0,0,0,8,244,0,0,0,0,0,0,8,20,0,0,0,0,0,0,8,52,0,0,0,0,0,0,8,20,0,0,0,0,0,8,8,20,0,0,0,0,0,8,8,52,16,16,16,16,16,16,16,239,0,0,16,16,16,16,16,44,0,16,16,16,16,16,16,47,0,0,16,16,16,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,47,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,238,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,16,16,16,16,16,16,16,46,0,0,16,16,16,16,16,108,0,16,16,16,16,16,16,238,0,0,16,16,16,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,238,0,0,0,0,16,16,16,239,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,236,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,104,16,16,16,16,16,16,16,108,0,0,16,16,16,16,16,47,0,16,16,16,16,16,16,44,0,0,16,16,16,16,16,111,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,238,0,0,0,0,16,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,16,16,16,16,16,16,16,44,0,0,16,16,16,16,16,238,0,16,16,16,16,16,16,108,0,0,16,16,16,16,16,46,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,104,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,111,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,104,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,16,16,16,16,16,16,16,232,0,0,16,16,16,16,16,40,0,16,16,16,16,16,16,40,0,0,16,16,16,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,238,16,16,16,16,16,16,16,40,0,0,16,16,16,16,16,104,0,16,16,16,16,16,16,232,0,0,16,16,16,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,16,16,16,16,16,16,16,104,0,0,16,16,16,16,16,40,0,16,16,16,16,16,16,40,0,0,16,16,16,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,44,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,238,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,108,16,16,16,16,16,16,16,40,0,0,16,16,16,16,16,232,0,16,16,16,16,16,16,104,0,0,16,16,16,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,16,16,16,16,239,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,47,0,0,0,16,16,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,47,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,238,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,16,16,16,16,46,0,0,0,16,16,16,16,108,0,0,0,16,16,16,16,238,0,0,0,16,16,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,238,0,0,0,0,16,16,16,239,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,236,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,104,0,0,0,16,16,16,16,108,0,0,0,16,16,16,16,47,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,111,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,238,0,0,0,0,16,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,238,0,0,0,16,16,16,16,108,0,0,0,16,16,16,16,46,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,104,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,111,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,104,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,238,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,44,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,238,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,108,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,16,16,16,16,16,16,16,47,0,0,16,16,16,16,16,108,0,16,16,16,16,16,16,239,0,0,16,16,16,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,239,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,110,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,16,16,16,16,16,16,16,238,0,0,16,16,16,16,16,44,0,16,16,16,16,16,16,46,0,0,16,16,16,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,46,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,239,0,0,0,0,16,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,239,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,16,16,16,16,16,16,16,44,0,0,16,16,16,16,16,239,0,16,16,16,16,16,16,108,0,0,16,16,16,16,16,47,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,104,0,0,0,0,16,16,16,238,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,16,16,16,16,16,16,16,108,0,0,16,16,16,16,16,46,0,16,16,16,16,16,16,44,0,0,16,16,16,16,16,110,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,239,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,47,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,111,16,16,16,16,16,16,16,40,0,0,16,16,16,16,16,104,0,16,16,16,16,16,16,232,0,0,16,16,16,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,104,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,46,16,16,16,16,16,16,16,232,0,0,16,16,16,16,16,40,0,16,16,16,16,16,16,40,0,0,16,16,16,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,16,16,16,16,16,16,16,40,0,0,16,16,16,16,16,232,0,16,16,16,16,16,16,104,0,0,16,16,16,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,236,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,44,16,16,16,16,16,16,16,104,0,0,16,16,16,16,16,40,0,16,16,16,16,16,16,40,0,0,16,16,16,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,16,16,16,16,47,0,0,0,16,16,16,16,108,0,0,0,16,16,16,16,239,0,0,0,16,16,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,239,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,110,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,16,16,16,16,238,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,46,0,0,0,16,16,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,46,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,239,0,0,0,0,16,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,239,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,239,0,0,0,16,16,16,16,108,0,0,0,16,16,16,16,47,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,104,0,0,0,0,16,16,16,238,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,16,16,16,16,108,0,0,0,16,16,16,16,46,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,110,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,239,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,47,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,111,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,16,16,16,108,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,104,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,46,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,236,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,44,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,16,16,16,16,16,16,16,111,0,0,16,16,16,16,16,44,0,16,16,16,16,16,16,47,0,0,16,16,16,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,47,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,110,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,16,16,16,16,16,16,16,46,0,0,16,16,16,16,16,236,0,16,16,16,16,16,16,110,0,0,16,16,16,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,110,0,0,0,0,16,16,16,111,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,108,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,232,16,16,16,16,16,16,16,236,0,0,16,16,16,16,16,47,0,16,16,16,16,16,16,44,0,0,16,16,16,16,16,239,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,110,0,0,0,0,16,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,16,16,16,16,16,16,16,44,0,0,16,16,16,16,16,110,0,16,16,16,16,16,16,236,0,0,16,16,16,16,16,46,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,232,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,239,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,232,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,16,16,16,16,16,16,16,104,0,0,16,16,16,16,16,40,0,16,16,16,16,16,16,40,0,0,16,16,16,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,110,16,16,16,16,16,16,16,40,0,0,16,16,16,16,16,232,0,16,16,16,16,16,16,104,0,0,16,16,16,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,16,16,16,16,16,16,16,232,0,0,16,16,16,16,16,40,0,16,16,16,16,16,16,40,0,0,16,16,16,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,44,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,110,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,236,16,16,16,16,16,16,16,40,0,0,16,16,16,16,16,104,0,16,16,16,16,16,16,232,0,0,16,16,16,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+870918);allocate([16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,16,16,16,16,111,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,47,0,0,0,16,16,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,47,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,110,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,16,16,16,16,46,0,0,0,16,16,16,16,236,0,0,0,16,16,16,16,110,0,0,0,16,16,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,110,0,0,0,0,16,16,16,111,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,108,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,239,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,232,0,0,0,16,16,16,16,236,0,0,0,16,16,16,16,47,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,239,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,110,0,0,0,0,16,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,110,0,0,0,16,16,16,16,236,0,0,0,16,16,16,16,46,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,232,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,239,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,232,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,110,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,44,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,110,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,238,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,236,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,40,16,16,16,16,16,16,16,47,0,0,16,16,16,16,16,236,0,16,16,16,16,16,16,111,0,0,16,16,16,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,111,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,238,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,16,16,16,16,16,16,16,110,0,0,16,16,16,16,16,44,0,16,16,16,16,16,16,46,0,0,16,16,16,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,46,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,111,0,0,0,0,16,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,111,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,16,16,16,16,16,16,16,44,0,0,16,16,16,16,16,111,0,16,16,16,16,16,16,236,0,0,16,16,16,16,16,47,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,232,0,0,0,0,16,16,16,110,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,16,16,16,16,16,16,16,236,0,0,16,16,16,16,16,46,0,16,16,16,16,16,16,44,0,0,16,16,16,16,16,238,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,111,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,47,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,239,16,16,16,16,16,16,16,40,0,0,16,16,16,16,16,232,0,16,16,16,16,16,16,104,0,0,16,16,16,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,232,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,46,16,16,16,16,16,16,16,104,0,0,16,16,16,16,16,40,0,16,16,16,16,16,16,40,0,0,16,16,16,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,16,16,16,16,16,16,16,40,0,0,16,16,16,16,16,104,0,16,16,16,16,16,16,232,0,0,16,16,16,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,108,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,44,16,16,16,16,16,16,16,232,0,0,16,16,16,16,16,40,0,16,16,16,16,16,16,40,0,0,16,16,16,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,16,16,16,16,47,0,0,0,16,16,16,16,236,0,0,0,16,16,16,16,111,0,0,0,16,16,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,111,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,238,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,16,16,16,16,110,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,46,0,0,0,16,16,16,16,108,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,46,0,0,0,0,16,16,16,47,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,111,0,0,0,0,16,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,111,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,111,0,0,0,16,16,16,16,236,0,0,0,16,16,16,16,47,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,232,0,0,0,0,16,16,16,110,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,46,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,232,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,239,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,16,16,16,16,236,0,0,0,16,16,16,16,46,0,0,0,16,16,16,16,44,0,0,0,16,16,16,16,238,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,111,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,47,0,0,0,0,0,16,16,111,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,47,0,0,0,0,0,16,16,40,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,111,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,47,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,239,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,16,16,16,236,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,232,0,0,0,0,0,16,16,46,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,110,0,0,0,0,0,16,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,46,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,232,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,104,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,108,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,104,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,108,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,238,0,0,0,0,0,16,16,236,0,0,0,0,0,16,16,46,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,46,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,110,0,0,0,0,0,0,16,44,0,0,0,16,16,16,16,232,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,40,0,0,0,16,16,16,16,232,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,108,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,16,16,16,40,0,0,0,0,16,16,16,104,0,0,0,0,16,16,16,232,0,0,0,0,16,16,16,40,0,0,0,0,0,16,16,104,0,0,0,0,0,16,16,44,0,0,0,0,0,16,16,40,0,0,0,0,0,16,16,236,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,232,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,104,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,236,0,0,0,0,0,0,16,40,0,0,0,0,0,0,16,44,0,0,0,0,0,0,16,232,32,32,32,32,32,32,32,223,0,0,0,0,0,32,32,216,0,0,32,32,32,32,32,95,0,0,0,0,0,32,32,88,0,32,32,32,32,32,32,223,0,0,0,0,0,32,32,216,0,0,32,32,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,32,32,32,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,92,0,32,32,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,32,32,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,32,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,32,32,32,32,32,32,32,208,0,0,0,0,0,32,32,88,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,216,0,32,32,32,32,32,32,208,0,0,0,0,0,32,32,88,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,216,32,32,32,32,32,32,32,208,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,80,0,32,32,32,32,32,32,208,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,80,32,32,32,32,32,32,32,222,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,94,0,0,0,0,0,32,32,80,0,32,32,32,32,32,32,222,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,32,32,32,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,92,0,32,32,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,32,32,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,32,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+881158);allocate([32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,95,0,0,0,0,0,32,32,88,32,32,32,32,32,32,32,208,0,0,0,0,0,32,32,223,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,95,0,32,32,32,32,32,32,208,0,0,0,0,0,32,32,223,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,95,32,32,32,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,92,0,0,0,0,0,32,32,80,0,32,32,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,32,32,32,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,216,0,32,32,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,32,32,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,32,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,94,0,0,0,0,0,32,32,80,32,32,32,32,32,32,32,208,0,0,0,0,0,32,32,222,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,94,0,32,32,32,32,32,32,208,0,0,0,0,0,32,32,222,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,94,32,32,32,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,92,0,0,0,0,0,32,32,80,0,32,32,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,32,32,32,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,216,0,32,32,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,32,32,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,32,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,32,32,32,32,32,32,32,95,0,0,0,0,0,32,32,88,0,0,32,32,32,32,32,223,0,0,0,0,0,32,32,216,0,32,32,32,32,32,32,95,0,0,0,0,0,32,32,88,0,0,32,32,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,32,32,32,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,220,0,32,32,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,32,32,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,32,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,32,32,32,32,32,32,32,80,0,0,0,0,0,32,32,216,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,88,0,32,32,32,32,32,32,80,0,0,0,0,0,32,32,216,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,88,32,32,32,32,32,32,32,80,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,208,0,32,32,32,32,32,32,80,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,208,32,32,32,32,32,32,32,94,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,222,0,0,0,0,0,32,32,208,0,32,32,32,32,32,32,94,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,32,32,32,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,220,0,32,32,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,32,32,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,32,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,223,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,95,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,223,0,0,0,0,0,32,32,216,32,32,32,32,32,32,32,80,0,0,0,0,0,32,32,95,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,223,0,32,32,32,32,32,32,80,0,0,0,0,0,32,32,95,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,223,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,95,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,223,32,32,32,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,220,0,0,0,0,0,32,32,208,0,32,32,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,94,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,32,32,32,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,88,0,32,32,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,32,32,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,32,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,216,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,80,0,0,0,0,0,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+891398);allocate([32,216,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,88,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,222,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,94,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,222,0,0,0,0,0,32,32,208,32,32,32,32,32,32,32,80,0,0,0,0,0,32,32,94,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,222,0,32,32,32,32,32,32,80,0,0,0,0,0,32,32,94,0,0,32,32,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,223,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,95,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,222,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,94,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,222,32,32,32,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,220,0,0,0,0,0,32,32,208,0,32,32,32,32,32,32,92,0,0,0,0,0,32,32,80,0,0,32,32,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,92,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,220,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,32,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,32,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,220,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,92,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,92,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,220,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,32,32,32,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,88,0,32,32,32,32,32,32,208,0,0,0,0,0,32,32,216,0,0,32,32,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,0,0,0,0,32,32,32,208,0,0,0,0,0,32,32,216,0,0,0,0,32,32,32,80,0,0,0,0,0,32,32,88,32,32,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,32,32,32,32,32,32,216,0,0,0,0,0,32,32,208,0,0,32,32,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,0,0,32,208,0,0,0,0,0,0,32,88,0,0,0,0,0,0,32,80,0,0,0,0,0,0,32,216,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,0,0,0,0,32,32,32,216,0,0,0,0,0,32,32,208,0,0,0,0,32,32,32,88,0,0,0,0,0,32,32,80,64,64,64,64,64,64,64,191,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,190,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,176,64,64,64,64,64,64,64,190,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,191,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,176,64,64,64,64,64,64,64,188,0,0,0,0,64,64,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,191,0,64,64,64,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,191,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,188,0,0,0,0,64,64,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,190,0,64,64,64,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,190,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,184,0,0,0,0,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,188,0,64,64,64,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,184,0,0,0,0,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,188,0,64,64,64,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,184,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,64,64,64,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,184,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,64,64,64,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,176,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,64,64,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,176,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,64,64,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,64,64,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,64,64,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,64,64,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,64,64,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,64,64,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,64,64,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,190,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,191,0,0,0,0,0,64,64,160,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,190,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,190,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,191,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,191,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,191,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,190,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,188,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,188,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,184,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,184,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,64,64,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,64,64,64,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,64,64,64,64,191,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,190,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,176,0,0,0,64,64,64,64,190,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,191,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,176,0,0,0,64,64,64,64,188,0,0,0,0,64,64,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,191,0,0,0,64,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,191,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,188,0,0,0,0,64,64,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,190,0,0,0,64,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,190,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,184,0,0,0,0,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,188,0,0,0,64,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,184,0,0,0,0,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,188,0,0,0,64,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,184,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,0,64,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,184,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,0,64,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,0,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,0,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,190,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,191,0,0,0,0,0,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,190,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,190,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,191,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,191,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,191,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,190,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,188,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,188,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,184,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,184,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+901638);allocate([64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,191,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,190,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,190,0,0,0,0,64,64,64,176,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,190,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,191,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,191,0,0,0,0,64,64,64,176,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,190,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,190,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,188,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,191,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,191,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,188,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,64,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,64,64,64,64,64,191,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,190,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,64,64,64,64,64,190,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,160,0,0,64,64,64,64,64,191,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,188,0,0,0,0,64,64,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,191,0,0,64,64,64,64,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,188,0,0,0,0,64,64,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,190,0,0,64,64,64,64,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,184,0,0,0,0,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,188,0,0,64,64,64,64,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,184,0,0,0,0,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,188,0,0,64,64,64,64,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,184,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,64,64,64,64,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,184,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,64,64,64,64,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,176,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,64,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,176,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,64,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,64,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,64,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,64,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,64,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,64,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,64,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,64,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,191,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,190,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,190,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,190,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,191,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,191,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,190,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,190,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,188,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,191,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,191,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,188,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,188,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,184,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,64,64,64,64,160,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,64,64,64,64,191,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,190,0,0,0,0,0,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,176,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,176,0,0,0,64,64,64,64,190,0,0,0,0,64,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,160,0,0,0,64,64,64,64,191,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,188,0,0,0,0,64,64,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,191,0,0,0,64,64,64,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,191,0,0,0,0,0,0,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,190,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,188,0,0,0,0,64,64,64,191,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,190,0,0,0,64,64,64,64,188,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,184,0,0,0,0,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,188,0,0,0,64,64,64,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,184,0,0,0,0,64,64,64,188,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,188,0,0,0,64,64,64,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,184,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,0,64,64,64,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,184,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,0,64,64,64,64,184,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,0,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,184,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,184,0,0,0,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,64,64,160,0,0,0,0,0,64,64,160,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,64,64,64,64,176,0,0,0,0,64,64,64,176,0,0,0,0,0,0,64,160,0,0,0,0,0,0,64,160,0,0,0,0,64,64,64,176,0,0,0,64,64,64,64,176,128,128,128,128,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,127,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,127,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,0,128,128,128,112,0,0,0,0,0,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+911878);allocate([128,126,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,128,128,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,128,128,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,126,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,127,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,126,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,127,0,128,128,128,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+922118);allocate([128,64,0,128,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,128,128,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,127,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,126,0,128,128,128,128,128,128,112,0,0,0,0,0,128,128,126,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+932358);allocate([128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,128,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,126,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,126,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,127,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,127,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,128,128,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,127,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,128,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,127,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,124,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,128,128,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,120,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,120,0,0,128,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,124,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,124,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,126,0,0,128,128,128,128,128,112,0,0,0,0,0,128,128,126,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,128,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,127,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,128,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,128,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,128,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,120,0,0,0,0,0,128,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,128,128,128,128,112,0,0,0,0,0,128,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,128,128,128,128,96,0,0,0,0,0,128,128,112,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,124,0,0,0,0,0,0,128,64,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,120,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,0,128,128,128,64,0,0,0,0,0,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+942598);allocate([128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,64,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,128,128,128,128,64,0,0,0,0,0,128,128,96,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,112,0,0,0,0,0,0,128,126,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,0,0,0,0,0,128,96,0,2,4,8,16,32,64,128,0,2,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,8,16,0,0,0,0,2,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,8,16,32,0,0,0,2,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,8,16,0,0,0,0,2,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,4,8,16,32,64,0,0,2,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,8,16,0,0,0,0,2,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,8,16,32,0,0,0,2,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,8,16,0,0,0,0,2,0,0,0,0,0,0,0,2,4,8,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,4,0,0,0,0,0,0,5,8,16,32,64,128,0,0,5,8,16,32,64,0,0,0,5,8,16,32,0,0,0,0,5,8,16,32,0,0,0,0,5,8,16,0,0,0,0,0,5,8,16,0,0,0,0,0,5,8,16,0,0,0,0,0,5,8,16,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,8,0,0,0,0,0,0,5,8,0,0,0,0,0,0,5,8,0,0,0,0,0,0,5,8,0,0,0,0,0,0,5,8,0,0,0,0,0,0,5,8,0,0,0,0,0,0,5,8,0,0,0,0,0,0,5,8,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,10,17,32,64,128,0,0,0,10,16,32,64,128,0,0,0,10,17,0,0,0,0,0,0,10,16,0,0,0,0,0,0,10,1,0,0,0,0,0,0,10,0,0,0,0,0,0,0,10,1,0,0,0,0,0,0,10,0,0,0,0,0,0,0,10,17,32,0,0,0,0,0,10,16,32,0,0,0,0,0,10,17,0,0,0,0,0,0,10,16,0,0,0,0,0,0,10,1,0,0,0,0,0,0,10,0,0,0,0,0,0,0,10,1,0,0,0,0,0,0,10,0,0,0,0,0,0,0,10,16,32,64,0,0,0,0,10,17,32,64,0,0,0,0,10,16,0,0,0,0,0,0,10,17,0,0,0,0,0,0,10,0,0,0,0,0,0,0,10,1,0,0,0,0,0,0,10,0,0,0,0,0,0,0,10,1,0,0,0,0,0,0,10,16,32,0,0,0,0,0,10,17,32,0,0,0,0,0,10,16,0,0,0,0,0,0,10,17,0,0,0,0,0,0,10,0,0,0,0,0,0,0,10,1,0,0,0,0,0,0,10,0,0,0,0,0,0,0,10,1,0,0,0,0,0,0,20,34,65,128,0,0,0,0,20,34,64,128,0,0,0,0,20,32,0,0,0,0,0,0,20,32,0,0,0,0,0,0,20,32,64,128,0,0,0,0,20,32,64,128,0,0,0,0,20,2,1,0,0,0,0,0,20,2,0,0,0,0,0,0,20,34,65,0,0,0,0,0,20,34,64,0,0,0,0,0,20,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,20,32,64,0,0,0,0,0,20,32,64,0,0,0,0,0,20,2,1,0,0,0,0,0,20,2,0,0,0,0,0,0,20,2,1,0,0,0,0,0,20,2,0,0,0,0,0,0,20,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,20,34,1,0,0,0,0,0,20,34,0,0,0,0,0,0,20,2,1,0,0,0,0,0,20,2,0,0,0,0,0,0,20,32,0,0,0,0,0,0,20,32,0,0,0,0,0,0,20,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,20,34,1,0,0,0,0,0,20,34,0,0,0,0,0,0,40,68,130,1,0,0,0,0,40,4,2,0,0,0,0,0,40,64,0,0,0,0,0,0,40,0,0,0,0,0,0,0,40,64,128,0,0,0,0,0,40,0,0,0,0,0,0,0,40,68,2,1,0,0,0,0,40,4,2,0,0,0,0,0,40,68,128,0,0,0,0,0,40,4,0,0,0,0,0,0,40,64,0,0,0,0,0,0,40,0,0,0,0,0,0,0,40,64,128,0,0,0,0,0,40,0,0,0,0,0,0,0,40,68,0,0,0,0,0,0,40,4,0,0,0,0,0,0,40,68,130,0,0,0,0,0,40,4,2,1,0,0,0,0,40,64,0,0,0,0,0,0,40,0,0,0,0,0,0,0,40,64,128,0,0,0,0,0,40,0,0,0,0,0,0,0,40,68,2,0,0,0,0,0,40,4,2,1,0,0,0,0,40,68,128,0,0,0,0,0,40,4,0,0,0,0,0,0,40,64,0,0,0,0,0,0,40,0,0,0,0,0,0,0,40,64,128,0,0,0,0,0,40,0,0,0,0,0,0,0,40,68,0,0,0,0,0,0,40,4,0,0,0,0,0,0,80,136,4,2,1,0,0,0,80,136,0,0,0,0,0,0,80,136,4,0,0,0,0,0,80,136,0,0,0,0,0,0,80,136,4,2,0,0,0,0,80,136,0,0,0,0,0,0,80,136,4,0,0,0,0,0,80,136,0,0,0,0,0,0,80,128,0,0,0,0,0,0,80,128,0,0,0,0,0,0,80,128,0,0,0,0,0,0,80,128,0,0,0,0,0,0,80,128,0,0,0,0,0,0,80,128,0,0,0,0,0,0,80,128,0,0,0,0,0,0,80,128,0,0,0,0,0,0,80,8,4,2,1,0,0,0,80,8,0,0,0,0,0,0,80,8,4,0,0,0,0,0,80,8,0,0,0,0,0,0,80,8,4,2,0,0,0,0,80,8,0,0,0,0,0,0,80,8,4,0,0,0,0,0,80,8,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,160,16,8,4,2,1,0,0,160,0,0,0,0,0,0,0,160,16,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,16,8,4,0,0,0,0,160,0,0,0,0,0,0,0,160,16,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,16,8,0,0,0,0,0,160,0,0,0,0,0,0,0,160,16,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,16,8,0,0,0,0,0,160,0,0,0,0,0,0,0,160,16,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,16,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,16,8,4,2,0,0,0,160,0,0,0,0,0,0,0,160,16,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,16,8,4,0,0,0,0,160,0,0,0,0,0,0,0,160,16,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,16,8,0,0,0,0,0,160,0,0,0,0,0,0,0,160,16,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,16,8,0,0,0,0,0,160,0,0,0,0,0,0,0,64,32,16,8,4,2,1,0,64,0,0,0,0,0,0,0,64,32,16,8,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,16,8,4,2,0,0,64,0,0,0,0,0,0,0,64,32,16,8,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,16,8,4,0,0,0,64,0,0,0,0,0,0,0,64,32,16,8,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,16,8,4,0,0,0,64,0,0,0,0,0,0,0,64,32,16,8,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,16,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,64,0,0,0,0,0,0,2,0,2,4,8,16,32,64,2,0,2,4,8,16,32,0,2,0,2,4,8,16,0,0,2,0,2,4,8,16,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,4,8,0,0,0,2,0,2,4,8,0,0,0,2,0,2,4,8,0,0,0,2,0,2,4,8,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,5,0,5,8,16,32,64,128,5,0,5,0,0,0,0,0,5,0,5,8,16,32,0,0,5,0,5,0,0,0,0,0,5,0,5,8,16,0,0,0,5,0,5,0,0,0,0,0,5,0,5,8,16,0,0,0,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,8,16,32,64,0,5,0,5,0,0,0,0,0,5,0,5,8,16,32,0,0,5,0,5,0,0,0,0,0,5,0,5,8,16,0,0,0,5,0,5,0,0,0,0,0,5,0,5,8,16,0,0,0,5,0,5,8,0,0,0,0,0,0,0,0,0,0,0,0,5,0,5,8,0,0,0,0,0,0,0,0,0,0,0,0,5,0,5,8,0,0,0,0,0,0,0,0,0,0,0,0,5,0,5,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,5,8,0,0,0,0,0,0,0,0,0,0,0,0,5,0,5,8,0,0,0,0,0,0,0,0,0,0,0,0,5,0,5,8,0,0,0,0,0,0,0,0,0,0,0,0,5,0,5,8,0,0,0,0,10,0,10,17,32,64,128,0,10,0,10,16,32,64,128,0,10,0,10,17,0,0,0,0,10,0,10,16,0,0,0,0,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,17,32,0,0,0,10,0,10,16,32,0,0,0,10,0,10,17,0,0,0,0,10,0,10,16,0,0,0,0,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,17,32,64,0,0,10,0,10,16,32,64,0,0,10,0,10,17,0,0,0,0,10,0,10,16,0,0,0,0,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,17,32,0,0,0,10,0,10,16,32,0,0,0,10,0,10,17,0,0,0,0,10,0,10,16,0,0,0,0,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,0,20,0,20,34,65,128,0,0,20,0,20,34,64,128,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,34,65,0,0,0,20,0,20,34,64,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,34,1,0,0,0,20,0,20,34,0,0,0,0,20,0,20,32,64,128,0,0,20,0,20,32,64,128,0,0,20,0,20,34,1,0,0,0,20,0,20,34,0,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,40,0,40,68,130,1,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,64,128,0,0,0,40,0,40,68,130,0,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,64,128,0,0,0,40,0,40,4,2,1,0,0,40,0,40,68,0,0,0,0,40,0,40,64,128,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,2,0,0,0,40,0,40,68,0,0,0,0,40,0,40,64,128,0,0,0,40,0,40,0,0,0,0,0,40,0,40,68,2,1,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,68,2,0,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,4,2,1,0,0,40,0,40,68,128,0,0,0,40,0,40,64,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,2,0,0,0,40,0,40,68,128,0,0,0,40,0,40,64,0,0,0,0,40,0,40,0,0,0,0,0,80,0,80,136,4,2,1,0,80,0,80,128,0,0,0,0,80,0,80,136,4,0,0,0,80,0,80,128,0,0,0,0,80,0,80,8,4,2,1,0,80,0,80,0,0,0,0,0,80,0,80,8,4,0,0,0,80,0,80,0,0,0,0,0,80,0,80,136,4,2,0,0,80,0,80,128,0,0,0,0,80,0,80,136,4,0,0,0,80,0,80,128,0,0,0,0,80,0,80,8,4,2,0,0,80,0,80,0,0,0,0,0,80,0,80,8,4,0,0,0,80,0,80,0,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,8,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,8,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,8,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,8,0,0,0,0,160,0,160,16,8,4,2,1,160,0,160,0,0,0,0,0,160,0,160,16,8,4,2,0,160,0,160,0,0,0,0,0,160,0,160,16,8,4,0,0,160,0,160,0,0,0,0,0,160,0,160,16,8,4,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,8,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,8,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,8,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,8,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,64,0,64,32,16,8,4,2,64,0,64,32,0,0,0,0,64,0,64,32,16,8,0,0,64,0,64,32,16,0,0,0,64,0,64,32,0,0,0,0,64,0,64,32,16,0,0,0,64,0,64,32,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,32,16,8,4,0,64,0,64,32,0,0,0,0,64,0,64,32,16,8,0,0,64,0,64,32,16,0,0,0,64,0,64,32,0,0,0,0,64,0,64,32,16,0,0,0,64,0,64,32,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,4,2,0,2,4,8,16,32,4,2,0,2,4,0,0,0,0,2,0,2,4,8,0,0,0,2,0,2,4,0,0,0,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,4,2,0,2,4,8,0,0,4,2,0,2,4,0,0,0,0,2,0,2,4,8,16,32,0,2,0,2,4,0,0,0,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,4,2,0,2,4,8,0,0,4,2,0,2,4,0,0,0,0,2,0,2,4,8,16,0,0,2,0,2,4,0,0,0,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,4,2,0,2,4,8,16,0,4,2,0,2,4,0,0,0,0,2,0,2,4,8,0,0,0,2,0,2,4,0,0,0,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,8,5,0,5,8,16,32,64,8,5,0,5,0,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,8,16,32,0,8,5,0,5,0,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,8,16,32,0,0,5,0,5,0,0,0,0,8,5,0,5,8,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,8,16,32,64,0,5,0,5,0,0,0,0,8,5,0,5,8,0,0,0,8,5,0,5,0,0,0,0,8,5,0,5,8,16,0,0,8,5,0,5,0,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,8,16,0,0,8,5,0,5,0,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,8,16,0,0,0,5,0,5,0,0,0,0,8,5,0,5,8,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,8,16,0,0,0,5,0,5,0,0,0,0,8,5,0,5,8,0,0,0,8,5,0,5,0,0,0,0,17,10,0,10,17,32,64,128,0,10,0,10,17,32,0,0,0,10,0,10,16,0,0,0,17,10,0,10,16,0,0,0,17,10,0,10,1,0,0,0,16,10,0,10,1,0,0,0,16,10,0,10,0,0,0,0,17,10,0,10,0,0,0,0,0,10,0,10,16,32,0,0,17,10,0,10,16,32,64,128,17,10,0,10,17,0,0,0,0,10,0,10,17,0,0,0,16,10,0,10,0,0,0,0,17,10,0,10,0,0,0,0,17,10,0,10,1,0,0,0,16,10,0,10,1,0,0,0,16,10,0,10,17,32,64,128,1,10,0,10,17,32,0,0,1,10,0,10,16,0,0,0,16,10,0,10,16,0,0,0,16,10,0,10,1,0,0,0,17,10,0,10,1,0,0,0,17,10,0,10,0,0,0,0,16,10,0,10,0,0,0,0,1,10,0,10,16,32,0,0,16,10,0,10,16,32,64,128,16,10,0,10,17,0,0,0,1,10,0,10,17,0,0,0,17,10,0,10,0,0,0,0,16,10,0,10,0,0,0,0,16,10,0,10,1,0,0,0,17,10,0,10,1,0,0,0,17,10,0,10,17,32,0,0,16,10,0,10,17,32,64,0,16,10,0,10,16,0,0,0,17,10,0,10,16,0,0,0,17,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,17,10,0,10,0,0,0,0,16,10,0,10,16,32,64,0,17,10,0,10,16,32,0,0,17,10,0,10,17,0,0,0,16,10,0,10,17,0,0,0,0,10,0,10,0,0,0,0,17,10,0,10,0,0,0,0,17,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,16,10,0,10,17,32,0,0,17,10,0,10,17,32,64,0,17,10,0,10,16,0,0,0,16,10,0,10,16,0,0,0,16,10,0,10,1,0,0,0,1,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,16,10,0,10,0,0,0,0,17,10,0,10,16,32,64,0,16,10,0,10,16,32,0,0,16,10,0,10,17,0,0,0,17,10,0,10,17,0,0,0,1,10,0,10,0,0,0,0,16,10,0,10,0,0,0,0,16,10,0,10,1,0,0,0,1,10,0,10,1,0,0,0,1,10,0,10,17,32,64,128,16,10,0,10,17,32,0,0,16,10,0,10,16,0,0,0,1,10,0,10,16,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,16,10,0,10,16,32,0,0,1,10,0,10,16,32,64,128,1,10,0,10,17,0,0,0,16,10,0,10,17,0,0,0,0,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,0,10,0,10,17,32,64,128,17,10,0,10,17,32,0,0,17,10,0,10,16,0,0,0,0,10,0,10,16,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,17,10,0,10,16,32,0,0,0,10,0,10,16,32,64,128,0,10,0,10,17,0,0,0,17,10,0,10,17,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,1,0,0,0,1,10,0,10,17,32,0,0,0,10,0,10,17,32,64,0,0,10,0,10,16,0,0,0,1,10,0,10,16,0,0,0,1,10,0,10,1,0,0,0,16,10,0,10,1,0,0,0,16,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,16,32,64,0,1,10,0,10,16,32,0,0,1,10,0,10,17,0,0,0,0,10,0,10,17,0,0,0,16,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,16,10,0,10,1,0,0,0,0,10,0,10,17,32,0,0,1,10,0,10,17,32,64,0,1,10,0,10,16,0,0,0,0,10,0,10,16,0,0,0,0,10,0,10,1,0,0,0,17,10,0,10,1,0,0,0,17,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,1,10,0,10,16,32,64,0,0,10,0,10,16,32,0,0,0,10,0,10,17,0,0,0,1,10,0,10,17,0,0,0,17,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,1,0,0,0,17,10,0,10,1,0,0,0,34,20,0,20,34,65,128,0,32,20,0,20,34,65,128,0,2,20,0,20,34,64,128,0,0,20,0,20,34,64,128,0,2,20,0,20,34,65,128,0,0,20,0,20,34,65,128,0,34,20,0,20,34,64,128,0,32,20,0,20,34,64,128,0,34,20,0,20,32,64,128,0,32,20,0,20,32,64,128,0,2,20,0,20,32,64,128,0,0,20,0,20,32,64,128,0,2,20,0,20,32,64,128,0,0,20,0,20,32,64,128,0,34,20,0,20,32,64,128,0,32,20,0,20,32,64,128,0,2,20,0,20,34,65,0,0,0,20,0,20,34,65,0,0,34,20,0,20,32,64,0,0,32,20,0,20,32,64,0,0,34,20,0,20,34,65,0,0,32,20,0,20,34,65,0,0,2,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,2,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,34,20,0,20,34,64,0,0,32,20,0,20,34,64,0,0,34,20,0,20,32,64,0,0,32,20,0,20,32,64,0,0,2,20,0,20,34,64,0,0,0,20,0,20,34,64,0,0,34,20,0,20,2,1,0,0,32,20,0,20,2,1,0,0,2,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,2,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,34,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,34,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,34,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,2,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,34,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,34,20,0,20,2,1,0,0,32,20,0,20,2,1,0,0,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,34,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,34,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,2,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,34,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,34,20,0,20,2,1,0,0,32,20,0,20,2,1,0,0,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,2,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,34,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,34,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,2,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,2,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,34,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,34,20,0,20,2,1,0,0,32,20,0,20,2,1,0,0,2,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,34,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,34,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,34,20,0,20,32,0,0,0,32,20,0,20,32,0,0,0,34,20,0,20,34,1,0,0,32,20,0,20,34,1,0,0,2,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,2,20,0,20,34,1,0,0,0,20,0,20,34,1,0,0,34,20,0,20,34,0,0,0,32,20,0,20,34,0,0,0,34,20,0,20,32,0,0,0,32,20,0,20,32,0,0,0,2,20,0,20,34,0,0,0,0,20,0,20,34,0,0,0,2,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,2,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,2,20,0,20,34,1,0,0,0,20,0,20,34,1,0,0,34,20,0,20,32,0,0,0,32,20,0,20,32,0,0,0,34,20,0,20,34,1,0,0,32,20,0,20,34,1,0,0,2,20,0,20,34,0,0,0,0,20,0,20,34,0,0,0,2,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,34,20,0,20,34,0,0,0,32,20,0,20,34,0,0,0,34,20,0,20,32,0,0,0,32,20,0,20,32,0,0,0,68,40,0,40,68,130,1,0,68,40,0,40,68,130,0,0,64,40,0,40,68,128,0,0,64,40,0,40,68,128,0,0,64,40,0,40,68,130,1,0,64,40,0,40,68,130,0,0,68,40,0,40,68,128,0,0,68,40,0,40,68,128,0,0,68,40,0,40,64,128,0,0,68,40,0,40,64,128,0,0,64,40,0,40,64,128,0,0,64,40,0,40,64,128,0,0,64,40,0,40,64,128,0,0,64,40,0,40,64,128,0,0,68,40,0,40,64,128,0,0,68,40,0,40,64,128,0,0,4,40,0,40,68,130,1,0,4,40,0,40,68,130,0,0,0,40,0,40,68,128,0,0,0,40,0,40,68,128,0,0,0,40,0,40,68,130,1,0,0,40,0,40,68,130,0,0,4,40,0,40,68,128,0,0,4,40,0,40,68,128,0,0,4,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,68,40,0,40,4,2,1,0,68,40,0,40,4,2,0,0,64,40,0,40,4,0,0,0,64,40,0,40,4,0,0,0,64,40,0,40,4,2,1,0,64,40,0,40,4,2,0,0,68,40,0,40,4,0,0,0,68,40,0,40,4,0,0,0,68,40,0,40,0,0,0,0,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,68,40,0,40,0,0,0,0,68,40,0,40,0,0,0,0,4,40,0,40,4,2,1,0,4,40,0,40,4,2,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,2,1,0,0,40,0,40,4,2,0,0,4,40,0,40,4,0,0,0,4,40,0,40,4,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,68,40,0,40,4,2,1,0,68,40,0,40,4,2,0,0,64,40,0,40,4,0,0,0,64,40,0,40,4,0,0,0,64,40,0,40,4,2,1,0,64,40,0,40,4,2,0,0,68,40,0,40,4,0,0,0,68,40,0,40,4,0,0,0,68,40,0,40,0,0,0,0,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,68,40,0,40,0,0,0,0,68,40,0,40,0,0,0,0,4,40,0,40,4,2,1,0,4,40,0,40,4,2,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,2,1,0,0,40,0,40,4,2,0,0,4,40,0,40,4,0,0,0,4,40,0,40,4,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,68,40,0,40,68,2,1,0,68,40,0,40,68,2,0,0,64,40,0,40,68,0,0,0,64,40,0,40,68,0,0,0,64,40,0,40,68,2,1,0,64,40,0,40,68,2,0,0,68,40,0,40,68,0,0,0,68,40,0,40,68,0,0,0,68,40,0,40,64,0,0,0,68,40,0,40,64,0,0,0,64,40,0,40,64,0,0,0,64,40,0,40,64,0,0,0,64,40,0,40,64,0,0,0,64,40,0,40,64,0,0,0,68,40,0,40,64,0,0,0,68,40,0,40,64,0,0,0,4,40,0,40,68,2,1,0,4,40,0,40,68,2,0,0,0,40,0,40,68,0,0,0,0,40,0,40,68,0,0,0,0,40,0,40,68,2,1,0,0,40,0,40,68,2,0,0,4,40,0,40,68,0,0,0,4,40,0,40,68,0,0,0,4,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,136,80,0,80,136,4,2,1,136,80,0,80,136,4,0,0,128,80,0,80,136,4,2,1,128,80,0,80,136,4,0,0,136,80,0,80,128,0,0,0,136,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,8,80,0,80,136,4,2,1,8,80,0,80,136,4,0,0,0,80,0,80,136,4,2,1,0,80,0,80,136,4,0,0,8,80,0,80,128,0,0,0,8,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,136,80,0,80,136,4,2,0,136,80,0,80,136,4,0,0,128,80,0,80,136,4,2,0,128,80,0,80,136,4,0,0,136,80,0,80,128,0,0,0,136,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,8,80,0,80,136,4,2,0,8,80,0,80,136,4,0,0,0,80,0,80,136,4,2,0,0,80,0,80,136,4,0,0,8,80,0,80,128,0,0,0,8,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,136,80,0,80,128,0,0,0,136,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,136,80,0,80,136,0,0,0,136,80,0,80,136,0,0,0,128,80,0,80,136,0,0,0,128,80,0,80,136,0,0,0,8,80,0,80,128,0,0,0,8,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,8,80,0,80,136,0,0,0,8,80,0,80,136,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,136,0,0,0,136,80,0,80,128,0,0,0,136,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,136,80,0,80,136,0,0,0,136,80,0,80,136,0,0,0,128,80,0,80,136,0,0,0,128,80,0,80,136,0,0,0,8,80,0,80,128,0,0,0,8,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,8,80,0,80,136,0,0,0,8,80,0,80,136,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,136,0,0,0,136,80,0,80,8,4,2,1,136,80,0,80,8,4,0,0,128,80,0,80,8,4,2,1,128,80,0,80,8,4,0,0,136,80,0,80,0,0,0,0,136,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,8,80,0,80,8,4,2,1,8,80,0,80,8,4,0,0,0,80,0,80,8,4,2,1,0,80,0,80,8,4,0,0,8,80,0,80,0,0,0,0,8,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,136,80,0,80,8,4,2,0,136,80,0,80,8,4,0,0,128,80,0,80,8,4,2,0,128,80,0,80,8,4,0,0,136,80,0,80,0,0,0,0,136,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,8,80,0,80,8,4,2,0,8,80,0,80,8,4,0,0,0,80,0,80,8,4,2,0,0,80,0,80,8,4,0,0,8,80,0,80,0,0,0,0,8,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,136,80,0,80,0,0,0,0,136,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,136,80,0,80,8,0,0,0,136,80,0,80,8,0,0,0,128,80,0,80,8,0,0,0,128,80,0,80,8,0,0,0,8,80,0,80,0,0,0,0,8,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,8,80,0,80,8,0,0,0,8,80,0,80,8,0,0,0,0,80,0,80,8,0,0,0,0,80,0,80,8,0,0,0,136,80,0,80,0,0,0,0,136,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,136,80,0,80,8,0,0,0,136,80,0,80,8,0,0,0,128,80,0,80,8,0,0,0,128,80,0,80,8,0,0,0,8,80,0,80,0,0,0,0,8,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,8,80,0,80,8,0,0,0,8,80,0,80,8,0,0,0,0,80,0,80,8,0,0,0,0,80,0,80,8,0,0,0,16,160,0,160,16,8,4,2,0,160,0,160,0,0,0,0,16,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,16,160,0,160,16,8,0,0,0,160,0,160,0,0,0,0,16,160,0,160,16,0,0,0,16,160,0,160,0,0,0,0,0,160,0,160,16,8,4,2,16,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,16,8,0,0,16,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,16,160,0,160,0,0,0,0,16,160,0,160,16,8,4,0,0,160,0,160,0,0,0,0,16,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,16,160,0,160,16,8,0,0,0,160,0,160,0,0,0,0,16,160,0,160,16,0,0,0,16,160,0,160,0,0,0,0,0,160,0,160,16,8,4,0,16,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,16,8,0,0,16,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,16,160,0,160,0,0,0,0,32,64,0,64,32,16,8,4,32,64,0,64,32,0,0,0,0,64,0,64,32,16,8,4,0,64,0,64,32,0,0,0,32,64,0,64,32,16,0,0,32,64,0,64,32,0,0,0,0,64,0,64,32,16,0,0,0,64,0,64,32,0,0,0,0,64,0,64,32,16,8,0,0,64,0,64,32,0,0,0,32,64,0,64,32,16,8,0,32,64,0,64,32,0,0,0,0,64,0,64,32,16,0,0,0,64,0,64,32,0,0,0,32,64,0,64,32,16,0,0,32,64,0,64,32,0,0,0,32,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,8,4,2,0,2,4,8,16,8,4,2,0,2,4,0,0,0,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,0,2,0,2,4,8,16,0,0,2,0,2,4,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,8,4,2,0,2,4,8,0,8,4,2,0,2,4,0,0,0,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,0,2,0,2,4,8,0,0,0,2,0,2,4,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,4,2,0,2,4,8,16,0,4,2,0,2,4,0,0,8,4,2,0,2,0,0,0,8,4,2,0,2,0,0,0,0,0,2,0,2,4,8,16,0,0,2,0,2,4,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,4,2,0,2,4,8,0,0,4,2,0,2,4,0,0,8,4,2,0,2,0,0,0,8,4,2,0,2,0,0,0,0,0,2,0,2,4,8,0,0,0,2,0,2,4,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,16,8,5,0,5,8,16,32,0,8,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,8,16,32,0,8,5,0,5,0,0,0,16,8,5,0,5],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+952838);allocate([5,0,5,0,0,0,0,0,5,0,5,0,0,0,16,8,5,0,5,8,16,0,0,8,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,8,16,0,16,8,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,8,16,32,16,8,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,8,16,32,16,8,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,8,16,0,16,8,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,8,16,0,0,8,5,0,5,0,0,0,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,0,0,0,32,17,10,0,10,17,32,64,0,16,10,0,10,16,32,0,0,16,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,16,10,0,10,0,0,0,32,17,10,0,10,17,0,0,0,16,10,0,10,16,0,0,0,16,10,0,10,17,32,0,32,17,10,0,10,16,32,64,0,1,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,16,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,16,10,0,10,17,0,0,32,17,10,0,10,16,0,0,32,16,10,0,10,17,32,64,0,17,10,0,10,16,32,64,0,1,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,0,0,0,32,16,10,0,10,17,0,0,0,17,10,0,10,16,0,0,0,17,10,0,10,17,32,64,32,16,10,0,10,16,32,64,0,0,10,0,10,1,0,0,0,16,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,17,10,0,10,17,0,0,32,16,10,0,10,16,0,0,32,17,10,0,10,17,32,0,0,16,10,0,10,16,32,64,0,0,10,0,10,1,0,0,32,16,10,0,10,0,0,0,32,17,10,0,10,1,0,0,0,0,10,0,10,0,0,0,32,17,10,0,10,17,0,0,0,16,10,0,10,16,0,0,0,16,10,0,10,17,32,64,32,17,10,0,10,16,32,0,32,17,10,0,10,1,0,0,0,17,10,0,10,0,0,0,0,0,10,0,10,1,0,0,32,17,10,0,10,0,0,0,0,16,10,0,10,17,0,0,32,17,10,0,10,16,0,0,32,16,10,0,10,17,32,0,0,17,10,0,10,16,32,0,0,17,10,0,10,1,0,0,32,17,10,0,10,0,0,0,32,16,10,0,10,1,0,0,0,17,10,0,10,0,0,0,32,16,10,0,10,17,0,0,0,17,10,0,10,16,0,0,0,17,10,0,10,17,32,0,32,16,10,0,10,16,32,0,32,16,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,17,10,0,10,1,0,0,32,16,10,0,10,0,0,0,0,17,10,0,10,17,0,0,32,16,10,0,10,16,0,0,0,1,10,0,10,17,32,64,0,0,10,0,10,16,32,0,0,0,10,0,10,1,0,0,32,16,10,0,10,0,0,0,32,17,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,16,0,0,0,0,10,0,10,17,32,0,0,1,10,0,10,16,32,64,32,17,10,0,10,1,0,0,0,17,10,0,10,0,0,0,0,0,10,0,10,1,0,0,32,17,10,0,10,0,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,0,10,0,10,17,32,64,0,1,10,0,10,16,32,64,0,17,10,0,10,1,0,0,32,17,10,0,10,0,0,0,32,16,10,0,10,1,0,0,0,17,10,0,10,0,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,1,10,0,10,17,32,64,0,0,10,0,10,16,32,64,32,16,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,17,10,0,10,1,0,0,32,16,10,0,10,0,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,16,0,0,0,1,10,0,10,17,32,0,0,0,10,0,10,16,32,64,0,16,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,16,10,0,10,0,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,16,0,0,0,0,10,0,10,17,32,64,0,1,10,0,10,16,32,0,0,1,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,16,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,0,10,0,10,17,32,0,0,1,10,0,10,16,32,0,0,1,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,1,10,0,10,17,32,0,0,0,10,0,10,16,32,0,0,0,10,0,10,1,0,0,0,16,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,0,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,16,0,0,65,34,20,0,20,34,65,128,64,34,20,0,20,34,65,128,65,34,20,0,20,2,1,0,64,34,20,0,20,2,1,0,0,34,20,0,20,2,1,0,1,34,20,0,20,34,1,0,0,34,20,0,20,34,1,0,1,34,20,0,20,2,1,0,65,34,20,0,20,34,1,0,64,34,20,0,20,34,1,0,65,34,20,0,20,2,1,0,64,34,20,0,20,2,1,0,65,34,20,0,20,34,65,0,64,34,20,0,20,34,65,0,65,34,20,0,20,2,1,0,64,34,20,0,20,2,1,0,0,34,20,0,20,2,1,0,1,34,20,0,20,34,65,128,0,34,20,0,20,34,65,128,1,34,20,0,20,2,1,0,65,34,20,0,20,34,1,0,64,34,20,0,20,34,1,0,65,34,20,0,20,2,1,0,64,34,20,0,20,2,1,0,0,34,20,0,20,2,1,0,1,34,20,0,20,34,1,0,0,34,20,0,20,34,1,0,1,34,20,0,20,2,1,0,0,34,20,0,20,2,1,0,1,34,20,0,20,34,65,0,0,34,20,0,20,34,65,0,1,34,20,0,20,2,1,0,64,32,20,0,20,34,65,128,64,32,20,0,20,34,65,128,64,32,20,0,20,2,1,0,64,32,20,0,20,2,1,0,0,32,20,0,20,2,1,0,0,32,20,0,20,34,1,0,0,32,20,0,20,34,1,0,0,32,20,0,20,2,1,0,64,32,20,0,20,34,1,0,64,32,20,0,20,34,1,0,64,32,20,0,20,2,1,0,64,32,20,0,20,2,1,0,64,32,20,0,20,34,65,0,64,32,20,0,20,34,65,0,64,32,20,0,20,2,1,0,64,32,20,0,20,2,1,0,0,32,20,0,20,2,1,0,0,32,20,0,20,34,65,128,0,32,20,0,20,34,65,128,0,32,20,0,20,2,1,0,64,32,20,0,20,34,1,0,64,32,20,0,20,34,1,0,64,32,20,0,20,2,1,0,64,32,20,0,20,2,1,0,0,32,20,0,20,2,1,0,0,32,20,0,20,34,1,0,0,32,20,0,20,34,1,0,0,32,20,0,20,2,1,0,0,32,20,0,20,2,1,0,0,32,20,0,20,34,65,0,0,32,20,0,20,34,65,0,0,32,20,0,20,2,1,0,65,34,20,0,20,34,64,128,64,34,20,0,20,34,64,128,65,34,20,0,20,2,0,0,64,34,20,0,20,2,0,0,0,34,20,0,20,2,0,0,1,34,20,0,20,34,0,0,0,34,20,0,20,34,0,0,1,34,20,0,20,2,0,0,65,34,20,0,20,34,0,0,64,34,20,0,20,34,0,0,65,34,20,0,20,2,0,0,64,34,20,0,20,2,0,0,65,34,20,0,20,34,64,0,64,34,20,0,20,34,64,0,65,34,20,0,20,2,0,0,64,34,20,0,20,2,0,0,0,34,20,0,20,2,0,0,1,34,20,0,20,34,64,128,0,34,20,0,20,34,64,128,1,34,20,0,20,2,0,0,65,34,20,0,20,34,0,0,64,34,20,0,20,34,0,0,65,34,20,0,20,2,0,0,64,34,20,0,20,2,0,0,0,34,20,0,20,2,0,0,1,34,20,0,20,34,0,0,0,34,20,0,20,34,0,0,1,34,20,0,20,2,0,0,0,34,20,0,20,2,0,0,1,34,20,0,20,34,64,0,0,34,20,0,20,34,64,0,1,34,20,0,20,2,0,0,64,32,20,0,20,34,64,128,64,32,20,0,20,34,64,128,64,32,20,0,20,2,0,0,64,32,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,34,0,0,0,32,20,0,20,34,0,0,0,32,20,0,20,2,0,0,64,32,20,0,20,34,0,0,64,32,20,0,20,34,0,0,64,32,20,0,20,2,0,0,64,32,20,0,20,2,0,0,64,32,20,0,20,34,64,0,64,32,20,0,20,34,64,0,64,32,20,0,20,2,0,0,64,32,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,34,64,128,0,32,20,0,20,34,64,128,0,32,20,0,20,2,0,0,64,32,20,0,20,34,0,0,64,32,20,0,20,34,0,0,64,32,20,0,20,2,0,0,64,32,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,34,0,0,0,32,20,0,20,34,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,34,64,0,0,32,20,0,20,34,64,0,0,32,20,0,20,2,0,0,1,2,20,0,20,34,65,128,0,2,20,0,20,34,65,128,1,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,1,2,20,0,20,34,1,0,0,2,20,0,20,34,1,0,1,2,20,0,20,2,1,0,1,2,20,0,20,34,1,0,0,2,20,0,20,34,1,0,1,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,1,2,20,0,20,34,65,0,0,2,20,0,20,34,65,0,1,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,1,2,20,0,20,34,65,128,0,2,20,0,20,34,65,128,1,2,20,0,20,2,1,0,1,2,20,0,20,34,1,0,0,2,20,0,20,34,1,0,1,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,1,2,20,0,20,34,1,0,0,2,20,0,20,34,1,0,1,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,1,2,20,0,20,34,65,0,0,2,20,0,20,34,65,0,1,2,20,0,20,2,1,0,0,0,20,0,20,34,65,128,0,0,20,0,20,34,65,128,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,34,1,0,0,0,20,0,20,34,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,34,1,0,0,0,20,0,20,34,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,34,65,0,0,0,20,0,20,34,65,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,34,65,128,0,0,20,0,20,34,65,128,0,0,20,0,20,2,1,0,0,0,20,0,20,34,1,0,0,0,20,0,20,34,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,34,1,0,0,0,20,0,20,34,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,34,65,0,0,0,20,0,20,34,65,0,0,0,20,0,20,2,1,0,1,2,20,0,20,34,64,128,0,2,20,0,20,34,64,128,1,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,1,2,20,0,20,34,0,0,0,2,20,0,20,34,0,0,1,2,20,0,20,2,0,0,1,2,20,0,20,34,0,0,0,2,20,0,20,34,0,0,1,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,1,2,20,0,20,34,64,0,0,2,20,0,20,34,64,0,1,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,1,2,20,0,20,34,64,128,0,2,20,0,20,34,64,128,1,2,20,0,20,2,0,0,1,2,20,0,20,34,0,0,0,2,20,0,20,34,0,0,1,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,1,2,20,0,20,34,0,0,0,2,20,0,20,34,0,0,1,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,1,2,20,0,20,34,64,0,0,2,20,0,20,34,64,0,1,2,20,0,20,2,0,0,0,0,20,0,20,34,64,128,0,0,20,0,20,34,64,128,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,34,64,0,0,0,20,0,20,34,64,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,34,64,128,0,0,20,0,20,34,64,128,0,0,20,0,20,2,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,34,64,0,0,0,20,0,20,34,64,0,0,0,20,0,20,2,0,0,65,34,20,0,20,32,64,128,64,34,20,0,20,32,64,128,65,34,20,0,20,0,0,0,64,34,20,0,20,0,0,0,0,34,20,0,20,0,0,0,1,34,20,0,20,32,0,0,0,34,20,0,20,32,0,0,1,34,20,0,20,0,0,0,65,34,20,0,20,32,0,0,64,34,20,0,20,32,0,0,65,34,20,0,20,0,0,0,64,34,20,0,20,0,0,0,65,34,20,0,20,32,64,0,64,34,20,0,20,32,64,0,65,34,20,0,20,0,0,0,64,34,20,0,20,0,0,0,0,34,20,0,20,0,0,0,1,34,20,0,20,32,64,128,0,34,20,0,20,32,64,128,1,34,20,0,20,0,0,0,65,34,20,0,20,32,0,0,64,34,20,0,20,32,0,0,65,34,20,0,20,0,0,0,64,34,20,0,20,0,0,0,0,34,20,0,20,0,0,0,1,34,20,0,20,32,0,0,0,34,20,0,20,32,0,0,1,34,20,0,20,0,0,0,0,34,20,0,20,0,0,0,1,34,20,0,20,32,64,0,0,34,20,0,20,32,64,0,1,34,20,0,20,0,0,0,64,32,20,0,20,32,64,128,64,32,20,0,20,32,64,128,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,0,0,0,64,32,20,0,20,32,0,0,64,32,20,0,20,32,0,0,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,64,32,20,0,20,32,64,0,64,32,20,0,20,32,64,0,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,32,64,128,0,32,20,0,20,32,64,128,0,32,20,0,20,0,0,0,64,32,20,0,20,32,0,0,64,32,20,0,20,32,0,0,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,32,64,0,0,32,20,0,20,32,64,0,0,32,20,0,20,0,0,0,64,34,20,0,20,32,64,128,65,34,20,0,20,32,64,128,64,34,20,0,20,0,0,0,65,34,20,0,20,0,0,0,1,34,20,0,20,32,0,0,0,34,20,0,20,0,0,0,1,34,20,0,20,0,0,0,0,34,20,0,20,32,0,0,64,34,20,0,20,32,0,0,65,34,20,0,20,32,0,0,64,34,20,0,20,0,0,0,65,34,20,0,20,0,0,0,64,34,20,0,20,32,64,0,65,34,20,0,20,32,64,0,64,34,20,0,20,0,0,0,65,34,20,0,20,0,0,0,1,34,20,0,20,32,64,128,0,34,20,0,20,0,0,0,1,34,20,0,20,0,0,0,0,34,20,0,20,32,64,128,64,34,20,0,20,32,0,0,65,34,20,0,20,32,0,0,64,34,20,0,20,0,0,0,65,34,20,0,20,0,0,0,1,34,20,0,20,32,0,0,0,34,20,0,20,0,0,0,1,34,20,0,20,0,0,0,0,34,20,0,20,32,0,0,1,34,20,0,20,32,64,0,0,34,20,0,20,0,0,0,1,34,20,0,20,0,0,0,0,34,20,0,20,32,64,0,64,32,20,0,20,32,64,128,64,32,20,0,20,32,64,128,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,32,0,0,64,32,20,0,20,32,0,0,64,32,20,0,20,32,0,0,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,64,32,20,0,20,32,64,0,64,32,20,0,20,32,64,0,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,32,20,0,20,32,64,128,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,32,64,128,64,32,20,0,20,32,0,0,64,32,20,0,20,32,0,0,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,32,64,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,32,64,0,1,2,20,0,20,32,64,128,0,2,20,0,20,32,64,128,1,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,1,2,20,0,20,32,0,0,0,2,20,0,20,32,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,32,0,0,0,2,20,0,20,32,0,0,1,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,1,2,20,0,20,32,64,0,0,2,20,0,20,32,64,0,1,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,1,2,20,0,20,32,64,128,0,2,20,0,20,32,64,128,1,2,20,0,20,0,0,0,1,2,20,0,20,32,0,0,0,2,20,0,20,32,0,0,1,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,1,2,20,0,20,32,0,0,0,2,20,0,20,32,0,0,1,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,1,2,20,0,20,32,64,0,0,2,20,0,20,32,64,0,1,2,20,0,20,0,0,0,0,0,20,0,20,32,64,128,0,0,20,0,20,32,64,128,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,64,128,0,0,20,0,20,32,64,128,0,0,20,0,20,0,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,0,0,0,0,2,20,0,20,32,64,128,1,2,20,0,20,32,64,128,0,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,32,0,0,0,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,0,2,20,0,20,32,0,0,0,2,20,0,20,32,0,0,1,2,20,0,20,32,0,0,0,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,0,2,20,0,20,32,64,0,1,2,20,0,20,32,64,0,0,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,32,64,128,0,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,0,2,20,0,20,32,64,128,0,2,20,0,20,32,0,0,1,2,20,0,20,32,0,0,0,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,32,0,0,0,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,0,2,20,0,20,32,0,0,1,2,20,0,20,32,64,0,0,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,0,2,20,0,20,32,64,0,0,0,20,0,20,32,64,128,0,0,20,0,20,32,64,128,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,64,128,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,64,128,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,64,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,64,0,130,68,40,0,40,68,130,1,130,68,40,0,40,68,130,0,2,68,40,0,40,64,128,0,2,68,40,0,40,64,128,0,130,68,40,0,40,68,128,0,130,68,40,0,40,68,128,0,2,68,40,0,40,64,128,0,2,68,40,0,40,64,128,0,130,68,40,0,40,64,128,0,130,68,40,0,40,64,128,0,2,68,40,0,40,68,130,1,2,68,40,0,40,68,130,0,130,68,40,0,40,64,128,0,130,68,40,0,40,64,128,0,2,68,40,0,40,68,128,0,2,68,40,0,40,68,128,0,0,0,40,0,40,68,0,0,0,0,40,0,40,68,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,68,2,1,0,0,40,0,40,68,2,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,68,0,0,0,0,40,0,40,68,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,68,2,1,0,0,40,0,40,68,2,0,130,68,40,0,40,4,2,1,130,68,40,0,40,4,2,0,2,68,40,0,40,0,0,0,2,68,40,0,40,0,0,0,130,68,40,0,40,4,0,0,130,68,40,0,40,4,0,0,2,68,40,0,40,0,0,0,2,68,40,0,40,0,0,0,130,68,40,0,40,0,0,0,130,68,40,0,40,0,0,0,2,68,40,0,40,4,2,1,2,68,40,0,40,4,2,0,130,68,40,0,40,0,0,0,130,68,40,0,40,0,0,0,2,68,40,0,40,4,0,0,2,68,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,2,1,0,0,40,0,40,4,2,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,2,1,0,0,40,0,40,4,2,0,130,68,40,0,40,68,2,1,130,68,40,0,40,68,2,0,2,68,40,0,40,64,0,0,2,68,40,0,40,64,0,0,130,68,40,0,40,68,0,0,130,68,40,0,40,68,0,0,2,68,40,0,40,64,0,0,2,68,40,0,40,64,0,0,130,68,40,0,40,64,0,0,130,68,40,0,40,64,0,0,2,68,40,0,40,68,2,1,2,68,40,0,40,68,2,0,130,68,40,0,40,64,0,0,130,68,40,0,40,64,0,0,2,68,40,0,40,68,0,0,2,68,40,0,40,68,0,0,0,0,40,0,40,68,128,0,0,0,40,0,40,68,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,68,130,1,0,0,40,0,40,68,130,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,68,128,0,0,0,40,0,40,68,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,68,130,1,0,0,40,0,40,68,130,0,130,68,40,0,40,4,2,1,130,68,40,0,40,4,2,0,2,68,40,0,40,0,0,0,2,68,40,0,40,0,0,0,130,68,40,0,40,4,0,0,130,68,40,0,40,4,0,0,2,68,40,0,40,0,0,0,2,68,40,0,40,0,0,0,130,68,40,0,40,0,0,0,130,68,40,0,40,0,0,0,2,68,40,0,40,4,2,1,2,68,40,0,40,4,2,0,130,68,40,0,40,0,0,0,130,68,40,0,40,0,0,0,2,68,40,0,40,4,0,0,2,68,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,2,1,0,0,40,0,40,4,2,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,2,1,0,0,40,0,40,4,2,0,128,68,40,0,40,68,130,1,128,68,40,0,40,68,130,0,0,68,40,0,40,64,128,0,0,68,40,0,40,64,128,0,128,68,40,0,40,68,128,0,128,68,40,0,40,68,128,0,0,68,40,0,40,64,128,0,0,68,40,0,40,64,128,0,128,68,40,0,40,64,128,0,128,68,40,0,40,64,128,0,0,68,40,0,40,68,130,1,0,68,40,0,40,68,130,0,128,68,40,0,40,64,128,0,128,68,40,0,40,64,128,0,0,68,40,0,40,68,128,0,0,68,40,0,40,68,128,0,0,0,40,0,40,68,0,0,0,0,40,0,40,68,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,68,2,1,0,0,40,0,40,68,2,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,68,0,0,0,0,40,0,40,68,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,0,40,0,40,68,2,1,0,0,40,0,40,68,2,0,128,68,40,0,40,4,2,1,128,68,40,0,40,4,2,0,0,68,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,68,40,0,40,4,0,0,128,68,40,0,40,4,0,0,0,68,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,68,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,68,40,0,40,4,2,1,0,68,40,0,40,4,2,0,128,68,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,68,40,0,40,4,0,0,0,68,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,2,1,0,0,40,0,40,4,2,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,2,1,0,0,40,0,40,4,2,0,128,68,40,0,40,68,2,1,128,68,40,0,40,68,2,0,0,68,40,0,40,64,0,0,0,68,40,0,40,64,0,0,128,68,40,0,40,68,0,0,128,68,40,0,40,68,0,0,0,68,40,0,40,64,0,0,0,68,40,0,40,64,0,0,128,68,40,0,40,64,0,0,128,68,40,0,40,64,0,0,0,68,40,0,40,68,2,1,0,68,40,0,40,68,2,0,128,68,40,0,40,64,0,0,128,68,40,0,40,64,0,0,0,68,40,0,40,68,0,0,0,68,40,0,40,68,0,0,0,0,40,0,40,68,128,0,0,0,40,0,40,68,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,68,130,1,0,0,40,0,40,68,130,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,68,128,0,0,0,40,0,40,68,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,0,40,0,40,68,130,1,0,0,40,0,40,68,130,0,128,68,40,0,40,4,2,1,128,68,40,0,40,4,2,0,0,68,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,68,40,0,40,4,0,0,128,68,40,0,40,4,0,0,0,68,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,68,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,68,40,0,40,4,2,1,0,68,40,0,40,4,2,0,128,68,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,68,40,0,40,4,0,0,0,68,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,2,1,0,0,40,0,40,4,2,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,4,2,1,0,0,40,0,40,4,2,0,128,64,40,0,40,68,0,0,128,64,40,0,40,68,0,0,0,64,40,0,40,64,0,0,0,64,40,0,40,64,0,0,128,64,40,0,40,68,2,1,128,64,40,0,40,68,2,0,0,64,40,0,40,64,0,0,0,64,40,0,40,64,0,0,128,64,40,0,40,64,0,0,128,64,40,0,40,64,0,0,0,64,40,0,40,68,0,0,0,64,40,0,40,68,0,0,128,64,40,0,40,64,0,0,128,64,40,0,40,64,0,0,0,64,40,0,40,68,2,1,0,64,40,0,40,68,2,0,2,4,40,0,40,68,130,1,2,4,40,0,40,68,130,0,2,4,40,0,40,64,128,0,2,4,40,0,40,64,128,0,2,4,40,0,40,68,128,0,2,4,40,0,40,68,128,0,2,4,40,0,40,64,128,0,2,4,40,0,40,64,128,0,2,4,40,0,40,64,128,0,2,4,40,0,40,64,128,0,2,4,40,0,40,68,130,1,2,4,40,0,40,68,130,0,2,4,40,0,40,64,128,0,2,4,40,0,40,64,128,0,2,4,40,0,40,68,128,0,2,4,40,0,40,68,128,0,128,64,40,0,40,4,0,0,128,64,40,0,40,4,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,64,40,0,40,4,2,1,128,64,40,0,40,4,2,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,64,40,0,40,4,0,0,0,64,40,0,40,4,0,0,128,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,64,40,0,40,4,2,1,0,64,40,0,40,4,2,0,2,4,40,0,40,4,2,1,2,4,40,0,40,4,2,0,2,4,40,0,40,0,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,4,0,0,2,4,40,0,40,4,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,4,2,1,2,4,40,0,40,4,2,0,2,4,40,0,40,0,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,4,0,0,2,4,40,0,40,4,0,0,128,64,40,0,40,68,128,0,128,64,40,0,40,68,128,0,0,64,40,0,40,64,128,0,0,64,40,0,40,64,128,0,128,64,40,0,40,68,130,1,128,64,40,0,40,68,130,0,0,64,40,0,40,64,128,0,0,64,40,0,40,64,128,0,128,64,40,0,40,64,128,0,128,64,40,0,40,64,128,0,0,64,40,0,40,68,128,0,0,64,40,0,40,68,128,0,128,64,40,0,40,64,128,0,128,64,40,0,40,64,128,0,0,64,40,0,40,68,130,1,0,64,40,0,40,68,130,0,2,4,40,0,40,68,2,1,2,4,40,0,40,68,2,0,2,4,40,0,40,64,0,0,2,4,40,0,40,64,0,0,2,4,40,0,40,68,0,0,2,4,40,0,40,68,0,0,2,4,40,0,40,64,0,0,2,4,40,0,40,64,0,0,2,4,40,0,40,64,0,0,2,4,40,0,40,64,0,0,2,4,40,0,40,68,2,1,2,4,40,0,40,68,2,0,2,4,40,0,40,64,0,0,2,4,40,0,40,64,0,0,2,4,40,0,40,68,0,0,2,4,40,0,40,68,0,0,128,64,40,0,40,4,0,0,128,64,40,0,40,4,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,64,40,0,40,4,2,1,128,64,40,0,40,4,2,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,64,40,0,40,4,0,0,0,64,40,0,40,4,0,0,128,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,64,40,0,40,4,2,1,0,64,40,0,40,4,2,0,2,4,40,0,40,4,2,1,2,4,40,0,40,4,2,0,2,4,40,0,40,0,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,4,0,0,2,4,40,0,40,4,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,4,2,1,2,4,40,0,40,4,2,0,2,4,40,0,40,0,0,0,2,4,40,0,40,0,0,0,2,4,40,0,40,4,0,0,2,4,40,0,40,4,0,0,128,64,40,0,40,68,0,0,128,64,40,0,40,68,0,0,0,64,40,0,40,64,0,0,0,64,40,0,40,64,0,0,128,64,40,0,40,68,2,1,128,64,40,0,40,68,2,0,0,64,40,0,40,64,0,0,0,64,40,0,40,64,0,0,128,64,40,0,40,64,0,0,128,64,40,0,40,64,0,0,0,64,40,0,40,68,0,0,0,64,40,0,40,68,0,0,128,64,40,0,40,64,0,0,128,64,40,0,40,64,0,0,0,64,40,0,40,68,2,1,0,64,40,0,40,68,2,0,0,4,40,0,40,68,130,1,0,4,40,0,40,68,130,0,0,4,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,4,40,0,40,68,128,0,0,4,40,0,40,68,128,0,0,4,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,4,40,0,40,68,130,1,0,4,40,0,40,68,130,0,0,4,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,4,40,0,40,68,128,0,0,4,40,0,40,68,128,0,128,64,40,0,40,4,0,0,128,64,40,0,40,4,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,64,40,0,40,4,2,1,128,64,40,0,40,4,2,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,64,40,0,40,4,0,0,0,64,40,0,40,4,0,0,128,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,64,40,0,40,4,2,1,0,64,40,0,40,4,2,0,0,4,40,0,40,4,2,1,0,4,40,0,40,4,2,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,4,0,0,0,4,40,0,40,4,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,4,2,1,0,4,40,0,40,4,2,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,4,0,0,0,4,40,0,40,4,0,0,128,64,40,0,40,68,128,0,128,64,40,0,40,68,128,0,0,64,40,0,40,64,128,0,0,64,40,0,40,64,128,0,128,64,40,0,40,68,130,1,128,64,40,0,40,68,130,0,0,64,40,0,40,64,128,0,0,64,40,0,40,64,128,0,128,64,40,0,40,64,128,0,128,64,40,0,40,64,128,0,0,64,40,0,40,68,128,0,0,64,40,0,40,68,128,0,128,64,40,0,40,64,128,0,128,64,40,0,40,64,128,0,0,64,40,0,40,68,130,1,0,64,40,0,40,68,130,0,0,4,40,0,40,68,2,1,0,4,40,0,40,68,2,0,0,4,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,4,40,0,40,68,0,0,0,4,40,0,40,68,0,0,0,4,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,4,40,0,40,68,2,1,0,4,40,0,40,68,2,0,0,4,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,4,40,0,40,68,0,0,0,4,40,0,40,68,0,0,128,64,40,0,40,4,0,0,128,64,40,0,40,4,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,64,40,0,40,4,2,1,128,64,40,0,40,4,2,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,64,40,0,40,4,0,0,0,64,40,0,40,4,0,0,128,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,64,40,0,40,4,2,1,0,64,40,0,40,4,2,0,0,4,40,0,40,4,2,1,0,4,40,0,40,4,2,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,4,0,0,0,4,40,0,40,4,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,4,2,1,0,4,40,0,40,4,2,0,0,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,4,40,0,40,4,0,0,0,4,40,0,40,4,0,0,4,136,80,0,80,136,4,2,0,136,80,0,80,136,4,2,4,136,80,0,80,136,0,0,0,136,80,0,80,136,0,0,4,136,80,0,80,128,0,0,0,136,80,0,80,128,0,0,4,136,80,0,80,128,0,0,0,136,80,0,80,128,0,0,0,128,80,0,80,136,4,2,0,128,80,0,80,136,4,2,0,128,80,0,80,136,0,0,0,128,80,0,80,136,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,128,0,0,4,136,80,0,80,8,4,2,0,136,80,0,80,8,4,2,4,136,80,0,80,8,0,0,0,136,80,0,80,8,0,0,4,136,80,0,80,0,0,0,0,136,80,0,80,0,0,0,4,136,80,0,80,0,0,0,0,136,80,0,80,0,0,0,0,128,80,0,80,8,4,2,0,128,80,0,80,8,4,2,0,128,80,0,80,8,0,0,0,128,80,0,80,8,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,0,0,0,4,8,80,0,80,136,4,2,0,8,80,0,80,136,4,2,4,8,80,0,80,136,0,0,0,8,80,0,80,136,0,0,4,8,80,0,80,128,0,0,0,8,80,0,80,128,0,0,4,8,80,0,80,128,0,0,0,8,80,0,80,128,0,0,0,0,80,0,80,136,4,2,0,0,80,0,80,136,4,2,0,0,80,0,80,136,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,128,0,0,4,8,80,0,80,8,4,2,0,8,80,0,80,8,4,2,4,8,80,0,80,8,0,0,0,8,80,0,80,8,0,0,4,8,80,0,80,0,0,0,0,8,80,0,80,0,0,0,4,8,80,0,80,0,0,0,0,8,80,0,80,0,0,0,0,0,80,0,80,8,4,2,0,0,80,0,80,8,4,2,0,0,80,0,80,8,0,0,0,0,80,0,80,8,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,0,0,0,4,136,80,0,80,136,4,0,0,136,80,0,80,136,4,0,4,136,80,0,80,136,0,0,0,136,80,0,80,136,0,0,4,136,80,0,80,128,0,0,0,136,80,0,80,128,0,0,4,136,80,0,80,128,0,0,0,136,80,0,80,128,0,0,0,128,80,0,80,136,4,0,0,128,80,0,80,136,4,0,0,128,80,0,80,136,0,0,0,128,80,0,80,136,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,128,0,0,4,136,80,0,80,8,4,0,0,136,80,0,80,8,4,0,4,136,80,0,80,8,0,0,0,136,80,0,80,8,0,0,4,136,80,0,80,0,0,0,0,136,80,0,80,0,0,0,4,136,80,0,80,0,0,0,0,136,80,0,80,0,0,0,0,128,80,0,80,8,4,0,0,128,80,0,80,8,4,0,0,128,80,0,80,8,0,0,0,128,80,0,80,8,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,0,0,0,4,8,80,0,80,136,4,0,0,8,80,0,80,136,4,0,4,8,80,0,80,136,0,0,0,8,80,0,80,136,0,0,4,8,80,0,80,128,0,0,0,8,80,0,80,128,0,0,4,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+963082);allocate([80,0,80,128,0,0,0,8,80,0,80,128,0,0,0,0,80,0,80,136,4,0,0,0,80,0,80,136,4,0,0,0,80,0,80,136,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,128,0,0,4,8,80,0,80,8,4,0,0,8,80,0,80,8,4,0,4,8,80,0,80,8,0,0,0,8,80,0,80,8,0,0,4,8,80,0,80,0,0,0,0,8,80,0,80,0,0,0,4,8,80,0,80,0,0,0,0,8,80,0,80,0,0,0,0,0,80,0,80,8,4,0,0,0,80,0,80,8,4,0,0,0,80,0,80,8,0,0,0,0,80,0,80,8,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,0,0,0,8,16,160,0,160,16,8,4,8,16,160,0,160,16,8,0,0,16,160,0,160,16,8,4,0,16,160,0,160,16,8,0,0,0,160,0,160,16,8,4,0,0,160,0,160,16,8,0,0,0,160,0,160,16,8,4,0,0,160,0,160,16,8,0,8,16,160,0,160,16,0,0,8,16,160,0,160,16,0,0,0,16,160,0,160,16,0,0,0,16,160,0,160,16,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,16,0,0,8,16,160,0,160,0,0,0,8,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,8,16,160,0,160,0,0,0,8,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,16,32,64,0,64,32,16,8,16,32,64,0,64,0,0,0,16,32,64,0,64,32,16,0,16,32,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,32,64,0,64,32,16,8,0,32,64,0,64,0,0,0,0,32,64,0,64,32,16,0,0,0,64,0,64,32,16,8,0,0,64,0,64,0,0,0,0,0,64,0,64,32,16,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,32,16,8,0,0,64,0,64,0,0,0,0,0,64,0,64,32,16,0,16,32,64,0,64,32,0,0,16,32,64,0,64,0,0,0,16,32,64,0,64,32,0,0,16,32,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,32,64,0,64,32,0,0,0,32,64,0,64,0,0,0,0,32,64,0,64,32,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,32,0,0,16,8,4,2,0,2,4,8,0,0,0,2,0,2,4,8,0,8,4,2,0,2,4,8,0,0,0,2,0,2,4,8,0,0,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,0,2,0,2,0,0,16,8,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,8,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,4,2,0,2,4,8,0,0,0,2,0,2,4,8,0,0,4,2,0,2,4,8,0,0,0,2,0,2,4,8,16,8,4,2,0,2,4,0,0,0,0,2,0,2,4,0,0,8,4,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,0,2,0,2,0,0,16,8,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,8,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,4,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,4,2,0,2,4,0,0,0,0,2,0,2,4,0,32,16,8,5,0,5,8,16,0,0,0,5,0,5,8,16,0,16,8,5,0,5,8,16,0,0,0,5,0,5,8,16,32,16,8,5,0,5,8,0,0,0,0,5,0,5,8,0,0,16,8,5,0,5,8,0,0,0,0,5,0,5,8,0,0,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,32,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,32,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,8,0,0,0,8,5,0,5,8,16,0,0,0,5,0,5,8,16,0,0,8,5,0,5,8,16,0,0,0,5,0,5,8,16,0,0,8,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,8,5,0,5,8,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,64,32,17,10,0,10,17,32,0,0,17,10,0,10,0,0,64,32,16,10,0,10,16,32,0,0,17,10,0,10,1,0,64,32,16,10,0,10,17,32,0,0,16,10,0,10,0,0,64,32,17,10,0,10,16,32,0,0,16,10,0,10,1,0,64,32,17,10,0,10,17,0,0,0,17,10,0,10,0,0,64,32,16,10,0,10,16,0,0,0,1,10,0,10,1,0,64,32,16,10,0,10,17,0,0,0,16,10,0,10,0,0,64,32,17,10,0,10,16,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,17,32,0,0,1,10,0,10,0,0,0,0,0,10,0,10,16,32,0,0,1,10,0,10,1,0,0,0,0,10,0,10,17,32,0,0,0,10,0,10,0,0,0,0,1,10,0,10,16,32,0,0,0,10,0,10,1,0,0,0,1,10,0,10,17,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,16,0,64,32,17,10,0,10,1,0,0,0,0,10,0,10,17,0,0,0,0,10,0,10,0,0,0,0,1,10,0,10,16,0,64,32,16,10,0,10,1,0,0,0,17,10,0,10,17,32,64,32,17,10,0,10,0,0,0,0,16,10,0,10,16,32,64,32,17,10,0,10,1,0,0,0,16,10,0,10,17,32,64,32,16,10,0,10,0,0,0,0,17,10,0,10,16,32,64,32,16,10,0,10,1,0,0,0,17,10,0,10,17,0,64,32,17,10,0,10,0,0,0,0,16,10,0,10,16,0,0,0,1,10,0,10,1,0,0,0,16,10,0,10,17,0,64,32,16,10,0,10,0,0,0,0,17,10,0,10,16,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,17,32,0,0,1,10,0,10,0,0,0,0,0,10,0,10,16,32,0,0,1,10,0,10,1,0,0,0,0,10,0,10,17,32,0,0,0,10,0,10,0,0,0,0,1,10,0,10,16,32,0,0,0,10,0,10,1,0,0,0,1,10,0,10,17,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,16,0,0,0,17,10,0,10,1,0,0,0,0,10,0,10,17,0,0,0,0,10,0,10,0,0,0,0,1,10,0,10,16,0,0,0,16,10,0,10,1,0,0,32,17,10,0,10,17,32,0,0,17,10,0,10,0,0,0,32,16,10,0,10,16,32,0,0,17,10,0,10,1,0,0,32,16,10,0,10,17,32,0,0,16,10,0,10,0,0,0,32,17,10,0,10,16,32,0,0,16,10,0,10,1,0,0,32,17,10,0,10,17,0,0,0,17,10,0,10,0,0,0,32,16,10,0,10,16,0,0,0,1,10,0,10,1,0,0,32,16,10,0,10,17,0,0,0,16,10,0,10,0,0,0,32,17,10,0,10,16,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,17,32,0,0,1,10,0,10,0,0,0,0,0,10,0,10,16,32,0,0,1,10,0,10,1,0,0,0,0,10,0,10,17,32,0,0,0,10,0,10,0,0,0,0,1,10,0,10,16,32,0,0,0,10,0,10,1,0,0,0,1,10,0,10,17,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,16,0,0,32,17,10,0,10,1,0,0,0,0,10,0,10,17,0,0,0,0,10,0,10,0,0,0,0,1,10,0,10,16,0,0,32,16,10,0,10,1,0,0,0,17,10,0,10,17,32,0,32,17,10,0,10,0,0,0,0,16,10,0,10,16,32,0,32,17,10,0,10,1,0,0,0,16,10,0,10,17,32,0,32,16,10,0,10,0,0,0,0,17,10,0,10,16,32,0,32,16,10,0,10,1,0,0,0,17,10,0,10,17,0,0,32,17,10,0,10,0,0,0,0,16,10,0,10,16,0,0,0,1,10,0,10,1,0,0,0,16,10,0,10,17,0,0,32,16,10,0,10,0,0,0,0,17,10,0,10,16,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,17,32,0,0,1,10,0,10,0,0,0,0,0,10,0,10,16,32,0,0,1,10,0,10,1,0,0,0,0,10,0,10,17,32,0,0,0,10,0,10,0,0,0,0,1,10,0,10,16,32,0,0,0,10,0,10,1,0,0,0,1,10,0,10,17,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,16,0,0,0,17,10,0,10,1,0,0,0,0,10,0,10,17,0,0,0,0,10,0,10,0,0,0,0,1,10,0,10,16,0,0,0,16,10,0,10,1,0,128,65,34,20,0,20,34,65,0,65,34,20,0,20,34,65,128,65,34,20,0,20,34,64,0,65,34,20,0,20,34,64,0,0,32,20,0,20,32,64,0,0,32,20,0,20,32,64,0,0,32,20,0,20,32,64,0,0,32,20,0,20,32,64,128,64,34,20,0,20,34,65,0,64,34,20,0,20,34,65,128,64,34,20,0,20,34,64,0,64,34,20,0,20,34,64,0,0,32,20,0,20,32,64,0,0,32,20,0,20,32,64,0,0,32,20,0,20,32,64,0,0,32,20,0,20,32,64,0,1,2,20,0,20,2,1,0,1,2,20,0,20,2,1,0,1,2,20,0,20,2,0,0,1,2,20,0,20,2,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,0,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,128,64,34,20,0,20,34,1,0,64,34,20,0,20,34,1,128,64,34,20,0,20,34,0,0,64,34,20,0,20,34,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,32,0,128,65,34,20,0,20,34,1,0,65,34,20,0,20,34,1,128,65,34,20,0,20,34,0,0,65,34,20,0,20,34,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,32,0,0,0,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,0,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,1,2,20,0,20,2,1,0,1,2,20,0,20,2,1,0,1,2,20,0,20,2,0,0,1,2,20,0,20,2,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,128,64,32,20,0,20,34,65,0,64,32,20,0,20,34,65,128,64,32,20,0,20,34,64,0,64,32,20,0,20,34,64,0,1,34,20,0,20,32,64,0,1,34,20,0,20,32,64,0,1,34,20,0,20,32,64,0,1,34,20,0,20,32,64,128,64,32,20,0,20,34,65,0,64,32,20,0,20,34,65,128,64,32,20,0,20,34,64,0,64,32,20,0,20,34,64,0,0,34,20,0,20,32,64,0,0,34,20,0,20,32,64,0,0,34,20,0,20,32,64,0,0,34,20,0,20,32,64,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,128,64,32,20,0,20,34,1,0,64,32,20,0,20,34,1,128,64,32,20,0,20,34,0,0,64,32,20,0,20,34,0,0,0,34,20,0,20,32,0,0,0,34,20,0,20,32,0,0,0,34,20,0,20,32,0,0,0,34,20,0,20,32,0,128,64,32,20,0,20,34,1,0,64,32,20,0,20,34,1,128,64,32,20,0,20,34,0,0,64,32,20,0,20,34,0,0,1,34,20,0,20,32,0,0,1,34,20,0,20,32,0,0,1,34,20,0,20,32,0,0,1,34,20,0,20,32,0,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,34,20,0,20,34,64,0,1,34,20,0,20,34,64,0,1,34,20,0,20,34,65,0,1,34,20,0,20,34,65,128,64,32,20,0,20,32,64,0,64,32,20,0,20,32,64,128,64,32,20,0,20,32,64,0,64,32,20,0,20,32,64,0,0,34,20,0,20,34,64,0,0,34,20,0,20,34,64,0,0,34,20,0,20,34,65,0,0,34,20,0,20,34,65,128,64,32,20,0,20,32,64,0,64,32,20,0,20,32,64,128,64,32,20,0,20,32,64,0,64,32,20,0,20,32,64,0,1,2,20,0,20,2,0,0,1,2,20,0,20,2,0,0,1,2,20,0,20,2,1,0,1,2,20,0,20,2,1,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,0,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,34,20,0,20,34,0,0,0,34,20,0,20,34,0,0,0,34,20,0,20,34,1,0,0,34,20,0,20,34,1,128,64,32,20,0,20,32,0,0,64,32,20,0,20,32,0,128,64,32,20,0,20,32,0,0,64,32,20,0,20,32,0,0,1,34,20,0,20,34,0,0,1,34,20,0,20,34,0,0,1,34,20,0,20,34,1,0,1,34,20,0,20,34,1,128,64,32,20,0,20,32,0,0,64,32,20,0,20,32,0,128,64,32,20,0,20,32,0,0,64,32,20,0,20,32,0,0,0,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,0,2,20,0,20,2,1,0,0,2,20,0,20,2,1,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,1,2,20,0,20,2,0,0,1,2,20,0,20,2,0,0,1,2,20,0,20,2,1,0,1,2,20,0,20,2,1,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,32,20,0,20,34,64,0,0,32,20,0,20,34,64,0,0,32,20,0,20,34,65,0,0,32,20,0,20,34,65,128,65,34,20,0,20,32,64,0,65,34,20,0,20,32,64,128,65,34,20,0,20,32,64,0,65,34,20,0,20,32,64,0,0,32,20,0,20,34,64,0,0,32,20,0,20,34,64,0,0,32,20,0,20,34,65,0,0,32,20,0,20,34,65,128,64,34,20,0,20,32,64,0,64,34,20,0,20,32,64,128,64,34,20,0,20,32,64,0,64,34,20,0,20,32,64,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,32,20,0,20,34,0,0,0,32,20,0,20,34,0,0,0,32,20,0,20,34,1,0,0,32,20,0,20,34,1,128,64,34,20,0,20,32,0,0,64,34,20,0,20,32,0,128,64,34,20,0,20,32,0,0,64,34,20,0,20,32,0,0,0,32,20,0,20,34,0,0,0,32,20,0,20,34,0,0,0,32,20,0,20,34,1,0,0,32,20,0,20,34,1,128,65,34,20,0,20,32,0,0,65,34,20,0,20,32,0,128,65,34,20,0,20,32,0,0,65,34,20,0,20,32,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,1,0,0,0,20,0,20,2,1,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,34,65,0,1,2,20,0,20,34,65,0,1,2,20,0,20,34,64,0,1,2,20,0,20,34,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,2,20,0,20,34,65,0,0,2,20,0,20,34,65,0,0,2,20,0,20,34,64,0,0,2,20,0,20,34,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,128,65,34,20,0,20,2,1,0,65,34,20,0,20,2,1,128,65,34,20,0,20,2,0,0,65,34,20,0,20,2,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,128,64,34,20,0,20,2,1,0,64,34,20,0,20,2,1,128,64,34,20,0,20,2,0,0,64,34,20,0,20,2,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,2,20,0,20,34,1,0,0,2,20,0,20,34,1,0,0,2,20,0,20,34,0,0,0,2,20,0,20,34,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,1,2,20,0,20,34,1,0,1,2,20,0,20,34,1,0,1,2,20,0,20,34,0,0,1,2,20,0,20,34,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,128,64,34,20,0,20,2,1,0,64,34,20,0,20,2,1,128,64,34,20,0,20,2,0,0,64,34,20,0,20,2,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,128,65,34,20,0,20,2,1,0,65,34,20,0,20,2,1,128,65,34,20,0,20,2,0,0,65,34,20,0,20,2,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,0,0,20,0,20,34,65,0,0,0,20,0,20,34,65,0,0,0,20,0,20,34,64,0,0,0,20,0,20,34,64,0,1,2,20,0,20,32,64,0,1,2,20,0,20,32,64,0,1,2,20,0,20,32,64,0,1,2,20,0,20,32,64,0,0,0,20,0,20,34,65,0,0,0,20,0,20,34,65,0,0,0,20,0,20,34,64,0,0,0,20,0,20,34,64,0,0,2,20,0,20,32,64,0,0,2,20,0,20,32,64,0,0,2,20,0,20,32,64,0,0,2,20,0,20,32,64,128,64,32,20,0,20,2,1,0,64,32,20,0,20,2,1,128,64,32,20,0,20,2,0,0,64,32,20,0,20,2,0,0,1,34,20,0,20,0,0,0,1,34,20,0,20,0,0,0,1,34,20,0,20,0,0,0,1,34,20,0,20,0,0,128,64,32,20,0,20,2,1,0,64,32,20,0,20,2,1,128,64,32,20,0,20,2,0,0,64,32,20,0,20,2,0,0,0,34,20,0,20,0,0,0,0,34,20,0,20,0,0,0,0,34,20,0,20,0,0,0,0,34,20,0,20,0,0,0,0,0,20,0,20,34,1,0,0,0,20,0,20,34,1,0,0,0,20,0,20,34,0,0,0,0,20,0,20,34,0,0,0,2,20,0,20,32,0,0,0,2,20,0,20,32,0,0,0,2,20,0,20,32,0,0,0,2,20,0,20,32,0,0,0,0,20,0,20,34,1,0,0,0,20,0,20,34,1,0,0,0,20,0,20,34,0,0,0,0,20,0,20,34,0,0,1,2,20,0,20,32,0,0,1,2,20,0,20,32,0,0,1,2,20,0,20,32,0,0,1,2,20,0,20,32,0,128,64,32,20,0,20,2,1,0,64,32,20,0,20,2,1,128,64,32,20,0,20,2,0,0,64,32,20,0,20,2,0,0,0,34,20,0,20,0,0,0,0,34,20,0,20,0,0,0,0,34,20,0,20,0,0,0,0,34,20,0,20,0,0,128,64,32,20,0,20,2,1,0,64,32,20,0,20,2,1,128,64,32,20,0,20,2,0,0,64,32,20,0,20,2,0,0,1,34,20,0,20,0,0,0,1,34,20,0,20,0,0,0,1,34,20,0,20,0,0,0,1,34,20,0,20,0,0,0,1,2,20,0,20,34,64,0,1,2,20,0,20,34,64,0,1,2,20,0,20,34,65,0,1,2,20,0,20,34,65,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,2,20,0,20,34,64,0,0,2,20,0,20,34,64,0,0,2,20,0,20,34,65,0,0,2,20,0,20,34,65,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,0,0,20,0,20,32,64,0,1,34,20,0,20,2,0,0,1,34,20,0,20,2,0,0,1,34,20,0,20,2,1,0,1,34,20,0,20,2,1,128,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,128,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,34,20,0,20,2,0,0,0,34,20,0,20,2,0,0,0,34,20,0,20,2,1,0,0,34,20,0,20,2,1,128,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,128,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,2,20,0,20,34,0,0,0,2,20,0,20,34,0,0,0,2,20,0,20,34,1,0,0,2,20,0,20,34,1,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,1,2,20,0,20,34,0,0,1,2,20,0,20,34,0,0,1,2,20,0,20,34,1,0,1,2,20,0,20,34,1,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,34,20,0,20,2,0,0,0,34,20,0,20,2,0,0,0,34,20,0,20,2,1,0,0,34,20,0,20,2,1,128,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,128,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,1,34,20,0,20,2,0,0,1,34,20,0,20,2,0,0,1,34,20,0,20,2,1,0,1,34,20,0,20,2,1,128,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,128,64,32,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,0,20,0,20,34,64,0,0,0,20,0,20,34,64,0,0,0,20,0,20,34,65,0,0,0,20,0,20,34,65,0,1,2,20,0,20,32,64,0,1,2,20,0,20,32,64,0,1,2,20,0,20,32,64,0,1,2,20,0,20,32,64,0,0,0,20,0,20,34,64,0,0,0,20,0,20,34,64,0,0,0,20,0,20,34,65,0,0,0,20,0,20,34,65,0,0,2,20,0,20,32,64,0,0,2,20,0,20,32,64,0,0,2,20,0,20,32,64,0,0,2,20,0,20,32,64,0,0,32,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,2,1,0,0,32,20,0,20,2,1,128,65,34,20,0,20,0,0,0,65,34,20,0,20,0,0,128,65,34,20,0,20,0,0,0,65,34,20,0,20,0,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,2,1,0,0,32,20,0,20,2,1,128,64,34,20,0,20,0,0,0,64,34,20,0,20,0,0,128,64,34,20,0,20,0,0,0,64,34,20,0,20,0,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,34,1,0,0,0,20,0,20,34,1,0,0,2,20,0,20,32,0,0,0,2,20,0,20,32,0,0,0,2,20,0,20,32,0,0,0,2,20,0,20,32,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,34,1,0,0,0,20,0,20,34,1,0,1,2,20,0,20,32,0,0,1,2,20,0,20,32,0,0,1,2,20,0,20,32,0,0,1,2,20,0,20,32,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,2,1,0,0,32,20,0,20,2,1,128,64,34,20,0,20,0,0,0,64,34,20,0,20,0,0,128,64,34,20,0,20,0,0,0,64,34,20,0,20,0,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,2,0,0,0,32,20,0,20,2,1,0,0,32,20,0,20,2,1,128,65,34,20,0,20,0,0,0,65,34,20,0,20,0,0,128,65,34,20,0,20,0,0,0,65,34,20,0,20,0,0,1,130,68,40,0,40,68,130,0,0,64,40,0,40,68,128,0,128,68,40,0,40,68,130,0,0,64,40,0,40,68,128,1,130,68,40,0,40,68,2,0,0,64,40,0,40,68,0,0,128,68,40,0,40,68,2,0,0,64,40,0,40,68,0,0,130,68,40,0,40,68,130,0,0,64,40,0,40,68,128,0,128,68,40,0,40,68,130,0,0,64,40,0,40,68,128,0,130,68,40,0,40,68,2,0,0,64,40,0,40,68,0,0,128,68,40,0,40,68,2,0,0,64,40,0,40,68,0,0,0,4,40,0,40,4,2,0,0,0,40,0,40,4,0,1,2,4,40,0,40,4,2,0,0,0,40,0,40,4,0,0,0,4,40,0,40,4,2,0,0,0,40,0,40,4,0,1,2,4,40,0,40,4,2,0,0,0,40,0,40,4,0,0,0,4,40,0,40,4,2,0,0,0,40,0,40,4,0,0,2,4,40,0,40,4,2,0,0,0,40,0,40,4,0,0,0,4,40,0,40,4,2,0,0,0,40,0,40,4,0,0,2,4,40,0,40,4,2,0,0,0,40,0,40,4,0,0,128,64,40,0,40,68,130,1,2,68,40,0,40,68,130,0,128,64,40,0,40,68,130,0,0,68,40,0,40,68,130,0,128,64,40,0,40,68,2,1,2,68,40,0,40,68,2,0,128,64,40,0,40,68,2,0,0,68,40,0,40,68,2,0,128,64,40,0,40,68,130,0,2,68,40,0,40,68,130,0,128,64,40,0,40,68,130,0,0,68,40,0,40,68,130,0,128,64,40,0,40,68,2,0,2,68,40,0,40,68,2,0,128,64,40,0,40,68,2,0,0,68,40,0,40,68,2,0,0,0,40,0,40,4,2,0,0,4,40,0,40,4,2,0,0,0,40,0,40,4,2,1,2,4,40,0,40,4,2,0,0,0,40,0,40,4,2,0,0,4,40,0,40,4,2,0,0,0,40,0,40,4,2,1,2,4,40,0,40,4,2,0,0,0,40,0,40,4,2,0,0,4,40,0,40,4,2,0,0,0,40,0,40,4,2,0,2,4,40,0,40,4,2,0,0,0,40,0,40,4,2,0,0,4,40,0,40,4,2,0,0,0,40,0,40,4,2,0,2,4,40,0,40,4,2,1,130,68,40,0,40,68,128,0,0,64,40,0,40,68,130,0,128,68,40,0,40,68,128,0,0,64,40,0,40,68,130,1,130,68,40,0,40,68,0,0,0,64,40,0,40,68,2,0,128,68,40,0,40,68,0,0,0,64,40,0,40,68,2,0,130,68,40,0,40,68,128,0,0,64,40,0,40,68,130,0,128,68,40,0,40,68,128,0,0,64,40,0,40,68,130,0,130,68,40,0,40,68,0,0,0,64,40,0,40,68,2,0,128,68,40,0,40,68,0,0,0,64,40,0,40,68,2,0,0,4,40,0,40,4,0,0,0,0,40,0,40,4,2,1,2,4,40,0,40,4,0,0,0,0,40,0,40,4,2,0,0,4,40,0,40,4,0,0,0,0,40,0,40,4,2,1,2,4,40,0,40,4,0,0,0,0,40,0,40,4,2,0,0,4,40,0,40,4,0,0,0,0,40,0,40,4,2,0,2,4,40,0,40,4,0,0,0,0,40,0,40,4,2,0,0,4,40,0,40,4,0,0,0,0,40,0,40,4,2,0,2,4,40,0,40,4,0,0,0,0,40,0,40,4,2,0,128,64,40,0,40,68,128,1,2,68,40,0,40,68,128,0,128,64,40,0,40,68,128,0,0,68,40,0,40,68,128,0,128,64,40,0,40,68,0,1,2,68,40,0,40,68,0,0,128,64,40,0,40,68,0,0,0,68,40,0,40,68,0,0,128,64,40,0,40,68,128,0,2,68,40,0,40,68,128,0,128,64,40,0,40,68,128,0,0,68,40,0,40,68,128,0,128,64,40,0,40,68,0,0,2,68,40,0,40,68,0,0,128,64,40,0,40,68,0,0,0,68,40,0,40,68,0,0,0,0,40,0,40,4,0,0,0,4,40,0,40,4,0,0,0,0,40,0,40,4,0,1,2,4,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,4,40,0,40,4,0,0,0,0,40,0,40,4,0,1,2,4,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,4,40,0,40,4,0,0,0,0,40,0,40,4,0,0,2,4,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,4,40,0,40,4,0,0,0,0,40,0,40,4,0,0,2,4,40,0,40,4,0,1,2,4,40,0,40,68,130,0,0,0,40,0,40,68,128,0,0,4,40,0,40,68,130,0,0,0,40,0,40,68,128,1,2,4,40,0,40,68,2,0,0,0,40,0,40,68,0,0,0,4,40,0,40,68,2,0,0,0,40,0,40,68,0,0,2,4,40,0,40,68,130,0,0,0,40,0,40,68,128,0,0,4,40,0,40,68,130,0,0,0,40,0,40,68,128,0,2,4,40,0,40,68,2,0,0,0,40,0,40,68,0,0,0,4,40,0,40,68,2,0,0,0,40,0,40,68,0,0,128,68,40,0,40,4,2,0,0,64,40,0,40,4,0,1,130,68,40,0,40,4,2,0,0,64,40,0,40,4,0,0,128,68,40,0,40,4,2,0,0,64,40,0,40,4,0,1,130,68,40,0,40,4,2,0,0,64,40,0,40,4,0,0,128,68,40,0,40,4,2,0,0,64,40,0,40,4,0,0,130,68,40,0,40,4,2,0,0,64,40,0,40,4,0,0,128,68,40,0,40,4,2,0,0,64,40,0,40,4,0,0,130,68,40,0,40,4,2,0,0,64,40,0,40,4,0,0,0,0,40,0,40,68,130,1,2,4,40,0,40,68,130,0,0,0,40,0,40,68,130,0,0,4,40,0,40,68,130,0,0,0,40,0,40,68,2,1,2,4,40,0,40,68,2,0,0,0,40,0,40,68,2,0,0,4,40,0,40,68,2,0,0,0,40,0,40,68,130,0,2,4,40,0,40,68,130,0,0,0,40,0,40,68,130,0,0,4,40,0,40,68,130,0,0,0,40,0,40,68,2,0,2,4,40,0,40,68,2,0,0,0,40,0,40,68,2,0,0,4,40,0,40,68,2,0,128,64,40,0,40,4,2,0,0,68,40,0,40,4,2,0,128,64,40,0,40,4,2,1,2,68,40,0,40,4,2,0,128,64,40,0,40,4,2,0,0,68,40,0,40,4,2,0,128,64,40,0,40,4,2,1,2,68,40,0,40,4,2,0,128,64,40,0,40,4,2,0,0,68,40,0,40,4,2,0,128,64,40,0,40,4,2,0,2,68,40,0,40,4,2,0,128,64,40,0,40,4,2,0,0,68,40,0,40,4,2,0,128,64,40,0,40,4,2,0,2,68,40,0,40,4,2,1,2,4,40,0,40,68,128,0,0,0,40,0,40,68,130,0,0,4,40,0,40,68,128,0,0,0,40,0,40,68,130,1,2,4,40,0,40,68,0,0,0,0,40,0,40,68,2,0,0,4,40,0,40,68,0,0,0,0,40,0,40,68,2,0,2,4,40,0,40,68,128,0,0,0,40,0,40,68,130,0,0,4,40,0,40,68,128,0,0,0,40,0,40,68,130,0,2,4,40,0,40,68,0,0,0,0,40,0,40,68,2,0,0,4,40,0,40,68,0,0,0,0,40,0,40,68,2,0,128,68,40,0,40,4,0,0,0,64,40,0,40,4,2,1,130,68,40,0,40,4,0,0,0,64,40,0,40,4,2,0,128,68,40,0,40,4,0,0,0,64,40,0,40,4,2,1,130,68,40,0,40,4,0,0,0,64,40,0,40,4,2,0,128,68,40,0,40,4,0,0,0,64,40,0,40,4,2,0,130,68,40,0,40,4,0,0,0,64,40,0,40,4,2,0,128,68,40,0,40,4,0,0,0,64,40,0,40,4,2,0,130,68,40,0,40,4,0,0,0,64,40,0,40,4,2,0,0,0,40,0,40,68,128,1,2,4,40,0,40,68,128,0,0,0,40,0,40,68,128,0,0,4,40,0,40,68,128,0,0,0,40,0,40,68,0,1,2,4,40,0,40,68,0,0,0,0,40,0,40,68,0,0,0,4,40,0,40,68,0,0,0,0,40,0,40,68,128,0,2,4,40,0,40,68,128,0,0,0,40,0,40,68,128,0,0,4,40,0,40,68,128,0,0,0,40,0,40,68,0,0,2,4,40,0,40,68,0,0,0,0,40,0,40,68,0,0,0,4,40,0,40,68,0,0,128,64,40,0,40,4,0,0,0,68,40,0,40,4,0,0,128,64,40,0,40,4,0,1,2,68,40,0,40,4,0,0,128,64,40,0,40,4,0,0,0,68,40,0,40,4,0,0,128,64,40,0,40,4,0,1,2,68,40,0,40,4,0,0,128,64,40,0,40,4,0,0,0,68,40,0,40,4,0,0,128,64,40,0,40,4,0,0,2,68,40,0,40,4,0,0,128,64,40,0,40,4,0,0,0,68,40,0,40,4,0,0,128,64,40,0,40,4,0,0,2,68,40,0,40,4,0,0,128,64,40,0,40,64,0,0,2,68,40,0,40,64,0,0,128,64,40,0,40,64,0,0,0,68,40,0,40,64,0,0,128,64,40,0,40,64,128,1,2,68,40,0,40,64,128,0,128,64,40,0,40,64,128,0,0,68,40,0,40,64,128,0,128,64,40,0,40,64,0,1,2,68,40,0,40,64,0,0,128,64,40,0,40,64,0,0,0,68,40,0,40,64,0,0,128,64,40,0,40,64,128,0,2,68,40,0,40,64,128,0,128,64,40,0,40,64,128,0,0,68,40,0,40,64,128,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,1,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,1,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,2,4,40,0,40,0,0,0,130,68,40,0,40,64,0,0,0,64,40,0,40,64,0,0,128,68,40,0,40,64,0,0,0,64,40,0,40,64,0,1,130,68,40,0,40,64,128,0,0,64,40,0,40,64,128,0,128,68,40,0,40,64,128,0,0,64,40,0,40,64,128,1,130,68,40,0,40,64,0,0,0,64,40,0,40,64,0,0,128,68,40,0,40,64,0,0,0,64,40,0,40,64,0,0,130,68,40,0,40,64,128,0,0,64,40,0,40,64,128,0,128,68,40,0,40,64,128,0,0,64,40,0,40,64,128,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,1,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,1,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,128,64,40,0,40,64,0,0,2,68,40,0,40,64,0,0,128,64,40,0,40,64,0,0,0,68,40,0,40,64,0,0,128,64,40,0,40,64,128,1,2,68,40,0,40,64,128,0,128,64,40,0,40,64,128,0,0,68,40,0,40,64,128,0,128,64,40,0,40,64,0,1,2,68,40,0,40,64,0,0,128,64,40,0,40,64,0,0,0,68,40,0,40,64,0,0,128,64,40,0,40,64,128,0,2,68,40,0,40,64,128,0,128,64,40,0,40,64,128,0,0,68,40,0,40,64,128,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,1,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,1,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,2,4,40,0,40,0,0,0,130,68,40,0,40,64,0,0,0,64,40,0,40,64,0,0,128,68,40,0,40,64,0,0,0,64,40,0,40,64,0,1,130,68,40,0,40,64,128,0,0,64,40,0,40,64,128,0,128,68,40,0,40,64,128,0,0,64,40,0,40,64,128,1,130,68,40,0,40,64,0,0,0,64,40,0,40,64,0,0,128,68,40,0,40,64,0,0,0,64,40,0,40,64,0,0,130,68,40,0,40,64,128,0,0,64,40,0,40,64,128,0,128,68,40,0,40,64,128,0,0,64,40,0,40,64,128,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,1,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,1,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,2,4,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,64,0,0,2,4,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,0,40,0,40,64,128,1,2,4,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,0,40,0,40,64,0,1,2,4,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,0,40,0,40,64,128,0,2,4,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,4,40,0,40,64,128,0,128,64,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,64,40,0,40,0,0,0,2,68,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,64,40,0,40,0,0,1,2,68,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,64,40,0,40,0,0,1,2,68,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,64,40,0,40,0,0,0,2,68,40,0,40,0,0,0,2,4,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,0,40,0,40,64,0,1,2,4,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,0,40,0,40,64,128,1,2,4,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,0,40,0,40,64,0,0,2,4,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,0,40,0,40,64,128,0,128,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,130,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,64,40,0,40,0,0,1,130,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,64,40,0,40,0,0,1,130,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,130,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,0,40,0,40,64,0,0,2,4,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,0,40,0,40,64,128,1,2,4,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,0,40,0,40,64,0,1,2,4,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,0,40,0,40,64,128,0,2,4,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,4,40,0,40,64,128,0,128,64,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,64,40,0,40,0,0,0,2,68,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,64,40,0,40,0,0,1,2,68,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,64,40,0,40,0,0,1,2,68,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,68,40,0,40,0,0,0,128,64,40,0,40,0,0,0,2,68,40,0,40,0,0,0,2,4,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,0,40,0,40,64,0,1,2,4,40,0,40,64,128,0,0,0,40,0,40,64,128],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+973322);allocate([4,40,0,40,64,128,0,0,0,40,0,40,64,128,1,2,4,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,0,40,0,40,64,0,0,2,4,40,0,40,64,128,0,0,0,40,0,40,64,128,0,0,4,40,0,40,64,128,0,0,0,40,0,40,64,128,0,128,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,130,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,64,40,0,40,0,0,1,130,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,64,40,0,40,0,0,1,130,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,64,40,0,40,0,0,0,130,68,40,0,40,0,0,0,0,64,40,0,40,0,0,2,4,136,80,0,80,136,4,0,0,0,80,0,80,8,4,2,4,136,80,0,80,136,0,0,0,0,80,0,80,8,0,2,4,136,80,0,80,128,0,0,0,0,80,0,80,0,0,2,4,136,80,0,80,128,0,0,0,0,80,0,80,0,0,0,0,128,80,0,80,136,4,0,0,8,80,0,80,136,4,0,0,128,80,0,80,136,0,0,0,8,80,0,80,136,0,0,0,128,80,0,80,128,0,0,0,8,80,0,80,128,0,0,0,128,80,0,80,128,0,0,0,8,80,0,80,128,0,2,4,136,80,0,80,8,4,0,0,0,80,0,80,136,4,2,4,136,80,0,80,8,0,0,0,0,80,0,80,136,0,2,4,136,80,0,80,0,0,0,0,0,80,0,80,128,0,2,4,136,80,0,80,0,0,0,0,0,80,0,80,128,0,0,0,128,80,0,80,8,4,0,0,8,80,0,80,8,4,0,0,128,80,0,80,8,0,0,0,8,80,0,80,8,0,0,0,128,80,0,80,0,0,0,0,8,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,8,80,0,80,0,0,2,4,8,80,0,80,136,4,0,0,128,80,0,80,8,4,2,4,8,80,0,80,136,0,0,0,128,80,0,80,8,0,2,4,8,80,0,80,128,0,0,0,128,80,0,80,0,0,2,4,8,80,0,80,128,0,0,0,128,80,0,80,0,0,0,0,0,80,0,80,136,4,0,4,136,80,0,80,136,4,0,0,0,80,0,80,136,0,0,4,136,80,0,80,136,0,0,0,0,80,0,80,128,0,0,4,136,80,0,80,128,0,0,0,0,80,0,80,128,0,0,4,136,80,0,80,128,0,2,4,8,80,0,80,8,4,0,0,128,80,0,80,136,4,2,4,8,80,0,80,8,0,0,0,128,80,0,80,136,0,2,4,8,80,0,80,0,0,0,0,128,80,0,80,128,0,2,4,8,80,0,80,0,0,0,0,128,80,0,80,128,0,0,0,0,80,0,80,8,4,0,4,136,80,0,80,8,4,0,0,0,80,0,80,8,0,0,4,136,80,0,80,8,0,0,0,0,80,0,80,0,0,0,4,136,80,0,80,0,0,0,0,0,80,0,80,0,0,0,4,136,80,0,80,0,0,0,0,136,80,0,80,136,4,0,0,0,80,0,80,8,4,0,0,136,80,0,80,136,0,0,0,0,80,0,80,8,0,0,0,136,80,0,80,128,0,0,0,0,80,0,80,0,0,0,0,136,80,0,80,128,0,0,0,0,80,0,80,0,0,0,0,128,80,0,80,136,4,0,4,8,80,0,80,136,4,0,0,128,80,0,80,136,0,0,4,8,80,0,80,136,0,0,0,128,80,0,80,128,0,0,4,8,80,0,80,128,0,0,0,128,80,0,80,128,0,0,4,8,80,0,80,128,0,0,0,136,80,0,80,8,4,0,0,0,80,0,80,136,4,0,0,136,80,0,80,8,0,0,0,0,80,0,80,136,0,0,0,136,80,0,80,0,0,0,0,0,80,0,80,128,0,0,0,136,80,0,80,0,0,0,0,0,80,0,80,128,0,0,0,128,80,0,80,8,4,0,4,8,80,0,80,8,4,0,0,128,80,0,80,8,0,0,4,8,80,0,80,8,0,0,0,128,80,0,80,0,0,0,4,8,80,0,80,0,0,0,0,128,80,0,80,0,0,0,4,8,80,0,80,0,0,0,0,8,80,0,80,136,4,0,0,128,80,0,80,8,4,0,0,8,80,0,80,136,0,0,0,128,80,0,80,8,0,0,0,8,80,0,80,128,0,0,0,128,80,0,80,0,0,0,0,8,80,0,80,128,0,0,0,128,80,0,80,0,0,0,0,0,80,0,80,136,4,0,0,136,80,0,80,136,4,0,0,0,80,0,80,136,0,0,0,136,80,0,80,136,0,0,0,0,80,0,80,128,0,0,0,136,80,0,80,128,0,0,0,0,80,0,80,128,0,0,0,136,80,0,80,128,0,0,0,8,80,0,80,8,4,0,0,128,80,0,80,136,4,0,0,8,80,0,80,8,0,0,0,128,80,0,80,136,0,0,0,8,80,0,80,0,0,0,0,128,80,0,80,128,0,0,0,8,80,0,80,0,0,0,0,128,80,0,80,128,0,0,0,0,80,0,80,8,4,0,0,136,80,0,80,8,4,0,0,0,80,0,80,8,0,0,0,136,80,0,80,8,0,0,0,0,80,0,80,0,0,0,0,136,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,136,80,0,80,0,0,4,8,16,160,0,160,16,8,0,0,16,160,0,160,0,0,4,8,16,160,0,160,16,0,0,0,16,160,0,160,0,0,0,8,16,160,0,160,16,8,0,0,16,160,0,160,0,0,0,8,16,160,0,160,16,0,0,0,16,160,0,160,0,0,0,0,0,160,0,160,16,8,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,8,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,8,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,8,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,16,160,0,160,16,8,0,8,16,160,0,160,0,0,0,0,16,160,0,160,16,0,4,8,16,160,0,160,0,0,0,0,16,160,0,160,16,8,4,8,16,160,0,160,0,0,0,0,16,160,0,160,16,0,0,8,16,160,0,160,0,0,8,16,32,64,0,64,32,16,0,16,32,64,0,64,32,16,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,32,16,0,0,32,64,0,64,32,16,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,8,16,32,64,0,64,32,0,0,16,32,64,0,64,32,0,0,0,32,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,32,64,0,64,32,0,0,0,32,64,0,64,32,0,8,16,32,64,0,64,0,0,0,16,32,64,0,64,0,0,0,0,0,64,0,64,32,16,0,0,0,64,0,64,32,16,0,0,32,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,32,16,0,0,0,64,0,64,32,16,8,16,32,64,0,64,0,0,0,16,32,64,0,64,0,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,32,16,8,4,2,0,2,4,0,0,0,4,2,0,2,4,0,0,8,4,2,0,2,4,0,0,0,4,2,0,2,4,32,16,8,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,8,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,16,8,4,2,0,2,4,0,0,0,4,2,0,2,4,0,0,8,4,2,0,2,4,0,0,0,4,2,0,2,4,0,16,8,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,8,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,4,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,64,32,16,8,5,0,5,8,0,32,16,8,5,0,5,8,0,0,16,8,5,0,5,8,0,0,16,8,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,8,5,0,5,8,0,0,0,8,5,0,5,8,0,0,0,8,5,0,5,8,0,0,0,8,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,8,0,0,0,0,5,0,5,8,0,0,16,8,5,0,5,0,0,0,16,8,5,0,5,0,64,32,16,8,5,0,5,0,0,32,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,0,5,0,5,0,128,64,32,17,10,0,10,17,128,64,32,16,10,0,10,17,128,64,32,17,10,0,10,16,128,64,32,16,10,0,10,16,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,0,10,0,10,16,128,64,32,17,10,0,10,1,128,64,32,16,10,0,10,1,128,64,32,17,10,0,10,0,128,64,32,16,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,0,0,0,32,17,10,0,10,17,0,0,32,16,10,0,10,17,0,0,32,17,10,0,10,16,0,0,32,16,10,0,10,16,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,0,10,0,10,16,0,0,32,17,10,0,10,1,0,0,32,16,10,0,10,1,0,0,32,17,10,0,10,0,0,0,32,16,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,0,0,64,32,17,10,0,10,1,0,64,32,16,10,0,10,1,0,64,32,17,10,0,10,0,0,64,32,16,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,0,0,64,32,17,10,0,10,17,0,64,32,16,10,0,10,17,0,64,32,17,10,0,10,16,0,64,32,16,10,0,10,16,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,0,10,0,10,16,0,0,32,17,10,0,10,1,0,0,32,16,10,0,10,1,0,0,32,17,10,0,10,0,0,0,32,16,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,0,0,0,32,17,10,0,10,17,0,0,32,16,10,0,10,17,0,0,32,17,10,0,10,16,0,0,32,16,10,0,10,16,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,0,10,0,10,16,0,0,0,17,10,0,10,17,0,0,0,16,10,0,10,17,0,0,0,17,10,0,10,16,0,0,0,16,10,0,10,16,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,0,10,0,10,16,0,0,0,17,10,0,10,1,0,0,0,16,10,0,10,1,0,0,0,17,10,0,10,0,0,0,0,16,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,17,10,0,10,17,0,0,0,16,10,0,10,17,0,0,0,17,10,0,10,16,0,0,0,16,10,0,10,16,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,0,10,0,10,16,0,0,0,17,10,0,10,1,0,0,0,16,10,0,10,1,0,0,0,17,10,0,10,0,0,0,0,16,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,17,10,0,10,1,0,0,0,16,10,0,10,1,0,0,0,17,10,0,10,0,0,0,0,16,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,17,10,0,10,17,0,0,0,16,10,0,10,17,0,0,0,17,10,0,10,16,0,0,0,16,10,0,10,16,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,0,10,0,10,16,0,0,0,17,10,0,10,1,0,0,0,16,10,0,10,1,0,0,0,17,10,0,10,0,0,0,0,16,10,0,10,0,0,0,0,1,10,0,10,1,0,0,0,0,10,0,10,1,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,17,10,0,10,17,0,0,0,16,10,0,10,17,0,0,0,17,10,0,10,16,0,0,0,16,10,0,10,16,0,0,0,1,10,0,10,17,0,0,0,0,10,0,10,17,0,0,0,1,10,0,10,16,0,0,0,0,10,0,10,16,0,128,65,34,20,0,20,34,0,0,1,34,20,0,20,32,0,0,0,2,20,0,20,0,0,0,0,34,20,0,20,0,0,0,1,2,20,0,20,34,0,0,1,2,20,0,20,32,0,0,64,34,20,0,20,0,0,0,0,2,20,0,20,0,0,128,65,34,20,0,20,2,0,0,1,34,20,0,20,0,0,0,0,2,20,0,20,32,0,0,0,34,20,0,20,32,0,0,1,2,20,0,20,2,0,0,1,2,20,0,20,0,0,0,64,34,20,0,20,32,0,0,0,2,20,0,20,32,0,0,1,34,20,0,20,34,0,128,64,34,20,0,20,2,0,0,0,2,20,0,20,0,0,0,65,34,20,0,20,34,0,0,1,2,20,0,20,34,0,0,0,2,20,0,20,2,0,0,0,34,20,0,20,0,0,0,1,2,20,0,20,34,0,0,1,34,20,0,20,2,0,128,64,34,20,0,20,34,0,0,0,2,20,0,20,32,0,0,65,34,20,0,20,2,0,0,1,2,20,0,20,2,0,0,0,2,20,0,20,34,0,0,0,34,20,0,20,32,0,0,1,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,0,34,20,0,20,2,0,128,65,34,20,0,20,32,0,0,1,34,20,0,20,34,0,0,64,34,20,0,20,2,0,0,0,2,20,0,20,2,0,0,1,2,20,0,20,32,0,0,1,2,20,0,20,34,0,0,0,2,20,0,20,34,0,0,0,34,20,0,20,34,0,128,65,34,20,0,20,0,0,0,1,34,20,0,20,2,0,0,64,34,20,0,20,34,0,0,0,2,20,0,20,34,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,2,0,0,0,2,20,0,20,2,0,0,65,34,20,0,20,32,0,0,1,34,20,0,20,32,0,128,64,34,20,0,20,0,0,0,0,34,20,0,20,2,0,0,1,2,20,0,20,32,0,0,1,2,20,0,20,32,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,34,0,0,65,34,20,0,20,0,0,0,1,34,20,0,20,0,0,128,64,34,20,0,20,32,0,0,0,34,20,0,20,34,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,0,2,20,0,20,32,0,0,0,32,20,0,20,32,0,128,64,32,20,0,20,34,0,0,0,32,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,32,20,0,20,0,0,128,64,32,20,0,20,2,0,0,0,32,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,32,0,0,64,32,20,0,20,32,0,128,64,32,20,0,20,2,0,0,0,32,20,0,20,34,0,0,64,32,20,0,20,34,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,34,0,0,0,32,20,0,20,0,0,128,64,32,20,0,20,34,0,0,0,32,20,0,20,2,0,0,64,32,20,0,20,2,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,32,20,0,20,32,0,0,0,32,20,0,20,2,0,0,0,0,20,0,20,2,0,0,0,32,20,0,20,34,0,128,64,32,20,0,20,32,0,0,0,0,20,0,20,2,0,0,64,32,20,0,20,2,0,0,0,0,20,0,20,34,0,0,0,0,20,0,20,32,0,0,0,32,20,0,20,34,0,0,0,0,20,0,20,34,0,0,0,32,20,0,20,2,0,128,64,32,20,0,20,0,0,0,0,0,20,0,20,34,0,0,64,32,20,0,20,34,0,0,0,0,20,0,20,2,0,0,0,0,20,0,20,0,0,0,64,32,20,0,20,32,0,0,0,0,20,0,20,2,0,128,64,32,20,0,20,0,0,0,0,32,20,0,20,32,0,0,0,0,20,0,20,32,0,0,0,32,20,0,20,2,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,32,0,0,64,32,20,0,20,0,0,0,0,0,20,0,20,34,0,128,64,32,20,0,20,32,0,0,0,32,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,32,20,0,20,34,0,0,0,0,20,0,20,32,0,0,0,0,20,0,20,0,0,1,130,68,40,0,40,68,0,1,2,4,40,0,40,68,0,0,130,68,40,0,40,68,0,0,2,4,40,0,40,68,0,0,128,68,40,0,40,68,0,0,0,4,40,0,40,68,0,0,128,68,40,0,40,68,0,0,0,4,40,0,40,68,0,1,130,68,40,0,40,64,0,1,2,4,40,0,40,64,0,0,130,68,40,0,40,64,0,0,2,4,40,0,40,64,0,0,128,68,40,0,40,64,0,0,0,4,40,0,40,64,0,0,128,68,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,64,40,0,40,68,0,0,0,0,40,0,40,68,0,0,0,64,40,0,40,68,0,0,0,0,40,0,40,68,0,0,0,64,40,0,40,68,0,0,0,0,40,0,40,68,0,0,0,64,40,0,40,68,0,0,0,0,40,0,40,68,0,0,0,64,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,64,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,64,40,0,40,64,0,0,0,0,40,0,40,64,0,0,0,64,40,0,40,64,0,0,0,0,40,0,40,64,0,1,130,68,40,0,40,4,0,1,2,4,40,0,40,4,0,0,130,68,40,0,40,4,0,0,2,4,40,0,40,4,0,0,128,68,40,0,40,4,0,0,0,4,40,0,40,4,0,0,128,68,40,0,40,4,0,0,0,4,40,0,40,4,0,1,130,68,40,0,40,0,0,1,2,4,40,0,40,0,0,0,130,68,40,0,40,0,0,0,2,4,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,4,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,64,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,64,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,64,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,64,40,0,40,4,0,0,0,0,40,0,40,4,0,0,0,64,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,0,40,0,40,0,0,1,2,68,40,0,40,68,0,1,2,4,40,0,40,68,0,0,2,68,40,0,40,68,0,0,2,4,40,0,40,68,0,0,0,68,40,0,40,68,0,0,0,4,40,0,40,68,0,0,0,68,40,0,40,68,0,0,0,4,40,0,40,68,0,1,2,68,40,0,40,64,0,1,2,4,40,0,40,64,0,0,2,68,40,0,40,64,0,0,2,4,40,0,40,64,0,0,0,68,40,0,40,64,0,0,0,4,40,0,40,64,0,0,0,68,40,0,40,64,0,0,0,4,40,0,40,64,0,0,128,64,40,0,40,68,0,0,0,0,40,0,40,68,0,0,128,64,40,0,40,68,0,0,0,0,40,0,40,68,0,0,128,64,40,0,40,68,0,0,0,0,40,0,40,68,0,0,128,64,40,0,40,68,0,0,0,0,40,0,40,68,0,0,128,64,40,0,40,64,0,0,0,0,40,0,40,64,0,0,128,64,40,0,40,64,0,0,0,0,40,0,40,64,0,0,128,64,40,0,40,64,0,0,0,0,40,0,40,64,0,0,128,64,40,0,40,64,0,0,0,0,40,0,40,64,0,1,2,68,40,0,40,4,0,1,2,4,40,0,40,4,0,0,2,68,40,0,40,4,0,0,2,4,40,0,40,4,0,0,0,68,40,0,40,4,0,0,0,4,40,0,40,4,0,0,0,68,40,0,40,4,0,0,0,4,40,0,40,4,0,1,2,68,40,0,40,0,0,1,2,4,40,0,40,0,0,0,2,68,40,0,40,0,0,0,2,4,40,0,40,0,0,0,0,68,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,68,40,0,40,0,0,0,0,4,40,0,40,0,0,0,128,64,40,0,40,4,0,0,0,0,40,0,40,4,0,0,128,64,40,0,40,4,0,0,0,0,40,0,40,4,0,0,128,64,40,0,40,4,0,0,0,0,40,0,40,4,0,0,128,64,40,0,40,4,0,0,0,0,40,0,40,4,0,0,128,64,40,0,40,0,0,0,0,0,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,0,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,0,40,0,40,0,0,0,128,64,40,0,40,0,0,0,0,0,40,0,40,0,1,2,4,136,80,0,80,136,0,0,0,136,80,0,80,8,0,0,0,128,80,0,80,136,0,0,0,128,80,0,80,8,0,0,0,136,80,0,80,136,0,2,4,136,80,0,80,8,0,0,0,128,80,0,80,136,0,0,0,128,80,0,80,8,1,2,4,8,80,0,80,136,0,0,0,8,80,0,80,8,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,8,0,0,0,8,80,0,80,136,0,2,4,8,80,0,80,8,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,8,0,0,0,136,80,0,80,0,1,2,4,136,80,0,80,128,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,128,0,2,4,136,80,0,80,0,0,0,0,136,80,0,80,128,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,128,0,0,0,8,80,0,80,0,1,2,4,8,80,0,80,128,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,128,0,2,4,8,80,0,80,0,0,0,0,8,80,0,80,128,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,128,0,0,4,136,80,0,80,136,0,0,0,136,80,0,80,8,0,0,0,128,80,0,80,136,0,0,0,128,80,0,80,8,0,0,0,136,80,0,80,136,0,0,4,136,80,0,80,8,0,0,0,128,80,0,80,136,0,0,0,128,80,0,80,8,0,0,4,8,80,0,80,136,0,0,0,8,80,0,80,8,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,8,0,0,0,8,80,0,80,136,0,0,4,8,80,0,80,8,0,0,0,0,80,0,80,136,0,0,0,0,80,0,80,8,0,0,0,136,80,0,80,0,0,0,4,136,80,0,80,128,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,128,0,0,4,136,80,0,80,0,0,0,0,136,80,0,80,128,0,0,0,128,80,0,80,0,0,0,0,128,80,0,80,128,0,0,0,8,80,0,80,0,0,0,4,8,80,0,80,128,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,128,0,0,4,8,80,0,80,0,0,0,0,8,80,0,80,128,0,0,0,0,80,0,80,0,0,0,0,0,80,0,80,128,0,0,0,136,80,0,80,8,0,2,4,136,80,0,80,136,0,0,0,128,80,0,80,8,0,0,0,128,80,0,80,136,1,2,4,136,80,0,80,8,0,0,0,136,80,0,80,136,0,0,0,128,80,0,80,8,0,0,0,128,80,0,80,136,0,0,0,8,80,0,80,8,0,2,4,8,80,0,80,136,0,0,0,0,80,0,80,8,0,0,0,0,80,0,80,136,1,2,4,8,80,0,80,8,0,0,0,8,80,0,80,136,0,0,0,0,80,0,80,8,0,0,0,0,80,0,80,136,0,2,4,136,80,0,80,128,0,0,0,136,80,0,80,0,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,0,0,0,0,136,80,0,80,128,1,2,4,136,80,0,80,0,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,0,0,2,4,8,80,0,80,128,0,0,0,8,80,0,80,0,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,0,0,0,0,8,80,0,80,128,1,2,4,8,80,0,80,0,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,0,0,0,0,136,80,0,80,8,0,0,4,136,80,0,80,136,0,0,0,128,80,0,80,8,0,0,0,128,80,0,80,136,0,0,4,136,80,0,80,8,0,0,0,136,80,0,80,136,0,0,0,128,80,0,80,8,0,0,0,128,80,0,80,136,0,0,0,8,80,0,80,8,0,0,4,8,80,0,80,136,0,0,0,0,80,0,80,8,0,0,0,0,80,0,80,136,0,0,4,8,80,0,80,8,0,0,0,8,80,0,80,136,0,0,0,0,80,0,80,8,0,0,0,0,80,0,80,136,0,0,4,136,80,0,80,128,0,0,0,136,80,0,80,0,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,0,0,0,0,136,80,0,80,128,0,0,4,136,80,0,80,0,0,0,0,128,80,0,80,128,0,0,0,128,80,0,80,0,0,0,4,8,80,0,80,128,0,0,0,8,80,0,80,0,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,0,0,0,0,8,80,0,80,128,0,0,4,8,80,0,80,0,0,0,0,0,80,0,80,128,0,0,0,0,80,0,80,0,2,4,8,16,160,0,160,16,0,0,8,16,160,0,160,16,0,4,8,16,160,0,160,16,0,0,8,16,160,0,160,16,2,4,8,16,160,0,160,0,0,0,8,16,160,0,160,0,0,4,8,16,160,0,160,0,0,0,8,16,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,16,160,0,160,16,0,0,0,16,160,0,160,16,0,0,0,16,160,0,160,16,0,0,0,16,160,0,160,16,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,16,0,0,0,0,160,0,160,16,4,8,16,32,64,0,64,32,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,16,32,64,0,64,32,0,0,0,32,64,0,64,32,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,32,4,8,16,32,64,0,64,0,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,32,0,0,16,32,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,32,0,0,0,32,64,0,64,0,0,8,16,32,64,0,64,32,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,16,32,64,0,64,32,0,0,0,32,64,0,64,32,0,0,0,0,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,32,0,8,16,32,64,0,64,0,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,32,0,0,16,32,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,32,0,0,0,0,64,0,64,32,0,0,0,32,64,0,64,0,64,32,16,8,4,2,0,2,0,0,0,0,4,2,0,2,0,0,16,8,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,8,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,8,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,32,16,8,4,2,0,2,0,0,0,0,4,2,0,2,0,0,16,8,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,8,4,2,0,2,0,0,0,0,4,2,0,2,0,0,0,8,4,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,2,128,64,32,16,8,5,0,5,0,0,0,0,0,5,0,5,0,64,32,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,32,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,32,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,16,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,0,0,0,8,5,0,5,0,0,0,0,0,5,0,5,0,128,64,32,17,10,0,10,0,0,0,0,17,10,0,10,0,0,64,32,17,10,0,10,0,0,0,0,17,10,0,10,0,0,0,32,17,10,0,10,0,0,0,0,17,10,0,10,0,0,0,32,17,10,0,10,0,0,0,0,17,10,0,10,0,0,0,32,16,10,0,10,0,0,0,0,16,10,0,10,0,0,0,32,16,10,0,10,0,0,0,0,16,10,0,10,0,128,64,32,16,10,0,10,0,0,0,0,16,10,0,10,0,0,64,32,16,10,0,10,0,0,0,0,16,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,1,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,0,0,0,0,0,10,0,10,0,0,128,65,34,20,0,20,0,0,0,1,34,20,0,20,0,0,128,64,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,64,34,20,0,20,0,0,0,0,34,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,65,34,20,0,20,0,0,0,1,34,20,0,20,0,0,0,64,32,20,0,20,0,0,0,0,32,20,0,20,0,0,128,64,34,20,0,20,0,0,0,0,34,20,0,20,0,0,128,64,32,20,0,20,0,0,0,0,32,20,0,20,0,0,0,1,2,20,0,20,0,0,0,1,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,2,20,0,20,0,0,0,0,0,20,0,20,0,0,0,0,0,20,0,20,0,0,1,130,68,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,130,68,40,0,40,0,0,0,128,68,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,1,2,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,128,64,40,0,40,0,0,0,128,64,40,0,40,0,0,0,2,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,128,64,40,0,40,0,0,0,128,64,40,0,40,0,0,1,2,68,40,0,40,0,0,0,0,68,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,0,2,68,40,0,40,0,0,0,0,68,40,0,40,0,0,0,0,0,40,0,40,0,0,0,0,0,40,0,40,0,0,1,2,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,0,0,2,4,40,0,40,0,0,0,0,4,40,0,40,0,0,0,0,64,40,0,40,0,0,0,0,64,40,0,40,0,1,2,4,136,80,0,80,0,0,0,0,8,80,0,80,0,0,0,4,136,80,0,80,0,0,0,0,8,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,0,80,0,80,0,0,2,4,136,80,0,80,0,0,0,0,8,80,0,80,0,0,0,4,136,80,0,80,0,0,0,0,8,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,136,80,0,80,0,1,2,4,8,80,0,80,0,0,0,0,136,80,0,80,0,0,0,4,8,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,136,80,0,80,0,0,2,4,8,80,0,80,0,0,0,0,136,80,0,80,0,0,0,4,8,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,0,80,0,80,0,0,0,0,128,80,0,80,0,0,0,0,0,80,0,80,1,2,4,8,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,8,16,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,16,160,0,160,0,0,0,8,16,160,0,160,0,0,4,8,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,2,4,8,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,8,16,160,0,160,0,0,4,8,16,160,0,160,0,0,0,0,16,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,0,160,0,160,0,0,0,0,16,160,0,160,0,0,0,8,16,160,0,160,2,4,8,16,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,0,4,8,16,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,16,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,16,32,64,0,64,0,0,0,0,0,64,0,64,0,0,8,16,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,0,0,8,16,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,16,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,0,32,64,0,64,0,0,0,0,0,64,0,64,0,0,0,16,32,64,0,64,0,0,0,0,0,64,0,64,128,64,32,16,8,4,2,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,16,8,4,2,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,32,16,8,4,2,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,16,8,4,2,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,64,32,16,8,4,2,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,16,8,4,2,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,32,16,8,4,2,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,16,8,4,2,0,0,0,0,0,8,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,4,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,128,64,32,16,8,5,0,0,0,64,32,16,8,5,0,0,0,0,0,16,8,5,0,0,0,0,0,16,8,5,0,0,0,0,32,16,8,5,0,0,0,0,32,16,8,5,0,0,0,0,0,16,8,5,0,0,0,0,0,16,8,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,8,5,0,0,0,0,0,0,8,5,0,0,0,0,0,0,8,5,0,0,0,0,0,0,8,5,0,0,0,0,0,0,8,5,0,0,0,0,0,0,8,5,0,0,0,0,0,0,8,5,0,0,0,0,0,0,8,5,0,0,0,128,64,32,17,10,0,0,0,128,64,32,16,10,0,0,0,0,0,0,1,10,0,0,0,0,0,0,0,10,0,0,0,0,0,0,17,10,0,0,0,0,0,0,16,10,0,0,0,0,0,0,1,10,0,0,0,0,0,0,0,10,0,0,0,0,64,32,17,10,0,0,0,0,64,32,16,10,0,0,0,0,0,0,1,10,0,0,0,0,0,0,0,10,0,0,0,0,0,0,17,10,0,0,0,0,0,0,16,10,0,0,0,0,0,0,1,10,0,0,0,0,0,0,0,10,0,0,0,0,0,32,17,10,0,0,0,0,0,32,16,10,0,0,0,0,0,0,1,10,0,0,0,0,0,0,0,10,0,0,0,0,0,0,17,10,0,0,0,0,0,0,16,10,0,0,0,0,0,0,1,10,0,0,0,0,0,0,0,10,0,0,0,0,0,32,17,10,0,0,0,0,0,32,16,10,0,0,0,0,0,0,1,10,0,0,0,0,0,0,0,10,0,0,0,0,0,0,17,10,0,0,0,0,0,0,16,10,0,0,0,0,0,0,1,10,0,0,0,0,0,0,0,10,0,0,0,0,128,65,34,20,0,0,0,0,128,64,32,20,0,0,0,0,128,64,34,20,0,0,0,0,128,64,32,20,0,0,0,0,0,1,2,20,0,0,0,0,0,0,0,20,0,0,0,0,0,0,2,20,0,0,0,0,0,0,0,20,0,0,0,0,0,1,34,20,0,0,0,0,0,0,32,20,0,0,0,0,0,0,34,20,0,0,0,0,0,0,32,20,0,0,0,0,0,1,2,20,0,0,0,0,0,0,0,20,0,0,0,0,0,0,2,20,0,0,0,0,0,0,0,20,0,0,0,0,0,65,34,20,0,0,0,0,0,64,32,20,0,0,0,0,0,64,34,20,0,0,0,0,0,64,32,20,0,0,0,0,0,1,2,20,0,0,0,0,0,0,0,20,0,0,0,0,0,0,2,20,0,0,0,0,0,0,0,20,0,0,0,0,0,1,34,20,0,0,0,0,0,0,32,20,0,0,0,0,0,0,34,20,0,0,0,0,0,0,32,20,0,0,0,0,0,1,2,20,0,0,0,0,0,0,0,20,0,0,0,0,0,0,2,20,0,0,0,0,0,0,0,20,0,0,0,0,1,130,68,40,0,0,0,0,0,128,68,40,0,0,0,0,0,128,64,40,0,0,0,0,0,128,64,40,0,0,0,0,0,130,68,40,0,0,0,0,0,128,68,40],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+983562);allocate([128,64,40,0,0,0,0,0,128,64,40,0,0,0,0,1,2,4,40,0,0,0,0,0,0,4,40,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,40,0,0,0,0,0,2,4,40,0,0,0,0,0,0,4,40,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,40,0,0,0,0,1,2,68,40,0,0,0,0,0,0,68,40,0,0,0,0,0,0,64,40,0,0,0,0,0,0,64,40,0,0,0,0,0,2,68,40,0,0,0,0,0,0,68,40,0,0,0,0,0,0,64,40,0,0,0,0,0,0,64,40,0,0,0,0,1,2,4,40,0,0,0,0,0,0,4,40,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,40,0,0,0,0,0,2,4,40,0,0,0,0,0,0,4,40,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,40,0,0,0,1,2,4,136,80,0,0,0,0,0,4,136,80,0,0,0,0,0,0,128,80,0,0,0,0,0,0,128,80,0,0,0,0,0,0,128,80,0,0,0,0,0,0,128,80,0,0,0,0,0,0,136,80,0,0,0,0,0,0,136,80,0,0,0,0,2,4,136,80,0,0,0,0,0,4,136,80,0,0,0,0,0,0,128,80,0,0,0,0,0,0,128,80,0,0,0,0,0,0,128,80,0,0,0,0,0,0,128,80,0,0,0,0,0,0,136,80,0,0,0,0,0,0,136,80,0,0,0,1,2,4,8,80,0,0,0,0,0,4,8,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,8,80,0,0,0,0,0,0,8,80,0,0,0,0,2,4,8,80,0,0,0,0,0,4,8,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,80,0,0,0,0,0,0,8,80,0,0,0,0,0,0,8,80,0,0,1,2,4,8,16,160,0,0,0,0,0,0,0,160,0,0,0,0,4,8,16,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,16,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,16,160,0,0,0,0,0,8,16,160,0,0,0,0,0,0,0,160,0,0,0,0,0,8,16,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,16,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,16,160,0,0,0,2,4,8,16,160,0,0,0,0,0,0,0,160,0,0,0,0,4,8,16,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,16,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,16,160,0,0,0,0,0,8,16,160,0,0,0,0,0,0,0,160,0,0,0,0,0,8,16,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,16,160,0,0,0,0,0,0,0,160,0,0,0,0,0,0,16,160,0,1,2,4,8,16,32,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,32,64,0,0,0,0,0,16,32,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,2,4,8,16,32,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,32,64,0,0,0,0,0,16,32,64,0,0,0,0,0,0,32,64,0,0,0,0,0,16,32,64,0,0,0,0,8,16,32,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,32,64,0,0,0,0,0,16,32,64,0,0,0,0,8,16,32,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,32,64,0,0,0,4,8,16,32,64,0,0,0,0,0,16,32,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,32,64,0,0,0,4,8,16,32,64,0,0,0,0,0,16,32,64,0,0,0,0,0,0,32,64,0,0,0,0,0,16,32,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,32,64,0,0,0,0,8,16,32,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,16,32,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,32,64,0,0,0,0,8,16,32,64,0,75,80,75,0,0,0,0,0,75,78,78,75,0,0,0,0,75,66,78,75,0,0,0,0,75,82,75,80,0,0,0,0,75,82,75,66,0,0,0,0,75,82,75,78,0,0,0,0,75,81,75,80,0,0,0,0,75,81,75,82,0,0,0,0,75,78,80,75,0,0,0,0,75,78,80,75,66,0,0,0,75,82,80,75,82,0,0,0,75,82,80,75,66,0,0,0,75,66,80,75,66,0,0,0,75,66,80,75,78,0,0,0,75,66,80,80,75,66,0,0,75,82,80,80,75,82,80,0,100,0,0,0,90,0,0,0,80,0,0,0,70,0,0,0,70,0,0,0,80,0,0,0,90,0,0,0,100,0,0,0,90,0,0,0,70,0,0,0,60,0,0,0,50,0,0,0,50,0,0,0,60,0,0,0,70,0,0,0,90,0,0,0,80,0,0,0,60,0,0,0,40,0,0,0,30,0,0,0,30,0,0,0,40,0,0,0,60,0,0,0,80,0,0,0,70,0,0,0,50,0,0,0,30,0,0,0,20,0,0,0,20,0,0,0,30,0,0,0,50,0,0,0,70,0,0,0,70,0,0,0,50,0,0,0,30,0,0,0,20,0,0,0,20,0,0,0,30,0,0,0,50,0,0,0,70,0,0,0,80,0,0,0,60,0,0,0,40,0,0,0,30,0,0,0,30,0,0,0,40,0,0,0,60,0,0,0,80,0,0,0,90,0,0,0,70,0,0,0,60,0,0,0,50,0,0,0,50,0,0,0,60,0,0,0,70,0,0,0,90,0,0,0,100,0,0,0,90,0,0,0,80,0,0,0,70,0,0,0,70,0,0,0,80,0,0,0,90,0,0,0,100,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,80,0,0,0,60,0,0,0,40,0,0,0,20,0,0,0,10,0,0,0,200,0,0,0,190,0,0,0,180,0,0,0,170,0,0,0,160,0,0,0,150,0,0,0,140,0,0,0,130,0,0,0,190,0,0,0,180,0,0,0,170,0,0,0,160,0,0,0,150,0,0,0,140,0,0,0,130,0,0,0,140,0,0,0,180,0,0,0,170,0,0,0,155,0,0,0,140,0,0,0,140,0,0,0,125,0,0,0,140,0,0,0,150,0,0,0,170,0,0,0,160,0,0,0,140,0,0,0,120,0,0,0,110,0,0,0,140,0,0,0,150,0,0,0,160,0,0,0,160,0,0,0,150,0,0,0,140,0,0,0,110,0,0,0,120,0,0,0,140,0,0,0,160,0,0,0,170,0,0,0,150,0,0,0,140,0,0,0,125,0,0,0,140,0,0,0,140,0,0,0,155,0,0,0,170,0,0,0,180,0,0,0,140,0,0,0,130,0,0,0,140,0,0,0,150,0,0,0,160,0,0,0,170,0,0,0,180,0,0,0,190,0,0,0,130,0,0,0,140,0,0,0,150,0,0,0,160,0,0,0,170,0,0,0,180,0,0,0,190,0,0,0,200,0,0,0,0,0,0,0,5,0,0,0,20,0,0,0,40,0,0,0,60,0,0,0,80,0,0,0,90,0,0,0,100,0,0,0,47,56,47,56,47,56,47,56,47,56,47,56,47,0,0,0,32,119,32,45,32,45,32,48,32,49,48,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,12,0,0,0,5,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,13,0,0,0,6,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,14,0,0,0,7,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,15,0,0,0,8,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,16,0,0,0,9,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,17,0,0,0,10,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,18,0,0,0,11,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,19,0,0,0,12,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,21,0,0,0,13,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,22,0,0,0,14,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,23,0,0,0,15,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,24,0,0,0,16,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,25,0,0,0,17,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,26,0,0,0,18,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,27,0,0,0,19,0,0,0,17,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,28,0,0,0,20,0,0,0,18],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+993804);allocate([33,1,0,0,88,1,0,0,233,0,0,0,201,0,0,0,221,0,0,0,17,1,0,0,46,0,0,0,0,0,0,0,65,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+997184);allocate([4,0,0,0,8,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,17,0,0,0,26,0,0,0,26,0,0,0,17,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,26,0,0,0,35,0,0,0,35,0,0,0,26,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,17,0,0,0,17,0,0,0,17,0,0,0,17,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,10,0,0,0,10,0,0,0,10,0,0,0,10,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,21,0,0,0,21,0,0,0,21,0,0,0,21,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,69,118,97,108,32,116,101,114,109,32,124,32,32,32,32,87,104,105,116,101,32,32,32,32,124,32,32,32,32,66,108,97,99,107,32,32,32,32,124,32,32,32,32,84,111,116,97,108,32,32,32,32,10,0,0,0,0,0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,124,32,32,32,77,71,32,32,32,32,69,71,32,32,124,32,32,32,77,71,32,32,32,32,69,71,32,32,124,32,32,32,77,71,32,32,32,32,69,71,32,32,10,0,0,0,0,0,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,43,45,45,45,45,45,45,45,45,45,45,45,45,45,43,45,45,45,45,45,45,45,45,45,45,45,45,45,43,45,45,45,45,45,45,45,45,45,45,45,45,45,10,0,0,0,0,0,77,97,116,101,114,105,97,108,0,0,0,0,0,0,0,0,73,109,98,97,108,97,110,99,101,0,0,0,0,0,0,0,80,97,119,110,115,0,0,0,75,110,105,103,104,116,115,0,66,105,115,104,111,112,115,0,82,111,111,107,115,0,0,0,81,117,101,101,110,115,0,0,77,111,98,105,108,105,116,121,0,0,0,0,0,0,0,0,75,105,110,103,32,115,97,102,101,116,121,0,0,0,0,0,84,104,114,101,97,116,115,0,80,97,115,115,101,100,32,112,97,119,110,115,0,0,0,0,84,111,116,97,108,0,0,0,10,84,111,116,97,108,32,69,118,97,108,117,97,116,105,111,110,58,32,0,0,0,0,0,32,40,119,104,105,116,101,32,115,105,100,101,41,10,0,0,64,0,0,0,0,0,0,0,0,0,0,0,29,0,0,0,30,0,0,0,56,0,0,0,248,255,255,255,0,0,0,0,31,0,0,0,32,0,0,0,192,255,255,255,192,255,255,255,0,0,0,0,33,0,0,0,34,0,0,0,0,0,0,0,100,67,15,0,204,67,15,0,12,68,15,0,32,68,15,0,220,135,15,0,240,135,15,0,244,67,15,0,224,67,15,0,140,67,15,0,120,67,15,0,64,0,0,0,0,0,0,0,0,0,0,0,35,0,0,0,36,0,0,0,56,0,0,0,248,255,255,255,0,0,0,0,37,0,0,0,38,0,0,0,192,255,255,255,192,255,255,255,0,0,0,0,39,0,0,0,40,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,6,0,0,0,192,255,255,255,192,255,255,255,0,0,0,0,7,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,41,0,0,0,42,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,21,0,0,0,2,0,0,0,2,0,0,0,22,0,0,0,4,0,0,0,19,0,0,0,3,0,0,0,20,0,0,0,32,124,32,32,32,45,45,45,32,32,32,45,45,45,32,124,32,32,32,45,45,45,32,32,32,45,45,45,32,124,32,0,32,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,71,15,0,0,0,0,0,1,0,0,0,200,71,15,0,1,0,0,0,0,0,0,0,176,71,15,0,0,0,0,0,1,0,0,0,176,71,15,0,1,0,0,0,0,0,0,0,152,71,15,0,0,0,0,0,1,0,0,0,152,71,15,0,1,0,0,0,0,0,0,0,128,71,15,0,0,0,0,0,1,0,0,0,128,71,15,0,1,0,0,0,0,0,0,0,104,71,15,0,0,0,0,0,1,0,0,0,104,71,15,0,1,0,0,0,0,0,0,0,60,7,0,0,94,255,255,255,158,251,255,255,73,255,255,255,249,0,0,0,102,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,0,0,15,1,0,0,252,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,105,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,229,255,255,255,254,255,255,255,46,0,0,0,100,0,0,0,115,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,79,255,255,255,25,0,0,0,129,0,0,0,142,0,0,0,119,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,57,0,0,0,64,0,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,50,0,0,0,40,0,0,0,23,0,0,0,234,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,0,0,0,105,0,0,0,217,255,255,255,141,0,0,0,18,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,43,0,0,0,23,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,44,0,0,0,24,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,45,0,0,0,25,0,0,0,23,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,46,0,0,0,26,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,47,0,0,0,27,0,0,0,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,97,110,32,70,101,98,32,77,97,114,32,65,112,114,32,77,97,121,32,74,117,110,32,74,117,108,32,65,117,103,32,83,101,112,32,79,99,116,32,78,111,118,32,68,101,99,0,74,117,110,32,50,51,32,50,48,49,53,0,0,0,0,0,83,116,111,99,107,102,105,115,104,32,0,0,0,0,0,0,10,105,100,32,97,117,116,104,111,114,32,0,0,0,0,0,32,98,121,32,0,0,0,0,84,111,114,100,32,82,111,109,115,116,97,100,44,32,77,97,114,99,111,32,67,111,115,116,97,108,98,97,32,97,110,100,32,74,111,111,110,97,32,75,105,105,115,107,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,105,111,95,108,111,103,46,116,120,116,0,0,0,0,0,0,97,0,0,0,0,0,0,0,104,0,0,0,0,0,0,0,0,0,0,0,48,0,0,0,49,0,0,0,152,255,255,255,152,255,255,255,0,0,0,0,50,0,0,0,51,0,0,0,196,73,15,0,252,73,15,0,16,74,15,0,216,73,15,0,104,0,0,0,0,0,0,0,0,0,0,0,52,0,0,0,53,0,0,0,152,255,255,255,152,255,255,255,0,0,0,0,54,0,0,0,55,0,0,0,0,0,0,0,0,0,0,0,56,0,0,0,57,0,0,0,2,0,0,0,4,0,0,0,3,0,0,0,3,0,0,0,28,0,0,0,2,0,0,0,2,0,0,0,29,0,0,0,30,0,0,0,26,0,0,0,3,0,0,0,27,0,0,0,60,60,32,0,0,0,0,0,10,0,0,0,0,0,0,0,62,62,32,0,0,0,0,0,43,0,13,0,48,0,20,0,48,0,23,0,48,0,23,0,48,0,23,0,48,0,23,0,48,0,20,0,43,0,13,0,45,0,37,0,52,0,54,0,52,0,60,0,52,0,60,0,52,0,60,0,52,0,60,0,52,0,54,0,45,0,37,0,30,0,25,0,35,0,36,0,35,0,40,0,35,0,40,0,35,0,40,0,35,0,40,0,35,0,36,0,30,0,25,0,42,0,30,0,46,0,43,0,46,0,49,0,46,0,49,0,46,0,49,0,46,0,49,0,46,0,43,0,42,0,30,0,28,0,20,0,31,0,29,0,31,0,33,0,31,0,33,0,31,0,33,0,31,0,33,0,31,0,29,0,28,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,20,0,20,0,40,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,13,0,0,0,24,0,0,0,64,0,0,0,89,0,0,0,93,0,0,0,104,0,0,0,0,0,0,0,110,0,0,0,1,0,0,0,29,0,0,0,75,0,0,0,96,0,0,0,102,0,0,0,107,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,39,0,0,0,74,0,0,0,88,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,88,0,0,0,4,0,0,0,33,0,0,0,67,0,0,0,92,0,0,0,94,0,0,0,107,0,0,0,0,0,0,0,0,0,0,0,63,0,0,0,128,0,0,0,43,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,131,0,0,0,44,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59,0,0,0,121,0,0,0,50,0,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,127,0,0,0,54,0,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,0,0,40,0,0,0,93,0,0,0,42,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,0,0,28,0,0,0,101,0,0,0,38,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,0,0,32,0,0,0,95,0,0,0,36,0,0,0,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,27,0,0,0,24,0,0,0,99,0,0,0,36,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,81,0,0,0,16,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,165,0,0,0,29,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,163,0,0,0,23,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,161,0,0,0,28,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,254,255,255,213,254,255,255,55,0,0,0,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,131,0,0,0,46,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,135,0,0,0,50,0,0,0,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,128,0,0,0,51,0,0,0,24],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+999344);allocate([198,0,0,0,49,3,0,0,68,3,0,0,246,4,0,0,217,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,0,0,78,3,0,0,89,3,0,0,254,4,0,0,254,9],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+1004844);allocate([32,80,78,66,82,81,75,32,32,112,110,98,114,113,107,0,10,32,43,45,45,45,43,45,45,45,43,45,45,45,43,45,45,45,43,45,45,45,43,45,45,45,43,45,45,45,43,45,45,45,43,10,0,0,0,0,32,124,32,0,0,0,0,0,32,124,10,32,43,45,45,45,43,45,45,45,43,45,45,45,43,45,45,45,43,45,45,45,43,45,45,45,43,45,45,45,43,45,45,45,43,10,0,0,10,70,101,110,58,32,0,0,10,75,101,121,58,32,0,0,10,67,104,101,99,107,101,114,115,58,32,0,0,0,0,0,10,76,101,103,97,108,32,109,111,118,101,115,58,32,0,0,10,76,101,103,97,108,32,117,99,105,32,109,111,118,101,115,58,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+1013384);allocate([32,119,32,0,0,0,0,0,32,98,32,0,0,0,0,0,32,45,32,0,0,0,0,0,0,0,0,0,0,0,0,0,47,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,66,32,0,0,0,0,0,0,87,32,0,0,0,0,0,0,45,0,0,0,0,0,0,0,54,0,0,0,0,0,0,0,51,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,0,0,0,0,58,0,0,0,59,0,0,0,200,255,255,255,200,255,255,255,0,0,0,0,60,0,0,0,61,0,0,0,164,135,15,0,220,135,15,0,240,135,15,0,184,135,15,0,56,0,0,0,0,0,0,0,0,0,0,0,52,0,0,0,53,0,0,0,200,255,255,255,200,255,255,255,0,0,0,0,54,0,0,0,55,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,63,0,0,0,196,255,255,255,196,255,255,255,0,0,0,0,64,0,0,0,65,0,0,0,4,136,15,0,60,136,15,0,80,136,15,0,24,136,15,0,60,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,6,0,0,0,196,255,255,255,196,255,255,255,0,0,0,0,7,0,0,0,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+1017656);allocate([105,110,102,111,32,100,101,112,116,104,32,48,32,115,99,111,114,101,32,0,0,0,0,0,105,110,102,111,32,110,111,100,101,115,32,0,0,0,0,0,32,116,105,109,101,32,0,0,98,101,115,116,109,111,118,101,32,0,0,0,0,0,0,0,32,112,111,110,100,101,114,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+1053192);allocate([66,0,0,0,67,0,0,0,68],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+1055528);allocate([105,110,102,111,32,100,101,112,116,104,32,0,0,0,0,0,32,99,117,114,114,109,111,118,101,32,0,0,0,0,0,0,32,99,117,114,114,109,111,118,101,110,117,109,98,101,114,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+1059648);allocate([69,0,0,0,70,0,0,0,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+1063816);allocate([32,115,101,108,100,101,112,116,104,32,0,0,0,0,0,0,32,109,117,108,116,105,112,118,32,0,0,0,0,0,0,0,32,115,99,111,114,101,32,0,32,108,111,119,101,114,98,111,117,110,100,0,0,0,0,0,32,117,112,112,101,114,98,111,117,110,100,0,0,0,0,0,32,110,111,100,101,115,32,0,32,110,112,115,32,0,0,0,32,112,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,66,0,0,0,71,0,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,73,0,0,0,74,0,0,0,0,0,0,0,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,0,0,0,0,0,77,66,32,102,111,114,32,116,114,97,110,115,112,111,115,105,116,105,111,110,32,116,97,98,108,101,46],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+1069704);allocate([113,117,105,116,0,0,0,0,115,116,111,112,0,0,0,0,112,111,110,100,101,114,104,105,116,0,0,0,0,0,0,0,117,99,105,0,0,0,0,0,105,100,32,110,97,109,101,32,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,10,117,99,105,111,107,0,0,105,115,114,101,97,100,121,0,114,101,97,100,121,111,107,0,117,99,105,110,101,119,103,97,109,101,0,0,0,0,0,0,103,111,0,0,0,0,0,0,112,111,115,105,116,105,111,110,0,0,0,0,0,0,0,0,115,101,116,111,112,116,105,111,110,0,0,0,0,0,0,0,102,108,105,112,0,0,0,0,98,101,110,99,104,0,0,0,100,0,0,0,0,0,0,0,101,118,97,108,0,0,0,0,112,101,114,102,116,0,0,0,32,0,0,0,0,0,0,0,32,99,117,114,114,101,110,116,32,112,101,114,102,116,0,0,85,110,107,110,111,119,110,32,99,111,109,109,97,110,100,58,32,0,0,0,0,0,0,0,40,110,111,110,101,41,0,0,48,48,48,48,0,0,0,0,32,112,110,98,114,113,107,0,32,80,78,66,82,81,75,0,79,45,79,0,0,0,0,0,79,45,79,45,79,0,0,0,61,0,0,0,0,0,0,0,43,0,0,0,0,0,0,0,35,0,0,0,0,0,0,0,99,112,32,0,0,0,0,0,109,97,116,101,32,0,0,0,118,97,108,117,101,0,0,0,78,111,32,115,117,99,104,32,111,112,116,105,111,110,58,32,0,0,0,0,0,0,0,0,115,116,97,114,116,112,111,115,0,0,0,0,0,0,0,0,102,101,110,0,0,0,0,0,109,111,118,101,115,0,0,0,115,101,97,114,99,104,109,111,118,101,115,0,0,0,0,0,119,116,105,109,101,0,0,0,98,116,105,109,101,0,0,0,119,105,110,99,0,0,0,0,98,105,110,99,0,0,0,0,109,111,118,101,115,116,111,103,111,0,0,0,0,0,0,0,100,101,112,116,104,0,0,0,110,111,100,101,115,0,0,0,109,111,118,101,116,105,109,101,0,0,0,0,0,0,0,0,109,97,116,101,0,0,0,0,105,110,102,105,110,105,116,101,0,0,0,0,0,0,0,0,112,111,110,100,101,114,0,0,114,110,98,113,107,98,110,114,47,112,112,112,112,112,112,112,112,47,56,47,56,47,56,47,56,47,80,80,80,80,80,80,80,80,47,82,78,66,81,75,66,78,82,32,119,32,75,81,107,113,32,45,32,48,32,49,0,0,0,0,0,0,0,0,164,94,16,0,0,0,0,0,0,0,0,0,0,0,0,0,87,114,105,116,101,32,68,101,98,117,103,32,76,111,103,0,67,111,110,116,101,109,112,116,0,0,0,0,0,0,0,0,77,111,98,105,108,105,116,121,32,40,77,105,100,103,97,109,101,41,0,0,0,0,0,0,77,111,98,105,108,105,116,121,32,40,69,110,100,103,97,109,101,41,0,0,0,0,0,0,80,97,119,110,32,83,116,114,117,99,116,117,114,101,32,40,77,105,100,103,97,109,101,41,0,0,0,0,0,0,0,0,80,97,119,110,32,83,116,114,117,99,116,117,114,101,32,40,69,110,100,103,97,109,101,41,0,0,0,0,0,0,0,0,80,97,115,115,101,100,32,80,97,119,110,115,32,40,77,105,100,103,97,109,101,41,0,0,80,97,115,115,101,100,32,80,97,119,110,115,32,40,69,110,100,103,97,109,101,41,0,0,83,112,97,99,101,0,0,0,75,105,110,103,32,83,97,102,101,116,121,0,0,0,0,0,77,105,110,32,83,112,108,105,116,32,68,101,112,116,104,0,84,104,114,101,97,100,115,0,72,97,115,104,0,0,0,0,67,108,101,97,114,32,72,97,115,104,0,0,0,0,0,0,80,111,110,100,101,114,0,0,77,117,108,116,105,80,86,0,83,107,105,108,108,32,76,101,118,101,108,0,0,0,0,0,83,107,105,108,108,32,76,101,118,101,108,32,77,97,120,105,109,117,109,32,69,114,114,111,114,0,0,0,0,0,0,0,83,107,105,108,108,32,76,101,118,101,108,32,80,114,111,98,97,98,105,108,105,116,121,0,77,111,118,101,32,79,118,101,114,104,101,97,100,0,0,0,77,105,110,105,109,117,109,32,84,104,105,110,107,105,110,103,32,84,105,109,101,0,0,0,83,108,111,119,32,77,111,118,101,114,0,0,0,0,0,0,85,67,73,95,67,104,101,115,115,57,54,48,0,0,0,0,10,111,112,116,105,111,110,32,110,97,109,101,32,0,0,0,32,116,121,112,101,32,0,0,98,117,116,116,111,110,0,0,32,100,101,102,97,117,108,116,32,0,0,0,0,0,0,0,115,112,105,110,0,0,0,0,32,109,105,110,32,0,0,0,32,109,97,120,32,0,0,0,99,104,101,99,107],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+1072216);allocate([48,101,16,0,75,0,0,0,76,0,0,0,3,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,6,0,0,0,33,0,0,0,34,0,0,0,28,0,0,0,7,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,72,149,16,0,16,101,16,0,168,106,16,0,0,0,0,0,0,0,0,0,152,101,16,0,75,0,0,0,77,0,0,0,4,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,35,0,0,0,32,0,0,0,6,0,0,0,36,0,0,0,37,0,0,0,30,0,0,0,8,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,72,149,16,0,128,101,16,0,168,106,16,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,48,102,16,0,56,0,0,0,78,0,0,0,5,0,0,0,4,0,0,0,3,0,0,0,3,0,0,0,38,0,0,0,2,0,0,0,2,0,0,0,39,0,0,0,4,0,0,0,26,0,0,0,9,0,0,0,32,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,72,149,16,0,16,102,16,0,104,106,16,0,0,0,0,0,0,0,0,0,152,102,16,0,56,0,0,0,79,0,0,0,6,0,0,0,4,0,0,0,3,0,0,0,3,0,0,0,21,0,0,0,2,0,0,0,2,0,0,0,40,0,0,0,41,0,0,0,33,0,0,0,3,0,0,0,34,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,72,149,16,0,128,102,16,0,104,106,16,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,32,149,16,0,168,102,16,0,58,32,0,0,0,0,0,0,0,0,0,0,8,103,16,0,80,0,0,0,81,0,0,0,42,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,72,149,16,0,240,102,16,0,56,148,16,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,32,149,16,0,24,103,16,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,72,149,16,0,64,103,16,0,56,103,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,104,106,16,0,82,0,0,0,83,0,0,0,2,0,0,0,4,0,0,0,3,0,0,0,3,0,0,0,21,0,0,0,2,0,0,0,2,0,0,0,39,0,0,0,4,0,0,0,26,0,0,0,3,0,0,0,34,0,0,0,0,0,0,0,168,106,16,0,84,0,0,0,85,0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,35,0,0,0,32,0,0,0,6,0,0,0,33,0,0,0,34,0,0,0,28,0,0,0,8,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,224,106,16,0,5,0,0,0,6,0,0,0,248,255,255,255,248,255,255,255,224,106,16,0,7,0,0,0,8,0,0,0,8,0,0,0,0,0,0,0,40,107,16,0,86,0,0,0,87,0,0,0,248,255,255,255,248,255,255,255,40,107,16,0,88,0,0,0,89,0,0,0,4,0,0,0,0,0,0,0,112,107,16,0,52,0,0,0,53,0,0,0,252,255,255,255,252,255,255,255,112,107,16,0,54,0,0,0,55,0,0,0,4,0,0,0,0,0,0,0,184,107,16,0,90,0,0,0,91,0,0,0,252,255,255,255,252,255,255,255,184,107,16,0,92,0,0,0,93,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,105,16,0,94,0,0,0,95,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,168,105,16,0,96,0,0,0,97,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,72,149,16,0,96,105,16,0,8,103,16,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,32,149,16,0,144,105,16,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,72,149,16,0,176,105,16,0,168,105,16,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,72,149,16,0,240,105,16,0,168,105,16,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,32,149,16,0,48,106,16,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,32,149,16,0,112,106,16,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,168,149,16,0,176,106,16,0,0,0,0,0,1,0,0,0,224,105,16,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,168,149,16,0,248,106,16,0,0,0,0,0,1,0,0,0,32,106,16,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,168,149,16,0,64,107,16,0,0,0,0,0,1,0,0,0,224,105,16,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,168,149,16,0,136,107,16,0,0,0,0,0,1,0,0,0,32,106,16,0,3,244,255,255,0,0,0,0,24,108,16,0,98,0,0,0,99,0,0,0,43,0,0,0,1,0,0,0,10,0,0,0,11,0,0,0,2,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,72,149,16,0,248,107,16,0,88,103,16,0,0,0,0,0,0,0,0,0,96,122,16,0,100,0,0,0,101,0,0,0,102,0,0,0,1,0,0,0,5,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,122,16,0,103,0,0,0,104,0,0,0,102,0,0,0,2,0,0,0,6,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,124,16,0,105,0,0,0,106,0,0,0,102,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,240,124,16,0,107,0,0,0,108,0,0,0,102,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,125,16,0,109,0,0,0,110,0,0,0,102,0,0,0,5,0,0,0,6,0,0,0,23,0,0,0,7,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,0,0,0,0,72,126,16,0,111,0,0,0,112,0,0,0,102,0,0,0,9,0,0,0,10,0,0,0,25,0,0,0,11,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,0,127,16,0,113,0,0,0,114,0,0,0,102,0,0,0,44,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,0,127,16,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,160,127,16,0,115,0,0,0,116,0,0,0,102,0,0,0,52,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,160,127,16,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,48,128,16,0,117,0,0,0,118,0,0,0,102,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,128,16,0,119,0,0,0,120,0,0,0,102,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,122,16,0,121,0,0,0,122,0,0,0,102,0,0,0,60,0,0,0,61,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,62,0,0,0,12,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,123,16,0,123,0,0,0,124,0,0,0,102,0,0,0,63,0,0,0,64,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,65,0,0,0,18,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,123,16,0,125,0,0,0,126,0,0,0,102,0,0,0,66,0,0,0,67,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,68,0,0,0,24,0,0,0,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,123,16,0,127,0,0,0,128,0,0,0,102,0,0,0,69,0,0,0,70,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,71,0,0,0,30,0,0,0,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,129,16,0,129,0,0,0,130,0,0,0,102,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,184,129,16,0,131,0,0,0,132,0,0,0,102,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,72,130,16,0,133,0,0,0,134,0,0,0,102,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,216,130,16,0,135,0,0,0,136,0,0,0,102,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,131,16,0,137,0,0,0,138,0,0,0,102,0,0,0,14,0,0,0,13,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,131,16,0,139,0,0,0,140,0,0,0,102,0,0,0,15,0,0,0,14,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,56,122,16,0,141,0,0,0,142,0,0,0,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,119,16,0,143,0,0,0,144,0,0,0,102,0,0,0,35,0,0,0,16,0,0,0,36,0,0,0,17,0,0,0,37,0,0,0,1,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,119,16,0,145,0,0,0,146,0,0,0,102,0,0,0,1,0,0,0,2,0,0,0,4,0,0,0,72,0,0,0,73,0,0,0,5,0,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,121,16,0,147,0,0,0,148,0,0,0,102,0,0,0,75,0,0,0,76,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,0,0,0,0,16,122,16,0,149,0,0,0,150,0,0,0,102,0,0,0,77,0,0,0,78,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,72,118,16,0,151,0,0,0,152,0,0,0,102,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,72,149,16,0,48,118,16,0,200,102,16,0,0,0,0,0,0,0,0,0,216,118,16,0,151,0,0,0,153,0,0,0,102,0,0,0,19,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,38,0,0,0,20,0,0,0,39,0,0,0,21,0,0,0,40,0,0,0,5,0,0,0,22,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,32,149,16,0,184,118,16,0,168,149,16,0,160,118,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,208,118,16,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,168,149,16,0,248,118,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,208,118,16,0,2,0,0,0,0,0,0,0,168,119,16,0,151,0,0,0,154,0,0,0,102,0,0,0,3,0,0,0,4,0,0,0,7,0,0,0,79,0,0,0,80,0,0,0,8,0,0,0,81,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,32,149,16,0,136,119,16,0,168,149,16,0,96,119,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,160,119,16,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,168,149,16,0,200,119,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,160,119,16,0,2,0,0,0,0,0,0,0,104,120,16,0,151,0,0,0,155,0,0,0,102,0,0,0,5,0,0,0,6,0,0,0,9,0,0,0,82,0,0,0,83,0,0,0,10,0,0,0,84,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,168,149,16,0,64,120,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,160,119,16,0,2,0,0,0,0,0,0,0,224,120,16,0,151,0,0,0,156,0,0,0,102,0,0,0,7,0,0,0,8,0,0,0,11,0,0,0,85,0,0,0,86,0,0,0,12,0,0,0,87,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,168,149,16,0,184,120,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,160,119,16,0,2,0,0,0,0,0,0,0,88,121,16,0,151,0,0,0,157,0,0,0,102,0,0,0,7,0,0,0,8,0,0,0,11,0,0,0,85,0,0,0,86,0,0,0,12,0,0,0,87,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,72,149,16,0,48,121,16,0,224,120,16,0,0,0,0,0,0,0,0,0,192,121,16,0,151,0,0,0,158,0,0,0,102,0,0,0,7,0,0,0,8,0,0,0,11,0,0,0,85,0,0,0,86,0,0,0,12,0,0,0,87,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,72,149,16,0,152,121,16,0,224,120,16,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,72,149,16,0,208,121,16,0,72,118,16,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,72,149,16,0,248,121,16,0,72,118,16,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,72,149,16,0,32,122,16,0,72,118,16,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,72,149,16,0,72,122,16,0,72,118,16,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,72,149,16,0,112,122,16,0,72,118,16,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,32,149,16,0,184,122,16,0,168,149,16,0,152,122,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,208,122,16,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,168,149,16,0,248,122,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,208,122,16,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,168,149,16,0,56,123,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,208,122,16,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,168,149,16,0,120,123,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,208,122,16,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,32,149,16,0,24,124,16,0,168,149,16,0,0,124,16,0,0,0,0,0,1,0,0,0,56,124,16,0,0,0,0,0,168,149,16,0,184,123,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,64,124,16,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,168,149,16,0,192,124,16,0,0,0,0,0,1,0,0,0,56,124,16,0,0,0,0,0,168,149,16,0,120,124,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,216,124,16,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,32,149,16,0,112,125,16,0,168,149,16,0,88,125,16,0,0,0,0,0,1,0,0,0,144,125,16,0,0,0,0,0,168,149,16,0,16,125,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,152,125,16,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,168,149,16,0,24,126,16,0,0,0,0,0,1,0,0,0,144,125,16,0,0,0,0,0,168,149,16,0,208,125,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,48,126,16,0,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,32,149,16,0,176,126,16,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,32,149,16,0,208,126,16,0,168,149,16,0,104,126,16,0,0,0,0,0,3,0,0,0,72,118,16,0,2,0,0,0,200,126,16,0,2,0,0,0,248,126,16,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,32,149,16,0,112,127,16,0,168,149,16,0,40,127,16,0,0,0,0,0,3,0,0,0,72,118,16,0,2,0,0,0,200,126,16,0,2,0,0,0,152,127,16,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,32,149,16,0,16,128,16,0,168,149,16,0,200,127,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,40,128,16,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,168,149,16,0,80,128,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,40,128,16,0,0,8,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,32,149,16,0,0,129,16,0,168,149,16,0,184,128,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,32,129,16,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,32,149,16,0,144,129,16,0,168,149,16,0,72,129,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,176,129,16,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,32,149,16,0,32,130,16,0,168,149,16,0,216,129,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,64,130,16,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,32,149,16,0,176,130,16,0,168,149,16,0,104,130,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,208,130,16,0,0,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,32,149,16,0,16,131,16,0,168,149,16,0,248,130,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,40,131,16,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,168,149,16,0,80,131,16,0,0,0,0,0,2,0,0,0,72,118,16,0,2,0,0,0,40,131,16,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+1074380);allocate([70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,117,110,99,97,117,103,104,116,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,58,32,37,115,0,0,0,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,102,111,114,101,105,103,110,32,101,120,99,101,112,116,105,111,110,0,0,0,116,101,114,109,105,110,97,116,105,110,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,116,104,114,101,97,100,95,111,110,99,101,32,102,97,105,108,117,114,101,32,105,110,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,95,102,97,115,116,40,41,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,112,116,104,114,101,97,100,32,107,101,121,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,0,0,0,0,0,0,99,97,110,110,111,116,32,122,101,114,111,32,111,117,116,32,116,104,114,101,97,100,32,118,97,108,117,101,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,0,0,0,0,0,0,0,248,146,16,0,159,0,0,0,160,0,0,0,88,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,72,149,16,0,232,146,16,0,72,147,16,0,0,0,0,0,116,101,114,109,105,110,97,116,101,95,104,97,110,100,108,101,114,32,117,110,101,120,112,101,99,116,101,100,108,121,32,114,101,116,117,114,110,101,100,0,0,0,0,0,0,0,0,0,83,116,57,101,120,99,101,112,116,105,111,110,0,0,0,0,32,149,16,0,56,147,16,0,0,0,0,0,144,147,16,0,161,0,0,0,162,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,56,148,16,0,163,0,0,0,164,0,0,0,42,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,72,149,16,0,128,147,16,0,72,147,16,0,0,0,0,0,0,0,0,0,208,147,16,0,161,0,0,0,165,0,0,0,89,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,72,149,16,0,184,147,16,0,144,147,16,0,0,0,0,0,0,0,0,0,16,148,16,0,161,0,0,0,166,0,0,0,89,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,72,149,16,0,248,147,16,0,144,147,16,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,72,149,16,0,32,148,16,0,72,147,16,0,0,0,0,0,0,0,0,0,152,148,16,0,167,0,0,0,168,0,0,0,90,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,32,149,16,0,112,148,16,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,72,149,16,0,136,148,16,0,72,147,16,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,72,149,16,0,168,148,16,0,128,148,16,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,72,149,16,0,224,148,16,0,208,148,16,0,0,0,0,0,0,0,0,0,8,149,16,0,169,0,0,0,170,0,0,0,171,0,0,0,172,0,0,0,23,0,0,0,15,0,0,0,1,0,0,0,7,0,0,0,0,0,0,0,144,149,16,0,169,0,0,0,173,0,0,0,171,0,0,0,172,0,0,0,23,0,0,0,16,0,0,0,2,0,0,0,8,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,72,149,16,0,104,149,16,0,8,149,16,0,0,0,0,0,0,0,0,0,240,149,16,0,169,0,0,0,174,0,0,0,171,0,0,0,172,0,0,0,23,0,0,0,17,0,0,0,3,0,0,0,9,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,72,149,16,0,200,149,16,0,8,149,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,1,2,4,7,3,6,5,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,45,43,32,32,32,48,88,48,120,0,0,0,0,0,0,0,40,110,117,108,108,41,0,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,0,0,0,0,0,105,110,102,0,0,0,0,0,73,78,70,0,0,0,0,0,110,97,110,0,0,0,0,0,78,65,78,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+1084624);var tempDoublePtr=Runtime.alignMemory(allocate(12,"i8",ALLOC_STATIC),8);assert(tempDoublePtr%8==0);function copyTempFloat(ptr){HEAP8[tempDoublePtr]=HEAP8[ptr];HEAP8[tempDoublePtr+1]=HEAP8[ptr+1];HEAP8[tempDoublePtr+2]=HEAP8[ptr+2];HEAP8[tempDoublePtr+3]=HEAP8[ptr+3]}function copyTempDouble(ptr){HEAP8[tempDoublePtr]=HEAP8[ptr];HEAP8[tempDoublePtr+1]=HEAP8[ptr+1];HEAP8[tempDoublePtr+2]=HEAP8[ptr+2];HEAP8[tempDoublePtr+3]=HEAP8[ptr+3];HEAP8[tempDoublePtr+4]=HEAP8[ptr+4];HEAP8[tempDoublePtr+5]=HEAP8[ptr+5];HEAP8[tempDoublePtr+6]=HEAP8[ptr+6];HEAP8[tempDoublePtr+7]=HEAP8[ptr+7]}Module["_i64Subtract"]=_i64Subtract;Module["_i64Add"]=_i64Add;function __ZSt18uncaught_exceptionv(){return!!__ZSt18uncaught_exceptionv.uncaught_exception}var EXCEPTIONS={last:0,caught:[],infos:{},deAdjust:(function(adjusted){if(!adjusted||EXCEPTIONS.infos[adjusted])return adjusted;for(var ptr in EXCEPTIONS.infos){var info=EXCEPTIONS.infos[ptr];if(info.adjusted===adjusted){return ptr}}return adjusted}),addRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount++}),decRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];assert(info.refcount>0);info.refcount--;if(info.refcount===0){if(info.destructor){Runtime.dynCall("vi",info.destructor,[ptr])}delete EXCEPTIONS.infos[ptr];___cxa_free_exception(ptr)}}),clearRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount=0})};function ___resumeException(ptr){if(!EXCEPTIONS.last){EXCEPTIONS.last=ptr}EXCEPTIONS.clearRef(EXCEPTIONS.deAdjust(ptr));throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}function ___cxa_find_matching_catch(){var thrown=EXCEPTIONS.last;if(!thrown){return(asm["setTempRet0"](0),0)|0}var info=EXCEPTIONS.infos[thrown];var throwntype=info.type;if(!throwntype){return(asm["setTempRet0"](0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=Module["___cxa_is_pointer_type"](throwntype);if(!___cxa_find_matching_catch.buffer)___cxa_find_matching_catch.buffer=_malloc(4);HEAP32[___cxa_find_matching_catch.buffer>>2]=thrown;thrown=___cxa_find_matching_catch.buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&Module["___cxa_can_catch"](typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted=thrown;return(asm["setTempRet0"](typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(asm["setTempRet0"](throwntype),thrown)|0}function ___cxa_throw(ptr,type,destructor){EXCEPTIONS.infos[ptr]={ptr:ptr,adjusted:ptr,type:type,destructor:destructor,refcount:0};EXCEPTIONS.last=ptr;if(!("uncaught_exception"in __ZSt18uncaught_exceptionv)){__ZSt18uncaught_exceptionv.uncaught_exception=1}else{__ZSt18uncaught_exceptionv.uncaught_exception++}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};var ___errno_state=0;function ___setErrNo(value){HEAP32[___errno_state>>2]=value;return value}var PATH={splitPath:(function(filename){var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)}),normalizeArray:(function(parts,allowAboveRoot){var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==="."){parts.splice(i,1)}else if(last===".."){parts.splice(i,1);up++}else if(up){parts.splice(i,1);up--}}if(allowAboveRoot){for(;up--;up){parts.unshift("..")}}return parts}),normalize:(function(path){var isAbsolute=path.charAt(0)==="/",trailingSlash=path.substr(-1)==="/";path=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),!isAbsolute).join("/");if(!path&&!isAbsolute){path="."}if(path&&trailingSlash){path+="/"}return(isAbsolute?"/":"")+path}),dirname:(function(path){var result=PATH.splitPath(path),root=result[0],dir=result[1];if(!root&&!dir){return"."}if(dir){dir=dir.substr(0,dir.length-1)}return root+dir}),basename:(function(path){if(path==="/")return"/";var lastSlash=path.lastIndexOf("/");if(lastSlash===-1)return path;return path.substr(lastSlash+1)}),extname:(function(path){return PATH.splitPath(path)[3]}),join:(function(){var paths=Array.prototype.slice.call(arguments,0);return PATH.normalize(paths.join("/"))}),join2:(function(l,r){return PATH.normalize(l+"/"+r)}),resolve:(function(){var resolvedPath="",resolvedAbsolute=false;for(var i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:FS.cwd();if(typeof path!=="string"){throw new TypeError("Arguments to path.resolve must be strings")}else if(!path){return""}resolvedPath=path+"/"+resolvedPath;resolvedAbsolute=path.charAt(0)==="/"}resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter((function(p){return!!p})),!resolvedAbsolute).join("/");return(resolvedAbsolute?"/":"")+resolvedPath||"."}),relative:(function(from,to){from=PATH.resolve(from).substr(1);to=PATH.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=="")break}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=="")break}if(start>end)return[];return arr.slice(start,end-start+1)}var fromParts=trim(from.split("/"));var toParts=trim(to.split("/"));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push("..")}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join("/")})};var TTY={ttys:[],init:(function(){}),shutdown:(function(){}),register:(function(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops};FS.registerDevice(dev,TTY.stream_ops)}),stream_ops:{open:(function(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}stream.tty=tty;stream.seekable=false}),close:(function(stream){stream.tty.ops.flush(stream.tty)}),flush:(function(stream){stream.tty.ops.flush(stream.tty)}),read:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}for(var i=0;i<length;i++){try{stream.tty.ops.put_char(stream.tty,buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})},default_tty_ops:{get_char:(function(tty){if(!tty.input.length){var result=null;if(ENVIRONMENT_IS_NODE){var BUFSIZE=256;var buf=new Buffer(BUFSIZE);var bytesRead=0;var fd=process.stdin.fd;var usingDevice=false;try{fd=fs.openSync("/dev/stdin","r");usingDevice=true}catch(e){}bytesRead=fs.readSync(fd,buf,0,BUFSIZE,null);if(usingDevice){fs.closeSync(fd)}if(bytesRead>0){result=buf.slice(0,bytesRead).toString("utf-8")}else{result=null}}else if(typeof window!="undefined"&&typeof window.prompt=="function"){result=window.prompt("Input: ");if(result!==null){result+="\n"}}else if(typeof readline=="function"){result=readline();if(result!==null){result+="\n"}}if(!result){return null}tty.input=intArrayFromString(result,true)}return tty.input.shift()}),put_char:(function(tty,val){if(val===null||val===10){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}})},default_tty1_ops:{put_char:(function(tty,val){if(val===null||val===10){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}})}};var MEMFS={ops_table:null,mount:(function(mount){return MEMFS.createNode(null,"/",16384|511,0)}),createNode:(function(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode)){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(!MEMFS.ops_table){MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}}}var node=FS.createNode(parent,name,mode,dev);if(FS.isDir(node.mode)){node.node_ops=MEMFS.ops_table.dir.node;node.stream_ops=MEMFS.ops_table.dir.stream;node.contents={}}else if(FS.isFile(node.mode)){node.node_ops=MEMFS.ops_table.file.node;node.stream_ops=MEMFS.ops_table.file.stream;node.usedBytes=0;node.contents=null}else if(FS.isLink(node.mode)){node.node_ops=MEMFS.ops_table.link.node;node.stream_ops=MEMFS.ops_table.link.stream}else if(FS.isChrdev(node.mode)){node.node_ops=MEMFS.ops_table.chrdev.node;node.stream_ops=MEMFS.ops_table.chrdev.stream}node.timestamp=Date.now();if(parent){parent.contents[name]=node}return node}),getFileDataAsRegularArray:(function(node){if(node.contents&&node.contents.subarray){var arr=[];for(var i=0;i<node.usedBytes;++i)arr.push(node.contents[i]);return arr}return node.contents}),getFileDataAsTypedArray:(function(node){if(!node.contents)return new Uint8Array;if(node.contents.subarray)return node.contents.subarray(0,node.usedBytes);return new Uint8Array(node.contents)}),expandFileStorage:(function(node,newCapacity){if(node.contents&&node.contents.subarray&&newCapacity>node.contents.length){node.contents=MEMFS.getFileDataAsRegularArray(node);node.usedBytes=node.contents.length}if(!node.contents||node.contents.subarray){var prevCapacity=node.contents?node.contents.buffer.byteLength:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1024*1024;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)|0);if(prevCapacity!=0)newCapacity=Math.max(newCapacity,256);var oldContents=node.contents;node.contents=new Uint8Array(newCapacity);if(node.usedBytes>0)node.contents.set(oldContents.subarray(0,node.usedBytes),0);return}if(!node.contents&&newCapacity>0)node.contents=[];while(node.contents.length<newCapacity)node.contents.push(0)}),resizeFileStorage:(function(node,newSize){if(node.usedBytes==newSize)return;if(newSize==0){node.contents=null;node.usedBytes=0;return}if(!node.contents||node.contents.subarray){var oldContents=node.contents;node.contents=new Uint8Array(new ArrayBuffer(newSize));if(oldContents){node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes)))}node.usedBytes=newSize;return}if(!node.contents)node.contents=[];if(node.contents.length>newSize)node.contents.length=newSize;else while(node.contents.length<newSize)node.contents.push(0);node.usedBytes=newSize}),node_ops:{getattr:(function(node){var attr={};attr.dev=FS.isChrdev(node.mode)?node.id:1;attr.ino=node.id;attr.mode=node.mode;attr.nlink=1;attr.uid=0;attr.gid=0;attr.rdev=node.rdev;if(FS.isDir(node.mode)){attr.size=4096}else if(FS.isFile(node.mode)){attr.size=node.usedBytes}else if(FS.isLink(node.mode)){attr.size=node.link.length}else{attr.size=0}attr.atime=new Date(node.timestamp);attr.mtime=new Date(node.timestamp);attr.ctime=new Date(node.timestamp);attr.blksize=4096;attr.blocks=Math.ceil(attr.size/attr.blksize);return attr}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}if(attr.size!==undefined){MEMFS.resizeFileStorage(node,attr.size)}}),lookup:(function(parent,name){throw FS.genericErrors[ERRNO_CODES.ENOENT]}),mknod:(function(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)}),rename:(function(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node){for(var i in new_node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}}}delete old_node.parent.contents[old_node.name];old_node.name=new_name;new_dir.contents[new_name]=old_node;old_node.parent=new_dir}),unlink:(function(parent,name){delete parent.contents[name]}),rmdir:(function(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}delete parent.contents[name]}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,511|40960,0);node.link=oldpath;return node}),readlink:(function(node){if(!FS.isLink(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return node.link})},stream_ops:{read:(function(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);assert(size>=0);if(size>8&&contents.subarray){buffer.set(contents.subarray(position,position+size),offset)}else{for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i]}return size}),write:(function(stream,buffer,offset,length,position,canOwn){if(!length)return 0;var node=stream.node;node.timestamp=Date.now();if(buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn){node.contents=buffer.subarray(offset,offset+length);node.usedBytes=length;return length}else if(node.usedBytes===0&&position===0){node.contents=new Uint8Array(buffer.subarray(offset,offset+length));node.usedBytes=length;return length}else if(position+length<=node.usedBytes){node.contents.set(buffer.subarray(offset,offset+length),position);return length}}MEMFS.expandFileStorage(node,position+length);if(node.contents.subarray&&buffer.subarray)node.contents.set(buffer.subarray(offset,offset+length),position);else for(var i=0;i<length;i++){node.contents[position+i]=buffer[offset+i]}node.usedBytes=Math.max(node.usedBytes,position+length);return length}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.usedBytes}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position}),allocate:(function(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length);stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}var ptr;var allocated;var contents=stream.node.contents;if(!(flags&2)&&(contents.buffer===buffer||contents.buffer===buffer.buffer)){allocated=false;ptr=contents.byteOffset}else{if(position>0||position+length<stream.node.usedBytes){if(contents.subarray){contents=contents.subarray(position,position+length)}else{contents=Array.prototype.slice.call(contents,position,position+length)}}allocated=true;ptr=_malloc(length);if(!ptr){throw new FS.ErrnoError(ERRNO_CODES.ENOMEM)}buffer.set(contents,ptr)}return{ptr:ptr,allocated:allocated}})}};var IDBFS={dbs:{},indexedDB:(function(){if(typeof indexedDB!=="undefined")return indexedDB;var ret=null;if(typeof window==="object")ret=window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB;assert(ret,"IDBFS used, but indexedDB not supported");return ret}),DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:(function(mount){return MEMFS.mount.apply(null,arguments)}),syncfs:(function(mount,populate,callback){IDBFS.getLocalSet(mount,(function(err,local){if(err)return callback(err);IDBFS.getRemoteSet(mount,(function(err,remote){if(err)return callback(err);var src=populate?remote:local;var dst=populate?local:remote;IDBFS.reconcile(src,dst,callback)}))}))}),getDB:(function(name,callback){var db=IDBFS.dbs[name];if(db){return callback(null,db)}var req;try{req=IDBFS.indexedDB().open(name,IDBFS.DB_VERSION)}catch(e){return callback(e)}req.onupgradeneeded=(function(e){var db=e.target.result;var transaction=e.target.transaction;var fileStore;if(db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)){fileStore=transaction.objectStore(IDBFS.DB_STORE_NAME)}else{fileStore=db.createObjectStore(IDBFS.DB_STORE_NAME)}if(!fileStore.indexNames.contains("timestamp")){fileStore.createIndex("timestamp","timestamp",{unique:false})}});req.onsuccess=(function(){db=req.result;IDBFS.dbs[name]=db;callback(null,db)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),getLocalSet:(function(mount,callback){var entries={};function isRealDir(p){return p!=="."&&p!==".."}function toAbsolute(root){return(function(p){return PATH.join2(root,p)})}var check=FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));while(check.length){var path=check.pop();var stat;try{stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){check.push.apply(check,FS.readdir(path).filter(isRealDir).map(toAbsolute(path)))}entries[path]={timestamp:stat.mtime}}return callback(null,{type:"local",entries:entries})}),getRemoteSet:(function(mount,callback){var entries={};IDBFS.getDB(mount.mountpoint,(function(err,db){if(err)return callback(err);var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readonly");transaction.onerror=(function(e){callback(this.error);e.preventDefault()});var store=transaction.objectStore(IDBFS.DB_STORE_NAME);var index=store.index("timestamp");index.openKeyCursor().onsuccess=(function(event){var cursor=event.target.result;if(!cursor){return callback(null,{type:"remote",db:db,entries:entries})}entries[cursor.primaryKey]={timestamp:cursor.key};cursor.continue()})}))}),loadLocalEntry:(function(path,callback){var stat,node;try{var lookup=FS.lookupPath(path);node=lookup.node;stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){return callback(null,{timestamp:stat.mtime,mode:stat.mode})}else if(FS.isFile(stat.mode)){node.contents=MEMFS.getFileDataAsTypedArray(node);return callback(null,{timestamp:stat.mtime,mode:stat.mode,contents:node.contents})}else{return callback(new Error("node type not supported"))}}),storeLocalEntry:(function(path,entry,callback){try{if(FS.isDir(entry.mode)){FS.mkdir(path,entry.mode)}else if(FS.isFile(entry.mode)){FS.writeFile(path,entry.contents,{encoding:"binary",canOwn:true})}else{return callback(new Error("node type not supported"))}FS.chmod(path,entry.mode);FS.utime(path,entry.timestamp,entry.timestamp)}catch(e){return callback(e)}callback(null)}),removeLocalEntry:(function(path,callback){try{var lookup=FS.lookupPath(path);var stat=FS.stat(path);if(FS.isDir(stat.mode)){FS.rmdir(path)}else if(FS.isFile(stat.mode)){FS.unlink(path)}}catch(e){return callback(e)}callback(null)}),loadRemoteEntry:(function(store,path,callback){var req=store.get(path);req.onsuccess=(function(event){callback(null,event.target.result)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),storeRemoteEntry:(function(store,path,entry,callback){var req=store.put(entry,path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),removeRemoteEntry:(function(store,path,callback){var req=store.delete(path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),reconcile:(function(src,dst,callback){var total=0;var create=[];Object.keys(src.entries).forEach((function(key){var e=src.entries[key];var e2=dst.entries[key];if(!e2||e.timestamp>e2.timestamp){create.push(key);total++}}));var remove=[];Object.keys(dst.entries).forEach((function(key){var e=dst.entries[key];var e2=src.entries[key];if(!e2){remove.push(key);total++}}));if(!total){return callback(null)}var errored=false;var completed=0;var db=src.type==="remote"?src.db:dst.db;var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readwrite");var store=transaction.objectStore(IDBFS.DB_STORE_NAME);function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=total){return callback(null)}}transaction.onerror=(function(e){done(this.error);e.preventDefault()});create.sort().forEach((function(path){if(dst.type==="local"){IDBFS.loadRemoteEntry(store,path,(function(err,entry){if(err)return done(err);IDBFS.storeLocalEntry(path,entry,done)}))}else{IDBFS.loadLocalEntry(path,(function(err,entry){if(err)return done(err);IDBFS.storeRemoteEntry(store,path,entry,done)}))}}));remove.sort().reverse().forEach((function(path){if(dst.type==="local"){IDBFS.removeLocalEntry(path,done)}else{IDBFS.removeRemoteEntry(store,path,done)}}))})};var NODEFS={isWindows:false,staticInit:(function(){NODEFS.isWindows=!!process.platform.match(/^win/)}),mount:(function(mount){assert(ENVIRONMENT_IS_NODE);return NODEFS.createNode(null,"/",NODEFS.getMode(mount.opts.root),0)}),createNode:(function(parent,name,mode,dev){if(!FS.isDir(mode)&&!FS.isFile(mode)&&!FS.isLink(mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=FS.createNode(parent,name,mode);node.node_ops=NODEFS.node_ops;node.stream_ops=NODEFS.stream_ops;return node}),getMode:(function(path){var stat;try{stat=fs.lstatSync(path);if(NODEFS.isWindows){stat.mode=stat.mode|(stat.mode&146)>>1}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return stat.mode}),realPath:(function(node){var parts=[];while(node.parent!==node){parts.push(node.name);node=node.parent}parts.push(node.mount.opts.root);parts.reverse();return PATH.join.apply(null,parts)}),flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:(function(flags){if(flags in NODEFS.flagsToPermissionStringMap){return NODEFS.flagsToPermissionStringMap[flags]}else{return flags}}),node_ops:{getattr:(function(node){var path=NODEFS.realPath(node);var stat;try{stat=fs.lstatSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(NODEFS.isWindows&&!stat.blksize){stat.blksize=4096}if(NODEFS.isWindows&&!stat.blocks){stat.blocks=(stat.size+stat.blksize-1)/stat.blksize|0}return{dev:stat.dev,ino:stat.ino,mode:stat.mode,nlink:stat.nlink,uid:stat.uid,gid:stat.gid,rdev:stat.rdev,size:stat.size,atime:stat.atime,mtime:stat.mtime,ctime:stat.ctime,blksize:stat.blksize,blocks:stat.blocks}}),setattr:(function(node,attr){var path=NODEFS.realPath(node);try{if(attr.mode!==undefined){fs.chmodSync(path,attr.mode);node.mode=attr.mode}if(attr.timestamp!==undefined){var date=new Date(attr.timestamp);fs.utimesSync(path,date,date)}if(attr.size!==undefined){fs.truncateSync(path,attr.size)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),lookup:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);var mode=NODEFS.getMode(path);return NODEFS.createNode(parent,name,mode)}),mknod:(function(parent,name,mode,dev){var node=NODEFS.createNode(parent,name,mode,dev);var path=NODEFS.realPath(node);try{if(FS.isDir(node.mode)){fs.mkdirSync(path,node.mode)}else{fs.writeFileSync(path,"",{mode:node.mode})}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return node}),rename:(function(oldNode,newDir,newName){var oldPath=NODEFS.realPath(oldNode);var newPath=PATH.join2(NODEFS.realPath(newDir),newName);try{fs.renameSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),unlink:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.unlinkSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),rmdir:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.rmdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readdir:(function(node){var path=NODEFS.realPath(node);try{return fs.readdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),symlink:(function(parent,newName,oldPath){var newPath=PATH.join2(NODEFS.realPath(parent),newName);try{fs.symlinkSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readlink:(function(node){var path=NODEFS.realPath(node);try{path=fs.readlinkSync(path);path=NODEJS_PATH.relative(NODEJS_PATH.resolve(node.mount.opts.root),path);return path}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}})},stream_ops:{open:(function(stream){var path=NODEFS.realPath(stream.node);try{if(FS.isFile(stream.node.mode)){stream.nfd=fs.openSync(path,NODEFS.flagsToPermissionString(stream.flags))}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),close:(function(stream){try{if(FS.isFile(stream.node.mode)&&stream.nfd){fs.closeSync(stream.nfd)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),read:(function(stream,buffer,offset,length,position){if(length===0)return 0;var nbuffer=new Buffer(length);var res;try{res=fs.readSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(res>0){for(var i=0;i<res;i++){buffer[offset+i]=nbuffer[i]}}return res}),write:(function(stream,buffer,offset,length,position){var nbuffer=new Buffer(buffer.subarray(offset,offset+length));var res;try{res=fs.writeSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}return res}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){try{var stat=fs.fstatSync(stream.nfd);position+=stat.size}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};var _stdin=allocate(1,"i32*",ALLOC_STATIC);var _stdout=allocate(1,"i32*",ALLOC_STATIC);var _stderr=allocate(1,"i32*",ALLOC_STATIC);function _fflush(stream){}var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},handleFSError:(function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return ___setErrNo(e.errno)}),lookupPath:(function(path,opts){path=PATH.resolve(FS.cwd(),path);opts=opts||{};if(!path)return{path:"",node:null};var defaults={follow_mount:true,recurse_count:0};for(var key in defaults){if(opts[key]===undefined){opts[key]=defaults[key]}}if(opts.recurse_count>8){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}var parts=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),false);var current=FS.root;var current_path="/";for(var i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent){break}current=FS.lookupNode(current,parts[i]);current_path=PATH.join2(current_path,parts[i]);if(FS.isMountpoint(current)){if(!islast||islast&&opts.follow_mount){current=current.mounted.root}}if(!islast||opts.follow){var count=0;while(FS.isLink(current.mode)){var link=FS.readlink(current_path);current_path=PATH.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count});current=lookup.node;if(count++>40){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}}}}return{path:current_path,node:current}}),getPath:(function(node){var path;while(true){if(FS.isRoot(node)){var mount=node.mount.mountpoint;if(!path)return mount;return mount[mount.length-1]!=="/"?mount+"/"+path:mount+path}path=path?node.name+"/"+path:node.name;node=node.parent}}),hashName:(function(parentid,name){var hash=0;for(var i=0;i<name.length;i++){hash=(hash<<5)-hash+name.charCodeAt(i)|0}return(parentid+hash>>>0)%FS.nameTable.length}),hashAddNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash];FS.nameTable[hash]=node}),hashRemoveNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node){FS.nameTable[hash]=node.name_next}else{var current=FS.nameTable[hash];while(current){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}}}),lookupNode:(function(parent,name){var err=FS.mayLookup(parent);if(err){throw new FS.ErrnoError(err,parent)}var hash=FS.hashName(parent.id,name);for(var node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name){return node}}return FS.lookup(parent,name)}),createNode:(function(parent,name,mode,rdev){if(!FS.FSNode){FS.FSNode=(function(parent,name,mode,rdev){if(!parent){parent=this}this.parent=parent;this.mount=parent.mount;this.mounted=null;this.id=FS.nextInode++;this.name=name;this.mode=mode;this.node_ops={};this.stream_ops={};this.rdev=rdev});FS.FSNode.prototype={};var readMode=292|73;var writeMode=146;Object.defineProperties(FS.FSNode.prototype,{read:{get:(function(){return(this.mode&readMode)===readMode}),set:(function(val){val?this.mode|=readMode:this.mode&=~readMode})},write:{get:(function(){return(this.mode&writeMode)===writeMode}),set:(function(val){val?this.mode|=writeMode:this.mode&=~writeMode})},isFolder:{get:(function(){return FS.isDir(this.mode)})},isDevice:{get:(function(){return FS.isChrdev(this.mode)})}})}var node=new FS.FSNode(parent,name,mode,rdev);FS.hashAddNode(node);return node}),destroyNode:(function(node){FS.hashRemoveNode(node)}),isRoot:(function(node){return node===node.parent}),isMountpoint:(function(node){return!!node.mounted}),isFile:(function(mode){return(mode&61440)===32768}),isDir:(function(mode){return(mode&61440)===16384}),isLink:(function(mode){return(mode&61440)===40960}),isChrdev:(function(mode){return(mode&61440)===8192}),isBlkdev:(function(mode){return(mode&61440)===24576}),isFIFO:(function(mode){return(mode&61440)===4096}),isSocket:(function(mode){return(mode&49152)===49152}),flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:(function(str){var flags=FS.flagModes[str];if(typeof flags==="undefined"){throw new Error("Unknown file open mode: "+str)}return flags}),flagsToPermissionString:(function(flag){var accmode=flag&2097155;var perms=["r","w","rw"][accmode];if(flag&512){perms+="w"}return perms}),nodePermissions:(function(node,perms){if(FS.ignorePermissions){return 0}if(perms.indexOf("r")!==-1&&!(node.mode&292)){return ERRNO_CODES.EACCES}else if(perms.indexOf("w")!==-1&&!(node.mode&146)){return ERRNO_CODES.EACCES}else if(perms.indexOf("x")!==-1&&!(node.mode&73)){return ERRNO_CODES.EACCES}return 0}),mayLookup:(function(dir){var err=FS.nodePermissions(dir,"x");if(err)return err;if(!dir.node_ops.lookup)return ERRNO_CODES.EACCES;return 0}),mayCreate:(function(dir,name){try{var node=FS.lookupNode(dir,name);return ERRNO_CODES.EEXIST}catch(e){}return FS.nodePermissions(dir,"wx")}),mayDelete:(function(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var err=FS.nodePermissions(dir,"wx");if(err){return err}if(isdir){if(!FS.isDir(node.mode)){return ERRNO_CODES.ENOTDIR}if(FS.isRoot(node)||FS.getPath(node)===FS.cwd()){return ERRNO_CODES.EBUSY}}else{if(FS.isDir(node.mode)){return ERRNO_CODES.EISDIR}}return 0}),mayOpen:(function(node,flags){if(!node){return ERRNO_CODES.ENOENT}if(FS.isLink(node.mode)){return ERRNO_CODES.ELOOP}else if(FS.isDir(node.mode)){if((flags&2097155)!==0||flags&512){return ERRNO_CODES.EISDIR}}return FS.nodePermissions(node,FS.flagsToPermissionString(flags))}),MAX_OPEN_FDS:4096,nextfd:(function(fd_start,fd_end){fd_start=fd_start||0;fd_end=fd_end||FS.MAX_OPEN_FDS;for(var fd=fd_start;fd<=fd_end;fd++){if(!FS.streams[fd]){return fd}}throw new FS.ErrnoError(ERRNO_CODES.EMFILE)}),getStream:(function(fd){return FS.streams[fd]}),createStream:(function(stream,fd_start,fd_end){if(!FS.FSStream){FS.FSStream=(function(){});FS.FSStream.prototype={};Object.defineProperties(FS.FSStream.prototype,{object:{get:(function(){return this.node}),set:(function(val){this.node=val})},isRead:{get:(function(){return(this.flags&2097155)!==1})},isWrite:{get:(function(){return(this.flags&2097155)!==0})},isAppend:{get:(function(){return this.flags&1024})}})}var newStream=new FS.FSStream;for(var p in stream){newStream[p]=stream[p]}stream=newStream;var fd=FS.nextfd(fd_start,fd_end);stream.fd=fd;FS.streams[fd]=stream;return stream}),closeStream:(function(fd){FS.streams[fd]=null}),getStreamFromPtr:(function(ptr){return FS.streams[ptr-1]}),getPtrForStream:(function(stream){return stream?stream.fd+1:0}),chrdev_stream_ops:{open:(function(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops;if(stream.stream_ops.open){stream.stream_ops.open(stream)}}),llseek:(function(){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)})},major:(function(dev){return dev>>8}),minor:(function(dev){return dev&255}),makedev:(function(ma,mi){return ma<<8|mi}),registerDevice:(function(dev,ops){FS.devices[dev]={stream_ops:ops}}),getDevice:(function(dev){return FS.devices[dev]}),getMounts:(function(mount){var mounts=[];var check=[mount];while(check.length){var m=check.pop();mounts.push(m);check.push.apply(check,m.mounts)}return mounts}),syncfs:(function(populate,callback){if(typeof populate==="function"){callback=populate;populate=false}var mounts=FS.getMounts(FS.root.mount);var completed=0;function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=mounts.length){callback(null)}}mounts.forEach((function(mount){if(!mount.type.syncfs){return done(null)}mount.type.syncfs(mount,populate,done)}))}),mount:(function(type,opts,mountpoint){var root=mountpoint==="/";var pseudo=!mountpoint;var node;if(root&&FS.root){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}else if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});mountpoint=lookup.path;node=lookup.node;if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]};var mountRoot=type.mount(mount);mountRoot.mount=mount;mount.root=mountRoot;if(root){FS.root=mountRoot}else if(node){node.mounted=mount;if(node.mount){node.mount.mounts.push(mount)}}return mountRoot}),unmount:(function(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});if(!FS.isMountpoint(lookup.node)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=lookup.node;var mount=node.mounted;var mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach((function(hash){var current=FS.nameTable[hash];while(current){var next=current.name_next;if(mounts.indexOf(current.mount)!==-1){FS.destroyNode(current)}current=next}}));node.mounted=null;var idx=node.mount.mounts.indexOf(mount);assert(idx!==-1);node.mount.mounts.splice(idx,1)}),lookup:(function(parent,name){return parent.node_ops.lookup(parent,name)}),mknod:(function(path,mode,dev){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);if(!name||name==="."||name===".."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.mayCreate(parent,name);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.mknod){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.mknod(parent,name,mode,dev)}),create:(function(path,mode){mode=mode!==undefined?mode:438;mode&=4095;mode|=32768;return FS.mknod(path,mode,0)}),mkdir:(function(path,mode){mode=mode!==undefined?mode:511;mode&=511|512;mode|=16384;return FS.mknod(path,mode,0)}),mkdev:(function(path,mode,dev){if(typeof dev==="undefined"){dev=mode;mode=438}mode|=8192;return FS.mknod(path,mode,dev)}),symlink:(function(oldpath,newpath){if(!PATH.resolve(oldpath)){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var lookup=FS.lookupPath(newpath,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var newname=PATH.basename(newpath);var err=FS.mayCreate(parent,newname);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.symlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.symlink(parent,newname,oldpath)}),rename:(function(old_path,new_path){var old_dirname=PATH.dirname(old_path);var new_dirname=PATH.dirname(new_path);var old_name=PATH.basename(old_path);var new_name=PATH.basename(new_path);var lookup,old_dir,new_dir;try{lookup=FS.lookupPath(old_path,{parent:true});old_dir=lookup.node;lookup=FS.lookupPath(new_path,{parent:true});new_dir=lookup.node}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!old_dir||!new_dir)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(old_dir.mount!==new_dir.mount){throw new FS.ErrnoError(ERRNO_CODES.EXDEV)}var old_node=FS.lookupNode(old_dir,old_name);var relative=PATH.relative(old_path,new_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}relative=PATH.relative(new_path,old_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node===new_node){return}var isdir=FS.isDir(old_node.mode);var err=FS.mayDelete(old_dir,old_name,isdir);if(err){throw new FS.ErrnoError(err)}err=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name);if(err){throw new FS.ErrnoError(err)}if(!old_dir.node_ops.rename){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(new_dir!==old_dir){err=FS.nodePermissions(old_dir,"w");if(err){throw new FS.ErrnoError(err)}}try{if(FS.trackingDelegate["willMovePath"]){FS.trackingDelegate["willMovePath"](old_path,new_path)}}catch(e){console.log("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name)}catch(e){throw e}finally{FS.hashAddNode(old_node)}try{if(FS.trackingDelegate["onMovePath"])FS.trackingDelegate["onMovePath"](old_path,new_path)}catch(e){console.log("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}}),rmdir:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,true);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.rmdir){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.rmdir(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;if(!node.node_ops.readdir){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}return node.node_ops.readdir(node)}),unlink:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,false);if(err){if(err===ERRNO_CODES.EISDIR)err=ERRNO_CODES.EPERM;throw new FS.ErrnoError(err)}if(!parent.node_ops.unlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.unlink(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readlink:(function(path){var lookup=FS.lookupPath(path);var link=lookup.node;if(!link){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!link.node_ops.readlink){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return PATH.resolve(FS.getPath(lookup.node.parent),link.node_ops.readlink(link))}),stat:(function(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow});var node=lookup.node;if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!node.node_ops.getattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return node.node_ops.getattr(node)}),lstat:(function(path){return FS.stat(path,true)}),chmod:(function(path,mode,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{mode:mode&4095|node.mode&~4095,timestamp:Date.now()})}),lchmod:(function(path,mode){FS.chmod(path,mode,true)}),fchmod:(function(fd,mode){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chmod(stream.node,mode)}),chown:(function(path,uid,gid,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{timestamp:Date.now()})}),lchown:(function(path,uid,gid){FS.chown(path,uid,gid,true)}),fchown:(function(fd,uid,gid){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chown(stream.node,uid,gid)}),truncate:(function(path,len){if(len<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:true});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!FS.isFile(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.nodePermissions(node,"w");if(err){throw new FS.ErrnoError(err)}node.node_ops.setattr(node,{size:len,timestamp:Date.now()})}),ftruncate:(function(fd,len){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}FS.truncate(stream.node,len)}),utime:(function(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})}),open:(function(path,flags,mode,fd_start,fd_end){if(path===""){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}flags=typeof flags==="string"?FS.modeStringToFlags(flags):flags;mode=typeof mode==="undefined"?438:mode;if(flags&64){mode=mode&4095|32768}else{mode=0}var node;if(typeof path==="object"){node=path}else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(flags&131072)});node=lookup.node}catch(e){}}var created=false;if(flags&64){if(node){if(flags&128){throw new FS.ErrnoError(ERRNO_CODES.EEXIST)}}else{node=FS.mknod(path,mode,0);created=true}}if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(FS.isChrdev(node.mode)){flags&=~512}if(!created){var err=FS.mayOpen(node,flags);if(err){throw new FS.ErrnoError(err)}}if(flags&512){FS.truncate(node,0)}flags&=~(128|512);var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:true,position:0,stream_ops:node.stream_ops,ungotten:[],error:false},fd_start,fd_end);if(stream.stream_ops.open){stream.stream_ops.open(stream)}if(Module["logReadFiles"]&&!(flags&1)){if(!FS.readFiles)FS.readFiles={};if(!(path in FS.readFiles)){FS.readFiles[path]=1;Module["printErr"]("read file: "+path)}}try{if(FS.trackingDelegate["onOpenFile"]){var trackingFlags=0;if((flags&2097155)!==1){trackingFlags|=FS.tracking.openFlags.READ}if((flags&2097155)!==0){trackingFlags|=FS.tracking.openFlags.WRITE}FS.trackingDelegate["onOpenFile"](path,trackingFlags)}}catch(e){console.log("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: "+e.message)}return stream}),close:(function(stream){try{if(stream.stream_ops.close){stream.stream_ops.close(stream)}}catch(e){throw e}finally{FS.closeStream(stream.fd)}}),llseek:(function(stream,offset,whence){if(!stream.seekable||!stream.stream_ops.llseek){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}stream.position=stream.stream_ops.llseek(stream,offset,whence);stream.ungotten=[];return stream.position}),read:(function(stream,buffer,offset,length,position){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.read){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);if(!seeking)stream.position+=bytesRead;return bytesRead}),write:(function(stream,buffer,offset,length,position,canOwn){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.write){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if(stream.flags&1024){FS.llseek(stream,0,2)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);if(!seeking)stream.position+=bytesWritten;try{if(stream.path&&FS.trackingDelegate["onWriteToFile"])FS.trackingDelegate["onWriteToFile"](stream.path)}catch(e){console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: "+e.message)}return bytesWritten}),allocate:(function(stream,offset,length){if(offset<0||length<=0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(!FS.isFile(stream.node.mode)&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(!stream.stream_ops.allocate){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)}stream.stream_ops.allocate(stream,offset,length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EACCES)}if(!stream.stream_ops.mmap){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}return stream.stream_ops.mmap(stream,buffer,offset,length,position,prot,flags)}),ioctl:(function(stream,cmd,arg){if(!stream.stream_ops.ioctl){throw new FS.ErrnoError(ERRNO_CODES.ENOTTY)}return stream.stream_ops.ioctl(stream,cmd,arg)}),readFile:(function(path,opts){opts=opts||{};opts.flags=opts.flags||"r";opts.encoding=opts.encoding||"binary";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var ret;var stream=FS.open(path,opts.flags);var stat=FS.stat(path);var length=stat.size;var buf=new Uint8Array(length);FS.read(stream,buf,0,length,0);if(opts.encoding==="utf8"){ret=UTF8ArrayToString(buf,0)}else if(opts.encoding==="binary"){ret=buf}FS.close(stream);return ret}),writeFile:(function(path,data,opts){opts=opts||{};opts.flags=opts.flags||"w";opts.encoding=opts.encoding||"utf8";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var stream=FS.open(path,opts.flags,opts.mode);if(opts.encoding==="utf8"){var buf=new Uint8Array(lengthBytesUTF8(data)+1);var actualNumBytes=stringToUTF8Array(data,buf,0,buf.length);FS.write(stream,buf,0,actualNumBytes,0,opts.canOwn)}else if(opts.encoding==="binary"){FS.write(stream,data,0,data.length,0,opts.canOwn)}FS.close(stream)}),cwd:(function(){return FS.currentPath}),chdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});if(!FS.isDir(lookup.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}var err=FS.nodePermissions(lookup.node,"x");if(err){throw new FS.ErrnoError(err)}FS.currentPath=lookup.path}),createDefaultDirectories:(function(){FS.mkdir("/tmp");FS.mkdir("/home");FS.mkdir("/home/web_user")}),createDefaultDevices:(function(){FS.mkdir("/dev");FS.registerDevice(FS.makedev(1,3),{read:(function(){return 0}),write:(function(){return 0})});FS.mkdev("/dev/null",FS.makedev(1,3));TTY.register(FS.makedev(5,0),TTY.default_tty_ops);TTY.register(FS.makedev(6,0),TTY.default_tty1_ops);FS.mkdev("/dev/tty",FS.makedev(5,0));FS.mkdev("/dev/tty1",FS.makedev(6,0));var random_device;if(typeof crypto!=="undefined"){var randomBuffer=new Uint8Array(1);random_device=(function(){crypto.getRandomValues(randomBuffer);return randomBuffer[0]})}else if(ENVIRONMENT_IS_NODE){random_device=(function(){return require("crypto").randomBytes(1)[0]})}else{random_device=(function(){return Math.random()*256|0})}FS.createDevice("/dev","random",random_device);FS.createDevice("/dev","urandom",random_device);FS.mkdir("/dev/shm");FS.mkdir("/dev/shm/tmp")}),createStandardStreams:(function(){if(Module["stdin"]){FS.createDevice("/dev","stdin",Module["stdin"])}else{FS.symlink("/dev/tty","/dev/stdin")}if(Module["stdout"]){FS.createDevice("/dev","stdout",null,Module["stdout"])}else{FS.symlink("/dev/tty","/dev/stdout")}if(Module["stderr"]){FS.createDevice("/dev","stderr",null,Module["stderr"])}else{FS.symlink("/dev/tty1","/dev/stderr")}var stdin=FS.open("/dev/stdin","r");HEAP32[_stdin>>2]=FS.getPtrForStream(stdin);assert(stdin.fd===0,"invalid handle for stdin ("+stdin.fd+")");var stdout=FS.open("/dev/stdout","w");HEAP32[_stdout>>2]=FS.getPtrForStream(stdout);assert(stdout.fd===1,"invalid handle for stdout ("+stdout.fd+")");var stderr=FS.open("/dev/stderr","w");HEAP32[_stderr>>2]=FS.getPtrForStream(stderr);assert(stderr.fd===2,"invalid handle for stderr ("+stderr.fd+")")}),ensureErrnoError:(function(){if(FS.ErrnoError)return;FS.ErrnoError=function ErrnoError(errno,node){this.node=node;this.setErrno=(function(errno){this.errno=errno;for(var key in ERRNO_CODES){if(ERRNO_CODES[key]===errno){this.code=key;break}}});this.setErrno(errno);this.message=ERRNO_MESSAGES[errno]};FS.ErrnoError.prototype=new Error;FS.ErrnoError.prototype.constructor=FS.ErrnoError;[ERRNO_CODES.ENOENT].forEach((function(code){FS.genericErrors[code]=new FS.ErrnoError(code);FS.genericErrors[code].stack="<generic error, no stack>"}))}),staticInit:(function(){FS.ensureErrnoError();FS.nameTable=new Array(4096);FS.mount(MEMFS,{},"/");FS.createDefaultDirectories();FS.createDefaultDevices()}),init:(function(input,output,error){assert(!FS.init.initialized,"FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");FS.init.initialized=true;FS.ensureErrnoError();Module["stdin"]=input||Module["stdin"];Module["stdout"]=output||Module["stdout"];Module["stderr"]=error||Module["stderr"];FS.createStandardStreams()}),quit:(function(){FS.init.initialized=false;for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];if(!stream){continue}FS.close(stream)}}),getMode:(function(canRead,canWrite){var mode=0;if(canRead)mode|=292|73;if(canWrite)mode|=146;return mode}),joinPath:(function(parts,forceRelative){var path=PATH.join.apply(null,parts);if(forceRelative&&path[0]=="/")path=path.substr(1);return path}),absolutePath:(function(relative,base){return PATH.resolve(base,relative)}),standardizePath:(function(path){return PATH.normalize(path)}),findObject:(function(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);if(ret.exists){return ret.object}else{___setErrNo(ret.error);return null}}),analyzePath:(function(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:false,exists:false,error:0,name:null,path:null,object:null,parentExists:false,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:true});ret.parentExists=true;ret.parentPath=lookup.path;ret.parentObject=lookup.node;ret.name=PATH.basename(path);lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});ret.exists=true;ret.path=lookup.path;ret.object=lookup.node;ret.name=lookup.node.name;ret.isRoot=lookup.path==="/"}catch(e){ret.error=e.errno}return ret}),createFolder:(function(parent,name,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.mkdir(path,mode)}),createPath:(function(parent,path,canRead,canWrite){parent=typeof parent==="string"?parent:FS.getPath(parent);var parts=path.split("/").reverse();while(parts.length){var part=parts.pop();if(!part)continue;var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}return current}),createFile:(function(parent,name,properties,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.create(path,mode)}),createDataFile:(function(parent,name,data,canRead,canWrite,canOwn){var path=name?PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name):parent;var mode=FS.getMode(canRead,canWrite);var node=FS.create(path,mode);if(data){if(typeof data==="string"){var arr=new Array(data.length);for(var i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,mode|146);var stream=FS.open(node,"w");FS.write(stream,data,0,data.length,0,canOwn);FS.close(stream);FS.chmod(node,mode)}return node}),createDevice:(function(parent,name,input,output){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(!!input,!!output);if(!FS.createDevice.major)FS.createDevice.major=64;var dev=FS.makedev(FS.createDevice.major++,0);FS.registerDevice(dev,{open:(function(stream){stream.seekable=false}),close:(function(stream){if(output&&output.buffer&&output.buffer.length){output(10)}}),read:(function(stream,buffer,offset,length,pos){var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){for(var i=0;i<length;i++){try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})});return FS.mkdev(path,mode,dev)}),createLink:(function(parent,name,target,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);return FS.symlink(target,path)}),forceLoadFile:(function(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return true;var success=true;if(typeof XMLHttpRequest!=="undefined"){throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")}else if(Module["read"]){try{obj.contents=intArrayFromString(Module["read"](obj.url),true);obj.usedBytes=obj.contents.length}catch(e){success=false}}else{throw new Error("Cannot load without read() or XMLHttpRequest.")}if(!success)___setErrNo(ERRNO_CODES.EIO);return success}),createLazyFile:(function(parent,name,url,canRead,canWrite){function LazyUint8Array(){this.lengthKnown=false;this.chunks=[]}LazyUint8Array.prototype.get=function LazyUint8Array_get(idx){if(idx>this.length-1||idx<0){return undefined}var chunkOffset=idx%this.chunkSize;var chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]};LazyUint8Array.prototype.setDataGetter=function LazyUint8Array_setDataGetter(getter){this.getter=getter};LazyUint8Array.prototype.cacheLength=function LazyUint8Array_cacheLength(){var xhr=new XMLHttpRequest;xhr.open("HEAD",url,false);xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var datalength=Number(xhr.getResponseHeader("Content-length"));var header;var hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&header==="bytes";var chunkSize=1024*1024;if(!hasByteServing)chunkSize=datalength;var doXHR=(function(from,to){if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;xhr.open("GET",url,false);if(datalength!==chunkSize)xhr.setRequestHeader("Range","bytes="+from+"-"+to);if(typeof Uint8Array!="undefined")xhr.responseType="arraybuffer";if(xhr.overrideMimeType){xhr.overrideMimeType("text/plain; charset=x-user-defined")}xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);if(xhr.response!==undefined){return new Uint8Array(xhr.response||[])}else{return intArrayFromString(xhr.responseText||"",true)}});var lazyArray=this;lazyArray.setDataGetter((function(chunkNum){var start=chunkNum*chunkSize;var end=(chunkNum+1)*chunkSize-1;end=Math.min(end,datalength-1);if(typeof lazyArray.chunks[chunkNum]==="undefined"){lazyArray.chunks[chunkNum]=doXHR(start,end)}if(typeof lazyArray.chunks[chunkNum]==="undefined")throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]}));this._length=datalength;this._chunkSize=chunkSize;this.lengthKnown=true};if(typeof XMLHttpRequest!=="undefined"){if(!ENVIRONMENT_IS_WORKER)throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var lazyArray=new LazyUint8Array;Object.defineProperty(lazyArray,"length",{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._length})});Object.defineProperty(lazyArray,"chunkSize",{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._chunkSize})});var properties={isDevice:false,contents:lazyArray}}else{var properties={isDevice:false,url:url}}var node=FS.createFile(parent,name,properties,canRead,canWrite);if(properties.contents){node.contents=properties.contents}else if(properties.url){node.contents=null;node.url=properties.url}Object.defineProperty(node,"usedBytes",{get:(function(){return this.contents.length})});var stream_ops={};var keys=Object.keys(node.stream_ops);keys.forEach((function(key){var fn=node.stream_ops[key];stream_ops[key]=function forceLoadLazyFile(){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return fn.apply(null,arguments)}}));stream_ops.read=function stream_ops_read(stream,buffer,offset,length,position){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);assert(size>=0);if(contents.slice){for(var i=0;i<size;i++){buffer[offset+i]=contents[position+i]}}else{for(var i=0;i<size;i++){buffer[offset+i]=contents.get(position+i)}}return size};node.stream_ops=stream_ops;return node}),createPreloadedFile:(function(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn){Browser.init();var fullname=name?PATH.resolve(PATH.join2(parent,name)):parent;function processData(byteArray){function finish(byteArray){if(!dontCreateFile){FS.createDataFile(parent,name,byteArray,canRead,canWrite,canOwn)}if(onload)onload();removeRunDependency("cp "+fullname)}var handled=false;Module["preloadPlugins"].forEach((function(plugin){if(handled)return;if(plugin["canHandle"](fullname)){plugin["handle"](byteArray,fullname,finish,(function(){if(onerror)onerror();removeRunDependency("cp "+fullname)}));handled=true}}));if(!handled)finish(byteArray)}addRunDependency("cp "+fullname);if(typeof url=="string"){Browser.asyncLoad(url,(function(byteArray){processData(byteArray)}),onerror)}else{processData(url)}}),indexedDB:(function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB}),DB_NAME:(function(){return"EM_FS_"+window.location.pathname}),DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=function openRequest_onupgradeneeded(){console.log("creating db");var db=openRequest.result;db.createObjectStore(FS.DB_STORE_NAME)};openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;var transaction=db.transaction([FS.DB_STORE_NAME],"readwrite");var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var putRequest=files.put(FS.analyzePath(path).object.contents,path);putRequest.onsuccess=function putRequest_onsuccess(){ok++;if(ok+fail==total)finish()};putRequest.onerror=function putRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror}),loadFilesFromDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=onerror;openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;try{var transaction=db.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){onerror(e);return}var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var getRequest=files.get(path);getRequest.onsuccess=function getRequest_onsuccess(){if(FS.analyzePath(path).exists){FS.unlink(path)}FS.createDataFile(PATH.dirname(path),PATH.basename(path),getRequest.result,true,true,true);ok++;if(ok+fail==total)finish()};getRequest.onerror=function getRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror})};function _close(fildes){var stream=FS.getStream(fildes);if(!stream){___setErrNo(ERRNO_CODES.EBADF);return-1}try{FS.close(stream);return 0}catch(e){FS.handleFSError(e);return-1}}function _fsync(fildes){var stream=FS.getStream(fildes);if(stream){return 0}else{___setErrNo(ERRNO_CODES.EBADF);return-1}}function _fileno(stream){stream=FS.getStreamFromPtr(stream);if(!stream)return-1;return stream.fd}function _fclose(stream){var fd=_fileno(stream);_fsync(fd);return _close(fd)}function _pthread_mutex_lock(){}function _open(path,oflag,varargs){var mode=HEAP32[varargs>>2];path=Pointer_stringify(path);try{var stream=FS.open(path,oflag,mode);return stream.fd}catch(e){FS.handleFSError(e);return-1}}function _fopen(filename,mode){var flags;mode=Pointer_stringify(mode);if(mode[0]=="r"){if(mode.indexOf("+")!=-1){flags=2}else{flags=0}}else if(mode[0]=="w"){if(mode.indexOf("+")!=-1){flags=2}else{flags=1}flags|=64;flags|=512}else if(mode[0]=="a"){if(mode.indexOf("+")!=-1){flags=2}else{flags=1}flags|=64;flags|=1024}else{___setErrNo(ERRNO_CODES.EINVAL);return 0}var fd=_open(filename,flags,allocate([511,0,0,0],"i32",ALLOC_STACK));return fd===-1?0:FS.getPtrForStream(FS.getStream(fd))}function _mkport(){throw"TODO"}var SOCKFS={mount:(function(mount){Module["websocket"]=Module["websocket"]&&"object"===typeof Module["websocket"]?Module["websocket"]:{};Module["websocket"]._callbacks={};Module["websocket"]["on"]=(function(event,callback){if("function"===typeof callback){this._callbacks[event]=callback}return this});Module["websocket"].emit=(function(event,param){if("function"===typeof this._callbacks[event]){this._callbacks[event].call(this,param)}});return FS.createNode(null,"/",16384|511,0)}),createSocket:(function(family,type,protocol){var streaming=type==1;if(protocol){assert(streaming==(protocol==6))}var sock={family:family,type:type,protocol:protocol,server:null,error:null,peers:{},pending:[],recv_queue:[],sock_ops:SOCKFS.websocket_sock_ops};var name=SOCKFS.nextname();var node=FS.createNode(SOCKFS.root,name,49152,0);node.sock=sock;var stream=FS.createStream({path:name,node:node,flags:FS.modeStringToFlags("r+"),seekable:false,stream_ops:SOCKFS.stream_ops});sock.stream=stream;return sock}),getSocket:(function(fd){var stream=FS.getStream(fd);if(!stream||!FS.isSocket(stream.node.mode)){return null}return stream.node.sock}),stream_ops:{poll:(function(stream){var sock=stream.node.sock;return sock.sock_ops.poll(sock)}),ioctl:(function(stream,request,varargs){var sock=stream.node.sock;return sock.sock_ops.ioctl(sock,request,varargs)}),read:(function(stream,buffer,offset,length,position){var sock=stream.node.sock;var msg=sock.sock_ops.recvmsg(sock,length);if(!msg){return 0}buffer.set(msg.buffer,offset);return msg.buffer.length}),write:(function(stream,buffer,offset,length,position){var sock=stream.node.sock;return sock.sock_ops.sendmsg(sock,buffer,offset,length)}),close:(function(stream){var sock=stream.node.sock;sock.sock_ops.close(sock)})},nextname:(function(){if(!SOCKFS.nextname.current){SOCKFS.nextname.current=0}return"socket["+SOCKFS.nextname.current++ +"]"}),websocket_sock_ops:{createPeer:(function(sock,addr,port){var ws;if(typeof addr==="object"){ws=addr;addr=null;port=null}if(ws){if(ws._socket){addr=ws._socket.remoteAddress;port=ws._socket.remotePort}else{var result=/ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);if(!result){throw new Error("WebSocket URL must be in the format ws(s)://address:port")}addr=result[1];port=parseInt(result[2],10)}}else{try{var runtimeConfig=Module["websocket"]&&"object"===typeof Module["websocket"];var url="ws:#".replace("#","//");if(runtimeConfig){if("string"===typeof Module["websocket"]["url"]){url=Module["websocket"]["url"]}}if(url==="ws://"||url==="wss://"){var parts=addr.split("/");url=url+parts[0]+":"+port+"/"+parts.slice(1).join("/")}var subProtocols="binary";if(runtimeConfig){if("string"===typeof Module["websocket"]["subprotocol"]){subProtocols=Module["websocket"]["subprotocol"]}}subProtocols=subProtocols.replace(/^ +| +$/g,"").split(/ *, */);var opts=ENVIRONMENT_IS_NODE?{"protocol":subProtocols.toString()}:subProtocols;var WebSocket=ENVIRONMENT_IS_NODE?require("ws"):window["WebSocket"];ws=new WebSocket(url,opts);ws.binaryType="arraybuffer"}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH)}}var peer={addr:addr,port:port,socket:ws,dgram_send_queue:[]};SOCKFS.websocket_sock_ops.addPeer(sock,peer);SOCKFS.websocket_sock_ops.handlePeerEvents(sock,peer);if(sock.type===2&&typeof sock.sport!=="undefined"){peer.dgram_send_queue.push(new Uint8Array([255,255,255,255,"p".charCodeAt(0),"o".charCodeAt(0),"r".charCodeAt(0),"t".charCodeAt(0),(sock.sport&65280)>>8,sock.sport&255]))}return peer}),getPeer:(function(sock,addr,port){return sock.peers[addr+":"+port]}),addPeer:(function(sock,peer){sock.peers[peer.addr+":"+peer.port]=peer}),removePeer:(function(sock,peer){delete sock.peers[peer.addr+":"+peer.port]}),handlePeerEvents:(function(sock,peer){var first=true;var handleOpen=(function(){Module["websocket"].emit("open",sock.stream.fd);try{var queued=peer.dgram_send_queue.shift();while(queued){peer.socket.send(queued);queued=peer.dgram_send_queue.shift()}}catch(e){peer.socket.close()}});function handleMessage(data){assert(typeof data!=="string"&&data.byteLength!==undefined);data=new Uint8Array(data);var wasfirst=first;first=false;if(wasfirst&&data.length===10&&data[0]===255&&data[1]===255&&data[2]===255&&data[3]===255&&data[4]==="p".charCodeAt(0)&&data[5]==="o".charCodeAt(0)&&data[6]==="r".charCodeAt(0)&&data[7]==="t".charCodeAt(0)){var newport=data[8]<<8|data[9];SOCKFS.websocket_sock_ops.removePeer(sock,peer);peer.port=newport;SOCKFS.websocket_sock_ops.addPeer(sock,peer);return}sock.recv_queue.push({addr:peer.addr,port:peer.port,data:data});Module["websocket"].emit("message",sock.stream.fd)}if(ENVIRONMENT_IS_NODE){peer.socket.on("open",handleOpen);peer.socket.on("message",(function(data,flags){if(!flags.binary){return}handleMessage((new Uint8Array(data)).buffer)}));peer.socket.on("close",(function(){Module["websocket"].emit("close",sock.stream.fd)}));peer.socket.on("error",(function(error){sock.error=ERRNO_CODES.ECONNREFUSED;Module["websocket"].emit("error",[sock.stream.fd,sock.error,"ECONNREFUSED: Connection refused"])}))}else{peer.socket.onopen=handleOpen;peer.socket.onclose=(function(){Module["websocket"].emit("close",sock.stream.fd)});peer.socket.onmessage=function peer_socket_onmessage(event){handleMessage(event.data)};peer.socket.onerror=(function(error){sock.error=ERRNO_CODES.ECONNREFUSED;Module["websocket"].emit("error",[sock.stream.fd,sock.error,"ECONNREFUSED: Connection refused"])})}}),poll:(function(sock){if(sock.type===1&&sock.server){return sock.pending.length?64|1:0}var mask=0;var dest=sock.type===1?SOCKFS.websocket_sock_ops.getPeer(sock,sock.daddr,sock.dport):null;if(sock.recv_queue.length||!dest||dest&&dest.socket.readyState===dest.socket.CLOSING||dest&&dest.socket.readyState===dest.socket.CLOSED){mask|=64|1}if(!dest||dest&&dest.socket.readyState===dest.socket.OPEN){mask|=4}if(dest&&dest.socket.readyState===dest.socket.CLOSING||dest&&dest.socket.readyState===dest.socket.CLOSED){mask|=16}return mask}),ioctl:(function(sock,request,arg){switch(request){case 21531:var bytes=0;if(sock.recv_queue.length){bytes=sock.recv_queue[0].data.length}HEAP32[arg>>2]=bytes;return 0;default:return ERRNO_CODES.EINVAL}}),close:(function(sock){if(sock.server){try{sock.server.close()}catch(e){}sock.server=null}var peers=Object.keys(sock.peers);for(var i=0;i<peers.length;i++){var peer=sock.peers[peers[i]];try{peer.socket.close()}catch(e){}SOCKFS.websocket_sock_ops.removePeer(sock,peer)}return 0}),bind:(function(sock,addr,port){if(typeof sock.saddr!=="undefined"||typeof sock.sport!=="undefined"){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}sock.saddr=addr;sock.sport=port||_mkport();if(sock.type===2){if(sock.server){sock.server.close();sock.server=null}try{sock.sock_ops.listen(sock,0)}catch(e){if(!(e instanceof FS.ErrnoError))throw e;if(e.errno!==ERRNO_CODES.EOPNOTSUPP)throw e}}}),connect:(function(sock,addr,port){if(sock.server){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)}if(typeof sock.daddr!=="undefined"&&typeof sock.dport!=="undefined"){var dest=SOCKFS.websocket_sock_ops.getPeer(sock,sock.daddr,sock.dport);if(dest){if(dest.socket.readyState===dest.socket.CONNECTING){throw new FS.ErrnoError(ERRNO_CODES.EALREADY)}else{throw new FS.ErrnoError(ERRNO_CODES.EISCONN)}}}var peer=SOCKFS.websocket_sock_ops.createPeer(sock,addr,port);sock.daddr=peer.addr;sock.dport=peer.port;throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS)}),listen:(function(sock,backlog){if(!ENVIRONMENT_IS_NODE){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)}if(sock.server){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var WebSocketServer=require("ws").Server;var host=sock.saddr;sock.server=new WebSocketServer({host:host,port:sock.sport});Module["websocket"].emit("listen",sock.stream.fd);sock.server.on("connection",(function(ws){if(sock.type===1){var newsock=SOCKFS.createSocket(sock.family,sock.type,sock.protocol);var peer=SOCKFS.websocket_sock_ops.createPeer(newsock,ws);newsock.daddr=peer.addr;newsock.dport=peer.port;sock.pending.push(newsock);Module["websocket"].emit("connection",newsock.stream.fd)}else{SOCKFS.websocket_sock_ops.createPeer(sock,ws);Module["websocket"].emit("connection",sock.stream.fd)}}));sock.server.on("closed",(function(){Module["websocket"].emit("close",sock.stream.fd);sock.server=null}));sock.server.on("error",(function(error){sock.error=ERRNO_CODES.EHOSTUNREACH;Module["websocket"].emit("error",[sock.stream.fd,sock.error,"EHOSTUNREACH: Host is unreachable"])}))}),accept:(function(listensock){if(!listensock.server){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var newsock=listensock.pending.shift();newsock.stream.flags=listensock.stream.flags;return newsock}),getname:(function(sock,peer){var addr,port;if(peer){if(sock.daddr===undefined||sock.dport===undefined){throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN)}addr=sock.daddr;port=sock.dport}else{addr=sock.saddr||0;port=sock.sport||0}return{addr:addr,port:port}}),sendmsg:(function(sock,buffer,offset,length,addr,port){if(sock.type===2){if(addr===undefined||port===undefined){addr=sock.daddr;port=sock.dport}if(addr===undefined||port===undefined){throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ)}}else{addr=sock.daddr;port=sock.dport}var dest=SOCKFS.websocket_sock_ops.getPeer(sock,addr,port);if(sock.type===1){if(!dest||dest.socket.readyState===dest.socket.CLOSING||dest.socket.readyState===dest.socket.CLOSED){throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN)}else if(dest.socket.readyState===dest.socket.CONNECTING){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}}var data;if(buffer instanceof Array||buffer instanceof ArrayBuffer){data=buffer.slice(offset,offset+length)}else{data=buffer.buffer.slice(buffer.byteOffset+offset,buffer.byteOffset+offset+length)}if(sock.type===2){if(!dest||dest.socket.readyState!==dest.socket.OPEN){if(!dest||dest.socket.readyState===dest.socket.CLOSING||dest.socket.readyState===dest.socket.CLOSED){dest=SOCKFS.websocket_sock_ops.createPeer(sock,addr,port)}dest.dgram_send_queue.push(data);return length}}try{dest.socket.send(data);return length}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}}),recvmsg:(function(sock,length){if(sock.type===1&&sock.server){throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN)}var queued=sock.recv_queue.shift();if(!queued){if(sock.type===1){var dest=SOCKFS.websocket_sock_ops.getPeer(sock,sock.daddr,sock.dport);if(!dest){throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN)}else if(dest.socket.readyState===dest.socket.CLOSING||dest.socket.readyState===dest.socket.CLOSED){return null}else{throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}}else{throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}}var queuedLength=queued.data.byteLength||queued.data.length;var queuedOffset=queued.data.byteOffset||0;var queuedBuffer=queued.data.buffer||queued.data;var bytesRead=Math.min(length,queuedLength);var res={buffer:new Uint8Array(queuedBuffer,queuedOffset,bytesRead),addr:queued.addr,port:queued.port};if(sock.type===1&&bytesRead<queuedLength){var bytesRemaining=queuedLength-bytesRead;queued.data=new Uint8Array(queuedBuffer,queuedOffset+bytesRead,bytesRemaining);sock.recv_queue.unshift(queued)}return res})}};function _send(fd,buf,len,flags){var sock=SOCKFS.getSocket(fd);if(!sock){___setErrNo(ERRNO_CODES.EBADF);return-1}return _write(fd,buf,len)}function _pwrite(fildes,buf,nbyte,offset){var stream=FS.getStream(fildes);if(!stream){___setErrNo(ERRNO_CODES.EBADF);return-1}try{var slab=HEAP8;return FS.write(stream,slab,buf,nbyte,offset)}catch(e){FS.handleFSError(e);return-1}}function _write(fildes,buf,nbyte){var stream=FS.getStream(fildes);if(!stream){___setErrNo(ERRNO_CODES.EBADF);return-1}try{var slab=HEAP8;return FS.write(stream,slab,buf,nbyte)}catch(e){FS.handleFSError(e);return-1}}function _fputc(c,stream){var chr=unSign(c&255);HEAP8[_fputc.ret>>0]=chr;var fd=_fileno(stream);var ret=_write(fd,_fputc.ret,1);if(ret==-1){var streamObj=FS.getStreamFromPtr(stream);if(streamObj)streamObj.error=true;return-1}else{return chr}}var _log=Math_log;function _fwrite(ptr,size,nitems,stream){var bytesToWrite=nitems*size;if(bytesToWrite==0)return 0;var fd=_fileno(stream);var bytesWritten=_write(fd,ptr,bytesToWrite);if(bytesWritten==-1){var streamObj=FS.getStreamFromPtr(stream);if(streamObj)streamObj.error=true;return 0}else{return bytesWritten/size|0}}function _emscripten_set_main_loop_timing(mode,value){Browser.mainLoop.timingMode=mode;Browser.mainLoop.timingValue=value;if(!Browser.mainLoop.func){return 1}if(mode==0){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler(){setTimeout(Browser.mainLoop.runner,value)};Browser.mainLoop.method="timeout"}else if(mode==1){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler(){Browser.requestAnimationFrame(Browser.mainLoop.runner)};Browser.mainLoop.method="rAF"}return 0}function _emscripten_set_main_loop(func,fps,simulateInfiniteLoop,arg,noSetTiming){Module["noExitRuntime"]=true;assert(!Browser.mainLoop.func,"emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");Browser.mainLoop.func=func;Browser.mainLoop.arg=arg;var thisMainLoopId=Browser.mainLoop.currentlyRunningMainloop;Browser.mainLoop.runner=function Browser_mainLoop_runner(){if(ABORT)return;if(Browser.mainLoop.queue.length>0){var start=Date.now();var blocker=Browser.mainLoop.queue.shift();blocker.func(blocker.arg);if(Browser.mainLoop.remainingBlockers){var remaining=Browser.mainLoop.remainingBlockers;var next=remaining%1==0?remaining-1:Math.floor(remaining);if(blocker.counted){Browser.mainLoop.remainingBlockers=next}else{next=next+.5;Browser.mainLoop.remainingBlockers=(8*remaining+next)/9}}console.log('main loop blocker "'+blocker.name+'" took '+(Date.now()-start)+" ms");Browser.mainLoop.updateStatus();setTimeout(Browser.mainLoop.runner,0);return}if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;Browser.mainLoop.currentFrameNumber=Browser.mainLoop.currentFrameNumber+1|0;if(Browser.mainLoop.timingMode==1&&Browser.mainLoop.timingValue>1&&Browser.mainLoop.currentFrameNumber%Browser.mainLoop.timingValue!=0){Browser.mainLoop.scheduler();return}if(Browser.mainLoop.method==="timeout"&&Module.ctx){Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");Browser.mainLoop.method=""}Browser.mainLoop.runIter((function(){if(typeof arg!=="undefined"){Runtime.dynCall("vi",func,[arg])}else{Runtime.dynCall("v",func)}}));if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;if(typeof SDL==="object"&&SDL.audio&&SDL.audio.queueNewAudioData)SDL.audio.queueNewAudioData();Browser.mainLoop.scheduler()};if(!noSetTiming){if(fps&&fps>0)_emscripten_set_main_loop_timing(0,1e3/fps);else _emscripten_set_main_loop_timing(1,1);Browser.mainLoop.scheduler()}if(simulateInfiniteLoop){throw"SimulateInfiniteLoop"}}var Browser={mainLoop:{scheduler:null,method:"",currentlyRunningMainloop:0,func:null,arg:0,timingMode:0,timingValue:0,currentFrameNumber:0,queue:[],pause:(function(){Browser.mainLoop.scheduler=null;Browser.mainLoop.currentlyRunningMainloop++}),resume:(function(){Browser.mainLoop.currentlyRunningMainloop++;var timingMode=Browser.mainLoop.timingMode;var timingValue=Browser.mainLoop.timingValue;var func=Browser.mainLoop.func;Browser.mainLoop.func=null;_emscripten_set_main_loop(func,0,false,Browser.mainLoop.arg,true);_emscripten_set_main_loop_timing(timingMode,timingValue);Browser.mainLoop.scheduler()}),updateStatus:(function(){if(Module["setStatus"]){var message=Module["statusMessage"]||"Please wait...";var remaining=Browser.mainLoop.remainingBlockers;var expected=Browser.mainLoop.expectedBlockers;if(remaining){if(remaining<expected){Module["setStatus"](message+" ("+(expected-remaining)+"/"+expected+")")}else{Module["setStatus"](message)}}else{Module["setStatus"]("")}}}),runIter:(function(func){if(ABORT)return;if(Module["preMainLoop"]){var preRet=Module["preMainLoop"]();if(preRet===false){return}}try{func()}catch(e){if(e instanceof ExitStatus){return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}if(Module["postMainLoop"])Module["postMainLoop"]()})},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:(function(){if(!Module["preloadPlugins"])Module["preloadPlugins"]=[];if(Browser.initted)return;Browser.initted=true;try{new Blob;Browser.hasBlobConstructor=true}catch(e){Browser.hasBlobConstructor=false;console.log("warning: no blob constructor, cannot create blobs with mimetypes")}Browser.BlobBuilder=typeof MozBlobBuilder!="undefined"?MozBlobBuilder:typeof WebKitBlobBuilder!="undefined"?WebKitBlobBuilder:!Browser.hasBlobConstructor?console.log("warning: no BlobBuilder"):null;Browser.URLObject=typeof window!="undefined"?window.URL?window.URL:window.webkitURL:undefined;if(!Module.noImageDecoding&&typeof Browser.URLObject==="undefined"){console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");Module.noImageDecoding=true}var imagePlugin={};imagePlugin["canHandle"]=function imagePlugin_canHandle(name){return!Module.noImageDecoding&&/\.(jpg|jpeg|png|bmp)$/i.test(name)};imagePlugin["handle"]=function imagePlugin_handle(byteArray,name,onload,onerror){var b=null;if(Browser.hasBlobConstructor){try{b=new Blob([byteArray],{type:Browser.getMimetype(name)});if(b.size!==byteArray.length){b=new Blob([(new Uint8Array(byteArray)).buffer],{type:Browser.getMimetype(name)})}}catch(e){Runtime.warnOnce("Blob constructor present but fails: "+e+"; falling back to blob builder")}}if(!b){var bb=new Browser.BlobBuilder;bb.append((new Uint8Array(byteArray)).buffer);b=bb.getBlob()}var url=Browser.URLObject.createObjectURL(b);var img=new Image;img.onload=function img_onload(){assert(img.complete,"Image "+name+" could not be decoded");var canvas=document.createElement("canvas");canvas.width=img.width;canvas.height=img.height;var ctx=canvas.getContext("2d");ctx.drawImage(img,0,0);Module["preloadedImages"][name]=canvas;Browser.URLObject.revokeObjectURL(url);if(onload)onload(byteArray)};img.onerror=function img_onerror(event){console.log("Image "+url+" could not be decoded");if(onerror)onerror()};img.src=url};Module["preloadPlugins"].push(imagePlugin);var audioPlugin={};audioPlugin["canHandle"]=function audioPlugin_canHandle(name){return!Module.noAudioDecoding&&name.substr(-4)in{".ogg":1,".wav":1,".mp3":1}};audioPlugin["handle"]=function audioPlugin_handle(byteArray,name,onload,onerror){var done=false;function finish(audio){if(done)return;done=true;Module["preloadedAudios"][name]=audio;if(onload)onload(byteArray)}function fail(){if(done)return;done=true;Module["preloadedAudios"][name]=new Audio;if(onerror)onerror()}if(Browser.hasBlobConstructor){try{var b=new Blob([byteArray],{type:Browser.getMimetype(name)})}catch(e){return fail()}var url=Browser.URLObject.createObjectURL(b);var audio=new Audio;audio.addEventListener("canplaythrough",(function(){finish(audio)}),false);audio.onerror=function audio_onerror(event){if(done)return;console.log("warning: browser could not fully decode audio "+name+", trying slower base64 approach");function encode64(data){var BASE="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";var PAD="=";var ret="";var leftchar=0;var leftbits=0;for(var i=0;i<data.length;i++){leftchar=leftchar<<8|data[i];leftbits+=8;while(leftbits>=6){var curr=leftchar>>leftbits-6&63;leftbits-=6;ret+=BASE[curr]}}if(leftbits==2){ret+=BASE[(leftchar&3)<<4];ret+=PAD+PAD}else if(leftbits==4){ret+=BASE[(leftchar&15)<<2];ret+=PAD}return ret}audio.src="data:audio/x-"+name.substr(-3)+";base64,"+encode64(byteArray);finish(audio)};audio.src=url;Browser.safeSetTimeout((function(){finish(audio)}),1e4)}else{return fail()}};Module["preloadPlugins"].push(audioPlugin);var canvas=Module["canvas"];function pointerLockChange(){Browser.pointerLock=document["pointerLockElement"]===canvas||document["mozPointerLockElement"]===canvas||document["webkitPointerLockElement"]===canvas||document["msPointerLockElement"]===canvas}if(canvas){canvas.requestPointerLock=canvas["requestPointerLock"]||canvas["mozRequestPointerLock"]||canvas["webkitRequestPointerLock"]||canvas["msRequestPointerLock"]||(function(){});canvas.exitPointerLock=document["exitPointerLock"]||document["mozExitPointerLock"]||document["webkitExitPointerLock"]||document["msExitPointerLock"]||(function(){});canvas.exitPointerLock=canvas.exitPointerLock.bind(document);document.addEventListener("pointerlockchange",pointerLockChange,false);document.addEventListener("mozpointerlockchange",pointerLockChange,false);document.addEventListener("webkitpointerlockchange",pointerLockChange,false);document.addEventListener("mspointerlockchange",pointerLockChange,false);if(Module["elementPointerLock"]){canvas.addEventListener("click",(function(ev){if(!Browser.pointerLock&&canvas.requestPointerLock){canvas.requestPointerLock();ev.preventDefault()}}),false)}}}),createContext:(function(canvas,useWebGL,setInModule,webGLContextAttributes){if(useWebGL&&Module.ctx&&canvas==Module.canvas)return Module.ctx;var ctx;var contextHandle;if(useWebGL){var contextAttributes={antialias:false,alpha:false};if(webGLContextAttributes){for(var attribute in webGLContextAttributes){contextAttributes[attribute]=webGLContextAttributes[attribute]}}contextHandle=GL.createContext(canvas,contextAttributes);if(contextHandle){ctx=GL.getContext(contextHandle).GLctx}canvas.style.backgroundColor="black"}else{ctx=canvas.getContext("2d")}if(!ctx)return null;if(setInModule){if(!useWebGL)assert(typeof GLctx==="undefined","cannot set in module if GLctx is used, but we are a non-GL context that would replace it");Module.ctx=ctx;if(useWebGL)GL.makeContextCurrent(contextHandle);Module.useWebGL=useWebGL;Browser.moduleContextCreatedCallbacks.forEach((function(callback){callback()}));Browser.init()}return ctx}),destroyContext:(function(canvas,useWebGL,setInModule){}),fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:(function(lockPointer,resizeCanvas,vrDevice){Browser.lockPointer=lockPointer;Browser.resizeCanvas=resizeCanvas;Browser.vrDevice=vrDevice;if(typeof Browser.lockPointer==="undefined")Browser.lockPointer=true;if(typeof Browser.resizeCanvas==="undefined")Browser.resizeCanvas=false;if(typeof Browser.vrDevice==="undefined")Browser.vrDevice=null;var canvas=Module["canvas"];function fullScreenChange(){Browser.isFullScreen=false;var canvasContainer=canvas.parentNode;if((document["webkitFullScreenElement"]||document["webkitFullscreenElement"]||document["mozFullScreenElement"]||document["mozFullscreenElement"]||document["fullScreenElement"]||document["fullscreenElement"]||document["msFullScreenElement"]||document["msFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvasContainer){canvas.cancelFullScreen=document["cancelFullScreen"]||document["mozCancelFullScreen"]||document["webkitCancelFullScreen"]||document["msExitFullscreen"]||document["exitFullscreen"]||(function(){});canvas.cancelFullScreen=canvas.cancelFullScreen.bind(document);if(Browser.lockPointer)canvas.requestPointerLock();Browser.isFullScreen=true;if(Browser.resizeCanvas)Browser.setFullScreenCanvasSize()}else{canvasContainer.parentNode.insertBefore(canvas,canvasContainer);canvasContainer.parentNode.removeChild(canvasContainer);if(Browser.resizeCanvas)Browser.setWindowedCanvasSize()}if(Module["onFullScreen"])Module["onFullScreen"](Browser.isFullScreen);Browser.updateCanvasDimensions(canvas)}if(!Browser.fullScreenHandlersInstalled){Browser.fullScreenHandlersInstalled=true;document.addEventListener("fullscreenchange",fullScreenChange,false);document.addEventListener("mozfullscreenchange",fullScreenChange,false);document.addEventListener("webkitfullscreenchange",fullScreenChange,false);document.addEventListener("MSFullscreenChange",fullScreenChange,false)}var canvasContainer=document.createElement("div");canvas.parentNode.insertBefore(canvasContainer,canvas);canvasContainer.appendChild(canvas);canvasContainer.requestFullScreen=canvasContainer["requestFullScreen"]||canvasContainer["mozRequestFullScreen"]||canvasContainer["msRequestFullscreen"]||(canvasContainer["webkitRequestFullScreen"]?(function(){canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null);if(vrDevice){canvasContainer.requestFullScreen({vrDisplay:vrDevice})}else{canvasContainer.requestFullScreen()}}),nextRAF:0,fakeRequestAnimationFrame:(function(func){var now=Date.now();if(Browser.nextRAF===0){Browser.nextRAF=now+1e3/60}else{while(now+2>=Browser.nextRAF){Browser.nextRAF+=1e3/60}}var delay=Math.max(Browser.nextRAF-now,0);setTimeout(func,delay)}),requestAnimationFrame:function requestAnimationFrame(func){if(typeof window==="undefined"){Browser.fakeRequestAnimationFrame(func)}else{if(!window.requestAnimationFrame){window.requestAnimationFrame=window["requestAnimationFrame"]||window["mozRequestAnimationFrame"]||window["webkitRequestAnimationFrame"]||window["msRequestAnimationFrame"]||window["oRequestAnimationFrame"]||Browser.fakeRequestAnimationFrame}window.requestAnimationFrame(func)}},safeCallback:(function(func){return(function(){if(!ABORT)return func.apply(null,arguments)})}),allowAsyncCallbacks:true,queuedAsyncCallbacks:[],pauseAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=false}),resumeAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=true;if(Browser.queuedAsyncCallbacks.length>0){var callbacks=Browser.queuedAsyncCallbacks;Browser.queuedAsyncCallbacks=[];callbacks.forEach((function(func){func()}))}}),safeRequestAnimationFrame:(function(func){return Browser.requestAnimationFrame((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}))}),safeSetTimeout:(function(func,timeout){Module["noExitRuntime"]=true;return setTimeout((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}),timeout)}),safeSetInterval:(function(func,timeout){Module["noExitRuntime"]=true;return setInterval((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}}),timeout)}),getMimetype:(function(name){return{"jpg":"image/jpeg","jpeg":"image/jpeg","png":"image/png","bmp":"image/bmp","ogg":"audio/ogg","wav":"audio/wav","mp3":"audio/mpeg"}[name.substr(name.lastIndexOf(".")+1)]}),getUserMedia:(function(func){if(!window.getUserMedia){window.getUserMedia=navigator["getUserMedia"]||navigator["mozGetUserMedia"]}window.getUserMedia(func)}),getMovementX:(function(event){return event["movementX"]||event["mozMovementX"]||event["webkitMovementX"]||0}),getMovementY:(function(event){return event["movementY"]||event["mozMovementY"]||event["webkitMovementY"]||0}),getMouseWheelDelta:(function(event){var delta=0;switch(event.type){case"DOMMouseScroll":delta=event.detail;break;case"mousewheel":delta=event.wheelDelta;break;case"wheel":delta=event["deltaY"];break;default:throw"unrecognized mouse wheel event: "+event.type}return delta}),mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,touches:{},lastTouches:{},calculateMouseEvent:(function(event){if(Browser.pointerLock){if(event.type!="mousemove"&&"mozMovementX"in event){Browser.mouseMovementX=Browser.mouseMovementY=0}else{Browser.mouseMovementX=Browser.getMovementX(event);Browser.mouseMovementY=Browser.getMovementY(event)}if(typeof SDL!="undefined"){Browser.mouseX=SDL.mouseX+Browser.mouseMovementX;Browser.mouseY=SDL.mouseY+Browser.mouseMovementY}else{Browser.mouseX+=Browser.mouseMovementX;Browser.mouseY+=Browser.mouseMovementY}}else{var rect=Module["canvas"].getBoundingClientRect();var cw=Module["canvas"].width;var ch=Module["canvas"].height;var scrollX=typeof window.scrollX!=="undefined"?window.scrollX:window.pageXOffset;var scrollY=typeof window.scrollY!=="undefined"?window.scrollY:window.pageYOffset;if(event.type==="touchstart"||event.type==="touchend"||event.type==="touchmove"){var touch=event.touch;if(touch===undefined){return}var adjustedX=touch.pageX-(scrollX+rect.left);var adjustedY=touch.pageY-(scrollY+rect.top);adjustedX=adjustedX*(cw/rect.width);adjustedY=adjustedY*(ch/rect.height);var coords={x:adjustedX,y:adjustedY};if(event.type==="touchstart"){Browser.lastTouches[touch.identifier]=coords;Browser.touches[touch.identifier]=coords}else if(event.type==="touchend"||event.type==="touchmove"){Browser.lastTouches[touch.identifier]=Browser.touches[touch.identifier];Browser.touches[touch.identifier]={x:adjustedX,y:adjustedY}}return}var x=event.pageX-(scrollX+rect.left);var y=event.pageY-(scrollY+rect.top);x=x*(cw/rect.width);y=y*(ch/rect.height);Browser.mouseMovementX=x-Browser.mouseX;Browser.mouseMovementY=y-Browser.mouseY;Browser.mouseX=x;Browser.mouseY=y}}),xhrLoad:(function(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response)}else{onerror()}};xhr.onerror=onerror;xhr.send(null)}),asyncLoad:(function(url,onload,onerror,noRunDep){Browser.xhrLoad(url,(function(arrayBuffer){assert(arrayBuffer,'Loading data file "'+url+'" failed (no arrayBuffer).');onload(new Uint8Array(arrayBuffer));if(!noRunDep)removeRunDependency("al "+url)}),(function(event){if(onerror){onerror()}else{throw'Loading data file "'+url+'" failed.'}}));if(!noRunDep)addRunDependency("al "+url)}),resizeListeners:[],updateResizeListeners:(function(){var canvas=Module["canvas"];Browser.resizeListeners.forEach((function(listener){listener(canvas.width,canvas.height)}))}),setCanvasSize:(function(width,height,noUpdates){var canvas=Module["canvas"];Browser.updateCanvasDimensions(canvas,width,height);if(!noUpdates)Browser.updateResizeListeners()}),windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags|8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),setWindowedCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags&~8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),updateCanvasDimensions:(function(canvas,wNative,hNative){if(wNative&&hNative){canvas.widthNative=wNative;canvas.heightNative=hNative}else{wNative=canvas.widthNative;hNative=canvas.heightNative}var w=wNative;var h=hNative;if(Module["forcedAspectRatio"]&&Module["forcedAspectRatio"]>0){if(w/h<Module["forcedAspectRatio"]){w=Math.round(h*Module["forcedAspectRatio"])}else{h=Math.round(w/Module["forcedAspectRatio"])}}if((document["webkitFullScreenElement"]||document["webkitFullscreenElement"]||document["mozFullScreenElement"]||document["mozFullscreenElement"]||document["fullScreenElement"]||document["fullscreenElement"]||document["msFullScreenElement"]||document["msFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvas.parentNode&&typeof screen!="undefined"){var factor=Math.min(screen.width/w,screen.height/h);w=Math.round(w*factor);h=Math.round(h*factor)}if(Browser.resizeCanvas){if(canvas.width!=w)canvas.width=w;if(canvas.height!=h)canvas.height=h;if(typeof canvas.style!="undefined"){canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}else{if(canvas.width!=wNative)canvas.width=wNative;if(canvas.height!=hNative)canvas.height=hNative;if(typeof canvas.style!="undefined"){if(w!=wNative||h!=hNative){canvas.style.setProperty("width",w+"px","important");canvas.style.setProperty("height",h+"px","important")}else{canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}}}),wgetRequests:{},nextWgetRequestHandle:0,getNextWgetRequestHandle:(function(){var handle=Browser.nextWgetRequestHandle;Browser.nextWgetRequestHandle++;return handle})};Module["_bitshift64Lshr"]=_bitshift64Lshr;Module["_memset"]=_memset;var _BDtoILow=true;var _BDtoIHigh=true;function _pthread_cond_broadcast(){return 0}function _gettimeofday(ptr){var now=Date.now();HEAP32[ptr>>2]=now/1e3|0;HEAP32[ptr+4>>2]=now%1e3*1e3|0;return 0}Module["_strlen"]=_strlen;function __reallyNegative(x){return x<0||x===0&&1/x===-Infinity}function __formatString(format,varargs){var textIndex=format;var argIndex=0;function getNextArg(type){var ret;if(type==="double"){ret=(HEAP32[tempDoublePtr>>2]=HEAP32[varargs+argIndex>>2],HEAP32[tempDoublePtr+4>>2]=HEAP32[varargs+(argIndex+4)>>2],+HEAPF64[tempDoublePtr>>3])}else if(type=="i64"){ret=[HEAP32[varargs+argIndex>>2],HEAP32[varargs+(argIndex+4)>>2]]}else{type="i32";ret=HEAP32[varargs+argIndex>>2]}argIndex+=Runtime.getNativeFieldSize(type);return ret}var ret=[];var curr,next,currArg;while(1){var startTextIndex=textIndex;curr=HEAP8[textIndex>>0];if(curr===0)break;next=HEAP8[textIndex+1>>0];if(curr==37){var flagAlwaysSigned=false;var flagLeftAlign=false;var flagAlternative=false;var flagZeroPad=false;var flagPadSign=false;flagsLoop:while(1){switch(next){case 43:flagAlwaysSigned=true;break;case 45:flagLeftAlign=true;break;case 35:flagAlternative=true;break;case 48:if(flagZeroPad){break flagsLoop}else{flagZeroPad=true;break};case 32:flagPadSign=true;break;default:break flagsLoop}textIndex++;next=HEAP8[textIndex+1>>0]}var width=0;if(next==42){width=getNextArg("i32");textIndex++;next=HEAP8[textIndex+1>>0]}else{while(next>=48&&next<=57){width=width*10+(next-48);textIndex++;next=HEAP8[textIndex+1>>0]}}var precisionSet=false,precision=-1;if(next==46){precision=0;precisionSet=true;textIndex++;next=HEAP8[textIndex+1>>0];if(next==42){precision=getNextArg("i32");textIndex++}else{while(1){var precisionChr=HEAP8[textIndex+1>>0];if(precisionChr<48||precisionChr>57)break;precision=precision*10+(precisionChr-48);textIndex++}}next=HEAP8[textIndex+1>>0]}if(precision<0){precision=6;precisionSet=false}var argSize;switch(String.fromCharCode(next)){case"h":var nextNext=HEAP8[textIndex+2>>0];if(nextNext==104){textIndex++;argSize=1}else{argSize=2}break;case"l":var nextNext=HEAP8[textIndex+2>>0];if(nextNext==108){textIndex++;argSize=8}else{argSize=4}break;case"L":case"q":case"j":argSize=8;break;case"z":case"t":case"I":argSize=4;break;default:argSize=null}if(argSize)textIndex++;next=HEAP8[textIndex+1>>0];switch(String.fromCharCode(next)){case"d":case"i":case"u":case"o":case"x":case"X":case"p":{var signed=next==100||next==105;argSize=argSize||4;var currArg=getNextArg("i"+argSize*8);var origArg=currArg;var argText;if(argSize==8){currArg=Runtime.makeBigInt(currArg[0],currArg[1],next==117)}if(argSize<=4){var limit=Math.pow(256,argSize)-1;currArg=(signed?reSign:unSign)(currArg&limit,argSize*8)}var currAbsArg=Math.abs(currArg);var prefix="";if(next==100||next==105){if(argSize==8&&i64Math)argText=i64Math.stringify(origArg[0],origArg[1],null);else argText=reSign(currArg,8*argSize,1).toString(10)}else if(next==117){if(argSize==8&&i64Math)argText=i64Math.stringify(origArg[0],origArg[1],true);else argText=unSign(currArg,8*argSize,1).toString(10);currArg=Math.abs(currArg)}else if(next==111){argText=(flagAlternative?"0":"")+currAbsArg.toString(8)}else if(next==120||next==88){prefix=flagAlternative&&currArg!=0?"0x":"";if(argSize==8&&i64Math){if(origArg[1]){argText=(origArg[1]>>>0).toString(16);var lower=(origArg[0]>>>0).toString(16);while(lower.length<8)lower="0"+lower;argText+=lower}else{argText=(origArg[0]>>>0).toString(16)}}else if(currArg<0){currArg=-currArg;argText=(currAbsArg-1).toString(16);var buffer=[];for(var i=0;i<argText.length;i++){buffer.push((15-parseInt(argText[i],16)).toString(16))}argText=buffer.join("");while(argText.length<argSize*2)argText="f"+argText}else{argText=currAbsArg.toString(16)}if(next==88){prefix=prefix.toUpperCase();argText=argText.toUpperCase()}}else if(next==112){if(currAbsArg===0){argText="(nil)"}else{prefix="0x";argText=currAbsArg.toString(16)}}if(precisionSet){while(argText.length<precision){argText="0"+argText}}if(currArg>=0){if(flagAlwaysSigned){prefix="+"+prefix}else if(flagPadSign){prefix=" "+prefix}}if(argText.charAt(0)=="-"){prefix="-"+prefix;argText=argText.substr(1)}while(prefix.length+argText.length<width){if(flagLeftAlign){argText+=" "}else{if(flagZeroPad){argText="0"+argText}else{prefix=" "+prefix}}}argText=prefix+argText;argText.split("").forEach((function(chr){ret.push(chr.charCodeAt(0))}));break};case"f":case"F":case"e":case"E":case"g":case"G":{var currArg=getNextArg("double");var argText;if(isNaN(currArg)){argText="nan";flagZeroPad=false}else if(!isFinite(currArg)){argText=(currArg<0?"-":"")+"inf";flagZeroPad=false}else{var isGeneral=false;var effectivePrecision=Math.min(precision,20);if(next==103||next==71){isGeneral=true;precision=precision||1;var exponent=parseInt(currArg.toExponential(effectivePrecision).split("e")[1],10);if(precision>exponent&&exponent>=-4){next=(next==103?"f":"F").charCodeAt(0);precision-=exponent+1}else{next=(next==103?"e":"E").charCodeAt(0);precision--}effectivePrecision=Math.min(precision,20)}if(next==101||next==69){argText=currArg.toExponential(effectivePrecision);if(/[eE][-+]\d$/.test(argText)){argText=argText.slice(0,-1)+"0"+argText.slice(-1)}}else if(next==102||next==70){argText=currArg.toFixed(effectivePrecision);if(currArg===0&&__reallyNegative(currArg)){argText="-"+argText}}var parts=argText.split("e");if(isGeneral&&!flagAlternative){while(parts[0].length>1&&parts[0].indexOf(".")!=-1&&(parts[0].slice(-1)=="0"||parts[0].slice(-1)==".")){parts[0]=parts[0].slice(0,-1)}}else{if(flagAlternative&&argText.indexOf(".")==-1)parts[0]+=".";while(precision>effectivePrecision++)parts[0]+="0"}argText=parts[0]+(parts.length>1?"e"+parts[1]:"");if(next==69)argText=argText.toUpperCase();if(currArg>=0){if(flagAlwaysSigned){argText="+"+argText}else if(flagPadSign){argText=" "+argText}}}while(argText.length<width){if(flagLeftAlign){argText+=" "}else{if(flagZeroPad&&(argText[0]=="-"||argText[0]=="+")){argText=argText[0]+"0"+argText.slice(1)}else{argText=(flagZeroPad?"0":" ")+argText}}}if(next<97)argText=argText.toUpperCase();argText.split("").forEach((function(chr){ret.push(chr.charCodeAt(0))}));break};case"s":{var arg=getNextArg("i8*");var argLength=arg?_strlen(arg):"(null)".length;if(precisionSet)argLength=Math.min(argLength,precision);if(!flagLeftAlign){while(argLength<width--){ret.push(32)}}if(arg){for(var i=0;i<argLength;i++){ret.push(HEAPU8[arg++>>0])}}else{ret=ret.concat(intArrayFromString("(null)".substr(0,argLength),true))}if(flagLeftAlign){while(argLength<width--){ret.push(32)}}break};case"c":{if(flagLeftAlign)ret.push(getNextArg("i8"));while(--width>0){ret.push(32)}if(!flagLeftAlign)ret.push(getNextArg("i8"));break};case"n":{var ptr=getNextArg("i32*");HEAP32[ptr>>2]=ret.length;break};case"%":{ret.push(curr);break};default:{for(var i=startTextIndex;i<textIndex+2;i++){ret.push(HEAP8[i>>0])}}}textIndex+=2}else{ret.push(curr);textIndex+=1}}return ret}function _fprintf(stream,format,varargs){var result=__formatString(format,varargs);var stack=Runtime.stackSave();var ret=_fwrite(allocate(result,"i8",ALLOC_STACK),1,result.length,stream);Runtime.stackRestore(stack);return ret}function _vfprintf(s,f,va_arg){return _fprintf(s,f,HEAP32[va_arg>>2])}function _pthread_mutex_unlock(){}function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}Module["_memcpy"]=_memcpy;var _llvm_pow_f64=Math_pow;function _sbrk(bytes){var self=_sbrk;if(!self.called){DYNAMICTOP=alignMemoryPage(DYNAMICTOP);self.called=true;assert(Runtime.dynamicAlloc);self.alloc=Runtime.dynamicAlloc;Runtime.dynamicAlloc=(function(){abort("cannot dynamically allocate, sbrk now has control")})}var ret=DYNAMICTOP;if(bytes!=0){var success=self.alloc(bytes);if(!success)return-1>>>0}return ret}Module["_memmove"]=_memmove;var LOCALE={curr:0,check:(function(locale){if(locale)locale=Pointer_stringify(locale);return locale==="C"||locale==="POSIX"||!locale})};function _calloc(n,s){var ret=_malloc(n*s);_memset(ret,0,n*s);return ret}Module["_calloc"]=_calloc;function _newlocale(mask,locale,base){if(!LOCALE.check(locale)){___setErrNo(ERRNO_CODES.ENOENT);return 0}if(!base)base=_calloc(1,4);return base}function ___errno_location(){return ___errno_state}var _BItoD=true;function _catclose(catd){return 0}function _free(){}Module["_free"]=_free;function ___cxa_free_exception(ptr){try{return _free(ptr)}catch(e){}}function ___cxa_end_catch(){if(___cxa_end_catch.rethrown){___cxa_end_catch.rethrown=false;return}asm["setThrew"](0);var ptr=EXCEPTIONS.caught.pop();if(ptr){EXCEPTIONS.decRef(EXCEPTIONS.deAdjust(ptr));EXCEPTIONS.last=0}}function ___cxa_rethrow(){___cxa_end_catch.rethrown=true;var ptr=EXCEPTIONS.caught.pop();EXCEPTIONS.last=ptr;throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}function ___cxa_guard_release(){}function _ungetc(c,stream){stream=FS.getStreamFromPtr(stream);if(!stream){return-1}if(c===-1){return c}c=unSign(c&255);stream.ungotten.push(c);stream.eof=false;return c}function _uselocale(locale){var old=LOCALE.curr;if(locale)LOCALE.curr=locale;return old}function _sysconf(name){switch(name){case 30:return PAGE_SIZE;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 80:case 81:case 79:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:{if(typeof navigator==="object")return navigator["hardwareConcurrency"]||1;return 1}}___setErrNo(ERRNO_CODES.EINVAL);return-1}function _recv(fd,buf,len,flags){var sock=SOCKFS.getSocket(fd);if(!sock){___setErrNo(ERRNO_CODES.EBADF);return-1}return _read(fd,buf,len)}function _pread(fildes,buf,nbyte,offset){var stream=FS.getStream(fildes);if(!stream){___setErrNo(ERRNO_CODES.EBADF);return-1}try{var slab=HEAP8;return FS.read(stream,slab,buf,nbyte,offset)}catch(e){FS.handleFSError(e);return-1}}function _read(fildes,buf,nbyte){var stream=FS.getStream(fildes);if(!stream){___setErrNo(ERRNO_CODES.EBADF);return-1}try{var slab=HEAP8;return FS.read(stream,slab,buf,nbyte)}catch(e){FS.handleFSError(e);return-1}}function _fread(ptr,size,nitems,stream){var bytesToRead=nitems*size;if(bytesToRead==0){return 0}var bytesRead=0;var streamObj=FS.getStreamFromPtr(stream);if(!streamObj){___setErrNo(ERRNO_CODES.EBADF);return 0}while(streamObj.ungotten.length&&bytesToRead>0){HEAP8[ptr++>>0]=streamObj.ungotten.pop();bytesToRead--;bytesRead++}var err=_read(streamObj.fd,ptr,bytesToRead);if(err==-1){if(streamObj)streamObj.error=true;return 0}bytesRead+=err;if(bytesRead<bytesToRead)streamObj.eof=true;return bytesRead/size|0}function _ftell(stream){stream=FS.getStreamFromPtr(stream);if(!stream){___setErrNo(ERRNO_CODES.EBADF);return-1}if(FS.isChrdev(stream.node.mode)){___setErrNo(ERRNO_CODES.ESPIPE);return-1}else{return stream.position}}function _ftello(){return _ftell.apply(null,arguments)}function _strerror_r(errnum,strerrbuf,buflen){if(errnum in ERRNO_MESSAGES){if(ERRNO_MESSAGES[errnum].length>buflen-1){return ___setErrNo(ERRNO_CODES.ERANGE)}else{var msg=ERRNO_MESSAGES[errnum];writeAsciiToMemory(msg,strerrbuf);return 0}}else{return ___setErrNo(ERRNO_CODES.EINVAL)}}function _strerror(errnum){if(!_strerror.buffer)_strerror.buffer=_malloc(256);_strerror_r(errnum,_strerror.buffer,256);return _strerror.buffer}function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]);return sum}var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?Pointer_stringify(tm_zone):""};var pattern=Pointer_stringify(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value==="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}else{return thisDate.getFullYear()}}else{return thisDate.getFullYear()-1}}var EXPANSION_RULES_2={"%a":(function(date){return WEEKDAYS[date.tm_wday].substring(0,3)}),"%A":(function(date){return WEEKDAYS[date.tm_wday]}),"%b":(function(date){return MONTHS[date.tm_mon].substring(0,3)}),"%B":(function(date){return MONTHS[date.tm_mon]}),"%C":(function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)}),"%d":(function(date){return leadingNulls(date.tm_mday,2)}),"%e":(function(date){return leadingSomething(date.tm_mday,2," ")}),"%g":(function(date){return getWeekBasedYear(date).toString().substring(2)}),"%G":(function(date){return getWeekBasedYear(date)}),"%H":(function(date){return leadingNulls(date.tm_hour,2)}),"%I":(function(date){return leadingNulls(date.tm_hour<13?date.tm_hour:date.tm_hour-12,2)}),"%j":(function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)}),"%m":(function(date){return leadingNulls(date.tm_mon+1,2)}),"%M":(function(date){return leadingNulls(date.tm_min,2)}),"%n":(function(){return"\n"}),"%p":(function(date){if(date.tm_hour>0&&date.tm_hour<13){return"AM"}else{return"PM"}}),"%S":(function(date){return leadingNulls(date.tm_sec,2)}),"%t":(function(){return"\t"}),"%u":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()||7}),"%U":(function(date){var janFirst=new Date(date.tm_year+1900,0,1);var firstSunday=janFirst.getDay()===0?janFirst:__addDays(janFirst,7-janFirst.getDay());var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstSunday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstSundayUntilEndJanuary=31-firstSunday.getDate();var days=firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstSunday,janFirst)===0?"01":"00"}),"%V":(function(date){var janFourthThisYear=new Date(date.tm_year+1900,0,4);var janFourthNextYear=new Date(date.tm_year+1901,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);var endDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);if(compareByDay(endDate,firstWeekStartThisYear)<0){return"53"}if(compareByDay(firstWeekStartNextYear,endDate)<=0){return"01"}var daysDifference;if(firstWeekStartThisYear.getFullYear()<date.tm_year+1900){daysDifference=date.tm_yday+32-firstWeekStartThisYear.getDate()}else{daysDifference=date.tm_yday+1-firstWeekStartThisYear.getDate()}return leadingNulls(Math.ceil(daysDifference/7),2)}),"%w":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()}),"%W":(function(date){var janFirst=new Date(date.tm_year,0,1);var firstMonday=janFirst.getDay()===1?janFirst:__addDays(janFirst,janFirst.getDay()===0?1:7-janFirst.getDay()+1);var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstMonday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstMondayUntilEndJanuary=31-firstMonday.getDate();var days=firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstMonday,janFirst)===0?"01":"00"}),"%y":(function(date){return(date.tm_year+1900).toString().substring(2)}),"%Y":(function(date){return date.tm_year+1900}),"%z":(function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)}),"%Z":(function(date){return date.tm_zone}),"%%":(function(){return"%"})};for(var rule in EXPANSION_RULES_2){if(pattern.indexOf(rule)>=0){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}function _strftime_l(s,maxsize,format,tm){return _strftime(s,maxsize,format,tm)}function _abort(){Module["abort"]()}function _pthread_once(ptr,func){if(!_pthread_once.seen)_pthread_once.seen={};if(ptr in _pthread_once.seen)return;Runtime.dynCall("v",func);_pthread_once.seen[ptr]=1}function _pthread_cond_wait(){return 0}var PTHREAD_SPECIFIC={};function _pthread_getspecific(key){return PTHREAD_SPECIFIC[key]||0}var _fabs=Math_abs;function _fgetc(stream){var streamObj=FS.getStreamFromPtr(stream);if(!streamObj)return-1;if(streamObj.eof||streamObj.error)return-1;var ret=_fread(_fgetc.ret,1,1,stream);if(ret==0){return-1}else if(ret==-1){streamObj.error=true;return-1}else{return HEAPU8[_fgetc.ret>>0]}}function _getc(){return _fgetc.apply(null,arguments)}function __exit(status){Module["exit"](status)}function _exit(status){__exit(status)}function _pthread_setspecific(key,value){if(!(key in PTHREAD_SPECIFIC)){return ERRNO_CODES.EINVAL}PTHREAD_SPECIFIC[key]=value;return 0}function ___ctype_b_loc(){var me=___ctype_b_loc;if(!me.ret){var values=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];var i16size=2;var arr=_malloc(values.length*i16size);for(var i=0;i<values.length;i++){HEAP16[arr+i*i16size>>1]=values[i]}me.ret=allocate([arr+128*i16size],"i16*",ALLOC_NORMAL)}return me.ret}function _freelocale(locale){_free(locale)}function _malloc(bytes){var ptr=Runtime.dynamicAlloc(bytes+8);return ptr+8&4294967288}Module["_malloc"]=_malloc;function ___cxa_allocate_exception(size){return _malloc(size)}function ___cxa_pure_virtual(){ABORT=true;throw"Pure virtual function called!"}function _catgets(catd,set_id,msg_id,s){return s}function _catopen(name,oflag){return-1}function ___ctype_toupper_loc(){var me=___ctype_toupper_loc;if(!me.ret){var values=[128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255];var i32size=4;var arr=_malloc(values.length*i32size);for(var i=0;i<values.length;i++){HEAP32[arr+i*i32size>>2]=values[i]}me.ret=allocate([arr+128*i32size],"i32*",ALLOC_NORMAL)}return me.ret}function ___cxa_guard_acquire(variable){if(!HEAP8[variable>>0]){HEAP8[variable>>0]=1;return 1}return 0}function ___ctype_tolower_loc(){var me=___ctype_tolower_loc;if(!me.ret){var values=[128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255];var i32size=4;var arr=_malloc(values.length*i32size);for(var i=0;i<values.length;i++){HEAP32[arr+i*i32size>>2]=values[i]}me.ret=allocate([arr+128*i32size],"i32*",ALLOC_NORMAL)}return me.ret}function ___cxa_begin_catch(ptr){__ZSt18uncaught_exceptionv.uncaught_exception--;EXCEPTIONS.caught.push(ptr);EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));return ptr}Module["_bitshift64Shl"]=_bitshift64Shl;function _lseek(fildes,offset,whence){var stream=FS.getStream(fildes);if(!stream){___setErrNo(ERRNO_CODES.EBADF);return-1}try{return FS.llseek(stream,offset,whence)}catch(e){FS.handleFSError(e);return-1}}function _fseek(stream,offset,whence){var fd=_fileno(stream);var ret=_lseek(fd,offset,whence);if(ret==-1){return-1}stream=FS.getStreamFromPtr(stream);stream.eof=false;return 0}function _fseeko(){return _fseek.apply(null,arguments)}var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key,destructor){if(key==0){return ERRNO_CODES.EINVAL}HEAP32[key>>2]=PTHREAD_SPECIFIC_NEXT_KEY;PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY]=0;PTHREAD_SPECIFIC_NEXT_KEY++;return 0}var _exp=Math_exp;function _time(ptr){var ret=Date.now()/1e3|0;if(ptr){HEAP32[ptr>>2]=ret}return ret}function _emscripten_async_call(func,arg,millis){Module["noExitRuntime"]=true;function wrapper(){Runtime.getFuncWrapper(func,"vi")(arg)}if(millis>=0){Browser.safeSetTimeout(wrapper,millis)}else{Browser.safeRequestAnimationFrame(wrapper)}}FS.staticInit();__ATINIT__.unshift({func:(function(){if(!Module["noFSInit"]&&!FS.init.initialized)FS.init()})});__ATMAIN__.push({func:(function(){FS.ignorePermissions=false})});__ATEXIT__.push({func:(function(){FS.quit()})});Module["FS_createFolder"]=FS.createFolder;Module["FS_createPath"]=FS.createPath;Module["FS_createDataFile"]=FS.createDataFile;Module["FS_createPreloadedFile"]=FS.createPreloadedFile;Module["FS_createLazyFile"]=FS.createLazyFile;Module["FS_createLink"]=FS.createLink;Module["FS_createDevice"]=FS.createDevice;___errno_state=Runtime.staticAlloc(4);HEAP32[___errno_state>>2]=0;__ATINIT__.unshift({func:(function(){TTY.init()})});__ATEXIT__.push({func:(function(){TTY.shutdown()})});if(ENVIRONMENT_IS_NODE){var fs=require("fs");var NODEJS_PATH=require("path");NODEFS.staticInit()}_fputc.ret=allocate([0],"i8",ALLOC_STATIC);__ATINIT__.push({func:(function(){SOCKFS.root=FS.mount(SOCKFS,{},null)})});Module["requestFullScreen"]=function Module_requestFullScreen(lockPointer,resizeCanvas,vrDevice){Browser.requestFullScreen(lockPointer,resizeCanvas,vrDevice)};Module["requestAnimationFrame"]=function Module_requestAnimationFrame(func){Browser.requestAnimationFrame(func)};Module["setCanvasSize"]=function Module_setCanvasSize(width,height,noUpdates){Browser.setCanvasSize(width,height,noUpdates)};Module["pauseMainLoop"]=function Module_pauseMainLoop(){Browser.mainLoop.pause()};Module["resumeMainLoop"]=function Module_resumeMainLoop(){Browser.mainLoop.resume()};Module["getUserMedia"]=function Module_getUserMedia(){Browser.getUserMedia()};_fgetc.ret=allocate([0],"i8",ALLOC_STATIC);STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);staticSealed=true;STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=DYNAMICTOP=Runtime.alignMemory(STACK_MAX);assert(DYNAMIC_BASE<TOTAL_MEMORY,"TOTAL_MEMORY not big enough for stack");var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_DYNAMIC);function invoke_iiii(index,a1,a2,a3){try{return Module["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vi(index,a1){try{Module["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vii(index,a1,a2){try{Module["dynCall_vii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_ii(index,a1){try{return Module["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viii(index,a1,a2,a3){try{Module["dynCall_viii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_v(index){try{Module["dynCall_v"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){try{return Module["dynCall_iiiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iii(index,a1,a2){try{return Module["dynCall_iii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiii(index,a1,a2,a3,a4){try{Module["dynCall_viiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}Module.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity};Module.asmLibraryArg={"abort":abort,"assert":assert,"invoke_iiii":invoke_iiii,"invoke_viiiiiii":invoke_viiiiiii,"invoke_viiiii":invoke_viiiii,"invoke_vi":invoke_vi,"invoke_vii":invoke_vii,"invoke_viiiiiiiii":invoke_viiiiiiiii,"invoke_ii":invoke_ii,"invoke_viiiiiid":invoke_viiiiiid,"invoke_viii":invoke_viii,"invoke_viiiiid":invoke_viiiiid,"invoke_v":invoke_v,"invoke_iiiiiiiii":invoke_iiiiiiiii,"invoke_iiiii":invoke_iiiii,"invoke_viiiiiiii":invoke_viiiiiiii,"invoke_viiiiii":invoke_viiiiii,"invoke_iii":invoke_iii,"invoke_iiiiii":invoke_iiiiii,"invoke_viiii":invoke_viiii,"_fabs":_fabs,"_strftime":_strftime,"_pthread_cond_wait":_pthread_cond_wait,"_exp":_exp,"_llvm_pow_f64":_llvm_pow_f64,"_send":_send,"_log":_log,"_fread":_fread,"___ctype_b_loc":___ctype_b_loc,"___cxa_pure_virtual":___cxa_pure_virtual,"___cxa_guard_acquire":___cxa_guard_acquire,"_lseek":_lseek,"___setErrNo":___setErrNo,"_vfprintf":_vfprintf,"_ungetc":_ungetc,"___cxa_free_exception":___cxa_free_exception,"___cxa_allocate_exception":___cxa_allocate_exception,"__ZSt18uncaught_exceptionv":__ZSt18uncaught_exceptionv,"___ctype_toupper_loc":___ctype_toupper_loc,"_fflush":_fflush,"___cxa_guard_release":___cxa_guard_release,"__addDays":__addDays,"_ftell":_ftell,"_strerror_r":_strerror_r,"_strftime_l":_strftime_l,"_pthread_mutex_lock":_pthread_mutex_lock,"_emscripten_set_main_loop_timing":_emscripten_set_main_loop_timing,"_sbrk":_sbrk,"_uselocale":_uselocale,"_catgets":_catgets,"_newlocale":_newlocale,"___cxa_begin_catch":___cxa_begin_catch,"_emscripten_memcpy_big":_emscripten_memcpy_big,"___cxa_end_catch":___cxa_end_catch,"___resumeException":___resumeException,"___cxa_find_matching_catch":___cxa_find_matching_catch,"_freelocale":_freelocale,"__reallyNegative":__reallyNegative,"_fopen":_fopen,"_close":_close,"_pthread_getspecific":_pthread_getspecific,"__arraySum":__arraySum,"_fseeko":_fseeko,"_read":_read,"___ctype_tolower_loc":___ctype_tolower_loc,"_fseek":_fseek,"_fileno":_fileno,"_pthread_mutex_unlock":_pthread_mutex_unlock,"_pthread_once":_pthread_once,"_pread":_pread,"_open":_open,"_fclose":_fclose,"_pthread_key_create":_pthread_key_create,"_getc":_getc,"_write":_write,"__isLeapYear":__isLeapYear,"_fsync":_fsync,"_emscripten_set_main_loop":_emscripten_set_main_loop,"___errno_location":___errno_location,"_recv":_recv,"_pthread_setspecific":_pthread_setspecific,"_fgetc":_fgetc,"_ftello":_ftello,"_fputc":_fputc,"_mkport":_mkport,"_sysconf":_sysconf,"_pthread_cond_broadcast":_pthread_cond_broadcast,"___cxa_rethrow":___cxa_rethrow,"__exit":__exit,"_abort":_abort,"_catclose":_catclose,"_fwrite":_fwrite,"___cxa_throw":___cxa_throw,"_fprintf":_fprintf,"_strerror":_strerror,"_gettimeofday":_gettimeofday,"__formatString":__formatString,"_pwrite":_pwrite,"_catopen":_catopen,"_exit":_exit,"_time":_time,"_emscripten_async_call":_emscripten_async_call,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"cttz_i8":cttz_i8,"_stderr":_stderr,"_stdin":_stdin,"_stdout":_stdout};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env._stderr|0;var o=env._stdin|0;var p=env._stdout|0;var q=0;var r=0;var s=0;var t=0;var u=global.NaN,v=global.Infinity;var w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0.0;var F=0;var G=0;var H=0;var I=0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=global.Math.floor;var Q=global.Math.abs;var R=global.Math.sqrt;var S=global.Math.pow;var T=global.Math.cos;var U=global.Math.sin;var V=global.Math.tan;var W=global.Math.acos;var X=global.Math.asin;var Y=global.Math.atan;var Z=global.Math.atan2;var _=global.Math.exp;var $=global.Math.log;var aa=global.Math.ceil;var ba=global.Math.imul;var ca=global.Math.min;var da=global.Math.clz32;var ea=env.abort;var fa=env.assert;var ga=env.invoke_iiii;var ha=env.invoke_viiiiiii;var ia=env.invoke_viiiii;var ja=env.invoke_vi;var ka=env.invoke_vii;var la=env.invoke_viiiiiiiii;var ma=env.invoke_ii;var na=env.invoke_viiiiiid;var oa=env.invoke_viii;var pa=env.invoke_viiiiid;var qa=env.invoke_v;var ra=env.invoke_iiiiiiiii;var sa=env.invoke_iiiii;var ta=env.invoke_viiiiiiii;var ua=env.invoke_viiiiii;var va=env.invoke_iii;var wa=env.invoke_iiiiii;var xa=env.invoke_viiii;var ya=env._fabs;var za=env._strftime;var Aa=env._pthread_cond_wait;var Ba=env._exp;var Ca=env._llvm_pow_f64;var Da=env._send;var Ea=env._log;var Fa=env._fread;var Ga=env.___ctype_b_loc;var Ha=env.___cxa_pure_virtual;var Ia=env.___cxa_guard_acquire;var Ja=env._lseek;var Ka=env.___setErrNo;var La=env._vfprintf;var Ma=env._ungetc;var Na=env.___cxa_free_exception;var Oa=env.___cxa_allocate_exception;var Pa=env.__ZSt18uncaught_exceptionv;var Qa=env.___ctype_toupper_loc;var Ra=env._fflush;var Sa=env.___cxa_guard_release;var Ta=env.__addDays;var Ua=env._ftell;var Va=env._strerror_r;var Wa=env._strftime_l;var Xa=env._pthread_mutex_lock;var Ya=env._emscripten_set_main_loop_timing;var Za=env._sbrk;var _a=env._uselocale;var $a=env._catgets;var ab=env._newlocale;var bb=env.___cxa_begin_catch;var cb=env._emscripten_memcpy_big;var db=env.___cxa_end_catch;var eb=env.___resumeException;var fb=env.___cxa_find_matching_catch;var gb=env._freelocale;var hb=env.__reallyNegative;var ib=env._fopen;var jb=env._close;var kb=env._pthread_getspecific;var lb=env.__arraySum;var mb=env._fseeko;var nb=env._read;var ob=env.___ctype_tolower_loc;var pb=env._fseek;var qb=env._fileno;var rb=env._pthread_mutex_unlock;var sb=env._pthread_once;var tb=env._pread;var ub=env._open;var vb=env._fclose;var wb=env._pthread_key_create;var xb=env._getc;var yb=env._write;var zb=env.__isLeapYear;var Ab=env._fsync;var Bb=env._emscripten_set_main_loop;var Cb=env.___errno_location;var Db=env._recv;var Eb=env._pthread_setspecific;var Fb=env._fgetc;var Gb=env._ftello;var Hb=env._fputc;var Ib=env._mkport;var Jb=env._sysconf;var Kb=env._pthread_cond_broadcast;var Lb=env.___cxa_rethrow;var Mb=env.__exit;var Nb=env._abort;var Ob=env._catclose;var Pb=env._fwrite;var Qb=env.___cxa_throw;var Rb=env._fprintf;var Sb=env._strerror;var Tb=env._gettimeofday;var Ub=env.__formatString;var Vb=env._pwrite;var Wb=env._catopen;var Xb=env._exit;var Yb=env._time;var Zb=env._emscripten_async_call;var _b=0.0;
// EMSCRIPTEN_START_FUNCS
function Bl(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0;do if((b|0)==(i|0))if(a[e>>0]|0){a[e>>0]=0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=46;j=a[k>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[k+4>>2]|0;if((j|0)!=0?(p=c[m>>2]|0,(p-l|0)<160):0){j=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=j;j=0}else j=0}else j=-1;else{if((b|0)==(j|0)){j=a[k>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[k+4>>2]|0;if(j){if(!(a[e>>0]|0)){j=-1;break}j=c[m>>2]|0;if((j-l|0)>=160){j=0;break}k=c[n>>2]|0;c[m>>2]=j+4;c[j>>2]=k;c[n>>2]=0;j=0;break}}j=o+128|0;i=o;do{if((c[i>>2]|0)==(b|0)){j=i;break}i=i+4|0}while((i|0)!=(j|0));i=j-o|0;j=i>>2;if((i|0)<=124){p=a[1076416+j>>0]|0;if((j|0)==24|(j|0)==25){j=c[h>>2]|0;if((j|0)!=(g|0)?(d[j+-1>>0]&95|0)!=(d[f>>0]&127|0):0){j=-1;break}c[h>>2]=j+1;a[j>>0]=p;j=0;break}else if(!((j|0)==23|(j|0)==22)){j=p&95;if((j|0)==(a[f>>0]|0)?(a[f>>0]=j|128,(a[e>>0]|0)!=0):0){a[e>>0]=0;j=a[k>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[k+4>>2]|0;if((j|0)!=0?(q=c[m>>2]|0,(q-l|0)<160):0){k=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=k}}}else a[f>>0]=80;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=p;if((i|0)>84)j=0;else{c[n>>2]=(c[n>>2]|0)+1;j=0}}else j=-1}while(0);return j|0}function Cl(a){a=a|0;return}function Dl(a){a=a|0;xt(a);return}function El(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=i;i=i+32|0;k=p+20|0;j=p+16|0;l=p+12|0;o=p;if(!(c[f+4>>2]&1)){o=c[(c[d>>2]|0)+24>>2]|0;c[j>>2]=c[e>>2];c[k+0>>2]=c[j+0>>2];nc[o&31](b,d,k,f,g,h&1)}else{hj(l,f);k=Zo(l,1078048)|0;ei(c[l>>2]|0)|0;j=c[k>>2]|0;if(h)dc[c[j+24>>2]&63](o,k);else dc[c[j+28>>2]&63](o,k);k=a[o>>0]|0;if(!(k&1)){h=o+1|0;j=h;m=o+8|0}else{m=o+8|0;j=c[m>>2]|0;h=o+1|0}n=o+4|0;while(1){if(!(k&1)){g=h;k=(k&255)>>>1}else{g=c[m>>2]|0;k=c[n>>2]|0}if((j|0)==(g+k|0))break;l=a[j>>0]|0;d=c[e>>2]|0;do if(d){f=d+24|0;g=c[f>>2]|0;if((g|0)!=(c[d+28>>2]|0)){c[f>>2]=g+1;a[g>>0]=l;break}if((oc[c[(c[d>>2]|0)+52>>2]&63](d,l&255)|0)==-1)c[e>>2]=0}while(0);k=a[o>>0]|0;j=j+1|0}c[b>>2]=c[e>>2];Bi(o)}i=p;return}function Fl(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+64|0;k=d;p=d+56|0;q=d+44|0;j=d+20|0;n=d+16|0;m=d+12|0;o=d+8|0;l=d+4|0;a[p+0>>0]=a[1076696]|0;a[p+1>>0]=a[1076697]|0;a[p+2>>0]=a[1076698]|0;a[p+3>>0]=a[1076699]|0;a[p+4>>0]=a[1076700]|0;a[p+5>>0]=a[1076701]|0;Gl(p+1|0,1076600,1,c[f+4>>2]|0);r=hl()|0;c[k>>2]=h;h=q+(or(q,12,r,p,k)|0)|0;p=Hl(q,h,f)|0;hj(o,f);Il(q,p,h,j,n,m,o);ei(c[o>>2]|0)|0;c[l>>2]=c[e>>2];h=c[n>>2]|0;e=c[m>>2]|0;c[k+0>>2]=c[l+0>>2];Fc(b,k,j,h,e,f,g);i=d;return}function Gl(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;if(e&2048){a[b>>0]=43;b=b+1|0}if(e&512){a[b>>0]=35;b=b+1|0}f=a[c>>0]|0;if(f<<24>>24){g=c;c=b;while(1){g=g+1|0;b=c+1|0;a[c>>0]=f;f=a[g>>0]|0;if(!(f<<24>>24))break;else c=b}}f=e&74;do if((f|0)==64)a[b>>0]=111;else if((f|0)==8)if(!(e&16384)){a[b>>0]=120;break}else{a[b>>0]=88;break}else if(d){a[b>>0]=100;break}else{a[b>>0]=117;break}while(0);return}function Hl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=c[e+4>>2]&176;do if((e|0)==32)b=d;else if((e|0)==16){e=a[b>>0]|0;if(e<<24>>24==43|e<<24>>24==45){b=b+1|0;break}if((d-b|0)>1&e<<24>>24==48?(e=a[b+1>>0]|0,e<<24>>24==88|e<<24>>24==120):0)b=b+2|0;else f=7}else f=7;while(0);return b|0}function Il(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;v=i;i=i+16|0;u=v;t=Zo(j,1077904)|0;o=Zo(j,1078048)|0;dc[c[(c[o>>2]|0)+20>>2]&63](u,o);j=a[u>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[u+4>>2]|0;if(j){c[h>>2]=f;j=a[b>>0]|0;if(j<<24>>24==43|j<<24>>24==45){s=oc[c[(c[t>>2]|0)+28>>2]&63](t,j)|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=s;j=b+1|0}else j=b;if(((e-j|0)>1?(a[j>>0]|0)==48:0)?(n=j+1|0,s=a[n>>0]|0,s<<24>>24==88|s<<24>>24==120):0){s=oc[c[(c[t>>2]|0)+28>>2]&63](t,48)|0;r=c[h>>2]|0;c[h>>2]=r+1;a[r>>0]=s;r=oc[c[(c[t>>2]|0)+28>>2]&63](t,a[n>>0]|0)|0;s=c[h>>2]|0;c[h>>2]=s+1;a[s>>0]=r;j=j+2|0}if((j|0)!=(e|0)?(m=e+-1|0,m>>>0>j>>>0):0){n=j;k=e;while(1){s=a[n>>0]|0;a[n>>0]=a[m>>0]|0;a[m>>0]=s;n=n+1|0;k=k+-2|0;if(n>>>0>=k>>>0)break;else{s=m;m=k;k=s}}}o=fc[c[(c[o>>2]|0)+16>>2]&127](o)|0;if(j>>>0<e>>>0){p=u+1|0;q=u+4|0;r=u+8|0;n=0;m=0;s=j;while(1){k=(a[u>>0]&1)==0;if((a[(k?p:c[r>>2]|0)+m>>0]|0)!=0?(n|0)==(a[(k?p:c[r>>2]|0)+m>>0]|0):0){n=c[h>>2]|0;c[h>>2]=n+1;a[n>>0]=o;n=a[u>>0]|0;if(!(n&1))n=(n&255)>>>1;else n=c[q>>2]|0;k=0;m=(m>>>0<(n+-1|0)>>>0&1)+m|0}else k=n;w=oc[c[(c[t>>2]|0)+28>>2]&63](t,a[s>>0]|0)|0;n=c[h>>2]|0;c[h>>2]=n+1;a[n>>0]=w;s=s+1|0;if(s>>>0>=e>>>0)break;else n=k+1|0}}k=f+(j-b)|0;j=c[h>>2]|0;if((k|0)!=(j|0)?(l=j+-1|0,l>>>0>k>>>0):0)while(1){s=a[k>>0]|0;a[k>>0]=a[l>>0]|0;a[l>>0]=s;k=k+1|0;j=j+-2|0;if(k>>>0>=j>>>0)break;else{s=l;l=j;j=s}}}else{lc[c[(c[t>>2]|0)+32>>2]&7](t,b,e,f)|0;c[h>>2]=f+(e-b)}if((d|0)==(e|0))k=c[h>>2]|0;else k=f+(d-b)|0;c[g>>2]=k;Bi(u);i=v;return}function Jl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+96|0;k=b+8|0;q=b;p=b+74|0;j=b+32|0;n=b+28|0;m=b+24|0;o=b+20|0;l=b+16|0;r=q;c[r>>2]=37;c[r+4>>2]=0;Gl(q+1|0,1076608,1,c[e+4>>2]|0);r=hl()|0;s=k;c[s>>2]=g;c[s+4>>2]=h;h=p+(or(p,22,r,q,k)|0)|0;g=Hl(p,h,e)|0;hj(o,e);Il(p,g,h,j,n,m,o);ei(c[o>>2]|0)|0;c[l>>2]=c[d>>2];h=c[n>>2]|0;g=c[m>>2]|0;c[k+0>>2]=c[l+0>>2];Fc(a,k,j,h,g,e,f);i=b;return}function Kl(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+64|0;k=d;p=d+56|0;q=d+44|0;j=d+20|0;n=d+16|0;m=d+12|0;o=d+8|0;l=d+4|0;a[p+0>>0]=a[1076696]|0;a[p+1>>0]=a[1076697]|0;a[p+2>>0]=a[1076698]|0;a[p+3>>0]=a[1076699]|0;a[p+4>>0]=a[1076700]|0;a[p+5>>0]=a[1076701]|0;Gl(p+1|0,1076600,0,c[f+4>>2]|0);r=hl()|0;c[k>>2]=h;h=q+(or(q,12,r,p,k)|0)|0;p=Hl(q,h,f)|0;hj(o,f);Il(q,p,h,j,n,m,o);ei(c[o>>2]|0)|0;c[l>>2]=c[e>>2];h=c[n>>2]|0;e=c[m>>2]|0;c[k+0>>2]=c[l+0>>2];Fc(b,k,j,h,e,f,g);i=d;return}function Ll(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+112|0;k=b+8|0;q=b;p=b+75|0;j=b+32|0;n=b+28|0;m=b+24|0;o=b+20|0;l=b+16|0;r=q;c[r>>2]=37;c[r+4>>2]=0;Gl(q+1|0,1076608,0,c[e+4>>2]|0);r=hl()|0;s=k;c[s>>2]=g;c[s+4>>2]=h;h=p+(or(p,23,r,q,k)|0)|0;g=Hl(p,h,e)|0;hj(o,e);Il(p,g,h,j,n,m,o);ei(c[o>>2]|0)|0;c[l>>2]=c[d>>2];h=c[n>>2]|0;g=c[m>>2]|0;c[k+0>>2]=c[l+0>>2];Fc(a,k,j,h,g,e,f);i=b;return}function Ml(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;v=i;i=i+144|0;o=v+8|0;j=v;m=v+102|0;b=v+40|0;n=v+44|0;u=v+36|0;t=v+32|0;p=v+28|0;q=v+24|0;r=v+20|0;B=j;c[B>>2]=37;c[B+4>>2]=0;B=Nl(j+1|0,1076616,c[e+4>>2]|0)|0;c[b>>2]=m;l=hl()|0;if(B){c[o>>2]=c[e+8>>2];B=o+4|0;h[k>>3]=g;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];l=or(m,30,l,j,o)|0}else{h[k>>3]=g;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];l=or(m,30,l,j,o)|0}if((l|0)>29){l=hl()|0;c[o>>2]=c[e+8>>2];B=o+4|0;h[k>>3]=g;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];j=pr(b,l,j,o)|0;b=c[b>>2]|0;if(!b)ou();else{w=b;z=b;s=j}}else{w=c[b>>2]|0;z=0;s=l}j=w+s|0;l=Hl(w,j,e)|0;if((w|0)!=(m|0)){b=tu(s<<1)|0;if(!b)ou();else{x=w;y=b;A=b}}else{x=m;y=0;A=n}hj(p,e);Ol(x,l,j,A,u,t,p);ei(c[p>>2]|0)|0;c[r>>2]=c[d>>2];w=c[u>>2]|0;x=c[t>>2]|0;c[o+0>>2]=c[r+0>>2];Fc(q,o,A,w,x,e,f);A=c[q>>2]|0;c[d>>2]=A;c[a>>2]=A;if(y)uu(y);if(z)uu(z);i=v;return}function Nl(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;if(d&2048){a[b>>0]=43;b=b+1|0}if(d&1024){a[b>>0]=35;b=b+1|0}h=d&260;f=d>>>14;i=(h|0)==260;if(i)g=0;else{a[b>>0]=46;a[b+1>>0]=42;b=b+2|0;g=1}e=a[c>>0]|0;if(e<<24>>24)while(1){c=c+1|0;d=b+1|0;a[b>>0]=e;e=a[c>>0]|0;if(!(e<<24>>24)){b=d;break}else b=d}do if((h|0)==256)if(!(f&1)){a[b>>0]=101;break}else{a[b>>0]=69;break}else if((h|0)==4)if(!(f&1)){a[b>>0]=102;break}else{a[b>>0]=70;break}else{d=(f&1|0)!=0;if(i)if(d){a[b>>0]=65;break}else{a[b>>0]=97;break}else if(d){a[b>>0]=71;break}else{a[b>>0]=103;break}}while(0);return g|0}function Ol(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=i;i=i+16|0;x=y;w=Zo(j,1077904)|0;u=Zo(j,1078048)|0;dc[c[(c[u>>2]|0)+20>>2]&63](x,u);c[h>>2]=f;l=a[b>>0]|0;if(l<<24>>24==43|l<<24>>24==45){r=oc[c[(c[w>>2]|0)+28>>2]&63](w,l)|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=r;j=b+1|0}else j=b;v=e;a:do if(((v-j|0)>1?(a[j>>0]|0)==48:0)?(n=j+1|0,r=a[n>>0]|0,r<<24>>24==88|r<<24>>24==120):0){r=oc[c[(c[w>>2]|0)+28>>2]&63](w,48)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q>>0]=r;j=j+2|0;q=oc[c[(c[w>>2]|0)+28>>2]&63](w,a[n>>0]|0)|0;r=c[h>>2]|0;c[h>>2]=r+1;a[r>>0]=q;if(j>>>0<e>>>0){l=j;while(1){r=a[l>>0]|0;k=l+1|0;if(!($s(r<<24>>24,hl()|0)|0)){t=j;k=l;break a}if(k>>>0<e>>>0)l=k;else{t=j;break}}}else{t=j;k=j}}else o=4;while(0);b:do if((o|0)==4)if(j>>>0<e>>>0){l=j;while(1){r=a[l>>0]|0;k=l+1|0;if(!(_s(r<<24>>24,hl()|0)|0)){t=j;k=l;break b}if(k>>>0<e>>>0)l=k;else{t=j;break}}}else{t=j;k=j}while(0);l=a[x>>0]|0;if(!(l&1))l=(l&255)>>>1;else l=c[x+4>>2]|0;if(l){if((t|0)!=(k|0)?(s=k+-1|0,s>>>0>t>>>0):0){n=t;j=s;l=k;while(1){s=a[n>>0]|0;a[n>>0]=a[j>>0]|0;a[j>>0]=s;n=n+1|0;l=l+-2|0;if(n>>>0>=l>>>0)break;else{s=j;j=l;l=s}}}o=fc[c[(c[u>>2]|0)+16>>2]&127](u)|0;if(t>>>0<k>>>0){p=x+1|0;q=x+4|0;r=x+8|0;n=0;l=0;s=t;while(1){j=(a[x>>0]&1)==0;if((a[(j?p:c[r>>2]|0)+l>>0]|0)>0?(n|0)==(a[(j?p:c[r>>2]|0)+l>>0]|0):0){n=c[h>>2]|0;c[h>>2]=n+1;a[n>>0]=o;n=a[x>>0]|0;if(!(n&1))n=(n&255)>>>1;else n=c[q>>2]|0;j=0;l=(l>>>0<(n+-1|0)>>>0&1)+l|0}else j=n;z=oc[c[(c[w>>2]|0)+28>>2]&63](w,a[s>>0]|0)|0;n=c[h>>2]|0;c[h>>2]=n+1;a[n>>0]=z;s=s+1|0;if(s>>>0>=k>>>0)break;else n=j+1|0}}j=f+(t-b)|0;l=c[h>>2]|0;if((j|0)!=(l|0)?(m=l+-1|0,m>>>0>j>>>0):0)while(1){t=a[j>>0]|0;a[j>>0]=a[m>>0]|0;a[m>>0]=t;j=j+1|0;l=l+-2|0;if(j>>>0>=l>>>0)break;else{t=m;m=l;l=t}}}else{lc[c[(c[w>>2]|0)+32>>2]&7](w,t,k,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(k-t)}c:do if(k>>>0<e>>>0){while(1){j=a[k>>0]|0;if(j<<24>>24==46)break;j=oc[c[(c[w>>2]|0)+28>>2]&63](w,j)|0;t=c[h>>2]|0;c[h>>2]=t+1;a[t>>0]=j;k=k+1|0;if(k>>>0>=e>>>0)break c}t=fc[c[(c[u>>2]|0)+12>>2]&127](u)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u>>0]=t;k=k+1|0}while(0);lc[c[(c[w>>2]|0)+32>>2]&7](w,k,e,c[h>>2]|0)|0;k=(c[h>>2]|0)+(v-k)|0;c[h>>2]=k;if((d|0)!=(e|0))k=f+(d-b)|0;c[g>>2]=k;Bi(x);i=y;return}function Pl(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;w=i;i=i+144|0;p=w+8|0;b=w;n=w+102|0;m=w+40|0;o=w+44|0;v=w+36|0;u=w+32|0;q=w+28|0;r=w+24|0;s=w+20|0;j=b;c[j>>2]=37;c[j+4>>2]=0;j=Nl(b+1|0,1076624,c[e+4>>2]|0)|0;c[m>>2]=n;l=hl()|0;if(j){c[p>>2]=c[e+8>>2];C=p+4|0;h[k>>3]=g;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];l=or(n,30,l,b,p)|0}else{h[k>>3]=g;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];l=or(n,30,l,b,p)|0}if((l|0)>29){l=hl()|0;if(j){c[p>>2]=c[e+8>>2];j=p+4|0;h[k>>3]=g;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];l=pr(m,l,b,p)|0}else{h[k>>3]=g;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];l=pr(m,l,b,p)|0}b=c[m>>2]|0;if(!b)ou();else{x=b;A=b;t=l}}else{x=c[m>>2]|0;A=0;t=l}j=x+t|0;l=Hl(x,j,e)|0;if((x|0)!=(n|0)){b=tu(t<<1)|0;if(!b)ou();else{y=x;z=b;B=b}}else{y=n;z=0;B=o}hj(q,e);Ol(y,l,j,B,v,u,q);ei(c[q>>2]|0)|0;c[s>>2]=c[d>>2];y=c[v>>2]|0;d=c[u>>2]|0;c[p+0>>2]=c[s+0>>2];Fc(r,p,B,y,d,e,f);c[a>>2]=c[r>>2];uu(z);uu(A);i=w;return}function Ql(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;n=i;i=i+80|0;k=n;o=n+72|0;j=n+52|0;m=n+12|0;q=n+8|0;l=n+4|0;a[o+0>>0]=a[1076704]|0;a[o+1>>0]=a[1076705]|0;a[o+2>>0]=a[1076706]|0;a[o+3>>0]=a[1076707]|0;a[o+4>>0]=a[1076708]|0;a[o+5>>0]=a[1076709]|0;d=hl()|0;c[k>>2]=h;h=or(j,20,d,o,k)|0;o=j+h|0;d=Hl(j,o,f)|0;hj(q,f);p=Zo(q,1077904)|0;ei(c[q>>2]|0)|0;lc[c[(c[p>>2]|0)+32>>2]&7](p,j,o,m)|0;h=m+h|0;if((d|0)==(o|0))d=h;else d=m+(d-j)|0;c[l>>2]=c[e>>2];c[k+0>>2]=c[l+0>>2];Fc(b,k,m,d,h,f,g);i=n;return}function Rl(a){a=a|0;return}function Sl(a){a=a|0;xt(a);return}function Tl(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;n=i;i=i+32|0;k=n+20|0;j=n+16|0;l=n+12|0;m=n;if(!(c[f+4>>2]&1)){m=c[(c[d>>2]|0)+24>>2]|0;c[j>>2]=c[e>>2];c[k+0>>2]=c[j+0>>2];nc[m&31](b,d,k,f,g,h&1)}else{hj(l,f);k=Zo(l,1078056)|0;ei(c[l>>2]|0)|0;j=c[k>>2]|0;if(h)dc[c[j+24>>2]&63](m,k);else dc[c[j+28>>2]&63](m,k);k=a[m>>0]|0;if(!(k&1)){d=m+4|0;j=d;l=m+8|0}else{l=m+8|0;j=c[l>>2]|0;d=m+4|0}h=j;while(1){if(!(k&1)){j=d;k=(k&255)>>>1}else{j=c[l>>2]|0;k=c[d>>2]|0}if((h|0)==(j+(k<<2)|0))break;j=c[h>>2]|0;k=c[e>>2]|0;if(k){f=k+24|0;g=c[f>>2]|0;if((g|0)==(c[k+28>>2]|0))j=oc[c[(c[k>>2]|0)+52>>2]&63](k,j)|0;else{c[f>>2]=g+4;c[g>>2]=j}if((j|0)==-1)c[e>>2]=0}k=a[m>>0]|0;h=h+4|0}c[b>>2]=c[e>>2];Yi(m)}i=n;return}function Ul(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+128|0;k=d;p=d+116|0;q=d+104|0;j=d+20|0;n=d+16|0;m=d+12|0;o=d+8|0;l=d+4|0;a[p+0>>0]=a[1076696]|0;a[p+1>>0]=a[1076697]|0;a[p+2>>0]=a[1076698]|0;a[p+3>>0]=a[1076699]|0;a[p+4>>0]=a[1076700]|0;a[p+5>>0]=a[1076701]|0;Gl(p+1|0,1076600,1,c[f+4>>2]|0);r=hl()|0;c[k>>2]=h;h=q+(or(q,12,r,p,k)|0)|0;p=Hl(q,h,f)|0;hj(o,f);Vl(q,p,h,j,n,m,o);ei(c[o>>2]|0)|0;c[l>>2]=c[e>>2];h=c[n>>2]|0;e=c[m>>2]|0;c[k+0>>2]=c[l+0>>2];qr(b,k,j,h,e,f,g);i=d;return}function Vl(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;w=i;i=i+16|0;v=w;u=Zo(j,1077896)|0;o=Zo(j,1078056)|0;dc[c[(c[o>>2]|0)+20>>2]&63](v,o);j=a[v>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[v+4>>2]|0;if(j){c[h>>2]=f;j=a[b>>0]|0;if(j<<24>>24==43|j<<24>>24==45){s=oc[c[(c[u>>2]|0)+44>>2]&63](u,j)|0;j=c[h>>2]|0;c[h>>2]=j+4;c[j>>2]=s;j=b+1|0}else j=b;if(((e-j|0)>1?(a[j>>0]|0)==48:0)?(n=j+1|0,s=a[n>>0]|0,s<<24>>24==88|s<<24>>24==120):0){s=oc[c[(c[u>>2]|0)+44>>2]&63](u,48)|0;r=c[h>>2]|0;c[h>>2]=r+4;c[r>>2]=s;r=oc[c[(c[u>>2]|0)+44>>2]&63](u,a[n>>0]|0)|0;s=c[h>>2]|0;c[h>>2]=s+4;c[s>>2]=r;j=j+2|0}if((j|0)!=(e|0)?(k=e+-1|0,k>>>0>j>>>0):0){n=j;l=e;while(1){s=a[n>>0]|0;a[n>>0]=a[k>>0]|0;a[k>>0]=s;n=n+1|0;l=l+-2|0;if(n>>>0>=l>>>0)break;else{s=k;k=l;l=s}}}p=fc[c[(c[o>>2]|0)+16>>2]&127](o)|0;if(j>>>0<e>>>0){q=v+1|0;r=v+4|0;s=v+8|0;n=0;l=0;t=j;while(1){o=(a[v>>0]&1)==0;if((a[(o?q:c[s>>2]|0)+l>>0]|0)!=0?(n|0)==(a[(o?q:c[s>>2]|0)+l>>0]|0):0){n=c[h>>2]|0;c[h>>2]=n+4;c[n>>2]=p;n=a[v>>0]|0;if(!(n&1))n=(n&255)>>>1;else n=c[r>>2]|0;o=0;l=(l>>>0<(n+-1|0)>>>0&1)+l|0}else o=n;x=oc[c[(c[u>>2]|0)+44>>2]&63](u,a[t>>0]|0)|0;n=c[h>>2]|0;k=n+4|0;c[h>>2]=k;c[n>>2]=x;t=t+1|0;if(t>>>0>=e>>>0)break;else n=o+1|0}}else k=c[h>>2]|0;l=f+(j-b<<2)|0;if((l|0)!=(k|0)?(m=k+-4|0,m>>>0>l>>>0):0){j=k;while(1){s=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=s;l=l+4|0;j=j+-8|0;if(l>>>0>=j>>>0)break;else{s=m;m=j;j=s}}}}else{lc[c[(c[u>>2]|0)+48>>2]&7](u,b,e,f)|0;k=f+(e-b<<2)|0;c[h>>2]=k}if((d|0)!=(e|0))k=f+(d-b<<2)|0;c[g>>2]=k;Bi(v);i=w;return}function Wl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+224|0;k=b+8|0;q=b;p=b+196|0;j=b+32|0;n=b+28|0;m=b+24|0;o=b+20|0;l=b+16|0;r=q;c[r>>2]=37;c[r+4>>2]=0;Gl(q+1|0,1076608,1,c[e+4>>2]|0);r=hl()|0;s=k;c[s>>2]=g;c[s+4>>2]=h;h=p+(or(p,22,r,q,k)|0)|0;g=Hl(p,h,e)|0;hj(o,e);Vl(p,g,h,j,n,m,o);ei(c[o>>2]|0)|0;c[l>>2]=c[d>>2];h=c[n>>2]|0;g=c[m>>2]|0;c[k+0>>2]=c[l+0>>2];qr(a,k,j,h,g,e,f);i=b;return}function Xl(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+128|0;k=d;p=d+116|0;q=d+104|0;j=d+20|0;n=d+16|0;m=d+12|0;o=d+8|0;l=d+4|0;a[p+0>>0]=a[1076696]|0;a[p+1>>0]=a[1076697]|0;a[p+2>>0]=a[1076698]|0;a[p+3>>0]=a[1076699]|0;a[p+4>>0]=a[1076700]|0;a[p+5>>0]=a[1076701]|0;Gl(p+1|0,1076600,0,c[f+4>>2]|0);r=hl()|0;c[k>>2]=h;h=q+(or(q,12,r,p,k)|0)|0;p=Hl(q,h,f)|0;hj(o,f);Vl(q,p,h,j,n,m,o);ei(c[o>>2]|0)|0;c[l>>2]=c[e>>2];h=c[n>>2]|0;e=c[m>>2]|0;c[k+0>>2]=c[l+0>>2];qr(b,k,j,h,e,f,g);i=d;return}function Yl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+240|0;k=b+8|0;q=b;p=b+204|0;j=b+32|0;n=b+28|0;m=b+24|0;o=b+20|0;l=b+16|0;r=q;c[r>>2]=37;c[r+4>>2]=0;Gl(q+1|0,1076608,0,c[e+4>>2]|0);r=hl()|0;s=k;c[s>>2]=g;c[s+4>>2]=h;h=p+(or(p,23,r,q,k)|0)|0;g=Hl(p,h,e)|0;hj(o,e);Vl(p,g,h,j,n,m,o);ei(c[o>>2]|0)|0;c[l>>2]=c[d>>2];h=c[n>>2]|0;g=c[m>>2]|0;c[k+0>>2]=c[l+0>>2];qr(a,k,j,h,g,e,f);i=b;return}function Zl(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;v=i;i=i+304|0;o=v+8|0;j=v;m=v+272|0;b=v+268|0;n=v+40|0;u=v+36|0;t=v+32|0;p=v+28|0;q=v+24|0;r=v+20|0;B=j;c[B>>2]=37;c[B+4>>2]=0;B=Nl(j+1|0,1076616,c[e+4>>2]|0)|0;c[b>>2]=m;l=hl()|0;if(B){c[o>>2]=c[e+8>>2];B=o+4|0;h[k>>3]=g;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];l=or(m,30,l,j,o)|0}else{h[k>>3]=g;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];l=or(m,30,l,j,o)|0}if((l|0)>29){l=hl()|0;c[o>>2]=c[e+8>>2];B=o+4|0;h[k>>3]=g;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];j=pr(b,l,j,o)|0;b=c[b>>2]|0;if(!b)ou();else{w=b;z=b;s=j}}else{w=c[b>>2]|0;z=0;s=l}j=w+s|0;l=Hl(w,j,e)|0;if((w|0)!=(m|0)){b=tu(s<<3)|0;if(!b)ou();else{x=w;y=b;A=b}}else{x=m;y=0;A=n}hj(p,e);_l(x,l,j,A,u,t,p);ei(c[p>>2]|0)|0;c[r>>2]=c[d>>2];w=c[u>>2]|0;x=c[t>>2]|0;c[o+0>>2]=c[r+0>>2];qr(q,o,A,w,x,e,f);A=c[q>>2]|0;c[d>>2]=A;c[a>>2]=A;if(y)uu(y);uu(z);i=v;return}function _l(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=i;i=i+16|0;y=z;x=Zo(j,1077896)|0;v=Zo(j,1078056)|0;dc[c[(c[v>>2]|0)+20>>2]&63](y,v);c[h>>2]=f;l=a[b>>0]|0;if(l<<24>>24==43|l<<24>>24==45){w=oc[c[(c[x>>2]|0)+44>>2]&63](x,l)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=w;l=b+1|0}else l=b;w=e;a:do if(((w-l|0)>1?(a[l>>0]|0)==48:0)?(m=l+1|0,u=a[m>>0]|0,u<<24>>24==88|u<<24>>24==120):0){u=oc[c[(c[x>>2]|0)+44>>2]&63](x,48)|0;k=c[h>>2]|0;c[h>>2]=k+4;c[k>>2]=u;l=l+2|0;k=oc[c[(c[x>>2]|0)+44>>2]&63](x,a[m>>0]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=k;if(l>>>0<e>>>0){m=l;while(1){u=a[m>>0]|0;k=m+1|0;if(!($s(u<<24>>24,hl()|0)|0)){u=l;k=m;break a}if(k>>>0<e>>>0)m=k;else{u=l;break}}}else{u=l;k=l}}else o=4;while(0);b:do if((o|0)==4)if(l>>>0<e>>>0){m=l;while(1){u=a[m>>0]|0;k=m+1|0;if(!(_s(u<<24>>24,hl()|0)|0)){u=l;k=m;break b}if(k>>>0<e>>>0)m=k;else{u=l;break}}}else{u=l;k=l}while(0);m=a[y>>0]|0;if(!(m&1))m=(m&255)>>>1;else m=c[y+4>>2]|0;if(m){if((u|0)!=(k|0)?(t=k+-1|0,t>>>0>u>>>0):0){j=u;l=t;m=k;while(1){t=a[j>>0]|0;a[j>>0]=a[l>>0]|0;a[l>>0]=t;j=j+1|0;m=m+-2|0;if(j>>>0>=m>>>0)break;else{t=l;l=m;m=t}}}p=fc[c[(c[v>>2]|0)+16>>2]&127](v)|0;if(u>>>0<k>>>0){q=y+1|0;r=y+4|0;s=y+8|0;m=0;l=0;t=u;while(1){j=(a[y>>0]&1)==0;if((a[(j?q:c[s>>2]|0)+l>>0]|0)>0?(m|0)==(a[(j?q:c[s>>2]|0)+l>>0]|0):0){m=c[h>>2]|0;c[h>>2]=m+4;c[m>>2]=p;m=a[y>>0]|0;if(!(m&1))m=(m&255)>>>1;else m=c[r>>2]|0;o=0;l=(l>>>0<(m+-1|0)>>>0&1)+l|0}else o=m;A=oc[c[(c[x>>2]|0)+44>>2]&63](x,a[t>>0]|0)|0;m=c[h>>2]|0;j=m+4|0;c[h>>2]=j;c[m>>2]=A;t=t+1|0;if(t>>>0>=k>>>0)break;else m=o+1|0}}else j=c[h>>2]|0;l=f+(u-b<<2)|0;if((l|0)!=(j|0)?(n=j+-4|0,n>>>0>l>>>0):0){m=j;while(1){u=c[l>>2]|0;c[l>>2]=c[n>>2];c[n>>2]=u;l=l+4|0;m=m+-8|0;if(l>>>0>=m>>>0)break;else{u=n;n=m;m=u}}}}else{lc[c[(c[x>>2]|0)+48>>2]&7](x,u,k,c[h>>2]|0)|0;j=(c[h>>2]|0)+(k-u<<2)|0;c[h>>2]=j}c:do if(k>>>0<e>>>0){while(1){j=a[k>>0]|0;if(j<<24>>24==46)break;t=oc[c[(c[x>>2]|0)+44>>2]&63](x,j)|0;u=c[h>>2]|0;j=u+4|0;c[h>>2]=j;c[u>>2]=t;k=k+1|0;if(k>>>0>=e>>>0)break c}u=fc[c[(c[v>>2]|0)+12>>2]&127](v)|0;v=c[h>>2]|0;j=v+4|0;c[h>>2]=j;c[v>>2]=u;k=k+1|0}while(0);lc[c[(c[x>>2]|0)+48>>2]&7](x,k,e,j)|0;k=(c[h>>2]|0)+(w-k<<2)|0;c[h>>2]=k;if((d|0)!=(e|0))k=f+(d-b<<2)|0;c[g>>2]=k;Bi(y);i=z;return}function $l(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;w=i;i=i+304|0;p=w+8|0;b=w;n=w+272|0;m=w+268|0;o=w+40|0;v=w+36|0;u=w+32|0;q=w+28|0;r=w+24|0;s=w+20|0;j=b;c[j>>2]=37;c[j+4>>2]=0;j=Nl(b+1|0,1076624,c[e+4>>2]|0)|0;c[m>>2]=n;l=hl()|0;if(j){c[p>>2]=c[e+8>>2];C=p+4|0;h[k>>3]=g;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];l=or(n,30,l,b,p)|0}else{h[k>>3]=g;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];l=or(n,30,l,b,p)|0}if((l|0)>29){l=hl()|0;if(j){c[p>>2]=c[e+8>>2];j=p+4|0;h[k>>3]=g;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];l=pr(m,l,b,p)|0}else{h[k>>3]=g;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];l=pr(m,l,b,p)|0}b=c[m>>2]|0;if(!b)ou();else{x=b;A=b;t=l}}else{x=c[m>>2]|0;A=0;t=l}j=x+t|0;l=Hl(x,j,e)|0;if((x|0)!=(n|0)){b=tu(t<<3)|0;if(!b)ou();else{y=x;z=b;B=b}}else{y=n;z=0;B=o}hj(q,e);_l(y,l,j,B,v,u,q);ei(c[q>>2]|0)|0;c[s>>2]=c[d>>2];x=c[v>>2]|0;y=c[u>>2]|0;c[p+0>>2]=c[s+0>>2];qr(r,p,B,x,y,e,f);B=c[r>>2]|0;c[d>>2]=B;c[a>>2]=B;if(z)uu(z);uu(A);i=w;return}function am(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;n=i;i=i+192|0;k=n;o=n+180|0;j=n+160|0;m=n+12|0;q=n+8|0;l=n+4|0;a[o+0>>0]=a[1076704]|0;a[o+1>>0]=a[1076705]|0;a[o+2>>0]=a[1076706]|0;a[o+3>>0]=a[1076707]|0;a[o+4>>0]=a[1076708]|0;a[o+5>>0]=a[1076709]|0;d=hl()|0;c[k>>2]=h;h=or(j,20,d,o,k)|0;o=j+h|0;d=Hl(j,o,f)|0;hj(q,f);p=Zo(q,1077896)|0;ei(c[q>>2]|0)|0;lc[c[(c[p>>2]|0)+48>>2]&7](p,j,o,m)|0;h=m+(h<<2)|0;if((d|0)==(o|0))d=h;else d=m+(d-j<<2)|0;c[l>>2]=c[e>>2];c[k+0>>2]=c[l+0>>2];qr(b,k,m,d,h,f,g);i=n;return}function bm(e,f,g,h,j,k,l,m,n){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=i;i=i+32|0;w=E+20|0;v=E+16|0;C=E+12|0;x=E+8|0;y=E+4|0;z=E;hj(C,j);A=Zo(C,1077904)|0;ei(c[C>>2]|0)|0;c[k>>2]=0;a:do if((m|0)!=(n|0)){C=A+8|0;b:while(1){o=c[g>>2]|0;if(o){if((c[o+12>>2]|0)==(c[o+16>>2]|0)?(fc[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1:0){c[g>>2]=0;o=0}}else o=0;p=(o|0)==0;q=c[h>>2]|0;do if(q){if((c[q+12>>2]|0)==(c[q+16>>2]|0)?(fc[c[(c[q>>2]|0)+36>>2]&127](q)|0)==-1:0){c[h>>2]=0;D=13;break}if(!p){D=14;break b}}else D=13;while(0);if((D|0)==13){D=0;if(p){D=14;break}else q=0}c:do if(($b[c[(c[A>>2]|0)+36>>2]&31](A,a[m>>0]|0,0)|0)<<24>>24==37){r=m+1|0;if((r|0)==(n|0)){D=17;break b}p=$b[c[(c[A>>2]|0)+36>>2]&31](A,a[r>>0]|0,0)|0;if(p<<24>>24==48|p<<24>>24==69){s=m+2|0;if((s|0)==(n|0)){D=20;break b}m=r;s=$b[c[(c[A>>2]|0)+36>>2]&31](A,a[s>>0]|0,0)|0}else{s=p;p=0}r=c[(c[f>>2]|0)+36>>2]|0;c[y>>2]=o;c[z>>2]=q;c[v+0>>2]=c[y+0>>2];c[w+0>>2]=c[z+0>>2];ec[r&3](x,f,v,w,j,k,l,s,p);o=c[x>>2]|0;c[g>>2]=o;m=m+2|0}else{p=a[m>>0]|0;if(p<<24>>24>-1?(B=c[C>>2]|0,(b[B+(p<<24>>24<<1)>>1]&8192)!=0):0){do{m=m+1|0;if((m|0)==(n|0)){m=n;break}p=a[m>>0]|0;if(p<<24>>24<=-1)break}while((b[B+(p<<24>>24<<1)>>1]&8192)!=0);s=o;t=q;r=q;while(1){if(s)if((c[s+12>>2]|0)==(c[s+16>>2]|0)?(fc[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1:0){c[g>>2]=0;o=0;u=0}else u=s;else u=0;s=(u|0)==0;do if(r){if((c[r+12>>2]|0)!=(c[r+16>>2]|0))if(s){q=t;break}else break c;if((fc[c[(c[r>>2]|0)+36>>2]&127](r)|0)!=-1)if(s^(t|0)==0){q=t;r=t;break}else break c;else{c[h>>2]=0;q=0;D=39;break}}else{q=t;D=39}while(0);if((D|0)==39){D=0;if(s)break c;else r=0}p=u+12|0;s=c[p>>2]|0;t=u+16|0;if((s|0)==(c[t>>2]|0))s=fc[c[(c[u>>2]|0)+36>>2]&127](u)|0;else s=d[s>>0]|0;if((s&255)<<24>>24<=-1)break c;if(!(b[(c[C>>2]|0)+(s<<24>>24<<1)>>1]&8192))break c;s=c[p>>2]|0;if((s|0)==(c[t>>2]|0)){fc[c[(c[u>>2]|0)+40>>2]&127](u)|0;s=u;t=q;continue}else{c[p>>2]=s+1;s=u;t=q;continue}}}s=o+12|0;q=c[s>>2]|0;r=o+16|0;if((q|0)==(c[r>>2]|0))q=fc[c[(c[o>>2]|0)+36>>2]&127](o)|0;else q=d[q>>0]|0;p=oc[c[(c[A>>2]|0)+12>>2]&63](A,q&255)|0;if(p<<24>>24!=(oc[c[(c[A>>2]|0)+12>>2]&63](A,a[m>>0]|0)|0)<<24>>24){D=57;break b}q=c[s>>2]|0;if((q|0)==(c[r>>2]|0))fc[c[(c[o>>2]|0)+40>>2]&127](o)|0;else c[s>>2]=q+1;m=m+1|0}while(0);if(!((m|0)!=(n|0)&(c[k>>2]|0)==0))break a}if((D|0)==14){c[k>>2]=4;break}else if((D|0)==17){c[k>>2]=4;break}else if((D|0)==20){c[k>>2]=4;break}else if((D|0)==57){c[k>>2]=4;break}}else o=c[g>>2]|0;while(0);if(o){if((c[o+12>>2]|0)==(c[o+16>>2]|0)?(fc[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1:0){c[g>>2]=0;o=0}}else o=0;p=(o|0)==0;m=c[h>>2]|0;do if(m){if((c[m+12>>2]|0)==(c[m+16>>2]|0)?(fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1:0){c[h>>2]=0;D=67;break}if(!p)D=68}else D=67;while(0);if((D|0)==67?p:0)D=68;if((D|0)==68)c[k>>2]=c[k>>2]|2;c[e>>2]=o;i=E;return}function cm(a){a=a|0;return}function dm(a){a=a|0;xt(a);return}function em(a){a=a|0;return 2}function fm(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];bm(a,b,l,k,f,g,h,1076808,1076816|0);i=j;return}function gm(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;q=i;i=i+16|0;n=q+12|0;m=q+8|0;o=q+4|0;p=q;l=d+8|0;l=fc[c[(c[l>>2]|0)+20>>2]&127](l)|0;c[o>>2]=c[e>>2];c[p>>2]=c[f>>2];e=a[l>>0]|0;if(!(e&1)){k=l+1|0;f=(e&255)>>>1;e=l+1|0}else{e=c[l+8>>2]|0;k=e;f=c[l+4>>2]|0}c[m+0>>2]=c[o+0>>2];c[n+0>>2]=c[p+0>>2];bm(b,d,m,n,g,h,j,e,k+f|0);i=q;return}function hm(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;m=j+4|0;l=j;hj(m,f);f=Zo(m,1077904)|0;ei(c[m>>2]|0)|0;c[l>>2]=c[e>>2];c[k+0>>2]=c[l+0>>2];im(b,h+24|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function im(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;i=i+16|0;j=h+4|0;k=h;a=a+8|0;a=fc[c[c[a>>2]>>2]&127](a)|0;c[k>>2]=c[e>>2];c[j+0>>2]=c[k+0>>2];d=(Vq(d,j,a,a+168|0,g,f,0)|0)-a|0;if((d|0)<168)c[b>>2]=((d|0)/12|0|0)%7|0;i=h;return}function jm(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;m=j+4|0;l=j;hj(m,f);f=Zo(m,1077904)|0;ei(c[m>>2]|0)|0;c[l>>2]=c[e>>2];c[k+0>>2]=c[l+0>>2];km(b,h+16|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function km(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;i=i+16|0;j=h+4|0;k=h;a=a+8|0;a=fc[c[(c[a>>2]|0)+4>>2]&127](a)|0;c[k>>2]=c[e>>2];c[j+0>>2]=c[k+0>>2];d=(Vq(d,j,a,a+288|0,g,f,0)|0)-a|0;if((d|0)<288)c[b>>2]=((d|0)/12|0|0)%12|0;i=h;return}function lm(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;m=j+4|0;l=j;hj(m,f);f=Zo(m,1077904)|0;ei(c[m>>2]|0)|0;c[l>>2]=c[e>>2];c[k+0>>2]=c[l+0>>2];mm(b,h+20|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function mm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];a=rr(d,a,f,g,4)|0;if(!(c[f>>2]&4)){if((a|0)<69)a=a+2e3|0;else a=(a+-69|0)>>>0<31?a+1900|0:a;c[b>>2]=a+-1900}i=h;return}function nm(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;$=i;i=i+176|0;_=$+160|0;Z=$+156|0;aa=$+152|0;v=$+148|0;G=$+144|0;W=$+140|0;X=$+136|0;Y=$+132|0;P=$+128|0;Q=$+124|0;R=$+120|0;o=$+116|0;n=$+112|0;m=$+108|0;l=$+104|0;p=$+100|0;q=$+96|0;r=$+92|0;s=$+88|0;t=$+84|0;u=$+80|0;w=$+76|0;x=$+72|0;y=$+68|0;z=$+64|0;A=$+60|0;B=$+56|0;C=$+52|0;D=$+48|0;E=$+44|0;F=$+40|0;H=$+36|0;I=$+32|0;J=$+28|0;K=$+24|0;T=$+20|0;U=$+16|0;V=$+12|0;L=$+8|0;M=$+4|0;N=$;c[h>>2]=0;hj(aa,g);O=Zo(aa,1077904)|0;ei(c[aa>>2]|0)|0;do switch(k<<24>>24|0){case 72:{c[p>>2]=c[f>>2];c[_+0>>2]=c[p+0>>2];pm(d,j+8|0,e,_,h,O);S=32;break}case 114:{c[y>>2]=c[e>>2];c[z>>2]=c[f>>2];c[Z+0>>2]=c[y+0>>2];c[_+0>>2]=c[z+0>>2];bm(x,d,Z,_,g,h,j,1076832,1076843|0);c[e>>2]=c[x>>2];S=32;break}case 112:{c[w>>2]=c[f>>2];c[_+0>>2]=c[w+0>>2];vm(d,j+8|0,e,_,h,O);S=32;break}case 99:{o=d+8|0;o=fc[c[(c[o>>2]|0)+12>>2]&127](o)|0;c[X>>2]=c[e>>2];c[Y>>2]=c[f>>2];l=a[o>>0]|0;if(!(l&1)){n=o+1|0;m=(l&255)>>>1;l=o+1|0}else{l=c[o+8>>2]|0;n=l;m=c[o+4>>2]|0}c[Z+0>>2]=c[X+0>>2];c[_+0>>2]=c[Y+0>>2];bm(W,d,Z,_,g,h,j,l,n+m|0);c[e>>2]=c[W>>2];S=32;break}case 37:{c[N>>2]=c[f>>2];c[_+0>>2]=c[N+0>>2];zm(d,e,_,h,O);S=32;break}case 73:{c[q>>2]=c[f>>2];c[_+0>>2]=c[q+0>>2];qm(d,j+8|0,e,_,h,O);S=32;break}case 116:case 110:{c[u>>2]=c[f>>2];c[_+0>>2]=c[u+0>>2];um(d,e,_,h,O);S=32;break}case 88:{n=d+8|0;n=fc[c[(c[n>>2]|0)+24>>2]&127](n)|0;c[U>>2]=c[e>>2];c[V>>2]=c[f>>2];l=a[n>>0]|0;if(!(l&1)){o=n+1|0;m=(l&255)>>>1;l=n+1|0}else{l=c[n+8>>2]|0;o=l;m=c[n+4>>2]|0}c[Z+0>>2]=c[U+0>>2];c[_+0>>2]=c[V+0>>2];bm(T,d,Z,_,g,h,j,l,o+m|0);c[e>>2]=c[T>>2];S=32;break}case 120:{Y=c[(c[d>>2]|0)+20>>2]|0;c[J>>2]=c[e>>2];c[K>>2]=c[f>>2];c[Z+0>>2]=c[J+0>>2];c[_+0>>2]=c[K+0>>2];ac[Y&63](b,d,Z,_,g,h,j);break}case 104:case 66:case 98:{c[G>>2]=c[f>>2];c[_+0>>2]=c[G+0>>2];km(d,j+16|0,e,_,h,O);S=32;break}case 77:{c[t>>2]=c[f>>2];c[_+0>>2]=c[t+0>>2];tm(d,j+4|0,e,_,h,O);S=32;break}case 119:{c[I>>2]=c[f>>2];c[_+0>>2]=c[I+0>>2];xm(d,j+24|0,e,_,h,O);S=32;break}case 65:case 97:{c[v>>2]=c[f>>2];c[_+0>>2]=c[v+0>>2];im(d,j+24|0,e,_,h,O);S=32;break}case 106:{c[r>>2]=c[f>>2];c[_+0>>2]=c[r+0>>2];rm(d,j+28|0,e,_,h,O);S=32;break}case 109:{c[s>>2]=c[f>>2];c[_+0>>2]=c[s+0>>2];sm(d,j+16|0,e,_,h,O);S=32;break}case 84:{c[F>>2]=c[e>>2];c[H>>2]=c[f>>2];c[Z+0>>2]=c[F+0>>2];c[_+0>>2]=c[H+0>>2];bm(E,d,Z,_,g,h,j,1076856,1076864|0);c[e>>2]=c[E>>2];S=32;break}case 82:{c[B>>2]=c[e>>2];c[C>>2]=c[f>>2];c[Z+0>>2]=c[B+0>>2];c[_+0>>2]=c[C+0>>2];bm(A,d,Z,_,g,h,j,1076848,1076853|0);c[e>>2]=c[A>>2];S=32;break}case 68:{c[R>>2]=c[e>>2];c[o>>2]=c[f>>2];c[Z+0>>2]=c[R+0>>2];c[_+0>>2]=c[o+0>>2];bm(Q,d,Z,_,g,h,j,1076816,1076824|0);c[e>>2]=c[Q>>2];S=32;break}case 89:{c[M>>2]=c[f>>2];c[_+0>>2]=c[M+0>>2];ym(d,j+20|0,e,_,h,O);S=32;break}case 101:case 100:{c[P>>2]=c[f>>2];c[_+0>>2]=c[P+0>>2];om(d,j+12|0,e,_,h,O);S=32;break}case 70:{c[m>>2]=c[e>>2];c[l>>2]=c[f>>2];c[Z+0>>2]=c[m+0>>2];c[_+0>>2]=c[l+0>>2];bm(n,d,Z,_,g,h,j,1076824,1076832|0);c[e>>2]=c[n>>2];S=32;break}case 83:{c[D>>2]=c[f>>2];c[_+0>>2]=c[D+0>>2];wm(d,j,e,_,h,O);S=32;break}case 121:{c[L>>2]=c[f>>2];c[_+0>>2]=c[L+0>>2];mm(d,j+20|0,e,_,h,O);S=32;break}default:{c[h>>2]=c[h>>2]|4;S=32}}while(0);if((S|0)==32)c[b>>2]=c[e>>2];i=$;return}function om(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=rr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)>0&(d|0)<32)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function pm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=rr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<24)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function qm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=rr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)>0&(d|0)<13)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function rm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=rr(d,a,f,g,3)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<366)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function sm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=rr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<13)c[b>>2]=d+-1;else c[f>>2]=a|4;i=h;return}function tm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=rr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<60)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function um(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0;j=h+8|0;a:while(1){h=c[e>>2]|0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0))if((fc[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[e>>2]=0;h=0;break}else{h=c[e>>2]|0;break}}else h=0;while(0);a=(h|0)==0;h=c[f>>2]|0;do if(h){if((c[h+12>>2]|0)!=(c[h+16>>2]|0))if(a)break;else{a=h;break a}if((fc[c[(c[h>>2]|0)+36>>2]&127](h)|0)!=-1)if(a)break;else{a=h;break a}else{c[f>>2]=0;k=12;break}}else k=12;while(0);if((k|0)==12){k=0;if(a){a=0;break}else h=0}a=c[e>>2]|0;i=c[a+12>>2]|0;if((i|0)==(c[a+16>>2]|0))a=fc[c[(c[a>>2]|0)+36>>2]&127](a)|0;else a=d[i>>0]|0;if((a&255)<<24>>24<=-1){a=h;break}if(!(b[(c[j>>2]|0)+(a<<24>>24<<1)>>1]&8192)){a=h;break}i=c[e>>2]|0;a=i+12|0;h=c[a>>2]|0;if((h|0)==(c[i+16>>2]|0)){fc[c[(c[i>>2]|0)+40>>2]&127](i)|0;continue}else{c[a>>2]=h+1;continue}}h=c[e>>2]|0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0))if((fc[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[e>>2]=0;h=0;break}else{h=c[e>>2]|0;break}}else h=0;while(0);h=(h|0)==0;do if(a){if((c[a+12>>2]|0)==(c[a+16>>2]|0)?(fc[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1:0){c[f>>2]=0;k=32;break}if(!h)k=33}else k=32;while(0);if((k|0)==32?h:0)k=33;if((k|0)==33)c[g>>2]=c[g>>2]|2;return}function vm(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;k=n+4|0;l=n;m=b+8|0;m=fc[c[(c[m>>2]|0)+8>>2]&127](m)|0;b=a[m>>0]|0;if(!(b&1))j=(b&255)>>>1;else j=c[m+4>>2]|0;b=a[m+12>>0]|0;if(!(b&1))b=(b&255)>>>1;else b=c[m+16>>2]|0;do if((j|0)!=(0-b|0)){c[l>>2]=c[f>>2];c[k+0>>2]=c[l+0>>2];j=Vq(e,k,m,m+24|0,h,g,0)|0;b=c[d>>2]|0;if((j|0)==(m|0)&(b|0)==12){c[d>>2]=0;break}if((j-m|0)==12&(b|0)<12)c[d>>2]=b+12}else c[g>>2]=c[g>>2]|4;while(0);i=n;return}function wm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=rr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<61)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function xm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=rr(d,a,f,g,1)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<7)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function ym(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];a=rr(d,a,f,g,4)|0;if(!(c[f>>2]&4))c[b>>2]=a+-1900;i=h;return}function zm(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;a=c[b>>2]|0;do if(a){if((c[a+12>>2]|0)==(c[a+16>>2]|0))if((fc[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){c[b>>2]=0;a=0;break}else{a=c[b>>2]|0;break}}else a=0;while(0);h=(a|0)==0;a=c[e>>2]|0;do if(a){if((c[a+12>>2]|0)==(c[a+16>>2]|0)?(fc[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1:0){c[e>>2]=0;j=11;break}if(h){i=a;j=13}else j=12}else j=11;while(0);if((j|0)==11)if(h)j=12;else{i=0;j=13}a:do if((j|0)==12)c[f>>2]=c[f>>2]|6;else if((j|0)==13){h=c[b>>2]|0;a=c[h+12>>2]|0;if((a|0)==(c[h+16>>2]|0))a=fc[c[(c[h>>2]|0)+36>>2]&127](h)|0;else a=d[a>>0]|0;if(($b[c[(c[g>>2]|0)+36>>2]&31](g,a&255,0)|0)<<24>>24!=37){c[f>>2]=c[f>>2]|4;break}a=c[b>>2]|0;h=a+12|0;g=c[h>>2]|0;if((g|0)==(c[a+16>>2]|0)){fc[c[(c[a>>2]|0)+40>>2]&127](a)|0;a=c[b>>2]|0}else c[h>>2]=g+1;do if(a){if((c[a+12>>2]|0)==(c[a+16>>2]|0))if((fc[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){c[b>>2]=0;a=0;break}else{a=c[b>>2]|0;break}}else a=0;while(0);a=(a|0)==0;do if(i){if((c[i+12>>2]|0)==(c[i+16>>2]|0)?(fc[c[(c[i>>2]|0)+36>>2]&127](i)|0)==-1:0){c[e>>2]=0;j=31;break}if(a)break a}else j=31;while(0);if((j|0)==31?!a:0)break;c[f>>2]=c[f>>2]|2}while(0);return}function Am(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=i;i=i+32|0;u=A+20|0;t=A+16|0;l=A+12|0;v=A+8|0;w=A+4|0;x=A;hj(l,f);y=Zo(l,1077896)|0;ei(c[l>>2]|0)|0;c[g>>2]=0;a:do if((j|0)!=(k|0)){b:while(1){m=c[d>>2]|0;do if(m){n=c[m+12>>2]|0;if((n|0)==(c[m+16>>2]|0))n=fc[c[(c[m>>2]|0)+36>>2]&127](m)|0;else n=c[n>>2]|0;if((n|0)==-1){c[d>>2]=0;l=0;m=1;break}else{l=m;m=(m|0)==0;break}}else{l=0;m=1}while(0);o=c[e>>2]|0;do if(o){n=c[o+12>>2]|0;if((n|0)==(c[o+16>>2]|0))n=fc[c[(c[o>>2]|0)+36>>2]&127](o)|0;else n=c[n>>2]|0;if((n|0)!=-1)if(m)break;else{z=19;break b}else{c[e>>2]=0;z=17;break}}else z=17;while(0);if((z|0)==17){z=0;if(m){z=19;break}else o=0}c:do if(($b[c[(c[y>>2]|0)+52>>2]&31](y,c[j>>2]|0,0)|0)<<24>>24==37){m=j+4|0;if((m|0)==(k|0)){z=22;break b}n=$b[c[(c[y>>2]|0)+52>>2]&31](y,c[m>>2]|0,0)|0;if(n<<24>>24==48|n<<24>>24==69){p=j+8|0;if((p|0)==(k|0)){z=25;break b}j=m;p=$b[c[(c[y>>2]|0)+52>>2]&31](y,c[p>>2]|0,0)|0}else{p=n;n=0}m=c[(c[b>>2]|0)+36>>2]|0;c[w>>2]=l;c[x>>2]=o;c[t+0>>2]=c[w+0>>2];c[u+0>>2]=c[x+0>>2];ec[m&3](v,b,t,u,f,g,h,p,n);l=c[v>>2]|0;c[d>>2]=l;j=j+8|0}else{if(!($b[c[(c[y>>2]|0)+12>>2]&31](y,8192,c[j>>2]|0)|0)){p=l+12|0;n=c[p>>2]|0;o=l+16|0;if((n|0)==(c[o>>2]|0))n=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else n=c[n>>2]|0;m=oc[c[(c[y>>2]|0)+28>>2]&63](y,n)|0;if((m|0)!=(oc[c[(c[y>>2]|0)+28>>2]&63](y,c[j>>2]|0)|0)){z=62;break b}n=c[p>>2]|0;if((n|0)==(c[o>>2]|0))fc[c[(c[l>>2]|0)+40>>2]&127](l)|0;else c[p>>2]=n+4;j=j+4|0;break}do{j=j+4|0;if((j|0)==(k|0)){j=k;break}}while($b[c[(c[y>>2]|0)+12>>2]&31](y,8192,c[j>>2]|0)|0);q=l;s=o;m=o;while(1){if(q){p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))n=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else n=c[p>>2]|0;if((n|0)==-1){c[d>>2]=0;l=0;q=0;o=1}else o=0}else{q=0;o=1}do if(m){p=c[m+12>>2]|0;if((p|0)==(c[m+16>>2]|0))n=fc[c[(c[m>>2]|0)+36>>2]&127](m)|0;else n=c[p>>2]|0;if((n|0)!=-1)if(o^(s|0)==0){n=s;r=s;break}else break c;else{c[e>>2]=0;n=0;z=45;break}}else{n=s;z=45}while(0);if((z|0)==45){z=0;if(o)break c;else r=0}m=q+12|0;p=c[m>>2]|0;o=q+16|0;if((p|0)==(c[o>>2]|0))p=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else p=c[p>>2]|0;if(!($b[c[(c[y>>2]|0)+12>>2]&31](y,8192,p)|0))break c;p=c[m>>2]|0;if((p|0)==(c[o>>2]|0)){fc[c[(c[q>>2]|0)+40>>2]&127](q)|0;s=n;m=r;continue}else{c[m>>2]=p+4;s=n;m=r;continue}}}while(0);if(!((j|0)!=(k|0)&(c[g>>2]|0)==0))break a}if((z|0)==19){c[g>>2]=4;break}else if((z|0)==22){c[g>>2]=4;break}else if((z|0)==25){c[g>>2]=4;break}else if((z|0)==62){c[g>>2]=4;break}}else l=c[d>>2]|0;while(0);if(l){m=c[l+12>>2]|0;if((m|0)==(c[l+16>>2]|0))m=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else m=c[m>>2]|0;if((m|0)==-1){c[d>>2]=0;l=0;j=1}else j=0}else{l=0;j=1}m=c[e>>2]|0;do if(m){n=c[m+12>>2]|0;if((n|0)==(c[m+16>>2]|0))m=fc[c[(c[m>>2]|0)+36>>2]&127](m)|0;else m=c[n>>2]|0;if((m|0)!=-1)if(j)break;else{z=77;break}else{c[e>>2]=0;z=75;break}}else z=75;while(0);if((z|0)==75?j:0)z=77;if((z|0)==77)c[g>>2]=c[g>>2]|2;c[a>>2]=l;i=A;return}function Bm(a){a=a|0;return}function Cm(a){a=a|0;xt(a);return}function Dm(a){a=a|0;return 2}function Em(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];Am(a,b,l,k,f,g,h,1076960,1076992|0);i=j;return}function Fm(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;q=i;i=i+16|0;n=q+12|0;m=q+8|0;o=q+4|0;p=q;l=d+8|0;l=fc[c[(c[l>>2]|0)+20>>2]&127](l)|0;c[o>>2]=c[e>>2];c[p>>2]=c[f>>2];e=a[l>>0]|0;if(!(e&1)){k=l+4|0;f=(e&255)>>>1;e=l+4|0}else{e=c[l+8>>2]|0;k=e;f=c[l+4>>2]|0}c[m+0>>2]=c[o+0>>2];c[n+0>>2]=c[p+0>>2];Am(b,d,m,n,g,h,j,e,k+(f<<2)|0);i=q;return}function Gm(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;m=j+4|0;l=j;hj(m,f);f=Zo(m,1077896)|0;ei(c[m>>2]|0)|0;c[l>>2]=c[e>>2];c[k+0>>2]=c[l+0>>2];Hm(b,h+24|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function Hm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;i=i+16|0;j=h+4|0;k=h;a=a+8|0;a=fc[c[c[a>>2]>>2]&127](a)|0;c[k>>2]=c[e>>2];c[j+0>>2]=c[k+0>>2];d=(er(d,j,a,a+168|0,g,f,0)|0)-a|0;if((d|0)<168)c[b>>2]=((d|0)/12|0|0)%7|0;i=h;return}function Im(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;m=j+4|0;l=j;hj(m,f);f=Zo(m,1077896)|0;ei(c[m>>2]|0)|0;c[l>>2]=c[e>>2];c[k+0>>2]=c[l+0>>2];Jm(b,h+16|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function Jm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;i=i+16|0;j=h+4|0;k=h;a=a+8|0;a=fc[c[(c[a>>2]|0)+4>>2]&127](a)|0;c[k>>2]=c[e>>2];c[j+0>>2]=c[k+0>>2];d=(er(d,j,a,a+288|0,g,f,0)|0)-a|0;if((d|0)<288)c[b>>2]=((d|0)/12|0|0)%12|0;i=h;return}function Km(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;m=j+4|0;l=j;hj(m,f);f=Zo(m,1077896)|0;ei(c[m>>2]|0)|0;c[l>>2]=c[e>>2];c[k+0>>2]=c[l+0>>2];Lm(b,h+20|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function Lm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];a=sr(d,a,f,g,4)|0;if(!(c[f>>2]&4)){if((a|0)<69)a=a+2e3|0;else a=(a+-69|0)>>>0<31?a+1900|0:a;c[b>>2]=a+-1900}i=h;return}function Mm(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;$=i;i=i+176|0;_=$+160|0;Z=$+156|0;aa=$+152|0;v=$+148|0;G=$+144|0;W=$+140|0;X=$+136|0;Y=$+132|0;P=$+128|0;Q=$+124|0;R=$+120|0;o=$+116|0;n=$+112|0;m=$+108|0;l=$+104|0;p=$+100|0;q=$+96|0;r=$+92|0;s=$+88|0;t=$+84|0;u=$+80|0;w=$+76|0;x=$+72|0;y=$+68|0;z=$+64|0;A=$+60|0;B=$+56|0;C=$+52|0;D=$+48|0;E=$+44|0;F=$+40|0;H=$+36|0;I=$+32|0;J=$+28|0;K=$+24|0;T=$+20|0;U=$+16|0;V=$+12|0;L=$+8|0;M=$+4|0;N=$;c[h>>2]=0;hj(aa,g);O=Zo(aa,1077896)|0;ei(c[aa>>2]|0)|0;do switch(k<<24>>24|0){case 82:{c[B>>2]=c[e>>2];c[C>>2]=c[f>>2];c[Z+0>>2]=c[B+0>>2];c[_+0>>2]=c[C+0>>2];Am(A,d,Z,_,g,h,j,1077104,1077124|0);c[e>>2]=c[A>>2];S=32;break}case 104:case 66:case 98:{c[G>>2]=c[f>>2];c[_+0>>2]=c[G+0>>2];Jm(d,j+16|0,e,_,h,O);S=32;break}case 112:{c[w>>2]=c[f>>2];c[_+0>>2]=c[w+0>>2];Um(d,j+8|0,e,_,h,O);S=32;break}case 77:{c[t>>2]=c[f>>2];c[_+0>>2]=c[t+0>>2];Sm(d,j+4|0,e,_,h,O);S=32;break}case 37:{c[N>>2]=c[f>>2];c[_+0>>2]=c[N+0>>2];Ym(d,e,_,h,O);S=32;break}case 83:{c[D>>2]=c[f>>2];c[_+0>>2]=c[D+0>>2];Vm(d,j,e,_,h,O);S=32;break}case 120:{Y=c[(c[d>>2]|0)+20>>2]|0;c[J>>2]=c[e>>2];c[K>>2]=c[f>>2];c[Z+0>>2]=c[J+0>>2];c[_+0>>2]=c[K+0>>2];ac[Y&63](b,d,Z,_,g,h,j);break}case 89:{c[M>>2]=c[f>>2];c[_+0>>2]=c[M+0>>2];Xm(d,j+20|0,e,_,h,O);S=32;break}case 72:{c[p>>2]=c[f>>2];c[_+0>>2]=c[p+0>>2];Om(d,j+8|0,e,_,h,O);S=32;break}case 106:{c[r>>2]=c[f>>2];c[_+0>>2]=c[r+0>>2];Qm(d,j+28|0,e,_,h,O);S=32;break}case 99:{o=d+8|0;o=fc[c[(c[o>>2]|0)+12>>2]&127](o)|0;c[X>>2]=c[e>>2];c[Y>>2]=c[f>>2];l=a[o>>0]|0;if(!(l&1)){n=o+4|0;m=(l&255)>>>1;l=o+4|0}else{l=c[o+8>>2]|0;n=l;m=c[o+4>>2]|0}c[Z+0>>2]=c[X+0>>2];c[_+0>>2]=c[Y+0>>2];Am(W,d,Z,_,g,h,j,l,n+(m<<2)|0);c[e>>2]=c[W>>2];S=32;break}case 70:{c[m>>2]=c[e>>2];c[l>>2]=c[f>>2];c[Z+0>>2]=c[m+0>>2];c[_+0>>2]=c[l+0>>2];Am(n,d,Z,_,g,h,j,1077024,1077056|0);c[e>>2]=c[n>>2];S=32;break}case 109:{c[s>>2]=c[f>>2];c[_+0>>2]=c[s+0>>2];Rm(d,j+16|0,e,_,h,O);S=32;break}case 73:{c[q>>2]=c[f>>2];c[_+0>>2]=c[q+0>>2];Pm(d,j+8|0,e,_,h,O);S=32;break}case 119:{c[I>>2]=c[f>>2];c[_+0>>2]=c[I+0>>2];Wm(d,j+24|0,e,_,h,O);S=32;break}case 114:{c[y>>2]=c[e>>2];c[z>>2]=c[f>>2];c[Z+0>>2]=c[y+0>>2];c[_+0>>2]=c[z+0>>2];Am(x,d,Z,_,g,h,j,1077056,1077100|0);c[e>>2]=c[x>>2];S=32;break}case 84:{c[F>>2]=c[e>>2];c[H>>2]=c[f>>2];c[Z+0>>2]=c[F+0>>2];c[_+0>>2]=c[H+0>>2];Am(E,d,Z,_,g,h,j,1077128,1077160|0);c[e>>2]=c[E>>2];S=32;break}case 68:{c[R>>2]=c[e>>2];c[o>>2]=c[f>>2];c[Z+0>>2]=c[R+0>>2];c[_+0>>2]=c[o+0>>2];Am(Q,d,Z,_,g,h,j,1076992,1077024|0);c[e>>2]=c[Q>>2];S=32;break}case 88:{n=d+8|0;n=fc[c[(c[n>>2]|0)+24>>2]&127](n)|0;c[U>>2]=c[e>>2];c[V>>2]=c[f>>2];l=a[n>>0]|0;if(!(l&1)){o=n+4|0;m=(l&255)>>>1;l=n+4|0}else{l=c[n+8>>2]|0;o=l;m=c[n+4>>2]|0}c[Z+0>>2]=c[U+0>>2];c[_+0>>2]=c[V+0>>2];Am(T,d,Z,_,g,h,j,l,o+(m<<2)|0);c[e>>2]=c[T>>2];S=32;break}case 101:case 100:{c[P>>2]=c[f>>2];c[_+0>>2]=c[P+0>>2];Nm(d,j+12|0,e,_,h,O);S=32;break}case 65:case 97:{c[v>>2]=c[f>>2];c[_+0>>2]=c[v+0>>2];Hm(d,j+24|0,e,_,h,O);S=32;break}case 116:case 110:{c[u>>2]=c[f>>2];c[_+0>>2]=c[u+0>>2];Tm(d,e,_,h,O);S=32;break}case 121:{c[L>>2]=c[f>>2];c[_+0>>2]=c[L+0>>2];Lm(d,j+20|0,e,_,h,O);S=32;break}default:{c[h>>2]=c[h>>2]|4;S=32}}while(0);if((S|0)==32)c[b>>2]=c[e>>2];i=$;return}function Nm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=sr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)>0&(d|0)<32)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function Om(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=sr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<24)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function Pm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=sr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)>0&(d|0)<13)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function Qm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=sr(d,a,f,g,3)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<366)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function Rm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=sr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<13)c[b>>2]=d+-1;else c[f>>2]=a|4;i=h;return}function Sm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=sr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<60)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function Tm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a:while(1){a=c[b>>2]|0;do if(a){g=c[a+12>>2]|0;if((g|0)==(c[a+16>>2]|0))a=fc[c[(c[a>>2]|0)+36>>2]&127](a)|0;else a=c[g>>2]|0;if((a|0)==-1){c[b>>2]=0;a=1;break}else{a=(c[b>>2]|0)==0;break}}else a=1;while(0);h=c[d>>2]|0;do if(h){g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))g=fc[c[(c[h>>2]|0)+36>>2]&127](h)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(a)break;else break a;else{c[d>>2]=0;i=15;break}}else i=15;while(0);if((i|0)==15){i=0;if(a){h=0;break}else h=0}g=c[b>>2]|0;a=c[g+12>>2]|0;if((a|0)==(c[g+16>>2]|0))a=fc[c[(c[g>>2]|0)+36>>2]&127](g)|0;else a=c[a>>2]|0;if(!($b[c[(c[f>>2]|0)+12>>2]&31](f,8192,a)|0))break;g=c[b>>2]|0;a=g+12|0;h=c[a>>2]|0;if((h|0)==(c[g+16>>2]|0)){fc[c[(c[g>>2]|0)+40>>2]&127](g)|0;continue}else{c[a>>2]=h+4;continue}}g=c[b>>2]|0;do if(g){a=c[g+12>>2]|0;if((a|0)==(c[g+16>>2]|0))a=fc[c[(c[g>>2]|0)+36>>2]&127](g)|0;else a=c[a>>2]|0;if((a|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);do if(h){a=c[h+12>>2]|0;if((a|0)==(c[h+16>>2]|0))a=fc[c[(c[h>>2]|0)+36>>2]&127](h)|0;else a=c[a>>2]|0;if((a|0)!=-1)if(g)break;else{i=39;break}else{c[d>>2]=0;i=37;break}}else i=37;while(0);if((i|0)==37?g:0)i=39;if((i|0)==39)c[e>>2]=c[e>>2]|2;return}function Um(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;k=n+4|0;l=n;m=b+8|0;m=fc[c[(c[m>>2]|0)+8>>2]&127](m)|0;b=a[m>>0]|0;if(!(b&1))j=(b&255)>>>1;else j=c[m+4>>2]|0;b=a[m+12>>0]|0;if(!(b&1))b=(b&255)>>>1;else b=c[m+16>>2]|0;do if((j|0)!=(0-b|0)){c[l>>2]=c[f>>2];c[k+0>>2]=c[l+0>>2];j=er(e,k,m,m+24|0,h,g,0)|0;b=c[d>>2]|0;if((j|0)==(m|0)&(b|0)==12){c[d>>2]=0;break}if((j-m|0)==12&(b|0)<12)c[d>>2]=b+12}else c[g>>2]=c[g>>2]|4;while(0);i=n;return}function Vm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=sr(d,a,f,g,2)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<61)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function Wm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];d=sr(d,a,f,g,1)|0;a=c[f>>2]|0;if((a&4|0)==0&(d|0)<7)c[b>>2]=d;else c[f>>2]=a|4;i=h;return}function Xm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;a=h+4|0;j=h;c[j>>2]=c[e>>2];c[a+0>>2]=c[j+0>>2];a=sr(d,a,f,g,4)|0;if(!(c[f>>2]&4))c[b>>2]=a+-1900;i=h;return}function Ym(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;a=c[b>>2]|0;do if(a){g=c[a+12>>2]|0;if((g|0)==(c[a+16>>2]|0))a=fc[c[(c[a>>2]|0)+36>>2]&127](a)|0;else a=c[g>>2]|0;if((a|0)==-1){c[b>>2]=0;a=1;break}else{a=(c[b>>2]|0)==0;break}}else a=1;while(0);h=c[d>>2]|0;do if(h){g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))g=fc[c[(c[h>>2]|0)+36>>2]&127](h)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(a){i=h;j=17;break}else{j=16;break}else{c[d>>2]=0;j=14;break}}else j=14;while(0);if((j|0)==14)if(a)j=16;else{i=0;j=17}a:do if((j|0)==16)c[e>>2]=c[e>>2]|6;else if((j|0)==17){h=c[b>>2]|0;g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))g=fc[c[(c[h>>2]|0)+36>>2]&127](h)|0;else g=c[g>>2]|0;if(($b[c[(c[f>>2]|0)+52>>2]&31](f,g,0)|0)<<24>>24!=37){c[e>>2]=c[e>>2]|4;break}g=c[b>>2]|0;h=g+12|0;a=c[h>>2]|0;if((a|0)==(c[g+16>>2]|0)){fc[c[(c[g>>2]|0)+40>>2]&127](g)|0;g=c[b>>2]|0}else c[h>>2]=a+4;do if(g){a=c[g+12>>2]|0;if((a|0)==(c[g+16>>2]|0))a=fc[c[(c[g>>2]|0)+36>>2]&127](g)|0;else a=c[a>>2]|0;if((a|0)==-1){c[b>>2]=0;h=1;break}else{h=(c[b>>2]|0)==0;break}}else h=1;while(0);do if(i){g=c[i+12>>2]|0;if((g|0)==(c[i+16>>2]|0))a=fc[c[(c[i>>2]|0)+36>>2]&127](i)|0;else a=c[g>>2]|0;if((a|0)!=-1)if(h)break a;else break;else{c[d>>2]=0;j=38;break}}else j=38;while(0);if((j|0)==38?!h:0)break;c[e>>2]=c[e>>2]|2}while(0);return}function Zm(a){a=a|0;var b=0;b=c[a>>2]|0;if((b|0)!=(hl()|0))gb(c[a>>2]|0);return}function _m(a){a=a|0;Zm(a+8|0);return}function $m(a){a=a|0;Zm(a+8|0);xt(a);return}function an(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;m=i;i=i+112|0;l=m+4|0;f=m;c[f>>2]=l+100;bn(d+8|0,l,f,h,j,k);d=c[f>>2]|0;f=c[e>>2]|0;if((l|0)!=(d|0))do{j=a[l>>0]|0;do if(f){g=f+24|0;k=c[g>>2]|0;if((k|0)==(c[f+28>>2]|0)){g=(oc[c[(c[f>>2]|0)+52>>2]&63](f,j&255)|0)==-1;f=g?0:f;break}else{c[g>>2]=k+1;a[k>>0]=j;break}}else f=0;while(0);l=l+1|0}while((l|0)!=(d|0));c[b>>2]=f;i=m;return}function bn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;m=i;i=i+16|0;l=m;a[l>>0]=37;j=l+1|0;a[j>>0]=g;k=l+2|0;a[k>>0]=h;a[l+3>>0]=0;if(h<<24>>24){a[j>>0]=h;a[k>>0]=g}c[e>>2]=d+(Wa(d|0,(c[e>>2]|0)-d|0,l|0,f|0,c[b>>2]|0)|0);i=m;return}function cn(a){a=a|0;Zm(a+8|0);return}function dn(a){a=a|0;Zm(a+8|0);xt(a);return}function en(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0;k=i;i=i+416|0;e=k+8|0;f=k;c[f>>2]=e+400;fn(b+8|0,e,f,g,h,j);g=c[f>>2]|0;f=c[d>>2]|0;if((e|0)!=(g|0)){b=e;do{e=c[b>>2]|0;if(!f)f=0;else{j=f+24|0;h=c[j>>2]|0;if((h|0)==(c[f+28>>2]|0))e=oc[c[(c[f>>2]|0)+52>>2]&63](f,e)|0;else{c[j>>2]=h+4;c[h>>2]=e}f=(e|0)==-1?0:f}b=b+4|0}while((b|0)!=(g|0))}c[a>>2]=f;i=k;return}function fn(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+128|0;l=h+16|0;m=h+12|0;j=h;k=h+8|0;c[m>>2]=l+100;bn(a,l,m,e,f,g);f=j;c[f>>2]=0;c[f+4>>2]=0;c[k>>2]=l;f=(c[d>>2]|0)-b>>2;g=_a(c[a>>2]|0)|0;f=et(b,k,f,j)|0;if(g)_a(g|0)|0;if((f|0)==-1)co(1078784);else{c[d>>2]=b+(f<<2);i=h;return}}function gn(a){a=a|0;return}function hn(a){a=a|0;xt(a);return}function jn(a){a=a|0;return 127}function kn(a){a=a|0;return 127}function ln(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function mn(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function nn(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function on(a,b){a=a|0;b=b|0;xi(a,1,45);return}function pn(a){a=a|0;return 0}function qn(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function rn(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function sn(a){a=a|0;return}function tn(a){a=a|0;xt(a);return}function un(a){a=a|0;return 127}function vn(a){a=a|0;return 127}function wn(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function xn(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function yn(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function zn(a,b){a=a|0;b=b|0;xi(a,1,45);return}function An(a){a=a|0;return 0}function Bn(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Cn(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Dn(a){a=a|0;return}function En(a){a=a|0;xt(a);return}function Fn(a){a=a|0;return 2147483647}function Gn(a){a=a|0;return 2147483647}function Hn(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function In(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function Jn(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function Kn(a,b){a=a|0;b=b|0;Wi(a,1,45);return}function Ln(a){a=a|0;return 0}function Mn(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Nn(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function On(a){a=a|0;return}function Pn(a){a=a|0;xt(a);return}function Qn(a){a=a|0;return 2147483647}function Rn(a){a=a|0;return 2147483647}function Sn(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function Tn(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function Un(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function Vn(a,b){a=a|0;b=b|0;Wi(a,1,45);return}function Wn(a){a=a|0;return 0}function Xn(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Yn(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Zn(a){a=a|0;return}function _n(a){a=a|0;xt(a);return}function $n(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=i;i=i+240|0;q=x;l=x+136|0;v=x+16|0;p=x+12|0;t=x+8|0;m=x+134|0;y=x+4|0;o=x+124|0;r=x+24|0;c[v>>2]=l;u=v+4|0;c[u>>2]=182;hj(t,h);d=Zo(t,1077904)|0;a[m>>0]=0;c[y>>2]=c[f>>2];h=c[h+4>>2]|0;c[q+0>>2]=c[y+0>>2];do if(bo(e,q,g,t,h,j,m,d,v,p,l+100|0)|0){lc[c[(c[d>>2]|0)+32>>2]&7](d,1077520,1077530,o)|0;g=c[p>>2]|0;l=c[v>>2]|0;d=g-l|0;if((d|0)>98){d=tu(d+2|0)|0;if(!d)ou();else{s=d;n=d}}else{s=0;n=r}if(!(a[m>>0]|0))d=n;else{a[n>>0]=45;d=n+1|0}if(l>>>0<g>>>0){m=o+10|0;n=o;do{g=a[l>>0]|0;h=o;while(1){if((a[h>>0]|0)==g<<24>>24)break;h=h+1|0;if((h|0)==(m|0)){h=m;break}}a[d>>0]=a[1077520+(h-n)>>0]|0;l=l+1|0;d=d+1|0}while(l>>>0<(c[p>>2]|0)>>>0)}a[d>>0]=0;c[q>>2]=k;if((jt(r,1077536,q)|0)==1){uu(s);break}else co(1077544)}while(0);h=c[e>>2]|0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0))if((fc[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[e>>2]=0;h=0;break}else{h=c[e>>2]|0;break}}else h=0;while(0);h=(h|0)==0;d=c[f>>2]|0;do if(d){if((c[d+12>>2]|0)!=(c[d+16>>2]|0))if(h)break;else{w=28;break}if((fc[c[(c[d>>2]|0)+36>>2]&127](d)|0)!=-1)if(h)break;else{w=28;break}else{c[f>>2]=0;w=26;break}}else w=26;while(0);if((w|0)==26?h:0)w=28;if((w|0)==28)c[j>>2]=c[j>>2]|2;c[b>>2]=c[e>>2];ei(c[t>>2]|0)|0;h=c[v>>2]|0;c[v>>2]=0;if(h)cc[c[u>>2]&255](h);i=x;return}function ao(a){a=a|0;return}function bo(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;aa=i;i=i+512|0;M=aa+488|0;t=aa+88|0;$=aa+80|0;Q=aa+72|0;P=aa+68|0;R=aa+496|0;N=aa+493|0;S=aa+492|0;W=aa+56|0;_=aa+44|0;Y=aa+32|0;X=aa+20|0;Z=aa+8|0;O=aa+4|0;U=aa;c[M>>2]=p;c[$>>2]=t;V=$+4|0;c[V>>2]=182;c[Q>>2]=t;c[P>>2]=t+400;c[W+0>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;c[_+0>>2]=0;c[_+4>>2]=0;c[_+8>>2]=0;c[Y+0>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=0;c[X+0>>2]=0;c[X+4>>2]=0;c[X+8>>2]=0;c[Z+0>>2]=0;c[Z+4>>2]=0;c[Z+8>>2]=0;fo(g,h,R,N,S,W,_,Y,X,O);c[o>>2]=c[n>>2];H=m+8|0;I=X+4|0;J=X+8|0;K=Y+4|0;L=Y+8|0;x=(j&512|0)!=0;y=_+1|0;z=_+8|0;A=_+4|0;B=Z+1|0;C=Z+8|0;D=Z+4|0;E=R+3|0;F=W+4|0;G=0;s=0;a:while(1){j=c[e>>2]|0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0))if((fc[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1){c[e>>2]=0;j=0;break}else{j=c[e>>2]|0;break}}else j=0;while(0);j=(j|0)==0;r=c[f>>2]|0;do if(r){if((c[r+12>>2]|0)!=(c[r+16>>2]|0))if(j)break;else{T=259;break a}if((fc[c[(c[r>>2]|0)+36>>2]&127](r)|0)!=-1)if(j^(c[f>>2]|0)==0)break;else{T=259;break a}else{c[f>>2]=0;T=12;break}}else T=12;while(0);if((T|0)==12?(T=0,j):0){T=259;break}b:do switch(a[R+G>>0]|0){case 1:{if((G|0)==3){T=259;break a}j=c[e>>2]|0;r=c[j+12>>2]|0;if((r|0)==(c[j+16>>2]|0))j=fc[c[(c[j>>2]|0)+36>>2]&127](j)|0;else j=d[r>>0]|0;if((j&255)<<24>>24<=-1){T=26;break a}if(!(b[(c[H>>2]|0)+(j<<24>>24<<1)>>1]&8192)){T=26;break a}j=c[e>>2]|0;r=j+12|0;q=c[r>>2]|0;if((q|0)==(c[j+16>>2]|0))j=fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;else{c[r>>2]=q+1;j=d[q>>0]|0}Ki(Z,j&255);T=27;break}case 2:{if(!((s|0)!=0|G>>>0<2)){if((G|0)==2)j=(a[E>>0]|0)!=0;else j=0;if(!(x|j)){s=0;break b}}w=a[_>>0]|0;v=(w&1)==0;r=v?y:c[z>>2]|0;c:do if((G|0)!=0?(d[R+(G+-1)>>0]|0)<2:0){q=(w&255)>>>1;p=c[H>>2]|0;h=c[z>>2]|0;m=c[A>>2]|0;while(1){if((r|0)==((v?y:h)+(v?q:m)|0)){u=r;break}j=a[r>>0]|0;if(j<<24>>24<=-1){u=r;break}if(!(b[p+(j<<24>>24<<1)>>1]&8192)){u=r;break}else r=r+1|0}p=u-(v?y:h)|0;m=a[Z>>0]|0;j=(m&1)==0;if(j)r=(m&255)>>>1;else r=c[D>>2]|0;d:do if(p>>>0<=r>>>0){if(j){r=B;q=(m&255)>>>1;j=Z+(((m&255)>>>1)-p)+1|0}else{m=c[C>>2]|0;j=c[D>>2]|0;r=m;q=j;j=m+(j-p)|0}q=r+q|0;if((j|0)==(q|0)){j=w;break c}else r=v?y:h;while(1){if((a[j>>0]|0)!=(a[r>>0]|0))break d;j=j+1|0;if((j|0)==(q|0)){j=w;break c}else r=r+1|0}}while(0);j=w;u=v?y:h}else{j=w;u=r}while(0);e:while(1){if(!(j&1)){r=y;j=(j&255)>>>1}else{r=c[z>>2]|0;j=c[A>>2]|0}if((u|0)==(r+j|0)){r=u;break}j=c[e>>2]|0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0))if((fc[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1){c[e>>2]=0;j=0;break}else{j=c[e>>2]|0;break}}else j=0;while(0);j=(j|0)==0;r=c[f>>2]|0;do if(r){if((c[r+12>>2]|0)!=(c[r+16>>2]|0))if(j)break;else{r=u;break e}if((fc[c[(c[r>>2]|0)+36>>2]&127](r)|0)!=-1)if(j^(c[f>>2]|0)==0)break;else{r=u;break e}else{c[f>>2]=0;T=158;break}}else T=158;while(0);if((T|0)==158?(T=0,j):0){r=u;break}j=c[e>>2]|0;r=c[j+12>>2]|0;if((r|0)==(c[j+16>>2]|0))j=fc[c[(c[j>>2]|0)+36>>2]&127](j)|0;else j=d[r>>0]|0;if((j&255)<<24>>24!=(a[u>>0]|0)){r=u;break}j=c[e>>2]|0;r=j+12|0;q=c[r>>2]|0;if((q|0)==(c[j+16>>2]|0))fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;else c[r>>2]=q+1;j=a[_>>0]|0;u=u+1|0}if(x){j=a[_>>0]|0;if(!(j&1)){q=y;j=(j&255)>>>1}else{q=c[z>>2]|0;j=c[A>>2]|0}if((r|0)!=(q+j|0)){T=173;break a}}break}case 0:{T=27;break}case 3:{h=b[Y>>1]|0;r=h&255;u=(r&1)==0;j=(h&65535)>>>8&255;if(u)p=(h&254)>>>1;else p=c[K>>2]|0;m=b[X>>1]|0;v=m&255;g=(v&1)==0;w=(m&65535)>>>8&255;if(g)q=(m&254)>>>1;else q=c[I>>2]|0;if((p|0)!=(0-q|0)){if(u)q=(h&254)>>>1;else q=c[K>>2]|0;if(q){if(g)q=(m&254)>>>1;else q=c[I>>2]|0;if(q){q=c[e>>2]|0;p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0)){g=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;j=b[Y>>1]|0;r=j&255;j=(j&65535)>>>8&255}else g=d[p>>0]|0;if(r&1)j=a[c[L>>2]>>0]|0;r=c[e>>2]|0;q=r+12|0;p=c[q>>2]|0;m=(p|0)==(c[r+16>>2]|0);if((g&255)<<24>>24==j<<24>>24){if(m)fc[c[(c[r>>2]|0)+40>>2]&127](r)|0;else c[q>>2]=p+1;j=a[Y>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[K>>2]|0;s=j>>>0>1?Y:s;break b}if(m)r=fc[c[(c[r>>2]|0)+36>>2]&127](r)|0;else r=d[p>>0]|0;j=b[X>>1]|0;if(!(j&1))j=(j&65535)>>>8&255;else j=a[c[J>>2]>>0]|0;if((r&255)<<24>>24!=j<<24>>24){T=122;break a}j=c[e>>2]|0;r=j+12|0;q=c[r>>2]|0;if((q|0)==(c[j+16>>2]|0))fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;else c[r>>2]=q+1;a[l>>0]=1;j=a[X>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[I>>2]|0;s=j>>>0>1?X:s;break b}}if(u)q=(h&254)>>>1;else q=c[K>>2]|0;p=c[e>>2]|0;m=c[p+12>>2]|0;g=(m|0)==(c[p+16>>2]|0);if(!q){if(g){q=fc[c[(c[p>>2]|0)+36>>2]&127](p)|0;j=b[X>>1]|0;r=j&255;j=(j&65535)>>>8&255}else{q=d[m>>0]|0;r=v;j=w}if(r&1)j=a[c[J>>2]>>0]|0;if((q&255)<<24>>24!=j<<24>>24)break b;j=c[e>>2]|0;r=j+12|0;q=c[r>>2]|0;if((q|0)==(c[j+16>>2]|0))fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;else c[r>>2]=q+1;a[l>>0]=1;j=a[X>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[I>>2]|0;s=j>>>0>1?X:s;break b}if(g){q=fc[c[(c[p>>2]|0)+36>>2]&127](p)|0;j=b[Y>>1]|0;r=j&255;j=(j&65535)>>>8&255}else q=d[m>>0]|0;if(r&1)j=a[c[L>>2]>>0]|0;if((q&255)<<24>>24!=j<<24>>24){a[l>>0]=1;break b}j=c[e>>2]|0;r=j+12|0;q=c[r>>2]|0;if((q|0)==(c[j+16>>2]|0))fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;else c[r>>2]=q+1;j=a[Y>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[K>>2]|0;s=j>>>0>1?Y:s}break}case 4:{w=a[S>>0]|0;j=0;f:while(1){r=c[e>>2]|0;do if(r){if((c[r+12>>2]|0)==(c[r+16>>2]|0))if((fc[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[e>>2]=0;r=0;break}else{r=c[e>>2]|0;break}}else r=0;while(0);r=(r|0)==0;q=c[f>>2]|0;do if(q){if((c[q+12>>2]|0)!=(c[q+16>>2]|0))if(r)break;else break f;if((fc[c[(c[q>>2]|0)+36>>2]&127](q)|0)!=-1)if(r^(c[f>>2]|0)==0)break;else break f;else{c[f>>2]=0;T=184;break}}else T=184;while(0);if((T|0)==184?(T=0,r):0)break;r=c[e>>2]|0;q=c[r+12>>2]|0;if((q|0)==(c[r+16>>2]|0))r=fc[c[(c[r>>2]|0)+36>>2]&127](r)|0;else r=d[q>>0]|0;q=r&255;if(q<<24>>24>-1?(b[(c[H>>2]|0)+(r<<24>>24<<1)>>1]&2048)!=0:0){r=c[o>>2]|0;if((r|0)==(c[M>>2]|0)){tr(n,o,M);r=c[o>>2]|0}c[o>>2]=r+1;a[r>>0]=q;j=j+1|0}else{r=a[W>>0]|0;if(!(r&1))r=(r&255)>>>1;else r=c[F>>2]|0;if(!((r|0)!=0&(j|0)!=0&q<<24>>24==w<<24>>24))break;if((t|0)==(c[P>>2]|0)){ur($,Q,P);t=c[Q>>2]|0}u=t+4|0;c[Q>>2]=u;c[t>>2]=j;t=u;j=0}r=c[e>>2]|0;q=r+12|0;p=c[q>>2]|0;if((p|0)==(c[r+16>>2]|0)){fc[c[(c[r>>2]|0)+40>>2]&127](r)|0;continue}else{c[q>>2]=p+1;continue}}if((j|0)!=0?(c[$>>2]|0)!=(t|0):0){if((t|0)==(c[P>>2]|0)){ur($,Q,P);t=c[Q>>2]|0}u=t+4|0;c[Q>>2]=u;c[t>>2]=j;t=u}p=c[O>>2]|0;if((p|0)>0){j=c[e>>2]|0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0))if((fc[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1){c[e>>2]=0;j=0;break}else{j=c[e>>2]|0;break}}else j=0;while(0);j=(j|0)==0;r=c[f>>2]|0;do if(r){if((c[r+12>>2]|0)!=(c[r+16>>2]|0))if(j)break;else{T=225;break a}if((fc[c[(c[r>>2]|0)+36>>2]&127](r)|0)!=-1)if(j^(c[f>>2]|0)==0)break;else{T=225;break a}else{c[f>>2]=0;T=219;break}}else T=219;while(0);if((T|0)==219?(T=0,j):0){T=225;break a}j=c[e>>2]|0;r=c[j+12>>2]|0;if((r|0)==(c[j+16>>2]|0))j=fc[c[(c[j>>2]|0)+36>>2]&127](j)|0;else j=d[r>>0]|0;if((j&255)<<24>>24!=(a[N>>0]|0)){T=225;break a}j=c[e>>2]|0;r=j+12|0;q=c[r>>2]|0;if((q|0)==(c[j+16>>2]|0))fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;else c[r>>2]=q+1;do{j=c[e>>2]|0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0))if((fc[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1){c[e>>2]=0;j=0;break}else{j=c[e>>2]|0;break}}else j=0;while(0);j=(j|0)==0;r=c[f>>2]|0;do if(r){if((c[r+12>>2]|0)!=(c[r+16>>2]|0))if(j)break;else{T=246;break a}if((fc[c[(c[r>>2]|0)+36>>2]&127](r)|0)!=-1)if(j^(c[f>>2]|0)==0)break;else{T=246;break a}else{c[f>>2]=0;T=239;break}}else T=239;while(0);if((T|0)==239?(T=0,j):0){T=246;break a}j=c[e>>2]|0;r=c[j+12>>2]|0;if((r|0)==(c[j+16>>2]|0))j=fc[c[(c[j>>2]|0)+36>>2]&127](j)|0;else j=d[r>>0]|0;if((j&255)<<24>>24<=-1){T=246;break a}if(!(b[(c[H>>2]|0)+(j<<24>>24<<1)>>1]&2048)){T=246;break a}if((c[o>>2]|0)==(c[M>>2]|0))tr(n,o,M);j=c[e>>2]|0;r=c[j+12>>2]|0;if((r|0)==(c[j+16>>2]|0))j=fc[c[(c[j>>2]|0)+36>>2]&127](j)|0;else j=d[r>>0]|0;r=c[o>>2]|0;c[o>>2]=r+1;a[r>>0]=j;p=p+-1|0;c[O>>2]=p;j=c[e>>2]|0;r=j+12|0;q=c[r>>2]|0;if((q|0)==(c[j+16>>2]|0))fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;else c[r>>2]=q+1}while((p|0)>0)}if((c[o>>2]|0)==(c[n>>2]|0)){T=257;break a}break}default:{}}while(0);g:do if((T|0)==27){T=0;if((G|0)==3){T=259;break a}while(1){j=c[e>>2]|0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0))if((fc[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1){c[e>>2]=0;j=0;break}else{j=c[e>>2]|0;break}}else j=0;while(0);r=(j|0)==0;j=c[f>>2]|0;do if(j){if((c[j+12>>2]|0)!=(c[j+16>>2]|0))if(r)break;else break g;if((fc[c[(c[j>>2]|0)+36>>2]&127](j)|0)!=-1)if(r^(c[f>>2]|0)==0)break;else break g;else{c[f>>2]=0;T=38;break}}else T=38;while(0);if((T|0)==38?(T=0,r):0)break g;j=c[e>>2]|0;r=c[j+12>>2]|0;if((r|0)==(c[j+16>>2]|0))j=fc[c[(c[j>>2]|0)+36>>2]&127](j)|0;else j=d[r>>0]|0;if((j&255)<<24>>24<=-1)break g;if(!(b[(c[H>>2]|0)+(j<<24>>24<<1)>>1]&8192))break g;j=c[e>>2]|0;r=j+12|0;q=c[r>>2]|0;if((q|0)==(c[j+16>>2]|0))j=fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;else{c[r>>2]=q+1;j=d[q>>0]|0}Ki(Z,j&255)}}while(0);G=G+1|0;if(G>>>0>=4){T=259;break}}h:do if((T|0)==26){c[k>>2]=c[k>>2]|4;g=0}else if((T|0)==122){c[k>>2]=c[k>>2]|4;g=0}else if((T|0)==173){c[k>>2]=c[k>>2]|4;g=0}else if((T|0)==225){c[k>>2]=c[k>>2]|4;g=0}else if((T|0)==246){c[k>>2]=c[k>>2]|4;g=0}else if((T|0)==257){c[k>>2]=c[k>>2]|4;g=0}else if((T|0)==259){i:do if(s){q=s+1|0;r=s+8|0;j=s+4|0;p=1;j:while(1){g=a[s>>0]|0;if(!(g&1))g=(g&255)>>>1;else g=c[j>>2]|0;if(p>>>0>=g>>>0)break i;g=c[e>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0))if((fc[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1){c[e>>2]=0;g=0;break}else{g=c[e>>2]|0;break}}else g=0;while(0);g=(g|0)==0;h=c[f>>2]|0;do if(h){if((c[h+12>>2]|0)!=(c[h+16>>2]|0))if(g)break;else break j;if((fc[c[(c[h>>2]|0)+36>>2]&127](h)|0)!=-1)if(g^(c[f>>2]|0)==0)break;else break j;else{c[f>>2]=0;T=275;break}}else T=275;while(0);if((T|0)==275?(T=0,g):0)break;g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=fc[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=d[h>>0]|0;if(!(a[s>>0]&1))h=q;else h=c[r>>2]|0;if((g&255)<<24>>24!=(a[h+p>>0]|0))break;g=p+1|0;h=c[e>>2]|0;m=h+12|0;p=c[m>>2]|0;if((p|0)==(c[h+16>>2]|0)){fc[c[(c[h>>2]|0)+40>>2]&127](h)|0;p=g;continue}else{c[m>>2]=p+1;p=g;continue}}c[k>>2]=c[k>>2]|4;g=0;break h}while(0);g=c[$>>2]|0;if((g|0)!=(t|0)?(c[U>>2]=0,go(W,g,t,U),(c[U>>2]|0)!=0):0){c[k>>2]=c[k>>2]|4;g=0}else g=1}while(0);Bi(Z);Bi(X);Bi(Y);Bi(_);Bi(W);h=c[$>>2]|0;c[$>>2]=0;if(h)cc[c[V>>2]&255](h);i=aa;return g|0}function co(a){a=a|0;var b=0;b=Oa(8)|0;hi(b,a);Qb(b|0,1086520,163)}function eo(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;s=i;i=i+144|0;u=s+24|0;t=s+32|0;q=s+16|0;m=s+8|0;o=s+4|0;l=s+28|0;v=s;c[q>>2]=t;p=q+4|0;c[p>>2]=182;hj(o,h);d=Zo(o,1077904)|0;a[l>>0]=0;n=c[f>>2]|0;c[v>>2]=n;h=c[h+4>>2]|0;c[u+0>>2]=c[v+0>>2];if(bo(e,u,g,o,h,j,l,d,q,m,t+100|0)|0){if(!(a[k>>0]&1)){a[k+1>>0]=0;a[k>>0]=0}else{a[c[k+8>>2]>>0]=0;c[k+4>>2]=0}if(a[l>>0]|0)Ki(k,oc[c[(c[d>>2]|0)+28>>2]&63](d,45)|0);h=oc[c[(c[d>>2]|0)+28>>2]&63](d,48)|0;d=c[q>>2]|0;m=c[m>>2]|0;g=m+-1|0;a:do if(d>>>0<g>>>0){l=d;while(1){d=l+1|0;if((a[l>>0]|0)!=h<<24>>24){d=l;break a}if(d>>>0<g>>>0)l=d;else break}}while(0);vr(k,d,m)|0}d=c[e>>2]|0;do if(d){if((c[d+12>>2]|0)==(c[d+16>>2]|0))if((fc[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[e>>2]=0;d=0;break}else{d=c[e>>2]|0;break}}else d=0;while(0);d=(d|0)==0;do if(n){if((c[n+12>>2]|0)!=(c[n+16>>2]|0))if(d)break;else{r=23;break}if((fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)!=-1)if(d^(n|0)==0)break;else{r=23;break}else{c[f>>2]=0;r=21;break}}else r=21;while(0);if((r|0)==21?d:0)r=23;if((r|0)==23)c[j>>2]=c[j>>2]|2;c[b>>2]=c[e>>2];ei(c[o>>2]|0)|0;d=c[q>>2]|0;c[q>>2]=0;if(d)cc[c[p>>2]&255](d);i=s;return}function fo(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=i;i=i+112|0;n=x+100|0;o=x+88|0;p=x+76|0;q=x+64|0;r=x+52|0;s=x+48|0;t=x+36|0;u=x+24|0;v=x+12|0;w=x;if(b){b=Zo(d,1077344)|0;dc[c[(c[b>>2]|0)+44>>2]&63](n,b);u=c[n>>2]|0;a[e>>0]=u;a[e+1>>0]=u>>8;a[e+2>>0]=u>>16;a[e+3>>0]=u>>24;dc[c[(c[b>>2]|0)+32>>2]&63](o,b);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Ii(l,0);c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Bi(o);dc[c[(c[b>>2]|0)+28>>2]&63](p,b);if(!(a[k>>0]&1)){a[k+1>>0]=0;a[k>>0]=0}else{a[c[k+8>>2]>>0]=0;c[k+4>>2]=0}Ii(k,0);c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Bi(p);a[f>>0]=fc[c[(c[b>>2]|0)+12>>2]&127](b)|0;a[g>>0]=fc[c[(c[b>>2]|0)+16>>2]&127](b)|0;dc[c[(c[b>>2]|0)+20>>2]&63](q,b);if(!(a[h>>0]&1)){a[h+1>>0]=0;a[h>>0]=0}else{a[c[h+8>>2]>>0]=0;c[h+4>>2]=0}Ii(h,0);c[h+0>>2]=c[q+0>>2];c[h+4>>2]=c[q+4>>2];c[h+8>>2]=c[q+8>>2];c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;Bi(q);dc[c[(c[b>>2]|0)+24>>2]&63](r,b);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Ii(j,0);c[j+0>>2]=c[r+0>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;Bi(r);b=fc[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{b=Zo(d,1077280)|0;dc[c[(c[b>>2]|0)+44>>2]&63](s,b);s=c[s>>2]|0;a[e>>0]=s;a[e+1>>0]=s>>8;a[e+2>>0]=s>>16;a[e+3>>0]=s>>24;dc[c[(c[b>>2]|0)+32>>2]&63](t,b);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Ii(l,0);c[l+0>>2]=c[t+0>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;Bi(t);dc[c[(c[b>>2]|0)+28>>2]&63](u,b);if(!(a[k>>0]&1)){a[k+1>>0]=0;a[k>>0]=0}else{a[c[k+8>>2]>>0]=0;c[k+4>>2]=0}Ii(k,0);c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];c[k+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Bi(u);a[f>>0]=fc[c[(c[b>>2]|0)+12>>2]&127](b)|0;a[g>>0]=fc[c[(c[b>>2]|0)+16>>2]&127](b)|0;dc[c[(c[b>>2]|0)+20>>2]&63](v,b);if(!(a[h>>0]&1)){a[h+1>>0]=0;a[h>>0]=0}else{a[c[h+8>>2]>>0]=0;c[h+4>>2]=0}Ii(h,0);c[h+0>>2]=c[v+0>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;Bi(v);dc[c[(c[b>>2]|0)+24>>2]&63](w,b);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Ii(j,0);c[j+0>>2]=c[w+0>>2];c[j+4>>2]=c[w+4>>2];c[j+8>>2]=c[w+8>>2];c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;Bi(w);b=fc[c[(c[b>>2]|0)+36>>2]&127](b)|0}c[m>>2]=b;i=x;return}function go(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;h=a[b>>0]|0;if(!(h&1))g=(h&255)>>>1;else g=c[b+4>>2]|0;a:do if(g){if((d|0)!=(e|0)?(i=e+-4|0,i>>>0>d>>>0):0){g=d;h=e;while(1){j=c[g>>2]|0;c[g>>2]=c[i>>2];c[i>>2]=j;g=g+4|0;h=h+-8|0;if(g>>>0>=h>>>0)break;else{j=i;i=h;h=j}}h=a[b>>0]|0}if(!(h&1)){j=b+1|0;i=(h&255)>>>1}else{j=c[b+8>>2]|0;i=c[b+4>>2]|0}e=e+-4|0;h=a[j>>0]|0;g=h<<24>>24<1|h<<24>>24==127;b:do if(e>>>0>d>>>0){b=j+i|0;i=d;while(1){if(!g?(h<<24>>24|0)!=(c[i>>2]|0):0)break;j=(b-j|0)>1?j+1|0:j;i=i+4|0;h=a[j>>0]|0;g=h<<24>>24<1|h<<24>>24==127;if(i>>>0>=e>>>0)break b}c[f>>2]=4;break a}while(0);if(!g?((c[e>>2]|0)+-1|0)>>>0>=h<<24>>24>>>0:0)c[f>>2]=4}while(0);return}function ho(a){a=a|0;return}function io(a){a=a|0;xt(a);return}function jo(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=i;i=i+576|0;q=x;n=x+72|0;v=x+64|0;p=x+56|0;t=x+52|0;m=x+572|0;y=x+48|0;o=x+8|0;r=x+472|0;c[v>>2]=n;u=v+4|0;c[u>>2]=182;hj(t,h);d=Zo(t,1077896)|0;a[m>>0]=0;c[y>>2]=c[f>>2];h=c[h+4>>2]|0;c[q+0>>2]=c[y+0>>2];do if(ko(e,q,g,t,h,j,m,d,v,p,n+400|0)|0){lc[c[(c[d>>2]|0)+48>>2]&7](d,1077600,1077610,o)|0;h=c[p>>2]|0;g=c[v>>2]|0;d=h-g|0;if((d|0)>392){d=tu((d>>2)+2|0)|0;if(!d)ou();else{s=d;l=d}}else{s=0;l=r}if(a[m>>0]|0){a[l>>0]=45;l=l+1|0}if(g>>>0<h>>>0){m=o+40|0;n=o;h=g;do{g=c[h>>2]|0;d=o;while(1){if((c[d>>2]|0)==(g|0))break;d=d+4|0;if((d|0)==(m|0)){d=m;break}}a[l>>0]=a[1077600+(d-n>>2)>>0]|0;h=h+4|0;l=l+1|0}while(h>>>0<(c[p>>2]|0)>>>0)}a[l>>0]=0;c[q>>2]=k;if((jt(r,1077536,q)|0)==1){uu(s);break}else co(1077544)}while(0);g=c[e>>2]|0;do if(g){d=c[g+12>>2]|0;if((d|0)==(c[g+16>>2]|0))g=fc[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=c[d>>2]|0;if((g|0)==-1){c[e>>2]=0;l=1;break}else{l=(c[e>>2]|0)==0;break}}else l=1;while(0);d=c[f>>2]|0;do if(d){g=c[d+12>>2]|0;if((g|0)==(c[d+16>>2]|0))g=fc[c[(c[d>>2]|0)+36>>2]&127](d)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(l)break;else{w=31;break}else{c[f>>2]=0;w=29;break}}else w=29;while(0);if((w|0)==29?l:0)w=31;if((w|0)==31)c[j>>2]=c[j>>2]|2;c[b>>2]=c[e>>2];ei(c[t>>2]|0)|0;g=c[v>>2]|0;c[v>>2]=0;if(g)cc[c[u>>2]&255](g);i=x;return}function ko(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;X=i;i=i+512|0;H=X+496|0;s=X+96|0;W=X+88|0;L=X+80|0;K=X+76|0;M=X+500|0;I=X+72|0;N=X+68|0;R=X+56|0;V=X+44|0;T=X+32|0;S=X+20|0;U=X+8|0;J=X+4|0;P=X;c[H>>2]=o;c[W>>2]=s;Q=W+4|0;c[Q>>2]=182;c[L>>2]=s;c[K>>2]=s+400;c[R+0>>2]=0;c[R+4>>2]=0;c[R+8>>2]=0;c[V+0>>2]=0;c[V+4>>2]=0;c[V+8>>2]=0;c[T+0>>2]=0;c[T+4>>2]=0;c[T+8>>2]=0;c[S+0>>2]=0;c[S+4>>2]=0;c[S+8>>2]=0;c[U+0>>2]=0;c[U+4>>2]=0;c[U+8>>2]=0;mo(f,g,M,I,N,R,V,T,S,J);c[n>>2]=c[m>>2];D=S+4|0;E=S+8|0;F=T+4|0;G=T+8|0;B=(h&512|0)!=0;v=V+4|0;w=V+8|0;x=U+4|0;y=U+8|0;z=M+3|0;A=R+4|0;C=0;r=0;a:while(1){q=c[b>>2]|0;do if(q){p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)==-1){c[b>>2]=0;o=1;break}else{o=(c[b>>2]|0)==0;break}}else o=1;while(0);q=c[e>>2]|0;do if(q){p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)!=-1)if(o^(c[e>>2]|0)==0)break;else{O=267;break a}else{c[e>>2]=0;O=15;break}}else O=15;while(0);if((O|0)==15?(O=0,o):0){O=267;break}b:do switch(a[M+C>>0]|0){case 2:{if(!((r|0)!=0|C>>>0<2)){if((C|0)==2)q=(a[z>>0]|0)!=0;else q=0;if(!(B|q)){r=0;break b}}p=a[V>>0]|0;q=(p&1)==0?v:c[w>>2]|0;c:do if((C|0)!=0?(d[M+(C+-1)>>0]|0)<2:0){while(1){if(!(p&1)){o=v;f=(p&255)>>>1}else{o=c[w>>2]|0;f=c[v>>2]|0}if((q|0)==(o+(f<<2)|0))break;if(!($b[c[(c[l>>2]|0)+12>>2]&31](l,8192,c[q>>2]|0)|0)){O=129;break}p=a[V>>0]|0;q=q+4|0}if((O|0)==129){O=0;p=a[V>>0]|0}u=(p&1)==0;h=q-(u?v:c[w>>2]|0)>>2;t=a[U>>0]|0;o=(t&1)==0;if(o)f=(t&255)>>>1;else f=c[x>>2]|0;d:do if(h>>>0<=f>>>0){if(o){f=x;g=(t&255)>>>1;o=x+(((t&255)>>>1)-h<<2)|0}else{t=c[y>>2]|0;o=c[x>>2]|0;f=t;g=o;o=t+(o-h<<2)|0}g=f+(g<<2)|0;if((o|0)==(g|0)){u=q;break c}else f=u?v:c[w>>2]|0;while(1){if((c[o>>2]|0)!=(c[f>>2]|0))break d;o=o+4|0;if((o|0)==(g|0)){u=q;break c}else f=f+4|0}}while(0);u=u?v:c[w>>2]|0}else u=q;while(0);e:while(1){if(!(p&1)){o=v;q=(p&255)>>>1}else{o=c[w>>2]|0;q=c[v>>2]|0}if((u|0)==(o+(q<<2)|0)){p=u;break}q=c[b>>2]|0;do if(q){p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)==-1){c[b>>2]=0;o=1;break}else{o=(c[b>>2]|0)==0;break}}else o=1;while(0);q=c[e>>2]|0;do if(q){p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)!=-1)if(o^(c[e>>2]|0)==0)break;else{p=u;break e}else{c[e>>2]=0;O=159;break}}else O=159;while(0);if((O|0)==159?(O=0,o):0){p=u;break}q=c[b>>2]|0;p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)!=(c[u>>2]|0)){p=u;break}q=c[b>>2]|0;p=q+12|0;o=c[p>>2]|0;if((o|0)==(c[q+16>>2]|0))fc[c[(c[q>>2]|0)+40>>2]&127](q)|0;else c[p>>2]=o+4;p=a[V>>0]|0;u=u+4|0}if(B){q=a[V>>0]|0;if(!(q&1)){o=v;q=(q&255)>>>1}else{o=c[w>>2]|0;q=c[v>>2]|0}if((p|0)!=(o+(q<<2)|0)){O=174;break a}}break}case 1:{if((C|0)==3){O=267;break a}q=c[b>>2]|0;p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if(!($b[c[(c[l>>2]|0)+12>>2]&31](l,8192,q)|0)){O=28;break a}q=c[b>>2]|0;p=q+12|0;o=c[p>>2]|0;if((o|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+40>>2]&127](q)|0;else{c[p>>2]=o+4;q=c[o>>2]|0}aj(U,q);O=29;break}case 4:{u=c[N>>2]|0;q=0;f:while(1){p=c[b>>2]|0;do if(p){o=c[p+12>>2]|0;if((o|0)==(c[p+16>>2]|0))p=fc[c[(c[p>>2]|0)+36>>2]&127](p)|0;else p=c[o>>2]|0;if((p|0)==-1){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);p=c[e>>2]|0;do if(p){o=c[p+12>>2]|0;if((o|0)==(c[p+16>>2]|0))p=fc[c[(c[p>>2]|0)+36>>2]&127](p)|0;else p=c[o>>2]|0;if((p|0)!=-1)if(f^(c[e>>2]|0)==0)break;else break f;else{c[e>>2]=0;O=188;break}}else O=188;while(0);if((O|0)==188?(O=0,f):0)break;p=c[b>>2]|0;o=c[p+12>>2]|0;if((o|0)==(c[p+16>>2]|0))o=fc[c[(c[p>>2]|0)+36>>2]&127](p)|0;else o=c[o>>2]|0;if($b[c[(c[l>>2]|0)+12>>2]&31](l,2048,o)|0){p=c[n>>2]|0;if((p|0)==(c[H>>2]|0)){wr(m,n,H);p=c[n>>2]|0}c[n>>2]=p+4;c[p>>2]=o;q=q+1|0}else{p=a[R>>0]|0;if(!(p&1))p=(p&255)>>>1;else p=c[A>>2]|0;if(!((p|0)!=0&(q|0)!=0&(o|0)==(u|0)))break;if((s|0)==(c[K>>2]|0)){ur(W,L,K);s=c[L>>2]|0}h=s+4|0;c[L>>2]=h;c[s>>2]=q;s=h;q=0}p=c[b>>2]|0;o=p+12|0;f=c[o>>2]|0;if((f|0)==(c[p+16>>2]|0)){fc[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[o>>2]=f+4;continue}}if((q|0)!=0?(c[W>>2]|0)!=(s|0):0){if((s|0)==(c[K>>2]|0)){ur(W,L,K);s=c[L>>2]|0}h=s+4|0;c[L>>2]=h;c[s>>2]=q;s=h}u=c[J>>2]|0;if((u|0)>0){q=c[b>>2]|0;do if(q){p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)==-1){c[b>>2]=0;o=1;break}else{o=(c[b>>2]|0)==0;break}}else o=1;while(0);q=c[e>>2]|0;do if(q){p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)!=-1)if(o^(c[e>>2]|0)==0)break;else{O=231;break a}else{c[e>>2]=0;O=225;break}}else O=225;while(0);if((O|0)==225?(O=0,o):0){O=231;break a}q=c[b>>2]|0;p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)!=(c[I>>2]|0)){O=231;break a}q=c[b>>2]|0;p=q+12|0;o=c[p>>2]|0;if((o|0)==(c[q+16>>2]|0))fc[c[(c[q>>2]|0)+40>>2]&127](q)|0;else c[p>>2]=o+4;do{q=c[b>>2]|0;do if(q){p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)==-1){c[b>>2]=0;o=1;break}else{o=(c[b>>2]|0)==0;break}}else o=1;while(0);q=c[e>>2]|0;do if(q){p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)!=-1)if(o^(c[e>>2]|0)==0)break;else{O=254;break a}else{c[e>>2]=0;O=248;break}}else O=248;while(0);if((O|0)==248?(O=0,o):0){O=254;break a}q=c[b>>2]|0;p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if(!($b[c[(c[l>>2]|0)+12>>2]&31](l,2048,q)|0)){O=254;break a}if((c[n>>2]|0)==(c[H>>2]|0))wr(m,n,H);q=c[b>>2]|0;p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;p=c[n>>2]|0;c[n>>2]=p+4;c[p>>2]=q;u=u+-1|0;c[J>>2]=u;q=c[b>>2]|0;p=q+12|0;o=c[p>>2]|0;if((o|0)==(c[q+16>>2]|0))fc[c[(c[q>>2]|0)+40>>2]&127](q)|0;else c[p>>2]=o+4}while((u|0)>0)}if((c[n>>2]|0)==(c[m>>2]|0)){O=265;break a}break}case 3:{q=a[T>>0]|0;g=(q&1)==0;if(g)o=(q&255)>>>1;else o=c[F>>2]|0;t=a[S>>0]|0;f=(t&1)==0;if(f)p=(t&255)>>>1;else p=c[D>>2]|0;if((o|0)!=(0-p|0)){if(g)p=(q&255)>>>1;else p=c[F>>2]|0;if(p){if(f)p=(t&255)>>>1;else p=c[D>>2]|0;if(p){p=c[b>>2]|0;o=c[p+12>>2]|0;if((o|0)==(c[p+16>>2]|0)){h=fc[c[(c[p>>2]|0)+36>>2]&127](p)|0;q=a[T>>0]|0}else h=c[o>>2]|0;p=c[b>>2]|0;o=p+12|0;f=c[o>>2]|0;g=(f|0)==(c[p+16>>2]|0);if((h|0)==(c[((q&1)==0?F:c[G>>2]|0)>>2]|0)){if(g)fc[c[(c[p>>2]|0)+40>>2]&127](p)|0;else c[o>>2]=f+4;q=a[T>>0]|0;if(!(q&1))q=(q&255)>>>1;else q=c[F>>2]|0;r=q>>>0>1?T:r;break b}if(g)q=fc[c[(c[p>>2]|0)+36>>2]&127](p)|0;else q=c[f>>2]|0;if((q|0)!=(c[((a[S>>0]&1)==0?D:c[E>>2]|0)>>2]|0)){O=117;break a}q=c[b>>2]|0;p=q+12|0;o=c[p>>2]|0;if((o|0)==(c[q+16>>2]|0))fc[c[(c[q>>2]|0)+40>>2]&127](q)|0;else c[p>>2]=o+4;a[k>>0]=1;q=a[S>>0]|0;if(!(q&1))q=(q&255)>>>1;else q=c[D>>2]|0;r=q>>>0>1?S:r;break b}}if(g)p=(q&255)>>>1;else p=c[F>>2]|0;o=c[b>>2]|0;f=c[o+12>>2]|0;g=(f|0)==(c[o+16>>2]|0);if(!p){if(g){p=fc[c[(c[o>>2]|0)+36>>2]&127](o)|0;q=a[S>>0]|0}else{p=c[f>>2]|0;q=t}if((p|0)!=(c[((q&1)==0?D:c[E>>2]|0)>>2]|0))break b;q=c[b>>2]|0;p=q+12|0;o=c[p>>2]|0;if((o|0)==(c[q+16>>2]|0))fc[c[(c[q>>2]|0)+40>>2]&127](q)|0;else c[p>>2]=o+4;a[k>>0]=1;q=a[S>>0]|0;if(!(q&1))q=(q&255)>>>1;else q=c[D>>2]|0;r=q>>>0>1?S:r;break b}if(g){p=fc[c[(c[o>>2]|0)+36>>2]&127](o)|0;q=a[T>>0]|0}else p=c[f>>2]|0;if((p|0)!=(c[((q&1)==0?F:c[G>>2]|0)>>2]|0)){a[k>>0]=1;break b}q=c[b>>2]|0;p=q+12|0;o=c[p>>2]|0;if((o|0)==(c[q+16>>2]|0))fc[c[(c[q>>2]|0)+40>>2]&127](q)|0;else c[p>>2]=o+4;q=a[T>>0]|0;if(!(q&1))q=(q&255)>>>1;else q=c[F>>2]|0;r=q>>>0>1?T:r}break}case 0:{O=29;break}default:{}}while(0);g:do if((O|0)==29){O=0;if((C|0)==3){O=267;break a}while(1){q=c[b>>2]|0;do if(q){p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)==-1){c[b>>2]=0;o=1;break}else{o=(c[b>>2]|0)==0;break}}else o=1;while(0);q=c[e>>2]|0;do if(q){p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if((q|0)!=-1)if(o^(c[e>>2]|0)==0)break;else break g;else{c[e>>2]=0;O=43;break}}else O=43;while(0);if((O|0)==43?(O=0,o):0)break g;q=c[b>>2]|0;p=c[q+12>>2]|0;if((p|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+36>>2]&127](q)|0;else q=c[p>>2]|0;if(!($b[c[(c[l>>2]|0)+12>>2]&31](l,8192,q)|0))break g;q=c[b>>2]|0;p=q+12|0;o=c[p>>2]|0;if((o|0)==(c[q+16>>2]|0))q=fc[c[(c[q>>2]|0)+40>>2]&127](q)|0;else{c[p>>2]=o+4;q=c[o>>2]|0}aj(U,q)}}while(0);C=C+1|0;if(C>>>0>=4){O=267;break}}h:do if((O|0)==28){c[j>>2]=c[j>>2]|4;g=0}else if((O|0)==117){c[j>>2]=c[j>>2]|4;g=0}else if((O|0)==174){c[j>>2]=c[j>>2]|4;g=0}else if((O|0)==231){c[j>>2]=c[j>>2]|4;g=0}else if((O|0)==254){c[j>>2]=c[j>>2]|4;g=0}else if((O|0)==265){c[j>>2]=c[j>>2]|4;g=0}else if((O|0)==267){i:do if(r){p=r+4|0;q=r+8|0;f=1;j:while(1){g=a[r>>0]|0;if(!(g&1))g=(g&255)>>>1;else g=c[p>>2]|0;if(f>>>0>=g>>>0)break i;g=c[b>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=fc[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=c[h>>2]|0;if((g|0)==-1){c[b>>2]=0;o=1;break}else{o=(c[b>>2]|0)==0;break}}else o=1;while(0);g=c[e>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=fc[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=c[h>>2]|0;if((g|0)!=-1)if(o^(c[e>>2]|0)==0)break;else break j;else{c[e>>2]=0;O=286;break}}else O=286;while(0);if((O|0)==286?(O=0,o):0)break;g=c[b>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=fc[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=c[h>>2]|0;if(!(a[r>>0]&1))h=p;else h=c[q>>2]|0;if((g|0)!=(c[h+(f<<2)>>2]|0))break;g=f+1|0;h=c[b>>2]|0;f=h+12|0;o=c[f>>2]|0;if((o|0)==(c[h+16>>2]|0)){fc[c[(c[h>>2]|0)+40>>2]&127](h)|0;f=g;continue}else{c[f>>2]=o+4;f=g;continue}}c[j>>2]=c[j>>2]|4;g=0;break h}while(0);g=c[W>>2]|0;if((g|0)!=(s|0)?(c[P>>2]=0,go(R,g,s,P),(c[P>>2]|0)!=0):0){c[j>>2]=c[j>>2]|4;g=0}else g=1}while(0);Yi(U);Yi(S);Yi(T);Yi(V);Bi(R);h=c[W>>2]|0;c[W>>2]=0;if(h)cc[c[Q>>2]&255](h);i=X;return g|0}function lo(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;s=i;i=i+432|0;u=s+424|0;t=s+24|0;q=s+16|0;d=s+8|0;o=s+4|0;l=s+428|0;v=s;c[q>>2]=t;p=q+4|0;c[p>>2]=182;hj(o,h);m=Zo(o,1077896)|0;a[l>>0]=0;n=c[f>>2]|0;c[v>>2]=n;h=c[h+4>>2]|0;c[u+0>>2]=c[v+0>>2];if(ko(e,u,g,o,h,j,l,m,q,d,t+400|0)|0){if(!(a[k>>0]&1))a[k>>0]=0;else c[c[k+8>>2]>>2]=0;c[k+4>>2]=0;if(a[l>>0]|0)aj(k,oc[c[(c[m>>2]|0)+44>>2]&63](m,45)|0);h=oc[c[(c[m>>2]|0)+44>>2]&63](m,48)|0;m=c[q>>2]|0;g=c[d>>2]|0;d=g+-4|0;a:do if(m>>>0<d>>>0)while(1){l=m+4|0;if((c[m>>2]|0)!=(h|0))break a;if(l>>>0<d>>>0)m=l;else{m=l;break}}while(0);xr(k,m,g)|0}d=c[e>>2]|0;do if(d){l=c[d+12>>2]|0;if((l|0)==(c[d+16>>2]|0))d=fc[c[(c[d>>2]|0)+36>>2]&127](d)|0;else d=c[l>>2]|0;if((d|0)==-1){c[e>>2]=0;m=1;break}else{m=(c[e>>2]|0)==0;break}}else m=1;while(0);do if(n){l=c[n+12>>2]|0;if((l|0)==(c[n+16>>2]|0))d=fc[c[(c[n>>2]|0)+36>>2]&127](n)|0;else d=c[l>>2]|0;if((d|0)!=-1)if(m)break;else{r=26;break}else{c[f>>2]=0;r=24;break}}else r=24;while(0);if((r|0)==24?m:0)r=26;if((r|0)==26)c[j>>2]=c[j>>2]|2;c[b>>2]=c[e>>2];ei(c[o>>2]|0)|0;d=c[q>>2]|0;c[q>>2]=0;if(d)cc[c[p>>2]&255](d);i=s;return}function mo(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=i;i=i+112|0;n=x+100|0;o=x+88|0;p=x+76|0;q=x+64|0;r=x+52|0;s=x+48|0;t=x+36|0;u=x+24|0;v=x+12|0;w=x;if(b){b=Zo(d,1077472)|0;dc[c[(c[b>>2]|0)+44>>2]&63](n,b);u=c[n>>2]|0;a[e>>0]=u;a[e+1>>0]=u>>8;a[e+2>>0]=u>>16;a[e+3>>0]=u>>24;dc[c[(c[b>>2]|0)+32>>2]&63](o,b);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;$i(l,0);c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Yi(o);dc[c[(c[b>>2]|0)+28>>2]&63](p,b);if(!(a[k>>0]&1))a[k>>0]=0;else c[c[k+8>>2]>>2]=0;c[k+4>>2]=0;$i(k,0);c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Yi(p);c[f>>2]=fc[c[(c[b>>2]|0)+12>>2]&127](b)|0;c[g>>2]=fc[c[(c[b>>2]|0)+16>>2]&127](b)|0;dc[c[(c[b>>2]|0)+20>>2]&63](q,b);if(!(a[h>>0]&1)){a[h+1>>0]=0;a[h>>0]=0}else{a[c[h+8>>2]>>0]=0;c[h+4>>2]=0}Ii(h,0);c[h+0>>2]=c[q+0>>2];c[h+4>>2]=c[q+4>>2];c[h+8>>2]=c[q+8>>2];c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;Bi(q);dc[c[(c[b>>2]|0)+24>>2]&63](r,b);if(!(a[j>>0]&1))a[j>>0]=0;else c[c[j+8>>2]>>2]=0;c[j+4>>2]=0;$i(j,0);c[j+0>>2]=c[r+0>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;Yi(r);b=fc[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{b=Zo(d,1077408)|0;dc[c[(c[b>>2]|0)+44>>2]&63](s,b);s=c[s>>2]|0;a[e>>0]=s;a[e+1>>0]=s>>8;a[e+2>>0]=s>>16;a[e+3>>0]=s>>24;dc[c[(c[b>>2]|0)+32>>2]&63](t,b);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;$i(l,0);c[l+0>>2]=c[t+0>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;Yi(t);dc[c[(c[b>>2]|0)+28>>2]&63](u,b);if(!(a[k>>0]&1))a[k>>0]=0;else c[c[k+8>>2]>>2]=0;c[k+4>>2]=0;$i(k,0);c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];c[k+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Yi(u);c[f>>2]=fc[c[(c[b>>2]|0)+12>>2]&127](b)|0;c[g>>2]=fc[c[(c[b>>2]|0)+16>>2]&127](b)|0;dc[c[(c[b>>2]|0)+20>>2]&63](v,b);if(!(a[h>>0]&1)){a[h+1>>0]=0;a[h>>0]=0}else{a[c[h+8>>2]>>0]=0;c[h+4>>2]=0}Ii(h,0);c[h+0>>2]=c[v+0>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;Bi(v);dc[c[(c[b>>2]|0)+24>>2]&63](w,b);if(!(a[j>>0]&1))a[j>>0]=0;else c[c[j+8>>2]>>2]=0;c[j+4>>2]=0;$i(j,0);c[j+0>>2]=c[w+0>>2];c[j+4>>2]=c[w+4>>2];c[j+8>>2]=c[w+8>>2];c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;Yi(w);b=fc[c[(c[b>>2]|0)+36>>2]&127](b)|0}c[m>>2]=b;i=x;return}function no(a){a=a|0;return}function oo(a){a=a|0;xt(a);return}function po(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;C=i;i=i+384|0;r=C;d=C+276|0;o=C+64|0;n=C+176|0;v=C+60|0;y=C+172|0;t=C+169|0;B=C+168|0;u=C+48|0;A=C+36|0;z=C+24|0;p=C+20|0;q=C+68|0;x=C+16|0;w=C+12|0;s=C+8|0;c[o>>2]=d;h[k>>3]=l;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];d=Uu(d,100,1077656,r)|0;if(d>>>0>99){d=hl()|0;h[k>>3]=l;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];d=pr(o,d,1077656,r)|0;m=c[o>>2]|0;if(!m)ou();n=tu(d)|0;if(!n)ou();else{E=n;F=m;G=n;I=d}}else{E=0;F=0;G=n;I=d}hj(v,g);n=Zo(v,1077904)|0;d=c[o>>2]|0;lc[c[(c[n>>2]|0)+32>>2]&7](n,d,d+I|0,G)|0;if(!I)o=0;else o=(a[c[o>>2]>>0]|0)==45;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;qo(f,o,v,y,t,B,u,A,z,p);f=c[p>>2]|0;if((I|0)>(f|0)){d=a[z>>0]|0;if(!(d&1))m=(d&255)>>>1;else m=c[z+4>>2]|0;d=a[A>>0]|0;if(!(d&1))d=(d&255)>>>1;else d=c[A+4>>2]|0;d=m+(I-f<<1|1)+d|0}else{d=a[z>>0]|0;if(!(d&1))m=(d&255)>>>1;else m=c[z+4>>2]|0;d=a[A>>0]|0;if(!(d&1))d=(d&255)>>>1;else d=c[A+4>>2]|0;d=m+2+d|0}d=d+f|0;if(d>>>0>100){d=tu(d)|0;if(!d)ou();else{D=d;H=d}}else{D=0;H=q}ro(H,x,w,c[g+4>>2]|0,G,G+I|0,n,o,y,a[t>>0]|0,a[B>>0]|0,u,A,z,f);c[s>>2]=c[e>>2];y=c[x>>2]|0;B=c[w>>2]|0;c[r+0>>2]=c[s+0>>2];Fc(b,r,H,y,B,g,j);uu(D);Bi(z);Bi(A);Bi(u);ei(c[v>>2]|0)|0;uu(E);uu(F);i=C;return}function qo(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=i;i=i+112|0;n=z+108|0;o=z+96|0;r=z+92|0;s=z+80|0;t=z+68|0;u=z+56|0;v=z+52|0;w=z+40|0;x=z+36|0;y=z+24|0;p=z+12|0;q=z;if(b){e=Zo(e,1077344)|0;b=c[e>>2]|0;if(d){dc[c[b+44>>2]&63](n,e);d=c[n>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;dc[c[(c[e>>2]|0)+32>>2]&63](o,e);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Ii(l,0);c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Bi(o)}else{dc[c[b+40>>2]&63](r,e);d=c[r>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;dc[c[(c[e>>2]|0)+28>>2]&63](s,e);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Ii(l,0);c[l+0>>2]=c[s+0>>2];c[l+4>>2]=c[s+4>>2];c[l+8>>2]=c[s+8>>2];c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;Bi(s)}a[g>>0]=fc[c[(c[e>>2]|0)+12>>2]&127](e)|0;a[h>>0]=fc[c[(c[e>>2]|0)+16>>2]&127](e)|0;dc[c[(c[e>>2]|0)+20>>2]&63](t,e);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Ii(j,0);c[j+0>>2]=c[t+0>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;Bi(t);dc[c[(c[e>>2]|0)+24>>2]&63](u,e);if(!(a[k>>0]&1)){a[k+1>>0]=0;a[k>>0]=0}else{a[c[k+8>>2]>>0]=0;c[k+4>>2]=0}Ii(k,0);c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];c[k+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Bi(u);e=fc[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{b=Zo(e,1077280)|0;e=c[b>>2]|0;if(d){dc[c[e+44>>2]&63](v,b);d=c[v>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;dc[c[(c[b>>2]|0)+32>>2]&63](w,b);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Ii(l,0);c[l+0>>2]=c[w+0>>2];c[l+4>>2]=c[w+4>>2];c[l+8>>2]=c[w+8>>2];c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;Bi(w)}else{dc[c[e+40>>2]&63](x,b);d=c[x>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;dc[c[(c[b>>2]|0)+28>>2]&63](y,b);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Ii(l,0);c[l+0>>2]=c[y+0>>2];c[l+4>>2]=c[y+4>>2];c[l+8>>2]=c[y+8>>2];c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;Bi(y)}a[g>>0]=fc[c[(c[b>>2]|0)+12>>2]&127](b)|0;a[h>>0]=fc[c[(c[b>>2]|0)+16>>2]&127](b)|0;dc[c[(c[b>>2]|0)+20>>2]&63](p,b);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Ii(j,0);c[j+0>>2]=c[p+0>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Bi(p);dc[c[(c[b>>2]|0)+24>>2]&63](q,b);if(!(a[k>>0]&1)){a[k+1>>0]=0;a[k>>0]=0}else{a[c[k+8>>2]>>0]=0;c[k+4>>2]=0}Ii(k,0);c[k+0>>2]=c[q+0>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;Bi(q);e=fc[c[(c[b>>2]|0)+36>>2]&127](b)|0}c[m>>2]=e;i=z;return}function ro(d,e,f,g,h,i,j,k,l,m,n,o,p,q,r){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;c[f>>2]=d;t=q+1|0;O=q+8|0;P=q+4|0;H=(g&512|0)==0;I=p+1|0;J=p+8|0;K=p+4|0;L=(r|0)>0;M=o+1|0;C=o+8|0;D=o+4|0;E=j+8|0;F=0-r|0;B=0;do{switch(a[l+B>>0]|0){case 2:{v=a[p>>0]|0;u=(v&1)==0;if(u)s=(v&255)>>>1;else s=c[K>>2]|0;if(!((s|0)==0|H)){if(u){w=I;u=(v&255)>>>1}else{w=c[J>>2]|0;u=c[K>>2]|0}x=w+u|0;u=c[f>>2]|0;if((w|0)!=(x|0)){v=w;do{a[u>>0]=a[v>>0]|0;v=v+1|0;u=u+1|0}while((v|0)!=(x|0))}c[f>>2]=u}break}case 4:{v=c[f>>2]|0;h=k?h+1|0:h;a:do if(h>>>0<i>>>0){u=c[E>>2]|0;x=h;while(1){w=a[x>>0]|0;if(w<<24>>24<=-1){s=x;break a}s=x+1|0;if(!(b[u+(w<<24>>24<<1)>>1]&2048)){s=x;break a}if(s>>>0<i>>>0)x=s;else break}}else s=h;while(0);u=s;if(L){if(s>>>0>h>>>0){A=h-u|0;A=A>>>0<F>>>0?F:A;x=A+r|0;z=v;w=s;u=r;while(1){y=w+-1|0;w=a[y>>0]|0;c[f>>2]=z+1;a[z>>0]=w;u=u+-1|0;w=(u|0)>0;if(!(y>>>0>h>>>0&w))break;z=c[f>>2]|0;w=y}s=s+A|0;if(w)N=31;else A=0}else{x=r;N=31}if((N|0)==31){N=0;A=oc[c[(c[j>>2]|0)+28>>2]&63](j,48)|0}u=c[f>>2]|0;c[f>>2]=u+1;if((x|0)>0)do{a[u>>0]=A;x=x+-1|0;u=c[f>>2]|0;c[f>>2]=u+1}while((x|0)>0);a[u>>0]=m}if((s|0)==(h|0)){u=oc[c[(c[j>>2]|0)+28>>2]&63](j,48)|0;s=c[f>>2]|0;c[f>>2]=s+1;a[s>>0]=u}else{u=a[o>>0]|0;x=(u&1)==0;if(x)u=(u&255)>>>1;else u=c[D>>2]|0;if(!u){y=-1;x=0;w=0}else{y=a[(x?M:c[C>>2]|0)>>0]|0;x=0;w=0}while(1){if((w|0)==(y|0)){u=c[f>>2]|0;c[f>>2]=u+1;a[u>>0]=n;u=x+1|0;x=a[o>>0]|0;w=(x&1)==0;if(w)x=(x&255)>>>1;else x=c[D>>2]|0;if(u>>>0<x>>>0)if((a[(w?M:c[C>>2]|0)+u>>0]|0)==127){y=-1;x=u;w=0}else{y=a[(w?M:c[C>>2]|0)+u>>0]|0;x=u;w=0}else{x=u;w=0}}s=s+-1|0;z=a[s>>0]|0;u=c[f>>2]|0;c[f>>2]=u+1;a[u>>0]=z;if((s|0)==(h|0))break;else w=w+1|0}}u=c[f>>2]|0;if((v|0)!=(u|0)?(G=u+-1|0,G>>>0>v>>>0):0){s=G;while(1){w=a[v>>0]|0;a[v>>0]=a[s>>0]|0;a[s>>0]=w;v=v+1|0;u=u+-2|0;if(v>>>0>=u>>>0)break;else{w=s;s=u;u=w}}}break}case 1:{c[e>>2]=c[f>>2];u=oc[c[(c[j>>2]|0)+28>>2]&63](j,32)|0;s=c[f>>2]|0;c[f>>2]=s+1;a[s>>0]=u;break}case 3:{u=a[q>>0]|0;s=(u&1)==0;if(s)u=(u&255)>>>1;else u=c[P>>2]|0;if(u){u=a[(s?t:c[O>>2]|0)>>0]|0;s=c[f>>2]|0;c[f>>2]=s+1;a[s>>0]=u}break}case 0:{c[e>>2]=c[f>>2];break}default:{}}B=B+1|0}while((B|0)!=4);h=a[q>>0]|0;s=(h&1)==0;if(s)u=(h&255)>>>1;else u=c[P>>2]|0;if(u>>>0>1){if(s)s=(h&255)>>>1;else{t=c[O>>2]|0;s=c[P>>2]|0}u=t+1|0;h=t+s|0;s=c[f>>2]|0;if((u|0)!=(h|0))while(1){a[s>>0]=a[u>>0]|0;t=t+2|0;s=s+1|0;if((t|0)==(h|0))break;else{M=u;u=t;t=M}}c[f>>2]=s}s=g&176;if((s|0)==32)c[e>>2]=c[f>>2];else if((s|0)!=16)c[e>>2]=d;return}function so(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;B=i;i=i+176|0;p=B+56|0;u=B+52|0;x=B+164|0;s=B+161|0;A=B+160|0;t=B+40|0;z=B+28|0;y=B+16|0;l=B+12|0;o=B+60|0;w=B+8|0;v=B+4|0;q=B;hj(u,g);r=Zo(u,1077904)|0;d=a[j>>0]|0;k=(d&1)==0;if(k)d=(d&255)>>>1;else d=c[j+4>>2]|0;if(!d)n=0;else{if(k)d=j+1|0;else d=c[j+8>>2]|0;n=a[d>>0]|0;n=n<<24>>24==(oc[c[(c[r>>2]|0)+28>>2]&63](r,45)|0)<<24>>24};c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;qo(f,n,u,x,s,A,t,z,y,l);m=a[j>>0]|0;k=(m&1)==0;if(k)d=(m&255)>>>1;else d=c[j+4>>2]|0;l=c[l>>2]|0;if((d|0)>(l|0)){if(k)f=(m&255)>>>1;else f=c[j+4>>2]|0;k=a[y>>0]|0;if(!(k&1))d=(k&255)>>>1;else d=c[y+4>>2]|0;k=a[z>>0]|0;if(!(k&1))k=(k&255)>>>1;else k=c[z+4>>2]|0;d=d+(f-l<<1|1)+k|0}else{d=a[y>>0]|0;if(!(d&1))d=(d&255)>>>1;else d=c[y+4>>2]|0;k=a[z>>0]|0;if(!(k&1))k=(k&255)>>>1;else k=c[z+4>>2]|0;d=d+2+k|0}d=d+l|0;if(d>>>0>100){d=tu(d)|0;if(!d)ou();else{C=d;D=d}}else{C=0;D=o}if(!(m&1)){k=j+1|0;d=(m&255)>>>1}else{k=c[j+8>>2]|0;d=c[j+4>>2]|0}ro(D,w,v,c[g+4>>2]|0,k,k+d|0,r,n,x,a[s>>0]|0,a[A>>0]|0,t,z,y,l);c[q>>2]=c[e>>2];x=c[w>>2]|0;A=c[v>>2]|0;c[p+0>>2]=c[q+0>>2];Fc(b,p,D,x,A,g,h);uu(C);Bi(y);Bi(z);Bi(t);ei(c[u>>2]|0)|0;i=B;return}function to(a){a=a|0;return}function uo(a){a=a|0;xt(a);return}function vo(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;C=i;i=i+992|0;r=C;d=C+888|0;o=C+880|0;n=C+480|0;v=C+472|0;y=C+884|0;t=C+468|0;B=C+464|0;u=C+452|0;A=C+440|0;z=C+428|0;p=C+424|0;q=C+24|0;x=C+16|0;w=C+12|0;s=C+8|0;c[o>>2]=d;h[k>>3]=l;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];d=Uu(d,100,1077656,r)|0;if(d>>>0>99){d=hl()|0;h[k>>3]=l;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];d=pr(o,d,1077656,r)|0;m=c[o>>2]|0;if(!m)ou();n=tu(d<<2)|0;if(!n)ou();else{E=n;F=m;G=n;I=d}}else{E=0;F=0;G=n;I=d}hj(v,g);n=Zo(v,1077896)|0;d=c[o>>2]|0;lc[c[(c[n>>2]|0)+48>>2]&7](n,d,d+I|0,G)|0;if(!I)o=0;else o=(a[c[o>>2]>>0]|0)==45;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;wo(f,o,v,y,t,B,u,A,z,p);f=c[p>>2]|0;if((I|0)>(f|0)){d=a[z>>0]|0;if(!(d&1))m=(d&255)>>>1;else m=c[z+4>>2]|0;d=a[A>>0]|0;if(!(d&1))d=(d&255)>>>1;else d=c[A+4>>2]|0;d=m+(I-f<<1|1)+d|0}else{d=a[z>>0]|0;if(!(d&1))m=(d&255)>>>1;else m=c[z+4>>2]|0;d=a[A>>0]|0;if(!(d&1))d=(d&255)>>>1;else d=c[A+4>>2]|0;d=m+2+d|0}d=d+f|0;if(d>>>0>100){d=tu(d<<2)|0;if(!d)ou();else{D=d;H=d}}else{D=0;H=q}xo(H,x,w,c[g+4>>2]|0,G,G+(I<<2)|0,n,o,y,c[t>>2]|0,c[B>>2]|0,u,A,z,f);c[s>>2]=c[e>>2];y=c[x>>2]|0;B=c[w>>2]|0;c[r+0>>2]=c[s+0>>2];qr(b,r,H,y,B,g,j);if(D)uu(D);Yi(z);Yi(A);Bi(u);ei(c[v>>2]|0)|0;if(E)uu(E);uu(F);i=C;return}function wo(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=i;i=i+112|0;n=z+108|0;o=z+96|0;r=z+92|0;s=z+80|0;t=z+68|0;u=z+56|0;v=z+52|0;w=z+40|0;x=z+36|0;y=z+24|0;p=z+12|0;q=z;if(b){e=Zo(e,1077472)|0;b=c[e>>2]|0;if(d){dc[c[b+44>>2]&63](n,e);d=c[n>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;dc[c[(c[e>>2]|0)+32>>2]&63](o,e);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;$i(l,0);c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Yi(o)}else{dc[c[b+40>>2]&63](r,e);d=c[r>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;dc[c[(c[e>>2]|0)+28>>2]&63](s,e);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;$i(l,0);c[l+0>>2]=c[s+0>>2];c[l+4>>2]=c[s+4>>2];c[l+8>>2]=c[s+8>>2];c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;Yi(s)}c[g>>2]=fc[c[(c[e>>2]|0)+12>>2]&127](e)|0;c[h>>2]=fc[c[(c[e>>2]|0)+16>>2]&127](e)|0;dc[c[(c[e>>2]|0)+20>>2]&63](t,e);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Ii(j,0);c[j+0>>2]=c[t+0>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;Bi(t);dc[c[(c[e>>2]|0)+24>>2]&63](u,e);if(!(a[k>>0]&1))a[k>>0]=0;else c[c[k+8>>2]>>2]=0;c[k+4>>2]=0;$i(k,0);c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];c[k+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Yi(u);e=fc[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{b=Zo(e,1077408)|0;e=c[b>>2]|0;if(d){dc[c[e+44>>2]&63](v,b);d=c[v>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;dc[c[(c[b>>2]|0)+32>>2]&63](w,b);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;$i(l,0);c[l+0>>2]=c[w+0>>2];c[l+4>>2]=c[w+4>>2];c[l+8>>2]=c[w+8>>2];c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;Yi(w)}else{dc[c[e+40>>2]&63](x,b);d=c[x>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;dc[c[(c[b>>2]|0)+28>>2]&63](y,b);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;$i(l,0);c[l+0>>2]=c[y+0>>2];c[l+4>>2]=c[y+4>>2];c[l+8>>2]=c[y+8>>2];c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;Yi(y)}c[g>>2]=fc[c[(c[b>>2]|0)+12>>2]&127](b)|0;c[h>>2]=fc[c[(c[b>>2]|0)+16>>2]&127](b)|0;dc[c[(c[b>>2]|0)+20>>2]&63](p,b);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Ii(j,0);c[j+0>>2]=c[p+0>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Bi(p);dc[c[(c[b>>2]|0)+24>>2]&63](q,b);if(!(a[k>>0]&1))a[k>>0]=0;else c[c[k+8>>2]>>2]=0;c[k+4>>2]=0;$i(k,0);c[k+0>>2]=c[q+0>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;Yi(q);e=fc[c[(c[b>>2]|0)+36>>2]&127](b)|0}c[m>>2]=e;i=z;return}function xo(b,d,e,f,g,h,i,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;c[e>>2]=b;J=p+4|0;I=p+8|0;A=(f&512|0)==0;B=o+4|0;C=o+8|0;D=(q|0)>0;E=n+1|0;F=n+8|0;G=n+4|0;z=0;do{switch(a[k+z>>0]|0){case 1:{c[d>>2]=c[e>>2];s=oc[c[(c[i>>2]|0)+44>>2]&63](i,32)|0;r=c[e>>2]|0;c[e>>2]=r+4;c[r>>2]=s;break}case 4:{u=c[e>>2]|0;g=j?g+4|0:g;a:do if(g>>>0<h>>>0){v=g;while(1){w=v+4|0;if(!($b[c[(c[i>>2]|0)+12>>2]&31](i,2048,c[v>>2]|0)|0)){w=v;break a}if(w>>>0<h>>>0)v=w;else break}}else w=g;while(0);if(D){if(w>>>0>g>>>0){t=c[e>>2]|0;s=q;do{w=w+-4|0;v=t;t=t+4|0;c[v>>2]=c[w>>2];s=s+-1|0;v=(s|0)>0}while(w>>>0>g>>>0&v);c[e>>2]=t;if(v)H=31;else{v=c[e>>2]|0;c[e>>2]=v+4}}else{s=q;H=31}if((H|0)==31){H=0;y=oc[c[(c[i>>2]|0)+44>>2]&63](i,48)|0;v=c[e>>2]|0;t=v+4|0;c[e>>2]=t;if((s|0)>0){r=v;x=s;while(1){c[r>>2]=y;x=x+-1|0;if((x|0)<=0)break;else{K=t;t=r+8|0;r=K}}c[e>>2]=v+(s+1<<2);v=v+(s<<2)|0}}c[v>>2]=l}if((w|0)==(g|0)){r=oc[c[(c[i>>2]|0)+44>>2]&63](i,48)|0;v=c[e>>2]|0;w=v+4|0;c[e>>2]=w;c[v>>2]=r}else{v=a[n>>0]|0;t=(v&1)==0;if(t)v=(v&255)>>>1;else v=c[G>>2]|0;if(!v){s=w;t=-1;y=0;x=0}else{s=w;t=a[(t?E:c[F>>2]|0)>>0]|0;y=0;x=0}while(1){w=c[e>>2]|0;if((x|0)==(t|0)){v=w+4|0;c[e>>2]=v;c[w>>2]=m;y=y+1|0;w=a[n>>0]|0;x=(w&1)==0;if(x)w=(w&255)>>>1;else w=c[G>>2]|0;if(y>>>0<w>>>0)if((a[(x?E:c[F>>2]|0)+y>>0]|0)==127){t=-1;x=0}else{t=a[(x?E:c[F>>2]|0)+y>>0]|0;x=0}else x=0}else v=w;s=s+-4|0;r=c[s>>2]|0;w=v+4|0;c[e>>2]=w;c[v>>2]=r;if((s|0)==(g|0))break;else x=x+1|0}}if((u|0)!=(w|0)&v>>>0>u>>>0)while(1){r=c[u>>2]|0;c[u>>2]=c[v>>2];c[v>>2]=r;u=u+4|0;w=w+-8|0;if(u>>>0>=w>>>0)break;else{r=v;v=w;w=r}}break}case 3:{w=a[p>>0]|0;v=(w&1)==0;if(v)w=(w&255)>>>1;else w=c[J>>2]|0;if(w){s=c[(v?J:c[I>>2]|0)>>2]|0;r=c[e>>2]|0;c[e>>2]=r+4;c[r>>2]=s}break}case 0:{c[d>>2]=c[e>>2];break}case 2:{u=a[o>>0]|0;w=(u&1)==0;if(w)v=(u&255)>>>1;else v=c[B>>2]|0;if(!((v|0)==0|A)){if(w){r=B;v=(u&255)>>>1}else{r=c[C>>2]|0;v=c[B>>2]|0}s=r+(v<<2)|0;w=c[e>>2]|0;if((r|0)!=(s|0)){t=(r+(v+-1<<2)-r|0)>>>2;u=w;v=r;while(1){c[u>>2]=c[v>>2];v=v+4|0;if((v|0)==(s|0))break;else u=u+4|0}w=w+(t+1<<2)|0}c[e>>2]=w}break}default:{}}z=z+1|0}while((z|0)!=4);t=a[p>>0]|0;r=(t&1)==0;if(r)s=(t&255)>>>1;else s=c[J>>2]|0;if(s>>>0>1){if(r){w=J;s=(t&255)>>>1}else{w=c[I>>2]|0;s=c[J>>2]|0}t=w+4|0;g=w+(s<<2)|0;r=c[e>>2]|0;if((t|0)!=(g|0)){v=(w+(s+-1<<2)-t|0)>>>2;u=r;s=t;t=w;while(1){c[u>>2]=c[s>>2];t=t+8|0;if((t|0)==(g|0))break;else{n=s;u=u+4|0;s=t;t=n}}r=r+(v+1<<2)|0}c[e>>2]=r}r=f&176;if((r|0)==32)c[d>>2]=c[e>>2];else if((r|0)!=16)c[d>>2]=b;return}function yo(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;B=i;i=i+480|0;p=B+468|0;u=B+464|0;x=B+472|0;s=B+460|0;A=B+456|0;t=B+444|0;z=B+432|0;y=B+420|0;l=B+416|0;o=B+16|0;w=B+8|0;v=B+4|0;q=B;hj(u,g);r=Zo(u,1077896)|0;d=a[j>>0]|0;k=(d&1)==0;if(k)d=(d&255)>>>1;else d=c[j+4>>2]|0;if(!d)n=0;else{if(k)d=j+4|0;else d=c[j+8>>2]|0;n=c[d>>2]|0;n=(n|0)==(oc[c[(c[r>>2]|0)+44>>2]&63](r,45)|0)};c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;wo(f,n,u,x,s,A,t,z,y,l);m=a[j>>0]|0;k=(m&1)==0;if(k)d=(m&255)>>>1;else d=c[j+4>>2]|0;l=c[l>>2]|0;if((d|0)>(l|0)){if(k)f=(m&255)>>>1;else f=c[j+4>>2]|0;k=a[y>>0]|0;if(!(k&1))d=(k&255)>>>1;else d=c[y+4>>2]|0;k=a[z>>0]|0;if(!(k&1))k=(k&255)>>>1;else k=c[z+4>>2]|0;d=d+(f-l<<1|1)+k|0}else{d=a[y>>0]|0;if(!(d&1))d=(d&255)>>>1;else d=c[y+4>>2]|0;k=a[z>>0]|0;if(!(k&1))k=(k&255)>>>1;else k=c[z+4>>2]|0;d=d+2+k|0}d=d+l|0;if(d>>>0>100){d=tu(d<<2)|0;if(!d)ou();else{C=d;D=d}}else{C=0;D=o}if(!(m&1)){k=j+4|0;d=(m&255)>>>1}else{k=c[j+8>>2]|0;d=c[j+4>>2]|0}xo(D,w,v,c[g+4>>2]|0,k,k+(d<<2)|0,r,n,x,c[s>>2]|0,c[A>>2]|0,t,z,y,l);c[q>>2]=c[e>>2];x=c[w>>2]|0;A=c[v>>2]|0;c[p+0>>2]=c[q+0>>2];qr(b,p,D,x,A,g,h);if(C)uu(C);Yi(y);Yi(z);Bi(t);ei(c[u>>2]|0)|0;i=B;return}function zo(a){a=a|0;return}function Ao(a){a=a|0;xt(a);return}function Bo(b,d,e){b=b|0;d=d|0;e=e|0;if(!(a[d>>0]&1))e=d+1|0;else e=c[d+8>>2]|0;e=Wb(e|0,1)|0;return e>>>((e|0)!=(-1|0)&1)|0}function Co(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;m=n;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;d=a[h>>0]|0;if(!(d&1)){k=h+1|0;j=(d&255)>>>1;d=h+1|0}else{d=c[h+8>>2]|0;k=d;j=c[h+4>>2]|0}j=k+j|0;if(d>>>0<j>>>0){do{Ki(m,a[d>>0]|0);d=d+1|0}while((d|0)!=(j|0));d=(e|0)==-1?-1:e<<1;if(!(a[m>>0]&1))l=9;else j=c[m+8>>2]|0}else{d=(e|0)==-1?-1:e<<1;l=9}if((l|0)==9)j=m+1|0;j=$a(d|0,f|0,g|0,j|0)|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;l=lv(j|0)|0;d=j+l|0;if((l|0)>0)do{Ki(b,a[j>>0]|0);j=j+1|0}while((j|0)!=(d|0));Bi(m);i=n;return}function Do(a,b){a=a|0;b=b|0;Ob(((b|0)==-1?-1:b<<1)|0)|0;return}function Eo(a){a=a|0;return}function Fo(a){a=a|0;xt(a);return}function Go(b,d,e){b=b|0;d=d|0;e=e|0;if(!(a[d>>0]&1))e=d+1|0;else e=c[d+8>>2]|0;e=Wb(e|0,1)|0;return e>>>((e|0)!=(-1|0)&1)|0}function Ho(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;t=i;i=i+176|0;q=t+168|0;p=t+40|0;o=t+32|0;s=t+28|0;r=t+16|0;m=t+8|0;n=t;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[m+4>>2]=0;c[m>>2]=1079560;j=a[h>>0]|0;if(!(j&1)){k=h+4|0;d=(j&255)>>>1;j=h+4|0}else{j=c[h+8>>2]|0;k=j;d=c[h+4>>2]|0}h=k+(d<<2)|0;a:do if(j>>>0<h>>>0){l=p+32|0;d=1079560|0;while(1){c[s>>2]=j;k=(kc[c[d+12>>2]&15](m,q,j,h,s,p,l,o)|0)==2;d=c[s>>2]|0;if(k|(d|0)==(j|0))break;if(p>>>0<(c[o>>2]|0)>>>0){j=p;do{Ki(r,a[j>>0]|0);j=j+1|0}while(j>>>0<(c[o>>2]|0)>>>0);j=c[s>>2]|0}else j=d;if(j>>>0>=h>>>0)break a;d=c[m>>2]|0}co(1078784)}while(0);if(!(a[r>>0]&1))d=r+1|0;else d=c[r+8>>2]|0;d=$a(((e|0)==-1?-1:e<<1)|0,f|0,g|0,d|0)|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[n+4>>2]=0;c[n>>2]=1079664;f=lv(d|0)|0;k=d+f|0;b:do if((f|0)>0){l=k;h=p+128|0;j=1079664|0;while(1){c[s>>2]=d;f=(kc[c[j+16>>2]&15](n,q,d,(l-d|0)>32?d+32|0:k,s,p,h,o)|0)==2;j=c[s>>2]|0;if(f|(j|0)==(d|0))break;if(p>>>0<(c[o>>2]|0)>>>0){d=p;do{aj(b,c[d>>2]|0);d=d+4|0}while(d>>>0<(c[o>>2]|0)>>>0);d=c[s>>2]|0}else d=j;if(d>>>0>=k>>>0)break b;j=c[n>>2]|0}co(1078784)}while(0);Bi(r);i=t;return}function Io(a,b){a=a|0;b=b|0;Ob(((b|0)==-1?-1:b<<1)|0)|0;return}function Jo(a){a=a|0;a=Oa(8)|0;fi(a,1077784);c[a>>2]=1086376;Qb(a|0,1086416,161)}function Ko(a){a=a|0;a=Oa(8)|0;fi(a,1077784);c[a>>2]=1086440;Qb(a|0,1086480,161)}function Lo(b,d){b=b|0;d=d|0;var e=0,f=0;c[b+4>>2]=d+-1;c[b>>2]=1077824;d=b+8|0;yr(d,28);vi(b+144|0,1077808,1);d=c[d>>2]|0;e=b+12|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);c[270679]=0;c[270678]=1076272;zr(b,1082712);c[270677]=0;c[270676]=1076312;Ar(b,1082704);c[270673]=0;c[270672]=1077920;c[270674]=0;a[1082700]=0;c[270674]=dp()|0;Br(b,1082688);c[270671]=0;c[270670]=1078880;Cr(b,1082680);c[270669]=0;c[270668]=1079096;Dr(b,1082672);Jp(1082656,1);Er(b,1082656);c[270663]=0;c[270662]=1079320;Fr(b,1082648);c[270661]=0;c[270660]=1079440;Gr(b,1082640);c[270655]=0;c[270654]=1078072;a[1082624]=46;a[1082625]=44;c[270657]=0;c[270658]=0;c[270659]=0;Hr(b,1082616);c[270647]=0;c[270646]=1078112;c[270648]=46;c[270649]=44;c[270650]=0;c[270651]=0;c[270652]=0;Ir(b,1082584);c[270645]=0;c[270644]=1076352;Jr(b,1082576);c[270643]=0;c[270642]=1076472;Kr(b,1082568);c[270641]=0;c[270640]=1076544;Lr(b,1082560);c[270639]=0;c[270638]=1076640;Mr(b,1082552);c[270637]=0;c[270636]=1077232;Nr(b,1082544);c[270635]=0;c[270634]=1077296;Or(b,1082536);c[270633]=0;c[270632]=1077360;Pr(b,1082528);c[270631]=0;c[270630]=1077424;Qr(b,1082520);c[270629]=0;c[270628]=1077488;Rr(b,1082512);c[270627]=0;c[270626]=1077568;Sr(b,1082504);c[270625]=0;c[270624]=1077624;Tr(b,1082496);c[270623]=0;c[270622]=1077672;Ur(b,1082488);c[270619]=0;c[270618]=1076720;c[270620]=1076768;Vr(b,1082472);c[270615]=0;c[270614]=1076872;c[270616]=1076920;Wr(b,1082456);c[270611]=0;c[270610]=1078816;c[270612]=hl()|0;c[270610]=1077168;Xr(b,1082440);c[270607]=0;c[270606]=1078816;c[270608]=hl()|0;c[270606]=1077200;Yr(b,1082424);c[270605]=0;c[270604]=1077712;Zr(b,1082416);c[270603]=0;c[270602]=1077752;_r(b,1082408);return}function Mo(){if((a[1077856]|0)==0?(Ia(1077856)|0)!=0:0){Ro()|0;c[269462]=1077840;Sa(1077856)}return c[269462]|0}function No(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;di(b);f=a+8|0;e=c[f>>2]|0;if((c[a+12>>2]|0)-e>>2>>>0<=d>>>0){as(f,d+1|0);e=c[f>>2]|0}a=c[e+(d<<2)>>2]|0;if(a){ei(a)|0;e=c[f>>2]|0}c[e+(d<<2)>>2]=b;return}function Oo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;c[a>>2]=1077824;g=a+8|0;h=a+12|0;b=c[h>>2]|0;d=c[g>>2]|0;if((b|0)!=(d|0)){f=0;do{e=c[d+(f<<2)>>2]|0;if(e){ei(e)|0;b=c[h>>2]|0;d=c[g>>2]|0}f=f+1|0}while(f>>>0<b-d>>2>>>0)}Bi(a+144|0);$r(g);return}function Po(a){a=a|0;Oo(a);xt(a);return}function Qo(a,b){a=a|0;b=b|0;if(bs(a,b)|0)return c[(c[a+8>>2]|0)+(b<<2)>>2]|0;else{b=Oa(4)|0;Qt(b);Qb(b|0,1086616,167)}return 0}function Ro(){Lo(1082248,1);c[269460]=1082248;return 1077840}function So(){var a=0;a=c[(Mo()|0)>>2]|0;c[269466]=a;di(a);return 1077864}function To(){if((a[1077880]|0)==0?(Ia(1077880)|0)!=0:0){So()|0;c[269468]=1077864;Sa(1077880)}return c[269468]|0}function Uo(a){a=a|0;var b=0;b=c[(To()|0)>>2]|0;c[a>>2]=b;di(b);return}function Vo(a,b){a=a|0;b=b|0;b=c[b>>2]|0;c[a>>2]=b;di(b);return}function Wo(a){a=a|0;ei(c[a>>2]|0)|0;return}function Xo(a,b){a=a|0;b=b|0;a=c[a>>2]|0;return bs(a,Yo(b)|0)|0}function Yo(a){a=a|0;var b=0,d=0;d=i;i=i+16|0;b=d;if((c[a>>2]|0)!=-1){c[b>>2]=a;c[b+4>>2]=183;c[b+8>>2]=0;ri(a,b,184)}i=d;return (c[a+4>>2]|0)+-1|0}function Zo(a,b){a=a|0;b=b|0;a=c[a>>2]|0;return Qo(a,Yo(b)|0)|0}function _o(a){a=a|0;xt(a);return}function $o(a){a=a|0;if(a)cc[c[(c[a>>2]|0)+4>>2]&255](a);return}function ap(a){a=a|0;var b=0;b=c[269472]|0;c[269472]=b+1;c[a+4>>2]=b+1;return}function bp(a){a=a|0;xt(a);return}function cp(a,c,d){a=a|0;c=c|0;d=d|0;if(d>>>0<128)d=(b[(dp()|0)+(d<<1)>>1]&c)<<16>>16!=0;else d=0;return d|0}function dp(){return c[(Ga()|0)>>2]|0}function ep(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;if((d|0)!=(e|0)){h=((e+-4-d|0)>>>2)+1|0;g=d;while(1){a=c[g>>2]|0;if(a>>>0<128)a=b[(dp()|0)+(a<<1)>>1]|0;else a=0;b[f>>1]=a;g=g+4|0;if((g|0)==(e|0))break;else f=f+2|0}d=d+(h<<2)|0}return d|0}function fp(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;a:do if((e|0)==(f|0))f=e;else do{a=c[e>>2]|0;if(a>>>0<128?(b[(dp()|0)+(a<<1)>>1]&d)<<16>>16!=0:0){f=e;break a}e=e+4|0}while((e|0)!=(f|0));while(0);return f|0}function gp(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;a:do if((e|0)==(f|0))f=e;else do{a=c[e>>2]|0;if(a>>>0>=128){f=e;break a}if(!((b[(dp()|0)+(a<<1)>>1]&d)<<16>>16)){f=e;break a}e=e+4|0}while((e|0)!=(f|0));while(0);return f|0}function hp(a,b){a=a|0;b=b|0;if(b>>>0<128)b=c[(ip()|0)+(b<<2)>>2]|0;return b|0}function ip(){return c[(Qa()|0)>>2]|0}function jp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;if((b|0)!=(d|0)){f=((d+-4-b|0)>>>2)+1|0;e=b;do{a=c[e>>2]|0;if(a>>>0<128)a=c[(ip()|0)+(a<<2)>>2]|0;c[e>>2]=a;e=e+4|0}while((e|0)!=(d|0));b=b+(f<<2)|0}return b|0}function kp(a,b){a=a|0;b=b|0;if(b>>>0<128)b=c[(lp()|0)+(b<<2)>>2]|0;return b|0}function lp(){return c[(ob()|0)>>2]|0}function mp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;if((b|0)!=(d|0)){f=((d+-4-b|0)>>>2)+1|0;e=b;do{a=c[e>>2]|0;if(a>>>0<128)a=c[(lp()|0)+(a<<2)>>2]|0;c[e>>2]=a;e=e+4|0}while((e|0)!=(d|0));b=b+(f<<2)|0}return b|0}function np(a,b){a=a|0;b=b|0;return b<<24>>24|0}function op(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;if((d|0)==(e|0))e=d;else while(1){c[f>>2]=a[d>>0];d=d+1|0;if((d|0)==(e|0))break;else f=f+4|0}return e|0}function pp(a,b,c){a=a|0;b=b|0;c=c|0;return (b>>>0<128?b&255:c)|0}function qp(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;if((d|0)!=(e|0)){i=((e+-4-d|0)>>>2)+1|0;h=d;b=g;while(1){g=c[h>>2]|0;a[b>>0]=g>>>0<128?g&255:f;h=h+4|0;if((h|0)==(e|0))break;else b=b+1|0}d=d+(i<<2)|0}return d|0}function rp(b){b=b|0;var d=0;c[b>>2]=1077920;d=c[b+8>>2]|0;if((d|0)!=0?(a[b+12>>0]|0)!=0:0)yt(d);return}function sp(a){a=a|0;rp(a);xt(a);return}function tp(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=c[(ip()|0)+((b&255)<<2)>>2]&255;return b|0}function up(b,d,e){b=b|0;d=d|0;e=e|0;if((d|0)==(e|0))e=d;else{b=d;do{d=a[b>>0]|0;if(d<<24>>24>-1)d=c[(ip()|0)+(d<<24>>24<<2)>>2]&255;a[b>>0]=d;b=b+1|0}while((b|0)!=(e|0))}return e|0}function vp(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=c[(lp()|0)+(b<<24>>24<<2)>>2]&255;return b|0}function wp(b,d,e){b=b|0;d=d|0;e=e|0;if((d|0)==(e|0))e=d;else{b=d;do{d=a[b>>0]|0;if(d<<24>>24>-1)d=c[(lp()|0)+(d<<24>>24<<2)>>2]&255;a[b>>0]=d;b=b+1|0}while((b|0)!=(e|0))}return e|0}function xp(a,b){a=a|0;b=b|0;return b|0}function yp(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;if((c|0)==(d|0))d=c;else while(1){a[e>>0]=a[c>>0]|0;c=c+1|0;if((c|0)==(d|0))break;else e=e+1|0}return d|0}function zp(a,b,c){a=a|0;b=b|0;c=c|0;return (b<<24>>24>-1?b:c)|0}function Ap(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if((c|0)==(d|0))d=c;else while(1){b=a[c>>0]|0;a[f>>0]=b<<24>>24>-1?b:e;c=c+1|0;if((c|0)==(d|0))break;else f=f+1|0}return d|0}function Bp(a){a=a|0;xt(a);return}function Cp(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function Dp(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function Ep(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function Fp(a){a=a|0;return 1}function Gp(a){a=a|0;return 1}function Hp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;return (b>>>0<e>>>0?b:e)|0}function Ip(a){a=a|0;return 1}function Jp(a,b){a=a|0;b=b|0;c[a+4>>2]=b+-1;c[a>>2]=1077992;c[a+8>>2]=hl()|0;return}function Kp(a){a=a|0;Lq(a);xt(a);return}function Lp(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=i;i=i+16|0;q=s;o=s+8|0;m=(e|0)==(f|0);a:do if(!m){l=e;while(1){if(!(c[l>>2]|0))break;l=l+4|0;if((l|0)==(f|0)){l=f;break}}c[k>>2]=h;c[g>>2]=e;if(m|(h|0)==(j|0))r=32;else{n=j;p=b+8|0;while(1){t=d;b=c[t+4>>2]|0;m=q;c[m>>2]=c[t>>2];c[m+4>>2]=b;m=_a(c[p>>2]|0)|0;b=gt(h,g,l-e>>2,n-h|0,d)|0;if(m)_a(m|0)|0;if(!b){e=1;break a}else if((b|0)==-1)break;h=(c[k>>2]|0)+b|0;c[k>>2]=h;if((h|0)==(j|0)){r=31;break}if((l|0)==(f|0)){e=c[g>>2]|0;l=f}else{l=_a(c[p>>2]|0)|0;h=Pu(o,0,d)|0;if(l)_a(l|0)|0;if((h|0)==-1){e=2;break a}l=c[k>>2]|0;if(h>>>0>(n-l|0)>>>0){e=1;break a}b:do if(h){m=o;while(1){b=a[m>>0]|0;c[k>>2]=l+1;a[l>>0]=b;h=h+-1|0;if(!h)break b;l=c[k>>2]|0;m=m+1|0}}while(0);l=c[g>>2]|0;e=l+4|0;c[g>>2]=e;c:do if((e|0)==(f|0))l=f;else{m=e;while(1){l=l+8|0;if(!(c[m>>2]|0)){l=m;break c}if((l|0)==(f|0)){l=f;break}else{b=m;m=l;l=b}}}while(0);h=c[k>>2]|0}if((e|0)==(f|0)|(h|0)==(j|0)){r=32;break a}}if((r|0)==31){e=c[g>>2]|0;r=32;break}c[k>>2]=h;d:do if((e|0)!=(c[g>>2]|0))do{f=c[e>>2]|0;l=_a(c[p>>2]|0)|0;h=Pu(h,f,q)|0;if(l)_a(l|0)|0;if((h|0)==-1)break d;h=(c[k>>2]|0)+h|0;c[k>>2]=h;e=e+4|0}while((e|0)!=(c[g>>2]|0));while(0);c[g>>2]=e;e=2}}else{c[k>>2]=h;c[g>>2]=e;r=32}while(0);if((r|0)==32)e=(e|0)!=(f|0)&1;i=s;return e|0}function Mp(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=i;i=i+16|0;q=s;m=(e|0)==(f|0);a:do if(!m){l=e;while(1){if(!(a[l>>0]|0))break;l=l+1|0;if((l|0)==(f|0)){l=f;break}}c[k>>2]=h;c[g>>2]=e;if(m|(h|0)==(j|0))r=31;else{o=j;p=b+8|0;while(1){n=d;b=c[n+4>>2]|0;m=q;c[m>>2]=c[n>>2];c[m+4>>2]=b;m=l;b=_a(c[p>>2]|0)|0;n=dt(h,g,m-e|0,o-h>>2,d)|0;if(b)_a(b|0)|0;if(!n){e=2;break a}else if((n|0)==-1)break;h=(c[k>>2]|0)+(n<<2)|0;c[k>>2]=h;if((h|0)==(j|0)){r=30;break}e=c[g>>2]|0;if((l|0)==(f|0))l=f;else{m=_a(c[p>>2]|0)|0;l=bt(h,e,1,d)|0;if(m)_a(m|0)|0;if(l){e=2;break a}c[k>>2]=(c[k>>2]|0)+4;l=c[g>>2]|0;e=l+1|0;c[g>>2]=e;b:do if((e|0)==(f|0))l=f;else{m=e;while(1){l=l+2|0;if(!(a[m>>0]|0)){l=m;break b}if((l|0)==(f|0)){l=f;break}else{n=m;m=l;l=n}}}while(0);h=c[k>>2]|0}if((e|0)==(f|0)|(h|0)==(j|0)){r=31;break a}}if((r|0)==30){e=c[g>>2]|0;r=31;break}c[k>>2]=h;c:do if((e|0)!=(c[g>>2]|0)){while(1){l=_a(c[p>>2]|0)|0;h=bt(h,e,m-e|0,q)|0;if(l)_a(l|0)|0;if(!h)e=e+1|0;else if((h|0)==-1){r=15;break}else if((h|0)==-2){r=16;break}else e=e+h|0;h=(c[k>>2]|0)+4|0;c[k>>2]=h;if((e|0)==(c[g>>2]|0))break c}if((r|0)==15){c[g>>2]=e;e=2;break a}else if((r|0)==16){c[g>>2]=e;e=1;break a}}while(0);c[g>>2]=e;e=(e|0)!=(f|0)&1}}else{c[k>>2]=h;c[g>>2]=e;r=31}while(0);if((r|0)==31)e=(e|0)!=(f|0)&1;i=s;return e|0}function Np(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;j=i;i=i+16|0;h=j;c[g>>2]=e;b=_a(c[b+8>>2]|0)|0;e=Pu(h,0,d)|0;if(b)_a(b|0)|0;a:do if(!((e|0)==0|(e|0)==-1)){e=e+-1|0;b=c[g>>2]|0;if(e>>>0<=(f-b|0)>>>0)if(!e)e=0;else while(1){d=a[h>>0]|0;c[g>>2]=b+1;a[b>>0]=d;e=e+-1|0;if(!e){e=0;break a}b=c[g>>2]|0;h=h+1|0}else e=1}else e=2;while(0);i=j;return e|0}function Op(a){a=a|0;var b=0,d=0;a=a+8|0;b=_a(c[a>>2]|0)|0;d=ft(0,0,4)|0;if(b)_a(b|0)|0;if(!d){a=c[a>>2]|0;if(a){a=_a(a|0)|0;if(!a)a=0;else{_a(a|0)|0;a=0}}else a=1}else a=-1;return a|0}function Pp(a){a=a|0;return 0}function Qp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a:do if((f|0)==0|(d|0)==(e|0))a=0;else{k=e;j=a+8|0;a=0;i=0;do{h=_a(c[j>>2]|0)|0;g=at(d,k-d|0,b)|0;if(h)_a(h|0)|0;if(!g){d=d+1|0;g=1}else if((g|0)==-2|(g|0)==-1)break a;else d=d+g|0;a=g+a|0;i=i+1|0}while(!(i>>>0>=f>>>0|(d|0)==(e|0)))}while(0);return a|0}function Rp(a){a=a|0;a=c[a+8>>2]|0;if(a){a=_a(a|0)|0;if(!a)a=4;else{_a(a|0)|0;a=4}}else a=1;return a|0}function Sp(a){a=a|0;xt(a);return}function Tp(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;a=i;i=i+16|0;l=a+4|0;k=a;c[l>>2]=d;c[k>>2]=g;b=ds(d,e,l,g,h,k,1114111,0)|0;c[f>>2]=d+((c[l>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=a;return b|0}function Up(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;a=i;i=i+16|0;l=a+4|0;k=a;c[l>>2]=d;c[k>>2]=g;b=es(d,e,l,g,h,k,1114111,0)|0;c[f>>2]=d+((c[l>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=a;return b|0}function Vp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function Wp(a){a=a|0;return 0}function Xp(a){a=a|0;return 0}function Yp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return fs(c,d,e,1114111,0)|0}function Zp(a){a=a|0;return 4}function _p(a){a=a|0;xt(a);return}function $p(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;a=i;i=i+16|0;l=a+4|0;k=a;c[l>>2]=d;c[k>>2]=g;b=gs(d,e,l,g,h,k,1114111,0)|0;c[f>>2]=d+((c[l>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=a;return b|0}function aq(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;a=i;i=i+16|0;l=a+4|0;k=a;c[l>>2]=d;c[k>>2]=g;b=hs(d,e,l,g,h,k,1114111,0)|0;c[f>>2]=d+((c[l>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=a;return b|0}function bq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function cq(a){a=a|0;return 0}function dq(a){a=a|0;return 0}function eq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return is(c,d,e,1114111,0)|0}function fq(a){a=a|0;return 4}function gq(a){a=a|0;xt(a);return}function hq(a){a=a|0;xt(a);return}function iq(a){a=a|0;c[a>>2]=1078072;Bi(a+12|0);return}function jq(a){a=a|0;iq(a);xt(a);return}function kq(a){a=a|0;c[a>>2]=1078112;Bi(a+16|0);return}function lq(a){a=a|0;kq(a);xt(a);return}function mq(b){b=b|0;return a[b+8>>0]|0}function nq(a){a=a|0;return c[a+8>>2]|0}function oq(b){b=b|0;return a[b+9>>0]|0}function pq(a){a=a|0;return c[a+12>>2]|0}function qq(a,b){a=a|0;b=b|0;wi(a,b+12|0);return}function rq(a,b){a=a|0;b=b|0;wi(a,b+16|0);return}function sq(a,b){a=a|0;b=b|0;vi(a,1078144,4);return}function tq(a,b){a=a|0;b=b|0;Vi(a,1078152,nt(1078152)|0);return}function uq(a,b){a=a|0;b=b|0;vi(a,1078176,5);return}function vq(a,b){a=a|0;b=b|0;Vi(a,1078184,nt(1078184)|0);return}function wq(a){a=a|0;a=c[a+4>>2]&74;if((a|0)==64)a=8;else if((a|0)==8)a=16;else if(!a)a=0;else a=10;return a|0}function xq(b){b=b|0;if((a[1078216]|0)==0?(Ia(1078216)|0)!=0:0){if((a[1085416]|0)==0?(Ia(1085416)|0)!=0:0){kv(1085248,0,168)|0;Sa(1085416)}Di(1085248,1085424)|0;Di(1085260,1085432)|0;Di(1085272,1085440)|0;Di(1085284,1085448)|0;Di(1085296,1085464)|0;Di(1085308,1085480)|0;Di(1085320,1085488)|0;Di(1085332,1085504)|0;Di(1085344,1085512)|0;Di(1085356,1085520)|0;Di(1085368,1085528)|0;Di(1085380,1085536)|0;Di(1085392,1085544)|0;Di(1085404,1085552)|0;c[269552]=1085248;Sa(1078216)}return c[269552]|0}function yq(b){b=b|0;if((a[1078232]|0)==0?(Ia(1078232)|0)!=0:0){if((a[1084880]|0)==0?(Ia(1084880)|0)!=0:0){kv(1084712,0,168)|0;Sa(1084880)}Zi(1084712,1084888)|0;Zi(1084724,1084920)|0;Zi(1084736,1084952)|0;Zi(1084748,1084984)|0;Zi(1084760,1085024)|0;Zi(1084772,1085064)|0;Zi(1084784,1085096)|0;Zi(1084796,1085136)|0;Zi(1084808,1085152)|0;Zi(1084820,1085168)|0;Zi(1084832,1085184)|0;Zi(1084844,1085200)|0;Zi(1084856,1085216)|0;Zi(1084868,1085232)|0;c[269556]=1084712;Sa(1078232)}return c[269556]|0}function zq(b){b=b|0;if((a[1078248]|0)==0?(Ia(1078248)|0)!=0:0){if((a[1084488]|0)==0?(Ia(1084488)|0)!=0:0){kv(1084200,0,288)|0;Sa(1084488)}Di(1084200,1084496)|0;Di(1084212,1084504)|0;Di(1084224,1084520)|0;Di(1084236,1084528)|0;Di(1084248,1084536)|0;Di(1084260,1084544)|0;Di(1084272,1084552)|0;Di(1084284,1084560)|0;Di(1084296,1084568)|0;Di(1084308,1084584)|0;Di(1084320,1084592)|0;Di(1084332,1084608)|0;Di(1084344,1084624)|0;Di(1084356,1084632)|0;Di(1084368,1084640)|0;Di(1084380,1084648)|0;Di(1084392,1084536)|0;Di(1084404,1084656)|0;Di(1084416,1084664)|0;Di(1084428,1084672)|0;Di(1084440,1084680)|0;Di(1084452,1084688)|0;Di(1084464,1084696)|0;Di(1084476,1084704)|0;c[269560]=1084200;Sa(1078248)}return c[269560]|0}function Aq(b){b=b|0;if((a[1078264]|0)==0?(Ia(1078264)|0)!=0:0){if((a[1083648]|0)==0?(Ia(1083648)|0)!=0:0){kv(1083360,0,288)|0;Sa(1083648)}Zi(1083360,1083656)|0;Zi(1083372,1083688)|0;Zi(1083384,1083728)|0;Zi(1083396,1083752)|0;Zi(1083408,1083776)|0;Zi(1083420,1083792)|0;Zi(1083432,1083816)|0;Zi(1083444,1083840)|0;Zi(1083456,1083872)|0;Zi(1083468,1083912)|0;Zi(1083480,1083944)|0;Zi(1083492,1083984)|0;Zi(1083504,1084024)|0;Zi(1083516,1084040)|0;Zi(1083528,1084056)|0;Zi(1083540,1084072)|0;Zi(1083552,1083776)|0;Zi(1083564,1084088)|0;Zi(1083576,1084104)|0;Zi(1083588,1084120)|0;Zi(1083600,1084136)|0;Zi(1083612,1084152)|0;Zi(1083624,1084168)|0;Zi(1083636,1084184)|0;c[269564]=1083360;Sa(1078264)}return c[269564]|0}function Bq(b){b=b|0;if((a[1078280]|0)==0?(Ia(1078280)|0)!=0:0){if((a[1083336]|0)==0?(Ia(1083336)|0)!=0:0){kv(1083048,0,288)|0;Sa(1083336)}Di(1083048,1083344)|0;Di(1083060,1083352)|0;c[269568]=1083048;Sa(1078280)}return c[269568]|0}function Cq(b){b=b|0;if((a[1078296]|0)==0?(Ia(1078296)|0)!=0:0){if((a[1083008]|0)==0?(Ia(1083008)|0)!=0:0){kv(1082720,0,288)|0;Sa(1083008)}Zi(1082720,1083016)|0;Zi(1082732,1083032)|0;c[269572]=1082720;Sa(1078296)}return c[269572]|0}function Dq(b){b=b|0;if((a[1078320]|0)==0?(Ia(1078320)|0)!=0:0){vi(1078304,1078328,8);Sa(1078320)}return 1078304}function Eq(b){b=b|0;if((a[1078360]|0)==0?(Ia(1078360)|0)!=0:0){Vi(1078344,1078368,nt(1078368)|0);Sa(1078360)}return 1078344}function Fq(b){b=b|0;if((a[1078424]|0)==0?(Ia(1078424)|0)!=0:0){vi(1078408,1078432,8);Sa(1078424)}return 1078408}function Gq(b){b=b|0;if((a[1078464]|0)==0?(Ia(1078464)|0)!=0:0){Vi(1078448,1078472,nt(1078472)|0);Sa(1078464)}return 1078448}function Hq(b){b=b|0;if((a[1078528]|0)==0?(Ia(1078528)|0)!=0:0){vi(1078512,1078536,20);Sa(1078528)}return 1078512}function Iq(b){b=b|0;if((a[1078576]|0)==0?(Ia(1078576)|0)!=0:0){Vi(1078560,1078584,nt(1078584)|0);Sa(1078576)}return 1078560}function Jq(b){b=b|0;if((a[1078688]|0)==0?(Ia(1078688)|0)!=0:0){vi(1078672,1078696,11);Sa(1078688)}return 1078672}function Kq(b){b=b|0;if((a[1078728]|0)==0?(Ia(1078728)|0)!=0:0){Vi(1078712,1078736,nt(1078736)|0);Sa(1078728)}return 1078712}function Lq(a){a=a|0;var b=0;c[a>>2]=1077992;a=a+8|0;b=c[a>>2]|0;if((b|0)!=(hl()|0))gb(c[a>>2]|0);return}function Mq(){bi(0);return}function Nq(a){a=a|0;bb(a|0)|0;Et()}function Oq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;nj(b);c[b>>2]=1074760;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52>>0]=0;Vo(g,b+4|0);zs(b,g);Wo(g);i=f;return}function Pq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;nj(b);c[b>>2]=1074648;c[b+32>>2]=d;Vo(g,b+4|0);d=Zo(g,1077968)|0;Wo(g);c[b+36>>2]=d;c[b+40>>2]=e;a[b+44>>0]=(fc[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;i=f;return}function Qq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;Dj(b);c[b>>2]=1074504;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52>>0]=0;Vo(g,b+4|0);ps(b,g);Wo(g);i=f;return}function Rq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;Dj(b);c[b>>2]=1074392;c[b+32>>2]=d;Vo(g,b+4|0);d=Zo(g,1077976)|0;Wo(g);c[b+36>>2]=d;c[b+40>>2]=e;a[b+44>>0]=(fc[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;i=f;return}function Sq(a,b){a=a|0;b=b|0;var d=0,e=0;e=lv(b|0)|0;d=ut(e+13|0)|0;c[d>>2]=e;c[d+4>>2]=e;c[d+8>>2]=0;d=d+12|0;mv(d|0,b|0,e+1|0)|0;c[a>>2]=d;return}function Tq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;g=d;f=e-g|0;if(f>>>0>4294967279)si(b);if(f>>>0<11){a[b>>0]=f<<1;f=b+1|0}else{i=f+16&-16;h=ut(i)|0;c[b+8>>2]=h;c[b>>2]=i|1;c[b+4>>2]=f;f=h}if((d|0)!=(e|0)){g=e-g|0;b=f;while(1){a[b>>0]=a[d>>0]|0;d=d+1|0;if((d|0)==(e|0))break;else b=b+1|0}f=f+g|0}a[f>>0]=0;return}function Uq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=d;f=e-h|0;g=f>>2;if(g>>>0>1073741807)si(b);if(g>>>0<2){a[b>>0]=f>>>1;b=b+4|0}else{i=g+4&-4;f=ut(i<<2)|0;c[b+8>>2]=f;c[b>>2]=i|1;c[b+4>>2]=g;b=f}if((d|0)!=(e|0)){g=((e+-4-h|0)>>>2)+1|0;f=b;while(1){c[f>>2]=c[d>>2];d=d+4|0;if((d|0)==(e|0))break;else f=f+4|0}b=b+(g<<2)|0}c[b>>2]=0;return}function Vq(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=i;i=i+112|0;m=z;n=(g-f|0)/12|0;if(n>>>0>100){m=tu(n)|0;if(!m)ou();else{x=m;l=m}}else{x=0;l=m}w=(f|0)==(g|0);if(w)m=0;else{p=f;m=0;q=l;while(1){o=a[p>>0]|0;if(!(o&1))o=(o&255)>>>1;else o=c[p+4>>2]|0;if(!o){a[q>>0]=2;m=m+1|0;n=n+-1|0}else a[q>>0]=1;p=p+12|0;if((p|0)==(g|0))break;else q=q+1|0}}o=0;p=m;s=n;a:while(1){t=o;while(1){n=c[b>>2]|0;do if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0))if((fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[b>>2]=0;n=0;break}else{n=c[b>>2]|0;break}}else n=0;while(0);q=(n|0)==0;n=c[e>>2]|0;if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)?(fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1:0){c[e>>2]=0;n=0}}else n=0;o=(n|0)==0;m=c[b>>2]|0;if(!((q^o)&(s|0)!=0))break a;o=c[m+12>>2]|0;if((o|0)==(c[m+16>>2]|0))n=fc[c[(c[m>>2]|0)+36>>2]&127](m)|0;else n=d[o>>0]|0;n=n&255;if(!k)n=oc[c[(c[h>>2]|0)+12>>2]&63](h,n)|0;o=t+1|0;if(w)t=o;else{u=t;break}}m=0;v=f;t=l;while(1){do if((a[t>>0]|0)==1){if(!(a[v>>0]&1))q=v+1|0;else q=c[v+8>>2]|0;q=a[q+u>>0]|0;if(!k)q=oc[c[(c[h>>2]|0)+12>>2]&63](h,q)|0;if(n<<24>>24!=q<<24>>24){a[t>>0]=0;q=m;r=p;s=s+-1|0;break}q=a[v>>0]|0;if(!(q&1))q=(q&255)>>>1;else q=c[v+4>>2]|0;if((q|0)==(o|0)){a[t>>0]=2;q=1;r=p+1|0;s=s+-1|0}else{q=1;r=p}}else{q=m;r=p}while(0);v=v+12|0;if((v|0)==(g|0))break;else{m=q;p=r;t=t+1|0}}if(!q){p=r;continue}m=c[b>>2]|0;p=m+12|0;n=c[p>>2]|0;if((n|0)==(c[m+16>>2]|0))fc[c[(c[m>>2]|0)+40>>2]&127](m)|0;else c[p>>2]=n+1;if((r+s|0)>>>0<2){p=r;continue}else{n=f;p=r;q=l}while(1){if((a[q>>0]|0)==2){m=a[n>>0]|0;if(!(m&1))m=(m&255)>>>1;else m=c[n+4>>2]|0;if((m|0)!=(o|0)){a[q>>0]=0;p=p+-1|0}}n=n+12|0;if((n|0)==(g|0))continue a;else q=q+1|0}}do if(m){if((c[m+12>>2]|0)==(c[m+16>>2]|0))if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1){c[b>>2]=0;m=0;break}else{m=c[b>>2]|0;break}}else m=0;while(0);m=(m|0)==0;do if(!o){if((c[n+12>>2]|0)!=(c[n+16>>2]|0))if(m)break;else{y=69;break}if((fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)!=-1)if(m)break;else{y=69;break}else{c[e>>2]=0;y=67;break}}else y=67;while(0);if((y|0)==67?m:0)y=69;if((y|0)==69)c[j>>2]=c[j>>2]|2;b:do if(w)y=73;else while(1){if((a[l>>0]|0)==2){g=f;break b}f=f+12|0;if((f|0)==(g|0)){y=73;break}else l=l+1|0}while(0);if((y|0)==73)c[j>>2]=c[j>>2]|4;if(x)uu(x);i=z;return g|0}function Wq(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;D=i;i=i+224|0;u=D+198|0;e=D+196|0;C=D+184|0;B=D+172|0;w=D+168|0;y=D+8|0;z=D+4|0;x=D;v=wq(h)|0;wl(C,h,u,e);c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;Gi(B,10,0);if(!(a[B>>0]&1)){l=B+1|0;r=l;s=B+8|0}else{l=B+8|0;r=B+1|0;s=l;l=c[l>>2]|0}c[w>>2]=l;c[z>>2]=y;c[x>>2]=0;t=B+4|0;q=a[e>>0]|0;e=c[f>>2]|0;a:while(1){if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;h=(e|0)==0;m=c[g>>2]|0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(h)break;else break a;if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(h)break;else break a;else{c[g>>2]=0;E=14;break}}else E=14;while(0);if((E|0)==14){E=0;if(h){m=0;break}else m=0}o=a[B>>0]|0;h=(o&1)==0;if(h)n=(o&255)>>>1;else n=c[t>>2]|0;if((c[w>>2]|0)==(l+n|0)){if(h){l=(o&255)>>>1;n=(o&255)>>>1}else{n=c[t>>2]|0;l=n}Gi(B,l<<1,0);if(!(a[B>>0]&1))l=10;else l=(c[B>>2]&-2)+-1|0;Gi(B,l,0);if(!(a[B>>0]&1))l=r;else l=c[s>>2]|0;c[w>>2]=l+n}o=e+12|0;n=c[o>>2]|0;p=e+16|0;if((n|0)==(c[p>>2]|0))h=fc[c[(c[e>>2]|0)+36>>2]&127](e)|0;else h=d[n>>0]|0;if(gl(h&255,v,l,w,x,q,C,y,z,u)|0)break;m=c[o>>2]|0;if((m|0)==(c[p>>2]|0)){fc[c[(c[e>>2]|0)+40>>2]&127](e)|0;continue}else{c[o>>2]=m+1;continue}}h=a[C>>0]|0;if(!(h&1))h=(h&255)>>>1;else h=c[C+4>>2]|0;if((h|0)!=0?(A=c[z>>2]|0,(A-y|0)<160):0){x=c[x>>2]|0;c[z>>2]=A+4;c[A>>2]=x}c[k>>2]=Es(l,c[w>>2]|0,j,v)|0;go(C,y,c[z>>2]|0,j);if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;h=(e|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(h)break;else{E=52;break}if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(h^(m|0)==0)break;else{E=52;break}else{c[g>>2]=0;E=50;break}}else E=50;while(0);if((E|0)==50?h:0)E=52;if((E|0)==52)c[j>>2]=c[j>>2]|2;c[b>>2]=e;Bi(B);Bi(C);i=D;return}function Xq(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;D=i;i=i+224|0;u=D+198|0;e=D+196|0;C=D+184|0;B=D+172|0;w=D+168|0;y=D+8|0;z=D+4|0;x=D;v=wq(h)|0;wl(C,h,u,e);c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;Gi(B,10,0);if(!(a[B>>0]&1)){l=B+1|0;r=l;s=B+8|0}else{l=B+8|0;r=B+1|0;s=l;l=c[l>>2]|0}c[w>>2]=l;c[z>>2]=y;c[x>>2]=0;t=B+4|0;q=a[e>>0]|0;e=c[f>>2]|0;a:while(1){if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;h=(e|0)==0;m=c[g>>2]|0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(h)break;else break a;if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(h)break;else break a;else{c[g>>2]=0;E=14;break}}else E=14;while(0);if((E|0)==14){E=0;if(h){m=0;break}else m=0}o=a[B>>0]|0;h=(o&1)==0;if(h)n=(o&255)>>>1;else n=c[t>>2]|0;if((c[w>>2]|0)==(l+n|0)){if(h){l=(o&255)>>>1;n=(o&255)>>>1}else{n=c[t>>2]|0;l=n}Gi(B,l<<1,0);if(!(a[B>>0]&1))l=10;else l=(c[B>>2]&-2)+-1|0;Gi(B,l,0);if(!(a[B>>0]&1))l=r;else l=c[s>>2]|0;c[w>>2]=l+n}o=e+12|0;n=c[o>>2]|0;p=e+16|0;if((n|0)==(c[p>>2]|0))h=fc[c[(c[e>>2]|0)+36>>2]&127](e)|0;else h=d[n>>0]|0;if(gl(h&255,v,l,w,x,q,C,y,z,u)|0)break;m=c[o>>2]|0;if((m|0)==(c[p>>2]|0)){fc[c[(c[e>>2]|0)+40>>2]&127](e)|0;continue}else{c[o>>2]=m+1;continue}}h=a[C>>0]|0;if(!(h&1))h=(h&255)>>>1;else h=c[C+4>>2]|0;if((h|0)!=0?(A=c[z>>2]|0,(A-y|0)<160):0){x=c[x>>2]|0;c[z>>2]=A+4;c[A>>2]=x}A=Fs(l,c[w>>2]|0,j,v)|0;c[k>>2]=A;c[k+4>>2]=F;go(C,y,c[z>>2]|0,j);if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;h=(e|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(h)break;else{E=52;break}if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(h^(m|0)==0)break;else{E=52;break}else{c[g>>2]=0;E=50;break}}else E=50;while(0);if((E|0)==50?h:0)E=52;if((E|0)==52)c[j>>2]=c[j>>2]|2;c[b>>2]=e;Bi(B);Bi(C);i=D;return}function Yq(e,f,g,h,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;E=i;i=i+224|0;v=E+198|0;f=E+196|0;D=E+184|0;C=E+172|0;x=E+168|0;z=E+8|0;A=E+4|0;y=E;w=wq(j)|0;wl(D,j,v,f);c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;Gi(C,10,0);if(!(a[C>>0]&1)){m=C+1|0;s=m;t=C+8|0}else{m=C+8|0;s=C+1|0;t=m;m=c[m>>2]|0}c[x>>2]=m;c[A>>2]=z;c[y>>2]=0;u=C+4|0;r=a[f>>0]|0;f=c[g>>2]|0;a:while(1){if(f){if((c[f+12>>2]|0)==(c[f+16>>2]|0)?(fc[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1:0){c[g>>2]=0;f=0}}else f=0;j=(f|0)==0;n=c[h>>2]|0;do if(n){if((c[n+12>>2]|0)!=(c[n+16>>2]|0))if(j)break;else break a;if((fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)!=-1)if(j)break;else break a;else{c[h>>2]=0;F=14;break}}else F=14;while(0);if((F|0)==14){F=0;if(j){n=0;break}else n=0}p=a[C>>0]|0;j=(p&1)==0;if(j)o=(p&255)>>>1;else o=c[u>>2]|0;if((c[x>>2]|0)==(m+o|0)){if(j){m=(p&255)>>>1;o=(p&255)>>>1}else{o=c[u>>2]|0;m=o}Gi(C,m<<1,0);if(!(a[C>>0]&1))m=10;else m=(c[C>>2]&-2)+-1|0;Gi(C,m,0);if(!(a[C>>0]&1))m=s;else m=c[t>>2]|0;c[x>>2]=m+o}p=f+12|0;o=c[p>>2]|0;q=f+16|0;if((o|0)==(c[q>>2]|0))j=fc[c[(c[f>>2]|0)+36>>2]&127](f)|0;else j=d[o>>0]|0;if(gl(j&255,w,m,x,y,r,D,z,A,v)|0)break;n=c[p>>2]|0;if((n|0)==(c[q>>2]|0)){fc[c[(c[f>>2]|0)+40>>2]&127](f)|0;continue}else{c[p>>2]=n+1;continue}}j=a[D>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[D+4>>2]|0;if((j|0)!=0?(B=c[A>>2]|0,(B-z|0)<160):0){y=c[y>>2]|0;c[A>>2]=B+4;c[B>>2]=y}b[l>>1]=Gs(m,c[x>>2]|0,k,w)|0;go(D,z,c[A>>2]|0,k);if(f){if((c[f+12>>2]|0)==(c[f+16>>2]|0)?(fc[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1:0){c[g>>2]=0;f=0}}else f=0;j=(f|0)==0;do if(n){if((c[n+12>>2]|0)!=(c[n+16>>2]|0))if(j)break;else{F=52;break}if((fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)!=-1)if(j^(n|0)==0)break;else{F=52;break}else{c[h>>2]=0;F=50;break}}else F=50;while(0);if((F|0)==50?j:0)F=52;if((F|0)==52)c[k>>2]=c[k>>2]|2;c[e>>2]=f;Bi(C);Bi(D);i=E;return}function Zq(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;D=i;i=i+224|0;u=D+198|0;e=D+196|0;C=D+184|0;B=D+172|0;w=D+168|0;y=D+8|0;z=D+4|0;x=D;v=wq(h)|0;wl(C,h,u,e);c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;Gi(B,10,0);if(!(a[B>>0]&1)){l=B+1|0;r=l;s=B+8|0}else{l=B+8|0;r=B+1|0;s=l;l=c[l>>2]|0}c[w>>2]=l;c[z>>2]=y;c[x>>2]=0;t=B+4|0;q=a[e>>0]|0;e=c[f>>2]|0;a:while(1){if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;h=(e|0)==0;m=c[g>>2]|0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(h)break;else break a;if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(h)break;else break a;else{c[g>>2]=0;E=14;break}}else E=14;while(0);if((E|0)==14){E=0;if(h){m=0;break}else m=0}o=a[B>>0]|0;h=(o&1)==0;if(h)n=(o&255)>>>1;else n=c[t>>2]|0;if((c[w>>2]|0)==(l+n|0)){if(h){l=(o&255)>>>1;n=(o&255)>>>1}else{n=c[t>>2]|0;l=n}Gi(B,l<<1,0);if(!(a[B>>0]&1))l=10;else l=(c[B>>2]&-2)+-1|0;Gi(B,l,0);if(!(a[B>>0]&1))l=r;else l=c[s>>2]|0;c[w>>2]=l+n}o=e+12|0;n=c[o>>2]|0;p=e+16|0;if((n|0)==(c[p>>2]|0))h=fc[c[(c[e>>2]|0)+36>>2]&127](e)|0;else h=d[n>>0]|0;if(gl(h&255,v,l,w,x,q,C,y,z,u)|0)break;m=c[o>>2]|0;if((m|0)==(c[p>>2]|0)){fc[c[(c[e>>2]|0)+40>>2]&127](e)|0;continue}else{c[o>>2]=m+1;continue}}h=a[C>>0]|0;if(!(h&1))h=(h&255)>>>1;else h=c[C+4>>2]|0;if((h|0)!=0?(A=c[z>>2]|0,(A-y|0)<160):0){x=c[x>>2]|0;c[z>>2]=A+4;c[A>>2]=x}c[k>>2]=Hs(l,c[w>>2]|0,j,v)|0;go(C,y,c[z>>2]|0,j);if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;h=(e|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(h)break;else{E=52;break}if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(h^(m|0)==0)break;else{E=52;break}else{c[g>>2]=0;E=50;break}}else E=50;while(0);if((E|0)==50?h:0)E=52;if((E|0)==52)c[j>>2]=c[j>>2]|2;c[b>>2]=e;Bi(B);Bi(C);i=D;return}function _q(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;D=i;i=i+224|0;u=D+198|0;e=D+196|0;C=D+184|0;B=D+172|0;w=D+168|0;y=D+8|0;z=D+4|0;x=D;v=wq(h)|0;wl(C,h,u,e);c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;Gi(B,10,0);if(!(a[B>>0]&1)){l=B+1|0;r=l;s=B+8|0}else{l=B+8|0;r=B+1|0;s=l;l=c[l>>2]|0}c[w>>2]=l;c[z>>2]=y;c[x>>2]=0;t=B+4|0;q=a[e>>0]|0;e=c[f>>2]|0;a:while(1){if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;h=(e|0)==0;m=c[g>>2]|0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(h)break;else break a;if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(h)break;else break a;else{c[g>>2]=0;E=14;break}}else E=14;while(0);if((E|0)==14){E=0;if(h){m=0;break}else m=0}o=a[B>>0]|0;h=(o&1)==0;if(h)n=(o&255)>>>1;else n=c[t>>2]|0;if((c[w>>2]|0)==(l+n|0)){if(h){l=(o&255)>>>1;n=(o&255)>>>1}else{n=c[t>>2]|0;l=n}Gi(B,l<<1,0);if(!(a[B>>0]&1))l=10;else l=(c[B>>2]&-2)+-1|0;Gi(B,l,0);if(!(a[B>>0]&1))l=r;else l=c[s>>2]|0;c[w>>2]=l+n}o=e+12|0;n=c[o>>2]|0;p=e+16|0;if((n|0)==(c[p>>2]|0))h=fc[c[(c[e>>2]|0)+36>>2]&127](e)|0;else h=d[n>>0]|0;if(gl(h&255,v,l,w,x,q,C,y,z,u)|0)break;m=c[o>>2]|0;if((m|0)==(c[p>>2]|0)){fc[c[(c[e>>2]|0)+40>>2]&127](e)|0;continue}else{c[o>>2]=m+1;continue}}h=a[C>>0]|0;if(!(h&1))h=(h&255)>>>1;else h=c[C+4>>2]|0;if((h|0)!=0?(A=c[z>>2]|0,(A-y|0)<160):0){x=c[x>>2]|0;c[z>>2]=A+4;c[A>>2]=x}c[k>>2]=Is(l,c[w>>2]|0,j,v)|0;go(C,y,c[z>>2]|0,j);if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;h=(e|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(h)break;else{E=52;break}if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(h^(m|0)==0)break;else{E=52;break}else{c[g>>2]=0;E=50;break}}else E=50;while(0);if((E|0)==50?h:0)E=52;if((E|0)==52)c[j>>2]=c[j>>2]|2;c[b>>2]=e;Bi(B);Bi(C);i=D;return}function $q(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;D=i;i=i+224|0;u=D+198|0;e=D+196|0;C=D+184|0;B=D+172|0;w=D+168|0;y=D+8|0;z=D+4|0;x=D;v=wq(h)|0;wl(C,h,u,e);c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;Gi(B,10,0);if(!(a[B>>0]&1)){l=B+1|0;r=l;s=B+8|0}else{l=B+8|0;r=B+1|0;s=l;l=c[l>>2]|0}c[w>>2]=l;c[z>>2]=y;c[x>>2]=0;t=B+4|0;q=a[e>>0]|0;e=c[f>>2]|0;a:while(1){if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;h=(e|0)==0;m=c[g>>2]|0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(h)break;else break a;if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(h)break;else break a;else{c[g>>2]=0;E=14;break}}else E=14;while(0);if((E|0)==14){E=0;if(h){m=0;break}else m=0}o=a[B>>0]|0;h=(o&1)==0;if(h)n=(o&255)>>>1;else n=c[t>>2]|0;if((c[w>>2]|0)==(l+n|0)){if(h){l=(o&255)>>>1;n=(o&255)>>>1}else{n=c[t>>2]|0;l=n}Gi(B,l<<1,0);if(!(a[B>>0]&1))l=10;else l=(c[B>>2]&-2)+-1|0;Gi(B,l,0);if(!(a[B>>0]&1))l=r;else l=c[s>>2]|0;c[w>>2]=l+n}o=e+12|0;n=c[o>>2]|0;p=e+16|0;if((n|0)==(c[p>>2]|0))h=fc[c[(c[e>>2]|0)+36>>2]&127](e)|0;else h=d[n>>0]|0;if(gl(h&255,v,l,w,x,q,C,y,z,u)|0)break;m=c[o>>2]|0;if((m|0)==(c[p>>2]|0)){fc[c[(c[e>>2]|0)+40>>2]&127](e)|0;continue}else{c[o>>2]=m+1;continue}}h=a[C>>0]|0;if(!(h&1))h=(h&255)>>>1;else h=c[C+4>>2]|0;if((h|0)!=0?(A=c[z>>2]|0,(A-y|0)<160):0){x=c[x>>2]|0;c[z>>2]=A+4;c[A>>2]=x}A=Js(l,c[w>>2]|0,j,v)|0;c[k>>2]=A;c[k+4>>2]=F;go(C,y,c[z>>2]|0,j);if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;h=(e|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(h)break;else{E=52;break}if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(h^(m|0)==0)break;else{E=52;break}else{c[g>>2]=0;E=50;break}}else E=50;while(0);if((E|0)==50?h:0)E=52;if((E|0)==52)c[j>>2]=c[j>>2]|2;c[b>>2]=e;Bi(B);Bi(C);i=D;return}
function Rg(d,f,g,h,j){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=i;i=i+2832|0;E=M+88|0;p=M+2828|0;D=M+160|0;C=M;w=f+44|0;x=f+48|0;c[x>>2]=M+2312;A=f+4|0;c[c[A>>2]>>2]=0;B=f+12|0;c[B>>2]=0;G=f+8|0;c[G>>2]=(c[f+-36>>2]|0)+1;if(!(og(d)|0)?(c[G>>2]|0)<=127:0){z=d+2220|0;J=(c[z>>2]|0)+48|0;I=c[J>>2]|0;J=c[J+4>>2]|0;L=Fh(1069912,I,J,p)|0;if(!(a[p>>0]|0))p=0;else p=e[L+2>>1]|0;H=f+36|0;c[H>>2]=32002;Hf(D,d,p,j,1055552,c[f+-32>>2]&63);Tf(C,d);t=d+2212|0;u=C+8|0;v=0-h|0;s=j+-1|0;r=g;n=0;m=-32001;a:while(1){q=0-r|0;while(1){p=Kf(D)|0;if(!p)break a;k=(m|0)>-31872;while(1){o=p&49152;l=C;if((o|0)==0&((c[l>>2]|0)==0&(c[l+4>>2]|0)==0)){j=C+((c[d+((p>>>6&63)<<2)>>2]&7)<<3)+16|0;l=46496+((p&63)<<3)|0;f=c[l>>2]&c[j>>2];j=c[l+4>>2]&c[j+4>>2]}else{f=(fg(d,p,C)|0)&1;j=0}f=(f|0)!=0|(j|0)!=0;if(!(((k?!((o|0)==32768|((o|0)!=49152?(c[d+((p&63)<<2)>>2]|0)!=0:0)):0)?!((o|0)==16384?1:(c[(c[z>>2]|0)+24>>2]&3<<(c[t>>2]<<1)|0)!=0):0)?(mg(d,p)|0)<0:0))K=18;if((K|0)==18?(K=0,l=u,dg(d,p,c[l>>2]|0,c[l+4>>2]|0)|0):0){c[B>>2]=p;hg(d,p,E,C,f);if(f)l=Rg(d,w,v,q,s)|0;else l=Sg(d,w,v,q,s)|0;f=0-l|0;ig(d,p);if((m|0)<(f|0)){m=f;break}}p=Kf(D)|0;if(!p)break a}if((r|0)<(m|0)){n=p;break}}j=c[A>>2]|0;f=c[x>>2]|0;c[j>>2]=n;p=j+4|0;if((f|0)!=0?(y=c[f>>2]|0,(y|0)!=0):0){k=p;o=y;p=j;while(1){f=f+4|0;c[k>>2]=o;p=p+8|0;o=c[f>>2]|0;if(!o)break;else{j=k;k=p;p=j}}}c[p>>2]=0;if((m|0)<(h|0))r=m;else{K=28;break}}if((K|0)==28){k=c[G>>2]|0;if((l|0)<-31871)k=k-l|0;else k=m-((l|0)>31871?k:0)|0;h=c[H>>2]|0;C=a[1069924]|0;B=jv(I|0,J|0,48)|0;b[L+2>>1]=n;b[L>>1]=B;b[L+4>>1]=k;b[L+6>>1]=h;a[L+8>>0]=C&255|2;a[L+9>>0]=0;C=m;i=M;return C|0}k=c[G>>2]|0;if((m|0)==-32001){C=k+-32e3|0;i=M;return C|0}if((m|0)>31871)p=k+m|0;else p=m-((m|0)<-31871?k:0)|0;f=(m|0)>(g|0)?3:1;o=c[H>>2]|0;j=a[1069924]|0;l=jv(I|0,J|0,48)|0;if(!n){k=l&65535;if(!((F|0)==0?(l|0)==(e[L>>1]|0):0))K=40}else{k=l&65535;K=40}if((K|0)==40)b[L+2>>1]=n;b[L>>1]=k;b[L+4>>1]=p;b[L+6>>1]=o;a[L+8>>0]=j&255|f;a[L+9>>0]=0;C=m;i=M;return C|0}C=c[1053192+(c[d+2212>>2]<<2)>>2]|0;i=M;return C|0}function Sg(f,g,h,j,k){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=i;i=i+2832|0;I=P+88|0;m=P+2828|0;H=P+160|0;G=P;A=g+44|0;B=g+48|0;c[B>>2]=P+2312;C=g+4|0;c[c[C>>2]>>2]=0;E=g+12|0;c[E>>2]=0;J=g+8|0;c[J>>2]=(c[g+-36>>2]|0)+1;z=og(f)|0;q=(c[J>>2]|0)>127;if(z){if(!q){j=c[1053192+(c[f+2212>>2]<<2)>>2]|0;i=P;return j|0}}else if(!q){N=k>>31;n=f+2220|0;L=(c[n>>2]|0)+48|0;K=c[L>>2]|0;L=c[L+4>>2]|0;O=Fh(1069912,K,L,m)|0;if(a[m>>0]|0){o=e[O+2>>1]|0;r=b[O+4>>1]|0;q=r<<16>>16;p=c[J>>2]|0;do if(r<<16>>16!=32002)if(r<<16>>16>31871){p=q-p|0;break}else{p=(r<<16>>16<-31871?p:0)+q|0;break}else p=32002;while(0);z=b[O+6>>1]|0;r=z<<16>>16;q=g+36|0;c[q>>2]=r;if(z<<16>>16==32002){r=xe(f)|0;c[q>>2]=r}if((p|0)==32002){q=o;p=r}else{q=o;p=(d[O+8>>0]&((p|0)>(r|0)?2:1)|0)==0?r:p}}else{if((c[g+-32>>2]|0)==65)r=34-(c[g+-8>>2]|0)|0;else r=xe(f)|0;c[g+36>>2]=r;q=0;p=r}if((p|0)>=(j|0)){if(a[m>>0]|0){j=p;i=P;return j|0}n=(c[n>>2]|0)+48|0;l=c[J>>2]|0;if((p|0)>31871)m=l+p|0;else m=p-((p|0)<-31871?l:0)|0;k=a[1069924]|0;l=jv(c[n>>2]|0,c[n+4>>2]|0,48)|0;if(!((F|0)==0?(l|0)==(e[O>>1]|0):0))b[O+2>>1]=0;b[O>>1]=l;b[O+4>>1]=m;b[O+6>>1]=r;a[O+8>>0]=k&255|2;a[O+9>>0]=-6;j=p;i=P;return j|0}z=p+128|0;Hf(H,f,q,k,1055552,c[g+-32>>2]&63);Tf(G,f);v=(z|0)>-1e4;w=f+2212|0;x=G+8|0;y=0-j|0;u=k+-1|0;t=(p|0)>(h|0)?p:h;k=p;l=0;a:while(1){r=Kf(H)|0;if(!r)break;n=(z|0)>(t|0);s=0-t|0;while(1){o=r;b:while(1){p=o&49152;m=G;if((p|0)==0&((c[m>>2]|0)==0&(c[m+4>>2]|0)==0)){q=G+((c[f+((o>>>6&63)<<2)>>2]&7)<<3)+16|0;m=46496+((o&63)<<3)|0;r=c[m>>2]&c[q>>2];q=c[m+4>>2]&c[q+4>>2]}else{r=(fg(f,o,G)|0)&1;q=0}q=(r|0)!=0|(q|0)!=0;do if(v&(q^1)){m=o>>>6&63;if((c[f+(m<<2)>>2]&7|0)==1?((c[w>>2]|0)*7^m>>>3|0)>3:0)break;r=(c[1004912+(c[f+((o&63)<<2)>>2]<<2)>>2]|0)+z|0;if((r|0)<=(t|0)){M=38;break b}if(!n?(ng(f,o)|0)<1:0){M=41;break b}}while(0);if(!((p|0)!=16384?(mg(f,o)|0)<0:0))M=45;if((M|0)==45?(M=0,m=x,dg(f,o,c[m>>2]|0,c[m+4>>2]|0)|0):0){c[E>>2]=o;hg(f,o,I,G,q);if(q)m=Rg(f,A,y,s,u)|0;else m=Sg(f,A,y,s,u)|0;q=0-m|0;ig(f,o);if((k|0)<(q|0)){r=o;k=q;M=50;break}}o=Kf(H)|0;if(!o)break a}if((M|0)==38){M=0;k=(k|0)<(r|0)?r:k}else if((M|0)==41){M=0;k=(k|0)<(z|0)?z:k}else if((M|0)==50){M=0;if((t|0)<(k|0)){l=r;break}}r=Kf(H)|0;if(!r)break a}p=c[C>>2]|0;q=c[B>>2]|0;c[p>>2]=l;r=p+4|0;if((q|0)!=0?(D=c[q>>2]|0,(D|0)!=0):0){n=r;o=D;r=p;while(1){q=q+4|0;c[n>>2]=o;r=r+8|0;o=c[q>>2]|0;if(!o)break;else{p=n;n=r;r=p}}}c[r>>2]=0;if((k|0)<(j|0))t=k;else{M=56;break}}if((M|0)==56){n=c[J>>2]|0;if((m|0)<-31871)m=n-m|0;else m=k-((m|0)>31871?n:0)|0;E=c[g+36>>2]|0;j=a[1069924]|0;D=jv(K|0,L|0,48)|0;b[O+2>>1]=l;b[O>>1]=D;b[O+4>>1]=m;b[O+6>>1]=E;a[O+8>>0]=j&255|2;a[O+9>>0]=N;j=k;i=P;return j|0}n=c[J>>2]|0;if((k|0)>31871)r=n+k|0;else r=k-((k|0)<-31871?n:0)|0;q=(k|0)>(h|0)?3:1;o=c[g+36>>2]|0;p=a[1069924]|0;m=jv(K|0,L|0,48)|0;if(!l){n=m&65535;if(!((F|0)==0?(m|0)==(e[O>>1]|0):0))M=66}else{n=m&65535;M=66}if((M|0)==66)b[O+2>>1]=l;b[O>>1]=n;b[O+4>>1]=r;b[O+6>>1]=o;a[O+8>>0]=p&255|q;a[O+9>>0]=N;j=k;i=P;return j|0}j=xe(f)|0;i=P;return j|0}function Tg(f,g,h,j,k,l){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;ra=i;i=i+3120|0;ga=ra+2592|0;ia=ra+2336|0;ha=ra+88|0;pa=ra+2332|0;la=ra+2328|0;x=ra+3108|0;ea=ra+2320|0;y=ra+2312|0;fa=ra+160|0;da=ra;ca=c[f+2216>>2]|0;s=f+2220|0;ja=(c[s>>2]|0)+56|0;ja=(c[ja>>2]|0)!=0|(c[ja+4>>2]|0)!=0;c[la>>2]=-32001;r=(c[g+-36>>2]|0)+1|0;ma=g+8|0;c[ma>>2]=r;q=ca+848|0;if((c[q>>2]|0)<(r|0))c[q>>2]=r;if(((a[1017944]|0)==0?!(og(f)|0):0)?(p=c[ma>>2]|0,(p|0)<=127):0){m=p+-32e3|0;m=(m|0)<(h|0)?h:m;ka=31999-p|0;ka=(ka|0)>(j|0)?j:ka;if((m|0)>=(ka|0)){da=m;i=ra;return da|0}c[pa>>2]=0;Y=g+44|0;c[g+64>>2]=0;r=g+16|0;c[r>>2]=0;Z=g+12|0;c[Z>>2]=0;a[g+84>>0]=0;c[g+76>>2]=0;c[g+116>>2]=0;c[g+112>>2]=0;_=g+20|0;$=c[_>>2]|0;aa=($|0)!=0;if(aa){na=Sf(f)|0;oa=F}else{oa=(c[s>>2]|0)+48|0;na=c[oa>>2]|0;oa=c[oa+4>>2]|0}n=Fh(1069912,na,oa,x)|0;j=(a[x>>0]|0)==0;do if(!j){q=e[n+2>>1]|0;c[r>>2]=q;r=b[n+4>>1]|0;h=r<<16>>16;p=c[ma>>2]|0;if(r<<16>>16!=32002)if(r<<16>>16>31871){o=q;w=h-p|0;break}else{o=q;w=(r<<16>>16<-31871?p:0)+h|0;break}else{o=q;w=32002}}else{c[r>>2]=0;o=0;w=32002}while(0);if(!ja){if(!j){X=b[n+6>>1]|0;r=X<<16>>16;q=g+36|0;c[q>>2]=r;if(X<<16>>16==32002){r=xe(f)|0;c[q>>2]=r}if((w|0)==32002){p=r;h=r}else{p=r;h=(d[n+8>>0]&((w|0)>(r|0)?2:1)|0)==0?r:w}}else{if((c[g+-32>>2]|0)==65)h=34-(c[g+-8>>2]|0)|0;else h=xe(f)|0;c[g+36>>2]=h;r=a[1069924]|0;q=jv(na|0,oa|0,48)|0;if(!((F|0)==0?(q|0)==(e[n>>1]|0):0))b[n+2>>1]=0;b[n>>1]=q;b[n+4>>1]=32002;b[n+6>>1]=h;a[n+8>>0]=r;a[n+9>>0]=-6;p=h}q=g+40|0;if(!(a[q>>0]|0)){r=c[s>>2]|0;if(((!((c[r+64>>2]|0)!=0|(p|0)==32002)?(t=c[g+-8>>2]|0,(t|0)!=32002):0)?(u=c[g+-32>>2]|0,!((u|0)==0|(u|0)==65)):0)?(u&49152|0)==0:0){X=u&63;W=0-(t+p)|0;X=1059720+(c[f+(X<<2)>>2]<<8)+(X<<2)|0;V=(c[X>>2]|0)+-1|0;c[X>>2]=(V|0)>(W|0)?V:W}if(((k|0)<7?(v=h+(ba(k,-200)|0)|0,(v|0)>=(ka|0)&(h|0)<1e4):0)?(c[r+(c[f+2212>>2]<<2)+16>>2]|0)!=0:0){da=v;i=ra;return da|0}if(!((k|0)<5|(o|0)!=0)){a[q>>0]=1;Tg(f,g,m,ka,k+-2|0,1)|0;a[q>>0]=0;r=Fh(1069912,na,oa,x)|0;if(!(a[x>>0]|0)){o=0;X=r}else{o=e[r+2>>1]|0;X=r}}else X=n}else X=n}else{c[g+36>>2]=32002;X=n}x=c[g+-32>>2]&63;W=c[f+(x<<2)>>2]|0;c[ea>>2]=c[1020280+(W<<9)+(x<<3)>>2];V=ea+4|0;c[V>>2]=c[1020280+(W<<9)+(x<<3)+4>>2];x=c[g+-76>>2]&63;W=c[f+(x<<2)>>2]|0;c[y>>2]=c[1028472+(W<<9)+(x<<3)>>2];c[y+4>>2]=c[1028472+(W<<9)+(x<<3)+4>>2];Gf(fa,f,o,k,1055552,ea,y,g);Tf(da,f);x=c[la>>2]|0;W=g+36|0;U=c[W>>2]|0;r=c[g+-52>>2]|0;r=(U|0)>=(r|0)|(U|0)==32002|(r|0)==32002;if(((k|0)>7&(o|0)!=0?!((((w|0)>-1?w:0-w|0)|0)>9999|aa):0)?(a[X+8>>0]&2)!=0:0)U=(a[X+9>>0]|0)>=(k+-3|0);else U=0;v=Kf(fa)|0;do if(v){S=g+48|0;T=da+8|0;D=w-(k<<1)|0;E=g+40|0;G=D+-1|0;H=(k|0)/2|0;I=k+-1|0;J=(k|0)>2;K=l^1;L=0-ka|0;M=g+4|0;N=ca+852|0;O=ca+856|0;P=g+24|0;Q=g+28|0;R=(k|0)>63?63:k;t=r&1;z=g+32|0;A=(k|0)<16;B=1053048+(t<<6)+(k<<2)|0;C=f+2212|0;s=0;j=0;u=x;a:while(1){b:do if((v|0)!=($|0)){r=s+1|0;c[S>>2]=0;x=v&49152;p=(x|0)==0;if(p){x=v&63;y=(c[f+(x<<2)>>2]|0)!=0;q=da;if((c[q>>2]|0)==0&(c[q+4>>2]|0)==0){w=da+((c[f+((v>>>6&63)<<2)>>2]&7)<<3)+16|0;n=46496+(x<<3)|0;x=c[n>>2]&c[w>>2];w=c[n+4>>2]&c[w+4>>2];n=y}else qa=55}else{y=(x|0)!=49152;qa=55}if((qa|0)==55){qa=0;x=(fg(f,v,da)|0)&1;w=0;n=y}q=(x|0)!=0|(w|0)!=0;if(!q)if(p){y=v>>>6&63;if((c[f+(y<<2)>>2]&7|0)==1){w=((c[C>>2]|0)*7^y>>>3|0)<4;y=0}else{w=1;y=0}}else{w=0;y=0}else{w=0;y=(mg(f,v)|0)>>>31^1}do if(U?!((v|0)!=(o|0)|(y|0)!=0):0){h=T;if(!(dg(f,o,c[h>>2]|0,c[h+4>>2]|0)|0)){y=0;x=u;break}c[_>>2]=o;a[E>>0]=1;x=Og(f,g,G,D,H,l)|0;a[E>>0]=0;c[_>>2]=0;y=(x|0)<(D|0)&1}else x=u;while(0);h=I+y|0;do if(!(n|ja)){u=c[la>>2]|0;if(!(w&(u|0)>-31872))break;if(A?(r|0)>=(c[B>>2]|0):0)break b;y=h-(a[((r|0)>63?63:r)+(1044856+(t<<12)+(R<<6))>>0]|0)|0;if((y|0)>=7)break;w=(y*200|0)+128+(c[W>>2]|0)+(c[1059720+(c[f+((v>>>6&63)<<2)>>2]<<8)+((v&63)<<2)>>2]|0)|0;if((w|0)<=(m|0)){c[la>>2]=(u|0)<(w|0)?w:u;break b}if((y|0)>=4)break;if((mg(f,v)|0)<0)break b}while(0);u=T;if(dg(f,v,c[u>>2]|0,c[u+4>>2]|0)|0){c[Z>>2]=v;if((j|0)<64&(n^1)){c[ia+(j<<2)>>2]=v;j=j+1|0}hg(f,v,ha,da,q);y=(s|0)>0;do if(!(n|J&y^1)){if((v|0)==(c[P>>2]|0)){qa=94;break}if((v|0)==(c[Q>>2]|0)){qa=94;break}x=a[((r|0)>63?63:r)+(1044856+(t<<12)+(R<<6))>>0]|0;c[z>>2]=x;y=v&63;w=c[f+(y<<2)>>2]|0;if((c[1055552+(w<<8)+(y<<2)>>2]|0)<0){x=x+1|0;c[z>>2]=x}if((v|0)==(c[ea>>2]|0)?1:(v|0)==(c[V>>2]|0)){x=x+-1|0;x=(x|0)>0?x:0;c[z>>2]=x}do if(!((x|0)==0|p^1|(w&7|0)==1)){p=(ng(f,y<<6|v>>>6&63)|0)<0;x=c[z>>2]|0;if(!p)break;x=x+-1|0;x=(x|0)>0?x:0;c[z>>2]=x}while(0);x=h-x|0;w=~m;y=0-m|0;x=0-(Og(f,Y,w,y,(x|0)<1?1:x,1)|0)|0;do if((m|0)<(x|0)){if((c[z>>2]|0)<4)break;x=h+-2|0;x=0-(Og(f,Y,w,y,(x|0)<1?1:x,1)|0)|0}while(0);if((x|0)>(m|0)){p=(c[z>>2]|0)==0;c[z>>2]=0;if(p)break;else{x=w;qa=96;break}}else{c[z>>2]=0;break}}else qa=94;while(0);do if((qa|0)==94){qa=0;if(!y)break;y=0-m|0;x=~m;qa=96}while(0);do if((qa|0)==96){qa=0;if((h|0)>=1){x=0-(Og(f,Y,x,y,h,K)|0)|0;break}if(q){x=0-(Pg(f,Y,x,y,0)|0)|0;break}else{x=0-(Qg(f,Y,x,y,0)|0)|0;break}}while(0);if((s|0)!=0?!((x|0)>(m|0)&(x|0)<(ka|0)):0)u=x;else qa=103;do if((qa|0)==103){qa=0;c[S>>2]=ga;c[ga>>2]=0;x=0-m|0;if((h|0)>=1){u=0-(Tg(f,Y,L,x,h,0)|0)|0;break}if(q){u=0-(Rg(f,Y,L,x,0)|0)|0;break}else{u=0-(Sg(f,Y,L,x,0)|0)|0;break}}while(0);ig(f,v);if(a[1017944]|0){m=0;qa=145;break a}if(qh(ca)|0){m=0;qa=145;break a}do if((u|0)>(c[la>>2]|0)){c[la>>2]=u;if((u|0)<=(m|0))break;c[pa>>2]=v;x=c[M>>2]|0;y=c[S>>2]|0;c[x>>2]=v;s=x+4|0;do if(y){w=c[y>>2]|0;if(!w)break;else v=s;while(1){y=y+4|0;c[v>>2]=w;s=x+8|0;w=c[y>>2]|0;if(!w)break;else{x=v;v=s}}}while(0);c[s>>2]=0;if((u|0)<(ka|0))m=u;else{qa=123;break a}}while(0);if((c[267459]|0)>(k|0)?1:(c[267457]|0)-(c[267456]|0)>>2>>>0<2){x=u;break}if((c[N>>2]|0)!=0?(a[(c[N>>2]|0)+56>>0]|0)!=0:0){x=u;break}if((c[O>>2]|0)>=8){x=u;break}sh(ca,f,g,m,ka,la,pa,k,r,fa,1,l);if(a[1017944]|0){m=0;qa=145;break a}if(qh(ca)|0){m=0;qa=145;break a}if((c[la>>2]|0)<(ka|0))x=u;else{qa=123;break a}}else r=s}else{r=s;x=u}while(0);v=Kf(fa)|0;if(!v){qa=123;break}else{s=r;u=x}}if((qa|0)==123){if(!r){qa=124;break}q=c[la>>2]|0;if((q|0)<(ka|0)){r=q;break}p=c[pa>>2]|0;h=p&49152;if(!h)h=(c[f+((p&63)<<2)>>2]|0)!=0;else h=(h|0)!=49152;if(h|ja){r=q;break}dh(f,g,p,k,ia,j+-1|0);r=c[la>>2]|0;break}else if((qa|0)==145){i=ra;return m|0}}else qa=124;while(0);if((qa|0)==124){do if(!aa)if(ja){m=(c[ma>>2]|0)+-32e3|0;break}else{m=c[1053192+(c[f+2212>>2]<<2)>>2]|0;break}while(0);c[la>>2]=m;r=m}m=c[ma>>2]|0;if((r|0)>31871)q=m+r|0;else q=r-((r|0)<-31871?m:0)|0;p=c[pa>>2]|0;if((r|0)<(ka|0))h=(p|0)!=0?3:1;else h=2;o=c[W>>2]|0;j=a[1069924]|0;n=jv(na|0,oa|0,48)|0;if(!p){m=n&65535;if(!((F|0)==0?(n|0)==(e[X>>1]|0):0))qa=143}else{m=n&65535;qa=143}if((qa|0)==143)b[X+2>>1]=p;b[X>>1]=m;b[X+4>>1]=q;b[X+6>>1]=o;a[X+8>>0]=j&255|h;a[X+9>>0]=k;da=r;i=ra;return da|0}if((c[ma>>2]|0)<128|ja){da=c[1053192+(c[f+2212>>2]<<2)>>2]|0;i=ra;return da|0}else{da=xe(f)|0;i=ra;return da|0}return 0}function Ug(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;m=a+8|0;g=c[m>>2]|0;n=a+4|0;f=c[n>>2]|0;e=f;if(g-e>>2>>>0>=b>>>0){d=b;e=f;while(1){if(e)c[e>>2]=0;d=d+-1|0;if(!d)break;else e=e+4|0}c[n>>2]=f+(b<<2);return}l=c[a>>2]|0;d=(e-l>>2)+b|0;if(d>>>0>1073741823)Jo(a);h=l;e=g-h|0;if(e>>2>>>0<536870911){f=e>>1;f=f>>>0<d>>>0?d:f;g=(c[n>>2]|0)-h|0;h=g>>2;if(!f){j=0;i=0;d=h}else k=11}else{g=(c[n>>2]|0)-h|0;f=1073741823;h=g>>2;k=11}if((k|0)==11){j=f;i=ut(f<<2)|0;d=h}f=b;h=i+(d<<2)|0;while(1){if(h)c[h>>2]=0;f=f+-1|0;if(!f)break;else h=h+4|0}mv(i|0,l|0,g|0)|0;e=c[a>>2]|0;c[a>>2]=i;c[n>>2]=i+(d+b<<2);c[m>>2]=i+(j<<2);if(!e)return;xt(e);return}function Vg(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=1055536;cd(a+816|0);e=c[a+804>>2]|0;if(e){d=a+808|0;b=c[d>>2]|0;if((b|0)!=(e|0))c[d>>2]=b+(~((b+-32-e|0)>>>5)<<5);xt(e)}b=c[a+792>>2]|0;if(!b){c[a>>2]=1063824;return}d=a+796|0;e=c[d>>2]|0;if((e|0)!=(b|0))c[d>>2]=e+(~(((e+-112-b|0)>>>0)/112|0)*112|0);xt(b);c[a>>2]=1063824;return}function Wg(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=1055536;cd(a+816|0);e=c[a+804>>2]|0;if(e){d=a+808|0;b=c[d>>2]|0;if((b|0)!=(e|0))c[d>>2]=b+(~((b+-32-e|0)>>>5)<<5);xt(e)}b=c[a+792>>2]|0;if(!b){xt(a);return}d=a+796|0;e=c[d>>2]|0;if((e|0)!=(b|0))c[d>>2]=e+(~(((e+-112-b|0)>>>0)/112|0)*112|0);xt(b);xt(a);return}function Xg(a){a=a|0;c[a>>2]=1063824;return}function Yg(a){a=a|0;xt(a);return}function Zg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;n=c[a>>2]|0;o=a+4|0;d=c[o>>2]|0;p=b+4|0;e=c[p>>2]|0;if((d|0)==(n|0)){m=e;k=n;c[a>>2]=m;c[p>>2]=k;k=b+8|0;m=c[o>>2]|0;l=c[k>>2]|0;c[o>>2]=l;c[k>>2]=m;k=a+8|0;m=b+12|0;l=c[k>>2]|0;j=c[m>>2]|0;c[k>>2]=j;c[m>>2]=l;m=c[p>>2]|0;c[b>>2]=m;return}while(1){f=d;d=d+-20|0;h=d;l=c[h+4>>2]|0;i=e+-20|0;c[i>>2]=c[h>>2];c[i+4>>2]=l;i=e+-12|0;c[i>>2]=0;l=e+-8|0;c[l>>2]=0;h=e+-4|0;c[h>>2]=0;j=f+-8|0;f=f+-12|0;g=(c[j>>2]|0)-(c[f>>2]|0)|0;e=g>>2;if(e){if(e>>>0>1073741823){q=4;break}k=ut(g)|0;c[l>>2]=k;c[i>>2]=k;c[h>>2]=k+(e<<2);h=c[f>>2]|0;f=c[j>>2]|0;if((h|0)!=(f|0)){e=h;g=k;while(1){c[g>>2]=c[e>>2];e=e+4|0;if((e|0)==(f|0))break;else g=g+4|0}c[l>>2]=k+(((f+-4-h|0)>>>2)+1<<2)}}e=(c[p>>2]|0)+-20|0;c[p>>2]=e;if((d|0)==(n|0)){m=e;break}}if((q|0)==4)Jo(i);k=c[a>>2]|0;c[a>>2]=m;c[p>>2]=k;k=b+8|0;m=c[o>>2]|0;l=c[k>>2]|0;c[o>>2]=l;c[k>>2]=m;k=a+8|0;m=b+12|0;l=c[k>>2]|0;j=c[m>>2]|0;c[k>>2]=j;c[m>>2]=l;m=c[p>>2]|0;c[b>>2]=m;return}function _g(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;n=i;i=i+32|0;d=n+24|0;l=n+12|0;m=n;if((a[1069816]|0)==0?(Ia(1069816)|0)!=0:0){Tb(d|0,0)|0;j=c[d>>2]|0;j=uv(j|0,((j|0)<0)<<31>>31|0,1e3,0)|0;k=(c[d+4>>2]|0)/1e3|0;j=iv(k|0,((k|0)<0)<<31>>31|0,j|0,F|0)|0;k=1069808;c[k>>2]=j;c[k+4>>2]=F;Sa(1069816)}d=c[254504]|0;e=c[d>>2]|0;g=b+4|0;f=c[g>>2]|0;h=e-(c[d+((f+-1|0)*20|0)>>2]|0)|0;h=(h|0)>198?198:h;j=120-(c[b>>2]<<1)|0;k=b+8|0;c[k>>2]=0;if(!f){m=c[k>>2]|0;i=n;return m|0}else{b=0;f=-32001}while(1){if(b){d=c[d+((b+-1|0)*20|0)>>2]|0;vi(l,1073112,25);d=(d|0)>(((Th(Bc(1072800,l)|0)|0)*198|0)+e|0);Bi(l);if(d){d=12;break}d=c[254504]|0}d=ba((c[d>>2]|0)-e|0,j)|0;o=1069808;p=c[o>>2]|0;o=c[o+4>>2]|0;q=jv(p|0,o|0,12)|0;p=q^p;o=F^o;q=ov(p|0,o|0,25)|0;p=q^p;o=F^o;q=jv(p|0,o|0,27)|0;p=q^p;o=F^o;q=1069808;c[q>>2]=p;c[q+4>>2]=o;o=uv(p|0,o|0,1332534557,625341585)|0;d=(ba((o>>>0)%(j>>>0)|0,h)|0)+d|0;vi(m,1073144,23);d=((d>>>0)/((Th(Bc(1072800,m)|0)|0)>>>0)|0)+e|0;Bi(m);if((d|0)>(f|0)){c[k>>2]=c[c[(c[254504]|0)+(b*20|0)+8>>2]>>2];f=d}b=b+1|0;if(b>>>0>=(c[g>>2]|0)>>>0){d=12;break}e=c[254504]|0;d=e;e=c[e+(b*20|0)>>2]|0}if((d|0)==12){m=c[k>>2]|0;i=n;return m|0}return 0}function $g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;l=b;e=d-l>>2;k=a+8|0;g=c[k>>2]|0;j=c[a>>2]|0;h=j;if(e>>>0<=g-h>>2>>>0){i=a+4|0;f=(c[i>>2]|0)-h|0;g=f>>2;if(e>>>0<=g>>>0){e=d-l|0;nv(j|0,b|0,e|0)|0;e=j+(e>>2<<2)|0;b=c[i>>2]|0;if((b|0)==(e|0))return;c[i>>2]=b+(~((b+-4-e|0)>>>2)<<2);return}e=b+(g<<2)|0;nv(j|0,b|0,f|0)|0;if((e|0)==(d|0))return;f=c[i>>2]|0;g=(d+-4-e|0)>>>2;b=e;e=f;while(1){if(e)c[e>>2]=c[b>>2];b=b+4|0;if((b|0)==(d|0))break;else e=e+4|0}c[i>>2]=f+(g+1<<2);return}if(j){g=a+4|0;f=c[g>>2]|0;if((f|0)!=(j|0))c[g>>2]=f+(~((f+-4-h|0)>>>2)<<2);xt(j);c[k>>2]=0;c[g>>2]=0;c[a>>2]=0;g=0}if(e>>>0>1073741823)Jo(a);g=g-0|0;if(g>>2>>>0<536870911){g=g>>1;g=g>>>0<e>>>0?e:g;if(g>>>0>1073741823)Jo(a);else i=g}else i=1073741823;f=ut(i<<2)|0;h=a+4|0;c[h>>2]=f;c[a>>2]=f;c[k>>2]=f+(i<<2);if((b|0)==(d|0))return;g=(d+-4-l|0)>>>2;e=f;while(1){c[e>>2]=c[b>>2];b=b+4|0;if((b|0)==(d|0))break;else e=e+4|0}c[h>>2]=f+(g+1<<2);return}function ah(d,f,g,j,k){d=d|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;na=i;i=i+3152|0;ba=na+3128|0;$=na+2608|0;ea=na+2352|0;aa=na+88|0;ja=na+2348|0;ha=na+2344|0;t=na+3136|0;Z=na+2336|0;u=na+2328|0;_=na+176|0;Y=na;U=na+160|0;X=c[d+2216>>2]|0;l=d+2220|0;o=c[l>>2]|0;fa=o+56|0;fa=(c[fa>>2]|0)!=0|(c[fa+4>>2]|0)!=0;c[ha>>2]=-32001;q=(c[f+-36>>2]|0)+1|0;ga=f+8|0;c[ga>>2]=q;p=X+848|0;if((c[p>>2]|0)<(q|0))c[p>>2]=q;c[ja>>2]=0;R=f+44|0;c[f+64>>2]=0;q=f+16|0;c[q>>2]=0;S=f+12|0;c[S>>2]=0;a[f+84>>0]=0;c[f+76>>2]=0;c[f+116>>2]=0;c[f+112>>2]=0;T=c[f+20>>2]|0;da=(T|0)!=0;if(da){ka=Sf(d)|0;la=F}else{la=o+48|0;ka=c[la>>2]|0;la=c[la+4>>2]|0}m=Fh(1069912,ka,la,t)|0;p=c[c[(c[254504]|0)+((c[264912]|0)*20|0)+8>>2]>>2]|0;c[q>>2]=p;if(!fa){if(a[t>>0]|0){ca=b[m+6>>1]|0;q=ca<<16>>16;o=f+36|0;c[o>>2]=q;if(ca<<16>>16==32002){q=xe(d)|0;c[o>>2]=q}}else{if((c[f+-32>>2]|0)==65)q=34-(c[f+-8>>2]|0)|0;else q=xe(d)|0;c[f+36>>2]=q;o=a[1069924]|0;n=jv(ka|0,la|0,48)|0;if(!((F|0)==0?(n|0)==(e[m>>1]|0):0))b[m+2>>1]=0;b[m>>1]=n;b[m+4>>1]=32002;b[m+6>>1]=q;a[m+8>>0]=o;a[m+9>>0]=-6}o=f+40|0;if(!(a[o>>0]|0)){if(((!((q|0)==32002?1:(c[(c[l>>2]|0)+64>>2]|0)!=0)?(r=c[f+-8>>2]|0,(r|0)!=32002):0)?(s=c[f+-32>>2]|0,!((s|0)==0|(s|0)==65)):0)?(s&49152|0)==0:0){ca=s&63;Q=0-(r+q)|0;ca=1059720+(c[d+(ca<<2)>>2]<<8)+(ca<<2)|0;P=(c[ca>>2]|0)+-1|0;c[ca>>2]=(P|0)>(Q|0)?P:Q}if(!((k|0)<5|(p|0)!=0)){a[o>>0]=1;Tg(d,f,g,j,k+-2|0,1)|0;a[o>>0]=0;q=Fh(1069912,ka,la,t)|0;if(!(a[t>>0]|0)){p=0;ca=q}else{p=e[q+2>>1]|0;ca=q}}else ca=m}else ca=m}else{c[f+36>>2]=32002;ca=m}l=c[f+-32>>2]&63;Q=c[d+(l<<2)>>2]|0;c[Z>>2]=c[1020280+(Q<<9)+(l<<3)>>2];P=Z+4|0;c[P>>2]=c[1020280+(Q<<9)+(l<<3)+4>>2];l=c[f+-76>>2]&63;Q=c[d+(l<<2)>>2]|0;c[u>>2]=c[1028472+(Q<<9)+(l<<3)>>2];c[u+4>>2]=c[1028472+(Q<<9)+(l<<3)+4>>2];Gf(_,d,p,k,1055552,Z,u,f);Tf(Y,d);l=c[ha>>2]|0;Q=f+36|0;t=c[Q>>2]|0;s=c[f+-52>>2]|0;u=Kf(_)|0;do if(u){A=ba+4|0;B=d+2224|0;C=U+1|0;D=U+8|0;E=U+4|0;G=f+48|0;H=k+-1|0;I=(k|0)>2;J=0-j|0;K=X+852|0;L=X+856|0;M=f+24|0;N=f+28|0;O=(k|0)>63?63:k;y=((t|0)>=(s|0)|(t|0)==32002|(s|0)==32002)&1;z=f+32|0;t=0;n=0;v=l;a:while(1){m=u;while(1){if((m|0)!=(T|0)?(V=(c[254504]|0)+((c[264912]|0)*20|0)|0,W=c[254505]|0,(V|0)!=(W|0)):0){l=V;u=0;do{u=((c[c[l+8>>2]>>2]|0)==(m|0)&1)+u|0;l=l+20|0}while((l|0)!=(W|0));if(u)break}m=Kf(_)|0;if(!m){q=t;ma=113;break a}}q=t+1|0;x=(t|0)==0;a[1017946]=x&1;u=c[267456]|0;if((c[267457]|0)==(u|0)){ma=35;break}if((X|0)==(c[u>>2]|0)?(Tb(ba|0,0)|0,r=c[ba>>2]|0,r=uv(r|0,((r|0)<0)<<31>>31|0,1e3,0)|0,s=(c[A>>2]|0)/1e3|0,r=iv(s|0,((s|0)<0)<<31>>31|0,r|0,F|0)|0,s=1020264,s=hv(r|0,F|0,c[s>>2]|0,c[s+4>>2]|0)|0,r=F,(r|0)>0|(r|0)==0&s>>>0>3e3):0){l=Ec(mk(Ec(ef(1073416,0)|0,1059656,11)|0,k)|0,1059672,10)|0;Mh(U,m,(a[B>>0]|0)!=0);u=a[U>>0]|0;if(!(u&1)){o=C;u=(u&255)>>>1}else{o=c[D>>2]|0;u=c[E>>2]|0}s=Ec(Ec(l,o,u)|0,1059688,16)|0;s=nk(s,(c[264912]|0)+q|0)|0;hj(ba,s+(c[(c[s>>2]|0)+-12>>2]|0)|0);r=Zo(ba,1077904)|0;r=oc[c[(c[r>>2]|0)+28>>2]&63](r,10)|0;Wo(ba);rk(s,r)|0;Wj(s)|0;ef(s,1)|0;Bi(U)}c[G>>2]=0;u=m&49152;r=(u|0)==0;if(r){u=m&63;l=(c[d+(u<<2)>>2]|0)!=0;s=Y;if((c[s>>2]|0)==0&(c[s+4>>2]|0)==0){p=Y+((c[d+((m>>>6&63)<<2)>>2]&7)<<3)+16|0;u=46496+(u<<3)|0;o=c[u>>2]&c[p>>2];p=c[u+4>>2]&c[p+4>>2];u=l}else{u=l;ma=46}}else{u=(u|0)!=49152;ma=46}if((ma|0)==46){ma=0;o=(fg(d,m,Y)|0)&1;p=0}s=(o|0)!=0|(p|0)!=0;if(s)l=(mg(d,m)|0)>>>31^1;else l=0;p=H+l|0;c[S>>2]=m;if((n|0)<64&(u^1)){c[ea+(n<<2)>>2]=m;n=n+1|0}hg(d,m,aa,Y,s);w=(t|0)>0;do if((!(u|I&w^1)?(m|0)!=(c[M>>2]|0):0)?(m|0)!=(c[N>>2]|0):0){u=a[((q|0)>63?63:q)+(1044856+(y<<12)+(O<<6))>>0]|0;c[z>>2]=u;l=m&63;o=c[d+(l<<2)>>2]|0;if((c[1055552+(o<<8)+(l<<2)>>2]|0)<0){u=u+1|0;c[z>>2]=u}if((m|0)==(c[Z>>2]|0)?1:(m|0)==(c[P>>2]|0)){u=u+-1|0;u=(u|0)>0?u:0;c[z>>2]=u}if(!((u|0)==0|r^1|(o&7|0)==1)){t=(ng(d,l<<6|m>>>6&63)|0)<0;u=c[z>>2]|0;if(t){u=u+-1|0;u=(u|0)>0?u:0;c[z>>2]=u}}u=p-u|0;o=~g;l=0-g|0;u=0-(Og(d,R,o,l,(u|0)<1?1:u,1)|0)|0;do if((g|0)<(u|0)){if((c[z>>2]|0)<4)break;u=p+-2|0;u=0-(Og(d,R,o,l,(u|0)<1?1:u,1)|0)|0}while(0);if((u|0)>(g|0)){t=(c[z>>2]|0)==0;c[z>>2]=0;if(t)break;else{u=o;ma=69;break}}else{c[z>>2]=0;break}}else ma=67;while(0);if((ma|0)==67){ma=0;if(w){l=0-g|0;u=~g;ma=69}else u=v}do if((ma|0)==69){ma=0;if((p|0)>=1){u=0-(Og(d,R,u,l,p,1)|0)|0;break}if(s){u=0-(Pg(d,R,u,l,0)|0)|0;break}else{u=0-(Qg(d,R,u,l,0)|0)|0;break}}while(0);do if(x|(u|0)>(g|0)){c[G>>2]=$;c[$>>2]=0;u=0-g|0;if((p|0)>=1){v=0-(Tg(d,R,J,u,p,0)|0)|0;break}if(s){v=0-(Rg(d,R,J,u,0)|0)|0;break}else{v=0-(Sg(d,R,J,u,0)|0)|0;break}}else v=u;while(0);ig(d,m);if(a[1017944]|0){g=0;ma=135;break}if(qh(X)|0){g=0;ma=135;break}u=c[254504]|0;l=c[254505]|0;b:do if((u|0)!=(l|0))while(1){if((c[c[u+8>>2]>>2]|0)==(m|0))break b;u=u+20|0;if((u|0)==(l|0)){u=l;break}}while(0);t=(v|0)>(g|0);do if(x|t){c[u>>2]=v;r=u+8|0;s=u+12|0;p=c[s>>2]|0;l=c[r>>2]|0;o=p-l>>2;do if(!o)Ug(r,1);else{if(o>>>0<=1)break;l=l+4|0;if((p|0)==(l|0))break;c[s>>2]=p+(~((p+-4-l|0)>>>2)<<2)}while(0);o=c[G>>2]|0;l=c[o>>2]|0;if(l){p=u+16|0;do{u=c[s>>2]|0;if((u|0)==(c[p>>2]|0))Ng(r,o);else{if(u)c[u>>2]=l;c[s>>2]=u+4}o=o+4|0;l=c[o>>2]|0}while((l|0)!=0)}if(!w)break;h[132464]=+h[132464]+1.0}else c[u>>2]=-32001;while(0);if((v|0)>(c[ha>>2]|0)?(c[ha>>2]=v,t):0){c[ja>>2]=m;if((v|0)<(j|0))g=v;else{ma=113;break}}do if(!((c[267459]|0)>(k|0)?1:(c[267457]|0)-(c[267456]|0)>>2>>>0<2)){if((c[K>>2]|0)!=0?(a[(c[K>>2]|0)+56>>0]|0)!=0:0)break;if((c[L>>2]|0)>=8)break;sh(X,d,f,g,j,ha,ja,k,q,_,0,0);if(a[1017944]|0){g=0;ma=135;break a}if(qh(X)|0){g=0;ma=135;break a}if((c[ha>>2]|0)>=(j|0)){ma=113;break a}}while(0);u=Kf(_)|0;if(!u){ma=113;break}else t=q}if((ma|0)==35)Ko(1069824);else if((ma|0)==113){if(!q){ma=114;break}q=c[ha>>2]|0;if((q|0)<(j|0)){ia=q;break}o=c[ja>>2]|0;p=o&49152;if(!p)p=(c[d+((o&63)<<2)>>2]|0)!=0;else p=(p|0)!=49152;if(p|fa){ia=q;break}dh(d,f,o,k,ea,n+-1|0);ia=c[ha>>2]|0;break}else if((ma|0)==135){i=na;return g|0}}else ma=114;while(0);if((ma|0)==114){do if(!da)if(fa){g=(c[ga>>2]|0)+-32e3|0;break}else{g=c[1053192+(c[d+2212>>2]<<2)>>2]|0;break}while(0);c[ha>>2]=g;ia=g}g=c[ga>>2]|0;if((ia|0)>31871)q=g+ia|0;else q=ia-((ia|0)<-31871?g:0)|0;o=c[ja>>2]|0;if((ia|0)<(j|0))p=(o|0)!=0?3:1;else p=2;m=c[Q>>2]|0;n=a[1069924]|0;l=jv(ka|0,la|0,48)|0;if(!o){g=l&65535;if(!((F|0)==0?(l|0)==(e[ca>>1]|0):0))ma=133}else{g=l&65535;ma=133}if((ma|0)==133)b[ca+2>>1]=o;b[ca>>1]=g;b[ca+4>>1]=q;b[ca+6>>1]=m;a[ca+8>>0]=n&255|p;a[ca+9>>0]=k;ca=ia;i=na;return ca|0}function bh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=i;i=i+96|0;z=A;l=A+80|0;k=A+76|0;r=A+72|0;h=A+68|0;q=A+64|0;s=A+60|0;t=A+56|0;u=A+52|0;v=A+48|0;w=A+44|0;x=A+40|0;y=A+36|0;m=A+32|0;n=A+28|0;o=A+24|0;p=A+20|0;if((e|0)==1|(e|0)==0){i=A;return}else if((e|0)==2){p=c[b>>2]|0;q=p+-20|0;c[b>>2]=q;m=c[a>>2]|0;if((c[q>>2]|0)<=(c[m>>2]|0)){i=A;return}j=m;r=c[j+4>>2]|0;k=z;c[k>>2]=c[j>>2];c[k+4>>2]=r;k=z+8|0;c[k>>2]=0;r=z+12|0;c[r>>2]=0;j=z+16|0;c[j>>2]=0;n=c[m+12>>2]|0;o=c[m+8>>2]|0;l=n-o|0;f=l>>2;if(f){if(f>>>0>1073741823)Jo(k);h=ut(l)|0;c[r>>2]=h;c[k>>2]=h;c[j>>2]=h+(f<<2);if((o|0)!=(n|0)){j=n+-4|0;l=o;k=h;while(1){c[k>>2]=c[l>>2];l=l+4|0;if((l|0)==(n|0))break;else k=k+4|0}c[r>>2]=h+(((j-o|0)>>>2)+1<<2)}}d=q;a=c[d+4>>2]|0;b=m;c[b>>2]=c[d>>2];c[b+4>>2]=a;if((m|0)!=(q|0))$g(m+8|0,c[p+-12>>2]|0,c[p+-8>>2]|0);d=z;a=c[d+4>>2]|0;b=q;c[b>>2]=c[d>>2];c[b+4>>2]=a;if((z|0)==(q|0))h=z+8|0;else{h=z+8|0;$g(p+-12|0,c[h>>2]|0,c[r>>2]|0)}h=c[h>>2]|0;if(!h){i=A;return}f=c[r>>2]|0;if((f|0)!=(h|0))c[r>>2]=f+(~((f+-4-h|0)>>>2)<<2);xt(h);i=A;return}else{if((e|0)<1){c[r>>2]=c[a>>2];c[h>>2]=c[b>>2];c[l+0>>2]=c[r+0>>2];c[z+0>>2]=c[h+0>>2];eh(l,z,d);i=A;return}j=(e|0)/2|0;r=c[a>>2]|0;h=r+(j*20|0)|0;if((e|0)>(g|0)){c[w>>2]=r;c[x>>2]=h;c[l+0>>2]=c[w+0>>2];c[z+0>>2]=c[x+0>>2];bh(l,z,d,j,f,g);c[y>>2]=h;a=c[b>>2]|0;c[m>>2]=a;b=e-j|0;c[l+0>>2]=c[y+0>>2];c[z+0>>2]=c[m+0>>2];bh(l,z,d,b,f,g);c[n>>2]=r;c[o>>2]=h;c[p>>2]=a;c[k+0>>2]=c[n+0>>2];c[l+0>>2]=c[o+0>>2];c[z+0>>2]=c[p+0>>2];hh(k,l,z,d,j,b,f,g);i=A;return}c[q>>2]=r;c[s>>2]=h;c[l+0>>2]=c[q+0>>2];c[z+0>>2]=c[s+0>>2];fh(l,z,d,j,f);c[t>>2]=h;c[u>>2]=c[b>>2];b=f+(j*20|0)|0;c[l+0>>2]=c[t+0>>2];c[z+0>>2]=c[u+0>>2];fh(l,z,d,e-j|0,b);c[v>>2]=r;c[z+0>>2]=c[v+0>>2];gh(f,b,b,f+(e*20|0)|0,z,d);if((f|0)==0|(e|0)==0){i=A;return}else l=0;while(1){h=c[f+8>>2]|0;if(h){j=f+12|0;k=c[j>>2]|0;if((k|0)!=(h|0))c[j>>2]=k+(~((k+-4-h|0)>>>2)<<2);xt(h)}l=l+1|0;if((l|0)==(e|0))break;else f=f+20|0}i=A;return}}function ch(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=i;i=i+208|0;n=M+184|0;L=M+40|0;h=M+24|0;C=M+12|0;E=M;G=L+64|0;J=L+8|0;c[J>>2]=1000312;K=L+12|0;c[L>>2]=1000460;c[G>>2]=1000480;c[L+4>>2]=0;ij(L+64|0,K);c[L+136>>2]=0;c[L+140>>2]=-1;c[L>>2]=1000292;c[G>>2]=1000332;c[J>>2]=1000312;nj(K);c[K>>2]=1000496;D=L+44|0;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[D+12>>2]=0;c[L+60>>2]=24;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Ae(K,n);Bi(n);Tb(n|0,0)|0;o=c[n>>2]|0;o=uv(o|0,((o|0)<0)<<31>>31|0,1e3,0)|0;n=(c[n+4>>2]|0)/1e3|0;H=1020264;I=c[H>>2]|0;H=c[H+4>>2]|0;n=iv(o|1|0,F|0,n|0,((n|0)<0)<<31>>31|0)|0;H=hv(n|0,F|0,I|0,H|0)|0;I=F;vi(h,1073088,7);n=Th(Bc(1072800,h)|0)|0;o=((c[254505]|0)-(c[254504]|0)|0)/20|0;m=o>>>0<n>>>0?o:n;Bi(h);h=c[267457]|0;l=c[267456]|0;if((h|0)==(l|0))h=0;else{j=h-l>>2;k=0;h=0;do{B=c[(c[l+(k<<2)>>2]|0)+848>>2]|0;h=(B|0)>(h|0)?B:h;k=k+1|0}while(k>>>0<j>>>0)}if(!m){Ce(b,K);c[L>>2]=1000292;c[G>>2]=1000332;c[J>>2]=1000312;c[K>>2]=1000496;Bi(D);kj(K);C=L+64|0;fj(C);i=M;return}w=(e|0)!=1;x=L+24|0;y=L+28|0;z=L+8|0;A=C+1|0;B=d+2200|0;q=d+2224|0;r=E+1|0;s=E+8|0;t=E+4|0;u=C+8|0;v=C+4|0;m=~n;p=~o;p=~(m>>>0>p>>>0?m:p);m=0;do{k=m>>>0<=(c[264912]|0)>>>0;if(w|k){o=c[254504]|0;o=c[(k?o+(m*20|0)|0:o+(m*20|0)+4|0)>>2]|0;d=c[x>>2]|0;l=c[y>>2]|0;if(d>>>0<l>>>0)d=l-d|0;else d=fc[c[(c[K>>2]|0)+28>>2]&127](K)|0;if(d)Ec(z,1072280,1)|0;n=m+1|0;k=Ec(nk(Ec(mk(Ec(mk(Ec(z,1059656,11)|0,((k^1)<<31>>31)+e|0)|0,1069712,10)|0,h)|0,1069728,9)|0,n)|0,1069744,7)|0;Lh(C,o);d=a[C>>0]|0;if(!(d&1)){l=A;d=(d&255)>>>1}else{l=c[u>>2]|0;d=c[v>>2]|0}Ec(k,l,d)|0;Bi(C);if((m|0)==(c[264912]|0)){if((o|0)<(g|0))l=(o|0)<=(f|0)?1069768:1076616;else l=1069752;Ec(z,l,lv(l|0)|0)|0}j=Ec(z,1069784,7)|0;k=B;k=Ec(pk(j,c[k>>2]|0,c[k+4>>2]|0)|0,1069792,5)|0;j=B;j=uv(c[j>>2]|0,c[j+4>>2]|0,1e3,0)|0;j=vv(j|0,F|0,H|0,I|0)|0;Ec(ok(Ec(pk(k,j,F)|0,1053240,6)|0,H,I)|0,1069800,3)|0;j=c[254504]|0;if((c[j+(m*20|0)+12>>2]|0)==(c[j+(m*20|0)+8>>2]|0))m=n;else{j=0;do{l=Ec(z,1072408,1)|0;Mh(E,c[(c[(c[254504]|0)+(m*20|0)+8>>2]|0)+(j<<2)>>2]|0,(a[q>>0]|0)!=0);d=a[E>>0]|0;if(!(d&1)){k=r;d=(d&255)>>>1}else{k=c[s>>2]|0;d=c[t>>2]|0}Ec(l,k,d)|0;Bi(E);j=j+1|0;k=c[254504]|0}while(j>>>0<(c[k+(m*20|0)+12>>2]|0)-(c[k+(m*20|0)+8>>2]|0)>>2>>>0);m=n}}else m=m+1|0}while((m|0)!=(p|0));Ce(b,K);c[L>>2]=1000292;c[G>>2]=1000332;c[J>>2]=1000312;c[K>>2]=1000496;Bi(D);kj(K);C=L+64|0;fj(C);i=M;return}function dh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;j=b+24|0;i=c[j>>2]|0;if((i|0)!=(d|0)){c[b+28>>2]=i;c[j>>2]=d}h=ba(e,e)|0;j=1055552+(c[a+((d>>>6&63)<<2)>>2]<<8)+((d&63)<<2)|0;i=(c[j>>2]|0)+h|0;if((((i|0)>-1?i:0-i|0)|0)<250)c[j>>2]=i;if((g|0)>0){e=0;do{j=c[f+(e<<2)>>2]|0;j=1055552+(c[a+((j>>>6&63)<<2)>>2]<<8)+((j&63)<<2)|0;i=(c[j>>2]|0)-h|0;if((((i|0)>-1?i:0-i|0)|0)<250)c[j>>2]=i;e=e+1|0}while((e|0)!=(g|0))}j=c[b+-32>>2]|0;if(((j>>>6^j)&63|0)!=0?(k=j&63,l=c[a+(k<<2)>>2]|0,m=1020280+(l<<9)+(k<<3)|0,n=c[m>>2]|0,(n|0)!=(d|0)):0){c[1020280+(l<<9)+(k<<3)+4>>2]=n;c[m>>2]=d}h=c[b+-76>>2]|0;if(!((h>>>6^h)&63))return;if((j|0)!=(c[b+-28>>2]|0))return;j=h&63;h=c[a+(j<<2)>>2]|0;e=1028472+(h<<9)+(j<<3)|0;i=c[e>>2]|0;if((i|0)==(d|0))return;c[1028472+(h<<9)+(j<<3)+4>>2]=i;c[e>>2]=d;return}function eh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;r=i;i=i+32|0;q=r;o=c[a>>2]|0;k=c[b>>2]|0;if((o|0)==(k|0)){i=r;return}b=o+20|0;if((b|0)==(k|0)){i=r;return}p=q+8|0;l=q+12|0;m=q+16|0;n=q+8|0;j=o;while(1){a=b;d=c[a+4>>2]|0;f=q;c[f>>2]=c[a>>2];c[f+4>>2]=d;c[p>>2]=0;c[l>>2]=0;c[m>>2]=0;f=j+32|0;d=j+28|0;a=(c[f>>2]|0)-(c[d>>2]|0)|0;e=a>>2;if(e){if(e>>>0>1073741823){d=6;break}h=ut(a)|0;c[l>>2]=h;c[p>>2]=h;c[m>>2]=h+(e<<2);g=c[d>>2]|0;f=c[f>>2]|0;if((g|0)!=(f|0)){a=f+-4|0;e=g;d=h;while(1){c[d>>2]=c[e>>2];e=e+4|0;if((e|0)==(f|0))break;else d=d+4|0}c[l>>2]=h+(((a-g|0)>>>2)+1<<2)}}a:do if((b|0)==(o|0))a=o;else{d=b;while(1){a=d;d=d+-20|0;if((c[q>>2]|0)<=(c[d>>2]|0))break a;f=d;g=c[f+4>>2]|0;h=a;c[h>>2]=c[f>>2];c[h+4>>2]=g;$g(a+8|0,c[a+-12>>2]|0,c[a+-8>>2]|0);if((d|0)==(o|0)){a=o;break}}}while(0);f=q;g=c[f+4>>2]|0;h=a;c[h>>2]=c[f>>2];c[h+4>>2]=g;if((a|0)!=(q|0))$g(a+8|0,c[n>>2]|0,c[l>>2]|0);a=c[n>>2]|0;if(a){d=c[l>>2]|0;if((d|0)!=(a|0))c[l>>2]=d+(~((d+-4-a|0)>>>2)<<2);xt(a)}a=j+40|0;if((a|0)==(k|0)){d=21;break}else{j=b;b=a}}if((d|0)==6)Jo(p);else if((d|0)==21){i=r;return}}function fh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=i;i=i+64|0;m=J+52|0;n=J+48|0;o=J+44|0;p=J+40|0;l=J+36|0;k=J+32|0;j=J+28|0;h=J+24|0;g=J+20|0;q=J+16|0;r=J+12|0;s=J+8|0;t=J+4|0;u=J;if((e|0)==1){if(!f){i=J;return}j=c[a>>2]|0;l=j;o=c[l+4>>2]|0;g=f;c[g>>2]=c[l>>2];c[g+4>>2]=o;g=f+8|0;c[g>>2]=0;o=f+12|0;c[o>>2]=0;l=f+16|0;c[l>>2]=0;m=j+12|0;j=j+8|0;k=(c[m>>2]|0)-(c[j>>2]|0)|0;h=k>>2;if(!h){i=J;return}if(h>>>0>1073741823)Jo(g);n=ut(k)|0;c[o>>2]=n;c[g>>2]=n;c[l>>2]=n+(h<<2);l=c[j>>2]|0;k=c[m>>2]|0;if((l|0)==(k|0)){i=J;return}j=k+-4|0;g=l;h=n;while(1){c[h>>2]=c[g>>2];g=g+4|0;if((g|0)==(k|0))break;else h=h+4|0}c[o>>2]=n+(((j-l|0)>>>2)+1<<2);i=J;return}else if((e|0)==2){p=c[b>>2]|0;n=p+-20|0;c[b>>2]=n;g=c[a>>2]|0;o=(f|0)==0;if((c[n>>2]|0)>(c[g>>2]|0)){if(!o?(C=n,I=c[C+4>>2]|0,B=f,c[B>>2]=c[C>>2],c[B+4>>2]=I,B=f+8|0,c[B>>2]=0,I=f+12|0,c[I>>2]=0,C=f+16|0,c[C>>2]=0,G=p+-8|0,D=p+-12|0,w=(c[G>>2]|0)-(c[D>>2]|0)|0,E=w>>2,(E|0)!=0):0){if(E>>>0>1073741823)Jo(B);o=ut(w)|0;c[I>>2]=o;c[B>>2]=o;c[C>>2]=o+(E<<2);h=c[D>>2]|0;m=c[G>>2]|0;if((h|0)!=(m|0)){k=m+-4|0;l=h;j=o;while(1){c[j>>2]=c[l>>2];l=l+4|0;if((l|0)==(m|0))break;else j=j+4|0}c[I>>2]=o+(((k-h|0)>>>2)+1<<2)}}l=g;o=c[l+4>>2]|0;m=f+20|0;c[m>>2]=c[l>>2];c[m+4>>2]=o;m=f+28|0;c[m>>2]=0;o=f+32|0;c[o>>2]=0;l=f+36|0;c[l>>2]=0;h=g+12|0;k=g+8|0;g=(c[h>>2]|0)-(c[k>>2]|0)|0;j=g>>2;if(!j){i=J;return}if(j>>>0>1073741823)Jo(m);n=ut(g)|0;c[o>>2]=n;c[m>>2]=n;c[l>>2]=n+(j<<2);l=c[k>>2]|0;h=c[h>>2]|0;if((l|0)==(h|0)){i=J;return}j=h+-4|0;g=l;k=n;while(1){c[k>>2]=c[g>>2];g=g+4|0;if((g|0)==(h|0))break;else k=k+4|0}c[o>>2]=n+(((j-l|0)>>>2)+1<<2);i=J;return}else{if(!o?(y=g,H=c[y+4>>2]|0,x=f,c[x>>2]=c[y>>2],c[x+4>>2]=H,x=f+8|0,c[x>>2]=0,H=f+12|0,c[H>>2]=0,y=f+16|0,c[y>>2]=0,F=g+12|0,z=g+8|0,v=(c[F>>2]|0)-(c[z>>2]|0)|0,A=v>>2,(A|0)!=0):0){if(A>>>0>1073741823)Jo(x);o=ut(v)|0;c[H>>2]=o;c[x>>2]=o;c[y>>2]=o+(A<<2);h=c[z>>2]|0;l=c[F>>2]|0;if((h|0)!=(l|0)){k=l+-4|0;m=h;j=o;while(1){c[j>>2]=c[m>>2];m=m+4|0;if((m|0)==(l|0))break;else j=j+4|0}c[H>>2]=o+(((k-h|0)>>>2)+1<<2)}}h=n;o=c[h+4>>2]|0;m=f+20|0;c[m>>2]=c[h>>2];c[m+4>>2]=o;m=f+28|0;c[m>>2]=0;o=f+32|0;c[o>>2]=0;h=f+36|0;c[h>>2]=0;g=p+-8|0;l=p+-12|0;k=(c[g>>2]|0)-(c[l>>2]|0)|0;j=k>>2;if(!j){i=J;return}if(j>>>0>1073741823)Jo(m);n=ut(k)|0;c[o>>2]=n;c[m>>2]=n;c[h>>2]=n+(j<<2);l=c[l>>2]|0;k=c[g>>2]|0;if((l|0)==(k|0)){i=J;return}j=k+-4|0;g=l;h=n;while(1){c[h>>2]=c[g>>2];g=g+4|0;if((g|0)==(k|0))break;else h=h+4|0}c[o>>2]=n+(((j-l|0)>>>2)+1<<2);i=J;return}}else if(e)if((e|0)<9){c[l>>2]=c[a>>2];c[k>>2]=c[b>>2];c[n+0>>2]=c[l+0>>2];c[m+0>>2]=c[k+0>>2];ih(n,m,f,d);i=J;return}else{k=(e|0)/2|0;w=c[a>>2]|0;x=w+(k*20|0)|0;c[j>>2]=w;c[h>>2]=x;c[n+0>>2]=c[j+0>>2];c[m+0>>2]=c[h+0>>2];bh(n,m,d,k,f,k);c[g>>2]=x;y=c[b>>2]|0;c[q>>2]=y;v=e-k|0;c[n+0>>2]=c[g+0>>2];c[m+0>>2]=c[q+0>>2];bh(n,m,d,v,f+(k*20|0)|0,v);c[r>>2]=w;c[s>>2]=x;c[t>>2]=x;c[u>>2]=y;c[p+0>>2]=c[r+0>>2];c[o+0>>2]=c[s+0>>2];c[n+0>>2]=c[t+0>>2];c[m+0>>2]=c[u+0>>2];jh(p,o,n,m,f,d);i=J;return}else{i=J;return}}function gh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;a:do if((a|0)!=(b|0)){g=a;while(1){if((d|0)==(e|0)){d=g;break}a=c[f>>2]|0;if((c[d>>2]|0)>(c[g>>2]|0)){j=d;i=c[j+4>>2]|0;h=a;c[h>>2]=c[j>>2];c[h+4>>2]=i;if((a|0)!=(d|0))$g(a+8|0,c[d+8>>2]|0,c[d+12>>2]|0);d=d+20|0}else{j=g;i=c[j+4>>2]|0;h=a;c[h>>2]=c[j>>2];c[h+4>>2]=i;if((a|0)!=(g|0))$g(a+8|0,c[g+8>>2]|0,c[g+12>>2]|0);g=g+20|0}c[f>>2]=a+20;if((g|0)==(b|0))break a}if((d|0)==(b|0))return;h=c[f>>2]|0;a=(((b+-20-d|0)>>>0)/20|0)+1|0;g=h;while(1){j=d;i=c[j+4>>2]|0;e=g;c[e>>2]=c[j>>2];c[e+4>>2]=i;if((g|0)!=(d|0))$g(g+8|0,c[d+8>>2]|0,c[d+12>>2]|0);d=d+20|0;if((d|0)==(b|0))break;else g=g+20|0}c[f>>2]=h+(a*20|0);return}while(0);if((d|0)==(e|0))return;h=c[f>>2]|0;a=(((e+-20-d|0)>>>0)/20|0)+1|0;g=h;while(1){j=d;i=c[j+4>>2]|0;b=g;c[b>>2]=c[j>>2];c[b+4>>2]=i;if((g|0)!=(d|0))$g(g+8|0,c[d+8>>2]|0,c[d+12>>2]|0);d=d+20|0;if((d|0)==(e|0))break;else g=g+20|0}c[f>>2]=h+(a*20|0);return}function hh(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;K=i;i=i+80|0;J=K;E=K+76|0;F=K+72|0;u=K+68|0;v=K+64|0;z=K+60|0;G=K+56|0;H=K+52|0;I=K+48|0;A=K+44|0;B=K+40|0;C=K+36|0;D=K+32|0;w=K+28|0;x=K+24|0;y=K+20|0;if((g|0)==0|(f|0)==0){i=K;return}q=c[a>>2]|0;o=c[b>>2]|0;a:while(1){r=c[o>>2]|0;while(1){if((r|0)>(c[q>>2]|0))break;q=q+20|0;c[a>>2]=q;f=f+-1|0;if(!f){p=49;break a}}if(!((f|0)>(j|0)&(g|0)>(j|0))){p=7;break}if((f|0)<(g|0)){t=(g|0)/2|0;k=o+(t*20|0)|0;if((o|0)==(q|0)){p=q;r=o}else{p=q;l=c[k>>2]|0;r=q;n=(o-p|0)/20|0;do{m=(n|0)/2|0;if((l|0)>(c[r+(m*20|0)>>2]|0))n=m;else{r=r+((m+1|0)*20|0)|0;n=n+-1-m|0}}while((n|0)!=0)}s=r;n=(r-p|0)/20|0;p=t}else{if((f|0)==1){g=q;f=o;p=17;break}t=(f|0)/2|0;s=q+(t*20|0)|0;r=c[d>>2]|0;if((r|0)==(o|0)){p=o;r=o}else{l=o;k=c[s>>2]|0;m=o;p=(r-l|0)/20|0;while(1){n=(p|0)/2|0;if((c[m+(n*20|0)>>2]|0)>(k|0)){r=m+((n+1|0)*20|0)|0;p=p+-1-n|0}else{r=m;p=n}if(!p){p=l;break}else m=r}}k=r;n=t;p=(r-p|0)/20|0}f=f-n|0;g=g-p|0;do if((s|0)!=(o|0))if((o|0)==(k|0)){c[A>>2]=s;r=s;break}else{c[u>>2]=s;c[v>>2]=o;c[z>>2]=k;c[F+0>>2]=c[u+0>>2];c[E+0>>2]=c[v+0>>2];c[J+0>>2]=c[z+0>>2];lh(A,F,E,J);r=c[A>>2]|0;break}else{c[A>>2]=k;r=k}while(0);c[b>>2]=r;if((p+n|0)<(g+f|0)){c[B>>2]=q;c[C>>2]=s;c[D>>2]=r;c[F+0>>2]=c[B+0>>2];c[E+0>>2]=c[C+0>>2];c[J+0>>2]=c[D+0>>2];hh(F,E,J,e,n,p,h,j);c[a>>2]=r;q=r;o=k}else{c[w>>2]=r;c[x>>2]=k;c[y>>2]=c[d>>2];c[F+0>>2]=c[w+0>>2];c[E+0>>2]=c[x+0>>2];c[J+0>>2]=c[y+0>>2];hh(F,E,J,e,f,g,h,j);c[d>>2]=r;f=n;g=p;o=s}c[b>>2]=o;if((g|0)==0|(f|0)==0){p=49;break}}if((p|0)==7){c[G>>2]=q;c[H>>2]=o;c[I>>2]=c[d>>2];c[F+0>>2]=c[G+0>>2];c[E+0>>2]=c[H+0>>2];c[J+0>>2]=c[I+0>>2];kh(F,E,J,e,f,g,h);i=K;return}else if((p|0)==17){k=g;r=c[k+4>>2]|0;m=J;c[m>>2]=c[k>>2];c[m+4>>2]=r;m=J+8|0;c[m>>2]=0;r=J+12|0;c[r>>2]=0;k=J+16|0;c[k>>2]=0;p=c[g+12>>2]|0;q=c[g+8>>2]|0;l=p-q|0;n=l>>2;if(n){if(n>>>0>1073741823)Jo(m);o=ut(l)|0;c[r>>2]=o;c[m>>2]=o;c[k>>2]=o+(n<<2);if((q|0)!=(p|0)){m=p+-4|0;l=q;k=o;while(1){c[k>>2]=c[l>>2];l=l+4|0;if((l|0)==(p|0))break;else k=k+4|0}c[r>>2]=o+(((m-q|0)>>>2)+1<<2)}}B=f;C=c[B+4>>2]|0;D=g;c[D>>2]=c[B>>2];c[D+4>>2]=C;if((g|0)!=(f|0))$g(g+8|0,c[f+8>>2]|0,c[f+12>>2]|0);B=J;C=c[B+4>>2]|0;D=f;c[D>>2]=c[B>>2];c[D+4>>2]=C;if((J|0)==(f|0))k=J+8|0;else{k=J+8|0;$g(f+8|0,c[k>>2]|0,c[r>>2]|0)}k=c[k>>2]|0;if(!k){i=K;return}l=c[r>>2]|0;if((l|0)!=(k|0))c[r>>2]=l+(~((l+-4-k|0)>>>2)<<2);xt(k);i=K;return}else if((p|0)==49){i=K;return}}function ih(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;m=c[a>>2]|0;n=c[b>>2]|0;if((m|0)==(n|0))return;if(d){g=m;k=c[g+4>>2]|0;h=d;c[h>>2]=c[g>>2];c[h+4>>2]=k;h=d+8|0;c[h>>2]=0;k=d+12|0;c[k>>2]=0;g=d+16|0;c[g>>2]=0;j=m+12|0;e=m+8|0;f=(c[j>>2]|0)-(c[e>>2]|0)|0;i=f>>2;if(i){if(i>>>0>1073741823)Jo(h);l=ut(f)|0;c[k>>2]=l;c[h>>2]=l;c[g>>2]=l+(i<<2);i=c[e>>2]|0;e=c[j>>2]|0;if((i|0)!=(e|0)){g=e+-4|0;f=i;h=l;while(1){c[h>>2]=c[f>>2];f=f+4|0;if((f|0)==(e|0))break;else h=h+4|0}c[k>>2]=l+(((g-i|0)>>>2)+1<<2);e=d}else e=d}else e=d}else e=0;f=m+20|0;c[a>>2]=f;if((f|0)==(n|0))return;else{p=m;q=f;o=e}while(1){e=o;o=o+20|0;if((c[p+20>>2]|0)>(c[e>>2]|0)){i=e;n=c[i+4>>2]|0;k=o;c[k>>2]=c[i>>2];c[k+4>>2]=n;k=e+28|0;c[k>>2]=0;n=e+32|0;c[n>>2]=0;i=e+36|0;c[i>>2]=0;l=e+12|0;h=e+8|0;j=(c[l>>2]|0)-(c[h>>2]|0)|0;g=j>>2;if(g){if(g>>>0>1073741823){f=14;break}m=ut(j)|0;c[n>>2]=m;c[k>>2]=m;c[i>>2]=m+(g<<2);f=c[h>>2]|0;j=c[l>>2]|0;if((f|0)!=(j|0)){h=j+-4|0;i=f;g=m;while(1){c[g>>2]=c[i>>2];i=i+4|0;if((i|0)==(j|0))break;else g=g+4|0}c[n>>2]=m+(((h-f|0)>>>2)+1<<2)}}a:do if((e|0)==(d|0))f=d;else while(1){f=e;e=e+-20|0;if((c[q>>2]|0)<=(c[e>>2]|0))break a;l=e;m=c[l+4>>2]|0;n=f;c[n>>2]=c[l>>2];c[n+4>>2]=m;$g(f+8|0,c[f+-12>>2]|0,c[f+-8>>2]|0);if((e|0)==(d|0)){f=d;break}}while(0);l=q;m=c[l+4>>2]|0;n=f;c[n>>2]=c[l>>2];c[n+4>>2]=m;if((f|0)!=(q|0))$g(f+8|0,c[q+8>>2]|0,c[q+12>>2]|0)}else{i=q;n=c[i+4>>2]|0;k=o;c[k>>2]=c[i>>2];c[k+4>>2]=n;k=e+28|0;c[k>>2]=0;n=e+32|0;c[n>>2]=0;i=e+36|0;c[i>>2]=0;j=p+32|0;g=p+28|0;h=(c[j>>2]|0)-(c[g>>2]|0)|0;f=h>>2;if(f){if(f>>>0>1073741823){f=27;break}l=ut(h)|0;c[n>>2]=l;c[k>>2]=l;c[i>>2]=l+(f<<2);i=c[g>>2]|0;g=c[j>>2]|0;if((i|0)!=(g|0)){f=g+-4|0;h=i;e=l;while(1){c[e>>2]=c[h>>2];h=h+4|0;if((h|0)==(g|0))break;else e=e+4|0}c[n>>2]=l+(((f-i|0)>>>2)+1<<2)}}}e=p+40|0;if((e|0)==(c[b>>2]|0)){f=33;break}else{p=q;q=e}}if((f|0)==14)Jo(k);else if((f|0)==27)Jo(k);else if((f|0)==33){c[a>>2]=e;return}}function jh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;j=c[a>>2]|0;i=c[b>>2]|0;a:do if((j|0)!=(i|0)){p=c[e>>2]|0;g=f;while(1){h=c[d>>2]|0;if((h|0)==(p|0)){m=g;C=i;k=j;g=14;break}f=(g|0)==0;if((c[h>>2]|0)>(c[j>>2]|0)){if(!f?(r=h,q=c[r+4>>2]|0,D=g,c[D>>2]=c[r>>2],c[D+4>>2]=q,D=g+8|0,c[D>>2]=0,q=g+12|0,c[q>>2]=0,r=g+16|0,c[r>>2]=0,s=h+12|0,t=h+8|0,u=(c[s>>2]|0)-(c[t>>2]|0)|0,v=u>>2,(v|0)!=0):0){if(v>>>0>1073741823){g=28;break}f=ut(u)|0;c[q>>2]=f;c[D>>2]=f;c[r>>2]=f+(v<<2);i=c[t>>2]|0;h=c[s>>2]|0;if((i|0)!=(h|0)){n=h+-4|0;j=i;o=f;while(1){c[o>>2]=c[j>>2];j=j+4|0;if((j|0)==(h|0))break;else o=o+4|0}c[q>>2]=f+(((n-i|0)>>>2)+1<<2)}}c[d>>2]=(c[d>>2]|0)+20;j=c[a>>2]|0}else{if(!f?(x=j,w=c[x+4>>2]|0,E=g,c[E>>2]=c[x>>2],c[E+4>>2]=w,E=g+8|0,c[E>>2]=0,w=g+12|0,c[w>>2]=0,x=g+16|0,c[x>>2]=0,y=j+12|0,z=j+8|0,A=(c[y>>2]|0)-(c[z>>2]|0)|0,B=A>>2,(B|0)!=0):0){if(B>>>0>1073741823){g=37;break}o=ut(A)|0;c[w>>2]=o;c[E>>2]=o;c[x>>2]=o+(B<<2);n=c[z>>2]|0;f=c[y>>2]|0;if((n|0)!=(f|0)){i=f+-4|0;j=n;h=o;while(1){c[h>>2]=c[j>>2];j=j+4|0;if((j|0)==(f|0))break;else h=h+4|0}c[w>>2]=o+(((i-n|0)>>>2)+1<<2)}}j=(c[a>>2]|0)+20|0;c[a>>2]=j}g=g+20|0;i=c[b>>2]|0;if((j|0)==(i|0)){l=g;break a}}if((g|0)==14){if((k|0)==(C|0))return;while(1){if((m|0)!=0?(H=k,G=c[H+4>>2]|0,F=m,c[F>>2]=c[H>>2],c[F+4>>2]=G,F=m+8|0,c[F>>2]=0,G=m+12|0,c[G>>2]=0,H=m+16|0,c[H>>2]=0,I=k+12|0,J=k+8|0,K=(c[I>>2]|0)-(c[J>>2]|0)|0,L=K>>2,(L|0)!=0):0){if(L>>>0>1073741823){g=18;break}g=ut(K)|0;c[G>>2]=g;c[F>>2]=g;c[H>>2]=g+(L<<2);j=c[J>>2]|0;f=c[I>>2]|0;if((j|0)!=(f|0)){i=f+-4|0;k=j;h=g;while(1){c[h>>2]=c[k>>2];k=k+4|0;if((k|0)==(f|0))break;else h=h+4|0}c[G>>2]=g+(((i-j|0)>>>2)+1<<2)}}k=(c[a>>2]|0)+20|0;c[a>>2]=k;if((k|0)==(c[b>>2]|0)){g=44;break}else m=m+20|0}if((g|0)==18)Jo(F);else if((g|0)==44)return}else if((g|0)==28)Jo(D);else if((g|0)==37)Jo(E)}else l=f;while(0);h=c[d>>2]|0;if((h|0)==(c[e>>2]|0))return;while(1){if((l|0)!=0?(O=h,N=c[O+4>>2]|0,M=l,c[M>>2]=c[O>>2],c[M+4>>2]=N,M=l+8|0,c[M>>2]=0,N=l+12|0,c[N>>2]=0,O=l+16|0,c[O>>2]=0,P=h+12|0,Q=h+8|0,R=(c[P>>2]|0)-(c[Q>>2]|0)|0,S=R>>2,(S|0)!=0):0){if(S>>>0>1073741823){g=7;break}i=ut(R)|0;c[N>>2]=i;c[M>>2]=i;c[O>>2]=i+(S<<2);f=c[Q>>2]|0;j=c[P>>2]|0;if((f|0)!=(j|0)){g=j+-4|0;h=f;k=i;while(1){c[k>>2]=c[h>>2];h=h+4|0;if((h|0)==(j|0))break;else k=k+4|0}c[N>>2]=i+(((g-f|0)>>>2)+1<<2)}}h=(c[d>>2]|0)+20|0;c[d>>2]=h;if((h|0)==(c[e>>2]|0)){g=44;break}else l=l+20|0}if((g|0)==7)Jo(M);else if((g|0)==44)return}function kh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;aa=i;i=i+128|0;Y=aa+120|0;X=aa+112|0;$=aa+104|0;_=aa+96|0;Z=aa+88|0;W=aa+80|0;J=aa+76|0;K=aa+72|0;O=aa+68|0;P=aa+64|0;Q=aa+60|0;R=aa+56|0;S=aa+24|0;T=aa+16|0;U=aa+8|0;V=aa;L=aa+48|0;M=aa+40|0;N=aa+32|0;if((f|0)>(g|0)){m=c[b>>2]|0;do if((m|0)!=(c[d>>2]|0)){n=0;l=h;while(1){if((l|0)!=0?(q=m,p=c[q+4>>2]|0,D=l,c[D>>2]=c[q>>2],c[D+4>>2]=p,D=l+8|0,c[D>>2]=0,p=l+12|0,c[p>>2]=0,q=l+16|0,c[q>>2]=0,r=m+12|0,z=m+8|0,A=(c[r>>2]|0)-(c[z>>2]|0)|0,B=A>>2,(B|0)!=0):0){if(B>>>0>1073741823){f=18;break}s=ut(A)|0;c[p>>2]=s;c[D>>2]=s;c[q>>2]=s+(B<<2);j=c[z>>2]|0;k=c[r>>2]|0;if((j|0)!=(k|0)){o=k+-4|0;f=j;g=s;while(1){c[g>>2]=c[f>>2];f=f+4|0;if((f|0)==(k|0))break;else g=g+4|0}c[p>>2]=s+(((o-j|0)>>>2)+1<<2)}}n=n+1|0;m=m+20|0;l=l+20|0;if((m|0)==(c[d>>2]|0)){f=24;break}}if((f|0)==18)Jo(D);else if((f|0)==24){H=n;I=c[b>>2]|0;F=m;E=l;break}}else{H=0;I=m;F=m;E=h}while(0);n=I;b=S;c[b>>2]=n;c[b+4>>2]=n;b=c[a>>2]|0;n=T;c[n>>2]=b;c[n+4>>2]=b;n=E;b=U;c[b>>2]=n;c[b+4>>2]=n;b=h;n=V;c[n>>2]=b;c[n+4>>2]=b;c[L>>2]=F;c[L+4>>2]=F;c[M>>2]=e;c[W+0>>2]=c[S+0>>2];c[W+4>>2]=c[S+4>>2];c[Z+0>>2]=c[T+0>>2];c[Z+4>>2]=c[T+4>>2];c[_+0>>2]=c[U+0>>2];c[_+4>>2]=c[U+4>>2];c[$+0>>2]=c[V+0>>2];c[$+4>>2]=c[V+4>>2];c[X+0>>2]=c[L+0>>2];c[X+4>>2]=c[L+4>>2];c[Y+0>>2]=c[M+0>>2];nh(N,W,Z,_,$,X,Y);n=H}else{k=c[a>>2]|0;do if((k|0)!=(c[b>>2]|0)){j=0;o=h;while(1){if((o|0)!=0?(u=k,t=c[u+4>>2]|0,C=o,c[C>>2]=c[u>>2],c[C+4>>2]=t,C=o+8|0,c[C>>2]=0,t=o+12|0,c[t>>2]=0,u=o+16|0,c[u>>2]=0,v=k+12|0,w=k+8|0,x=(c[v>>2]|0)-(c[w>>2]|0)|0,y=x>>2,(y|0)!=0):0){if(y>>>0>1073741823){f=6;break}q=ut(x)|0;c[t>>2]=q;c[C>>2]=q;c[u>>2]=q+(y<<2);r=c[w>>2]|0;s=c[v>>2]|0;if((r|0)!=(s|0)){g=s+-4|0;p=r;f=q;while(1){c[f>>2]=c[p>>2];p=p+4|0;if((p|0)==(s|0))break;else f=f+4|0}c[t>>2]=q+(((g-r|0)>>>2)+1<<2)}}j=j+1|0;k=k+20|0;o=o+20|0;if((k|0)==(c[b>>2]|0)){n=j;m=k;l=o;f=12;break}}if((f|0)==6)Jo(C);else if((f|0)==12){G=c[a>>2]|0;break}}else{n=0;m=k;G=k;l=h}while(0);c[J>>2]=h;c[K>>2]=l;c[O>>2]=m;c[P>>2]=c[d>>2];c[Q>>2]=G;c[Z+0>>2]=c[J+0>>2];c[_+0>>2]=c[K+0>>2];c[$+0>>2]=c[O+0>>2];c[X+0>>2]=c[P+0>>2];c[Y+0>>2]=c[Q+0>>2];mh(R,Z,_,$,X,Y,e)}if((h|0)==0|(n|0)==0){i=aa;return}else{j=n;m=0}while(1){l=c[h+8>>2]|0;if(l){j=h+12|0;k=c[j>>2]|0;if((k|0)!=(l|0))c[j>>2]=k+(~((k+-4-l|0)>>>2)<<2);xt(l);j=n}m=m+1|0;if(m>>>0>=j>>>0)break;else h=h+20|0}i=aa;return}function lh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=i;i=i+32|0;x=z;r=x+8|0;s=x+12|0;t=x+16|0;q=x+8|0;v=c[e>>2]|0;p=c[d>>2]|0;h=c[b>>2]|0;a:while(1){e=p;o=h;while(1){k=o;n=c[k+4>>2]|0;h=x;c[h>>2]=c[k>>2];c[h+4>>2]=n;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;h=c[o+12>>2]|0;n=c[o+8>>2]|0;k=h-n|0;l=k>>2;if(l){if(l>>>0>1073741823){y=5;break a}j=ut(k)|0;c[s>>2]=j;c[r>>2]=j;c[t>>2]=j+(l<<2);if((n|0)!=(h|0)){k=h+-4|0;m=n;l=j;while(1){c[l>>2]=c[m>>2];m=m+4|0;if((m|0)==(h|0))break;else l=l+4|0}c[s>>2]=j+(((k-n|0)>>>2)+1<<2)}}k=e;j=c[k+4>>2]|0;h=o;c[h>>2]=c[k>>2];c[h+4>>2]=j;if((o|0)!=(e|0))$g(o+8|0,c[e+8>>2]|0,c[e+12>>2]|0);k=x;j=c[k+4>>2]|0;h=e;c[h>>2]=c[k>>2];c[h+4>>2]=j;if((x|0)!=(e|0))$g(e+8|0,c[q>>2]|0,c[s>>2]|0);h=c[q>>2]|0;if(h){j=c[s>>2]|0;if((j|0)!=(h|0))c[s>>2]=j+(~((j+-4-h|0)>>>2)<<2);xt(h)}h=o+20|0;e=e+20|0;if((e|0)==(v|0)){g=o;f=h;u=p;break a}if((h|0)==(p|0))break;else o=h}c[d>>2]=e;p=e}if((y|0)==5)Jo(r);c[b>>2]=f;c[a>>2]=f;if((f|0)==(u|0)){i=z;return}t=x+8|0;s=x+12|0;r=x+16|0;a=x+8|0;p=u;b:while(1){e=p;n=f;while(1){h=n;l=c[h+4>>2]|0;m=x;c[m>>2]=c[h>>2];c[m+4>>2]=l;c[t>>2]=0;c[s>>2]=0;c[r>>2]=0;m=c[g+32>>2]|0;l=c[g+28>>2]|0;h=m-l|0;f=h>>2;if(f){if(f>>>0>1073741823){y=26;break b}k=ut(h)|0;c[s>>2]=k;c[t>>2]=k;c[r>>2]=k+(f<<2);if((l|0)!=(m|0)){f=m+-4|0;j=l;h=k;while(1){c[h>>2]=c[j>>2];j=j+4|0;if((j|0)==(m|0))break;else h=h+4|0}c[s>>2]=k+(((f-l|0)>>>2)+1<<2)}}f=e;q=c[f+4>>2]|0;u=n;c[u>>2]=c[f>>2];c[u+4>>2]=q;if((n|0)!=(e|0))$g(g+28|0,c[e+8>>2]|0,c[e+12>>2]|0);f=x;q=c[f+4>>2]|0;u=e;c[u>>2]=c[f>>2];c[u+4>>2]=q;if((x|0)!=(e|0))$g(e+8|0,c[a>>2]|0,c[s>>2]|0);f=c[a>>2]|0;if(f){h=c[s>>2]|0;if((h|0)!=(f|0))c[s>>2]=h+(~((h+-4-f|0)>>>2)<<2);xt(f)}f=g+40|0;e=e+20|0;g=(f|0)==(p|0);if((e|0)==(v|0))if(g){w=p;break b}else{g=n;e=p;n=f;continue}else if(g){g=n;break}else{g=n;n=f;continue}}c[d>>2]=e;p=e}if((y|0)==26)Jo(t);c[b>>2]=w;i=z;return}function mh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=c[b>>2]|0;k=c[d>>2]|0;d=c[e>>2]|0;j=c[f>>2]|0;a:do if((i|0)==(k|0))f=c[g>>2]|0;else{while(1){if((d|0)==(j|0))break;h=c[g>>2]|0;if((c[d>>2]|0)>(c[i>>2]|0)){m=d;l=c[m+4>>2]|0;f=h;c[f>>2]=c[m>>2];c[f+4>>2]=l;if((h|0)!=(d|0))$g(h+8|0,c[d+8>>2]|0,c[d+12>>2]|0);d=d+20|0;c[e>>2]=d}else{m=i;l=c[m+4>>2]|0;f=h;c[f>>2]=c[m>>2];c[f+4>>2]=l;if((h|0)!=(i|0))$g(h+8|0,c[i+8>>2]|0,c[i+12>>2]|0);i=i+20|0;c[b>>2]=i}f=h+20|0;c[g>>2]=f;if((i|0)==(k|0))break a}f=c[g>>2]|0;if((i|0)!=(k|0)){h=((k+-20-i|0)>>>0)/20|0;d=f;while(1){e=i;j=c[e+4>>2]|0;g=d;c[g>>2]=c[e>>2];c[g+4>>2]=j;if((d|0)!=(i|0))$g(d+8|0,c[i+8>>2]|0,c[i+12>>2]|0);i=i+20|0;if((i|0)==(k|0))break;else d=d+20|0}f=f+((h+1|0)*20|0)|0}c[a>>2]=f;return}while(0);if((d|0)!=(j|0)){h=((j+-20-d|0)>>>0)/20|0;i=f;while(1){e=d;g=c[e+4>>2]|0;k=i;c[k>>2]=c[e>>2];c[k+4>>2]=g;if((i|0)!=(d|0))$g(i+8|0,c[d+8>>2]|0,c[d+12>>2]|0);d=d+20|0;if((d|0)==(j|0))break;else i=i+20|0}f=f+((h+1|0)*20|0)|0}c[a>>2]=f;return}function nh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;l=c[b+4>>2]|0;m=l;s=c[d+4>>2]|0;u=s;j=c[e+4>>2]|0;h=c[f+4>>2]|0;do if((m|0)!=(u|0)){o=h;p=e+4|0;q=b+4|0;r=g+4|0;d=j;i=j;f=l;while(1){if((d|0)==(o|0)){h=m;break}m=c[p>>2]|0;d=m+-20|0;l=c[q>>2]|0;k=l+-20|0;j=c[r>>2]|0;n=j+-20|0;if((c[d>>2]|0)>(c[k>>2]|0)){d=k;m=c[d+4>>2]|0;f=n;c[f>>2]=c[d>>2];c[f+4>>2]=m;if((j|0)!=(l|0))$g(j+-12|0,c[l+-12>>2]|0,c[l+-8>>2]|0);c[q>>2]=k;f=c[b+4>>2]|0}else{i=d;k=c[i+4>>2]|0;l=n;c[l>>2]=c[i>>2];c[l+4>>2]=k;if((j|0)!=(m|0))$g(j+-12|0,c[m+-12>>2]|0,c[m+-8>>2]|0);c[p>>2]=d;i=c[e+4>>2]|0}c[r>>2]=n;m=f;if((m|0)==(u|0)){t=19;break}else d=i}if((t|0)==19){j=i;break}i=g;m=c[i>>2]|0;i=c[i+4>>2]|0;if((h|0)!=(u|0)){d=((h+-20+(0-s)|0)>>>0)/20|0;l=i;do{k=l;l=l+-20|0;j=h;h=h+-20|0;f=h;n=c[f+4>>2]|0;o=l;c[o>>2]=c[f>>2];c[o+4>>2]=n;if((k|0)!=(j|0))$g(k+-12|0,c[j+-12>>2]|0,c[j+-8>>2]|0)}while((h|0)!=(u|0));i=i+(~d*20|0)|0}o=a;c[o>>2]=m;c[o+4>>2]=i;return}while(0);i=g;f=c[i>>2]|0;i=c[i+4>>2]|0;m=h;if((j|0)!=(m|0)){l=((j+-20+(0-h)|0)>>>0)/20|0;d=i;do{h=d;d=d+-20|0;k=j;j=j+-20|0;p=j;n=c[p+4>>2]|0;o=d;c[o>>2]=c[p>>2];c[o+4>>2]=n;if((h|0)!=(k|0))$g(h+-12|0,c[k+-12>>2]|0,c[k+-8>>2]|0)}while((j|0)!=(m|0));i=i+(~l*20|0)|0}o=a;c[o>>2]=f;c[o+4>>2]=i;return}function oh(a){a=a|0;return}function ph(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;k=i;i=i+112|0;j=k;c[b>>2]=1063824;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;a[b+16>>0]=0;c[b>>2]=1055536;f=b+60|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;f=b+156|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;f=b+252|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;f=b+348|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;f=b+444|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;f=b+540|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;f=b+636|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;f=b+732|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;f=j+0|0;d=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(d|0));h=b+796|0;d=ut(1835008)|0;c[h>>2]=d;c[b+792>>2]=d;c[b+800>>2]=d+1835008;g=16384;do{f=d+0|0;e=j+0|0;d=f+112|0;do{c[f>>2]=c[e>>2];f=f+4|0;e=e+4|0}while((f|0)<(d|0));d=(c[h>>2]|0)+112|0;c[h>>2]=d;g=g+-1|0}while((g|0)!=0);c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;c[j+28>>2]=0;e=b+808|0;f=ut(262144)|0;c[e>>2]=f;c[b+804>>2]=f;c[b+812>>2]=f+262144;d=8192;do{c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];c[f+24>>2]=c[j+24>>2];c[f+28>>2]=c[j+28>>2];f=(c[e>>2]|0)+32|0;c[e>>2]=f;d=d+-1|0}while((d|0)!=0);bd(b+816|0);a[b+860>>0]=0;d=b+856|0;c[d>>2]=0;c[b+848>>2]=c[d>>2];c[b+852>>2]=0;c[b+840>>2]=0;c[b+844>>2]=(c[267457]|0)-(c[267456]|0)>>2;i=k;return}function qh(b){b=b|0;var d=0;b=c[b+852>>2]|0;if(!b){b=0;return b|0}while(1){if(a[b+88>>0]|0){b=1;d=4;break}b=c[b+32>>2]|0;if(!b){b=0;d=4;break}}if((d|0)==4)return b|0;return 0}function rh(a,b){a=a|0;b=b|0;return 0}function sh(b,d,e,f,g,h,i,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0;r=b+856|0;t=c[r>>2]|0;s=b+(t*96|0)+24|0;c[b+(t*96|0)+32>>2]=b;p=b+852|0;q=b+(t*96|0)+56|0;c[q>>2]=c[p>>2];u=b+(t*96|0)+64|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;u=c[b+844>>2]|0;o=b+(t*96|0)+(u>>>5<<2)+64|0;c[o>>2]=1<<(u&31)|c[o>>2];c[b+(t*96|0)+36>>2]=j;j=b+(t*96|0)+100|0;c[j>>2]=c[h>>2];o=b+(t*96|0)+104|0;c[o>>2]=c[i>>2];c[b+(t*96|0)+96>>2]=f;c[b+(t*96|0)+40>>2]=g;c[b+(t*96|0)+44>>2]=m;a[b+(t*96|0)+48>>0]=n&1;c[b+(t*96|0)+52>>2]=l;c[b+(t*96|0)+108>>2]=k;c[s>>2]=d;l=b+(t*96|0)+88|0;m=l;c[m>>2]=0;c[m+4>>2]=0;a[b+(t*96|0)+112>>0]=0;c[b+(t*96|0)+28>>2]=e;a[b+(t*96|0)+80>>0]=1;c[r>>2]=(c[r>>2]|0)+1;c[p>>2]=s;m=b+840|0;c[m>>2]=0;Hg(b);a[b+860>>0]=1;c[r>>2]=(c[r>>2]|0)+-1;c[p>>2]=c[q>>2];c[m>>2]=d;d=d+2200|0;m=d;m=iv(c[l>>2]|0,c[l+4>>2]|0,c[m>>2]|0,c[m+4>>2]|0)|0;c[d>>2]=m;c[d+4>>2]=F;c[i>>2]=c[o>>2];c[h>>2]=c[j>>2];return}function th(b){b=b|0;var c=0,d=0,e=0;c=b+16|0;if(a[c>>0]|0)return;d=b+17|0;e=b+8|0;b=b+4|0;do{if(!(a[c>>0]|0))gf(e,b,(a[d>>0]|0)!=0?5:2147483647);if(a[d>>0]|0)Ig()}while((a[c>>0]|0)==0);return}function uh(b){b=b|0;var c=0,d=0;c=b+16|0;if(a[c>>0]|0)return;d=b+861|0;b=b+860|0;do{a[d>>0]=0;do if(a[d>>0]|0)break;while((a[c>>0]|0)==0);if(!(a[c>>0]|0)){a[b>>0]=1;Dg();a[b>>0]=0}}while((a[c>>0]|0)==0);return}function vh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;h=i;i=i+16|0;d=h;f=ut(20)|0;c[f>>2]=1063824;c[f+4>>2]=0;c[f+8>>2]=0;g=f+12|0;c[g>>2]=0;a[f+16>>0]=0;c[f>>2]=1069888;a[f+17>>0]=0;c[g>>2]=0;c[b+24>>2]=f;f=ut(864)|0;ph(f);c[f>>2]=1069864;a[f+861>>0]=1;c[f+12>>2]=0;c[d>>2]=f;g=b+4|0;e=c[g>>2]|0;if((e|0)==(c[b+8>>2]|0)){zh(b,d);wh(b);i=h;return}if(!e)d=0;else{c[e>>2]=f;d=c[g>>2]|0}c[g>>2]=d+4;wh(b);i=h;return}function wh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;k=i;i=i+32|0;j=k+16|0;e=k+4|0;g=k;vi(j,1073032,15);d=b+12|0;c[d>>2]=Th(Bc(1072800,j)|0)|0;Bi(j);vi(e,1073048,7);j=Th(Bc(1072800,e)|0)|0;Bi(e);if(!(c[d>>2]|0))c[d>>2]=j>>>0<8?4:7;h=b+4|0;d=c[h>>2]|0;e=c[b>>2]|0;if(d-e>>2>>>0<j>>>0){f=b+8|0;do{e=ut(864)|0;ph(e);c[e+12>>2]=0;c[g>>2]=e;d=c[h>>2]|0;if((d|0)==(c[f>>2]|0)){zh(b,g);d=c[h>>2]|0}else{if(!d)e=0;else{c[d>>2]=e;e=c[h>>2]|0}d=e+4|0;c[h>>2]=d}e=c[b>>2]|0}while(d-e>>2>>>0<j>>>0)}if(d-e>>2>>>0<=j>>>0){i=k;return}do{d=c[d+-4>>2]|0;a[d+16>>0]=1;if(d)cc[c[(c[d>>2]|0)+4>>2]&255](d);d=(c[h>>2]|0)+-4|0;c[h>>2]=d}while(d-(c[b>>2]|0)>>2>>>0>j>>>0);i=k;return}function xh(a){a=a|0;return}function yh(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=i;i=i+2080|0;o=u+24|0;t=u;Tb(o|0,0)|0;b=c[o>>2]|0;b=uv(b|0,((b|0)<0)<<31>>31|0,1e3,0)|0;k=(c[o+4>>2]|0)/1e3|0;b=iv(k|0,((k|0)<0)<<31>>31|0,b|0,F|0)|0;k=1020264;c[k>>2]=b;c[k+4>>2]=F;a[1017946]=0;a[1017945]=a[1017946]|0;a[1017947]=0;a[1017944]=a[1017947]|0;k=c[254504]|0;b=c[254505]|0;if((b|0)!=(k|0))do{h=b+-20|0;c[254505]=h;j=c[b+-12>>2]|0;if(!j)b=h;else{h=b+-8|0;g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);xt(j);b=c[254505]|0}}while((b|0)!=(k|0));Xf(1018032,d)|0;if((e|0)!=1017952)$g(1017952,c[e>>2]|0,c[e+4>>2]|0);b=1017964|0;g=e+12|0;h=b+52|0;do{c[b>>2]=c[g>>2];b=b+4|0;g=g+4|0}while((b|0)<(h|0));n=c[f>>2]|0;if(n){c[f>>2]=0;p=c[255068]|0;if(!((p|0)==(n|0)|(p|0)==0)){r=p+4|0;h=c[r>>2]|0;s=p+16|0;k=c[s>>2]|0;j=h+(((k>>>0)/56|0)<<2)|0;q=p+8|0;l=c[q>>2]|0;if((l|0)==(h|0)){k=0;f=0;m=p+20|0}else{m=p+20|0;f=(c[m>>2]|0)+k|0;k=(c[j>>2]|0)+(((k>>>0)%56|0)*72|0)|0;f=(c[h+(((f>>>0)/56|0)<<2)>>2]|0)+(((f>>>0)%56|0)*72|0)|0}a:while(1){do{if((k|0)==(f|0))break a;k=k+72|0}while((k-(c[j>>2]|0)|0)!=4032);g=j+4|0;k=c[g>>2]|0;j=g}c[m>>2]=0;j=l-h>>2;if(j>>>0>2)do{xt(c[h>>2]|0);h=(c[r>>2]|0)+4|0;c[r>>2]=h;k=c[q>>2]|0;j=k-h>>2}while(j>>>0>2);else k=l;if((j|0)==1)c[s>>2]=28;else if((j|0)==2)c[s>>2]=56;if((h|0)!=(k|0)){do{xt(c[h>>2]|0);h=h+4|0}while((h|0)!=(k|0));h=c[r>>2]|0;g=c[q>>2]|0;if((g|0)!=(h|0))c[q>>2]=g+(~((g+-4-h|0)>>>2)<<2)}b=c[p>>2]|0;if(b)xt(b);xt(p)}c[255068]=n}s=o+2048|0;c[s>>2]=o;h=Af(d,o)|0;c[o+2052>>2]=h;c[h>>2]=0;h=c[c[s>>2]>>2]|0;if(!h){Dg();i=u;return}n=e+4|0;o=t+4|0;p=t+8|0;q=t+12|0;r=t+16|0;do{g=c[e>>2]|0;k=c[n>>2]|0;if((g|0)!=(k|0)){j=g;g=0;do{g=((c[j>>2]|0)==(h|0)&1)+g|0;j=j+4|0}while((j|0)!=(k|0));if(g)v=38}else v=38;if((v|0)==38){v=0;c[t>>2]=-32001;c[o>>2]=-32001;l=ut(4)|0;c[p>>2]=l;m=l+4|0;c[r>>2]=m;c[l>>2]=h;c[q>>2]=m;j=c[254505]|0;if((j|0)==(c[254506]|0))Lg(1018016,t);else{if(j){g=t;f=c[g+4>>2]|0;k=j;c[k>>2]=c[g>>2];c[k+4>>2]=f;k=j+8|0;c[k>>2]=0;f=j+12|0;c[f>>2]=0;g=j+16|0;c[g>>2]=0;b=ut(4)|0;c[f>>2]=b;c[k>>2]=b;c[g>>2]=b+4;g=l;j=b;while(1){c[j>>2]=h;k=g+4|0;if((k|0)==(m|0))break;g=k;h=c[k>>2]|0;j=j+4|0}c[f>>2]=b+4}c[254505]=(c[254505]|0)+20}c[q>>2]=l;xt(l)}h=(c[s>>2]|0)+8|0;c[s>>2]=h;h=c[h>>2]|0}while((h|0)!=0);Dg();i=u;return}function zh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;k=a+4|0;l=c[a>>2]|0;e=((c[k>>2]|0)-l>>2)+1|0;if(e>>>0>1073741823)Jo(a);m=a+8|0;f=l;d=(c[m>>2]|0)-f|0;if(d>>2>>>0<536870911){d=d>>1;e=d>>>0<e>>>0?e:d;d=(c[k>>2]|0)-f|0;f=d>>2;if(!e){i=0;h=0;g=f;e=d}else j=6}else{d=(c[k>>2]|0)-f|0;e=1073741823;f=d>>2;j=6}if((j|0)==6){i=e;h=ut(e<<2)|0;g=f;e=d}f=h+(g<<2)|0;if(f)c[f>>2]=c[b>>2];mv(h|0,l|0,e|0)|0;c[a>>2]=h;c[k>>2]=h+(g+1<<2);c[m>>2]=h+(i<<2);if(!l)return;xt(l);return}function Ah(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=1055536;cd(a+816|0);e=c[a+804>>2]|0;if(e){d=a+808|0;b=c[d>>2]|0;if((b|0)!=(e|0))c[d>>2]=b+(~((b+-32-e|0)>>>5)<<5);xt(e)}b=c[a+792>>2]|0;if(!b){xt(a);return}d=a+796|0;e=c[d>>2]|0;if((e|0)!=(b|0))c[d>>2]=e+(~(((e+-112-b|0)>>>0)/112|0)*112|0);xt(b);xt(a);return}function Bh(a){a=a|0;xt(a);return}function Ch(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;x=i;i=i+48|0;v=x+36|0;k=x+24|0;s=x+12|0;t=x;vi(v,1073184,21);u=Th(Bc(1072800,v)|0)|0;Bi(v);vi(k,1073168,13);v=Th(Bc(1072800,k)|0)|0;Bi(k);vi(s,1073208,10);k=Th(Bc(1072800,s)|0)|0;Bi(s);h[a+8>>3]=1.0;s=b+(d<<2)+12|0;m=c[s>>2]|0;m=(m|0)<(u|0)?u:m;w=a+4|0;c[w>>2]=m;c[a>>2]=m;f=b+28|0;g=c[f>>2]|0;if(g){f=c[((g|0)>50?1069904:f)>>2]|0;if((f|0)>=1)j=3}else{f=50;j=3}if((j|0)==3){r=b+(d<<2)+20|0;o=+(k|0)*(+S(+(+_(+((+(e|0)+-59.8)/9.3))+1.0),-.172)+2.2250738585072014e-308)/100.0;p=o*7.0;q=m;b=m;g=1;while(1){k=ba(c[r>>2]|0,g+-1|0)|0;k=(c[s>>2]|0)-(ba((g|0)>40?42:g+2|0,v)|0)+k|0;j=(k|0)<0;d=(g|0)>1;if(d){m=1;l=0.0;do{l=l+(+S(+(+_(+((+((m<<1)+e|0)+-59.8)/9.3))+1.0),-.172)+2.2250738585072014e-308);m=m+1|0}while((m|0)!=(g|0))}else l=0.0;n=o+l;y=o/n;l=(o+l*0.0)/n;n=j?0.0:+(k|0);m=~~(n*(l<y?l:y))+u|0;if(d){k=1;l=0.0;do{l=l+(+S(+(+_(+((+((k<<1)+e|0)+-59.8)/9.3))+1.0),-.172)+2.2250738585072014e-308);k=k+1|0}while((k|0)!=(g|0))}else l=0.0;y=p/(p+l);l=(o+l*.33)/(o+l);k=~~(n*(l<y?l:y))+u|0;q=(q|0)<(m|0)?q:m;c[a>>2]=q;b=(b|0)<(k|0)?b:k;c[w>>2]=b;if((g|0)==(f|0))break;else g=g+1|0}}vi(t,1073080,6);m=(Th(Bc(1072800,t)|0)|0)==0;Bi(t);f=c[a>>2]|0;if(m){m=f;k=c[w>>2]|0;j=(k|0)<(m|0);m=j?k:m;c[a>>2]=m;i=x;return}m=((f|0)/4|0)+f|0;c[a>>2]=m;k=c[w>>2]|0;j=(k|0)<(m|0);m=j?k:m;c[a>>2]=m;i=x;return}function Dh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;f=i;i=i+16|0;e=f;d=1<<($c(b<<15&134184960,0)|0);if((d|0)==(c[a>>2]|0)){i=f;return}c[a>>2]=d;g=a+8|0;uu(c[g>>2]|0);d=vu((c[a>>2]<<5)+63|0,1)|0;c[g>>2]=d;if(!d){b=Ec(nk(Ec(1073504,1069928,19)|0,b)|0,1069952,27)|0;hj(e,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);g=Zo(e,1077904)|0;g=oc[c[(c[g>>2]|0)+28>>2]&63](g,10)|0;Wo(e);rk(b,g)|0;Wj(b)|0;Xb(1)}c[a+4>>2]=d+63&-64;i=f;return}function Eh(a){a=a|0;kv(c[a+4>>2]|0,0,c[a>>2]<<5|0)|0;return}function Fh(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;o=(c[e>>2]|0)+-1&f;p=c[e+4>>2]|0;n=p+(o<<5)|0;k=jv(f|0,g|0,48)|0;l=0;while(1){f=p+(o<<5)+(l*10|0)|0;g=b[f>>1]|0;j=g<<16>>16==0;i=l+1|0;if(j|(g&65535|0)==(k|0)){m=5;break}if((i|0)<3)l=i;else break}if((m|0)==5){if(!j){o=p+(o<<5)+(l*10|0)+8|0;a[o>>0]=d[o>>0]&3|d[e+12>>0]}o=f;n=g<<16>>16!=0&1;a[h>>0]=n;return o|0}i=d[e+12>>0]|0;g=a[p+(o<<5)+18>>0]|0;if((g&252|0)==(i|0))g=1;else g=(g&3)==3;f=((((d[p+(o<<5)+8>>0]&252|0)==(i|0))<<31>>31)+(g&1)+(((a[p+(o<<5)+19>>0]|0)<(a[p+(o<<5)+9>>0]|0))<<31>>31)|0)<0?p+(o<<5)+10|0:n;g=a[p+(o<<5)+28>>0]|0;if((g&252|0)==(i|0))g=1;else g=(g&3)==3;o=((((d[f+8>>0]&252|0)==(i|0))<<31>>31)+(g&1)+(((a[p+(o<<5)+29>>0]|0)<(a[f+9>>0]|0))<<31>>31)|0)<0?p+(o<<5)+20|0:f;n=0;a[h>>0]=n;return o|0}function Gh(){var a=0,b=0,d=0,e=0;e=i;i=i+2256|0;a=e;b=e+2232|0;vi(b,1072736,56);d=c[267456]|0;if((c[267457]|0)==(d|0))Ko(1069824);else{Zf(a,b,0,c[d>>2]|0);Xf(1069992,a)|0;Bi(b);i=e;return}}function Hh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=i;i=i+544|0;y=E+72|0;x=E+400|0;w=E+388|0;v=E+376|0;u=E;m=E+364|0;n=E+352|0;s=E+340|0;D=E+328|0;C=E+188|0;q=E+176|0;p=E+164|0;g=E+160|0;j=E+148|0;h=E+136|0;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;B=C+60|0;z=C+8|0;c[C>>2]=1017916;c[B>>2]=1017936;c[C+4>>2]=0;ij(C+60|0,z);c[C+132>>2]=0;c[C+136>>2]=-1;c[C>>2]=1017860;c[B>>2]=1017880;nj(z);c[z>>2]=1000496;A=C+40|0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;c[C+56>>2]=8;Ae(z,b);if(!(a[D>>0]&1)){a[D+1>>0]=0;a[D>>0]=0}else{a[c[D+8>>2]>>0]=0;c[D+4>>2]=0}r=C+((c[(c[C>>2]|0)+-12>>2]|0)+4)|0;c[r>>2]=c[r>>2]|4096;Ac(C,D)|0;do if((Ti(D,1072224)|0)!=0?(Ti(D,1072232)|0)!=0:0){if((Ti(D,1072240)|0)==0?(a[1017945]|0)!=0:0)break;if(!(Ti(D,1072240)|0)){c[254500]=0;c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}if(!(Ti(D,1072256)|0)){e=Ec(ef(1073416,0)|0,1072264,8)|0;cf(q,1);f=a[q>>0]|0;if(!(f&1)){d=q+1|0;f=(f&255)>>>1}else{d=c[q+8>>2]|0;f=c[q+4>>2]|0}x=Ec(Zh(Ec(Ec(e,d,f)|0,1072280,1)|0,1072800)|0,1072288,6)|0;hj(y,x+(c[(c[x>>2]|0)+-12>>2]|0)|0);w=Zo(y,1077904)|0;w=oc[c[(c[w>>2]|0)+28>>2]&63](w,10)|0;Wo(y);rk(x,w)|0;Wj(x)|0;ef(x,1)|0;Bi(q);c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}if(!(Ti(D,1072296)|0)){x=Ec(ef(1073416,0)|0,1072304,7)|0;hj(y,x+(c[(c[x>>2]|0)+-12>>2]|0)|0);w=Zo(y,1077904)|0;w=oc[c[(c[w>>2]|0)+28>>2]&63](w,10)|0;Wo(y);rk(x,w)|0;Wj(x)|0;ef(x,1)|0;c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}if(!(Ti(D,1072312)|0)){Eh(1069912);c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}if(!(Ti(D,1072328)|0)){r=y+56|0;e=r;c[e>>2]=0;c[e+4>>2]=0;e=y+0|0;d=e+52|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;v=Ac(C,x)|0;if(!(c[v+((c[(c[v>>2]|0)+-12>>2]|0)+16)>>2]&5)){l=y+12|0;k=y+16|0;j=y+20|0;h=y+24|0;g=y+28|0;f=y+32|0;e=y+36|0;d=y+40|0;m=y+44|0;n=y+48|0;o=y+4|0;p=y+8|0;do{do if(!(Ti(x,1072608)|0)){v=Ac(C,x)|0;if(!(c[v+((c[(c[v>>2]|0)+-12>>2]|0)+16)>>2]&5))do{q=Nh(1069992,x)|0;c[w>>2]=q;b=c[o>>2]|0;if((b|0)==(c[p>>2]|0))Ng(y,w);else{if(b)c[b>>2]=q;c[o>>2]=b+4}v=Ac(C,x)|0}while((c[v+((c[(c[v>>2]|0)+-12>>2]|0)+16)>>2]&5|0)==0)}else{if(!(Ti(x,1072624)|0)){Zj(C,l)|0;break}if(!(Ti(x,1072632)|0)){Zj(C,k)|0;break}if(!(Ti(x,1072640)|0)){Zj(C,j)|0;break}if(!(Ti(x,1072648)|0)){Zj(C,h)|0;break}if(!(Ti(x,1072656)|0)){Zj(C,g)|0;break}if(!(Ti(x,1072672)|0)){Zj(C,f)|0;break}if(!(Ti(x,1072680)|0)){_j(C,r)|0;break}if(!(Ti(x,1072688)|0)){Zj(C,e)|0;break}if(!(Ti(x,1072704)|0)){Zj(C,d)|0;break}if(!(Ti(x,1072712)|0)){c[m>>2]=1;break}if(Ti(x,1072728)|0)break;c[n>>2]=1}while(0);v=Ac(C,x)|0}while((c[v+((c[(c[v>>2]|0)+-12>>2]|0)+16)>>2]&5|0)==0)}yh(1069824,1069992,y,1069984);Bi(x);f=c[y>>2]|0;if(!f){c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}d=y+4|0;e=c[d>>2]|0;if((e|0)!=(f|0))c[d>>2]=e+(~((e+-4-f|0)>>>2)<<2);xt(f);c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}if(!(Ti(D,1072336)|0)){c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;Ac(C,y)|0;a:do if(Ti(y,1072576)|0){if(!(Ti(y,1072592)|0)){t=Ac(C,y)|0;if(!(c[t+((c[(c[t>>2]|0)+-12>>2]|0)+16)>>2]&5)){j=y+1|0;h=w+1|0;e=w+8|0;d=w+4|0;k=y+4|0;l=y+8|0;while(1){if(!(Ti(y,1072600)|0)){t=74;break a};c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;f=a[y>>0]|0;if(!(f&1)){g=(f&255)>>>1;f=j}else{g=c[k>>2]|0;f=c[l>>2]|0}Ui(w,f,g,g+1|0);Li(w,1072408,1)|0;g=a[w>>0]|0;if(!(g&1)){f=h;g=(g&255)>>>1}else{f=c[e>>2]|0;g=c[d>>2]|0}Li(x,f,g)|0;Bi(w);t=Ac(C,y)|0;if(c[t+((c[(c[t>>2]|0)+-12>>2]|0)+16)>>2]&5){t=74;break}}}else t=74}}else{Di(x,1072736)|0;Ac(C,y)|0;t=74}while(0);b:do if((t|0)==74){vi(v,1073224,12);f=(Th(Bc(1072800,v)|0)|0)!=0;e=c[267456]|0;if((c[267457]|0)==(e|0))Ko(1069824);Zf(1069992,x,f,c[e>>2]|0);Bi(v);f=ut(24)|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;e=c[267496]|0;if(!((e|0)==(f|0)|(e|0)==0)){Oh(e);xt(e)}c[267496]=f;w=Ac(C,y)|0;if(!(c[w+((c[(c[w>>2]|0)+-12>>2]|0)+16)>>2]&5))do{q=Nh(1069992,y)|0;if(!q)break b;l=c[267496]|0;e=u+0|0;d=e+72|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));k=l+8|0;g=c[k>>2]|0;b=l+4|0;d=c[b>>2]|0;f=g-d>>2;if(!f)j=0;else j=(f*56|0)+-1|0;e=l+16|0;h=c[e>>2]|0;r=l+20|0;f=c[r>>2]|0;if((j-h|0)==(f|0)){Ph(l);h=c[e>>2]|0;f=c[r>>2]|0;g=c[k>>2]|0;d=c[b>>2]|0}e=f+h|0;do if((g|0)!=(d|0)){e=(c[d+(((e>>>0)/56|0)<<2)>>2]|0)+(((e>>>0)%56|0)*72|0)|0;if(!e)break;e=e+0|0;f=u+0|0;d=e+72|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(d|0));f=c[r>>2]|0}while(0);c[r>>2]=f+1;v=c[267496]|0;w=(c[v+20>>2]|0)+-1+(c[v+16>>2]|0)|0;gg(1069992,q,(c[(c[v+4>>2]|0)+(((w>>>0)/56|0)<<2)>>2]|0)+(((w>>>0)%56|0)*72|0)|0);w=Ac(C,y)|0}while((c[w+((c[(c[w>>2]|0)+-12>>2]|0)+16)>>2]&5|0)==0)}while(0);Bi(x);Bi(y);c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}if(Ti(D,1072352)|0){if(!(Ti(D,1072368)|0)){pg(1069992);c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}if(!(Ti(D,1072376)|0)){zc(1069992,C);c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}if(!(Ti(D,1072384)|0)){x=Uf(ef(1073416,0)|0,1069992)|0;hj(y,x+(c[(c[x>>2]|0)+-12>>2]|0)|0);w=Zo(y,1077904)|0;w=oc[c[(c[w>>2]|0)+28>>2]&63](w,10)|0;Wo(y);rk(x,w)|0;Wj(x)|0;ef(x,1)|0;c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}if(!(Ti(D,1072392)|0)){e=ef(1073416,0)|0;ye(p,1069992);f=a[p>>0]|0;if(!(f&1)){d=p+1|0;f=(f&255)>>>1}else{d=c[p+8>>2]|0;f=c[p+4>>2]|0}x=Ec(e,d,f)|0;hj(y,x+(c[(c[x>>2]|0)+-12>>2]|0)|0);w=Zo(y,1077904)|0;w=oc[c[(c[w>>2]|0)+28>>2]&63](w,10)|0;Wo(y);rk(x,w)|0;Wj(x)|0;ef(x,1)|0;Bi(p);c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}if(!(Ti(D,1072400)|0)){t=x+64|0;u=x+8|0;c[u>>2]=1000312;w=x+12|0;c[x>>2]=1000460;c[t>>2]=1000480;c[x+4>>2]=0;ij(x+64|0,w);c[x+136>>2]=0;c[x+140>>2]=-1;c[x>>2]=1000292;c[t>>2]=1000332;c[u>>2]=1000312;nj(w);c[w>>2]=1000496;v=x+44|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[x+60>>2]=24;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;Ae(w,y);Bi(y);Zj(C,g)|0;vi(j,1073056,4);y=Ec(mk(x+8|0,Th(Bc(1072800,j)|0)|0)|0,1072408,1)|0;vi(h,1073048,7);y=Ec(mk(y,Th(Bc(1072800,h)|0)|0)|0,1072408,1)|0;Ec(mk(y,c[g>>2]|0)|0,1072416,14)|0;Bi(h);Bi(j);zc(1069992,x);c[x>>2]=1000292;c[t>>2]=1000332;c[u>>2]=1000312;c[w>>2]=1000496;Bi(v);kj(w);fj(x+64|0);c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}e=Ec(ef(1073416,0)|0,1072432,17)|0;f=a[b>>0]|0;if(!(f&1)){d=b+1|0;f=(f&255)>>>1}else{d=c[b+8>>2]|0;f=c[b+4>>2]|0}x=Ec(e,d,f)|0;hj(y,x+(c[(c[x>>2]|0)+-12>>2]|0)|0);w=Zo(y,1077904)|0;w=oc[c[(c[w>>2]|0)+28>>2]&63](w,10)|0;Wo(y);rk(x,w)|0;Wj(x)|0;ef(x,1)|0;c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return};c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;Ac(C,x)|0;r=Ac(C,x)|0;c:do if(!(c[r+((c[(c[r>>2]|0)+-12>>2]|0)+16)>>2]&5)){p=m+1|0;o=x+1|0;d=u+1|0;e=u+8|0;f=u+4|0;g=x+8|0;h=m+8|0;j=x+4|0;k=m+4|0;l=w+4|0;do{if(!(Ti(x,1072544)|0))break c;b=a[w>>0]|0;if(!(b&1))b=(b&255)>>>1;else b=c[l>>2]|0;vi(m,1072408,(b|0)!=0&1);c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;r=a[m>>0]|0;q=(r&1)==0;if(q)b=(r&255)>>>1;else b=c[k>>2]|0;r=a[x>>0]|0;if(!(r&1))r=(r&255)>>>1;else r=c[j>>2]|0;Ui(u,q?p:c[h>>2]|0,b,r+b|0);Li(u,(a[x>>0]&1)==0?o:c[g>>2]|0,r)|0;r=a[u>>0]|0;if(!(r&1)){b=d;r=(r&255)>>>1}else{b=c[e>>2]|0;r=c[f>>2]|0}Li(w,b,r)|0;Bi(u);Bi(m);r=Ac(C,x)|0}while((c[r+((c[(c[r>>2]|0)+-12>>2]|0)+16)>>2]&5|0)==0)}while(0);u=Ac(C,x)|0;if(!(c[u+((c[(c[u>>2]|0)+-12>>2]|0)+16)>>2]&5)){p=s+1|0;o=x+1|0;d=n+1|0;e=n+8|0;f=n+4|0;g=x+8|0;h=s+8|0;j=x+4|0;k=s+4|0;l=v+4|0;do{b=a[v>>0]|0;if(!(b&1))b=(b&255)>>>1;else b=c[l>>2]|0;vi(s,1072408,(b|0)!=0&1);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;b=a[s>>0]|0;q=(b&1)==0;if(q)r=(b&255)>>>1;else r=c[k>>2]|0;b=a[x>>0]|0;if(!(b&1))b=(b&255)>>>1;else b=c[j>>2]|0;Ui(n,q?p:c[h>>2]|0,r,b+r|0);Li(n,(a[x>>0]&1)==0?o:c[g>>2]|0,b)|0;b=a[n>>0]|0;if(!(b&1)){q=d;b=(b&255)>>>1}else{q=c[e>>2]|0;b=c[f>>2]|0}Li(v,q,b)|0;Bi(n);Bi(s);u=Ac(C,x)|0}while((c[u+((c[(c[u>>2]|0)+-12>>2]|0)+16)>>2]&5|0)==0)}f=c[268201]|0;d:do if(!f)t=128;else{while(1){e=f+16|0;if(!(Xh(1072808,w,e)|0)){if(!(Xh(1072808,e,w)|0))break;f=f+4|0}f=c[f>>2]|0;if(!f){t=128;break d}}ai(Bc(1072800,w)|0,v)|0}while(0);if((t|0)==128){e=Ec(ef(1073416,0)|0,1072552,16)|0;f=a[w>>0]|0;if(!(f&1)){d=w+1|0;f=(f&255)>>>1}else{d=c[w+8>>2]|0;f=c[w+4>>2]|0}u=Ec(e,d,f)|0;hj(y,u+(c[(c[u>>2]|0)+-12>>2]|0)|0);t=Zo(y,1077904)|0;t=oc[c[(c[t>>2]|0)+28>>2]&63](t,10)|0;Wo(y);rk(u,t)|0;Wj(u)|0;ef(u,1)|0}Bi(v);Bi(w);Bi(x);c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}while(0);a[1017944]=1;if((c[267457]|0)==(c[267456]|0))Ko(1069824);c[C>>2]=1017860;c[B>>2]=1017880;c[z>>2]=1000496;Bi(A);kj(z);y=C+60|0;fj(y);Bi(D);i=E;return}function Ih(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+48|0;j=o+36|0;n=o+24|0;k=o+12|0;l=o;h=d>>>6;g=h&63;f=d&63;if((d|0)==65){vi(b,1072464,4);i=o;return}else if(!d){vi(b,1072456,6);i=o;return}else{m=d&49152;if(!((m|0)!=49152|e))f=(f>>>0>g>>>0?6:2)|h&56;a[j>>0]=(h&7)+97;e=j+1|0;a[e>>0]=(g>>>3)+49;g=j+2|0;a[g>>0]=0;vi(k,j,lv(j|0)|0);a[j>>0]=(f&7)+97;a[e>>0]=(f>>>3)+49;a[g>>0]=0;vi(l,j,lv(j|0)|0);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;f=a[k>>0]|0;g=(f&1)==0;if(g)h=(f&255)>>>1;else h=c[k+4>>2]|0;f=a[l>>0]|0;if(!(f&1))e=(f&255)>>>1;else e=c[l+4>>2]|0;if(g)f=k+1|0;else f=c[k+8>>2]|0;Ui(n,f,h,e+h|0);if(!(a[l>>0]&1))f=l+1|0;else f=c[l+8>>2]|0;Li(n,f,e)|0;Bi(l);Bi(k);if((m|0)==16384)Ki(n,a[(d>>>12&3)+1072474>>0]|0);wi(b,n);Bi(n);i=o;return}}function Jh(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=d;a[e>>0]=(c&7)+97;a[e+1>>0]=(c>>>3)+49;a[e+2>>0]=0;vi(b,e,lv(e|0)|0);i=d;return}function Kh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=i;i=i+2288|0;x=y+88|0;w=y+2264|0;o=y+2252|0;q=y+2240|0;s=y+2228|0;t=y+2216|0;u=y;v=y+160|0;if((e|0)==65){vi(b,1088296,6);i=y;return}else if(!e){vi(b,1072456,6);i=y;return}else{c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;l=c[d+2212>>2]|0;m=e>>>6;n=m&63;p=e&63;h=c[d+(n<<2)>>2]|0;g=h&7;r=e&49152;if((r|0)!=49152){do if((g|0)==1){if((r|0)==32768?1:(c[d+(p<<2)>>2]|0)!=0)Ei(w,(m&7)+97&255)|0}else{Ei(w,a[1072480+g>>0]|0)|0;j=d+256|0;j=Ff(h,p,c[j>>2]|0,c[j+4>>2]|0)|0;h=d+(l<<3)+320|0;f=d+(g<<3)+256|0;g=46496+(n<<3)|0;j=c[g>>2]^c[h>>2]&j&c[f>>2];f=c[g+4>>2]^c[h+4>>2]&F&c[f+4>>2];h=j;g=f;a:while(1){do{if((h|0)==0&(g|0)==0)break a;k=_c(h,g)|0;z=iv(h|0,g|0,-1,-1)|0;h=z&h;g=F&g;z=bg(d,l,l)|0}while(dg(d,k<<6|p,z,F)|0);k=46496+(k<<3)|0;j=c[k>>2]^j;f=c[k+4>>2]^f}if(!((j|0)==0&(f|0)==0)){g=m&7;h=47008+(g<<3)|0;if((c[h>>2]&j|0)==0?(c[h+4>>2]&f|0)==0:0){Ki(w,g+97&255);break}h=n>>>3;k=47072+(h<<3)|0;if((c[k>>2]&j|0)==0?(c[k+4>>2]&f|0)==0:0){Ki(w,h+49&255);break}a[x>>0]=g+97;a[x+1>>0]=h+49;a[x+2>>0]=0;vi(o,x,lv(x|0)|0);h=a[o>>0]|0;if(!(h&1)){g=o+1|0;h=(h&255)>>>1}else{g=c[o+8>>2]|0;h=c[o+4>>2]|0}Li(w,g,h)|0;Bi(o)}}while(0);if((r|0)==32768?1:(c[d+(p<<2)>>2]|0)!=0)Ki(w,120);a[x>>0]=(e&7)+97;a[x+1>>0]=(p>>>3)+49;a[x+2>>0]=0;vi(q,x,lv(x|0)|0);g=a[q>>0]|0;if(!(g&1)){h=q+1|0;g=(g&255)>>>1}else{h=c[q+8>>2]|0;g=c[q+4>>2]|0}Li(w,h,g)|0;Bi(q);if((r|0)==16384){vi(t,1072504,1);h=a[(e>>>12&3)+1072482>>0]|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=a[t>>0]|0;if(!(f&1)){f=(f&255)>>>1;g=t+1|0}else{f=c[t+4>>2]|0;g=c[t+8>>2]|0}Ui(s,g,f,f+1|0);Ki(s,h);f=a[s>>0]|0;if(!(f&1)){g=s+1|0;f=(f&255)>>>1}else{g=c[s+8>>2]|0;f=c[s+4>>2]|0}Li(w,g,f)|0;Bi(s);Bi(t)}}else Di(w,p>>>0>n>>>0?1072488:1072496)|0;Tf(u,d);if(fg(d,e,u)|0){gg(d,e,x);c[v+2048>>2]=v;x=Af(d,v)|0;c[v+2052>>2]=x;c[x>>2]=0;Ji(w,(x|0)!=(v|0)?1072512:1072520)|0;ig(d,e)}wi(b,w);Bi(w);i=y;return}}function Lh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;k=i;i=i+160|0;e=k+144|0;j=k;d=j+64|0;f=j+8|0;c[f>>2]=1000312;g=j+12|0;c[j>>2]=1000460;c[d>>2]=1000480;c[j+4>>2]=0;ij(j+64|0,g);c[j+136>>2]=0;c[j+140>>2]=-1;c[j>>2]=1000292;c[d>>2]=1000332;c[f>>2]=1000312;nj(g);c[g>>2]=1000496;h=j+44|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[j+60>>2]=24;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Ae(g,e);Bi(e);e=j+8|0;if((((b|0)>-1?b:0-b|0)|0)<31872)mk(Ec(e,1072528,3)|0,(b*100|0)/258|0)|0;else{e=Ec(e,1072536,5)|0;mk(e,(((b|0)>0?32001:-32e3)-b|0)/2|0)|0}Ce(a,g);c[j>>2]=1000292;c[d>>2]=1000332;c[f>>2]=1000312;c[g>>2]=1000496;Bi(h);kj(g);fj(j+64|0);i=k;return}function Mh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+48|0;j=o+36|0;n=o+24|0;k=o+12|0;l=o;h=d>>>6;g=h&63;f=d&63;if((d|0)==65){vi(b,1072464,4);i=o;return}else if(!d){vi(b,1072456,6);i=o;return}else{m=d&49152;if(!((m|0)!=49152|e))f=(f>>>0>g>>>0?6:2)|h&56;a[j>>0]=(h&7)+97;e=j+1|0;a[e>>0]=(g>>>3)+49;g=j+2|0;a[g>>0]=0;vi(k,j,lv(j|0)|0);a[j>>0]=(f&7)+97;a[e>>0]=(f>>>3)+49;a[g>>0]=0;vi(l,j,lv(j|0)|0);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;f=a[k>>0]|0;g=(f&1)==0;if(g)h=(f&255)>>>1;else h=c[k+4>>2]|0;f=a[l>>0]|0;if(!(f&1))e=(f&255)>>>1;else e=c[l+4>>2]|0;if(g)f=k+1|0;else f=c[k+8>>2]|0;Ui(n,f,h,e+h|0);if(!(a[l>>0]&1))f=l+1|0;else f=c[l+8>>2]|0;Li(n,f,e)|0;Bi(l);Bi(k);if((m|0)==16384)Ki(n,a[(d>>>12&3)+1072474>>0]|0);wi(b,n);Bi(n);i=o;return}}function Nh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=i;i=i+2080|0;h=s+16|0;r=s;e=a[d>>0]|0;g=(e&1)==0;if(g)f=(e&255)>>>1;else f=c[d+4>>2]|0;if((f|0)==5){if(g)e=d+1|0;else e=c[d+8>>2]|0;e=(Bu(a[e+4>>0]|0)|0)&255;if(!(a[d>>0]&1))f=d+1|0;else f=c[d+8>>2]|0;a[f+4>>0]=e}p=h+2048|0;c[p>>2]=h;g=Af(b,h)|0;c[h+2052>>2]=g;c[g>>2]=0;g=c[c[p>>2]>>2]|0;if(!g){n=0;i=s;return n|0}e=b+2224|0;j=d+1|0;k=r+1|0;l=r+8|0;m=d+8|0;n=r+4|0;o=d+4|0;a:while(1){Mh(r,g,(a[e>>0]|0)!=0);h=a[d>>0]|0;f=(h&1)==0;if(f)g=(h&255)>>>1;else g=c[o>>2]|0;b=a[r>>0]|0;h=(b&1)==0;if(h)b=(b&255)>>>1;else b=c[n>>2]|0;b:do if((g|0)==(b|0)){b=f?j:c[m>>2]|0;h=h?k:c[l>>2]|0;if(!f){b=(av(b,h,g)|0)==0;Bi(r);if(b)break a;else break}if(!g){q=25;break a}while(1){if((a[b>>0]|0)!=(a[h>>0]|0)){q=26;break b}g=g+-1|0;if(!g){q=25;break a}else{b=b+1|0;h=h+1|0}}}else q=26;while(0);if((q|0)==26){q=0;Bi(r)}g=(c[p>>2]|0)+8|0;c[p>>2]=g;g=c[g>>2]|0;if(!g){e=0;q=30;break}}if((q|0)==25)Bi(r);else if((q|0)==30){i=s;return e|0}n=c[c[p>>2]>>2]|0;i=s;return n|0}function Oh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;j=a+4|0;b=c[j>>2]|0;i=a+16|0;d=c[i>>2]|0;e=b+(((d>>>0)/56|0)<<2)|0;k=a+8|0;h=c[k>>2]|0;if((h|0)==(b|0)){f=0;g=a+20|0;d=0}else{g=a+20|0;f=(c[g>>2]|0)+d|0;f=(c[b+(((f>>>0)/56|0)<<2)>>2]|0)+(((f>>>0)%56|0)*72|0)|0;d=(c[e>>2]|0)+(((d>>>0)%56|0)*72|0)|0}a:while(1){do{if((d|0)==(f|0))break a;d=d+72|0}while((d-(c[e>>2]|0)|0)!=4032);l=e+4|0;d=c[l>>2]|0;e=l}c[g>>2]=0;d=h-b>>2;if(d>>>0>2)do{xt(c[b>>2]|0);b=(c[j>>2]|0)+4|0;c[j>>2]=b;d=(c[k>>2]|0)-b>>2}while(d>>>0>2);if((d|0)==1)c[i>>2]=28;else if((d|0)==2)c[i>>2]=56;d=c[j>>2]|0;b=c[k>>2]|0;if((d|0)!=(b|0)){do{xt(c[d>>2]|0);d=d+4|0}while((d|0)!=(b|0));b=c[j>>2]|0;d=c[k>>2]|0;if((d|0)!=(b|0))c[k>>2]=d+(~((d+-4-b|0)>>>2)<<2)}b=c[a>>2]|0;if(!b)return;xt(b);return}function Ph(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;r=i;i=i+16|0;g=r;b=a+16|0;d=c[b>>2]|0;if(d>>>0>55){c[b>>2]=d+-56;n=a+4|0;h=c[n>>2]|0;o=c[h>>2]|0;g=h+4|0;c[n>>2]=g;p=a+8|0;f=c[p>>2]|0;k=a+12|0;do if((f|0)==(c[k>>2]|0)){b=c[a>>2]|0;if(g>>>0>b>>>0){d=g;e=((d-b>>2)+1|0)/-2|0;d=f-d|0;nv(h+(e+1<<2)|0,g|0,d|0)|0;d=h+((d>>2)+1+e<<2)|0;c[p>>2]=d;c[n>>2]=(c[n>>2]|0)+(e<<2);e=13;break}m=f-b>>1;m=(m|0)==0?1:m;l=ut(m<<2)|0;e=l+(m>>>2<<2)|0;m=l+(m<<2)|0;if((g|0)==(f|0))d=e;else{d=e;j=g;while(1){if(!d)d=0;else c[d>>2]=c[j>>2];d=d+4|0;g=h+8|0;if((g|0)==(f|0))break;else{h=j;j=g}}b=c[a>>2]|0}c[a>>2]=l;c[n>>2]=e;c[p>>2]=d;c[k>>2]=m;if(!b)e=12;else{xt(b);d=c[p>>2]|0;e=12}}else{d=f;e=12}while(0);if((e|0)==12)if(!d)b=0;else e=13;if((e|0)==13){c[d>>2]=o;b=c[p>>2]|0}c[p>>2]=b+4;i=r;return}q=a+8|0;e=c[q>>2]|0;p=a+4|0;h=e-(c[p>>2]|0)|0;j=h>>2;m=a+12|0;b=c[m>>2]|0;d=b-(c[a>>2]|0)|0;if(j>>>0<d>>2>>>0){d=ut(4032)|0;if((b|0)!=(e|0)){if(!e)b=0;else{c[e>>2]=d;b=c[q>>2]|0}c[q>>2]=b+4;i=r;return}c[g>>2]=d;Qh(a,g);j=c[p>>2]|0;o=c[j>>2]|0;g=j+4|0;c[p>>2]=g;f=c[q>>2]|0;do if((f|0)==(c[m>>2]|0)){d=c[a>>2]|0;if(g>>>0>d>>>0){b=g;e=((b-d>>2)+1|0)/-2|0;b=f-b|0;nv(j+(e+1<<2)|0,g|0,b|0)|0;b=j+((b>>2)+1+e<<2)|0;c[q>>2]=b;c[p>>2]=(c[p>>2]|0)+(e<<2);e=31;break}l=f-d>>1;l=(l|0)==0?1:l;e=ut(l<<2)|0;k=e+(l>>>2<<2)|0;l=e+(l<<2)|0;if((g|0)==(f|0))b=k;else{b=k;h=g;g=j;while(1){if(!b)b=0;else c[b>>2]=c[h>>2];b=b+4|0;g=g+8|0;if((g|0)==(f|0))break;else{j=h;h=g;g=j}}d=c[a>>2]|0}c[a>>2]=e;c[p>>2]=k;c[q>>2]=b;c[m>>2]=l;if(!d)e=30;else{xt(d);b=c[q>>2]|0;e=30}}else{b=f;e=30}while(0);if((e|0)==30)if(!b)b=0;else e=31;if((e|0)==31){c[b>>2]=o;b=c[q>>2]|0}c[q>>2]=b+4;i=r;return}l=d>>1;l=(l|0)==0?1:l;f=ut(l<<2)|0;d=f+(j<<2)|0;b=f+(l<<2)|0;g=ut(4032)|0;do if((j|0)==(l|0))if((h|0)>0){e=f+(((j+1|0)/-2|0)+j<<2)|0;break}else{b=h>>1;b=(b|0)==0?1:b;l=ut(b<<2)|0;xt(f);e=l+(b>>>2<<2)|0;b=l+(b<<2)|0;f=l;break}else e=d;while(0);if(!e)d=0;else{c[e>>2]=g;d=e}d=d+4|0;g=c[q>>2]|0;if((g|0)==(c[p>>2]|0)){j=b;g=d;d=f}else{l=d;n=g;while(1){n=n+-4|0;do if((e|0)==(f|0)){d=b;if(l>>>0<b>>>0){e=l;g=((d-e>>2)+1|0)/2|0;d=e-f|0;e=l+(g-(d>>2)<<2)|0;nv(e|0,f|0,d|0)|0;g=l+(g<<2)|0;d=f;break}b=d-f>>1;b=(b|0)==0?1:b;d=ut(b<<2)|0;e=d+((b+3|0)>>>2<<2)|0;b=d+(b<<2)|0;if((f|0)==(l|0))g=e;else{g=e;h=f;do{if(!g)g=0;else c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((h|0)!=(l|0))}if(f)xt(f)}else{g=l;d=f}while(0);e=e+-4|0;c[e>>2]=c[n>>2];if((n|0)==(c[p>>2]|0)){j=b;break}else{f=d;l=g}}}b=c[a>>2]|0;c[a>>2]=d;c[p>>2]=e;c[q>>2]=g;c[m>>2]=j;if(!b){i=r;return}xt(b);i=r;return}function Qh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;l=a+4|0;f=c[l>>2]|0;do if((f|0)==(c[a>>2]|0)){j=a+8|0;g=c[j>>2]|0;k=a+12|0;i=c[k>>2]|0;d=i;if(g>>>0<i>>>0){k=g;a=((d-k>>2)+1|0)/2|0;k=k-f|0;d=g+(a-(k>>2)<<2)|0;nv(d|0,f|0,k|0)|0;c[l>>2]=d;c[j>>2]=(c[j>>2]|0)+(a<<2);break}i=d-f>>1;i=(i|0)==0?1:i;h=ut(i<<2)|0;d=h+((i+3|0)>>>2<<2)|0;i=h+(i<<2)|0;if((f|0)==(g|0))e=d;else{e=d;do{if(!e)e=0;else c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((f|0)!=(g|0));f=c[a>>2]|0}c[a>>2]=h;c[l>>2]=d;c[j>>2]=e;c[k>>2]=i;if(f){xt(f);d=c[l>>2]|0}}else d=f;while(0);c[d+-4>>2]=c[b>>2];c[l>>2]=(c[l>>2]|0)+-4;return}function Rh(a){a=a|0;Eh(1069912);return}function Sh(b){b=b|0;var d=0;d=b+12|0;if(Ti(b+24|0,1073288)|0){d=(Ti(d,1078144)|0)==0&1;Dh(1069912,d);return}if(!(a[d>>0]&1))d=d+1|0;else d=c[b+20>>2]|0;d=Xu(d)|0;Dh(1069912,d);return}function Th(b){b=b|0;var d=0;d=b+12|0;if(Ti(b+24|0,1073288)|0){d=(Ti(d,1078144)|0)==0&1;return d|0}if(!(a[d>>0]&1))d=d+1|0;else d=c[b+20>>2]|0;d=Xu(d)|0;return d|0}function Uh(b){b=b|0;var d=0;d=b+12|0;if(Ti(b+24|0,1073288)|0){d=(Ti(d,1078144)|0)==0&1;d=(d|0)!=0;ff(d);return}if(!(a[d>>0]&1))d=d+1|0;else d=c[b+20>>2]|0;d=Xu(d)|0;d=(d|0)!=0;ff(d);return}function Vh(a){a=a|0;ze();return}function Wh(a){a=a|0;wh(1069824);return}function Xh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=a[d>>0]|0;if(!(b&1)){f=d+1|0;b=(b&255)>>>1;d=d+1|0}else{g=c[d+8>>2]|0;f=g;b=c[d+4>>2]|0;d=g}h=f+b|0;b=a[e>>0]|0;if(!(b&1)){g=e+1|0;f=(b&255)>>>1;b=e+1|0}else{b=c[e+8>>2]|0;g=b;f=c[e+4>>2]|0}f=g+f|0;if((b|0)==(f|0)){d=0;return d|0}while(1){if((d|0)==(h|0)){d=1;b=12;break}g=a[b>>0]|0;e=Bu(a[d>>0]|0)|0;if((e|0)<(Bu(g<<24>>24)|0)){d=1;b=12;break}g=a[d>>0]|0;e=Bu(a[b>>0]|0)|0;if((e|0)<(Bu(g<<24>>24)|0)){d=0;b=12;break}b=b+1|0;if((b|0)==(f|0)){d=0;b=12;break}else d=d+1|0}if((b|0)==12)return d|0;return 0}function Yh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;b=i;i=i+1472|0;Y=b+1460|0;V=b+1408|0;W=b+1396|0;T=b+1344|0;U=b+1332|0;R=b+1280|0;S=b+1268|0;P=b+1216|0;Q=b+1204|0;N=b+1152|0;O=b+1140|0;L=b+1088|0;M=b+1076|0;J=b+1024|0;K=b+1012|0;H=b+960|0;I=b+948|0;F=b+896|0;G=b+884|0;D=b+832|0;E=b+820|0;x=b+768|0;B=b+756|0;C=b+704|0;z=b+692|0;A=b+640|0;y=b+628|0;v=b+576|0;w=b+564|0;t=b+512|0;u=b+500|0;r=b+448|0;s=b+436|0;p=b+384|0;q=b+372|0;n=b+320|0;o=b+308|0;l=b+256|0;m=b+244|0;h=b+192|0;k=b+180|0;j=b+128|0;g=b+116|0;f=b+64|0;d=b+52|0;e=b;vi(Y,1072816,15);_=Bc(a,Y)|0;X=V+12|0;Z=V+24|0;c[V+0>>2]=0;c[V+4>>2]=0;c[V+8>>2]=0;c[V+12>>2]=0;c[V+16>>2]=0;c[V+20>>2]=0;vi(Z,1073312,5);aa=V+36|0;c[aa>>2]=0;c[V+40>>2]=0;c[V+48>>2]=177;Ci(V,Di(X,1078176)|0)|0;Ci(_,V)|0;Ci(_+12|0,X)|0;Ci(_+24|0,Z)|0;$=_+36|0;c[$+0>>2]=c[aa+0>>2];c[$+4>>2]=c[aa+4>>2];c[$+8>>2]=c[aa+8>>2];c[$+12>>2]=c[aa+12>>2];$=c[268330]|0;c[268330]=$+1;c[_+44>>2]=$;Bi(Z);Bi(X);Bi(V);Bi(Y);vi(W,1072832,8);Y=Bc(a,W)|0;$h(T,0,-100,100,0);Ci(Y,T)|0;V=T+12|0;Ci(Y+12|0,V)|0;X=T+24|0;Ci(Y+24|0,X)|0;Z=Y+36|0;_=T+36|0;c[Z+0>>2]=c[_+0>>2];c[Z+4>>2]=c[_+4>>2];c[Z+8>>2]=c[_+8>>2];c[Z+12>>2]=c[_+12>>2];Z=c[268330]|0;c[268330]=Z+1;c[Y+44>>2]=Z;Bi(X);Bi(V);Bi(T);Bi(W);vi(U,1072848,18);W=Bc(a,U)|0;$h(R,100,0,200,178);Ci(W,R)|0;T=R+12|0;Ci(W+12|0,T)|0;V=R+24|0;Ci(W+24|0,V)|0;X=W+36|0;Y=R+36|0;c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];c[X+12>>2]=c[Y+12>>2];X=c[268330]|0;c[268330]=X+1;c[W+44>>2]=X;Bi(V);Bi(T);Bi(R);Bi(U);vi(S,1072872,18);U=Bc(a,S)|0;$h(P,100,0,200,178);Ci(U,P)|0;R=P+12|0;Ci(U+12|0,R)|0;T=P+24|0;Ci(U+24|0,T)|0;V=U+36|0;W=P+36|0;c[V+0>>2]=c[W+0>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];c[V+12>>2]=c[W+12>>2];V=c[268330]|0;c[268330]=V+1;c[U+44>>2]=V;Bi(T);Bi(R);Bi(P);Bi(S);vi(Q,1072896,24);S=Bc(a,Q)|0;$h(N,100,0,200,178);Ci(S,N)|0;P=N+12|0;Ci(S+12|0,P)|0;R=N+24|0;Ci(S+24|0,R)|0;T=S+36|0;U=N+36|0;c[T+0>>2]=c[U+0>>2];c[T+4>>2]=c[U+4>>2];c[T+8>>2]=c[U+8>>2];c[T+12>>2]=c[U+12>>2];T=c[268330]|0;c[268330]=T+1;c[S+44>>2]=T;Bi(R);Bi(P);Bi(N);Bi(Q);vi(O,1072928,24);Q=Bc(a,O)|0;$h(L,100,0,200,178);Ci(Q,L)|0;N=L+12|0;Ci(Q+12|0,N)|0;P=L+24|0;Ci(Q+24|0,P)|0;R=Q+36|0;S=L+36|0;c[R+0>>2]=c[S+0>>2];c[R+4>>2]=c[S+4>>2];c[R+8>>2]=c[S+8>>2];c[R+12>>2]=c[S+12>>2];R=c[268330]|0;c[268330]=R+1;c[Q+44>>2]=R;Bi(P);Bi(N);Bi(L);Bi(O);vi(M,1072960,22);O=Bc(a,M)|0;$h(J,100,0,200,178);Ci(O,J)|0;L=J+12|0;Ci(O+12|0,L)|0;N=J+24|0;Ci(O+24|0,N)|0;P=O+36|0;Q=J+36|0;c[P+0>>2]=c[Q+0>>2];c[P+4>>2]=c[Q+4>>2];c[P+8>>2]=c[Q+8>>2];c[P+12>>2]=c[Q+12>>2];P=c[268330]|0;c[268330]=P+1;c[O+44>>2]=P;Bi(N);Bi(L);Bi(J);Bi(M);vi(K,1072984,22);M=Bc(a,K)|0;$h(H,100,0,200,178);Ci(M,H)|0;J=H+12|0;Ci(M+12|0,J)|0;L=H+24|0;Ci(M+24|0,L)|0;N=M+36|0;O=H+36|0;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];c[N+12>>2]=c[O+12>>2];N=c[268330]|0;c[268330]=N+1;c[M+44>>2]=N;Bi(L);Bi(J);Bi(H);Bi(K);vi(I,1073008,5);K=Bc(a,I)|0;$h(F,100,0,200,178);Ci(K,F)|0;H=F+12|0;Ci(K+12|0,H)|0;J=F+24|0;Ci(K+24|0,J)|0;L=K+36|0;M=F+36|0;c[L+0>>2]=c[M+0>>2];c[L+4>>2]=c[M+4>>2];c[L+8>>2]=c[M+8>>2];c[L+12>>2]=c[M+12>>2];L=c[268330]|0;c[268330]=L+1;c[K+44>>2]=L;Bi(J);Bi(H);Bi(F);Bi(I);vi(G,1073016,11);I=Bc(a,G)|0;$h(D,100,0,200,178);Ci(I,D)|0;F=D+12|0;Ci(I+12|0,F)|0;H=D+24|0;Ci(I+24|0,H)|0;J=I+36|0;K=D+36|0;c[J+0>>2]=c[K+0>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];c[J+12>>2]=c[K+12>>2];J=c[268330]|0;c[268330]=J+1;c[I+44>>2]=J;Bi(H);Bi(F);Bi(D);Bi(G);vi(E,1073032,15);G=Bc(a,E)|0;$h(x,0,0,12,179);Ci(G,x)|0;D=x+12|0;Ci(G+12|0,D)|0;F=x+24|0;Ci(G+24|0,F)|0;H=G+36|0;I=x+36|0;c[H+0>>2]=c[I+0>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2];c[H+12>>2]=c[I+12>>2];H=c[268330]|0;c[268330]=H+1;c[G+44>>2]=H;Bi(F);Bi(D);Bi(x);Bi(E);vi(B,1073048,7);E=Bc(a,B)|0;$h(C,1,1,128,179);Ci(E,C)|0;x=C+12|0;Ci(E+12|0,x)|0;D=C+24|0;Ci(E+24|0,D)|0;F=E+36|0;G=C+36|0;c[F+0>>2]=c[G+0>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];c[F+12>>2]=c[G+12>>2];F=c[268330]|0;c[268330]=F+1;c[E+44>>2]=F;Bi(D);Bi(x);Bi(C);Bi(B);vi(z,1073056,4);B=Bc(a,z)|0;$h(A,16,1,2048,180);Ci(B,A)|0;C=A+12|0;Ci(B+12|0,C)|0;x=A+24|0;Ci(B+24|0,x)|0;D=B+36|0;E=A+36|0;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];c[D+12>>2]=c[E+12>>2];D=c[268330]|0;c[268330]=D+1;c[B+44>>2]=D;Bi(x);Bi(C);Bi(A);Bi(z);vi(y,1073064,10);z=Bc(a,y)|0;A=v+24|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[v+16>>2]=0;c[v+20>>2]=0;vi(A,1073264,6);C=v+36|0;c[C>>2]=0;c[v+40>>2]=0;c[v+48>>2]=181;Ci(z,v)|0;x=v+12|0;Ci(z+12|0,x)|0;Ci(z+24|0,A)|0;B=z+36|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];B=c[268330]|0;c[268330]=B+1;c[z+44>>2]=B;Bi(A);Bi(x);Bi(v);Bi(y);vi(w,1073080,6);y=Bc(a,w)|0;v=t+12|0;x=t+24|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;c[t+20>>2]=0;vi(x,1073312,5);A=t+36|0;c[A>>2]=0;c[t+40>>2]=0;c[t+48>>2]=0;Ci(t,Di(v,1078144)|0)|0;Ci(y,t)|0;Ci(y+12|0,v)|0;Ci(y+24|0,x)|0;z=y+36|0;c[z+0>>2]=c[A+0>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];c[z+12>>2]=c[A+12>>2];z=c[268330]|0;c[268330]=z+1;c[y+44>>2]=z;Bi(x);Bi(v);Bi(t);Bi(w);vi(u,1073088,7);w=Bc(a,u)|0;$h(r,1,1,500,0);Ci(w,r)|0;t=r+12|0;Ci(w+12|0,t)|0;v=r+24|0;Ci(w+24|0,v)|0;x=w+36|0;y=r+36|0;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];c[x+12>>2]=c[y+12>>2];x=c[268330]|0;c[268330]=x+1;c[w+44>>2]=x;Bi(v);Bi(t);Bi(r);Bi(u);vi(s,1073096,11);u=Bc(a,s)|0;$h(p,20,0,20,0);Ci(u,p)|0;r=p+12|0;Ci(u+12|0,r)|0;t=p+24|0;Ci(u+24|0,t)|0;v=u+36|0;w=p+36|0;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];v=c[268330]|0;c[268330]=v+1;c[u+44>>2]=v;Bi(t);Bi(r);Bi(p);Bi(s);vi(q,1073112,25);s=Bc(a,q)|0;$h(n,2,1,100,0);Ci(s,n)|0;p=n+12|0;Ci(s+12|0,p)|0;r=n+24|0;Ci(s+24|0,r)|0;t=s+36|0;u=n+36|0;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];t=c[268330]|0;c[268330]=t+1;c[s+44>>2]=t;Bi(r);Bi(p);Bi(n);Bi(q);vi(o,1073144,23);q=Bc(a,o)|0;$h(l,128,1,1e3,0);Ci(q,l)|0;n=l+12|0;Ci(q+12|0,n)|0;p=l+24|0;Ci(q+24|0,p)|0;r=q+36|0;s=l+36|0;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];r=c[268330]|0;c[268330]=r+1;c[q+44>>2]=r;Bi(p);Bi(n);Bi(l);Bi(o);vi(m,1073168,13);o=Bc(a,m)|0;$h(h,30,0,5e3,0);Ci(o,h)|0;l=h+12|0;Ci(o+12|0,l)|0;n=h+24|0;Ci(o+24|0,n)|0;p=o+36|0;q=h+36|0;c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];c[p+12>>2]=c[q+12>>2];p=c[268330]|0;c[268330]=p+1;c[o+44>>2]=p;Bi(n);Bi(l);Bi(h);Bi(m);vi(k,1073184,21);m=Bc(a,k)|0;$h(j,20,0,5e3,0);Ci(m,j)|0;h=j+12|0;Ci(m+12|0,h)|0;l=j+24|0;Ci(m+24|0,l)|0;n=m+36|0;o=j+36|0;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];n=c[268330]|0;c[268330]=n+1;c[m+44>>2]=n;Bi(l);Bi(h);Bi(j);Bi(k);vi(g,1073208,10);k=Bc(a,g)|0;$h(f,80,10,1e3,0);Ci(k,f)|0;j=f+12|0;Ci(k+12|0,j)|0;h=f+24|0;Ci(k+24|0,h)|0;l=k+36|0;m=f+36|0;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];l=c[268330]|0;c[268330]=l+1;c[k+44>>2]=l;Bi(h);Bi(j);Bi(f);Bi(g);vi(d,1073224,12);g=Bc(a,d)|0;a=e+12|0;f=e+24|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;vi(f,1073312,5);j=e+36|0;c[j>>2]=0;c[e+40>>2]=0;c[e+48>>2]=0;Ci(e,Di(a,1078176)|0)|0;Ci(g,e)|0;Ci(g+12|0,a)|0;Ci(g+24|0,f)|0;h=g+36|0;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];h=c[268330]|0;c[268330]=h+1;c[g+44>>2]=h;Bi(f);Bi(a);Bi(e);Bi(d);i=b;return}function Zh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;k=d+8|0;if(!(c[k>>2]|0))return b|0;l=d+4|0;m=0;do{e=c[d>>2]|0;a:do if((e|0)!=(l|0)){while(1){if((c[e+72>>2]|0)==(m|0))break;f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;break}else e=f}else{e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}if((e|0)==(l|0))break a}f=e+16|0;i=Ec(b,1073240,13)|0;g=a[f>>0]|0;if(!(g&1)){h=f+1|0;f=(g&255)>>>1}else{h=c[e+24>>2]|0;f=c[e+20>>2]|0}i=Ec(Ec(i,h,f)|0,1073256,6)|0;j=e+52|0;h=a[j>>0]|0;if(!(h&1)){g=j+1|0;h=(h&255)>>>1}else{g=c[e+60>>2]|0;h=c[e+56>>2]|0}Ec(i,g,h)|0;if(Ti(j,1073264)|0){f=Ec(b,1073272,9)|0;h=e+28|0;i=a[h>>0]|0;if(!(i&1)){g=h+1|0;h=(i&255)>>>1}else{g=c[e+36>>2]|0;h=c[e+32>>2]|0}Ec(f,g,h)|0}if(!(Ti(j,1073288)|0)){j=Ec(b,1073296,5)|0;j=Ec(mk(j,c[e+64>>2]|0)|0,1073304,5)|0;mk(j,c[e+68>>2]|0)|0}}while(0);m=m+1|0}while(m>>>0<(c[k>>2]|0)>>>0);return b|0}function _h(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;vi(a+24|0,1073264,6);c[a+36>>2]=0;c[a+40>>2]=0;c[a+48>>2]=b;return}function $h(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+176|0;k=g+152|0;h=g+16|0;j=g;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;vi(a+24|0,1073288,4);c[a+36>>2]=d;c[a+40>>2]=e;c[a+48>>2]=f;d=h+56|0;f=h+4|0;c[h>>2]=1017820;c[d>>2]=1017840;ij(h+56|0,f);c[h+128>>2]=0;c[h+132>>2]=-1;c[h>>2]=1017764;c[d>>2]=1017784;nj(f);c[f>>2]=1000496;e=h+36|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[h+52>>2]=16;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Ae(f,k);Bi(k);mk(h,b)|0;Ce(j,f);Ci(a,Ci(a+12|0,j)|0)|0;Bi(j);c[h>>2]=1017764;c[d>>2]=1017784;c[f>>2]=1000496;Bi(e);kj(f);fj(h+56|0);i=g;return}function ai(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;g=b+24|0;if(Ti(g,1073264)|0){e=a[d>>0]|0;if(!(e&1))e=(e&255)>>>1;else e=c[d+4>>2]|0;if(!e)return b|0}if(((Ti(g,1073312)|0)==0?(Ti(d,1078144)|0)!=0:0)?(Ti(d,1078176)|0)!=0:0)return b|0;if(!(Ti(g,1073288)|0)){e=(a[d>>0]&1)==0;if(e)f=d+1|0;else f=c[d+8>>2]|0;f=Xu(f)|0;if((f|0)<(c[b+36>>2]|0))return b|0;if(e)e=d+1|0;else e=c[d+8>>2]|0;e=Xu(e)|0;if((e|0)>(c[b+40>>2]|0))return b|0}if(Ti(g,1073264)|0)Ci(b+12|0,d)|0;e=c[b+48>>2]|0;if(!e)return b|0;cc[e&255](b);return b|0}function bi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=c[o>>2]|0;Oq(1074032,b,1074088);c[268332]=1075276;c[268334]=1075296;c[268333]=0;e=c[268816]|0;ij(1073328+e|0,1074032);c[e+1073400>>2]=0;c[e+1073404>>2]=-1;e=c[p>>2]|0;Pq(1074136,e,1074096|0);c[268354]=1075356;c[268355]=1075376;h=c[268836]|0;ij(1073416+h|0,1074136);f=h+72|0;c[1073416+f>>2]=0;a=h+76|0;c[1073416+a>>2]=-1;d=c[n>>2]|0;Pq(1074184,d,1074104|0);c[268376]=1075356;c[268377]=1075376;ij(1073504+h|0,1074184);c[1073504+f>>2]=0;c[1073504+a>>2]=-1;g=c[(c[(c[268376]|0)+-12>>2]|0)+1073528>>2]|0;c[268398]=1075356;c[268399]=1075376;ij(1073592+h|0,g);c[1073592+f>>2]=0;c[1073592+a>>2]=-1;c[(c[(c[268332]|0)+-12>>2]|0)+1073400>>2]=1073416;a=(c[(c[268376]|0)+-12>>2]|0)+1073508|0;c[a>>2]=c[a>>2]|8192;c[(c[(c[268376]|0)+-12>>2]|0)+1073576>>2]=1073416;Qq(1074232,b,1074112|0);c[268420]=1075316;c[268422]=1075336;c[268421]=0;b=c[268826]|0;ij(1073680+b|0,1074232);c[b+1073752>>2]=0;c[b+1073756>>2]=-1;Rq(1074288,e,1074120|0);c[268442]=1075396;c[268443]=1075416;e=c[268846]|0;ij(1073768+e|0,1074288);b=e+72|0;c[1073768+b>>2]=0;a=e+76|0;c[1073768+a>>2]=-1;Rq(1074336,d,1074128|0);c[268464]=1075396;c[268465]=1075416;ij(1073856+e|0,1074336);c[1073856+b>>2]=0;c[1073856+a>>2]=-1;d=c[(c[(c[268464]|0)+-12>>2]|0)+1073880>>2]|0;c[268486]=1075396;c[268487]=1075416;ij(1073944+e|0,d);c[1073944+b>>2]=0;c[1073944+a>>2]=-1;c[(c[(c[268420]|0)+-12>>2]|0)+1073752>>2]=1073768;a=(c[(c[268464]|0)+-12>>2]|0)+1073860|0;c[a>>2]=c[a>>2]|8192;c[(c[(c[268464]|0)+-12>>2]|0)+1073928>>2]=1073768;return}function ci(a){a=a|0;return}function di(a){a=a|0;a=a+4|0;c[a>>2]=(c[a>>2]|0)+1;return}function ei(a){a=a|0;var b=0,d=0;d=a+4|0;b=c[d>>2]|0;c[d>>2]=b+-1;if(!b){cc[c[(c[a>>2]|0)+8>>2]&255](a);a=1}else a=0;return a|0}function fi(a,b){a=a|0;b=b|0;c[a>>2]=1086296;Sq(a+4|0,b);return}function gi(b,d){b=b|0;d=d|0;c[b>>2]=1086320;if(!(a[d>>0]&1))d=d+1|0;else d=c[d+8>>2]|0;Sq(b+4|0,d);return}function hi(a,b){a=a|0;b=b|0;c[a>>2]=1086320;Sq(a+4|0,b);return}function ii(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;return}function ji(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=i;i=i+16|0;e=f;hc[c[(c[a>>2]|0)+12>>2]&3](e,a,b);if((c[e+4>>2]|0)==(c[d+4>>2]|0))e=(c[e>>2]|0)==(c[d>>2]|0);else e=0;i=f;return e|0}function ki(a,b,d){a=a|0;b=b|0;d=d|0;if((c[b+4>>2]|0)==(a|0))b=(c[b>>2]|0)==(d|0);else b=0;return b|0}function li(a,b,c){a=a|0;b=b|0;c=c|0;c=Sb(c|0)|0;vi(a,c,lv(c|0)|0);return}function mi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;j=i;i=i+16|0;h=j;f=c[d>>2]|0;if(f){g=a[e>>0]|0;if(!(g&1))g=(g&255)>>>1;else g=c[e+4>>2]|0;if(g){Ji(e,1074896)|0;f=c[d>>2]|0}g=c[d+4>>2]|0;hc[c[(c[g>>2]|0)+24>>2]&3](h,g,f);f=a[h>>0]|0;if(!(f&1)){g=h+1|0;f=(f&255)>>>1}else{g=c[h+8>>2]|0;f=c[h+4>>2]|0}Li(e,g,f)|0;Bi(h)};c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;i=j;return}function ni(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;g=e+12|0;f=e;vi(f,d,lv(d|0)|0);mi(g,b,f);gi(a,g);Bi(g);Bi(f);c[a>>2]=1074912;f=b;d=c[f+4>>2]|0;b=a+8|0;c[b>>2]=c[f>>2];c[b+4>>2]=d;i=e;return}function oi(a){a=a|0;Kt(a);return}function pi(a){a=a|0;Kt(a);xt(a);return}function qi(a){a=a|0;return}function ri(a,b,d){a=a|0;b=b|0;d=d|0;Xa(1075048)|0;if((c[a>>2]|0)==1)do Aa(1075072,1075048)|0;while((c[a>>2]|0)==1);if(!(c[a>>2]|0)){c[a>>2]=1;rb(1075048)|0;cc[d&255](b);Xa(1075048)|0;c[a>>2]=-1;rb(1075048)|0;Kb(1075072)|0}else rb(1075048)|0;return}function si(a){a=a|0;a=Oa(8)|0;fi(a,1075120);c[a>>2]=1086376;Qb(a|0,1086416,161)}function ti(a){a=a|0;a=Oa(8)|0;fi(a,1075120);c[a>>2]=1086440;Qb(a|0,1086480,161)}function ui(b,d){b=b|0;d=d|0;if(!(a[d>>0]&1)){c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2]}else vi(b,c[d+8>>2]|0,c[d+4>>2]|0);return}function vi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;if(e>>>0>4294967279)si(b);if(e>>>0<11){a[b>>0]=e<<1;b=b+1|0}else{g=e+16&-16;f=ut(g)|0;c[b+8>>2]=f;c[b>>2]=g|1;c[b+4>>2]=e;b=f}mv(b|0,d|0,e|0)|0;a[b+e>>0]=0;return}function wi(a,b){a=a|0;b=b|0;ui(a,b);return}function xi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;if(d>>>0>4294967279)si(b);if(d>>>0<11){a[b>>0]=d<<1;b=b+1|0}else{g=d+16&-16;f=ut(g)|0;c[b+8>>2]=f;c[b>>2]=g|1;c[b+4>>2]=d;b=f}kv(b|0,e|0,d|0)|0;a[b+d>>0]=0;return}function yi(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;g=a[d>>0]|0;h=(g&1)==0;if(h)i=(g&255)>>>1;else i=c[d+4>>2]|0;if(i>>>0<e>>>0)ti(b);if(h)g=d+1|0;else g=c[d+8>>2]|0;h=i-e|0;vi(b,g+e|0,h>>>0<f>>>0?h:f);return}function zi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yi(a,b,c,d,e);return}function Ai(b){b=b|0;if(a[b>>0]&1)xt(c[b+8>>2]|0);return}function Bi(a){a=a|0;Ai(a);return}function Ci(b,d){b=b|0;d=d|0;var e=0,f=0;if((b|0)!=(d|0)){e=a[d>>0]|0;if(!(e&1)){f=d+1|0;e=(e&255)>>>1}else{f=c[d+8>>2]|0;e=c[d+4>>2]|0}Fi(b,f,e)|0}return b|0}function Di(a,b){a=a|0;b=b|0;return Fi(a,b,lv(b|0)|0)|0}function Ei(b,d){b=b|0;d=d|0;var e=0;if(!(a[b>>0]&1)){a[b>>0]=2;e=b+1|0}else{e=c[b+8>>2]|0;c[b+4>>2]=1}a[e>>0]=d;a[e+1>>0]=0;return b|0}function Fi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=a[b>>0]|0;if(!(f&1))h=10;else{f=c[b>>2]|0;h=(f&-2)+-1|0;f=f&255}g=(f&1)==0;do if(h>>>0>=e>>>0){if(g)f=b+1|0;else f=c[b+8>>2]|0;nv(f|0,d|0,e|0)|0;a[f+e>>0]=0;if(!(a[b>>0]&1)){a[b>>0]=e<<1;break}else{c[b+4>>2]=e;break}}else{if(g)f=(f&255)>>>1;else f=c[b+4>>2]|0;Mi(b,h,e-h|0,f,0,f,e,d)}while(0);return b|0}function Gi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=a[b>>0]|0;g=(f&1)==0;if(g)f=(f&255)>>>1;else f=c[b+4>>2]|0;do if(f>>>0>=d>>>0)if(g){a[b+d+1>>0]=0;a[b>>0]=d<<1;break}else{a[(c[b+8>>2]|0)+d>>0]=0;c[b+4>>2]=d;break}else Hi(b,d-f|0,e)|0;while(0);return}function Hi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;if(d){f=a[b>>0]|0;if(!(f&1))g=10;else{f=c[b>>2]|0;g=(f&-2)+-1|0;f=f&255}if(!(f&1))h=(f&255)>>>1;else h=c[b+4>>2]|0;if((g-h|0)>>>0<d>>>0){Ni(b,g,d-g+h|0,h,h,0,0);f=a[b>>0]|0}if(!(f&1))g=b+1|0;else g=c[b+8>>2]|0;kv(g+h|0,e|0,d|0)|0;f=h+d|0;if(!(a[b>>0]&1))a[b>>0]=f<<1;else c[b+4>>2]=f;a[g+f>>0]=0}return b|0}function Ii(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;if(d>>>0>4294967279)si(b);e=a[b>>0]|0;if(!(e&1))f=10;else{e=c[b>>2]|0;f=(e&-2)+-1|0;e=e&255}if(!(e&1))j=(e&255)>>>1;else j=c[b+4>>2]|0;d=j>>>0>d>>>0?j:d;if(d>>>0<11)i=10;else i=(d+16&-16)+-1|0;do if((i|0)!=(f|0)){do if((i|0)!=10){d=i+1|0;if(i>>>0>f>>>0)d=ut(d)|0;else d=ut(d)|0;if(!(e&1)){f=1;g=b+1|0;h=0;break}else{f=1;g=c[b+8>>2]|0;h=1;break}}else{d=b+1|0;f=0;g=c[b+8>>2]|0;h=1}while(0);if(!(e&1))e=(e&255)>>>1;else e=c[b+4>>2]|0;mv(d|0,g|0,e+1|0)|0;if(h)xt(g);if(f){c[b>>2]=i+1|1;c[b+4>>2]=j;c[b+8>>2]=d;break}else{a[b>>0]=j<<1;break}}while(0);return}function Ji(a,b){a=a|0;b=b|0;return Li(a,b,lv(b|0)|0)|0}function Ki(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=a[b>>0]|0;f=(e&1)!=0;if(f){g=(c[b>>2]&-2)+-1|0;h=c[b+4>>2]|0}else{g=10;h=(e&255)>>>1}if((h|0)==(g|0)){Ni(b,g,1,g,g,0,0);if(!(a[b>>0]&1))g=7;else g=8}else if(f)g=8;else g=7;if((g|0)==7){a[b>>0]=(h<<1)+2;e=b+1|0;f=h+1|0}else if((g|0)==8){e=c[b+8>>2]|0;f=h+1|0;c[b+4>>2]=f}a[e+h>>0]=d;a[e+f>>0]=0;return}function Li(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=a[b>>0]|0;if(!(f&1))g=10;else{f=c[b>>2]|0;g=(f&-2)+-1|0;f=f&255}if(!(f&1))h=(f&255)>>>1;else h=c[b+4>>2]|0;if((g-h|0)>>>0>=e>>>0){if(e){if(!(f&1))g=b+1|0;else g=c[b+8>>2]|0;mv(g+h|0,d|0,e|0)|0;f=h+e|0;if(!(a[b>>0]&1))a[b>>0]=f<<1;else c[b+4>>2]=f;a[g+f>>0]=0}}else Mi(b,g,e-g+h|0,h,h,0,e,d);return b|0}function Mi(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;if((-18-d|0)>>>0<e>>>0)si(b);if(!(a[b>>0]&1))m=b+1|0;else m=c[b+8>>2]|0;if(d>>>0<2147483623){e=e+d|0;l=d<<1;e=e>>>0<l>>>0?l:e;if(e>>>0<11)k=11;else k=e+16&-16}else k=-17;l=ut(k)|0;if(g)mv(l|0,m|0,g|0)|0;if(i)mv(l+g|0,j|0,i|0)|0;e=f-h|0;if((e|0)!=(g|0))mv(l+(i+g)|0,m+(h+g)|0,e-g|0)|0;if((d|0)!=10)xt(m);c[b+8>>2]=l;c[b>>2]=k|1;d=e+i|0;c[b+4>>2]=d;a[l+d>>0]=0;return}function Ni(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;if((-17-d|0)>>>0<e>>>0)si(b);if(!(a[b>>0]&1))l=b+1|0;else l=c[b+8>>2]|0;if(d>>>0<2147483623){e=e+d|0;j=d<<1;e=e>>>0<j>>>0?j:e;if(e>>>0<11)j=11;else j=e+16&-16}else j=-17;k=ut(j)|0;if(g)mv(k|0,l|0,g|0)|0;e=f-h|0;if((e|0)!=(g|0))mv(k+(i+g)|0,l+(h+g)|0,e-g|0)|0;if((d|0)!=10)xt(l);c[b+8>>2]=k;c[b>>2]=j|1;return}function Oi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=a[b>>0]|0;h=(g&1)==0;if(h)j=(g&255)>>>1;else j=c[b+4>>2]|0;if(j>>>0<d>>>0)ti(b);if(h)h=10;else{g=c[b>>2]|0;h=(g&-2)+-1|0;g=g&255}if((h-j|0)>>>0>=f>>>0){if(f){if(!(g&1))i=b+1|0;else i=c[b+8>>2]|0;h=j-d|0;g=i+d|0;if((j|0)!=(d|0)){if(g>>>0<=e>>>0&(i+j|0)>>>0>e>>>0)e=e+f|0;nv(i+(f+d)|0,g|0,h|0)|0}nv(g|0,e|0,f|0)|0;e=j+f|0;if(!(a[b>>0]&1))a[b>>0]=e<<1;else c[b+4>>2]=e;a[i+e>>0]=0}}else Mi(b,h,j+f-h|0,j,d,0,f,e);return b|0}function Pi(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=a[b>>0]|0;i=(h&1)==0;if(i)n=(h&255)>>>1;else n=c[b+4>>2]|0;if(n>>>0<d>>>0)ti(b);k=n-d|0;e=k>>>0<e>>>0?k:e;if(i)i=10;else{h=c[b>>2]|0;i=(h&-2)+-1|0;h=h&255}if((e-n+i|0)>>>0<g>>>0)Mi(b,i,n+g-e-i|0,n,d,e,g,f);else{if(!(h&1))m=b+1|0;else m=c[b+8>>2]|0;do if((e|0)!=(g|0)){j=k-e|0;if((k|0)==(e|0)){h=g;e=k;l=21}else{i=m+d|0;if(e>>>0>g>>>0){nv(i|0,f|0,g|0)|0;nv(m+(g+d)|0,m+(e+d)|0,j|0)|0;h=g;break}do if(i>>>0<f>>>0&(m+n|0)>>>0>f>>>0){h=e+d|0;if((m+h|0)>>>0>f>>>0){nv(i|0,f|0,e|0)|0;d=h;f=f+g|0;h=g-e|0;e=0;break}else{f=f+(g-e)|0;h=g;break}}else h=g;while(0);nv(m+(d+h)|0,m+(d+e)|0,j|0)|0;l=21}}else{h=g;e=g;l=21}while(0);if((l|0)==21)nv(m+d|0,f|0,h|0)|0;e=h-e+n|0;if(!(a[b>>0]&1))a[b>>0]=e<<1;else c[b+4>>2]=e;a[m+e>>0]=0}return b|0}function Qi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Pi(a,b,c,d,lv(d|0)|0)|0}function Ri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=a[b>>0]|0;if(!(f&1)){g=(f&255)>>>1;f=b+1|0}else{g=c[b+4>>2]|0;f=c[b+8>>2]|0}if(g>>>0>e>>>0?(h=$u(f+e|0,d&255,g-e|0)|0,(h|0)!=0):0)f=h-f|0;else f=-1;return f|0}function Si(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=a[b>>0]|0;j=(h&1)==0;if(j)i=(h&255)>>>1;else i=c[b+4>>2]|0;if(i>>>0<d>>>0|(g|0)==-1)ti(b);h=i-d|0;e=h>>>0<e>>>0?h:e;if(j)h=b+1|0;else h=c[b+8>>2]|0;i=e>>>0>g>>>0;h=av(h+d|0,f,i?g:e)|0;if(!h)if(e>>>0<g>>>0)h=-1;else return i&1|0;return h|0}function Ti(a,b){a=a|0;b=b|0;return Si(a,0,-1,b,lv(b|0)|0)|0}function Ui(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;if(f>>>0>4294967279)si(b);if(f>>>0<11){a[b>>0]=e<<1;f=b+1|0}else{g=f+16&-16;f=ut(g)|0;c[b+8>>2]=f;c[b>>2]=g|1;c[b+4>>2]=e}mv(f|0,d|0,e|0)|0;a[f+e>>0]=0;return}function Vi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;if(e>>>0>1073741807)si(b);if(e>>>0<2){a[b>>0]=e<<1;b=b+4|0}else{g=e+4&-4;f=ut(g<<2)|0;c[b+8>>2]=f;c[b>>2]=g|1;c[b+4>>2]=e;b=f}ot(b,d,e)|0;c[b+(e<<2)>>2]=0;return}function Wi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;if(d>>>0>1073741807)si(b);if(d>>>0<2){a[b>>0]=d<<1;b=b+4|0}else{g=d+4&-4;f=ut(g<<2)|0;c[b+8>>2]=f;c[b>>2]=g|1;c[b+4>>2]=d;b=f}qt(b,e,d)|0;c[b+(d<<2)>>2]=0;return}function Xi(b){b=b|0;if(a[b>>0]&1)xt(c[b+8>>2]|0);return}function Yi(a){a=a|0;Xi(a);return}function Zi(a,b){a=a|0;b=b|0;return _i(a,b,nt(b)|0)|0}function _i(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=a[b>>0]|0;if(!(f&1))h=1;else{f=c[b>>2]|0;h=(f&-2)+-1|0;f=f&255}g=(f&1)==0;do if(h>>>0>=e>>>0){if(g)f=b+4|0;else f=c[b+8>>2]|0;pt(f,d,e)|0;c[f+(e<<2)>>2]=0;if(!(a[b>>0]&1)){a[b>>0]=e<<1;break}else{c[b+4>>2]=e;break}}else{if(g)f=(f&255)>>>1;else f=c[b+4>>2]|0;bj(b,h,e-h|0,f,0,f,e,d)}while(0);return b|0}function $i(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;if(d>>>0>1073741807)si(b);e=a[b>>0]|0;if(!(e&1))f=1;else{e=c[b>>2]|0;f=(e&-2)+-1|0;e=e&255}if(!(e&1))j=(e&255)>>>1;else j=c[b+4>>2]|0;d=j>>>0>d>>>0?j:d;if(d>>>0<2)i=1;else i=(d+4&-4)+-1|0;do if((i|0)!=(f|0)){do if((i|0)!=1){d=(i<<2)+4|0;if(i>>>0>f>>>0)d=ut(d)|0;else d=ut(d)|0;if(!(e&1)){f=1;g=b+4|0;h=0;break}else{f=1;g=c[b+8>>2]|0;h=1;break}}else{d=b+4|0;f=0;g=c[b+8>>2]|0;h=1}while(0);if(!(e&1))e=(e&255)>>>1;else e=c[b+4>>2]|0;ot(d,g,e+1|0)|0;if(h)xt(g);if(f){c[b>>2]=i+1|1;c[b+4>>2]=j;c[b+8>>2]=d;break}else{a[b>>0]=j<<1;break}}while(0);return}function aj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=a[b>>0]|0;f=(e&1)!=0;if(f){g=(c[b>>2]&-2)+-1|0;h=c[b+4>>2]|0}else{g=1;h=(e&255)>>>1}if((h|0)==(g|0)){cj(b,g,1,g,g,0,0);if(!(a[b>>0]&1))g=7;else g=8}else if(f)g=8;else g=7;if((g|0)==7){a[b>>0]=(h<<1)+2;e=b+4|0;f=h+1|0}else if((g|0)==8){e=c[b+8>>2]|0;f=h+1|0;c[b+4>>2]=f}c[e+(h<<2)>>2]=d;c[e+(f<<2)>>2]=0;return}function bj(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;if((1073741806-d|0)>>>0<e>>>0)si(b);if(!(a[b>>0]&1))m=b+4|0;else m=c[b+8>>2]|0;if(d>>>0<536870887){e=e+d|0;l=d<<1;e=e>>>0<l>>>0?l:e;if(e>>>0<2)k=2;else k=e+4&-4}else k=1073741807;l=ut(k<<2)|0;if(g)ot(l,m,g)|0;if(i)ot(l+(g<<2)|0,j,i)|0;e=f-h|0;if((e|0)!=(g|0))ot(l+(i+g<<2)|0,m+(h+g<<2)|0,e-g|0)|0;if((d|0)!=1)xt(m);c[b+8>>2]=l;c[b>>2]=k|1;d=e+i|0;c[b+4>>2]=d;c[l+(d<<2)>>2]=0;return}function cj(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;if((1073741807-d|0)>>>0<e>>>0)si(b);if(!(a[b>>0]&1))l=b+4|0;else l=c[b+8>>2]|0;if(d>>>0<536870887){e=e+d|0;j=d<<1;e=e>>>0<j>>>0?j:e;if(e>>>0<2)j=2;else j=e+4&-4}else j=1073741807;k=ut(j<<2)|0;if(g)ot(k,l,g)|0;e=f-h|0;if((e|0)!=(g|0))ot(k+(i+g<<2)|0,l+(h+g<<2)|0,e-g|0)|0;if((d|0)!=1)xt(l);c[b+8>>2]=k;c[b>>2]=j|1;return}function dj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=i;i=i+16|0;d=e;f=(c[a+24>>2]|0)==0;c[a+16>>2]=f&1|b;if(!((f&1|b)&c[a+20>>2])){i=e;return}else{b=Oa(16)|0;Fk()|0;a=d;c[a>>2]=1;c[a+4>>2]=1075480;Gk(b,1075536,d);Qb(b|0,1075584,94)}}function ej(a){a=a|0;c[a>>2]=1075528;gj(a,0);Wo(a+28|0);uu(c[a+32>>2]|0);uu(c[a+36>>2]|0);uu(c[a+48>>2]|0);uu(c[a+60>>2]|0);return}function fj(a){a=a|0;ej(a);return}function gj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+40>>2]|0;if(d){e=a+32|0;f=a+36|0;do{d=d+-1|0;hc[c[(c[e>>2]|0)+(d<<2)>>2]&3](b,a,c[(c[f>>2]|0)+(d<<2)>>2]|0)}while((d|0)!=0)}return}function hj(a,b){a=a|0;b=b|0;Vo(a,b+28|0);return}function ij(a,b){a=a|0;b=b|0;var d=0;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0&1;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;d=a+28|0;a=a+32|0;b=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(b|0));Uo(d);return}function jj(a){a=a|0;ej(a);return}function kj(a){a=a|0;c[a>>2]=1075144;Wo(a+4|0);return}function lj(a){a=a|0;c[a>>2]=1075144;Wo(a+4|0);return}function mj(a){a=a|0;c[a>>2]=1075144;Wo(a+4|0);xt(a);return}function nj(a){a=a|0;c[a>>2]=1075144;Uo(a+4|0);a=a+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;return}function oj(a,b){a=a|0;b=b|0;return}function pj(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function qj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;d=a;c[d>>2]=0;c[d+4>>2]=0;d=a+8|0;c[d>>2]=-1;c[d+4>>2]=-1;return}function rj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;d=a;c[d>>2]=0;c[d+4>>2]=0;d=a+8|0;c[d>>2]=-1;c[d+4>>2]=-1;return}function sj(a){a=a|0;return 0}function tj(a){a=a|0;return 0}function uj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a:do if((e|0)>0){h=b+12|0;i=b+16|0;g=d;d=0;while(1){f=c[h>>2]|0;if(f>>>0<(c[i>>2]|0)>>>0){c[h>>2]=f+1;f=a[f>>0]|0}else{f=fc[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((f|0)==-1)break a;f=f&255}a[g>>0]=f;d=d+1|0;if((d|0)<(e|0))g=g+1|0;else break}}else d=0;while(0);return d|0}function vj(a){a=a|0;return -1}function wj(a){a=a|0;var b=0;if((fc[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1)a=-1;else{b=a+12|0;a=c[b>>2]|0;c[b>>2]=a+1;a=d[a>>0]|0}return a|0}function xj(a,b){a=a|0;b=b|0;return -1}function yj(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a:do if((f|0)>0){i=b+24|0;j=b+28|0;h=e;e=0;while(1){g=c[i>>2]|0;if(g>>>0>=(c[j>>2]|0)>>>0){if((oc[c[(c[b>>2]|0)+52>>2]&63](b,d[h>>0]|0)|0)==-1)break a}else{k=a[h>>0]|0;c[i>>2]=g+1;a[g>>0]=k}e=e+1|0;if((e|0)<(f|0))h=h+1|0;else break}}else e=0;while(0);return e|0}function zj(a,b){a=a|0;b=b|0;return -1}function Aj(a){a=a|0;c[a>>2]=1075208;Wo(a+4|0);return}function Bj(a){a=a|0;c[a>>2]=1075208;Wo(a+4|0);return}function Cj(a){a=a|0;c[a>>2]=1075208;Wo(a+4|0);xt(a);return}function Dj(a){a=a|0;c[a>>2]=1075208;Uo(a+4|0);a=a+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;return}function Ej(a,b){a=a|0;b=b|0;return}function Fj(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function Gj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;d=a;c[d>>2]=0;c[d+4>>2]=0;d=a+8|0;c[d>>2]=-1;c[d+4>>2]=-1;return}function Hj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;d=a;c[d>>2]=0;c[d+4>>2]=0;d=a+8|0;c[d>>2]=-1;c[d+4>>2]=-1;return}function Ij(a){a=a|0;return 0}function Jj(a){a=a|0;return 0}function Kj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a:do if((d|0)>0){g=a+12|0;h=a+16|0;f=b;b=0;while(1){e=c[g>>2]|0;if(e>>>0>=(c[h>>2]|0)>>>0){e=fc[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((e|0)==-1)break a}else{c[g>>2]=e+4;e=c[e>>2]|0}c[f>>2]=e;b=b+1|0;if((b|0)<(d|0))f=f+4|0;else break}}else b=0;while(0);return b|0}function Lj(a){a=a|0;return -1}function Mj(a){a=a|0;var b=0;if((fc[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1)a=-1;else{b=a+12|0;a=c[b>>2]|0;c[b>>2]=a+4;a=c[a>>2]|0}return a|0}function Nj(a,b){a=a|0;b=b|0;return -1}function Oj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;a:do if((d|0)>0){g=a+24|0;h=a+28|0;f=b;b=0;while(1){e=c[g>>2]|0;if(e>>>0>=(c[h>>2]|0)>>>0){if((oc[c[(c[a>>2]|0)+52>>2]&63](a,c[f>>2]|0)|0)==-1)break a}else{i=c[f>>2]|0;c[g>>2]=e+4;c[e>>2]=i}b=b+1|0;if((b|0)<(d|0))f=f+4|0;else break}}else b=0;while(0);return b|0}function Pj(a,b){a=a|0;b=b|0;return -1}function Qj(a,b){a=a|0;b=b|0;return}function Rj(a){a=a|0;ej(a+8|0);return}function Sj(a){a=a|0;ej(a+((c[(c[a>>2]|0)+-12>>2]|0)+8)|0);return}function Tj(a){a=a|0;ej(a+8|0);xt(a);return}function Uj(a){a=a|0;Tj(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function Vj(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+16|0;k=o;a[e>>0]=0;j=c[(c[f>>2]|0)+-12>>2]|0;h=c[f+(j+16)>>2]|0;if(!h){h=c[f+(j+72)>>2]|0;if(h)Wj(h)|0;do if(!g?(l=c[(c[f>>2]|0)+-12>>2]|0,(c[f+(l+4)>>2]&4096|0)!=0):0){Vo(k,f+(l+28)|0);h=Zo(k,1077904)|0;Wo(k);k=h+8|0;h=c[f+((c[(c[f>>2]|0)+-12>>2]|0)+24)>>2]|0;while(1){if(!h)break;if((c[h+12>>2]|0)==(c[h+16>>2]|0)){j=(fc[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1;h=j?0:h;if(!h)break}g=h+12|0;j=c[g>>2]|0;l=h+16|0;if((j|0)==(c[l>>2]|0))j=fc[c[(c[h>>2]|0)+36>>2]&127](h)|0;else j=d[j>>0]|0;if((j&255)<<24>>24<=-1){m=h;n=18;break}if(!(b[(c[k>>2]|0)+(j<<24>>24<<1)>>1]&8192)){m=h;n=18;break}j=c[g>>2]|0;if((j|0)==(c[l>>2]|0)){fc[c[(c[h>>2]|0)+40>>2]&127](h)|0;continue}else{c[g>>2]=j+1;continue}}if((n|0)==18?(m|0)!=0:0){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))break;if(!((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1|(m|0)==0))break}h=c[(c[f>>2]|0)+-12>>2]|0;dj(f+h|0,c[f+(h+16)>>2]|6)}while(0);a[e>>0]=(c[f+((c[(c[f>>2]|0)+-12>>2]|0)+16)>>2]|0)==0&1}else dj(f+j|0,h|4);i=o;return}function Wj(b){b=b|0;var d=0,e=0,f=0;e=i;i=i+16|0;d=e;if(c[b+((c[(c[b>>2]|0)+-12>>2]|0)+24)>>2]|0){ik(d,b);if((a[d>>0]|0)!=0?(f=c[b+((c[(c[b>>2]|0)+-12>>2]|0)+24)>>2]|0,(fc[c[(c[f>>2]|0)+24>>2]&127](f)|0)==-1):0){f=c[(c[b>>2]|0)+-12>>2]|0;dj(b+f|0,c[b+(f+16)>>2]|1)}kk(d)}i=e;return b|0}function Xj(a,b,c){a=a|0;b=b|0;c=c|0;Vj(a,b,c);return}function Yj(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if(!(c[a+20>>2]&1))return;else Lb()}function Zj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;m=i;i=i+48|0;f=m+28|0;e=m+24|0;g=m+20|0;h=m+16|0;n=m+32|0;k=m+12|0;l=m+8|0;j=m+4|0;Vj(n,b,0);if(a[n>>0]|0){c[k>>2]=0;Vo(j,b+((c[(c[b>>2]|0)+-12>>2]|0)+28)|0);o=Zo(j,1076408)|0;n=c[(c[b>>2]|0)+-12>>2]|0;p=c[(c[o>>2]|0)+16>>2]|0;c[g>>2]=c[b+(n+24)>>2];c[h>>2]=0;c[e+0>>2]=c[g+0>>2];c[f+0>>2]=c[h+0>>2];ac[p&63](m,o,e,f,b+n|0,k,l);Wo(j);c[d>>2]=c[l>>2];l=c[(c[b>>2]|0)+-12>>2]|0;dj(b+l|0,c[b+(l+16)>>2]|c[k>>2])}i=m;return b|0}function _j(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;l=i;i=i+32|0;f=l+24|0;e=l+20|0;g=l+16|0;h=l+12|0;m=l+28|0;k=l+8|0;j=l+4|0;Vj(m,b,0);if(a[m>>0]|0){c[k>>2]=0;Vo(j,b+((c[(c[b>>2]|0)+-12>>2]|0)+28)|0);n=Zo(j,1076408)|0;m=c[(c[b>>2]|0)+-12>>2]|0;o=c[(c[n>>2]|0)+20>>2]|0;c[g>>2]=c[b+(m+24)>>2];c[h>>2]=0;c[e+0>>2]=c[g+0>>2];c[f+0>>2]=c[h+0>>2];ac[o&63](l,n,e,f,b+m|0,k,d);Wo(j);e=c[(c[b>>2]|0)+-12>>2]|0;dj(b+e|0,c[b+(e+16)>>2]|c[k>>2])}i=l;return b|0}function $j(a){a=a|0;ej(a+8|0);return}function ak(a){a=a|0;ej(a+((c[(c[a>>2]|0)+-12>>2]|0)+8)|0);return}function bk(a){a=a|0;ej(a+8|0);xt(a);return}function ck(a){a=a|0;bk(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function dk(a,b){a=a|0;b=b|0;return}function ek(a){a=a|0;ej(a+4|0);return}function fk(a){a=a|0;ej(a+((c[(c[a>>2]|0)+-12>>2]|0)+4)|0);return}function gk(a){a=a|0;ej(a+4|0);xt(a);return}function hk(a){a=a|0;gk(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function ik(b,d){b=b|0;d=d|0;var e=0;a[b>>0]=0;c[b+4>>2]=d;e=c[(c[d>>2]|0)+-12>>2]|0;if(!(c[d+(e+16)>>2]|0)){e=c[d+(e+72)>>2]|0;if(e)Wj(e)|0;a[b>>0]=1}return}function jk(a,b){a=a|0;b=b|0;ik(a,b);return}function kk(a){a=a|0;var b=0,d=0;a=a+4|0;d=c[a>>2]|0;b=c[(c[d>>2]|0)+-12>>2]|0;if(((((c[d+(b+24)>>2]|0)!=0?(c[d+(b+16)>>2]|0)==0:0)?(c[d+(b+4)>>2]&8192|0)!=0:0)?!(Pa()|0):0)?(b=c[a>>2]|0,b=c[b+((c[(c[b>>2]|0)+-12>>2]|0)+24)>>2]|0,(fc[c[(c[b>>2]|0)+24>>2]&127](b)|0)==-1):0){b=c[a>>2]|0;a=c[(c[b>>2]|0)+-12>>2]|0;dj(b+a|0,c[b+(a+16)>>2]|1)}return}function lk(a){a=a|0;kk(a);return}function mk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+32|0;j=o+20|0;k=o+16|0;n=o+8|0;e=o+4|0;l=o;ik(n,b);if(a[n>>0]|0){Vo(e,b+((c[(c[b>>2]|0)+-12>>2]|0)+28)|0);m=Zo(e,1076592)|0;Wo(e);g=c[(c[b>>2]|0)+-12>>2]|0;h=c[b+(g+24)>>2]|0;f=b+(g+76)|0;e=c[f>>2]|0;if((e|0)==-1){Vo(j,b+(g+28)|0);e=Zo(j,1077904)|0;e=oc[c[(c[e>>2]|0)+28>>2]&63](e,32)|0;Wo(j);e=e<<24>>24;c[f>>2]=e}f=c[(c[m>>2]|0)+16>>2]|0;c[k>>2]=h;c[j+0>>2]=c[k+0>>2];nc[f&31](l,m,j,b+g|0,e&255,d);if(!(c[l>>2]|0)){d=c[(c[b>>2]|0)+-12>>2]|0;dj(b+d|0,c[b+(d+16)>>2]|5)}}kk(n);i=o;return b|0}function nk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+32|0;j=o+20|0;k=o+16|0;n=o+8|0;e=o+4|0;l=o;ik(n,b);if(a[n>>0]|0){Vo(e,b+((c[(c[b>>2]|0)+-12>>2]|0)+28)|0);m=Zo(e,1076592)|0;Wo(e);g=c[(c[b>>2]|0)+-12>>2]|0;h=c[b+(g+24)>>2]|0;f=b+(g+76)|0;e=c[f>>2]|0;if((e|0)==-1){Vo(j,b+(g+28)|0);e=Zo(j,1077904)|0;e=oc[c[(c[e>>2]|0)+28>>2]&63](e,32)|0;Wo(j);e=e<<24>>24;c[f>>2]=e}f=c[(c[m>>2]|0)+24>>2]|0;c[k>>2]=h;c[j+0>>2]=c[k+0>>2];nc[f&31](l,m,j,b+g|0,e&255,d);if(!(c[l>>2]|0)){d=c[(c[b>>2]|0)+-12>>2]|0;dj(b+d|0,c[b+(d+16)>>2]|5)}}kk(n);i=o;return b|0}function ok(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=i;i=i+32|0;k=p+20|0;m=p+16|0;o=p+8|0;f=p+4|0;n=p;ik(o,b);if(a[o>>0]|0){Vo(f,b+((c[(c[b>>2]|0)+-12>>2]|0)+28)|0);l=Zo(f,1076592)|0;Wo(f);h=c[(c[b>>2]|0)+-12>>2]|0;j=c[b+(h+24)>>2]|0;g=b+(h+76)|0;f=c[g>>2]|0;if((f|0)==-1){Vo(k,b+(h+28)|0);f=Zo(k,1077904)|0;f=oc[c[(c[f>>2]|0)+28>>2]&63](f,32)|0;Wo(k);f=f<<24>>24;c[g>>2]=f}g=c[(c[l>>2]|0)+20>>2]|0;c[m>>2]=j;c[k+0>>2]=c[m+0>>2];ac[g&63](n,l,k,b+h|0,f&255,d,e);if(!(c[n>>2]|0)){n=c[(c[b>>2]|0)+-12>>2]|0;dj(b+n|0,c[b+(n+16)>>2]|5)}}kk(o);i=p;return b|0}function pk(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=i;i=i+32|0;k=p+20|0;m=p+16|0;o=p+8|0;f=p+4|0;n=p;ik(o,b);if(a[o>>0]|0){Vo(f,b+((c[(c[b>>2]|0)+-12>>2]|0)+28)|0);l=Zo(f,1076592)|0;Wo(f);h=c[(c[b>>2]|0)+-12>>2]|0;j=c[b+(h+24)>>2]|0;g=b+(h+76)|0;f=c[g>>2]|0;if((f|0)==-1){Vo(k,b+(h+28)|0);f=Zo(k,1077904)|0;f=oc[c[(c[f>>2]|0)+28>>2]&63](f,32)|0;Wo(k);f=f<<24>>24;c[g>>2]=f}g=c[(c[l>>2]|0)+28>>2]|0;c[m>>2]=j;c[k+0>>2]=c[m+0>>2];ac[g&63](n,l,k,b+h|0,f&255,d,e);if(!(c[n>>2]|0)){n=c[(c[b>>2]|0)+-12>>2]|0;dj(b+n|0,c[b+(n+16)>>2]|5)}}kk(o);i=p;return b|0}function qk(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+32|0;j=o+20|0;k=o+16|0;n=o+8|0;e=o+4|0;l=o;ik(n,b);if(a[n>>0]|0){Vo(e,b+((c[(c[b>>2]|0)+-12>>2]|0)+28)|0);m=Zo(e,1076592)|0;Wo(e);g=c[(c[b>>2]|0)+-12>>2]|0;h=c[b+(g+24)>>2]|0;f=b+(g+76)|0;e=c[f>>2]|0;if((e|0)==-1){Vo(j,b+(g+28)|0);e=Zo(j,1077904)|0;e=oc[c[(c[e>>2]|0)+28>>2]&63](e,32)|0;Wo(j);e=e<<24>>24;c[f>>2]=e}f=c[(c[m>>2]|0)+32>>2]|0;c[k>>2]=h;c[j+0>>2]=c[k+0>>2];ic[f&7](l,m,j,b+g|0,e&255,d);if(!(c[l>>2]|0)){m=c[(c[b>>2]|0)+-12>>2]|0;dj(b+m|0,c[b+(m+16)>>2]|5)}}kk(n);i=o;return b|0}function rk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=i;i=i+16|0;h=j;ik(h,b);do if(a[h>>0]|0){e=c[b>>2]|0;g=c[b+((c[e+-12>>2]|0)+24)>>2]|0;if(g){e=g+24|0;f=c[e>>2]|0;if((f|0)!=(c[g+28>>2]|0)){c[e>>2]=f+1;a[f>>0]=d;break}if((oc[c[(c[g>>2]|0)+52>>2]&63](g,d&255)|0)!=-1)break;e=c[b>>2]|0}e=c[e+-12>>2]|0;dj(b+e|0,c[b+(e+16)>>2]|1)}while(0);kk(h);i=j;return b|0}function sk(a){a=a|0;ej(a+4|0);return}function tk(a){a=a|0;ej(a+((c[(c[a>>2]|0)+-12>>2]|0)+4)|0);return}function uk(a){a=a|0;ej(a+4|0);xt(a);return}function vk(a){a=a|0;uk(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function wk(a,b){a=a|0;b=b|0;return}function xk(a){a=a|0;ej(a+12|0);return}function yk(a){a=a|0;ej(a+-8+12|0);return}function zk(a){a=a|0;ej(a+((c[(c[a>>2]|0)+-12>>2]|0)+12)|0);return}function Ak(a){a=a|0;ej(a+12|0);xt(a);return}function Bk(a){a=a|0;Ak(a+-8|0);return}function Ck(a){a=a|0;Ak(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function Dk(a){a=a|0;return 1075424}function Ek(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)!=1&(c|0)<257)li(a,b,c);else vi(a,1075440,35);return}function Fk(){if((a[1075488]|0)==0?(Ia(1075488)|0)!=0:0){c[268870]=1076184;Sa(1075488)}return 1075480}function Gk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;j=d;h=c[j+4>>2]|0;d=g;c[d>>2]=c[j>>2];c[d+4>>2]=h;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];ni(a,f,b);c[a>>2]=1075504;i=e;return}function Hk(a){a=a|0;oi(a);return}function Ik(a){a=a|0;oi(a);xt(a);return}function Jk(a){a=a|0;ej(a);xt(a);return}function Kk(a){a=a|0;return}function Lk(a){a=a|0;return}function Mk(a){a=a|0;xt(a);return}function Nk(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a:do if((e|0)==(f|0))h=6;else while(1){if((c|0)==(d|0)){c=-1;break a}b=a[c>>0]|0;g=a[e>>0]|0;if(b<<24>>24<g<<24>>24){c=-1;break a}if(g<<24>>24<b<<24>>24){c=1;break a}c=c+1|0;e=e+1|0;if((e|0)==(f|0)){h=6;break}}while(0);if((h|0)==6)c=(c|0)!=(d|0)&1;return c|0}function Ok(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Tq(a,c,d);return}function Pk(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)==(d|0))b=0;else{b=0;do{b=(a[c>>0]|0)+(b<<4)|0;e=b&-268435456;b=(e>>>24|e)^b;c=c+1|0}while((c|0)!=(d|0))}return b|0}function Qk(a){a=a|0;return}function Rk(a){a=a|0;xt(a);return}function Sk(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a:do if((e|0)==(f|0))h=6;else while(1){if((b|0)==(d|0)){b=-1;break a}a=c[b>>2]|0;g=c[e>>2]|0;if((a|0)<(g|0)){b=-1;break a}if((g|0)<(a|0)){b=1;break a}b=b+4|0;e=e+4|0;if((e|0)==(f|0)){h=6;break}}while(0);if((h|0)==6)b=(b|0)!=(d|0)&1;return b|0}function Tk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Uq(a,c,d);return}function Uk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if((b|0)==(d|0))a=0;else{a=0;do{a=(c[b>>2]|0)+(a<<4)|0;e=a&-268435456;a=(e>>>24|e)^a;b=b+4|0}while((b|0)!=(d|0))}return a|0}function Vk(a){a=a|0;return}function Wk(a){a=a|0;xt(a);return}function Xk(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=i;i=i+64|0;k=u+60|0;l=u+56|0;t=u+52|0;m=u+48|0;n=u+44|0;o=u+40|0;p=u+36|0;q=u+32|0;s=u+8|0;r=u;if(!(c[g+4>>2]&1)){c[t>>2]=-1;r=c[(c[d>>2]|0)+16>>2]|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[o+0>>2];ac[r&63](m,d,l,k,g,h,t);l=c[m>>2]|0;c[e>>2]=l;k=c[t>>2]|0;if((k|0)==1)a[j>>0]=1;else if(!k)a[j>>0]=0;else{a[j>>0]=1;c[h>>2]=4}c[b>>2]=l}else{hj(p,g);o=Zo(p,1077904)|0;ei(c[p>>2]|0)|0;hj(q,g);g=Zo(q,1078048)|0;ei(c[q>>2]|0)|0;dc[c[(c[g>>2]|0)+24>>2]&63](s,g);dc[c[(c[g>>2]|0)+28>>2]&63](s+12|0,g);c[r>>2]=c[f>>2];c[k+0>>2]=c[r+0>>2];a[j>>0]=(Vq(e,k,s,s+24|0,o,h,1)|0)==(s|0)&1;c[b>>2]=c[e>>2];Bi(s+12|0);Bi(s)}i=u;return}function Yk(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];Wq(a,b,l,k,f,g,h);i=j;return}function Zk(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];Xq(a,b,l,k,f,g,h);i=j;return}function _k(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];Yq(a,b,l,k,f,g,h);i=j;return}function $k(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];Zq(a,b,l,k,f,g,h);i=j;return}function al(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];_q(a,b,l,k,f,g,h);i=j;return}function bl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];$q(a,b,l,k,f,g,h);i=j;return}function cl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];ar(a,b,l,k,f,g,h);i=j;return}function dl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];br(a,b,l,k,f,g,h);i=j;return}function el(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];cr(a,b,l,k,f,g,h);i=j;return}function fl(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=i;i=i+240|0;y=B;s=B+208|0;A=B+196|0;w=B+192|0;z=B+180|0;x=B+176|0;u=B+16|0;v=B+8|0;t=B+4|0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;hj(w,h);e=Zo(w,1077904)|0;lc[c[(c[e>>2]|0)+32>>2]&7](e,1076416,1076442|0,s)|0;ei(c[w>>2]|0)|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;Gi(z,10,0);if(!(a[z>>0]&1)){h=z+1|0;l=h;w=z+8|0}else{h=z+8|0;l=z+1|0;w=h;h=c[h>>2]|0}c[x>>2]=h;c[v>>2]=u;c[t>>2]=0;r=z+4|0;e=c[f>>2]|0;a:while(1){if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;n=(e|0)==0;m=c[g>>2]|0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(n)break;else break a;if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(n)break;else break a;else{c[g>>2]=0;C=14;break}}else C=14;while(0);if((C|0)==14){C=0;if(n){m=0;break}else m=0}p=a[z>>0]|0;n=(p&1)==0;if(n)o=(p&255)>>>1;else o=c[r>>2]|0;if((c[x>>2]|0)==(h+o|0)){if(n){n=(p&255)>>>1;o=(p&255)>>>1}else{o=c[r>>2]|0;n=o}Gi(z,n<<1,0);if(!(a[z>>0]&1))n=10;else n=(c[z>>2]&-2)+-1|0;Gi(z,n,0);if(!(a[z>>0]&1))h=l;else h=c[w>>2]|0;c[x>>2]=h+o}p=e+12|0;o=c[p>>2]|0;q=e+16|0;if((o|0)==(c[q>>2]|0))n=fc[c[(c[e>>2]|0)+36>>2]&127](e)|0;else n=d[o>>0]|0;if(gl(n&255,16,h,x,t,0,A,u,v,s)|0)break;n=c[p>>2]|0;if((n|0)==(c[q>>2]|0)){fc[c[(c[e>>2]|0)+40>>2]&127](e)|0;continue}else{c[p>>2]=n+1;continue}}Gi(z,(c[x>>2]|0)-h|0,0);if(a[z>>0]&1)l=c[w>>2]|0;x=hl()|0;c[y>>2]=k;if((dr(l,x,1076456,y)|0)!=1)c[j>>2]=4;if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;l=(e|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(l)break;else{C=50;break}if((fc[c[(c[m>>2]|0)+36>>2]&127](m)|0)!=-1)if(l^(m|0)==0)break;else{C=50;break}else{c[g>>2]=0;C=48;break}}else C=48;while(0);if((C|0)==48?l:0)C=50;if((C|0)==50)c[j>>2]=c[j>>2]|2;c[b>>2]=e;Bi(z);Bi(A);i=B;return}function gl(b,d,e,f,g,h,i,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;o=c[f>>2]|0;p=(o|0)==(e|0);do if(p){m=(a[l+24>>0]|0)==b<<24>>24;if(!m?(a[l+25>>0]|0)!=b<<24>>24:0){n=5;break}c[f>>2]=e+1;a[e>>0]=m?43:45;c[g>>2]=0;i=0}else n=5;while(0);do if((n|0)==5){m=a[i>>0]|0;if(!(m&1))m=(m&255)>>>1;else m=c[i+4>>2]|0;if((m|0)!=0?b<<24>>24==h<<24>>24:0){i=c[k>>2]|0;if((i-j|0)>=160){i=0;break}p=c[g>>2]|0;c[k>>2]=i+4;c[i>>2]=p;c[g>>2]=0;i=0;break}i=l+26|0;m=l;do{if((a[m>>0]|0)==b<<24>>24){i=m;break}m=m+1|0}while((m|0)!=(i|0));i=i-l|0;if((i|0)>23)i=-1;else{if((d|0)==10|(d|0)==8){if((i|0)>=(d|0)){i=-1;break}}else if((d|0)==16?(i|0)>=22:0){if(p){i=-1;break}if((o-e|0)>=3){i=-1;break}if((a[o+-1>>0]|0)!=48){i=-1;break}c[g>>2]=0;i=a[1076416+i>>0]|0;c[f>>2]=o+1;a[o>>0]=i;i=0;break}i=a[1076416+i>>0]|0;c[f>>2]=o+1;a[o>>0]=i;c[g>>2]=(c[g>>2]|0)+1;i=0}}while(0);return i|0}function hl(){if((a[1077800]|0)==0?(Ia(1077800)|0)!=0:0){c[269448]=ab(2147483647,1077808,0)|0;Sa(1077800)}return c[269448]|0}function il(a){a=a|0;return}function jl(a){a=a|0;xt(a);return}function kl(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=i;i=i+64|0;k=u+60|0;l=u+56|0;t=u+52|0;m=u+48|0;n=u+44|0;o=u+40|0;p=u+36|0;q=u+32|0;s=u+8|0;r=u;if(!(c[g+4>>2]&1)){c[t>>2]=-1;r=c[(c[d>>2]|0)+16>>2]|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[o+0>>2];ac[r&63](m,d,l,k,g,h,t);l=c[m>>2]|0;c[e>>2]=l;k=c[t>>2]|0;if(!k)a[j>>0]=0;else if((k|0)==1)a[j>>0]=1;else{a[j>>0]=1;c[h>>2]=4}c[b>>2]=l}else{hj(p,g);o=Zo(p,1077896)|0;ei(c[p>>2]|0)|0;hj(q,g);g=Zo(q,1078056)|0;ei(c[q>>2]|0)|0;dc[c[(c[g>>2]|0)+24>>2]&63](s,g);dc[c[(c[g>>2]|0)+28>>2]&63](s+12|0,g);c[r>>2]=c[f>>2];c[k+0>>2]=c[r+0>>2];a[j>>0]=(er(e,k,s,s+24|0,o,h,1)|0)==(s|0)&1;c[b>>2]=c[e>>2];Yi(s+12|0);Yi(s)}i=u;return}function ll(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];fr(a,b,l,k,f,g,h);i=j;return}function ml(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];gr(a,b,l,k,f,g,h);i=j;return}function nl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];hr(a,b,l,k,f,g,h);i=j;return}function ol(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];ir(a,b,l,k,f,g,h);i=j;return}function pl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];jr(a,b,l,k,f,g,h);i=j;return}function ql(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];kr(a,b,l,k,f,g,h);i=j;return}function rl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];lr(a,b,l,k,f,g,h);i=j;return}function sl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];mr(a,b,l,k,f,g,h);i=j;return}function tl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;n=j+4|0;m=j;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];c[l+0>>2]=c[n+0>>2];c[k+0>>2]=c[m+0>>2];nr(a,b,l,k,f,g,h);i=j;return}function ul(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=i;i=i+320|0;x=A;r=A+208|0;z=A+196|0;v=A+192|0;y=A+180|0;w=A+176|0;t=A+16|0;u=A+8|0;s=A+4|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;hj(v,g);d=Zo(v,1077896)|0;lc[c[(c[d>>2]|0)+48>>2]&7](d,1076416,1076442|0,r)|0;ei(c[v>>2]|0)|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;Gi(y,10,0);if(!(a[y>>0]&1)){d=y+1|0;g=d;v=y+8|0}else{d=y+8|0;g=y+1|0;v=d;d=c[d>>2]|0}c[w>>2]=d;c[u>>2]=t;c[s>>2]=0;q=y+4|0;k=c[e>>2]|0;a:while(1){if(k){l=c[k+12>>2]|0;if((l|0)==(c[k+16>>2]|0))l=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else l=c[l>>2]|0;if((l|0)==-1){c[e>>2]=0;m=1;k=0}else m=0}else{m=1;k=0}n=c[f>>2]|0;do if(n){l=c[n+12>>2]|0;if((l|0)==(c[n+16>>2]|0))l=fc[c[(c[n>>2]|0)+36>>2]&127](n)|0;else l=c[l>>2]|0;if((l|0)!=-1)if(m)break;else{l=n;break a}else{c[f>>2]=0;B=17;break}}else B=17;while(0);if((B|0)==17){B=0;if(m){l=0;break}else n=0}o=a[y>>0]|0;l=(o&1)==0;if(l)m=(o&255)>>>1;else m=c[q>>2]|0;if((c[w>>2]|0)==(d+m|0)){if(l){l=(o&255)>>>1;m=(o&255)>>>1}else{m=c[q>>2]|0;l=m}Gi(y,l<<1,0);if(!(a[y>>0]&1))l=10;else l=(c[y>>2]&-2)+-1|0;Gi(y,l,0);if(!(a[y>>0]&1))d=g;else d=c[v>>2]|0;c[w>>2]=d+m}o=k+12|0;m=c[o>>2]|0;p=k+16|0;if((m|0)==(c[p>>2]|0))l=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else l=c[m>>2]|0;if(vl(l,16,d,w,s,0,z,t,u,r)|0){l=n;break}l=c[o>>2]|0;if((l|0)==(c[p>>2]|0)){fc[c[(c[k>>2]|0)+40>>2]&127](k)|0;continue}else{c[o>>2]=l+4;continue}}Gi(y,(c[w>>2]|0)-d|0,0);if(a[y>>0]&1)g=c[v>>2]|0;w=hl()|0;c[x>>2]=j;if((dr(g,w,1076456,x)|0)!=1)c[h>>2]=4;if(k){d=c[k+12>>2]|0;if((d|0)==(c[k+16>>2]|0))d=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else d=c[d>>2]|0;if((d|0)==-1){c[e>>2]=0;k=0;g=1}else g=0}else{k=0;g=1}do if(l){d=c[l+12>>2]|0;if((d|0)==(c[l+16>>2]|0))d=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else d=c[d>>2]|0;if((d|0)!=-1)if(g)break;else{B=56;break}else{c[f>>2]=0;B=54;break}}else B=54;while(0);if((B|0)==54?g:0)B=56;if((B|0)==56)c[h>>2]=c[h>>2]|2;c[b>>2]=k;Bi(y);Bi(z);i=A;return}function vl(b,d,e,f,g,h,i,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;o=c[f>>2]|0;p=(o|0)==(e|0);do if(p){m=(c[l+96>>2]|0)==(b|0);if(!m?(c[l+100>>2]|0)!=(b|0):0){n=5;break}c[f>>2]=e+1;a[e>>0]=m?43:45;c[g>>2]=0;i=0}else n=5;while(0);do if((n|0)==5){m=a[i>>0]|0;if(!(m&1))m=(m&255)>>>1;else m=c[i+4>>2]|0;if((m|0)!=0&(b|0)==(h|0)){i=c[k>>2]|0;if((i-j|0)>=160){i=0;break}p=c[g>>2]|0;c[k>>2]=i+4;c[i>>2]=p;c[g>>2]=0;i=0;break}i=l+104|0;m=l;do{if((c[m>>2]|0)==(b|0)){i=m;break}m=m+4|0}while((m|0)!=(i|0));i=i-l|0;m=i>>2;if((i|0)>92)i=-1;else{if((d|0)==16){if((i|0)>=88){if(p){i=-1;break}if((o-e|0)>=3){i=-1;break}if((a[o+-1>>0]|0)!=48){i=-1;break}c[g>>2]=0;i=a[1076416+m>>0]|0;c[f>>2]=o+1;a[o>>0]=i;i=0;break}}else if((d|0)==10|(d|0)==8?(m|0)>=(d|0):0){i=-1;break}i=a[1076416+m>>0]|0;c[f>>2]=o+1;a[o>>0]=i;c[g>>2]=(c[g>>2]|0)+1;i=0}}while(0);return i|0}function wl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;hj(h,d);d=Zo(h,1077904)|0;lc[c[(c[d>>2]|0)+32>>2]&7](d,1076416,1076442|0,e)|0;e=Zo(h,1078048)|0;a[f>>0]=fc[c[(c[e>>2]|0)+16>>2]&127](e)|0;dc[c[(c[e>>2]|0)+20>>2]&63](b,e);ei(c[h>>2]|0)|0;i=g;return}function xl(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;hj(j,d);d=Zo(j,1077904)|0;lc[c[(c[d>>2]|0)+32>>2]&7](d,1076416,1076448|0,e)|0;e=Zo(j,1078048)|0;a[f>>0]=fc[c[(c[e>>2]|0)+12>>2]&127](e)|0;a[g>>0]=fc[c[(c[e>>2]|0)+16>>2]&127](e)|0;dc[c[(c[e>>2]|0)+20>>2]&63](b,e);ei(c[j>>2]|0)|0;i=h;return}function yl(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0;do if(b<<24>>24==i<<24>>24)if(a[e>>0]|0){a[e>>0]=0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=46;j=a[k>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[k+4>>2]|0;if((j|0)!=0?(p=c[m>>2]|0,(p-l|0)<160):0){j=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=j;j=0}else j=0}else j=-1;else{if(b<<24>>24==j<<24>>24){j=a[k>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[k+4>>2]|0;if(j){if(!(a[e>>0]|0)){j=-1;break}j=c[m>>2]|0;if((j-l|0)>=160){j=0;break}k=c[n>>2]|0;c[m>>2]=j+4;c[j>>2]=k;c[n>>2]=0;j=0;break}}j=o+32|0;i=o;do{if((a[i>>0]|0)==b<<24>>24){j=i;break}i=i+1|0}while((i|0)!=(j|0));i=j-o|0;if((i|0)<=31){p=a[1076416+i>>0]|0;if((i|0)==23|(i|0)==22){a[f>>0]=80;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=p;j=0;break}else if((i|0)==24|(i|0)==25){j=c[h>>2]|0;if((j|0)!=(g|0)?(d[j+-1>>0]&95|0)!=(d[f>>0]&127|0):0){j=-1;break}c[h>>2]=j+1;a[j>>0]=p;j=0;break}else{j=p&95;if((j|0)==(a[f>>0]|0)?(a[f>>0]=j|128,(a[e>>0]|0)!=0):0){a[e>>0]=0;j=a[k>>0]|0;if(!(j&1))j=(j&255)>>>1;else j=c[k+4>>2]|0;if((j|0)!=0?(q=c[m>>2]|0,(q-l|0)<160):0){k=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=k}}k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=p;if((i|0)>21){j=0;break}c[n>>2]=(c[n>>2]|0)+1;j=0;break}}else j=-1}while(0);return j|0}function zl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;hj(g,b);b=Zo(g,1077896)|0;lc[c[(c[b>>2]|0)+48>>2]&7](b,1076416,1076442|0,d)|0;d=Zo(g,1078056)|0;c[e>>2]=fc[c[(c[d>>2]|0)+16>>2]&127](d)|0;dc[c[(c[d>>2]|0)+20>>2]&63](a,d);ei(c[g>>2]|0)|0;i=f;return}function Al(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;hj(h,b);b=Zo(h,1077896)|0;lc[c[(c[b>>2]|0)+48>>2]&7](b,1076416,1076448|0,d)|0;d=Zo(h,1078056)|0;c[e>>2]=fc[c[(c[d>>2]|0)+12>>2]&127](d)|0;c[f>>2]=fc[c[(c[d>>2]|0)+16>>2]&127](d)|0;dc[c[(c[d>>2]|0)+20>>2]&63](a,d);ei(c[h>>2]|0)|0;i=g;return}
function ar(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;G=i;i=i+240|0;w=G+200|0;n=G+199|0;m=G+198|0;F=G+184|0;E=G+172|0;y=G+168|0;A=G+8|0;B=G+4|0;z=G;C=G+197|0;x=G+196|0;xl(F,j,w,n,m);c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;Gi(E,10,0);if(!(a[E>>0]&1)){j=E+1|0;t=j;u=E+8|0}else{j=E+8|0;t=E+1|0;u=j;j=c[j>>2]|0}c[y>>2]=j;c[B>>2]=A;c[z>>2]=0;a[C>>0]=1;a[x>>0]=69;v=E+4|0;s=a[n>>0]|0;r=a[m>>0]|0;e=c[f>>2]|0;a:while(1){if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;m=(e|0)==0;n=c[h>>2]|0;do if(n){if((c[n+12>>2]|0)!=(c[n+16>>2]|0))if(m)break;else break a;if((fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)!=-1)if(m)break;else break a;else{c[h>>2]=0;H=14;break}}else H=14;while(0);if((H|0)==14){H=0;if(m){n=0;break}else n=0}p=a[E>>0]|0;m=(p&1)==0;if(m)o=(p&255)>>>1;else o=c[v>>2]|0;if((c[y>>2]|0)==(j+o|0)){if(m){j=(p&255)>>>1;o=(p&255)>>>1}else{o=c[v>>2]|0;j=o}Gi(E,j<<1,0);if(!(a[E>>0]&1))j=10;else j=(c[E>>2]&-2)+-1|0;Gi(E,j,0);if(!(a[E>>0]&1))j=t;else j=c[u>>2]|0;c[y>>2]=j+o}p=e+12|0;o=c[p>>2]|0;q=e+16|0;if((o|0)==(c[q>>2]|0))m=fc[c[(c[e>>2]|0)+36>>2]&127](e)|0;else m=d[o>>0]|0;if(yl(m&255,C,x,j,y,s,r,F,A,B,z,w)|0)break;n=c[p>>2]|0;if((n|0)==(c[q>>2]|0)){fc[c[(c[e>>2]|0)+40>>2]&127](e)|0;continue}else{c[p>>2]=n+1;continue}}m=a[F>>0]|0;if(!(m&1))m=(m&255)>>>1;else m=c[F+4>>2]|0;if(!((m|0)==0|(a[C>>0]|0)==0)?(D=c[B>>2]|0,(D-A|0)<160):0){C=c[z>>2]|0;c[B>>2]=D+4;c[D>>2]=C}g[l>>2]=+Ks(j,c[y>>2]|0,k);go(F,A,c[B>>2]|0,k);if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;m=(e|0)==0;do if(n){if((c[n+12>>2]|0)!=(c[n+16>>2]|0))if(m)break;else{H=52;break}if((fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)!=-1)if(m^(n|0)==0)break;else{H=52;break}else{c[h>>2]=0;H=50;break}}else H=50;while(0);if((H|0)==50?m:0)H=52;if((H|0)==52)c[k>>2]=c[k>>2]|2;c[b>>2]=e;Bi(E);Bi(F);i=G;return}function br(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;G=i;i=i+240|0;w=G+200|0;n=G+199|0;m=G+198|0;F=G+184|0;E=G+172|0;y=G+168|0;A=G+8|0;B=G+4|0;z=G;C=G+197|0;x=G+196|0;xl(F,j,w,n,m);c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;Gi(E,10,0);if(!(a[E>>0]&1)){j=E+1|0;t=j;u=E+8|0}else{j=E+8|0;t=E+1|0;u=j;j=c[j>>2]|0}c[y>>2]=j;c[B>>2]=A;c[z>>2]=0;a[C>>0]=1;a[x>>0]=69;v=E+4|0;s=a[n>>0]|0;r=a[m>>0]|0;e=c[f>>2]|0;a:while(1){if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;m=(e|0)==0;n=c[g>>2]|0;do if(n){if((c[n+12>>2]|0)!=(c[n+16>>2]|0))if(m)break;else break a;if((fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)!=-1)if(m)break;else break a;else{c[g>>2]=0;H=14;break}}else H=14;while(0);if((H|0)==14){H=0;if(m){n=0;break}else n=0}p=a[E>>0]|0;m=(p&1)==0;if(m)o=(p&255)>>>1;else o=c[v>>2]|0;if((c[y>>2]|0)==(j+o|0)){if(m){j=(p&255)>>>1;o=(p&255)>>>1}else{o=c[v>>2]|0;j=o}Gi(E,j<<1,0);if(!(a[E>>0]&1))j=10;else j=(c[E>>2]&-2)+-1|0;Gi(E,j,0);if(!(a[E>>0]&1))j=t;else j=c[u>>2]|0;c[y>>2]=j+o}p=e+12|0;o=c[p>>2]|0;q=e+16|0;if((o|0)==(c[q>>2]|0))m=fc[c[(c[e>>2]|0)+36>>2]&127](e)|0;else m=d[o>>0]|0;if(yl(m&255,C,x,j,y,s,r,F,A,B,z,w)|0)break;n=c[p>>2]|0;if((n|0)==(c[q>>2]|0)){fc[c[(c[e>>2]|0)+40>>2]&127](e)|0;continue}else{c[p>>2]=n+1;continue}}m=a[F>>0]|0;if(!(m&1))m=(m&255)>>>1;else m=c[F+4>>2]|0;if(!((m|0)==0|(a[C>>0]|0)==0)?(D=c[B>>2]|0,(D-A|0)<160):0){C=c[z>>2]|0;c[B>>2]=D+4;c[D>>2]=C}h[l>>3]=+Ls(j,c[y>>2]|0,k);go(F,A,c[B>>2]|0,k);if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;m=(e|0)==0;do if(n){if((c[n+12>>2]|0)!=(c[n+16>>2]|0))if(m)break;else{H=52;break}if((fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)!=-1)if(m^(n|0)==0)break;else{H=52;break}else{c[g>>2]=0;H=50;break}}else H=50;while(0);if((H|0)==50?m:0)H=52;if((H|0)==52)c[k>>2]=c[k>>2]|2;c[b>>2]=e;Bi(E);Bi(F);i=G;return}function cr(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;G=i;i=i+240|0;w=G+200|0;n=G+199|0;m=G+198|0;F=G+184|0;E=G+172|0;y=G+168|0;A=G+8|0;B=G+4|0;z=G;C=G+197|0;x=G+196|0;xl(F,j,w,n,m);c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;Gi(E,10,0);if(!(a[E>>0]&1)){j=E+1|0;t=j;u=E+8|0}else{j=E+8|0;t=E+1|0;u=j;j=c[j>>2]|0}c[y>>2]=j;c[B>>2]=A;c[z>>2]=0;a[C>>0]=1;a[x>>0]=69;v=E+4|0;s=a[n>>0]|0;r=a[m>>0]|0;e=c[f>>2]|0;a:while(1){if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;m=(e|0)==0;n=c[g>>2]|0;do if(n){if((c[n+12>>2]|0)!=(c[n+16>>2]|0))if(m)break;else break a;if((fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)!=-1)if(m)break;else break a;else{c[g>>2]=0;H=14;break}}else H=14;while(0);if((H|0)==14){H=0;if(m){n=0;break}else n=0}p=a[E>>0]|0;m=(p&1)==0;if(m)o=(p&255)>>>1;else o=c[v>>2]|0;if((c[y>>2]|0)==(j+o|0)){if(m){j=(p&255)>>>1;o=(p&255)>>>1}else{o=c[v>>2]|0;j=o}Gi(E,j<<1,0);if(!(a[E>>0]&1))j=10;else j=(c[E>>2]&-2)+-1|0;Gi(E,j,0);if(!(a[E>>0]&1))j=t;else j=c[u>>2]|0;c[y>>2]=j+o}p=e+12|0;o=c[p>>2]|0;q=e+16|0;if((o|0)==(c[q>>2]|0))m=fc[c[(c[e>>2]|0)+36>>2]&127](e)|0;else m=d[o>>0]|0;if(yl(m&255,C,x,j,y,s,r,F,A,B,z,w)|0)break;n=c[p>>2]|0;if((n|0)==(c[q>>2]|0)){fc[c[(c[e>>2]|0)+40>>2]&127](e)|0;continue}else{c[p>>2]=n+1;continue}}m=a[F>>0]|0;if(!(m&1))m=(m&255)>>>1;else m=c[F+4>>2]|0;if(!((m|0)==0|(a[C>>0]|0)==0)?(D=c[B>>2]|0,(D-A|0)<160):0){C=c[z>>2]|0;c[B>>2]=D+4;c[D>>2]=C}h[l>>3]=+Ms(j,c[y>>2]|0,k);go(F,A,c[B>>2]|0,k);if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(fc[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;m=(e|0)==0;do if(n){if((c[n+12>>2]|0)!=(c[n+16>>2]|0))if(m)break;else{H=52;break}if((fc[c[(c[n>>2]|0)+36>>2]&127](n)|0)!=-1)if(m^(n|0)==0)break;else{H=52;break}else{c[g>>2]=0;H=50;break}}else H=50;while(0);if((H|0)==50?m:0)H=52;if((H|0)==52)c[k>>2]=c[k>>2]|2;c[b>>2]=e;Bi(E);Bi(F);i=G;return}function dr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;b=_a(b|0)|0;e=mt(a,d,g)|0;if(b)_a(b|0)|0;i=f;return e|0}function er(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=i;i=i+112|0;m=x;n=(f-e|0)/12|0;if(n>>>0>100){m=tu(n)|0;if(!m)ou();else{v=m;k=m}}else{v=0;k=m}u=(e|0)==(f|0);if(u)m=0;else{p=e;o=0;l=k;while(1){m=a[p>>0]|0;if(!(m&1))m=(m&255)>>>1;else m=c[p+4>>2]|0;if(!m){a[l>>0]=2;m=o+1|0;n=n+-1|0}else{a[l>>0]=1;m=o}p=p+12|0;if((p|0)==(f|0))break;else{o=m;l=l+1|0}}}l=0;q=m;r=n;a:while(1){while(1){n=c[b>>2]|0;do if(n){m=c[n+12>>2]|0;if((m|0)==(c[n+16>>2]|0))m=fc[c[(c[n>>2]|0)+36>>2]&127](n)|0;else m=c[m>>2]|0;if((m|0)==-1){c[b>>2]=0;p=1;break}else{p=(c[b>>2]|0)==0;break}}else p=1;while(0);n=c[d>>2]|0;if(n){m=c[n+12>>2]|0;if((m|0)==(c[n+16>>2]|0))m=fc[c[(c[n>>2]|0)+36>>2]&127](n)|0;else m=c[m>>2]|0;if((m|0)==-1){c[d>>2]=0;n=0;o=1}else o=0}else{n=0;o=1}m=c[b>>2]|0;if(!((p^o)&(r|0)!=0))break a;n=c[m+12>>2]|0;if((n|0)==(c[m+16>>2]|0))m=fc[c[(c[m>>2]|0)+36>>2]&127](m)|0;else m=c[n>>2]|0;if(!j)m=oc[c[(c[g>>2]|0)+28>>2]&63](g,m)|0;n=l+1|0;if(u)l=n;else break}p=0;t=e;s=k;while(1){do if((a[s>>0]|0)==1){if(!(a[t>>0]&1))o=t+4|0;else o=c[t+8>>2]|0;o=c[o+(l<<2)>>2]|0;if(!j)o=oc[c[(c[g>>2]|0)+28>>2]&63](g,o)|0;if((m|0)!=(o|0)){a[s>>0]=0;r=r+-1|0;break}o=a[t>>0]|0;if(!(o&1))o=(o&255)>>>1;else o=c[t+4>>2]|0;if((o|0)==(n|0)){a[s>>0]=2;p=1;q=q+1|0;r=r+-1|0}else p=1}while(0);t=t+12|0;if((t|0)==(f|0))break;else s=s+1|0}if(!p){l=n;continue}m=c[b>>2]|0;l=m+12|0;o=c[l>>2]|0;if((o|0)==(c[m+16>>2]|0))fc[c[(c[m>>2]|0)+40>>2]&127](m)|0;else c[l>>2]=o+4;if((q+r|0)>>>0<2){l=n;continue}else{m=e;o=q;p=k}while(1){if((a[p>>0]|0)==2){l=a[m>>0]|0;if(!(l&1))l=(l&255)>>>1;else l=c[m+4>>2]|0;if((l|0)!=(n|0)){a[p>>0]=0;o=o+-1|0}}m=m+12|0;if((m|0)==(f|0)){l=n;q=o;continue a}else p=p+1|0}}do if(m){l=c[m+12>>2]|0;if((l|0)==(c[m+16>>2]|0))l=fc[c[(c[m>>2]|0)+36>>2]&127](m)|0;else l=c[l>>2]|0;if((l|0)==-1){c[b>>2]=0;m=1;break}else{m=(c[b>>2]|0)==0;break}}else m=1;while(0);do if(n){l=c[n+12>>2]|0;if((l|0)==(c[n+16>>2]|0))l=fc[c[(c[n>>2]|0)+36>>2]&127](n)|0;else l=c[l>>2]|0;if((l|0)!=-1)if(m)break;else{w=76;break}else{c[d>>2]=0;w=74;break}}else w=74;while(0);if((w|0)==74?m:0)w=76;if((w|0)==76)c[h>>2]=c[h>>2]|2;b:do if(u)w=80;else while(1){if((a[k>>0]|0)==2){f=e;break b}e=e+12|0;if((e|0)==(f|0)){w=80;break}else k=k+1|0}while(0);if((w|0)==80)c[h>>2]=c[h>>2]|4;if(v)uu(v);i=x;return f|0}function fr(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=i;i=i+304|0;t=C+200|0;k=C+196|0;B=C+184|0;A=C+172|0;v=C+168|0;x=C+8|0;y=C+4|0;w=C;u=wq(g)|0;zl(B,g,t,k);c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;Gi(A,10,0);if(!(a[A>>0]&1)){d=A+1|0;q=d;r=A+8|0}else{d=A+8|0;q=A+1|0;r=d;d=c[d>>2]|0}c[v>>2]=d;c[y>>2]=x;c[w>>2]=0;s=A+4|0;p=c[k>>2]|0;k=c[e>>2]|0;a:while(1){if(k){g=c[k+12>>2]|0;if((g|0)==(c[k+16>>2]|0))g=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else g=c[g>>2]|0;if((g|0)==-1){c[e>>2]=0;m=1;k=0}else m=0}else{m=1;k=0}l=c[f>>2]|0;do if(l){g=c[l+12>>2]|0;if((g|0)==(c[l+16>>2]|0))g=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(m){o=l;break}else break a;else{c[f>>2]=0;D=17;break}}else D=17;while(0);if((D|0)==17){D=0;if(m){l=0;break}else o=0}m=a[A>>0]|0;g=(m&1)==0;if(g)l=(m&255)>>>1;else l=c[s>>2]|0;if((c[v>>2]|0)==(d+l|0)){if(g){g=(m&255)>>>1;l=(m&255)>>>1}else{l=c[s>>2]|0;g=l}Gi(A,g<<1,0);if(!(a[A>>0]&1))g=10;else g=(c[A>>2]&-2)+-1|0;Gi(A,g,0);if(!(a[A>>0]&1))d=q;else d=c[r>>2]|0;c[v>>2]=d+l}m=k+12|0;l=c[m>>2]|0;n=k+16|0;if((l|0)==(c[n>>2]|0))g=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else g=c[l>>2]|0;if(vl(g,u,d,v,w,p,B,x,y,t)|0){l=o;break}g=c[m>>2]|0;if((g|0)==(c[n>>2]|0)){fc[c[(c[k>>2]|0)+40>>2]&127](k)|0;continue}else{c[m>>2]=g+4;continue}}g=a[B>>0]|0;if(!(g&1))g=(g&255)>>>1;else g=c[B+4>>2]|0;if((g|0)!=0?(z=c[y>>2]|0,(z-x|0)<160):0){w=c[w>>2]|0;c[y>>2]=z+4;c[z>>2]=w}c[j>>2]=Es(d,c[v>>2]|0,h,u)|0;go(B,x,c[y>>2]|0,h);if(k){d=c[k+12>>2]|0;if((d|0)==(c[k+16>>2]|0))d=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else d=c[d>>2]|0;if((d|0)==-1){c[e>>2]=0;k=0;g=1}else g=0}else{k=0;g=1}do if(l){d=c[l+12>>2]|0;if((d|0)==(c[l+16>>2]|0))d=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else d=c[d>>2]|0;if((d|0)!=-1)if(g)break;else{D=58;break}else{c[f>>2]=0;D=56;break}}else D=56;while(0);if((D|0)==56?g:0)D=58;if((D|0)==58)c[h>>2]=c[h>>2]|2;c[b>>2]=k;Bi(A);Bi(B);i=C;return}function gr(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=i;i=i+304|0;t=C+200|0;k=C+196|0;B=C+184|0;A=C+172|0;v=C+168|0;x=C+8|0;y=C+4|0;w=C;u=wq(g)|0;zl(B,g,t,k);c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;Gi(A,10,0);if(!(a[A>>0]&1)){d=A+1|0;q=d;r=A+8|0}else{d=A+8|0;q=A+1|0;r=d;d=c[d>>2]|0}c[v>>2]=d;c[y>>2]=x;c[w>>2]=0;s=A+4|0;p=c[k>>2]|0;k=c[e>>2]|0;a:while(1){if(k){g=c[k+12>>2]|0;if((g|0)==(c[k+16>>2]|0))g=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else g=c[g>>2]|0;if((g|0)==-1){c[e>>2]=0;m=1;k=0}else m=0}else{m=1;k=0}l=c[f>>2]|0;do if(l){g=c[l+12>>2]|0;if((g|0)==(c[l+16>>2]|0))g=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(m){o=l;break}else break a;else{c[f>>2]=0;D=17;break}}else D=17;while(0);if((D|0)==17){D=0;if(m){l=0;break}else o=0}m=a[A>>0]|0;g=(m&1)==0;if(g)l=(m&255)>>>1;else l=c[s>>2]|0;if((c[v>>2]|0)==(d+l|0)){if(g){g=(m&255)>>>1;l=(m&255)>>>1}else{l=c[s>>2]|0;g=l}Gi(A,g<<1,0);if(!(a[A>>0]&1))g=10;else g=(c[A>>2]&-2)+-1|0;Gi(A,g,0);if(!(a[A>>0]&1))d=q;else d=c[r>>2]|0;c[v>>2]=d+l}m=k+12|0;l=c[m>>2]|0;n=k+16|0;if((l|0)==(c[n>>2]|0))g=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else g=c[l>>2]|0;if(vl(g,u,d,v,w,p,B,x,y,t)|0){l=o;break}g=c[m>>2]|0;if((g|0)==(c[n>>2]|0)){fc[c[(c[k>>2]|0)+40>>2]&127](k)|0;continue}else{c[m>>2]=g+4;continue}}g=a[B>>0]|0;if(!(g&1))g=(g&255)>>>1;else g=c[B+4>>2]|0;if((g|0)!=0?(z=c[y>>2]|0,(z-x|0)<160):0){w=c[w>>2]|0;c[y>>2]=z+4;c[z>>2]=w}z=Fs(d,c[v>>2]|0,h,u)|0;c[j>>2]=z;c[j+4>>2]=F;go(B,x,c[y>>2]|0,h);if(k){d=c[k+12>>2]|0;if((d|0)==(c[k+16>>2]|0))d=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else d=c[d>>2]|0;if((d|0)==-1){c[e>>2]=0;k=0;g=1}else g=0}else{k=0;g=1}do if(l){d=c[l+12>>2]|0;if((d|0)==(c[l+16>>2]|0))d=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else d=c[d>>2]|0;if((d|0)!=-1)if(g)break;else{D=58;break}else{c[f>>2]=0;D=56;break}}else D=56;while(0);if((D|0)==56?g:0)D=58;if((D|0)==58)c[h>>2]=c[h>>2]|2;c[b>>2]=k;Bi(A);Bi(B);i=C;return}function hr(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;D=i;i=i+304|0;u=D+200|0;l=D+196|0;C=D+184|0;B=D+172|0;w=D+168|0;y=D+8|0;z=D+4|0;x=D;v=wq(h)|0;zl(C,h,u,l);c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;Gi(B,10,0);if(!(a[B>>0]&1)){e=B+1|0;r=e;s=B+8|0}else{e=B+8|0;r=B+1|0;s=e;e=c[e>>2]|0}c[w>>2]=e;c[z>>2]=y;c[x>>2]=0;t=B+4|0;q=c[l>>2]|0;l=c[f>>2]|0;a:while(1){if(l){h=c[l+12>>2]|0;if((h|0)==(c[l+16>>2]|0))h=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else h=c[h>>2]|0;if((h|0)==-1){c[f>>2]=0;n=1;l=0}else n=0}else{n=1;l=0}m=c[g>>2]|0;do if(m){h=c[m+12>>2]|0;if((h|0)==(c[m+16>>2]|0))h=fc[c[(c[m>>2]|0)+36>>2]&127](m)|0;else h=c[h>>2]|0;if((h|0)!=-1)if(n){p=m;break}else break a;else{c[g>>2]=0;E=17;break}}else E=17;while(0);if((E|0)==17){E=0;if(n){m=0;break}else p=0}n=a[B>>0]|0;h=(n&1)==0;if(h)m=(n&255)>>>1;else m=c[t>>2]|0;if((c[w>>2]|0)==(e+m|0)){if(h){h=(n&255)>>>1;m=(n&255)>>>1}else{m=c[t>>2]|0;h=m}Gi(B,h<<1,0);if(!(a[B>>0]&1))h=10;else h=(c[B>>2]&-2)+-1|0;Gi(B,h,0);if(!(a[B>>0]&1))e=r;else e=c[s>>2]|0;c[w>>2]=e+m}n=l+12|0;m=c[n>>2]|0;o=l+16|0;if((m|0)==(c[o>>2]|0))h=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else h=c[m>>2]|0;if(vl(h,v,e,w,x,q,C,y,z,u)|0){m=p;break}h=c[n>>2]|0;if((h|0)==(c[o>>2]|0)){fc[c[(c[l>>2]|0)+40>>2]&127](l)|0;continue}else{c[n>>2]=h+4;continue}}h=a[C>>0]|0;if(!(h&1))h=(h&255)>>>1;else h=c[C+4>>2]|0;if((h|0)!=0?(A=c[z>>2]|0,(A-y|0)<160):0){x=c[x>>2]|0;c[z>>2]=A+4;c[A>>2]=x}b[k>>1]=Gs(e,c[w>>2]|0,j,v)|0;go(C,y,c[z>>2]|0,j);if(l){e=c[l+12>>2]|0;if((e|0)==(c[l+16>>2]|0))e=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else e=c[e>>2]|0;if((e|0)==-1){c[f>>2]=0;l=0;h=1}else h=0}else{l=0;h=1}do if(m){e=c[m+12>>2]|0;if((e|0)==(c[m+16>>2]|0))e=fc[c[(c[m>>2]|0)+36>>2]&127](m)|0;else e=c[e>>2]|0;if((e|0)!=-1)if(h)break;else{E=58;break}else{c[g>>2]=0;E=56;break}}else E=56;while(0);if((E|0)==56?h:0)E=58;if((E|0)==58)c[j>>2]=c[j>>2]|2;c[d>>2]=l;Bi(B);Bi(C);i=D;return}function ir(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=i;i=i+304|0;t=C+200|0;k=C+196|0;B=C+184|0;A=C+172|0;v=C+168|0;x=C+8|0;y=C+4|0;w=C;u=wq(g)|0;zl(B,g,t,k);c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;Gi(A,10,0);if(!(a[A>>0]&1)){d=A+1|0;q=d;r=A+8|0}else{d=A+8|0;q=A+1|0;r=d;d=c[d>>2]|0}c[v>>2]=d;c[y>>2]=x;c[w>>2]=0;s=A+4|0;p=c[k>>2]|0;k=c[e>>2]|0;a:while(1){if(k){g=c[k+12>>2]|0;if((g|0)==(c[k+16>>2]|0))g=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else g=c[g>>2]|0;if((g|0)==-1){c[e>>2]=0;m=1;k=0}else m=0}else{m=1;k=0}l=c[f>>2]|0;do if(l){g=c[l+12>>2]|0;if((g|0)==(c[l+16>>2]|0))g=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(m){o=l;break}else break a;else{c[f>>2]=0;D=17;break}}else D=17;while(0);if((D|0)==17){D=0;if(m){l=0;break}else o=0}m=a[A>>0]|0;g=(m&1)==0;if(g)l=(m&255)>>>1;else l=c[s>>2]|0;if((c[v>>2]|0)==(d+l|0)){if(g){g=(m&255)>>>1;l=(m&255)>>>1}else{l=c[s>>2]|0;g=l}Gi(A,g<<1,0);if(!(a[A>>0]&1))g=10;else g=(c[A>>2]&-2)+-1|0;Gi(A,g,0);if(!(a[A>>0]&1))d=q;else d=c[r>>2]|0;c[v>>2]=d+l}m=k+12|0;l=c[m>>2]|0;n=k+16|0;if((l|0)==(c[n>>2]|0))g=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else g=c[l>>2]|0;if(vl(g,u,d,v,w,p,B,x,y,t)|0){l=o;break}g=c[m>>2]|0;if((g|0)==(c[n>>2]|0)){fc[c[(c[k>>2]|0)+40>>2]&127](k)|0;continue}else{c[m>>2]=g+4;continue}}g=a[B>>0]|0;if(!(g&1))g=(g&255)>>>1;else g=c[B+4>>2]|0;if((g|0)!=0?(z=c[y>>2]|0,(z-x|0)<160):0){w=c[w>>2]|0;c[y>>2]=z+4;c[z>>2]=w}c[j>>2]=Hs(d,c[v>>2]|0,h,u)|0;go(B,x,c[y>>2]|0,h);if(k){d=c[k+12>>2]|0;if((d|0)==(c[k+16>>2]|0))d=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else d=c[d>>2]|0;if((d|0)==-1){c[e>>2]=0;k=0;g=1}else g=0}else{k=0;g=1}do if(l){d=c[l+12>>2]|0;if((d|0)==(c[l+16>>2]|0))d=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else d=c[d>>2]|0;if((d|0)!=-1)if(g)break;else{D=58;break}else{c[f>>2]=0;D=56;break}}else D=56;while(0);if((D|0)==56?g:0)D=58;if((D|0)==58)c[h>>2]=c[h>>2]|2;c[b>>2]=k;Bi(A);Bi(B);i=C;return}function jr(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=i;i=i+304|0;t=C+200|0;k=C+196|0;B=C+184|0;A=C+172|0;v=C+168|0;x=C+8|0;y=C+4|0;w=C;u=wq(g)|0;zl(B,g,t,k);c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;Gi(A,10,0);if(!(a[A>>0]&1)){d=A+1|0;q=d;r=A+8|0}else{d=A+8|0;q=A+1|0;r=d;d=c[d>>2]|0}c[v>>2]=d;c[y>>2]=x;c[w>>2]=0;s=A+4|0;p=c[k>>2]|0;k=c[e>>2]|0;a:while(1){if(k){g=c[k+12>>2]|0;if((g|0)==(c[k+16>>2]|0))g=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else g=c[g>>2]|0;if((g|0)==-1){c[e>>2]=0;m=1;k=0}else m=0}else{m=1;k=0}l=c[f>>2]|0;do if(l){g=c[l+12>>2]|0;if((g|0)==(c[l+16>>2]|0))g=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(m){o=l;break}else break a;else{c[f>>2]=0;D=17;break}}else D=17;while(0);if((D|0)==17){D=0;if(m){l=0;break}else o=0}m=a[A>>0]|0;g=(m&1)==0;if(g)l=(m&255)>>>1;else l=c[s>>2]|0;if((c[v>>2]|0)==(d+l|0)){if(g){g=(m&255)>>>1;l=(m&255)>>>1}else{l=c[s>>2]|0;g=l}Gi(A,g<<1,0);if(!(a[A>>0]&1))g=10;else g=(c[A>>2]&-2)+-1|0;Gi(A,g,0);if(!(a[A>>0]&1))d=q;else d=c[r>>2]|0;c[v>>2]=d+l}m=k+12|0;l=c[m>>2]|0;n=k+16|0;if((l|0)==(c[n>>2]|0))g=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else g=c[l>>2]|0;if(vl(g,u,d,v,w,p,B,x,y,t)|0){l=o;break}g=c[m>>2]|0;if((g|0)==(c[n>>2]|0)){fc[c[(c[k>>2]|0)+40>>2]&127](k)|0;continue}else{c[m>>2]=g+4;continue}}g=a[B>>0]|0;if(!(g&1))g=(g&255)>>>1;else g=c[B+4>>2]|0;if((g|0)!=0?(z=c[y>>2]|0,(z-x|0)<160):0){w=c[w>>2]|0;c[y>>2]=z+4;c[z>>2]=w}c[j>>2]=Is(d,c[v>>2]|0,h,u)|0;go(B,x,c[y>>2]|0,h);if(k){d=c[k+12>>2]|0;if((d|0)==(c[k+16>>2]|0))d=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else d=c[d>>2]|0;if((d|0)==-1){c[e>>2]=0;k=0;g=1}else g=0}else{k=0;g=1}do if(l){d=c[l+12>>2]|0;if((d|0)==(c[l+16>>2]|0))d=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else d=c[d>>2]|0;if((d|0)!=-1)if(g)break;else{D=58;break}else{c[f>>2]=0;D=56;break}}else D=56;while(0);if((D|0)==56?g:0)D=58;if((D|0)==58)c[h>>2]=c[h>>2]|2;c[b>>2]=k;Bi(A);Bi(B);i=C;return}function kr(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=i;i=i+304|0;t=C+200|0;k=C+196|0;B=C+184|0;A=C+172|0;v=C+168|0;x=C+8|0;y=C+4|0;w=C;u=wq(g)|0;zl(B,g,t,k);c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;Gi(A,10,0);if(!(a[A>>0]&1)){d=A+1|0;q=d;r=A+8|0}else{d=A+8|0;q=A+1|0;r=d;d=c[d>>2]|0}c[v>>2]=d;c[y>>2]=x;c[w>>2]=0;s=A+4|0;p=c[k>>2]|0;k=c[e>>2]|0;a:while(1){if(k){g=c[k+12>>2]|0;if((g|0)==(c[k+16>>2]|0))g=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else g=c[g>>2]|0;if((g|0)==-1){c[e>>2]=0;m=1;k=0}else m=0}else{m=1;k=0}l=c[f>>2]|0;do if(l){g=c[l+12>>2]|0;if((g|0)==(c[l+16>>2]|0))g=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(m){o=l;break}else break a;else{c[f>>2]=0;D=17;break}}else D=17;while(0);if((D|0)==17){D=0;if(m){l=0;break}else o=0}m=a[A>>0]|0;g=(m&1)==0;if(g)l=(m&255)>>>1;else l=c[s>>2]|0;if((c[v>>2]|0)==(d+l|0)){if(g){g=(m&255)>>>1;l=(m&255)>>>1}else{l=c[s>>2]|0;g=l}Gi(A,g<<1,0);if(!(a[A>>0]&1))g=10;else g=(c[A>>2]&-2)+-1|0;Gi(A,g,0);if(!(a[A>>0]&1))d=q;else d=c[r>>2]|0;c[v>>2]=d+l}m=k+12|0;l=c[m>>2]|0;n=k+16|0;if((l|0)==(c[n>>2]|0))g=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else g=c[l>>2]|0;if(vl(g,u,d,v,w,p,B,x,y,t)|0){l=o;break}g=c[m>>2]|0;if((g|0)==(c[n>>2]|0)){fc[c[(c[k>>2]|0)+40>>2]&127](k)|0;continue}else{c[m>>2]=g+4;continue}}g=a[B>>0]|0;if(!(g&1))g=(g&255)>>>1;else g=c[B+4>>2]|0;if((g|0)!=0?(z=c[y>>2]|0,(z-x|0)<160):0){w=c[w>>2]|0;c[y>>2]=z+4;c[z>>2]=w}z=Js(d,c[v>>2]|0,h,u)|0;c[j>>2]=z;c[j+4>>2]=F;go(B,x,c[y>>2]|0,h);if(k){d=c[k+12>>2]|0;if((d|0)==(c[k+16>>2]|0))d=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else d=c[d>>2]|0;if((d|0)==-1){c[e>>2]=0;k=0;g=1}else g=0}else{k=0;g=1}do if(l){d=c[l+12>>2]|0;if((d|0)==(c[l+16>>2]|0))d=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else d=c[d>>2]|0;if((d|0)!=-1)if(g)break;else{D=58;break}else{c[f>>2]=0;D=56;break}}else D=56;while(0);if((D|0)==56?g:0)D=58;if((D|0)==58)c[h>>2]=c[h>>2]|2;c[b>>2]=k;Bi(A);Bi(B);i=C;return}function lr(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;E=i;i=i+352|0;u=E+208|0;l=E+200|0;m=E+196|0;D=E+184|0;C=E+172|0;w=E+168|0;y=E+8|0;z=E+4|0;x=E;A=E+337|0;v=E+336|0;Al(D,h,u,l,m);c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;Gi(C,10,0);if(!(a[C>>0]&1)){d=C+1|0;r=d;s=C+8|0}else{d=C+8|0;r=C+1|0;s=d;d=c[d>>2]|0}c[w>>2]=d;c[z>>2]=y;c[x>>2]=0;a[A>>0]=1;a[v>>0]=69;t=C+4|0;q=c[l>>2]|0;p=c[m>>2]|0;l=c[e>>2]|0;a:while(1){if(l){h=c[l+12>>2]|0;if((h|0)==(c[l+16>>2]|0))h=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else h=c[h>>2]|0;if((h|0)==-1){c[e>>2]=0;h=1;l=0}else h=0}else{h=1;l=0}n=c[f>>2]|0;do if(n){m=c[n+12>>2]|0;if((m|0)==(c[n+16>>2]|0))m=fc[c[(c[n>>2]|0)+36>>2]&127](n)|0;else m=c[m>>2]|0;if((m|0)!=-1)if(h)break;else{m=n;break a}else{c[f>>2]=0;F=17;break}}else F=17;while(0);if((F|0)==17){F=0;if(h){m=0;break}else n=0}o=a[C>>0]|0;m=(o&1)==0;if(m)h=(o&255)>>>1;else h=c[t>>2]|0;if((c[w>>2]|0)==(d+h|0)){if(m){m=(o&255)>>>1;h=(o&255)>>>1}else{h=c[t>>2]|0;m=h}Gi(C,m<<1,0);if(!(a[C>>0]&1))m=10;else m=(c[C>>2]&-2)+-1|0;Gi(C,m,0);if(!(a[C>>0]&1))d=r;else d=c[s>>2]|0;c[w>>2]=d+h}o=l+12|0;m=c[o>>2]|0;h=l+16|0;if((m|0)==(c[h>>2]|0))m=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else m=c[m>>2]|0;if(Bl(m,A,v,d,w,q,p,D,y,z,x,u)|0){m=n;break}m=c[o>>2]|0;if((m|0)==(c[h>>2]|0)){fc[c[(c[l>>2]|0)+40>>2]&127](l)|0;continue}else{c[o>>2]=m+4;continue}}h=a[D>>0]|0;if(!(h&1))h=(h&255)>>>1;else h=c[D+4>>2]|0;if(!((h|0)==0|(a[A>>0]|0)==0)?(B=c[z>>2]|0,(B-y|0)<160):0){A=c[x>>2]|0;c[z>>2]=B+4;c[B>>2]=A}g[k>>2]=+Ks(d,c[w>>2]|0,j);go(D,y,c[z>>2]|0,j);if(l){d=c[l+12>>2]|0;if((d|0)==(c[l+16>>2]|0))d=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else d=c[d>>2]|0;if((d|0)==-1){c[e>>2]=0;l=0;h=1}else h=0}else{l=0;h=1}do if(m){d=c[m+12>>2]|0;if((d|0)==(c[m+16>>2]|0))d=fc[c[(c[m>>2]|0)+36>>2]&127](m)|0;else d=c[d>>2]|0;if((d|0)!=-1)if(h)break;else{F=58;break}else{c[f>>2]=0;F=56;break}}else F=56;while(0);if((F|0)==56?h:0)F=58;if((F|0)==58)c[j>>2]=c[j>>2]|2;c[b>>2]=l;Bi(C);Bi(D);i=E;return}function mr(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;E=i;i=i+352|0;u=E+208|0;l=E+200|0;m=E+196|0;D=E+184|0;C=E+172|0;w=E+168|0;y=E+8|0;z=E+4|0;x=E;A=E+337|0;v=E+336|0;Al(D,g,u,l,m);c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;Gi(C,10,0);if(!(a[C>>0]&1)){d=C+1|0;r=d;s=C+8|0}else{d=C+8|0;r=C+1|0;s=d;d=c[d>>2]|0}c[w>>2]=d;c[z>>2]=y;c[x>>2]=0;a[A>>0]=1;a[v>>0]=69;t=C+4|0;q=c[l>>2]|0;p=c[m>>2]|0;l=c[e>>2]|0;a:while(1){if(l){g=c[l+12>>2]|0;if((g|0)==(c[l+16>>2]|0))g=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else g=c[g>>2]|0;if((g|0)==-1){c[e>>2]=0;g=1;l=0}else g=0}else{g=1;l=0}n=c[f>>2]|0;do if(n){m=c[n+12>>2]|0;if((m|0)==(c[n+16>>2]|0))m=fc[c[(c[n>>2]|0)+36>>2]&127](n)|0;else m=c[m>>2]|0;if((m|0)!=-1)if(g)break;else{m=n;break a}else{c[f>>2]=0;F=17;break}}else F=17;while(0);if((F|0)==17){F=0;if(g){m=0;break}else n=0}o=a[C>>0]|0;m=(o&1)==0;if(m)g=(o&255)>>>1;else g=c[t>>2]|0;if((c[w>>2]|0)==(d+g|0)){if(m){m=(o&255)>>>1;g=(o&255)>>>1}else{g=c[t>>2]|0;m=g}Gi(C,m<<1,0);if(!(a[C>>0]&1))m=10;else m=(c[C>>2]&-2)+-1|0;Gi(C,m,0);if(!(a[C>>0]&1))d=r;else d=c[s>>2]|0;c[w>>2]=d+g}o=l+12|0;m=c[o>>2]|0;g=l+16|0;if((m|0)==(c[g>>2]|0))m=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else m=c[m>>2]|0;if(Bl(m,A,v,d,w,q,p,D,y,z,x,u)|0){m=n;break}m=c[o>>2]|0;if((m|0)==(c[g>>2]|0)){fc[c[(c[l>>2]|0)+40>>2]&127](l)|0;continue}else{c[o>>2]=m+4;continue}}g=a[D>>0]|0;if(!(g&1))g=(g&255)>>>1;else g=c[D+4>>2]|0;if(!((g|0)==0|(a[A>>0]|0)==0)?(B=c[z>>2]|0,(B-y|0)<160):0){A=c[x>>2]|0;c[z>>2]=B+4;c[B>>2]=A}h[k>>3]=+Ls(d,c[w>>2]|0,j);go(D,y,c[z>>2]|0,j);if(l){d=c[l+12>>2]|0;if((d|0)==(c[l+16>>2]|0))d=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else d=c[d>>2]|0;if((d|0)==-1){c[e>>2]=0;l=0;g=1}else g=0}else{l=0;g=1}do if(m){d=c[m+12>>2]|0;if((d|0)==(c[m+16>>2]|0))d=fc[c[(c[m>>2]|0)+36>>2]&127](m)|0;else d=c[d>>2]|0;if((d|0)!=-1)if(g)break;else{F=58;break}else{c[f>>2]=0;F=56;break}}else F=56;while(0);if((F|0)==56?g:0)F=58;if((F|0)==58)c[j>>2]=c[j>>2]|2;c[b>>2]=l;Bi(C);Bi(D);i=E;return}function nr(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;E=i;i=i+352|0;u=E+208|0;l=E+200|0;m=E+196|0;D=E+184|0;C=E+172|0;w=E+168|0;y=E+8|0;z=E+4|0;x=E;A=E+337|0;v=E+336|0;Al(D,g,u,l,m);c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;Gi(C,10,0);if(!(a[C>>0]&1)){d=C+1|0;r=d;s=C+8|0}else{d=C+8|0;r=C+1|0;s=d;d=c[d>>2]|0}c[w>>2]=d;c[z>>2]=y;c[x>>2]=0;a[A>>0]=1;a[v>>0]=69;t=C+4|0;q=c[l>>2]|0;p=c[m>>2]|0;l=c[e>>2]|0;a:while(1){if(l){g=c[l+12>>2]|0;if((g|0)==(c[l+16>>2]|0))g=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else g=c[g>>2]|0;if((g|0)==-1){c[e>>2]=0;g=1;l=0}else g=0}else{g=1;l=0}n=c[f>>2]|0;do if(n){m=c[n+12>>2]|0;if((m|0)==(c[n+16>>2]|0))m=fc[c[(c[n>>2]|0)+36>>2]&127](n)|0;else m=c[m>>2]|0;if((m|0)!=-1)if(g)break;else{m=n;break a}else{c[f>>2]=0;F=17;break}}else F=17;while(0);if((F|0)==17){F=0;if(g){m=0;break}else n=0}o=a[C>>0]|0;m=(o&1)==0;if(m)g=(o&255)>>>1;else g=c[t>>2]|0;if((c[w>>2]|0)==(d+g|0)){if(m){m=(o&255)>>>1;g=(o&255)>>>1}else{g=c[t>>2]|0;m=g}Gi(C,m<<1,0);if(!(a[C>>0]&1))m=10;else m=(c[C>>2]&-2)+-1|0;Gi(C,m,0);if(!(a[C>>0]&1))d=r;else d=c[s>>2]|0;c[w>>2]=d+g}o=l+12|0;m=c[o>>2]|0;g=l+16|0;if((m|0)==(c[g>>2]|0))m=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else m=c[m>>2]|0;if(Bl(m,A,v,d,w,q,p,D,y,z,x,u)|0){m=n;break}m=c[o>>2]|0;if((m|0)==(c[g>>2]|0)){fc[c[(c[l>>2]|0)+40>>2]&127](l)|0;continue}else{c[o>>2]=m+4;continue}}g=a[D>>0]|0;if(!(g&1))g=(g&255)>>>1;else g=c[D+4>>2]|0;if(!((g|0)==0|(a[A>>0]|0)==0)?(B=c[z>>2]|0,(B-y|0)<160):0){A=c[x>>2]|0;c[z>>2]=B+4;c[B>>2]=A}h[k>>3]=+Ms(d,c[w>>2]|0,j);go(D,y,c[z>>2]|0,j);if(l){d=c[l+12>>2]|0;if((d|0)==(c[l+16>>2]|0))d=fc[c[(c[l>>2]|0)+36>>2]&127](l)|0;else d=c[d>>2]|0;if((d|0)==-1){c[e>>2]=0;l=0;g=1}else g=0}else{l=0;g=1}do if(m){d=c[m+12>>2]|0;if((d|0)==(c[m+16>>2]|0))d=fc[c[(c[m>>2]|0)+36>>2]&127](m)|0;else d=c[d>>2]|0;if((d|0)!=-1)if(g)break;else{F=58;break}else{c[f>>2]=0;F=56;break}}else F=56;while(0);if((F|0)==56?g:0)F=58;if((F|0)==58)c[j>>2]=c[j>>2]|2;c[b>>2]=l;Bi(C);Bi(D);i=E;return}function or(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;d=_a(d|0)|0;f=Wu(a,b,e,h)|0;if(d)_a(d|0)|0;i=g;return f|0}function pr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;b=_a(b|0)|0;e=kt(a,d,g)|0;if(b)_a(b|0)|0;i=f;return e|0}function qr(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;p=i;i=i+16|0;n=p;o=c[d>>2]|0;a:do if(!o)c[b>>2]=0;else{q=e;l=g-q>>2;m=h+12|0;k=c[m>>2]|0;l=(k|0)>(l|0)?k-l|0:0;k=f;q=k-q|0;h=q>>2;if((q|0)>0?($b[c[(c[o>>2]|0)+48>>2]&31](o,e,h)|0)!=(h|0):0){c[d>>2]=0;c[b>>2]=0;break}do if((l|0)>0){Wi(n,l,j);if(!(a[n>>0]&1))h=n+4|0;else h=c[n+8>>2]|0;if(($b[c[(c[o>>2]|0)+48>>2]&31](o,h,l)|0)==(l|0)){Yi(n);break}else{c[d>>2]=0;c[b>>2]=0;Yi(n);break a}}while(0);n=g-k|0;g=n>>2;if((n|0)>0?($b[c[(c[o>>2]|0)+48>>2]&31](o,f,g)|0)!=(g|0):0){c[d>>2]=0;c[b>>2]=0;break}c[m>>2]=0;c[b>>2]=o}while(0);i=p;return}function rr(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=c[a>>2]|0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0))if((fc[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1){c[a>>2]=0;j=0;break}else{j=c[a>>2]|0;break}}else j=0;while(0);i=(j|0)==0;j=c[e>>2]|0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)?(fc[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1:0){c[e>>2]=0;q=11;break}if(i)q=13;else q=12}else q=11;while(0);if((q|0)==11)if(i)q=12;else{j=0;q=13}a:do if((q|0)==12){c[f>>2]=c[f>>2]|6;i=0}else if((q|0)==13){k=c[a>>2]|0;i=c[k+12>>2]|0;if((i|0)==(c[k+16>>2]|0))i=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else i=d[i>>0]|0;k=i&255;if(k<<24>>24>-1?(p=g+8|0,(b[(c[p>>2]|0)+(i<<24>>24<<1)>>1]&2048)!=0):0){k=($b[c[(c[g>>2]|0)+36>>2]&31](g,k,0)|0)<<24>>24;l=c[a>>2]|0;i=l+12|0;m=c[i>>2]|0;if((m|0)==(c[l+16>>2]|0)){fc[c[(c[l>>2]|0)+40>>2]&127](l)|0;m=h;h=j;l=j}else{c[i>>2]=m+1;m=h;h=j;l=j}while(1){i=k+-48|0;o=m+-1|0;k=c[a>>2]|0;do if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0))if((fc[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[a>>2]=0;k=0;break}else{k=c[a>>2]|0;break}}else k=0;while(0);m=(k|0)==0;if(l)if((c[l+12>>2]|0)==(c[l+16>>2]|0))if((fc[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;k=0;n=0}else{k=h;n=h}else{k=h;n=l}else{k=h;n=0}j=c[a>>2]|0;if(!((m^(n|0)==0)&(o|0)>0))break;m=c[j+12>>2]|0;if((m|0)==(c[j+16>>2]|0))j=fc[c[(c[j>>2]|0)+36>>2]&127](j)|0;else j=d[m>>0]|0;l=j&255;if(l<<24>>24<=-1)break a;if(!(b[(c[p>>2]|0)+(j<<24>>24<<1)>>1]&2048))break a;i=(($b[c[(c[g>>2]|0)+36>>2]&31](g,l,0)|0)<<24>>24)+(i*10|0)|0;m=c[a>>2]|0;l=m+12|0;j=c[l>>2]|0;if((j|0)==(c[m+16>>2]|0)){fc[c[(c[m>>2]|0)+40>>2]&127](m)|0;m=o;h=k;l=n;k=i;continue}else{c[l>>2]=j+1;m=o;h=k;l=n;k=i;continue}}do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0))if((fc[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1){c[a>>2]=0;j=0;break}else{j=c[a>>2]|0;break}}else j=0;while(0);j=(j|0)==0;do if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)?(fc[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1:0){c[e>>2]=0;q=50;break}if(j)break a}else q=50;while(0);if((q|0)==50)if(!j)break;c[f>>2]=c[f>>2]|2;break}c[f>>2]=c[f>>2]|4;i=0}while(0);return i|0}function sr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=c[a>>2]|0;do if(h){g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))g=fc[c[(c[h>>2]|0)+36>>2]&127](h)|0;else g=c[g>>2]|0;if((g|0)==-1){c[a>>2]=0;j=1;break}else{j=(c[a>>2]|0)==0;break}}else j=1;while(0);g=c[b>>2]|0;do if(g){i=c[g+12>>2]|0;if((i|0)==(c[g+16>>2]|0))h=fc[c[(c[g>>2]|0)+36>>2]&127](g)|0;else h=c[i>>2]|0;if((h|0)!=-1)if(j){o=17;break}else{o=16;break}else{c[b>>2]=0;o=14;break}}else o=14;while(0);if((o|0)==14)if(j)o=16;else{g=0;o=17}a:do if((o|0)==16){c[d>>2]=c[d>>2]|6;g=0}else if((o|0)==17){i=c[a>>2]|0;h=c[i+12>>2]|0;if((h|0)==(c[i+16>>2]|0))h=fc[c[(c[i>>2]|0)+36>>2]&127](i)|0;else h=c[h>>2]|0;if(!($b[c[(c[e>>2]|0)+12>>2]&31](e,2048,h)|0)){c[d>>2]=c[d>>2]|4;g=0;break}i=($b[c[(c[e>>2]|0)+52>>2]&31](e,h,0)|0)<<24>>24;j=c[a>>2]|0;h=j+12|0;k=c[h>>2]|0;if((k|0)==(c[j+16>>2]|0)){fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;k=f;m=g;h=g}else{c[h>>2]=k+4;k=f;m=g;h=g}while(1){g=i+-48|0;n=k+-1|0;k=c[a>>2]|0;do if(k){j=c[k+12>>2]|0;if((j|0)==(c[k+16>>2]|0))i=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else i=c[j>>2]|0;if((i|0)==-1){c[a>>2]=0;j=1;break}else{j=(c[a>>2]|0)==0;break}}else j=1;while(0);do if(h){k=c[h+12>>2]|0;if((k|0)==(c[h+16>>2]|0))i=fc[c[(c[h>>2]|0)+36>>2]&127](h)|0;else i=c[k>>2]|0;if((i|0)==-1){c[b>>2]=0;f=0;l=0;k=1;break}else{f=m;l=m;k=(m|0)==0;break}}else{f=m;l=0;k=1}while(0);i=c[a>>2]|0;if(!((j^k)&(n|0)>0)){k=f;break}k=c[i+12>>2]|0;if((k|0)==(c[i+16>>2]|0))i=fc[c[(c[i>>2]|0)+36>>2]&127](i)|0;else i=c[k>>2]|0;if(!($b[c[(c[e>>2]|0)+12>>2]&31](e,2048,i)|0))break a;i=(($b[c[(c[e>>2]|0)+52>>2]&31](e,i,0)|0)<<24>>24)+(g*10|0)|0;k=c[a>>2]|0;j=k+12|0;h=c[j>>2]|0;if((h|0)==(c[k+16>>2]|0)){fc[c[(c[k>>2]|0)+40>>2]&127](k)|0;k=n;m=f;h=l;continue}else{c[j>>2]=h+4;k=n;m=f;h=l;continue}}do if(i){h=c[i+12>>2]|0;if((h|0)==(c[i+16>>2]|0))h=fc[c[(c[i>>2]|0)+36>>2]&127](i)|0;else h=c[h>>2]|0;if((h|0)==-1){c[a>>2]=0;i=1;break}else{i=(c[a>>2]|0)==0;break}}else i=1;while(0);do if(k){h=c[k+12>>2]|0;if((h|0)==(c[k+16>>2]|0))h=fc[c[(c[k>>2]|0)+36>>2]&127](k)|0;else h=c[h>>2]|0;if((h|0)!=-1)if(i)break a;else break;else{c[b>>2]=0;o=60;break}}else o=60;while(0);if((o|0)==60)if(!i)break;c[d>>2]=c[d>>2]|2}while(0);return g|0}function tr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;h=a+4|0;f=(c[h>>2]|0)!=182;e=c[a>>2]|0;i=e;g=(c[d>>2]|0)-i|0;g=g>>>0<2147483647?g<<1:-1;i=(c[b>>2]|0)-i|0;e=wu(f?e:0,g)|0;if(!e)ou();if(!f){f=c[a>>2]|0;c[a>>2]=e;if(f){cc[c[h>>2]&255](f);e=c[a>>2]|0}}else c[a>>2]=e;c[h>>2]=185;c[b>>2]=e+i;c[d>>2]=(c[a>>2]|0)+g;return}function ur(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;h=a+4|0;f=(c[h>>2]|0)!=182;e=c[a>>2]|0;i=e;g=(c[d>>2]|0)-i|0;g=g>>>0<2147483647?g<<1:-1;i=(c[b>>2]|0)-i>>2;e=wu(f?e:0,g)|0;if(!e)ou();if(!f){f=c[a>>2]|0;c[a>>2]=e;if(f){cc[c[h>>2]&255](f);e=c[a>>2]|0}}else c[a>>2]=e;c[h>>2]=185;c[b>>2]=e+(i<<2);c[d>>2]=(c[a>>2]|0)+(g>>>2<<2);return}function vr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;h=d;f=a[b>>0]|0;if(!(f&1)){k=(f&255)>>>1;g=10}else{f=c[b>>2]|0;k=c[b+4>>2]|0;g=(f&-2)+-1|0;f=f&255}j=e-h|0;do if((e|0)!=(d|0)){if((g-k|0)>>>0<j>>>0){Ni(b,g,k+j-g|0,k,k,0,0);f=a[b>>0]|0}if(!(f&1))i=b+1|0;else i=c[b+8>>2]|0;h=e+(k-h)|0;f=d;g=i+k|0;while(1){a[g>>0]=a[f>>0]|0;f=f+1|0;if((f|0)==(e|0))break;else g=g+1|0}a[i+h>>0]=0;f=k+j|0;if(!(a[b>>0]&1)){a[b>>0]=f<<1;break}else{c[b+4>>2]=f;break}}while(0);return b|0}function wr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;h=a+4|0;f=(c[h>>2]|0)!=182;e=c[a>>2]|0;i=e;g=(c[d>>2]|0)-i|0;g=g>>>0<2147483647?g<<1:-1;i=(c[b>>2]|0)-i>>2;e=wu(f?e:0,g)|0;if(!e)ou();if(!f){f=c[a>>2]|0;c[a>>2]=e;if(f){cc[c[h>>2]&255](f);e=c[a>>2]|0}}else c[a>>2]=e;c[h>>2]=185;c[b>>2]=e+(i<<2);c[d>>2]=(c[a>>2]|0)+(g>>>2<<2);return}function xr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;i=d;f=a[b>>0]|0;if(!(f&1)){k=(f&255)>>>1;g=1}else{f=c[b>>2]|0;k=c[b+4>>2]|0;g=(f&-2)+-1|0;f=f&255}j=e-i>>2;do if(j){if((g-k|0)>>>0<j>>>0){cj(b,g,k+j-g|0,k,k,0,0);f=a[b>>0]|0}if(!(f&1))h=b+4|0;else h=c[b+8>>2]|0;f=h+(k<<2)|0;if((d|0)!=(e|0)){g=k+((e+-4-i|0)>>>2)+1|0;while(1){c[f>>2]=c[d>>2];d=d+4|0;if((d|0)==(e|0))break;else f=f+4|0}f=h+(g<<2)|0}c[f>>2]=0;f=k+j|0;if(!(a[b>>0]&1)){a[b>>0]=f<<1;break}else{c[b+4>>2]=f;break}}while(0);return b|0}function yr(b,d){b=b|0;d=d|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;a[b+128>>0]=0;if(d){Ns(b,d);Os(b,d)}return}function zr(a,b){a=a|0;b=b|0;No(a,b,Yo(1076296)|0);return}function Ar(a,b){a=a|0;b=b|0;No(a,b,Yo(1076336)|0);return}function Br(a,b){a=a|0;b=b|0;No(a,b,Yo(1077904)|0);return}function Cr(a,b){a=a|0;b=b|0;No(a,b,Yo(1077896)|0);return}function Dr(a,b){a=a|0;b=b|0;No(a,b,Yo(1077968)|0);return}function Er(a,b){a=a|0;b=b|0;No(a,b,Yo(1077976)|0);return}function Fr(a,b){a=a|0;b=b|0;No(a,b,Yo(1078032)|0);return}function Gr(a,b){a=a|0;b=b|0;No(a,b,Yo(1078040)|0);return}function Hr(a,b){a=a|0;b=b|0;No(a,b,Yo(1078048)|0);return}function Ir(a,b){a=a|0;b=b|0;No(a,b,Yo(1078056)|0);return}function Jr(a,b){a=a|0;b=b|0;No(a,b,Yo(1076408)|0);return}function Kr(a,b){a=a|0;b=b|0;No(a,b,Yo(1076528)|0);return}function Lr(a,b){a=a|0;b=b|0;No(a,b,Yo(1076592)|0);return}function Mr(a,b){a=a|0;b=b|0;No(a,b,Yo(1076688)|0);return}function Nr(a,b){a=a|0;b=b|0;No(a,b,Yo(1077280)|0);return}function Or(a,b){a=a|0;b=b|0;No(a,b,Yo(1077344)|0);return}function Pr(a,b){a=a|0;b=b|0;No(a,b,Yo(1077408)|0);return}function Qr(a,b){a=a|0;b=b|0;No(a,b,Yo(1077472)|0);return}function Rr(a,b){a=a|0;b=b|0;No(a,b,Yo(1077512)|0);return}function Sr(a,b){a=a|0;b=b|0;No(a,b,Yo(1077592)|0);return}function Tr(a,b){a=a|0;b=b|0;No(a,b,Yo(1077648)|0);return}function Ur(a,b){a=a|0;b=b|0;No(a,b,Yo(1077696)|0);return}function Vr(a,b){a=a|0;b=b|0;No(a,b,Yo(1076800)|0);return}function Wr(a,b){a=a|0;b=b|0;No(a,b,Yo(1076952)|0);return}function Xr(a,b){a=a|0;b=b|0;No(a,b,Yo(1077184)|0);return}function Yr(a,b){a=a|0;b=b|0;No(a,b,Yo(1077216)|0);return}function Zr(a,b){a=a|0;b=b|0;No(a,b,Yo(1077736)|0);return}function _r(a,b){a=a|0;b=b|0;No(a,b,Yo(1077776)|0);return}function $r(b){b=b|0;var d=0,e=0,f=0;d=c[b>>2]|0;do if(d){e=b+4|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);if((b+16|0)==(d|0)){a[b+128>>0]=0;break}else{xt(d);break}}while(0);return}function as(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=a+4|0;e=c[d>>2]|0;g=c[a>>2]|0;h=e-g>>2;if(h>>>0>=b>>>0){if(h>>>0>b>>>0?(f=g+(b<<2)|0,(e|0)!=(f|0)):0)c[d>>2]=e+(~((e+-4-f|0)>>>2)<<2)}else Ps(a,b-h|0);return}function bs(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;if((c[a+12>>2]|0)-d>>2>>>0>b>>>0)d=(c[d+(b<<2)>>2]|0)!=0;else d=0;return d|0}function cs(a){a=a|0;var b=0,e=0;e=a+4|0;b=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;e=e+4|0;e=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;a=(c[a>>2]|0)+(e>>1)|0;if(e&1)b=c[(c[a>>2]|0)+b>>2]|0;cc[b&255](a);return}function ds(d,f,g,h,i,j,k,l){d=d|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0;c[g>>2]=d;c[j>>2]=h;if(l&2)if((i-h|0)<3)d=1;else{c[j>>2]=h+1;a[h>>0]=-17;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=-69;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=-65;m=4}else m=4;a:do if((m|0)==4){n=f;d=c[g>>2]|0;if(d>>>0<f>>>0)while(1){h=b[d>>1]|0;m=h&65535;if(m>>>0>k>>>0){d=2;break a}do if((h&65535)<128){d=c[j>>2]|0;if((i-d|0)<1){d=1;break a}c[j>>2]=d+1;a[d>>0]=h}else{if((h&65535)<2048){d=c[j>>2]|0;if((i-d|0)<2){d=1;break a}c[j>>2]=d+1;a[d>>0]=m>>>6|192;d=c[j>>2]|0;c[j>>2]=d+1;a[d>>0]=m&63|128;break}if((h&65535)<55296){d=c[j>>2]|0;if((i-d|0)<3){d=1;break a}c[j>>2]=d+1;a[d>>0]=m>>>12|224;d=c[j>>2]|0;c[j>>2]=d+1;a[d>>0]=m>>>6&63|128;d=c[j>>2]|0;c[j>>2]=d+1;a[d>>0]=m&63|128;break}if((h&65535)>=56320){if((h&65535)<57344){d=2;break a}d=c[j>>2]|0;if((i-d|0)<3){d=1;break a}c[j>>2]=d+1;a[d>>0]=m>>>12|224;d=c[j>>2]|0;c[j>>2]=d+1;a[d>>0]=m>>>6&63|128;d=c[j>>2]|0;c[j>>2]=d+1;a[d>>0]=m&63|128;break}if((n-d|0)<4){d=1;break a}h=d+2|0;l=e[h>>1]|0;if((l&64512|0)!=56320){d=2;break a}if((i-(c[j>>2]|0)|0)<4){d=1;break a}d=m&960;if(((d<<10)+65536|m<<10&64512|l&1023)>>>0>k>>>0){d=2;break a}c[g>>2]=h;h=(d>>>6)+1|0;d=c[j>>2]|0;c[j>>2]=d+1;a[d>>0]=h>>>2|240;d=c[j>>2]|0;c[j>>2]=d+1;a[d>>0]=m>>>2&15|h<<4&48|128;d=c[j>>2]|0;c[j>>2]=d+1;a[d>>0]=m<<4&48|l>>>6&15|128;d=c[j>>2]|0;c[j>>2]=d+1;a[d>>0]=l&63|128}while(0);d=(c[g>>2]|0)+2|0;c[g>>2]=d;if(d>>>0>=f>>>0){d=0;break}}else d=0}while(0);return d|0}function es(e,f,g,h,i,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0;c[g>>2]=e;c[j>>2]=h;e=c[g>>2]|0;if(((((l&4|0)!=0?(f-e|0)>2:0)?(a[e>>0]|0)==-17:0)?(a[e+1>>0]|0)==-69:0)?(a[e+2>>0]|0)==-65:0){e=e+3|0;c[g>>2]=e}a:do if(e>>>0<f>>>0){p=f;q=i;r=c[j>>2]|0;while(1){if(r>>>0>=i>>>0){s=40;break a}l=a[e>>0]|0;m=l&255;if(m>>>0>k>>>0){e=2;break a}do if(l<<24>>24>-1){b[r>>1]=l&255;c[g>>2]=e+1}else{if((l&255)<194){e=2;break a}if((l&255)<224){if((p-e|0)<2){e=1;break a}l=d[e+1>>0]|0;if((l&192|0)!=128){e=2;break a}l=l&63|m<<6&1984;if(l>>>0>k>>>0){e=2;break a}b[r>>1]=l;c[g>>2]=e+2;break}if((l&255)<240){if((p-e|0)<3){e=1;break a}h=a[e+1>>0]|0;l=a[e+2>>0]|0;if((m|0)==237){if((h&-32)<<24>>24!=-128){e=2;break a}}else if((m|0)==224){if((h&-32)<<24>>24!=-96){e=2;break a}}else if((h&-64)<<24>>24!=-128){e=2;break a}l=l&255;if((l&192|0)!=128){e=2;break a}l=(h&255)<<6&4032|m<<12|l&63;if((l&65535)>>>0>k>>>0){e=2;break a}b[r>>1]=l;c[g>>2]=e+3;break}if((l&255)>=245){e=2;break a}if((p-e|0)<4){e=1;break a}n=a[e+1>>0]|0;l=a[e+2>>0]|0;h=a[e+3>>0]|0;if((m|0)==240){if((n+112&255)>=48){e=2;break a}}else if((m|0)==244){if((n&-16)<<24>>24!=-128){e=2;break a}}else if((n&-64)<<24>>24!=-128){e=2;break a}o=l&255;if((o&192|0)!=128){e=2;break a}l=h&255;if((l&192|0)!=128){e=2;break a}if((q-r|0)<4){e=1;break a}m=m&7;e=n&255;h=o<<6;l=l&63;if((e<<12&258048|m<<18|h&4032|l)>>>0>k>>>0){e=2;break a}b[r>>1]=e<<2&60|o>>>4&3|((e>>>4&3|m<<2)<<6)+16320|55296;r=r+2|0;c[j>>2]=r;b[r>>1]=l|h&960|56320;c[g>>2]=(c[g>>2]|0)+4}while(0);r=(c[j>>2]|0)+2|0;c[j>>2]=r;e=c[g>>2]|0;if(e>>>0>=f>>>0){s=40;break}}}else s=40;while(0);if((s|0)==40)e=e>>>0<f>>>0&1;return e|0}function fs(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;if((((g&4|0)!=0?(c-b|0)>2:0)?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0)g=(a[b+2>>0]|0)==-65?b+3|0:b;else g=b;a:do if(g>>>0<c>>>0&(e|0)!=0){n=c;m=g;h=0;b:while(1){g=a[m>>0]|0;l=g&255;if(l>>>0>f>>>0){g=m;h=43;break a}do if(g<<24>>24>-1)g=m+1|0;else{if((g&255)<194){g=m;h=43;break a}if((g&255)<224){if((n-m|0)<2){g=m;h=43;break a}g=d[m+1>>0]|0;if((g&192|0)!=128){g=m;h=43;break a}if((g&63|l<<6&1984)>>>0>f>>>0){g=m;h=43;break a}g=m+2|0;break}if((g&255)<240){g=m;if((n-g|0)<3){g=m;h=43;break a}j=a[m+1>>0]|0;i=a[m+2>>0]|0;if((l|0)==237){if((j&-32)<<24>>24!=-128){h=23;break b}}else if((l|0)==224){if((j&-32)<<24>>24!=-96){h=21;break b}}else if((j&-64)<<24>>24!=-128){h=25;break b}g=i&255;if((g&192|0)!=128){g=m;h=43;break a}if(((j&255)<<6&4032|l<<12&61440|g&63)>>>0>f>>>0){g=m;h=43;break a}g=m+3|0;break}if((g&255)>=245){g=m;h=43;break a}g=m;if((n-g|0)<4|(e-h|0)>>>0<2){g=m;h=43;break a}k=a[m+1>>0]|0;j=a[m+2>>0]|0;i=a[m+3>>0]|0;if((l|0)==240){if((k+112&255)>=48){h=33;break b}}else if((l|0)==244){if((k&-16)<<24>>24!=-128){h=35;break b}}else if((k&-64)<<24>>24!=-128){h=37;break b}j=j&255;if((j&192|0)!=128){g=m;h=43;break a}i=i&255;if((i&192|0)!=128){g=m;h=43;break a}if(((k&255)<<12&258048|l<<18&1835008|j<<6&4032|i&63)>>>0>f>>>0){g=m;h=43;break a}g=m+4|0;h=h+1|0}while(0);h=h+1|0;if(!(g>>>0<c>>>0&h>>>0<e>>>0)){h=43;break a}else m=g}if((h|0)==21){g=g-b|0;break}else if((h|0)==23){g=g-b|0;break}else if((h|0)==25){g=g-b|0;break}else if((h|0)==33){g=g-b|0;break}else if((h|0)==35){g=g-b|0;break}else if((h|0)==37){g=g-b|0;break}}else h=43;while(0);if((h|0)==43)g=g-b|0;return g|0}function gs(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0;c[e>>2]=b;c[h>>2]=f;if(j&2)if((g-f|0)<3)j=1;else{c[h>>2]=f+1;a[f>>0]=-17;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=-69;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=-65;k=4}else k=4;a:do if((k|0)==4){j=c[e>>2]|0;if(j>>>0<d>>>0)while(1){f=c[j>>2]|0;if((f&-2048|0)==55296|f>>>0>i>>>0){j=2;break a}do if(f>>>0>=128){if(f>>>0<2048){j=c[h>>2]|0;if((g-j|0)<2){j=1;break a}c[h>>2]=j+1;a[j>>0]=f>>>6|192;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=f&63|128;break}j=c[h>>2]|0;b=g-j|0;if(f>>>0<65536){if((b|0)<3){j=1;break a}c[h>>2]=j+1;a[j>>0]=f>>>12|224;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=f>>>6&63|128;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=f&63|128;break}else{if((b|0)<4){j=1;break a}c[h>>2]=j+1;a[j>>0]=f>>>18|240;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=f>>>12&63|128;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=f>>>6&63|128;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=f&63|128;break}}else{j=c[h>>2]|0;if((g-j|0)<1){j=1;break a}c[h>>2]=j+1;a[j>>0]=f}while(0);j=(c[e>>2]|0)+4|0;c[e>>2]=j;if(j>>>0>=d>>>0){j=0;break}}else j=0}while(0);return j|0}function hs(b,e,f,g,h,i,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;c[f>>2]=b;c[i>>2]=g;b=c[f>>2]|0;if(((((k&4|0)!=0?(e-b|0)>2:0)?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0)?(a[b+2>>0]|0)==-65:0){b=b+3|0;c[f>>2]=b}a:do if(b>>>0<e>>>0){o=e;p=c[i>>2]|0;while(1){if(p>>>0>=h>>>0){q=39;break a}k=a[b>>0]|0;n=k&255;do if(k<<24>>24>-1){if(n>>>0>j>>>0){b=2;break a}c[p>>2]=n;c[f>>2]=b+1}else{if((k&255)<194){b=2;break a}if((k&255)<224){if((o-b|0)<2){b=1;break a}k=d[b+1>>0]|0;if((k&192|0)!=128){b=2;break a}g=k&63|n<<6&1984;if(g>>>0>j>>>0){b=2;break a}c[p>>2]=g;c[f>>2]=b+2;break}if((k&255)<240){if((o-b|0)<3){b=1;break a}g=a[b+1>>0]|0;k=a[b+2>>0]|0;if((n|0)==224){if((g&-32)<<24>>24!=-96){b=2;break a}}else if((n|0)==237){if((g&-32)<<24>>24!=-128){b=2;break a}}else if((g&-64)<<24>>24!=-128){b=2;break a}k=k&255;if((k&192|0)!=128){b=2;break a}g=(g&255)<<6&4032|n<<12&61440|k&63;if(g>>>0>j>>>0){b=2;break a}c[p>>2]=g;c[f>>2]=b+3;break}if((k&255)>=245){b=2;break a}if((o-b|0)<4){b=1;break a}m=a[b+1>>0]|0;k=a[b+2>>0]|0;g=a[b+3>>0]|0;if((n|0)==240){if((m+112&255)>=48){b=2;break a}}else if((n|0)==244){if((m&-16)<<24>>24!=-128){b=2;break a}}else if((m&-64)<<24>>24!=-128){b=2;break a}l=k&255;if((l&192|0)!=128){b=2;break a}k=g&255;if((k&192|0)!=128){b=2;break a}g=(m&255)<<12&258048|n<<18&1835008|l<<6&4032|k&63;if(g>>>0>j>>>0){b=2;break a}c[p>>2]=g;c[f>>2]=b+4}while(0);p=(c[i>>2]|0)+4|0;c[i>>2]=p;b=c[f>>2]|0;if(b>>>0>=e>>>0){q=39;break}}}else q=39;while(0);if((q|0)==39)b=b>>>0<e>>>0&1;return b|0}function is(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;if((((g&4|0)!=0?(c-b|0)>2:0)?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0)g=(a[b+2>>0]|0)==-65?b+3|0:b;else g=b;a:do if(g>>>0<c>>>0&(e|0)!=0){n=c;l=g;m=0;b:while(1){g=a[l>>0]|0;k=g&255;do if(g<<24>>24>-1){if(k>>>0>f>>>0){g=l;h=43;break a}g=l+1|0}else{if((g&255)<194){g=l;h=43;break a}if((g&255)<224){if((n-l|0)<2){g=l;h=43;break a}g=d[l+1>>0]|0;if((g&192|0)!=128){g=l;h=43;break a}if((g&63|k<<6&1984)>>>0>f>>>0){g=l;h=43;break a}g=l+2|0;break}if((g&255)<240){g=l;if((n-g|0)<3){g=l;h=43;break a}i=a[l+1>>0]|0;h=a[l+2>>0]|0;if((k|0)==224){if((i&-32)<<24>>24!=-96){h=21;break b}}else if((k|0)==237){if((i&-32)<<24>>24!=-128){h=23;break b}}else if((i&-64)<<24>>24!=-128){h=25;break b}g=h&255;if((g&192|0)!=128){g=l;h=43;break a}if(((i&255)<<6&4032|k<<12&61440|g&63)>>>0>f>>>0){g=l;h=43;break a}g=l+3|0;break}if((g&255)>=245){g=l;h=43;break a}g=l;if((n-g|0)<4){g=l;h=43;break a}j=a[l+1>>0]|0;i=a[l+2>>0]|0;h=a[l+3>>0]|0;if((k|0)==244){if((j&-16)<<24>>24!=-128){h=35;break b}}else if((k|0)==240){if((j+112&255)>=48){h=33;break b}}else if((j&-64)<<24>>24!=-128){h=37;break b}i=i&255;if((i&192|0)!=128){g=l;h=43;break a}h=h&255;if((h&192|0)!=128){g=l;h=43;break a}if(((j&255)<<12&258048|k<<18&1835008|i<<6&4032|h&63)>>>0>f>>>0){g=l;h=43;break a}g=l+4|0}while(0);m=m+1|0;if(!(g>>>0<c>>>0&m>>>0<e>>>0)){h=43;break a}else l=g}if((h|0)==21){g=g-b|0;break}else if((h|0)==23){g=g-b|0;break}else if((h|0)==25){g=g-b|0;break}else if((h|0)==33){g=g-b|0;break}else if((h|0)==35){g=g-b|0;break}else if((h|0)==37){g=g-b|0;break}}else h=43;while(0);if((h|0)==43)g=g-b|0;return g|0}function js(a){a=a|0;Aj(a);xt(a);return}function ks(b,d){b=b|0;d=d|0;fc[c[(c[b>>2]|0)+24>>2]&127](b)|0;d=Zo(d,1077976)|0;c[b+36>>2]=d;a[b+44>>0]=(fc[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;return}function ls(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;l=i;i=i+16|0;j=l+8|0;h=l;d=a+36|0;e=a+40|0;f=j+8|0;g=j;b=a+32|0;while(1){a=c[d>>2]|0;a=pc[c[(c[a>>2]|0)+20>>2]&15](a,c[e>>2]|0,j,f,h)|0;m=(c[h>>2]|0)-g|0;if((Pb(j|0,1,m|0,c[b>>2]|0)|0)!=(m|0)){a=-1;break}if((a|0)==2){a=-1;break}else if((a|0)!=1){k=4;break}}if((k|0)==4)a=((Ra(c[b>>2]|0)|0)!=0)<<31>>31;i=l;return a|0}function ms(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;a:do if(!(a[b+44>>0]|0))if((e|0)>0){f=d;d=0;while(1){if((oc[c[(c[b>>2]|0)+52>>2]&63](b,c[f>>2]|0)|0)==-1)break a;d=d+1|0;if((d|0)<(e|0))f=f+4|0;else break}}else d=0;else d=Pb(d|0,4,e|0,c[b+32>>2]|0)|0;while(0);return d|0}function ns(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=i;i=i+32|0;p=s+16|0;e=s+8|0;o=s+4|0;n=s;q=(d|0)==-1;a:do if(!q){c[e>>2]=d;if(a[b+44>>0]|0)if((Pb(e|0,4,1,c[b+32>>2]|0)|0)==1){r=11;break}else{e=-1;break}c[o>>2]=p;l=e+4|0;m=b+36|0;g=b+40|0;h=p+8|0;j=p;k=b+32|0;while(1){b=c[m>>2]|0;b=kc[c[(c[b>>2]|0)+12>>2]&15](b,c[g>>2]|0,e,l,n,p,h,o)|0;if((c[n>>2]|0)==(e|0)){e=-1;break a}if((b|0)==3)break;f=(b|0)==1;if(b>>>0>=2){e=-1;break a}b=(c[o>>2]|0)-j|0;if((Pb(p|0,1,b|0,c[k>>2]|0)|0)!=(b|0)){e=-1;break a}if(f)e=f?c[n>>2]|0:e;else{r=11;break a}}if((Pb(e|0,1,1,c[k>>2]|0)|0)!=1)e=-1;else r=11}else r=11;while(0);if((r|0)==11)e=q?0:d;i=s;return e|0}function os(a){a=a|0;Aj(a);xt(a);return}function ps(b,d){b=b|0;d=d|0;var e=0,f=0;f=Zo(d,1077976)|0;e=b+36|0;c[e>>2]=f;d=b+44|0;c[d>>2]=fc[c[(c[f>>2]|0)+24>>2]&127](f)|0;e=c[e>>2]|0;a[b+53>>0]=(fc[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[d>>2]|0)>8)co(1074600);else return}function qs(a){a=a|0;return Qs(a,0)|0}function rs(a){a=a|0;return Qs(a,1)|0}function ss(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;m=i;i=i+32|0;l=m+16|0;k=m+8|0;e=m+4|0;g=m;h=b+52|0;f=(a[h>>0]|0)!=0;a:do if((d|0)==-1)if(f)d=-1;else{d=c[b+48>>2]|0;a[h>>0]=(d|0)!=-1&1}else{j=b+48|0;b:do if(f){c[e>>2]=c[j>>2];f=c[b+36>>2]|0;e=kc[c[(c[f>>2]|0)+12>>2]&15](f,c[b+40>>2]|0,e,e+4|0,g,l,l+8|0,k)|0;if((e|0)==1|(e|0)==2){d=-1;break a}else if((e|0)==3){a[l>>0]=c[j>>2];c[k>>2]=l+1}e=b+32|0;while(1){f=c[k>>2]|0;if(f>>>0<=l>>>0)break b;f=f+-1|0;c[k>>2]=f;if((Ma(a[f>>0]|0,c[e>>2]|0)|0)==-1){d=-1;break a}}}while(0);c[j>>2]=d;a[h>>0]=1}while(0);i=m;return d|0}function ts(a){a=a|0;kj(a);xt(a);return}function us(b,d){b=b|0;d=d|0;fc[c[(c[b>>2]|0)+24>>2]&127](b)|0;d=Zo(d,1077968)|0;c[b+36>>2]=d;a[b+44>>0]=(fc[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;return}function vs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;l=i;i=i+16|0;j=l+8|0;h=l;d=a+36|0;e=a+40|0;f=j+8|0;g=j;b=a+32|0;while(1){a=c[d>>2]|0;a=pc[c[(c[a>>2]|0)+20>>2]&15](a,c[e>>2]|0,j,f,h)|0;m=(c[h>>2]|0)-g|0;if((Pb(j|0,1,m|0,c[b>>2]|0)|0)!=(m|0)){a=-1;break}if((a|0)==2){a=-1;break}else if((a|0)!=1){k=4;break}}if((k|0)==4)a=((Ra(c[b>>2]|0)|0)!=0)<<31>>31;i=l;return a|0}function ws(b,e,f){b=b|0;e=e|0;f=f|0;var g=0;a:do if(!(a[b+44>>0]|0))if((f|0)>0){g=e;e=0;while(1){if((oc[c[(c[b>>2]|0)+52>>2]&63](b,d[g>>0]|0)|0)==-1)break a;e=e+1|0;if((e|0)<(f|0))g=g+1|0;else break}}else e=0;else e=Pb(e|0,1,f|0,c[b+32>>2]|0)|0;while(0);return e|0}function xs(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=i;i=i+32|0;p=s+16|0;e=s+8|0;o=s+4|0;n=s;q=(d|0)==-1;a:do if(!q){a[e>>0]=d;if(a[b+44>>0]|0)if((Pb(e|0,1,1,c[b+32>>2]|0)|0)==1){r=11;break}else{e=-1;break}c[o>>2]=p;m=e+1|0;g=b+36|0;h=b+40|0;j=p+8|0;k=p;l=b+32|0;while(1){b=c[g>>2]|0;b=kc[c[(c[b>>2]|0)+12>>2]&15](b,c[h>>2]|0,e,m,n,p,j,o)|0;if((c[n>>2]|0)==(e|0)){e=-1;break a}if((b|0)==3)break;f=(b|0)==1;if(b>>>0>=2){e=-1;break a}b=(c[o>>2]|0)-k|0;if((Pb(p|0,1,b|0,c[l>>2]|0)|0)!=(b|0)){e=-1;break a}if(f)e=f?c[n>>2]|0:e;else{r=11;break a}}if((Pb(e|0,1,1,c[l>>2]|0)|0)!=1)e=-1;else r=11}else r=11;while(0);if((r|0)==11)e=q?0:d;i=s;return e|0}function ys(a){a=a|0;kj(a);xt(a);return}function zs(b,d){b=b|0;d=d|0;var e=0,f=0;f=Zo(d,1077968)|0;e=b+36|0;c[e>>2]=f;d=b+44|0;c[d>>2]=fc[c[(c[f>>2]|0)+24>>2]&127](f)|0;e=c[e>>2]|0;a[b+53>>0]=(fc[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[d>>2]|0)>8)co(1074600);else return}function As(a){a=a|0;return Rs(a,0)|0}function Bs(a){a=a|0;return Rs(a,1)|0}function Cs(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;m=i;i=i+32|0;l=m+16|0;k=m+4|0;e=m+8|0;g=m;h=b+52|0;f=(a[h>>0]|0)!=0;a:do if((d|0)==-1)if(f)d=-1;else{d=c[b+48>>2]|0;a[h>>0]=(d|0)!=-1&1}else{j=b+48|0;b:do if(f){a[e>>0]=c[j>>2];f=c[b+36>>2]|0;e=kc[c[(c[f>>2]|0)+12>>2]&15](f,c[b+40>>2]|0,e,e+1|0,g,l,l+8|0,k)|0;if((e|0)==3){a[l>>0]=c[j>>2];c[k>>2]=l+1}else if((e|0)==1|(e|0)==2){d=-1;break a}e=b+32|0;while(1){f=c[k>>2]|0;if(f>>>0<=l>>>0)break b;f=f+-1|0;c[k>>2]=f;if((Ma(a[f>>0]|0,c[e>>2]|0)|0)==-1){d=-1;break a}}}while(0);c[j>>2]=d;a[h>>0]=1}while(0);i=m;return d|0}function Ds(a){a=a|0;xt(a);return}function Es(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;k=i;i=i+16|0;j=k;a:do if((a|0)==(b|0)){c[d>>2]=4;a=0}else{g=Cb()|0;h=c[g>>2]|0;c[g>>2]=0;a=Xs(a,j,e,hl()|0)|0;e=F;f=c[g>>2]|0;if(!f)c[g>>2]=h;if((c[j>>2]|0)!=(b|0)){c[d>>2]=4;a=0;break}do if((f|0)==34){c[d>>2]=4;if((e|0)>0|(e|0)==0&a>>>0>0){a=2147483647;break a}}else{if((e|0)<-1|(e|0)==-1&a>>>0<2147483648){c[d>>2]=4;break}if((e|0)>0|(e|0)==0&a>>>0>2147483647){c[d>>2]=4;a=2147483647;break a}else break a}while(0);a=-2147483648}while(0);i=k;return a|0}function Fs(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;k=i;i=i+16|0;j=k;do if((a|0)!=(b|0)){g=Cb()|0;h=c[g>>2]|0;c[g>>2]=0;e=Xs(a,j,e,hl()|0)|0;a=F;f=c[g>>2]|0;if(!f)c[g>>2]=h;if((c[j>>2]|0)!=(b|0)){c[d>>2]=4;a=0;e=0;break}if((f|0)==34){c[d>>2]=4;e=(a|0)>0|(a|0)==0&e>>>0>0;F=e?2147483647:-2147483648;i=k;return (e?-1:0)|0}}else{c[d>>2]=4;a=0;e=0}while(0);F=a;i=k;return e|0}function Gs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;l=i;i=i+16|0;k=l;do if((b|0)!=(d|0)){if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}h=Cb()|0;j=c[h>>2]|0;c[h>>2]=0;f=Ws(b,k,f,hl()|0)|0;b=F;g=c[h>>2]|0;if(!g)c[h>>2]=j;if((c[k>>2]|0)!=(d|0)){c[e>>2]=4;b=0;break}if((g|0)==34|(b>>>0>0|(b|0)==0&f>>>0>65535)){c[e>>2]=4;b=-1;break}else{b=f&65535;break}}else{c[e>>2]=4;b=0}while(0);i=l;return b|0}function Hs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;l=i;i=i+16|0;k=l;do if((b|0)!=(d|0)){if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}h=Cb()|0;j=c[h>>2]|0;c[h>>2]=0;b=Ws(b,k,f,hl()|0)|0;f=F;g=c[h>>2]|0;if(!g)c[h>>2]=j;if((c[k>>2]|0)!=(d|0)){c[e>>2]=4;b=0;break}if((g|0)==34|(f>>>0>0|(f|0)==0&b>>>0>4294967295)){c[e>>2]=4;b=-1;break}else break}else{c[e>>2]=4;b=0}while(0);i=l;return b|0}function Is(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;l=i;i=i+16|0;k=l;do if((b|0)!=(d|0)){if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}h=Cb()|0;j=c[h>>2]|0;c[h>>2]=0;b=Ws(b,k,f,hl()|0)|0;f=F;g=c[h>>2]|0;if(!g)c[h>>2]=j;if((c[k>>2]|0)!=(d|0)){c[e>>2]=4;b=0;break}if((g|0)==34|(f>>>0>0|(f|0)==0&b>>>0>4294967295)){c[e>>2]=4;b=-1;break}else break}else{c[e>>2]=4;b=0}while(0);i=l;return b|0}function Js(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;k=i;i=i+16|0;j=k;do if((b|0)!=(d|0)){if((a[b>>0]|0)==45){c[e>>2]=4;b=0;f=0;break}g=Cb()|0;h=c[g>>2]|0;c[g>>2]=0;f=Ws(b,j,f,hl()|0)|0;b=c[g>>2]|0;if(!b)c[g>>2]=h;if((c[j>>2]|0)!=(d|0)){c[e>>2]=4;b=0;f=0;break}if((b|0)==34){c[e>>2]=4;b=-1;f=-1}else b=F}else{c[e>>2]=4;b=0;f=0}while(0);F=b;i=k;return f|0}function Ks(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,j=0;j=i;i=i+16|0;h=j;do if((a|0)==(b|0)){c[d>>2]=4;e=0.0}else{f=Cb()|0;g=c[f>>2]|0;c[f>>2]=0;e=+Yu(a,h,hl()|0);a=c[f>>2]|0;if(!a)c[f>>2]=g;if((c[h>>2]|0)!=(b|0)){c[d>>2]=4;e=0.0;break}if((a|0)==34)c[d>>2]=4}while(0);i=j;return +e}function Ls(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,j=0;j=i;i=i+16|0;h=j;do if((a|0)!=(b|0)){f=Cb()|0;g=c[f>>2]|0;c[f>>2]=0;e=+Yu(a,h,hl()|0);a=c[f>>2]|0;if(!a)c[f>>2]=g;if((c[h>>2]|0)!=(b|0)){c[d>>2]=4;e=0.0;break}if((a|0)==34)c[d>>2]=4}else{c[d>>2]=4;e=0.0}while(0);i=j;return +e}function Ms(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,j=0;j=i;i=i+16|0;h=j;do if((a|0)!=(b|0)){f=Cb()|0;g=c[f>>2]|0;c[f>>2]=0;e=+Yu(a,h,hl()|0);a=c[f>>2]|0;if(!a)c[f>>2]=g;if((c[h>>2]|0)!=(b|0)){c[d>>2]=4;e=0.0;break}if((a|0)==34)c[d>>2]=4}else{c[d>>2]=4;e=0.0}while(0);i=j;return +e}function Ns(b,d){b=b|0;d=d|0;var e=0;if(d>>>0>1073741823)Jo(b);e=b+128|0;if((a[e>>0]|0)==0&d>>>0<29){a[e>>0]=1;e=b+16|0}else e=ut(d<<2)|0;c[b+4>>2]=e;c[b>>2]=e;c[b+8>>2]=e+(d<<2);return}function Os(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=c[d>>2]|0;do{if(!a)a=0;else{c[a>>2]=0;a=c[d>>2]|0}a=a+4|0;c[d>>2]=a;b=b+-1|0}while((b|0)!=0);return}function Ps(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;k=i;i=i+32|0;j=k;g=c[a+8>>2]|0;d=c[a+4>>2]|0;if(g-d>>2>>>0<b>>>0){e=c[a>>2]|0;h=d-e>>2;f=h+b|0;if(f>>>0>1073741823)Jo(a);d=g-e|0;if(d>>2>>>0<536870911){d=d>>1;d=d>>>0<f>>>0?f:d}else d=1073741823;Ss(j,d,h,a+16|0);Ts(j,b);Us(a,j);Vs(j)}else Os(a,b);i=k;return}function Qs(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=i;i=i+32|0;r=s+16|0;q=s+8|0;o=s+4|0;p=s;g=b+52|0;a:do if(a[g>>0]|0){f=b+48|0;e=c[f>>2]|0;if(d){c[f>>2]=-1;a[g>>0]=0}}else{f=c[b+44>>2]|0;f=(f|0)>1?f:1;if((f|0)>0){g=b+32|0;h=0;do{e=xb(c[g>>2]|0)|0;if((e|0)==-1){e=-1;break a}a[r+h>>0]=e;h=h+1|0}while((h|0)<(f|0))}b:do if(!(a[b+53>>0]|0)){k=b+40|0;l=b+36|0;m=q+4|0;n=b+32|0;while(1){e=c[k>>2]|0;g=e;h=c[g>>2]|0;g=c[g+4>>2]|0;t=c[l>>2]|0;j=r+f|0;e=kc[c[(c[t>>2]|0)+16>>2]&15](t,e,r,j,o,q,m,p)|0;if((e|0)==2){e=-1;break a}else if((e|0)==3)break;else if((e|0)!=1)break b;e=c[k>>2]|0;c[e>>2]=h;c[e+4>>2]=g;if((f|0)==8){e=-1;break a}h=xb(c[n>>2]|0)|0;if((h|0)==-1){e=-1;break a}a[j>>0]=h;f=f+1|0}c[q>>2]=a[r>>0]}else c[q>>2]=a[r>>0];while(0);if(d){e=c[q>>2]|0;c[b+48>>2]=e;break}e=b+32|0;while(1){if((f|0)<=0)break;f=f+-1|0;if((Ma(a[r+f>>0]|0,c[e>>2]|0)|0)==-1){e=-1;break a}}e=c[q>>2]|0}while(0);i=s;return e|0}function Rs(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;t=i;i=i+32|0;s=t+16|0;r=t+8|0;p=t+4|0;q=t;h=b+52|0;a:do if(a[h>>0]|0){g=b+48|0;f=c[g>>2]|0;if(e){c[g>>2]=-1;a[h>>0]=0}}else{g=c[b+44>>2]|0;g=(g|0)>1?g:1;if((g|0)>0){h=b+32|0;j=0;do{f=xb(c[h>>2]|0)|0;if((f|0)==-1){f=-1;break a}a[s+j>>0]=f;j=j+1|0}while((j|0)<(g|0))}b:do if(!(a[b+53>>0]|0)){l=b+40|0;m=b+36|0;n=r+1|0;o=b+32|0;while(1){f=c[l>>2]|0;h=f;j=c[h>>2]|0;h=c[h+4>>2]|0;u=c[m>>2]|0;k=s+g|0;f=kc[c[(c[u>>2]|0)+16>>2]&15](u,f,s,k,p,r,n,q)|0;if((f|0)==3)break;else if((f|0)==2){f=-1;break a}else if((f|0)!=1)break b;f=c[l>>2]|0;c[f>>2]=j;c[f+4>>2]=h;if((g|0)==8){f=-1;break a}j=xb(c[o>>2]|0)|0;if((j|0)==-1){f=-1;break a}a[k>>0]=j;g=g+1|0}a[r>>0]=a[s>>0]|0}else a[r>>0]=a[s>>0]|0;while(0);if(e){f=a[r>>0]|0;c[b+48>>2]=f&255}else{f=b+32|0;while(1){if((g|0)<=0)break;g=g+-1|0;if((Ma(d[s+g>>0]|0,c[f>>2]|0)|0)==-1){f=-1;break a}}f=a[r>>0]|0}f=f&255}while(0);i=t;return f|0}function Ss(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;h=b+12|0;c[h>>2]=0;c[b+16>>2]=f;do if(d){g=f+112|0;if((a[g>>0]|0)==0&d>>>0<29){a[g>>0]=1;break}else{f=ut(d<<2)|0;break}}else f=0;while(0);c[b>>2]=f;g=f+(e<<2)|0;c[b+8>>2]=g;c[b+4>>2]=g;c[h>>2]=f+(d<<2);return}function Ts(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;do{if(!a)a=0;else{c[a>>2]=0;a=c[d>>2]|0}a=a+4|0;c[d>>2]=a;b=b+-1|0}while((b|0)!=0);return}function Us(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;g=a+4|0;d=b+4|0;f=(c[g>>2]|0)-e|0;h=(c[d>>2]|0)+(0-(f>>2)<<2)|0;c[d>>2]=h;mv(h|0,e|0,f|0)|0;f=c[a>>2]|0;c[a>>2]=c[d>>2];c[d>>2]=f;f=b+8|0;e=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=e;f=a+8|0;a=b+12|0;e=c[f>>2]|0;c[f>>2]=c[a>>2];c[a>>2]=e;c[b>>2]=c[d>>2];return}function Vs(b){b=b|0;var d=0,e=0,f=0;e=c[b+4>>2]|0;d=b+8|0;f=c[d>>2]|0;if((f|0)!=(e|0))c[d>>2]=f+(~((f+-4-e|0)>>>2)<<2);e=c[b>>2]|0;do if(e){d=c[b+16>>2]|0;if((d|0)==(e|0)){a[d+112>>0]=0;break}else{xt(e);break}}while(0);return}function Ws(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c=Zu(a,b,c)|0;return c|0}function Xs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c=_u(a,b,c)|0;return c|0}function Ys(a){a=a|0;return (a+-97|0)>>>0<26|0}function Zs(a){a=a|0;var b=0;b=(Ys(a)|0)==0;return (b?a:a&95)|0}function _s(a,b){a=a|0;b=b|0;return (a+-48|0)>>>0<10|0}function $s(a,b){a=a|0;b=b|0;return Au(a)|0}function at(a,b,c){a=a|0;b=b|0;c=c|0;return bt(0,a,b,(c|0)!=0?c:1085768)|0}function bt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;k=i;i=i+16|0;h=k;c[h>>2]=b;j=(f|0)==0?1085776:f;g=c[j>>2]|0;a:do if(!d){if(!g){g=0;i=k;return g|0}}else{if(!b)c[h>>2]=h;else h=b;if(!e){g=-2;i=k;return g|0}do if(!g){f=a[d>>0]|0;g=f&255;if(f<<24>>24>-1){c[h>>2]=g;g=f<<24>>24!=0&1;i=k;return g|0}else{g=g+-194|0;if(g>>>0>50)break a;f=e+-1|0;g=c[1085560+(g<<2)>>2]|0;d=d+1|0;break}}else f=e;while(0);b:do if(f){b=a[d>>0]|0;l=(b&255)>>>3;if((l+-16|l+(g>>26))>>>0>7)break a;while(1){d=d+1|0;g=(b&255)+-128|g<<6;f=f+-1|0;if((g|0)>=0)break;if(!f)break b;b=a[d>>0]|0;if((b&-64)<<24>>24!=-128)break a}c[j>>2]=0;c[h>>2]=g;g=e-f|0;i=k;return g|0}while(0);c[j>>2]=g;g=-2;i=k;return g|0}while(0);c[j>>2]=0;c[(Cb()|0)>>2]=84;g=-1;i=k;return g|0}function ct(a){a=a|0;if(!a)a=1;else a=(c[a>>2]|0)==0;return a&1|0}function dt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=i;i=i+1040|0;l=p+8|0;o=p;h=c[b>>2]|0;c[o>>2]=h;n=(a|0)!=0;e=n?e:256;g=n?a:l;a:do if((h|0)!=0&(e|0)!=0){k=d;a=0;while(1){j=k>>>2;d=j>>>0>=e>>>0;if(!(d|k>>>0>131)){d=k;m=7;break a}d=d?e:j;j=k-d|0;d=et(g,o,d,f)|0;if((d|0)==-1){a=-1;break a}if((g|0)==(l|0))g=l;else{e=e-d|0;g=g+(d<<2)|0}a=d+a|0;h=c[o>>2]|0;if((h|0)!=0&(e|0)!=0)k=j;else{d=j;m=7;break}}}else{a=0;m=7}while(0);b:do if((m|0)==7)if((h|0)!=0&(e|0)!=0&(d|0)!=0){j=e;while(1){e=bt(g,h,d,f)|0;if((e+2|0)>>>0<3)break;h=(c[o>>2]|0)+e|0;c[o>>2]=h;j=j+-1|0;a=a+1|0;if(!((j|0)!=0&(d|0)!=(e|0)))break b;else{d=d-e|0;g=g+4|0}}if((e|0)==-1){a=-1;break}else if(!e){c[o>>2]=0;break}else{c[f>>2]=0;break}}while(0);if(!n){i=p;return a|0}c[b>>2]=c[o>>2];i=p;return a|0}function et(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=c[e>>2]|0;if((g|0)!=0?(i=c[g>>2]|0,(i|0)!=0):0)if(!b){g=f;j=h;l=16}else{c[g>>2]=0;g=f;j=i;k=h;l=36}else if(!b){g=f;l=7}else{g=f;l=6}a:while(1)if((l|0)==6){if(!g){l=26;break}while(1){i=a[h>>0]|0;b:do if(((i&255)+-1|0)>>>0<127?(h&3|0)==0&g>>>0>4:0){while(1){i=c[h>>2]|0;if((i+-16843009|i)&-2139062144){i=i&255;break b}c[b>>2]=i&255;c[b+4>>2]=d[h+1>>0];c[b+8>>2]=d[h+2>>0];i=h+4|0;j=b+16|0;c[b+12>>2]=d[h+3>>0];g=g+-4|0;if(g>>>0>4){b=j;h=i}else{h=i;b=j;break}}i=a[h>>0]|0}while(0);i=i&255;if((i+-1|0)>>>0>=127)break;h=h+1|0;c[b>>2]=i;g=g+-1|0;if(!g){l=26;break a}else b=b+4|0}i=i+-194|0;if(i>>>0>50){l=47;break}j=c[1085560+(i<<2)>>2]|0;k=h+1|0;l=36;continue}else if((l|0)==7){i=a[h>>0]|0;if(((i&255)+-1|0)>>>0<127?(h&3|0)==0:0){i=c[h>>2]|0;if(!((i+-16843009|i)&-2139062144))do{h=h+4|0;g=g+-4|0;i=c[h>>2]|0}while(((i+-16843009|i)&-2139062144|0)==0);i=i&255}i=i&255;if((i+-1|0)>>>0<127){g=g+-1|0;h=h+1|0;l=7;continue}i=i+-194|0;if(i>>>0>50){l=47;break}i=c[1085560+(i<<2)>>2]|0;j=h+1|0;l=16;continue}else if((l|0)==16){h=(d[j>>0]|0)>>>3;if((h+-16|h+(i>>26))>>>0>7){l=17;break}h=j+1|0;if(i&33554432){if((a[h>>0]&-64)<<24>>24!=-128){l=20;break}h=j+2|0;if(i&524288){if((a[h>>0]&-64)<<24>>24!=-128){l=23;break}h=j+3|0}}g=g+-1|0;l=7;continue}else if((l|0)==36){i=d[k>>0]|0;h=i>>>3;if((h+-16|h+(j>>26))>>>0>7){l=37;break}h=k+1|0;j=i+-128|j<<6;if((j|0)<0){i=d[h>>0]|0;if((i&192|0)!=128){l=40;break}h=k+2|0;j=i+-128|j<<6;if((j|0)<0){i=d[h>>0]|0;if((i&192|0)!=128){l=43;break}j=i+-128|j<<6;h=k+3|0}}c[b>>2]=j;b=b+4|0;g=g+-1|0;l=6;continue}if((l|0)==17){h=j+-1|0;l=46}else if((l|0)==20){h=j+-1|0;l=46}else if((l|0)==23){h=j+-1|0;l=46}else if((l|0)==26){c[e>>2]=h;h=f;return h|0}else if((l|0)==37){i=j;h=k+-1|0;l=46}else if((l|0)==40){i=j;h=k+-1|0;l=46}else if((l|0)==43){i=j;h=k+-1|0;l=46}if((l|0)==46)if(!i)l=47;if((l|0)==47)if(!(a[h>>0]|0)){if(b){c[b>>2]=0;c[e>>2]=0}h=f-g|0;return h|0}c[(Cb()|0)>>2]=84;if(!b){h=-1;return h|0}c[e>>2]=h;h=-1;return h|0}function ft(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0;j=i;i=i+16|0;g=j;c[g>>2]=b;if(!e){g=0;i=j;return g|0}do if(f){if(!b){c[g>>2]=g;h=g}else h=b;b=a[e>>0]|0;g=b&255;if(b<<24>>24>-1){c[h>>2]=g;g=b<<24>>24!=0&1;i=j;return g|0}b=g+-194|0;if(b>>>0<=50){g=e+1|0;b=c[1085560+(b<<2)>>2]|0;if(f>>>0<4?(b&-2147483648>>>((f*6|0)+-6|0)|0)!=0:0)break;g=d[g>>0]|0;f=g>>>3;if((f+-16|f+(b>>26))>>>0<=7){g=g+-128|b<<6;if((g|0)>=0){c[h>>2]=g;g=2;i=j;return g|0}b=d[e+2>>0]|0;if((b&192|0)==128){b=b+-128|g<<6;if((b|0)>=0){c[h>>2]=b;g=3;i=j;return g|0}g=d[e+3>>0]|0;if((g&192|0)==128){c[h>>2]=g+-128|b<<6;g=4;i=j;return g|0}}}}}while(0);c[(Cb()|0)>>2]=84;g=-1;i=j;return g|0}function gt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+272|0;j=n+8|0;m=n;g=c[b>>2]|0;c[m>>2]=g;l=(a|0)!=0;e=l?e:256;a=l?a:j;a:do if((g|0)!=0&(e|0)!=0){h=e;f=0;while(1){e=d>>>0>=h>>>0;if(!(e|d>>>0>32)){e=h;k=7;break a}g=e?h:d;d=d-g|0;g=ht(a,m,g,0)|0;if((g|0)==-1){f=-1;break a}if((a|0)==(j|0)){e=h;a=j}else{e=h-g|0;a=a+g|0}f=g+f|0;g=c[m>>2]|0;if((g|0)!=0&(e|0)!=0)h=e;else{k=7;break}}}else{f=0;k=7}while(0);b:do if((k|0)==7)if((g|0)!=0&(e|0)!=0&(d|0)!=0){h=d;d=e;while(1){e=Pu(a,c[g>>2]|0,0)|0;if((e+1|0)>>>0<2)break;g=(c[m>>2]|0)+4|0;c[m>>2]=g;h=h+-1|0;f=f+1|0;if(!((d|0)!=(e|0)&(h|0)!=0))break b;else{d=d-e|0;a=a+e|0}}if(!e)c[m>>2]=0;else f=-1}while(0);if(!l){i=n;return f|0}c[b>>2]=c[m>>2];i=n;return f|0}function ht(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;o=i;i=i+16|0;n=o;if(!b){g=c[d>>2]|0;f=c[g>>2]|0;if(!f){n=0;i=o;return n|0}else h=0;while(1){if(f>>>0>127){f=Pu(n,f,0)|0;if((f|0)==-1){m=-1;j=26;break}}else f=1;h=f+h|0;g=g+4|0;f=c[g>>2]|0;if(!f){m=h;j=26;break}}if((j|0)==26){i=o;return m|0}}a:do if(e>>>0>3){g=e;h=c[d>>2]|0;while(1){f=c[h>>2]|0;if((f+-1|0)>>>0>126){if(!f){k=b;l=g;break}f=Pu(b,f,0)|0;if((f|0)==-1){m=-1;j=26;break}b=b+f|0;g=g-f|0}else{a[b>>0]=f;b=b+1|0;g=g+-1|0;h=c[d>>2]|0}h=h+4|0;c[d>>2]=h;if(g>>>0<=3)break a}if((j|0)==26){i=o;return m|0}a[k>>0]=0;c[d>>2]=0;n=e-l|0;i=o;return n|0}else g=e;while(0);if(!g){n=e;i=o;return n|0}f=c[d>>2]|0;while(1){h=c[f>>2]|0;if((h+-1|0)>>>0>126){if(!h){p=b;q=g;j=19;break}h=Pu(n,h,0)|0;if((h|0)==-1){m=-1;j=26;break}if(g>>>0<h>>>0){r=g;j=22;break}Pu(b,c[f>>2]|0,0)|0;b=b+h|0;g=g-h|0}else{a[b>>0]=h;b=b+1|0;g=g+-1|0;f=c[d>>2]|0}f=f+4|0;c[d>>2]=f;if(!g){m=e;j=26;break}}if((j|0)==19){a[p>>0]=0;c[d>>2]=0;n=e-q|0;i=o;return n|0}else if((j|0)==22){n=e-r|0;i=o;return n|0}else if((j|0)==26){i=o;return m|0}return 0}function it(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=a+84|0;h=c[g>>2]|0;e=d+256|0;f=$u(h,0,e)|0;if(f)e=f-h|0;f=e>>>0<d>>>0?e:d;mv(b|0,h|0,f|0)|0;c[a+4>>2]=h+f;e=h+e|0;c[a+8>>2]=e;c[g>>2]=e;return f|0}function jt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;b=mt(a,b,f)|0;i=e;return b|0}function kt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=i;i=i+16|0;e=j;f=tu(240)|0;do if(f){c[e>>2]=c[d>>2];e=Wu(f,240,b,e)|0;if(e>>>0<240){g=wu(f,e+1|0)|0;c[a>>2]=(g|0)!=0?g:f;break}uu(f);if((e|0)>=0?(h=e+1|0,g=tu(h)|0,c[a>>2]=g,(g|0)!=0):0)e=Wu(g,h,b,d)|0;else e=-1}else e=-1;while(0);i=j;return e|0}function lt(e,f,j){e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;O=i;i=i+304|0;H=O+16|0;J=O+8|0;I=O+33|0;K=O;y=O+32|0;m=a[f>>0]|0;if(!(m<<24>>24)){G=0;i=O;return G|0}L=e+4|0;M=e+100|0;B=e+108|0;C=e+8|0;D=I+10|0;E=I+33|0;G=J+4|0;z=I+46|0;A=I+94|0;k=0;n=f;s=0;f=0;l=0;a:while(1){b:do if(!(yu(m&255)|0)){o=(a[n>>0]|0)==37;c:do if(o){q=n+1|0;m=a[q>>0]|0;do if(m<<24>>24==42){x=0;m=n+2|0}else if(m<<24>>24==37)break c;else{o=(m&255)+-48|0;if(o>>>0<10?(a[n+2>>0]|0)==36:0){c[H>>2]=c[j>>2];while(1){x=c[H>>2]|0;m=c[x>>2]|0;c[H>>2]=x+4;if(o>>>0>1)o=o+-1|0;else break}x=m;m=n+3|0;break}m=c[j>>2]|0;x=c[m>>2]|0;c[j>>2]=m+4;m=q}while(0);o=a[m>>0]|0;n=o&255;if((n+-48|0)>>>0<10){o=0;while(1){r=(o*10|0)+-48+n|0;m=m+1|0;o=a[m>>0]|0;n=o&255;if((n+-48|0)>>>0>=10){q=m;break}else o=r}}else{q=m;r=0}if(o<<24>>24==109){q=q+1|0;o=a[q>>0]|0;m=(x|0)!=0&1;f=0;l=0}else m=0;n=q+1|0;switch(o&255|0){case 104:{w=(a[n>>0]|0)==104;n=w?q+2|0:n;q=w?-2:-1;break}case 106:{q=3;break}case 76:{q=2;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{n=q;q=0;break}case 116:case 122:{q=1;break}case 108:{w=(a[n>>0]|0)==108;n=w?q+2|0:n;q=w?3:1;break}default:{N=163;break a}}t=d[n>>0]|0;u=(t&47|0)==3;t=u?t|32:t;u=u?1:q;if((t|0)==91)w=s;else if((t|0)==110){if(!x){r=s;break b}switch(u|0){case 3:{r=x;c[r>>2]=s;c[r+4>>2]=((s|0)<0)<<31>>31;r=s;break b}case 0:{c[x>>2]=s;r=s;break b}case 1:{c[x>>2]=s;r=s;break b}case -2:{a[x>>0]=s;r=s;break b}case -1:{b[x>>1]=s;r=s;break b}default:{r=s;break b}}}else if((t|0)==99){w=s;r=(r|0)<1?1:r}else{Eu(e,0);do{q=c[L>>2]|0;if(q>>>0<(c[M>>2]|0)>>>0){c[L>>2]=q+1;q=d[q>>0]|0}else q=Fu(e)|0}while((yu(q)|0)!=0);q=c[L>>2]|0;if(c[M>>2]|0){q=q+-1|0;c[L>>2]=q}w=(c[B>>2]|0)+s+q-(c[C>>2]|0)|0}Eu(e,r);q=c[L>>2]|0;o=c[M>>2]|0;if(q>>>0<o>>>0)c[L>>2]=q+1;else{if((Fu(e)|0)<0){N=163;break a}o=c[M>>2]|0}if(o)c[L>>2]=(c[L>>2]|0)+-1;d:do switch(t|0){case 111:{q=8;N=145;break}case 117:case 100:{q=10;N=145;break}case 91:case 99:case 115:{v=(t|0)==99;e:do if((t&239|0)==99){kv(I|0,-1,257)|0;a[I>>0]=0;if((t|0)==115){a[E>>0]=0;a[D+0>>0]=0;a[D+1>>0]=0;a[D+2>>0]=0;a[D+3>>0]=0;a[D+4>>0]=0}}else{P=n+1|0;q=(a[P>>0]|0)==94;s=q&1;t=q?P:n;n=q?n+2|0:P;kv(I|0,q&1|0,257)|0;a[I>>0]=0;q=a[n>>0]|0;if(q<<24>>24==93){s=(s^1)&255;a[A>>0]=s;n=t+2|0}else if(q<<24>>24==45){s=(s^1)&255;a[z>>0]=s;n=t+2|0}else s=(s^1)&255;while(1){q=a[n>>0]|0;if(q<<24>>24==45){t=n+1|0;q=a[t>>0]|0;if(!(q<<24>>24==93|q<<24>>24==0)){n=a[n+-1>>0]|0;if((n&255)<(q&255)){n=n&255;do{n=n+1|0;a[I+n>>0]=s;q=a[t>>0]|0}while((n|0)<(q&255|0));n=t}else n=t}else q=45}else if(q<<24>>24==93)break e;else if(!(q<<24>>24)){N=163;break a}a[I+((q&255)+1)>>0]=s;n=n+1|0}}while(0);t=v?r+1|0:31;u=(u|0)==1;s=(m|0)!=0;f:do if(u){if(s){l=tu(t<<2)|0;if(!l){f=0;N=163;break a}}else l=x;c[J>>2]=0;c[G>>2]=0;q=0;g:while(1){if(!l)while(1){o=c[L>>2]|0;if(o>>>0<(c[M>>2]|0)>>>0){c[L>>2]=o+1;o=d[o>>0]|0}else o=Fu(e)|0;if(!(a[I+(o+1)>>0]|0)){l=0;break g}a[y>>0]=o;o=bt(K,y,1,J)|0;if((o|0)==-1){f=0;l=0;N=163;break a}else if((o|0)==-2)continue;if(s&(q|0)==(t|0))break}else{if(!s){N=85;break}while(1){while(1){o=c[L>>2]|0;if(o>>>0<(c[M>>2]|0)>>>0){c[L>>2]=o+1;o=d[o>>0]|0}else o=Fu(e)|0;if(!(a[I+(o+1)>>0]|0))break g;a[y>>0]=o;o=bt(K,y,1,J)|0;if((o|0)==-1){f=0;N=163;break a}else if((o|0)!=-2)break}c[l+(q<<2)>>2]=c[K>>2];q=q+1|0;if((q|0)==(t|0)){q=t;break}}}o=t<<1|1;f=wu(l,o<<2)|0;if(!f){f=0;N=163;break a}t=o;l=f}h:do if((N|0)==85){N=0;o=q;while(1){while(1){q=c[L>>2]|0;if(q>>>0<(c[M>>2]|0)>>>0){c[L>>2]=q+1;q=d[q>>0]|0}else q=Fu(e)|0;if(!(a[I+(q+1)>>0]|0)){q=o;break h}a[y>>0]=q;q=bt(K,y,1,J)|0;if((q|0)==-1){m=0;f=0;N=163;break a}else if((q|0)!=-2)break}c[l+(o<<2)>>2]=c[K>>2];o=o+1|0}}while(0);if(!(ct(J)|0)){f=0;N=163;break a}else f=0}else{if(s){f=tu(t)|0;if(!f){f=0;l=0;N=163;break a}else q=0;while(1){do{o=c[L>>2]|0;if(o>>>0<(c[M>>2]|0)>>>0){c[L>>2]=o+1;o=d[o>>0]|0}else o=Fu(e)|0;if(!(a[I+(o+1)>>0]|0)){l=0;break f}a[f+q>>0]=o;q=q+1|0}while((q|0)!=(t|0));q=t<<1|1;o=wu(f,q)|0;if(!o){l=0;N=163;break a}else{l=t;t=q;f=o;q=l}}}if(!x)while(1){q=c[L>>2]|0;if(q>>>0<o>>>0){c[L>>2]=q+1;o=d[q>>0]|0}else o=Fu(e)|0;if(!(a[I+(o+1)>>0]|0)){q=0;f=0;l=0;break f}o=c[M>>2]|0}else{f=0;while(1){q=c[L>>2]|0;if(q>>>0<o>>>0){c[L>>2]=q+1;q=d[q>>0]|0}else q=Fu(e)|0;if(!(a[I+(q+1)>>0]|0)){q=f;f=x;l=0;break f}a[x+f>>0]=q;o=c[M>>2]|0;f=f+1|0}}}while(0);o=c[L>>2]|0;if(c[M>>2]|0){o=o+-1|0;c[L>>2]=o}o=o-(c[C>>2]|0)+(c[B>>2]|0)|0;if(!o)break a;if(!((o|0)==(r|0)|v^1))break a;do if(s)if(u){c[x>>2]=l;break}else{c[x>>2]=f;break}while(0);if(!v){if(l)c[l+(q<<2)>>2]=0;if(!f)f=0;else a[f+q>>0]=0}break}case 105:{q=0;N=145;break}case 120:case 88:case 112:{q=16;N=145;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{p=+Du(e,u,0);if((c[B>>2]|0)==((c[C>>2]|0)-(c[L>>2]|0)|0))break a;if(x)if(!u){g[x>>2]=p;break d}else if((u|0)==1){h[x>>3]=p;break d}else if((u|0)==2){h[x>>3]=p;break d}else break d;break}default:{}}while(0);i:do if((N|0)==145){N=0;o=Cu(e,q,0,-1,-1)|0;if((c[B>>2]|0)==((c[C>>2]|0)-(c[L>>2]|0)|0))break a;if((t|0)==112&(x|0)!=0){c[x>>2]=o;break}if(x)switch(u|0){case -2:{a[x>>0]=o;break i}case -1:{b[x>>1]=o;break i}case 0:{c[x>>2]=o;break i}case 1:{c[x>>2]=o;break i}case 3:{v=x;c[v>>2]=o;c[v+4>>2]=F;break i}default:break i}}while(0);k=((x|0)!=0&1)+k|0;r=(c[B>>2]|0)+w+(c[L>>2]|0)-(c[C>>2]|0)|0;break b}while(0);n=n+(o&1)|0;Eu(e,0);m=c[L>>2]|0;if(m>>>0<(c[M>>2]|0)>>>0){c[L>>2]=m+1;m=d[m>>0]|0}else m=Fu(e)|0;if((m|0)!=(d[n>>0]|0)){N=19;break a}r=s+1|0}else{while(1){m=n+1|0;if(!(yu(d[m>>0]|0)|0))break;else n=m}Eu(e,0);do{m=c[L>>2]|0;if(m>>>0<(c[M>>2]|0)>>>0){c[L>>2]=m+1;m=d[m>>0]|0}else m=Fu(e)|0}while((yu(m)|0)!=0);m=c[L>>2]|0;if(c[M>>2]|0){m=m+-1|0;c[L>>2]=m}r=(c[B>>2]|0)+s+m-(c[C>>2]|0)|0}while(0);n=n+1|0;m=a[n>>0]|0;if(!(m<<24>>24)){N=167;break}else s=r}if((N|0)==19){if(c[M>>2]|0)c[L>>2]=(c[L>>2]|0)+-1;if((m|0)>-1|(k|0)!=0){G=k;i=O;return G|0}else{k=0;N=164}}else if((N|0)==163){if(!k){k=m;N=164}}else if((N|0)==167){i=O;return k|0}if((N|0)==164){m=k;k=-1}if(!m){G=k;i=O;return G|0}uu(f);uu(l);G=k;i=O;return G|0}function mt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=i;i=i+112|0;e=g;f=e+0|0;h=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));c[e+32>>2]=25;c[e+44>>2]=a;c[e+76>>2]=-1;c[e+84>>2]=a;d=lt(e,b,d)|0;i=g;return d|0}function nt(a){a=a|0;var b=0;b=a;while(1)if(!(c[b>>2]|0))break;else b=b+4|0;return b-a>>2|0}function ot(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(!d)return a|0;else e=a;while(1){d=d+-1|0;c[e>>2]=c[b>>2];if(!d)break;else{b=b+4|0;e=e+4|0}}return a|0}function pt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(e)return a|0;do{d=d+-1|0;c[a+(d<<2)>>2]=c[b+(d<<2)>>2]}while((d|0)!=0);return a|0}else{if(e)return a|0;else{e=b;b=a}while(1){d=d+-1|0;c[b>>2]=c[e>>2];if(!d)break;else{e=e+4|0;b=b+4|0}}return a|0}return 0}function qt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(!d)return a|0;else e=a;while(1){d=d+-1|0;c[e>>2]=b;if(!d)break;else e=e+4|0}return a|0}function rt(a,b,c){a=a|0;b=b|0;c=c|0;return it(a,b,c)|0}function st(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;c[d>>2]=b;b=c[n>>2]|0;La(b|0,a|0,d|0)|0;Hb(10,b|0)|0;Nb()}function tt(){var a=0,b=0;a=i;i=i+16|0;if(!(sb(1085968,3)|0)){b=kb(c[271490]|0)|0;i=a;return b|0}else st(1085976,a);return 0}function ut(a){a=a|0;var b=0;b=(a|0)==0?1:a;a=tu(b)|0;a:do if(!a){while(1){a=Ft()|0;if(!a)break;jc[a&3]();a=tu(b)|0;if(a)break a}a=Oa(4)|0;c[a>>2]=1086152;Qb(a|0,1086200,159)}while(0);return a|0}function vt(a,b){a=a|0;b=b|0;return ut(a)|0}function wt(a){a=a|0;return ut(a)|0}function xt(a){a=a|0;uu(a);return}function yt(a){a=a|0;xt(a);return}function zt(a){a=a|0;c[a>>2]=1086152;return}function At(a){a=a|0;return}function Bt(a){a=a|0;xt(a);return}function Ct(a){a=a|0;return 1086168}function Dt(a){a=a|0;var b=0;b=i;i=i+16|0;jc[a&3]();st(1086216,b)}function Et(){var a=0,b=0;a=tt()|0;if(((a|0)!=0?(b=c[a>>2]|0,(b|0)!=0):0)?(a=b+48|0,(c[a>>2]&-256|0)==1126902528?(c[a+4>>2]|0)==1129074247:0):0)Dt(c[b+12>>2]|0);a=c[271446]|0;c[271446]=a+0;Dt(a)}function Ft(){var a=0;a=c[271564]|0;c[271564]=a+0;return a|0}function Gt(a){a=a|0;return}function Ht(a){a=a|0;c[a>>2]=1086296;ru(a+4|0);return}function It(a){a=a|0;Ht(a);xt(a);return}function Jt(a){a=a|0;return c[a+4>>2]|0}function Kt(a){a=a|0;c[a>>2]=1086320;ru(a+4|0);return}function Lt(a){a=a|0;Kt(a);xt(a);return}function Mt(a){a=a|0;return c[a+4>>2]|0}function Nt(a){a=a|0;Ht(a);xt(a);return}function Ot(a){a=a|0;Ht(a);xt(a);return}function Pt(a){a=a|0;return}function Qt(a){a=a|0;c[a>>2]=1086544;return}function Rt(a){a=a|0;return}function St(a){a=a|0;xt(a);return}function Tt(a){a=a|0;return 1086560}function Ut(a){a=a|0;return}function Vt(a){a=a|0;return}function Wt(a){a=a|0;return}function Xt(a){a=a|0;xt(a);return}function Yt(a){a=a|0;xt(a);return}function Zt(a){a=a|0;xt(a);return}function _t(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=i;i=i+64|0;g=h;if((a|0)!=(b|0))if((b|0)!=0?(f=eu(b,1086672,1086728,0)|0,(f|0)!=0):0){b=g+0|0;e=b+56|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(e|0));c[g>>2]=f;c[g+8>>2]=a;c[g+12>>2]=-1;c[g+48>>2]=1;qc[c[(c[f>>2]|0)+28>>2]&15](f,g,c[d>>2]|0,1);if((c[g+24>>2]|0)==1){c[d>>2]=c[g+16>>2];b=1}else b=0}else b=0;else b=1;i=h;return b|0}function $t(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;b=d+16|0;g=c[b>>2]|0;do if(g){if((g|0)!=(e|0)){b=d+36|0;c[b>>2]=(c[b>>2]|0)+1;c[d+24>>2]=2;a[d+54>>0]=1;break}b=d+24|0;if((c[b>>2]|0)==2)c[b>>2]=f}else{c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1}while(0);return}function au(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;if((c[b+8>>2]|0)==(a|0))$t(0,b,d,e);return}function bu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;if((a|0)==(c[b+8>>2]|0))$t(0,b,d,e);else{a=c[a+8>>2]|0;qc[c[(c[a>>2]|0)+28>>2]&15](a,b,d,e)}return}function cu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;g=c[a+4>>2]|0;f=g>>8;if(g&1)f=c[(c[d>>2]|0)+f>>2]|0;a=c[a>>2]|0;qc[c[(c[a>>2]|0)+28>>2]&15](a,b,d+f|0,(g&2|0)!=0?e:2);return}function du(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a:do if((b|0)!=(c[d+8>>2]|0)){h=c[b+12>>2]|0;g=b+(h<<3)+16|0;cu(b+16|0,d,e,f);if((h|0)>1){h=d+54|0;b=b+24|0;do{cu(b,d,e,f);if(a[h>>0]|0)break a;b=b+8|0}while(b>>>0<g>>>0)}}else $t(0,d,e,f);while(0);return}function eu(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;r=i;i=i+64|0;q=r;p=c[d>>2]|0;o=d+(c[p+-8>>2]|0)|0;p=c[p+-4>>2]|0;c[q>>2]=f;c[q+4>>2]=d;c[q+8>>2]=e;c[q+12>>2]=g;h=q+16|0;j=q+20|0;k=q+24|0;l=q+28|0;m=q+32|0;n=q+40|0;e=(p|0)==(f|0);d=h+0|0;g=d+36|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(g|0));b[h+36>>1]=0;a[h+38>>0]=0;do if(e){c[q+48>>2]=1;nc[c[(c[p>>2]|0)+20>>2]&31](p,q,o,o,1,0);g=(c[k>>2]|0)==1?o:0}else{bc[c[(c[p>>2]|0)+24>>2]&3](p,q,o,1,0);g=c[q+36>>2]|0;if(!g){g=(c[n>>2]|0)==1&(c[l>>2]|0)==1&(c[m>>2]|0)==1?c[j>>2]|0:0;break}else if((g|0)!=1){g=0;break}if((c[k>>2]|0)!=1?!((c[n>>2]|0)==0&(c[l>>2]|0)==1&(c[m>>2]|0)==1):0){g=0;break}g=c[h>>2]|0}while(0);i=r;return g|0}function fu(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a[d+53>>0]=1;do if((c[d+4>>2]|0)==(f|0)){a[d+52>>0]=1;f=d+16|0;b=c[f>>2]|0;if(!b){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((g|0)==1?(c[d+48>>2]|0)==1:0))break;a[d+54>>0]=1;break}if((b|0)!=(e|0)){b=d+36|0;c[b>>2]=(c[b>>2]|0)+1;a[d+54>>0]=1;break}f=d+24|0;b=c[f>>2]|0;if((b|0)==2){c[f>>2]=g;b=g}if((b|0)==1?(c[d+48>>2]|0)==1:0)a[d+54>>0]=1}while(0);return}function gu(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a:do if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)==(e|0)?(h=d+28|0,(c[h>>2]|0)!=1):0)c[h>>2]=f}else{if((b|0)!=(c[d>>2]|0)){o=c[b+12>>2]|0;k=b+(o<<3)+16|0;iu(b+16|0,d,e,f,g);h=b+24|0;if((o|0)<=1)break;i=c[b+8>>2]|0;if((i&2|0)==0?(l=d+36|0,(c[l>>2]|0)!=1):0){if(!(i&1)){i=d+54|0;while(1){if(a[i>>0]|0)break a;if((c[l>>2]|0)==1)break a;iu(h,d,e,f,g);h=h+8|0;if(h>>>0>=k>>>0)break a}}i=d+24|0;j=d+54|0;while(1){if(a[j>>0]|0)break a;if((c[l>>2]|0)==1?(c[i>>2]|0)==1:0)break a;iu(h,d,e,f,g);h=h+8|0;if(h>>>0>=k>>>0)break a}}i=d+54|0;while(1){if(a[i>>0]|0)break a;iu(h,d,e,f,g);h=h+8|0;if(h>>>0>=k>>>0)break a}}if((c[d+16>>2]|0)!=(e|0)?(q=d+20|0,(c[q>>2]|0)!=(e|0)):0){c[d+32>>2]=f;p=d+44|0;if((c[p>>2]|0)==4)break;f=c[b+12>>2]|0;k=b+(f<<3)+16|0;b:do if((f|0)>0){j=d+52|0;m=d+53|0;n=d+54|0;o=b+8|0;f=d+24|0;i=0;h=0;l=b+16|0;c:do{a[j>>0]=0;a[m>>0]=0;hu(l,d,e,e,1,g);if(a[n>>0]|0)break;do if(a[m>>0]|0){if(!(a[j>>0]|0))if(!(c[o>>2]&1)){h=1;break c}else{h=1;break}if((c[f>>2]|0)==1){i=25;break b}if(!(c[o>>2]&2)){i=25;break b}else{i=1;h=1}}while(0);l=l+8|0}while(l>>>0<k>>>0);if(i)i=24;else i=21}else{h=0;i=21}while(0);if((i|0)==21){c[q>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0){a[d+54>>0]=1;if(h)i=25;else i=26}else i=24}if((i|0)==24)if(h)i=25;else i=26;if((i|0)==25){c[p>>2]=3;break}else if((i|0)==26){c[p>>2]=4;break}}if((f|0)==1)c[d+32>>2]=1}while(0);return}function hu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;i=c[a+4>>2]|0;h=i>>8;if(i&1)h=c[(c[e>>2]|0)+h>>2]|0;a=c[a>>2]|0;nc[c[(c[a>>2]|0)+20>>2]&31](a,b,d,e+h|0,(i&2|0)!=0?f:2,g);return}function iu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;h=c[a+4>>2]|0;g=h>>8;if(h&1)g=c[(c[d>>2]|0)+g>>2]|0;a=c[a>>2]|0;bc[c[(c[a>>2]|0)+24>>2]&3](a,b,d+g|0,(h&2|0)!=0?e:2,f);return}function ju(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;a:do if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)==(e|0)?(h=d+28|0,(c[h>>2]|0)!=1):0)c[h>>2]=f}else{if((b|0)!=(c[d>>2]|0)){h=c[b+8>>2]|0;bc[c[(c[h>>2]|0)+24>>2]&3](h,d,e,f,g);break}if((c[d+16>>2]|0)!=(e|0)?(i=d+20|0,(c[i>>2]|0)!=(e|0)):0){c[d+32>>2]=f;f=d+44|0;if((c[f>>2]|0)==4)break;h=d+52|0;a[h>>0]=0;k=d+53|0;a[k>>0]=0;b=c[b+8>>2]|0;nc[c[(c[b>>2]|0)+20>>2]&31](b,d,e,e,1,g);if(a[k>>0]|0){if(!(a[h>>0]|0)){h=1;j=13}}else{h=0;j=13}do if((j|0)==13){c[i>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0){a[d+54>>0]=1;if(h)break}else j=16;if((j|0)==16?h:0)break;c[f>>2]=4;break a}while(0);c[f>>2]=3;break}if((f|0)==1)c[d+32>>2]=1}while(0);return}function ku(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;do if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)==(e|0)?(i=d+28|0,(c[i>>2]|0)!=1):0)c[i>>2]=f}else if((c[d>>2]|0)==(b|0)){if((c[d+16>>2]|0)!=(e|0)?(h=d+20|0,(c[h>>2]|0)!=(e|0)):0){c[d+32>>2]=f;c[h>>2]=e;h=d+40|0;c[h>>2]=(c[h>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0)a[d+54>>0]=1;c[d+44>>2]=4;break}if((f|0)==1)c[d+32>>2]=1}while(0);return}function lu(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if((b|0)==(c[d+8>>2]|0))fu(0,d,e,f,g);else{m=d+52|0;n=a[m>>0]|0;o=d+53|0;p=a[o>>0]|0;l=c[b+12>>2]|0;i=b+(l<<3)+16|0;a[m>>0]=0;a[o>>0]=0;hu(b+16|0,d,e,f,g,h);a:do if((l|0)>1){j=d+24|0;k=b+8|0;l=d+54|0;b=b+24|0;do{if(a[l>>0]|0)break a;if(!(a[m>>0]|0)){if((a[o>>0]|0)!=0?(c[k>>2]&1|0)==0:0)break a}else{if((c[j>>2]|0)==1)break a;if(!(c[k>>2]&2))break a}a[m>>0]=0;a[o>>0]=0;hu(b,d,e,f,g,h);b=b+8|0}while(b>>>0<i>>>0)}while(0);a[m>>0]=n;a[o>>0]=p}return}function mu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if((a|0)==(c[b+8>>2]|0))fu(0,b,d,e,f);else{a=c[a+8>>2]|0;nc[c[(c[a>>2]|0)+20>>2]&31](a,b,d,e,f,g)}return}function nu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if((c[b+8>>2]|0)==(a|0))fu(0,b,d,e,f);return}function ou(){var a=0;a=Oa(4)|0;zt(a);Qb(a|0,1086200,159)}function pu(){var a=0,b=0,d=0,e=0,f=0;e=i;i=i+16|0;f=e;e=e+12|0;a=tt()|0;if((a|0)!=0?(d=c[a>>2]|0,(d|0)!=0):0){a=d+48|0;b=c[a>>2]|0;a=c[a+4>>2]|0;if(!((b&-256|0)==1126902528&(a|0)==1129074247)){c[f>>2]=1085792;st(1085904,f)}if((b|0)==1126902529&(a|0)==1129074247)a=c[d+44>>2]|0;else a=d+80|0;c[e>>2]=a;b=c[d>>2]|0;a=c[b+4>>2]|0;if($b[c[(c[1086280>>2]|0)+16>>2]&31](1086280,b,e)|0){b=c[e>>2]|0;b=fc[c[(c[b>>2]|0)+8>>2]&127](b)|0;c[f>>2]=1085792;c[f+4>>2]=a;c[f+8>>2]=b;st(1085808,f)}else{c[f>>2]=1085792;c[f+4>>2]=a;st(1085856,f)}}st(1085944,f)}function qu(){var a=0;a=i;i=i+16|0;if(!(wb(1085960,186)|0)){i=a;return}else st(1086032,a)}function ru(a){a=a|0;var b=0,d=0;d=(c[a>>2]|0)+-4|0;b=c[d>>2]|0;c[d>>2]=b+-1;if((b+-1|0)<0)xt((c[a>>2]|0)+-12|0);return}function su(a){a=a|0;var b=0;b=i;i=i+16|0;uu(a);if(!(Eb(c[271490]|0,0)|0)){i=b;return}else st(1086088,b)}function tu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;do if(a>>>0<245){if(a>>>0<11)p=16;else p=a+11&-8;a=p>>>3;l=c[271746]|0;i=l>>>a;if(i&3){e=(i&1^1)+a|0;f=e<<1;b=1087024+(f<<2)|0;f=1087024+(f+2<<2)|0;g=c[f>>2]|0;h=g+8|0;i=c[h>>2]|0;do if((b|0)!=(i|0)){if(i>>>0<(c[271750]|0)>>>0)Nb();d=i+12|0;if((c[d>>2]|0)==(g|0)){c[d>>2]=b;c[f>>2]=i;break}else Nb()}else c[271746]=l&~(1<<e);while(0);w=e<<3;c[g+4>>2]=w|3;w=g+(w|4)|0;c[w>>2]=c[w>>2]|1;w=h;return w|0}k=c[271748]|0;if(p>>>0>k>>>0){if(i){f=2<<a;f=i<<a&(f|0-f);f=(f&0-f)+-1|0;a=f>>>12&16;f=f>>>a;e=f>>>5&8;f=f>>>e;d=f>>>2&4;f=f>>>d;g=f>>>1&2;f=f>>>g;h=f>>>1&1;h=(e|a|d|g|h)+(f>>>h)|0;f=h<<1;g=1087024+(f<<2)|0;f=1087024+(f+2<<2)|0;d=c[f>>2]|0;a=d+8|0;e=c[a>>2]|0;do if((g|0)!=(e|0)){if(e>>>0<(c[271750]|0)>>>0)Nb();i=e+12|0;if((c[i>>2]|0)==(d|0)){c[i>>2]=g;c[f>>2]=e;m=c[271748]|0;break}else Nb()}else{c[271746]=l&~(1<<h);m=k}while(0);w=h<<3;b=w-p|0;c[d+4>>2]=p|3;j=d+p|0;c[d+(p|4)>>2]=b|1;c[d+w>>2]=b;if(m){e=c[271751]|0;g=m>>>3;i=g<<1;f=1087024+(i<<2)|0;h=c[271746]|0;g=1<<g;if(h&g){h=1087024+(i+2<<2)|0;i=c[h>>2]|0;if(i>>>0<(c[271750]|0)>>>0)Nb();else{n=h;o=i}}else{c[271746]=h|g;n=1087024+(i+2<<2)|0;o=f}c[n>>2]=e;c[o+12>>2]=e;c[e+8>>2]=o;c[e+12>>2]=f}c[271748]=b;c[271751]=j;w=a;return w|0}a=c[271747]|0;if(a){h=(a&0-a)+-1|0;v=h>>>12&16;h=h>>>v;u=h>>>5&8;h=h>>>u;w=h>>>2&4;h=h>>>w;i=h>>>1&2;h=h>>>i;g=h>>>1&1;g=c[1087288+((u|v|w|i|g)+(h>>>g)<<2)>>2]|0;h=(c[g+4>>2]&-8)-p|0;i=g;while(1){d=c[i+16>>2]|0;if(!d){d=c[i+20>>2]|0;if(!d){l=h;k=g;break}}i=(c[d+4>>2]&-8)-p|0;w=i>>>0<h>>>0;h=w?i:h;i=d;g=w?d:g}a=c[271750]|0;if(k>>>0<a>>>0)Nb();b=k+p|0;if(k>>>0>=b>>>0)Nb();j=c[k+24>>2]|0;g=c[k+12>>2]|0;do if((g|0)==(k|0)){h=k+20|0;i=c[h>>2]|0;if(!i){h=k+16|0;i=c[h>>2]|0;if(!i){e=0;break}}while(1){g=i+20|0;f=c[g>>2]|0;if(f){i=f;h=g;continue}g=i+16|0;f=c[g>>2]|0;if(!f)break;else{i=f;h=g}}if(h>>>0<a>>>0)Nb();else{c[h>>2]=0;e=i;break}}else{f=c[k+8>>2]|0;if(f>>>0<a>>>0)Nb();i=f+12|0;if((c[i>>2]|0)!=(k|0))Nb();h=g+8|0;if((c[h>>2]|0)==(k|0)){c[i>>2]=g;c[h>>2]=f;e=g;break}else Nb()}while(0);do if(j){i=c[k+28>>2]|0;h=1087288+(i<<2)|0;if((k|0)==(c[h>>2]|0)){c[h>>2]=e;if(!e){c[271747]=c[271747]&~(1<<i);break}}else{if(j>>>0<(c[271750]|0)>>>0)Nb();i=j+16|0;if((c[i>>2]|0)==(k|0))c[i>>2]=e;else c[j+20>>2]=e;if(!e)break}h=c[271750]|0;if(e>>>0<h>>>0)Nb();c[e+24>>2]=j;i=c[k+16>>2]|0;do if(i)if(i>>>0<h>>>0)Nb();else{c[e+16>>2]=i;c[i+24>>2]=e;break}while(0);i=c[k+20>>2]|0;if(i)if(i>>>0<(c[271750]|0)>>>0)Nb();else{c[e+20>>2]=i;c[i+24>>2]=e;break}}while(0);if(l>>>0<16){w=l+p|0;c[k+4>>2]=w|3;w=k+(w+4)|0;c[w>>2]=c[w>>2]|1}else{c[k+4>>2]=p|3;c[k+(p|4)>>2]=l|1;c[k+(l+p)>>2]=l;d=c[271748]|0;if(d){e=c[271751]|0;g=d>>>3;i=g<<1;f=1087024+(i<<2)|0;h=c[271746]|0;g=1<<g;if(h&g){i=1087024+(i+2<<2)|0;h=c[i>>2]|0;if(h>>>0<(c[271750]|0)>>>0)Nb();else{q=i;r=h}}else{c[271746]=h|g;q=1087024+(i+2<<2)|0;r=f}c[q>>2]=e;c[r+12>>2]=e;c[e+8>>2]=r;c[e+12>>2]=f}c[271748]=l;c[271751]=b}w=k+8|0;return w|0}else r=p}else r=p}else if(a>>>0<=4294967231){a=a+11|0;r=a&-8;k=c[271747]|0;if(k){h=0-r|0;a=a>>>8;if(a)if(r>>>0>16777215)d=31;else{p=(a+1048320|0)>>>16&8;q=a<<p;o=(q+520192|0)>>>16&4;q=q<<o;d=(q+245760|0)>>>16&2;d=14-(o|p|d)+(q<<d>>>15)|0;d=r>>>(d+7|0)&1|d<<1}else d=0;f=c[1087288+(d<<2)>>2]|0;a:do if(!f){a=0;i=0}else{if((d|0)==31)i=0;else i=25-(d>>>1)|0;l=h;a=0;b=r<<i;i=0;while(1){e=c[f+4>>2]&-8;h=e-r|0;if(h>>>0<l>>>0)if((e|0)==(r|0)){a=f;i=f;break a}else i=f;else h=l;q=c[f+20>>2]|0;f=c[f+(b>>>31<<2)+16>>2]|0;a=(q|0)==0|(q|0)==(f|0)?a:q;if(!f)break;else{l=h;b=b<<1}}}while(0);if((a|0)==0&(i|0)==0){a=2<<d;a=k&(a|0-a);if(!a)break;q=(a&0-a)+-1|0;n=q>>>12&16;q=q>>>n;m=q>>>5&8;q=q>>>m;o=q>>>2&4;q=q>>>o;p=q>>>1&2;q=q>>>p;a=q>>>1&1;a=c[1087288+((m|n|o|p|a)+(q>>>a)<<2)>>2]|0}if(!a){o=h;p=i}else while(1){q=(c[a+4>>2]&-8)-r|0;f=q>>>0<h>>>0;h=f?q:h;i=f?a:i;f=c[a+16>>2]|0;if(f){a=f;continue}a=c[a+20>>2]|0;if(!a){o=h;p=i;break}}if((p|0)!=0?o>>>0<((c[271748]|0)-r|0)>>>0:0){a=c[271750]|0;if(p>>>0<a>>>0)Nb();m=p+r|0;if(p>>>0>=m>>>0)Nb();j=c[p+24>>2]|0;g=c[p+12>>2]|0;do if((g|0)==(p|0)){h=p+20|0;i=c[h>>2]|0;if(!i){h=p+16|0;i=c[h>>2]|0;if(!i){t=0;break}}while(1){g=i+20|0;f=c[g>>2]|0;if(f){i=f;h=g;continue}g=i+16|0;f=c[g>>2]|0;if(!f)break;else{i=f;h=g}}if(h>>>0<a>>>0)Nb();else{c[h>>2]=0;t=i;break}}else{f=c[p+8>>2]|0;if(f>>>0<a>>>0)Nb();i=f+12|0;if((c[i>>2]|0)!=(p|0))Nb();h=g+8|0;if((c[h>>2]|0)==(p|0)){c[i>>2]=g;c[h>>2]=f;t=g;break}else Nb()}while(0);do if(j){i=c[p+28>>2]|0;h=1087288+(i<<2)|0;if((p|0)==(c[h>>2]|0)){c[h>>2]=t;if(!t){c[271747]=c[271747]&~(1<<i);break}}else{if(j>>>0<(c[271750]|0)>>>0)Nb();i=j+16|0;if((c[i>>2]|0)==(p|0))c[i>>2]=t;else c[j+20>>2]=t;if(!t)break}h=c[271750]|0;if(t>>>0<h>>>0)Nb();c[t+24>>2]=j;i=c[p+16>>2]|0;do if(i)if(i>>>0<h>>>0)Nb();else{c[t+16>>2]=i;c[i+24>>2]=t;break}while(0);i=c[p+20>>2]|0;if(i)if(i>>>0<(c[271750]|0)>>>0)Nb();else{c[t+20>>2]=i;c[i+24>>2]=t;break}}while(0);b:do if(o>>>0>=16){c[p+4>>2]=r|3;c[p+(r|4)>>2]=o|1;c[p+(o+r)>>2]=o;i=o>>>3;if(o>>>0<256){h=i<<1;f=1087024+(h<<2)|0;g=c[271746]|0;i=1<<i;do if(!(g&i)){c[271746]=g|i;u=1087024+(h+2<<2)|0;v=f}else{i=1087024+(h+2<<2)|0;h=c[i>>2]|0;if(h>>>0>=(c[271750]|0)>>>0){u=i;v=h;break}Nb()}while(0);c[u>>2]=m;c[v+12>>2]=m;c[p+(r+8)>>2]=v;c[p+(r+12)>>2]=f;break}d=o>>>8;if(d)if(o>>>0>16777215)f=31;else{v=(d+1048320|0)>>>16&8;w=d<<v;u=(w+520192|0)>>>16&4;w=w<<u;f=(w+245760|0)>>>16&2;f=14-(u|v|f)+(w<<f>>>15)|0;f=o>>>(f+7|0)&1|f<<1}else f=0;i=1087288+(f<<2)|0;c[p+(r+28)>>2]=f;c[p+(r+20)>>2]=0;c[p+(r+16)>>2]=0;h=c[271747]|0;g=1<<f;if(!(h&g)){c[271747]=h|g;c[i>>2]=m;c[p+(r+24)>>2]=i;c[p+(r+12)>>2]=m;c[p+(r+8)>>2]=m;break}d=c[i>>2]|0;if((f|0)==31)b=0;else b=25-(f>>>1)|0;c:do if((c[d+4>>2]&-8|0)!=(o|0)){h=o<<b;while(1){b=d+(h>>>31<<2)+16|0;i=c[b>>2]|0;if(!i)break;if((c[i+4>>2]&-8|0)==(o|0)){B=i;break c}else{h=h<<1;d=i}}if(b>>>0<(c[271750]|0)>>>0)Nb();else{c[b>>2]=m;c[p+(r+24)>>2]=d;c[p+(r+12)>>2]=m;c[p+(r+8)>>2]=m;break b}}else B=d;while(0);d=B+8|0;b=c[d>>2]|0;w=c[271750]|0;if(B>>>0>=w>>>0&b>>>0>=w>>>0){c[b+12>>2]=m;c[d>>2]=m;c[p+(r+8)>>2]=b;c[p+(r+12)>>2]=B;c[p+(r+24)>>2]=0;break}else Nb()}else{w=o+r|0;c[p+4>>2]=w|3;w=p+(w+4)|0;c[w>>2]=c[w>>2]|1}while(0);w=p+8|0;return w|0}}}else r=-1;while(0);a=c[271748]|0;if(a>>>0>=r>>>0){b=a-r|0;d=c[271751]|0;if(b>>>0>15){c[271751]=d+r;c[271748]=b;c[d+(r+4)>>2]=b|1;c[d+a>>2]=b;c[d+4>>2]=r|3}else{c[271748]=0;c[271751]=0;c[d+4>>2]=a|3;w=d+(a+4)|0;c[w>>2]=c[w>>2]|1}w=d+8|0;return w|0}a=c[271749]|0;if(a>>>0>r>>>0){v=a-r|0;c[271749]=v;w=c[271752]|0;c[271752]=w+r;c[w+(r+4)>>2]=v|1;c[w+4>>2]=r|3;w=w+8|0;return w|0}do if(!(c[271864]|0)){a=Jb(30)|0;if(!(a+-1&a)){c[271866]=a;c[271865]=a;c[271867]=-1;c[271868]=-1;c[271869]=0;c[271857]=0;c[271864]=(Yb(0)|0)&-16^1431655768;break}else Nb()}while(0);l=r+48|0;b=c[271866]|0;k=r+47|0;d=b+k|0;b=0-b|0;m=d&b;if(m>>>0<=r>>>0){w=0;return w|0}a=c[271856]|0;if((a|0)!=0?(u=c[271854]|0,v=u+m|0,v>>>0<=u>>>0|v>>>0>a>>>0):0){w=0;return w|0}d:do if(!(c[271857]&4)){a=c[271752]|0;e:do if(a){f=1087432|0;while(1){i=c[f>>2]|0;if(i>>>0<=a>>>0?(s=f+4|0,(i+(c[s>>2]|0)|0)>>>0>a>>>0):0){e=f;h=s;a=f;break}f=c[f+8>>2]|0;if(!f){G=181;break e}}if(a){a=d-(c[271749]|0)&b;if(a>>>0<2147483647){i=Za(a|0)|0;if((i|0)==((c[e>>2]|0)+(c[h>>2]|0)|0))G=190;else G=191}else a=0}else G=181}else G=181;while(0);do if((G|0)==181){i=Za(0)|0;if((i|0)!=(-1|0)){a=i;h=c[271865]|0;f=h+-1|0;if(!(f&a))a=m;else a=m-a+(f+a&0-h)|0;h=c[271854]|0;f=h+a|0;if(a>>>0>r>>>0&a>>>0<2147483647){v=c[271856]|0;if((v|0)!=0?f>>>0<=h>>>0|f>>>0>v>>>0:0){a=0;break}h=Za(a|0)|0;if((h|0)==(i|0))G=190;else{i=h;G=191}}else a=0}else a=0}while(0);f:do if((G|0)==190){if((i|0)!=(-1|0)){x=i;G=201;break d}}else if((G|0)==191){h=0-a|0;do if((i|0)!=(-1|0)&a>>>0<2147483647&l>>>0>a>>>0?(w=c[271866]|0,w=k-a+w&0-w,w>>>0<2147483647):0)if((Za(w|0)|0)==(-1|0)){Za(h|0)|0;a=0;break f}else{a=w+a|0;break}while(0);if((i|0)==(-1|0))a=0;else{x=i;G=201;break d}}while(0);c[271857]=c[271857]|4;G=198}else{a=0;G=198}while(0);if((((G|0)==198?m>>>0<2147483647:0)?(x=Za(m|0)|0,y=Za(0)|0,(x|0)!=(-1|0)&(y|0)!=(-1|0)&x>>>0<y>>>0):0)?(z=y-x|0,A=z>>>0>(r+40|0)>>>0,A):0){a=A?z:a;G=201}if((G|0)==201){i=(c[271854]|0)+a|0;c[271854]=i;if(i>>>0>(c[271855]|0)>>>0)c[271855]=i;l=c[271752]|0;g:do if(l){e=1087432|0;do{i=c[e>>2]|0;h=e+4|0;f=c[h>>2]|0;if((x|0)==(i+f|0)){C=i;D=h;E=f;F=e;G=213;break}e=c[e+8>>2]|0}while((e|0)!=0);if(((G|0)==213?(c[F+12>>2]&8|0)==0:0)?l>>>0>=C>>>0&l>>>0<x>>>0:0){c[D>>2]=E+a;b=(c[271749]|0)+a|0;d=l+8|0;if(!(d&7))d=0;else d=0-d&7;w=b-d|0;c[271752]=l+d;c[271749]=w;c[l+(d+4)>>2]=w|1;c[l+(b+4)>>2]=40;c[271753]=c[271868];break}i=c[271750]|0;if(x>>>0<i>>>0){c[271750]=x;k=x}else k=i;i=x+a|0;h=1087432|0;do{if((c[h>>2]|0)==(i|0)){H=h;I=h;G=223;break}h=c[h+8>>2]|0}while((h|0)!=0);if((G|0)==223?(c[I+12>>2]&8|0)==0:0){c[H>>2]=x;i=I+4|0;c[i>>2]=(c[i>>2]|0)+a;i=x+8|0;if(!(i&7))p=0;else p=0-i&7;i=x+(a+8)|0;if(!(i&7))d=0;else d=0-i&7;i=x+(d+a)|0;o=p+r|0;n=x+o|0;m=i-(x+p)-r|0;c[x+(p+4)>>2]=r|3;h:do if((i|0)!=(l|0)){if((i|0)==(c[271751]|0)){w=(c[271748]|0)+m|0;c[271748]=w;c[271751]=n;c[x+(o+4)>>2]=w|1;c[x+(w+o)>>2]=w;break}l=a+4|0;j=c[x+(l+d)>>2]|0;if((j&3|0)==1){b=j&-8;f=j>>>3;i:do if(j>>>0>=256){e=c[x+((d|24)+a)>>2]|0;g=c[x+(a+12+d)>>2]|0;do if((g|0)==(i|0)){g=d|16;h=x+(l+g)|0;j=c[h>>2]|0;if(!j){h=x+(g+a)|0;j=c[h>>2]|0;if(!j){N=0;break}}while(1){g=j+20|0;f=c[g>>2]|0;if(f){j=f;h=g;continue}g=j+16|0;f=c[g>>2]|0;if(!f)break;else{j=f;h=g}}if(h>>>0<k>>>0)Nb();else{c[h>>2]=0;N=j;break}}else{f=c[x+((d|8)+a)>>2]|0;if(f>>>0<k>>>0)Nb();j=f+12|0;if((c[j>>2]|0)!=(i|0))Nb();h=g+8|0;if((c[h>>2]|0)==(i|0)){c[j>>2]=g;c[h>>2]=f;N=g;break}else Nb()}while(0);if(!e)break;j=c[x+(a+28+d)>>2]|0;h=1087288+(j<<2)|0;do if((i|0)!=(c[h>>2]|0)){if(e>>>0<(c[271750]|0)>>>0)Nb();j=e+16|0;if((c[j>>2]|0)==(i|0))c[j>>2]=N;else c[e+20>>2]=N;if(!N)break i}else{c[h>>2]=N;if(N)break;c[271747]=c[271747]&~(1<<j);break i}while(0);h=c[271750]|0;if(N>>>0<h>>>0)Nb();c[N+24>>2]=e;j=d|16;i=c[x+(j+a)>>2]|0;do if(i)if(i>>>0<h>>>0)Nb();else{c[N+16>>2]=i;c[i+24>>2]=N;break}while(0);i=c[x+(l+j)>>2]|0;if(!i)break;if(i>>>0<(c[271750]|0)>>>0)Nb();else{c[N+20>>2]=i;c[i+24>>2]=N;break}}else{h=c[x+((d|8)+a)>>2]|0;g=c[x+(a+12+d)>>2]|0;j=1087024+(f<<1<<2)|0;do if((h|0)!=(j|0)){if(h>>>0<k>>>0)Nb();if((c[h+12>>2]|0)==(i|0))break;Nb()}while(0);if((g|0)==(h|0)){c[271746]=c[271746]&~(1<<f);break}do if((g|0)==(j|0))J=g+8|0;else{if(g>>>0<k>>>0)Nb();j=g+8|0;if((c[j>>2]|0)==(i|0)){J=j;break}Nb()}while(0);c[h+12>>2]=g;c[J>>2]=h}while(0);i=x+((b|d)+a)|0;j=b+m|0}else j=m;i=i+4|0;c[i>>2]=c[i>>2]&-2;c[x+(o+4)>>2]=j|1;c[x+(j+o)>>2]=j;i=j>>>3;if(j>>>0<256){h=i<<1;f=1087024+(h<<2)|0;g=c[271746]|0;i=1<<i;do if(!(g&i)){c[271746]=g|i;O=1087024+(h+2<<2)|0;P=f}else{i=1087024+(h+2<<2)|0;h=c[i>>2]|0;if(h>>>0>=(c[271750]|0)>>>0){O=i;P=h;break}Nb()}while(0);c[O>>2]=n;c[P+12>>2]=n;c[x+(o+8)>>2]=P;c[x+(o+12)>>2]=f;break}d=j>>>8;do if(!d)f=0;else{if(j>>>0>16777215){f=31;break}v=(d+1048320|0)>>>16&8;w=d<<v;u=(w+520192|0)>>>16&4;w=w<<u;f=(w+245760|0)>>>16&2;f=14-(u|v|f)+(w<<f>>>15)|0;f=j>>>(f+7|0)&1|f<<1}while(0);i=1087288+(f<<2)|0;c[x+(o+28)>>2]=f;c[x+(o+20)>>2]=0;c[x+(o+16)>>2]=0;h=c[271747]|0;g=1<<f;if(!(h&g)){c[271747]=h|g;c[i>>2]=n;c[x+(o+24)>>2]=i;c[x+(o+12)>>2]=n;c[x+(o+8)>>2]=n;break}d=c[i>>2]|0;if((f|0)==31)i=0;else i=25-(f>>>1)|0;j:do if((c[d+4>>2]&-8|0)!=(j|0)){h=j<<i;while(1){b=d+(h>>>31<<2)+16|0;i=c[b>>2]|0;if(!i)break;if((c[i+4>>2]&-8|0)==(j|0)){Q=i;break j}else{h=h<<1;d=i}}if(b>>>0<(c[271750]|0)>>>0)Nb();else{c[b>>2]=n;c[x+(o+24)>>2]=d;c[x+(o+12)>>2]=n;c[x+(o+8)>>2]=n;break h}}else Q=d;while(0);d=Q+8|0;b=c[d>>2]|0;w=c[271750]|0;if(Q>>>0>=w>>>0&b>>>0>=w>>>0){c[b+12>>2]=n;c[d>>2]=n;c[x+(o+8)>>2]=b;c[x+(o+12)>>2]=Q;c[x+(o+24)>>2]=0;break}else Nb()}else{w=(c[271749]|0)+m|0;c[271749]=w;c[271752]=n;c[x+(o+4)>>2]=w|1}while(0);w=x+(p|8)|0;return w|0}h=1087432|0;while(1){i=c[h>>2]|0;if(i>>>0<=l>>>0?(g=c[h+4>>2]|0,j=i+g|0,j>>>0>l>>>0):0)break;h=c[h+8>>2]|0}h=i+(g+-39)|0;if(!(h&7))h=0;else h=0-h&7;g=i+(g+-47+h)|0;g=g>>>0<(l+16|0)>>>0?l:g;h=g+8|0;i=x+8|0;if(!(i&7))i=0;else i=0-i&7;w=a+-40-i|0;c[271752]=x+i;c[271749]=w;c[x+(i+4)>>2]=w|1;c[x+(a+-36)>>2]=40;c[271753]=c[271868];c[g+4>>2]=27;c[h+0>>2]=c[271858];c[h+4>>2]=c[271859];c[h+8>>2]=c[271860];c[h+12>>2]=c[271861];c[271858]=x;c[271859]=a;c[271861]=0;c[271860]=h;i=g+28|0;c[i>>2]=7;if((g+32|0)>>>0<j>>>0)do{w=i;i=i+4|0;c[i>>2]=7}while((w+8|0)>>>0<j>>>0);if((g|0)!=(l|0)){j=g-l|0;i=l+(j+4)|0;c[i>>2]=c[i>>2]&-2;c[l+4>>2]=j|1;c[l+j>>2]=j;i=j>>>3;if(j>>>0<256){h=i<<1;f=1087024+(h<<2)|0;g=c[271746]|0;i=1<<i;do if(!(g&i)){c[271746]=g|i;K=1087024+(h+2<<2)|0;L=f}else{d=1087024+(h+2<<2)|0;b=c[d>>2]|0;if(b>>>0>=(c[271750]|0)>>>0){K=d;L=b;break}Nb()}while(0);c[K>>2]=l;c[L+12>>2]=l;c[l+8>>2]=L;c[l+12>>2]=f;break}d=j>>>8;if(d)if(j>>>0>16777215)i=31;else{v=(d+1048320|0)>>>16&8;w=d<<v;u=(w+520192|0)>>>16&4;w=w<<u;i=(w+245760|0)>>>16&2;i=14-(u|v|i)+(w<<i>>>15)|0;i=j>>>(i+7|0)&1|i<<1}else i=0;d=1087288+(i<<2)|0;c[l+28>>2]=i;c[l+20>>2]=0;c[l+16>>2]=0;b=c[271747]|0;e=1<<i;if(!(b&e)){c[271747]=b|e;c[d>>2]=l;c[l+24>>2]=d;c[l+12>>2]=l;c[l+8>>2]=l;break}d=c[d>>2]|0;if((i|0)==31)b=0;else b=25-(i>>>1)|0;k:do if((c[d+4>>2]&-8|0)!=(j|0)){i=j<<b;while(1){b=d+(i>>>31<<2)+16|0;e=c[b>>2]|0;if(!e)break;if((c[e+4>>2]&-8|0)==(j|0)){M=e;break k}else{i=i<<1;d=e}}if(b>>>0<(c[271750]|0)>>>0)Nb();else{c[b>>2]=l;c[l+24>>2]=d;c[l+12>>2]=l;c[l+8>>2]=l;break g}}else M=d;while(0);d=M+8|0;b=c[d>>2]|0;w=c[271750]|0;if(M>>>0>=w>>>0&b>>>0>=w>>>0){c[b+12>>2]=l;c[d>>2]=l;c[l+8>>2]=b;c[l+12>>2]=M;c[l+24>>2]=0;break}else Nb()}}else{w=c[271750]|0;if((w|0)==0|x>>>0<w>>>0)c[271750]=x;c[271858]=x;c[271859]=a;c[271861]=0;c[271755]=c[271864];c[271754]=-1;d=0;do{w=d<<1;v=1087024+(w<<2)|0;c[1087024+(w+3<<2)>>2]=v;c[1087024+(w+2<<2)>>2]=v;d=d+1|0}while((d|0)!=32);d=x+8|0;if(!(d&7))d=0;else d=0-d&7;w=a+-40-d|0;c[271752]=x+d;c[271749]=w;c[x+(d+4)>>2]=w|1;c[x+(a+-36)>>2]=40;c[271753]=c[271868]}while(0);b=c[271749]|0;if(b>>>0>r>>>0){v=b-r|0;c[271749]=v;w=c[271752]|0;c[271752]=w+r;c[w+(r+4)>>2]=v|1;c[w+4>>2]=r|3;w=w+8|0;return w|0}}c[(Cb()|0)>>2]=12;w=0;return w|0}function uu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!a)return;g=a+-8|0;h=c[271750]|0;if(g>>>0<h>>>0)Nb();f=c[a+-4>>2]|0;e=f&3;if((e|0)==1)Nb();o=f&-8;q=a+(o+-8)|0;do if(!(f&1)){g=c[g>>2]|0;if(!e)return;i=-8-g|0;l=a+i|0;m=g+o|0;if(l>>>0<h>>>0)Nb();if((l|0)==(c[271751]|0)){g=a+(o+-4)|0;f=c[g>>2]|0;if((f&3|0)!=3){u=l;k=m;break}c[271748]=m;c[g>>2]=f&-2;c[a+(i+4)>>2]=m|1;c[q>>2]=m;return}d=g>>>3;if(g>>>0<256){e=c[a+(i+8)>>2]|0;f=c[a+(i+12)>>2]|0;g=1087024+(d<<1<<2)|0;if((e|0)!=(g|0)){if(e>>>0<h>>>0)Nb();if((c[e+12>>2]|0)!=(l|0))Nb()}if((f|0)==(e|0)){c[271746]=c[271746]&~(1<<d);u=l;k=m;break}if((f|0)!=(g|0)){if(f>>>0<h>>>0)Nb();g=f+8|0;if((c[g>>2]|0)==(l|0))b=g;else Nb()}else b=f+8|0;c[e+12>>2]=f;c[b>>2]=e;u=l;k=m;break}b=c[a+(i+24)>>2]|0;e=c[a+(i+12)>>2]|0;do if((e|0)==(l|0)){f=a+(i+20)|0;g=c[f>>2]|0;if(!g){f=a+(i+16)|0;g=c[f>>2]|0;if(!g){j=0;break}}while(1){e=g+20|0;d=c[e>>2]|0;if(d){g=d;f=e;continue}e=g+16|0;d=c[e>>2]|0;if(!d)break;else{g=d;f=e}}if(f>>>0<h>>>0)Nb();else{c[f>>2]=0;j=g;break}}else{d=c[a+(i+8)>>2]|0;if(d>>>0<h>>>0)Nb();g=d+12|0;if((c[g>>2]|0)!=(l|0))Nb();f=e+8|0;if((c[f>>2]|0)==(l|0)){c[g>>2]=e;c[f>>2]=d;j=e;break}else Nb()}while(0);if(b){g=c[a+(i+28)>>2]|0;f=1087288+(g<<2)|0;if((l|0)==(c[f>>2]|0)){c[f>>2]=j;if(!j){c[271747]=c[271747]&~(1<<g);u=l;k=m;break}}else{if(b>>>0<(c[271750]|0)>>>0)Nb();g=b+16|0;if((c[g>>2]|0)==(l|0))c[g>>2]=j;else c[b+20>>2]=j;if(!j){u=l;k=m;break}}f=c[271750]|0;if(j>>>0<f>>>0)Nb();c[j+24>>2]=b;g=c[a+(i+16)>>2]|0;do if(g)if(g>>>0<f>>>0)Nb();else{c[j+16>>2]=g;c[g+24>>2]=j;break}while(0);g=c[a+(i+20)>>2]|0;if(g)if(g>>>0<(c[271750]|0)>>>0)Nb();else{c[j+20>>2]=g;c[g+24>>2]=j;u=l;k=m;break}else{u=l;k=m}}else{u=l;k=m}}else{u=g;k=o}while(0);if(u>>>0>=q>>>0)Nb();g=a+(o+-4)|0;f=c[g>>2]|0;if(!(f&1))Nb();if(!(f&2)){if((q|0)==(c[271752]|0)){l=(c[271749]|0)+k|0;c[271749]=l;c[271752]=u;c[u+4>>2]=l|1;if((u|0)!=(c[271751]|0))return;c[271751]=0;c[271748]=0;return}if((q|0)==(c[271751]|0)){l=(c[271748]|0)+k|0;c[271748]=l;c[271751]=u;c[u+4>>2]=l|1;c[u+l>>2]=l;return}h=(f&-8)+k|0;b=f>>>3;do if(f>>>0>=256){b=c[a+(o+16)>>2]|0;g=c[a+(o|4)>>2]|0;do if((g|0)==(q|0)){f=a+(o+12)|0;g=c[f>>2]|0;if(!g){f=a+(o+8)|0;g=c[f>>2]|0;if(!g){p=0;break}}while(1){e=g+20|0;d=c[e>>2]|0;if(d){g=d;f=e;continue}e=g+16|0;d=c[e>>2]|0;if(!d)break;else{g=d;f=e}}if(f>>>0<(c[271750]|0)>>>0)Nb();else{c[f>>2]=0;p=g;break}}else{f=c[a+o>>2]|0;if(f>>>0<(c[271750]|0)>>>0)Nb();e=f+12|0;if((c[e>>2]|0)!=(q|0))Nb();d=g+8|0;if((c[d>>2]|0)==(q|0)){c[e>>2]=g;c[d>>2]=f;p=g;break}else Nb()}while(0);if(b){g=c[a+(o+20)>>2]|0;f=1087288+(g<<2)|0;if((q|0)==(c[f>>2]|0)){c[f>>2]=p;if(!p){c[271747]=c[271747]&~(1<<g);break}}else{if(b>>>0<(c[271750]|0)>>>0)Nb();g=b+16|0;if((c[g>>2]|0)==(q|0))c[g>>2]=p;else c[b+20>>2]=p;if(!p)break}g=c[271750]|0;if(p>>>0<g>>>0)Nb();c[p+24>>2]=b;f=c[a+(o+8)>>2]|0;do if(f)if(f>>>0<g>>>0)Nb();else{c[p+16>>2]=f;c[f+24>>2]=p;break}while(0);d=c[a+(o+12)>>2]|0;if(d)if(d>>>0<(c[271750]|0)>>>0)Nb();else{c[p+20>>2]=d;c[d+24>>2]=p;break}}}else{d=c[a+o>>2]|0;e=c[a+(o|4)>>2]|0;g=1087024+(b<<1<<2)|0;if((d|0)!=(g|0)){if(d>>>0<(c[271750]|0)>>>0)Nb();if((c[d+12>>2]|0)!=(q|0))Nb()}if((e|0)==(d|0)){c[271746]=c[271746]&~(1<<b);break}if((e|0)!=(g|0)){if(e>>>0<(c[271750]|0)>>>0)Nb();f=e+8|0;if((c[f>>2]|0)==(q|0))n=f;else Nb()}else n=e+8|0;c[d+12>>2]=e;c[n>>2]=d}while(0);c[u+4>>2]=h|1;c[u+h>>2]=h;if((u|0)==(c[271751]|0)){c[271748]=h;return}else g=h}else{c[g>>2]=f&-2;c[u+4>>2]=k|1;c[u+k>>2]=k;g=k}f=g>>>3;if(g>>>0<256){e=f<<1;g=1087024+(e<<2)|0;b=c[271746]|0;d=1<<f;if(b&d){d=1087024+(e+2<<2)|0;b=c[d>>2]|0;if(b>>>0<(c[271750]|0)>>>0)Nb();else{r=d;s=b}}else{c[271746]=b|d;r=1087024+(e+2<<2)|0;s=g}c[r>>2]=u;c[s+12>>2]=u;c[u+8>>2]=s;c[u+12>>2]=g;return}b=g>>>8;if(b)if(g>>>0>16777215)f=31;else{k=(b+1048320|0)>>>16&8;l=b<<k;j=(l+520192|0)>>>16&4;l=l<<j;f=(l+245760|0)>>>16&2;f=14-(j|k|f)+(l<<f>>>15)|0;f=g>>>(f+7|0)&1|f<<1}else f=0;d=1087288+(f<<2)|0;c[u+28>>2]=f;c[u+20>>2]=0;c[u+16>>2]=0;b=c[271747]|0;e=1<<f;a:do if(b&e){d=c[d>>2]|0;if((f|0)==31)b=0;else b=25-(f>>>1)|0;b:do if((c[d+4>>2]&-8|0)!=(g|0)){f=g<<b;while(1){b=d+(f>>>31<<2)+16|0;e=c[b>>2]|0;if(!e)break;if((c[e+4>>2]&-8|0)==(g|0)){t=e;break b}else{f=f<<1;d=e}}if(b>>>0<(c[271750]|0)>>>0)Nb();else{c[b>>2]=u;c[u+24>>2]=d;c[u+12>>2]=u;c[u+8>>2]=u;break a}}else t=d;while(0);b=t+8|0;d=c[b>>2]|0;l=c[271750]|0;if(t>>>0>=l>>>0&d>>>0>=l>>>0){c[d+12>>2]=u;c[b>>2]=u;c[u+8>>2]=d;c[u+12>>2]=t;c[u+24>>2]=0;break}else Nb()}else{c[271747]=b|e;c[d>>2]=u;c[u+24>>2]=d;c[u+12>>2]=u;c[u+8>>2]=u}while(0);l=(c[271754]|0)+-1|0;c[271754]=l;if(!l)b=1087440|0;else return;while(1){b=c[b>>2]|0;if(!b)break;else b=b+8|0}c[271754]=-1;return}function vu(a,b){a=a|0;b=b|0;var d=0;if(a){d=ba(b,a)|0;if((b|a)>>>0>65535)d=((d>>>0)/(a>>>0)|0|0)==(b|0)?d:-1}else d=0;b=tu(d)|0;if(!b)return b|0;if(!(c[b+-4>>2]&3))return b|0;kv(b|0,0,d|0)|0;return b|0}function wu(a,b){a=a|0;b=b|0;var d=0,e=0;if(!a){d=tu(b)|0;return d|0}if(b>>>0>4294967231){c[(Cb()|0)>>2]=12;d=0;return d|0}if(b>>>0<11)d=16;else d=b+11&-8;d=bv(a+-8|0,d)|0;if(d){d=d+8|0;return d|0}d=tu(b)|0;if(!d){d=0;return d|0}e=c[a+-4>>2]|0;e=(e&-8)-((e&3|0)==0?8:4)|0;mv(d|0,a|0,(e>>>0<b>>>0?e:b)|0)|0;uu(a);return d|0}function xu(a){a=a|0;return (a+-48|0)>>>0<10|0}function yu(a){a=a|0;if((a|0)==32)a=1;else a=(a+-9|0)>>>0<5;return a&1|0}function zu(a){a=a|0;return (a+-65|0)>>>0<26|0}function Au(a){a=a|0;if((a+-48|0)>>>0<10){a=1;a=a&1;return a|0}a=((a|32)+-97|0)>>>0<6;a=a&1;return a|0}function Bu(a){a=a|0;var b=0;b=(zu(a)|0)==0;return (b?a:a|32)|0}function Cu(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(e>>>0>36){c[(Cb()|0)>>2]=22;o=0;p=0;F=o;return p|0}s=b+4|0;r=b+100|0;do{i=c[s>>2]|0;if(i>>>0<(c[r>>2]|0)>>>0){c[s>>2]=i+1;i=d[i>>0]|0}else i=Fu(b)|0}while((yu(i)|0)!=0);do if((i|0)==43|(i|0)==45){k=((i|0)==45)<<31>>31;i=c[s>>2]|0;if(i>>>0<(c[r>>2]|0)>>>0){c[s>>2]=i+1;i=d[i>>0]|0;q=k;break}else{i=Fu(b)|0;q=k;break}}else q=0;while(0);l=(e|0)==0;do if((e&-17|0)==0&(i|0)==48){k=c[s>>2]|0;if(k>>>0<(c[r>>2]|0)>>>0){c[s>>2]=k+1;i=d[k>>0]|0}else i=Fu(b)|0;if((i|32|0)!=120)if(l){e=8;p=46;break}else{p=32;break}i=c[s>>2]|0;if(i>>>0<(c[r>>2]|0)>>>0){c[s>>2]=i+1;i=d[i>>0]|0}else i=Fu(b)|0;if((d[i+1087481>>0]|0)>15){e=(c[r>>2]|0)==0;if(!e)c[s>>2]=(c[s>>2]|0)+-1;if(!f){Eu(b,0);o=0;p=0;F=o;return p|0}if(e){o=0;p=0;F=o;return p|0}c[s>>2]=(c[s>>2]|0)+-1;o=0;p=0;F=o;return p|0}else{e=16;p=46}}else{e=l?10:e;if((d[i+1087481>>0]|0)>>>0<e>>>0)p=32;else{if(c[r>>2]|0)c[s>>2]=(c[s>>2]|0)+-1;Eu(b,0);c[(Cb()|0)>>2]=22;o=0;p=0;F=o;return p|0}}while(0);if((p|0)==32)if((e|0)==10){e=i+-48|0;if(e>>>0<10){i=0;while(1){k=(i*10|0)+e|0;i=c[s>>2]|0;if(i>>>0<(c[r>>2]|0)>>>0){c[s>>2]=i+1;i=d[i>>0]|0}else i=Fu(b)|0;e=i+-48|0;if(!(e>>>0<10&k>>>0<429496729)){e=k;break}else i=k}k=0}else{e=0;k=0}l=i+-48|0;if(l>>>0<10){while(1){j=uv(e|0,k|0,10,0)|0;m=F;n=((l|0)<0)<<31>>31;o=~n;if(m>>>0>o>>>0|(m|0)==(o|0)&j>>>0>~l>>>0){f=l;l=e;break}e=iv(j|0,m|0,l|0,n|0)|0;k=F;i=c[s>>2]|0;if(i>>>0<(c[r>>2]|0)>>>0){c[s>>2]=i+1;i=d[i>>0]|0}else i=Fu(b)|0;l=i+-48|0;if(!(l>>>0<10&(k>>>0<429496729|(k|0)==429496729&e>>>0<2576980378))){f=l;l=e;break}}if(f>>>0>9)i=l;else{e=10;p=72}}else i=e}else p=46;a:do if((p|0)==46){if(!(e+-1&e)){p=a[1087744+((e*23|0)>>>5&7)>>0]|0;k=a[i+1087481>>0]|0;j=k&255;if(j>>>0<e>>>0){k=0;while(1){l=j|k<<p;k=c[s>>2]|0;if(k>>>0<(c[r>>2]|0)>>>0){c[s>>2]=k+1;i=d[k>>0]|0}else i=Fu(b)|0;k=a[i+1087481>>0]|0;j=k&255;if(!(j>>>0<e>>>0&l>>>0<134217728))break;else k=l}j=0}else{j=0;l=0}f=jv(-1,-1,p|0)|0;n=F;if((k&255)>>>0>=e>>>0|(j>>>0>n>>>0|(j|0)==(n|0)&l>>>0>f>>>0)){k=j;p=72;break}while(1){l=ov(l|0,j|0,p|0)|0;j=F;l=k&255|l;k=c[s>>2]|0;if(k>>>0<(c[r>>2]|0)>>>0){c[s>>2]=k+1;i=d[k>>0]|0}else i=Fu(b)|0;k=a[i+1087481>>0]|0;if((k&255)>>>0>=e>>>0|(j>>>0>n>>>0|(j|0)==(n|0)&l>>>0>f>>>0)){k=j;p=72;break a}}}j=a[i+1087481>>0]|0;k=j&255;if(k>>>0<e>>>0){i=0;while(1){l=k+(ba(i,e)|0)|0;i=c[s>>2]|0;if(i>>>0<(c[r>>2]|0)>>>0){c[s>>2]=i+1;i=d[i>>0]|0}else i=Fu(b)|0;j=a[i+1087481>>0]|0;k=j&255;if(!(k>>>0<e>>>0&l>>>0<119304647))break;else i=l}k=0}else{l=0;k=0}if((j&255)>>>0<e>>>0){o=vv(-1,-1,e|0,0)|0;p=F;while(1){if(k>>>0>p>>>0|(k|0)==(p|0)&l>>>0>o>>>0){p=72;break a}m=uv(l|0,k|0,e|0,0)|0;f=F;n=j&255;if(f>>>0>4294967295|(f|0)==-1&m>>>0>~n>>>0){p=72;break a}l=iv(n|0,0,m|0,f|0)|0;k=F;j=c[s>>2]|0;if(j>>>0<(c[r>>2]|0)>>>0){c[s>>2]=j+1;i=d[j>>0]|0}else i=Fu(b)|0;j=a[i+1087481>>0]|0;if((j&255)>>>0>=e>>>0){p=72;break}}}else p=72}while(0);if((p|0)==72)if((d[i+1087481>>0]|0)>>>0<e>>>0){do{i=c[s>>2]|0;if(i>>>0<(c[r>>2]|0)>>>0){c[s>>2]=i+1;i=d[i>>0]|0}else i=Fu(b)|0}while((d[i+1087481>>0]|0)>>>0<e>>>0);c[(Cb()|0)>>2]=34;k=h;i=g}else i=l;if(c[r>>2]|0)c[s>>2]=(c[s>>2]|0)+-1;if(!(k>>>0<h>>>0|(k|0)==(h|0)&i>>>0<g>>>0)){if(!((g&1|0)!=0|0!=0|(q|0)!=0)){c[(Cb()|0)>>2]=34;p=iv(g|0,h|0,-1,-1)|0;o=F;F=o;return p|0}if(k>>>0>h>>>0|(k|0)==(h|0)&i>>>0>g>>>0){c[(Cb()|0)>>2]=34;o=h;p=g;F=o;return p|0}}p=((q|0)<0)<<31>>31;p=hv(i^q|0,k^p|0,q|0,p|0)|0;o=F;F=o;return p|0}function Du(b,e,f){b=b|0;e=e|0;f=f|0;var g=0.0,h=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0;K=i;i=i+512|0;H=K;if(!e){l=24;J=-149}else if((e|0)==2){l=53;J=-1074}else if((e|0)==1){l=53;J=-1074}else{g=0.0;i=K;return +g}D=b+4|0;C=b+100|0;do{k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;k=d[k>>0]|0}else k=Fu(b)|0}while((yu(k)|0)!=0);do if((k|0)==43|(k|0)==45){e=1-(((k|0)==45&1)<<1)|0;k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;k=d[k>>0]|0;I=e;break}else{k=Fu(b)|0;I=e;break}}else I=1;while(0);h=0;do{if((k|32|0)!=(a[1087760+h>>0]|0))break;do if(h>>>0<7){k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;k=d[k>>0]|0;break}else{k=Fu(b)|0;break}}while(0);h=h+1|0}while(h>>>0<8);do if((h|0)==3)z=23;else if((h|0)!=8){t=(f|0)!=0;if(h>>>0>3&t)if((h|0)==8)break;else{z=23;break}a:do if(!h){h=0;do{if((k|32|0)!=(a[1088344+h>>0]|0))break a;do if(h>>>0<2){k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;k=d[k>>0]|0;break}else{k=Fu(b)|0;break}}while(0);h=h+1|0}while(h>>>0<3)}while(0);if((h|0)==3){e=c[D>>2]|0;if(e>>>0<(c[C>>2]|0)>>>0){c[D>>2]=e+1;e=d[e>>0]|0}else e=Fu(b)|0;if((e|0)==40)h=1;else{if(!(c[C>>2]|0)){g=u;i=K;return +g}c[D>>2]=(c[D>>2]|0)+-1;g=u;i=K;return +g}while(1){e=c[D>>2]|0;if(e>>>0<(c[C>>2]|0)>>>0){c[D>>2]=e+1;e=d[e>>0]|0}else e=Fu(b)|0;if(!((e+-48|0)>>>0<10|(e+-65|0)>>>0<26)?!((e+-97|0)>>>0<26|(e|0)==95):0)break;h=h+1|0}if((e|0)==41){g=u;i=K;return +g}e=(c[C>>2]|0)==0;if(!e)c[D>>2]=(c[D>>2]|0)+-1;if(!t){c[(Cb()|0)>>2]=22;Eu(b,0);g=0.0;i=K;return +g}if((h|0)==0|e){g=u;i=K;return +g}do{h=h+-1|0;c[D>>2]=(c[D>>2]|0)+-1}while((h|0)!=0);g=u;i=K;return +g}else if(!h){do if((k|0)==48){k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;k=d[k>>0]|0}else k=Fu(b)|0;if((k|32|0)!=120){if(!(c[C>>2]|0)){k=48;break}c[D>>2]=(c[D>>2]|0)+-1;k=48;break}k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;q=d[k>>0]|0;m=0}else{q=Fu(b)|0;m=0}while(1){if((q|0)==46){z=70;break}else if((q|0)!=48){o=0;A=0;n=0;e=0;r=0;x=0;w=1.0;h=0;g=0.0;break}k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;q=d[k>>0]|0;m=1;continue}else{q=Fu(b)|0;m=1;continue}}if((z|0)==70){k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;q=d[k>>0]|0}else q=Fu(b)|0;if((q|0)==48){n=0;e=0;do{k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;q=d[k>>0]|0}else q=Fu(b)|0;n=iv(n|0,e|0,-1,-1)|0;e=F}while((q|0)==48);o=0;A=0;m=1;r=1;x=0;w=1.0;h=0;g=0.0}else{o=0;A=0;n=0;e=0;r=1;x=0;w=1.0;h=0;g=0.0}}b:while(1){k=q+-48|0;do if(k>>>0>=10){s=q|32;t=(q|0)==46;if(!((s+-97|0)>>>0<6|t)){k=A;break b}if(t)if(!r){n=A;e=o;s=A;r=1;p=w;break}else{k=A;q=46;break b}else{q=(q|0)>57?s+-87|0:k;z=83;break}}else{q=k;z=83}while(0);if((z|0)==83){z=0;do if(!((o|0)<0|(o|0)==0&A>>>0<8)){if((o|0)<0|(o|0)==0&A>>>0<14){j=w*.0625;t=x;p=j;g=g+j*+(q|0);break}if((q|0)==0|(x|0)!=0){t=x;p=w}else{t=1;p=w;g=g+w*.5}}else{t=x;p=w;h=q+(h<<4)|0}while(0);s=iv(A|0,o|0,1,0)|0;o=F;m=1;x=t}t=c[D>>2]|0;if(t>>>0<(c[C>>2]|0)>>>0){c[D>>2]=t+1;A=s;q=d[t>>0]|0;w=p;continue}else{A=s;q=Fu(b)|0;w=p;continue}}if(!m){e=(c[C>>2]|0)==0;if(!e)c[D>>2]=(c[D>>2]|0)+-1;if(f){if(!e?(B=c[D>>2]|0,c[D>>2]=B+-1,(r|0)!=0):0)c[D>>2]=B+-2}else Eu(b,0);g=+(I|0)*0.0;i=K;return +g}t=(r|0)==0;s=t?k:n;t=t?o:e;if((o|0)<0|(o|0)==0&k>>>0<8){n=k;do{h=h<<4;n=iv(n|0,o|0,1,0)|0;o=F}while((o|0)<0|(o|0)==0&n>>>0<8)}do if((q|32|0)==112){e=dv(b,f)|0;k=F;if((e|0)==0&(k|0)==-2147483648)if(!f){Eu(b,0);g=0.0;i=K;return +g}else{if(!(c[C>>2]|0)){e=0;k=0;break}c[D>>2]=(c[D>>2]|0)+-1;e=0;k=0;break}}else if(!(c[C>>2]|0)){e=0;k=0}else{c[D>>2]=(c[D>>2]|0)+-1;e=0;k=0}while(0);b=ov(s|0,t|0,2)|0;b=iv(b|0,F|0,-32,-1)|0;e=iv(b|0,F|0,e|0,k|0)|0;k=F;if(!h){g=+(I|0)*0.0;i=K;return +g}if((k|0)>0|(k|0)==0&e>>>0>(0-J|0)>>>0){c[(Cb()|0)>>2]=34;g=+(I|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;i=K;return +g}b=J+-106|0;D=((b|0)<0)<<31>>31;if((k|0)<(D|0)|(k|0)==(D|0)&e>>>0<b>>>0){c[(Cb()|0)>>2]=34;g=+(I|0)*2.2250738585072014e-308*2.2250738585072014e-308;i=K;return +g}if((h|0)>-1){do{h=h<<1;if(!(g>=.5))j=g;else{j=g+-1.0;h=h|1}g=g+j;e=iv(e|0,k|0,-1,-1)|0;k=F}while((h|0)>-1);r=e;p=g}else{r=e;p=g}e=hv(32,0,J|0,((J|0)<0)<<31>>31|0)|0;e=iv(r|0,k|0,e|0,F|0)|0;b=F;if(0>(b|0)|0==(b|0)&l>>>0>e>>>0)if((e|0)<0){e=0;z=126}else z=124;else{e=l;z=124}if((z|0)==124)if((e|0)<53)z=126;else{k=e;j=+(I|0);g=0.0}if((z|0)==126){g=+(I|0);k=e;j=g;g=+Hu(+Mu(1.0,84-e|0),g)}b=(k|0)<32&p!=0.0&(h&1|0)==0;g=j*(b?0.0:p)+(g+j*+(((b&1)+h|0)>>>0))-g;if(!(g!=0.0))c[(Cb()|0)>>2]=34;g=+Nu(g,r);i=K;return +g}while(0);E=J+l|0;G=0-E|0;q=0;while(1){if((k|0)==46){z=137;break}else if((k|0)!=48){e=0;m=0;h=0;break}k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;k=d[k>>0]|0;q=1;continue}else{k=Fu(b)|0;q=1;continue}}if((z|0)==137){k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;k=d[k>>0]|0}else k=Fu(b)|0;if((k|0)==48){e=0;k=0;while(1){e=iv(e|0,k|0,-1,-1)|0;q=F;k=c[D>>2]|0;if(k>>>0<(c[C>>2]|0)>>>0){c[D>>2]=k+1;k=d[k>>0]|0}else k=Fu(b)|0;if((k|0)==48)k=q;else{m=q;q=1;h=1;break}}}else{e=0;m=0;h=1}}c[H>>2]=0;o=k+-48|0;r=(k|0)==46;c:do if(o>>>0<10|r){B=H+496|0;y=0;n=0;z=h;s=0;t=0;A=0;d:while(1){do if(r)if(!z){e=y;m=n;h=1;x=A}else{h=m;o=y;r=A;break d}else{r=iv(y|0,n|0,1,0)|0;n=F;x=(k|0)!=48;if((t|0)>=125){if(!x){y=r;h=z;x=A;break}c[B>>2]=c[B>>2]|1;y=r;h=z;x=A;break}h=H+(t<<2)|0;if(s)o=k+-48+((c[h>>2]|0)*10|0)|0;c[h>>2]=o;s=s+1|0;k=(s|0)==9;y=r;q=1;h=z;s=k?0:s;t=(k&1)+t|0;x=x?r:A}while(0);r=c[D>>2]|0;if(r>>>0<(c[C>>2]|0)>>>0){c[D>>2]=r+1;k=d[r>>0]|0}else k=Fu(b)|0;o=k+-48|0;r=(k|0)==46;if(!(o>>>0<10|r)){r=x;z=160;break c}else{z=h;A=x}}m=(q|0)!=0;z=168}else{y=0;n=0;s=0;t=0;r=0;z=160}while(0);do if((z|0)==160){h=(h|0)==0;e=h?y:e;h=h?n:m;m=(q|0)!=0;if(!(m&(k|32|0)==101))if((k|0)>-1){o=y;z=168;break}else{o=y;z=170;break}o=dv(b,f)|0;q=F;do if((o|0)==0&(q|0)==-2147483648)if(!f){Eu(b,0);g=0.0;i=K;return +g}else{if(!(c[C>>2]|0)){o=0;q=0;break}c[D>>2]=(c[D>>2]|0)+-1;o=0;q=0;break}while(0);m=iv(o|0,q|0,e|0,h|0)|0;o=y;k=F;h=n;e=s}while(0);if((z|0)==168)if(c[C>>2]|0){c[D>>2]=(c[D>>2]|0)+-1;if(m){m=e;k=h;h=n;e=s}else z=171}else z=170;if((z|0)==170)if(m){m=e;k=h;h=n;e=s}else z=171;if((z|0)==171){c[(Cb()|0)>>2]=22;Eu(b,0);g=0.0;i=K;return +g}n=c[H>>2]|0;if(!n){g=+(I|0)*0.0;i=K;return +g}if((m|0)==(o|0)&(k|0)==(h|0)&((h|0)<0|(h|0)==0&o>>>0<10)?l>>>0>30|(n>>>l|0)==0:0){g=+(I|0)*+(n>>>0);i=K;return +g}b=(J|0)/-2|0;D=((b|0)<0)<<31>>31;if((k|0)>(D|0)|(k|0)==(D|0)&m>>>0>b>>>0){c[(Cb()|0)>>2]=34;g=+(I|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;i=K;return +g}b=J+-106|0;D=((b|0)<0)<<31>>31;if((k|0)<(D|0)|(k|0)==(D|0)&m>>>0<b>>>0){c[(Cb()|0)>>2]=34;g=+(I|0)*2.2250738585072014e-308*2.2250738585072014e-308;i=K;return +g}if(e){if((e|0)<9){o=H+(t<<2)|0;k=c[o>>2]|0;do{k=k*10|0;e=e+1|0}while((e|0)!=9);c[o>>2]=k}t=t+1|0}if((r|0)<9?(r|0)<=(m|0)&(m|0)<18:0){if((m|0)==9){g=+(I|0)*+((c[H>>2]|0)>>>0);i=K;return +g}if((m|0)<9){g=+(I|0)*+((c[H>>2]|0)>>>0)/+(c[1087784+(8-m<<2)>>2]|0);i=K;return +g}b=l+27+(ba(m,-3)|0)|0;k=c[H>>2]|0;if((b|0)>30|(k>>>b|0)==0){g=+(I|0)*+(k>>>0)*+(c[1087784+(m+-10<<2)>>2]|0);i=K;return +g}}k=(m|0)%9|0;if(!k){e=0;h=0;k=t}else{s=(m|0)>-1?k:k+9|0;q=c[1087784+(8-s<<2)>>2]|0;if(t){o=1e9/(q|0)|0;e=0;h=0;n=0;k=m;do{C=H+(n<<2)|0;D=c[C>>2]|0;b=((D>>>0)/(q>>>0)|0)+h|0;c[C>>2]=b;h=ba((D>>>0)%(q>>>0)|0,o)|0;D=n;n=n+1|0;if((D|0)==(e|0)&(b|0)==0){e=n&127;k=k+-9|0}}while((n|0)!=(t|0));if(!h){m=k;k=t}else{c[H+(t<<2)>>2]=h;m=k;k=t+1|0}}else{e=0;k=0}h=0;m=9-s+m|0}e:while(1){t=H+(e<<2)|0;if((m|0)<18)do{o=0;n=k+127|0;while(1){r=n&127;q=H+(r<<2)|0;n=ov(c[q>>2]|0,0,29)|0;n=iv(n|0,F|0,o|0,0)|0;o=F;if(o>>>0>0|(o|0)==0&n>>>0>1e9){b=vv(n|0,o|0,1e9,0)|0;n=wv(n|0,o|0,1e9,0)|0;o=b}else o=0;c[q>>2]=n;q=(r|0)==(e|0);if(!((r|0)!=(k+127&127|0)|q))k=(n|0)==0?r:k;if(q)break;else n=r+-1|0}h=h+-29|0}while((o|0)==0);else{if((m|0)!=18)break;do{if((c[t>>2]|0)>>>0>=9007199){m=18;break e}o=0;q=k+127|0;while(1){r=q&127;n=H+(r<<2)|0;q=ov(c[n>>2]|0,0,29)|0;q=iv(q|0,F|0,o|0,0)|0;o=F;if(o>>>0>0|(o|0)==0&q>>>0>1e9){b=vv(q|0,o|0,1e9,0)|0;q=wv(q|0,o|0,1e9,0)|0;o=b}else o=0;c[n>>2]=q;n=(r|0)==(e|0);if(!((r|0)!=(k+127&127|0)|n))k=(q|0)==0?r:k;if(n)break;else q=r+-1|0}h=h+-29|0}while((o|0)==0)}e=e+127&127;if((e|0)==(k|0)){b=k+127&127;k=H+((k+126&127)<<2)|0;c[k>>2]=c[k>>2]|c[H+(b<<2)>>2];k=b}c[H+(e<<2)>>2]=o;m=m+9|0}f:while(1){A=k+1&127;z=H+((k+127&127)<<2)|0;while(1){t=(m|0)==18;x=(m|0)>27?9:1;while(1){r=0;while(1){q=r+e&127;if((q|0)==(k|0)){q=2;break}o=c[H+(q<<2)>>2]|0;n=c[1087776+(r<<2)>>2]|0;if(o>>>0<n>>>0){q=2;break}q=r+1|0;if(o>>>0>n>>>0){q=r;break}if((q|0)<2)r=q;else break}if((q|0)==2&t){n=A;x=e;break f}h=x+h|0;if((e|0)==(k|0))e=k;else break}o=(1<<x)+-1|0;s=1e9>>>x;r=e;n=0;q=e;while(1){D=H+(q<<2)|0;b=c[D>>2]|0;e=(b>>>x)+n|0;c[D>>2]=e;n=ba(b&o,s)|0;e=(q|0)==(r|0)&(e|0)==0;q=q+1&127;m=e?m+-9|0:m;e=e?q:r;if((q|0)==(k|0))break;else r=e}if(!n)continue;if((A|0)!=(e|0))break;c[z>>2]=c[z>>2]|1}c[H+(k<<2)>>2]=n;k=A}e=x&127;if((e|0)==(k|0)){c[H+(n+-1<<2)>>2]=0;k=n}j=+((c[H+(e<<2)>>2]|0)>>>0);e=x+1&127;if((e|0)==(k|0)){k=k+1&127;c[H+(k+-1<<2)>>2]=0}w=+(I|0);p=w*(j*1.0e9+ +((c[H+(e<<2)>>2]|0)>>>0));s=h+53|0;t=s-J|0;if((t|0)<(l|0))if((t|0)<0){l=0;e=1;z=244}else{l=t;e=1;z=243}else{e=0;z=243}if((z|0)==243)if((l|0)<53)z=244;else{g=0.0;j=0.0}if((z|0)==244){M=+Hu(+Mu(1.0,105-l|0),p);L=+Ju(p,+Mu(1.0,53-l|0));g=M;j=L;p=M+(p-L)}q=x+2&127;do if((q|0)!=(k|0)){o=c[H+(q<<2)>>2]|0;do if(o>>>0>=5e8){if(o>>>0>5e8){j=w*.75+j;break}if((x+3&127|0)==(k|0)){j=w*.5+j;break}else{j=w*.75+j;break}}else{if((o|0)==0?(x+3&127|0)==(k|0):0)break;j=w*.25+j}while(0);if((53-l|0)<=1)break;if(+Ju(j,1.0)!=0.0)break;j=j+1.0}while(0);g=p+j-g;do if((s&2147483647|0)>(-2-E|0)){if(+Q(+g)>=9007199254740992.0){e=(e|0)!=0&(l|0)==(t|0)?0:e;h=h+1|0;g=g*.5}if((h+50|0)<=(G|0)?!((e|0)!=0&j!=0.0):0)break;c[(Cb()|0)>>2]=34}while(0);g=+Nu(g,h);i=K;return +g}else{if(c[C>>2]|0)c[D>>2]=(c[D>>2]|0)+-1;c[(Cb()|0)>>2]=22;Eu(b,0);g=0.0;i=K;return +g}}while(0);if((z|0)==23){e=(c[C>>2]|0)==0;if(!e)c[D>>2]=(c[D>>2]|0)+-1;if(!(h>>>0<4|(f|0)==0|e))do{c[D>>2]=(c[D>>2]|0)+-1;h=h+-1|0}while(h>>>0>3)}g=+(I|0)*v;i=K;return +g}function Eu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a+104>>2]=b;d=c[a+8>>2]|0;e=c[a+4>>2]|0;f=d-e|0;c[a+108>>2]=f;if(!((b|0)!=0&(f|0)>(b|0))){e=d;d=a+100|0;c[d>>2]=e;return}e=e+b|0;d=a+100|0;c[d>>2]=e;return}function Fu(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=b+104|0;j=c[e>>2]|0;if(!((j|0)!=0?(c[b+108>>2]|0)>=(j|0):0))f=3;if((f|0)==3?(i=Su(b)|0,(i|0)>=0):0){e=c[e>>2]|0;f=c[b+8>>2]|0;if((e|0)!=0?(g=c[b+4>>2]|0,h=e-(c[b+108>>2]|0)+-1|0,(f-g|0)>(h|0)):0)c[b+100>>2]=g+h;else c[b+100>>2]=f;e=c[b+4>>2]|0;if(f){g=b+108|0;c[g>>2]=f+1-e+(c[g>>2]|0)}e=e+-1|0;if((d[e>>0]|0|0)==(i|0)){e=i;return e|0}a[e>>0]=i;e=i;return e|0}c[b+100>>2]=0;e=-1;return e|0}function Gu(a,b){a=+a;b=+b;var d=0,e=0;h[k>>3]=a;e=c[k>>2]|0;d=c[k+4>>2]|0;h[k>>3]=b;d=c[k+4>>2]&-2147483648|d&2147483647;c[k>>2]=e;c[k+4>>2]=d;return +(+h[k>>3])}function Hu(a,b){a=+a;b=+b;return +(+Gu(a,b))}function Iu(a,b){a=+a;b=+b;var d=0,e=0,f=0,g=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;h[k>>3]=a;l=c[k>>2]|0;m=c[k+4>>2]|0;h[k>>3]=b;n=c[k>>2]|0;o=c[k+4>>2]|0;d=jv(l|0,m|0,52)|0;d=d&2047;g=jv(n|0,o|0,52)|0;g=g&2047;p=m&-2147483648;e=ov(n|0,o|0,1)|0;j=F;if(!((e|0)==0&(j|0)==0)?(i=o&2147483647,!(i>>>0>2146435072|(i|0)==2146435072&n>>>0>0|(d|0)==2047)):0){i=ov(l|0,m|0,1)|0;f=F;if(!(f>>>0>j>>>0|(f|0)==(j|0)&i>>>0>e>>>0)){if(!((i|0)==(e|0)&(f|0)==(j|0))){b=a;return +b}b=a*0.0;return +b}if(!d){f=ov(l|0,m|0,12)|0;e=F;if((e|0)>-1|(e|0)==-1&f>>>0>4294967295){d=0;do{d=d+-1|0;f=ov(f|0,e|0,1)|0;e=F}while((e|0)>-1|(e|0)==-1&f>>>0>4294967295)}else d=0;l=ov(l|0,m|0,1-d|0)|0;j=F}else j=m&1048575|1048576;if(!g){f=ov(n|0,o|0,12)|0;e=F;if((e|0)>-1|(e|0)==-1&f>>>0>4294967295){g=0;do{g=g+-1|0;f=ov(f|0,e|0,1)|0;e=F}while((e|0)>-1|(e|0)==-1&f>>>0>4294967295)}else g=0;n=ov(n|0,o|0,1-g|0)|0;o=F}else o=o&1048575|1048576;e=hv(l|0,j|0,n|0,o|0)|0;f=F;i=(f|0)>-1|(f|0)==-1&e>>>0>4294967295;a:do if((d|0)>(g|0)){while(1){if(i){if((l|0)==(n|0)&(j|0)==(o|0))break}else{e=l;f=j}l=ov(e|0,f|0,1)|0;j=F;d=d+-1|0;e=hv(l|0,j|0,n|0,o|0)|0;f=F;i=(f|0)>-1|(f|0)==-1&e>>>0>4294967295;if((d|0)<=(g|0))break a}b=a*0.0;return +b}while(0);if(i){if((l|0)==(n|0)&(j|0)==(o|0)){b=a*0.0;return +b}}else{f=j;e=l}if(f>>>0<1048576|(f|0)==1048576&e>>>0<0)do{e=ov(e|0,f|0,1)|0;f=F;d=d+-1|0}while(f>>>0<1048576|(f|0)==1048576&e>>>0<0);if((d|0)>0){o=iv(e|0,f|0,0,-1048576)|0;n=F;e=ov(d|0,0,52)|0;d=n|F;e=o|e}else{e=jv(e|0,f|0,1-d|0)|0;d=F}c[k>>2]=e;c[k+4>>2]=d|p;b=+h[k>>3];return +b}b=a*b;b=b/b;return +b}function Ju(a,b){a=+a;b=+b;return +(+Iu(a,b))}function Ku(a,b){a=+a;b=b|0;var d=0,e=0,f=0;h[k>>3]=a;d=c[k>>2]|0;e=c[k+4>>2]|0;f=jv(d|0,e|0,52)|0;f=f&2047;if(!f){if(a!=0.0){a=+Ku(a*18446744073709551616.0,b);d=(c[b>>2]|0)+-64|0}else d=0;c[b>>2]=d;return +a}else if((f|0)==2047)return +a;else{c[b>>2]=f+-1022;c[k>>2]=d;c[k+4>>2]=e&-2146435073|1071644672;a=+h[k>>3];return +a}return 0.0}function Lu(a,b){a=+a;b=b|0;return +(+Ku(a,b))}function Mu(a,b){a=+a;b=b|0;var d=0;if((b|0)>1023){a=a*8988465674311579538646525.0e283;d=b+-1023|0;if((d|0)>1023){d=b+-2046|0;d=(d|0)>1023?1023:d;a=a*8988465674311579538646525.0e283}}else if((b|0)<-1022){a=a*2.2250738585072014e-308;d=b+1022|0;if((d|0)<-1022){d=b+2044|0;d=(d|0)<-1022?-1022:d;a=a*2.2250738585072014e-308}}else d=b;b=ov(d+1023|0,0,52)|0;d=F;c[k>>2]=b;c[k+4>>2]=d;return +(a*+h[k>>3])}function Nu(a,b){a=+a;b=b|0;return +(+Mu(a,b))}function Ou(a,b){a=a|0;b=b|0;if(!a)a=0;else a=Pu(a,b,0)|0;return a|0}function Pu(b,d,e){b=b|0;d=d|0;e=e|0;if(!b){b=1;return b|0}if(d>>>0<128){a[b>>0]=d;b=1;return b|0}if(d>>>0<2048){a[b>>0]=d>>>6|192;a[b+1>>0]=d&63|128;b=2;return b|0}if(d>>>0<55296|(d&-8192|0)==57344){a[b>>0]=d>>>12|224;a[b+1>>0]=d>>>6&63|128;a[b+2>>0]=d&63|128;b=3;return b|0}if((d+-65536|0)>>>0<1048576){a[b>>0]=d>>>18|240;a[b+1>>0]=d>>>12&63|128;a[b+2>>0]=d>>>6&63|128;a[b+3>>0]=d&63|128;b=4;return b|0}else{c[(Cb()|0)>>2]=84;b=-1;return b|0}return 0}function Qu(b){b=b|0;var d=0,e=0;d=b+74|0;e=a[d>>0]|0;a[d>>0]=e+255|e;d=b+20|0;e=b+44|0;if((c[d>>2]|0)>>>0>(c[e>>2]|0)>>>0)$b[c[b+36>>2]&31](b,0,0)|0;c[b+16>>2]=0;c[b+28>>2]=0;c[d>>2]=0;d=c[b>>2]|0;if(!(d&20)){d=c[e>>2]|0;c[b+8>>2]=d;c[b+4>>2]=d;d=0;return d|0}if(!(d&4)){d=-1;return d|0}c[b>>2]=d|32;d=-1;return d|0}function Ru(b){b=b|0;var d=0,e=0;d=b+74|0;e=a[d>>0]|0;a[d>>0]=e+255|e;d=c[b>>2]|0;if(!(d&8)){c[b+8>>2]=0;c[b+4>>2]=0;d=c[b+44>>2]|0;c[b+28>>2]=d;c[b+20>>2]=d;c[b+16>>2]=d+(c[b+48>>2]|0);d=0;return d|0}else{c[b>>2]=d|32;d=-1;return d|0}return 0}function Su(a){a=a|0;var b=0,e=0;e=i;i=i+16|0;b=e;if((c[a+8>>2]|0)==0?(Qu(a)|0)!=0:0)b=-1;else if(($b[c[a+32>>2]&31](a,b,1)|0)==1)b=d[b>>0]|0;else b=-1;i=e;return b|0}function Tu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=e+16|0;g=c[f>>2]|0;do if(!g)if(!(Ru(e)|0)){g=c[f>>2]|0;break}else{f=0;return f|0}while(0);i=e+20|0;f=c[i>>2]|0;if((g-f|0)>>>0<d>>>0){f=$b[c[e+36>>2]&31](e,b,d)|0;return f|0}a:do if((a[e+75>>0]|0)>-1){g=d;while(1){if(!g){h=d;g=0;break a}h=g+-1|0;if((a[b+h>>0]|0)==10)break;else g=h}if(($b[c[e+36>>2]&31](e,b,g)|0)>>>0<g>>>0){f=g;return f|0}else{h=d-g|0;b=b+g|0;f=c[i>>2]|0;break}}else{h=d;g=0}while(0);mv(f|0,b|0,h|0)|0;c[i>>2]=(c[i>>2]|0)+h;f=g+h|0;return f|0}function Uu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;d=Wu(a,b,d,g)|0;i=f;return d|0}function Vu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=i;i=i+224|0;l=p+120|0;o=p+80|0;n=p;m=p+136|0;e=o+0|0;f=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[l>>2]=c[d>>2];if((ev(0,b,l,n,o)|0)<0){m=-1;i=p;return m|0}e=a+48|0;if(!(c[e>>2]|0)){g=a+44|0;h=c[g>>2]|0;c[g>>2]=m;j=a+28|0;c[j>>2]=m;k=a+20|0;c[k>>2]=m;c[e>>2]=80;f=a+16|0;c[f>>2]=m+80;d=ev(a,b,l,n,o)|0;if(h){$b[c[a+36>>2]&31](a,0,0)|0;d=(c[k>>2]|0)==0?-1:d;c[g>>2]=h;c[e>>2]=0;c[f>>2]=0;c[j>>2]=0;c[k>>2]=0}}else d=ev(a,b,l,n,o)|0;m=d;i=p;return m|0}function Wu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;m=i;i=i+128|0;g=m+112|0;l=m;h=l+0|0;j=1088384|0;k=h+112|0;do{c[h>>2]=c[j>>2];h=h+4|0;j=j+4|0}while((h|0)<(k|0));if((d+-1|0)>>>0>2147483646)if(!d)d=1;else{c[(Cb()|0)>>2]=75;d=-1;i=m;return d|0}else g=b;h=-2-g|0;h=d>>>0>h>>>0?h:d;c[l+48>>2]=h;b=l+20|0;c[b>>2]=g;c[l+44>>2]=g;d=g+h|0;g=l+16|0;c[g>>2]=d;c[l+28>>2]=d;d=Vu(l,e,f)|0;if(!h){i=m;return d|0}b=c[b>>2]|0;a[b+(((b|0)==(c[g>>2]|0))<<31>>31)>>0]=0;i=m;return d|0}function Xu(b){b=b|0;var c=0,d=0,e=0,f=0;while(1){c=b+1|0;if(!(yu(a[b>>0]|0)|0))break;else b=c}e=a[b>>0]|0;d=e<<24>>24;if((d|0)==45){e=1;f=5}else if((d|0)==43){e=0;f=5}else{d=e;e=0}if((f|0)==5){b=c;d=a[c>>0]|0}if(!(xu(d<<24>>24)|0)){c=0;d=(e|0)!=0;b=0-c|0;b=d?c:b;return b|0}else{c=b;b=0}do{b=(b*10|0)+48-(a[c>>0]|0)|0;c=c+1|0}while((xu(a[c>>0]|0)|0)!=0);d=(e|0)!=0;c=0-b|0;b=d?b:c;return b|0}function Yu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,g=0,h=0;h=i;i=i+112|0;g=h;d=g+0|0;e=d+112|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));e=g+4|0;c[e>>2]=a;d=g+8|0;c[d>>2]=-1;c[g+44>>2]=a;c[g+76>>2]=-1;Eu(g,0);f=+Du(g,2,1);d=(c[e>>2]|0)-(c[d>>2]|0)+(c[g+108>>2]|0)|0;if(!b){i=h;return +f}if(!d)d=a;else d=a+d|0;c[b>>2]=d;i=h;return +f}function Zu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=i;i=i+112|0;h=j;c[h>>2]=0;f=h+4|0;c[f>>2]=a;c[h+44>>2]=a;g=h+8|0;c[g>>2]=(a|0)<0?-1:a+2147483647|0;c[h+76>>2]=-1;Eu(h,0);d=Cu(h,d,1,-1,-1)|0;e=F;if(!b){F=e;i=j;return d|0}c[b>>2]=a+((c[f>>2]|0)+(c[h+108>>2]|0)-(c[g>>2]|0));F=e;i=j;return d|0}function _u(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=i;i=i+112|0;h=j;c[h>>2]=0;f=h+4|0;c[f>>2]=a;c[h+44>>2]=a;g=h+8|0;c[g>>2]=(a|0)<0?-1:a+2147483647|0;c[h+76>>2]=-1;Eu(h,0);d=Cu(h,d,1,0,-2147483648)|0;e=F;if(!b){F=e;i=j;return d|0}c[b>>2]=a+((c[f>>2]|0)+(c[h+108>>2]|0)-(c[g>>2]|0));F=e;i=j;return d|0}function $u(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=d&255;f=(e|0)!=0;a:do if((b&3|0)!=0&f){g=d&255;while(1){if((a[b>>0]|0)==g<<24>>24){g=6;break a}b=b+1|0;e=e+-1|0;f=(e|0)!=0;if(!((b&3|0)!=0&f)){g=5;break}}}else g=5;while(0);if((g|0)==5)if(f)g=6;else e=0;b:do if((g|0)==6){g=d&255;if((a[b>>0]|0)!=g<<24>>24){f=ba(h,16843009)|0;c:do if(e>>>0>3)do{d=c[b>>2]^f;if((d&-2139062144^-2139062144)&d+-16843009)break c;b=b+4|0;e=e+-4|0}while(e>>>0>3);while(0);if(!e)e=0;else while(1){if((a[b>>0]|0)==g<<24>>24)break b;b=b+1|0;e=e+-1|0;if(!e){e=0;break}}}}while(0);return ((e|0)!=0?b:0)|0}function av(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;if(!d){b=0;return b|0}else{f=d;e=b}while(1){d=a[e>>0]|0;b=a[c>>0]|0;if(d<<24>>24!=b<<24>>24)break;f=f+-1|0;if(!f){b=0;g=5;break}else{e=e+1|0;c=c+1|0}}if((g|0)==5)return b|0;b=(d&255)-(b&255)|0;return b|0}function bv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;o=a+4|0;p=c[o>>2]|0;j=p&-8;l=a+j|0;i=c[271750]|0;e=p&3;if(!((e|0)!=1&a>>>0>=i>>>0&a>>>0<l>>>0))Nb();d=a+(j|4)|0;g=c[d>>2]|0;if(!(g&1))Nb();if(!e){if(b>>>0<256){m=0;return m|0}if(j>>>0>=(b+4|0)>>>0?(j-b|0)>>>0<=c[271866]<<1>>>0:0){m=a;return m|0}m=0;return m|0}if(j>>>0>=b>>>0){e=j-b|0;if(e>>>0<=15){m=a;return m|0}c[o>>2]=p&1|b|2;c[a+(b+4)>>2]=e|3;c[d>>2]=c[d>>2]|1;cv(a+b|0,e);m=a;return m|0}if((l|0)==(c[271752]|0)){e=(c[271749]|0)+j|0;if(e>>>0<=b>>>0){m=0;return m|0}m=e-b|0;c[o>>2]=p&1|b|2;c[a+(b+4)>>2]=m|1;c[271752]=a+b;c[271749]=m;m=a;return m|0}if((l|0)==(c[271751]|0)){e=(c[271748]|0)+j|0;if(e>>>0<b>>>0){m=0;return m|0}d=e-b|0;if(d>>>0>15){c[o>>2]=p&1|b|2;c[a+(b+4)>>2]=d|1;c[a+e>>2]=d;e=a+(e+4)|0;c[e>>2]=c[e>>2]&-2;e=a+b|0}else{c[o>>2]=p&1|e|2;e=a+(e+4)|0;c[e>>2]=c[e>>2]|1;e=0;d=0}c[271748]=d;c[271751]=e;m=a;return m|0}if(g&2){m=0;return m|0}m=(g&-8)+j|0;if(m>>>0<b>>>0){m=0;return m|0}n=m-b|0;f=g>>>3;do if(g>>>0>=256){h=c[a+(j+24)>>2]|0;g=c[a+(j+12)>>2]|0;do if((g|0)==(l|0)){d=a+(j+20)|0;e=c[d>>2]|0;if(!e){d=a+(j+16)|0;e=c[d>>2]|0;if(!e){k=0;break}}while(1){f=e+20|0;g=c[f>>2]|0;if(g){e=g;d=f;continue}g=e+16|0;f=c[g>>2]|0;if(!f)break;else{e=f;d=g}}if(d>>>0<i>>>0)Nb();else{c[d>>2]=0;k=e;break}}else{f=c[a+(j+8)>>2]|0;if(f>>>0<i>>>0)Nb();e=f+12|0;if((c[e>>2]|0)!=(l|0))Nb();d=g+8|0;if((c[d>>2]|0)==(l|0)){c[e>>2]=g;c[d>>2]=f;k=g;break}else Nb()}while(0);if(h){e=c[a+(j+28)>>2]|0;d=1087288+(e<<2)|0;if((l|0)==(c[d>>2]|0)){c[d>>2]=k;if(!k){c[271747]=c[271747]&~(1<<e);break}}else{if(h>>>0<(c[271750]|0)>>>0)Nb();e=h+16|0;if((c[e>>2]|0)==(l|0))c[e>>2]=k;else c[h+20>>2]=k;if(!k)break}d=c[271750]|0;if(k>>>0<d>>>0)Nb();c[k+24>>2]=h;e=c[a+(j+16)>>2]|0;do if(e)if(e>>>0<d>>>0)Nb();else{c[k+16>>2]=e;c[e+24>>2]=k;break}while(0);e=c[a+(j+20)>>2]|0;if(e)if(e>>>0<(c[271750]|0)>>>0)Nb();else{c[k+20>>2]=e;c[e+24>>2]=k;break}}}else{g=c[a+(j+8)>>2]|0;d=c[a+(j+12)>>2]|0;e=1087024+(f<<1<<2)|0;if((g|0)!=(e|0)){if(g>>>0<i>>>0)Nb();if((c[g+12>>2]|0)!=(l|0))Nb()}if((d|0)==(g|0)){c[271746]=c[271746]&~(1<<f);break}if((d|0)!=(e|0)){if(d>>>0<i>>>0)Nb();e=d+8|0;if((c[e>>2]|0)==(l|0))h=e;else Nb()}else h=d+8|0;c[g+12>>2]=d;c[h>>2]=g}while(0);if(n>>>0<16){c[o>>2]=m|p&1|2;m=a+(m|4)|0;c[m>>2]=c[m>>2]|1;m=a;return m|0}else{c[o>>2]=p&1|b|2;c[a+(b+4)>>2]=n|3;m=a+(m|4)|0;c[m>>2]=c[m>>2]|1;cv(a+b|0,n);m=a;return m|0}return 0}
function Af(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=a+2212|0;f=c[j>>2]|0;f=bg(a,f,f)|0;g=F;j=c[a+(c[j>>2]<<9)+784>>2]|0;d=(c[a+2220>>2]|0)+56|0;if((c[d>>2]|0)==0&(c[d+4>>2]|0)==0)d=xf(a,b)|0;else d=zf(a,b)|0;if((d|0)==(b|0))return b|0;if(!((f|0)==0&(g|0)==0)){a:while(1){while(1){if(!(dg(a,c[b>>2]|0,f,g)|0)){e=b;break}b=b+8|0;if((b|0)==(d|0)){b=d;d=15;break a}}d=d+-8|0;c[e>>2]=c[d>>2];if((b|0)==(d|0)){d=15;break}}if((d|0)==15)return b|0}else{i=d;h=b}b:while(1){b=h;while(1){d=c[b>>2]|0;if((d>>>6&63|0)==(j|0)|(d&49152|0)==32768?!(dg(a,d,0,0)|0):0)break;b=b+8|0;if((b|0)==(i|0)){b=i;d=15;break b}}i=i+-8|0;c[b>>2]=c[i>>2];if((b|0)==(i|0)){d=15;break}else h=b}if((d|0)==15)return b|0;return 0}function Bf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=a+256|0;d=g;e=c[d>>2]|0;d=c[d+4>>2]|0;l=a+2008|0;if(!((c[l>>2]&e|0)==0?(c[l+4>>2]&d|0)==0:0)){l=b;return l|0}if(!(c[(c[a+2220>>2]|0)+24>>2]&1)){l=b;return l|0}l=c[a+784>>2]|0;m=c[a+1940>>2]|0;k=a+328|0;f=k;h=c[f>>2]|0;f=c[f+4>>2]|0;i=(l|0)<6?-1:1;do if((l|0)!=6){j=6;while(1){e=cg(a,j,e,d)|0;j=j+i|0;if(!((e&h|0)==0&(F&f|0)==0)){g=9;break}d=g;e=c[d>>2]|0;d=c[d+4>>2]|0;if((j|0)==(l|0)){g=6;break}}if((g|0)==6){f=k;h=c[f>>2]|0;f=c[f+4>>2]|0;break}else if((g|0)==9)return b|0}while(0);i=46496+(m<<3)|0;i=((ba(4210752&(c[i+4>>2]^d),1214252160)|0)^(ba(1077952574&(c[i>>2]^e),270534817)|0))>>>21;i=(c[10862]|0)+(i<<3)|0;k=a+288|0;j=a+296|0;if(!((h&c[i>>2]&(c[j>>2]|c[k>>2])|0)==0?(f&c[i+4>>2]&(c[j+4>>2]|c[k+4>>2])|0)==0:0)){l=b;return l|0}c[b>>2]=m|l<<6|49152;l=b+8|0;return l|0}function Cf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=a+256|0;d=g;e=c[d>>2]|0;d=c[d+4>>2]|0;l=a+2016|0;if(!((c[l>>2]&e|0)==0?(c[l+4>>2]&d|0)==0:0)){l=b;return l|0}if(!(c[(c[a+2220>>2]|0)+24>>2]&2)){l=b;return l|0}l=c[a+784>>2]|0;m=c[a+1944>>2]|0;k=a+328|0;f=k;h=c[f>>2]|0;f=c[f+4>>2]|0;i=(l|0)<2?-1:1;do if((l|0)!=2){j=2;while(1){e=cg(a,j,e,d)|0;j=j+i|0;if(!((e&h|0)==0&(F&f|0)==0)){g=9;break}d=g;e=c[d>>2]|0;d=c[d+4>>2]|0;if((j|0)==(l|0)){g=6;break}}if((g|0)==6){f=k;h=c[f>>2]|0;f=c[f+4>>2]|0;break}else if((g|0)==9)return b|0}while(0);i=46496+(m<<3)|0;i=((ba(263172&(c[i+4>>2]^d),2099728)|0)^(ba(67372154&(c[i>>2]^e),-528480112)|0))>>>21;i=(c[10858]|0)+(i<<3)|0;k=a+288|0;j=a+296|0;if(!((h&c[i>>2]&(c[j>>2]|c[k>>2])|0)==0?(f&c[i+4>>2]&(c[j+4>>2]|c[k+4>>2])|0)==0:0)){l=b;return l|0}c[b>>2]=m|l<<6|49152;l=b+8|0;return l|0}function Df(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=a+256|0;d=g;e=c[d>>2]|0;d=c[d+4>>2]|0;l=a+2032|0;if(!((c[l>>2]&e|0)==0?(c[l+4>>2]&d|0)==0:0)){l=b;return l|0}if(!(c[(c[a+2220>>2]|0)+24>>2]&4)){l=b;return l|0}l=c[a+1296>>2]|0;m=c[a+1952>>2]|0;k=a+320|0;f=k;h=c[f>>2]|0;f=c[f+4>>2]|0;i=(l|0)<62?-1:1;do if((l|0)!=62){j=62;while(1){e=cg(a,j,e,d)|0;j=j+i|0;if(!((e&h|0)==0&(F&f|0)==0)){g=9;break}d=g;e=c[d>>2]|0;d=c[d+4>>2]|0;if((j|0)==(l|0)){g=6;break}}if((g|0)==6){f=k;h=c[f>>2]|0;f=c[f+4>>2]|0;break}else if((g|0)==9)return b|0}while(0);i=46496+(m<<3)|0;i=((ba(1044398144&(c[i+4>>2]^d),1179777)|0)^(ba(1077952512&(c[i>>2]^e),67111557)|0))>>>21;i=(c[10918]|0)+(i<<3)|0;k=a+288|0;j=a+296|0;if(!((h&c[i>>2]&(c[j>>2]|c[k>>2])|0)==0?(f&c[i+4>>2]&(c[j+4>>2]|c[k+4>>2])|0)==0:0)){l=b;return l|0}c[b>>2]=m|l<<6|49152;l=b+8|0;return l|0}function Ef(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=a+256|0;d=g;e=c[d>>2]|0;d=c[d+4>>2]|0;l=a+2064|0;if(!((c[l>>2]&e|0)==0?(c[l+4>>2]&d|0)==0:0)){l=b;return l|0}if(!(c[(c[a+2220>>2]|0)+24>>2]&8)){l=b;return l|0}l=c[a+1296>>2]|0;m=c[a+1968>>2]|0;k=a+320|0;f=k;h=c[f>>2]|0;f=c[f+4>>2]|0;i=(l|0)<58?-1:1;do if((l|0)!=58){j=58;while(1){e=cg(a,j,e,d)|0;j=j+i|0;if(!((e&h|0)==0&(F&f|0)==0)){g=9;break}d=g;e=c[d>>2]|0;d=c[d+4>>2]|0;if((j|0)==(l|0)){g=6;break}}if((g|0)==6){f=k;h=c[f>>2]|0;f=c[f+4>>2]|0;break}else if((g|0)==9)return b|0}while(0);i=46496+(m<<3)|0;i=((ba(2047083524&(c[i+4>>2]^d),538003493)|0)^(ba(67372032&(c[i>>2]^e),537419781)|0))>>>21;i=(c[10914]|0)+(i<<3)|0;k=a+288|0;j=a+296|0;if(!((h&c[i>>2]&(c[j>>2]|c[k>>2])|0)==0?(f&c[i+4>>2]&(c[j+4>>2]|c[k+4>>2])|0)==0:0)){l=b;return l|0}c[b>>2]=m|l<<6|49152;l=b+8|0;return l|0}function Ff(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=a&7;if((f|0)==5){g=45728+(b<<3)|0;f=45216+(b<<3)|0;f=(ba(c[g+4>>2]&e,c[f+4>>2]|0)|0)^(ba(c[g>>2]&d,c[f>>2]|0)|0);f=(c[43680+(b<<2)>>2]|0)+(f>>>(c[46240+(b<<2)>>2]|0)<<3)|0;g=44448+(b<<3)|0;a=43936+(b<<3)|0;d=(ba(c[g+4>>2]&e,c[a+4>>2]|0)|0)^(ba(c[g>>2]&d,c[a>>2]|0)|0);d=(c[43424+(b<<2)>>2]|0)+(d>>>(c[44960+(b<<2)>>2]|0)<<3)|0;e=c[d+4>>2]|c[f+4>>2];d=c[d>>2]|c[f>>2];F=e;return d|0}else if((f|0)==3){a=45728+(b<<3)|0;f=45216+(b<<3)|0;d=(ba(c[a+4>>2]&e,c[f+4>>2]|0)|0)^(ba(c[a>>2]&d,c[f>>2]|0)|0);d=(c[43680+(b<<2)>>2]|0)+(d>>>(c[46240+(b<<2)>>2]|0)<<3)|0;e=c[d+4>>2]|0;d=c[d>>2]|0;F=e;return d|0}else if((f|0)==4){a=44448+(b<<3)|0;f=43936+(b<<3)|0;d=(ba(c[a+4>>2]&e,c[f+4>>2]|0)|0)^(ba(c[a>>2]&d,c[f>>2]|0)|0);d=(c[43424+(b<<2)>>2]|0)+(d>>>(c[44960+(b<<2)>>2]|0)<<3)|0;e=c[d+4>>2]|0;d=c[d>>2]|0;F=e;return d|0}else{d=47328+(a<<9)+(b<<3)|0;e=c[d+4>>2]|0;d=c[d>>2]|0;F=e;return d|0}return 0}function Gf(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[a>>2]=b;c[a+4>>2]=f;c[a+20>>2]=e;f=a+104|0;e=a+92|0;c[e>>2]=f;c[a+88>>2]=f;c[a+100>>2]=a+2144;c[a+12>>2]=g;c[a+16>>2]=h;c[a+8>>2]=i;g=(c[b+2220>>2]|0)+56|0;c[a+84>>2]=(c[g>>2]|0)==0&(c[g+4>>2]|0)==0?0:6;if(!d){h=0;g=f;f=a+24|0;c[f>>2]=h;f=(h|0)!=0;f=f&1;f=g+(f<<3)|0;c[e>>2]=f;return}f=eg(b,d)|0;f=f?d:0;g=c[e>>2]|0;h=a+24|0;c[h>>2]=f;f=(f|0)!=0;f=f&1;f=g+(f<<3)|0;c[e>>2]=f;return}function Hf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;c[a>>2]=b;c[a+4>>2]=f;h=a+104|0;c[a+88>>2]=h;i=a+92|0;c[i>>2]=h;f=(c[b+2220>>2]|0)+56|0;do if((c[f>>2]|0)==0&(c[f+4>>2]|0)==0){if((e|0)>-1){c[a+84>>2]=8;j=8;break}f=a+84|0;if((e|0)>-5){c[f>>2]=11;j=8;break}else{c[f>>2]=15;c[a+76>>2]=g;f=0;break}}else{c[a+84>>2]=6;j=8}while(0);if((j|0)==8)if(!d)f=0;else{f=eg(b,d)|0;f=f?d:0;h=c[i>>2]|0}c[a+24>>2]=f;c[i>>2]=h+(((f|0)!=0&1)<<3);return}function If(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;c[a>>2]=b;c[a+4>>2]=e;h=a+104|0;c[a+88>>2]=h;g=a+92|0;c[g>>2]=h;c[a+84>>2]=13;h=a+80|0;c[h>>2]=c[1004848+(f<<2)>>2];if((d|0)!=0?eg(b,d)|0:0){b=a+24|0;c[b>>2]=d;e=c[a>>2]|0;f=d&49152;if((f|0)==32768|((f|0)!=49152?(c[e+((d&63)<<2)>>2]|0)!=0:0)?(e=ng(e,d)|0,(e|0)>(c[h>>2]|0)):0){e=(c[b>>2]|0)!=0;e=e&1;b=c[g>>2]|0;e=b+(e<<3)|0;c[g>>2]=e;return}c[b>>2]=0;e=0;e=e&1;b=c[g>>2]|0;e=b+(e<<3)|0;c[g>>2]=e;return}c[a+24>>2]=0;e=0;e=e&1;b=c[g>>2]|0;e=b+(e<<3)|0;c[g>>2]=e;return}function Jf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=a+104|0;i=a+88|0;c[i>>2]=f;b=a+84|0;l=c[b>>2]|0;c[b>>2]=l+1;switch(l|0){case 1:{d=a+28|0;c[i>>2]=d;i=a+44|0;b=a+92|0;c[b>>2]=i;k=c[a+8>>2]|0;h=c[k+24>>2]|0;c[d>>2]=h;k=c[k+28>>2]|0;c[a+36>>2]=k;c[a+52>>2]=0;c[a+44>>2]=0;c[a+68>>2]=0;c[a+60>>2]=0;f=c[a+12>>2]|0;l=a+36|0;g=c[f>>2]|0;if((g|0)==(h|0)|(g|0)==(k|0)){k=3;j=2}else{e=a+52|0;c[b>>2]=e;c[i>>2]=g;k=4;j=3;i=e}g=c[f+4>>2]|0;if((g|0)!=(h|0)?(g|0)!=(c[l>>2]|0):0){i=a+(k<<3)+28|0;c[b>>2]=i;c[a+(j<<3)+28>>2]=g;h=c[d>>2]|0}j=c[a+16>>2]|0;e=a+44|0;k=a+52|0;g=c[j>>2]|0;if((((g|0)!=(h|0)?(g|0)!=(c[l>>2]|0):0)?(g|0)!=(c[e>>2]|0):0)?(g|0)!=(c[k>>2]|0):0){h=i+8|0;c[b>>2]=h;c[i>>2]=g;i=h;h=c[d>>2]|0}f=c[j+4>>2]|0;if((f|0)==(h|0))return;if((f|0)==(c[l>>2]|0))return;if((f|0)==(c[e>>2]|0))return;if((f|0)==(c[k>>2]|0))return;c[b>>2]=i+8;c[i>>2]=f;return}case 2:{b=wf(c[a>>2]|0,f)|0;k=a+92|0;c[k>>2]=b;c[a+96>>2]=b;if((f|0)!=(b|0)){e=a+4|0;do{l=c[f>>2]|0;c[f+4>>2]=c[(c[e>>2]|0)+(c[(c[a>>2]|0)+((l>>>6&63)<<2)>>2]<<8)+((l&63)<<2)>>2];f=f+8|0}while((f|0)!=(b|0))}d=c[i>>2]|0;a:do if((d|0)!=(b|0)){e=b;b=d;do{while(1){d=b;b=b+8|0;if((c[d+4>>2]|0)<=0)break;if((b|0)==(e|0)){b=e;break a}}while(1){f=e+-8|0;if((d|0)==(f|0)){b=d;break a}if((c[e+-4>>2]|0)>0){e=f;break}else e=f}j=d;h=c[j>>2]|0;j=c[j+4>>2]|0;f=e;g=c[f+4>>2]|0;l=d;c[l>>2]=c[f>>2];c[l+4>>2]=g;l=e;c[l>>2]=h;c[l+4>>2]=j}while((b|0)!=(e|0))}while(0);c[k>>2]=b;k=c[i>>2]|0;d=k+8|0;if(d>>>0<b>>>0){i=k;j=d}else return;while(1){e=j;f=c[e>>2]|0;e=c[e+4>>2]|0;b:do if((j|0)==(k|0))g=k;else{h=j;while(1){g=h;h=h+-8|0;if((c[g+-4>>2]|0)>=(e|0))break b;a=h;d=c[a+4>>2]|0;l=g;c[l>>2]=c[a>>2];c[l+4>>2]=d;if((h|0)==(k|0)){g=k;break}}}while(0);d=g;c[d>>2]=f;c[d+4>>2]=e;d=i+16|0;if(d>>>0<b>>>0){i=j;j=d}else break}return}case 3:{l=a+92|0;j=c[l>>2]|0;c[i>>2]=j;k=c[a+96>>2]|0;c[l>>2]=k;if((c[a+20>>2]|0)<3)return;d=j+8|0;if(d>>>0<k>>>0)i=j;else return;while(1){e=d;f=c[e>>2]|0;e=c[e+4>>2]|0;c:do if((d|0)==(j|0))g=j;else{h=d;while(1){g=h;h=h+-8|0;if((c[g+-4>>2]|0)>=(e|0))break c;a=h;b=c[a+4>>2]|0;l=g;c[l>>2]=c[a>>2];c[l+4>>2]=b;if((h|0)==(j|0)){g=j;break}}}while(0);b=g;c[b>>2]=f;c[b+4>>2]=e;b=i+16|0;if(b>>>0<k>>>0){i=d;d=b}else break}return}case 6:{l=zf(c[a>>2]|0,f)|0;i=a+92|0;c[i>>2]=l;if(l>>>0<=(a+112|0)>>>0|(f|0)==(l|0))return;b=a+4|0;d=f;do{h=c[d>>2]|0;f=mg(c[a>>2]|0,h)|0;do if((f|0)>=0){g=c[a>>2]|0;f=h&63;e=c[g+(f<<2)>>2]|0;l=h&49152;if((l|0)==32768|(l|0)!=49152&(e|0)!=0){c[d+4>>2]=(c[1004848+(e<<2)>>2]|0)+250-(c[g+((h>>>6&63)<<2)>>2]&7);break}else{c[d+4>>2]=c[(c[b>>2]|0)+(c[g+((h>>>6&63)<<2)>>2]<<8)+(f<<2)>>2];break}}else c[d+4>>2]=f+-250;while(0);d=d+8|0}while((d|0)!=(c[i>>2]|0));return}case 9:{c[a+92>>2]=yf(c[a>>2]|0,f)|0;return}case 14:case 12:case 10:case 7:case 5:{c[b>>2]=17;break}case 16:break;case 4:{c[i>>2]=a+2144;c[a+92>>2]=c[a+100>>2];return}case 15:case 13:case 11:case 8:case 0:{h=vf(c[a>>2]|0,f)|0;c[a+92>>2]=h;if((f|0)==(h|0))return;do{g=c[f>>2]|0;e=c[a>>2]|0;e=(c[1004848+(c[e+((g&63)<<2)>>2]<<2)>>2]|0)-(c[e+((g>>>6&63)<<2)>>2]&7)|0;d=f+4|0;c[d>>2]=e;b=g&49152;if((b|0)==32768)c[d>>2]=(c[251213]|0)+e;else if((b|0)==16384)c[d>>2]=(c[1004848+((g>>>12&3)+2<<2)>>2]|0)+e-(c[251213]|0);f=f+8|0}while((f|0)!=(h|0));return}default:return}c[a+92>>2]=a+112;return}function Kf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;t=a+88|0;h=a+92|0;l=a+84|0;s=a+24|0;m=a+100|0;n=a+28|0;o=a+36|0;p=a+44|0;q=a+52|0;r=a+60|0;i=a+68|0;j=a+80|0;k=a+76|0;a:while(1){b=c[t>>2]|0;g=c[h>>2]|0;if((b|0)==(g|0)){Jf(a);continue}switch(c[l>>2]|0){case 13:case 11:case 8:case 6:case 0:{d=5;break a}case 12:case 9:case 7:{e=b+8|0;c[t>>2]=e;if((e|0)==(g|0))d=b;else{d=b;f=b;while(1){d=(c[d+4>>2]|0)<(c[f+12>>2]|0)?e:d;f=f+16|0;if((f|0)==(g|0))break;else{u=e;e=f;f=u}}}f=b;e=c[f>>2]|0;f=c[f+4>>2]|0;v=d;u=c[v+4>>2]|0;g=b;c[g>>2]=c[v>>2];c[g+4>>2]=u;g=d;c[g>>2]=e;c[g+4>>2]=f;b=c[b>>2]|0;if((b|0)==(c[s>>2]|0))continue a;else{d=34;break a}}case 5:{d=22;break a}case 14:{e=b+8|0;c[t>>2]=e;if((e|0)==(g|0))d=b;else{d=b;f=b;while(1){d=(c[d+4>>2]|0)<(c[f+12>>2]|0)?e:d;f=f+16|0;if((f|0)==(g|0))break;else{u=e;e=f;f=u}}}f=b;e=c[f>>2]|0;f=c[f+4>>2]|0;v=d;u=c[v+4>>2]|0;g=b;c[g>>2]=c[v>>2];c[g+4>>2]=u;g=d;c[g>>2]=e;c[g+4>>2]=f;b=c[b>>2]|0;if((b|0)==(c[s>>2]|0))continue a;g=ng(c[a>>2]|0,b)|0;if((g|0)>(c[j>>2]|0)){d=34;break a}else continue a}case 1:{e=b+8|0;c[t>>2]=e;if((e|0)==(g|0))d=b;else{d=b;f=b;while(1){d=(c[d+4>>2]|0)<(c[f+12>>2]|0)?e:d;f=f+16|0;if((f|0)==(g|0))break;else{u=e;e=f;f=u}}}f=b;e=c[f>>2]|0;f=c[f+4>>2]|0;v=d;u=c[v+4>>2]|0;g=b;c[g>>2]=c[v>>2];c[g+4>>2]=u;g=d;c[g>>2]=e;c[g+4>>2]=f;b=c[b>>2]|0;if((b|0)==(c[s>>2]|0))continue a;if((mg(c[a>>2]|0,b)|0)>-1){d=34;break a}g=c[m>>2]|0;c[m>>2]=g+-8;c[g>>2]=b;continue a}case 10:{c[t>>2]=b+8;b=c[b>>2]|0;if((b|0)==(c[s>>2]|0))continue a;else{d=34;break a}}case 2:{c[t>>2]=b+8;b=c[b>>2]|0;if(!b)continue a;if((b|0)==(c[s>>2]|0))continue a;if(!(eg(c[a>>2]|0,b)|0))continue a;g=b&49152;if((g|0)==32768|((g|0)!=49152?(c[(c[a>>2]|0)+((b&63)<<2)>>2]|0)!=0:0))continue a;else{d=34;break a}}case 16:{e=b+8|0;c[t>>2]=e;if((e|0)==(g|0))d=b;else{d=b;f=b;while(1){d=(c[d+4>>2]|0)<(c[f+12>>2]|0)?e:d;f=f+16|0;if((f|0)==(g|0))break;else{u=e;e=f;f=u}}}f=b;e=c[f>>2]|0;f=c[f+4>>2]|0;v=d;u=c[v+4>>2]|0;g=b;c[g>>2]=c[v>>2];c[g+4>>2]=u;g=d;c[g>>2]=e;c[g+4>>2]=f;b=c[b>>2]|0;if((b&63|0)==(c[k>>2]|0)){d=34;break a}else continue a}case 17:{b=0;d=34;break a}case 4:case 3:{c[t>>2]=b+8;b=c[b>>2]|0;if((b|0)==(c[s>>2]|0))continue a;if((b|0)==(c[n>>2]|0))continue a;if((b|0)==(c[o>>2]|0))continue a;if((b|0)==(c[p>>2]|0))continue a;if((b|0)==(c[q>>2]|0))continue a;if((b|0)==(c[r>>2]|0))continue a;if((b|0)==(c[i>>2]|0))continue a;else{d=34;break a}}default:continue a}}if((d|0)==5){c[t>>2]=b+8;l=c[s>>2]|0;return l|0}else if((d|0)==22){c[t>>2]=b+-8;l=c[b>>2]|0;return l|0}else if((d|0)==34)return b|0;return 0}function Lf(a){a=a|0;return Kf(c[(c[c[a+8>>2]>>2]|0)+28>>2]|0)|0}function Mf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;c[a+48>>2]=d;i=b+2220|0;c[a+72>>2]=c[(c[i>>2]|0)+24>>2]&3;j=a+64|0;c[j>>2]=0;g=b+320|0;e=b+264|0;f=c[e>>2]&c[g>>2];g=c[e+4>>2]&c[g+4>>2];if((f|0)==0&(g|0)==0)f=0;else{h=0;while(1){e=h+1|0;h=55520+(d<<6)+(h<<3)|0;if((c[h>>2]&f|0)==0?(c[h+4>>2]&g|0)==0:0)h=e;else break}c[j>>2]=e;f=ba(e,-16)|0}if((d>>3|0)>3){e=f;return e|0}e=Qf(a,b,d)|0;f=c[(c[i>>2]|0)+24>>2]|0;if(f&1){g=Qf(a,b,6)|0;f=c[(c[i>>2]|0)+24>>2]|0;e=(e|0)<(g|0)?g:e}if(f&2){f=Qf(a,b,2)|0;e=(e|0)<(f|0)?f:e}e=(ba(c[j>>2]|0,-16)|0)+(e<<16)|0;return e|0}function Nf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;c[a+52>>2]=d;i=b+2220|0;c[a+76>>2]=c[(c[i>>2]|0)+24>>2]&12;j=a+68|0;c[j>>2]=0;g=b+328|0;e=b+264|0;f=c[e>>2]&c[g>>2];g=c[e+4>>2]&c[g+4>>2];if((f|0)==0&(g|0)==0)f=0;else{h=0;while(1){e=h+1|0;h=55520+(d<<6)+(h<<3)|0;if((c[h>>2]&f|0)==0?(c[h+4>>2]&g|0)==0:0)h=e;else break}c[j>>2]=e;f=ba(e,-16)|0}if((d>>3^7|0)>3){e=f;return e|0}e=Rf(a,b,d)|0;f=c[(c[i>>2]|0)+24>>2]|0;if(f&4){g=Rf(a,b,62)|0;f=c[(c[i>>2]|0)+24>>2]|0;e=(e|0)<(g|0)?g:e}if(f&8){f=Rf(a,b,58)|0;e=(e|0)<(f|0)?f:e}e=(ba(c[j>>2]|0,-16)|0)+(e<<16)|0;return e|0}function Of(){var a=0;a=0;do{c[1002292+(a<<6)>>2]=(6>>>a)+196608;c[1002296+(a<<6)>>2]=(15>>>a)+458752;c[1002300+(a<<6)>>2]=(10>>>a)+327680;c[1002304+(a<<6)>>2]=(57>>>a)+1835008;c[1002308+(a<<6)>>2]=(75>>>a)+2424832;c[1002312+(a<<6)>>2]=(135>>>a)+4390912;c[1002324+(a<<6)>>2]=(10>>>a)+327680;c[1002328+(a<<6)>>2]=(13>>>a)+393216;c[1002332+(a<<6)>>2]=(33>>>a)+1048576;c[1002336+(a<<6)>>2]=(66>>>a)+2162688;c[1002340+(a<<6)>>2]=(105>>>a)+3407872;c[1002344+(a<<6)>>2]=(196>>>a)+6422528;a=a+1|0}while((a|0)!=2);return}function Pf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0;d=c[a+2220>>2]|0;b=c[d>>2]|0;d=c[d+4>>2]|0;H=b&16383;I=c[(c[a+2216>>2]|0)+792>>2]|0;J=I+(H*112|0)|0;x=J;if((c[x>>2]|0)==(b|0)?(c[x+4>>2]|0)==(d|0):0)return J|0;E=J;c[E>>2]=b;c[E+4>>2]=d;E=a+320|0;t=E;C=a+264|0;v=C;u=c[v>>2]|0;v=c[v+4>>2]|0;z=u&c[t>>2];t=v&c[t+4>>2];D=a+328|0;w=D;u=c[w>>2]&u;v=c[w+4>>2]&v;w=I+(H*112|0)+16|0;x=w;c[x>>2]=0;c[x+4>>2]=0;c[I+(H*112|0)+48>>2]=64;x=I+(H*112|0)+80|0;c[x>>2]=255;q=ov(z|0,t|0,9)|0;s=F&-16843010;r=ov(z|0,t|0,7)|0;e=I+(H*112|0)+32|0;c[e>>2]=q&-16843264|r&2139062016;c[e+4>>2]=s|F&2139062143;e=z&-1437226411;e=e-(e>>>1&1426085120)|0;s=jv(z|0,t|0,33)|0;s=(t&-1437226411)-(s&1426085120)|0;e=(ba((e&858993425)+(s&858993425)+(s>>>2&858993425)+(e>>>2&858993425)|0,286331153)|0)>>>28;c[I+(H*112|0)+100>>2]=e;c[I+(H*112|0)+96>>2]=(c[a+340>>2]|0)-e;e=c[a+464>>2]|0;if((e|0)!=64){B=u|z;A=v|t;d=e;b=255;e=0;y=a+468|0;while(1){r=d&7;c[x>>2]=b&~(1<<r);k=47072+(d+-8>>3<<3)|0;l=c[k>>2]|0;k=c[k+4>>2]|0;j=47136+(r<<3)|0;f=c[j>>2]&z;j=c[j+4>>2]&t;g=d>>3;b=47072+(g<<3)|0;i=c[b>>2]|0;b=c[b+4>>2]|0;n=(i|l)&f;m=(b|k)&j;b=(f&i|0)!=0|(j&b|0)!=0;l=f&l;k=j&k;j=(f|0)==0&(j|0)==0;f=59616+(d<<3)|0;i=c[f>>2]|0;f=c[f+4>>2]|0;q=i&z;p=f&t;f=(i&u|0)!=0|(f&v|0)!=0;i=60640+(d<<3)|0;i=(c[i>>2]&u|0)==0?(c[i+4>>2]&v|0)==0:0;h=47840+(d<<3)|0;h=(c[h>>2]&u|0)==0?(c[h+4>>2]&v|0)==0:0;if(((m|0)==0?(i&1|j&1|n|0)==0:0)?(s=62176+(d<<3)|0,!(((c[s>>2]&z|0)!=0?1:(c[s+4>>2]&t|0)!=0)|h^1)):0){s=61664+(d<<3)|0;o=c[s>>2]|0;s=c[s+4>>2]|0;G=47072+((_c(o&B,s&A)|0)>>3<<3)|0;o=c[G>>2]&o;s=c[G+4>>2]&s;G=ov(o|0,s|0,8)|0;s=((G|o)&u|0)!=0|((F|s)&v|0)!=0}else s=0;o=(q|0)!=0|(p|0)!=0;if(!(o|i^1)){G=46496+(d<<3)|0;K=w;i=c[K+4>>2]|c[G+4>>2];d=w;c[d>>2]=c[K>>2]|c[G>>2];c[d+4>>2]=i}if(j)e=e-(c[1002128+((f&1)<<5)+(r<<2)>>2]|0)|0;else e=(l|0)!=0|(k|0)!=0?e:e+-1310730|0;if(o){o=c[1002096+(r<<2)>>2]|0;q=($c(q,p)|0)>>3;q=(g|0)<(q|0)?q-g|0:g-q|0;e=e-((o<<16>>16|0)/(q|0)|0)-(((o+32768>>16|0)/(q|0)|0)<<16)|0}if(s)e=e-(c[1002192+((f&1)<<5)+(r<<2)>>2]|0)|0;if(!((n|0)==0&(m|0)==0))e=(c[1002288+((f&1)<<6)+((b&1)<<5)+(g<<2)>>2]|0)+e|0;if(!h)e=(c[1002256+(g<<2)>>2]|0)+e|0;d=c[y>>2]|0;if((d|0)==64)break;b=c[x>>2]|0;y=y+4|0}x=c[x>>2]|0;d=x^255;b=((d|0)<0)<<31>>31;if((x|0)==255){G=e;e=0}else{x=$c(d,b)|0;G=e;e=x-(_c(d,b)|0)|0}}else{G=0;e=0}c[I+(H*112|0)+88>>2]=e;A=D;v=C;u=c[v>>2]|0;v=c[v+4>>2]|0;z=u&c[A>>2];A=v&c[A+4>>2];w=E;u=c[w>>2]&u;v=c[w+4>>2]&v;w=I+(H*112|0)+24|0;B=w;c[B>>2]=0;c[B+4>>2]=0;c[I+(H*112|0)+52>>2]=64;B=I+(H*112|0)+84|0;c[B>>2]=255;s=jv(z|0,A|0,9)|0;x=F&8355711;t=jv(z|0,A|0,7)|0;e=I+(H*112|0)+40|0;c[e>>2]=s&2139062143|t&-16843010;c[e+4>>2]=x|F&16711422;e=z&-1437226411;e=e-(e>>>1&1426085120)|0;x=jv(z|0,A|0,33)|0;x=(A&-1437226411)-(x&1426085120)|0;e=(ba((e&858993425)+(x&858993425)+(x>>>2&858993425)+(e>>>2&858993425)|0,286331153)|0)>>>28;c[I+(H*112|0)+108>>2]=e;c[I+(H*112|0)+104>>2]=(c[a+372>>2]|0)-e;e=c[a+976>>2]|0;if((e|0)!=64){x=u|z;y=v|A;b=255;d=0;t=a+980|0;while(1){m=e&7;c[B>>2]=b&~(1<<m);f=47072+(e+8>>3<<3)|0;b=c[f>>2]|0;f=c[f+4>>2]|0;g=47136+(m<<3)|0;q=c[g>>2]&z;g=c[g+4>>2]&A;r=e>>3;p=47072+(r<<3)|0;h=c[p>>2]|0;p=c[p+4>>2]|0;n=(h|b)&q;o=(p|f)&g;p=(q&h|0)!=0|(g&p|0)!=0;b=q&b;f=g&f;g=(q|0)==0&(g|0)==0;q=60128+(e<<3)|0;h=c[q>>2]|0;q=c[q+4>>2]|0;i=h&z;j=q&A;q=(h&u|0)!=0|(q&v|0)!=0;h=61152+(e<<3)|0;h=(c[h>>2]&u|0)==0?(c[h+4>>2]&v|0)==0:0;s=51936+(e<<3)|0;s=(c[s>>2]&u|0)==0?(c[s+4>>2]&v|0)==0:0;if(((o|0)==0?(h&1|g&1|n|0)==0:0)?(k=61664+(e<<3)|0,!(((c[k>>2]&z|0)!=0?1:(c[k+4>>2]&A|0)!=0)|s^1)):0){l=62176+(e<<3)|0;k=c[l>>2]|0;l=c[l+4>>2]|0;C=47072+(($c(k&x,l&y)|0)>>3<<3)|0;k=c[C>>2]&k;l=c[C+4>>2]&l;C=jv(k|0,l|0,8)|0;l=((C|k)&u|0)!=0|((F|l)&v|0)!=0}else l=0;k=(i|0)!=0|(j|0)!=0;if(!(k|h^1)){C=46496+(e<<3)|0;D=w;h=c[D+4>>2]|c[C+4>>2];e=w;c[e>>2]=c[D>>2]|c[C>>2];c[e+4>>2]=h}if(g)d=d-(c[1002128+((q&1)<<5)+(m<<2)>>2]|0)|0;else d=(b|0)!=0|(f|0)!=0?d:d+-1310730|0;if(k){e=c[1002096+(m<<2)>>2]|0;b=(_c(i,j)|0)>>3;b=(r|0)<(b|0)?b-r|0:r-b|0;d=d-((e<<16>>16|0)/(b|0)|0)-(((e+32768>>16|0)/(b|0)|0)<<16)|0}if(l)d=d-(c[1002192+((q&1)<<5)+(m<<2)>>2]|0)|0;if(!((n|0)==0&(o|0)==0))d=(c[1002288+((q&1)<<6)+((p&1)<<5)+((r^7)<<2)>>2]|0)+d|0;if(!s)d=(c[1002256+((r^7)<<2)>>2]|0)+d|0;e=c[t>>2]|0;if((e|0)==64)break;b=c[B>>2]|0;t=t+4|0}x=c[B>>2]|0;b=x^255;e=((b|0)<0)<<31>>31;if((x|0)==255)b=0;else{x=$c(b,e)|0;b=x-(_c(b,e)|0)|0}}else{d=0;b=0}c[I+(H*112|0)+92>>2]=b;c[I+(H*112|0)+8>>2]=G-d;return J|0}function Qf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=b+264|0;k=d>>3;p=47200+(k<<3)|0;o=47072+(k<<3)|0;m=(c[o>>2]|c[p>>2])&c[i>>2];i=(c[o+4>>2]|c[p+4>>2])&c[i+4>>2];p=b+320|0;o=m&c[p>>2];p=i&c[p+4>>2];n=b+328|0;m=m&c[n>>2];n=i&c[n+4>>2];i=d&7;l=i>>>0<6?i:6;l=l>>>0>1?l:1;j=l+1|0;k=k+1|0;l=l+-1|0;a=257;while(1){b=47008+(l<<3)|0;e=b;d=c[e>>2]|0;e=c[e+4>>2]|0;f=o&d;g=p&e;if((f|0)==0&(g|0)==0)h=0;else{h=(_c(f,g)|0)>>3;e=b;d=c[e>>2]|0;e=c[e+4>>2]|0}b=m&d;d=n&e;if((b|0)==0&(d|0)==0)d=0;else d=(_c(b,d)|0)>>3;g=7-l|0;g=(g|0)<(l|0)?g:l;f=c[1002416+(g<<5)+(h<<2)>>2]|0;if(!((l|0)==(i|0)&(d|0)==(k|0)))if(!h)e=0;else e=(d|0)==(h+1|0)?2:1;else e=3;a=a-f-(c[1002544+(e<<7)+(g<<5)+(d<<2)>>2]|0)|0;if((l|0)<(j|0))l=l+1|0;else break}return a|0}function Rf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=b+264|0;k=d>>3;p=47264+(k<<3)|0;o=47072+(k<<3)|0;m=(c[o>>2]|c[p>>2])&c[i>>2];i=(c[o+4>>2]|c[p+4>>2])&c[i+4>>2];p=b+328|0;o=m&c[p>>2];p=i&c[p+4>>2];n=b+320|0;m=m&c[n>>2];n=i&c[n+4>>2];i=d&7;l=i>>>0<6?i:6;l=l>>>0>1?l:1;j=l+1|0;k=(k^7)+1|0;a=257;l=l+-1|0;while(1){b=47008+(l<<3)|0;e=b;d=c[e>>2]|0;e=c[e+4>>2]|0;f=o&d;g=p&e;if((f|0)==0&(g|0)==0)h=0;else{h=($c(f,g)|0)>>3^7;e=b;d=c[e>>2]|0;e=c[e+4>>2]|0}b=m&d;d=n&e;if((b|0)==0&(d|0)==0)d=0;else d=($c(b,d)|0)>>3^7;g=7-l|0;g=(g|0)<(l|0)?g:l;f=c[1002416+(g<<5)+(h<<2)>>2]|0;if(!((l|0)==(i|0)&(d|0)==(k|0)))if(!h)e=0;else e=(d|0)==(h+1|0)?2:1;else e=3;a=a-f-(c[1002544+(e<<7)+(g<<5)+(d<<2)>>2]|0)|0;if((l|0)<(j|0))l=l+1|0;else break}return a|0}function Sf(a){a=a|0;var b=0;a=(c[a+2220>>2]|0)+48|0;b=1013368;F=c[b+4>>2]^c[a+4>>2];return c[b>>2]^c[a>>2]|0}function Tf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;l=b+2212|0;k=c[l>>2]|0;p=k^1;q=a+80|0;c[q>>2]=c[b+(p<<9)+784>>2];j=c[b+(k<<9)+784>>2]|0;o=b+288|0;d=o;m=b+296|0;s=m;i=c[s>>2]|0;s=c[s+4>>2]|0;f=64736+(j<<3)|0;n=b+280|0;u=n;t=64224+(j<<3)|0;h=b+(p<<3)+320|0;r=b+256|0;k=b+(k<<3)+320|0;g=0;e=0;i=((c[u>>2]|i)&c[t>>2]|(i|c[d>>2])&c[f>>2])&c[h>>2];h=((c[u+4>>2]|s)&c[t+4>>2]|(s|c[d+4>>2])&c[f+4>>2])&c[h+4>>2];a:while(1){do{if((i|0)==0&(h|0)==0)break a;d=_c(i,h)|0;s=iv(i|0,h|0,-1,-1)|0;i=s&i;h=F&h;d=99552+(j<<9)+(d<<3)|0;s=r;f=c[s>>2]&c[d>>2];d=c[s+4>>2]&c[d+4>>2];s=iv(f|0,d|0,-1,-1)|0}while(!((s&f|0)==0&(F&d|0)==0));s=k;g=c[s>>2]&f|g;e=c[s+4>>2]&d|e}j=a+8|0;c[j>>2]=g;c[j+4>>2]=e;j=c[l>>2]|0;k=c[b+((j^1)<<9)+784>>2]|0;l=o;i=m;g=c[i>>2]|0;i=c[i+4>>2]|0;m=64736+(k<<3)|0;h=64224+(k<<3)|0;j=b+(j<<3)+320|0;f=j;e=0;d=0;g=((c[n>>2]|g)&c[h>>2]|(g|c[l>>2])&c[m>>2])&c[f>>2];f=((c[n+4>>2]|i)&c[h+4>>2]|(i|c[l+4>>2])&c[m+4>>2])&c[f+4>>2];b:while(1){do{if((g|0)==0&(f|0)==0)break b;i=_c(g,f)|0;m=iv(g|0,f|0,-1,-1)|0;g=m&g;f=F&f;i=99552+(k<<9)+(i<<3)|0;m=r;h=c[m>>2]&c[i>>2];i=c[m+4>>2]&c[i+4>>2];m=iv(h|0,i|0,-1,-1)|0}while(!((m&h|0)==0&(F&i|0)==0));m=j;e=c[m>>2]&h|e;d=c[m+4>>2]&i|d}l=a;c[l>>2]=e;c[l+4>>2]=d;l=c[q>>2]|0;i=47328+((p<<3|1)<<9)+(l<<3)|0;m=c[i+4>>2]|0;k=a+24|0;c[k>>2]=c[i>>2];c[k+4>>2]=m;k=48352+(l<<3)|0;m=c[k+4>>2]|0;i=a+32|0;c[i>>2]=c[k>>2];c[i+4>>2]=m;i=r;m=45728+(l<<3)|0;k=45216+(l<<3)|0;k=(ba(c[m+4>>2]&c[i+4>>2],c[k+4>>2]|0)|0)^(ba(c[m>>2]&c[i>>2],c[k>>2]|0)|0);k=(c[43680+(l<<2)>>2]|0)+(k>>>(c[46240+(l<<2)>>2]|0)<<3)|0;i=c[k>>2]|0;k=c[k+4>>2]|0;m=a+40|0;c[m>>2]=i;c[m+4>>2]=k;m=r;h=44448+(l<<3)|0;j=43936+(l<<3)|0;j=(ba(c[h+4>>2]&c[m+4>>2],c[j+4>>2]|0)|0)^(ba(c[h>>2]&c[m>>2],c[j>>2]|0)|0);l=(c[43424+(l<<2)>>2]|0)+(j>>>(c[44960+(l<<2)>>2]|0)<<3)|0;j=c[l>>2]|0;l=c[l+4>>2]|0;m=a+48|0;c[m>>2]=j;c[m+4>>2]=l;m=a+56|0;c[m>>2]=i|j;c[m+4>>2]=k|l;m=a+64|0;c[m>>2]=0;c[m+4>>2]=0;return}function Uf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;q=i;i=i+2112|0;o=q+48|0;k=q+36|0;m=q+24|0;n=q+12|0;p=q;Ec(b,1013408,36)|0;e=7;while(1){f=e<<3;g=0;do{l=Ec(b,1013448,3)|0;a[o>>0]=a[((a[1013376]&1)==0?1013377:c[253346]|0)+(c[d+((g|f)<<2)>>2]|0)>>0]|0;Ec(l,o,1)|0;g=g+1|0}while((g|0)!=8);Ec(b,1013456,38)|0;if((e|0)>0)e=e+-1|0;else break}g=Ec(b,1013496,6)|0;Vf(k,d);f=a[k>>0]|0;if(!(f&1)){e=k+1|0;f=(f&255)>>>1}else{e=c[k+8>>2]|0;f=c[k+4>>2]|0}j=Ec(Ec(g,e,f)|0,1013504,6)|0;g=j+((c[(c[j>>2]|0)+-12>>2]|0)+4)|0;c[g>>2]=c[g>>2]&-75|8;g=j+((c[(c[j>>2]|0)+-12>>2]|0)+4)|0;c[g>>2]=c[g>>2]|16384;c[j+((c[(c[j>>2]|0)+-12>>2]|0)+76)>>2]=48;c[j+((c[(c[j>>2]|0)+-12>>2]|0)+12)>>2]=16;g=d+2220|0;l=(c[g>>2]|0)+48|0;l=pk(j,c[l>>2]|0,c[l+4>>2]|0)|0;j=l+((c[(c[l>>2]|0)+-12>>2]|0)+4)|0;c[j>>2]=c[j>>2]&-75|2;Ec(l,1013512,11)|0;Bi(k);k=(c[g>>2]|0)+56|0;g=c[k>>2]|0;k=c[k+4>>2]|0;if(!((g|0)==0&(k|0)==0)){l=m+1|0;f=m+8|0;e=m+4|0;do{j=_c(g,k)|0;h=iv(g|0,k|0,-1,-1)|0;g=h&g;k=F&k;Jh(m,j);j=a[m>>0]|0;if(!(j&1)){h=l;j=(j&255)>>>1}else{h=c[f>>2]|0;j=c[e>>2]|0}Ec(Ec(b,h,j)|0,1072408,1)|0;Bi(m)}while(!((g|0)==0&(k|0)==0))}Ec(b,1013528,14)|0;j=o+2048|0;c[j>>2]=o;e=Af(d,o)|0;c[o+2052>>2]=e;c[e>>2]=0;e=c[c[j>>2]>>2]|0;if(e){h=n+1|0;f=n+8|0;l=n+4|0;do{Kh(n,d,e);g=a[n>>0]|0;if(!(g&1)){k=h;g=(g&255)>>>1}else{k=c[f>>2]|0;g=c[l>>2]|0}Ec(Ec(b,k,g)|0,1072408,1)|0;Bi(n);e=(c[j>>2]|0)+8|0;c[j>>2]=e;e=c[e>>2]|0}while((e|0)!=0)}Ec(b,1013544,18)|0;l=o+2048|0;c[l>>2]=o;e=Af(d,o)|0;c[o+2052>>2]=e;c[e>>2]=0;e=c[c[l>>2]>>2]|0;if(!e){i=q;return b|0}g=d+2224|0;h=p+1|0;j=p+8|0;k=p+4|0;do{Ih(p,e,(a[g>>0]|0)!=0);e=a[p>>0]|0;if(!(e&1)){f=h;e=(e&255)>>>1}else{f=c[j>>2]|0;e=c[k>>2]|0}Ec(Ec(b,f,e)|0,1072408,1)|0;Bi(p);e=(c[l>>2]|0)+8|0;c[l>>2]=e;e=c[e>>2]|0}while((e|0)!=0);i=q;return b|0}function Vf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=i;i=i+192|0;k=s+176|0;r=s+40|0;l=s+24|0;m=s+12|0;n=s;o=r+56|0;p=r+4|0;c[r>>2]=1017820;c[o>>2]=1017840;ij(r+56|0,p);c[r+128>>2]=0;c[r+132>>2]=-1;c[r>>2]=1017764;c[o>>2]=1017784;nj(p);c[p>>2]=1000496;q=r+36|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[r+52>>2]=16;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Ae(p,k);Bi(k);j=7;while(1){h=j<<3;e=0;do{do if((e|0)<8){f=0;while(1){if(c[d+((e|h)<<2)>>2]|0){g=1;break}f=f+1|0;e=e+1|0;if((e|0)>=8){g=0;break}}if(!f){if(!g)break}else{mk(r,f)|0;if(!g)break}a[k>>0]=a[((a[1013376]&1)==0?1013377:c[253346]|0)+(c[d+((e|h)<<2)>>2]|0)>>0]|0;Ec(r,k,1)|0}while(0);e=e+1|0}while((e|0)<8);if((j|0)<=0)break;a[k>>0]=47;Ec(r,k,1)|0;j=j+-1|0}j=d+2212|0;Ec(r,(c[j>>2]|0)==0?1017664:1017672,3)|0;h=d+2220|0;e=c[h>>2]|0;f=c[e+24>>2]|0;if(f&1){if(!(a[d+2224>>0]|0))f=75;else f=(c[d+1940>>2]&7)+65&255;a[k>>0]=f;Ec(r,k,1)|0;f=c[h>>2]|0;e=f;f=c[f+24>>2]|0}if(f&2){if(!(a[d+2224>>0]|0))f=81;else f=(c[d+1944>>2]&7)+65&255;a[k>>0]=f;Ec(r,k,1)|0;f=c[h>>2]|0;e=f;f=c[f+24>>2]|0}if(f&4){if(!(a[d+2224>>0]|0))f=107;else f=(c[d+1952>>2]&7)+97&255;a[k>>0]=f;Ec(r,k,1)|0;f=c[h>>2]|0;e=f;f=c[f+24>>2]|0}if(f&8){if(!(a[d+2224>>0]|0))f=113;else f=(c[d+1968>>2]&7)+97&255;a[k>>0]=f;Ec(r,k,1)|0;f=c[h>>2]|0;e=f;f=c[f+24>>2]|0}if(!(f&15)){a[k>>0]=45;Ec(r,k,1)|0;e=c[h>>2]|0}e=c[e+40>>2]|0;if((e|0)==64){vi(l,1017680,3);g=0;e=l}else{Jh(n,e);c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;e=a[n>>0]|0;if(!(e&1))e=(e&255)>>>1;else e=c[n+4>>2]|0;Ui(m,1072408,1,e+1|0);if(!(a[n>>0]&1))f=n+1|0;else f=c[n+8>>2]|0;Li(m,f,e)|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;e=a[m>>0]|0;if(!(e&1)){f=(e&255)>>>1;e=m+1|0}else{f=c[m+4>>2]|0;e=c[m+8>>2]|0}Ui(l,e,f,f+1|0);Li(l,1072408,1)|0;g=1;e=l}f=a[e>>0]|0;if(!(f&1)){e=l+1|0;f=(f&255)>>>1}else{e=c[l+8>>2]|0;f=c[l+4>>2]|0}k=Ec(r,e,f)|0;k=Ec(mk(k,c[(c[h>>2]|0)+28>>2]|0)|0,1072408,1)|0;mk(k,(((c[d+2208>>2]|0)-((c[j>>2]|0)==1&1)|0)/2|0)+1|0)|0;Bi(l);if(!g){Ce(b,p);c[r>>2]=1017764;c[o>>2]=1017784;c[p>>2]=1000496;Bi(q);kj(p);o=r+56|0;fj(o);i=s;return}Bi(m);Bi(n);Ce(b,p);c[r>>2]=1017764;c[o>>2]=1017784;c[p>>2]=1000496;Bi(q);kj(p);o=r+56|0;fj(o);i=s;return}function Wf(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=0;b=1070372;a=0;do{d=0;do{f=jv(b|0,a|0,12)|0;b=f^b;a=F^a;f=ov(b|0,a|0,25)|0;b=f^b;a=F^a;f=jv(b|0,a|0,27)|0;b=f^b;a=F^a;f=uv(b|0,a|0,1332534557,625341585)|0;e=1004976+(i<<12)+(d<<3)+512|0;c[e>>2]=f;c[e+4>>2]=F;d=d+1|0}while((d|0)!=64);d=0;do{f=jv(b|0,a|0,12)|0;b=f^b;a=F^a;f=ov(b|0,a|0,25)|0;b=f^b;a=F^a;f=jv(b|0,a|0,27)|0;b=f^b;a=F^a;f=uv(b|0,a|0,1332534557,625341585)|0;e=1004976+(i<<12)+(d<<3)+1024|0;c[e>>2]=f;c[e+4>>2]=F;d=d+1|0}while((d|0)!=64);d=0;do{f=jv(b|0,a|0,12)|0;b=f^b;a=F^a;f=ov(b|0,a|0,25)|0;b=f^b;a=F^a;f=jv(b|0,a|0,27)|0;b=f^b;a=F^a;f=uv(b|0,a|0,1332534557,625341585)|0;e=1004976+(i<<12)+(d<<3)+1536|0;c[e>>2]=f;c[e+4>>2]=F;d=d+1|0}while((d|0)!=64);d=0;do{f=jv(b|0,a|0,12)|0;b=f^b;a=F^a;f=ov(b|0,a|0,25)|0;b=f^b;a=F^a;f=jv(b|0,a|0,27)|0;b=f^b;a=F^a;f=uv(b|0,a|0,1332534557,625341585)|0;e=1004976+(i<<12)+(d<<3)+2048|0;c[e>>2]=f;c[e+4>>2]=F;d=d+1|0}while((d|0)!=64);d=0;do{f=jv(b|0,a|0,12)|0;b=f^b;a=F^a;f=ov(b|0,a|0,25)|0;b=f^b;a=F^a;f=jv(b|0,a|0,27)|0;b=f^b;a=F^a;f=uv(b|0,a|0,1332534557,625341585)|0;e=1004976+(i<<12)+(d<<3)+2560|0;c[e>>2]=f;c[e+4>>2]=F;d=d+1|0}while((d|0)!=64);d=0;do{f=jv(b|0,a|0,12)|0;b=f^b;a=F^a;f=ov(b|0,a|0,25)|0;b=f^b;a=F^a;f=jv(b|0,a|0,27)|0;b=f^b;a=F^a;f=uv(b|0,a|0,1332534557,625341585)|0;e=1004976+(i<<12)+(d<<3)+3072|0;c[e>>2]=f;c[e+4>>2]=F;d=d+1|0}while((d|0)!=64);i=i+1|0}while((i|0)!=2);d=jv(b|0,a|0,12)|0;b=d^b;a=F^a;d=ov(b|0,a|0,25)|0;b=d^b;a=F^a;d=jv(b|0,a|0,27)|0;b=d^b;a=F^a;d=uv(b|0,a|0,1332534557,625341585)|0;e=1013168;c[e>>2]=d;c[e+4>>2]=F;e=jv(b|0,a|0,12)|0;b=e^b;a=F^a;e=ov(b|0,a|0,25)|0;b=e^b;a=F^a;e=jv(b|0,a|0,27)|0;b=e^b;a=F^a;e=uv(b|0,a|0,1332534557,625341585)|0;d=1013176|0;c[d>>2]=e;c[d+4>>2]=F;d=jv(b|0,a|0,12)|0;b=d^b;a=F^a;d=ov(b|0,a|0,25)|0;b=d^b;a=F^a;d=jv(b|0,a|0,27)|0;b=d^b;a=F^a;d=uv(b|0,a|0,1332534557,625341585)|0;e=1013184|0;c[e>>2]=d;c[e+4>>2]=F;e=jv(b|0,a|0,12)|0;b=e^b;a=F^a;e=ov(b|0,a|0,25)|0;b=e^b;a=F^a;e=jv(b|0,a|0,27)|0;b=e^b;a=F^a;e=uv(b|0,a|0,1332534557,625341585)|0;d=1013192|0;c[d>>2]=e;c[d+4>>2]=F;d=jv(b|0,a|0,12)|0;b=d^b;a=F^a;d=ov(b|0,a|0,25)|0;b=d^b;a=F^a;d=jv(b|0,a|0,27)|0;b=d^b;a=F^a;d=uv(b|0,a|0,1332534557,625341585)|0;e=1013200|0;c[e>>2]=d;c[e+4>>2]=F;e=jv(b|0,a|0,12)|0;b=e^b;a=F^a;e=ov(b|0,a|0,25)|0;b=e^b;a=F^a;e=jv(b|0,a|0,27)|0;b=e^b;a=F^a;e=uv(b|0,a|0,1332534557,625341585)|0;d=1013208|0;c[d>>2]=e;c[d+4>>2]=F;d=jv(b|0,a|0,12)|0;b=d^b;a=F^a;d=ov(b|0,a|0,25)|0;b=d^b;a=F^a;d=jv(b|0,a|0,27)|0;b=d^b;a=F^a;d=uv(b|0,a|0,1332534557,625341585)|0;e=1013216|0;c[e>>2]=d;c[e+4>>2]=F;e=jv(b|0,a|0,12)|0;b=e^b;a=F^a;e=ov(b|0,a|0,25)|0;b=e^b;a=F^a;e=jv(b|0,a|0,27)|0;b=e^b;a=F^a;e=uv(b|0,a|0,1332534557,625341585)|0;d=1013224|0;c[d>>2]=e;c[d+4>>2]=F;d=0;do{while(1){if(d)break;d=d+1|0}g=1013232+(d<<3)|0;h=d;i=((d|0)<0)<<31>>31;do{f=_c(h,i)|0;e=iv(h|0,i|0,-1,-1)|0;h=e&h;i=F&i;f=ov(1,0,f|0)|0;f=1013232+(f<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if((e|0)==0&(f|0)==0){e=jv(b|0,a|0,12)|0;b=e^b;a=F^a;e=ov(b|0,a|0,25)|0;b=e^b;a=F^a;e=jv(b|0,a|0,27)|0;b=e^b;a=F^a;e=uv(b|0,a|0,1332534557,625341585)|0;f=F}k=g;j=c[k+4>>2]^f;f=g;c[f>>2]=c[k>>2]^e;c[f+4>>2]=j}while(!((h|0)==0&(i|0)==0));d=d+1|0}while((d|0)!=16);e=jv(b|0,a|0,12)|0;b=e^b;a=F^a;e=ov(b|0,a|0,25)|0;b=e^b;a=F^a;e=jv(b|0,a|0,27)|0;b=e^b;a=F^a;e=uv(b|0,a|0,1332534557,625341585)|0;d=1013360;c[d>>2]=e;c[d+4>>2]=F;d=jv(b|0,a|0,12)|0;b=d^b;a=F^a;d=ov(b|0,a|0,25)|0;b=d^b;a=F^a;d=jv(b|0,a|0,27)|0;a=uv(d^b|0,F^a|0,1332534557,625341585)|0;b=1013368;c[b>>2]=a;c[b+4>>2]=F;b=1;do{d=1004848+(b<<2)|0;e=b|8;c[1004848+(e<<2)>>2]=c[d>>2];a=1004912+(b<<2)|0;c[1004912+(e<<2)>>2]=c[a>>2];a=(c[d>>2]<<16)+(c[a>>2]|0)|0;d=0;do{e=(c[1003056+(b<<8)+(d<<2)>>2]|0)+a|0;c[1013568+(b<<8)+(d<<2)>>2]=e;c[1013568+(b<<8)+((d^56)<<2)+2048>>2]=0-e;d=d+1|0}while((d|0)!=64);b=b+1|0}while((b|0)!=7);return}function Xf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;mv(a|0,b|0,2232)|0;b=a+2128|0;d=a+2220|0;e=b+0|0;f=(c[d>>2]|0)+0|0;g=e+72|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(g|0));c[d>>2]=b;b=a+2200|0;c[b>>2]=0;c[b+4>>2]=0;return a|0}function Yf(a){a=a|0;var b=0;kv(a|0,0,2232)|0;c[a+2168>>2]=64;c[a+2220>>2]=a+2128;b=0;do{c[a+(b<<6)+912>>2]=64;c[a+(b<<6)+400>>2]=64;c[a+(b<<6)+916>>2]=64;c[a+(b<<6)+404>>2]=64;c[a+(b<<6)+920>>2]=64;c[a+(b<<6)+408>>2]=64;c[a+(b<<6)+924>>2]=64;c[a+(b<<6)+412>>2]=64;c[a+(b<<6)+928>>2]=64;c[a+(b<<6)+416>>2]=64;c[a+(b<<6)+932>>2]=64;c[a+(b<<6)+420>>2]=64;c[a+(b<<6)+936>>2]=64;c[a+(b<<6)+424>>2]=64;c[a+(b<<6)+940>>2]=64;c[a+(b<<6)+428>>2]=64;c[a+(b<<6)+944>>2]=64;c[a+(b<<6)+432>>2]=64;c[a+(b<<6)+948>>2]=64;c[a+(b<<6)+436>>2]=64;c[a+(b<<6)+952>>2]=64;c[a+(b<<6)+440>>2]=64;c[a+(b<<6)+956>>2]=64;c[a+(b<<6)+444>>2]=64;c[a+(b<<6)+960>>2]=64;c[a+(b<<6)+448>>2]=64;c[a+(b<<6)+964>>2]=64;c[a+(b<<6)+452>>2]=64;c[a+(b<<6)+968>>2]=64;c[a+(b<<6)+456>>2]=64;c[a+(b<<6)+972>>2]=64;c[a+(b<<6)+460>>2]=64;b=b+1|0}while((b|0)!=8);return}function Zf(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;v=i;i=i+144|0;o=v+141|0;m=v+140|0;u=v;r=u+60|0;s=u+8|0;c[u>>2]=1017916;c[r>>2]=1017936;c[u+4>>2]=0;ij(u+60|0,s);c[u+132>>2]=0;c[u+136>>2]=-1;c[u>>2]=1017860;c[r>>2]=1017880;nj(s);c[s>>2]=1000496;t=u+40|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[u+56>>2]=8;Ae(s,e);Yf(b);p=u+((c[(c[u>>2]|0)+-12>>2]|0)+4)|0;c[p>>2]=c[p>>2]&-4097;p=b+256|0;j=0;l=56;a:while(1){while(1){Xj(o,u,0);do if(!(a[o>>0]|0))k=j;else{k=c[u+((c[(c[u>>2]|0)+-12>>2]|0)+24)>>2]|0;h=k+12|0;e=c[h>>2]|0;if((e|0)==(c[k+16>>2]|0)){e=fc[c[(c[k>>2]|0)+40>>2]&127](k)|0;if((e|0)==-1){k=c[(c[u>>2]|0)+-12>>2]|0;dj(u+k|0,c[u+(k+16)>>2]|6);k=j;break}}else{c[h>>2]=e+1;e=d[e>>0]|0}k=e&255}while(0);if(c[u+((c[(c[u>>2]|0)+-12>>2]|0)+16)>>2]&5)break a;j=k&255;if(yu(j)|0)break a;h=j+-48|0;if(h>>>0<10){j=k;e=12;break}if(k<<24>>24==47){e=14;break}j=Ri(1013376,k,0)|0;if((j|0)==-1)j=k;else{e=16;break}}if((e|0)==12){l=h+l|0;continue}else if((e|0)==14){j=47;l=l+-16|0;continue}else if((e|0)==16){n=j>>3;h=j&7;c[b+(l<<2)>>2]=n<<3|h;w=46496+(l<<3)|0;y=w;x=p;j=c[x+4>>2]|c[y+4>>2];e=p;c[e>>2]=c[x>>2]|c[y>>2];c[e+4>>2]=j;e=b+(h<<3)+256|0;j=w;y=e;x=c[y+4>>2]|c[j+4>>2];c[e>>2]=c[y>>2]|c[j>>2];c[e+4>>2]=x;e=b+(n<<3)+320|0;x=e;j=c[x+4>>2]|c[w+4>>2];c[e>>2]=c[x>>2]|c[w>>2];c[e+4>>2]=j;e=b+(n<<5)+(h<<2)+336|0;j=c[e>>2]|0;c[e>>2]=j+1;c[b+(l<<2)+1424>>2]=j;c[b+(n<<9)+(h<<6)+(j<<2)+400>>2]=l;j=b+(n<<5)+336|0;c[j>>2]=(c[j>>2]|0)+1;j=k;l=l+1|0;continue}}Xj(o,u,0);do if(a[o>>0]|0){j=c[u+((c[(c[u>>2]|0)+-12>>2]|0)+24)>>2]|0;h=j+12|0;e=c[h>>2]|0;if((e|0)==(c[j+16>>2]|0)){e=fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;if((e|0)==-1){n=c[(c[u>>2]|0)+-12>>2]|0;dj(u+n|0,c[u+(n+16)>>2]|6);break}}else{c[h>>2]=e+1;e=d[e>>0]|0}k=e&255}while(0);n=b+2212|0;c[n>>2]=k<<24>>24!=119&1;Xj(m,u,0);do if(!(a[m>>0]|0))e=k;else{j=c[u+((c[(c[u>>2]|0)+-12>>2]|0)+24)>>2]|0;h=j+12|0;e=c[h>>2]|0;if((e|0)==(c[j+16>>2]|0)){e=fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;if((e|0)==-1){e=c[(c[u>>2]|0)+-12>>2]|0;dj(u+e|0,c[u+(e+16)>>2]|6);e=k;break}}else{c[h>>2]=e+1;e=d[e>>0]|0}e=e&255}while(0);k=e;while(1){Xj(o,u,0);do if(!(a[o>>0]|0))e=k;else{j=c[u+((c[(c[u>>2]|0)+-12>>2]|0)+24)>>2]|0;h=j+12|0;e=c[h>>2]|0;if((e|0)==(c[j+16>>2]|0)){e=fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;if((e|0)==-1){e=c[(c[u>>2]|0)+-12>>2]|0;dj(u+e|0,c[u+(e+16)>>2]|6);e=k;break}}else{c[h>>2]=e+1;e=d[e>>0]|0}e=e&255}while(0);if(c[u+((c[(c[u>>2]|0)+-12>>2]|0)+16)>>2]&5)break;h=e&255;if(yu(h)|0)break;e=(Ys(h)|0)!=0;l=e&1;j=Zs(h)|0;k=j&255;j=j&255;if((j|0)==81){h=e?56:0;while(1)if((c[b+(h<<2)>>2]&7|0)==4)break;else h=h+1|0}else if((j|0)==75){h=e?63:7;while(1)if((c[b+(h<<2)>>2]&7|0)==4)break;else h=h+-1|0}else{j=j+-65|0;if(j>>>0>=8)continue;h=j|(e?56:0)}_f(b,l,h)}Xj(o,u,0);do if(!(a[o>>0]|0))l=0;else{h=c[u+((c[(c[u>>2]|0)+-12>>2]|0)+24)>>2]|0;e=h+12|0;j=c[e>>2]|0;if((j|0)==(c[h+16>>2]|0)){e=fc[c[(c[h>>2]|0)+40>>2]&127](h)|0;if((e|0)==-1){l=c[(c[u>>2]|0)+-12>>2]|0;dj(u+l|0,c[u+(l+16)>>2]|6);l=0;break}}else{c[e>>2]=j+1;e=d[j>>0]|0}l=e&255}while(0);e=c[u>>2]|0;if((l+-97&255)<8?(c[u+((c[e+-12>>2]|0)+16)>>2]&5|0)==0:0){Xj(o,u,0);do if(!(a[o>>0]|0))h=0;else{j=c[u+((c[(c[u>>2]|0)+-12>>2]|0)+24)>>2]|0;h=j+12|0;e=c[h>>2]|0;if((e|0)==(c[j+16>>2]|0)){e=fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;if((e|0)==-1){h=c[(c[u>>2]|0)+-12>>2]|0;dj(u+h|0,c[u+(h+16)>>2]|6);h=0;break}}else{c[h>>2]=e+1;e=d[e>>0]|0}h=e&255}while(0);e=c[u>>2]|0;if(((c[u+((c[e+-12>>2]|0)+16)>>2]&5|0)==0?h<<24>>24==54|h<<24>>24==51:0)?(o=((h&255)<<3)+-392|(l&255)+-97,q=(c[b+2220>>2]|0)+40|0,c[q>>2]=o,D=p,k=c[D>>2]|0,D=c[D+4>>2]|0,z=51936+(o<<3)|0,A=b+320|0,y=b+264|0,F=c[y>>2]|0,y=c[y+4>>2]|0,C=47840+(o<<3)|0,B=b+328|0,w=48352+(o<<3)|0,x=b+272|0,h=44448+(o<<3)|0,j=43936+(o<<3)|0,j=(ba(c[h+4>>2]&D,c[j+4>>2]|0)|0)^(ba(c[h>>2]&k,c[j>>2]|0)|0),j=(c[43424+(o<<2)>>2]|0)+(j>>>(c[44960+(o<<2)>>2]|0)<<3)|0,h=b+288|0,l=b+296|0,E=c[l>>2]|0,l=c[l+4>>2]|0,p=45728+(o<<3)|0,m=45216+(o<<3)|0,m=(ba(c[p+4>>2]&D,c[m+4>>2]|0)|0)^(ba(c[p>>2]&k,c[m>>2]|0)|0),m=(c[43680+(o<<2)>>2]|0)+(m>>>(c[46240+(o<<2)>>2]|0)<<3)|0,k=b+280|0,p=50400+(o<<3)|0,o=b+304|0,D=b+(c[n>>2]<<3)+320|0,(c[D>>2]&F&(c[C>>2]&F&c[B>>2]|c[A>>2]&c[z>>2]&F|c[x>>2]&c[w>>2]|(E|c[h>>2])&c[j>>2]|(c[k>>2]|E)&c[m>>2]|c[o>>2]&c[p>>2])|0)==0?(c[D+4>>2]&y&(c[C+4>>2]&y&c[B+4>>2]|c[A+4>>2]&c[z+4>>2]&y|c[x+4>>2]&c[w+4>>2]|(l|c[h+4>>2])&c[j+4>>2]|(c[k+4>>2]|l)&c[m+4>>2]|c[o+4>>2]&c[p+4>>2])|0)==0:0):0)c[q>>2]=64}z=u+((c[e+-12>>2]|0)+4)|0;c[z>>2]=c[z>>2]|4096;z=b+2220|0;y=b+2208|0;Zj(Zj(u,(c[z>>2]|0)+28|0)|0,y)|0;x=(c[y>>2]<<1)+-2|0;c[y>>2]=((x|0)<0?0:x)|(c[n>>2]|0)==1;a[b+2224>>0]=f&1;c[b+2216>>2]=g;$f(b,c[z>>2]|0);c[u>>2]=1017860;c[r>>2]=1017880;c[s>>2]=1000496;Bi(t);kj(s);fj(u+60|0);i=v;return}function _f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;i=c[a+(b<<9)+784>>2]|0;g=(i|0)<(d|0);h=1<<((g&1|b<<1)^1);e=(c[a+2220>>2]|0)+24|0;c[e>>2]=h|c[e>>2];e=a+(i<<2)+1680|0;c[e>>2]=h|c[e>>2];e=a+(d<<2)+1680|0;c[e>>2]=h|c[e>>2];c[a+(h<<2)+1936>>2]=d;e=b*56|0;b=(g?5:3)|e;f=(b|0)>(d|0)?b:d;h=a+(h<<3)+2e3|0;b=(b|0)<(d|0)?b:d;while(1){if(!((b|0)==(i|0)|(b|0)==(d|0))){k=46496+(b<<3)|0;l=h;j=c[l+4>>2]|c[k+4>>2];a=h;c[a>>2]=c[l>>2]|c[k>>2];c[a+4>>2]=j}if((b|0)<(f|0))b=b+1|0;else break}b=(g?6:2)|e;a=(i|0)<(b|0)?b:i;b=(b|0)<(i|0)?b:i;while(1){if(!((b|0)==(i|0)|(b|0)==(d|0))){g=46496+(b<<3)|0;f=h;j=c[f+4>>2]|c[g+4>>2];k=h;c[k>>2]=c[f>>2]|c[g>>2];c[k+4>>2]=j}if((b|0)<(a|0))b=b+1|0;else break}return}function $f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=b+8|0;h=b+48|0;k=h;c[k>>2]=0;c[k+4>>2]=0;k=b+20|0;l=b+16|0;e=b+36|0;c[e>>2]=0;d=a+2212|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;n=c[d>>2]|0;o=c[a+(n<<9)+784>>2]|0;f=a+256|0;C=f;s=c[C>>2]|0;C=c[C+4>>2]|0;y=51936+(o<<3)|0;z=a+320|0;i=a+264|0;g=i;x=c[g>>2]|0;g=c[g+4>>2]|0;B=47840+(o<<3)|0;A=a+328|0;v=48352+(o<<3)|0;w=a+272|0;u=44448+(o<<3)|0;t=43936+(o<<3)|0;t=(ba(c[u+4>>2]&C,c[t+4>>2]|0)|0)^(ba(c[u>>2]&s,c[t>>2]|0)|0);t=(c[43424+(o<<2)>>2]|0)+(t>>>(c[44960+(o<<2)>>2]|0)<<3)|0;u=a+288|0;m=a+296|0;r=c[m>>2]|0;m=c[m+4>>2]|0;p=45728+(o<<3)|0;q=45216+(o<<3)|0;q=(ba(c[p+4>>2]&C,c[q+4>>2]|0)|0)^(ba(c[p>>2]&s,c[q>>2]|0)|0);q=(c[43680+(o<<2)>>2]|0)+(q>>>(c[46240+(o<<2)>>2]|0)<<3)|0;s=a+280|0;o=50400+(o<<3)|0;p=a+304|0;n=a+((n^1)<<3)+320|0;m=(c[B+4>>2]&g&c[A+4>>2]|c[z+4>>2]&c[y+4>>2]&g|c[w+4>>2]&c[v+4>>2]|(m|c[u+4>>2])&c[t+4>>2]|(c[s+4>>2]|m)&c[q+4>>2]|c[p+4>>2]&c[o+4>>2])&c[n+4>>2];g=b+56|0;c[g>>2]=(c[B>>2]&x&c[A>>2]|c[z>>2]&c[y>>2]&x|c[w>>2]&c[v>>2]|(r|c[u>>2])&c[t>>2]|(c[s>>2]|r)&c[q>>2]|c[p>>2]&c[o>>2])&c[n>>2];c[g+4>>2]=m;g=c[f>>2]|0;f=c[f+4>>2]|0;if(!((g|0)==0&(f|0)==0))do{w=_c(g,f)|0;u=iv(g|0,f|0,-1,-1)|0;g=u&g;f=F&f;u=c[a+(w<<2)>>2]|0;v=u&7;u=u>>3;r=1004976+(u<<12)+(v<<9)+(w<<3)|0;q=h;s=c[q+4>>2]^c[r+4>>2];t=h;c[t>>2]=c[q>>2]^c[r>>2];c[t+4>>2]=s;c[e>>2]=(c[e>>2]|0)+(c[1013568+(u<<11)+(v<<8)+(w<<2)>>2]|0)}while(!((g|0)==0&(f|0)==0));e=c[a+2220>>2]|0;g=c[e+40>>2]|0;if((g|0)!=64){u=1013168+((g&7)<<3)|0;t=h;v=c[t+4>>2]^c[u+4>>2];w=h;c[w>>2]=c[t>>2]^c[u>>2];c[w+4>>2]=v}if((c[d>>2]|0)==1){f=1013360;w=h;g=c[w>>2]^c[f>>2];f=c[w+4>>2]^c[f+4>>2];w=h;c[w>>2]=g;c[w+4>>2]=f}else{f=h;g=c[f>>2]|0;f=c[f+4>>2]|0}w=1013232+(c[e+24>>2]<<3)|0;d=f^c[w+4>>2];e=h;c[e>>2]=g^c[w>>2];c[e+4>>2]=d;e=i;d=c[e>>2]|0;e=c[e+4>>2]|0;if((d|0)==0&(e|0)==0)b=0;else{do{u=_c(d,e)|0;t=iv(d|0,e|0,-1,-1)|0;d=t&d;e=F&e;u=1004976+(c[a+(u<<2)>>2]>>3<<12)+(u<<3)+512|0;t=b;v=c[t+4>>2]^c[u+4>>2];w=b;c[w>>2]=c[t>>2]^c[u>>2];c[w+4>>2]=v}while(!((d|0)==0&(e|0)==0));b=0}do{e=c[a+(b<<5)+340>>2]|0;if((e|0)>0){f=j;d=c[f>>2]|0;f=c[f+4>>2]|0;g=0;do{w=1004976+(b<<12)+(g<<3)+512|0;d=d^c[w>>2];f=f^c[w+4>>2];w=j;c[w>>2]=d;c[w+4>>2]=f;g=g+1|0}while((g|0)<(e|0))}f=c[a+(b<<5)+344>>2]|0;if((f|0)>0){d=j;e=c[d>>2]|0;d=c[d+4>>2]|0;g=0;do{w=1004976+(b<<12)+(g<<3)+1024|0;e=e^c[w>>2];d=d^c[w+4>>2];w=j;c[w>>2]=e;c[w+4>>2]=d;g=g+1|0}while((g|0)<(f|0))}f=c[a+(b<<5)+348>>2]|0;if((f|0)>0){d=j;e=c[d>>2]|0;d=c[d+4>>2]|0;g=0;do{w=1004976+(b<<12)+(g<<3)+1536|0;e=e^c[w>>2];d=d^c[w+4>>2];w=j;c[w>>2]=e;c[w+4>>2]=d;g=g+1|0}while((g|0)<(f|0))}f=c[a+(b<<5)+352>>2]|0;if((f|0)>0){d=j;e=c[d>>2]|0;d=c[d+4>>2]|0;g=0;do{w=1004976+(b<<12)+(g<<3)+2048|0;e=e^c[w>>2];d=d^c[w+4>>2];w=j;c[w>>2]=e;c[w+4>>2]=d;g=g+1|0}while((g|0)<(f|0))}f=c[a+(b<<5)+356>>2]|0;if((f|0)>0){d=j;e=c[d>>2]|0;d=c[d+4>>2]|0;g=0;do{w=1004976+(b<<12)+(g<<3)+2560|0;e=e^c[w>>2];d=d^c[w+4>>2];w=j;c[w>>2]=e;c[w+4>>2]=d;g=g+1|0}while((g|0)<(f|0))}f=c[a+(b<<5)+360>>2]|0;if((f|0)>0){d=j;e=c[d>>2]|0;d=c[d+4>>2]|0;g=0;do{w=1004976+(b<<12)+(g<<3)+3072|0;e=e^c[w>>2];d=d^c[w+4>>2];w=j;c[w>>2]=e;c[w+4>>2]=d;g=g+1|0}while((g|0)<(f|0))}b=b+1|0}while((b|0)!=2);w=ba(c[251214]|0,c[a+344>>2]|0)|0;w=(c[l>>2]|0)+w|0;c[l>>2]=w;w=w+(ba(c[251215]|0,c[a+348>>2]|0)|0)|0;c[l>>2]=w;w=w+(ba(c[251216]|0,c[a+352>>2]|0)|0)|0;c[l>>2]=w;c[l>>2]=w+(ba(c[251217]|0,c[a+356>>2]|0)|0);w=ba(c[251214]|0,c[a+376>>2]|0)|0;w=(c[k>>2]|0)+w|0;c[k>>2]=w;w=w+(ba(c[251215]|0,c[a+380>>2]|0)|0)|0;c[k>>2]=w;w=w+(ba(c[251216]|0,c[a+384>>2]|0)|0)|0;c[k>>2]=w;c[k>>2]=w+(ba(c[251217]|0,c[a+388>>2]|0)|0);return}function ag(a){a=a|0;a=c[a+2220>>2]|0;a=(c[a+20>>2]|0)+(c[a+16>>2]|0)|0;a=(a|0)>15581?15581:a;return ((a|0)>3998?((a<<7)+-511744|0)/11583|0:0)|0}function bg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;j=c[a+(d<<9)+784>>2]|0;g=a+288|0;k=a+296|0;n=c[k>>2]|0;k=c[k+4>>2]|0;f=64736+(j<<3)|0;m=a+280|0;l=64224+(j<<3)|0;e=a+((d^1)<<3)+320|0;i=a+256|0;h=a+(b<<3)+320|0;b=0;d=0;a=((c[m>>2]|n)&c[l>>2]|(n|c[g>>2])&c[f>>2])&c[e>>2];e=((c[m+4>>2]|k)&c[l+4>>2]|(k|c[g+4>>2])&c[f+4>>2])&c[e+4>>2];a:while(1){do{if((a|0)==0&(e|0)==0)break a;f=_c(a,e)|0;k=iv(a|0,e|0,-1,-1)|0;a=k&a;e=F&e;f=99552+(j<<9)+(f<<3)|0;k=i;g=c[k>>2]&c[f>>2];f=c[k+4>>2]&c[f+4>>2];k=iv(g|0,f|0,-1,-1)|0}while(!((k&g|0)==0&(F&f|0)==0));k=h;b=c[k>>2]&g|b;d=c[k+4>>2]&f|d}F=d;return b|0}function cg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;n=51936+(b<<3)|0;o=a+320|0;s=a+264|0;m=c[s>>2]|0;s=c[s+4>>2]|0;q=47840+(b<<3)|0;p=a+328|0;k=48352+(b<<3)|0;l=a+272|0;j=44448+(b<<3)|0;i=43936+(b<<3)|0;i=(ba(c[j+4>>2]&e,c[i+4>>2]|0)|0)^(ba(c[j>>2]&d,c[i>>2]|0)|0);i=(c[43424+(b<<2)>>2]|0)+(i>>>(c[44960+(b<<2)>>2]|0)<<3)|0;j=a+288|0;r=a+296|0;g=c[r>>2]|0;r=c[r+4>>2]|0;h=45728+(b<<3)|0;f=45216+(b<<3)|0;f=(ba(c[h+4>>2]&e,c[f+4>>2]|0)|0)^(ba(c[h>>2]&d,c[f>>2]|0)|0);f=(c[43680+(b<<2)>>2]|0)+(f>>>(c[46240+(b<<2)>>2]|0)<<3)|0;h=a+280|0;d=50400+(b<<3)|0;e=a+304|0;F=c[q+4>>2]&s&c[p+4>>2]|c[o+4>>2]&c[n+4>>2]&s|c[l+4>>2]&c[k+4>>2]|(r|c[j+4>>2])&c[i+4>>2]|(c[h+4>>2]|r)&c[f+4>>2]|c[e+4>>2]&c[d+4>>2];return c[q>>2]&m&c[p>>2]|c[o>>2]&c[n>>2]&m|c[l>>2]&c[k>>2]|(g|c[j>>2])&c[i>>2]|(c[h>>2]|g)&c[f>>2]|c[e>>2]&c[d>>2]|0}function dg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=c[a+2212>>2]|0;g=b>>>6&63;f=b&49152;if((f|0)==32768){j=c[a+(i<<9)+784>>2]|0;b=b&63;f=a+256|0;k=46496+(g<<3)|0;h=46496+(b-((i|0)==0?8:-8)<<3)|0;g=46496+(b<<3)|0;b=c[g>>2]|c[k>>2]^c[f>>2]^c[h>>2];h=c[g+4>>2]|c[k+4>>2]^c[f+4>>2]^c[h+4>>2];f=44448+(j<<3)|0;k=43936+(j<<3)|0;k=(ba(c[f+4>>2]&h,c[k+4>>2]|0)|0)^(ba(c[f>>2]&b,c[k>>2]|0)|0);k=(c[43424+(j<<2)>>2]|0)+(k>>>(c[44960+(j<<2)>>2]|0)<<3)|0;f=a+((i^1)<<3)+320|0;g=c[f>>2]|0;f=c[f+4>>2]|0;d=a+296|0;e=c[d>>2]|0;d=c[d+4>>2]|0;i=a+288|0;if(!((g&c[k>>2]&(c[i>>2]|e)|0)==0?(f&c[k+4>>2]&(c[i+4>>2]|d)|0)==0:0)){d=0;return d|0}k=45728+(j<<3)|0;i=45216+(j<<3)|0;h=(ba(c[k+4>>2]&h,c[i+4>>2]|0)|0)^(ba(c[k>>2]&b,c[i>>2]|0)|0);h=(c[43680+(j<<2)>>2]|0)+(h>>>(c[46240+(j<<2)>>2]|0)<<3)|0;b=a+280|0;d=(c[h>>2]&g&(c[b>>2]|e)|0)==0?(c[h+4>>2]&f&(c[b+4>>2]|d)|0)==0:0;return d|0}if((c[a+(g<<2)>>2]&7|0)==6){if((f|0)==49152){d=1;return d|0}e=b&63;d=a+256|0;h=c[d>>2]|0;d=c[d+4>>2]|0;o=51936+(e<<3)|0;p=a+320|0;n=a+264|0;t=c[n>>2]|0;n=c[n+4>>2]|0;r=47840+(e<<3)|0;q=a+328|0;l=48352+(e<<3)|0;m=a+272|0;k=44448+(e<<3)|0;j=43936+(e<<3)|0;j=(ba(c[k+4>>2]&d,c[j+4>>2]|0)|0)^(ba(c[k>>2]&h,c[j>>2]|0)|0);j=(c[43424+(e<<2)>>2]|0)+(j>>>(c[44960+(e<<2)>>2]|0)<<3)|0;k=a+288|0;b=a+296|0;s=c[b>>2]|0;b=c[b+4>>2]|0;f=45728+(e<<3)|0;g=45216+(e<<3)|0;g=(ba(c[f+4>>2]&d,c[g+4>>2]|0)|0)^(ba(c[f>>2]&h,c[g>>2]|0)|0);g=(c[43680+(e<<2)>>2]|0)+(g>>>(c[46240+(e<<2)>>2]|0)<<3)|0;h=a+280|0;e=50400+(e<<3)|0;f=a+304|0;d=a+((i^1)<<3)+320|0;d=((c[r>>2]&t&c[q>>2]|c[p>>2]&c[o>>2]&t|c[m>>2]&c[l>>2]|(s|c[k>>2])&c[j>>2]|(c[h>>2]|s)&c[g>>2]|c[f>>2]&c[e>>2])&c[d>>2]|0)==0?((c[r+4>>2]&n&c[q+4>>2]|c[p+4>>2]&c[o+4>>2]&n|c[m+4>>2]&c[l+4>>2]|(b|c[k+4>>2])&c[j+4>>2]|(c[h+4>>2]|b)&c[g+4>>2]|c[f+4>>2]&c[e+4>>2])&c[d+4>>2]|0)==0:0;return d|0}if((d|0)==0&(e|0)==0){k=1;return k|0}k=46496+(g<<3)|0;if((c[k>>2]&d|0)==0?(c[k+4>>2]&e|0)==0:0){k=1;return k|0}k=66784+(g<<9)+((b&63)<<3)|0;a=46496+(c[a+(i<<9)+784>>2]<<3)|0;k=(c[a>>2]&c[k>>2]|0)!=0?1:(c[a+4>>2]&c[k+4>>2]|0)!=0;return k|0}function eg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;m=i;i=i+2064|0;d=m;j=c[a+2212>>2]|0;k=b>>>6&63;l=b&63;f=c[a+(k<<2)>>2]|0;if(b&49152){c[d+2048>>2]=d;e=Af(a,d)|0;c[d+2052>>2]=e;c[e>>2]=0;if((d|0)==(e|0)){a=0;i=m;return a|0}while(1){if((c[d>>2]|0)==(b|0)){d=1;e=23;break}d=d+8|0;if((d|0)==(e|0)){d=0;e=23;break}}if((e|0)==23){i=m;return d|0}}if(!((f|0)!=0&(b&12288|0)==0&(f>>3|0)==(j|0))){a=0;i=m;return a|0}h=a+(j<<3)+320|0;g=46496+(l<<3)|0;e=g;b=c[e>>2]|0;e=c[e+4>>2]|0;if(!((b&c[h>>2]|0)==0?(e&c[h+4>>2]|0)==0:0)){a=0;i=m;return a|0}h=f&7;do if((h|0)==1){d=j*7|0;if((l>>>3|0)==(d^7|0)){a=0;i=m;return a|0}n=47328+((j<<3|1)<<9)+(k<<3)|0;f=a+((j^1)<<3)+320|0;if((c[n>>2]&b&c[f>>2]|0)==0?(c[n+4>>2]&e&c[f+4>>2]|0)==0:0){e=(j|0)==0?8:-8;if((e+k|0)==(l|0)?(c[a+(l<<2)>>2]|0)==0:0)break;if(((e<<1)+k|0)!=(l|0)){a=0;i=m;return a|0}if((k>>>3|0)!=(d^1|0)){a=0;i=m;return a|0}if(c[a+(l<<2)>>2]|0){a=0;i=m;return a|0}if(c[a+(l-e<<2)>>2]|0){a=0;i=m;return a|0}}}else{d=a+256|0;f=Ff(f,k,c[d>>2]|0,c[d+4>>2]|0)|0;if((f&b|0)==0&(F&e|0)==0){a=0;i=m;return a|0}}while(0);e=a+2220|0;b=(c[e>>2]|0)+56|0;d=c[b>>2]|0;b=c[b+4>>2]|0;do if(!((d|0)==0&(b|0)==0)){if((h|0)==6){v=a+256|0;p=46496+(k<<3)|0;f=c[p>>2]^c[v>>2];v=c[p+4>>2]^c[v+4>>2];p=51936+(l<<3)|0;q=a+320|0;o=a+264|0;u=c[o>>2]|0;o=c[o+4>>2]|0;s=47840+(l<<3)|0;r=a+328|0;d=48352+(l<<3)|0;n=a+272|0;e=44448+(l<<3)|0;b=43936+(l<<3)|0;b=(ba(c[e+4>>2]&v,c[b+4>>2]|0)|0)^(ba(c[e>>2]&f,c[b>>2]|0)|0);b=(c[43424+(l<<2)>>2]|0)+(b>>>(c[44960+(l<<2)>>2]|0)<<3)|0;e=a+288|0;g=a+296|0;t=c[g>>2]|0;g=c[g+4>>2]|0;k=45728+(l<<3)|0;h=45216+(l<<3)|0;h=(ba(c[k+4>>2]&v,c[h+4>>2]|0)|0)^(ba(c[k>>2]&f,c[h>>2]|0)|0);h=(c[43680+(l<<2)>>2]|0)+(h>>>(c[46240+(l<<2)>>2]|0)<<3)|0;f=a+280|0;l=50400+(l<<3)|0;k=a+304|0;a=a+((j^1)<<3)+320|0;if(((c[s>>2]&u&c[r>>2]|c[q>>2]&c[p>>2]&u|c[n>>2]&c[d>>2]|(t|c[e>>2])&c[b>>2]|(c[f>>2]|t)&c[h>>2]|c[k>>2]&c[l>>2])&c[a>>2]|0)==0?((c[s+4>>2]&o&c[r+4>>2]|c[q+4>>2]&c[p+4>>2]&o|c[n+4>>2]&c[d+4>>2]|(g|c[e+4>>2])&c[b+4>>2]|(c[f+4>>2]|g)&c[h+4>>2]|c[k+4>>2]&c[l+4>>2])&c[a+4>>2]|0)==0:0)break;else d=0;i=m;return d|0}l=iv(d|0,b|0,-1,-1)|0;if(!((l&d|0)==0&(F&b|0)==0)){a=0;i=m;return a|0}l=_c(d,b)|0;a=99552+(l<<9)+(c[a+(j<<9)+784>>2]<<3)|0;l=(c[e>>2]|0)+56|0;k=g;if((c[k>>2]&(c[l>>2]|c[a>>2])|0)==0?(c[k+4>>2]&(c[l+4>>2]|c[a+4>>2])|0)==0:0){a=0;i=m;return a|0}}while(0);a=1;i=m;return a|0}function fg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=b>>>6;j=g&63;e=b&63;i=d+((c[a+(j<<2)>>2]&7)<<3)+16|0;l=46496+(e<<3)|0;k=c[l>>2]|0;l=c[l+4>>2]|0;if(!((k&c[i>>2]|0)==0?(l&c[i+4>>2]|0)==0:0)){l=1;return l|0}h=d;i=c[h>>2]|0;h=c[h+4>>2]|0;if((!((i|0)==0&(h|0)==0)?(f=46496+(j<<3)|0,!((c[f>>2]&i|0)==0?(c[f+4>>2]&h|0)==0:0)):0)?(i=66784+(j<<9)+(e<<3)|0,h=46496+(c[d+80>>2]<<3)|0,(c[h>>2]&c[i>>2]|0)==0?(c[h+4>>2]&c[i+4>>2]|0)==0:0):0){l=1;return l|0}f=b&49152;if((f|0)==49152){g=e>>>0>j>>>0;h=(c[a+2212>>2]|0)*56|0;i=h|(g?5:3);b=64736+(i<<3)|0;f=46496+(c[d+80>>2]<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if((e&c[b>>2]|0)==0?(f&c[b+4>>2]|0)==0:0){l=0;return l|0}b=a+256|0;a=46496+(j<<3)|0;m=46496+(i<<3)|0;d=46496+((h|(g?6:2))<<3)|0;h=44448+(i<<3)|0;j=43936+(i<<3)|0;l=(ba(c[h+4>>2]&(c[m+4>>2]|c[a+4>>2]^c[b+4>>2]^l|c[d+4>>2]),c[j+4>>2]|0)|0)^(ba(c[h>>2]&(c[m>>2]|c[a>>2]^c[b>>2]^k|c[d>>2]),c[j>>2]|0)|0);l=(c[43424+(i<<2)>>2]|0)+(l>>>(c[44960+(i<<2)>>2]|0)<<3)|0;l=(c[l>>2]&e|0)!=0?1:(c[l+4>>2]&f|0)!=0;return l|0}else if((f|0)==16384){k=a+256|0;l=46496+(j<<3)|0;k=Ff((b>>>12&3)+2|0,e,c[l>>2]^c[k>>2],c[l+4>>2]^c[k+4>>2])|0;l=46496+(c[d+80>>2]<<3)|0;l=(c[l>>2]&k|0)!=0?1:(c[l+4>>2]&F|0)!=0;return l|0}else if((f|0)==32768){i=a+256|0;j=46496+(j<<3)|0;m=46496+((g&56|b&7)<<3)|0;f=k|c[j>>2]^c[i>>2]^c[m>>2];m=l|c[j+4>>2]^c[i+4>>2]^c[m+4>>2];i=c[d+80>>2]|0;d=44448+(i<<3)|0;j=43936+(i<<3)|0;j=(ba(c[d+4>>2]&m,c[j+4>>2]|0)|0)^(ba(c[d>>2]&f,c[j>>2]|0)|0);j=(c[43424+(i<<2)>>2]|0)+(j>>>(c[44960+(i<<2)>>2]|0)<<3)|0;d=a+(c[a+2212>>2]<<3)+320|0;g=c[d>>2]|0;d=c[d+4>>2]|0;l=a+296|0;h=c[l>>2]|0;l=c[l+4>>2]|0;k=a+288|0;e=45728+(i<<3)|0;b=45216+(i<<3)|0;b=(ba(c[e+4>>2]&m,c[b+4>>2]|0)|0)^(ba(c[e>>2]&f,c[b>>2]|0)|0);i=(c[43680+(i<<2)>>2]|0)+(b>>>(c[46240+(i<<2)>>2]|0)<<3)|0;b=a+280|0;l=(c[i>>2]&g&(c[b>>2]|h)|g&c[j>>2]&(c[k>>2]|h)|0)!=0?1:(c[i+4>>2]&d&(c[b+4>>2]|l)|d&c[j+4>>2]&(c[k+4>>2]|l)|0)!=0;return l|0}else{l=0;return l|0}return 0}function gg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+96|0;e=d;Tf(e,a);hg(a,b,c,e,fg(a,b,e)|0);i=d;return}function hg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;z=i;i=i+16|0;q=z+8|0;m=z+4|0;n=z;y=a+2200|0;x=y;x=iv(c[x>>2]|0,c[x+4>>2]|0,1,0)|0;c[y>>2]=x;c[y+4>>2]=F;y=(c[254422]|0)+1|0;c[254422]=y;if(!(y&31))Ig();r=a+2220|0;h=c[r>>2]|0;l=h+48|0;k=c[l>>2]|0;l=c[l+4>>2]|0;j=d+0|0;h=h+0|0;g=j+56|0;do{c[j>>2]=c[h>>2];j=j+4|0;h=h+4|0}while((j|0)<(g|0));c[d+68>>2]=c[r>>2];c[r>>2]=d;h=1013360;g=c[h>>2]^k;h=c[h+4>>2]^l;y=a+2208|0;c[y>>2]=(c[y>>2]|0)+1;y=d+28|0;c[y>>2]=(c[y>>2]|0)+1;y=d+32|0;c[y>>2]=(c[y>>2]|0)+1;y=a+2212|0;w=c[y>>2]|0;u=w^1;v=b>>>6&63;l=b&63;c[q>>2]=l;o=a+(v<<2)|0;x=c[o>>2]&7;s=b&49152;k=(s|0)==32768;do if(!k){j=c[a+(l<<2)>>2]&7;if((s|0)==49152){rg(a,v,q,m,n);d=c[r>>2]|0;l=d+36|0;n=c[n>>2]|0;j=c[m>>2]|0;c[l>>2]=(c[1013568+(w<<11)+(n<<2)+1024>>2]|0)-(c[1013568+(w<<11)+(j<<2)+1024>>2]|0)+(c[l>>2]|0);j=1004976+(w<<12)+(j<<3)+2048|0;m=1004976+(w<<12)+(n<<3)+2048|0;n=1;l=c[q>>2]|0;k=c[j>>2]^g^c[m>>2];h=c[j+4>>2]^h^c[m+4>>2];m=0;break}if((j|0)==1)if(k){t=8;break}else{k=l;t=9;break}else if(!j){n=0;k=g;m=0;break}else{k=d+(u<<2)+16|0;c[k>>2]=(c[k>>2]|0)-(c[1004848+(j<<2)>>2]|0);k=l;t=11;break}}else t=8;while(0);if((t|0)==8){k=l+((w|0)==1?8:-8)|0;c[a+(k<<2)>>2]=0;d=c[r>>2]|0;t=9}if((t|0)==9){n=1004976+(u<<12)+(k<<3)+512|0;A=d;m=c[A+4>>2]^c[n+4>>2];j=d;c[j>>2]=c[A>>2]^c[n>>2];c[j+4>>2]=m;j=1;t=11}if((t|0)==11){d=a+256|0;A=46496+(k<<3)|0;B=A;n=d;m=c[n+4>>2]^c[B+4>>2];c[d>>2]=c[n>>2]^c[B>>2];c[d+4>>2]=m;d=a+(j<<3)+256|0;m=A;B=d;n=c[B+4>>2]^c[m+4>>2];c[d>>2]=c[B>>2]^c[m>>2];c[d+4>>2]=n;d=a+(u<<3)+320|0;n=d;m=c[n+4>>2]^c[A+4>>2];c[d>>2]=c[n>>2]^c[A>>2];c[d+4>>2]=m;d=a+(u<<5)+(j<<2)+336|0;m=(c[d>>2]|0)+-1|0;c[d>>2]=m;m=c[a+(u<<9)+(j<<6)+(m<<2)+400>>2]|0;A=c[a+(k<<2)+1424>>2]|0;c[a+(m<<2)+1424>>2]=A;c[a+(u<<9)+(j<<6)+(A<<2)+400>>2]=m;c[a+(u<<9)+(j<<6)+(c[d>>2]<<2)+400>>2]=64;A=a+(u<<5)+336|0;c[A>>2]=(c[A>>2]|0)+-1;A=1004976+(u<<12)+(j<<9)+(k<<3)|0;m=c[A>>2]^g;h=c[A+4>>2]^h;g=1004976+(u<<12)+(j<<9)+(c[d>>2]<<3)|0;d=(c[r>>2]|0)+8|0;A=d;n=c[A+4>>2]^c[g+4>>2];c[d>>2]=c[A>>2]^c[g>>2];c[d+4>>2]=n;d=c[r>>2]|0;n=d+36|0;c[n>>2]=(c[n>>2]|0)-(c[1013568+(u<<11)+(j<<8)+(k<<2)>>2]|0);c[d+28>>2]=0;n=0;k=m;m=j}A=1004976+(w<<12)+(x<<9)+(v<<3)|0;g=1004976+(w<<12)+(x<<9)+(l<<3)|0;j=c[A>>2]^k^c[g>>2];k=c[A+4>>2]^h^c[g+4>>2];h=d+40|0;g=c[h>>2]|0;if((g|0)!=64){g=1013168+((g&7)<<3)|0;j=c[g>>2]^j;k=c[g+4>>2]^k;c[h>>2]=64}d=d+24|0;h=c[d>>2]|0;if((h|0)!=0?(p=c[a+(l<<2)+1680>>2]|c[a+(v<<2)+1680>>2],(p|0)!=0):0){g=1013232+((p&h)<<3)|0;j=c[g>>2]^j;k=c[g+4>>2]^k;c[d>>2]=h&~p}if(!n){h=46496+(v<<3)|0;g=46496+(l<<3)|0;d=c[g>>2]^c[h>>2];h=c[g+4>>2]^c[h+4>>2];g=a+256|0;n=g;p=c[n+4>>2]^h;c[g>>2]=c[n>>2]^d;c[g+4>>2]=p;g=a+(x<<3)+256|0;p=g;n=c[p+4>>2]^h;c[g>>2]=c[p>>2]^d;c[g+4>>2]=n;g=a+(w<<3)+320|0;n=g;h=c[n+4>>2]^h;c[g>>2]=c[n>>2]^d;c[g+4>>2]=h;c[o>>2]=0;c[a+(l<<2)>>2]=x|w<<3;g=c[a+(v<<2)+1424>>2]|0;c[a+(l<<2)+1424>>2]=g;c[a+(w<<9)+(x<<6)+(g<<2)+400>>2]=l}if((x|0)==1){if((l^v|0)==16?(h=47328+((w<<3|1)<<9)+(((w|0)==0?8:-8)+v<<3)|0,d=a+(u<<3)+320|0,g=a+264|0,!((c[d>>2]&c[h>>2]&c[g>>2]|0)==0?(c[d+4>>2]&c[h+4>>2]&c[g+4>>2]|0)==0:0)):0){b=(l+v|0)/2|0;q=c[r>>2]|0;c[q+40>>2]=b;b=1013168+((b&7)<<3)|0;h=c[b>>2]^j;k=c[b+4>>2]^k;j=q}else t=24;do if((t|0)==24)if((s|0)==16384){t=(b>>>12&3)+2|0;b=a+256|0;h=46496+(l<<3)|0;B=h;p=b;d=c[p+4>>2]^c[B+4>>2];n=b;c[n>>2]=c[p>>2]^c[B>>2];c[n+4>>2]=d;n=a+264|0;d=h;B=n;p=c[B+4>>2]^c[d+4>>2];c[n>>2]=c[B>>2]^c[d>>2];c[n+4>>2]=p;n=a+(w<<3)+320|0;p=h;d=n;B=c[d+4>>2]^c[p+4>>2];o=n;c[o>>2]=c[d>>2]^c[p>>2];c[o+4>>2]=B;o=a+(w<<5)+340|0;B=(c[o>>2]|0)+-1|0;c[o>>2]=B;B=c[a+(w<<9)+(B<<2)+464>>2]|0;p=a+(l<<2)+1424|0;d=c[p>>2]|0;c[a+(B<<2)+1424>>2]=d;c[a+(w<<9)+(d<<2)+464>>2]=B;c[a+(w<<9)+(c[o>>2]<<2)+464>>2]=64;d=a+(w<<5)+336|0;c[d>>2]=(c[d>>2]|0)+-1;c[a+(l<<2)>>2]=w<<3|t;B=h;g=b;A=c[g+4>>2]|c[B+4>>2];c[b>>2]=c[g>>2]|c[B>>2];c[b+4>>2]=A;b=a+(t<<3)+256|0;A=h;B=b;g=c[B+4>>2]|c[A+4>>2];c[b>>2]=c[B>>2]|c[A>>2];c[b+4>>2]=g;b=n;g=c[b+4>>2]|c[h+4>>2];c[n>>2]=c[b>>2]|c[h>>2];c[n+4>>2]=g;n=a+(w<<5)+(t<<2)+336|0;g=c[n>>2]|0;c[n>>2]=g+1;c[p>>2]=g;c[a+(w<<9)+(t<<6)+(g<<2)+400>>2]=l;c[d>>2]=(c[d>>2]|0)+1;d=1004976+(w<<12)+(l<<3)+512|0;g=c[d>>2]|0;d=c[d+4>>2]|0;p=1004976+(w<<12)+(t<<9)+(l<<3)|0;h=g^j^c[p>>2];k=d^k^c[p+4>>2];j=c[r>>2]|0;p=j;d=c[p+4>>2]^d;b=j;c[b>>2]=c[p>>2]^g;c[b+4>>2]=d;n=1004976+(w<<12)+(t<<9)+((c[n>>2]|0)+-1<<3)|0;o=1004976+(w<<12)+(c[o>>2]<<3)+512|0;b=j+8|0;d=b;g=c[o+4>>2]^c[n+4>>2]^c[d+4>>2];c[b>>2]=c[o>>2]^c[n>>2]^c[d>>2];c[b+4>>2]=g;b=j+36|0;c[b>>2]=(c[1013568+(w<<11)+(t<<8)+(l<<2)>>2]|0)-(c[1013568+(w<<11)+(l<<2)+256>>2]|0)+(c[b>>2]|0);l=j+(w<<2)+16|0;c[l>>2]=(c[l>>2]|0)+(c[1004848+(t<<2)>>2]|0);l=c[q>>2]|0;break}else{h=j;j=c[r>>2]|0;break}while(0);b=1004976+(w<<12)+(v<<3)+512|0;g=1004976+(w<<12)+(l<<3)+512|0;q=j;t=c[g+4>>2]^c[b+4>>2]^c[q+4>>2];d=j;c[d>>2]=c[g>>2]^c[b>>2]^c[q>>2];c[d+4>>2]=t;d=c[r>>2]|0;c[d+28>>2]=0;j=h}else d=c[r>>2]|0;t=d+36|0;c[t>>2]=(c[1013568+(w<<11)+(x<<8)+(l<<2)>>2]|0)-(c[1013568+(w<<11)+(x<<8)+(v<<2)>>2]|0)+(c[t>>2]|0);c[d+64>>2]=m;m=d+48|0;c[m>>2]=j;c[m+4>>2]=k;m=d+56|0;t=m;c[t>>2]=0;c[t+4>>2]=0;if(!f){x=c[y>>2]|0;x=x^1;c[y>>2]=x;i=z;return}if(s){v=c[a+(u<<9)+784>>2]|0;n=a+256|0;s=c[n>>2]|0;n=c[n+4>>2]|0;j=51936+(v<<3)|0;k=a+320|0;x=a+264|0;h=c[x>>2]|0;x=c[x+4>>2]|0;l=47840+(v<<3)|0;d=a+328|0;b=48352+(v<<3)|0;g=a+272|0;q=44448+(v<<3)|0;r=43936+(v<<3)|0;r=(ba(c[q+4>>2]&n,c[r+4>>2]|0)|0)^(ba(c[q>>2]&s,c[r>>2]|0)|0);r=(c[43424+(v<<2)>>2]|0)+(r>>>(c[44960+(v<<2)>>2]|0)<<3)|0;q=a+288|0;e=a+296|0;t=c[e>>2]|0;e=c[e+4>>2]|0;u=45728+(v<<3)|0;f=45216+(v<<3)|0;f=(ba(c[u+4>>2]&n,c[f+4>>2]|0)|0)^(ba(c[u>>2]&s,c[f>>2]|0)|0);f=(c[43680+(v<<2)>>2]|0)+(f>>>(c[46240+(v<<2)>>2]|0)<<3)|0;s=a+280|0;v=50400+(v<<3)|0;u=a+304|0;w=a+(w<<3)+320|0;e=(c[l+4>>2]&x&c[d+4>>2]|c[k+4>>2]&c[j+4>>2]&x|c[g+4>>2]&c[b+4>>2]|(e|c[q+4>>2])&c[r+4>>2]|(c[s+4>>2]|e)&c[f+4>>2]|c[u+4>>2]&c[v+4>>2])&c[w+4>>2];x=m;c[x>>2]=(c[l>>2]&h&c[d>>2]|c[k>>2]&c[j>>2]&h|c[g>>2]&c[b>>2]|(t|c[q>>2])&c[r>>2]|(c[s>>2]|t)&c[f>>2]|c[u>>2]&c[v>>2])&c[w>>2];c[x+4>>2]=e;x=c[y>>2]|0;x=x^1;c[y>>2]=x;i=z;return}f=e+(x<<3)+16|0;g=46496+(l<<3)|0;h=c[g>>2]|0;g=c[g+4>>2]|0;if((h&c[f>>2]|0)==0?(g&c[f+4>>2]|0)==0:0){h=0;g=0}else{f=m;c[f>>2]=h;c[f+4>>2]=g}k=e;j=c[k>>2]|0;k=c[k+4>>2]|0;if((j|0)==0&(k|0)==0){x=c[y>>2]|0;x=x^1;c[y>>2]=x;i=z;return}e=46496+(v<<3)|0;if((c[e>>2]&j|0)==0?(c[e+4>>2]&k|0)==0:0){x=c[y>>2]|0;x=x^1;c[y>>2]=x;i=z;return}d=c[a+(u<<9)+784>>2]|0;l=a+256|0;if((x|0)!=4){k=l;u=44448+(d<<3)|0;v=43936+(d<<3)|0;v=(ba(c[u+4>>2]&c[k+4>>2],c[v+4>>2]|0)|0)^(ba(c[u>>2]&c[k>>2],c[v>>2]|0)|0);v=(c[43424+(d<<2)>>2]|0)+(v>>>(c[44960+(d<<2)>>2]|0)<<3)|0;k=a+(w<<3)+320|0;u=k;j=a+296|0;e=j;w=a+288|0;h=h|c[u>>2]&c[v>>2]&(c[w>>2]|c[e>>2]);g=g|c[u+4>>2]&c[v+4>>2]&(c[w+4>>2]|c[e+4>>2]);e=m;c[e>>2]=h;c[e+4>>2]=g;if((x|0)==3){x=c[y>>2]|0;x=x^1;c[y>>2]=x;i=z;return}}else{k=a+(w<<3)+320|0;j=a+296|0}f=l;w=45728+(d<<3)|0;u=45216+(d<<3)|0;u=(ba(c[w+4>>2]&c[f+4>>2],c[u+4>>2]|0)|0)^(ba(c[w>>2]&c[f>>2],c[u>>2]|0)|0);u=(c[43680+(d<<2)>>2]|0)+(u>>>(c[46240+(d<<2)>>2]|0)<<3)|0;f=k;w=j;v=a+280|0;e=g|c[f+4>>2]&c[u+4>>2]&(c[v+4>>2]|c[w+4>>2]);x=m;c[x>>2]=h|c[f>>2]&c[u>>2]&(c[v>>2]|c[w>>2]);c[x+4>>2]=e;x=c[y>>2]|0;x=x^1;c[y>>2]=x;i=z;return}function ig(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;p=i;i=i+16|0;e=p+8|0;k=a+2212|0;o=c[k>>2]|0;j=o^1;c[k>>2]=j;k=b>>>6&63;d=b&63;c[e>>2]=d;l=a+(d<<2)|0;n=b&49152;if((n|0)==49152){sg(a,k,e,p+4|0,p);m=a+2220|0;l=c[m>>2]|0;l=l+68|0;l=c[l>>2]|0;c[m>>2]=l;m=a+2208|0;l=c[m>>2]|0;l=l+-1|0;c[m>>2]=l;i=p;return}else if((n|0)==16384){g=(b>>>12&3)+2|0;m=a+256|0;e=46496+(d<<3)|0;t=e;b=m;r=c[b+4>>2]^c[t+4>>2];f=m;c[f>>2]=c[b>>2]^c[t>>2];c[f+4>>2]=r;f=a+(g<<3)+256|0;r=e;t=f;b=c[t+4>>2]^c[r+4>>2];c[f>>2]=c[t>>2]^c[r>>2];c[f+4>>2]=b;f=a+(j<<3)+320|0;b=e;r=f;t=c[r+4>>2]^c[b+4>>2];h=f;c[h>>2]=c[r>>2]^c[b>>2];c[h+4>>2]=t;h=a+(j<<5)+(g<<2)+336|0;t=(c[h>>2]|0)+-1|0;c[h>>2]=t;t=c[a+(j<<9)+(g<<6)+(t<<2)+400>>2]|0;b=a+(d<<2)+1424|0;r=c[b>>2]|0;c[a+(t<<2)+1424>>2]=r;c[a+(j<<9)+(g<<6)+(r<<2)+400>>2]=t;c[a+(j<<9)+(g<<6)+(c[h>>2]<<2)+400>>2]=64;h=a+(j<<5)+336|0;c[h>>2]=(c[h>>2]|0)+-1;g=j<<3;c[l>>2]=g|1;r=e;t=m;q=c[t+4>>2]|c[r+4>>2];s=m;c[s>>2]=c[t>>2]|c[r>>2];c[s+4>>2]=q;s=a+264|0;q=e;r=s;t=c[r+4>>2]|c[q+4>>2];c[s>>2]=c[r>>2]|c[q>>2];c[s+4>>2]=t;s=e;t=f;q=c[t+4>>2]|c[s+4>>2];r=f;c[r>>2]=c[t>>2]|c[s>>2];c[r+4>>2]=q;r=a+(j<<5)+340|0;q=c[r>>2]|0;c[r>>2]=q+1;c[b>>2]=q;c[a+(j<<9)+(q<<2)+464>>2]=d;c[h>>2]=(c[h>>2]|0)+1;h=1}else{b=a+(d<<2)+1424|0;e=46496+(d<<3)|0;m=a+256|0;f=a+(j<<3)+320|0;g=j<<3;h=c[l>>2]&7}q=e;e=46496+(k<<3)|0;r=c[e>>2]^c[q>>2];q=c[e+4>>2]^c[q+4>>2];e=m;t=c[e+4>>2]^q;s=m;c[s>>2]=c[e>>2]^r;c[s+4>>2]=t;s=a+(h<<3)+256|0;t=s;e=c[t+4>>2]^q;c[s>>2]=c[t>>2]^r;c[s+4>>2]=e;s=f;q=c[s+4>>2]^q;e=f;c[e>>2]=c[s>>2]^r;c[e+4>>2]=q;c[l>>2]=0;c[a+(k<<2)>>2]=h|g;e=c[b>>2]|0;c[a+(k<<2)+1424>>2]=e;c[a+(j<<9)+(h<<6)+(e<<2)+400>>2]=k;e=a+2220|0;b=c[(c[e>>2]|0)+64>>2]|0;if(!b){m=e;l=c[m>>2]|0;l=l+68|0;l=c[l>>2]|0;c[m>>2]=l;m=a+2208|0;l=c[m>>2]|0;l=l+-1|0;c[m>>2]=l;i=p;return}if((n|0)==32768)d=d-((o|0)==1?8:-8)|0;c[a+(d<<2)>>2]=b|o<<3;k=46496+(d<<3)|0;j=k;g=m;h=c[g+4>>2]|c[j+4>>2];l=m;c[l>>2]=c[g>>2]|c[j>>2];c[l+4>>2]=h;l=a+(b<<3)+256|0;m=k;h=l;j=c[h+4>>2]|c[m+4>>2];c[l>>2]=c[h>>2]|c[m>>2];c[l+4>>2]=j;l=a+(o<<3)+320|0;j=l;m=c[j+4>>2]|c[k+4>>2];c[l>>2]=c[j>>2]|c[k>>2];c[l+4>>2]=m;l=a+(o<<5)+(b<<2)+336|0;m=c[l>>2]|0;c[l>>2]=m+1;c[a+(d<<2)+1424>>2]=m;c[a+(o<<9)+(b<<6)+(m<<2)+400>>2]=d;m=a+(o<<5)+336|0;c[m>>2]=(c[m>>2]|0)+1;m=e;l=c[m>>2]|0;l=l+68|0;l=c[l>>2]|0;c[m>>2]=l;m=a+2208|0;l=c[m>>2]|0;l=l+-1|0;c[m>>2]=l;i=p;return}function jg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;g=a+2220|0;e=b+0|0;d=(c[g>>2]|0)+0|0;f=e+72|0;do{c[e>>2]=c[d>>2];e=e+4|0;d=d+4|0}while((e|0)<(f|0));c[b+68>>2]=c[g>>2];c[g>>2]=b;d=b+40|0;e=c[d>>2]|0;if((e|0)==64){e=b+48|0;d=c[e>>2]|0;e=c[e+4>>2]|0}else{e=1013168+((e&7)<<3)|0;h=b+48|0;i=h;f=c[i>>2]^c[e>>2];e=c[i+4>>2]^c[e+4>>2];c[h>>2]=f;c[h+4>>2]=e;c[d>>2]=64;d=f}h=1013360;f=e^c[h+4>>2];e=b+48|0;c[e>>2]=d^c[h>>2];c[e+4>>2]=f;d=c[g>>2]|0;e=d+28|0;c[e>>2]=(c[e>>2]|0)+1;c[d+32>>2]=0;d=a+2212|0;c[d>>2]=c[d>>2]^1;return}function kg(a){a=a|0;var b=0;b=a+2220|0;c[b>>2]=c[(c[b>>2]|0)+68>>2];a=a+2212|0;c[a>>2]=c[a>>2]^1;return}function lg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;g=c[a+2212>>2]|0;h=b>>>6&63;e=b&63;f=c[a+(h<<2)>>2]&7;d=c[a+(e<<2)>>2]&7;b=(c[a+2220>>2]|0)+48|0;i=1013360;a=c[i>>2]^c[b>>2];b=c[i+4>>2]^c[b+4>>2];if(d){d=1004976+((g^1)<<12)+(d<<9)+(e<<3)|0;a=c[d>>2]^a;b=c[d+4>>2]^b}e=1004976+(g<<12)+(f<<9)+(e<<3)|0;d=1004976+(g<<12)+(f<<9)+(h<<3)|0;F=c[e+4>>2]^b^c[d+4>>2];return c[e>>2]^a^c[d>>2]|0}function mg(a,b){a=a|0;b=b|0;if((c[1004848+(c[a+((b>>>6&63)<<2)>>2]<<2)>>2]|0)<=(c[1004848+(c[a+((b&63)<<2)>>2]<<2)>>2]|0)){b=1e4;return b|0}b=ng(a,b)|0;return b|0}function ng(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;S=i;i=i+128|0;R=S;f=b>>>6&63;h=b&63;d=c[1004848+(c[a+(h<<2)>>2]<<2)>>2]|0;c[R>>2]=d;m=c[a+(f<<2)>>2]|0;k=m>>3;g=a+256|0;f=46496+(f<<3)|0;e=c[f>>2]^c[g>>2];g=c[f+4>>2]^c[g+4>>2];f=b&49152;if((f|0)==49152){y=0;i=S;return y|0}else if((f|0)==32768){l=46496+(h-((k|0)==0?8:-8)<<3)|0;e=c[l>>2]^e;l=c[l+4>>2]^g;j=c[251213]|0;c[R>>2]=j}else{l=g;j=d}T=51936+(h<<3)|0;U=a+320|0;N=a+264|0;M=c[N>>2]|0;N=c[N+4>>2]|0;W=47840+(h<<3)|0;V=a+328|0;n=48352+(h<<3)|0;P=a+272|0;O=c[P>>2]|0;P=c[P+4>>2]|0;q=44448+(h<<3)|0;p=c[q>>2]|0;q=c[q+4>>2]|0;s=43936+(h<<3)|0;r=c[s>>2]|0;s=c[s+4>>2]|0;o=(ba(q&l,s)|0)^(ba(p&e,r)|0);t=c[44960+(h<<2)>>2]|0;u=c[43424+(h<<2)>>2]|0;o=u+(o>>>t<<3)|0;w=a+288|0;v=c[w>>2]|0;w=c[w+4>>2]|0;y=a+296|0;x=c[y>>2]|0;y=c[y+4>>2]|0;z=x|v;A=y|w;C=45728+(h<<3)|0;B=c[C>>2]|0;C=c[C+4>>2]|0;E=45216+(h<<3)|0;D=c[E>>2]|0;E=c[E+4>>2]|0;g=(ba(C&l,E)|0)^(ba(B&e,D)|0);G=c[46240+(h<<2)>>2]|0;H=c[43680+(h<<2)>>2]|0;g=H+(g>>>G<<3)|0;J=a+280|0;I=c[J>>2]|0;J=c[J+4>>2]|0;K=I|x;L=J|y;d=50400+(h<<3)|0;f=a+304|0;b=(c[W>>2]&M&c[V>>2]|c[U>>2]&c[T>>2]&M|O&c[n>>2]|z&c[o>>2]|K&c[g>>2]|c[f>>2]&c[d>>2])&e;d=(c[W+4>>2]&N&c[V+4>>2]|c[U+4>>2]&c[T+4>>2]&N|P&c[n+4>>2]|A&c[o+4>>2]|L&c[g+4>>2]|c[f+4>>2]&c[d+4>>2])&l;k=k^1;f=a+(k<<3)+320|0;g=b&c[f>>2];f=d&c[f+4>>2];if((g|0)==0&(f|0)==0){y=j;i=S;return y|0}o=j;n=e;j=m&7;e=1;m=k;a:while(1){o=(c[1004848+(j<<2)>>2]|0)-o|0;c[R+(e<<2)>>2]=o;h=M&g;j=N&f;do if((h|0)==0&(j|0)==0){j=O&g;h=P&f;if(!((j|0)==0&(h|0)==0)){k=hv(0,0,j|0,h|0)|0;j=j&k^n;h=h&F^l;k=2;b=j&b;d=h&d;break}j=I&g;h=J&f;if(!((j|0)==0&(h|0)==0)){k=hv(0,0,j|0,h|0)|0;j=j&k^n;h=h&F^l;n=H+(((ba(C&h,E)|0)^(ba(B&j,D)|0))>>>G<<3)|0;k=3;b=(K&c[n>>2]|b)&j;d=(L&c[n+4>>2]|d)&h;break}j=v&g;h=w&f;if(!((j|0)==0&(h|0)==0)){k=hv(0,0,j|0,h|0)|0;j=j&k^n;h=h&F^l;n=u+(((ba(q&h,s)|0)^(ba(p&j,r)|0))>>>t<<3)|0;k=4;b=(z&c[n>>2]|b)&j;d=(A&c[n+4>>2]|d)&h;break}j=x&g;h=y&f;if((j|0)==0&(h|0)==0){Q=15;break a}f=hv(0,0,j|0,h|0)|0;j=j&f^n;h=h&F^l;f=H+(((ba(C&h,E)|0)^(ba(B&j,D)|0))>>>G<<3)|0;n=u+(((ba(q&h,s)|0)^(ba(p&j,r)|0))>>>t<<3)|0;k=5;b=(c[f>>2]&K|b|c[n>>2]&z)&j;d=(c[f+4>>2]&L|d|c[n+4>>2]&A)&h}else{k=hv(0,0,h|0,j|0)|0;n=h&k^n;h=j&F^l;j=H+(((ba(C&h,E)|0)^(ba(B&n,D)|0))>>>G<<3)|0;k=1;b=(K&c[j>>2]|b)&n;d=(L&c[j+4>>2]|d)&h;j=n}while(0);m=m^1;f=a+(m<<3)+320|0;g=c[f>>2]&b;f=c[f+4>>2]&d;e=e+1|0;if((g|0)==0&(f|0)==0)break;else{n=j;l=h;j=k}}if((Q|0)==15)e=((g|0)==(b|0)&(f|0)==(d|0)&1)+e|0;d=e+-1|0;if(d)while(1){y=0-(c[R+(d<<2)>>2]|0)|0;e=R+(e+-2<<2)|0;x=c[e>>2]|0;c[e>>2]=(x|0)<(y|0)?x:y;e=d+-1|0;if(!e)break;else{y=d;d=e;e=y}}y=c[R>>2]|0;i=S;return y|0}function og(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;g=i;i=i+2064|0;d=g;e=a+2220|0;f=c[e>>2]|0;b=c[f+28>>2]|0;do if((b|0)>99){b=f+56|0;if((c[b>>2]|0)==0&(c[b+4>>2]|0)==0){b=1;i=g;return b|0}c[d+2048>>2]=d;b=Af(a,d)|0;c[d+2052>>2]=b;c[b>>2]=0;if((b|0)==(d|0)){b=c[e>>2]|0;f=b;b=c[b+28>>2]|0;break}else{b=1;i=g;return b|0}}while(0);a=c[f+32>>2]|0;a=(a|0)<(b|0)?a:b;if((a|0)<2){b=0;i=g;return b|0}d=f+48|0;e=c[d>>2]|0;d=c[d+4>>2]|0;b=2;while(1){f=c[(c[f+68>>2]|0)+68>>2]|0;h=f+48|0;b=b+2|0;if((c[h>>2]|0)==(e|0)?(c[h+4>>2]|0)==(d|0):0){b=1;d=9;break}if((b|0)>(a|0)){b=0;d=9;break}}if((d|0)==9){i=g;return b|0}return 0}function pg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=i;i=i+224|0;p=A+208|0;x=A+196|0;z=A+184|0;y=A+40|0;r=A+24|0;k=A+12|0;n=A;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;Vf(r,b);u=y+64|0;v=y+8|0;c[v>>2]=1000312;w=y+12|0;c[y>>2]=1000460;c[u>>2]=1000480;c[y+4>>2]=0;ij(y+64|0,w);c[y+136>>2]=0;c[y+140>>2]=-1;c[y>>2]=1000292;c[u>>2]=1000332;c[v>>2]=1000312;nj(w);c[w>>2]=1000496;q=y+44|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[y+60>>2]=24;Ae(w,r);Bi(r);r=z+1|0;d=k+1|0;h=k+8|0;j=k+4|0;s=z+4|0;t=z+8|0;o=x+4|0;l=7;while(1){m=(l|0)>0;Gc(y,z,m?47:32)|0;g=a[x>>0]|0;if(!(g&1))e=(g&255)>>>1;else e=c[o>>2]|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;g=a[z>>0]|0;if(!(g&1)){g=(g&255)>>>1;f=r}else{g=c[s>>2]|0;f=c[t>>2]|0}Ui(k,f,g,g+1|0);Li(k,(e|0)==0?1072408:1017696,1)|0;g=a[k>>0]|0;if(!(g&1)){f=d;g=(g&255)>>>1}else{f=c[h>>2]|0;g=c[j>>2]|0}Oi(x,0,f,g)|0;Bi(k);if(m)l=l+-1|0;else break}Ac(y,z)|0;e=(Ti(z,1017704)|0)==0;Ji(x,e?1017712:1017720)|0;Ac(y,z)|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;e=a[z>>0]|0;if(!(e&1)){f=(e&255)>>>1;e=r}else{f=c[s>>2]|0;e=c[t>>2]|0}Ui(n,e,f,f+1|0);Li(n,1072408,1)|0;f=a[n>>0]|0;if(!(f&1)){e=n+1|0;f=(f&255)>>>1}else{e=c[n+8>>2]|0;f=c[n+4>>2]|0}Li(x,e,f)|0;Bi(n);f=a[x>>0]|0;if(!(f&1)){d=x+1|0;e=x+1|0;g=x+((f&255)>>>1)+1|0}else{g=c[x+8>>2]|0;d=g;e=g;g=g+(c[o>>2]|0)|0}if((e|0)!=(g|0))while(1){f=a[e>>0]|0;if(!(Ys(f)|0))f=Bu(f)|0;else f=Zs(f)|0;a[d>>0]=f;e=e+1|0;if((e|0)==(g|0))break;else d=d+1|0}Ac(y,z)|0;if(!(Ti(z,1017728)|0))e=z;else e=Qi(z,1,1,(a[((a[z>>0]&1)==0?r:c[t>>2]|0)+1>>0]|0)==51?1017736:1017744)|0;d=a[e>>0]|0;if(!(d&1)){f=e+1|0;d=(d&255)>>>1}else{f=c[e+8>>2]|0;d=c[e+4>>2]|0}Li(x,f,d)|0;hj(p,y+(c[(c[y>>2]|0)+-12>>2]|0)|0);d=Zo(p,1077904)|0;d=oc[c[(c[d>>2]|0)+28>>2]&63](d,10)|0;Wo(p);Gc(y,z,d)|0;d=a[z>>0]|0;if(!(d&1)){t=r;s=(d&255)>>>1;Li(x,t,s)|0;s=b+2224|0;s=a[s>>0]|0;s=s<<24>>24!=0;t=b+2216|0;t=c[t>>2]|0;Zf(b,x,s,t);c[y>>2]=1000292;c[u>>2]=1000332;c[v>>2]=1000312;c[w>>2]=1000496;Bi(q);kj(w);b=y+64|0;fj(b);Bi(z);Bi(x);i=A;return}else{t=c[t>>2]|0;s=c[s>>2]|0;Li(x,t,s)|0;s=b+2224|0;s=a[s>>0]|0;s=s<<24>>24!=0;t=b+2216|0;t=c[t>>2]|0;Zf(b,x,s,t);c[y>>2]=1000292;c[u>>2]=1000332;c[v>>2]=1000312;c[w>>2]=1000496;Bi(q);kj(w);b=y+64|0;fj(b);Bi(z);Bi(x);i=A;return}}function qg(){kv(1003056,0,288)|0;c[250836]=-1310720;c[250837]=0;c[250838]=0;c[250839]=0;c[250840]=0;c[250841]=0;c[250842]=0;c[250843]=-1310720;c[250844]=-1310720;c[250845]=0;c[250846]=655360;c[250847]=1310720;c[250848]=1310720;c[250849]=655360;c[250850]=0;c[250851]=-1310720;c[250852]=-1310720;c[250853]=0;c[250854]=1310720;c[250855]=2621440;c[250856]=2621440;c[250857]=1310720;c[250858]=0;c[250859]=-1310720;c[250860]=-1310720;c[250861]=0;c[250862]=655360;c[250863]=1310720;c[250864]=1310720;c[250865]=655360;c[250866]=0;c[250867]=-1310720;c[250868]=-1310720;c[250869]=0;c[250870]=0;c[250871]=0;c[250872]=0;c[250873]=0;c[250874]=0;c[250875]=-1310720;c[250876]=-1310720;c[250877]=0;c[250878]=0;c[250879]=0;c[250880]=0;c[250881]=0;c[250882]=0;c[250883]=-1310720;c[250884]=0;c[250885]=0;c[250886]=0;c[250887]=0;c[250888]=0;c[250889]=0;c[250890]=0;c[250891]=0;c[250892]=-9437282;c[250893]=-7143507;c[250894]=-5570611;c[250895]=-4784144;c[250896]=-4784144;c[250897]=-5570611;c[250898]=-7143507;c[250899]=-9437282;c[250900]=-5767236;c[250901]=-2818101;c[250902]=-1245205;c[250903]=-458738;c[250904]=-458738;c[250905]=-1245205;c[250906]=-2818101;c[250907]=-5767236;c[250908]=-4522037;c[250909]=-1572902;c[250910]=-6;c[250911]=786461;c[250912]=786461;c[250913]=-6;c[250914]=-1572902;c[250915]=-4522037;c[250916]=-1835050;c[250917]=1114085;c[250918]=2686981;c[250919]=3473448;c[250920]=3473448;c[250921]=2686981;c[250922]=1114085;c[250923]=-1835050;c[250924]=-1966122;c[250925]=983013;c[250926]=2555909;c[250927]=3342376;c[250928]=3342376;c[250929]=2555909;c[250930]=983013;c[250931]=-1966122;c[250932]=-655413;c[250933]=2293722;c[250934]=3866618;c[250935]=4653085;c[250936]=4653085;c[250937]=3866618;c[250938]=2293722;c[250939]=-655413;c[250940]=-4194372;c[250941]=-1245237;c[250942]=327659;c[250943]=1114126;c[250944]=1114126;c[250945]=327659;c[250946]=-1245237;c[250947]=-4194372;c[250948]=-13107298;c[250949]=-4259923;c[250950]=-2687027;c[250951]=-1900560;c[250952]=-1900560;c[250953]=-2687027;c[250954]=-4259923;c[250955]=-13107298;c[250956]=-3539009;c[250957]=-1769514;c[250958]=-2228268;c[250959]=-2818074;c[250960]=-2818074;c[250961]=-2228268;c[250962]=-1769514;c[250963]=-3539009;c[250964]=-1900587;c[250965]=524268;c[250966]=65514;c[250967]=-524292;c[250968]=-524292;c[250969]=65514;c[250970]=524268;c[250971]=-1900587;c[250972]=-1310753;c[250973]=1114102;c[250974]=655348;c[250975]=65542;c[250976]=65542;c[250977]=655348;c[250978]=1114102;c[250979]=-1310753;c[250980]=-1245219;c[250981]=1179636;c[250982]=720882;c[250983]=131076;c[250984]=131076;c[250985]=720882;c[250986]=1179636;c[250987]=-1245219;c[250988]=-1441827;c[250989]=983028;c[250990]=524274;c[250991]=-65532;c[250992]=-65532;c[250993]=524274;c[250994]=983028;c[250995]=-1441827;c[250996]=-1835041;c[250997]=589814;c[250998]=131060;c[250999]=-458746;c[251e3]=-458746;c[251001]=131060;c[251002]=589814;c[251003]=-1835041;c[251004]=-2097195;c[251005]=327660;c[251006]=-131094;c[251007]=-720900;c[251008]=-720900;c[251009]=-131094;c[251010]=327660;c[251011]=-2097195;c[251012]=-3211329;c[251013]=-1441834;c[251014]=-1900588;c[251015]=-2490394;c[251016]=-2490394;c[251017]=-1900588;c[251018]=-1441834;c[251019]=-3211329;c[251020]=-1441789;c[251021]=-1114109;c[251022]=-786429;c[251023]=-524285;c[251024]=-524285;c[251025]=-786429;c[251026]=-1114109;c[251027]=-1441789;c[251028]=-1441789;c[251029]=-458749;c[251030]=-131069;c[251031]=131075;c[251032]=131075;c[251033]=-131069;c[251034]=-458749;c[251035]=-1441789;c[251036]=-1441789;c[251037]=-458749;c[251038]=-131069;c[251039]=131075;c[251040]=131075;c[251041]=-131069;c[251042]=-458749;c[251043]=-1441789;c[251044]=-1441789;c[251045]=-458749;c[251046]=-131069;c[251047]=131075;c[251048]=131075;c[251049]=-131069;c[251050]=-458749;c[251051]=-1441789;c[251052]=-1441789;c[251053]=-458749;c[251054]=-131069;c[251055]=131075;c[251056]=131075;c[251057]=-131069;c[251058]=-458749;c[251059]=-1441789;c[251060]=-1441789;c[251061]=-458749;c[251062]=-131069;c[251063]=131075;c[251064]=131075;c[251065]=-131069;c[251066]=-458749;c[251067]=-1441789;c[251068]=-720893;c[251069]=262147;c[251070]=589827;c[251071]=851971;c[251072]=851971;c[251073]=589827;c[251074]=262147;c[251075]=-720893;c[251076]=-1441789;c[251077]=-1114109;c[251078]=-786429;c[251079]=-524285;c[251080]=-524285;c[251081]=-786429;c[251082]=-1114109;c[251083]=-1441789;c[251084]=-131152;c[251085]=-131126;c[251086]=-131114;c[251087]=-131102;c[251088]=-131102;c[251089]=-131114;c[251090]=-131126;c[251091]=-131152;c[251092]=-131126;c[251093]=524258;c[251094]=524270;c[251095]=524282;c[251096]=524282;c[251097]=524270;c[251098]=524258;c[251099]=-131126;c[251100]=-131114;c[251101]=524270;c[251102]=524282;c[251103]=524294;c[251104]=524294;c[251105]=524282;c[251106]=524270;c[251107]=-131114;c[251108]=-131102;c[251109]=524282;c[251110]=524294;c[251111]=524306;c[251112]=524306;c[251113]=524294;c[251114]=524282;c[251115]=-131102;c[251116]=-131102;c[251117]=524282;c[251118]=524294;c[251119]=524306;c[251120]=524306;c[251121]=524294;c[251122]=524282;c[251123]=-131102;c[251124]=-131114;c[251125]=524270;c[251126]=524282;c[251127]=524294;c[251128]=524294;c[251129]=524282;c[251130]=524270;c[251131]=-131114;c[251132]=-131126;c[251133]=524258;c[251134]=524270;c[251135]=524282;c[251136]=524282;c[251137]=524270;c[251138]=524258;c[251139]=-131126;c[251140]=-131152;c[251141]=-131126;c[251142]=-131114;c[251143]=-131102;c[251144]=-131102;c[251145]=-131114;c[251146]=-131126;c[251147]=-131152;c[251148]=19529755;c[251149]=21758033;c[251150]=17891436;c[251151]=14745716;c[251152]=14745716;c[251153]=17891436;c[251154]=21758033;c[251155]=19529755;c[251156]=18808906;c[251157]=21037184;c[251158]=17170587;c[251159]=14024867;c[251160]=14024867;c[251161]=17170587;c[251162]=21037184;c[251163]=18808906;c[251164]=14680175;c[251165]=16908453;c[251166]=13041856;c[251167]=9896136;c[251168]=9896136;c[251169]=13041856;c[251170]=16908453;c[251171]=14680175;c[251172]=12845191;c[251173]=15073469;c[251174]=11206872;c[251175]=8061152;c[251176]=8061152;c[251177]=11206872;c[251178]=15073469;c[251179]=12845191;c[251180]=11337863;c[251181]=13566141;c[251182]=9699544;c[251183]=6553824;c[251184]=6553824;c[251185]=9699544;c[251186]=13566141;c[251187]=11337863;c[251188]=9568367;c[251189]=11796645;c[251190]=7930048;c[251191]=4784328;c[251192]=4784328;c[251193]=7930048;c[251194]=11796645;c[251195]=9568367;c[251196]=7798858;c[251197]=10027136;c[251198]=6160539;c[251199]=3014819;c[251200]=3014819;c[251201]=6160539;c[251202]=10027136;c[251203]=7798858;c[251204]=6422555;c[251205]=8650833;c[251206]=4784236;c[251207]=1638516;c[251208]=1638516;c[251209]=4784236;c[251210]=8650833;c[251211]=6422555;vi(1013376,1013392,15);return}function rg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=c[d>>2]|0;k=(g|0)>(b|0);c[e>>2]=g;g=a+2212|0;m=c[g>>2]|0;o=m*56|0;c[f>>2]=o|(k?5:3);c[d>>2]=o|(k?6:2);k=a+256|0;o=46496+(b<<3)|0;h=o;p=k;q=c[p+4>>2]^c[h+4>>2];i=k;c[i>>2]=c[p>>2]^c[h>>2];c[i+4>>2]=q;i=a+304|0;q=o;h=i;p=c[h+4>>2]^c[q+4>>2];l=i;c[l>>2]=c[h>>2]^c[q>>2];c[l+4>>2]=p;l=a+(m<<3)+320|0;p=l;q=c[p+4>>2]^c[o+4>>2];c[l>>2]=c[p>>2]^c[o>>2];c[l+4>>2]=q;l=a+(m<<5)+360|0;q=(c[l>>2]|0)+-1|0;c[l>>2]=q;q=c[a+(m<<9)+(q<<2)+784>>2]|0;o=c[a+(b<<2)+1424>>2]|0;c[a+(q<<2)+1424>>2]=o;c[a+(m<<9)+(o<<2)+784>>2]=q;c[a+(m<<9)+(c[l>>2]<<2)+784>>2]=64;m=a+(m<<5)+336|0;c[m>>2]=(c[m>>2]|0)+-1;m=c[e>>2]|0;l=c[g>>2]|0;o=46496+(m<<3)|0;q=o;p=k;h=c[p+4>>2]^c[q+4>>2];j=k;c[j>>2]=c[p>>2]^c[q>>2];c[j+4>>2]=h;j=a+288|0;h=o;q=j;p=c[q+4>>2]^c[h+4>>2];n=j;c[n>>2]=c[q>>2]^c[h>>2];c[n+4>>2]=p;n=a+(l<<3)+320|0;p=n;h=c[p+4>>2]^c[o+4>>2];c[n>>2]=c[p>>2]^c[o>>2];c[n+4>>2]=h;n=a+(l<<5)+352|0;h=(c[n>>2]|0)+-1|0;c[n>>2]=h;h=c[a+(l<<9)+(h<<2)+656>>2]|0;m=c[a+(m<<2)+1424>>2]|0;c[a+(h<<2)+1424>>2]=m;c[a+(l<<9)+(m<<2)+656>>2]=h;c[a+(l<<9)+(c[n>>2]<<2)+656>>2]=64;l=a+(l<<5)+336|0;c[l>>2]=(c[l>>2]|0)+-1;c[a+(c[e>>2]<<2)>>2]=0;c[a+(b<<2)>>2]=0;d=c[d>>2]|0;b=c[g>>2]|0;c[a+(d<<2)>>2]=b<<3|6;e=46496+(d<<3)|0;l=e;n=k;m=c[n+4>>2]|c[l+4>>2];h=k;c[h>>2]=c[n>>2]|c[l>>2];c[h+4>>2]=m;h=e;m=i;l=c[m+4>>2]|c[h+4>>2];c[i>>2]=c[m>>2]|c[h>>2];c[i+4>>2]=l;i=a+(b<<3)+320|0;l=i;h=c[l+4>>2]|c[e+4>>2];c[i>>2]=c[l>>2]|c[e>>2];c[i+4>>2]=h;i=a+(b<<5)+360|0;h=c[i>>2]|0;c[i>>2]=h+1;c[a+(d<<2)+1424>>2]=h;c[a+(b<<9)+(h<<2)+784>>2]=d;b=a+(b<<5)+336|0;c[b>>2]=(c[b>>2]|0)+1;f=c[f>>2]|0;b=c[g>>2]|0;c[a+(f<<2)>>2]=b<<3|4;g=46496+(f<<3)|0;h=g;d=k;i=c[d+4>>2]|c[h+4>>2];e=k;c[e>>2]=c[d>>2]|c[h>>2];c[e+4>>2]=i;e=g;i=j;h=c[i+4>>2]|c[e+4>>2];d=j;c[d>>2]=c[i>>2]|c[e>>2];c[d+4>>2]=h;d=a+(b<<3)+320|0;h=d;e=c[h+4>>2]|c[g+4>>2];c[d>>2]=c[h>>2]|c[g>>2];c[d+4>>2]=e;d=a+(b<<5)+352|0;e=c[d>>2]|0;c[d>>2]=e+1;c[a+(f<<2)+1424>>2]=e;c[a+(b<<9)+(e<<2)+656>>2]=f;b=a+(b<<5)+336|0;c[b>>2]=(c[b>>2]|0)+1;return}function sg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=c[d>>2]|0;o=(g|0)>(b|0);c[e>>2]=g;g=a+2212|0;m=c[g>>2]|0;k=m*56|0;c[f>>2]=k|(o?5:3);o=k|(o?6:2);c[d>>2]=o;k=a+256|0;p=46496+(o<<3)|0;j=p;h=k;q=c[h+4>>2]^c[j+4>>2];n=k;c[n>>2]=c[h>>2]^c[j>>2];c[n+4>>2]=q;n=a+304|0;q=p;j=n;h=c[j+4>>2]^c[q+4>>2];i=n;c[i>>2]=c[j>>2]^c[q>>2];c[i+4>>2]=h;i=a+(m<<3)+320|0;h=i;q=c[h+4>>2]^c[p+4>>2];c[i>>2]=c[h>>2]^c[p>>2];c[i+4>>2]=q;i=a+(m<<5)+360|0;q=(c[i>>2]|0)+-1|0;c[i>>2]=q;q=c[a+(m<<9)+(q<<2)+784>>2]|0;o=c[a+(o<<2)+1424>>2]|0;c[a+(q<<2)+1424>>2]=o;c[a+(m<<9)+(o<<2)+784>>2]=q;c[a+(m<<9)+(c[i>>2]<<2)+784>>2]=64;m=a+(m<<5)+336|0;c[m>>2]=(c[m>>2]|0)+-1;m=c[f>>2]|0;i=c[g>>2]|0;o=46496+(m<<3)|0;q=o;p=k;h=c[p+4>>2]^c[q+4>>2];j=k;c[j>>2]=c[p>>2]^c[q>>2];c[j+4>>2]=h;j=a+288|0;h=o;q=j;p=c[q+4>>2]^c[h+4>>2];l=j;c[l>>2]=c[q>>2]^c[h>>2];c[l+4>>2]=p;l=a+(i<<3)+320|0;p=l;h=c[p+4>>2]^c[o+4>>2];c[l>>2]=c[p>>2]^c[o>>2];c[l+4>>2]=h;l=a+(i<<5)+352|0;h=(c[l>>2]|0)+-1|0;c[l>>2]=h;h=c[a+(i<<9)+(h<<2)+656>>2]|0;m=c[a+(m<<2)+1424>>2]|0;c[a+(h<<2)+1424>>2]=m;c[a+(i<<9)+(m<<2)+656>>2]=h;c[a+(i<<9)+(c[l>>2]<<2)+656>>2]=64;i=a+(i<<5)+336|0;c[i>>2]=(c[i>>2]|0)+-1;c[a+(c[f>>2]<<2)>>2]=0;c[a+(c[d>>2]<<2)>>2]=0;f=c[g>>2]|0;c[a+(b<<2)>>2]=f<<3|6;i=46496+(b<<3)|0;l=i;d=k;m=c[d+4>>2]|c[l+4>>2];h=k;c[h>>2]=c[d>>2]|c[l>>2];c[h+4>>2]=m;h=i;m=n;l=c[m+4>>2]|c[h+4>>2];d=n;c[d>>2]=c[m>>2]|c[h>>2];c[d+4>>2]=l;d=a+(f<<3)+320|0;l=d;h=c[l+4>>2]|c[i+4>>2];c[d>>2]=c[l>>2]|c[i>>2];c[d+4>>2]=h;d=a+(f<<5)+360|0;h=c[d>>2]|0;c[d>>2]=h+1;c[a+(b<<2)+1424>>2]=h;c[a+(f<<9)+(h<<2)+784>>2]=b;f=a+(f<<5)+336|0;c[f>>2]=(c[f>>2]|0)+1;f=c[e>>2]|0;b=c[g>>2]|0;c[a+(f<<2)>>2]=b<<3|4;g=46496+(f<<3)|0;h=g;d=k;i=c[d+4>>2]|c[h+4>>2];e=k;c[e>>2]=c[d>>2]|c[h>>2];c[e+4>>2]=i;e=g;i=j;h=c[i+4>>2]|c[e+4>>2];d=j;c[d>>2]=c[i>>2]|c[e>>2];c[d+4>>2]=h;d=a+(b<<3)+320|0;h=d;e=c[h+4>>2]|c[g+4>>2];c[d>>2]=c[h>>2]|c[g>>2];c[d+4>>2]=e;d=a+(b<<5)+352|0;e=c[d>>2]|0;c[d>>2]=e+1;c[a+(f<<2)+1424>>2]=e;c[a+(b<<9)+(e<<2)+656>>2]=f;b=a+(b<<5)+336|0;c[b>>2]=(c[b>>2]|0)+1;return}function tg(a){a=a|0;var b=0;c[a>>2]=1017764;c[a+56>>2]=1017784;b=a+4|0;c[b>>2]=1000496;Bi(a+36|0);kj(b);fj(a+56|0);return}function ug(a){a=a|0;var b=0;c[a>>2]=1017764;c[a+56>>2]=1017784;b=a+4|0;c[b>>2]=1000496;Bi(a+36|0);kj(b);fj(a+56|0);xt(a);return}function vg(a){a=a|0;var b=0,d=0,e=0;e=c[(c[a>>2]|0)+-12>>2]|0;c[a+e>>2]=1017764;b=a+(e+56)|0;c[b>>2]=1017784;d=a+(e+4)|0;c[d>>2]=1000496;Bi(a+(e+36)|0);kj(d);fj(b);return}function wg(a){a=a|0;var b=0,d=0,e=0,f=0;f=c[(c[a>>2]|0)+-12>>2]|0;b=a+f|0;c[b>>2]=1017764;d=a+(f+56)|0;c[d>>2]=1017784;e=a+(f+4)|0;c[e>>2]=1000496;Bi(a+(f+36)|0);kj(e);fj(d);xt(b);return}function xg(a){a=a|0;var b=0;c[a>>2]=1017860;c[a+60>>2]=1017880;b=a+8|0;c[b>>2]=1000496;Bi(a+40|0);kj(b);fj(a+60|0);return}function yg(a){a=a|0;var b=0;c[a>>2]=1017860;c[a+60>>2]=1017880;b=a+8|0;c[b>>2]=1000496;Bi(a+40|0);kj(b);fj(a+60|0);xt(a);return}function zg(a){a=a|0;var b=0,d=0,e=0;e=c[(c[a>>2]|0)+-12>>2]|0;c[a+e>>2]=1017860;b=a+(e+60)|0;c[b>>2]=1017880;d=a+(e+8)|0;c[d>>2]=1000496;Bi(a+(e+40)|0);kj(d);fj(b);return}function Ag(a){a=a|0;var b=0,d=0,e=0,f=0;f=c[(c[a>>2]|0)+-12>>2]|0;b=a+f|0;c[b>>2]=1017860;d=a+(f+60)|0;c[d>>2]=1017880;e=a+(f+8)|0;c[e>>2]=1000496;Bi(a+(f+40)|0);kj(e);fj(d);xt(b);return}function Bg(){var b=0,d=0.0,e=0,f=0.0,g=0.0,h=0,i=0;h=1;do{g=+$(+(+(h|0)));i=1;do{f=g*+$(+(+(i|0)));d=f/3.0+0.0;f=f/2.25+.33;if(!(d>=1.0))b=0;else b=~~(d+.5);a[1044856+(h<<6)+i+4096>>0]=b;if(f>=1.0){e=~~(f+.5);a[1036664+(h<<6)+i+4096>>0]=e;a[1044856+(h<<6)+i>>0]=b;b=1036664+(h<<6)+i|0;if(e<<24>>24>1)e=(e&255)+1&255}else{a[1036664+(h<<6)+i+4096>>0]=0;a[1044856+(h<<6)+i>>0]=b;b=1036664+(h<<6)+i|0;e=0}a[b>>0]=e;i=i+1|0}while((i|0)!=64);h=h+1|0}while((h|0)!=64);b=0;do{d=+(b|0);c[1053048+(b<<2)>>2]=~~(+S(+d,1.8)*.773+2.4);c[1053112+(b<<2)>>2]=~~(+S(+(d+.49),1.8)*1.045+2.9);b=b+1|0}while((b|0)!=16);return}function Cg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=i;i=i+4304|0;t=A+4288|0;s=A+88|0;r=A;x=A+2232|0;l=A+176|0;y=A+160|0;Tf(r,b);q=(d|0)==2;z=x+2048|0;c[z>>2]=x;h=Af(b,x)|0;c[x+2052>>2]=h;c[h>>2]=0;h=c[c[z>>2]>>2]|0;if(!h){x=0;y=0;F=x;i=A;return y|0}u=b+2224|0;v=y+1|0;w=y+8|0;x=y+4|0;m=l+2048|0;n=l+2052|0;o=l;p=d+-1|0;if((d|0)<2){e=0;f=0;do{e=iv(e|0,f|0,1,0)|0;f=F;d=ef(1073416,0)|0;Mh(y,c[c[z>>2]>>2]|0,(a[u>>0]|0)!=0);g=a[y>>0]|0;if(!(g&1)){h=v;g=(g&255)>>>1}else{h=c[w>>2]|0;g=c[x>>2]|0}s=pk(Ec(Ec(d,h,g)|0,1074896,2)|0,1,0)|0;hj(t,s+(c[(c[s>>2]|0)+-12>>2]|0)|0);b=Zo(t,1077904)|0;b=oc[c[(c[b>>2]|0)+28>>2]&63](b,10)|0;Wo(t);rk(s,b)|0;Wj(s)|0;ef(s,1)|0;Bi(y);s=(c[z>>2]|0)+8|0;c[z>>2]=s}while((c[s>>2]|0)!=0);F=f;i=A;return e|0}else{e=0;f=0}do{hg(b,h,s,r,fg(b,h,r)|0);if(q){c[m>>2]=l;j=Af(b,l)|0;c[n>>2]=j;c[j>>2]=0;j=j-o>>3;k=0}else{j=Kg(b,p)|0;k=F}e=iv(j|0,k|0,e|0,f|0)|0;f=F;ig(b,c[c[z>>2]>>2]|0);d=ef(1073416,0)|0;Mh(y,c[c[z>>2]>>2]|0,(a[u>>0]|0)!=0);h=a[y>>0]|0;if(!(h&1)){g=v;h=(h&255)>>>1}else{g=c[w>>2]|0;h=c[x>>2]|0}h=pk(Ec(Ec(d,g,h)|0,1074896,2)|0,j,k)|0;hj(t,h+(c[(c[h>>2]|0)+-12>>2]|0)|0);g=Zo(t,1077904)|0;g=oc[c[(c[g>>2]|0)+28>>2]&63](g,10)|0;Wo(t);rk(h,g)|0;Wj(h)|0;ef(h,1)|0;Bi(y);h=(c[z>>2]|0)+8|0;c[z>>2]=h;h=c[h>>2]|0}while((h|0)!=0);F=f;i=A;return e|0}function Dg(){var b=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=i;i=i+80|0;o=p+56|0;g=p+44|0;e=p+32|0;f=p;n=p+20|0;Ch(1053176,1017952,c[255061]|0,c[255060]|0);vi(e,1072832,8);m=((Th(Bc(1072800,e)|0)|0)*258|0)/100|0;Bi(e);e=c[255061]|0;c[1053192+(e<<2)>>2]=0-m;c[1053192+((e^1)<<2)>>2]=m;e=c[254504]|0;if((e|0)!=(c[254505]|0)){e=c[267457]|0;f=c[267456]|0;if((e|0)!=(f|0)){e=e-f>>2;b=0;do{c[(c[f+(b<<2)>>2]|0)+848>>2]=0;b=b+1|0}while(b>>>0<e>>>0)}a[(c[267462]|0)+17>>0]=1;kv(1063840,0,220)|0;h[132464]=0.0;a[1069924]=(d[1069924]|0)+4;kv(1055552,0,4096)|0;kv(1059720,0,4096)|0;kv(1020280,0,8192)|0;kv(1028472,0,8192)|0;vi(o,1073088,7);c[267412]=Th(Bc(1072800,o)|0)|0;Bi(o);e=ut(12)|0;vi(g,1073096,11);o=Th(Bc(1072800,g)|0)|0;b=((c[254505]|0)-(c[254504]|0)|0)/20|0;c[e>>2]=o;if((o|0)<20)b=(b|0)<4?b:4;else b=0;c[e+4>>2]=b;c[e+8>>2]=0;c[267414]=e;Bi(g);n=c[(c[267414]|0)+4>>2]|0;o=c[267412]|0;c[267412]=o>>>0<n>>>0?n:o;c[267416]=0;c[267418]=-32001;c[267420]=-32001;c[267422]=32001;c[267424]=-32001;Xf(1053280,1018032)|0;c[267426]=1063928;Mg(0);i=p;return}c[f>>2]=-32001;c[f+4>>2]=-32001;k=f+12|0;l=ut(4)|0;c[f+8>>2]=l;m=l+4|0;c[f+16>>2]=m;c[l>>2]=0;c[k>>2]=m;if((e|0)==(c[254506]|0))Lg(1018016,f);else{if(e){b=f;j=c[b+4>>2]|0;f=e;c[f>>2]=c[b>>2];c[f+4>>2]=j;f=e+8|0;c[f>>2]=0;j=e+12|0;c[j>>2]=0;e=e+16|0;c[e>>2]=0;b=ut(4)|0;c[j>>2]=b;c[f>>2]=b;c[e>>2]=b+4;e=l;f=0;g=b;while(1){c[g>>2]=f;f=e+4|0;if((f|0)==(m|0))break;e=f;f=c[f>>2]|0;g=g+4|0}c[j>>2]=b+4}c[254505]=(c[254505]|0)+20}c[k>>2]=l;xt(l);f=Ec(ef(1073416,0)|0,1053200,19)|0;e=(c[255063]|0)+56|0;Lh(n,(c[e>>2]|0)==0&(c[e+4>>2]|0)==0?0:-32e3);e=a[n>>0]|0;if(!(e&1)){b=n+1|0;e=(e&255)>>>1}else{b=c[n+8>>2]|0;e=c[n+4>>2]|0}m=Ec(f,b,e)|0;hj(o,m+(c[(c[m>>2]|0)+-12>>2]|0)|0);l=Zo(o,1077904)|0;l=oc[c[(c[l>>2]|0)+28>>2]&63](l,10)|0;Wo(o);rk(m,l)|0;Wj(m)|0;ef(m,1)|0;Bi(n);Eg(0);i=p;return}function Eg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;j=i;i=i+32|0;g=j+24|0;e=j+12|0;h=j;l=Ec(ef(1073416,0)|0,1053224,11)|0;d=1020232;d=Ec(pk(l,c[d>>2]|0,c[d+4>>2]|0)|0,1053240,6)|0;Tb(g|0,0)|0;l=c[g>>2]|0;l=uv(l|0,((l|0)<0)<<31>>31|0,1e3,0)|0;k=(c[g+4>>2]|0)/1e3|0;b=1020264;f=c[b>>2]|0;b=c[b+4>>2]|0;k=iv(l|1|0,F|0,k|0,((k|0)<0)<<31>>31|0)|0;b=hv(k|0,F|0,f|0,b|0)|0;b=ok(d,b,F)|0;hj(g,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);d=Zo(g,1077904)|0;d=oc[c[(c[d>>2]|0)+28>>2]&63](d,10)|0;Wo(g);rk(b,d)|0;Wj(b)|0;ef(b,1)|0;if((a[1017944]|0)==0?(c[254499]|c[254500]|0)!=0:0){a[1017945]=1;Zb(175,0,30);i=j;return}b=Ec(ef(1073416,0)|0,1053248,9)|0;Mh(e,c[c[(c[254504]|0)+8>>2]>>2]|0,(a[1020256]|0)!=0);d=a[e>>0]|0;if(!(d&1)){f=e+1|0;d=(d&255)>>>1}else{f=c[e+8>>2]|0;d=c[e+4>>2]|0}Ec(b,f,d)|0;Bi(e);b=c[254504]|0;if(!((c[b+12>>2]|0)-(c[b+8>>2]|0)>>2>>>0<=1?(Fg(b,1018032)|0)==0:0)){e=Ec(1073416,1053264,8)|0;Mh(h,c[(c[(c[254504]|0)+8>>2]|0)+4>>2]|0,(a[1020256]|0)!=0);b=a[h>>0]|0;if(!(b&1)){d=h+1|0;b=(b&255)>>>1}else{d=c[h+8>>2]|0;b=c[h+4>>2]|0}Ec(e,d,b)|0;Bi(h)}hj(g,1073416+(c[(c[268354]|0)+-12>>2]|0)|0);b=Zo(g,1077904)|0;b=oc[c[(c[b>>2]|0)+28>>2]&63](b,10)|0;Wo(g);rk(1073416,b)|0;Wj(1073416)|0;ef(1073416,1)|0;i=j;return}function Fg(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+2144|0;h=n+2132|0;m=n+2128|0;f=n+72|0;l=b+8|0;gg(d,c[c[l>>2]>>2]|0,n);g=(c[d+2220>>2]|0)+48|0;g=Fh(1069912,c[g>>2]|0,c[g+4>>2]|0,h)|0;if(!(a[h>>0]|0))h=0;else h=e[g+2>>1]|0;c[m>>2]=h;c[f+2048>>2]=f;j=Af(d,f)|0;c[f+2052>>2]=j;c[j>>2]=0;a:do if((f|0)==(j|0))k=6;else{g=f;while(1){if((c[g>>2]|0)==(h|0))break a;g=g+8|0;if((g|0)==(j|0)){k=6;break}}}while(0);if((k|0)==6){c[m>>2]=0;h=0}ig(d,c[c[l>>2]>>2]|0);f=b+12|0;g=c[f>>2]|0;if((g|0)==(c[b+16>>2]|0)){Ng(l,m);i=n;return h|0}if(g)c[g>>2]=h;c[f>>2]=g+4;i=n;return h|0}function Gg(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=i;i=i+9232|0;p=s+9216|0;o=d+12|0;r=d+8|0;if((c[o>>2]|0)==(c[r>>2]|0)){i=s;return}m=f+2220|0;d=0;n=s;while(1){l=(c[m>>2]|0)+48|0;l=Fh(1069912,c[l>>2]|0,c[l+4>>2]|0,p)|0;if(a[p>>0]|0){h=e[l+2>>1]|0;g=c[(c[r>>2]|0)+(d<<2)>>2]|0;if((h|0)==(g|0))g=h;else q=7}else{g=c[(c[r>>2]|0)+(d<<2)>>2]|0;q=7}if((q|0)==7){q=0;j=(c[m>>2]|0)+48|0;k=a[1069924]|0;j=jv(c[j>>2]|0,c[j+4>>2]|0,48)|0;if(!g){h=j&65535;if(!((F|0)==0?(j|0)==(e[l>>1]|0):0))q=10}else{h=j&65535;q=10}if((q|0)==10){q=0;b[l+2>>1]=g}b[l>>1]=h;b[l+4>>1]=32002;b[l+6>>1]=32002;a[l+8>>0]=k;a[l+9>>0]=-6}gg(f,g,n);d=d+1|0;g=c[r>>2]|0;if(d>>>0<(c[o>>2]|0)-g>>2>>>0)n=n+72|0;else break}if(!d){i=s;return}while(1){d=d+-1|0;ig(f,c[g+(d<<2)>>2]|0);if(!d)break;g=c[r>>2]|0}i=s;return}function Hg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0;Va=i;i=i+15536|0;Qa=Va+2640|0;La=Va+13384|0;Ga=Va+2552|0;Ra=Va+2480|0;Ma=Va+11232|0;Ha=Va+2392|0;Ta=Va+11224|0;Oa=Va+10704|0;Pa=Va+2320|0;Ia=Va+10696|0;Ja=Va+10688|0;Ka=Va+8536|0;Fa=Va+2232|0;ka=Va+8520|0;Sa=Va+2712|0;Na=Va;if(!(c[b+856>>2]|0))d=0;else d=c[b+852>>2]|0;Ba=b+16|0;if(a[Ba>>0]|0){i=Va;return}Ca=b+860|0;la=(d|0)==0;J=d+40|0;K=b+852|0;L=Sa+88|0;M=Na+2216|0;N=b+840|0;O=b+844|0;P=Na+2200|0;Q=Na+2220|0;R=Sa+56|0;S=Ia+4|0;T=Sa+12|0;U=Ja+4|0;V=Sa+124|0;W=Sa+36|0;X=Ha+8|0;Y=Na+2212|0;Z=Sa+100|0;_=Sa+132|0;$=Sa+112|0;aa=Sa+116|0;ba=Sa+120|0;ca=Ga+8|0;da=Sa+136|0;ea=Fa+8|0;fa=Ta+4|0;ga=Na+2224|0;ha=ka+1|0;ia=ka+8|0;ja=ka+4|0;a:while(1){if(a[Ca>>0]|0)do{I=c[K>>2]|0;Xf(Na,c[I>>2]|0)|0;c[M>>2]=b;mv(Sa|0,(c[I+4>>2]|0)+-88|0,220)|0;c[L>>2]=I;c[N>>2]=Na;d=c[I+20>>2]|0;b:do if(!d){k=c[I+72>>2]|0;t=c[I+16>>2]|0;u=c[I+12>>2]|0;j=a[I+24>>0]|0;v=c[M>>2]|0;w=c[L>>2]|0;x=w+80|0;y=w+76|0;d=c[y>>2]|0;g=c[R>>2]&63;f=c[Na+(g<<2)>>2]|0;c[Ia>>2]=c[1020280+(f<<9)+(g<<3)>>2];c[S>>2]=c[1020280+(f<<9)+(g<<3)+4>>2];g=c[T>>2]&63;f=c[Na+(g<<2)>>2]|0;c[Ja>>2]=c[1028472+(f<<9)+(g<<3)>>2];c[U>>2]=c[1028472+(f<<9)+(g<<3)+4>>2];Gf(Ka,Na,0,u,1055552,Ia,Ja,L);Tf(Fa,Na);g=c[V>>2]|0;f=c[W>>2]|0;e=Lf(Ka)|0;if(e){z=w+84|0;A=u+-1|0;G=(u|0)>2;H=w+72|0;C=j<<24>>24==0;B=0-t|0;s=(u|0)>63?63:u;E=((g|0)>=(f|0)|(g|0)==32002|(f|0)==32002)&1;j=k;k=e;c:while(1){while(1){g=(c[254504]|0)+((c[264912]|0)*20|0)|0;e=c[254505]|0;if((g|0)!=(e|0)){f=g;g=0;do{g=((c[c[f+8>>2]>>2]|0)==(k|0)&1)+g|0;f=f+20|0}while((f|0)!=(e|0));if((g|0)!=0?(r=ea,dg(Na,k,c[r>>2]|0,c[r+4>>2]|0)|0):0){D=k;break}}k=Lf(Ka)|0;if(!k)break b}o=c[z>>2]|0;p=o+1|0;c[z>>2]=p;q=(o|0)==0;a[1017946]=q&1;k=c[267456]|0;if((c[267457]|0)==(k|0)){Ua=129;break a}if((v|0)==(c[k>>2]|0)?(Tb(Ta|0,0)|0,e=c[Ta>>2]|0,e=uv(e|0,((e|0)<0)<<31>>31|0,1e3,0)|0,r=(c[fa>>2]|0)/1e3|0,e=iv(r|0,((r|0)<0)<<31>>31|0,e|0,F|0)|0,r=1020264,r=hv(e|0,F|0,c[r>>2]|0,c[r+4>>2]|0)|0,e=F,(e|0)>0|(e|0)==0&r>>>0>3e3):0){k=Ec(mk(Ec(ef(1073416,0)|0,1059656,11)|0,u)|0,1059672,10)|0;Mh(ka,D,(a[ga>>0]|0)!=0);l=a[ka>>0]|0;if(!(l&1)){g=ha;l=(l&255)>>>1}else{g=c[ia>>2]|0;l=c[ja>>2]|0}r=Ec(Ec(k,g,l)|0,1059688,16)|0;r=nk(r,(c[264912]|0)+p|0)|0;hj(Ta,r+(c[(c[r>>2]|0)+-12>>2]|0)|0);e=Zo(Ta,1077904)|0;e=oc[c[(c[e>>2]|0)+28>>2]&63](e,10)|0;Wo(Ta);rk(r,e)|0;Wj(r)|0;ef(r,1)|0;Bi(ka)}c[da>>2]=0;k=D&49152;e=(k|0)==0;if(e){l=D&63;m=(c[Na+(l<<2)>>2]|0)!=0;r=Fa;if((c[r>>2]|0)==0&(c[r+4>>2]|0)==0){k=Fa+((c[Na+((D>>>6&63)<<2)>>2]&7)<<3)+16|0;r=46496+(l<<3)|0;l=c[r>>2]&c[k>>2];k=c[r+4>>2]&c[k+4>>2]}else Ua=140}else{m=(k|0)!=49152;Ua=140}if((Ua|0)==140){Ua=0;l=(fg(Na,D,Fa)|0)&1;k=0}n=(l|0)!=0|(k|0)!=0;if(n)l=(mg(Na,D)|0)>>>31^1;else l=0;f=A+l|0;c[Z>>2]=D;hg(Na,D,Pa,Fa,n);r=(o|0)>0;do if(m|G&r^1|(D|0)==(c[$>>2]|0)|(D|0)==(c[aa>>2]|0))if(r)Ua=157;else k=d;else{k=a[((p|0)>63?63:p)+(1044856+(E<<12)+(s<<6))>>0]|0;c[ba>>2]=k;m=D&63;l=c[Na+(m<<2)>>2]|0;if((c[1055552+(l<<8)+(m<<2)>>2]|0)<0){k=k+1|0;c[ba>>2]=k}if((D|0)==(c[Ia>>2]|0)?1:(D|0)==(c[S>>2]|0)){k=k+-1|0;k=(k|0)>0?k:0;c[ba>>2]=k}if(!((k|0)==0|e^1|(l&7|0)==1)){p=(ng(Na,m<<6|D>>>6&63)|0)<0;k=c[ba>>2]|0;if(p){k=k+-1|0;k=(k|0)>0?k:0;c[ba>>2]=k}}k=f-k|0;j=c[H>>2]|0;l=~j;g=0-j|0;k=0-(Og(Na,_,l,g,(k|0)<1?1:k,1)|0)|0;if(!((j|0)>=(k|0)|(c[ba>>2]|0)<4)){k=f+-2|0;k=0-(Og(Na,_,l,g,(k|0)<1?1:k,1)|0)|0}if((k|0)>(j|0)){p=(c[ba>>2]|0)==0;c[ba>>2]=0;if(p)break;else{Ua=157;break}}else{c[ba>>2]=0;break}}while(0);do if((Ua|0)==157){Ua=0;j=c[H>>2]|0;l=~j;k=0-j|0;if((f|0)>=1){k=0-(Og(Na,_,l,k,f,C)|0)|0;break}if(n){k=0-(Pg(Na,_,l,k,0)|0)|0;break}else{k=0-(Qg(Na,_,l,k,0)|0)|0;break}}while(0);do if(q|(k|0)>(j|0)){c[da>>2]=Oa;c[Oa>>2]=0;k=0-j|0;if((f|0)>=1){d=0-(Tg(Na,_,B,k,f,0)|0)|0;break}if(n){d=0-(Rg(Na,_,B,k,0)|0)|0;break}else{d=0-(Sg(Na,_,B,k,0)|0)|0;break}}else d=k;while(0);ig(Na,D);p=c[y>>2]|0;j=c[H>>2]|0;if(a[1017944]|0)break b;if(qh(v)|0)break b;k=c[254504]|0;l=c[254505]|0;d:do if((k|0)!=(l|0))while(1){if((c[c[k+8>>2]>>2]|0)==(D|0))break d;k=k+20|0;if((k|0)==(l|0)){k=l;break}}while(0);o=(d|0)>(j|0);do if(q|o){c[k>>2]=d;f=k+8|0;e=k+12|0;n=c[e>>2]|0;m=c[f>>2]|0;l=n-m>>2;do if(!l)Ug(f,1);else{if(l>>>0<=1)break;m=m+4|0;if((n|0)==(m|0))break;c[e>>2]=n+(~((n+-4-m|0)>>>2)<<2)}while(0);n=c[da>>2]|0;m=c[n>>2]|0;if(m){g=k+16|0;k=n;do{l=c[e>>2]|0;if((l|0)==(c[g>>2]|0))Ng(f,k);else{if(l)c[l>>2]=m;c[e>>2]=l+4}k=k+4|0;m=c[k>>2]|0}while((m|0)!=0)}if(!r)break;h[132464]=+h[132464]+1.0}else c[k>>2]=-32001;while(0);do if((d|0)>(p|0)){c[y>>2]=d;if(!o)break;c[x>>2]=D;if((d|0)>=(t|0))break c;c[H>>2]=d;j=c[H>>2]|0}while(0);k=Lf(Ka)|0;if(!k)break b}a[w+88>>0]=1}}else if((d|0)==2){l=c[I+72>>2]|0;k=c[I+12>>2]|0;v=(a[I+24>>0]|0)!=0;w=c[M>>2]|0;g=(c[Q>>2]|0)+56|0;j=c[g>>2]|0;g=c[g+4>>2]|0;A=c[L>>2]|0;E=A+80|0;x=A+76|0;m=c[x>>2]|0;f=c[R>>2]&63;d=c[Na+(f<<2)>>2]|0;c[Ia>>2]=c[1020280+(d<<9)+(f<<3)>>2];c[S>>2]=c[1020280+(d<<9)+(f<<3)+4>>2];f=c[T>>2]&63;d=c[Na+(f<<2)>>2]|0;c[Ja>>2]=c[1028472+(d<<9)+(f<<3)>>2];c[U>>2]=c[1028472+(d<<9)+(f<<3)+4>>2];Gf(Ma,Na,0,k,1055552,Ia,Ja,L);Tf(Ha,Na);f=c[V>>2]|0;d=c[W>>2]|0;e=Lf(Ma)|0;if(e){y=A+84|0;z=k+-1|0;t=(j|0)!=0|(g|0)!=0;u=(k|0)<16;q=((f|0)>=(d|0)|(f|0)==32002|(d|0)==32002)&1;r=1053048+(q<<6)+(k<<2)|0;s=(k|0)>63?63:k;B=(k|0)<3;D=A+72|0;C=v^1;j=m;while(1){p=j;e:while(1){o=(p|0)>-31872;f:while(1){d=X;do if(dg(Na,e,c[d>>2]|0,c[d+4>>2]|0)|0){m=c[y>>2]|0;k=m+1|0;c[y>>2]=k;j=e&49152;g=(j|0)==0;if(g){j=e&63;f=(c[Na+(j<<2)>>2]|0)!=0;d=Ha;if((c[d>>2]|0)==0&(c[d+4>>2]|0)==0){n=Ha+((c[Na+((e>>>6&63)<<2)>>2]&7)<<3)+16|0;j=46496+(j<<3)|0;d=c[j>>2]&c[n>>2];n=c[j+4>>2]&c[n+4>>2]}else{j=f;Ua=17}}else{j=(j|0)!=49152;Ua=17}if((Ua|0)==17){Ua=0;d=(fg(Na,e,Ha)|0)&1;n=0;f=j}if(!((d|0)==0&(n|0)==0)){n=e;j=f;Ua=22;break e}if(!g){j=f;l=0;g=0;n=0;Ua=23;break e}j=e>>>6&63;d=c[Na+(j<<2)>>2]|0;if((d&7|0)==1)j=((c[Y>>2]|0)*7^j>>>3|0)<4;else j=1;if(!(j&o&((f|t)^1))){l=0;j=f;g=1;n=z;break e}if(u?(k|0)>=(c[r>>2]|0):0)break;g=z-(a[((k|0)>63?63:k)+(1036664+(q<<12)+(s<<6))>>0]|0)|0;if((g|0)>=7){l=0;j=f;g=1;n=z;break e}j=(g*200|0)+128+(c[V>>2]|0)+(c[1059720+(d<<8)+((e&63)<<2)>>2]|0)|0;if((j|0)<=(l|0))break f;if((g|0)>=4){l=0;j=f;g=1;n=z;break e}if((mg(Na,e)|0)>=0){l=0;j=f;g=1;n=z;break e}}while(0);e=Lf(Ma)|0;if(!e)break b}p=(p|0)<(j|0)?j:p;if((p|0)>(c[x>>2]|0))c[x>>2]=p;e=Lf(Ma)|0;if(!e)break b}if((Ua|0)==22){e=n;l=1;n=(mg(Na,n)|0)>>>31^1;Ua=23}if((Ua|0)==23){Ua=0;n=n+z|0}c[Z>>2]=e;hg(Na,e,Ra,Ha,l);do if(!((m|0)<1|B|j|(e|0)==(c[$>>2]|0)|(e|0)==(c[aa>>2]|0))){j=a[((k|0)>63?63:k)+(1036664+(q<<12)+(s<<6))>>0]|0;c[ba>>2]=j;if(!(!v?(p=e&63,(c[1055552+(c[Na+(p<<2)>>2]<<8)+(p<<2)>>2]|0)>=0):0)){j=j+1|0;c[ba>>2]=j}if((e|0)==(c[Ia>>2]|0)?1:(e|0)==(c[S>>2]|0)){j=j+-1|0;j=(j|0)>0?j:0;c[ba>>2]=j}if(!((j|0)==0|g^1)?(ma=e&63,(c[Na+(ma<<2)>>2]&7|0)!=1):0){p=(ng(Na,ma<<6|e>>>6&63)|0)<0;j=c[ba>>2]|0;if(p){j=j+-1|0;j=(j|0)>0?j:0;c[ba>>2]=j}}g=n-j|0;f=c[D>>2]|0;k=~f;j=0-f|0;g=0-(Og(Na,_,k,j,(g|0)<1?1:g,1)|0)|0;if(!((f|0)>=(g|0)|(c[ba>>2]|0)<4)){g=n+-2|0;g=0-(Og(Na,_,k,j,(g|0)<1?1:g,1)|0)|0}if((g|0)>(f|0)){p=(c[ba>>2]|0)==0;c[ba>>2]=0;if(p)break;else{Ua=49;break}}else{c[ba>>2]=0;break}}else Ua=49;while(0);do if((Ua|0)==49){Ua=0;g=c[D>>2]|0;j=~g;g=0-g|0;if((n|0)>=1){g=0-(Og(Na,_,j,g,n,C)|0)|0;break}if(l){g=0-(Pg(Na,_,j,g,0)|0)|0;break}else{g=0-(Qg(Na,_,j,g,0)|0)|0;break}}while(0);ig(Na,e);j=c[x>>2]|0;l=c[D>>2]|0;if(a[1017944]|0)break b;if(qh(w)|0)break b;if((g|0)>(j|0)){c[x>>2]=g;if((g|0)>(l|0))break;else j=c[x>>2]|0}e=Lf(Ma)|0;if(!e)break b}c[E>>2]=e;a[A+88>>0]=1}}else if((d|0)==1?(na=c[I+72>>2]|0,oa=c[I+16>>2]|0,pa=c[I+12>>2]|0,qa=a[I+24>>0]|0,ra=c[M>>2]|0,ta=(c[Q>>2]|0)+56|0,sa=c[ta>>2]|0,ta=c[ta+4>>2]|0,ua=c[L>>2]|0,va=ua+80|0,wa=ua+76|0,xa=c[wa>>2]|0,ya=c[R>>2]&63,za=c[Na+(ya<<2)>>2]|0,c[Ia>>2]=c[1020280+(za<<9)+(ya<<3)>>2],c[S>>2]=c[1020280+(za<<9)+(ya<<3)+4>>2],ya=c[T>>2]&63,za=c[Na+(ya<<2)>>2]|0,c[Ja>>2]=c[1028472+(za<<9)+(ya<<3)>>2],c[U>>2]=c[1028472+(za<<9)+(ya<<3)+4>>2],Gf(La,Na,0,pa,1055552,Ia,Ja,L),Tf(Ga,Na),ya=c[V>>2]|0,za=c[W>>2]|0,Aa=Lf(La)|0,(Aa|0)!=0):0){s=ua+84|0;t=pa+-1|0;u=(sa|0)!=0|(ta|0)!=0;v=(pa|0)<16;w=((ya|0)>=(za|0)|(ya|0)==32002|(za|0)==32002)&1;x=1053048+(w<<6)+(pa<<2)|0;y=(pa|0)>63?63:pa;z=(pa|0)>2;A=ua+72|0;B=qa<<24>>24==0;C=0-oa|0;D=ua+4|0;g=na;r=Aa;j=xa;f=xa;g:while(1){q=ca;h:do if(dg(Na,r,c[q>>2]|0,c[q+4>>2]|0)|0){q=c[s>>2]|0;o=q+1|0;c[s>>2]=o;c[da>>2]=0;e=r&49152;p=(e|0)==0;if(p){k=r&63;e=(c[Na+(k<<2)>>2]|0)!=0;d=Ga;if((c[d>>2]|0)==0&(c[d+4>>2]|0)==0){d=Ga+((c[Na+((r>>>6&63)<<2)>>2]&7)<<3)+16|0;k=46496+(k<<3)|0;l=c[k>>2]&c[d>>2];d=c[k+4>>2]&c[d+4>>2]}else{k=e;Ua=68}}else{k=(e|0)!=49152;Ua=68}if((Ua|0)==68){Ua=0;l=(fg(Na,r,Ga)|0)&1;d=0;e=k}n=(l|0)!=0|(d|0)!=0;do if(!n)if(p){k=r>>>6&63;m=c[Na+(k<<2)>>2]|0;if((m&7|0)==1)k=((c[Y>>2]|0)*7^k>>>3|0)<4;else k=1;if(k&(j|0)>-31872&((e|u)^1)){if(v?(o|0)>=(c[x>>2]|0):0)break h;l=t-(a[((o|0)>63?63:o)+(1044856+(w<<12)+(y<<6))>>0]|0)|0;if((l|0)<7){k=(l*200|0)+128+(c[V>>2]|0)+(c[1059720+(m<<8)+((r&63)<<2)>>2]|0)|0;if((k|0)>(g|0)){if((l|0)>=4){d=t;break}if((mg(Na,r)|0)<0)break h;else{d=t;break}}else{j=(j|0)<(k|0)?k:j;if((j|0)<=(c[wa>>2]|0))break h;c[wa>>2]=j;break h}}else d=t}else d=t}else{k=0;Ua=74}else{k=(mg(Na,r)|0)>>>31^1;Ua=74}while(0);if((Ua|0)==74){Ua=0;d=k+t|0}c[Z>>2]=r;hg(Na,r,Qa,Ga,n);k=(q|0)>0;do if(e|z&k^1|(r|0)==(c[$>>2]|0)|(r|0)==(c[aa>>2]|0)){if(k)Ua=98}else{j=a[((o|0)>63?63:o)+(1044856+(w<<12)+(y<<6))>>0]|0;c[ba>>2]=j;k=r&63;g=c[Na+(k<<2)>>2]|0;if((c[1055552+(g<<8)+(k<<2)>>2]|0)<0){j=j+1|0;c[ba>>2]=j}if((r|0)==(c[Ia>>2]|0)?1:(r|0)==(c[S>>2]|0)){j=j+-1|0;j=(j|0)>0?j:0;c[ba>>2]=j}if(!((j|0)==0|p^1|(g&7|0)==1)){p=(ng(Na,k<<6|r>>>6&63)|0)<0;j=c[ba>>2]|0;if(p){j=j+-1|0;j=(j|0)>0?j:0;c[ba>>2]=j}}f=d-j|0;g=c[A>>2]|0;j=~g;e=0-g|0;f=0-(Og(Na,_,j,e,(f|0)<1?1:f,1)|0)|0;if(!((g|0)>=(f|0)|(c[ba>>2]|0)<4)){f=d+-2|0;f=0-(Og(Na,_,j,e,(f|0)<1?1:f,1)|0)|0}if((f|0)>(g|0)){p=(c[ba>>2]|0)==0;c[ba>>2]=0;if(p)break;else{Ua=98;break}}else{c[ba>>2]=0;break}}while(0);do if((Ua|0)==98){Ua=0;g=c[A>>2]|0;j=~g;f=0-g|0;if((d|0)>=1){f=0-(Og(Na,_,j,f,d,B)|0)|0;break}if(n){f=0-(Pg(Na,_,j,f,0)|0)|0;break}else{f=0-(Qg(Na,_,j,f,0)|0)|0;break}}while(0);if(!((q|0)!=0?!((f|0)>(g|0)&(f|0)<(oa|0)):0))Ua=105;do if((Ua|0)==105){Ua=0;c[da>>2]=Oa;c[Oa>>2]=0;j=0-g|0;if((d|0)>=1){f=0-(Tg(Na,_,C,j,d,0)|0)|0;break}if(n){f=0-(Rg(Na,_,C,j,0)|0)|0;break}else{f=0-(Sg(Na,_,C,j,0)|0)|0;break}}while(0);ig(Na,r);j=c[wa>>2]|0;g=c[A>>2]|0;if(a[1017944]|0)break b;if(qh(ra)|0)break b;if((f|0)>(j|0)){c[wa>>2]=f;n=c[wa>>2]|0;if((f|0)>(g|0)){c[va>>2]=r;d=c[(c[D>>2]|0)+4>>2]|0;k=c[da>>2]|0;c[d>>2]=r;j=d+4|0;do if(k){g=c[k>>2]|0;if(!g)break;else{e=j;j=d}while(1){k=k+4|0;c[e>>2]=g;j=j+8|0;g=c[k>>2]|0;if(!g)break;else{r=e;e=j;j=r}}}while(0);c[j>>2]=0;if((f|0)>=(oa|0))break g;c[A>>2]=f;g=c[A>>2]|0;j=n}else j=n}}while(0);r=Lf(La)|0;if(!r)break b}a[ua+88>>0]=1}while(0);a[Ca>>0]=0;c[N>>2]=0;A=c[O>>2]|0;z=I+(A>>>5<<2)+40|0;c[z>>2]=c[z>>2]&~(1<<(A&31));a[I+56>>0]=0;z=P;A=I+64|0;y=A;z=iv(c[y>>2]|0,c[y+4>>2]|0,c[z>>2]|0,c[z+4>>2]|0)|0;c[A>>2]=z;c[A+4>>2]=F;i:do if((c[I+8>>2]|0)!=(b|0)){e=128;d=I+40|0;while(1){if(c[d>>2]|0)break i;d=d+4|0;f=e+-32|0;if(f>>>0>31)e=f;else break}if((f|0)!=0?(c[d>>2]&-1>>>(64-e|0)|0)!=0:0)break}while(0);A=c[267457]|0;d=c[267456]|0;j:do if(!(A-d>>2>>>0<3|(A|0)==(d|0))){f=0;while(1){d=c[d+(f<<2)>>2]|0;e=c[d+856>>2]|0;if(((e|0)!=0?(Da=e+-1|0,Ea=d+(Da*96|0)+80|0,(a[Ea>>0]|0)!=0):0)?rh(b,c[(c[267456]|0)+(f<<2)>>2]|0)|0:0){g=Da;j=Ea;e=f;break}f=f+1|0;d=c[267456]|0;if(f>>>0>=(c[267457]|0)-d>>2>>>0)break j}f=d+(g*96|0)+24|0;if((a[j>>0]|0)!=0?rh(b,c[(c[267456]|0)+(e<<2)>>2]|0)|0:0){z=c[O>>2]|0;A=d+(g*96|0)+(z>>>5<<2)+64|0;c[A>>2]=1<<(z&31)|c[A>>2];c[K>>2]=f;a[Ca>>0]=1}}while(0)}while((a[Ca>>0]|0)!=0);k:do if(!la){e=128;d=J;while(1){if(c[d>>2]|0)break k;d=d+4|0;f=e+-32|0;if(f>>>0>31)e=f;else break}if(!f){Ua=220;break a}if(!(c[d>>2]&-1>>>(64-e|0))){Ua=220;break a}}while(0);if(a[Ba>>0]|0){Ua=220;break}}if((Ua|0)==129)Ko(1069824);else if((Ua|0)==220){i=Va;return}}function Ig(){var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;p=i;i=i+16|0;e=p;if((a[1055520]|0)==0?(Ia(1055520)|0)!=0:0){Tb(e|0,0)|0;m=c[e>>2]|0;m=uv(m|0,((m|0)<0)<<31>>31|0,1e3,0)|0;n=(c[e+4>>2]|0)/1e3|0;m=iv(n|0,((n|0)<0)<<31>>31|0,m|0,F|0)|0;n=1055512;c[n>>2]=m;c[n+4>>2]=F;Sa(1055520)}Tb(e|0,0)|0;g=c[e>>2]|0;g=uv(g|0,((g|0)<0)<<31>>31|0,1e3,0)|0;b=(c[e+4>>2]|0)/1e3|0;g=iv(b|0,((b|0)<0)<<31>>31|0,g|0,F|0)|0;b=1020264;b=hv(g|0,F|0,c[b>>2]|0,c[b+4>>2]|0)|0;g=F;Tb(e|0,0)|0;m=c[e>>2]|0;m=uv(m|0,((m|0)<0)<<31>>31|0,1e3,0)|0;n=(c[e+4>>2]|0)/1e3|0;m=iv(n|0,((n|0)<0)<<31>>31|0,m|0,F|0)|0;n=1055512;n=hv(m|0,F|0,c[n>>2]|0,c[n+4>>2]|0)|0;m=F;if((m|0)>0|(m|0)==0&n>>>0>999){Tb(e|0,0)|0;m=c[e>>2]|0;m=uv(m|0,((m|0)<0)<<31>>31|0,1e3,0)|0;n=(c[e+4>>2]|0)/1e3|0;m=iv(n|0,((n|0)<0)<<31>>31|0,m|0,F|0)|0;n=1055512;c[n>>2]=m;c[n+4>>2]=F;df()}if(c[254500]|0){i=p;return}f=c[254497]|0;m=f|c[254498]|c[254496];k=1018008;d=c[k>>2]|0;k=c[k+4>>2]|0;n=c[254499]|0;if((m|d|n|0)==0?(((m|0)<0)<<31>>31|k|((n|0)<0)<<31>>31|0)==0:0){if(!(((a[1017946]|0)!=0?(a[1017947]|0)==0:0)?(n=(~~(+(c[263294]|0)*+h[131648]*.71)*75|0)/100|0,m=((n|0)<0)<<31>>31,(g|0)>(m|0)|(g|0)==(m|0)&b>>>0>n>>>0):0))j=11;if((j|0)==11?(n=(c[263295]|0)+-10|0,m=((n|0)<0)<<31>>31,!((g|0)>(m|0)|(g|0)==(m|0)&b>>>0>n>>>0)):0){i=p;return}a[1017944]=1;i=p;return}n=((f|0)<0)<<31>>31;if(!((f|0)==0|((g|0)<(n|0)|(g|0)==(n|0)&b>>>0<f>>>0))){a[1017944]=1;i=p;return}if((d|0)==0&(k|0)==0){i=p;return}b=1020232;e=c[b>>2]|0;b=c[b+4>>2]|0;f=c[267457]|0;n=c[267456]|0;if((f|0)==(n|0))f=k;else{m=f-n>>2;l=0;do{f=n+(l<<2)|0;j=c[f>>2]|0;if((c[j+856>>2]|0)>0){f=c[f>>2]|0;d=f+856|0;g=0;while(1){k=j+(g*96|0)+88|0;e=iv(c[k>>2]|0,c[k+4>>2]|0,e|0,b|0)|0;b=F;k=0;do{if((c[j+(g*96|0)+(k>>>5<<2)+64>>2]&1<<(k&31)|0)!=0?(o=c[(c[n+(k<<2)>>2]|0)+840>>2]|0,(o|0)!=0):0){q=o+2200|0;e=iv(c[q>>2]|0,c[q+4>>2]|0,e|0,b|0)|0;b=F}k=k+1|0}while(k>>>0<m>>>0);g=g+1|0;if((g|0)<(c[d>>2]|0))j=f;else break}}l=l+1|0}while(l>>>0<m>>>0);d=1018008;f=c[d+4>>2]|0;d=c[d>>2]|0}if((b|0)<(f|0)|(b|0)==(f|0)&e>>>0<d>>>0){i=p;return}a[1017944]=1;i=p;return}function Jg(){var a=0,b=0;a=1018008|0;c[a>>2]=0;c[a+4>>2]=0;a=1017952|0;b=a+52|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(b|0));c[254504]=0;c[254505]=0;c[254506]=0;c[255068]=0;a=1020280;do{c[a>>2]=0;c[a+4>>2]=0;a=a+8|0}while((a|0)!=(1028472|0));a=1028472;do{c[a>>2]=0;c[a+4>>2]=0;a=a+8|0}while((a|0)!=(1036664|0));return}function Kg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+4272|0;n=o+88|0;m=o;k=o+2216|0;f=o+160|0;Tf(m,a);l=k+2048|0;c[l>>2]=k;e=Af(a,k)|0;c[k+2052>>2]=e;c[e>>2]=0;e=c[c[l>>2]>>2]|0;if(!e){l=0;m=0;F=l;i=o;return m|0}j=f+2048|0;k=f+2052|0;g=f;h=b+-1|0;if((b|0)==2){d=0;b=0;do{hg(a,e,n,m,fg(a,e,m)|0);c[j>>2]=f;h=Af(a,f)|0;c[k>>2]=h;c[h>>2]=0;d=iv(h-g>>3|0,0,d|0,b|0)|0;b=F;ig(a,c[c[l>>2]>>2]|0);h=(c[l>>2]|0)+8|0;c[l>>2]=h;e=c[h>>2]|0}while((e|0)!=0);F=b;i=o;return d|0}else{d=0;b=0;do{hg(a,e,n,m,fg(a,e,m)|0);k=Kg(a,h)|0;d=iv(k|0,F|0,d|0,b|0)|0;b=F;ig(a,c[c[l>>2]>>2]|0);k=(c[l>>2]|0)+8|0;c[l>>2]=k;e=c[k>>2]|0}while((e|0)!=0);F=b;i=o;return d|0}return 0}function Lg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=i;i=i+32|0;t=u;g=a+4|0;k=c[a>>2]|0;h=(((c[g>>2]|0)-k|0)/20|0)+1|0;if(h>>>0>214748364)Jo(a);j=((c[a+8>>2]|0)-k|0)/20|0;if(j>>>0<107374182){j=j<<1;h=j>>>0<h>>>0?h:j}else h=214748364;f=((c[g>>2]|0)-k|0)/20|0;k=t+12|0;c[k>>2]=0;c[t+16>>2]=a+8;if(!h)e=0;else e=ut(h*20|0)|0;c[t>>2]=e;j=e+(f*20|0)|0;s=t+8|0;c[s>>2]=j;d=t+4|0;c[d>>2]=j;c[k>>2]=e+(h*20|0);if((j|0)!=0?(n=b,p=c[n+4>>2]|0,m=j,c[m>>2]=c[n>>2],c[m+4>>2]=p,m=e+(f*20|0)+8|0,c[m>>2]=0,p=e+(f*20|0)+12|0,c[p>>2]=0,n=e+(f*20|0)+16|0,c[n>>2]=0,q=c[b+12>>2]|0,r=c[b+8>>2]|0,l=q-r|0,o=l>>2,(o|0)!=0):0){if(o>>>0>1073741823)Jo(m);g=ut(l)|0;c[p>>2]=g;c[m>>2]=g;c[n>>2]=g+(o<<2);if((r|0)!=(q|0)){h=q+-4|0;k=r;j=g;while(1){c[j>>2]=c[k>>2];k=k+4|0;if((k|0)==(q|0))break;else j=j+4|0}c[p>>2]=g+(((h-r|0)>>>2)+1<<2)}}c[s>>2]=e+((f+1|0)*20|0);Zg(a,t);d=c[d>>2]|0;e=c[s>>2]|0;if((e|0)!=(d|0)){f=~(((e+-20-d|0)>>>0)/20|0);g=e;do{h=c[g+-12>>2]|0;if(h){j=g+-8|0;k=c[j>>2]|0;if((k|0)!=(h|0))c[j>>2]=k+(~((k+-4-h|0)>>>2)<<2);xt(h)}g=g+-20|0}while((g|0)!=(d|0));c[s>>2]=e+(f*20|0)}d=c[t>>2]|0;if(!d){i=u;return}xt(d);i=u;return}function Mg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;N=i;i=i+2336|0;M=N+2248|0;x=N+2320|0;y=N+2316|0;z=N+2312|0;A=N+2240|0;B=N+2308|0;C=N+2304|0;D=N+2232|0;K=N;L=N+2292|0;E=N+2280|0;G=N+2268|0;J=c[267416]|0;l=c[267418]|0;n=c[267420]|0;g=c[267422]|0;m=c[267424]|0;mv(K|0,1053280,2232)|0;H=c[267426]|0;I=c[267414]|0;c[L+0>>2]=c[I+0>>2];c[L+4>>2]=c[I+4>>2];c[L+8>>2]=c[I+8>>2];I=J+1|0;if(((I|0)<128?(a[1017944]|0)==0:0)?(w=c[254496]|0,!((w|0)!=0&(J|0)>=(w|0))):0){h[132464]=+h[132464]*.5;k=c[254505]|0;f=c[254504]|0;e=k;if((k|0)!=(f|0)){k=(e-f|0)/20|0;j=0;do{c[f+(j*20|0)+4>>2]=c[f+(j*20|0)>>2];j=j+1|0}while(j>>>0<k>>>0);k=f}c[264912]=0;v=(e-k|0)/20|0;w=c[267412]|0;a:do if((v>>>0<w>>>0?v:w)|0){b=(I|0)<5;o=M+4|0;p=E+1|0;q=E+8|0;r=E+4|0;s=G+1|0;t=G+8|0;u=G+4|0;v=M+4|0;w=M+4|0;j=0;do{if(a[1017944]|0)break a;if(!b){g=c[k+(j*20|0)+4>>2]|0;n=g+-16|0;g=g+16|0;m=16;n=(n|0)<-32001?-32001:n;g=(g|0)>32001?32001:g}while(1){l=ah(K,H,n,g,I)|0;f=(c[254504]|0)+((c[264912]|0)*20|0)|0;e=c[254505]|0;j=e-f|0;d=(j|0)/20|0;if((j|0)>0){j=d;while(1){k=vt(j*20|0,1086976)|0;if(k)break;if((j|0)>1)j=(j|0)/2|0;else{k=0;j=0;break}}}else{k=0;j=0}c[B>>2]=f;c[C>>2]=e;c[x+0>>2]=c[B+0>>2];c[M+0>>2]=c[C+0>>2];bh(x,M,D,d,k,j);if(!k)k=0;else{xt(k);k=0}do{Gg((c[254504]|0)+(k*20|0)|0,K);k=k+1|0}while(k>>>0<=(c[264912]|0)>>>0);if(a[1017944]|0)break;if(((c[267412]|0)==1?!((l|0)>(n|0)&(l|0)<(g|0)):0)?(Tb(M|0,0)|0,e=c[M>>2]|0,e=uv(e|0,((e|0)<0)<<31>>31|0,1e3,0)|0,d=(c[o>>2]|0)/1e3|0,e=iv(d|0,((d|0)<0)<<31>>31|0,e|0,F|0)|0,d=1020264,d=hv(e|0,F|0,c[d>>2]|0,c[d+4>>2]|0)|0,e=F,(e|0)>0|(e|0)==0&d>>>0>3e3):0){j=ef(1073416,0)|0;ch(E,K,I,n,g);k=a[E>>0]|0;if(!(k&1)){f=p;k=(k&255)>>>1}else{f=c[q>>2]|0;k=c[r>>2]|0}d=Ec(j,f,k)|0;hj(M,d+(c[(c[d>>2]|0)+-12>>2]|0)|0);e=Zo(M,1077904)|0;e=oc[c[(c[e>>2]|0)+28>>2]&63](e,10)|0;Wo(M);rk(d,e)|0;Wj(d)|0;ef(d,1)|0;Bi(E)}if((l|0)>(n|0)){if((l|0)<(g|0))break;d=l+m|0;l=(g+n|0)/2|0;g=(d|0)>32001?32001:d}else{l=l-m|0;a[1017947]=1;a[1017945]=0;l=(l|0)<-32001?-32001:l;g=(g+n|0)/2|0}m=((m|0)/2|0)+m|0;n=l}f=c[254504]|0;j=(c[264912]|0)+1|0;e=f+(j*20|0)|0;j=j*20|0;d=(j|0)/20|0;if((j|0)>0){j=d;while(1){k=vt(j*20|0,1086976)|0;if(k)break;if((j|0)>1)j=(j|0)/2|0;else{k=0;j=0;break}}}else{k=0;j=0}c[y>>2]=f;c[z>>2]=e;c[x+0>>2]=c[y+0>>2];c[M+0>>2]=c[z+0>>2];bh(x,M,A,d,k,j);if(k)xt(k);do if(!(a[1017944]|0)){e=((c[254505]|0)-(c[254504]|0)|0)/20|0;d=c[267412]|0;if(((c[264912]|0)+1|0)!=((e>>>0<d>>>0?e:d)|0)?(Tb(M|0,0)|0,e=c[M>>2]|0,e=uv(e|0,((e|0)<0)<<31>>31|0,1e3,0)|0,d=(c[v>>2]|0)/1e3|0,e=iv(d|0,((d|0)<0)<<31>>31|0,e|0,F|0)|0,d=1020264,d=hv(e|0,F|0,c[d>>2]|0,c[d+4>>2]|0)|0,e=F,!((e|0)>0|(e|0)==0&d>>>0>3e3)):0)break;j=ef(1073416,0)|0;ch(G,K,I,n,g);k=a[G>>0]|0;if(!(k&1)){f=s;k=(k&255)>>>1}else{f=c[t>>2]|0;k=c[u>>2]|0}d=Ec(j,f,k)|0;hj(M,d+(c[(c[d>>2]|0)+-12>>2]|0)|0);e=Zo(M,1077904)|0;e=oc[c[(c[e>>2]|0)+28>>2]&63](e,10)|0;Wo(M);rk(d,e)|0;Wj(d)|0;ef(d,1)|0;Bi(G)}else{f=Ec(ef(1073416,0)|0,1053224,11)|0;e=1020232;e=Ec(pk(f,c[e>>2]|0,c[e+4>>2]|0)|0,1053240,6)|0;Tb(M|0,0)|0;f=c[M>>2]|0;f=uv(f|0,((f|0)<0)<<31>>31|0,1e3,0)|0;d=(c[w>>2]|0)/1e3|0;f=iv(d|0,((d|0)<0)<<31>>31|0,f|0,F|0)|0;d=1020264;d=hv(f|0,F|0,c[d>>2]|0,c[d+4>>2]|0)|0;d=ok(e,d,F)|0;hj(M,d+(c[(c[d>>2]|0)+-12>>2]|0)|0);e=Zo(M,1077904)|0;e=oc[c[(c[e>>2]|0)+28>>2]&63](e,10)|0;Wo(M);rk(d,e)|0;Wj(d)|0;ef(d,1)|0}while(0);j=(c[264912]|0)+1|0;c[264912]=j;k=c[254504]|0;e=((c[254505]|0)-k|0)/20|0;d=c[267412]|0}while(j>>>0<(e>>>0<d>>>0?e:d)>>>0)}while(0);if((c[L+4>>2]|0)!=0?(c[L>>2]|0)==(J|0):0)_g(L)|0;e=c[254498]|0;if((e|0)!=0&(l|0)>31871?(32e3-l|0)<=(e<<1|0):0){a[1017944]=1;e=c[254498]|0}x=c[254497]|e|c[254496];y=1018008;z=c[254499]|0;do if((((x|c[y>>2]|z|0)==0?(((x|0)<0)<<31>>31|c[y+4>>2]|((z|0)<0)<<31>>31|0)==0:0)?(a[1017944]|0)==0:0)?(a[1017945]|0)==0:0){if((J|0)>3&(c[267412]|0)==1)h[131648]=+h[132464]+1.0;if(((c[254505]|0)-(c[254504]|0)|0)!=20?(Tb(M|0,0)|0,w=c[M>>2]|0,w=uv(w|0,((w|0)<0)<<31>>31|0,1e3,0)|0,y=(c[M+4>>2]|0)/1e3|0,w=iv(y|0,((y|0)<0)<<31>>31|0,w|0,F|0)|0,y=1020264,y=hv(w|0,F|0,c[y>>2]|0,c[y+4>>2]|0)|0,w=F,z=~~(+(c[263294]|0)*+h[131648]*.71),x=((z|0)<0)<<31>>31,!((w|0)>(x|0)|(w|0)==(x|0)&y>>>0>z>>>0)):0)break;if(!(c[254500]|0)){a[1017944]=1;break}else{a[1017945]=1;break}}while(0);c[267416]=I;c[267418]=l;c[267420]=n;c[267422]=g;c[267424]=m;Xf(1053280,K)|0;c[267426]=H;Zb(176,0,1);i=N;return}do if(c[L+4>>2]|0){b=L+8|0;d=c[b>>2]|0;if(!d){d=_g(L)|0;c[b>>2]=d;if(!d)break}m=c[254504]|0;b=c[254505]|0;b:do if((m|0)==(b|0))b=m;else{e=m;do{if((c[c[e+8>>2]>>2]|0)==(d|0)){b=e;break b}e=e+20|0}while((e|0)!=(b|0))}while(0);d=m;n=c[d+4>>2]|0;f=M;c[f>>2]=c[d>>2];c[f+4>>2]=n;f=M+8|0;c[f>>2]=0;n=M+12|0;c[n>>2]=0;d=M+16|0;c[d>>2]=0;k=c[m+12>>2]|0;l=c[m+8>>2]|0;e=k-l|0;g=e>>2;if(g){if(g>>>0>1073741823)Jo(f);j=ut(e)|0;c[n>>2]=j;c[f>>2]=j;c[d>>2]=j+(g<<2);if((l|0)!=(k|0)){f=k+-4|0;e=l;d=j;while(1){c[d>>2]=c[e>>2];e=e+4|0;if((e|0)==(k|0))break;else d=d+4|0}c[n>>2]=j+(((f-l|0)>>>2)+1<<2)}}x=b;y=c[x+4>>2]|0;z=m;c[z>>2]=c[x>>2];c[z+4>>2]=y;if((m|0)!=(b|0))$g(m+8|0,c[b+8>>2]|0,c[b+12>>2]|0);x=M;y=c[x+4>>2]|0;z=b;c[z>>2]=c[x>>2];c[z+4>>2]=y;if((M|0)==(b|0))b=M+8|0;else{z=M+8|0;$g(b+8|0,c[z>>2]|0,c[n>>2]|0);b=z}b=c[b>>2]|0;if(b){d=c[n>>2]|0;if((d|0)!=(b|0))c[n>>2]=d+(~((d+-4-b|0)>>>2)<<2);xt(b)}}while(0);a[(c[267462]|0)+17>>0]=0;Eg(0);i=N;return}function Ng(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;k=a+4|0;l=c[a>>2]|0;e=((c[k>>2]|0)-l>>2)+1|0;if(e>>>0>1073741823)Jo(a);m=a+8|0;f=l;d=(c[m>>2]|0)-f|0;if(d>>2>>>0<536870911){d=d>>1;e=d>>>0<e>>>0?e:d;d=(c[k>>2]|0)-f|0;f=d>>2;if(!e){i=0;h=0;g=f;e=d}else j=6}else{d=(c[k>>2]|0)-f|0;e=1073741823;f=d>>2;j=6}if((j|0)==6){i=e;h=ut(e<<2)|0;g=f;e=d}f=h+(g<<2)|0;if(f)c[f>>2]=c[b>>2];mv(h|0,l|0,e|0)|0;c[a>>2]=h;c[k>>2]=h+(g+1<<2);c[m>>2]=h+(i<<2);if(!l)return;xt(l);return}function Og(f,g,h,j,k,l){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;pa=i;i=i+4848|0;ga=pa+4576|0;ea=pa+176|0;na=pa+4572|0;ia=pa+4568|0;T=pa+4832|0;P=pa+2416|0;Q=pa+88|0;ca=pa+2408|0;S=pa+2400|0;da=pa+248|0;aa=pa;_=c[f+2216>>2]|0;D=f+2220|0;ja=(c[D>>2]|0)+56|0;ja=(c[ja>>2]|0)!=0|(c[ja+4>>2]|0)!=0;c[ia>>2]=-32001;ka=g+8|0;c[ka>>2]=(c[g+-36>>2]|0)+1;if(((a[1017944]|0)==0?!(og(f)|0):0)?(r=c[ka>>2]|0,(r|0)<=127):0){p=r+-32e3|0;p=(p|0)<(h|0)?h:p;ha=31999-r|0;ha=(ha|0)>(j|0)?j:ha;if((p|0)>=(ha|0)){l=p;i=pa;return l|0}c[na>>2]=0;W=g+44|0;c[g+64>>2]=0;r=g+16|0;c[r>>2]=0;X=g+12|0;c[X>>2]=0;C=g+84|0;a[C>>0]=0;c[g+76>>2]=0;c[g+116>>2]=0;c[g+112>>2]=0;Y=g+20|0;Z=c[Y>>2]|0;fa=(Z|0)!=0;if(fa){la=Sf(f)|0;ma=F}else{ma=(c[D>>2]|0)+48|0;la=c[ma>>2]|0;ma=c[ma+4>>2]|0}G=Fh(1069912,la,ma,T)|0;h=a[T>>0]|0;if(h<<24>>24){o=b[G+2>>1]|0;x=o&65535;c[r>>2]=x;r=b[G+4>>1]|0;j=r<<16>>16;q=c[ka>>2]|0;if(r<<16>>16!=32002){if(r<<16>>16>31871)s=j-q|0;else s=(r<<16>>16<-31871?q:0)+j|0;if(((s|0)!=32002?(a[G+9>>0]|0)>=(k|0):0)?(n=(s|0)>=(ha|0),(d[G+8>>0]&(n?2:1)|0)!=0):0){c[X>>2]=x;if(!(n&o<<16>>16!=0)){l=s;i=pa;return l|0}p=x&49152;if(!p)p=(c[f+((x&63)<<2)>>2]|0)!=0;else p=(p|0)!=49152;if(p|ja){l=s;i=pa;return l|0}p=g+24|0;o=c[p>>2]|0;if((o|0)!=(x|0)){c[g+28>>2]=o;c[p>>2]=x}o=ba(k,k)|0;p=1055552+(c[f+((x>>>6&63)<<2)>>2]<<8)+((x&63)<<2)|0;o=(c[p>>2]|0)+o|0;if((((o|0)>-1?o:0-o|0)|0)<250)c[p>>2]=o;p=c[g+-32>>2]|0;if(((p>>>6^p)&63|0)!=0?(t=p&63,u=c[f+(t<<2)>>2]|0,v=1020280+(u<<9)+(t<<3)|0,w=c[v>>2]|0,(w|0)!=(x|0)):0){c[1020280+(u<<9)+(t<<3)+4>>2]=w;c[v>>2]=x}m=c[g+-76>>2]|0;if(!((m>>>6^m)&63)){l=s;i=pa;return l|0}if((p|0)!=(c[g+-28>>2]|0)){l=s;i=pa;return l|0}p=m&63;m=c[f+(p<<2)>>2]|0;n=1028472+(m<<9)+(p<<3)|0;o=c[n>>2]|0;if((o|0)==(x|0)){l=s;i=pa;return l|0}c[1028472+(m<<9)+(p<<3)+4>>2]=o;c[n>>2]=x;l=s;i=pa;return l|0}else o=s}else o=32002}else{c[r>>2]=0;h=0;o=32002;x=0}if(!ja){if(h<<24>>24){V=b[G+6>>1]|0;h=V<<16>>16;r=g+36|0;c[r>>2]=h;if(V<<16>>16==32002){h=xe(f)|0;c[r>>2]=h}if((o|0)==32002){q=h;r=32002;j=h}else{q=h;r=o;j=(d[G+8>>0]&((o|0)>(h|0)?2:1)|0)==0?h:o}}else{if((c[g+-32>>2]|0)==65)j=34-(c[g+-8>>2]|0)|0;else j=xe(f)|0;c[g+36>>2]=j;h=a[1069924]|0;r=jv(la|0,ma|0,48)|0;if(!((F|0)==0?(r|0)==(e[G>>1]|0):0))b[G+2>>1]=0;b[G>>1]=r;b[G+4>>1]=32002;b[G+6>>1]=j;a[G+8>>0]=h;a[G+9>>0]=-6;q=j;r=o}s=g+40|0;if(!(a[s>>0]|0)){if(((!((q|0)==32002?1:(c[(c[D>>2]|0)+64>>2]|0)!=0)?(y=c[g+-8>>2]|0,(y|0)!=32002):0)?(z=c[g+-32>>2]|0,!((z|0)==0|(z|0)==65)):0)?(z&49152|0)==0:0){V=z&63;U=0-(y+q)|0;V=1059720+(c[f+(V<<2)>>2]<<8)+(V<<2)|0;R=(c[V>>2]|0)+-1|0;c[V>>2]=(R|0)>(U|0)?R:U}do if(((k|0)<4?(A=(k<<5)+512|0,(j+A|0)<=(p|0)&(x|0)==0):0)?(V=c[f+2212>>2]|0,U=f+(V<<3)+320|0,R=f+264|0,V=47072+((V*7^6)<<3)|0,(c[R>>2]&c[U>>2]&c[V>>2]|0)==0?(c[R+4>>2]&c[U+4>>2]&c[V+4>>2]|0)==0:0):0)if((k|0)>1|(j+608|0)>(p|0)){V=p-A|0;h=Qg(f,g,V,V+1|0,0)|0;if((h|0)>(V|0))break;else m=h;i=pa;return m|0}else{l=Qg(f,g,p,ha,0)|0;i=pa;return l|0}while(0);if(((k|0)<7?(B=j+(ba(k,-200)|0)|0,(B|0)>=(ha|0)&(j|0)<1e4):0)?(c[(c[D>>2]|0)+(c[f+2212>>2]<<2)+16>>2]|0)!=0:0){l=B;i=pa;return l|0}do if(!((k|0)<2|(j|0)<(ha|0))?(c[(c[D>>2]|0)+(c[f+2212>>2]<<2)+16>>2]|0)!=0:0){c[X>>2]=65;o=j-ha|0;jg(f,ea);a[C>>0]=1;o=(((k*67|0)+823|0)/-256|0)+k+((o|0)>791?-3:(o|0)/-198|0)|0;n=(o|0)<1;q=0-ha|0;h=1-ha|0;if(n)h=Qg(f,W,q,h,0)|0;else h=Og(f,W,q,h,o,l^1)|0;j=0-h|0;a[C>>0]=0;kg(f);if((ha|0)<=(j|0)){j=(h|0)<-31871?ha:j;do if((k|0)<12){if((((ha|0)>-1?ha:q)|0)<1e4)m=j;else break;i=pa;return m|0}while(0);a[s>>0]=1;h=ha+-1|0;if(n)h=Qg(f,g,h,ha,0)|0;else h=Og(f,g,h,ha,o,0)|0;a[s>>0]=0;if((h|0)<(ha|0))break;else m=j;i=pa;return m|0}}while(0);if((k|0)>=5){a:do if((((ha|0)>-1?ha:0-ha|0)|0)<31872?(H=ha+200|0,H=(H|0)>32001?32001:H,I=k+-4|0,If(P,f,x,1055552,c[(c[D>>2]|0)+64>>2]|0),Tf(Q,f),E=Kf(P)|0,(E|0)!=0):0){j=Q+8|0;q=0-H|0;o=1-H|0;n=l^1;h=E;while(1){V=j;if(dg(f,h,c[V>>2]|0,c[V+4>>2]|0)|0?(c[X>>2]=h,hg(f,h,ea,Q,fg(f,h,Q)|0),m=0-(Og(f,W,q,o,I,n)|0)|0,ig(f,h),(H|0)<=(m|0)):0)break;h=Kf(P)|0;if(!h)break a}i=pa;return m|0}while(0);if(!((k|0)<8|(x|0)!=0))if(((c[g+36>>2]|0)+256|0)>=(ha|0)){a[s>>0]=1;Og(f,g,p,ha,((k<<1)+-4+((k|0)/-2|0)|0)/2|0,1)|0;a[s>>0]=0;h=Fh(1069912,la,ma,T)|0;if(!(a[T>>0]|0)){x=0;G=h}else{x=e[h+2>>1]|0;G=h}}else x=0}}}else{c[g+36>>2]=32002;r=o}V=c[g+-32>>2]&63;T=c[f+(V<<2)>>2]|0;c[ca>>2]=c[1020280+(T<<9)+(V<<3)>>2];U=ca+4|0;c[U>>2]=c[1020280+(T<<9)+(V<<3)+4>>2];V=c[g+-76>>2]&63;T=c[f+(V<<2)>>2]|0;c[S>>2]=c[1028472+(T<<9)+(V<<3)>>2];c[S+4>>2]=c[1028472+(T<<9)+(V<<3)+4>>2];Gf(da,f,x,k,1055552,ca,S,g);Tf(aa,f);V=g+36|0;T=c[V>>2]|0;h=c[g+-52>>2]|0;h=(T|0)>=(h|0)|(T|0)==32002|(h|0)==32002;if(((k|0)>7&(x|0)!=0?!((((r|0)>-1?r:0-r|0)|0)>9999|fa):0)?(a[G+8>>0]&2)!=0:0)T=(a[G+9>>0]|0)>=(k+-3|0);else T=0;j=Kf(da)|0;if(j){S=aa+8|0;I=r-(k<<1)|0;H=g+40|0;t=I+-1|0;m=(k|0)/2|0;u=k+-1|0;R=(k|0)<3;J=~p;K=0-p|0;L=l^1;M=_+852|0;N=_+856|0;O=g+24|0;P=g+28|0;Q=(k|0)>63?63:k;E=h&1;D=g+32|0;y=(k|0)<16;w=1053048+(E<<6)+(k<<2)|0;v=f+2212|0;A=0;h=0;b:while(1){c:do if((j|0)!=(Z|0)){r=A+1|0;q=j&49152;z=(q|0)==0;if(z){q=j&63;o=(c[f+(q<<2)>>2]|0)!=0;s=aa;if((c[s>>2]|0)==0&(c[s+4>>2]|0)==0){n=aa+((c[f+((j>>>6&63)<<2)>>2]&7)<<3)+16|0;q=46496+(q<<3)|0;s=c[q>>2]&c[n>>2];n=c[q+4>>2]&c[n+4>>2]}else{q=o;oa=97}}else{q=(q|0)!=49152;oa=97}if((oa|0)==97){oa=0;s=(fg(f,j,aa)|0)&1;n=0;o=q}C=(s|0)!=0|(n|0)!=0;if(!C)if(z){q=j>>>6&63;if((c[f+(q<<2)>>2]&7|0)==1){s=((c[v>>2]|0)*7^q>>>3|0)<4;q=0}else{s=1;q=0}}else{s=0;q=0}else{s=0;q=(mg(f,j)|0)>>>31^1}if(T?!((j|0)!=(x|0)|(q|0)!=0):0){q=S;if(dg(f,x,c[q>>2]|0,c[q+4>>2]|0)|0){c[Y>>2]=x;a[H>>0]=1;q=Og(f,g,t,I,m,l)|0;a[H>>0]=0;c[Y>>2]=0;q=(q|0)<(I|0)&1}else q=0}B=u+q|0;do if(!(o|ja)?($=c[ia>>2]|0,s&($|0)>-31872):0){if(y?(r|0)>=(c[w>>2]|0):0)break c;s=B-(a[((r|0)>63?63:r)+(1036664+(E<<12)+(Q<<6))>>0]|0)|0;if((s|0)>=7)break;q=(s*200|0)+128+(c[V>>2]|0)+(c[1059720+(c[f+((j>>>6&63)<<2)>>2]<<8)+((j&63)<<2)>>2]|0)|0;if((q|0)<=(p|0)){c[ia>>2]=($|0)<(q|0)?q:$;break c}if((s|0)>=4)break;if((mg(f,j)|0)<0)break c}while(0);s=S;if(dg(f,j,c[s>>2]|0,c[s+4>>2]|0)|0){c[X>>2]=j;if((h|0)<64&(o^1)){c[ga+(h<<2)>>2]=j;h=h+1|0}hg(f,j,ea,aa,C);do if(!((A|0)<1|R|o)){if((j|0)==(c[O>>2]|0)){oa=138;break}if((j|0)==(c[P>>2]|0)){oa=138;break}q=a[((r|0)>63?63:r)+(1036664+(E<<12)+(Q<<6))>>0]|0;c[D>>2]=q;if(!(!l?(s=j&63,(c[1055552+(c[f+(s<<2)>>2]<<8)+(s<<2)>>2]|0)>=0):0)){q=q+1|0;c[D>>2]=q}if((j|0)==(c[ca>>2]|0)?1:(j|0)==(c[U>>2]|0)){q=q+-1|0;q=(q|0)>0?q:0;c[D>>2]=q}do if(!((q|0)==0|z^1)){o=j&63;if((c[f+(o<<2)>>2]&7|0)==1)break;s=(ng(f,o<<6|j>>>6&63)|0)<0;q=c[D>>2]|0;if(!s)break;q=q+-1|0;q=(q|0)>0?q:0;c[D>>2]=q}while(0);q=B-q|0;q=0-(Og(f,W,J,K,(q|0)<1?1:q,1)|0)|0;do if((p|0)<(q|0)){if((c[D>>2]|0)<4)break;q=B+-2|0;q=0-(Og(f,W,J,K,(q|0)<1?1:q,1)|0)|0}while(0);if((q|0)>(p|0)){s=(c[D>>2]|0)==0;c[D>>2]=0;if(s)break;else{oa=138;break}}else{c[D>>2]=0;break}}else oa=138;while(0);do if((oa|0)==138){oa=0;if((B|0)>=1){q=0-(Og(f,W,J,K,B,L)|0)|0;break}if(C){q=0-(Pg(f,W,J,K,0)|0)|0;break}else{q=0-(Qg(f,W,J,K,0)|0)|0;break}}while(0);ig(f,j);if(a[1017944]|0){m=0;oa=175;break b}if(qh(_)|0){m=0;oa=175;break b}if((q|0)>(c[ia>>2]|0)?(c[ia>>2]=q,(q|0)>(p|0)):0){oa=147;break b}if((c[267459]|0)>(k|0)?1:(c[267457]|0)-(c[267456]|0)>>2>>>0<2)break;if((c[M>>2]|0)!=0?(a[(c[M>>2]|0)+56>>0]|0)!=0:0)break;if((c[N>>2]|0)>=8)break;sh(_,f,g,p,ha,ia,na,k,r,da,2,l);if(a[1017944]|0){m=0;oa=175;break b}if(qh(_)|0){m=0;oa=175;break b}if((c[ia>>2]|0)>=(ha|0))break b}else r=A}else r=A;while(0);j=Kf(da)|0;if(!j)break;else A=r}if((oa|0)==147)c[na>>2]=j;else if((oa|0)==175){i=pa;return m|0}if(r){r=c[ia>>2]|0;if((r|0)>=(ha|0)){q=c[na>>2]|0;j=q&49152;if(!j)j=(c[f+((q&63)<<2)>>2]|0)!=0;else j=(j|0)!=49152;if(!(j|ja)){dh(f,g,q,k,ga,h+-1|0);h=c[ia>>2]|0}else h=r}else h=r}else oa=156}else oa=156;if((oa|0)==156){do if(!fa)if(ja){p=(c[ka>>2]|0)+-32e3|0;break}else{p=c[1053192+(c[f+2212>>2]<<2)>>2]|0;break}while(0);c[ia>>2]=p;h=p}p=c[ka>>2]|0;if((h|0)>31871)r=p+h|0;else r=h-((h|0)<-31871?p:0)|0;j=(h|0)>=(ha|0)?2:1;n=c[na>>2]|0;m=c[V>>2]|0;q=a[1069924]|0;o=jv(la|0,ma|0,48)|0;if(!n){p=o&65535;if(!((F|0)==0?(o|0)==(e[G>>1]|0):0))oa=173}else{p=o&65535;oa=173}if((oa|0)==173)b[G+2>>1]=n;b[G>>1]=p;b[G+4>>1]=r;b[G+6>>1]=m;a[G+8>>0]=q&255|j;a[G+9>>0]=k;l=h;i=pa;return l|0}if((c[ka>>2]|0)<128|ja){l=c[1053192+(c[f+2212>>2]<<2)>>2]|0;i=pa;return l|0}else{l=xe(f)|0;i=pa;return l|0}return 0}function Pg(f,g,h,j,k){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0;G=i;i=i+2320|0;y=G+88|0;o=G+2312|0;x=G+160|0;w=G;u=g+12|0;c[u>>2]=0;A=g+8|0;c[A>>2]=(c[g+-36>>2]|0)+1;if(!(og(f)|0)?(c[A>>2]|0)<=127:0){v=f+2220|0;D=(c[v>>2]|0)+48|0;C=c[D>>2]|0;D=c[D+4>>2]|0;E=Fh(1069912,C,D,o)|0;if(a[o>>0]|0){l=e[E+2>>1]|0;o=b[E+4>>1]|0;n=o<<16>>16;m=c[A>>2]|0;if(o<<16>>16!=32002){if(o<<16>>16>31871)o=n-m|0;else o=(o<<16>>16<-31871?m:0)+n|0;if((a[E+9>>0]|0)>-1&(o|0)!=32002?(d[E+8>>0]&((o|0)>=(j|0)?2:1)|0)!=0:0){c[u>>2]=l;B=o;i=G;return B|0}else o=l}else o=l}else o=0;z=g+36|0;c[z>>2]=32002;Hf(x,f,o,k,1055552,c[g+-32>>2]&63);Tf(w,f);s=f+2212|0;t=w+8|0;r=g+44|0;p=0-j|0;q=0-h|0;j=k+-1|0;m=-32001;a:while(1){o=Kf(x)|0;if(!o){o=m;break}k=(m|0)>-31872;while(1){g=o&49152;l=w;if((g|0)==0&((c[l>>2]|0)==0&(c[l+4>>2]|0)==0)){l=w+((c[f+((o>>>6&63)<<2)>>2]&7)<<3)+16|0;H=46496+((o&63)<<3)|0;n=c[H>>2]&c[l>>2];l=c[H+4>>2]&c[l+4>>2]}else{n=(fg(f,o,w)|0)&1;l=0}n=(n|0)!=0|(l|0)!=0;if(!(((k?!((g|0)==32768|((g|0)!=49152?(c[f+((o&63)<<2)>>2]|0)!=0:0)):0)?!((g|0)==16384?1:(c[(c[v>>2]|0)+24>>2]&3<<(c[s>>2]<<1)|0)!=0):0)?(mg(f,o)|0)<0:0))B=23;if((B|0)==23?(B=0,g=t,dg(f,o,c[g>>2]|0,c[g+4>>2]|0)|0):0){c[u>>2]=o;hg(f,o,y,w,n);if(n)n=Pg(f,r,p,q,j)|0;else n=Qg(f,r,p,q,j)|0;l=0-n|0;ig(f,o);if((m|0)<(l|0)){m=l;break}}o=Kf(x)|0;if(!o){o=m;break a}}if((m|0)>(h|0)){B=29;break}}if((B|0)==29){g=c[A>>2]|0;if((n|0)<-31871)g=g-n|0;else g=m-((n|0)>31871?g:0)|0;A=c[z>>2]|0;B=a[1069924]|0;z=jv(C|0,D|0,48)|0;b[E+2>>1]=o;b[E>>1]=z;b[E+4>>1]=g;b[E+6>>1]=A;a[E+8>>0]=B&255|2;a[E+9>>0]=0;B=m;i=G;return B|0}g=c[A>>2]|0;if((o|0)==-32001){B=g+-32e3|0;i=G;return B|0}if((o|0)>31871)n=g+o|0;else n=o-((o|0)<-31871?g:0)|0;l=c[z>>2]|0;m=a[1069924]|0;g=jv(C|0,D|0,48)|0;if(!((F|0)==0?(g|0)==(e[E>>1]|0):0))b[E+2>>1]=0;b[E>>1]=g;b[E+4>>1]=n;b[E+6>>1]=l;a[E+8>>0]=m&255|1;a[E+9>>0]=0;B=o;i=G;return B|0}B=c[1053192+(c[f+2212>>2]<<2)>>2]|0;i=G;return B|0}function Qg(f,g,h,j,k){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0;J=i;i=i+2320|0;B=J+88|0;r=J+2312|0;A=J+160|0;z=J;y=g+12|0;c[y>>2]=0;D=g+8|0;c[D>>2]=(c[g+-36>>2]|0)+1;x=og(f)|0;p=(c[D>>2]|0)>127;if(x){if(!p){C=c[1053192+(c[f+2212>>2]<<2)>>2]|0;i=J;return C|0}}else if(!p){H=k>>31;l=f+2220|0;G=(c[l>>2]|0)+48|0;E=c[G>>2]|0;G=c[G+4>>2]|0;I=Fh(1069912,E,G,r)|0;if(a[r>>0]|0){m=e[I+2>>1]|0;p=b[I+4>>1]|0;o=p<<16>>16;n=c[D>>2]|0;if(p<<16>>16!=32002){if(p<<16>>16>31871)p=o-n|0;else p=(p<<16>>16<-31871?n:0)+o|0;if(((p|0)!=32002?(a[I+9>>0]|0)>=(H|0):0)?(d[I+8>>0]&((p|0)>=(j|0)?2:1)|0)!=0:0){c[y>>2]=m;C=p;i=J;return C|0}}else p=32002;x=b[I+6>>1]|0;o=x<<16>>16;n=g+36|0;c[n>>2]=o;if(x<<16>>16==32002){o=xe(f)|0;c[n>>2]=o}if((p|0)==32002){q=o;n=m;p=o}else{q=o;n=m;p=(d[I+8>>0]&((p|0)>(o|0)?2:1)|0)==0?o:p}}else{if((c[g+-32>>2]|0)==65)p=34-(c[g+-8>>2]|0)|0;else p=xe(f)|0;c[g+36>>2]=p;q=p;n=0}if((p|0)>=(j|0)){if(a[r>>0]|0){C=p;i=J;return C|0}o=(c[l>>2]|0)+48|0;l=c[D>>2]|0;if((p|0)>31871)n=l+p|0;else n=p-((p|0)<-31871?l:0)|0;m=a[1069924]|0;l=jv(c[o>>2]|0,c[o+4>>2]|0,48)|0;if(!((F|0)==0?(l|0)==(e[I>>1]|0):0))b[I+2>>1]=0;b[I>>1]=l;b[I+4>>1]=n;b[I+6>>1]=q;a[I+8>>0]=m&255|2;a[I+9>>0]=-6;C=p;i=J;return C|0}x=p+128|0;Hf(A,f,n,k,1055552,c[g+-32>>2]&63);Tf(z,f);o=Kf(A)|0;a:do if(o){s=(x|0)>-1e4;t=f+2212|0;u=(x|0)>(h|0);v=z+8|0;w=g+44|0;r=0-j|0;l=0-h|0;j=k+-1|0;m=p;p=o;while(1){b:while(1){q=p&49152;n=z;if((q|0)==0&((c[n>>2]|0)==0&(c[n+4>>2]|0)==0)){n=z+((c[f+((p>>>6&63)<<2)>>2]&7)<<3)+16|0;k=46496+((p&63)<<3)|0;o=c[k>>2]&c[n>>2];n=c[k+4>>2]&c[n+4>>2]}else{o=(fg(f,p,z)|0)&1;n=0}o=(o|0)!=0|(n|0)!=0;do if(s&(o^1)){n=p>>>6&63;if((c[f+(n<<2)>>2]&7|0)==1?((c[t>>2]|0)*7^n>>>3|0)>3:0)break;n=(c[1004912+(c[f+((p&63)<<2)>>2]<<2)>>2]|0)+x|0;if((n|0)<=(h|0)){p=n;C=40;break b}if(!u?(ng(f,p)|0)<1:0){C=43;break b}}while(0);if(!((q|0)!=16384?(mg(f,p)|0)<0:0))C=47;if((C|0)==47?(C=0,n=v,dg(f,p,c[n>>2]|0,c[n+4>>2]|0)|0):0){c[y>>2]=p;hg(f,p,B,z,o);if(o)n=Pg(f,w,r,l,j)|0;else n=Qg(f,w,r,l,j)|0;o=0-n|0;ig(f,p);if((m|0)<(o|0)){m=o;C=52;break}}p=Kf(A)|0;if(!p){p=m;break a}}if((C|0)==40){C=0;m=(m|0)<(p|0)?p:m}else if((C|0)==43){C=0;m=(m|0)<(x|0)?x:m}else if((C|0)==52){C=0;if((m|0)>(h|0))break}p=Kf(A)|0;if(!p){p=m;break a}}o=c[D>>2]|0;if((n|0)<-31871)n=o-n|0;else n=m-((n|0)>31871?o:0)|0;B=c[g+36>>2]|0;C=a[1069924]|0;f=jv(E|0,G|0,48)|0;b[I+2>>1]=p;b[I>>1]=f;b[I+4>>1]=n;b[I+6>>1]=B;a[I+8>>0]=C&255|2;a[I+9>>0]=H;C=m;i=J;return C|0}while(0);l=c[D>>2]|0;if((p|0)>31871)m=l+p|0;else m=p-((p|0)<-31871?l:0)|0;o=c[g+36>>2]|0;n=a[1069924]|0;l=jv(E|0,G|0,48)|0;if(!((F|0)==0?(l|0)==(e[I>>1]|0):0))b[I+2>>1]=0;b[I>>1]=l;b[I+4>>1]=m;b[I+6>>1]=o;a[I+8>>0]=n&255|1;a[I+9>>0]=H;C=p;i=J;return C|0}C=xe(f)|0;i=J;return C|0}
function ye(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0.0;ub=i;i=i+160|0;sb=ub+144|0;tb=ub;g=999792;h=g+120|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));pb=f+2220|0;Ya=c[(c[pb>>2]|0)+36>>2]|0;qb=Te(f)|0;rb=qb+8|0;h=c[qb+12>>2]|0;if(h){Ta=oc[c[(c[h>>2]|0)+12>>2]&63](h,f)|0;Wa=c[f+2212>>2]|0;Va=Ta+17|0;Wa=(Wa|0)==0;Ta=-17-Ta|0;Ta=Wa?Va:Ta;Va=tb+64|0;Wa=tb+8|0;c[Wa>>2]=1000312;Ya=tb+12|0;c[tb>>2]=1000460;c[Va>>2]=1000480;Xa=tb+4|0;c[Xa>>2]=0;Xa=tb+64|0;ij(Xa,Ya);Xa=tb+136|0;c[Xa>>2]=0;Xa=tb+140|0;c[Xa>>2]=-1;c[tb>>2]=1000292;c[Va>>2]=1000332;c[Wa>>2]=1000312;nj(Ya);c[Ya>>2]=1000496;Xa=tb+44|0;Ua=tb+60|0;c[Xa+0>>2]=0;c[Xa+4>>2]=0;c[Xa+8>>2]=0;c[Xa+12>>2]=0;c[Ua>>2]=24;c[sb+0>>2]=0;c[sb+4>>2]=0;c[sb+8>>2]=0;Ae(Ya,sb);Bi(sb);Ua=tb+8|0;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+4|0;Sa=Ua+Sa|0;Ra=c[Sa>>2]|0;Ra=Ra|1024;c[Sa>>2]=Ra;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+4|0;Sa=Ua+Sa|0;Ra=c[Sa>>2]|0;Ra=Ra&-2049;c[Sa>>2]=Ra;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+4|0;Sa=Ua+Sa|0;Ra=c[Sa>>2]|0;Ra=Ra&-261;Ra=Ra|4;c[Sa>>2]=Ra;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+8|0;Sa=Ua+Sa|0;c[Sa>>2]=2;Sa=Ec(Ua,999912,59)|0;Sa=Ec(Sa,999976,59)|0;Ec(Sa,1000040,59)|0;Sa=c[249956]|0;Ra=c[249971]|0;Qa=c[Ua>>2]|0;Qa=Qa+-12|0;Qa=c[Qa>>2]|0;Qa=Qa+12|0;Qa=Ua+Qa|0;c[Qa>>2]=15;Qa=Ec(Ua,1000104,8)|0;Qa=Ec(Qa,1000552,31)|0;Pa=c[Qa>>2]|0;Pa=Pa+-12|0;Pa=c[Pa>>2]|0;Pa=Pa+12|0;Pa=Qa+Pa|0;c[Pa>>2]=5;Ra=Sa-Ra|0;Sa=Ra+32768|0;Sa=Sa>>16;vb=+(Sa|0);vb=vb/258.0;Qa=qk(Qa,vb)|0;Qa=Ec(Qa,1072408,1)|0;Sa=c[Qa>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+12|0;Sa=Qa+Sa|0;c[Sa>>2]=5;Ra=Ra<<16;Ra=Ra>>16;vb=+(Ra|0);vb=vb/258.0;Qa=qk(Qa,vb)|0;Ec(Qa,1000584,2)|0;Qa=c[249957]|0;Ra=c[249972]|0;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+12|0;Sa=Ua+Sa|0;c[Sa>>2]=15;Sa=Ec(Ua,1000120,9)|0;Sa=Ec(Sa,1000552,31)|0;Pa=c[Sa>>2]|0;Pa=Pa+-12|0;Pa=c[Pa>>2]|0;Pa=Pa+12|0;Pa=Sa+Pa|0;c[Pa>>2]=5;Ra=Qa-Ra|0;Qa=Ra+32768|0;Qa=Qa>>16;vb=+(Qa|0);vb=vb/258.0;Sa=qk(Sa,vb)|0;Sa=Ec(Sa,1072408,1)|0;Qa=c[Sa>>2]|0;Qa=Qa+-12|0;Qa=c[Qa>>2]|0;Qa=Qa+12|0;Qa=Sa+Qa|0;c[Qa>>2]=5;Ra=Ra<<16;Ra=Ra>>16;vb=+(Ra|0);vb=vb/258.0;Sa=qk(Sa,vb)|0;Ec(Sa,1000584,2)|0;Sa=c[249949]|0;Ra=c[249964]|0;Qa=c[Ua>>2]|0;Qa=Qa+-12|0;Qa=c[Qa>>2]|0;Qa=Qa+12|0;Qa=Ua+Qa|0;c[Qa>>2]=15;Qa=Ec(Ua,1000136,5)|0;Qa=Ec(Qa,1000552,31)|0;Pa=c[Qa>>2]|0;Pa=Pa+-12|0;Pa=c[Pa>>2]|0;Pa=Pa+12|0;Pa=Qa+Pa|0;c[Pa>>2]=5;Ra=Sa-Ra|0;Sa=Ra+32768|0;Sa=Sa>>16;vb=+(Sa|0);vb=vb/258.0;Qa=qk(Qa,vb)|0;Qa=Ec(Qa,1072408,1)|0;Sa=c[Qa>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+12|0;Sa=Qa+Sa|0;c[Sa>>2]=5;Ra=Ra<<16;Ra=Ra>>16;vb=+(Ra|0);vb=vb/258.0;Qa=qk(Qa,vb)|0;Ec(Qa,1000584,2)|0;Be(tb,1000144,2);Be(tb,1000152,3);Be(tb,1000160,4);Be(tb,1000168,5);Be(tb,1000176,10);Be(tb,1000192,6);Be(tb,1000208,11);Be(tb,1000216,12);Be(tb,1073008,13);Ec(Ua,1000040,59)|0;Qa=c[249962]|0;Ra=c[249977]|0;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+12|0;Sa=Ua+Sa|0;c[Sa>>2]=15;Sa=Ec(Ua,1000232,5)|0;Sa=Ec(Sa,1000552,31)|0;Pa=c[Sa>>2]|0;Pa=Pa+-12|0;Pa=c[Pa>>2]|0;Pa=Pa+12|0;Pa=Sa+Pa|0;c[Pa>>2]=5;Ra=Qa-Ra|0;Qa=Ra+32768|0;Qa=Qa>>16;vb=+(Qa|0);vb=vb/258.0;Sa=qk(Sa,vb)|0;Sa=Ec(Sa,1072408,1)|0;Qa=c[Sa>>2]|0;Qa=Qa+-12|0;Qa=c[Qa>>2]|0;Qa=Qa+12|0;Qa=Sa+Qa|0;c[Qa>>2]=5;Ra=Ra<<16;Ra=Ra>>16;vb=+(Ra|0);vb=vb/258.0;Sa=qk(Sa,vb)|0;Ec(Sa,1000584,2)|0;Ua=Ec(Ua,1000240,19)|0;vb=+(Ta|0);vb=vb/258.0;Ua=qk(Ua,vb)|0;Ec(Ua,1000264,14)|0;Ce(e,Ya);c[tb>>2]=1000292;c[Va>>2]=1000332;c[Wa>>2]=1000312;c[Ya>>2]=1000496;Bi(Xa);kj(Ya);Ya=tb+64|0;fj(Ya);i=ub;return}Va=(b[rb>>1]|0)*65537|0;hb=Pf(f)|0;ib=hb+8|0;Xa=c[ib>>2]|0;Wa=(ba(Xa+32768>>16,c[249300]|0)|0)/256|0;Xa=(ba(Xa<<16>>16,c[249301]|0)|0)/256|0;jb=bg(f,0,0)|0;kb=F;Ua=f+1296|0;mb=50400+(c[Ua>>2]<<3)|0;lb=c[mb>>2]|0;mb=c[mb+4>>2]|0;ob=hb+32|0;nb=c[ob>>2]|0;ob=c[ob+4>>2]|0;if((c[(c[pb>>2]|0)+16>>2]|0)>2520){h=jv(lb|0,mb|0,8)|0;h=h|lb;k=F|mb;g=nb&lb;j=ob&mb;if((g|0)==0&(j|0)==0)n=0;else{Ta=g-(g>>>1&1431655765)|0;n=jv(g|0,j|0,33)|0;n=j-(n&1431655765)|0;n=(ba((n&858993459)+(Ta&858993459)+(Ta>>>2&858993459)+(n>>>2&858993459)|0,286331153)|0)>>>28}}else{h=0;k=0;n=0}ab=bg(f,1,1)|0;bb=F;Ta=f+784|0;Ea=c[Ta>>2]|0;db=50400+(Ea<<3)|0;cb=c[db>>2]|0;db=c[db+4>>2]|0;fb=hb+40|0;eb=c[fb>>2]|0;fb=c[fb+4>>2]|0;za=c[pb>>2]|0;if((c[za+20>>2]|0)>2520){l=ov(cb|0,db|0,8)|0;l=l|cb;m=F|db;j=eb&cb;g=fb&db;if((j|0)==0&(g|0)==0)x=0;else{Sa=j-(j>>>1&1431655765)|0;x=jv(j|0,g|0,33)|0;x=g-(x&1431655765)|0;x=(ba((x&858993459)+(Sa&858993459)+(Sa>>>2&858993459)+(x>>>2&858993459)|0,286331153)|0)>>>28}}else{x=0;l=0;m=0}g=cb|nb;j=db|ob;X=eb|lb;W=fb|mb;Za=f+320|0;qa=Za;oa=c[qa>>2]|0;qa=c[qa+4>>2]|0;_a=f+264|0;ra=_a;pa=c[ra>>2]|0;ra=c[ra+4>>2]|0;ya=f+304|0;xa=c[ya>>2]|pa;ya=c[ya+4>>2]|ra;va=~(xa&oa|eb);wa=~(ya&qa|fb);$a=f+328|0;na=$a;ma=c[na>>2]|0;na=c[na+4>>2]|0;xa=~(xa&ma|nb);ya=~(ya&na|ob);r=c[f+528>>2]|0;if((r|0)==64){Qa=0;Sa=0;Ra=0;ia=0;q=0;y=0}else{D=ma&pa;C=na&ra;E=f+272|0;J=f+280|0;E=(c[E>>2]&ma|0)==0?(c[E+4>>2]&na|0)==0:0;G=c[249288]|0;H=c[249272]|0;I=c[J>>2]&ma;J=c[J+4>>2]&na;w=0;s=0;v=g;t=n;q=0;u=0;y=0;g=0;B=f+532|0;while(1){o=48352+(r<<3)|0;n=c[o>>2]|0;o=c[o+4>>2]|0;A=46496+(r<<3)|0;z=c[A>>2]|0;A=c[A+4>>2]|0;if(!((z&jb|0)==0&(A&kb|0)==0)){Sa=66784+(Ea<<9)+(r<<3)|0;n=c[Sa>>2]&n;o=c[Sa+4>>2]&o}w=n|w;s=o|s;v=w|v;K=s|j;if(!((n&h|0)==0&(o&k|0)==0)){t=t+1|0;q=q+6|0;j=n&lb;p=o&mb;if(!((j|0)==0&(p|0)==0)){Ra=j-(j>>>1&1431655765)|0;Sa=jv(j|0,p|0,33)|0;Sa=p-(Sa&1431655765)|0;u=((ba((Sa&858993459)+(Ra&858993459)+(Ra>>>2&858993459)+(Sa>>>2&858993459)|0,286331153)|0)>>>28)+u|0}}Sa=n&va;Qa=o&wa;Ra=Sa-(Sa>>>1&1431655765)|0;Sa=jv(Sa|0,Qa|0,33)|0;Sa=Qa-(Sa&1431655765)|0;y=(c[996440+((ba((Sa&858993459)+(Ra&858993459)+(Ra>>>2&858993459)+(Sa>>>2&858993459)|0,286331153)|0)>>>28<<2)>>2]|0)+y|0;g=g-((z&eb|0)==0&(A&fb|0)==0?0:H)|0;Sa=61664+(r<<3)|0;if((D&c[Sa>>2]|0)==0?(C&c[Sa+4>>2]|0)==0:0){j=c[999280+(r<<2)>>2]|0;do if(j){if(!((z&nb|0)==0&(A&ob|0)==0)){if(E?(Sa=(z&-1437226411|0)!=0|(A&-1437226411|0)!=0,(I&(Sa?-1437226411:1437226410)|0)==0&(J&(Sa?-1437226411:1437226410)|0)==0):0){j=((j|0)/2|0)+(j<<1)|0;break}j=((j|0)/2|0)+j|0}}else j=0;while(0);g=((j|0)/2|0)+g+(j<<17)|0}if((r>>3|0)<4){Sa=46496+(r+8<<3)|0;g=(((c[Sa>>2]&pa|0)==0?(c[Sa+4>>2]&ra|0)==0:0)?0:G)+g|0}r=c[B>>2]|0;if((r|0)==64){Qa=g;Sa=w;Ra=s;ia=u;n=t;g=v;j=K;break}else{j=K;B=B+4|0}}}c[249950]=Qa;r=c[f+1040>>2]|0;if((r|0)==64){Ma=0;Pa=0;Oa=0;K=0;v=0;B=X;J=W;C=0}else{G=c[Ua>>2]|0;E=pa&oa;D=ra&qa;L=f+272|0;P=f+280|0;L=(c[L>>2]&oa|0)==0?(c[L+4>>2]&qa|0)==0:0;M=c[249288]|0;N=c[249272]|0;O=c[P>>2]&oa;P=c[P+4>>2]&qa;w=0;s=0;B=X;A=W;v=0;z=0;C=0;o=0;H=f+1044|0;while(1){u=48352+(r<<3)|0;t=c[u>>2]|0;u=c[u+4>>2]|0;J=46496+(r<<3)|0;K=c[J>>2]|0;J=c[J+4>>2]|0;if(!((K&ab|0)==0&(J&bb|0)==0)){Pa=66784+(G<<9)+(r<<3)|0;t=c[Pa>>2]&t;u=c[Pa+4>>2]&u}w=t|w;I=u|s;B=w|B;A=I|A;if(!((t&l|0)==0&(u&m|0)==0)){x=x+1|0;v=v+6|0;s=t&cb;p=u&db;if(!((s|0)==0&(p|0)==0)){Oa=s-(s>>>1&1431655765)|0;Pa=jv(s|0,p|0,33)|0;Pa=p-(Pa&1431655765)|0;z=((ba((Pa&858993459)+(Oa&858993459)+(Oa>>>2&858993459)+(Pa>>>2&858993459)|0,286331153)|0)>>>28)+z|0}}Pa=t&xa;Na=u&ya;Oa=Pa-(Pa>>>1&1431655765)|0;Pa=jv(Pa|0,Na|0,33)|0;Pa=Na-(Pa&1431655765)|0;C=(c[996440+((ba((Pa&858993459)+(Oa&858993459)+(Oa>>>2&858993459)+(Pa>>>2&858993459)|0,286331153)|0)>>>28<<2)>>2]|0)+C|0;o=o-((K&nb|0)==0&(J&ob|0)==0?0:N)|0;Pa=62176+(r<<3)|0;if((E&c[Pa>>2]|0)==0?(D&c[Pa+4>>2]|0)==0:0){p=c[999280+((r^56)<<2)>>2]|0;do if(p){if(!((K&eb|0)==0&(J&fb|0)==0)){if(L?(Pa=(K&-1437226411|0)!=0|(J&-1437226411|0)!=0,(O&(Pa?-1437226411:1437226410)|0)==0&(P&(Pa?-1437226411:1437226410)|0)==0):0){p=((p|0)/2|0)+(p<<1)|0;break}p=((p|0)/2|0)+p|0}}else p=0;while(0);o=((p|0)/2|0)+o+(p<<17)|0}if((r>>3^7|0)<4){Pa=46496+(r+-8<<3)|0;o=(((c[Pa>>2]&pa|0)==0?(c[Pa+4>>2]&ra|0)==0:0)?0:M)+o|0}r=c[H>>2]|0;if((r|0)==64){Ma=o;Pa=w;Oa=I;K=z;J=A;break}else{s=I;H=H+4|0}}}c[249965]=Ma;Na=f+592|0;t=c[Na>>2]|0;if((t|0)==64){Ka=0;P=0;O=0;t=ia;p=y}else{G=f+256|0;E=f+296|0;H=c[E>>2]&oa^c[G>>2];G=c[E+4>>2]&qa^c[G+4>>2];E=ma&pa;D=na&ra;o=f+272|0;U=f+280|0;o=(c[o>>2]&ma|0)==0?(c[o+4>>2]&na|0)==0:0;r=c[249288]|0;s=c[249286]|0;Q=(a[f+2224>>0]|0)==0;R=c[249296]|0;S=c[249273]|0;T=c[U>>2]&ma;U=c[U+4>>2]&na;I=t;P=0;O=0;t=ia;p=y;w=0;L=f+596|0;while(1){y=45728+(I<<3)|0;A=45216+(I<<3)|0;A=(ba(c[y+4>>2]&G,c[A+4>>2]|0)|0)^(ba(c[y>>2]&H,c[A>>2]|0)|0);A=(c[43680+(I<<2)>>2]|0)+(A>>>(c[46240+(I<<2)>>2]|0)<<3)|0;y=c[A>>2]|0;A=c[A+4>>2]|0;M=46496+(I<<3)|0;N=c[M>>2]|0;M=c[M+4>>2]|0;if(!((N&jb|0)==0&(M&kb|0)==0)){La=66784+(Ea<<9)+(I<<3)|0;y=c[La>>2]&y;A=c[La+4>>2]&A}P=y|P;O=A|O;g=P|g;j=O|j;if(!((y&h|0)==0&(A&k|0)==0)){n=n+1|0;q=q+2|0;z=y&lb;u=A&mb;if(!((z|0)==0&(u|0)==0)){Ka=z-(z>>>1&1431655765)|0;La=jv(z|0,u|0,33)|0;La=u-(La&1431655765)|0;t=((ba((La&858993459)+(Ka&858993459)+(Ka>>>2&858993459)+(La>>>2&858993459)|0,286331153)|0)>>>28)+t|0}}La=y&va;Fa=A&wa;Ka=La-(La>>>1&1431655765)|0;La=jv(La|0,Fa|0,33)|0;La=Fa-(La&1431655765)|0;p=(c[996568+((ba((La&858993459)+(Ka&858993459)+(Ka>>>2&858993459)+(La>>>2&858993459)|0,286331153)|0)>>>28<<2)>>2]|0)+p|0;w=w-((N&eb|0)==0&(M&fb|0)==0?0:S)|0;La=61664+(I<<3)|0;if((E&c[La>>2]|0)==0?(D&c[La+4>>2]|0)==0:0){y=c[999536+(I<<2)>>2]|0;do if(y){if(!((N&nb|0)==0&(M&ob|0)==0)){if(o?(La=(N&-1437226411|0)!=0|(M&-1437226411|0)!=0,(T&(La?-1437226411:1437226410)|0)==0&(U&(La?-1437226411:1437226410)|0)==0):0){y=((y|0)/2|0)+(y<<1)|0;break}y=((y|0)/2|0)+y|0}}else y=0;while(0);w=((y|0)/2|0)+w+(y<<17)|0}if((I>>3|0)<4){La=46496+(I+8<<3)|0;w=(((c[La>>2]&pa|0)==0?(c[La+4>>2]&ra|0)==0:0)?0:r)+w|0}w=w-(ba(c[hb+((((N&-1437226411|0)!=0|(M&-1437226411|0)!=0)&1)<<2)+96>>2]|0,s)|0)|0;if((!Q?(I|0)==7|(I|0)==0:0)?(ja=(I&7|0)==0?9:7,ha=ja+I|0,(c[f+(ha<<2)>>2]|0)==1):0){if(!(c[f+(ha+8<<2)>>2]|0))u=(c[f+(ha+ja<<2)>>2]|0)==1&1;else u=2;w=w-(R<<u)|0}I=c[L>>2]|0;if((I|0)==64){Ka=w;break}else L=L+4|0}}c[249951]=Ka;La=f+1104|0;w=c[La>>2]|0;if((w|0)==64){Fa=0;N=0;M=0;L=K;ja=J}else{S=f+256|0;R=f+296|0;T=c[R>>2]&ma^c[S>>2];S=c[R+4>>2]&na^c[S+4>>2];R=pa&oa;Q=ra&qa;H=f+272|0;X=f+280|0;H=(c[H>>2]&oa|0)==0?(c[H+4>>2]&qa|0)==0:0;G=c[249288]|0;E=c[249286]|0;D=(a[f+2224>>0]|0)==0;o=c[249296]|0;r=c[249273]|0;V=c[Ua>>2]|0;W=c[X>>2]&oa;X=c[X+4>>2]&qa;y=0;U=f+1108|0;N=0;M=0;while(1){A=45728+(w<<3)|0;z=45216+(w<<3)|0;z=(ba(c[A+4>>2]&S,c[z+4>>2]|0)|0)^(ba(c[A>>2]&T,c[z>>2]|0)|0);z=(c[43680+(w<<2)>>2]|0)+(z>>>(c[46240+(w<<2)>>2]|0)<<3)|0;A=c[z>>2]|0;z=c[z+4>>2]|0;I=46496+(w<<3)|0;L=c[I>>2]|0;I=c[I+4>>2]|0;if(!((L&ab|0)==0&(I&bb|0)==0)){Fa=66784+(V<<9)+(w<<3)|0;A=c[Fa>>2]&A;z=c[Fa+4>>2]&z}N=A|N;M=z|M;B=N|B;J=M|J;if(!((A&l|0)==0&(z&m|0)==0)){x=x+1|0;v=v+2|0;u=A&cb;s=z&db;if(!((u|0)==0&(s|0)==0)){ja=u-(u>>>1&1431655765)|0;Fa=jv(u|0,s|0,33)|0;Fa=s-(Fa&1431655765)|0;K=((ba((Fa&858993459)+(ja&858993459)+(ja>>>2&858993459)+(Fa>>>2&858993459)|0,286331153)|0)>>>28)+K|0}}Fa=A&xa;ia=z&ya;ja=Fa-(Fa>>>1&1431655765)|0;Fa=jv(Fa|0,ia|0,33)|0;Fa=ia-(Fa&1431655765)|0;C=(c[996568+((ba((Fa&858993459)+(ja&858993459)+(ja>>>2&858993459)+(Fa>>>2&858993459)|0,286331153)|0)>>>28<<2)>>2]|0)+C|0;y=y-((L&nb|0)==0&(I&ob|0)==0?0:r)|0;Fa=62176+(w<<3)|0;if((R&c[Fa>>2]|0)==0?(Q&c[Fa+4>>2]|0)==0:0){A=c[999536+((w^56)<<2)>>2]|0;do if(A){if(!((L&eb|0)==0&(I&fb|0)==0)){if(H?(Fa=(L&-1437226411|0)!=0|(I&-1437226411|0)!=0,(W&(Fa?-1437226411:1437226410)|0)==0&(X&(Fa?-1437226411:1437226410)|0)==0):0){A=((A|0)/2|0)+(A<<1)|0;break}A=((A|0)/2|0)+A|0}}else A=0;while(0);y=((A|0)/2|0)+y+(A<<17)|0}if((w>>3^7|0)<4){Fa=46496+(w+-8<<3)|0;y=(((c[Fa>>2]&pa|0)==0?(c[Fa+4>>2]&ra|0)==0:0)?0:G)+y|0}y=y-(ba(c[hb+((((L&-1437226411|0)!=0|(I&-1437226411|0)!=0)&1)<<2)+104>>2]|0,E)|0)|0;if((!D?(w|0)==63|(w|0)==56:0)?(ga=(w&7|0)==0?-7:-9,fa=ga+w|0,(c[f+(fa<<2)>>2]|0)==9):0){if(!(c[f+(fa+-8<<2)>>2]|0))w=(c[f+(fa+ga<<2)>>2]|0)==9&1;else w=2;y=y-(o<<w)|0}w=c[U>>2]|0;if((w|0)==64){Fa=y;L=K;ja=J;break}else U=U+4|0}}c[249966]=Fa;y=c[f+656>>2]|0;if((y|0)==64){la=0;ka=0;U=0}else{X=Ea&7;W=X>>>0<4;V=Ea>>3;S=(V|0)==0;R=(1<<X)+-1|0;Q=za+24|0;s=-1<<X+1;u=hb+84|0;z=f+256|0;A=f+288|0;Y=f+296|0;w=(c[Y>>2]|c[A>>2])&oa^c[z>>2];z=(c[Y+4>>2]|c[A+4>>2])&qa^c[z+4>>2];A=ma&pa;Y=na&ra;Z=c[249280]|0;_=c[hb+80>>2]|0;$=c[249290]|0;aa=c[249282]|0;ca=c[249284]|0;da=c[249274]|0;I=0;H=0;D=0;T=f+660|0;while(1){K=44448+(y<<3)|0;J=43936+(y<<3)|0;J=(ba(c[K+4>>2]&z,c[J+4>>2]|0)|0)^(ba(c[K>>2]&w,c[J>>2]|0)|0);J=(c[43424+(y<<2)>>2]|0)+(J>>>(c[44960+(y<<2)>>2]|0)<<3)|0;K=c[J>>2]|0;J=c[J+4>>2]|0;o=46496+(y<<3)|0;E=c[o>>2]|0;o=c[o+4>>2]|0;if(!((E&jb|0)==0&(o&kb|0)==0)){ia=66784+(Ea<<9)+(y<<3)|0;K=c[ia>>2]&K;J=c[ia+4>>2]&J}r=K|I;U=J|H;g=r|g;j=U|j;if(!((K&h|0)==0&(J&k|0)==0)){n=n+1|0;q=q+5|0;I=K&lb;H=J&mb;if(!((I|0)==0&(H|0)==0)){ha=I-(I>>>1&1431655765)|0;ia=jv(I|0,H|0,33)|0;ia=H-(ia&1431655765)|0;t=((ba((ia&858993459)+(ha&858993459)+(ha>>>2&858993459)+(ia>>>2&858993459)|0,286331153)|0)>>>28)+t|0}}H=K&va;I=J&wa;G=H-(H>>>1&1431655765)|0;H=jv(H|0,I|0,33)|0;H=I-(H&1431655765)|0;H=ba((H&858993459)+(G&858993459)+(G>>>2&858993459)+(H>>>2&858993459)|0,286331153)|0;G=H>>>28;p=(c[996696+(G<<2)>>2]|0)+p|0;D=D-((E&eb|0)==0&(o&fb|0)==0?0:da)|0;I=y>>3;if((I|0)>3?(ka=64736+(y<<3)|0,ea=A&c[ka>>2],ka=Y&c[ka+4>>2],!((ea|0)==0&(ka|0)==0)):0){ha=ea-(ea>>>1&1431655765)|0;ia=jv(ea|0,ka|0,33)|0;ia=ka-(ia&1431655765)|0;D=(ba((ba((ia&858993459)+(ha&858993459)+(ha>>>2&858993459)+(ia>>>2&858993459)|0,286331153)|0)>>>28,Z)|0)+D|0}K=y&7;J=1<<K;if(!(J&_)){if((H>>>0<=1073741823?(la=K>>>0<X>>>0,((V|0)==(I|0)|S)&(W^la^1)):0)?((la?R:s)&_|0)==0:0){ia=(ba(G,-1441792)|0)+$|0;D=D-(ba((c[Q>>2]&3|0)==0?2:1,ia)|0)|0}}else D=((c[u>>2]&J|0)!=0?aa:ca)+D|0;y=c[T>>2]|0;if((y|0)==64){la=D;ka=r;break}else{I=r;H=U;T=T+4|0}}}c[249952]=la;A=c[f+1168>>2]|0;if((A|0)==64){ua=0;ia=f+256|0;sa=0;ta=0;ha=ja}else{ia=f+256|0;aa=c[Ua>>2]|0;Y=aa&7;Z=Y>>>0<4;_=aa>>3;$=(_|0)==7;ea=(1<<Y)+-1|0;fa=za+24|0;ga=-1<<Y+1;ha=hb+80|0;da=ia;r=f+288|0;X=f+296|0;ca=(c[X>>2]|c[r>>2])&ma^c[da>>2];da=(c[X+4>>2]|c[r+4>>2])&na^c[da+4>>2];r=pa&oa;X=ra&qa;W=c[249280]|0;V=c[hb+84>>2]|0;S=c[249290]|0;R=c[249282]|0;Q=c[249284]|0;o=c[249274]|0;J=0;G=0;K=ja;z=0;D=f+1172|0;while(1){y=44448+(A<<3)|0;w=43936+(A<<3)|0;w=(ba(c[y+4>>2]&da,c[w+4>>2]|0)|0)^(ba(c[y>>2]&ca,c[w>>2]|0)|0);w=(c[43424+(A<<2)>>2]|0)+(w>>>(c[44960+(A<<2)>>2]|0)<<3)|0;y=c[w>>2]|0;w=c[w+4>>2]|0;H=46496+(A<<3)|0;I=c[H>>2]|0;H=c[H+4>>2]|0;if(!((I&ab|0)==0&(H&bb|0)==0)){ra=66784+(aa<<9)+(A<<3)|0;y=c[ra>>2]&y;w=c[ra+4>>2]&w}E=y|J;G=w|G;B=E|B;T=G|K;if(!((y&l|0)==0&(w&m|0)==0)){x=x+1|0;v=v+5|0;u=y&cb;s=w&db;if(!((u|0)==0&(s|0)==0)){qa=u-(u>>>1&1431655765)|0;ra=jv(u|0,s|0,33)|0;ra=s-(ra&1431655765)|0;L=((ba((ra&858993459)+(qa&858993459)+(qa>>>2&858993459)+(ra>>>2&858993459)|0,286331153)|0)>>>28)+L|0}}K=y&xa;w=w&ya;J=K-(K>>>1&1431655765)|0;K=jv(K|0,w|0,33)|0;K=w-(K&1431655765)|0;K=ba((K&858993459)+(J&858993459)+(J>>>2&858993459)+(K>>>2&858993459)|0,286331153)|0;J=K>>>28;C=(c[996696+(J<<2)>>2]|0)+C|0;z=z-((I&nb|0)==0&(H&ob|0)==0?0:o)|0;w=A>>3;if((w^7|0)>3?(ta=64736+(A<<3)|0,sa=r&c[ta>>2],ta=X&c[ta+4>>2],!((sa|0)==0&(ta|0)==0)):0){qa=sa-(sa>>>1&1431655765)|0;ra=jv(sa|0,ta|0,33)|0;ra=ta-(ra&1431655765)|0;z=(ba((ba((ra&858993459)+(qa&858993459)+(qa>>>2&858993459)+(ra>>>2&858993459)|0,286331153)|0)>>>28,W)|0)+z|0}A=A&7;y=1<<A;if(!(y&V)){if((K>>>0<=1073741823?(ua=A>>>0<Y>>>0,((_|0)==(w|0)|$)&(Z^ua^1)):0)?((ua?ea:ga)&V|0)==0:0){ra=(ba(J,-1441792)|0)+S|0;z=z-(ba((c[fa>>2]&12|0)==0?2:1,ra)|0)|0}}else z=((c[ha>>2]&y|0)!=0?R:Q)+z|0;A=c[D>>2]|0;if((A|0)==64){ua=z;sa=E;ta=G;ha=T;break}else{J=E;K=T;D=D+4|0}}}c[249967]=ua;E=N|Pa;G=M|Oa;J=~(sa|E)&va;K=~(ta|G)&wa;ja=c[249275]|0;T=0;s=n;n=0;o=0;r=f+720|0;a:while(1){u=s;y=t;D=p;while(1){w=r+4|0;r=c[r>>2]|0;if((r|0)==64){ma=y;na=q;oa=n;pa=o;qa=g;ra=j;break a}wa=ia;p=c[wa>>2]|0;wa=c[wa+4>>2]|0;A=44448+(r<<3)|0;s=43936+(r<<3)|0;s=(ba(c[A+4>>2]&wa,c[s+4>>2]|0)|0)^(ba(c[A>>2]&p,c[s>>2]|0)|0);s=(c[43424+(r<<2)>>2]|0)+(s>>>(c[44960+(r<<2)>>2]|0)<<3)|0;A=45728+(r<<3)|0;z=45216+(r<<3)|0;z=(ba(c[A+4>>2]&wa,c[z+4>>2]|0)|0)^(ba(c[A>>2]&p,c[z>>2]|0)|0);z=(c[43680+(r<<2)>>2]|0)+(z>>>(c[46240+(r<<2)>>2]|0)<<3)|0;p=c[z>>2]|c[s>>2];s=c[z+4>>2]|c[s+4>>2];z=46496+(r<<3)|0;A=c[z>>2]|0;z=c[z+4>>2]|0;if(!((A&jb|0)==0&(z&kb|0)==0)){wa=66784+(Ea<<9)+(r<<3)|0;p=c[wa>>2]&p;s=c[wa+4>>2]&s}n=p|n;o=s|o;g=n|g;j=o|j;if(!((p&h|0)==0&(s&k|0)==0)){u=u+1|0;q=q+5|0;r=p&lb;t=s&mb;if((r|0)==0&(t|0)==0)t=y;else{wa=r-(r>>>1&1431655765)|0;va=jv(r|0,t|0,33)|0;t=t-(va&1431655765)|0;t=((ba((t&858993459)+(wa&858993459)+(wa>>>2&858993459)+(t>>>2&858993459)|0,286331153)|0)>>>28)+y|0}}else t=y;p=J&p;va=K&s;wa=p-(p>>>1&1431655765)|0;p=jv(p|0,va|0,33)|0;p=va-(p&1431655765)|0;wa=(wa>>>2&858993459)+(wa&858993459)|0;p=(p>>>2&858993459)+(p&858993459)|0;p=(c[996824+((ba(p+wa+(wa>>>4)+(p>>>4)&252645135,16843009)|0)>>>24<<2)>>2]|0)+D|0;if((A&eb|0)==0&(z&fb|0)==0){y=t;D=p;r=w}else{r=w;s=u;break}}T=T-ja|0}c[249953]=T;W=c[Ua>>2]|0;ga=P|Sa;fa=O|Ra;X=~(ka|ga)&xa;S=~(U|fa)&ya;V=0;n=L;o=v;p=x;g=B;j=ha;v=C;t=0;s=0;r=f+1232|0;b:while(1){z=g;K=j;x=n;while(1){y=r+4|0;r=c[r>>2]|0;if((r|0)==64){Y=x;X=o;W=p;S=v;R=z;Q=K;C=t;aa=s;break b}ya=ia;g=c[ya>>2]|0;ya=c[ya+4>>2]|0;q=44448+(r<<3)|0;j=43936+(r<<3)|0;j=(ba(c[q+4>>2]&ya,c[j+4>>2]|0)|0)^(ba(c[q>>2]&g,c[j>>2]|0)|0);j=(c[43424+(r<<2)>>2]|0)+(j>>>(c[44960+(r<<2)>>2]|0)<<3)|0;q=45728+(r<<3)|0;w=45216+(r<<3)|0;w=(ba(c[q+4>>2]&ya,c[w+4>>2]|0)|0)^(ba(c[q>>2]&g,c[w>>2]|0)|0);w=(c[43680+(r<<2)>>2]|0)+(w>>>(c[46240+(r<<2)>>2]|0)<<3)|0;g=c[w>>2]|c[j>>2];j=c[w+4>>2]|c[j+4>>2];w=46496+(r<<3)|0;q=c[w>>2]|0;w=c[w+4>>2]|0;if(!((q&ab|0)==0&(w&bb|0)==0)){ya=66784+(W<<9)+(r<<3)|0;g=c[ya>>2]&g;j=c[ya+4>>2]&j}t=g|t;s=j|s;z=t|z;K=s|K;if(!((g&l|0)==0&(j&m|0)==0)){p=p+1|0;o=o+5|0;r=g&cb;n=j&db;if((r|0)==0&(n|0)==0)n=x;else{ya=r-(r>>>1&1431655765)|0;xa=jv(r|0,n|0,33)|0;n=n-(xa&1431655765)|0;n=((ba((n&858993459)+(ya&858993459)+(ya>>>2&858993459)+(n>>>2&858993459)|0,286331153)|0)>>>28)+x|0}}else n=x;ya=X&g;wa=S&j;xa=ya-(ya>>>1&1431655765)|0;ya=jv(ya|0,wa|0,33)|0;ya=wa-(ya&1431655765)|0;xa=(xa>>>2&858993459)+(xa&858993459)|0;ya=(ya>>>2&858993459)+(ya&858993459)|0;v=(c[996824+((ba(ya+xa+(xa>>>4)+(ya>>>4)&252645135,16843009)|0)>>>24<<2)>>2]|0)+v|0;if((q&nb|0)==0&(w&ob|0)==0){x=n;r=y}else{r=y;g=z;j=K;break}}V=V-ja|0}c[249968]=V;ca=D-S|0;da=(ba(c[249298]|0,ca+32768>>16)|0)/256|0;ca=(ba(c[249299]|0,ca<<16>>16)|0)/256|0;if((c[hb+48>>2]|0)==(Ea|0)?(c[hb+72>>2]|0)==(c[za+24>>2]&3|0):0)K=c[hb+56>>2]|0;else{K=Mf(hb,f,Ea)|0;c[hb+56>>2]=K}if(!W)ea=K;else{g=cb&~(Sa|nb|P|ka|oa)&R;n=db&~(Ra|ob|O|U|pa)&Q;x=ba(W,X)|0;v=g-(g>>>1&1431655765)|0;r=jv(g|0,n|0,33)|0;r=n-(r&1431655765)|0;r=((ba((r&858993459)+(v&858993459)+(v>>>2&858993459)+(r>>>2&858993459)|0,286331153)|0)>>>28)*19|0;r=(Y*10|0)+((jb|0)!=0|(kb|0)!=0?9:0)+((x|0)<77?x:77)+r+(((K+32768>>16)*63|0)/-512|0)+((c[f+388>>2]|0)==0?-60:0)|0;x=$a;v=c[x>>2]|0;x=c[x+4>>2]|0;j=~v;o=~x;t=C&g&j;s=aa&n&o;if(!((t|0)==0&(s|0)==0)?(Aa=t&(Pa|eb|N|sa),Ba=s&(Oa|fb|M|ta),!((Aa|0)==0&(Ba|0)==0)):0){za=Aa-(Aa>>>1&1431655765)|0;Aa=jv(Aa|0,Ba|0,33)|0;Ba=Ba-(Aa&1431655765)|0;r=(((ba((Ba&858993459)+(za&858993459)+(za>>>2&858993459)+(Ba>>>2&858993459)|0,286331153)|0)>>>28)*92|0)+r|0}Ba=64736+(Ea<<3)|0;j=g&sa&j&c[Ba>>2];g=n&ta&o&c[Ba+4>>2];if(!((j|0)==0&(g|0)==0)?(Ca=j&(Pa|eb|N|C),Da=g&(Oa|fb|M|aa),!((Ca|0)==0&(Da|0)==0)):0){Ba=Ca-(Ca>>>1&1431655765)|0;Ca=jv(Ca|0,Da|0,33)|0;Da=Da-(Ca&1431655765)|0;r=(((ba((Da&858993459)+(Ba&858993459)+(Ba>>>2&858993459)+(Da>>>2&858993459)|0,286331153)|0)>>>28)*68|0)+r|0}v=~(v|qa);p=~(x|ra);j=f+256|0;n=c[j>>2]|0;j=c[j+4>>2]|0;t=44448+(Ea<<3)|0;s=43936+(Ea<<3)|0;s=(ba(c[t+4>>2]&j,c[s+4>>2]|0)|0)^(ba(c[t>>2]&n,c[s>>2]|0)|0);s=(c[43424+(Ea<<2)>>2]|0)+(s>>>(c[44960+(Ea<<2)>>2]|0)<<3)|0;t=c[s>>2]&v;s=c[s+4>>2]&p;g=45728+(Ea<<3)|0;o=45216+(Ea<<3)|0;o=(ba(c[g+4>>2]&j,c[o+4>>2]|0)|0)^(ba(c[g>>2]&n,c[o>>2]|0)|0);o=(c[43680+(Ea<<2)>>2]|0)+(o>>>(c[46240+(Ea<<2)>>2]|0)<<3)|0;n=c[o>>2]&v;o=c[o+4>>2]&p;g=(n|t)&C;j=(o|s)&aa;if(!((g|0)==0&(j|0)==0)){Ca=g-(g>>>1&1431655765)|0;Da=jv(g|0,j|0,33)|0;Da=j-(Da&1431655765)|0;r=(((ba((Da&858993459)+(Ca&858993459)+(Ca>>>2&858993459)+(Da>>>2&858993459)|0,286331153)|0)>>>28)*50|0)+r|0}j=t&sa;g=s&ta;if(!((j|0)==0&(g|0)==0)){Ca=j-(j>>>1&1431655765)|0;Da=jv(j|0,g|0,33)|0;Da=g-(Da&1431655765)|0;r=r+(((ba((Da&858993459)+(Ca&858993459)+(Ca>>>2&858993459)+(Da>>>2&858993459)|0,286331153)|0)>>>28)*36|0)|0}j=n&N;g=o&M;if(!((j|0)==0&(g|0)==0)){Ca=j-(j>>>1&1431655765)|0;Da=jv(j|0,g|0,33)|0;Da=g-(Da&1431655765)|0;r=r+(((ba((Da&858993459)+(Ca&858993459)+(Ca>>>2&858993459)+(Da>>>2&858993459)|0,286331153)|0)>>>28)*7|0)|0}g=48352+(Ea<<3)|0;j=Pa&v&c[g>>2];g=Oa&p&c[g+4>>2];if(!((j|0)==0&(g|0)==0)){Da=j-(j>>>1&1431655765)|0;Ea=jv(j|0,g|0,33)|0;Ea=g-(Ea&1431655765)|0;r=(((ba((Ea&858993459)+(Da&858993459)+(Da>>>2&858993459)+(Ea>>>2&858993459)|0,286331153)|0)>>>28)*14|0)+r|0}ea=(r|0)>399?399:r;ea=K-(c[997232+(((ea|0)<0?0:ea)<<2)>>2]|0)|0}c[249954]=ea;K=c[Ua>>2]|0;if((c[hb+52>>2]|0)==(K|0)?(c[hb+76>>2]|0)==(c[(c[pb>>2]|0)+24>>2]&12|0):0)J=c[hb+60>>2]|0;else{J=Nf(hb,f,K)|0;c[hb+60>>2]=J}if(!u)ha=J;else{g=qa&lb&~(Pa|eb|N|sa|C);n=ra&mb&~(Oa|fb|M|ta|aa);q=ba(u,na)|0;p=g-(g>>>1&1431655765)|0;r=jv(g|0,n|0,33)|0;r=n-(r&1431655765)|0;r=((ba((r&858993459)+(p&858993459)+(p>>>2&858993459)+(r>>>2&858993459)|0,286331153)|0)>>>28)*19|0;r=(ma*10|0)+((ab|0)!=0|(bb|0)!=0?9:0)+((q|0)<77?q:77)+r+(((J+32768>>16)*63|0)/-512|0)+((c[f+356>>2]|0)==0?-60:0)|0;q=Za;p=c[q>>2]|0;q=c[q+4>>2]|0;j=~p;o=~q;t=g&oa&j;s=n&pa&o;if(!((t|0)==0&(s|0)==0)?(Ga=t&(Sa|nb|P|ka),Ha=s&(Ra|ob|O|U),!((Ga|0)==0&(Ha|0)==0)):0){Ea=Ga-(Ga>>>1&1431655765)|0;Ga=jv(Ga|0,Ha|0,33)|0;Ha=Ha-(Ga&1431655765)|0;r=(((ba((Ha&858993459)+(Ea&858993459)+(Ea>>>2&858993459)+(Ha>>>2&858993459)|0,286331153)|0)>>>28)*92|0)+r|0}Ha=64736+(K<<3)|0;j=g&ka&j&c[Ha>>2];g=n&U&o&c[Ha+4>>2];if(!((j|0)==0&(g|0)==0)?(Ia=j&(Sa|nb|P|oa),Ja=g&(Ra|ob|O|pa),!((Ia|0)==0&(Ja|0)==0)):0){Ha=Ia-(Ia>>>1&1431655765)|0;Ia=jv(Ia|0,Ja|0,33)|0;Ja=Ja-(Ia&1431655765)|0;r=(((ba((Ja&858993459)+(Ha&858993459)+(Ha>>>2&858993459)+(Ja>>>2&858993459)|0,286331153)|0)>>>28)*68|0)+r|0}p=~(p|R);q=~(q|Q);j=f+256|0;t=c[j>>2]|0;j=c[j+4>>2]|0;n=44448+(K<<3)|0;o=43936+(K<<3)|0;o=(ba(c[n+4>>2]&j,c[o+4>>2]|0)|0)^(ba(c[n>>2]&t,c[o>>2]|0)|0);o=(c[43424+(K<<2)>>2]|0)+(o>>>(c[44960+(K<<2)>>2]|0)<<3)|0;n=c[o>>2]&p;o=c[o+4>>2]&q;g=45728+(K<<3)|0;s=45216+(K<<3)|0;s=(ba(c[g+4>>2]&j,c[s+4>>2]|0)|0)^(ba(c[g>>2]&t,c[s>>2]|0)|0);s=(c[43680+(K<<2)>>2]|0)+(s>>>(c[46240+(K<<2)>>2]|0)<<3)|0;t=c[s>>2]&p;s=c[s+4>>2]&q;g=(t|n)&oa;j=(s|o)&pa;if(!((g|0)==0&(j|0)==0)){Ia=g-(g>>>1&1431655765)|0;Ja=jv(g|0,j|0,33)|0;Ja=j-(Ja&1431655765)|0;r=(((ba((Ja&858993459)+(Ia&858993459)+(Ia>>>2&858993459)+(Ja>>>2&858993459)|0,286331153)|0)>>>28)*50|0)+r|0}j=n&ka;g=o&U;if(!((j|0)==0&(g|0)==0)){Ia=j-(j>>>1&1431655765)|0;Ja=jv(j|0,g|0,33)|0;Ja=g-(Ja&1431655765)|0;r=r+(((ba((Ja&858993459)+(Ia&858993459)+(Ia>>>2&858993459)+(Ja>>>2&858993459)|0,286331153)|0)>>>28)*36|0)|0}j=t&P;g=s&O;if(!((j|0)==0&(g|0)==0)){Ia=j-(j>>>1&1431655765)|0;Ja=jv(j|0,g|0,33)|0;Ja=g-(Ja&1431655765)|0;r=r+(((ba((Ja&858993459)+(Ia&858993459)+(Ia>>>2&858993459)+(Ja>>>2&858993459)|0,286331153)|0)>>>28)*7|0)|0}g=48352+(K<<3)|0;j=Sa&p&c[g>>2];g=Ra&q&c[g+4>>2];if(!((j|0)==0&(g|0)==0)){Ia=j-(j>>>1&1431655765)|0;Ja=jv(j|0,g|0,33)|0;Ja=g-(Ja&1431655765)|0;r=(((ba((Ja&858993459)+(Ia&858993459)+(Ia>>>2&858993459)+(Ja>>>2&858993459)|0,286331153)|0)>>>28)*14|0)+r|0}ha=(r|0)>399?399:r;ha=J-(c[997232+(((ha|0)<0?0:ha)<<2)>>2]|0)|0}c[249969]=ha;g=$a;r=c[g>>2]|0;g=c[g+4>>2]|0;o=_a;n=r&eb&~c[o>>2];o=g&fb&~c[o+4>>2];if((n|0)==0&(o|0)==0){j=r;r=0}else{r=n&ga;g=o&fa;if((r|0)==0&(g|0)==0)r=0;else{j=r;r=0;do{Ja=_c(j,g)|0;Ia=iv(j|0,g|0,-1,-1)|0;j=Ia&j;g=F&g;r=(c[996952+((c[f+(Ja<<2)>>2]&7)<<2)>>2]|0)+r|0}while(!((j|0)==0&(g|0)==0))}g=n&ka;j=o&U;if(!((g|0)==0&(j|0)==0))do{Ja=_c(g,j)|0;Ia=iv(g|0,j|0,-1,-1)|0;g=Ia&g;j=F&j;r=(c[996984+((c[f+(Ja<<2)>>2]&7)<<2)>>2]|0)+r|0}while(!((g|0)==0&(j|0)==0));g=$a;j=c[g>>2]|0;g=c[g+4>>2]|0}v=qa&~eb&j;t=ra&~fb&g;if(!((v|0)==0&(t|0)==0)){g=v&ga;j=t&fa;if(!((g|0)==0&(j|0)==0))do{Ja=_c(g,j)|0;Ia=iv(g|0,j|0,-1,-1)|0;g=Ia&g;j=F&j;r=(c[997016+((c[f+(Ja<<2)>>2]&7)<<2)>>2]|0)+r|0}while(!((g|0)==0&(j|0)==0));g=v&(oa|ka);j=t&(pa|U);if(!((g|0)==0&(j|0)==0))do{Ja=_c(g,j)|0;Ia=iv(g|0,j|0,-1,-1)|0;g=Ia&g;j=F&j;r=(c[997048+((c[f+(Ja<<2)>>2]&7)<<2)>>2]|0)+r|0}while(!((g|0)==0&(j|0)==0));g=v&~R;j=t&~Q;if((g|0)==0&(j|0)==0)j=r;else{Ia=c[249294]|0;Ja=g-(g>>>1&1431655765)|0;Ha=jv(g|0,j|0,33)|0;j=j-(Ha&1431655765)|0;j=(ba(Ia,(ba((j&858993459)+(Ja&858993459)+(Ja>>>2&858993459)+(j>>>2&858993459)|0,286331153)|0)>>>28)|0)+r|0}g=v&cb;r=t&db;if((g|0)==0&(r|0)==0)ja=j;else{ja=iv(g|0,r|0,-1,-1)|0;ja=((ja&g|0)!=0|(F&r|0)!=0?c[249278]|0:c[249276]|0)+j|0}}else ja=r;c[249959]=ja;g=Za;r=c[g>>2]|0;g=c[g+4>>2]|0;o=_a;n=r&nb&~c[o>>2];o=g&ob&~c[o+4>>2];if((n|0)==0&(o|0)==0){j=r;r=0}else{r=n&E;g=o&G;if((r|0)==0&(g|0)==0)r=0;else{j=r;r=0;do{Ja=_c(j,g)|0;Ia=iv(j|0,g|0,-1,-1)|0;j=Ia&j;g=F&g;r=(c[996952+((c[f+(Ja<<2)>>2]&7)<<2)>>2]|0)+r|0}while(!((j|0)==0&(g|0)==0))}g=n&sa;j=o&ta;if(!((g|0)==0&(j|0)==0))do{Ja=_c(g,j)|0;Ia=iv(g|0,j|0,-1,-1)|0;g=Ia&g;j=F&j;r=(c[996984+((c[f+(Ja<<2)>>2]&7)<<2)>>2]|0)+r|0}while(!((g|0)==0&(j|0)==0));g=Za;j=c[g>>2]|0;g=c[g+4>>2]|0}v=R&~nb&j;t=Q&~ob&g;do if((v|0)==0&(t|0)==0)j=r;else{g=v&E;j=t&G;if(!((g|0)==0&(j|0)==0))do{Ja=_c(g,j)|0;Ia=iv(g|0,j|0,-1,-1)|0;g=Ia&g;j=F&j;r=(c[997016+((c[f+(Ja<<2)>>2]&7)<<2)>>2]|0)+r|0}while(!((g|0)==0&(j|0)==0));g=v&(C|sa);j=t&(aa|ta);if(!((g|0)==0&(j|0)==0))do{Ja=_c(g,j)|0;Ia=iv(g|0,j|0,-1,-1)|0;g=Ia&g;j=F&j;r=(c[997048+((c[f+(Ja<<2)>>2]&7)<<2)>>2]|0)+r|0}while(!((g|0)==0&(j|0)==0));g=v&~qa;j=t&~ra;if((g|0)==0&(j|0)==0)j=r;else{Ia=c[249294]|0;Ja=g-(g>>>1&1431655765)|0;Ha=jv(g|0,j|0,33)|0;j=j-(Ha&1431655765)|0;j=(ba(Ia,(ba((j&858993459)+(Ja&858993459)+(Ja>>>2&858993459)+(j>>>2&858993459)|0,286331153)|0)>>>28)|0)+r|0}g=v&lb;r=t&mb;if((g|0)==0&(r|0)==0)break;Ja=iv(g|0,r|0,-1,-1)|0;j=((Ja&g|0)!=0|(F&r|0)!=0?c[249278]|0:c[249276]|0)+j|0}while(0);c[249974]=j;ia=hb+16|0;g=ia;r=c[g>>2]|0;g=c[g+4>>2]|0;if((r|0)==0&(g|0)==0)r=0;else{J=f+340|0;I=f+372|0;H=f+288|0;G=f+296|0;E=f+256|0;K=r;r=0;do{q=_c(K,g)|0;s=iv(K|0,g|0,-1,-1)|0;K=s&K;g=F&g;s=q>>3;p=s+-1|0;z=ba(p,s+-2|0)|0;o=z*17|0;n=(ba(p*7|0,p)|0)+7|0;do if(z){A=q+8|0;t=c[Ta>>2]|0;n=(ba(((c[27040+(c[Ua>>2]<<8)+(A<<2)>>2]|0)*5|0)-(c[27040+(t<<8)+(A<<2)>>2]<<1)|0,z)|0)+n|0;if((A&-8|0)!=56)n=n-(ba(c[27040+(t<<8)+(q+16<<2)>>2]|0,z)|0)|0;if(c[f+(A<<2)>>2]|0){Ja=Za;Ia=46496+(A<<3)|0;if((c[Ia>>2]&c[Ja>>2]|0)==0?(c[Ia+4>>2]&c[Ja+4>>2]|0)==0:0)break;n=n+(ba(p,s)|0)|0;o=(p<<1)+3+(z*3|0)+o|0;break}x=59616+(q<<3)|0;w=c[x>>2]|0;x=c[x+4>>2]|0;v=60128+(q<<3)|0;s=H;t=G;Ia=E;Ha=44448+(q<<3)|0;Ja=43936+(q<<3)|0;Ja=(ba(c[Ha+4>>2]&c[Ia+4>>2],c[Ja+4>>2]|0)|0)^(ba(c[Ha>>2]&c[Ia>>2],c[Ja>>2]|0)|0);Ja=(c[43424+(q<<2)>>2]|0)+(Ja>>>(c[44960+(q<<2)>>2]|0)<<3)|0;Ia=(c[t>>2]|c[s>>2])&c[v>>2]&c[Ja>>2];Ja=(c[t+4>>2]|c[s+4>>2])&c[v+4>>2]&c[Ja+4>>2];q=Za;q=(c[q>>2]&Ia|0)==0?(c[q+4>>2]&Ja|0)==0:0;v=(q?qa:-1)&w;q=(q?ra:-1)&x;s=$a;t=c[s>>2]|0;s=c[s+4>>2]|0;if((t&Ia|0)==0&(s&Ja|0)==0){p=(t|R)&w;t=(s|Q)&x}else{p=w;t=x}if((p|0)==0&(t|0)==0)t=15;else{Ja=46496+(A<<3)|0;t=((c[Ja>>2]&p|0)==0?(c[Ja+4>>2]&t|0)==0:0)?9:0}if((v|0)==(w|0)&(q|0)==(x|0))p=t+6|0;else{p=46496+(A<<3)|0;p=((c[p>>2]&v|0)==0?(c[p+4>>2]&q|0)==0:0)?t:t+4|0}Ja=ba(p,z)|0;n=Ja+n|0;o=Ja+o|0}while(0);if((c[J>>2]|0)<(c[I>>2]|0))n=((n|0)/4|0)+n|0;r=(o<<16)+r+n|0}while(!((K|0)==0&(g|0)==0))}n=c[249302]|0;g=c[249303]|0;L=(((ba(r+32768>>16,n)|0)/256|0)<<16)+((ba(g,r<<16>>16)|0)/256|0)|0;c[249960]=L;q=hb+24|0;o=q;r=c[o>>2]|0;o=c[o+4>>2]|0;if((r|0)==0&(o|0)==0)r=0;else{J=f+372|0;I=f+340|0;H=f+288|0;G=f+296|0;E=f+256|0;K=r;r=0;do{x=_c(K,o)|0;s=iv(K|0,o|0,-1,-1)|0;K=s&K;o=F&o;s=x>>3^7;v=s+-1|0;B=ba(v,s+-2|0)|0;n=B*17|0;g=(ba(v*7|0,v)|0)+7|0;do if(B){A=x+-8|0;t=c[Ua>>2]|0;g=(ba(((c[27040+(c[Ta>>2]<<8)+(A<<2)>>2]|0)*5|0)-(c[27040+(t<<8)+(A<<2)>>2]<<1)|0,B)|0)+g|0;if(A>>>0>=8)g=g-(ba(c[27040+(t<<8)+(x+-16<<2)>>2]|0,B)|0)|0;if(c[f+(A<<2)>>2]|0){Ja=$a;Ia=46496+(A<<3)|0;if((c[Ia>>2]&c[Ja>>2]|0)==0?(c[Ia+4>>2]&c[Ja+4>>2]|0)==0:0)break;g=g+(ba(v,s)|0)|0;n=(v<<1)+3+(B*3|0)+n|0;break}p=60128+(x<<3)|0;y=c[p>>2]|0;p=c[p+4>>2]|0;w=59616+(x<<3)|0;v=H;t=G;Ia=E;Ha=44448+(x<<3)|0;Ja=43936+(x<<3)|0;Ja=(ba(c[Ha+4>>2]&c[Ia+4>>2],c[Ja+4>>2]|0)|0)^(ba(c[Ha>>2]&c[Ia>>2],c[Ja>>2]|0)|0);Ja=(c[43424+(x<<2)>>2]|0)+(Ja>>>(c[44960+(x<<2)>>2]|0)<<3)|0;Ia=(c[t>>2]|c[v>>2])&c[w>>2]&c[Ja>>2];Ja=(c[t+4>>2]|c[v+4>>2])&c[w+4>>2]&c[Ja+4>>2];w=$a;w=(c[w>>2]&Ia|0)==0?(c[w+4>>2]&Ja|0)==0:0;x=(w?R:-1)&y;w=(w?Q:-1)&p;v=Za;t=c[v>>2]|0;v=c[v+4>>2]|0;if((t&Ia|0)==0&(v&Ja|0)==0){s=(t|qa)&y;t=(v|ra)&p}else{s=y;t=p}if((s|0)==0&(t|0)==0)t=15;else{Ja=46496+(A<<3)|0;t=((c[Ja>>2]&s|0)==0?(c[Ja+4>>2]&t|0)==0:0)?9:0}if((x|0)==(y|0)&(w|0)==(p|0))p=t+6|0;else{p=46496+(A<<3)|0;p=((c[p>>2]&x|0)==0?(c[p+4>>2]&w|0)==0:0)?t:t+4|0}Ja=ba(p,B)|0;g=Ja+g|0;n=Ja+n|0}while(0);if((c[J>>2]|0)<(c[I>>2]|0))g=((g|0)/4|0)+g|0;r=(n<<16)+r+g|0}while(!((K|0)==0&(o|0)==0));n=c[249302]|0;g=c[249303]|0}n=(((ba(r+32768>>16,n)|0)/256|0)<<16)+((ba(r<<16>>16,g)|0)/256|0)|0;c[249975]=n;j=Va+Ya+Xa+Qa-Ma+Ka-Fa+la-ua+T-V+ca+(da+Wa<<16)+ea-ha+ja-j+L-n|0;n=c[pb>>2]|0;do if(!(c[n+16>>2]|0)){if(c[n+20>>2]|0)break;g=ia;n=c[g>>2]|0;g=c[g+4>>2]|0;if(!((n|0)==0&(g|0)==0)){Ya=($c(n,g)|0)>>3;j=(ba(c[249292]|0,Ya)|0)+j|0}g=q;n=c[g>>2]|0;g=c[g+4>>2]|0;if((n|0)==0&(g|0)==0)break;Ya=(_c(n,g)|0)>>3^7;j=j-(ba(Ya,c[249292]|0)|0)|0}while(0);Ya=c[pb>>2]|0;if(((c[Ya+20>>2]|0)+(c[Ya+16>>2]|0)|0)>=11756){Ta=Za;Ua=_a;Xa=c[Ua>>2]|0;Ua=c[Ua+4>>2]|0;Wa=Xa&c[Ta>>2];Ta=Ua&c[Ta+4>>2];Ya=(R^1010580480|qa)&(eb^1010580480)&(Wa&1010580480^1010580480);Va=jv(Wa|0,Ta|0,8)|0;Wa=Va|Wa;Ta=F|Ta;Va=jv(Wa|0,Ta|0,16)|0;Wa=(Va|Wa)&Ya;Wa=Wa-(Wa>>>1&1431655765)|0;Va=jv(Ya|0,0,1)|0;Va=Ya-(Va&336860160)|0;Wa=(Wa>>>2&858993459)+(Wa&858993459)|0;Va=(Va>>>2&858993459)+(Va&858992640)|0;Wa=(ba((Va>>>4)+Va+Wa+(Wa>>>4)&252645135,16843009)|0)>>>24;Va=(c[f+348>>2]|0)+(c[f+344>>2]|0)+(c[f+376>>2]|0)+(c[f+380>>2]|0)|0;Va=ba(Va<<16,Va)|0;Ya=$a;Xa=c[Ya>>2]&Xa;Ua=c[Ya+4>>2]&Ua;Ya=(Q|ra^3947580)&(ob^3947580)&(Ua&3947580^3947580);Ta=ov(Xa|0,Ua|0,8)|0;Xa=Ta|Xa;Ua=F|Ua;Ta=ov(Xa|0,Ua|0,16)|0;Ua=(F|Ua)&Ya;Xa=jv(0,Ya|0,33)|0;Xa=Ya-(Xa&1315860)|0;Ya=jv(0,Ua|0,33)|0;Ya=Ua-(Ya&1431655765)|0;Xa=(Xa>>>2&858993459)+(Xa&858993459)|0;Ya=(Ya>>>2&858993459)+(Ya&858993459)|0;Ya=ba(Va,Wa-((ba((Xa>>>4)+Xa+Ya+(Ya>>>4)&252645135,16843009)|0)>>>24)|0)|0;j=(((ba(Ya>>16,c[249304]|0)|0)/256|0)<<16)+j|0}p=j<<16;r=p>>16;q=(p|0)<65536&1;n=qb+(q<<2)+16|0;g=c[n>>2]|0;do if(!g)gb=267;else{if((oc[c[(c[g>>2]|0)+12>>2]&63](g,f)|0)==255){gb=267;break}g=c[n>>2]|0;g=oc[c[(c[g>>2]|0)+12>>2]&63](g,f)|0}while(0);if((gb|0)==267)g=d[qb+q+10>>0]|0;o=c[qb+24>>2]|0;c:do if((o|0)<128){if(!((g|0)==48|(g|0)==64))break;do if((c[f+348>>2]|0)==1){if((c[f+380>>2]|0)!=1)break;Ya=c[La>>2]^c[Na>>2];if(!((Ya>>>3^Ya)&1))break;n=c[pb>>2]|0;do if((c[n+16>>2]|0)==836){if((c[n+20>>2]|0)!=836)break;g=_a;Ya=c[g>>2]|0;g=c[g+4>>2]|0;Xa=iv(Ya|0,g|0,-1,-1)|0;g=(Xa&Ya|0)!=0|(F&g|0)!=0?32:8;break c}while(0);g=(g*50|0)/64|0;break c}while(0);if((((p|0)>-65536?r:0-r|0)|0)>=858)break;n=c[hb+(q<<2)+88>>2]|0;if((n|0)>=2)break;Ya=q^1;Xa=f+(q<<3)+320|0;Wa=_a;Ya=60640+(Ya<<9)+(c[f+(Ya<<9)+784>>2]<<3)|0;if((c[Wa>>2]&c[Xa>>2]&c[Ya>>2]|0)==0?(c[Wa+4>>2]&c[Xa+4>>2]&c[Ya+4>>2]|0)==0:0)break;g=(n|0)!=0?56:38}while(0);Ta=(((ba(ba(128-o|0,r)|0,g)|0)/64|0)+(ba(o,j+32768>>16)|0)|0)/128|0;c[249956]=c[(c[pb>>2]|0)+36>>2];c[249971]=0;c[249957]=(b[rb>>1]|0)*65537;c[249972]=0;c[249949]=c[ib>>2];c[249964]=0;Ua=c[249298]|0;Qa=c[249299]|0;Xa=(((ba(Ua,S+32768>>16)|0)/256|0)<<16)+((ba(Qa,S<<16>>16)|0)/256|0)|0;c[249958]=(((ba(Ua,D+32768>>16)|0)/256|0)<<16)+((ba(Qa,D<<16>>16)|0)/256|0);c[249973]=Xa;Xa=Za;Qa=_a;Ua=c[Qa>>2]|0;Qa=c[Qa+4>>2]|0;Va=Ua&c[Xa>>2];Xa=Qa&c[Xa+4>>2];Wa=(R^1010580480|qa)&(eb^1010580480)&(Va&1010580480^1010580480);Ya=jv(Va|0,Xa|0,8)|0;Va=Ya|Va;Xa=F|Xa;Ya=jv(Va|0,Xa|0,16)|0;Va=(Ya|Va)&Wa;Va=Va-(Va>>>1&1431655765)|0;Ya=jv(Wa|0,0,1)|0;Ya=Wa-(Ya&336860160)|0;Va=(Va>>>2&858993459)+(Va&858993459)|0;Ya=(Ya>>>2&858993459)+(Ya&858992640)|0;Va=(ba((Ya>>>4)+Ya+Va+(Va>>>4)&252645135,16843009)|0)>>>24;Ya=(c[f+348>>2]|0)+(c[f+344>>2]|0)+(c[f+376>>2]|0)+(c[f+380>>2]|0)|0;Ya=ba(Ya<<16,Ya)|0;Va=ba(Va,Ya)|0;Wa=c[249304]|0;Va=((ba(Va>>16,Wa)|0)/256|0)<<16;Xa=$a;Ua=c[Xa>>2]&Ua;Qa=c[Xa+4>>2]&Qa;Xa=(Q|ra^3947580)&(ob^3947580)&(Qa&3947580^3947580);Na=ov(Ua|0,Qa|0,8)|0;Ua=Na|Ua;Qa=F|Qa;Na=ov(Ua|0,Qa|0,16)|0;Qa=(F|Qa)&Xa;Ua=jv(0,Xa|0,33)|0;Ua=Xa-(Ua&1315860)|0;Xa=jv(0,Qa|0,33)|0;Xa=Qa-(Xa&1431655765)|0;Ua=(Ua>>>2&858993459)+(Ua&858993459)|0;Xa=(Xa>>>2&858993459)+(Xa&858993459)|0;Wa=((ba((ba((ba((Ua>>>4)+Ua+Xa+(Xa>>>4)&252645135,16843009)|0)>>>24,Ya)|0)>>16,Wa)|0)/256|0)<<16;c[249961]=Va;c[249976]=Wa;c[249962]=j;c[249977]=0;c[250148]=qb;c[250149]=hb;Wa=1000600;c[Wa>>2]=qa;c[Wa+4>>2]=ra;Wa=1000608;c[Wa>>2]=nb;c[Wa+4>>2]=ob;Wa=1000616;c[Wa>>2]=Sa;c[Wa+4>>2]=Ra;Wa=1000624;c[Wa>>2]=P;c[Wa+4>>2]=O;Wa=1000632;c[Wa>>2]=ka;c[Wa+4>>2]=U;Wa=1000640;c[Wa>>2]=oa;c[Wa+4>>2]=pa;Wa=1000648;c[Wa>>2]=cb;c[Wa+4>>2]=db;Wa=1000664;c[Wa>>2]=R;c[Wa+4>>2]=Q;Wa=1000672;c[Wa>>2]=eb;c[Wa+4>>2]=fb;Wa=1000680;c[Wa>>2]=Pa;c[Wa+4>>2]=Oa;Wa=1000688;c[Wa>>2]=N;c[Wa+4>>2]=M;Wa=1000696;c[Wa>>2]=sa;c[Wa+4>>2]=ta;Wa=1000704;c[Wa>>2]=C;c[Wa+4>>2]=aa;Wa=1000712;c[Wa>>2]=lb;c[Wa+4>>2]=mb;Wa=1000728;c[Wa>>2]=l;c[Wa+4>>2]=m;Wa=1000736;c[Wa>>2]=h;c[Wa+4>>2]=k;c[250186]=u;c[250187]=W;c[250188]=na;c[250189]=X;c[250190]=ma;c[250191]=Y;Wa=1000768;c[Wa>>2]=jb;c[Wa+4>>2]=kb;Wa=1000776;c[Wa>>2]=ab;c[Wa+4>>2]=bb;Wa=c[f+2212>>2]|0;Ta=(Wa|0)==0?Ta:0-Ta|0;Va=Ta+17|0;Wa=(Wa|0)==0;Ta=-17-Ta|0;Ta=Wa?Va:Ta;Va=tb+64|0;Wa=tb+8|0;c[Wa>>2]=1000312;Ya=tb+12|0;c[tb>>2]=1000460;c[Va>>2]=1000480;Xa=tb+4|0;c[Xa>>2]=0;Xa=tb+64|0;ij(Xa,Ya);Xa=tb+136|0;c[Xa>>2]=0;Xa=tb+140|0;c[Xa>>2]=-1;c[tb>>2]=1000292;c[Va>>2]=1000332;c[Wa>>2]=1000312;nj(Ya);c[Ya>>2]=1000496;Xa=tb+44|0;Ua=tb+60|0;c[Xa+0>>2]=0;c[Xa+4>>2]=0;c[Xa+8>>2]=0;c[Xa+12>>2]=0;c[Ua>>2]=24;c[sb+0>>2]=0;c[sb+4>>2]=0;c[sb+8>>2]=0;Ae(Ya,sb);Bi(sb);Ua=tb+8|0;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+4|0;Sa=Ua+Sa|0;Ra=c[Sa>>2]|0;Ra=Ra|1024;c[Sa>>2]=Ra;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+4|0;Sa=Ua+Sa|0;Ra=c[Sa>>2]|0;Ra=Ra&-2049;c[Sa>>2]=Ra;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+4|0;Sa=Ua+Sa|0;Ra=c[Sa>>2]|0;Ra=Ra&-261;Ra=Ra|4;c[Sa>>2]=Ra;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+8|0;Sa=Ua+Sa|0;c[Sa>>2]=2;Sa=Ec(Ua,999912,59)|0;Sa=Ec(Sa,999976,59)|0;Ec(Sa,1000040,59)|0;Sa=c[249956]|0;Ra=c[249971]|0;Qa=c[Ua>>2]|0;Qa=Qa+-12|0;Qa=c[Qa>>2]|0;Qa=Qa+12|0;Qa=Ua+Qa|0;c[Qa>>2]=15;Qa=Ec(Ua,1000104,8)|0;Qa=Ec(Qa,1000552,31)|0;Pa=c[Qa>>2]|0;Pa=Pa+-12|0;Pa=c[Pa>>2]|0;Pa=Pa+12|0;Pa=Qa+Pa|0;c[Pa>>2]=5;Ra=Sa-Ra|0;Sa=Ra+32768|0;Sa=Sa>>16;vb=+(Sa|0);vb=vb/258.0;Qa=qk(Qa,vb)|0;Qa=Ec(Qa,1072408,1)|0;Sa=c[Qa>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+12|0;Sa=Qa+Sa|0;c[Sa>>2]=5;Ra=Ra<<16;Ra=Ra>>16;vb=+(Ra|0);vb=vb/258.0;Qa=qk(Qa,vb)|0;Ec(Qa,1000584,2)|0;Qa=c[249957]|0;Ra=c[249972]|0;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+12|0;Sa=Ua+Sa|0;c[Sa>>2]=15;Sa=Ec(Ua,1000120,9)|0;Sa=Ec(Sa,1000552,31)|0;Pa=c[Sa>>2]|0;Pa=Pa+-12|0;Pa=c[Pa>>2]|0;Pa=Pa+12|0;Pa=Sa+Pa|0;c[Pa>>2]=5;Ra=Qa-Ra|0;Qa=Ra+32768|0;Qa=Qa>>16;vb=+(Qa|0);vb=vb/258.0;Sa=qk(Sa,vb)|0;Sa=Ec(Sa,1072408,1)|0;Qa=c[Sa>>2]|0;Qa=Qa+-12|0;Qa=c[Qa>>2]|0;Qa=Qa+12|0;Qa=Sa+Qa|0;c[Qa>>2]=5;Ra=Ra<<16;Ra=Ra>>16;vb=+(Ra|0);vb=vb/258.0;Sa=qk(Sa,vb)|0;Ec(Sa,1000584,2)|0;Sa=c[249949]|0;Ra=c[249964]|0;Qa=c[Ua>>2]|0;Qa=Qa+-12|0;Qa=c[Qa>>2]|0;Qa=Qa+12|0;Qa=Ua+Qa|0;c[Qa>>2]=15;Qa=Ec(Ua,1000136,5)|0;Qa=Ec(Qa,1000552,31)|0;Pa=c[Qa>>2]|0;Pa=Pa+-12|0;Pa=c[Pa>>2]|0;Pa=Pa+12|0;Pa=Qa+Pa|0;c[Pa>>2]=5;Ra=Sa-Ra|0;Sa=Ra+32768|0;Sa=Sa>>16;vb=+(Sa|0);vb=vb/258.0;Qa=qk(Qa,vb)|0;Qa=Ec(Qa,1072408,1)|0;Sa=c[Qa>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+12|0;Sa=Qa+Sa|0;c[Sa>>2]=5;Ra=Ra<<16;Ra=Ra>>16;vb=+(Ra|0);vb=vb/258.0;Qa=qk(Qa,vb)|0;Ec(Qa,1000584,2)|0;Be(tb,1000144,2);Be(tb,1000152,3);Be(tb,1000160,4);Be(tb,1000168,5);Be(tb,1000176,10);Be(tb,1000192,6);Be(tb,1000208,11);Be(tb,1000216,12);Be(tb,1073008,13);Ec(Ua,1000040,59)|0;Qa=c[249962]|0;Ra=c[249977]|0;Sa=c[Ua>>2]|0;Sa=Sa+-12|0;Sa=c[Sa>>2]|0;Sa=Sa+12|0;Sa=Ua+Sa|0;c[Sa>>2]=15;Sa=Ec(Ua,1000232,5)|0;Sa=Ec(Sa,1000552,31)|0;Pa=c[Sa>>2]|0;Pa=Pa+-12|0;Pa=c[Pa>>2]|0;Pa=Pa+12|0;Pa=Sa+Pa|0;c[Pa>>2]=5;Ra=Qa-Ra|0;Qa=Ra+32768|0;Qa=Qa>>16;vb=+(Qa|0);vb=vb/258.0;Sa=qk(Sa,vb)|0;Sa=Ec(Sa,1072408,1)|0;Qa=c[Sa>>2]|0;Qa=Qa+-12|0;Qa=c[Qa>>2]|0;Qa=Qa+12|0;Qa=Sa+Qa|0;c[Qa>>2]=5;Ra=Ra<<16;Ra=Ra>>16;vb=+(Ra|0);vb=vb/258.0;Sa=qk(Sa,vb)|0;Ec(Sa,1000584,2)|0;Ua=Ec(Ua,1000240,19)|0;vb=+(Ta|0);vb=vb/258.0;Ua=qk(Ua,vb)|0;Ec(Ua,1000264,14)|0;Ce(e,Ya);c[tb>>2]=1000292;c[Va>>2]=1000332;c[Wa>>2]=1000312;c[Ya>>2]=1000496;Bi(Xa);kj(Ya);Ya=tb+64|0;fj(Ya);i=ub;return}function ze(){var a=0,b=0,d=0.0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0;e=i;i=i+128|0;n=e+108|0;o=e+96|0;l=e+84|0;m=e+72|0;j=e+60|0;k=e+48|0;g=e+36|0;h=e+24|0;a=e+12|0;b=e;vi(n,1072848,18);vi(o,1072872,18);p=c[249040]|0;q=(ba(Th(Bc(1072800,n)|0)|0,p+32768>>16)|0)/100|0;p=(ba(Th(Bc(1072800,o)|0)|0,p<<16>>16)|0)/100|0;f=997192;c[f>>2]=q;c[f+4>>2]=p;Bi(o);Bi(n);vi(l,1072896,24);vi(m,1072928,24);n=c[249041]|0;o=(ba(Th(Bc(1072800,l)|0)|0,n+32768>>16)|0)/100|0;n=(ba(Th(Bc(1072800,m)|0)|0,n<<16>>16)|0)/100|0;f=997200|0;c[f>>2]=o;c[f+4>>2]=n;Bi(m);Bi(l);vi(j,1072960,22);vi(k,1072984,22);l=c[249042]|0;m=(ba(Th(Bc(1072800,j)|0)|0,l+32768>>16)|0)/100|0;l=(ba(Th(Bc(1072800,k)|0)|0,l<<16>>16)|0)/100|0;f=997208|0;c[f>>2]=m;c[f+4>>2]=l;Bi(k);Bi(j);vi(g,1073008,5);vi(h,1073008,5);j=c[249043]|0;k=(ba(Th(Bc(1072800,g)|0)|0,j+32768>>16)|0)/100|0;j=(ba(Th(Bc(1072800,h)|0)|0,j<<16>>16)|0)/100|0;f=997216|0;c[f>>2]=k;c[f+4>>2]=j;Bi(h);Bi(g);vi(a,1073016,11);vi(b,1073016,11);g=c[249044]|0;h=(ba(Th(Bc(1072800,a)|0)|0,g+32768>>16)|0)/100|0;g=(ba(Th(Bc(1072800,b)|0)|0,g<<16>>16)|0)/100|0;f=997224|0;c[f>>2]=h;c[f+4>>2]=g;Bi(b);Bi(a);a=c[249306]|0;b=1;d=0.0;do{r=+(b|0);r=r*(r*.025);s=d+7.5;r=s<r?s:r;d=r<1280.0?r:1280.0;c[997232+(b<<2)>>2]=((ba(a,~~d<<16>>16)|0)/256|0)<<16;b=b+1|0}while((b|0)!=400);i=e;return}function Ae(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=b+32|0;Ci(i,d)|0;h=b+44|0;c[h>>2]=0;j=b+48|0;g=c[j>>2]|0;if(g&8){d=a[i>>0]|0;if(!(d&1)){f=i+((d&255)>>>1)+1|0;c[h>>2]=f;e=i+1|0;d=i+1|0}else{f=(c[b+40>>2]|0)+(c[b+36>>2]|0)|0;c[h>>2]=f;d=c[b+40>>2]|0;e=d}c[b+8>>2]=e;c[b+12>>2]=d;c[b+16>>2]=f}if(!(g&16))return;d=a[i>>0]|0;if(!(d&1)){e=(d&255)>>>1;c[h>>2]=i+e+1;d=10;h=e}else{e=c[b+36>>2]|0;c[h>>2]=(c[b+40>>2]|0)+e;d=(c[i>>2]&-2)+-1|0;h=e}Gi(i,d,0);d=a[i>>0]|0;if(!(d&1)){g=i+1|0;f=(d&255)>>>1;e=i+1|0}else{e=c[b+40>>2]|0;g=e;f=c[b+36>>2]|0}d=b+24|0;c[d>>2]=e;c[b+20>>2]=e;c[b+28>>2]=g+f;if(!(c[j>>2]&3))return;c[d>>2]=e+h;return}function Be(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=c[999792+(d<<2)>>2]|0;f=c[999852+(d<<2)>>2]|0;if((d|0)==14|(d|0)==1|(d|0)==9|(d|0)==8){d=a+8|0;c[d+((c[(c[d>>2]|0)+-12>>2]|0)+12)>>2]=15;d=Ec(Ec(d,b,lv(b|0)|0)|0,1000552,31)|0;c[d+((c[(c[d>>2]|0)+-12>>2]|0)+12)>>2]=5;e=e-f|0;f=Ec(qk(d,+(e+32768>>16|0)/258.0)|0,1072408,1)|0;c[f+((c[(c[f>>2]|0)+-12>>2]|0)+12)>>2]=5;Ec(qk(f,+(e<<16>>16|0)/258.0)|0,1000584,2)|0;return}else{d=a+8|0;c[d+((c[(c[d>>2]|0)+-12>>2]|0)+12)>>2]=15;d=Ec(Ec(d,b,lv(b|0)|0)|0,1013448,3)|0;b=d+((c[(c[d>>2]|0)+-12>>2]|0)+4)|0;c[b>>2]=c[b>>2]&-2049;c[d+((c[(c[d>>2]|0)+-12>>2]|0)+12)>>2]=5;d=Ec(qk(d,+(e+32768>>16|0)/258.0)|0,1072408,1)|0;c[d+((c[(c[d>>2]|0)+-12>>2]|0)+12)>>2]=5;d=Ec(qk(d,+(e<<16>>16|0)/258.0)|0,1013448,3)|0;c[d+((c[(c[d>>2]|0)+-12>>2]|0)+12)>>2]=5;d=Ec(qk(d,+(f+32768>>16|0)/258.0)|0,1072408,1)|0;c[d+((c[(c[d>>2]|0)+-12>>2]|0)+12)>>2]=5;d=Ec(qk(d,+(f<<16>>16|0)/258.0)|0,1013448,3)|0;c[d+((c[(c[d>>2]|0)+-12>>2]|0)+12)>>2]=5;e=e-f|0;f=Ec(qk(d,+(e+32768>>16|0)/258.0)|0,1072408,1)|0;c[f+((c[(c[f>>2]|0)+-12>>2]|0)+12)>>2]=5;Ec(qk(f,+(e<<16>>16|0)/258.0)|0,1000584,2)|0;return}}function Ce(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=c[d+48>>2]|0;if(e&16){f=d+44|0;e=c[f>>2]|0;g=c[d+24>>2]|0;if(e>>>0<g>>>0)c[f>>2]=g;else g=e;f=c[d+20>>2]|0;d=g-f|0;if(d>>>0>4294967279)si(b);if(d>>>0<11){a[b>>0]=d<<1;e=b+1|0}else{h=d+16&-16;e=ut(h)|0;c[b+8>>2]=e;c[b>>2]=h|1;c[b+4>>2]=d}if((f|0)!=(g|0)){h=e;while(1){a[h>>0]=a[f>>0]|0;f=f+1|0;if((f|0)==(g|0))break;else h=h+1|0}e=e+d|0}a[e>>0]=0;return}if(!(e&8)){c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;return}f=c[d+8>>2]|0;d=c[d+16>>2]|0;h=d-f|0;if(h>>>0>4294967279)si(b);if(h>>>0<11){a[b>>0]=h<<1;e=b+1|0}else{g=h+16&-16;e=ut(g)|0;c[b+8>>2]=e;c[b>>2]=g|1;c[b+4>>2]=h}if((f|0)!=(d|0)){g=e;while(1){a[g>>0]=a[f>>0]|0;f=f+1|0;if((f|0)==(d|0))break;else g=g+1|0}e=e+h|0}a[e>>0]=0;return}function De(a){a=a|0;var b=0;c[a>>2]=1000292;c[a+64>>2]=1000332;c[a+8>>2]=1000312;b=a+12|0;c[b>>2]=1000496;Bi(a+44|0);kj(b);fj(a+64|0);return}function Ee(a){a=a|0;var b=0;c[a>>2]=1000292;c[a+64>>2]=1000332;c[a+8>>2]=1000312;b=a+12|0;c[b>>2]=1000496;Bi(a+44|0);kj(b);fj(a+64|0);xt(a);return}function Fe(a){a=a|0;var b=0,d=0;d=a+-8|0;c[d>>2]=1000292;a=d+64|0;c[a>>2]=1000332;c[d+8>>2]=1000312;b=d+12|0;c[b>>2]=1000496;Bi(d+44|0);kj(b);fj(a);return}function Ge(a){a=a|0;var b=0,d=0;a=a+-8|0;c[a>>2]=1000292;b=a+64|0;c[b>>2]=1000332;c[a+8>>2]=1000312;d=a+12|0;c[d>>2]=1000496;Bi(a+44|0);kj(d);fj(b);xt(a);return}function He(a){a=a|0;var b=0,d=0,e=0;e=c[(c[a>>2]|0)+-12>>2]|0;c[a+e>>2]=1000292;b=a+(e+64)|0;c[b>>2]=1000332;c[a+(e+8)>>2]=1000312;d=a+(e+12)|0;c[d>>2]=1000496;Bi(a+(e+44)|0);kj(d);fj(b);return}function Ie(a){a=a|0;var b=0,d=0,e=0,f=0;f=c[(c[a>>2]|0)+-12>>2]|0;b=a+f|0;c[b>>2]=1000292;d=a+(f+64)|0;c[d>>2]=1000332;c[a+(f+8)>>2]=1000312;e=a+(f+12)|0;c[e>>2]=1000496;Bi(a+(f+44)|0);kj(e);fj(d);xt(b);return}function Je(a){a=a|0;c[a>>2]=1000496;Bi(a+32|0);kj(a);return}function Ke(a){a=a|0;c[a>>2]=1000496;Bi(a+32|0);kj(a);xt(a);return}function Le(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=d+44|0;j=c[i>>2]|0;l=d+24|0;m=c[l>>2]|0;if(j>>>0<m>>>0){c[i>>2]=m;j=m}i=h&24;if(!i){h=b;c[h>>2]=0;c[h+4>>2]=0;b=b+8|0;c[b>>2]=-1;c[b+4>>2]=-1;return}if((i|0)==24&(g|0)==1){h=b;c[h>>2]=0;c[h+4>>2]=0;b=b+8|0;c[b>>2]=-1;c[b+4>>2]=-1;return}do if((g|0)==1)if(!(h&8)){k=m-(c[d+20>>2]|0)|0;i=k;k=((k|0)<0)<<31>>31;break}else{k=(c[d+12>>2]|0)-(c[d+8>>2]|0)|0;i=k;k=((k|0)<0)<<31>>31;break}else if((g|0)==2){i=d+32|0;if(!(a[i>>0]&1))i=i+1|0;else i=c[d+40>>2]|0;k=j-i|0;i=k;k=((k|0)<0)<<31>>31}else if(!g){i=0;k=0}else{h=b;c[h>>2]=0;c[h+4>>2]=0;b=b+8|0;c[b>>2]=-1;c[b+4>>2]=-1;return}while(0);k=iv(i|0,k|0,e|0,f|0)|0;g=F;if((g|0)>=0){i=d+32|0;if(!(a[i>>0]&1))i=i+1|0;else i=c[d+40>>2]|0;f=j-i|0;e=((f|0)<0)<<31>>31;if(!((e|0)<(g|0)|(e|0)==(g|0)&f>>>0<k>>>0)){i=h&8;if(!((k|0)==0&(g|0)==0)){if((i|0)!=0?(c[d+12>>2]|0)==0:0){h=b;c[h>>2]=0;c[h+4>>2]=0;b=b+8|0;c[b>>2]=-1;c[b+4>>2]=-1;return}if((h&16|0)!=0&(m|0)==0){h=b;c[h>>2]=0;c[h+4>>2]=0;b=b+8|0;c[b>>2]=-1;c[b+4>>2]=-1;return}}if(i){c[d+12>>2]=(c[d+8>>2]|0)+k;c[d+16>>2]=j}if(h&16)c[l>>2]=(c[d+20>>2]|0)+k;h=b;c[h>>2]=0;c[h+4>>2]=0;b=b+8|0;c[b>>2]=k;c[b+4>>2]=g;return}}h=b;c[h>>2]=0;c[h+4>>2]=0;b=b+8|0;c[b>>2]=-1;c[b+4>>2]=-1;return}function Me(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;d=d+8|0;nc[c[(c[b>>2]|0)+16>>2]&31](a,b,c[d>>2]|0,c[d+4>>2]|0,0,e);return}function Ne(a){a=a|0;var b=0,e=0,f=0,g=0;b=a+44|0;e=c[b>>2]|0;f=c[a+24>>2]|0;if(e>>>0<f>>>0){c[b>>2]=f;e=f}if(!(c[a+48>>2]&8)){b=-1;return b|0}g=a+16|0;b=c[g>>2]|0;f=c[a+12>>2]|0;if(b>>>0<e>>>0){c[g>>2]=e;b=e}if(f>>>0>=b>>>0){b=-1;return b|0}b=d[f>>0]|0;return b|0}function Oe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=b+44|0;f=c[e>>2]|0;g=c[b+24>>2]|0;if(f>>>0<g>>>0){c[e>>2]=g;f=g}h=b+8|0;i=c[h>>2]|0;j=b+12|0;g=c[j>>2]|0;if(i>>>0>=g>>>0){e=-1;return e|0}if((d|0)==-1){c[h>>2]=i;c[j>>2]=g+-1;c[b+16>>2]=f;e=0;return e|0}if(!(c[b+48>>2]&16)){e=d&255;g=g+-1|0;if(e<<24>>24!=(a[g>>0]|0)){e=-1;return e|0}}else{e=d&255;g=g+-1|0}c[h>>2]=i;c[j>>2]=g;c[b+16>>2]=f;a[g>>0]=e;e=d;return e|0}function Pe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if((d|0)==-1){n=0;return n|0}n=b+12|0;o=b+8|0;p=(c[n>>2]|0)-(c[o>>2]|0)|0;q=b+24|0;j=c[q>>2]|0;m=b+28|0;e=c[m>>2]|0;if((j|0)==(e|0)){g=b+48|0;if(!(c[g>>2]&16)){n=-1;return n|0}f=b+20|0;e=c[f>>2]|0;k=b+44|0;l=(c[k>>2]|0)-e|0;h=b+32|0;Ki(h,0);if(!(a[h>>0]&1))i=10;else i=(c[h>>2]&-2)+-1|0;Gi(h,i,0);i=a[h>>0]|0;if(!(i&1)){h=h+1|0;i=(i&255)>>>1}else{h=c[b+40>>2]|0;i=c[b+36>>2]|0}i=h+i|0;c[f>>2]=h;c[m>>2]=i;j=h+(j-e)|0;c[q>>2]=j;f=h+l|0;c[k>>2]=f}else{g=b+48|0;f=c[b+44>>2]|0;i=e}h=j+1|0;f=h>>>0<f>>>0?f:h;c[b+44>>2]=f;if(c[g>>2]&8){e=b+32|0;if(!(a[e>>0]&1))e=e+1|0;else e=c[b+40>>2]|0;c[o>>2]=e;c[n>>2]=e+p;c[b+16>>2]=f}if((j|0)==(i|0)){n=oc[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;return n|0}else{c[q>>2]=h;a[j>>0]=d;n=d&255;return n|0}return 0}function Qe(){var a=0,b=0;c[249040]=18940248;c[249041]=15270089;c[249042]=14483729;c[249043]=3014656;c[249044]=21037056;kv(996184,0,256)|0;c[249110]=-4259890;c[249111]=-2752542;c[249112]=-589834;c[249113]=196608;c[249114]=983050;c[249115]=1769492;c[249116]=2424860;c[249117]=2752543;c[249118]=2883617;a=996476|0;b=a+92|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(b|0));c[249142]=-3407919;c[249143]=-1835031;c[249144]=393217;c[249145]=1310735;c[249146]=2228253;c[249147]=3145771;c[249148]=3932215;c[249149]=4456511;c[249150]=4849732;c[249151]=5046344;c[249152]=5242955;c[249153]=5374029;c[249154]=5505103;c[249155]=5636177;a=996624|0;b=a+72|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(b|0));c[249174]=-3080245;c[249175]=-2031642;c[249176]=-327680;c[249177]=65552;c[249178]=458784;c[249179]=852016;c[249180]=1179712;c[249181]=1441872;c[249182]=1704032;c[249183]=1900653;c[249184]=2031731;c[249185]=2162807;c[249186]=2293882;c[249187]=2359419;c[249188]=2424956;a=996756|0;b=a+68|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(b|0));c[249206]=-2752552;c[249207]=-1835031;c[249208]=-327687;c[249209]=0;c[249210]=393226;c[249211]=720915;c[249212]=851997;c[249213]=1179686;c[249214]=1310760;c[249215]=1376297;c[249216]=1441833;c[249217]=1441833;c[249218]=1441833;c[249219]=1507369;c[249220]=1572905;c[249221]=1638441;c[249222]=1638441;c[249223]=1638441;c[249224]=1638441;c[249225]=1638441;c[249226]=1638441;c[249227]=1638441;c[249228]=1638441;c[249229]=1638441;c[249230]=1638441;c[249231]=1638441;c[249232]=1638441;c[249233]=1638441;c[249234]=0;c[249235]=0;c[249236]=0;c[249237]=0;c[249238]=0;c[249239]=0;c[249240]=1245221;c[249241]=1572901;c[249242]=2883681;c[249243]=2293866;c[249244]=0;c[249245]=0;c[249246]=0;c[249247]=0;c[249248]=589838;c[249249]=589838;c[249250]=458766;c[249251]=1572912;c[249252]=0;c[249253]=0;c[249254]=0;c[249255]=32;c[249256]=2162729;c[249257]=2031666;c[249258]=2687076;c[249259]=2293864;c[249260]=0;c[249261]=0;c[249262]=0;c[249263]=27;c[249264]=1703993;c[249265]=1703993;c[249266]=43;c[249267]=1507379;a=997072|0;c[a>>2]=0;c[a+4>>2]=0;c[249270]=0;c[249271]=0;c[249272]=5701750;c[249273]=5505146;c[249274]=7471307;c[249275]=7930073;c[249276]=131130;c[249278]=393341;c[249280]=458779;c[249282]=2818069;c[249284]=1245194;c[249286]=524300;c[249288]=1048576;c[249290]=6029312;c[249292]=20;c[249294]=2031642;c[249296]=3276850;return}function Re(){var b=0,d=0,e=0,f=0,g=0,h=0;h=i;i=i+32|0;d=h+24|0;e=h+12|0;g=h;cf(e,0);b=a[e>>0]|0;if(!(b&1)){f=e+1|0;b=(b&255)>>>1}else{f=c[e+8>>2]|0;b=c[e+4>>2]|0}b=Ec(1073416,f,b)|0;hj(d,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);f=Zo(d,1077904)|0;f=oc[c[(c[f>>2]|0)+28>>2]&63](f,10)|0;Wo(d);rk(b,f)|0;Wj(b)|0;Bi(e);Yh(1072800);ad();Wf();Bg();ze();Of();vh(1069824);vi(g,1073056,4);Dh(1069912,Th(Bc(1072800,g)|0)|0);Bi(g);Gh();i=h;return}function Se(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;vi(c,a,lv(a|0)|0);Hh(c);Bi(c);i=b;return}function Te(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=i;i=i+64|0;u=y;r=d+2220|0;o=(c[r>>2]|0)+8|0;n=c[o>>2]|0;o=c[o+4>>2]|0;h=d+2216|0;v=n&8191;w=c[(c[h>>2]|0)+804>>2]|0;x=w+(v<<5)|0;m=x;if((c[m>>2]|0)==(n|0)?(c[m+4>>2]|0)==(o|0):0){i=y;return x|0};c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[x+16>>2]=0;c[x+20>>2]=0;c[x+24>>2]=0;c[x+28>>2]=0;t=x;c[t>>2]=n;c[t+4>>2]=o;t=w+(v<<5)+11|0;a[t>>0]=64;s=w+(v<<5)+10|0;a[s>>0]=64;c[w+(v<<5)+24>>2]=ag(d)|0;p=c[h>>2]|0;f=w+(v<<5)+12|0;e=p+820|0;j=c[e>>2]|0;a:do if(j){k=j;while(1){l=k+16|0;m=c[l>>2]|0;l=c[l+4>>2]|0;if(!(l>>>0>o>>>0|(l|0)==(o|0)&m>>>0>n>>>0)){if(!(l>>>0<o>>>0|(l|0)==(o|0)&m>>>0<n>>>0))break;k=k+4|0}k=c[k>>2]|0;if(!k){q=20;break a}}m=j;while(1){j=m+16|0;k=c[j>>2]|0;j=c[j+4>>2]|0;if(o>>>0<j>>>0|(o|0)==(j|0)&n>>>0<k>>>0){k=c[m>>2]|0;if(!k){k=m;j=m;q=11;break}else{m=k;continue}}if(!(j>>>0<o>>>0|(j|0)==(o|0)&k>>>0<n>>>0)){j=m;q=15;break}k=m+4|0;j=c[k>>2]|0;if(!j){j=m;q=14;break}else m=j}if((q|0)==11)c[u>>2]=j;else if((q|0)==14)c[u>>2]=j;else if((q|0)==15){c[u>>2]=j;k=u}g=c[k>>2]|0;if(!g){g=ut(32)|0;m=g+16|0;c[m>>2]=n;c[m+4>>2]=o;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=j;c[k>>2]=g;m=p+816|0;l=c[c[m>>2]>>2]|0;if(!l)k=g;else{c[m>>2]=l;k=c[k>>2]|0}Wc(c[e>>2]|0,k);m=p+824|0;c[m>>2]=(c[m>>2]|0)+1}m=c[g+24>>2]|0;c[f>>2]=m;if(m){i=y;return x|0}}else q=20;while(0);if((q|0)==20)c[f>>2]=0;m=d+328|0;l=c[m>>2]|0;m=c[m+4>>2]|0;k=iv(l|0,m|0,-1,-1)|0;if((k&l|0)==0&(F&m|0)==0?(c[(c[r>>2]|0)+16>>2]|0)>1269:0){c[f>>2]=1000784;i=y;return x|0}m=d+320|0;l=c[m>>2]|0;m=c[m+4>>2]|0;k=iv(l|0,m|0,-1,-1)|0;if((k&l|0)==0&(F&m|0)==0?(c[(c[r>>2]|0)+20>>2]|0)>1269:0){c[f>>2]=1000796;i=y;return x|0}p=c[h>>2]|0;l=p+832|0;j=c[l>>2]|0;b:do if(j){h=j;while(1){g=h+16|0;k=c[g>>2]|0;g=c[g+4>>2]|0;if(!(g>>>0>o>>>0|(g|0)==(o|0)&k>>>0>n>>>0)){if(!(g>>>0<o>>>0|(g|0)==(o|0)&k>>>0<n>>>0))break;h=h+4|0}h=c[h>>2]|0;if(!h)break b}while(1){g=j+16|0;h=c[g>>2]|0;g=c[g+4>>2]|0;if(o>>>0<g>>>0|(o|0)==(g|0)&n>>>0<h>>>0){g=c[j>>2]|0;if(!g){h=j;q=37;break}else{j=g;continue}}if(!(g>>>0<o>>>0|(g|0)==(o|0)&h>>>0<n>>>0)){q=41;break}h=j+4|0;g=c[h>>2]|0;if(!g){q=40;break}else j=g}if((q|0)==37)c[u>>2]=j;else if((q|0)==40)c[u>>2]=j;else if((q|0)==41){c[u>>2]=j;h=u}f=c[h>>2]|0;if(!f){f=ut(32)|0;g=f+16|0;c[g>>2]=n;c[g+4>>2]=o;c[f+24>>2]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=j;c[h>>2]=f;g=p+828|0;e=c[c[g>>2]>>2]|0;if(!e)g=f;else{c[g>>2]=e;g=c[h>>2]|0}Wc(c[l>>2]|0,g);o=p+836|0;c[o>>2]=(c[o>>2]|0)+1}f=c[f+24>>2]|0;if(f){c[w+(v<<5)+((fc[c[(c[f>>2]|0)+8>>2]&127](f)|0)<<2)+16>>2]=f;i=y;return x|0}}while(0);o=d+340|0;h=c[o>>2]|0;p=d+348|0;g=c[r>>2]|0;if(((c[p>>2]|0)==1?(c[g+16>>2]|0)==836:0)&(h|0)>0){c[w+(v<<5)+16>>2]=1000808;g=c[r>>2]|0}e=d+372|0;l=c[e>>2]|0;n=d+380|0;k=(l|0)>0;if(((c[n>>2]|0)==1?(c[g+20>>2]|0)==836:0)&k)c[w+(v<<5)+20>>2]=1000820;if((((h|0)==0?(c[(c[r>>2]|0)+16>>2]|0)==2521:0)?(c[d+356>>2]|0)==1:0)?!((c[d+384>>2]|0)!=1|k^1):0){c[w+(v<<5)+16>>2]=1000832;h=0}else if(!l)if((c[(c[r>>2]|0)+20>>2]|0)==2521?(c[d+388>>2]|0)==1:0){h=c[o>>2]|0;if((h|0)>0?(c[d+352>>2]|0)==1:0){c[w+(v<<5)+20>>2]=1000844;l=0}else l=0}else l=0;g=c[r>>2]|0;m=c[g+16>>2]|0;g=c[g+20>>2]|0;do if((g|0)==(0-m|0)?(k=d+264|0,!((c[k>>2]|0)==0&(c[k+4>>2]|0)==0)):0){if(!l){c[w+(v<<5)+16>>2]=1000856;q=71;break}if(!h){c[w+(v<<5)+20>>2]=1000868;q=71;break}else if((h|0)==1)q=68;if((q|0)==68?(l|0)==1:0){c[w+(v<<5)+16>>2]=1000880;c[w+(v<<5)+20>>2]=1000892}k=(m-g|0)<837}else q=71;while(0);if((q|0)==71){k=(m-g|0)<837;if((h|0)==0&k){if((m|0)<1270)h=0;else h=(g|0)<837?4:12;a[s>>0]=h;l=c[e>>2]|0}}j=(g-m|0)<837;if((l|0)==0&j){if((g|0)<1270)g=0;else g=(m|0)<837?4:12;a[t>>0]=g}if((c[o>>2]|0)==1&k)a[s>>0]=48;f=c[e>>2]|0;if((f|0)==1&j){a[t>>0]=48;f=c[e>>2]|0}e=c[p>>2]|0;j=(e|0)>1&1;c[u>>2]=j;c[u+4>>2]=c[o>>2];c[u+8>>2]=c[d+344>>2];c[u+12>>2]=e;c[u+16>>2]=c[d+352>>2];c[u+20>>2]=c[d+356>>2];e=u+24|0;c[e>>2]=0;c[e+4>>2]=0;e=c[n>>2]|0;m=(e|0)>1&1;c[u+32>>2]=m;c[u+36>>2]=f;c[u+40>>2]=c[d+376>>2];c[u+44>>2]=e;c[u+48>>2]=c[d+384>>2];c[u+52>>2]=c[d+388>>2];e=u+56|0;c[e>>2]=0;c[e+4>>2]=0;e=0;k=1;h=0;while(1){if(j){g=0;f=c[1000904+(h<<2)>>2]|0;do{o=ba(c[u+(g<<2)>>2]|0,c[1000928+(h<<5)+(g<<2)>>2]|0)|0;f=o+f+(ba(c[u+(g<<2)+32>>2]|0,c[1001120+(h<<5)+(g<<2)>>2]|0)|0)|0;g=g+1|0}while((g|0)!=(k|0));e=(ba(f,j)|0)+e|0}f=h+1|0;if((f|0)==6){l=e;break}j=c[u+(f<<2)>>2]|0;k=k+1|0;h=f}j=m;e=0;k=1;h=0;while(1){if(j){g=0;f=c[1000904+(h<<2)>>2]|0;do{o=ba(c[u+(g<<2)+32>>2]|0,c[1000928+(h<<5)+(g<<2)>>2]|0)|0;f=o+f+(ba(c[u+(g<<2)>>2]|0,c[1001120+(h<<5)+(g<<2)>>2]|0)|0)|0;g=g+1|0}while((g|0)!=(k|0));e=(ba(f,j)|0)+e|0}f=h+1|0;if((f|0)==6)break;j=c[u+(f<<2)+32>>2]|0;k=k+1|0;h=f}b[w+(v<<5)+8>>1]=(l-e|0)/16|0;i=y;return x|0}function Ue(a){a=a|0;xt(a);return}function Ve(a){a=a|0;return c[a+4>>2]|0}function We(a){a=a|0;xt(a);return}function Xe(a){a=a|0;return c[a+4>>2]|0}function Ye(a){a=a|0;xt(a);return}function Ze(a){a=a|0;return c[a+4>>2]|0}function _e(a){a=a|0;xt(a);return}function $e(a){a=a|0;return c[a+4>>2]|0}function af(a){a=a|0;xt(a);return}function bf(a){a=a|0;return c[a+4>>2]|0}function cf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=i;i=i+368|0;p=F+216|0;C=F+204|0;B=F+192|0;A=F+180|0;E=F+168|0;D=F+24|0;w=F+12|0;v=F;vi(C,1001448,47);c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;x=D+64|0;y=D+8|0;c[y>>2]=1000312;z=D+12|0;c[D>>2]=1000460;c[x>>2]=1000480;c[D+4>>2]=0;ij(D+64|0,z);c[D+136>>2]=0;c[D+140>>2]=-1;c[D>>2]=1000292;c[x>>2]=1000332;c[y>>2]=1000312;nj(z);c[z>>2]=1000496;q=D+44|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[D+60>>2]=24;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Ae(z,p);Bi(p);vi(w,1001496,11);r=p+64|0;s=p+8|0;c[s>>2]=1000312;t=p+12|0;c[p>>2]=1000460;c[r>>2]=1000480;c[p+4>>2]=0;ij(p+64|0,t);c[p+136>>2]=0;c[p+140>>2]=-1;c[p>>2]=1000292;c[r>>2]=1000332;c[s>>2]=1000312;nj(t);c[t>>2]=1000496;u=p+44|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[p+60>>2]=24;Ae(t,w);Bi(w);w=D+8|0;f=Ec(w,1001512,10)|0;g=a[1001432]|0;if(!(g&1)){e=1001433;g=(g&255)>>>1}else{e=c[250360]|0;g=c[250359]|0}e=Ec(f,e,g)|0;c[e+((c[(c[e>>2]|0)+-12>>2]|0)+76)>>2]=48;e=a[1001432]|0;if(!(e&1))e=(e&255)>>>1;else e=c[250359]|0;if(!e){Ac(Ac(Ac(p,B)|0,A)|0,E)|0;c[w+((c[(c[w>>2]|0)+-12>>2]|0)+12)>>2]=2;e=a[A>>0]|0;if(!(e&1)){g=A+1|0;e=(e&255)>>>1}else{g=c[A+8>>2]|0;e=c[A+4>>2]|0}n=Ec(w,g,e)|0;c[n+((c[(c[n>>2]|0)+-12>>2]|0)+12)>>2]=2;e=a[C>>0]|0;if(!(e&1)){f=(e&255)>>>1;e=C+1|0}else{f=c[C+4>>2]|0;e=c[C+8>>2]|0}g=a[B>>0]|0;if(!(g&1)){g=(g&255)>>>1;k=B+1|0}else{g=c[B+4>>2]|0;k=c[B+8>>2]|0}a:do if(f>>>0>=g>>>0)if(g){l=e+f|0;j=k+g|0;m=e;if((f|0)>=(g|0)?(f=1-g+f|0,o=e+f|0,(f|0)!=0):0){h=a[k>>0]|0;b:while(1){if((a[e>>0]|0)==h<<24>>24){g=e;f=k;do{f=f+1|0;if((f|0)==(j|0))break b;g=g+1|0}while((a[g>>0]|0)==(a[f>>0]|0))}e=e+1|0;if((e|0)==(o|0)){e=1073741824;break a}}if((e|0)!=(l|0))e=((e-m|0)>>>2)+1|0;else e=1073741824}else e=1073741824}else e=1;else e=1073741824;while(0);f=nk(n,e)|0;zi(v,E,2,-1,E);e=a[v>>0]|0;if(!(e&1)){g=v+1|0;e=(e&255)>>>1}else{g=c[v+8>>2]|0;e=c[v+4>>2]|0}Ec(f,g,e)|0;Bi(v)}w=Ec(Ec(w,1076616,0)|0,1076616,0)|0;Ec(Ec(w,d?1001528:1001544,d?11:4)|0,1001552,45)|0;Ce(b,z);c[p>>2]=1000292;c[r>>2]=1000332;c[s>>2]=1000312;c[t>>2]=1000496;Bi(u);kj(t);fj(p+64|0);c[D>>2]=1000292;c[x>>2]=1000332;c[y>>2]=1000312;c[z>>2]=1000496;Bi(q);kj(z);fj(D+64|0);Bi(E);Bi(A);Bi(B);Bi(C);i=F;return}function df(){return}function ef(b,d){b=b|0;d=d|0;if(a[1001608]|0)return b|0;if(!(Ia(1001608)|0))return b|0;c[250400]=0;Sa(1001608);return b|0}function ff(a){a=a|0;kf(a);return}function gf(a,b,c){a=a|0;b=b|0;c=c|0;c=i;i=i+16|0;Tb(c|0,0)|0;i=c;return}function hf(a){a=a|0;return}function jf(){vi(1001432,1017736,1);return}function kf(b){b=b|0;var d=0,e=0;if((a[1001880]|0)==0?(Ia(1001880)|0)!=0:0){c[250404]=1001980;c[250430]=1002e3;ij(1001720,1001620);c[250448]=0;c[250449]=-1;c[250404]=1001924;c[250430]=1001944;Hc(1001620);d=c[(c[(c[268332]|0)+-12>>2]|0)+1073352>>2]|0;nj(1001800);c[250450]=1002016;c[250458]=d;c[250459]=1001616;d=c[(c[(c[268354]|0)+-12>>2]|0)+1073440>>2]|0;nj(1001840);c[250460]=1002016;c[250468]=d;c[250469]=1001616;Sa(1001880)}d=(c[250421]|0)!=0;if(b){if(d)return;d=ib(1001888,1001904)|0;c[250421]=d;if(!d){d=c[(c[250404]|0)+-12>>2]|0;dj(1001616+d|0,c[d+1001632>>2]|4)}else{c[250427]=17;dj(1001616+(c[(c[250404]|0)+-12>>2]|0)|0,0)}d=c[(c[268332]|0)+-12>>2]|0;c[d+1073352>>2]=1001800;dj(1073328+d|0,0);d=c[(c[268354]|0)+-12>>2]|0;c[d+1073440>>2]=1001840;dj(1073416+d|0,0);return}if(!d)return;d=c[(c[268354]|0)+-12>>2]|0;c[d+1073440>>2]=c[250468];dj(1073416+d|0,0);d=c[(c[268332]|0)+-12>>2]|0;c[d+1073352>>2]=c[250458];dj(1073328+d|0,0);d=c[250421]|0;if(((d|0)!=0?(e=fc[c[(c[1001616+4>>2]|0)+24>>2]&127](1001620)|0,(vb(d|0)|0)==0):0)?(c[250421]=0,(e|0)==0):0)return;d=c[(c[250404]|0)+-12>>2]|0;dj(1001616+d|0,c[d+1001632>>2]|4);return}function lf(a){a=a|0;uf(a,1001952);fj(a+104|0);return}function mf(a){a=a|0;uf(a,1001952);fj(a+104|0);xt(a);return}function nf(a){a=a|0;var b=0;b=c[(c[a>>2]|0)+-12>>2]|0;uf(a+b|0,1001952);fj(a+(b+104)|0);return}function of(a){a=a|0;var b=0,d=0;d=c[(c[a>>2]|0)+-12>>2]|0;b=a+d|0;uf(b,1001952);fj(a+(d+104)|0);xt(b);return}function pf(a){a=a|0;kj(a);xt(a);return}function qf(a){a=a|0;var b=0;b=(c[a+36>>2]|0)+4|0;fc[c[(c[b>>2]|0)+24>>2]&127](b)|0;a=c[a+32>>2]|0;return fc[c[(c[a>>2]|0)+24>>2]&127](a)|0}function rf(a){a=a|0;var b=0;a=c[a+32>>2]|0;b=c[a+12>>2]|0;if((b|0)==(c[a+16>>2]|0)){a=fc[c[(c[a>>2]|0)+36>>2]&127](a)|0;return a|0}else{a=d[b>>0]|0;return a|0}return 0}function sf(b){b=b|0;var e=0,f=0,g=0,h=0;e=c[b+32>>2]|0;f=e+12|0;g=c[f>>2]|0;if((g|0)==(c[e+16>>2]|0))h=fc[c[(c[e>>2]|0)+40>>2]&127](e)|0;else{c[f>>2]=g+1;h=d[g>>0]|0}e=b+36|0;if((c[250520]|0)==10){f=(c[e>>2]|0)+4|0;$b[c[(c[f>>2]|0)+48>>2]&31](f,1002088,3)|0}b=c[e>>2]|0;f=b+4|0;e=b+28|0;g=c[e>>2]|0;if((g|0)==(c[b+32>>2]|0)){e=oc[c[(c[f>>2]|0)+52>>2]&63](f,h&255)|0;c[250520]=e;return e|0}else{c[e>>2]=g+1;a[g>>0]=h;e=h&255;c[250520]=e;return e|0}return 0}function tf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;g=c[b+32>>2]|0;f=g+24|0;e=c[f>>2]|0;if((e|0)==(c[g+28>>2]|0))d=oc[c[(c[g>>2]|0)+52>>2]&63](g,d&255)|0;else{c[f>>2]=e+1;a[e>>0]=d;d=d&255}e=b+36|0;if((c[250520]|0)==10){f=(c[e>>2]|0)+4|0;$b[c[(c[f>>2]|0)+48>>2]&31](f,1002072,3)|0}b=c[e>>2]|0;e=b+4|0;f=b+28|0;g=c[f>>2]|0;if((g|0)==(c[b+32>>2]|0)){e=oc[c[(c[e>>2]|0)+52>>2]&63](e,d&255)|0;c[250520]=e;return e|0}else{c[f>>2]=g+1;a[g>>0]=d;e=d&255;c[250520]=e;return e|0}return 0}function uf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;g=c[d>>2]|0;c[b>>2]=g;c[b+(c[g+-12>>2]|0)>>2]=c[d+12>>2];g=b+4|0;c[g>>2]=464;d=b+68|0;e=c[d>>2]|0;if((e|0)!=0?(Rc(g)|0,(vb(e|0)|0)==0):0)c[d>>2]=0;if((a[b+100>>0]|0)!=0?(f=c[b+36>>2]|0,(f|0)!=0):0)yt(f);if(!(a[b+101>>0]|0)){kj(g);return}d=c[b+60>>2]|0;if(!d){kj(g);return}yt(d);kj(g);return}function vf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;l=c[a+2212>>2]|0;q=a+((l^1)<<3)+320|0;p=c[q>>2]|0;q=c[q+4>>2]|0;if(!l){k=a+320|0;i=a+264|0;l=c[i>>2]&c[k>>2];k=c[i+4>>2]&c[k+4>>2];i=k&16711680;m=k&-16711681;if(!(0==0&(i|0)==0)){j=a+256|0;g=~c[j>>2];j=~c[j+4>>2];d=ov(0,i|0,9)|0;d=d&p;e=F&q;ov(0,i|0,7)|0;h=q&2130706432&F;i=ov(0,i|0,8)|0;g=i&g;i=F&j;if(!((d|0)==0&(e|0)==0)){j=b;while(1){o=_c(d,e)|0;b=iv(d|0,e|0,-1,-1)|0;d=b&d;e=F&e;b=j+8|0;c[j>>2]=o|(o<<6)+-576|28672;if((d|0)==0&(e|0)==0)break;else j=b}}if(!(0==0&(h|0)==0)){e=b;d=0;while(1){j=_c(d,h)|0;b=iv(d|0,h|0,-1,-1)|0;d=b&d;h=F&h;b=e+8|0;c[e>>2]=j|(j<<6)+-448|28672;if((d|0)==0&(h|0)==0)break;else e=b}}if(!((g|0)==0&(i|0)==0))while(1){j=_c(g,i)|0;h=iv(g|0,i|0,-1,-1)|0;g=h&g;i=F&i;h=b+8|0;c[b>>2]=j|(j<<6)+-512|28672;if((g|0)==0&(i|0)==0){b=h;break}else b=h}}e=ov(l|0,k|0,9)|0;e=p&-16843264&e;i=q&16711422&F;h=ov(l|0,k|0,7)|0;h=p&2139062016&h;g=q&8355711&F;if(!((e|0)==0&(i|0)==0)){d=b;while(1){k=_c(e,i)|0;b=iv(e|0,i|0,-1,-1)|0;e=b&e;i=F&i;b=d+8|0;c[d>>2]=(k<<6)+-576|k;if((e|0)==0&(i|0)==0)break;else d=b}}if(!((h|0)==0&(g|0)==0)){i=b;while(1){k=_c(h,g)|0;b=iv(h|0,g|0,-1,-1)|0;h=b&h;g=F&g;b=i+8|0;c[i>>2]=(k<<6)+-448|k;if((h|0)==0&(g|0)==0)break;else i=b}}i=a+2220|0;g=c[(c[i>>2]|0)+40>>2]|0;if((g|0)!=64?(f=51936+(g<<3)|0,n=l&c[f>>2],f=m&c[f+4>>2],!((n|0)==0&(f|0)==0)):0){g=n;while(1){l=_c(g,f)|0;e=iv(g|0,f|0,-1,-1)|0;g=e&g;f=F&f;e=b+8|0;c[b>>2]=l<<6|c[(c[i>>2]|0)+40>>2]|32768;if((g|0)==0&(f|0)==0){b=e;break}else b=e}}e=a+528|0;f=c[e>>2]|0;if((f|0)!=64)do{g=48352+(f<<3)|0;d=c[g>>2]&p;g=c[g+4>>2]&q;if(!((d|0)==0&(g|0)==0)){h=f<<6;f=b;while(1){l=_c(d,g)|0;b=iv(d|0,g|0,-1,-1)|0;d=b&d;g=F&g;b=f+8|0;c[f>>2]=l|h;if((d|0)==0&(g|0)==0)break;else f=b}}e=e+4|0;f=c[e>>2]|0}while((f|0)!=64);f=a+592|0;g=c[f>>2]|0;if((g|0)!=64){j=a+256|0;do{e=j;l=45728+(g<<3)|0;d=45216+(g<<3)|0;d=(ba(c[l+4>>2]&c[e+4>>2],c[d+4>>2]|0)|0)^(ba(c[l>>2]&c[e>>2],c[d>>2]|0)|0);d=(c[43680+(g<<2)>>2]|0)+(d>>>(c[46240+(g<<2)>>2]|0)<<3)|0;e=c[d>>2]&p;d=c[d+4>>2]&q;if(!((e|0)==0&(d|0)==0)){i=g<<6;h=b;g=d;while(1){l=_c(e,g)|0;b=iv(e|0,g|0,-1,-1)|0;e=b&e;g=F&g;b=h+8|0;c[h>>2]=l|i;if((e|0)==0&(g|0)==0)break;else h=b}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64)}f=a+656|0;g=c[f>>2]|0;if((g|0)!=64){j=a+256|0;do{e=j;l=44448+(g<<3)|0;d=43936+(g<<3)|0;d=(ba(c[l+4>>2]&c[e+4>>2],c[d+4>>2]|0)|0)^(ba(c[l>>2]&c[e>>2],c[d>>2]|0)|0);d=(c[43424+(g<<2)>>2]|0)+(d>>>(c[44960+(g<<2)>>2]|0)<<3)|0;e=c[d>>2]&p;d=c[d+4>>2]&q;if(!((e|0)==0&(d|0)==0)){i=g<<6;h=b;g=d;while(1){l=_c(e,g)|0;b=iv(e|0,g|0,-1,-1)|0;e=b&e;g=F&g;b=h+8|0;c[h>>2]=l|i;if((e|0)==0&(g|0)==0)break;else h=b}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64)}f=a+720|0;g=c[f>>2]|0;if((g|0)==64)f=b;else{j=a+256|0;do{i=j;e=c[i>>2]|0;i=c[i+4>>2]|0;k=44448+(g<<3)|0;d=43936+(g<<3)|0;d=(ba(c[k+4>>2]&i,c[d+4>>2]|0)|0)^(ba(c[k>>2]&e,c[d>>2]|0)|0);d=(c[43424+(g<<2)>>2]|0)+(d>>>(c[44960+(g<<2)>>2]|0)<<3)|0;k=45728+(g<<3)|0;l=45216+(g<<3)|0;l=(ba(c[k+4>>2]&i,c[l+4>>2]|0)|0)^(ba(c[k>>2]&e,c[l>>2]|0)|0);l=(c[43680+(g<<2)>>2]|0)+(l>>>(c[46240+(g<<2)>>2]|0)<<3)|0;e=(c[l>>2]|c[d>>2])&p;d=(c[l+4>>2]|c[d+4>>2])&q;if(!((e|0)==0&(d|0)==0)){i=g<<6;h=b;g=d;while(1){l=_c(e,g)|0;b=iv(e|0,g|0,-1,-1)|0;e=b&e;g=F&g;b=h+8|0;c[h>>2]=l|i;if((e|0)==0&(g|0)==0)break;else h=b}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64);f=b}d=c[a+784>>2]|0;b=50400+(d<<3)|0;e=c[b>>2]&p;b=c[b+4>>2]&q;if((e|0)==0&(b|0)==0){l=f;return l|0}g=d<<6;while(1){l=_c(e,b)|0;d=iv(e|0,b|0,-1,-1)|0;e=d&e;b=F&b;d=f+8|0;c[f>>2]=l|g;if((e|0)==0&(b|0)==0)break;else f=d}return d|0}else{m=a+328|0;i=a+264|0;k=c[i>>2]&c[m>>2];m=c[i+4>>2]&c[m+4>>2];i=k&65280;l=k&-65281;if(!((i|0)==0&0==0)){h=a+256|0;j=~c[h>>2];h=~c[h+4>>2];d=jv(i|0,0,9)|0;d=d&p;e=F&q;f=jv(i|0,0,7)|0;f=p&254&f;i=jv(i|0,0,8)|0;i=i&j;h=F&h;if(!((d|0)==0&(e|0)==0)){j=b;while(1){n=_c(d,e)|0;b=iv(d|0,e|0,-1,-1)|0;d=b&d;e=F&e;b=j+8|0;c[j>>2]=n|(n<<6)+576|28672;if((d|0)==0&(e|0)==0)break;else j=b}}if(!((f|0)==0&0==0)){d=b;e=0;while(1){j=_c(f,e)|0;b=iv(f|0,e|0,-1,-1)|0;f=b&f;e=F&e;b=d+8|0;c[d>>2]=j|(j<<6)+448|28672;if((f|0)==0&(e|0)==0)break;else d=b}}if(!((i|0)==0&(h|0)==0)){f=b;while(1){j=_c(i,h)|0;b=iv(i|0,h|0,-1,-1)|0;i=b&i;h=F&h;b=f+8|0;c[f>>2]=j|(j<<6)+512|28672;if((i|0)==0&(h|0)==0)break;else f=b}}}e=jv(k|0,m|0,9)|0;e=p&2139062016&e;i=q&8355711&F;h=jv(k|0,m|0,7)|0;h=p&-16843264&h;f=q&16711422&F;if(!((e|0)==0&(i|0)==0)){d=b;while(1){k=_c(e,i)|0;b=iv(e|0,i|0,-1,-1)|0;e=b&e;i=F&i;b=d+8|0;c[d>>2]=(k<<6)+576|k;if((e|0)==0&(i|0)==0)break;else d=b}}if(!((h|0)==0&(f|0)==0)){i=b;while(1){k=_c(h,f)|0;b=iv(h|0,f|0,-1,-1)|0;h=b&h;f=F&f;b=i+8|0;c[i>>2]=(k<<6)+448|k;if((h|0)==0&(f|0)==0)break;else i=b}}i=a+2220|0;f=c[(c[i>>2]|0)+40>>2]|0;if((f|0)!=64?(g=47840+(f<<3)|0,o=l&c[g>>2],g=m&c[g+4>>2],!((o|0)==0&(g|0)==0)):0){e=b;f=o;while(1){l=_c(f,g)|0;b=iv(f|0,g|0,-1,-1)|0;f=b&f;g=F&g;b=e+8|0;c[e>>2]=l<<6|c[(c[i>>2]|0)+40>>2]|32768;if((f|0)==0&(g|0)==0)break;else e=b}}g=a+1040|0;f=c[g>>2]|0;if((f|0)!=64)do{h=48352+(f<<3)|0;e=c[h>>2]&p;h=c[h+4>>2]&q;if(!((e|0)==0&(h|0)==0)){i=f<<6;d=e;f=h;while(1){l=_c(d,f)|0;e=iv(d|0,f|0,-1,-1)|0;d=e&d;f=F&f;e=b+8|0;c[b>>2]=l|i;if((d|0)==0&(f|0)==0){b=e;break}else b=e}}g=g+4|0;f=c[g>>2]|0}while((f|0)!=64);f=a+1104|0;g=c[f>>2]|0;if((g|0)!=64){j=a+256|0;do{h=j;l=45728+(g<<3)|0;i=45216+(g<<3)|0;i=(ba(c[l+4>>2]&c[h+4>>2],c[i+4>>2]|0)|0)^(ba(c[l>>2]&c[h>>2],c[i>>2]|0)|0);i=(c[43680+(g<<2)>>2]|0)+(i>>>(c[46240+(g<<2)>>2]|0)<<3)|0;h=c[i>>2]&p;i=c[i+4>>2]&q;if(!((h|0)==0&(i|0)==0)){d=g<<6;e=b;g=i;while(1){l=_c(h,g)|0;b=iv(h|0,g|0,-1,-1)|0;h=b&h;g=F&g;b=e+8|0;c[e>>2]=l|d;if((h|0)==0&(g|0)==0)break;else e=b}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64)}f=a+1168|0;g=c[f>>2]|0;if((g|0)!=64){j=a+256|0;do{h=j;l=44448+(g<<3)|0;i=43936+(g<<3)|0;i=(ba(c[l+4>>2]&c[h+4>>2],c[i+4>>2]|0)|0)^(ba(c[l>>2]&c[h>>2],c[i>>2]|0)|0);i=(c[43424+(g<<2)>>2]|0)+(i>>>(c[44960+(g<<2)>>2]|0)<<3)|0;h=c[i>>2]&p;i=c[i+4>>2]&q;if(!((h|0)==0&(i|0)==0)){d=g<<6;e=b;g=i;while(1){l=_c(h,g)|0;b=iv(h|0,g|0,-1,-1)|0;h=b&h;g=F&g;b=e+8|0;c[e>>2]=l|d;if((h|0)==0&(g|0)==0)break;else e=b}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64)}f=a+1232|0;g=c[f>>2]|0;if((g|0)==64)f=b;else{j=a+256|0;do{e=j;h=c[e>>2]|0;e=c[e+4>>2]|0;k=44448+(g<<3)|0;i=43936+(g<<3)|0;i=(ba(c[k+4>>2]&e,c[i+4>>2]|0)|0)^(ba(c[k>>2]&h,c[i>>2]|0)|0);i=(c[43424+(g<<2)>>2]|0)+(i>>>(c[44960+(g<<2)>>2]|0)<<3)|0;k=45728+(g<<3)|0;l=45216+(g<<3)|0;l=(ba(c[k+4>>2]&e,c[l+4>>2]|0)|0)^(ba(c[k>>2]&h,c[l>>2]|0)|0);l=(c[43680+(g<<2)>>2]|0)+(l>>>(c[46240+(g<<2)>>2]|0)<<3)|0;h=(c[l>>2]|c[i>>2])&p;i=(c[l+4>>2]|c[i+4>>2])&q;if(!((h|0)==0&(i|0)==0)){d=g<<6;g=i;while(1){l=_c(h,g)|0;e=iv(h|0,g|0,-1,-1)|0;h=e&h;g=F&g;e=b+8|0;c[b>>2]=l|d;if((h|0)==0&(g|0)==0){b=e;break}else b=e}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64);f=b}e=c[a+1296>>2]|0;b=50400+(e<<3)|0;d=c[b>>2]&p;b=c[b+4>>2]&q;if((d|0)==0&(b|0)==0){l=f;return l|0}g=e<<6;e=d;while(1){l=_c(e,b)|0;d=iv(e|0,b|0,-1,-1)|0;e=d&e;b=F&b;d=f+8|0;c[f>>2]=l|g;if((e|0)==0&(b|0)==0)break;else f=d}return d|0}return 0}function wf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;q=b+256|0;p=q;o=~c[p>>2];p=~c[p+4>>2];i=b+264|0;j=c[i>>2]|0;i=c[i+4>>2]|0;m=b+320|0;f=m;l=c[f>>2]|0;f=c[f+4>>2]|0;n=b+328|0;e=n;k=c[e>>2]|0;e=c[e+4>>2]|0;if(!(c[b+2212>>2]|0)){i=f&i;f=i&16711680;i=ov(l&j|0,i|0,8)|0;i=o&-256&i;h=p&16777215&F;j=ov(i|0,h|0,8)|0;j=o&-16777216&j;if(!((i|0)==0&(h|0)==0)){g=d;while(1){m=_c(i,h)|0;d=iv(i|0,h|0,-1,-1)|0;i=d&i;h=F&h;d=g+8|0;c[g>>2]=(m<<6)+-512|m;if((i|0)==0&(h|0)==0)break;else g=d}}if(!((j|0)==0&0==0)){h=d;i=0;while(1){m=_c(j,i)|0;d=iv(j|0,i|0,-1,-1)|0;j=d&j;i=F&i;d=h+8|0;c[h>>2]=(m<<6)+-1024|m;if((j|0)==0&(i|0)==0)break;else h=d}}if(!(0==0&(f|0)==0)){h=ov(0,f|0,9)|0;h=h&k;j=F&e;ov(0,f|0,7)|0;i=e&2130706432&F;g=ov(0,f|0,8)|0;g=g&o;e=F&p;if(!((h|0)==0&(j|0)==0)){f=d;while(1){m=_c(h,j)|0;d=iv(h|0,j|0,-1,-1)|0;h=d&h;j=F&j;m=(m<<6)+-576|m;c[f>>2]=m|24576;c[f+8>>2]=m|20480;d=f+24|0;c[f+16>>2]=m|16384;if((h|0)==0&(j|0)==0)break;else f=d}}if(!(0==0&(i|0)==0)){h=d;j=0;while(1){m=_c(j,i)|0;d=iv(j|0,i|0,-1,-1)|0;j=d&j;i=F&i;m=(m<<6)+-448|m;c[h>>2]=m|24576;c[h+8>>2]=m|20480;d=h+24|0;c[h+16>>2]=m|16384;if((j|0)==0&(i|0)==0)break;else h=d}}if(!((g|0)==0&(e|0)==0))while(1){m=_c(g,e)|0;f=iv(g|0,e|0,-1,-1)|0;g=f&g;e=F&e;m=(m<<6)+-512|m;c[d>>2]=m|24576;c[d+8>>2]=m|20480;f=d+24|0;c[d+16>>2]=m|16384;if((g|0)==0&(e|0)==0){d=f;break}else d=f}}g=b+528|0;f=c[g>>2]|0;if((f|0)!=64)do{i=48352+(f<<3)|0;j=c[i>>2]&o;i=c[i+4>>2]&p;if(!((j|0)==0&(i|0)==0)){f=f<<6;h=d;while(1){m=_c(j,i)|0;d=iv(j|0,i|0,-1,-1)|0;j=d&j;i=F&i;d=h+8|0;c[h>>2]=m|f;if((j|0)==0&(i|0)==0)break;else h=d}}g=g+4|0;f=c[g>>2]|0}while((f|0)!=64);g=b+592|0;f=c[g>>2]|0;if((f|0)!=64)do{j=q;m=45728+(f<<3)|0;i=45216+(f<<3)|0;i=(ba(c[m+4>>2]&c[j+4>>2],c[i+4>>2]|0)|0)^(ba(c[m>>2]&c[j>>2],c[i>>2]|0)|0);i=(c[43680+(f<<2)>>2]|0)+(i>>>(c[46240+(f<<2)>>2]|0)<<3)|0;j=c[i>>2]&o;i=c[i+4>>2]&p;if(!((j|0)==0&(i|0)==0)){f=f<<6;h=d;while(1){m=_c(j,i)|0;d=iv(j|0,i|0,-1,-1)|0;j=d&j;i=F&i;d=h+8|0;c[h>>2]=m|f;if((j|0)==0&(i|0)==0)break;else h=d}}g=g+4|0;f=c[g>>2]|0}while((f|0)!=64);g=b+656|0;f=c[g>>2]|0;if((f|0)!=64)do{j=q;m=44448+(f<<3)|0;i=43936+(f<<3)|0;i=(ba(c[m+4>>2]&c[j+4>>2],c[i+4>>2]|0)|0)^(ba(c[m>>2]&c[j>>2],c[i>>2]|0)|0);i=(c[43424+(f<<2)>>2]|0)+(i>>>(c[44960+(f<<2)>>2]|0)<<3)|0;j=c[i>>2]&o;i=c[i+4>>2]&p;if(!((j|0)==0&(i|0)==0)){f=f<<6;h=d;while(1){m=_c(j,i)|0;d=iv(j|0,i|0,-1,-1)|0;j=d&j;i=F&i;d=h+8|0;c[h>>2]=m|f;if((j|0)==0&(i|0)==0)break;else h=d}}g=g+4|0;f=c[g>>2]|0}while((f|0)!=64);g=b+720|0;f=c[g>>2]|0;if((f|0)!=64)do{k=q;j=c[k>>2]|0;k=c[k+4>>2]|0;l=44448+(f<<3)|0;i=43936+(f<<3)|0;i=(ba(c[l+4>>2]&k,c[i+4>>2]|0)|0)^(ba(c[l>>2]&j,c[i>>2]|0)|0);i=(c[43424+(f<<2)>>2]|0)+(i>>>(c[44960+(f<<2)>>2]|0)<<3)|0;l=45728+(f<<3)|0;m=45216+(f<<3)|0;m=(ba(c[l+4>>2]&k,c[m+4>>2]|0)|0)^(ba(c[l>>2]&j,c[m>>2]|0)|0);m=(c[43680+(f<<2)>>2]|0)+(m>>>(c[46240+(f<<2)>>2]|0)<<3)|0;j=(c[m>>2]|c[i>>2])&o;i=(c[m+4>>2]|c[i+4>>2])&p;if(!((j|0)==0&(i|0)==0)){f=f<<6;h=d;while(1){m=_c(j,i)|0;d=iv(j|0,i|0,-1,-1)|0;j=d&j;i=F&i;d=h+8|0;c[h>>2]=m|f;if((j|0)==0&(i|0)==0)break;else h=d}}g=g+4|0;f=c[g>>2]|0}while((f|0)!=64);l=b+784|0;g=c[l>>2]|0;f=50400+(g<<3)|0;i=c[f>>2]&o;f=c[f+4>>2]&p;if(!((i|0)==0&(f|0)==0)){j=g<<6;e=d;g=i;while(1){m=_c(g,f)|0;d=iv(g|0,f|0,-1,-1)|0;g=d&g;f=F&f;d=e+8|0;c[e>>2]=m|j;if((g|0)==0&(f|0)==0)break;else e=d}}k=b+2220|0;f=c[(c[k>>2]|0)+24>>2]|0;if(!(f&3)){m=d;return m|0}if(a[b+2224>>0]|0){m=Cf(b,Bf(b,d)|0)|0;return m|0}i=q;j=c[i>>2]|0;i=c[i+4>>2]|0;m=b+2008|0;a:do if(!(((c[m>>2]&j|0)!=0?1:(c[m+4>>2]&i|0)!=0)|(f&1|0)==0)){h=c[l>>2]|0;g=c[b+1940>>2]|0;e=n;f=c[e>>2]|0;e=c[e+4>>2]|0;b:do if((h|0)!=6){m=cg(b,6,j,i)|0;if((m&f|0)==0&(F&e|0)==0)i=5;else break a;while(1){if((i|0)==(h|0))break b;m=q;m=cg(b,i,c[m>>2]|0,c[m+4>>2]|0)|0;if((m&f|0)==0&(F&e|0)==0)i=i+-1|0;else break a}}while(0);c[d>>2]=g|h<<6|49152;d=d+8|0}while(0);e=q;j=c[e>>2]|0;e=c[e+4>>2]|0;m=b+2016|0;if(!((c[m>>2]&j|0)==0?(c[m+4>>2]&e|0)==0:0)){m=d;return m|0}if(!(c[(c[k>>2]|0)+24>>2]&2)){m=d;return m|0}i=c[l>>2]|0;h=c[b+1944>>2]|0;f=n;g=c[f>>2]|0;f=c[f+4>>2]|0;c:do if((i|0)!=2){m=cg(b,2,j,e)|0;if((m&g|0)==0&(F&f|0)==0)e=3;else{m=d;return m|0}while(1){if((e|0)==(i|0))break c;m=q;m=cg(b,e,c[m>>2]|0,c[m+4>>2]|0)|0;if((m&g|0)==0&(F&f|0)==0)e=e+1|0;else break}return d|0}while(0);c[d>>2]=h|i<<6|49152;m=d+8|0;return m|0}else{h=k&j;k=h&65280;i=jv(h|0,e&i|0,8)|0;i=o&-256&i;h=p&16777215&F;jv(i|0,h|0,8)|0;j=p&255&F;if(!((i|0)==0&(h|0)==0)){g=d;while(1){e=_c(i,h)|0;d=iv(i|0,h|0,-1,-1)|0;i=d&i;h=F&h;d=g+8|0;c[g>>2]=(e<<6)+512|e;if((i|0)==0&(h|0)==0)break;else g=d}}if(!(0==0&(j|0)==0)){i=d;h=0;while(1){g=_c(h,j)|0;d=iv(h|0,j|0,-1,-1)|0;h=d&h;j=F&j;d=i+8|0;c[i>>2]=(g<<6)+1024|g;if((h|0)==0&(j|0)==0)break;else i=d}}if(!((k|0)==0&0==0)){h=jv(k|0,0,9)|0;h=h&l;j=F&f;i=jv(k|0,0,7)|0;i=l&254&i;g=jv(k|0,0,8)|0;g=g&o;f=F&p;if(!((h|0)==0&(j|0)==0)){e=d;while(1){l=_c(h,j)|0;d=iv(h|0,j|0,-1,-1)|0;h=d&h;j=F&j;l=(l<<6)+576|l;c[e>>2]=l|24576;c[e+8>>2]=l|20480;d=e+24|0;c[e+16>>2]=l|16384;if((h|0)==0&(j|0)==0)break;else e=d}}if(!((i|0)==0&0==0)){e=d;h=0;while(1){l=_c(i,h)|0;d=iv(i|0,h|0,-1,-1)|0;i=d&i;h=F&h;l=(l<<6)+448|l;c[e>>2]=l|24576;c[e+8>>2]=l|20480;d=e+24|0;c[e+16>>2]=l|16384;if((i|0)==0&(h|0)==0)break;else e=d}}if(!((g|0)==0&(f|0)==0)){e=d;while(1){l=_c(g,f)|0;d=iv(g|0,f|0,-1,-1)|0;g=d&g;f=F&f;l=(l<<6)+512|l;c[e>>2]=l|24576;c[e+8>>2]=l|20480;d=e+24|0;c[e+16>>2]=l|16384;if((g|0)==0&(f|0)==0)break;else e=d}}}g=b+1040|0;f=c[g>>2]|0;if((f|0)!=64)do{i=48352+(f<<3)|0;j=c[i>>2]&o;i=c[i+4>>2]&p;if(!((j|0)==0&(i|0)==0)){f=f<<6;h=d;while(1){l=_c(j,i)|0;d=iv(j|0,i|0,-1,-1)|0;j=d&j;i=F&i;d=h+8|0;c[h>>2]=l|f;if((j|0)==0&(i|0)==0)break;else h=d}}g=g+4|0;f=c[g>>2]|0}while((f|0)!=64);g=b+1104|0;f=c[g>>2]|0;if((f|0)!=64)do{j=q;l=45728+(f<<3)|0;i=45216+(f<<3)|0;i=(ba(c[l+4>>2]&c[j+4>>2],c[i+4>>2]|0)|0)^(ba(c[l>>2]&c[j>>2],c[i>>2]|0)|0);i=(c[43680+(f<<2)>>2]|0)+(i>>>(c[46240+(f<<2)>>2]|0)<<3)|0;j=c[i>>2]&o;i=c[i+4>>2]&p;if(!((j|0)==0&(i|0)==0)){f=f<<6;h=d;while(1){l=_c(j,i)|0;d=iv(j|0,i|0,-1,-1)|0;j=d&j;i=F&i;d=h+8|0;c[h>>2]=l|f;if((j|0)==0&(i|0)==0)break;else h=d}}g=g+4|0;f=c[g>>2]|0}while((f|0)!=64);g=b+1168|0;f=c[g>>2]|0;if((f|0)!=64)do{j=q;l=44448+(f<<3)|0;i=43936+(f<<3)|0;i=(ba(c[l+4>>2]&c[j+4>>2],c[i+4>>2]|0)|0)^(ba(c[l>>2]&c[j>>2],c[i>>2]|0)|0);i=(c[43424+(f<<2)>>2]|0)+(i>>>(c[44960+(f<<2)>>2]|0)<<3)|0;j=c[i>>2]&o;i=c[i+4>>2]&p;if(!((j|0)==0&(i|0)==0)){f=f<<6;h=d;while(1){l=_c(j,i)|0;d=iv(j|0,i|0,-1,-1)|0;j=d&j;i=F&i;d=h+8|0;c[h>>2]=l|f;if((j|0)==0&(i|0)==0)break;else h=d}}g=g+4|0;f=c[g>>2]|0}while((f|0)!=64);g=b+1232|0;f=c[g>>2]|0;if((f|0)!=64)do{h=q;j=c[h>>2]|0;h=c[h+4>>2]|0;k=44448+(f<<3)|0;i=43936+(f<<3)|0;i=(ba(c[k+4>>2]&h,c[i+4>>2]|0)|0)^(ba(c[k>>2]&j,c[i>>2]|0)|0);i=(c[43424+(f<<2)>>2]|0)+(i>>>(c[44960+(f<<2)>>2]|0)<<3)|0;k=45728+(f<<3)|0;l=45216+(f<<3)|0;l=(ba(c[k+4>>2]&h,c[l+4>>2]|0)|0)^(ba(c[k>>2]&j,c[l>>2]|0)|0);l=(c[43680+(f<<2)>>2]|0)+(l>>>(c[46240+(f<<2)>>2]|0)<<3)|0;j=(c[l>>2]|c[i>>2])&o;i=(c[l+4>>2]|c[i+4>>2])&p;if(!((j|0)==0&(i|0)==0)){f=f<<6;h=d;while(1){l=_c(j,i)|0;d=iv(j|0,i|0,-1,-1)|0;j=d&j;i=F&i;d=h+8|0;c[h>>2]=l|f;if((j|0)==0&(i|0)==0)break;else h=d}}g=g+4|0;f=c[g>>2]|0}while((f|0)!=64);l=b+1296|0;g=c[l>>2]|0;f=50400+(g<<3)|0;i=c[f>>2]&o;f=c[f+4>>2]&p;if(!((i|0)==0&(f|0)==0)){j=g<<6;e=d;g=i;while(1){k=_c(g,f)|0;d=iv(g|0,f|0,-1,-1)|0;g=d&g;f=F&f;d=e+8|0;c[e>>2]=k|j;if((g|0)==0&(f|0)==0)break;else e=d}}k=b+2220|0;f=c[(c[k>>2]|0)+24>>2]|0;if(!(f&12)){m=d;return m|0}if(a[b+2224>>0]|0){m=Ef(b,Df(b,d)|0)|0;return m|0}i=q;j=c[i>>2]|0;i=c[i+4>>2]|0;h=b+2032|0;d:do if(!(((c[h>>2]&j|0)!=0?1:(c[h+4>>2]&i|0)!=0)|(f&4|0)==0)){h=c[l>>2]|0;g=c[b+1952>>2]|0;e=m;f=c[e>>2]|0;e=c[e+4>>2]|0;e:do if((h|0)!=62){j=cg(b,62,j,i)|0;if((j&f|0)==0&(F&e|0)==0)i=61;else break d;while(1){if((i|0)==(h|0))break e;j=q;j=cg(b,i,c[j>>2]|0,c[j+4>>2]|0)|0;if((j&f|0)==0&(F&e|0)==0)i=i+-1|0;else break d}}while(0);c[d>>2]=g|h<<6|49152;d=d+8|0}while(0);j=q;e=c[j>>2]|0;j=c[j+4>>2]|0;i=b+2064|0;if(!((c[i>>2]&e|0)==0?(c[i+4>>2]&j|0)==0:0)){m=d;return m|0}if(!(c[(c[k>>2]|0)+24>>2]&8)){m=d;return m|0}h=c[l>>2]|0;i=c[b+1968>>2]|0;g=m;f=c[g>>2]|0;g=c[g+4>>2]|0;f:do if((h|0)!=58){m=cg(b,58,e,j)|0;if((m&f|0)==0&(F&g|0)==0)e=59;else{m=d;return m|0}while(1){if((e|0)==(h|0))break f;m=q;m=cg(b,e,c[m>>2]|0,c[m+4>>2]|0)|0;if((m&f|0)==0&(F&g|0)==0)e=e+1|0;else break}return d|0}while(0);c[d>>2]=i|h<<6|49152;m=d+8|0;return m|0}return 0}function xf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=c[b+2212>>2]|0;w=b+(m<<3)+320|0;v=~c[w>>2];w=~c[w+4>>2];if(!m){o=b+320|0;e=b+264|0;r=c[e>>2]&c[o>>2];o=c[e+4>>2]&c[o+4>>2];e=o&16711680;s=o&-16711681;t=b+328|0;q=t;p=c[q>>2]|0;q=c[q+4>>2]|0;u=b+256|0;n=u;m=~c[n>>2];n=~c[n+4>>2];l=ov(r|0,s|0,8)|0;l=l&m;j=F&n;k=ov(l|0,j|0,8)|0;k=m&-16777216&k;if(!((l|0)==0&(j|0)==0)){h=d;while(1){f=_c(l,j)|0;d=iv(l|0,j|0,-1,-1)|0;l=d&l;j=F&j;d=h+8|0;c[h>>2]=(f<<6)+-512|f;if((l|0)==0&(j|0)==0)break;else h=d}}if(!((k|0)==0&0==0)){h=d;j=0;while(1){l=_c(k,j)|0;d=iv(k|0,j|0,-1,-1)|0;k=d&k;j=F&j;d=h+8|0;c[h>>2]=(l<<6)+-1024|l;if((k|0)==0&(j|0)==0)break;else h=d}}if(!(0==0&(e|0)==0)){l=ov(0,e|0,9)|0;l=l&p;f=F&q;ov(0,e|0,7)|0;h=q&2130706432&F;j=ov(0,e|0,8)|0;j=j&m;k=F&n;if(!((l|0)==0&(f|0)==0))while(1){m=_c(l,f)|0;e=iv(l|0,f|0,-1,-1)|0;l=e&l;f=F&f;m=(m<<6)+-576|m;c[d>>2]=m|28672;c[d+8>>2]=m|24576;c[d+16>>2]=m|20480;e=d+32|0;c[d+24>>2]=m|16384;if((l|0)==0&(f|0)==0){d=e;break}else d=e}if(!(0==0&(h|0)==0)){f=d;e=0;while(1){m=_c(e,h)|0;d=iv(e|0,h|0,-1,-1)|0;e=d&e;h=F&h;m=(m<<6)+-448|m;c[f>>2]=m|28672;c[f+8>>2]=m|24576;c[f+16>>2]=m|20480;d=f+32|0;c[f+24>>2]=m|16384;if((e|0)==0&(h|0)==0)break;else f=d}}if(!((j|0)==0&(k|0)==0)){h=d;while(1){m=_c(j,k)|0;d=iv(j|0,k|0,-1,-1)|0;j=d&j;k=F&k;m=(m<<6)+-512|m;c[h>>2]=m|28672;c[h+8>>2]=m|24576;c[h+16>>2]=m|20480;d=h+32|0;c[h+24>>2]=m|16384;if((j|0)==0&(k|0)==0)break;else h=d}}}f=ov(r|0,o|0,9)|0;f=p&-16843264&f;h=q&16711422&F;j=ov(r|0,o|0,7)|0;j=p&2139062016&j;k=q&8355711&F;if(!((f|0)==0&(h|0)==0)){e=d;while(1){m=_c(f,h)|0;d=iv(f|0,h|0,-1,-1)|0;f=d&f;h=F&h;d=e+8|0;c[e>>2]=(m<<6)+-576|m;if((f|0)==0&(h|0)==0)break;else e=d}}if(!((j|0)==0&(k|0)==0)){h=d;while(1){m=_c(j,k)|0;d=iv(j|0,k|0,-1,-1)|0;j=d&j;k=F&k;d=h+8|0;c[h>>2]=(m<<6)+-448|m;if((j|0)==0&(k|0)==0)break;else h=d}}q=b+2220|0;j=c[(c[q>>2]|0)+40>>2]|0;if((j|0)!=64?(g=51936+(j<<3)|0,i=c[g>>2]&r,g=c[g+4>>2]&s,!((i|0)==0&(g|0)==0)):0)while(1){m=_c(i,g)|0;f=iv(i|0,g|0,-1,-1)|0;i=f&i;g=F&g;f=d+8|0;c[d>>2]=m<<6|c[(c[q>>2]|0)+40>>2]|32768;if((i|0)==0&(g|0)==0){d=f;break}else d=f}i=b+528|0;g=c[i>>2]|0;if((g|0)!=64)do{j=48352+(g<<3)|0;k=c[j>>2]&v;j=c[j+4>>2]&w;if(!((k|0)==0&(j|0)==0)){g=g<<6;h=d;while(1){m=_c(k,j)|0;d=iv(k|0,j|0,-1,-1)|0;k=d&k;j=F&j;d=h+8|0;c[h>>2]=m|g;if((k|0)==0&(j|0)==0)break;else h=d}}i=i+4|0;g=c[i>>2]|0}while((g|0)!=64);i=b+592|0;g=c[i>>2]|0;if((g|0)!=64)do{k=u;m=45728+(g<<3)|0;j=45216+(g<<3)|0;j=(ba(c[m+4>>2]&c[k+4>>2],c[j+4>>2]|0)|0)^(ba(c[m>>2]&c[k>>2],c[j>>2]|0)|0);j=(c[43680+(g<<2)>>2]|0)+(j>>>(c[46240+(g<<2)>>2]|0)<<3)|0;k=c[j>>2]&v;j=c[j+4>>2]&w;if(!((k|0)==0&(j|0)==0)){g=g<<6;h=d;while(1){m=_c(k,j)|0;d=iv(k|0,j|0,-1,-1)|0;k=d&k;j=F&j;d=h+8|0;c[h>>2]=m|g;if((k|0)==0&(j|0)==0)break;else h=d}}i=i+4|0;g=c[i>>2]|0}while((g|0)!=64);i=b+656|0;g=c[i>>2]|0;if((g|0)!=64)do{k=u;m=44448+(g<<3)|0;j=43936+(g<<3)|0;j=(ba(c[m+4>>2]&c[k+4>>2],c[j+4>>2]|0)|0)^(ba(c[m>>2]&c[k>>2],c[j>>2]|0)|0);j=(c[43424+(g<<2)>>2]|0)+(j>>>(c[44960+(g<<2)>>2]|0)<<3)|0;k=c[j>>2]&v;j=c[j+4>>2]&w;if(!((k|0)==0&(j|0)==0)){g=g<<6;h=d;while(1){m=_c(k,j)|0;d=iv(k|0,j|0,-1,-1)|0;k=d&k;j=F&j;d=h+8|0;c[h>>2]=m|g;if((k|0)==0&(j|0)==0)break;else h=d}}i=i+4|0;g=c[i>>2]|0}while((g|0)!=64);i=b+720|0;g=c[i>>2]|0;if((g|0)!=64)do{h=u;k=c[h>>2]|0;h=c[h+4>>2]|0;l=44448+(g<<3)|0;j=43936+(g<<3)|0;j=(ba(c[l+4>>2]&h,c[j+4>>2]|0)|0)^(ba(c[l>>2]&k,c[j>>2]|0)|0);j=(c[43424+(g<<2)>>2]|0)+(j>>>(c[44960+(g<<2)>>2]|0)<<3)|0;l=45728+(g<<3)|0;m=45216+(g<<3)|0;m=(ba(c[l+4>>2]&h,c[m+4>>2]|0)|0)^(ba(c[l>>2]&k,c[m>>2]|0)|0);m=(c[43680+(g<<2)>>2]|0)+(m>>>(c[46240+(g<<2)>>2]|0)<<3)|0;k=(c[m>>2]|c[j>>2])&v;j=(c[m+4>>2]|c[j+4>>2])&w;if(!((k|0)==0&(j|0)==0)){g=g<<6;h=d;while(1){m=_c(k,j)|0;d=iv(k|0,j|0,-1,-1)|0;k=d&k;j=F&j;d=h+8|0;c[h>>2]=m|g;if((k|0)==0&(j|0)==0)break;else h=d}}i=i+4|0;g=c[i>>2]|0}while((g|0)!=64);l=b+784|0;i=c[l>>2]|0;g=50400+(i<<3)|0;j=c[g>>2]&v;g=c[g+4>>2]&w;if(!((j|0)==0&(g|0)==0)){k=i<<6;h=d;i=j;while(1){m=_c(i,g)|0;d=iv(i|0,g|0,-1,-1)|0;i=d&i;g=F&g;d=h+8|0;c[h>>2]=m|k;if((i|0)==0&(g|0)==0)break;else h=d}}e=c[(c[q>>2]|0)+24>>2]|0;if(!(e&3)){m=d;return m|0}if(a[b+2224>>0]|0){m=Cf(b,Bf(b,d)|0)|0;return m|0}j=u;k=c[j>>2]|0;j=c[j+4>>2]|0;m=b+2008|0;a:do if(!(((c[m>>2]&k|0)!=0?1:(c[m+4>>2]&j|0)!=0)|(e&1|0)==0)){h=c[l>>2]|0;g=c[b+1940>>2]|0;e=t;f=c[e>>2]|0;e=c[e+4>>2]|0;b:do if((h|0)!=6){m=cg(b,6,k,j)|0;if((m&f|0)==0&(F&e|0)==0)i=5;else break a;while(1){if((i|0)==(h|0))break b;m=u;m=cg(b,i,c[m>>2]|0,c[m+4>>2]|0)|0;if((m&f|0)==0&(F&e|0)==0)i=i+-1|0;else break a}}while(0);c[d>>2]=g|h<<6|49152;d=d+8|0}while(0);e=u;j=c[e>>2]|0;e=c[e+4>>2]|0;m=b+2016|0;if(!((c[m>>2]&j|0)==0?(c[m+4>>2]&e|0)==0:0)){m=d;return m|0}if(!(c[(c[q>>2]|0)+24>>2]&2)){m=d;return m|0}i=c[l>>2]|0;h=c[b+1944>>2]|0;f=t;g=c[f>>2]|0;f=c[f+4>>2]|0;c:do if((i|0)!=2){m=cg(b,2,j,e)|0;if((m&g|0)==0&(F&f|0)==0)e=3;else{m=d;return m|0}while(1){if((e|0)==(i|0))break c;m=u;m=cg(b,e,c[m>>2]|0,c[m+4>>2]|0)|0;if((m&g|0)==0&(F&f|0)==0)e=e+1|0;else break}return d|0}while(0);c[d>>2]=h|i<<6|49152;m=d+8|0;return m|0}else{s=b+328|0;m=b+264|0;p=c[m>>2]&c[s>>2];s=c[m+4>>2]&c[s+4>>2];m=p&65280;r=p&-65281;t=b+320|0;q=t;o=c[q>>2]|0;q=c[q+4>>2]|0;u=b+256|0;n=u;g=~c[n>>2];n=~c[n+4>>2];l=jv(r|0,s|0,8)|0;l=l&g;j=F&n;jv(l|0,j|0,8)|0;k=n&255&F;if(!((l|0)==0&(j|0)==0)){i=d;while(1){h=_c(l,j)|0;d=iv(l|0,j|0,-1,-1)|0;l=d&l;j=F&j;d=i+8|0;c[i>>2]=(h<<6)+512|h;if((l|0)==0&(j|0)==0)break;else i=d}}if(!(0==0&(k|0)==0)){j=d;l=0;while(1){i=_c(l,k)|0;d=iv(l|0,k|0,-1,-1)|0;l=d&l;k=F&k;d=j+8|0;c[j>>2]=(i<<6)+1024|i;if((l|0)==0&(k|0)==0)break;else j=d}}if(!((m|0)==0&0==0)){l=jv(m|0,0,9)|0;l=l&o;h=F&q;i=jv(m|0,0,7)|0;i=o&254&i;j=jv(m|0,0,8)|0;j=j&g;k=F&n;if(!((l|0)==0&(h|0)==0)){g=d;while(1){m=_c(l,h)|0;d=iv(l|0,h|0,-1,-1)|0;l=d&l;h=F&h;m=(m<<6)+576|m;c[g>>2]=m|28672;c[g+8>>2]=m|24576;c[g+16>>2]=m|20480;d=g+32|0;c[g+24>>2]=m|16384;if((l|0)==0&(h|0)==0)break;else g=d}}if(!((i|0)==0&0==0)){g=d;h=0;while(1){m=_c(i,h)|0;d=iv(i|0,h|0,-1,-1)|0;i=d&i;h=F&h;m=(m<<6)+448|m;c[g>>2]=m|28672;c[g+8>>2]=m|24576;c[g+16>>2]=m|20480;d=g+32|0;c[g+24>>2]=m|16384;if((i|0)==0&(h|0)==0)break;else g=d}}if(!((j|0)==0&(k|0)==0)){i=d;while(1){m=_c(j,k)|0;d=iv(j|0,k|0,-1,-1)|0;j=d&j;k=F&k;m=(m<<6)+512|m;c[i>>2]=m|28672;c[i+8>>2]=m|24576;c[i+16>>2]=m|20480;d=i+32|0;c[i+24>>2]=m|16384;if((j|0)==0&(k|0)==0)break;else i=d}}}h=jv(p|0,s|0,9)|0;h=o&2139062016&h;i=q&8355711&F;j=jv(p|0,s|0,7)|0;j=o&-16843264&j;k=q&16711422&F;if(!((h|0)==0&(i|0)==0)){g=d;while(1){m=_c(h,i)|0;d=iv(h|0,i|0,-1,-1)|0;h=d&h;i=F&i;d=g+8|0;c[g>>2]=(m<<6)+576|m;if((h|0)==0&(i|0)==0)break;else g=d}}if(!((j|0)==0&(k|0)==0)){i=d;while(1){m=_c(j,k)|0;d=iv(j|0,k|0,-1,-1)|0;j=d&j;k=F&k;d=i+8|0;c[i>>2]=(m<<6)+448|m;if((j|0)==0&(k|0)==0)break;else i=d}}q=b+2220|0;j=c[(c[q>>2]|0)+40>>2]|0;if((j|0)!=64?(f=47840+(j<<3)|0,e=c[f>>2]&r,f=c[f+4>>2]&s,!((e|0)==0&(f|0)==0)):0){h=d;i=e;g=f;while(1){m=_c(i,g)|0;d=iv(i|0,g|0,-1,-1)|0;i=d&i;g=F&g;d=h+8|0;c[h>>2]=m<<6|c[(c[q>>2]|0)+40>>2]|32768;if((i|0)==0&(g|0)==0)break;else h=d}}i=b+1040|0;g=c[i>>2]|0;if((g|0)!=64)do{j=48352+(g<<3)|0;k=c[j>>2]&v;j=c[j+4>>2]&w;if(!((k|0)==0&(j|0)==0)){g=g<<6;h=d;while(1){m=_c(k,j)|0;d=iv(k|0,j|0,-1,-1)|0;k=d&k;j=F&j;d=h+8|0;c[h>>2]=m|g;if((k|0)==0&(j|0)==0)break;else h=d}}i=i+4|0;g=c[i>>2]|0}while((g|0)!=64);i=b+1104|0;g=c[i>>2]|0;if((g|0)!=64)do{k=u;m=45728+(g<<3)|0;j=45216+(g<<3)|0;j=(ba(c[m+4>>2]&c[k+4>>2],c[j+4>>2]|0)|0)^(ba(c[m>>2]&c[k>>2],c[j>>2]|0)|0);j=(c[43680+(g<<2)>>2]|0)+(j>>>(c[46240+(g<<2)>>2]|0)<<3)|0;k=c[j>>2]&v;j=c[j+4>>2]&w;if(!((k|0)==0&(j|0)==0)){g=g<<6;h=d;while(1){m=_c(k,j)|0;d=iv(k|0,j|0,-1,-1)|0;k=d&k;j=F&j;d=h+8|0;c[h>>2]=m|g;if((k|0)==0&(j|0)==0)break;else h=d}}i=i+4|0;g=c[i>>2]|0}while((g|0)!=64);i=b+1168|0;g=c[i>>2]|0;if((g|0)!=64)do{j=u;m=44448+(g<<3)|0;h=43936+(g<<3)|0;h=(ba(c[m+4>>2]&c[j+4>>2],c[h+4>>2]|0)|0)^(ba(c[m>>2]&c[j>>2],c[h>>2]|0)|0);h=(c[43424+(g<<2)>>2]|0)+(h>>>(c[44960+(g<<2)>>2]|0)<<3)|0;j=c[h>>2]&v;h=c[h+4>>2]&w;if(!((j|0)==0&(h|0)==0)){g=g<<6;k=d;while(1){m=_c(j,h)|0;d=iv(j|0,h|0,-1,-1)|0;j=d&j;h=F&h;d=k+8|0;c[k>>2]=m|g;if((j|0)==0&(h|0)==0)break;else k=d}}i=i+4|0;g=c[i>>2]|0}while((g|0)!=64);f=b+1232|0;g=c[f>>2]|0;if((g|0)!=64)do{k=u;j=c[k>>2]|0;k=c[k+4>>2]|0;l=44448+(g<<3)|0;i=43936+(g<<3)|0;i=(ba(c[l+4>>2]&k,c[i+4>>2]|0)|0)^(ba(c[l>>2]&j,c[i>>2]|0)|0);i=(c[43424+(g<<2)>>2]|0)+(i>>>(c[44960+(g<<2)>>2]|0)<<3)|0;l=45728+(g<<3)|0;m=45216+(g<<3)|0;m=(ba(c[l+4>>2]&k,c[m+4>>2]|0)|0)^(ba(c[l>>2]&j,c[m>>2]|0)|0);m=(c[43680+(g<<2)>>2]|0)+(m>>>(c[46240+(g<<2)>>2]|0)<<3)|0;j=(c[m>>2]|c[i>>2])&v;i=(c[m+4>>2]|c[i+4>>2])&w;if(!((j|0)==0&(i|0)==0)){h=g<<6;k=d;while(1){m=_c(j,i)|0;d=iv(j|0,i|0,-1,-1)|0;j=d&j;i=F&i;d=k+8|0;c[k>>2]=m|h;if((j|0)==0&(i|0)==0)break;else k=d}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64);l=b+1296|0;g=c[l>>2]|0;e=50400+(g<<3)|0;h=c[e>>2]&v;e=c[e+4>>2]&w;if(!((h|0)==0&(e|0)==0)){j=g<<6;i=d;g=h;while(1){m=_c(g,e)|0;d=iv(g|0,e|0,-1,-1)|0;g=d&g;e=F&e;d=i+8|0;c[i>>2]=m|j;if((g|0)==0&(e|0)==0)break;else i=d}}e=c[(c[q>>2]|0)+24>>2]|0;if(!(e&12)){m=d;return m|0}if(a[b+2224>>0]|0){m=Ef(b,Df(b,d)|0)|0;return m|0}i=u;j=c[i>>2]|0;i=c[i+4>>2]|0;m=b+2032|0;d:do if(!(((c[m>>2]&j|0)!=0?1:(c[m+4>>2]&i|0)!=0)|(e&4|0)==0)){h=c[l>>2]|0;f=c[b+1952>>2]|0;k=t;e=c[k>>2]|0;k=c[k+4>>2]|0;e:do if((h|0)!=62){m=cg(b,62,j,i)|0;if((m&e|0)==0&(F&k|0)==0)g=61;else break d;while(1){if((g|0)==(h|0))break e;m=u;m=cg(b,g,c[m>>2]|0,c[m+4>>2]|0)|0;if((m&e|0)==0&(F&k|0)==0)g=g+-1|0;else break d}}while(0);c[d>>2]=f|h<<6|49152;d=d+8|0}while(0);j=u;e=c[j>>2]|0;j=c[j+4>>2]|0;m=b+2064|0;if(!((c[m>>2]&e|0)==0?(c[m+4>>2]&j|0)==0:0)){m=d;return m|0}if(!(c[(c[q>>2]|0)+24>>2]&8)){m=d;return m|0}h=c[l>>2]|0;i=c[b+1968>>2]|0;g=t;f=c[g>>2]|0;g=c[g+4>>2]|0;f:do if((h|0)!=58){m=cg(b,58,e,j)|0;if((m&f|0)==0&(F&g|0)==0)e=59;else{m=d;return m|0}while(1){if((e|0)==(h|0))break f;m=u;m=cg(b,e,c[m>>2]|0,c[m+4>>2]|0)|0;if((m&f|0)==0&(F&g|0)==0)e=e+1|0;else break}return d|0}while(0);c[d>>2]=i|h<<6|49152;m=d+8|0;return m|0}return 0}function yf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;O=i;i=i+96|0;N=O;o=c[b+2212>>2]|0;Tf(N,b);j=N;M=b+256|0;s=N+80|0;k=c[j>>2]|0;j=c[j+4>>2]|0;a:while(1){while(1){if((k|0)==0&(j|0)==0)break a;n=_c(k,j)|0;m=iv(k|0,j|0,-1,-1)|0;k=m&k;j=F&j;m=c[b+(n<<2)>>2]&7;if((m|0)==1)continue;g=M;h=c[g>>2]|0;g=c[g+4>>2]|0;u=Ff(m,n,h,g)|0;h=u&~h;g=F&~g;if((m|0)==6){u=65248+(c[s>>2]<<3)|0;h=h&~c[u>>2];g=g&~c[u+4>>2]}if(!((h|0)==0&(g|0)==0))break}p=n<<6;m=d;n=g;while(1){u=_c(h,n)|0;d=iv(h|0,n|0,-1,-1)|0;h=d&h;n=F&n;d=m+8|0;c[m>>2]=u|p;if((h|0)==0&(n|0)==0)continue a;else m=d}}L=M;K=~c[L>>2];L=~c[L+4>>2];m=b+264|0;n=c[m>>2]|0;m=c[m+4>>2]|0;t=b+320|0;p=t;e=c[p>>2]|0;p=c[p+4>>2]|0;u=b+328|0;r=u;q=c[r>>2]|0;r=c[r+4>>2]|0;if(!o){k=e&n;f=p&m;p=f&16711680;f=f&-16711681;g=ov(k|0,f|0,8)|0;g=g&K;h=F&L;z=ov(g|0,h|0,8)|0;m=c[s>>2]|0;n=51936+(m<<3)|0;j=c[n>>2]|0;g=j&g;h=c[n+4>>2]&h;n=K&-16777216;j=z&n&j;z=N;k=c[z>>2]&k;f=c[z+4>>2]&f;if((k|0)==0&(f|0)==0)k=0;else{y=ov(k|0,f|0,8)|0;z=47008+((m&7)<<3)|0;y=y&K&~c[z>>2];z=F&L&~c[z+4>>2];k=ov(y|0,z|0,8)|0;g=y|g;h=z|h;j=k&n|j;k=0}if(!((g|0)==0&(h|0)==0)){m=d;while(1){z=_c(g,h)|0;d=iv(g|0,h|0,-1,-1)|0;g=d&g;h=F&h;d=m+8|0;c[m>>2]=(z<<6)+-512|z;if((g|0)==0&(h|0)==0)break;else m=d}}if(!((j|0)==0&(k|0)==0)){h=d;while(1){z=_c(j,k)|0;d=iv(j|0,k|0,-1,-1)|0;j=d&j;k=F&k;d=h+8|0;c[h>>2]=(z<<6)+-1024|z;if((j|0)==0&(k|0)==0)break;else h=d}}b:do if(!(0==0&(p|0)==0)){k=ov(0,p|0,9)|0;k=k&q;j=F&r;c:while(1){do{if((k|0)==0&(j|0)==0)break c;h=_c(k,j)|0;z=iv(k|0,j|0,-1,-1)|0;k=z&k;j=F&j;z=48352+(h<<3)|0;y=46496+(c[s>>2]<<3)|0}while((c[y>>2]&c[z>>2]|0)==0?(c[y+4>>2]&c[z+4>>2]|0)==0:0);c[d>>2]=h|(h<<6)+-576|16384;d=d+8|0}ov(0,p|0,7)|0;j=0;k=r&2130706432&F;d:while(1){do{if((j|0)==0&(k|0)==0)break d;h=_c(j,k)|0;z=iv(j|0,k|0,-1,-1)|0;j=z&j;k=F&k;z=48352+(h<<3)|0;y=46496+(c[s>>2]<<3)|0}while((c[y>>2]&c[z>>2]|0)==0?(c[y+4>>2]&c[z+4>>2]|0)==0:0);c[d>>2]=h|(h<<6)+-448|16384;d=d+8|0}k=ov(0,p|0,8)|0;k=k&K;j=F&L;while(1){do{if((k|0)==0&(j|0)==0)break b;h=_c(k,j)|0;z=iv(k|0,j|0,-1,-1)|0;k=z&k;j=F&j;z=48352+(h<<3)|0;y=46496+(c[s>>2]<<3)|0}while((c[y>>2]&c[z>>2]|0)==0?(c[y+4>>2]&c[z+4>>2]|0)==0:0);c[d>>2]=h|(h<<6)+-512|16384;d=d+8|0}}while(0);j=b+528|0;k=c[j>>2]|0;if((k|0)!=64){n=N+32|0;do{g=N;h=c[g>>2]|0;g=c[g+4>>2]|0;if(!(!((h|0)==0&(g|0)==0)?(z=46496+(k<<3)|0,!((c[z>>2]&h|0)==0?(c[z+4>>2]&g|0)==0:0)):0)){z=48352+(k<<3)|0;f=n;h=c[z>>2]&K&c[f>>2];f=c[z+4>>2]&L&c[f+4>>2];if(!((h|0)==0&(f|0)==0)){e=k<<6;g=d;k=f;while(1){z=_c(h,k)|0;d=iv(h|0,k|0,-1,-1)|0;h=d&h;k=F&k;d=g+8|0;c[g>>2]=z|e;if((h|0)==0&(k|0)==0)break;else g=d}}}j=j+4|0;k=c[j>>2]|0}while((k|0)!=64)}j=b+592|0;k=c[j>>2]|0;if((k|0)!=64){p=N+40|0;do{z=64224+(k<<3)|0;e=p;h=c[e>>2]|0;e=c[e+4>>2]|0;do if(!((c[z>>2]&K&h|0)==0?(c[z+4>>2]&L&e|0)==0:0)){f=N;g=c[f>>2]|0;f=c[f+4>>2]|0;if(!((g|0)==0&(f|0)==0)?(z=46496+(k<<3)|0,!((c[z>>2]&g|0)==0?(c[z+4>>2]&f|0)==0:0)):0)break;z=M;y=45728+(k<<3)|0;f=45216+(k<<3)|0;f=(ba(c[y+4>>2]&c[z+4>>2],c[f+4>>2]|0)|0)^(ba(c[y>>2]&c[z>>2],c[f>>2]|0)|0);f=(c[43680+(k<<2)>>2]|0)+(f>>>(c[46240+(k<<2)>>2]|0)<<3)|0;h=h&K&c[f>>2];f=e&L&c[f+4>>2];if(!((h|0)==0&(f|0)==0)){e=k<<6;g=d;k=f;while(1){z=_c(h,k)|0;d=iv(h|0,k|0,-1,-1)|0;h=d&h;k=F&k;d=g+8|0;c[g>>2]=z|e;if((h|0)==0&(k|0)==0)break;else g=d}}}while(0);j=j+4|0;k=c[j>>2]|0}while((k|0)!=64)}j=b+656|0;k=c[j>>2]|0;if((k|0)!=64){p=N+48|0;do{z=64736+(k<<3)|0;e=p;h=c[e>>2]|0;e=c[e+4>>2]|0;do if(!((c[z>>2]&K&h|0)==0?(c[z+4>>2]&L&e|0)==0:0)){f=N;g=c[f>>2]|0;f=c[f+4>>2]|0;if(!((g|0)==0&(f|0)==0)?(z=46496+(k<<3)|0,!((c[z>>2]&g|0)==0?(c[z+4>>2]&f|0)==0:0)):0)break;z=M;y=44448+(k<<3)|0;f=43936+(k<<3)|0;f=(ba(c[y+4>>2]&c[z+4>>2],c[f+4>>2]|0)|0)^(ba(c[y>>2]&c[z>>2],c[f>>2]|0)|0);f=(c[43424+(k<<2)>>2]|0)+(f>>>(c[44960+(k<<2)>>2]|0)<<3)|0;h=h&K&c[f>>2];f=e&L&c[f+4>>2];if(!((h|0)==0&(f|0)==0)){e=k<<6;g=d;k=f;while(1){z=_c(h,k)|0;d=iv(h|0,k|0,-1,-1)|0;h=d&h;k=F&k;d=g+8|0;c[g>>2]=z|e;if((h|0)==0&(k|0)==0)break;else g=d}}}while(0);j=j+4|0;k=c[j>>2]|0}while((k|0)!=64)}j=b+720|0;k=c[j>>2]|0;if((k|0)==64)n=d;else{p=N+56|0;do{z=65248+(k<<3)|0;e=p;h=c[e>>2]|0;e=c[e+4>>2]|0;do if(!((c[z>>2]&K&h|0)==0?(c[z+4>>2]&L&e|0)==0:0)){f=N;g=c[f>>2]|0;f=c[f+4>>2]|0;if(!((g|0)==0&(f|0)==0)?(z=46496+(k<<3)|0,!((c[z>>2]&g|0)==0?(c[z+4>>2]&f|0)==0:0)):0)break;v=M;y=c[v>>2]|0;v=c[v+4>>2]|0;x=44448+(k<<3)|0;f=43936+(k<<3)|0;f=(ba(c[x+4>>2]&v,c[f+4>>2]|0)|0)^(ba(c[x>>2]&y,c[f>>2]|0)|0);f=(c[43424+(k<<2)>>2]|0)+(f>>>(c[44960+(k<<2)>>2]|0)<<3)|0;x=45728+(k<<3)|0;z=45216+(k<<3)|0;z=(ba(c[x+4>>2]&v,c[z+4>>2]|0)|0)^(ba(c[x>>2]&y,c[z>>2]|0)|0);z=(c[43680+(k<<2)>>2]|0)+(z>>>(c[46240+(k<<2)>>2]|0)<<3)|0;h=h&K&(c[z>>2]|c[f>>2]);f=e&L&(c[z+4>>2]|c[f+4>>2]);if(!((h|0)==0&(f|0)==0)){e=k<<6;g=d;k=f;while(1){z=_c(h,k)|0;d=iv(h|0,k|0,-1,-1)|0;h=d&h;k=F&k;d=g+8|0;c[g>>2]=z|e;if((h|0)==0&(k|0)==0)break;else g=d}}}while(0);j=j+4|0;k=c[j>>2]|0}while((k|0)!=64);n=d}q=b+2220|0;d=c[(c[q>>2]|0)+24>>2]|0;if(!(d&3)){z=n;i=O;return z|0}e=M;f=c[e>>2]|0;e=c[e+4>>2]|0;z=b+2008|0;d=((c[z>>2]&f|0)!=0?1:(c[z+4>>2]&e|0)!=0)|(d&1|0)==0;if(!(a[b+2224>>0]|0)){e:do if(!d){d=c[b+784>>2]|0;k=c[b+1940>>2]|0;h=u;j=c[h>>2]|0;h=c[h+4>>2]|0;f:do if((d|0)!=6){z=cg(b,6,f,e)|0;if((z&j|0)==0&(F&h|0)==0)g=5;else{l=n;break e}while(1){if((g|0)==(d|0))break f;z=M;z=cg(b,g,c[z>>2]|0,c[z+4>>2]|0)|0;if((z&j|0)==0&(F&h|0)==0)g=g+-1|0;else{l=n;break e}}}while(0);e=k|d<<6|49152;if(fg(b,e,N)|0){c[n>>2]=e;l=n+8|0}else l=n}else l=n;while(0);k=M;d=c[k>>2]|0;k=c[k+4>>2]|0;z=b+2016|0;if(!((c[z>>2]&d|0)==0?(c[z+4>>2]&k|0)==0:0)){z=l;i=O;return z|0}if(!(c[(c[q>>2]|0)+24>>2]&2)){z=l;i=O;return z|0}h=c[b+784>>2]|0;j=c[b+1944>>2]|0;g=u;f=c[g>>2]|0;g=c[g+4>>2]|0;g:do if((h|0)!=2){z=cg(b,2,d,k)|0;if((z&f|0)==0&(F&g|0)==0)e=3;else{z=l;i=O;return z|0}while(1){if((e|0)==(h|0))break g;z=M;z=cg(b,e,c[z>>2]|0,c[z+4>>2]|0)|0;if((z&f|0)==0&(F&g|0)==0)e=e+1|0;else break}i=O;return l|0}while(0);e=j|h<<6|49152;if(!(fg(b,e,N)|0)){z=l;i=O;return z|0}c[l>>2]=e;z=l+8|0;i=O;return z|0}h:do if(!d){p=c[b+784>>2]|0;o=c[b+1940>>2]|0;j=u;h=c[j>>2]|0;j=c[j+4>>2]|0;m=(p|0)<6?-1:1;if((p|0)==6){d=f;k=e}else{g=6;d=f;k=e;do{z=cg(b,g,d,k)|0;g=g+m|0;if(!((z&h|0)==0&(F&j|0)==0))break h;k=M;d=c[k>>2]|0;k=c[k+4>>2]|0}while((g|0)!=(p|0));j=u;h=c[j>>2]|0;j=c[j+4>>2]|0}x=46496+(o<<3)|0;x=((ba(4210752&(c[x+4>>2]^k),1214252160)|0)^(ba(1077952574&(c[x>>2]^d),270534817)|0))>>>21;x=(c[10862]|0)+(x<<3)|0;z=b+288|0;y=b+296|0;if(((c[x>>2]&h&(c[y>>2]|c[z>>2])|0)==0?(c[x+4>>2]&j&(c[y+4>>2]|c[z+4>>2])|0)==0:0)?(w=o|p<<6|49152,fg(b,w,N)|0):0){c[n>>2]=w;n=n+8|0}}while(0);k=M;d=c[k>>2]|0;k=c[k+4>>2]|0;z=b+2016|0;if(!((c[z>>2]&d|0)==0?(c[z+4>>2]&k|0)==0:0)){z=n;i=O;return z|0}if(!(c[(c[q>>2]|0)+24>>2]&2)){z=n;i=O;return z|0}m=c[b+784>>2]|0;e=c[b+1944>>2]|0;h=u;j=c[h>>2]|0;h=c[h+4>>2]|0;g=(m|0)<2?-1:1;do if((m|0)!=2){f=2;while(1){z=cg(b,f,d,k)|0;f=f+g|0;if(!((z&j|0)==0&(F&h|0)==0)){l=n;d=193;break}k=M;d=c[k>>2]|0;k=c[k+4>>2]|0;if((f|0)==(m|0)){B=d;C=k;d=83;break}}if((d|0)==83){J=u;G=B;H=C;I=c[J>>2]|0;J=c[J+4>>2]|0;break}else if((d|0)==193){i=O;return l|0}}else{G=d;H=k;I=j;J=h}while(0);x=46496+(e<<3)|0;x=((ba(263172&(c[x+4>>2]^H),2099728)|0)^(ba(67372154&(c[x>>2]^G),-528480112)|0))>>>21;x=(c[10858]|0)+(x<<3)|0;z=b+288|0;y=b+296|0;if(!((c[x>>2]&I&(c[y>>2]|c[z>>2])|0)==0?(c[x+4>>2]&J&(c[y+4>>2]|c[z+4>>2])|0)==0:0)){z=n;i=O;return z|0}e=e|m<<6|49152;if(!(fg(b,e,N)|0)){z=n;i=O;return z|0}c[n>>2]=e;z=n+8|0;i=O;return z|0}else{j=q&n;f=r&m;q=j&65280;j=j&-65281;g=jv(j|0,f|0,8)|0;g=g&K;h=F&L;jv(g|0,h|0,8)|0;m=c[s>>2]|0;n=47840+(m<<3)|0;k=c[n+4>>2]|0;g=c[n>>2]&g;h=k&h;n=L&255;k=F&n&k;w=N;j=c[w>>2]&j;f=c[w+4>>2]&f;if((j|0)==0&(f|0)==0)j=0;else{w=jv(j|0,f|0,8)|0;j=47008+((m&7)<<3)|0;w=w&K&~c[j>>2];j=F&L&~c[j+4>>2];jv(w|0,j|0,8)|0;g=w|g;h=j|h;j=0;k=F&n|k}if(!((g|0)==0&(h|0)==0)){m=d;while(1){w=_c(g,h)|0;d=iv(g|0,h|0,-1,-1)|0;g=d&g;h=F&h;d=m+8|0;c[m>>2]=(w<<6)+512|w;if((g|0)==0&(h|0)==0)break;else m=d}}if(!((j|0)==0&(k|0)==0)){h=d;while(1){w=_c(j,k)|0;d=iv(j|0,k|0,-1,-1)|0;j=d&j;k=F&k;d=h+8|0;c[h>>2]=(w<<6)+1024|w;if((j|0)==0&(k|0)==0)break;else h=d}}i:do if(!((q|0)==0&0==0)){j=jv(q|0,0,9)|0;j=j&e;k=F&p;j:while(1){do{if((j|0)==0&(k|0)==0)break j;h=_c(j,k)|0;w=iv(j|0,k|0,-1,-1)|0;j=w&j;k=F&k;w=48352+(h<<3)|0;u=46496+(c[s>>2]<<3)|0}while((c[u>>2]&c[w>>2]|0)==0?(c[u+4>>2]&c[w+4>>2]|0)==0:0);c[d>>2]=h|(h<<6)+576|16384;d=d+8|0}k=jv(q|0,0,7)|0;k=e&254&k;j=0;k:while(1){do{if((k|0)==0&(j|0)==0)break k;h=_c(k,j)|0;w=iv(k|0,j|0,-1,-1)|0;k=w&k;j=F&j;w=48352+(h<<3)|0;u=46496+(c[s>>2]<<3)|0}while((c[u>>2]&c[w>>2]|0)==0?(c[u+4>>2]&c[w+4>>2]|0)==0:0);c[d>>2]=h|(h<<6)+448|16384;d=d+8|0}k=jv(q|0,0,8)|0;k=k&K;j=F&L;while(1){do{if((k|0)==0&(j|0)==0)break i;h=_c(k,j)|0;w=iv(k|0,j|0,-1,-1)|0;k=w&k;j=F&j;w=48352+(h<<3)|0;u=46496+(c[s>>2]<<3)|0}while((c[u>>2]&c[w>>2]|0)==0?(c[u+4>>2]&c[w+4>>2]|0)==0:0);c[d>>2]=h|(h<<6)+512|16384;d=d+8|0}}while(0);j=b+1040|0;k=c[j>>2]|0;if((k|0)!=64){n=N+32|0;do{g=N;h=c[g>>2]|0;g=c[g+4>>2]|0;if(!(!((h|0)==0&(g|0)==0)?(w=46496+(k<<3)|0,!((c[w>>2]&h|0)==0?(c[w+4>>2]&g|0)==0:0)):0)){w=48352+(k<<3)|0;f=n;h=c[w>>2]&K&c[f>>2];f=c[w+4>>2]&L&c[f+4>>2];if(!((h|0)==0&(f|0)==0)){e=k<<6;g=d;k=f;while(1){w=_c(h,k)|0;d=iv(h|0,k|0,-1,-1)|0;h=d&h;k=F&k;d=g+8|0;c[g>>2]=w|e;if((h|0)==0&(k|0)==0)break;else g=d}}}j=j+4|0;k=c[j>>2]|0}while((k|0)!=64)}j=b+1104|0;k=c[j>>2]|0;if((k|0)!=64){p=N+40|0;do{w=64224+(k<<3)|0;e=p;h=c[e>>2]|0;e=c[e+4>>2]|0;do if(!((c[w>>2]&K&h|0)==0?(c[w+4>>2]&L&e|0)==0:0)){f=N;g=c[f>>2]|0;f=c[f+4>>2]|0;if(!((g|0)==0&(f|0)==0)?(w=46496+(k<<3)|0,!((c[w>>2]&g|0)==0?(c[w+4>>2]&f|0)==0:0)):0)break;w=M;u=45728+(k<<3)|0;f=45216+(k<<3)|0;f=(ba(c[u+4>>2]&c[w+4>>2],c[f+4>>2]|0)|0)^(ba(c[u>>2]&c[w>>2],c[f>>2]|0)|0);f=(c[43680+(k<<2)>>2]|0)+(f>>>(c[46240+(k<<2)>>2]|0)<<3)|0;h=h&K&c[f>>2];f=e&L&c[f+4>>2];if(!((h|0)==0&(f|0)==0)){e=k<<6;g=d;k=f;while(1){w=_c(h,k)|0;d=iv(h|0,k|0,-1,-1)|0;h=d&h;k=F&k;d=g+8|0;c[g>>2]=w|e;if((h|0)==0&(k|0)==0)break;else g=d}}}while(0);j=j+4|0;k=c[j>>2]|0}while((k|0)!=64)}j=b+1168|0;k=c[j>>2]|0;if((k|0)!=64){p=N+48|0;do{w=64736+(k<<3)|0;e=p;h=c[e>>2]|0;e=c[e+4>>2]|0;do if(!((c[w>>2]&K&h|0)==0?(c[w+4>>2]&L&e|0)==0:0)){f=N;g=c[f>>2]|0;f=c[f+4>>2]|0;if(!((g|0)==0&(f|0)==0)?(w=46496+(k<<3)|0,!((c[w>>2]&g|0)==0?(c[w+4>>2]&f|0)==0:0)):0)break;w=M;u=44448+(k<<3)|0;f=43936+(k<<3)|0;f=(ba(c[u+4>>2]&c[w+4>>2],c[f+4>>2]|0)|0)^(ba(c[u>>2]&c[w>>2],c[f>>2]|0)|0);f=(c[43424+(k<<2)>>2]|0)+(f>>>(c[44960+(k<<2)>>2]|0)<<3)|0;h=h&K&c[f>>2];f=e&L&c[f+4>>2];if(!((h|0)==0&(f|0)==0)){e=k<<6;g=d;k=f;while(1){w=_c(h,k)|0;d=iv(h|0,k|0,-1,-1)|0;h=d&h;k=F&k;d=g+8|0;c[g>>2]=w|e;if((h|0)==0&(k|0)==0)break;else g=d}}}while(0);j=j+4|0;k=c[j>>2]|0}while((k|0)!=64)}j=b+1232|0;k=c[j>>2]|0;if((k|0)==64)n=d;else{p=N+56|0;do{w=65248+(k<<3)|0;e=p;h=c[e>>2]|0;e=c[e+4>>2]|0;do if(!((c[w>>2]&K&h|0)==0?(c[w+4>>2]&L&e|0)==0:0)){f=N;g=c[f>>2]|0;f=c[f+4>>2]|0;if(!((g|0)==0&(f|0)==0)?(w=46496+(k<<3)|0,!((c[w>>2]&g|0)==0?(c[w+4>>2]&f|0)==0:0)):0)break;r=M;g=c[r>>2]|0;r=c[r+4>>2]|0;s=44448+(k<<3)|0;w=43936+(k<<3)|0;w=(ba(c[s+4>>2]&r,c[w+4>>2]|0)|0)^(ba(c[s>>2]&g,c[w>>2]|0)|0);w=(c[43424+(k<<2)>>2]|0)+(w>>>(c[44960+(k<<2)>>2]|0)<<3)|0;s=45728+(k<<3)|0;u=45216+(k<<3)|0;u=(ba(c[s+4>>2]&r,c[u+4>>2]|0)|0)^(ba(c[s>>2]&g,c[u>>2]|0)|0);u=(c[43680+(k<<2)>>2]|0)+(u>>>(c[46240+(k<<2)>>2]|0)<<3)|0;g=h&K&(c[u>>2]|c[w>>2]);h=e&L&(c[u+4>>2]|c[w+4>>2]);if(!((g|0)==0&(h|0)==0)){f=k<<6;k=h;while(1){w=_c(g,k)|0;h=iv(g|0,k|0,-1,-1)|0;g=h&g;k=F&k;h=d+8|0;c[d>>2]=w|f;if((g|0)==0&(k|0)==0){d=h;break}else d=h}}}while(0);j=j+4|0;k=c[j>>2]|0}while((k|0)!=64);n=d}q=b+2220|0;d=c[(c[q>>2]|0)+24>>2]|0;if(!(d&12)){z=n;i=O;return z|0}e=M;f=c[e>>2]|0;e=c[e+4>>2]|0;w=b+2032|0;d=((c[w>>2]&f|0)!=0?1:(c[w+4>>2]&e|0)!=0)|(d&4|0)==0;if(!(a[b+2224>>0]|0)){l:do if(!d){d=c[b+1296>>2]|0;k=c[b+1952>>2]|0;h=t;j=c[h>>2]|0;h=c[h+4>>2]|0;m:do if((d|0)!=62){z=cg(b,62,f,e)|0;if((z&j|0)==0&(F&h|0)==0)g=61;else{l=n;break l}while(1){if((g|0)==(d|0))break m;z=M;z=cg(b,g,c[z>>2]|0,c[z+4>>2]|0)|0;if((z&j|0)==0&(F&h|0)==0)g=g+-1|0;else{l=n;break l}}}while(0);e=k|d<<6|49152;if(fg(b,e,N)|0){c[n>>2]=e;l=n+8|0}else l=n}else l=n;while(0);h=M;j=c[h>>2]|0;h=c[h+4>>2]|0;z=b+2064|0;if(!((c[z>>2]&j|0)==0?(c[z+4>>2]&h|0)==0:0)){z=l;i=O;return z|0}if(!(c[(c[q>>2]|0)+24>>2]&8)){z=l;i=O;return z|0}k=c[b+1296>>2]|0;d=c[b+1968>>2]|0;f=t;g=c[f>>2]|0;f=c[f+4>>2]|0;n:do if((k|0)!=58){z=cg(b,58,j,h)|0;if((z&g|0)==0&(F&f|0)==0)e=59;else{z=l;i=O;return z|0}while(1){if((e|0)==(k|0))break n;z=M;z=cg(b,e,c[z>>2]|0,c[z+4>>2]|0)|0;if((z&g|0)==0&(F&f|0)==0)e=e+1|0;else break}i=O;return l|0}while(0);e=d|k<<6|49152;if(!(fg(b,e,N)|0)){z=l;i=O;return z|0}c[l>>2]=e;z=l+8|0;i=O;return z|0}o:do if(!d){o=c[b+1296>>2]|0;p=c[b+1952>>2]|0;j=t;h=c[j>>2]|0;j=c[j+4>>2]|0;m=(o|0)<62?-1:1;if((o|0)==62){d=f;k=e}else{g=62;d=f;k=e;do{w=cg(b,g,d,k)|0;g=g+m|0;if(!((w&h|0)==0&(F&j|0)==0))break o;k=M;d=c[k>>2]|0;k=c[k+4>>2]|0}while((g|0)!=(o|0));j=t;h=c[j>>2]|0;j=c[j+4>>2]|0}s=46496+(p<<3)|0;s=((ba(1044398144&(c[s+4>>2]^k),1179777)|0)^(ba(1077952512&(c[s>>2]^d),67111557)|0))>>>21;s=(c[10918]|0)+(s<<3)|0;w=b+288|0;u=b+296|0;if(((c[s>>2]&h&(c[u>>2]|c[w>>2])|0)==0?(c[s+4>>2]&j&(c[u+4>>2]|c[w+4>>2])|0)==0:0)?(v=p|o<<6|49152,fg(b,v,N)|0):0){c[n>>2]=v;n=n+8|0}}while(0);k=M;d=c[k>>2]|0;k=c[k+4>>2]|0;w=b+2064|0;if(!((c[w>>2]&d|0)==0?(c[w+4>>2]&k|0)==0:0)){z=n;i=O;return z|0}if(!(c[(c[q>>2]|0)+24>>2]&8)){z=n;i=O;return z|0}e=c[b+1296>>2]|0;m=c[b+1968>>2]|0;h=t;j=c[h>>2]|0;h=c[h+4>>2]|0;g=(e|0)<58?-1:1;do if((e|0)!=58){f=58;while(1){w=cg(b,f,d,k)|0;f=f+g|0;if(!((w&j|0)==0&(F&h|0)==0)){l=n;d=193;break}k=M;d=c[k>>2]|0;k=c[k+4>>2]|0;if((f|0)==(e|0)){D=d;E=k;d=174;break}}if((d|0)==174){A=t;x=D;y=E;z=c[A>>2]|0;A=c[A+4>>2]|0;break}else if((d|0)==193){i=O;return l|0}}else{x=d;y=k;z=j;A=h}while(0);w=46496+(m<<3)|0;w=((ba(2047083524&(c[w+4>>2]^y),538003493)|0)^(ba(67372032&(c[w>>2]^x),537419781)|0))>>>21;w=(c[10914]|0)+(w<<3)|0;y=b+288|0;x=b+296|0;if(!((c[w>>2]&z&(c[x>>2]|c[y>>2])|0)==0?(c[w+4>>2]&A&(c[x+4>>2]|c[y+4>>2])|0)==0:0)){z=n;i=O;return z|0}e=m|e<<6|49152;if(!(fg(b,e,N)|0)){z=n;i=O;return z|0}c[n>>2]=e;z=n+8|0;i=O;return z|0}return 0}function zf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;n=c[a+2212>>2]|0;l=c[a+(n<<9)+784>>2]|0;u=a+2220|0;j=(c[u>>2]|0)+56|0;h=a+272|0;m=a+264|0;k=m;i=c[j>>2]&~(c[k>>2]|c[h>>2]);h=c[j+4>>2]&~(c[k+4>>2]|c[h+4>>2]);if((i|0)==0&(h|0)==0){i=-1;h=-1}else{d=0;j=0;do{o=_c(i,h)|0;k=iv(i|0,h|0,-1,-1)|0;i=k&i;h=F&h;k=66784+(o<<9)+(l<<3)|0;o=46496+(o<<3)|0;d=c[o>>2]^c[k>>2]|d;j=c[o+4>>2]^c[k+4>>2]|j}while(!((i|0)==0&(h|0)==0));i=d;h=j;i=~i;h=~h}d=50400+(l<<3)|0;k=a+(n<<3)+320|0;j=c[d>>2]&i&~c[k>>2];i=c[d+4>>2]&h&~c[k+4>>2];if(!((j|0)==0&(i|0)==0)){d=l<<6;h=b;while(1){k=_c(j,i)|0;b=iv(j|0,i|0,-1,-1)|0;j=b&j;i=F&i;b=h+8|0;c[h>>2]=k|d;if((j|0)==0&(i|0)==0)break;else h=b}}i=(c[u>>2]|0)+56|0;h=c[i>>2]|0;i=c[i+4>>2]|0;k=iv(h|0,i|0,-1,-1)|0;if(!((k&h|0)==0&(F&i|0)==0)){l=b;return l|0}v=_c(h,i)|0;w=99552+(v<<9)+(l<<3)|0;l=46496+(v<<3)|0;v=c[l>>2]|c[w>>2];w=c[l+4>>2]|c[w+4>>2];if(!n){n=a+320|0;d=m;q=c[d>>2]&c[n>>2];n=c[d+4>>2]&c[n+4>>2];d=n&16711680;r=n&-16711681;p=a+328|0;o=c[p>>2]&v;p=c[p+4>>2]&w;t=a+256|0;m=t;l=~c[m>>2];m=~c[m+4>>2];i=ov(q|0,r|0,8)|0;i=i&l;h=F&m;j=ov(i|0,h|0,8)|0;i=i&v;h=h&w;j=v&-16777216&l&j;if(!((i|0)==0&(h|0)==0)){k=b;while(1){g=_c(i,h)|0;b=iv(i|0,h|0,-1,-1)|0;i=b&i;h=F&h;b=k+8|0;c[k>>2]=(g<<6)+-512|g;if((i|0)==0&(h|0)==0)break;else k=b}}if(!((j|0)==0&0==0)){h=b;i=0;while(1){k=_c(j,i)|0;b=iv(j|0,i|0,-1,-1)|0;j=b&j;i=F&i;b=h+8|0;c[h>>2]=(k<<6)+-1024|k;if((j|0)==0&(i|0)==0)break;else h=b}}if((0!=0|(d|0)!=0)&(w>>>0>16777215|(w|0)==16777215&v>>>0>4294967295)){f=ov(0,d|0,9)|0;f=f&o;g=F&p;ov(0,d|0,7)|0;h=p&2130706432&F;i=ov(0,d|0,8)|0;i=v&l&i;j=w&m&F;if(!((f|0)==0&(g|0)==0)){d=b;while(1){l=_c(f,g)|0;b=iv(f|0,g|0,-1,-1)|0;f=b&f;g=F&g;l=(l<<6)+-576|l;c[d>>2]=l|28672;c[d+8>>2]=l|24576;c[d+16>>2]=l|20480;b=d+32|0;c[d+24>>2]=l|16384;if((f|0)==0&(g|0)==0)break;else d=b}}if(!(0==0&(h|0)==0)){g=b;f=0;while(1){l=_c(f,h)|0;b=iv(f|0,h|0,-1,-1)|0;f=b&f;h=F&h;l=(l<<6)+-448|l;c[g>>2]=l|28672;c[g+8>>2]=l|24576;c[g+16>>2]=l|20480;b=g+32|0;c[g+24>>2]=l|16384;if((f|0)==0&(h|0)==0)break;else g=b}}if(!((i|0)==0&(j|0)==0)){h=b;while(1){l=_c(i,j)|0;b=iv(i|0,j|0,-1,-1)|0;i=b&i;j=F&j;l=(l<<6)+-512|l;c[h>>2]=l|28672;c[h+8>>2]=l|24576;c[h+16>>2]=l|20480;b=h+32|0;c[h+24>>2]=l|16384;if((i|0)==0&(j|0)==0)break;else h=b}}}j=ov(q|0,n|0,9)|0;j=j&-16843264&o;g=F&16711422&p;h=ov(q|0,n|0,7)|0;h=h&2139062016&o;i=F&8355711&p;if(!((j|0)==0&(g|0)==0))while(1){l=_c(j,g)|0;f=iv(j|0,g|0,-1,-1)|0;j=f&j;g=F&g;f=b+8|0;c[b>>2]=(l<<6)+-576|l;if((j|0)==0&(g|0)==0){b=f;break}else b=f}if(!((h|0)==0&(i|0)==0)){g=b;while(1){l=_c(h,i)|0;b=iv(h|0,i|0,-1,-1)|0;h=b&h;i=F&i;b=g+8|0;c[g>>2]=(l<<6)+-448|l;if((h|0)==0&(i|0)==0)break;else g=b}}h=c[(c[u>>2]|0)+40>>2]|0;if(((h|0)!=64?(l=46496+(h+-8<<3)|0,!((c[l>>2]&v|0)==0?(c[l+4>>2]&w|0)==0:0)):0)?(e=51936+(h<<3)|0,s=c[e>>2]&q,e=c[e+4>>2]&r,!((s|0)==0&(e|0)==0)):0){f=s;while(1){l=_c(f,e)|0;d=iv(f|0,e|0,-1,-1)|0;f=d&f;e=F&e;d=b+8|0;c[b>>2]=l<<6|c[(c[u>>2]|0)+40>>2]|32768;if((f|0)==0&(e|0)==0){b=d;break}else b=d}}d=a+528|0;e=c[d>>2]|0;if((e|0)!=64)do{f=48352+(e<<3)|0;h=c[f>>2]&v;f=c[f+4>>2]&w;if(!((h|0)==0&(f|0)==0)){i=e<<6;g=b;while(1){l=_c(h,f)|0;b=iv(h|0,f|0,-1,-1)|0;h=b&h;f=F&f;b=g+8|0;c[g>>2]=l|i;if((h|0)==0&(f|0)==0)break;else g=b}}d=d+4|0;e=c[d>>2]|0}while((e|0)!=64);d=a+592|0;e=c[d>>2]|0;if((e|0)!=64)do{h=t;l=45728+(e<<3)|0;f=45216+(e<<3)|0;f=(ba(c[l+4>>2]&c[h+4>>2],c[f+4>>2]|0)|0)^(ba(c[l>>2]&c[h>>2],c[f>>2]|0)|0);f=(c[43680+(e<<2)>>2]|0)+(f>>>(c[46240+(e<<2)>>2]|0)<<3)|0;h=c[f>>2]&v;f=c[f+4>>2]&w;if(!((h|0)==0&(f|0)==0)){i=e<<6;g=b;while(1){l=_c(h,f)|0;b=iv(h|0,f|0,-1,-1)|0;h=b&h;f=F&f;b=g+8|0;c[g>>2]=l|i;if((h|0)==0&(f|0)==0)break;else g=b}}d=d+4|0;e=c[d>>2]|0}while((e|0)!=64);d=a+656|0;e=c[d>>2]|0;if((e|0)!=64)do{h=t;l=44448+(e<<3)|0;f=43936+(e<<3)|0;f=(ba(c[l+4>>2]&c[h+4>>2],c[f+4>>2]|0)|0)^(ba(c[l>>2]&c[h>>2],c[f>>2]|0)|0);f=(c[43424+(e<<2)>>2]|0)+(f>>>(c[44960+(e<<2)>>2]|0)<<3)|0;h=c[f>>2]&v;f=c[f+4>>2]&w;if(!((h|0)==0&(f|0)==0)){i=e<<6;g=b;while(1){l=_c(h,f)|0;b=iv(h|0,f|0,-1,-1)|0;h=b&h;f=F&f;b=g+8|0;c[g>>2]=l|i;if((h|0)==0&(f|0)==0)break;else g=b}}d=d+4|0;e=c[d>>2]|0}while((e|0)!=64);e=a+720|0;d=c[e>>2]|0;if((d|0)==64){l=b;return l|0}do{j=t;f=c[j>>2]|0;j=c[j+4>>2]|0;k=44448+(d<<3)|0;h=43936+(d<<3)|0;h=(ba(c[k+4>>2]&j,c[h+4>>2]|0)|0)^(ba(c[k>>2]&f,c[h>>2]|0)|0);h=(c[43424+(d<<2)>>2]|0)+(h>>>(c[44960+(d<<2)>>2]|0)<<3)|0;k=45728+(d<<3)|0;l=45216+(d<<3)|0;l=(ba(c[k+4>>2]&j,c[l+4>>2]|0)|0)^(ba(c[k>>2]&f,c[l>>2]|0)|0);l=(c[43680+(d<<2)>>2]|0)+(l>>>(c[46240+(d<<2)>>2]|0)<<3)|0;f=(c[l>>2]|c[h>>2])&v;h=(c[l+4>>2]|c[h+4>>2])&w;if(!((f|0)==0&(h|0)==0)){i=d<<6;g=f;d=h;while(1){l=_c(g,d)|0;f=iv(g|0,d|0,-1,-1)|0;g=f&g;d=F&d;f=b+8|0;c[b>>2]=l|i;if((g|0)==0&(d|0)==0){b=f;break}else b=f}}e=e+4|0;d=c[e>>2]|0}while((d|0)!=64);return b|0}else{r=a+328|0;l=m;o=c[l>>2]&c[r>>2];r=c[l+4>>2]&c[r+4>>2];l=o&65280;s=o&-65281;q=a+320|0;p=c[q>>2]&v;q=c[q+4>>2]&w;t=a+256|0;n=t;m=~c[n>>2];n=~c[n+4>>2];i=jv(s|0,r|0,8)|0;i=i&m;h=F&n;jv(i|0,h|0,8)|0;i=i&v;h=h&w;j=w&255&n&F;if(!((i|0)==0&(h|0)==0)){k=b;while(1){e=_c(i,h)|0;b=iv(i|0,h|0,-1,-1)|0;i=b&i;h=F&h;b=k+8|0;c[k>>2]=(e<<6)+512|e;if((i|0)==0&(h|0)==0)break;else k=b}}if(!(0==0&(j|0)==0)){i=b;h=0;while(1){k=_c(h,j)|0;b=iv(h|0,j|0,-1,-1)|0;h=b&h;j=F&j;b=i+8|0;c[i>>2]=(k<<6)+1024|k;if((h|0)==0&(j|0)==0)break;else i=b}}if(!((l|0)==0&0==0|(v&255|0)==0&0==0)){d=jv(l|0,0,9)|0;d=d&p;e=F&q;h=jv(l|0,0,7)|0;h=p&254&h;i=jv(l|0,0,8)|0;i=v&m&i;j=w&n&F;if(!((d|0)==0&(e|0)==0)){k=b;while(1){l=_c(d,e)|0;b=iv(d|0,e|0,-1,-1)|0;d=b&d;e=F&e;l=(l<<6)+576|l;c[k>>2]=l|28672;c[k+8>>2]=l|24576;c[k+16>>2]=l|20480;b=k+32|0;c[k+24>>2]=l|16384;if((d|0)==0&(e|0)==0)break;else k=b}}if(!((h|0)==0&0==0)){d=b;e=0;while(1){l=_c(h,e)|0;b=iv(h|0,e|0,-1,-1)|0;h=b&h;e=F&e;l=(l<<6)+448|l;c[d>>2]=l|28672;c[d+8>>2]=l|24576;c[d+16>>2]=l|20480;b=d+32|0;c[d+24>>2]=l|16384;if((h|0)==0&(e|0)==0)break;else d=b}}if(!((i|0)==0&(j|0)==0)){h=b;while(1){l=_c(i,j)|0;b=iv(i|0,j|0,-1,-1)|0;i=b&i;j=F&j;l=(l<<6)+512|l;c[h>>2]=l|28672;c[h+8>>2]=l|24576;c[h+16>>2]=l|20480;b=h+32|0;c[h+24>>2]=l|16384;if((i|0)==0&(j|0)==0)break;else h=b}}}e=jv(o|0,r|0,9)|0;e=e&2139062016&p;j=F&8355711&q;h=jv(o|0,r|0,7)|0;h=h&-16843264&p;i=F&16711422&q;if(!((e|0)==0&(j|0)==0)){d=b;while(1){l=_c(e,j)|0;b=iv(e|0,j|0,-1,-1)|0;e=b&e;j=F&j;b=d+8|0;c[d>>2]=(l<<6)+576|l;if((e|0)==0&(j|0)==0)break;else d=b}}if(!((h|0)==0&(i|0)==0)){e=b;while(1){l=_c(h,i)|0;b=iv(h|0,i|0,-1,-1)|0;h=b&h;i=F&i;b=e+8|0;c[e>>2]=(l<<6)+448|l;if((h|0)==0&(i|0)==0)break;else e=b}}h=c[(c[u>>2]|0)+40>>2]|0;if(((h|0)!=64?(l=46496+(h+8<<3)|0,!((c[l>>2]&v|0)==0?(c[l+4>>2]&w|0)==0:0)):0)?(f=47840+(h<<3)|0,g=c[f>>2]&s,f=c[f+4>>2]&r,!((g|0)==0&(f|0)==0)):0){e=b;while(1){l=_c(g,f)|0;b=iv(g|0,f|0,-1,-1)|0;g=b&g;f=F&f;b=e+8|0;c[e>>2]=l<<6|c[(c[u>>2]|0)+40>>2]|32768;if((g|0)==0&(f|0)==0)break;else e=b}}f=a+1040|0;e=c[f>>2]|0;if((e|0)!=64)do{g=48352+(e<<3)|0;h=c[g>>2]&v;g=c[g+4>>2]&w;if(!((h|0)==0&(g|0)==0)){i=e<<6;e=b;while(1){l=_c(h,g)|0;b=iv(h|0,g|0,-1,-1)|0;h=b&h;g=F&g;b=e+8|0;c[e>>2]=l|i;if((h|0)==0&(g|0)==0)break;else e=b}}f=f+4|0;e=c[f>>2]|0}while((e|0)!=64);f=a+1104|0;e=c[f>>2]|0;if((e|0)!=64)do{h=t;l=45728+(e<<3)|0;g=45216+(e<<3)|0;g=(ba(c[l+4>>2]&c[h+4>>2],c[g+4>>2]|0)|0)^(ba(c[l>>2]&c[h>>2],c[g>>2]|0)|0);g=(c[43680+(e<<2)>>2]|0)+(g>>>(c[46240+(e<<2)>>2]|0)<<3)|0;h=c[g>>2]&v;g=c[g+4>>2]&w;if(!((h|0)==0&(g|0)==0)){i=e<<6;e=b;while(1){l=_c(h,g)|0;b=iv(h|0,g|0,-1,-1)|0;h=b&h;g=F&g;b=e+8|0;c[e>>2]=l|i;if((h|0)==0&(g|0)==0)break;else e=b}}f=f+4|0;e=c[f>>2]|0}while((e|0)!=64);f=a+1168|0;e=c[f>>2]|0;if((e|0)!=64)do{g=t;l=44448+(e<<3)|0;d=43936+(e<<3)|0;d=(ba(c[l+4>>2]&c[g+4>>2],c[d+4>>2]|0)|0)^(ba(c[l>>2]&c[g>>2],c[d>>2]|0)|0);d=(c[43424+(e<<2)>>2]|0)+(d>>>(c[44960+(e<<2)>>2]|0)<<3)|0;g=c[d>>2]&v;d=c[d+4>>2]&w;if(!((g|0)==0&(d|0)==0)){i=e<<6;h=b;e=d;while(1){l=_c(g,e)|0;b=iv(g|0,e|0,-1,-1)|0;g=b&g;e=F&e;b=h+8|0;c[h>>2]=l|i;if((g|0)==0&(e|0)==0)break;else h=b}}f=f+4|0;e=c[f>>2]|0}while((e|0)!=64);e=a+1232|0;d=c[e>>2]|0;if((d|0)==64){l=b;return l|0}do{j=t;f=c[j>>2]|0;j=c[j+4>>2]|0;k=44448+(d<<3)|0;h=43936+(d<<3)|0;h=(ba(c[k+4>>2]&j,c[h+4>>2]|0)|0)^(ba(c[k>>2]&f,c[h>>2]|0)|0);h=(c[43424+(d<<2)>>2]|0)+(h>>>(c[44960+(d<<2)>>2]|0)<<3)|0;k=45728+(d<<3)|0;l=45216+(d<<3)|0;l=(ba(c[k+4>>2]&j,c[l+4>>2]|0)|0)^(ba(c[k>>2]&f,c[l>>2]|0)|0);l=(c[43680+(d<<2)>>2]|0)+(l>>>(c[46240+(d<<2)>>2]|0)<<3)|0;f=(c[l>>2]|c[h>>2])&v;h=(c[l+4>>2]|c[h+4>>2])&w;if(!((f|0)==0&(h|0)==0)){i=d<<6;g=b;d=h;while(1){l=_c(f,d)|0;b=iv(f|0,d|0,-1,-1)|0;f=b&f;d=F&d;b=g+8|0;c[g>>2]=l|i;if((f|0)==0&(d|0)==0)break;else g=b}}e=e+4|0;d=c[e>>2]|0}while((d|0)!=64);return b|0}return 0}
function rc(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+15&-16;return b|0}function sc(){return i|0}function tc(a){a=a|0;i=a}function uc(a,b){a=a|0;b=b|0;if(!q){q=a;r=b}}function vc(b){b=b|0;a[k>>0]=a[b>>0];a[k+1>>0]=a[b+1>>0];a[k+2>>0]=a[b+2>>0];a[k+3>>0]=a[b+3>>0]}function wc(b){b=b|0;a[k>>0]=a[b>>0];a[k+1>>0]=a[b+1>>0];a[k+2>>0]=a[b+2>>0];a[k+3>>0]=a[b+3>>0];a[k+4>>0]=a[b+4>>0];a[k+5>>0]=a[b+5>>0];a[k+6>>0]=a[b+6>>0];a[k+7>>0]=a[b+7>>0]}function xc(a){a=a|0;F=a}function yc(){return F|0}function zc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=i;i=i+2464|0;t=E+2448|0;D=E+2432|0;C=E+2232|0;B=E+2420|0;z=E+2408|0;y=E+2396|0;w=E+2384|0;v=E+2372|0;x=E+2360|0;h=E+2348|0;g=E+2336|0;e=E+2324|0;o=E+2312|0;u=E;s=E+2308|0;r=E+2296|0;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;f=C+56|0;k=f;c[k>>2]=0;c[k+4>>2]=0;k=C+0|0;j=k+52|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(j|0));c[B>>2]=0;A=B+4|0;c[A>>2]=0;l=B+8|0;c[l>>2]=0;j=Ac(d,D)|0;if(!(c[j+((c[(c[j>>2]|0)+-12>>2]|0)+16)>>2]&5))wi(z,D);else vi(z,8,2);j=Ac(d,D)|0;if(!(c[j+((c[(c[j>>2]|0)+-12>>2]|0)+16)>>2]&5))wi(y,D);else vi(y,16,1);j=Ac(d,D)|0;if(!(c[j+((c[(c[j>>2]|0)+-12>>2]|0)+16)>>2]&5))wi(w,D);else vi(w,24,2);j=Ac(d,D)|0;if(!(c[j+((c[(c[j>>2]|0)+-12>>2]|0)+16)>>2]&5))wi(v,D);else vi(v,32,7);j=Ac(d,D)|0;if(!(c[j+((c[(c[j>>2]|0)+-12>>2]|0)+16)>>2]&5))wi(x,D);else vi(x,1072672,5);vi(h,1073056,4);ai(Bc(1072800,h)|0,z)|0;Bi(h);vi(g,1073048,7);ai(Bc(1072800,g)|0,y)|0;Bi(g);Eh(1069912);do if(Ti(x,40)|0){if(!(Ti(x,1072680)|0)){if(!(a[w>>0]&1))k=w+1|0;else k=c[w+8>>2]|0;g=Xu(k)|0;c[f>>2]=g;c[f+4>>2]=((g|0)<0)<<31>>31;break}j=(Ti(x,1072704)|0)==0;if(!(a[w>>0]&1))k=w+1|0;else k=c[w+8>>2]|0;k=Xu(k)|0;if(j){c[C+40>>2]=k;break}else{c[C+32>>2]=k;break}}else{if(!(a[w>>0]&1))g=w+1|0;else g=c[w+8>>2]|0;c[C+36>>2]=Xu(g)|0}while(0);do if(!(Ti(v,32)|0)){Cc(B,48,196|0);m=68}else{if(!(Ti(v,200)|0)){Vf(e,b);g=c[A>>2]|0;if((g|0)==(c[l>>2]|0))Vc(B,e);else{if(!g)g=0;else{wi(g,e);g=c[A>>2]|0}c[A>>2]=g+12}Bi(e);m=68;break};c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;if(!(a[v>>0]&1))g=v+1|0;else g=c[v+8>>2]|0;j=u+108|0;d=u+8|0;c[u>>2]=420;c[j>>2]=440;c[u+4>>2]=0;ij(u+108|0,d);c[u+180>>2]=0;c[u+184>>2]=-1;c[u>>2]=364;c[j>>2]=384;Hc(d);j=u+72|0;if((c[j>>2]|0)==0?(b=ib(g|0,448)|0,c[j>>2]=b,(b|0)!=0):0)c[u+96>>2]=8;else m=47;if((m|0)==47?(b=c[(c[u>>2]|0)+-12>>2]|0,dj(u+b|0,c[u+(b+16)>>2]|4),(c[j>>2]|0)==0):0){f=Ec(1073504,208,20)|0;g=a[v>>0]|0;if(!(g&1)){e=v+1|0;g=(g&255)>>>1}else{e=c[v+8>>2]|0;g=c[v+4>>2]|0}s=Ec(f,e,g)|0;hj(t,s+(c[(c[s>>2]|0)+-12>>2]|0)|0);r=Zo(t,1077904)|0;r=oc[c[(c[r>>2]|0)+28>>2]&63](r,10)|0;Wo(t);rk(s,r)|0;Wj(s)|0;Xc(u,392);fj(u+108|0);Bi(o);break}k=o+4|0;while(1){hj(t,u+(c[(c[u>>2]|0)+-12>>2]|0)|0);b=Zo(t,1077904)|0;b=oc[c[(c[b>>2]|0)+28>>2]&63](b,10)|0;Wo(t);b=Gc(u,o,b)|0;if(c[b+((c[(c[b>>2]|0)+-12>>2]|0)+16)>>2]&5)break;g=a[o>>0]|0;if(!(g&1))g=(g&255)>>>1;else g=c[k>>2]|0;if(!g)continue;g=c[A>>2]|0;if((g|0)==(c[l>>2]|0)){Vc(B,o);continue}if(!g)g=0;else{wi(g,o);g=c[A>>2]|0}c[A>>2]=g+12}g=c[j>>2]|0;if(!(((g|0)!=0?(n=fc[c[(c[d>>2]|0)+24>>2]&127](d)|0,(vb(g|0)|0)==0):0)?(c[j>>2]=0,(n|0)==0):0)){b=c[(c[u>>2]|0)+-12>>2]|0;dj(u+b|0,c[u+(b+16)>>2]|4)}Xc(u,392);fj(u+108|0);Bi(o);m=68}while(0);if((m|0)==68){c[s>>2]=0;Tb(t|0,0)|0;f=c[t>>2]|0;e=((f|0)<0)<<31>>31;m=(c[t+4>>2]|0)/1e3|0;n=((m|0)<0)<<31>>31;g=c[B>>2]|0;a:do if((c[A>>2]|0)==(g|0)){p=0;q=0}else{b=C+32|0;k=0;d=0;l=0;while(1){vi(r,1073224,12);j=(Th(Bc(1072800,r)|0)|0)!=0;h=c[267456]|0;if((c[267457]|0)==(h|0))break;Zf(u,g+(l*12|0)|0,j,c[h>>2]|0);Bi(r);l=l+1|0;o=nk(Ec(1073504,232,11)|0,l)|0;a[t>>0]=47;o=Ec(o,t,1)|0;o=nk(o,((c[A>>2]|0)-(c[B>>2]|0)|0)/12|0)|0;hj(t,o+(c[(c[o>>2]|0)+-12>>2]|0)|0);g=Zo(t,1077904)|0;g=oc[c[(c[g>>2]|0)+28>>2]&63](g,10)|0;Wo(t);rk(o,g)|0;Wj(o)|0;if(!(Ti(x,1072400)|0)){j=Cg(u,c[b>>2]|0)|0;h=F}else{yh(1069824,u,C,s);h=1020232|0;j=c[h>>2]|0;h=c[h+4>>2]|0}k=iv(j|0,h|0,k|0,d|0)|0;j=F;g=c[B>>2]|0;if(l>>>0>=(((c[A>>2]|0)-g|0)/12|0)>>>0){p=k;q=j;break a}else d=j}Ko(1069824)}while(0);Tb(t|0,0)|0;o=c[t>>2]|0;o=uv(o|0,((o|0)<0)<<31>>31|0,1e3,0)|0;u=F;r=(c[t+4>>2]|0)/1e3|0;b=uv(f|0,e|0,-1e3,-1)|0;m=hv(b|1|0,F|0,m|0,n|0)|0;m=iv(m|0,F|0,o|0,u|0)|0;r=iv(m|0,F|0,r|0,((r|0)<0)<<31>>31|0)|0;m=F;df();u=Ec(pk(Ec(ok(Ec(Ec(1073504,248,28)|0,280,19)|0,r,m)|0,304,19)|0,p,q)|0,328,19)|0;q=uv(p|0,q|0,1e3,0)|0;m=vv(q|0,F|0,r|0,m|0)|0;m=pk(u,m,F)|0;hj(t,m+(c[(c[m>>2]|0)+-12>>2]|0)|0);u=Zo(t,1077904)|0;u=oc[c[(c[u>>2]|0)+28>>2]&63](u,10)|0;Wo(t);rk(m,u)|0;Wj(m)|0;m=c[s>>2]|0;if(m){l=m+4|0;f=c[l>>2]|0;d=m+16|0;g=c[d>>2]|0;e=f+(((g>>>0)/56|0)<<2)|0;b=m+8|0;h=c[b>>2]|0;if((h|0)==(f|0)){j=0;k=m+20|0;g=0}else{k=m+20|0;j=(c[k>>2]|0)+g|0;j=(c[f+(((j>>>0)/56|0)<<2)>>2]|0)+(((j>>>0)%56|0)*72|0)|0;g=(c[e>>2]|0)+(((g>>>0)%56|0)*72|0)|0}b:while(1){do{if((g|0)==(j|0))break b;g=g+72|0}while((g-(c[e>>2]|0)|0)!=4032);u=e+4|0;g=c[u>>2]|0;e=u}c[k>>2]=0;g=h-f>>2;if(g>>>0>2)do{xt(c[f>>2]|0);f=(c[l>>2]|0)+4|0;c[l>>2]=f;g=(c[b>>2]|0)-f>>2}while(g>>>0>2);if((g|0)==1)c[d>>2]=28;else if((g|0)==2)c[d>>2]=56;g=c[l>>2]|0;f=c[b>>2]|0;if((g|0)!=(f|0)){do{xt(c[g>>2]|0);g=g+4|0}while((g|0)!=(f|0));g=c[l>>2]|0;f=c[b>>2]|0;if((f|0)!=(g|0))c[b>>2]=f+(~((f+-4-g|0)>>>2)<<2)}g=c[m>>2]|0;if(g)xt(g);xt(m)}}Bi(x);Bi(v);Bi(w);Bi(y);Bi(z);e=c[B>>2]|0;if(e){g=c[A>>2]|0;if((g|0)!=(e|0)){do{y=g+-12|0;c[A>>2]=y;Bi(y);g=c[A>>2]|0}while((g|0)!=(e|0));e=c[B>>2]|0}xt(e)}g=c[C>>2]|0;if(!g){Bi(D);i=E;return}e=C+4|0;f=c[e>>2]|0;if((f|0)!=(g|0))c[e>>2]=f+(~((f+-4-g|0)>>>2)<<2);xt(g);Bi(D);i=E;return}function Ac(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;g=n+4|0;h=n;Xj(g,e,0);if(!(a[g>>0]|0)){g=c[(c[e>>2]|0)+-12>>2]|0;dj(e+g|0,c[e+(g+16)>>2]|4);i=n;return e|0}if(!(a[f>>0]&1)){a[f+1>>0]=0;a[f>>0]=0}else{a[c[f+8>>2]>>0]=0;c[f+4>>2]=0}g=c[(c[e>>2]|0)+-12>>2]|0;m=c[e+(g+12)>>2]|0;m=(m|0)<1?2147483647:m;hj(h,e+g|0);g=Zo(h,1077904)|0;Wo(h);a:do if((m|0)>0){l=g+8|0;g=0;while(1){h=c[e+((c[(c[e>>2]|0)+-12>>2]|0)+24)>>2]|0;j=c[h+12>>2]|0;if((j|0)==(c[h+16>>2]|0)){h=fc[c[(c[h>>2]|0)+36>>2]&127](h)|0;if((h|0)==-1){h=2;break a}}else h=d[j>>0]|0;j=h&255;if(j<<24>>24>-1?(b[(c[l>>2]|0)+(h<<24>>24<<1)>>1]&8192)!=0:0){h=0;break a}Ki(f,j);g=g+1|0;j=c[e+((c[(c[e>>2]|0)+-12>>2]|0)+24)>>2]|0;h=j+12|0;k=c[h>>2]|0;if((k|0)==(c[j+16>>2]|0))fc[c[(c[j>>2]|0)+40>>2]&127](j)|0;else c[h>>2]=k+1;if((g|0)>=(m|0)){h=0;break}}}else{g=0;h=0}while(0);c[e+((c[(c[e>>2]|0)+-12>>2]|0)+12)>>2]=0;j=c[(c[e>>2]|0)+-12>>2]|0;dj(e+j|0,c[e+(j+16)>>2]|((g|0)==0?h|4:h));i=n;return e|0}function Bc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;k=i;i=i+16|0;h=k;j=a+4|0;d=c[j>>2]|0;do if(d){g=a+8|0;while(1){e=d+16|0;if(Xh(g,b,e)|0){e=c[d>>2]|0;if(!e){e=d;f=5;break}else{d=e;continue}}if(!(Xh(g,e,b)|0)){f=9;break}e=d+4|0;f=c[e>>2]|0;if(!f){f=8;break}else d=f}if((f|0)==5){c[h>>2]=d;g=e;break}else if((f|0)==8){c[h>>2]=d;g=e;break}else if((f|0)==9){c[h>>2]=d;g=h;break}}else{d=a+4|0;c[h>>2]=d;g=d}while(0);e=c[g>>2]|0;if(e){d=e;d=d+28|0;i=k;return d|0}f=ut(80)|0;wi(f+16|0,b);_h(f+28|0,0);c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=d;c[g>>2]=f;d=c[c[a>>2]>>2]|0;if(!d)d=f;else{c[a>>2]=d;d=c[g>>2]|0}Wc(c[j>>2]|0,d);d=a+8|0;c[d>>2]=(c[d>>2]|0)+1;d=f;d=d+28|0;i=k;return d|0}function Cc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=b;h=d-f>>2;j=a+8|0;e=c[j>>2]|0;k=c[a>>2]|0;g=k;if(h>>>0>((e-g|0)/12|0)>>>0){if(k){g=a+4|0;f=c[g>>2]|0;if((f|0)==(k|0))e=k;else{do{e=f+-12|0;c[g>>2]=e;Bi(e);f=c[g>>2]|0}while((f|0)!=(k|0));e=c[a>>2]|0}xt(e);c[j>>2]=0;c[g>>2]=0;c[a>>2]=0;e=0}if(h>>>0>357913941)Jo(a);e=(e-0|0)/12|0;if(e>>>0<178956970){e=e<<1;e=e>>>0<h>>>0?h:e;if(e>>>0>357913941)Jo(a);else i=e}else i=357913941;e=ut(i*12|0)|0;f=a+4|0;c[f>>2]=e;c[a>>2]=e;c[j>>2]=e+(i*12|0);if((b|0)==(d|0))return;do{g=c[b>>2]|0;vi(e,g,lv(g|0)|0);e=(c[f>>2]|0)+12|0;c[f>>2]=e;b=b+4|0}while((b|0)!=(d|0));return}i=a+4|0;e=((c[i>>2]|0)-g|0)/12|0;if(h>>>0>e>>>0){h=1;g=b+(e<<2)|0}else{h=0;g=d}if((g|0)==(b|0))b=k;else{f=g+-4-f|0;e=k;while(1){Di(e,c[b>>2]|0)|0;b=b+4|0;if((b|0)==(g|0))break;else e=e+12|0}b=k+(((f>>>2)+1|0)*12|0)|0}if(!h){e=c[i>>2]|0;if((e|0)==(b|0))return;do{f=e+-12|0;c[i>>2]=f;Bi(f);e=c[i>>2]|0}while((e|0)!=(b|0));return}if((g|0)==(d|0))return;b=g;e=c[i>>2]|0;do{if(!e)e=0;else{f=c[b>>2]|0;vi(e,f,lv(f|0)|0);e=c[i>>2]|0}e=e+12|0;c[i>>2]=e;b=b+4|0}while((b|0)!=(d|0));return}function Dc(a){a=a|0;Xc(a,392);fj(a+108|0);return}function Ec(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+32|0;k=o+16|0;n=o+8|0;l=o+4|0;m=o;jk(n,b);if(!(a[n>>0]|0)){lk(n);i=o;return b|0}f=c[(c[b>>2]|0)+-12>>2]|0;c[l>>2]=c[b+(f+24)>>2];h=d+e|0;g=(c[b+(f+4)>>2]&176|0)==32?h:d;j=b+f|0;f=b+(f+76)|0;e=c[f>>2]|0;if((e|0)==-1){hj(k,j);e=Zo(k,1077904)|0;e=oc[c[(c[e>>2]|0)+28>>2]&63](e,32)|0;Wo(k);e=e<<24>>24;c[f>>2]=e}c[k+0>>2]=c[l+0>>2];Fc(m,k,d,g,h,j,e&255);if(c[m>>2]|0){lk(n);i=o;return b|0}m=c[(c[b>>2]|0)+-12>>2]|0;dj(b+m|0,c[b+(m+16)>>2]|5);lk(n);i=o;return b|0}function Fc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;p=i;i=i+16|0;n=p;o=c[d>>2]|0;if(!o){c[b>>2]=0;i=p;return}q=e;l=g-q|0;m=h+12|0;k=c[m>>2]|0;l=(k|0)>(l|0)?k-l|0:0;k=f;h=k-q|0;if((h|0)>0?($b[c[(c[o>>2]|0)+48>>2]&31](o,e,h)|0)!=(h|0):0){c[d>>2]=0;c[b>>2]=0;i=p;return}do if((l|0)>0){xi(n,l,j);if(!(a[n>>0]&1))h=n+1|0;else h=c[n+8>>2]|0;if(($b[c[(c[o>>2]|0)+48>>2]&31](o,h,l)|0)==(l|0)){Bi(n);break}c[d>>2]=0;c[b>>2]=0;Bi(n);i=p;return}while(0);g=g-k|0;if((g|0)>0?($b[c[(c[o>>2]|0)+48>>2]&31](o,f,g)|0)!=(g|0):0){c[d>>2]=0;c[b>>2]=0;i=p;return}c[m>>2]=0;c[b>>2]=o;i=p;return}function Gc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;m=i;i=i+16|0;g=m;Xj(g,b,1);if(!(a[g>>0]|0)){i=m;return b|0}if(!(a[e>>0]&1)){a[e+1>>0]=0;a[e>>0]=0;l=e+4|0}else{a[c[e+8>>2]>>0]=0;l=e+4|0;c[l>>2]=0}g=0;while(1){h=c[b+((c[(c[b>>2]|0)+-12>>2]|0)+24)>>2]|0;j=h+12|0;k=c[j>>2]|0;if((k|0)==(c[h+16>>2]|0)){h=fc[c[(c[h>>2]|0)+40>>2]&127](h)|0;if((h|0)==-1){h=2;break}}else{c[j>>2]=k+1;h=d[k>>0]|0}g=g+1|0;h=h&255;if(h<<24>>24==f<<24>>24){h=0;break}Ki(e,h);if(!(a[e>>0]&1))continue;if((c[l>>2]|0)==-17){h=4;break}}j=c[(c[b>>2]|0)+-12>>2]|0;dj(b+j|0,c[b+(j+16)>>2]|((g|0)==0?h|4:h));i=m;return b|0}function Hc(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;l=i;i=i+16|0;e=l+4|0;f=l;nj(d);c[d>>2]=464;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;g=d+52|0;h=d+68|0;j=d+4|0;k=g+0|0;m=k+44|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(m|0));b[g+44>>1]=0;a[g+46>>0]=0;Vo(e,j);g=Xo(e,1077968)|0;Wo(e);if(!g){e=c[d>>2]|0;e=e+12|0;e=c[e>>2]|0;$b[e&31](d,0,4096)|0;i=l;return}Vo(f,j);c[h>>2]=Zo(f,1077968)|0;Wo(f);e=c[h>>2]|0;a[d+98>>0]=(fc[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;e=c[d>>2]|0;e=e+12|0;e=c[e>>2]|0;$b[e&31](d,0,4096)|0;i=l;return}function Ic(a){a=a|0;Xc(a,392);fj(a+108|0);xt(a);return}function Jc(a){a=a|0;var b=0;b=c[(c[a>>2]|0)+-12>>2]|0;Xc(a+b|0,392);fj(a+(b+108)|0);return}function Kc(a){a=a|0;var b=0,d=0;d=c[(c[a>>2]|0)+-12>>2]|0;b=a+d|0;Xc(b,392);fj(a+(d+108)|0);xt(b);return}function Lc(b){b=b|0;var d=0,e=0,f=0,g=0;c[b>>2]=464;d=b+64|0;e=c[d>>2]|0;if((e|0)!=0?(Rc(b)|0,(vb(e|0)|0)==0):0)c[d>>2]=0;if((a[b+96>>0]|0)!=0?(g=c[b+32>>2]|0,(g|0)!=0):0)yt(g);if((a[b+97>>0]|0)!=0?(f=c[b+56>>2]|0,(f|0)!=0):0)yt(f);kj(b);return}function Mc(b){b=b|0;var d=0,e=0,f=0,g=0;c[b>>2]=464;d=b+64|0;e=c[d>>2]|0;if((e|0)!=0?(Rc(b)|0,(vb(e|0)|0)==0):0)c[d>>2]=0;if((a[b+96>>0]|0)!=0?(g=c[b+32>>2]|0,(g|0)!=0):0)yt(g);if((a[b+97>>0]|0)!=0?(f=c[b+56>>2]|0,(f|0)!=0):0)yt(f);kj(b);xt(b);return}function Nc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;fc[c[(c[b>>2]|0)+24>>2]&127](b)|0;d=Zo(d,1077968)|0;c[b+68>>2]=d;f=b+98|0;e=a[f>>0]|0;d=fc[c[(c[d>>2]|0)+28>>2]&127](d)|0;a[f>>0]=d&1;if((e&255|0)==(d&1|0))return;f=b+8|0;e=b+96|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;f=(a[e>>0]|0)!=0;if(d){d=b+32|0;if(f?(i=c[d>>2]|0,(i|0)!=0):0)yt(i);f=b+97|0;a[e>>0]=a[f>>0]|0;g=b+60|0;c[b+52>>2]=c[g>>2];e=b+56|0;c[d>>2]=c[e>>2];c[g>>2]=0;c[e>>2]=0;a[f>>0]=0;return}if(!f?(g=b+32|0,h=c[g>>2]|0,(h|0)!=(b+44|0)):0){d=c[b+52>>2]|0;c[b+60>>2]=d;c[b+56>>2]=h;a[b+97>>0]=0;c[g>>2]=wt(d)|0;a[e>>0]=1;return}d=c[b+52>>2]|0;c[b+60>>2]=d;c[b+56>>2]=wt(d)|0;a[b+97>>0]=1;return}function Oc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;i=b+8|0;h=b+96|0;c[i+0>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;c[i+12>>2]=0;c[i+16>>2]=0;c[i+20>>2]=0;if((a[h>>0]|0)!=0?(f=c[b+32>>2]|0,(f|0)!=0):0)yt(f);i=b+97|0;if((a[i>>0]|0)!=0?(g=c[b+56>>2]|0,(g|0)!=0):0)yt(g);f=b+52|0;c[f>>2]=e;do if(e>>>0>8){f=a[b+98>>0]|0;if(f<<24>>24!=0&(d|0)!=0){c[b+32>>2]=d;a[h>>0]=0;break}else{c[b+32>>2]=wt(e)|0;a[h>>0]=1;break}}else{c[b+32>>2]=b+44;c[f>>2]=8;a[h>>0]=0;f=a[b+98>>0]|0}while(0);if(f<<24>>24){c[b+60>>2]=0;c[b+56>>2]=0;a[i>>0]=0;return b|0}f=(e|0)<8?8:e;c[b+60>>2]=f;if((d|0)!=0&f>>>0>7){c[b+56>>2]=d;a[i>>0]=0;return b|0}else{c[b+56>>2]=wt(f)|0;a[i>>0]=1;return b|0}return 0}function Pc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;g=c[b+68>>2]|0;g=fc[c[(c[g>>2]|0)+24>>2]&127](g)|0;i=b+64|0;if(((c[i>>2]|0)!=0?!((g|0)<1&((d|0)!=0|(e|0)!=0)):0)?(fc[c[(c[b>>2]|0)+24>>2]&127](b)|0)==0:0){if(f>>>0>=3){g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}h=c[i>>2]|0;if((g|0)>0)g=uv(g|0,((g|0)<0)<<31>>31|0,d|0,e|0)|0;else g=0;if(!(mb(h|0,g|0,f|0)|0)){d=Gb(c[i>>2]|0)|0;h=b+72|0;e=c[h+4>>2]|0;g=a;c[g>>2]=c[h>>2];c[g+4>>2]=e;g=a+8|0;c[g>>2]=d;c[g+4>>2]=((d|0)<0)<<31>>31;return}else{g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}}g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function Qc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=b+64|0;if((c[e>>2]|0)!=0?(fc[c[(c[b>>2]|0)+24>>2]&127](b)|0)==0:0)if(!(mb(c[e>>2]|0,c[d+8>>2]|0,0)|0)){g=d;f=c[g+4>>2]|0;e=b+72|0;c[e>>2]=c[g>>2];c[e+4>>2]=f;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}else{e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;return}e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;return}function Rc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;j=n+8|0;l=n;m=b+64|0;if(!(c[m>>2]|0)){m=0;i=n;return m|0}k=b+92|0;e=c[k>>2]|0;do if(!(e&16)){if(e&8){g=b+80|0;h=c[g+4>>2]|0;j=l;c[j>>2]=c[g>>2];c[j+4>>2]=h;do if(!(a[b+98>>0]|0)){g=b+68|0;h=c[g>>2]|0;h=fc[c[(c[h>>2]|0)+24>>2]&127](h)|0;f=b+36|0;d=c[f>>2]|0;e=(c[b+40>>2]|0)-d|0;if((h|0)>0){e=(ba((c[b+16>>2]|0)-(c[b+12>>2]|0)|0,h)|0)+e|0;d=0;break}h=c[b+12>>2]|0;if((h|0)==(c[b+16>>2]|0))d=0;else{g=c[g>>2]|0;j=b+32|0;d=pc[c[(c[g>>2]|0)+32>>2]&15](g,l,c[j>>2]|0,d,h-(c[b+8>>2]|0)|0)|0;e=e-d+(c[f>>2]|0)-(c[j>>2]|0)|0;d=1}}else{e=(c[b+16>>2]|0)-(c[b+12>>2]|0)|0;d=0}while(0);if(mb(c[m>>2]|0,0-e|0,1)|0){m=-1;i=n;return m|0}if(d){j=l;l=c[j+4>>2]|0;m=b+72|0;c[m>>2]=c[j>>2];c[m+4>>2]=l}m=c[b+32>>2]|0;c[b+40>>2]=m;c[b+36>>2]=m;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[k>>2]=0}}else{if((c[b+24>>2]|0)!=(c[b+20>>2]|0)?(oc[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1:0){m=-1;i=n;return m|0}f=b+68|0;g=b+72|0;h=b+32|0;e=b+52|0;while(1){l=c[f>>2]|0;d=c[h>>2]|0;d=pc[c[(c[l>>2]|0)+20>>2]&15](l,g,d,d+(c[e>>2]|0)|0,j)|0;l=c[h>>2]|0;b=(c[j>>2]|0)-l|0;if((Pb(l|0,1,b|0,c[m>>2]|0)|0)!=(b|0)){d=-1;e=21;break}if((d|0)==2){d=-1;e=21;break}else if((d|0)!=1){e=8;break}}if((e|0)==8){if(!(Ra(c[m>>2]|0)|0))break;else d=-1;i=n;return d|0}else if((e|0)==21){i=n;return d|0}}while(0);m=0;i=n;return m|0}function Sc(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;t=i;i=i+16|0;s=t+4|0;p=t;o=b+64|0;if(!(c[o>>2]|0)){o=-1;i=t;return o|0}e=b+92|0;if(!(c[e>>2]&8)){c[b+24>>2]=0;c[b+20>>2]=0;c[b+28>>2]=0;if(!(a[b+98>>0]|0)){f=c[b+56>>2]|0;g=f+(c[b+60>>2]|0)|0}else{f=c[b+32>>2]|0;g=f+(c[b+52>>2]|0)|0}c[b+8>>2]=f;c[b+12>>2]=g;c[b+16>>2]=g;c[e>>2]=8;h=1;f=g}else{h=0;f=c[b+12>>2]|0}r=b+12|0;if(!f){e=s+1|0;c[b+8>>2]=s;c[r>>2]=e;c[b+16>>2]=e}else e=f;g=c[b+16>>2]|0;if(h)n=0;else{n=(g-(c[b+8>>2]|0)|0)/2|0;n=n>>>0>4?4:n}q=b+16|0;do if((e|0)==(g|0)){f=b+8|0;nv(c[f>>2]|0,e+(0-n)|0,n|0)|0;if(a[b+98>>0]|0){e=c[f>>2]|0;e=Fa(e+n|0,1,(c[q>>2]|0)-n-e|0,c[o>>2]|0)|0;if(!e){e=-1;break}m=c[f>>2]|0;o=m+n|0;c[r>>2]=o;c[q>>2]=m+(e+n);e=d[o>>0]|0;break}k=b+32|0;l=b+36|0;h=c[l>>2]|0;m=b+40|0;nv(c[k>>2]|0,h|0,(c[m>>2]|0)-h|0)|0;h=c[k>>2]|0;j=h+((c[m>>2]|0)-(c[l>>2]|0))|0;c[l>>2]=j;if((h|0)==(b+44|0))g=8;else g=c[b+52>>2]|0;u=h+g|0;c[m>>2]=u;g=b+60|0;h=(c[g>>2]|0)-n|0;u=u-j|0;e=b+72|0;x=e;w=c[x+4>>2]|0;v=b+80|0;c[v>>2]=c[x>>2];c[v+4>>2]=w;h=Fa(j|0,1,(u>>>0<h>>>0?u:h)|0,c[o>>2]|0)|0;if(h){j=(c[l>>2]|0)+h|0;c[m>>2]=j;h=c[b+68>>2]|0;o=c[f>>2]|0;if((kc[c[(c[h>>2]|0)+16>>2]&15](h,e,c[k>>2]|0,j,l,o+n|0,o+(c[g>>2]|0)|0,p)|0)==3){e=c[k>>2]|0;o=c[m>>2]|0;c[f>>2]=e;c[r>>2]=e;c[q>>2]=o;e=d[e>>0]|0;break}g=c[p>>2]|0;e=c[f>>2]|0;h=e+n|0;if((g|0)!=(h|0)){c[f>>2]=e;c[r>>2]=h;c[q>>2]=g;e=d[h>>0]|0}else e=-1}else e=-1}else{f=b+8|0;e=d[e>>0]|0}while(0);if((c[f>>2]|0)!=(s|0)){o=e;i=t;return o|0}c[f>>2]=0;c[r>>2]=0;c[q>>2]=0;o=e;i=t;return o|0}function Tc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if(!(c[b+64>>2]|0)){b=-1;return b|0}g=b+12|0;f=c[g>>2]|0;if((c[b+8>>2]|0)>>>0>=f>>>0){b=-1;return b|0}if((d|0)==-1){c[g>>2]=f+-1;b=0;return b|0}if(!(c[b+88>>2]&16)){e=d&255;b=f+-1|0;if(e<<24>>24!=(a[b>>0]|0)){b=-1;return b|0}}else{e=d&255;b=f+-1|0}c[g>>2]=b;a[b>>0]=e;b=d;return b|0}function Uc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=i;i=i+16|0;h=u+8|0;s=u+4|0;r=u;t=b+64|0;if(!(c[t>>2]|0)){n=-1;i=u;return n|0}f=b+92|0;if(!(c[f>>2]&16)){c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;e=c[b+52>>2]|0;do if(e>>>0>8)if(!(a[b+98>>0]|0)){e=c[b+56>>2]|0;g=e+((c[b+60>>2]|0)+-1)|0;c[b+24>>2]=e;c[b+20>>2]=e;c[b+28>>2]=g;break}else{n=c[b+32>>2]|0;g=n+(e+-1)|0;c[b+24>>2]=n;c[b+20>>2]=n;c[b+28>>2]=g;e=n;break}else{c[b+24>>2]=0;c[b+20>>2]=0;c[b+28>>2]=0;g=0;e=0}while(0);c[f>>2]=16;p=b+28|0;q=b+20|0;o=e}else{o=b+20|0;g=b+28|0;p=g;q=o;o=c[o>>2]|0;g=c[g>>2]|0}n=(d|0)==-1;e=b+24|0;f=c[e>>2]|0;if(n)h=o;else{if(!f){c[e>>2]=h;c[q>>2]=h;c[p>>2]=h+1;f=h}a[f>>0]=d;f=(c[e>>2]|0)+1|0;c[e>>2]=f;h=c[q>>2]|0}m=b+24|0;if((f|0)!=(h|0)){a:do if(!(a[b+98>>0]|0)){j=b+32|0;e=c[j>>2]|0;c[s>>2]=e;k=b+68|0;l=b+72|0;b=b+52|0;while(1){v=c[k>>2]|0;f=kc[c[(c[v>>2]|0)+12>>2]&15](v,l,h,f,r,e,e+(c[b>>2]|0)|0,s)|0;e=c[q>>2]|0;if((c[r>>2]|0)==(e|0)){e=-1;f=27;break}if((f|0)==3){f=20;break}if(f>>>0>=2){e=-1;f=27;break}e=c[j>>2]|0;h=(c[s>>2]|0)-e|0;if((Pb(e|0,1,h|0,c[t>>2]|0)|0)!=(h|0)){e=-1;f=27;break}if((f|0)!=1)break a;h=c[r>>2]|0;f=c[m>>2]|0;c[q>>2]=h;c[p>>2]=f;f=h+(f-h)|0;c[m>>2]=f;e=c[j>>2]|0}if((f|0)==20){l=(c[m>>2]|0)-e|0;if((Pb(e|0,1,l|0,c[t>>2]|0)|0)==(l|0))break;else e=-1;i=u;return e|0}else if((f|0)==27){i=u;return e|0}}else{l=f-h|0;if((Pb(h|0,1,l|0,c[t>>2]|0)|0)!=(l|0)){n=-1;i=u;return n|0}}while(0);c[m>>2]=o;c[q>>2]=o;c[p>>2]=g}n=n?0:d;i=u;return n|0}function Vc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;k=a+4|0;g=c[a>>2]|0;d=(((c[k>>2]|0)-g|0)/12|0)+1|0;if(d>>>0>357913941)Jo(a);l=a+8|0;f=g;e=((c[l>>2]|0)-f|0)/12|0;if(e>>>0<178956970){e=e<<1;e=e>>>0<d>>>0?d:e;d=c[k>>2]|0;f=(d-f|0)/12|0;if(!e){h=0;j=0}else i=6}else{d=c[k>>2]|0;e=357913941;f=(d-f|0)/12|0;i=6}if((i|0)==6){h=e;j=ut(e*12|0)|0}e=j+(f*12|0)|0;i=j+(h*12|0)|0;if(e){wi(e,b);d=c[k>>2]|0;g=c[a>>2]|0}h=j+((f+1|0)*12|0)|0;if((d|0)!=(g|0)){f=f+-1-(((d+-12-g|0)>>>0)/12|0)|0;do{e=e+-12|0;d=d+-12|0;wi(e,d)}while((d|0)!=(g|0));d=c[a>>2]|0;e=c[k>>2]|0;c[a>>2]=j+(f*12|0);c[k>>2]=h;c[l>>2]=i;if((e|0)!=(d|0))do{e=e+-12|0;Bi(e)}while((e|0)!=(d|0))}else{c[a>>2]=e;c[k>>2]=h;c[l>>2]=i}if(!d)return;xt(d);return}function Wc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=(d|0)==(b|0);a[d+12>>0]=e&1;if(e)return;while(1){g=d+8|0;i=c[g>>2]|0;f=i+12|0;if(a[f>>0]|0){h=37;break}j=i+8|0;e=d;d=c[j>>2]|0;h=c[d>>2]|0;if((h|0)==(i|0)){g=c[d+4>>2]|0;if(!g){h=7;break}g=g+12|0;if(a[g>>0]|0){h=7;break}a[f>>0]=1;a[d+12>>0]=(d|0)==(b|0)&1;a[g>>0]=1}else{if(!h){b=g;h=24;break}h=h+12|0;if(a[h>>0]|0){b=g;h=24;break}a[f>>0]=1;a[d+12>>0]=(d|0)==(b|0)&1;a[h>>0]=1}if((d|0)==(b|0)){h=37;break}}if((h|0)==7){if((c[i>>2]|0)==(e|0)){f=i;h=i}else{e=i+4|0;h=c[e>>2]|0;f=c[h>>2]|0;c[e>>2]=f;if(f){c[f+8>>2]=i;d=c[j>>2]|0}g=h+8|0;c[g>>2]=d;f=c[j>>2]|0;if((c[f>>2]|0)==(i|0))c[f>>2]=h;else c[f+4>>2]=h;c[h>>2]=i;c[j>>2]=h;e=c[g>>2]|0;f=h;d=e;h=c[e>>2]|0}a[f+12>>0]=1;a[d+12>>0]=0;g=h+4|0;e=c[g>>2]|0;c[d>>2]=e;if(e)c[e+8>>2]=d;f=d+8|0;c[h+8>>2]=c[f>>2];e=c[f>>2]|0;if((c[e>>2]|0)==(d|0))c[e>>2]=h;else c[e+4>>2]=h;c[g>>2]=d;c[f>>2]=h;return}else if((h|0)==24){if((c[i>>2]|0)==(e|0)){f=e+4|0;h=c[f>>2]|0;c[i>>2]=h;if(h){c[h+8>>2]=i;d=c[j>>2]|0}c[b>>2]=d;g=c[j>>2]|0;if((c[g>>2]|0)==(i|0))c[g>>2]=e;else c[g+4>>2]=e;c[f>>2]=i;c[j>>2]=e;d=c[b>>2]|0}else e=i;a[e+12>>0]=1;a[d+12>>0]=0;f=d+4|0;g=c[f>>2]|0;e=c[g>>2]|0;c[f>>2]=e;if(e)c[e+8>>2]=d;e=d+8|0;c[g+8>>2]=c[e>>2];f=c[e>>2]|0;if((c[f>>2]|0)==(d|0))c[f>>2]=g;else c[f+4>>2]=g;c[g>>2]=d;c[e>>2]=g;return}else if((h|0)==37)return}function Xc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;g=c[d>>2]|0;c[b>>2]=g;c[b+(c[g+-12>>2]|0)>>2]=c[d+12>>2];g=b+8|0;c[g>>2]=464;d=b+72|0;e=c[d>>2]|0;if((e|0)!=0?(Rc(g)|0,(vb(e|0)|0)==0):0)c[d>>2]=0;if((a[b+104>>0]|0)!=0?(f=c[b+40>>2]|0,(f|0)!=0):0)yt(f);if(!(a[b+105>>0]|0)){kj(g);return}d=c[b+64>>2]|0;if(!d){kj(g);return}yt(d);kj(g);return}function Yc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;return (c[2464+((d<<6|a|b<<13&57344|e<<12|6-(b>>>3)<<15)>>>5<<2)>>2]&1<<(a&31)|0)!=0|0}function Zc(){return}function _c(a,b){a=a|0;b=b|0;var d=0;d=iv(a|0,b|0,-1,-1)|0;return c[132320+((ba(F^b^(d^a),2017106723)|0)>>>26<<2)>>2]|0}function $c(a,b){a=a|0;b=b|0;if(b>>>0>0|(b|0)==0&a>>>0>4294967295){a=b;b=32}else b=0;if(a>>>0>65535){a=a>>>16;b=b|16}if(a>>>0>255){a=a>>>8;b=b+8|0}return (c[132576+(a<<2)>>2]|0)+b|0}function ad(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;a=0;do{b=ov(1,0,a|0)|0;e=F;d=46496+(a<<3)|0;c[d>>2]=b;c[d+4>>2]=e;d=iv(b|0,e|0,-1,-1)|0;c[132320+((ba(F^e^(d^b),2017106723)|0)>>>26<<2)>>2]=a;a=a+1|0}while((a|0)!=64);e=1;d=0;do{a=iv(e|0,d|0,-1,-1)|0;b=F;if((a&e|0)==0&(b&d|0)==0)a=132320+((ba(b^d^(a^e),2017106723)|0)>>>26<<2)|0;else{a=iv(e|0,d|0,-1,0)|0;a=132576+(a<<2)|0}c[132576+(e<<2)>>2]=c[a>>2];e=iv(e|0,d|0,1,0)|0;d=F}while(d>>>0<0|(d|0)==0&e>>>0<256);b=47008;c[b>>2]=16843009;c[b+4>>2]=16843009;b=47016|0;c[b>>2]=33686018;c[b+4>>2]=33686018;b=47024|0;c[b>>2]=67372036;c[b+4>>2]=67372036;b=47032|0;c[b>>2]=134744072;c[b+4>>2]=134744072;b=47040|0;c[b>>2]=269488144;c[b+4>>2]=269488144;b=47048|0;c[b>>2]=538976288;c[b+4>>2]=538976288;b=47056|0;c[b>>2]=1077952576;c[b+4>>2]=1077952576;b=47064|0;c[b>>2]=-2139062144;c[b+4>>2]=-2139062144;b=47072;c[b>>2]=255;c[b+4>>2]=0;b=47080|0;c[b>>2]=65280;c[b+4>>2]=0;b=47088|0;c[b>>2]=16711680;c[b+4>>2]=0;b=47096|0;c[b>>2]=-16777216;c[b+4>>2]=0;b=47104|0;c[b>>2]=0;c[b+4>>2]=255;b=47112|0;c[b>>2]=0;c[b+4>>2]=65280;b=47120|0;c[b>>2]=0;c[b+4>>2]=16711680;b=47128|0;c[b>>2]=0;c[b+4>>2]=-16777216;b=47136;c[b>>2]=33686018;c[b+4>>2]=33686018;b=47144|0;c[b>>2]=84215045;c[b+4>>2]=84215045;b=47152|0;c[b>>2]=168430090;c[b+4>>2]=168430090;b=47160|0;c[b>>2]=336860180;c[b+4>>2]=336860180;b=47168|0;c[b>>2]=673720360;c[b+4>>2]=673720360;b=47176|0;c[b>>2]=1347440720;c[b+4>>2]=1347440720;b=47184|0;c[b>>2]=-1600085856;c[b+4>>2]=-1600085856;b=47192|0;c[b>>2]=1077952576;c[b+4>>2]=1077952576;b=47264|0;d=c[b>>2]|0;b=c[b+4>>2]|0;a=47272|0;c[a>>2]=d|255;c[a+4>>2]=b;a=47200;c[a>>2]=d&-256^-256;c[a+4>>2]=~b;a=47280|0;c[a>>2]=d|65535;c[a+4>>2]=b;a=47208|0;c[a>>2]=d&-65536^-65536;c[a+4>>2]=~b;a=47288|0;c[a>>2]=d|16777215;c[a+4>>2]=b;a=47216|0;c[a>>2]=d&-16777216^-16777216;c[a+4>>2]=~b;a=47296|0;c[a>>2]=-1;c[a+4>>2]=b;a=47224|0;c[a>>2]=0;c[a+4>>2]=~b;a=47304|0;c[a>>2]=-1;c[a+4>>2]=b|255;a=47232|0;c[a>>2]=0;c[a+4>>2]=b&-256^-256;a=47312|0;c[a>>2]=-1;c[a+4>>2]=b|65535;a=47240|0;c[a>>2]=0;c[a+4>>2]=b&-65536^-65536;a=47320|0;c[a>>2]=-1;c[a+4>>2]=b|16777215;a=47248|0;c[a>>2]=0;c[a+4>>2]=b&-16777216^-16777216;a=0;do{d=47200+(a>>3<<3)|0;f=c[d>>2]|0;d=c[d+4>>2]|0;b=a&7;e=47008+(b<<3)|0;g=c[e>>2]&f;e=c[e+4>>2]&d;h=59616+(a<<3)|0;c[h>>2]=g;c[h+4>>2]=e;b=47136+(b<<3)|0;f=c[b>>2]&f;d=c[b+4>>2]&d;b=61664+(a<<3)|0;c[b>>2]=f;c[b+4>>2]=d;b=60640+(a<<3)|0;c[b>>2]=g|f;c[b+4>>2]=e|d;a=a+1|0}while((a|0)!=64);a=0;do{d=47264+(a>>3<<3)|0;f=c[d>>2]|0;d=c[d+4>>2]|0;b=a&7;e=47008+(b<<3)|0;g=c[e>>2]&f;e=c[e+4>>2]&d;h=60128+(a<<3)|0;c[h>>2]=g;c[h+4>>2]=e;b=47136+(b<<3)|0;f=c[b>>2]&f;d=c[b+4>>2]&d;b=62176+(a<<3)|0;c[b>>2]=f;c[b+4>>2]=d;b=61152+(a<<3)|0;c[b>>2]=g|f;c[b+4>>2]=e|d;a=a+1|0}while((a|0)!=64);a=0;do{b=a&7;d=a>>3;e=0;do{if((a|0)!=(e|0)){f=e&7;f=b>>>0<f>>>0?f-b|0:b-f|0;h=e>>3;h=(d|0)<(h|0)?h-d|0:d-h|0;f=(f|0)<(h|0)?h:f;c[27040+(a<<8)+(e<<2)>>2]=f;f=55520+(a<<6)+(f+-1<<3)|0;h=46496+(e<<3)|0;i=f;g=c[i+4>>2]|c[h+4>>2];c[f>>2]=c[i>>2]|c[h>>2];c[f+4>>2]=g}e=e+1|0}while((e|0)!=64);a=a+1|0}while((a|0)!=64);g=1;do{d=c[133600+(g*36|0)>>2]|0;if(!(57>>>g&1)){a=0;do{b=47328+(g<<9)+(a<<3)|0;e=d;f=0;do{e=e+a|0;if(e>>>0<64?(c[27040+(a<<8)+(e<<2)>>2]|0)<3:0){i=46496+(e<<3)|0;j=b;h=c[j+4>>2]|c[i+4>>2];e=b;c[e>>2]=c[j>>2]|c[i>>2];c[e+4>>2]=h}f=f+1|0;e=c[133600+(g*36|0)+(f<<2)>>2]|0}while((e|0)!=0);a=a+1|0}while((a|0)!=64)}else{a=0;do a=a+1|0;while((a|0)!=64)}g=g+1|0}while((g|0)!=7);h=1;do{g=c[133600+(h*36|0)>>2]|0;f=h|8;if(!(57>>>h&1)){b=0;do{d=47328+(f<<9)+(b<<3)|0;e=g;a=0;do{e=b-e|0;if(e>>>0<64?(c[27040+(b<<8)+(e<<2)>>2]|0)<3:0){j=46496+(e<<3)|0;k=d;i=c[k+4>>2]|c[j+4>>2];e=d;c[e>>2]=c[k>>2]|c[j>>2];c[e+4>>2]=i}a=a+1|0;e=c[133600+(h*36|0)+(a<<2)>>2]|0}while((e|0)!=0);b=b+1|0}while((b|0)!=64)}else{a=0;do a=a+1|0;while((a|0)!=64)}h=h+1|0}while((h|0)!=7);c[10856]=133856;c[10857]=166624;c[10858]=183008;c[10859]=199392;c[10860]=215776;c[10861]=232160;c[10862]=248544;c[10863]=264928;c[10864]=297696;c[10865]=314080;c[10866]=322272;c[10867]=330464;c[10868]=338656;c[10869]=346848;c[10870]=355040;c[10871]=363232;c[10872]=379616;c[10873]=396e3;c[10874]=404192;c[10875]=412384;c[10876]=420576;c[10877]=428768;c[10878]=436960;c[10879]=445152;c[10880]=461536;c[10881]=477920;c[10882]=486112;c[10883]=494304;c[10884]=502496;c[10885]=510688;c[10886]=518880;c[10887]=527072;c[10888]=543456;c[10889]=559840;c[10890]=568032;c[10891]=576224;c[10892]=584416;c[10893]=592608;c[10894]=600800;c[10895]=608992;c[10896]=625376;c[10897]=641760;c[10898]=649952;c[10899]=658144;c[10900]=666336;c[10901]=674528;c[10902]=682720;c[10903]=690912;c[10904]=707296;c[10905]=723680;c[10906]=731872;c[10907]=740064;c[10908]=748256;c[10909]=756448;c[10910]=764640;c[10911]=772832;c[10912]=789216;c[10913]=821984;c[10914]=838368;c[10915]=854752;c[10916]=871136;c[10917]=887520;c[10918]=903904;c[10919]=920288;c[10920]=953056;c[10921]=953568;c[10922]=953824;c[10923]=954080;c[10924]=954336;c[10925]=954592;c[10926]=954848;c[10927]=955104;c[10928]=955616;c[10929]=955872;c[10930]=956128;c[10931]=956384;c[10932]=956640;c[10933]=956896;c[10934]=957152;c[10935]=957408;c[10936]=957664;c[10937]=957920;c[10938]=958176;c[10939]=959200;c[10940]=960224;c[10941]=961248;c[10942]=962272;c[10943]=962528;c[10944]=962784;c[10945]=963040;c[10946]=963296;c[10947]=964320;c[10948]=968416;c[10949]=972512;c[10950]=973536;c[10951]=973792;c[10952]=974048;c[10953]=974304;c[10954]=974560;c[10955]=975584;c[10956]=979680;c[10957]=983776;c[10958]=984800;c[10959]=985056;c[10960]=985312;c[10961]=985568;c[10962]=985824;c[10963]=986848;c[10964]=987872;c[10965]=988896;c[10966]=989920;c[10967]=990176;c[10968]=990432;c[10969]=990688;c[10970]=990944;c[10971]=991200;c[10972]=991456;c[10973]=991712;c[10974]=991968;c[10975]=992224;c[10976]=992480;c[10977]=992992;c[10978]=993248;c[10979]=993504;c[10980]=993760;c[10981]=994016;c[10982]=994272;c[10983]=994528;return}function bd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+192|0;t=b+180|0;s=b+168|0;r=b+156|0;q=b+144|0;p=b+132|0;o=b+120|0;n=b+108|0;m=b+96|0;l=b+84|0;k=b+72|0;j=b+60|0;h=b+48|0;g=b+36|0;f=b+24|0;e=b+12|0;d=b;c[a+4>>2]=0;c[a+8>>2]=0;c[a>>2]=a+4;c[a+16>>2]=0;c[a+20>>2]=0;c[a+12>>2]=a+16;vi(t,995040,3);yd(a,t);Bi(t);vi(s,995048,4);zd(a,s);Bi(s);vi(r,995056,4);Ad(a,r);Bi(r);vi(q,995064,4);Bd(a,q);Bi(q);vi(p,995072,4);Cd(a,p);Bi(p);vi(o,995080,4);Dd(a,o);Bi(o);vi(n,995088,4);Ed(a,n);Bi(n);vi(m,995096,4);Fd(a,m);Bi(m);vi(l,995104,4);Gd(a,l);Bi(l);vi(k,995112,5);Hd(a,k);Bi(k);vi(j,995120,5);Id(a,j);Bi(j);vi(h,995128,5);Jd(a,h);Bi(h);vi(g,995136,5);Kd(a,g);Bi(g);vi(f,995144,5);Ld(a,f);Bi(f);vi(e,995152,6);Md(a,e);Bi(e);vi(d,995160,7);Nd(a,d);Bi(d);i=b;return}function cd(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a>>2]|0;e=a+4|0;if((b|0)!=(e|0))do{d=c[b+24>>2]|0;if(d)cc[c[(c[d>>2]|0)+4>>2]&255](d);d=c[b+4>>2]|0;if(!d)while(1){d=c[b+8>>2]|0;if((c[d>>2]|0)==(b|0)){b=d;break}else b=d}else{b=d;while(1){d=c[b>>2]|0;if(!d)break;else b=d}}}while((b|0)!=(e|0));e=a+12|0;b=c[e>>2]|0;f=a+16|0;if((b|0)!=(f|0))do{d=c[b+24>>2]|0;if(d)cc[c[(c[d>>2]|0)+4>>2]&255](d);d=c[b+4>>2]|0;if(!d)while(1){d=c[b+8>>2]|0;if((c[d>>2]|0)==(b|0)){b=d;break}else b=d}else{b=d;while(1){d=c[b>>2]|0;if(!d)break;else b=d}}}while((b|0)!=(f|0));Od(e,c[a+16>>2]|0);Pd(a,c[a+4>>2]|0);return}function dd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;j=i;i=i+2064|0;e=j;g=b+2212|0;f=a+8|0;d=c[f>>2]|0;do if((c[g>>2]|0)==(d|0)){c[e+2048>>2]=e;d=Af(b,e)|0;c[e+2052>>2]=d;c[d>>2]=0;if((d|0)==(e|0)){i=j;return 0}else{d=c[f>>2]|0;break}}while(0);f=c[a+4>>2]|0;d=c[b+(d<<9)+784>>2]|0;d=((c[b+(f<<5)+340>>2]|0)*258|0)+(c[(c[b+2220>>2]|0)+(f<<2)+16>>2]|0)+(c[995168+(d<<2)>>2]|0)+(c[995424+(c[27040+(c[b+(f<<9)+784>>2]<<8)+(d<<2)>>2]<<2)>>2]|0)|0;if((c[b+(f<<5)+356>>2]|0)==0?(c[b+(f<<5)+352>>2]|0)==0:0){e=c[b+(f<<5)+348>>2]|0;if(e)if(!(c[b+(f<<5)+344>>2]|0)){if((e|0)>1?(e=c[b+(f<<9)+596>>2]^c[b+(f<<9)+592>>2],((e>>>3^e)&1|0)!=0):0)h=10}else h=10}else h=10;if((h|0)==10)d=d+1e4|0;i=j;return ((f|0)==(c[g>>2]|0)?d:0-d|0)|0}function ed(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=c[a+4>>2]|0;d=c[b+(e<<9)+784>>2]|0;a=c[b+(c[a+8>>2]<<9)+784>>2]|0;f=c[b+(e<<9)+592>>2]|0;if((f>>>3^f)&1){a=a^56;d=d^56}a=(c[995424+(c[27040+(d<<8)+(a<<2)>>2]<<2)>>2]|0)+1e4+(c[995456+(a<<2)>>2]|0)|0;return ((e|0)==(c[b+2212>>2]|0)?a:0-a|0)|0}function fd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=a+4|0;f=c[e>>2]|0;i=c[b+(f<<9)+784>>2]|0;d=c[b+(f<<9)+464>>2]|0;j=(d&4|0)!=0;i=j?i^7:i;h=(f|0)==1;g=c[b+(c[a+8>>2]<<9)+784>>2]|0;g=j?g^7:g;d=j?d^7:d;d=h?d^56:d;a=b+2212|0;if(Yc(h?i^56:i,d,h?g^56:g,(f|0)!=(c[a>>2]|0)&1)|0){d=d>>3;return ((c[e>>2]|0)==(c[a>>2]|0)?d+10258|0:-10258-d|0)|0}else return 0;return 0}function gd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;i=c[a+4>>2]|0;g=c[b+(i<<9)+784>>2]|0;j=i*56|0;l=j^g;h=c[a+8>>2]|0;a=c[b+(h<<9)+784>>2]^j;e=c[b+(h<<9)+464>>2]|0;d=e^j;e=e&7;if((l|0)<(d|0)&(g&7|0)==(e|0)){j=c[b+2212>>2]|0;k=1278-(c[27040+(l<<8)+(d<<2)>>2]|0)|0;j=(i|0)==(j|0);l=0-k|0;l=j?k:l;return l|0}f=c[27040+(a<<8)+(d<<2)>>2]|0;g=c[b+2212>>2]|0;if((f|0)>=(((g|0)==(h|0)?4:3)|0)?(c[27040+(a<<8)+((c[b+(i<<9)+656>>2]^j)<<2)>>2]|0)>2:0){j=g;k=1278-(c[27040+(l<<8)+(d<<2)>>2]|0)|0;j=(i|0)==(j|0);l=0-k|0;l=j?k:l;return l|0}if(((a>>3|0)<3?(f|0)==1&(l>>3|0)>2:0)?(k=c[27040+(l<<8)+(d<<2)>>2]|0,(k|0)>((g|0)==(i|0)|2|0)):0){j=g;k=80-(k<<3)|0;j=(i|0)==(j|0);l=0-k|0;l=j?k:l;return l|0}k=d+-8|0;j=g;k=200-((c[27040+(l<<8)+(k<<2)>>2]|0)-(c[27040+(a<<8)+(k<<2)>>2]|0)-(c[27040+(d<<8)+(e<<2)>>2]|0)<<3)|0;j=(i|0)==(j|0);l=0-k|0;l=j?k:l;return l|0}function hd(a,b){a=a|0;b=b|0;var d=0;d=c[995168+(c[b+(c[a+8>>2]<<9)+784>>2]<<2)>>2]|0;return ((c[a+4>>2]|0)==(c[b+2212>>2]|0)?d:0-d|0)|0}function id(a,b){a=a|0;b=b|0;var d=0,e=0;e=c[a+8>>2]|0;d=c[b+(e<<9)+784>>2]|0;d=(c[995712+(c[27040+(d<<8)+(c[b+(e<<9)+528>>2]<<2)>>2]<<2)>>2]|0)+(c[995168+(d<<2)>>2]|0)|0;return ((c[a+4>>2]|0)==(c[b+2212>>2]|0)?d:0-d|0)|0}function jd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;e=c[a+4>>2]|0;g=c[a+8>>2]|0;f=c[b+(g<<9)+784>>2]|0;d=c[b+(g<<9)+464>>2]|0;a=c[995424+(c[27040+(c[b+(e<<9)+784>>2]<<8)+(f<<2)>>2]<<2)>>2]|0;if(((d>>3^g*7|0)==6?(c[27040+(f<<8)+(d<<2)>>2]|0)==1:0)?(d=46496+(d<<3)|0,!((c[d>>2]&-1515870811|0)==0?(c[d+4>>2]&-1515870811|0)==0:0)):0){d=a;a=b+2212|0;a=c[a>>2]|0;e=(e|0)==(a|0);a=0-d|0;a=e?d:a;return a|0}d=a+2300|0;a=b+2212|0;a=c[a>>2]|0;e=(e|0)==(a|0);a=0-d|0;a=e?d:a;return a|0}function kd(a,b){a=a|0;b=b|0;var d=0;d=c[a+4>>2]|0;a=c[b+(c[a+8>>2]<<9)+784>>2]|0;a=(c[995168+(a<<2)>>2]|0)+1280+(c[995424+(c[27040+(c[b+(d<<9)+784>>2]<<8)+(a<<2)>>2]<<2)>>2]|0)|0;return ((d|0)==(c[b+2212>>2]|0)?a:0-a|0)|0}function ld(a,b){a=a|0;b=b|0;return 0}function md(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;m=a+4|0;i=c[m>>2]|0;f=b+(i<<3)+320|0;o=b+264|0;k=o;h=c[k>>2]|0;k=c[k+4>>2]|0;g=h&c[f>>2];f=k&c[f+4>>2];e=c[b+(i<<9)+464>>2]&7;if((e|0)==1|(e|0)==6)j=6;else if((e|0)==0|(e|0)==7){p=47008+(e<<3)|0;if((((g&~c[p>>2]|0)==0?(f&~c[p+4>>2]|0)==0:0)?(d=i*56^(e|56),i=d^c[b+(i<<9)+592>>2],((i>>>3^i)&1|0)!=0):0)?(c[27040+(d<<8)+(c[b+(c[a+8>>2]<<9)+784>>2]<<2)>>2]|0)<2:0){l=0;return l|0}if((e|0)==1|(e|0)==6)j=6}do if((((j|0)==6?(j=47008+(e<<3)|0,(h&~c[j>>2]|0)==0?(k&~c[j+4>>2]|0)==0:0):0)?(n=a+8|0,l=c[n>>2]|0,(c[(c[b+2220>>2]|0)+(l<<2)+16>>2]|0)==0):0)?(c[b+(l<<5)+340>>2]|0)>0:0){a=b+(l<<3)+320|0;d=c[a>>2]&h;a=c[a+4>>2]&k;if(!l)i=_c(d,a)|0;else i=$c(d,a)|0;g=c[m>>2]|0;h=c[b+(g<<9)+784>>2]|0;d=c[n>>2]|0;a=c[b+(d<<9)+784>>2]|0;e=c[b+(g<<9)+592>>2]|0;f=g*7|0;if((f^i>>3|0)==6?(k=b+(g<<3)+320|0,j=o,l=46496+(((d|0)==0?8:-8)+i<<3)|0,!((c[j>>2]&c[k>>2]&c[l>>2]|0)==0?(c[j+4>>2]&c[k+4>>2]&c[l+4>>2]|0)==0:0)):0){l=e^i;if(((l>>>3^l)&1|0)==0?(c[b+(g<<5)+340>>2]|0)!=1:0)break;l=c[27040+(i<<8)+(a<<2)>>2]|0;if(!((l|0)>2|(f^a>>3|0)<6|(l|0)>(c[27040+(i<<8)+(h<<2)>>2]|0))){l=0;return l|0}}}while(0);l=255;return l|0}function nd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=c[a+8>>2]|0;f=c[b+(d<<9)+784>>2]|0;g=c[b+(d<<9)+656>>2]|0;h=d*7|0;if((((f>>3^h|0)<2?(e=c[a+4>>2]|0,(c[b+(e<<9)+784>>2]>>3^h|0)>2):0)?(g>>3^h|0)==2:0)?(h=b+(d<<3)+320|0,b=b+264|0,f=50400+(f<<3)|0,d=47328+((e<<3|1)<<9)+(g<<3)|0,!((c[b>>2]&c[h>>2]&c[f>>2]&c[d>>2]|0)==0?(c[b+4>>2]&c[h+4>>2]&c[f+4>>2]&c[d+4>>2]|0)==0:0)):0){d=0;return d|0}d=255;return d|0}function od(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=c[a+4>>2]|0;p=c[b+(e<<9)+784>>2]|0;f=c[b+(e<<9)+464>>2]|0;h=(f&4|0)!=0;p=h?p^7:p;n=(e|0)==1;p=n?p^56:p;d=c[a+8>>2]|0;j=c[b+(d<<9)+784>>2]|0;j=h?j^7:j;j=n?j^56:j;g=c[b+(e<<9)+656>>2]|0;g=h?g^7:g;g=n?g^56:g;f=h?f^7:f;f=n?f^56:f;d=c[b+(d<<9)+656>>2]|0;d=h?d^7:d;d=n?d^56:d;n=f&7;h=f>>3;i=n|56;b=(c[b+2212>>2]|0)==(e|0);e=b&1;a=(h|0)<5;if(a?((p|0)<40?(c[27040+(j<<8)+(i<<2)>>2]|0)<2:0):0){if((d&-8|0)==40){k=0;return k|0}if(!((h|0)>2|(g&-8|0)==40)){k=0;return k|0}}if(((h|0)==5?(c[27040+(j<<8)+(i<<2)>>2]|0)<2:0)?(e+(p>>3)|0)<6:0){if(d>>>0<8){k=0;return k|0}if(!b?(q=d&7,((q>>>0<n>>>0?n-q|0:q-n|0)|0)>2):0){k=0;return k|0}}if((h|0)>4&(j|0)==(i|0)&d>>>0<8){if(!b){k=0;return k|0}if((c[27040+(p<<8)+(f<<2)>>2]|0)>1){k=0;return k|0}}if((f|0)==48&(g|0)==56&(j&-2|0)==54&(d&7|0)==0?(d>>3|0)<3|(p&7)>>>0>2|(p>>3|0)<5:0){k=0;return k|0}b=f+8|0;if((a&(j|0)==(b|0)?((c[27040+(p<<8)+(f<<2)>>2]|0)-e|0)>1:0)?((c[27040+(p<<8)+(d<<2)>>2]|0)-e|0)>1:0){k=0;return k|0}a=(n|0)!=0;if((((h|0)==6&a?!((g&7|0)!=(n|0)|(g|0)==(i|0)):0)?(o=c[27040+(p<<8)+(i<<2)>>2]|0,(o|0)<((e|-2)+(c[27040+(j<<8)+(i<<2)>>2]|0)|0)):0)?(o|0)<((c[27040+(j<<8)+(g<<2)>>2]|0)+e|0):0){k=128-(o<<1)|0;return k|0}do if(((a?(g&7|0)==(n|0)&(g|0)<(f|0):0)?(k=c[27040+(p<<8)+(i<<2)>>2]|0,l=e|-2,(k|0)<(l+(c[27040+(j<<8)+(i<<2)>>2]|0)|0)):0)?(m=c[27040+(p<<8)+(b<<2)>>2]|0,(m|0)<(l+(c[27040+(j<<8)+(b<<2)>>2]|0)|0)):0){g=(c[27040+(j<<8)+(g<<2)>>2]|0)+e|0;if((g|0)<=2?!((k|0)<(g|0)&(m|0)<(g|0)):0)break;k=128-(c[27040+(f<<8)+(i<<2)>>2]<<3)-(k<<1)|0;return k|0}while(0);if(!((h|0)<4&(j|0)>(f|0))){k=255;return k|0}a=j&7;if((a|0)==(n|0)){k=10;return k|0}if(((a>>>0<n>>>0?n-a|0:a-n|0)|0)!=1){k=255;return k|0}a=c[27040+(p<<8)+(j<<2)>>2]|0;if((a|0)<=2){k=255;return k|0}k=24-(a<<1)|0;return k|0}function pd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b+264|0;do if(!((c[d>>2]&-2122219135|0)==0?(c[d+4>>2]&-2122219135|0)==0:0)){e=c[a+8>>2]|0;h=c[b+(e<<9)+784>>2]|0;e=c[b+(e<<9)+592>>2]|0;f=c[a+4>>2]|0;a=c[b+(f<<9)+464>>2]|0;d=a>>3^f*7;g=(f|0)==0?8:-8;if((d|0)==5){if((c[27040+((g<<1)+a<<8)+(h<<2)>>2]|0)>=2)break;d=64224+(e<<3)|0;f=46496+(g+a<<3)|0;if((c[f>>2]&c[d>>2]|0)==0?(c[f+4>>2]&c[d+4>>2]|0)==0:0)break;d=e&7;a=a&7;if(((d>>>0<a>>>0?a-d|0:d-a|0)|0)>1)a=8;else break;return a|0}else if((d|0)!=4)break;d=a^e;if(!((d>>>3^d)&1)){a=c[27040+((g*3|0)+a<<8)+(h<<2)>>2]|0;if((a|0)<3){if(a){a=24;return a|0}if((h|0)!=((c[b+(f<<9)+784>>2]|0)+(g<<1)|0)){a=24;return a|0}}a=48;return a|0}}while(0);a=255;return a|0}function qd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a+4>>2]|0;g=c[b+(e<<9)+464>>2]|0;h=c[b+(e<<9)+468>>2]|0;f=c[b+(c[a+8>>2]<<9)+784>>2]|0;d=b+((e^1)<<3)+320|0;b=b+264|0;a=c[b>>2]&c[d>>2];d=c[b+4>>2]&c[d+4>>2];b=60640+(e<<9)+(g<<3)|0;if((a&c[b>>2]|0)==0?(d&c[b+4>>2]|0)==0:0){a=255;return a|0}b=60640+(e<<9)+(h<<3)|0;if((c[b>>2]&a|0)==0?(c[b+4>>2]&d|0)==0:0){a=255;return a|0}d=e*7|0;a=g>>3^d;b=h>>3^d;a=(a|0)<(b|0)?b:a;b=f&7;e=g&7;a:do if((((b>>>0<e>>>0?e-b|0:b-e|0)|0)<2?(e=h&7,((b>>>0<e>>>0?e-b|0:b-e|0)|0)<2):0)?(f>>3^d|0)>(a|0):0)switch(a|0){case 5:{a=40;return a|0}case 2:case 1:{a=10;return a|0}case 3:{a=15;return a|0}case 4:{a=20;return a|0}default:break a}while(0);a=255;return a|0}function rd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;f=c[a+8>>2]|0;d=c[b+(f<<9)+784>>2]|0;g=c[a+4>>2]|0;a=b+(g<<3)+320|0;h=b+264|0;e=c[h>>2]&c[a>>2];a=c[h+4>>2]&c[a+4>>2];b=c[b+(g<<9)+464>>2]|0;f=47200+(f<<6)+(d>>3<<3)|0;if((((e&~c[f>>2]|0)==0?(a&~c[f+4>>2]|0)==0:0)?(e&-16843010|0)==0&(a&-16843010|0)==0|(e&2139062143|0)==0&(a&2139062143|0)==0:0)?(a=d&7,b=b&7,((a>>>0<b>>>0?b-a|0:a-b|0)|0)<2):0){b=0;return b|0}b=255;return b|0}function sd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=c[a+4>>2]|0;i=c[b+(d<<9)+464>>2]|0;f=c[b+(d<<9)+592>>2]|0;g=c[a+8>>2]|0;h=c[b+(g<<9)+592>>2]|0;a=c[b+(g<<9)+784>>2]|0;if((((a^i)&7|0)==0?(j=d*7|0,e=a>>3^j,(i>>3^j|0)<(e|0)):0)?(a=a^f,((a>>>3^a)&1|0)!=0|(e|0)<6):0){d=0;return d|0}a=h^f;if((a>>>3^a)&1){if((d*7^i>>3|0)<5){d=0;return d|0}a=59616+(d<<9)+(i<<3)|0;d=c[a>>2]|0;a=c[a+4>>2]|0;f=b+(g<<3)+320|0;e=b+304|0;if(!((c[f>>2]&d&c[e>>2]|0)==0?(c[f+4>>2]&a&c[e+4>>2]|0)==0:0)){d=0;return d|0}f=b+256|0;g=45728+(h<<3)|0;e=45216+(h<<3)|0;e=(ba(c[g+4>>2]&c[f+4>>2],c[e+4>>2]|0)|0)^(ba(c[g>>2]&c[f>>2],c[e>>2]|0)|0);e=(c[43680+(h<<2)>>2]|0)+(e>>>(c[46240+(h<<2)>>2]|0)<<3)|0;if(!((c[e>>2]&d|0)==0?(c[e+4>>2]&a|0)==0:0)?(c[27040+(h<<8)+(i<<2)>>2]|0)>2:0){d=0;return d|0}}d=255;return d|0}function td(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=c[a+4>>2]|0;o=c[b+(h<<9)+592>>2]|0;m=c[a+8>>2]|0;n=c[b+(m<<9)+592>>2]|0;l=n^o;if(!((l>>>3^l)&1)){l=255;return l|0}i=c[b+(m<<9)+784>>2]|0;d=c[b+(h<<9)+464>>2]|0;a=c[b+(h<<9)+468>>2]|0;j=d>>3;k=a>>3;l=h*7|0;if((j^l|0)>(k^l|0)){g=a&7;e=d;f=g;a=d&7;g=j<<3|g}else{g=d&7;e=a;f=a&7;a=g;g=k<<3|g}d=e+((h|0)==0?8:-8)|0;a=a>>>0<f>>>0?f-a|0:a-f|0;if(!a){if((((d^i)&7|0)==0?(l^i>>3|0)>=(l^d>>3|0):0)?(l=i^o,((l>>>3^l)&1|0)!=0):0){l=0;return l|0}l=255;return l|0}else if((a|0)==1){if((i|0)==(d|0)?(l=i^o,((l>>>3^l)&1|0)!=0):0){if((n|0)==(g|0)){l=0;return l|0}f=b+256|0;l=45728+(g<<3)|0;h=45216+(g<<3)|0;h=(ba(c[l+4>>2]&c[f+4>>2],c[h+4>>2]|0)|0)^(ba(c[l>>2]&c[f>>2],c[h>>2]|0)|0);h=(c[43680+(g<<2)>>2]|0)+(h>>>(c[46240+(g<<2)>>2]|0)<<3)|0;f=b+(m<<3)+320|0;l=b+280|0;if(!((c[f>>2]&c[h>>2]&c[l>>2]|0)==0?(c[f+4>>2]&c[h+4>>2]&c[l+4>>2]|0)==0:0)){l=0;return l|0}if((((j|0)<(k|0)?k-j|0:j-k|0)|0)>1){l=0;return l|0}}if((i|0)==(g|0)?(l=i^o,((l>>>3^l)&1|0)!=0):0){if((n|0)==(d|0)){l=0;return l|0}j=b+256|0;l=45728+(d<<3)|0;k=45216+(d<<3)|0;k=(ba(c[l+4>>2]&c[j+4>>2],c[k+4>>2]|0)|0)^(ba(c[l>>2]&c[j>>2],c[k>>2]|0)|0);k=(c[43680+(d<<2)>>2]|0)+(k>>>(c[46240+(d<<2)>>2]|0)<<3)|0;j=b+(m<<3)+320|0;l=b+280|0;if(!((c[j>>2]&c[k>>2]&c[l>>2]|0)==0?(c[j+4>>2]&c[k+4>>2]&c[l+4>>2]|0)==0:0)){l=0;return l|0}}l=255;return l|0}else{l=255;return l|0}return 0}function ud(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=c[a+4>>2]|0;f=c[b+(d<<9)+464>>2]|0;g=c[b+(d<<9)+592>>2]|0;b=c[b+(c[a+8>>2]<<9)+784>>2]|0;if((((b^f)&7|0)==0?(a=d*7|0,e=b>>3^a,(f>>3^a|0)<(e|0)):0)?(b=b^g,((b>>>3^b)&1|0)!=0|(e|0)<6):0){b=0;return b|0}b=255;return b|0}function vd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+4>>2]|0;e=c[b+(d<<9)+464>>2]|0;f=(e&4|0)!=0;e=f?e^7:e;d=(d|0)==1;b=c[b+(c[a+8>>2]<<9)+784>>2]|0;b=f?b^7:b;if(((d?e^56:e)|0)==48?(c[41376+((d?b^56:b)<<2)>>2]|0)<2:0){b=0;return b|0}b=255;return b|0}function wd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=c[a+4>>2]|0;d=c[b+(e<<9)+464>>2]|0;a=c[a+8>>2]|0;f=c[b+(a<<9)+592>>2]|0;e=59616+(e<<9)+(d<<3)|0;h=b+256|0;i=45728+(f<<3)|0;g=45216+(f<<3)|0;g=(ba(c[i+4>>2]&c[h+4>>2],c[g+4>>2]|0)|0)^(ba(c[i>>2]&c[h>>2],c[g>>2]|0)|0);f=(c[43680+(f<<2)>>2]|0)+(g>>>(c[46240+(f<<2)>>2]|0)<<3)|0;if((c[f>>2]&c[e>>2]|0)==0?(c[f+4>>2]&c[e+4>>2]|0)==0:0){a=255;return a|0}a=c[27040+(c[b+(a<<9)+784>>2]<<8)+(d<<2)>>2]|0;return a|0}function xd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;f=c[a+4>>2]|0;e=c[b+(f<<9)+784>>2]|0;h=c[b+(f<<9)+464>>2]|0;i=(h&4|0)!=0;e=i?e^7:e;g=(f|0)==1;d=c[b+(c[a+8>>2]<<9)+784>>2]|0;d=i?d^7:d;a=i?h^7:h;a=g?a^56:a;if(!((a>>3|0)<4|(a&7|0)==0)){a=255;return a|0}a=Yc(g?e^56:e,a,g?d^56:d,(f|0)!=(c[b+2212>>2]|0)&1)|0;a=a?255:0;return a|0}function yd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;l=n;k=ut(12)|0;c[k>>2]=996144;c[k+4>>2]=0;c[k+8>>2]=1;j=we(b,0)|0;h=F;m=a+4|0;e=c[m>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}Wc(c[m>>2]|0,e);j=a+8|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=996144;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[m>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=n;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[a>>2]>>2]|0;if(!d)d=g;else{c[a>>2]=d;d=c[f>>2]|0}Wc(c[m>>2]|0,d);m=a+8|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=n;return}function zd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;l=n;k=ut(12)|0;c[k>>2]=996120;c[k+4>>2]=0;c[k+8>>2]=1;j=we(b,0)|0;h=F;m=a+4|0;e=c[m>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}Wc(c[m>>2]|0,e);j=a+8|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=996120;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[m>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=n;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[a>>2]>>2]|0;if(!d)d=g;else{c[a>>2]=d;d=c[f>>2]|0}Wc(c[m>>2]|0,d);m=a+8|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=n;return}function Ad(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;l=n;k=ut(12)|0;c[k>>2]=996096;c[k+4>>2]=0;c[k+8>>2]=1;j=we(b,0)|0;h=F;m=a+4|0;e=c[m>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}Wc(c[m>>2]|0,e);j=a+8|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=996096;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[m>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=n;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[a>>2]>>2]|0;if(!d)d=g;else{c[a>>2]=d;d=c[f>>2]|0}Wc(c[m>>2]|0,d);m=a+8|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=n;return}function Bd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;l=n;k=ut(12)|0;c[k>>2]=996072;c[k+4>>2]=0;c[k+8>>2]=1;j=we(b,0)|0;h=F;m=a+4|0;e=c[m>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}Wc(c[m>>2]|0,e);j=a+8|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=996072;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[m>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=n;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[a>>2]>>2]|0;if(!d)d=g;else{c[a>>2]=d;d=c[f>>2]|0}Wc(c[m>>2]|0,d);m=a+8|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=n;return}function Cd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;l=n;k=ut(12)|0;c[k>>2]=996048;c[k+4>>2]=0;c[k+8>>2]=1;j=we(b,0)|0;h=F;m=a+4|0;e=c[m>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}Wc(c[m>>2]|0,e);j=a+8|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=996048;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[m>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=n;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[a>>2]>>2]|0;if(!d)d=g;else{c[a>>2]=d;d=c[f>>2]|0}Wc(c[m>>2]|0,d);m=a+8|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=n;return}function Dd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;l=n;k=ut(12)|0;c[k>>2]=996024;c[k+4>>2]=0;c[k+8>>2]=1;j=we(b,0)|0;h=F;m=a+4|0;e=c[m>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}Wc(c[m>>2]|0,e);j=a+8|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=996024;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[m>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=n;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[a>>2]>>2]|0;if(!d)d=g;else{c[a>>2]=d;d=c[f>>2]|0}Wc(c[m>>2]|0,d);m=a+8|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=n;return}function Ed(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;l=n;k=ut(12)|0;c[k>>2]=996e3;c[k+4>>2]=0;c[k+8>>2]=1;j=we(b,0)|0;h=F;m=a+4|0;e=c[m>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}Wc(c[m>>2]|0,e);j=a+8|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=996e3;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[m>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=n;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[a>>2]>>2]|0;if(!d)d=g;else{c[a>>2]=d;d=c[f>>2]|0}Wc(c[m>>2]|0,d);m=a+8|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=n;return}function Fd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;i=i+16|0;l=n;k=ut(12)|0;c[k>>2]=995976;c[k+4>>2]=0;c[k+8>>2]=1;j=we(b,0)|0;h=F;m=a+4|0;e=c[m>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}Wc(c[m>>2]|0,e);j=a+8|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=995976;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[m>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+4|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=n;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[a>>2]>>2]|0;if(!d)d=g;else{c[a>>2]=d;d=c[f>>2]|0}Wc(c[m>>2]|0,d);m=a+8|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=n;return}function Gd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+16|0;l=o;k=ut(12)|0;c[k>>2]=995952;c[k+4>>2]=0;c[k+8>>2]=1;m=a+12|0;j=we(b,0)|0;h=F;n=a+16|0;e=c[n>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[m>>2]>>2]|0;if(!e)e=d;else{c[m>>2]=e;e=c[f>>2]|0}Wc(c[n>>2]|0,e);j=a+20|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=995952;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[n>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=o;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[m>>2]>>2]|0;if(!d)d=g;else{c[m>>2]=d;d=c[f>>2]|0}Wc(c[n>>2]|0,d);m=a+20|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=o;return}function Hd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+16|0;l=o;k=ut(12)|0;c[k>>2]=995928;c[k+4>>2]=0;c[k+8>>2]=1;m=a+12|0;j=we(b,0)|0;h=F;n=a+16|0;e=c[n>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[m>>2]>>2]|0;if(!e)e=d;else{c[m>>2]=e;e=c[f>>2]|0}Wc(c[n>>2]|0,e);j=a+20|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=995928;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[n>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=o;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[m>>2]>>2]|0;if(!d)d=g;else{c[m>>2]=d;d=c[f>>2]|0}Wc(c[n>>2]|0,d);m=a+20|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=o;return}function Id(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+16|0;l=o;k=ut(12)|0;c[k>>2]=995904;c[k+4>>2]=0;c[k+8>>2]=1;m=a+12|0;j=we(b,0)|0;h=F;n=a+16|0;e=c[n>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[m>>2]>>2]|0;if(!e)e=d;else{c[m>>2]=e;e=c[f>>2]|0}Wc(c[n>>2]|0,e);j=a+20|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=995904;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[n>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=o;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[m>>2]>>2]|0;if(!d)d=g;else{c[m>>2]=d;d=c[f>>2]|0}Wc(c[n>>2]|0,d);m=a+20|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=o;return}function Jd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+16|0;l=o;k=ut(12)|0;c[k>>2]=995880;c[k+4>>2]=0;c[k+8>>2]=1;m=a+12|0;j=we(b,0)|0;h=F;n=a+16|0;e=c[n>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[m>>2]>>2]|0;if(!e)e=d;else{c[m>>2]=e;e=c[f>>2]|0}Wc(c[n>>2]|0,e);j=a+20|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=995880;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[n>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=o;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[m>>2]>>2]|0;if(!d)d=g;else{c[m>>2]=d;d=c[f>>2]|0}Wc(c[n>>2]|0,d);m=a+20|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=o;return}function Kd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+16|0;l=o;k=ut(12)|0;c[k>>2]=995856;c[k+4>>2]=0;c[k+8>>2]=1;m=a+12|0;j=we(b,0)|0;h=F;n=a+16|0;e=c[n>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[m>>2]>>2]|0;if(!e)e=d;else{c[m>>2]=e;e=c[f>>2]|0}Wc(c[n>>2]|0,e);j=a+20|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=995856;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[n>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=o;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[m>>2]>>2]|0;if(!d)d=g;else{c[m>>2]=d;d=c[f>>2]|0}Wc(c[n>>2]|0,d);m=a+20|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=o;return}function Ld(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+16|0;l=o;k=ut(12)|0;c[k>>2]=995832;c[k+4>>2]=0;c[k+8>>2]=1;m=a+12|0;j=we(b,0)|0;h=F;n=a+16|0;e=c[n>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[m>>2]>>2]|0;if(!e)e=d;else{c[m>>2]=e;e=c[f>>2]|0}Wc(c[n>>2]|0,e);j=a+20|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=995832;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[n>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=o;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[m>>2]>>2]|0;if(!d)d=g;else{c[m>>2]=d;d=c[f>>2]|0}Wc(c[n>>2]|0,d);m=a+20|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=o;return}function Md(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+16|0;l=o;k=ut(12)|0;c[k>>2]=995808;c[k+4>>2]=0;c[k+8>>2]=1;m=a+12|0;j=we(b,0)|0;h=F;n=a+16|0;e=c[n>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[m>>2]>>2]|0;if(!e)e=d;else{c[m>>2]=e;e=c[f>>2]|0}Wc(c[n>>2]|0,e);j=a+20|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=995808;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[n>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=o;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[m>>2]>>2]|0;if(!d)d=g;else{c[m>>2]=d;d=c[f>>2]|0}Wc(c[n>>2]|0,d);m=a+20|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=o;return}function Nd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;i=i+16|0;l=o;k=ut(12)|0;c[k>>2]=995784;c[k+4>>2]=0;c[k+8>>2]=1;m=a+12|0;j=we(b,0)|0;h=F;n=a+16|0;e=c[n>>2]|0;do if(e){while(1){d=e+16|0;f=c[d>>2]|0;d=c[d+4>>2]|0;if(h>>>0<d>>>0|(h|0)==(d|0)&j>>>0<f>>>0){d=c[e>>2]|0;if(!d){f=e;g=4;break}else{e=d;continue}}if(!(d>>>0<h>>>0|(d|0)==(h|0)&f>>>0<j>>>0)){g=8;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=7;break}else e=d}if((g|0)==4){c[l>>2]=e;break}else if((g|0)==7){c[l>>2]=e;break}else if((g|0)==8){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(!d){d=ut(32)|0;g=d+16|0;c[g>>2]=j;c[g+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[m>>2]>>2]|0;if(!e)e=d;else{c[m>>2]=e;e=c[f>>2]|0}Wc(c[n>>2]|0,e);j=a+20|0;c[j>>2]=(c[j>>2]|0)+1}c[d+24>>2]=k;k=ut(12)|0;c[k>>2]=995784;c[k+4>>2]=1;c[k+8>>2]=0;h=we(b,1)|0;j=F;e=c[n>>2]|0;do if(e){while(1){f=e+16|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&h>>>0<d>>>0){d=c[e>>2]|0;if(!d){f=e;g=17;break}else{e=d;continue}}if(!(f>>>0<j>>>0|(f|0)==(j|0)&d>>>0<h>>>0)){g=21;break}f=e+4|0;d=c[f>>2]|0;if(!d){g=20;break}else e=d}if((g|0)==17){c[l>>2]=e;break}else if((g|0)==20){c[l>>2]=e;break}else if((g|0)==21){c[l>>2]=e;f=l;break}}else{e=a+16|0;c[l>>2]=e;f=e}while(0);d=c[f>>2]|0;if(d){m=d;m=m+24|0;c[m>>2]=k;i=o;return}g=ut(32)|0;d=g+16|0;c[d>>2]=h;c[d+4>>2]=j;c[g+24>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[f>>2]=g;d=c[c[m>>2]>>2]|0;if(!d)d=g;else{c[m>>2]=d;d=c[f>>2]|0}Wc(c[n>>2]|0,d);m=a+20|0;c[m>>2]=(c[m>>2]|0)+1;m=g;m=m+24|0;c[m>>2]=k;i=o;return}function Od(a,b){a=a|0;b=b|0;if(!b)return;else{Od(a,c[b>>2]|0);Od(a,c[b+4>>2]|0);xt(b);return}}function Pd(a,b){a=a|0;b=b|0;if(!b)return;else{Pd(a,c[b>>2]|0);Pd(a,c[b+4>>2]|0);xt(b);return}}function Qd(a){a=a|0;return}function Rd(a){a=a|0;xt(a);return}function Sd(a){a=a|0;return c[a+4>>2]|0}function Td(a){a=a|0;xt(a);return}function Ud(a){a=a|0;return c[a+4>>2]|0}function Vd(a){a=a|0;xt(a);return}function Wd(a){a=a|0;return c[a+4>>2]|0}function Xd(a){a=a|0;xt(a);return}function Yd(a){a=a|0;return c[a+4>>2]|0}function Zd(a){a=a|0;xt(a);return}function _d(a){a=a|0;return c[a+4>>2]|0}function $d(a){a=a|0;xt(a);return}function ae(a){a=a|0;return c[a+4>>2]|0}function be(a){a=a|0;xt(a);return}function ce(a){a=a|0;return c[a+4>>2]|0}function de(a){a=a|0;xt(a);return}function ee(a){a=a|0;return c[a+4>>2]|0}function fe(a){a=a|0;return}function ge(a){a=a|0;xt(a);return}function he(a){a=a|0;return c[a+4>>2]|0}function ie(a){a=a|0;xt(a);return}function je(a){a=a|0;return c[a+4>>2]|0}function ke(a){a=a|0;xt(a);return}function le(a){a=a|0;return c[a+4>>2]|0}function me(a){a=a|0;xt(a);return}function ne(a){a=a|0;return c[a+4>>2]|0}function oe(a){a=a|0;xt(a);return}function pe(a){a=a|0;return c[a+4>>2]|0}function qe(a){a=a|0;xt(a);return}function re(a){a=a|0;return c[a+4>>2]|0}function se(a){a=a|0;xt(a);return}function te(a){a=a|0;return c[a+4>>2]|0}function ue(a){a=a|0;xt(a);return}function ve(a){a=a|0;return c[a+4>>2]|0}function we(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;q=i;i=i+2320|0;p=q+2296|0;o=q+2280|0;j=q+2268|0;k=q+2256|0;l=q+2244|0;m=q+2232|0;n=q;zi(p,b,Ri(b,75,1)|0,-1,b);h=p+12|0;zi(h,b,0,Ri(b,75,1)|0,b);g=p+(d*12|0)|0;e=a[g>>0]|0;if(!(e&1)){f=g+1|0;b=g+1|0;g=g+((e&255)>>>1)+1|0}else{g=c[p+(d*12|0)+8>>2]|0;f=g;b=g;g=g+(c[p+(d*12|0)+4>>2]|0)|0}if((b|0)!=(g|0))while(1){a[f>>0]=Bu(a[b>>0]|0)|0;b=b+1|0;if((b|0)==(g|0))break;else f=f+1|0}b=a[p>>0]|0;if(!(b&1)){c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;g=(b&255)>>>1;f=(b&255)>>>1;b=p+1|0;e=m}else{g=c[p+4>>2]|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=c[p+4>>2]|0;b=c[p+8>>2]|0;e=m}Ui(m,b,f,f+1|0);Ki(m,56-g&255);c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;b=a[e>>0]|0;if(!(b&1)){b=(b&255)>>>1;e=m+1|0}else{b=c[m+4>>2]|0;e=c[m+8>>2]|0}Ui(l,e,b,b+13|0);Li(l,995744,13)|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;b=a[l>>0]|0;g=(b&1)==0;if(g)b=(b&255)>>>1;else b=c[l+4>>2]|0;f=a[h>>0]|0;if(!(f&1))e=(f&255)>>>1;else e=c[p+16>>2]|0;if(g)f=l+1|0;else f=c[l+8>>2]|0;Ui(k,f,b,e+b|0);if(!(a[h>>0]&1))b=h+1|0;else b=c[p+20>>2]|0;Li(k,b,e)|0;e=a[h>>0]|0;if(!(e&1))f=(e&255)>>>1;else f=c[p+16>>2]|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;e=a[k>>0]|0;if(!(e&1)){b=(e&255)>>>1;e=k+1|0}else{b=c[k+4>>2]|0;e=c[k+8>>2]|0}Ui(j,e,b,b+1|0);Ki(j,56-f&255);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;e=a[j>>0]|0;if(!(e&1)){e=(e&255)>>>1;b=j+1|0}else{e=c[j+4>>2]|0;b=c[j+8>>2]|0}Ui(o,b,e,e+11|0);Li(o,995760,11)|0;Bi(j);Bi(k);Bi(l);Bi(m);Zf(n,o,0,0);l=(c[n+2220>>2]|0)+8|0;m=c[l>>2]|0;l=c[l+4>>2]|0;Bi(o);Bi(p+12|0);Bi(p);F=l;i=q;return m|0}function xe(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0;ob=e+2220|0;fb=c[(c[ob>>2]|0)+36>>2]|0;mb=Te(e)|0;l=c[mb+12>>2]|0;if(l){Wa=oc[c[(c[l>>2]|0)+12>>2]&63](l,e)|0;Wa=Wa+17|0;return Wa|0}bb=(b[mb+8>>1]|0)*65537|0;lb=Pf(e)|0;eb=c[lb+8>>2]|0;db=(ba(eb+32768>>16,c[249300]|0)|0)/256|0;eb=(ba(eb<<16>>16,c[249301]|0)|0)/256|0;Ba=bg(e,0,0)|0;Ca=F;$a=e+1296|0;Ya=50400+(c[$a>>2]<<3)|0;Xa=c[Ya>>2]|0;Ya=c[Ya+4>>2]|0;jb=lb+32|0;ib=c[jb>>2]|0;jb=c[jb+4>>2]|0;if((c[(c[ob>>2]|0)+16>>2]|0)>2520){l=jv(Xa|0,Ya|0,8)|0;l=l|Xa;i=F|Ya;k=ib&Xa;j=jb&Ya;if((k|0)==0&(j|0)==0)f=0;else{Wa=k-(k>>>1&1431655765)|0;f=jv(k|0,j|0,33)|0;f=j-(f&1431655765)|0;f=(ba((f&858993459)+(Wa&858993459)+(Wa>>>2&858993459)+(f>>>2&858993459)|0,286331153)|0)>>>28}}else{l=0;i=0;f=0}La=bg(e,1,1)|0;Ma=F;_a=e+784|0;Ja=c[_a>>2]|0;Ua=50400+(Ja<<3)|0;Ta=c[Ua>>2]|0;Ua=c[Ua+4>>2]|0;hb=lb+40|0;gb=c[hb>>2]|0;hb=c[hb+4>>2]|0;Aa=c[ob>>2]|0;if((c[Aa+20>>2]|0)>2520){h=ov(Ta|0,Ua|0,8)|0;h=h|Ta;g=F|Ua;k=gb&Ta;j=hb&Ua;if((k|0)==0&(j|0)==0)u=0;else{Wa=k-(k>>>1&1431655765)|0;u=jv(k|0,j|0,33)|0;u=j-(u&1431655765)|0;u=(ba((u&858993459)+(Wa&858993459)+(Wa>>>2&858993459)+(u>>>2&858993459)|0,286331153)|0)>>>28}}else{u=0;h=0;g=0}B=Ta|ib;C=Ua|jb;T=gb|Xa;S=hb|Ya;ab=e+320|0;ha=ab;fa=c[ha>>2]|0;ha=c[ha+4>>2]|0;kb=e+264|0;ia=kb;ga=c[ia>>2]|0;ia=c[ia+4>>2]|0;wa=e+304|0;va=c[wa>>2]|ga;wa=c[wa+4>>2]|ia;ra=~(va&fa|gb);sa=~(wa&ha|hb);cb=e+328|0;ea=cb;da=c[ea>>2]|0;ea=c[ea+4>>2]|0;va=~(va&da|ib);wa=~(wa&ea|jb);z=c[e+528>>2]|0;if((z|0)==64){Za=0;Ha=0;Ia=0;k=0;j=0;m=B;p=0}else{y=da&ga;A=ea&ia;D=e+272|0;I=e+280|0;D=(c[D>>2]&da|0)==0?(c[D+4>>2]&ea|0)==0:0;E=c[249288]|0;G=c[249272]|0;H=c[I>>2]&da;I=c[I+4>>2]&ea;r=0;s=0;m=B;j=0;q=0;p=0;B=0;w=e+532|0;while(1){n=48352+(z<<3)|0;o=c[n>>2]|0;n=c[n+4>>2]|0;v=46496+(z<<3)|0;t=c[v>>2]|0;v=c[v+4>>2]|0;if(!((t&Ba|0)==0&(v&Ca|0)==0)){Wa=66784+(Ja<<9)+(z<<3)|0;o=c[Wa>>2]&o;n=c[Wa+4>>2]&n}r=o|r;s=n|s;x=r|m;C=s|C;if(!((o&l|0)==0&(n&i|0)==0)){f=f+1|0;j=j+6|0;m=o&Xa;k=n&Ya;if((m|0)==0&(k|0)==0)k=q;else{Wa=m-(m>>>1&1431655765)|0;Va=jv(m|0,k|0,33)|0;k=k-(Va&1431655765)|0;k=((ba((k&858993459)+(Wa&858993459)+(Wa>>>2&858993459)+(k>>>2&858993459)|0,286331153)|0)>>>28)+q|0}}else k=q;Wa=o&ra;Sa=n&sa;Va=Wa-(Wa>>>1&1431655765)|0;Wa=jv(Wa|0,Sa|0,33)|0;Wa=Sa-(Wa&1431655765)|0;p=(c[996440+((ba((Wa&858993459)+(Va&858993459)+(Va>>>2&858993459)+(Wa>>>2&858993459)|0,286331153)|0)>>>28<<2)>>2]|0)+p|0;B=B-((t&gb|0)==0&(v&hb|0)==0?0:G)|0;Wa=61664+(z<<3)|0;if((y&c[Wa>>2]|0)==0?(A&c[Wa+4>>2]|0)==0:0){o=c[999280+(z<<2)>>2]|0;do if(o){if(!((t&ib|0)==0&(v&jb|0)==0)){if(D?(Wa=(t&-1437226411|0)!=0|(v&-1437226411|0)!=0,(H&(Wa?-1437226411:1437226410)|0)==0&(I&(Wa?-1437226411:1437226410)|0)==0):0){o=((o|0)/2|0)+(o<<1)|0;break}o=((o|0)/2|0)+o|0}}else o=0;while(0);B=((o|0)/2|0)+B+(o<<17)|0}if((z>>3|0)<4){Wa=46496+(z+8<<3)|0;B=(((c[Wa>>2]&ga|0)==0?(c[Wa+4>>2]&ia|0)==0:0)?0:E)+B|0}z=c[w>>2]|0;if((z|0)==64){Za=B;Ha=r;Ia=s;m=x;break}else{m=x;q=k;w=w+4|0}}}B=c[e+1040>>2]|0;if((B|0)==64){Va=0;xa=0;ya=0;v=0;t=0;E=T;I=S;A=0}else{D=c[$a>>2]|0;y=ga&fa;z=ia&ha;J=e+272|0;N=e+280|0;J=(c[J>>2]&fa|0)==0?(c[J+4>>2]&ha|0)==0:0;K=c[249288]|0;L=c[249272]|0;M=c[N>>2]&fa;N=c[N+4>>2]&ha;w=0;x=0;s=T;r=S;t=0;v=0;A=0;o=0;G=e+1044|0;while(1){q=48352+(B<<3)|0;n=c[q>>2]|0;q=c[q+4>>2]|0;H=46496+(B<<3)|0;I=c[H>>2]|0;H=c[H+4>>2]|0;if(!((I&La|0)==0&(H&Ma|0)==0)){Wa=66784+(D<<9)+(B<<3)|0;n=c[Wa>>2]&n;q=c[Wa+4>>2]&q}w=n|w;x=q|x;E=w|s;O=x|r;if(!((n&h|0)==0&(q&g|0)==0)){u=u+1|0;t=t+6|0;r=n&Ta;s=q&Ua;if(!((r|0)==0&(s|0)==0)){Va=r-(r>>>1&1431655765)|0;Wa=jv(r|0,s|0,33)|0;Wa=s-(Wa&1431655765)|0;v=((ba((Wa&858993459)+(Va&858993459)+(Va>>>2&858993459)+(Wa>>>2&858993459)|0,286331153)|0)>>>28)+v|0}}Wa=n&va;Sa=q&wa;Va=Wa-(Wa>>>1&1431655765)|0;Wa=jv(Wa|0,Sa|0,33)|0;Wa=Sa-(Wa&1431655765)|0;A=(c[996440+((ba((Wa&858993459)+(Va&858993459)+(Va>>>2&858993459)+(Wa>>>2&858993459)|0,286331153)|0)>>>28<<2)>>2]|0)+A|0;o=o-((I&ib|0)==0&(H&jb|0)==0?0:L)|0;Wa=62176+(B<<3)|0;if((y&c[Wa>>2]|0)==0?(z&c[Wa+4>>2]|0)==0:0){n=c[999280+((B^56)<<2)>>2]|0;do if(n){if(!((I&gb|0)==0&(H&hb|0)==0)){if(J?(Wa=(I&-1437226411|0)!=0|(H&-1437226411|0)!=0,(M&(Wa?-1437226411:1437226410)|0)==0&(N&(Wa?-1437226411:1437226410)|0)==0):0){n=((n|0)/2|0)+(n<<1)|0;break}n=((n|0)/2|0)+n|0}}else n=0;while(0);o=((n|0)/2|0)+o+(n<<17)|0}if((B>>3^7|0)<4){Wa=46496+(B+-8<<3)|0;o=(((c[Wa>>2]&ga|0)==0?(c[Wa+4>>2]&ia|0)==0:0)?0:K)+o|0}B=c[G>>2]|0;if((B|0)==64){Va=o;xa=w;ya=x;I=O;break}else{s=E;r=O;G=G+4|0}}}Wa=e+592|0;B=c[Wa>>2]|0;if((B|0)==64){Ra=0;ta=0;ua=0}else{H=e+256|0;G=e+296|0;J=c[G>>2]&fa^c[H>>2];H=c[G+4>>2]&ha^c[H+4>>2];G=da&ga;D=ea&ia;w=e+272|0;S=e+280|0;w=(c[w>>2]&da|0)==0?(c[w+4>>2]&ea|0)==0:0;x=c[249288]|0;y=c[249286]|0;z=(a[e+2224>>0]|0)==0;P=c[249296]|0;Q=c[249273]|0;R=c[S>>2]&da;S=c[S+4>>2]&ea;O=0;N=0;o=0;K=e+596|0;while(1){n=45728+(B<<3)|0;q=45216+(B<<3)|0;q=(ba(c[n+4>>2]&H,c[q+4>>2]|0)|0)^(ba(c[n>>2]&J,c[q>>2]|0)|0);q=(c[43680+(B<<2)>>2]|0)+(q>>>(c[46240+(B<<2)>>2]|0)<<3)|0;n=c[q>>2]|0;q=c[q+4>>2]|0;L=46496+(B<<3)|0;M=c[L>>2]|0;L=c[L+4>>2]|0;if(!((M&Ba|0)==0&(L&Ca|0)==0)){Sa=66784+(Ja<<9)+(B<<3)|0;n=c[Sa>>2]&n;q=c[Sa+4>>2]&q}O=n|O;N=q|N;m=O|m;C=N|C;if(!((n&l|0)==0&(q&i|0)==0)){f=f+1|0;j=j+2|0;r=n&Xa;s=q&Ya;if(!((r|0)==0&(s|0)==0)){Ra=r-(r>>>1&1431655765)|0;Sa=jv(r|0,s|0,33)|0;Sa=s-(Sa&1431655765)|0;k=((ba((Sa&858993459)+(Ra&858993459)+(Ra>>>2&858993459)+(Sa>>>2&858993459)|0,286331153)|0)>>>28)+k|0}}Sa=n&ra;Ka=q&sa;Ra=Sa-(Sa>>>1&1431655765)|0;Sa=jv(Sa|0,Ka|0,33)|0;Sa=Ka-(Sa&1431655765)|0;p=(c[996568+((ba((Sa&858993459)+(Ra&858993459)+(Ra>>>2&858993459)+(Sa>>>2&858993459)|0,286331153)|0)>>>28<<2)>>2]|0)+p|0;o=o-((M&gb|0)==0&(L&hb|0)==0?0:Q)|0;Sa=61664+(B<<3)|0;if((G&c[Sa>>2]|0)==0?(D&c[Sa+4>>2]|0)==0:0){n=c[999536+(B<<2)>>2]|0;do if(n){if(!((M&ib|0)==0&(L&jb|0)==0)){if(w?(Sa=(M&-1437226411|0)!=0|(L&-1437226411|0)!=0,(R&(Sa?-1437226411:1437226410)|0)==0&(S&(Sa?-1437226411:1437226410)|0)==0):0){n=((n|0)/2|0)+(n<<1)|0;break}n=((n|0)/2|0)+n|0}}else n=0;while(0);o=((n|0)/2|0)+o+(n<<17)|0}if((B>>3|0)<4){Sa=46496+(B+8<<3)|0;o=(((c[Sa>>2]&ga|0)==0?(c[Sa+4>>2]&ia|0)==0:0)?0:x)+o|0}o=o-(ba(c[lb+((((M&-1437226411|0)!=0|(L&-1437226411|0)!=0)&1)<<2)+96>>2]|0,y)|0)|0;if((!z?(B|0)==7|(B|0)==0:0)?($=(B&7|0)==0?9:7,_=$+B|0,(c[e+(_<<2)>>2]|0)==1):0){if(!(c[e+(_+8<<2)>>2]|0))B=(c[e+(_+$<<2)>>2]|0)==1&1;else B=2;o=o-(P<<B)|0}B=c[K>>2]|0;if((B|0)==64){Ra=o;ta=O;ua=N;break}else K=K+4|0}}Sa=e+1104|0;B=c[Sa>>2]|0;if((B|0)==64){Ka=0;pa=0;qa=0;M=E;$=I}else{Q=e+256|0;P=e+296|0;R=c[P>>2]&da^c[Q>>2];Q=c[P+4>>2]&ea^c[Q+4>>2];P=ga&fa;K=ia&ha;J=e+272|0;T=e+280|0;J=(c[J>>2]&fa|0)==0?(c[J+4>>2]&ha|0)==0:0;H=c[249288]|0;G=c[249286]|0;D=(a[e+2224>>0]|0)==0;w=c[249296]|0;x=c[249273]|0;y=c[$a>>2]|0;z=c[T>>2]&fa;T=c[T+4>>2]&ha;o=0;S=e+1108|0;O=0;N=0;while(1){n=45728+(B<<3)|0;q=45216+(B<<3)|0;q=(ba(c[n+4>>2]&Q,c[q+4>>2]|0)|0)^(ba(c[n>>2]&R,c[q>>2]|0)|0);q=(c[43680+(B<<2)>>2]|0)+(q>>>(c[46240+(B<<2)>>2]|0)<<3)|0;n=c[q>>2]|0;q=c[q+4>>2]|0;L=46496+(B<<3)|0;M=c[L>>2]|0;L=c[L+4>>2]|0;if(!((M&La|0)==0&(L&Ma|0)==0)){Ka=66784+(y<<9)+(B<<3)|0;n=c[Ka>>2]&n;q=c[Ka+4>>2]&q}O=n|O;N=q|N;E=O|E;I=N|I;if(!((n&h|0)==0&(q&g|0)==0)){u=u+1|0;t=t+2|0;r=n&Ta;s=q&Ua;if(!((r|0)==0&(s|0)==0)){za=r-(r>>>1&1431655765)|0;Ka=jv(r|0,s|0,33)|0;Ka=s-(Ka&1431655765)|0;v=((ba((Ka&858993459)+(za&858993459)+(za>>>2&858993459)+(Ka>>>2&858993459)|0,286331153)|0)>>>28)+v|0}}Ka=n&va;qa=q&wa;za=Ka-(Ka>>>1&1431655765)|0;Ka=jv(Ka|0,qa|0,33)|0;Ka=qa-(Ka&1431655765)|0;A=(c[996568+((ba((Ka&858993459)+(za&858993459)+(za>>>2&858993459)+(Ka>>>2&858993459)|0,286331153)|0)>>>28<<2)>>2]|0)+A|0;o=o-((M&ib|0)==0&(L&jb|0)==0?0:x)|0;Ka=62176+(B<<3)|0;if((P&c[Ka>>2]|0)==0?(K&c[Ka+4>>2]|0)==0:0){n=c[999536+((B^56)<<2)>>2]|0;do if(n){if(!((M&gb|0)==0&(L&hb|0)==0)){if(J?(Ka=(M&-1437226411|0)!=0|(L&-1437226411|0)!=0,(z&(Ka?-1437226411:1437226410)|0)==0&(T&(Ka?-1437226411:1437226410)|0)==0):0){n=((n|0)/2|0)+(n<<1)|0;break}n=((n|0)/2|0)+n|0}}else n=0;while(0);o=((n|0)/2|0)+o+(n<<17)|0}if((B>>3^7|0)<4){Ka=46496+(B+-8<<3)|0;o=(((c[Ka>>2]&ga|0)==0?(c[Ka+4>>2]&ia|0)==0:0)?0:H)+o|0}o=o-(ba(c[lb+((((M&-1437226411|0)!=0|(L&-1437226411|0)!=0)&1)<<2)+104>>2]|0,G)|0)|0;if((!D?(B|0)==63|(B|0)==56:0)?(U=(B&7|0)==0?-7:-9,V=U+B|0,(c[e+(V<<2)>>2]|0)==9):0){if(!(c[e+(V+-8<<2)>>2]|0))B=(c[e+(V+U<<2)>>2]|0)==9&1;else B=2;o=o-(w<<B)|0}B=c[S>>2]|0;if((B|0)==64){Ka=o;pa=O;qa=N;M=E;$=I;break}else S=S+4|0}}B=c[e+656>>2]|0;if((B|0)==64){za=0;ca=0;aa=0}else{T=Ja&7;R=T>>>0<4;Q=Ja>>3;P=(Q|0)==0;J=(1<<T)+-1|0;n=Aa+24|0;q=-1<<T+1;r=lb+84|0;w=e+256|0;x=e+288|0;y=e+296|0;s=(c[y>>2]|c[x>>2])&fa^c[w>>2];w=(c[y+4>>2]|c[x+4>>2])&ha^c[w+4>>2];x=da&ga;y=ea&ia;z=c[249280]|0;U=c[lb+80>>2]|0;V=c[249290]|0;W=c[249282]|0;X=c[249284]|0;Y=c[249274]|0;L=0;K=0;o=0;S=e+660|0;while(1){I=44448+(B<<3)|0;H=43936+(B<<3)|0;H=(ba(c[I+4>>2]&w,c[H+4>>2]|0)|0)^(ba(c[I>>2]&s,c[H>>2]|0)|0);H=(c[43424+(B<<2)>>2]|0)+(H>>>(c[44960+(B<<2)>>2]|0)<<3)|0;I=c[H>>2]|0;H=c[H+4>>2]|0;N=46496+(B<<3)|0;O=c[N>>2]|0;N=c[N+4>>2]|0;if(!((O&Ba|0)==0&(N&Ca|0)==0)){za=66784+(Ja<<9)+(B<<3)|0;I=c[za>>2]&I;H=c[za+4>>2]&H}L=I|L;K=H|K;m=L|m;C=K|C;if(!((I&l|0)==0&(H&i|0)==0)){f=f+1|0;j=j+5|0;G=I&Xa;E=H&Ya;if(!((G|0)==0&(E|0)==0)){_=G-(G>>>1&1431655765)|0;za=jv(G|0,E|0,33)|0;za=E-(za&1431655765)|0;k=((ba((za&858993459)+(_&858993459)+(_>>>2&858993459)+(za>>>2&858993459)|0,286331153)|0)>>>28)+k|0}}E=I&ra;G=H&sa;D=E-(E>>>1&1431655765)|0;E=jv(E|0,G|0,33)|0;E=G-(E&1431655765)|0;E=ba((E&858993459)+(D&858993459)+(D>>>2&858993459)+(E>>>2&858993459)|0,286331153)|0;D=E>>>28;p=(c[996696+(D<<2)>>2]|0)+p|0;o=o-((O&gb|0)==0&(N&hb|0)==0?0:Y)|0;G=B>>3;if((G|0)>3?(aa=64736+(B<<3)|0,Z=x&c[aa>>2],aa=y&c[aa+4>>2],!((Z|0)==0&(aa|0)==0)):0){_=Z-(Z>>>1&1431655765)|0;za=jv(Z|0,aa|0,33)|0;za=aa-(za&1431655765)|0;o=(ba((ba((za&858993459)+(_&858993459)+(_>>>2&858993459)+(za>>>2&858993459)|0,286331153)|0)>>>28,z)|0)+o|0}I=B&7;H=1<<I;if(!(H&U)){if((E>>>0<=1073741823?(ca=I>>>0<T>>>0,((Q|0)==(G|0)|P)&(R^ca^1)):0)?((ca?J:q)&U|0)==0:0){za=(ba(D,-1441792)|0)+V|0;o=o-(ba((c[n>>2]&3|0)==0?2:1,za)|0)|0}}else o=((c[r>>2]&H|0)!=0?W:X)+o|0;B=c[S>>2]|0;if((B|0)==64){za=o;ca=L;aa=K;break}else S=S+4|0}}B=c[e+1168>>2]|0;if((B|0)!=64){J=e+1172|0;_=e+256|0;E=c[$a>>2]|0;D=E&7;w=D>>>0<4;Y=E>>3;x=(1<<D)+-1|0;y=Aa+24|0;z=-1<<D+1;Z=lb+80|0;P=_;Q=e+288|0;X=e+296|0;G=(c[X>>2]|c[Q>>2])&da^c[P>>2];P=(c[X+4>>2]|c[Q+4>>2])&ea^c[P+4>>2];Q=ga&fa;X=ia&ha;W=c[249280]|0;V=c[lb+84>>2]|0;U=c[249290]|0;T=c[249282]|0;S=c[249284]|0;R=c[249274]|0;if((Y|0)==7){H=B;L=0;K=0;I=$;B=0;while(1){o=44448+(H<<3)|0;n=43936+(H<<3)|0;n=(ba(c[o+4>>2]&P,c[n+4>>2]|0)|0)^(ba(c[o>>2]&G,c[n>>2]|0)|0);n=(c[43424+(H<<2)>>2]|0)+(n>>>(c[44960+(H<<2)>>2]|0)<<3)|0;o=c[n>>2]|0;n=c[n+4>>2]|0;N=46496+(H<<3)|0;O=c[N>>2]|0;N=c[N+4>>2]|0;if(!((O&La|0)==0&(N&Ma|0)==0)){oa=66784+(E<<9)+(H<<3)|0;o=c[oa>>2]&o;n=c[oa+4>>2]&n}L=o|L;K=n|K;M=L|M;I=K|I;if(!((o&h|0)==0&(n&g|0)==0)){u=u+1|0;t=t+5|0;q=o&Ta;r=n&Ua;if(!((q|0)==0&(r|0)==0)){na=q-(q>>>1&1431655765)|0;oa=jv(q|0,r|0,33)|0;oa=r-(oa&1431655765)|0;v=((ba((oa&858993459)+(na&858993459)+(na>>>2&858993459)+(oa>>>2&858993459)|0,286331153)|0)>>>28)+v|0}}q=o&va;oa=n&wa;r=q-(q>>>1&1431655765)|0;q=jv(q|0,oa|0,33)|0;q=oa-(q&1431655765)|0;q=ba((q&858993459)+(r&858993459)+(r>>>2&858993459)+(q>>>2&858993459)|0,286331153)|0;r=q>>>28;A=(c[996696+(r<<2)>>2]|0)+A|0;B=B-((O&ib|0)==0&(N&jb|0)==0?0:R)|0;if((H>>3^7|0)>3?(ka=64736+(H<<3)|0,ja=c[ka>>2]&Q,ka=c[ka+4>>2]&X,!((ja|0)==0&(ka|0)==0)):0){na=ja-(ja>>>1&1431655765)|0;oa=jv(ja|0,ka|0,33)|0;oa=ka-(oa&1431655765)|0;B=(ba((ba((oa&858993459)+(na&858993459)+(na>>>2&858993459)+(oa>>>2&858993459)|0,286331153)|0)>>>28,W)|0)+B|0}o=H&7;n=1<<o;do if(!(n&V)){if(q>>>0<=1073741823?(la=o>>>0<D>>>0,!(w^la)):0){if((la?x:z)&V)break;oa=(ba(r,-1441792)|0)+U|0;B=B-(ba((c[y>>2]&12|0)==0?2:1,oa)|0)|0}}else B=((c[Z>>2]&n|0)!=0?T:S)+B|0;while(0);H=c[J>>2]|0;if((H|0)==64){oa=B;Y=v;break}else J=J+4|0}}else{H=B;L=0;K=0;I=$;B=0;while(1){o=44448+(H<<3)|0;n=43936+(H<<3)|0;n=(ba(c[o+4>>2]&P,c[n+4>>2]|0)|0)^(ba(c[o>>2]&G,c[n>>2]|0)|0);n=(c[43424+(H<<2)>>2]|0)+(n>>>(c[44960+(H<<2)>>2]|0)<<3)|0;o=c[n>>2]|0;n=c[n+4>>2]|0;N=46496+(H<<3)|0;O=c[N>>2]|0;N=c[N+4>>2]|0;if(!((O&La|0)==0&(N&Ma|0)==0)){la=66784+(E<<9)+(H<<3)|0;o=c[la>>2]&o;n=c[la+4>>2]&n}L=o|L;K=n|K;M=L|M;I=K|I;if(!((o&h|0)==0&(n&g|0)==0)){u=u+1|0;t=t+5|0;q=o&Ta;r=n&Ua;if(!((q|0)==0&(r|0)==0)){ka=q-(q>>>1&1431655765)|0;la=jv(q|0,r|0,33)|0;la=r-(la&1431655765)|0;v=((ba((la&858993459)+(ka&858993459)+(ka>>>2&858993459)+(la>>>2&858993459)|0,286331153)|0)>>>28)+v|0}}r=o&va;q=n&wa;s=r-(r>>>1&1431655765)|0;r=jv(r|0,q|0,33)|0;r=q-(r&1431655765)|0;r=ba((r&858993459)+(s&858993459)+(s>>>2&858993459)+(r>>>2&858993459)|0,286331153)|0;s=r>>>28;A=(c[996696+(s<<2)>>2]|0)+A|0;B=B-((O&ib|0)==0&(N&jb|0)==0?0:R)|0;q=H>>3;if((q^7|0)>3?(na=64736+(H<<3)|0,ma=c[na>>2]&Q,na=c[na+4>>2]&X,!((ma|0)==0&(na|0)==0)):0){ka=ma-(ma>>>1&1431655765)|0;la=jv(ma|0,na|0,33)|0;la=na-(la&1431655765)|0;B=(ba((ba((la&858993459)+(ka&858993459)+(ka>>>2&858993459)+(la>>>2&858993459)|0,286331153)|0)>>>28,W)|0)+B|0}o=H&7;n=1<<o;do if(!(n&V)){if(r>>>0<=1073741823?(oa=o>>>0<D>>>0,(Y|0)==(q|0)&(w^oa^1)):0){if((oa?x:z)&V)break;la=(ba(s,-1441792)|0)+U|0;B=B-(ba((c[y>>2]&12|0)==0?2:1,la)|0)|0}}else B=((c[Z>>2]&n|0)!=0?T:S)+B|0;while(0);H=c[J>>2]|0;if((H|0)==64){oa=B;Y=v;break}else J=J+4|0}}}else{oa=0;_=e+256|0;L=0;K=0;Y=v;I=$}R=pa|xa;T=qa|ya;N=~(L|R)&ra;O=~(K|T)&sa;$=c[249275]|0;J=0;o=0;n=0;B=e+720|0;a:while(1){w=m;q=k;x=p;while(1){v=B+4|0;B=c[B>>2]|0;if((B|0)==64){G=o;P=n;ha=w;ia=C;break a}sa=_;m=c[sa>>2]|0;sa=c[sa+4>>2]|0;r=44448+(B<<3)|0;k=43936+(B<<3)|0;k=(ba(c[r+4>>2]&sa,c[k+4>>2]|0)|0)^(ba(c[r>>2]&m,c[k>>2]|0)|0);k=(c[43424+(B<<2)>>2]|0)+(k>>>(c[44960+(B<<2)>>2]|0)<<3)|0;r=45728+(B<<3)|0;s=45216+(B<<3)|0;s=(ba(c[r+4>>2]&sa,c[s+4>>2]|0)|0)^(ba(c[r>>2]&m,c[s>>2]|0)|0);s=(c[43680+(B<<2)>>2]|0)+(s>>>(c[46240+(B<<2)>>2]|0)<<3)|0;m=c[s>>2]|c[k>>2];k=c[s+4>>2]|c[k+4>>2];s=46496+(B<<3)|0;r=c[s>>2]|0;s=c[s+4>>2]|0;if(!((r&Ba|0)==0&(s&Ca|0)==0)){sa=66784+(Ja<<9)+(B<<3)|0;m=c[sa>>2]&m;k=c[sa+4>>2]&k}o=m|o;n=k|n;w=o|w;C=n|C;if(!((m&l|0)==0&(k&i|0)==0)){f=f+1|0;p=j+5|0;B=m&Xa;j=k&Ya;if((B|0)==0&(j|0)==0)j=p;else{sa=B-(B>>>1&1431655765)|0;ra=jv(B|0,j|0,33)|0;j=j-(ra&1431655765)|0;q=((ba((j&858993459)+(sa&858993459)+(sa>>>2&858993459)+(j>>>2&858993459)|0,286331153)|0)>>>28)+q|0;j=p}}p=N&m;ra=O&k;sa=p-(p>>>1&1431655765)|0;p=jv(p|0,ra|0,33)|0;p=ra-(p&1431655765)|0;sa=(sa>>>2&858993459)+(sa&858993459)|0;p=(p>>>2&858993459)+(p&858993459)|0;p=(c[996824+((ba(p+sa+(sa>>>4)+(p>>>4)&252645135,16843009)|0)>>>24<<2)>>2]|0)+x|0;if((r&gb|0)==0&(s&hb|0)==0){x=p;B=v}else{B=v;k=q;m=w;break}}J=J-$|0}H=c[$a>>2]|0;D=ta|Ha;E=ua|Ia;N=~(ca|D)&va;O=~(aa|E)&wa;S=0;k=Y;l=t;n=u;m=M;i=I;B=0;o=0;C=e+1232|0;b:while(1){u=m;v=i;while(1){t=C+4|0;C=c[C>>2]|0;if((C|0)==64){Q=u;N=v;_=B;u=o;break b}wa=_;m=c[wa>>2]|0;wa=c[wa+4>>2]|0;r=44448+(C<<3)|0;i=43936+(C<<3)|0;i=(ba(c[r+4>>2]&wa,c[i+4>>2]|0)|0)^(ba(c[r>>2]&m,c[i>>2]|0)|0);i=(c[43424+(C<<2)>>2]|0)+(i>>>(c[44960+(C<<2)>>2]|0)<<3)|0;r=45728+(C<<3)|0;s=45216+(C<<3)|0;s=(ba(c[r+4>>2]&wa,c[s+4>>2]|0)|0)^(ba(c[r>>2]&m,c[s>>2]|0)|0);s=(c[43680+(C<<2)>>2]|0)+(s>>>(c[46240+(C<<2)>>2]|0)<<3)|0;m=c[s>>2]|c[i>>2];i=c[s+4>>2]|c[i+4>>2];s=46496+(C<<3)|0;r=c[s>>2]|0;s=c[s+4>>2]|0;if(!((r&La|0)==0&(s&Ma|0)==0)){wa=66784+(H<<9)+(C<<3)|0;m=c[wa>>2]&m;i=c[wa+4>>2]&i}B=m|B;o=i|o;u=B|u;v=o|v;if(!((m&h|0)==0&(i&g|0)==0)){n=n+1|0;l=l+5|0;C=m&Ta;p=i&Ua;if(!((C|0)==0&(p|0)==0)){va=C-(C>>>1&1431655765)|0;wa=jv(C|0,p|0,33)|0;wa=p-(wa&1431655765)|0;k=((ba((wa&858993459)+(va&858993459)+(va>>>2&858993459)+(wa>>>2&858993459)|0,286331153)|0)>>>28)+k|0}}wa=N&m;sa=O&i;va=wa-(wa>>>1&1431655765)|0;wa=jv(wa|0,sa|0,33)|0;wa=sa-(wa&1431655765)|0;va=(va>>>2&858993459)+(va&858993459)|0;wa=(wa>>>2&858993459)+(wa&858993459)|0;A=(c[996824+((ba(wa+va+(va>>>4)+(wa>>>4)&252645135,16843009)|0)>>>24<<2)>>2]|0)+A|0;if((r&ib|0)==0&(s&jb|0)==0)C=t;else{C=t;m=u;i=v;break}}S=S-$|0}M=x-A|0;I=(ba(c[249298]|0,M+32768>>16)|0)/256|0;M=(ba(c[249299]|0,M<<16>>16)|0)/256|0;if((c[lb+48>>2]|0)==(Ja|0)?(c[lb+72>>2]|0)==(c[Aa+24>>2]&3|0):0)i=c[lb+56>>2]|0;else{i=Mf(lb,e,Ja)|0;c[lb+56>>2]=i}if(!n)H=i;else{C=Ta&~(Ha|ib|ta|ca|G)&Q;m=Ua&~(Ia|jb|ua|aa|P)&N;n=ba(n,l)|0;o=C-(C>>>1&1431655765)|0;s=jv(C|0,m|0,33)|0;s=m-(s&1431655765)|0;s=((ba((s&858993459)+(o&858993459)+(o>>>2&858993459)+(s>>>2&858993459)|0,286331153)|0)>>>28)*19|0;s=(k*10|0)+((Ba|0)!=0|(Ca|0)!=0?9:0)+((n|0)<77?n:77)+s+(((i+32768>>16)*63|0)/-512|0)+((c[e+388>>2]|0)==0?-60:0)|0;n=cb;o=c[n>>2]|0;n=c[n+4>>2]|0;A=~o;B=~n;z=_&C&A;y=u&m&B;if(!((z|0)==0&(y|0)==0)?(Da=z&(xa|gb|pa|L),Ea=y&(ya|hb|qa|K),!((Da|0)==0&(Ea|0)==0)):0){Ca=Da-(Da>>>1&1431655765)|0;Da=jv(Da|0,Ea|0,33)|0;Ea=Ea-(Da&1431655765)|0;s=(((ba((Ea&858993459)+(Ca&858993459)+(Ca>>>2&858993459)+(Ea>>>2&858993459)|0,286331153)|0)>>>28)*92|0)+s|0}y=64736+(Ja<<3)|0;z=C&L&A&c[y>>2];y=m&K&B&c[y+4>>2];if(!((z|0)==0&(y|0)==0)?(Fa=z&(xa|gb|pa|_),Ga=y&(ya|hb|qa|u),!((Fa|0)==0&(Ga|0)==0)):0){Ea=Fa-(Fa>>>1&1431655765)|0;Fa=jv(Fa|0,Ga|0,33)|0;Ga=Ga-(Fa&1431655765)|0;s=(((ba((Ga&858993459)+(Ea&858993459)+(Ea>>>2&858993459)+(Ga>>>2&858993459)|0,286331153)|0)>>>28)*68|0)+s|0}B=~(o|ha);o=~(n|ia);y=e+256|0;v=c[y>>2]|0;y=c[y+4>>2]|0;x=44448+(Ja<<3)|0;w=43936+(Ja<<3)|0;w=(ba(c[x+4>>2]&y,c[w+4>>2]|0)|0)^(ba(c[x>>2]&v,c[w>>2]|0)|0);w=(c[43424+(Ja<<2)>>2]|0)+(w>>>(c[44960+(Ja<<2)>>2]|0)<<3)|0;x=c[w>>2]&B;w=c[w+4>>2]&o;z=45728+(Ja<<3)|0;A=45216+(Ja<<3)|0;A=(ba(c[z+4>>2]&y,c[A+4>>2]|0)|0)^(ba(c[z>>2]&v,c[A>>2]|0)|0);A=(c[43680+(Ja<<2)>>2]|0)+(A>>>(c[46240+(Ja<<2)>>2]|0)<<3)|0;v=c[A>>2]&B;A=c[A+4>>2]&o;z=(v|x)&_;y=(A|w)&u;if(!((z|0)==0&(y|0)==0)){Fa=z-(z>>>1&1431655765)|0;Ga=jv(z|0,y|0,33)|0;Ga=y-(Ga&1431655765)|0;s=(((ba((Ga&858993459)+(Fa&858993459)+(Fa>>>2&858993459)+(Ga>>>2&858993459)|0,286331153)|0)>>>28)*50|0)+s|0}z=x&L;y=w&K;if(!((z|0)==0&(y|0)==0)){Fa=z-(z>>>1&1431655765)|0;Ga=jv(z|0,y|0,33)|0;Ga=y-(Ga&1431655765)|0;s=s+(((ba((Ga&858993459)+(Fa&858993459)+(Fa>>>2&858993459)+(Ga>>>2&858993459)|0,286331153)|0)>>>28)*36|0)|0}x=v&pa;y=A&qa;if(!((x|0)==0&(y|0)==0)){Fa=x-(x>>>1&1431655765)|0;Ga=jv(x|0,y|0,33)|0;Ga=y-(Ga&1431655765)|0;s=s+(((ba((Ga&858993459)+(Fa&858993459)+(Fa>>>2&858993459)+(Ga>>>2&858993459)|0,286331153)|0)>>>28)*7|0)|0}r=48352+(Ja<<3)|0;t=xa&B&c[r>>2];r=ya&o&c[r+4>>2];if(!((t|0)==0&(r|0)==0)){Ga=t-(t>>>1&1431655765)|0;Ja=jv(t|0,r|0,33)|0;Ja=r-(Ja&1431655765)|0;s=(((ba((Ja&858993459)+(Ga&858993459)+(Ga>>>2&858993459)+(Ja>>>2&858993459)|0,286331153)|0)>>>28)*14|0)+s|0}H=(s|0)>399?399:s;H=i-(c[997232+(((H|0)<0?0:H)<<2)>>2]|0)|0}C=c[$a>>2]|0;if((c[lb+52>>2]|0)==(C|0)?(c[lb+76>>2]|0)==(c[(c[ob>>2]|0)+24>>2]&12|0):0)B=c[lb+60>>2]|0;else{B=Nf(lb,e,C)|0;c[lb+60>>2]=B}if(!f)$=B;else{w=ha&Xa&~(xa|gb|pa|L|_);z=ia&Ya&~(ya|hb|qa|K|u);x=ba(f,j)|0;y=w-(w>>>1&1431655765)|0;l=jv(w|0,z|0,33)|0;l=z-(l&1431655765)|0;l=((ba((l&858993459)+(y&858993459)+(y>>>2&858993459)+(l>>>2&858993459)|0,286331153)|0)>>>28)*19|0;l=(q*10|0)+((La|0)!=0|(Ma|0)!=0?9:0)+((x|0)<77?x:77)+l+(((B+32768>>16)*63|0)/-512|0)+((c[e+356>>2]|0)==0?-60:0)|0;x=ab;y=c[x>>2]|0;x=c[x+4>>2]|0;q=~y;t=~x;s=w&G&q;r=z&P&t;if(!((s|0)==0&(r|0)==0)?(Na=s&(Ha|ib|ta|ca),Oa=r&(Ia|jb|ua|aa),!((Na|0)==0&(Oa|0)==0)):0){Ma=Na-(Na>>>1&1431655765)|0;Na=jv(Na|0,Oa|0,33)|0;Oa=Oa-(Na&1431655765)|0;l=(((ba((Oa&858993459)+(Ma&858993459)+(Ma>>>2&858993459)+(Oa>>>2&858993459)|0,286331153)|0)>>>28)*92|0)+l|0}Oa=64736+(C<<3)|0;r=w&ca&q&c[Oa>>2];q=z&aa&t&c[Oa+4>>2];if(!((r|0)==0&(q|0)==0)?(Pa=r&(Ha|ib|ta|G),Qa=q&(Ia|jb|ua|P),!((Pa|0)==0&(Qa|0)==0)):0){Oa=Pa-(Pa>>>1&1431655765)|0;Pa=jv(Pa|0,Qa|0,33)|0;Qa=Qa-(Pa&1431655765)|0;l=(((ba((Qa&858993459)+(Oa&858993459)+(Oa>>>2&858993459)+(Qa>>>2&858993459)|0,286331153)|0)>>>28)*68|0)+l|0}y=~(y|Q);x=~(x|N);q=e+256|0;s=c[q>>2]|0;q=c[q+4>>2]|0;p=44448+(C<<3)|0;f=43936+(C<<3)|0;f=(ba(c[p+4>>2]&q,c[f+4>>2]|0)|0)^(ba(c[p>>2]&s,c[f>>2]|0)|0);f=(c[43424+(C<<2)>>2]|0)+(f>>>(c[44960+(C<<2)>>2]|0)<<3)|0;p=c[f>>2]&y;f=c[f+4>>2]&x;r=45728+(C<<3)|0;g=45216+(C<<3)|0;g=(ba(c[r+4>>2]&q,c[g+4>>2]|0)|0)^(ba(c[r>>2]&s,c[g>>2]|0)|0);g=(c[43680+(C<<2)>>2]|0)+(g>>>(c[46240+(C<<2)>>2]|0)<<3)|0;s=c[g>>2]&y;g=c[g+4>>2]&x;r=(s|p)&G;q=(g|f)&P;if(!((r|0)==0&(q|0)==0)){Pa=r-(r>>>1&1431655765)|0;Qa=jv(r|0,q|0,33)|0;Qa=q-(Qa&1431655765)|0;l=(((ba((Qa&858993459)+(Pa&858993459)+(Pa>>>2&858993459)+(Qa>>>2&858993459)|0,286331153)|0)>>>28)*50|0)+l|0}r=p&ca;q=f&aa;if(!((r|0)==0&(q|0)==0)){Pa=r-(r>>>1&1431655765)|0;Qa=jv(r|0,q|0,33)|0;Qa=q-(Qa&1431655765)|0;l=l+(((ba((Qa&858993459)+(Pa&858993459)+(Pa>>>2&858993459)+(Qa>>>2&858993459)|0,286331153)|0)>>>28)*36|0)|0}q=s&ta;n=g&ua;if(!((q|0)==0&(n|0)==0)){Pa=q-(q>>>1&1431655765)|0;Qa=jv(q|0,n|0,33)|0;Qa=n-(Qa&1431655765)|0;l=l+(((ba((Qa&858993459)+(Pa&858993459)+(Pa>>>2&858993459)+(Qa>>>2&858993459)|0,286331153)|0)>>>28)*7|0)|0}k=48352+(C<<3)|0;j=Ha&y&c[k>>2];k=Ia&x&c[k+4>>2];if(!((j|0)==0&(k|0)==0)){Pa=j-(j>>>1&1431655765)|0;Qa=jv(j|0,k|0,33)|0;Qa=k-(Qa&1431655765)|0;l=(((ba((Qa&858993459)+(Pa&858993459)+(Pa>>>2&858993459)+(Qa>>>2&858993459)|0,286331153)|0)>>>28)*14|0)+l|0}$=(l|0)>399?399:l;$=B-(c[997232+((($|0)<0?0:$)<<2)>>2]|0)|0}k=cb;l=c[k>>2]|0;k=c[k+4>>2]|0;p=kb;q=l&gb&~c[p>>2];p=k&hb&~c[p+4>>2];if((q|0)==0&(p|0)==0){j=l;l=0}else{l=q&D;k=p&E;if((l|0)==0&(k|0)==0)l=0;else{m=l;l=0;do{Qa=_c(m,k)|0;Pa=iv(m|0,k|0,-1,-1)|0;m=Pa&m;k=F&k;l=(c[996952+((c[e+(Qa<<2)>>2]&7)<<2)>>2]|0)+l|0}while(!((m|0)==0&(k|0)==0))}k=q&ca;j=p&aa;if(!((k|0)==0&(j|0)==0))do{Qa=_c(k,j)|0;Pa=iv(k|0,j|0,-1,-1)|0;k=Pa&k;j=F&j;l=(c[996984+((c[e+(Qa<<2)>>2]&7)<<2)>>2]|0)+l|0}while(!((k|0)==0&(j|0)==0));k=cb;j=c[k>>2]|0;k=c[k+4>>2]|0}t=ha&~gb&j;s=ia&~hb&k;if(!((t|0)==0&(s|0)==0)){k=t&D;j=s&E;if(!((k|0)==0&(j|0)==0))do{Qa=_c(k,j)|0;Pa=iv(k|0,j|0,-1,-1)|0;k=Pa&k;j=F&j;l=(c[997016+((c[e+(Qa<<2)>>2]&7)<<2)>>2]|0)+l|0}while(!((k|0)==0&(j|0)==0));j=t&(G|ca);k=s&(P|aa);if(!((j|0)==0&(k|0)==0))do{Qa=_c(j,k)|0;Pa=iv(j|0,k|0,-1,-1)|0;j=Pa&j;k=F&k;l=(c[997048+((c[e+(Qa<<2)>>2]&7)<<2)>>2]|0)+l|0}while(!((j|0)==0&(k|0)==0));k=t&~Q;j=s&~N;if((k|0)==0&(j|0)==0)j=l;else{Pa=c[249294]|0;Qa=k-(k>>>1&1431655765)|0;Oa=jv(k|0,j|0,33)|0;j=j-(Oa&1431655765)|0;j=(ba(Pa,(ba((j&858993459)+(Qa&858993459)+(Qa>>>2&858993459)+(j>>>2&858993459)|0,286331153)|0)>>>28)|0)+l|0}k=t&Ta;l=s&Ua;if((k|0)==0&(l|0)==0)Y=j;else{Y=iv(k|0,l|0,-1,-1)|0;Y=((Y&k|0)!=0|(F&l|0)!=0?c[249278]|0:c[249276]|0)+j|0}}else Y=l;k=ab;l=c[k>>2]|0;k=c[k+4>>2]|0;h=kb;i=l&ib&~c[h>>2];h=k&jb&~c[h+4>>2];if((i|0)==0&(h|0)==0){j=l;l=0}else{l=i&R;k=h&T;if((l|0)==0&(k|0)==0)l=0;else{j=l;l=0;do{Ua=_c(j,k)|0;Ta=iv(j|0,k|0,-1,-1)|0;j=Ta&j;k=F&k;l=(c[996952+((c[e+(Ua<<2)>>2]&7)<<2)>>2]|0)+l|0}while(!((j|0)==0&(k|0)==0))}k=i&L;j=h&K;if(!((k|0)==0&(j|0)==0))do{Ua=_c(k,j)|0;Ta=iv(k|0,j|0,-1,-1)|0;k=Ta&k;j=F&j;l=(c[996984+((c[e+(Ua<<2)>>2]&7)<<2)>>2]|0)+l|0}while(!((k|0)==0&(j|0)==0));k=ab;j=c[k>>2]|0;k=c[k+4>>2]|0}r=Q&~ib&j;q=N&~jb&k;do if((r|0)==0&(q|0)==0)j=l;else{k=r&R;j=q&T;if(!((k|0)==0&(j|0)==0))do{Ua=_c(k,j)|0;Ta=iv(k|0,j|0,-1,-1)|0;k=Ta&k;j=F&j;l=(c[997016+((c[e+(Ua<<2)>>2]&7)<<2)>>2]|0)+l|0}while(!((k|0)==0&(j|0)==0));j=r&(_|L);k=q&(u|K);if(!((j|0)==0&(k|0)==0))do{Ua=_c(j,k)|0;Ta=iv(j|0,k|0,-1,-1)|0;j=Ta&j;k=F&k;l=(c[997048+((c[e+(Ua<<2)>>2]&7)<<2)>>2]|0)+l|0}while(!((j|0)==0&(k|0)==0));k=r&~ha;j=q&~ia;if((k|0)==0&(j|0)==0)j=l;else{Ta=c[249294]|0;Ua=k-(k>>>1&1431655765)|0;Qa=jv(k|0,j|0,33)|0;j=j-(Qa&1431655765)|0;j=(ba(Ta,(ba((j&858993459)+(Ua&858993459)+(Ua>>>2&858993459)+(j>>>2&858993459)|0,286331153)|0)>>>28)|0)+l|0}k=r&Xa;l=q&Ya;if((k|0)==0&(l|0)==0)break;Ua=iv(k|0,l|0,-1,-1)|0;j=((Ua&k|0)!=0|(F&l|0)!=0?c[249278]|0:c[249276]|0)+j|0}while(0);O=lb+16|0;k=O;l=c[k>>2]|0;k=c[k+4>>2]|0;if((l|0)==0&(k|0)==0)l=0;else{u=e+340|0;v=e+372|0;w=e+288|0;x=e+296|0;y=e+256|0;t=l;l=0;do{n=_c(t,k)|0;f=iv(t|0,k|0,-1,-1)|0;t=f&t;k=F&k;f=n>>3;m=f+-1|0;s=ba(m,f+-2|0)|0;h=s*17|0;i=(ba(m*7|0,m)|0)+7|0;do if(s){r=n+8|0;g=c[_a>>2]|0;i=(ba(((c[27040+(c[$a>>2]<<8)+(r<<2)>>2]|0)*5|0)-(c[27040+(g<<8)+(r<<2)>>2]<<1)|0,s)|0)+i|0;if((r&-8|0)!=56)i=i-(ba(c[27040+(g<<8)+(n+16<<2)>>2]|0,s)|0)|0;if(c[e+(r<<2)>>2]|0){Ua=ab;Ta=46496+(r<<3)|0;if((c[Ta>>2]&c[Ua>>2]|0)==0?(c[Ta+4>>2]&c[Ua+4>>2]|0)==0:0)break;i=i+(ba(m,f)|0)|0;h=(m<<1)+3+(s*3|0)+h|0;break}q=59616+(n<<3)|0;p=c[q>>2]|0;q=c[q+4>>2]|0;o=60128+(n<<3)|0;m=w;g=x;Ta=y;Qa=44448+(n<<3)|0;Ua=43936+(n<<3)|0;Ua=(ba(c[Qa+4>>2]&c[Ta+4>>2],c[Ua+4>>2]|0)|0)^(ba(c[Qa>>2]&c[Ta>>2],c[Ua>>2]|0)|0);Ua=(c[43424+(n<<2)>>2]|0)+(Ua>>>(c[44960+(n<<2)>>2]|0)<<3)|0;Ta=(c[g>>2]|c[m>>2])&c[o>>2]&c[Ua>>2];Ua=(c[g+4>>2]|c[m+4>>2])&c[o+4>>2]&c[Ua+4>>2];o=ab;o=(c[o>>2]&Ta|0)==0?(c[o+4>>2]&Ua|0)==0:0;n=(o?ha:-1)&p;o=(o?ia:-1)&q;m=cb;g=c[m>>2]|0;m=c[m+4>>2]|0;if((g&Ta|0)==0&(m&Ua|0)==0){f=(g|Q)&p;g=(m|N)&q}else{f=p;g=q}if((f|0)==0&(g|0)==0)g=15;else{Ua=46496+(r<<3)|0;g=((c[Ua>>2]&f|0)==0?(c[Ua+4>>2]&g|0)==0:0)?9:0}if((n|0)==(p|0)&(o|0)==(q|0))g=g+6|0;else{Ua=46496+(r<<3)|0;g=((c[Ua>>2]&n|0)==0?(c[Ua+4>>2]&o|0)==0:0)?g:g+4|0}Ua=ba(g,s)|0;i=Ua+i|0;h=Ua+h|0}while(0);if((c[u>>2]|0)<(c[v>>2]|0))i=((i|0)/4|0)+i|0;l=(h<<16)+l+i|0}while(!((t|0)==0&(k|0)==0))}i=c[249302]|0;k=c[249303]|0;B=(ba(l+32768>>16,i)|0)/256|0;A=(ba(k,l<<16>>16)|0)/256|0;C=lb+24|0;h=C;l=c[h>>2]|0;h=c[h+4>>2]|0;if((l|0)==0&(h|0)==0)l=0;else{x=e+372|0;w=e+340|0;v=e+288|0;u=e+296|0;z=e+256|0;y=l;l=0;do{p=_c(y,h)|0;o=iv(y|0,h|0,-1,-1)|0;y=o&y;h=F&h;o=p>>3^7;q=o+-1|0;t=ba(q,o+-2|0)|0;i=t*17|0;k=(ba(q*7|0,q)|0)+7|0;do if(t){s=p+-8|0;n=c[$a>>2]|0;k=(ba(((c[27040+(c[_a>>2]<<8)+(s<<2)>>2]|0)*5|0)-(c[27040+(n<<8)+(s<<2)>>2]<<1)|0,t)|0)+k|0;if(s>>>0>=8)k=k-(ba(c[27040+(n<<8)+(p+-16<<2)>>2]|0,t)|0)|0;if(c[e+(s<<2)>>2]|0){Ua=cb;Ta=46496+(s<<3)|0;if((c[Ta>>2]&c[Ua>>2]|0)==0?(c[Ta+4>>2]&c[Ua+4>>2]|0)==0:0)break;k=k+(ba(q,o)|0)|0;i=(q<<1)+3+(t*3|0)+i|0;break}r=60128+(p<<3)|0;m=c[r>>2]|0;r=c[r+4>>2]|0;g=59616+(p<<3)|0;f=v;q=u;Ta=z;o=44448+(p<<3)|0;Ua=43936+(p<<3)|0;Ua=(ba(c[o+4>>2]&c[Ta+4>>2],c[Ua+4>>2]|0)|0)^(ba(c[o>>2]&c[Ta>>2],c[Ua>>2]|0)|0);Ua=(c[43424+(p<<2)>>2]|0)+(Ua>>>(c[44960+(p<<2)>>2]|0)<<3)|0;Ta=(c[q>>2]|c[f>>2])&c[g>>2]&c[Ua>>2];Ua=(c[q+4>>2]|c[f+4>>2])&c[g+4>>2]&c[Ua+4>>2];g=cb;g=(c[g>>2]&Ta|0)==0?(c[g+4>>2]&Ua|0)==0:0;f=(g?Q:-1)&m;g=(g?N:-1)&r;q=ab;o=c[q>>2]|0;q=c[q+4>>2]|0;if((o&Ta|0)==0&(q&Ua|0)==0){p=(o|ha)&m;o=(q|ia)&r}else{p=m;o=r}if((p|0)==0&(o|0)==0)n=15;else{n=46496+(s<<3)|0;n=((c[n>>2]&p|0)==0?(c[n+4>>2]&o|0)==0:0)?9:0}if((f|0)==(m|0)&(g|0)==(r|0))g=n+6|0;else{Ua=46496+(s<<3)|0;g=((c[Ua>>2]&f|0)==0?(c[Ua+4>>2]&g|0)==0:0)?n:n+4|0}Ua=ba(g,t)|0;k=Ua+k|0;i=Ua+i|0}while(0);if((c[x>>2]|0)<(c[w>>2]|0))k=((k|0)/4|0)+k|0;l=(i<<16)+l+k|0}while(!((y|0)==0&(h|0)==0));i=c[249302]|0;k=c[249303]|0}j=bb+fb+eb+Za-Va+Ra-Ka+za-oa+J-S+M+H-$+Y-j+A+(I+db+B<<16)+((ba(l<<16>>16,k)|0)/-256|0)+(ba((ba(l+32768>>16,i)|0)/256|0,-65536)|0)|0;l=c[ob>>2]|0;do if(!(c[l+16>>2]|0)){if(c[l+20>>2]|0)break;k=O;l=c[k>>2]|0;k=c[k+4>>2]|0;if(!((l|0)==0&(k|0)==0)){Va=($c(l,k)|0)>>3;j=(ba(c[249292]|0,Va)|0)+j|0}k=C;l=c[k>>2]|0;k=c[k+4>>2]|0;if((l|0)==0&(k|0)==0)break;Va=(_c(l,k)|0)>>3^7;j=j-(ba(Va,c[249292]|0)|0)|0}while(0);Va=c[ob>>2]|0;if(((c[Va+20>>2]|0)+(c[Va+16>>2]|0)|0)<11756)k=j;else{Qa=ab;Ra=kb;Va=c[Ra>>2]|0;Ra=c[Ra+4>>2]|0;Ua=Va&c[Qa>>2];Qa=Ra&c[Qa+4>>2];k=(Q^1010580480|ha)&(gb^1010580480)&(Ua&1010580480^1010580480);Ta=jv(Ua|0,Qa|0,8)|0;Ua=Ta|Ua;Qa=F|Qa;Ta=jv(Ua|0,Qa|0,16)|0;Ua=(Ta|Ua)&k;Ua=Ua-(Ua>>>1&1431655765)|0;Ta=jv(k|0,0,1)|0;Ta=k-(Ta&336860160)|0;Ua=(Ua>>>2&858993459)+(Ua&858993459)|0;Ta=(Ta>>>2&858993459)+(Ta&858992640)|0;Ua=(ba((Ta>>>4)+Ta+Ua+(Ua>>>4)&252645135,16843009)|0)>>>24;Ta=(c[e+348>>2]|0)+(c[e+344>>2]|0)+(c[e+376>>2]|0)+(c[e+380>>2]|0)|0;Ta=ba(Ta<<16,Ta)|0;k=cb;Va=c[k>>2]&Va;Ra=c[k+4>>2]&Ra;k=(N|ia^3947580)&(jb^3947580)&(Ra&3947580^3947580);Qa=ov(Va|0,Ra|0,8)|0;Va=Qa|Va;Ra=F|Ra;Qa=ov(Va|0,Ra|0,16)|0;Ra=(F|Ra)&k;Va=jv(0,k|0,33)|0;Va=k-(Va&1315860)|0;k=jv(0,Ra|0,33)|0;k=Ra-(k&1431655765)|0;Va=(Va>>>2&858993459)+(Va&858993459)|0;k=(k>>>2&858993459)+(k&858993459)|0;k=ba(Ta,Ua-((ba((Va>>>4)+Va+k+(k>>>4)&252645135,16843009)|0)>>>24)|0)|0;k=(((ba(k>>16,c[249304]|0)|0)/256|0)<<16)+j|0}i=k<<16;l=i>>16;j=(i|0)<65536&1;g=mb+(j<<2)+16|0;f=c[g>>2]|0;do if(!f)nb=282;else{if((oc[c[(c[f>>2]|0)+12>>2]&63](f,e)|0)==255){nb=282;break}f=c[g>>2]|0;f=oc[c[(c[f>>2]|0)+12>>2]&63](f,e)|0}while(0);if((nb|0)==282)f=d[mb+j+10>>0]|0;h=c[mb+24>>2]|0;c:do if((h|0)<128){if(!((f|0)==48|(f|0)==64))break;do if((c[e+348>>2]|0)==1){if((c[e+380>>2]|0)!=1)break;Wa=c[Sa>>2]^c[Wa>>2];if(!((Wa>>>3^Wa)&1))break;g=c[ob>>2]|0;do if((c[g+16>>2]|0)==836){if((c[g+20>>2]|0)!=836)break;f=kb;Wa=c[f>>2]|0;f=c[f+4>>2]|0;Va=iv(Wa|0,f|0,-1,-1)|0;f=(Va&Wa|0)!=0|(F&f|0)!=0?32:8;break c}while(0);f=(f*50|0)/64|0;break c}while(0);if((((i|0)>-65536?l:0-l|0)|0)>=858)break;g=c[lb+(j<<2)+88>>2]|0;if((g|0)>=2)break;Wa=j^1;Va=e+(j<<3)+320|0;Ua=kb;Wa=60640+(Wa<<9)+(c[e+(Wa<<9)+784>>2]<<3)|0;if((c[Ua>>2]&c[Va>>2]&c[Wa>>2]|0)==0?(c[Ua+4>>2]&c[Va+4>>2]&c[Wa+4>>2]|0)==0:0)break;f=(g|0)!=0?56:38}while(0);Wa=(((ba(ba(128-h|0,l)|0,f)|0)/64|0)+(ba(h,k+32768>>16)|0)|0)/128|0;Wa=(c[e+2212>>2]|0)==0?Wa:0-Wa|0;Wa=Wa+17|0;return Wa|0}
function cv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;q=a+b|0;h=c[a+4>>2]|0;do if(!(h&1)){j=c[a>>2]|0;if(!(h&3))return;n=a+(0-j)|0;m=j+b|0;i=c[271750]|0;if(n>>>0<i>>>0)Nb();if((n|0)==(c[271751]|0)){g=a+(b+4)|0;h=c[g>>2]|0;if((h&3|0)!=3){t=n;l=m;break}c[271748]=m;c[g>>2]=h&-2;c[a+(4-j)>>2]=m|1;c[q>>2]=m;return}e=j>>>3;if(j>>>0<256){f=c[a+(8-j)>>2]|0;g=c[a+(12-j)>>2]|0;h=1087024+(e<<1<<2)|0;if((f|0)!=(h|0)){if(f>>>0<i>>>0)Nb();if((c[f+12>>2]|0)!=(n|0))Nb()}if((g|0)==(f|0)){c[271746]=c[271746]&~(1<<e);t=n;l=m;break}if((g|0)!=(h|0)){if(g>>>0<i>>>0)Nb();h=g+8|0;if((c[h>>2]|0)==(n|0))d=h;else Nb()}else d=g+8|0;c[f+12>>2]=g;c[d>>2]=f;t=n;l=m;break}d=c[a+(24-j)>>2]|0;f=c[a+(12-j)>>2]|0;do if((f|0)==(n|0)){f=16-j|0;g=a+(f+4)|0;h=c[g>>2]|0;if(!h){g=a+f|0;h=c[g>>2]|0;if(!h){k=0;break}}while(1){f=h+20|0;e=c[f>>2]|0;if(e){h=e;g=f;continue}f=h+16|0;e=c[f>>2]|0;if(!e)break;else{h=e;g=f}}if(g>>>0<i>>>0)Nb();else{c[g>>2]=0;k=h;break}}else{e=c[a+(8-j)>>2]|0;if(e>>>0<i>>>0)Nb();h=e+12|0;if((c[h>>2]|0)!=(n|0))Nb();g=f+8|0;if((c[g>>2]|0)==(n|0)){c[h>>2]=f;c[g>>2]=e;k=f;break}else Nb()}while(0);if(d){h=c[a+(28-j)>>2]|0;g=1087288+(h<<2)|0;if((n|0)==(c[g>>2]|0)){c[g>>2]=k;if(!k){c[271747]=c[271747]&~(1<<h);t=n;l=m;break}}else{if(d>>>0<(c[271750]|0)>>>0)Nb();h=d+16|0;if((c[h>>2]|0)==(n|0))c[h>>2]=k;else c[d+20>>2]=k;if(!k){t=n;l=m;break}}f=c[271750]|0;if(k>>>0<f>>>0)Nb();c[k+24>>2]=d;h=16-j|0;g=c[a+h>>2]|0;do if(g)if(g>>>0<f>>>0)Nb();else{c[k+16>>2]=g;c[g+24>>2]=k;break}while(0);h=c[a+(h+4)>>2]|0;if(h)if(h>>>0<(c[271750]|0)>>>0)Nb();else{c[k+20>>2]=h;c[h+24>>2]=k;t=n;l=m;break}else{t=n;l=m}}else{t=n;l=m}}else{t=a;l=b}while(0);i=c[271750]|0;if(q>>>0<i>>>0)Nb();h=a+(b+4)|0;g=c[h>>2]|0;if(!(g&2)){if((q|0)==(c[271752]|0)){m=(c[271749]|0)+l|0;c[271749]=m;c[271752]=t;c[t+4>>2]=m|1;if((t|0)!=(c[271751]|0))return;c[271751]=0;c[271748]=0;return}if((q|0)==(c[271751]|0)){m=(c[271748]|0)+l|0;c[271748]=m;c[271751]=t;c[t+4>>2]=m|1;c[t+m>>2]=m;return}j=(g&-8)+l|0;d=g>>>3;do if(g>>>0>=256){d=c[a+(b+24)>>2]|0;f=c[a+(b+12)>>2]|0;do if((f|0)==(q|0)){g=a+(b+20)|0;h=c[g>>2]|0;if(!h){g=a+(b+16)|0;h=c[g>>2]|0;if(!h){p=0;break}}while(1){f=h+20|0;e=c[f>>2]|0;if(e){h=e;g=f;continue}f=h+16|0;e=c[f>>2]|0;if(!e)break;else{h=e;g=f}}if(g>>>0<i>>>0)Nb();else{c[g>>2]=0;p=h;break}}else{e=c[a+(b+8)>>2]|0;if(e>>>0<i>>>0)Nb();h=e+12|0;if((c[h>>2]|0)!=(q|0))Nb();g=f+8|0;if((c[g>>2]|0)==(q|0)){c[h>>2]=f;c[g>>2]=e;p=f;break}else Nb()}while(0);if(d){h=c[a+(b+28)>>2]|0;g=1087288+(h<<2)|0;if((q|0)==(c[g>>2]|0)){c[g>>2]=p;if(!p){c[271747]=c[271747]&~(1<<h);break}}else{if(d>>>0<(c[271750]|0)>>>0)Nb();g=d+16|0;if((c[g>>2]|0)==(q|0))c[g>>2]=p;else c[d+20>>2]=p;if(!p)break}f=c[271750]|0;if(p>>>0<f>>>0)Nb();c[p+24>>2]=d;g=c[a+(b+16)>>2]|0;do if(g)if(g>>>0<f>>>0)Nb();else{c[p+16>>2]=g;c[g+24>>2]=p;break}while(0);f=c[a+(b+20)>>2]|0;if(f)if(f>>>0<(c[271750]|0)>>>0)Nb();else{c[p+20>>2]=f;c[f+24>>2]=p;break}}}else{e=c[a+(b+8)>>2]|0;f=c[a+(b+12)>>2]|0;h=1087024+(d<<1<<2)|0;if((e|0)!=(h|0)){if(e>>>0<i>>>0)Nb();if((c[e+12>>2]|0)!=(q|0))Nb()}if((f|0)==(e|0)){c[271746]=c[271746]&~(1<<d);break}if((f|0)!=(h|0)){if(f>>>0<i>>>0)Nb();g=f+8|0;if((c[g>>2]|0)==(q|0))o=g;else Nb()}else o=f+8|0;c[e+12>>2]=f;c[o>>2]=e}while(0);c[t+4>>2]=j|1;c[t+j>>2]=j;if((t|0)==(c[271751]|0)){c[271748]=j;return}else h=j}else{c[h>>2]=g&-2;c[t+4>>2]=l|1;c[t+l>>2]=l;h=l}g=h>>>3;if(h>>>0<256){e=g<<1;h=1087024+(e<<2)|0;d=c[271746]|0;f=1<<g;if(d&f){f=1087024+(e+2<<2)|0;e=c[f>>2]|0;if(e>>>0<(c[271750]|0)>>>0)Nb();else{r=f;s=e}}else{c[271746]=d|f;r=1087024+(e+2<<2)|0;s=h}c[r>>2]=t;c[s+12>>2]=t;c[t+8>>2]=s;c[t+12>>2]=h;return}d=h>>>8;if(d)if(h>>>0>16777215)g=31;else{l=(d+1048320|0)>>>16&8;m=d<<l;k=(m+520192|0)>>>16&4;m=m<<k;g=(m+245760|0)>>>16&2;g=14-(k|l|g)+(m<<g>>>15)|0;g=h>>>(g+7|0)&1|g<<1}else g=0;f=1087288+(g<<2)|0;c[t+28>>2]=g;c[t+20>>2]=0;c[t+16>>2]=0;e=c[271747]|0;d=1<<g;if(!(e&d)){c[271747]=e|d;c[f>>2]=t;c[t+24>>2]=f;c[t+12>>2]=t;c[t+8>>2]=t;return}d=c[f>>2]|0;if((g|0)==31)e=0;else e=25-(g>>>1)|0;a:do if((c[d+4>>2]&-8|0)!=(h|0)){g=h<<e;while(1){e=d+(g>>>31<<2)+16|0;f=c[e>>2]|0;if(!f)break;if((c[f+4>>2]&-8|0)==(h|0)){d=f;break a}else{g=g<<1;d=f}}if(e>>>0<(c[271750]|0)>>>0)Nb();c[e>>2]=t;c[t+24>>2]=d;c[t+12>>2]=t;c[t+8>>2]=t;return}while(0);e=d+8|0;f=c[e>>2]|0;m=c[271750]|0;if(!(d>>>0>=m>>>0&f>>>0>=m>>>0))Nb();c[f+12>>2]=t;c[e>>2]=t;c[t+8>>2]=f;c[t+12>>2]=d;c[t+24>>2]=0;return}function dv(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0;h=a+4|0;e=c[h>>2]|0;i=a+100|0;if(e>>>0<(c[i>>2]|0)>>>0){c[h>>2]=e+1;e=d[e>>0]|0}else e=Fu(a)|0;if((e|0)==43|(e|0)==45){f=(e|0)==45&1;e=c[h>>2]|0;if(e>>>0<(c[i>>2]|0)>>>0){c[h>>2]=e+1;e=d[e>>0]|0}else e=Fu(a)|0;if((e+-48|0)>>>0>9&(b|0)!=0?(c[i>>2]|0)!=0:0){c[h>>2]=(c[h>>2]|0)+-1;g=f}else g=f}else g=0;if((e+-48|0)>>>0>9){if(!(c[i>>2]|0)){f=-2147483648;e=0;F=f;return e|0}c[h>>2]=(c[h>>2]|0)+-1;f=-2147483648;e=0;F=f;return e|0}else f=0;do{f=e+-48+(f*10|0)|0;e=c[h>>2]|0;if(e>>>0<(c[i>>2]|0)>>>0){c[h>>2]=e+1;e=d[e>>0]|0}else e=Fu(a)|0}while((e+-48|0)>>>0<10&(f|0)<214748364);b=((f|0)<0)<<31>>31;if((e+-48|0)>>>0<10)do{b=uv(f|0,b|0,10,0)|0;f=F;e=iv(e|0,((e|0)<0)<<31>>31|0,-48,-1)|0;f=iv(e|0,F|0,b|0,f|0)|0;b=F;e=c[h>>2]|0;if(e>>>0<(c[i>>2]|0)>>>0){c[h>>2]=e+1;e=d[e>>0]|0}else e=Fu(a)|0}while((e+-48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&f>>>0<2061584302));if((e+-48|0)>>>0<10)do{e=c[h>>2]|0;if(e>>>0<(c[i>>2]|0)>>>0){c[h>>2]=e+1;e=d[e>>0]|0}else e=Fu(a)|0}while((e+-48|0)>>>0<10);if(c[i>>2]|0)c[h>>2]=(c[h>>2]|0)+-1;g=(g|0)!=0;e=hv(0,0,f|0,b|0)|0;b=g?F:b;e=g?e:f;F=b;return e|0}function ev(e,f,g,j,l){e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0;hb=i;i=i+864|0;Qa=hb+16|0;Ta=hb+8|0;Ra=hb+836|0;la=Ra;Na=hb+824|0;Za=hb+568|0;Ja=hb+528|0;db=hb;Wa=hb+520|0;ma=(e|0)!=0;Da=Ja+40|0;Ia=Da;Ja=Ja+39|0;Ka=db+4|0;La=db;Ma=Na+12|0;Na=Na+11|0;Oa=Ma;na=Oa-la|0;va=-2-la|0;wa=Oa+2|0;xa=Qa+288|0;ya=Ra+9|0;za=ya;Aa=Ra+8|0;E=0;D=0;v=0;p=0;u=0;a:while(1){do if((v|0)>-1)if((p|0)>(2147483647-v|0)){c[(Cb()|0)>>2]=75;$=-1;break}else{$=p+v|0;break}else $=v;while(0);p=a[f>>0]|0;if(!(p<<24>>24)){Sa=$;Va=u;O=351;break}else o=f;while(1){if(!(p<<24>>24)){ga=o;fa=o;break}else if(p<<24>>24==37){Ha=o;eb=o;O=9;break}I=o+1|0;p=a[I>>0]|0;o=I}b:do if((O|0)==9)while(1){O=0;if((a[Ha+1>>0]|0)!=37){ga=Ha;fa=eb;break b}o=eb+1|0;p=Ha+2|0;if((a[p>>0]|0)==37){Ha=p;eb=o}else{ga=p;fa=o;break}}while(0);p=fa-f|0;if(ma)Tu(f,p,e)|0;if((fa|0)!=(f|0)){f=ga;v=$;continue}s=ga+1|0;q=a[s>>0]|0;o=(q<<24>>24)+-48|0;if(o>>>0<10){I=(a[ga+2>>0]|0)==36;s=I?ga+3|0:s;q=a[s>>0]|0;G=I?o:-1;u=I?1:u}else G=-1;o=q<<24>>24;c:do if((o&-32|0)==32){t=0;do{if(!(1<<o+-32&75913))break c;t=1<<(q<<24>>24)+-32|t;s=s+1|0;q=a[s>>0]|0;o=q<<24>>24}while((o&-32|0)==32)}else t=0;while(0);do if(q<<24>>24==42){o=s+1|0;q=(a[o>>0]|0)+-48|0;if(q>>>0<10?(a[s+2>>0]|0)==36:0){c[l+(q<<2)>>2]=10;u=1;q=s+3|0;s=c[j+((a[o>>0]|0)+-48<<3)>>2]|0}else{if(u){fb=-1;O=369;break a}if(!ma){q=o;u=0;N=0;break}u=c[g>>2]|0;s=c[u>>2]|0;c[g>>2]=u+4;u=0;q=o}if((s|0)<0){t=t|8192;N=0-s|0}else N=s}else{o=(q<<24>>24)+-48|0;if(o>>>0<10){q=s;s=0;do{s=(s*10|0)+o|0;q=q+1|0;o=(a[q>>0]|0)+-48|0}while(o>>>0<10);if((s|0)<0){fb=-1;O=369;break a}else N=s}else{q=s;N=0}}while(0);d:do if((a[q>>0]|0)==46){s=q+1|0;o=a[s>>0]|0;if(o<<24>>24!=42){v=(o<<24>>24)+-48|0;if(v>>>0<10)o=0;else{q=s;I=0;break}while(1){o=(o*10|0)+v|0;q=q+2|0;v=(a[q>>0]|0)+-48|0;if(v>>>0>=10){I=o;break d}else{I=s;s=q;q=I}}}o=q+2|0;s=(a[o>>0]|0)+-48|0;if(s>>>0<10?(a[q+3>>0]|0)==36:0){c[l+(s<<2)>>2]=10;q=q+4|0;I=c[j+((a[o>>0]|0)+-48<<3)>>2]|0;break}if(u){fb=-1;O=369;break a}if(ma){q=c[g>>2]|0;I=c[q>>2]|0;c[g>>2]=q+4;q=o}else{q=o;I=0}}else I=-1;while(0);y=0;while(1){v=a[q>>0]|0;s=(v<<24>>24)+-65|0;if(s>>>0>57){fb=-1;O=369;break a}w=q+1|0;o=a[1087816+(y*58|0)+s>>0]|0;s=o&255;if((s+-1|0)>>>0<8){q=w;y=s}else{z=v;break}}if(!(o<<24>>24)){fb=-1;O=369;break}v=(G|0)>-1;e:do if(o<<24>>24==19)if(v){fb=-1;O=369;break a}else{oa=E;pa=D;O=62}else{if(v){c[l+(G<<2)>>2]=s;pa=j+(G<<3)|0;oa=c[pa>>2]|0;pa=c[pa+4>>2]|0;O=62;break}if(!ma){fb=0;O=369;break a}if((o&255)>20){Ba=z;Ca=E;Ea=D}else do switch(s|0){case 10:{qa=c[g>>2]|0;ra=c[qa>>2]|0;c[g>>2]=qa+4;qa=((ra|0)<0)<<31>>31;O=63;break e}case 16:{qa=c[g>>2]|0;ra=c[qa>>2]|0;c[g>>2]=qa+4;qa=0;ra=ra&255;O=63;break e}case 9:{qa=c[g>>2]|0;ra=c[qa>>2]|0;c[g>>2]=qa+4;qa=D;O=63;break e}case 17:{qa=c[g>>2]|0;c[k>>2]=c[qa>>2];c[k+4>>2]=c[qa+4>>2];r=+h[k>>3];c[g>>2]=qa+8;h[k>>3]=r;qa=c[k+4>>2]|0;ra=c[k>>2]|0;O=63;break e}case 11:{qa=c[g>>2]|0;ra=c[qa>>2]|0;c[g>>2]=qa+4;qa=0;O=63;break e}case 12:{O=c[g>>2]|0;qa=O;ra=c[qa>>2]|0;qa=c[qa+4>>2]|0;c[g>>2]=O+8;O=63;break e}case 15:{qa=c[g>>2]|0;ra=c[qa>>2]|0;c[g>>2]=qa+4;qa=(((ra&255)<<24>>24|0)<0)<<31>>31;ra=ra<<24>>24;O=63;break e}case 14:{qa=c[g>>2]|0;ra=c[qa>>2]|0;c[g>>2]=qa+4;qa=0;ra=ra&65535;O=63;break e}case 18:{oa=c[g>>2]|0;c[k>>2]=c[oa>>2];c[k+4>>2]=c[oa+4>>2];r=+h[k>>3];c[g>>2]=oa+8;h[k>>3]=r;oa=c[k>>2]|0;pa=c[k+4>>2]|0;O=62;break e}case 13:{qa=c[g>>2]|0;ra=c[qa>>2]|0;c[g>>2]=qa+4;qa=(((ra&65535)<<16>>16|0)<0)<<31>>31;ra=ra<<16>>16;O=63;break e}default:{qa=D;ra=E;O=63;break e}}while(0)}while(0);if((O|0)==62){O=0;if(ma){qa=pa;ra=oa;O=63}else{E=oa;D=pa;f=w;v=$;continue}}if((O|0)==63){O=0;Ba=a[q>>0]|0;Ca=ra;Ea=qa}E=Ba<<24>>24;E=(y|0)!=0&(E&15|0)==3?E&-33:E;q=t&-65537;M=(t&8192|0)==0?t:q;f:do switch(E|0){case 117:{Fa=Ea;Ga=Ca;_a=0;$a=1088280;O=85;break}case 111:{o=(Ca|0)==0&(Ea|0)==0;if(o)n=Da;else{n=Da;f=Ca;p=Ea;do{n=n+-1|0;a[n>>0]=f&7|48;f=jv(f|0,p|0,3)|0;p=F}while(!((f|0)==0&(p|0)==0))}S=(M&8|0)==0|o;T=Ca;U=Ea;P=M;Q=I;R=S&1^1;S=S?1088280:1088285;O=90;break}case 105:case 100:{if((Ea|0)<0){Ga=hv(0,0,Ca|0,Ea|0)|0;Fa=F;_a=1;$a=1088280;O=85;break f}if(!(M&2048)){$a=M&1;Fa=Ea;Ga=Ca;_a=$a;$a=($a|0)==0?1088280:1088282;O=85}else{Fa=Ea;Ga=Ca;_a=1;$a=1088281;O=85}break}case 67:{c[db>>2]=Ca;c[Ka>>2]=0;sa=db;ta=La;Ya=-1;O=100;break}case 83:{f=Ca;if(!I){Z=Ca;_=f;Y=0;O=105}else{sa=f;ta=Ca;Ya=I;O=100}break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{c[k>>2]=Ca;c[k+4>>2]=Ea;r=+h[k>>3];c[Ta>>2]=0;if((Ea|0)>=0)if(!(M&2048)){K=M&1;t=K;K=(K|0)==0?1088305:1088310}else{t=1;K=1088307}else{r=-r;t=1;K=1088304}h[k>>3]=r;H=c[k+4>>2]&2146435072;if(!(H>>>0<2146435072|(H|0)==2146435072&0<0)){q=(E&32|0)!=0;if(r!=r|0.0!=0.0){t=0;s=q?1088344:1088352}else s=q?1088328:1088336;o=t+3|0;p=(N|0)>(o|0);if((M&8192|0)==0&p){q=N-o|0;kv(Za|0,32,(q>>>0>256?256:q)|0)|0;if(q>>>0>255){f=q;do{Tu(Za,256,e)|0;f=f+-256|0}while(f>>>0>255);q=q&255}Tu(Za,q,e)|0}Tu(K,t,e)|0;Tu(s,3,e)|0;if((M&73728|0)==8192&p){f=N-o|0;kv(Za|0,32,(f>>>0>256?256:f)|0)|0;if(f>>>0>255){q=f;do{Tu(Za,256,e)|0;q=q+-256|0}while(q>>>0>255);f=f&255}Tu(Za,f,e)|0}E=Ca;D=Ea;f=w;v=$;p=p?N:o;continue a}x=+Lu(r,Ta)*2.0;s=x!=0.0;if(s)c[Ta>>2]=(c[Ta>>2]|0)+-1;H=E|32;if((H|0)==97){A=E&32;p=(A|0)==0?K:K+9|0;C=t|2;s=I>>>0>11?0:12-I|0;do if(s){r=8.0;do{s=s+-1|0;r=r*16.0}while((s|0)!=0);if((a[p>>0]|0)==45){r=-(r+(-x-r));break}else{r=x+r-r;break}}else r=x;while(0);s=c[Ta>>2]|0;s=(s|0)<0?0-s|0:s;if((s|0)<0){q=Ma;t=s;v=((s|0)<0)<<31>>31;while(1){s=wv(t|0,v|0,10,0)|0;q=q+-1|0;a[q>>0]=s|48;s=vv(t|0,v|0,10,0)|0;if(v>>>0>9|(v|0)==9&t>>>0>4294967295){t=s;v=F}else break}}else q=Ma;if(s)while(1){q=q+-1|0;a[q>>0]=(s>>>0)%10|0|48;if(s>>>0<10)break;else s=(s>>>0)/10|0}if((q|0)==(Ma|0)){a[Na>>0]=48;q=Na}a[q+-1>>0]=(c[Ta>>2]>>31&2)+43;B=q+-2|0;a[B>>0]=E+15;if((I|0)<1)if(!(M&8)){q=Ra;do{H=~~r;s=q+1|0;a[q>>0]=d[1088360+H>>0]|A;r=(r-+(H|0))*16.0;if((s-la|0)!=1|r==0.0)q=s;else{a[s>>0]=46;q=q+2|0}}while(r!=0.0)}else{q=Ra;do{H=~~r;s=q+1|0;a[q>>0]=d[1088360+H>>0]|A;r=(r-+(H|0))*16.0;if((s-la|0)==1){a[s>>0]=46;q=q+2|0}else q=s}while(r!=0.0)}else{q=Ra;do{H=~~r;s=q+1|0;a[q>>0]=d[1088360+H>>0]|A;r=(r-+(H|0))*16.0;if((s-la|0)==1){a[s>>0]=46;q=q+2|0}else q=s}while(r!=0.0)}f=B;if((I|0)!=0&(va+q|0)<(I|0))o=wa+I-f|0;else o=na-f+q|0;y=o+C|0;z=M&73728;A=(N|0)>(y|0);if((z|0)==0&A){s=N-y|0;kv(Za|0,32,(s>>>0>256?256:s)|0)|0;if(s>>>0>255){f=s;do{Tu(Za,256,e)|0;f=f+-256|0}while(f>>>0>255);s=s&255}Tu(Za,s,e)|0}Tu(p,C,e)|0;if((z|0)==65536&A){f=N-y|0;kv(Za|0,48,(f>>>0>256?256:f)|0)|0;if(f>>>0>255){p=f;do{Tu(Za,256,e)|0;p=p+-256|0}while(p>>>0>255);f=f&255}Tu(Za,f,e)|0}q=q-la|0;Tu(Ra,q,e)|0;s=Oa-B|0;q=o-s-q|0;if((q|0)>0){kv(Za|0,48,(q>>>0>256?256:q)|0)|0;if(q>>>0>255){f=q;do{Tu(Za,256,e)|0;f=f+-256|0}while(f>>>0>255);q=q&255}Tu(Za,q,e)|0}Tu(B,s,e)|0;if((z|0)==8192&A){f=N-y|0;kv(Za|0,32,(f>>>0>256?256:f)|0)|0;if(f>>>0>255){q=f;do{Tu(Za,256,e)|0;q=q+-256|0}while(q>>>0>255);f=f&255}Tu(Za,f,e)|0}E=Ca;D=Ea;f=w;v=$;p=A?N:y;continue a}q=(I|0)<0?6:I;if(s){s=(c[Ta>>2]|0)+-28|0;c[Ta>>2]=s;r=x*268435456.0}else{r=x;s=c[Ta>>2]|0}L=(s|0)<0?Qa:xa;J=L;s=L;do{I=~~r>>>0;c[s>>2]=I;s=s+4|0;r=(r-+(I>>>0))*1.0e9}while(r!=0.0);v=s;s=c[Ta>>2]|0;if((s|0)>0){f=s;s=L;z=v;while(1){y=(f|0)>29?29:f;f=z+-4|0;do if(f>>>0>=s>>>0){o=z;v=0;while(1){I=ov(c[f>>2]|0,0,y|0)|0;I=iv(I|0,F|0,v|0,0)|0;v=F;G=wv(I|0,v|0,1e9,0)|0;c[f>>2]=G;v=vv(I|0,v|0,1e9,0)|0;o=o+-8|0;if(o>>>0<s>>>0)break;else{I=f;f=o;o=I}}if(!v)break;s=s+-4|0;c[s>>2]=v}while(0);f=z;while(1){if(f>>>0<=s>>>0){v=f;break}v=f+-4|0;if(!(c[v>>2]|0))f=v;else{v=f;break}}f=(c[Ta>>2]|0)-y|0;c[Ta>>2]=f;if((f|0)>0)z=v;else break}}else{f=s;s=L}g:do if((f|0)<0){B=((q+25|0)/9|0)+1|0;if((H|0)==102){p=L+(B<<2)|0;while(1){A=(f|0)<-9?9:0-f|0;do if(s>>>0<v>>>0){z=(1<<A)+-1|0;y=1e9>>>A;f=0;o=s;do{I=c[o>>2]|0;c[o>>2]=(I>>>A)+f;f=ba(I&z,y)|0;o=o+4|0}while(o>>>0<v>>>0);s=(c[s>>2]|0)==0?s+4|0:s;if(!f)break;c[v>>2]=f;v=v+4|0}else s=(c[s>>2]|0)==0?s+4|0:s;while(0);v=(v-J>>2|0)>(B|0)?p:v;f=(c[Ta>>2]|0)+A|0;c[Ta>>2]=f;if((f|0)>=0){C=v;break g}}}do{p=(f|0)<-9?9:0-f|0;do if(s>>>0<v>>>0){z=(1<<p)+-1|0;y=1e9>>>p;f=0;o=s;do{I=c[o>>2]|0;c[o>>2]=(I>>>p)+f;f=ba(I&z,y)|0;o=o+4|0}while(o>>>0<v>>>0);s=(c[s>>2]|0)==0?s+4|0:s;if(!f)break;c[v>>2]=f;v=v+4|0}else s=(c[s>>2]|0)==0?s+4|0:s;while(0);if((v-s>>2|0)>(B|0))v=s+(B<<2)|0;f=(c[Ta>>2]|0)+p|0;c[Ta>>2]=f}while((f|0)<0);C=v}else C=v;while(0);do if(s>>>0<C>>>0){v=(J-s>>2)*9|0;o=c[s>>2]|0;if(o>>>0<10)break;else f=10;do{f=f*10|0;v=v+1|0}while(o>>>0>=f>>>0)}else v=0;while(0);B=(H|0)==103;f=q-((H|0)!=102?v:0)+((B&(q|0)!=0)<<31>>31)|0;if((f|0)<(((C-J>>2)*9|0)+-9|0)){p=f+9216|0;A=(p|0)/9|0;f=L+(A+-1023<<2)|0;p=((p|0)%9|0)+1|0;if((p|0)<9){o=10;do{o=o*10|0;p=p+1|0}while((p|0)!=9)}else o=10;z=c[f>>2]|0;y=(z>>>0)%(o>>>0)|0;if((y|0)==0?(L+(A+-1022<<2)|0)==(C|0):0){X=s;W=f;V=v}else O=231;do if((O|0)==231){O=0;x=(((z>>>0)/(o>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;p=(o|0)/2|0;do if(y>>>0<p>>>0)r=.5;else{if((y|0)==(p|0)?(L+(A+-1022<<2)|0)==(C|0):0){r=1.0;break}r=1.5}while(0);do if(t){if((a[K>>0]|0)!=45)break;x=-x;r=-r}while(0);p=z-y|0;c[f>>2]=p;if(!(x+r!=x)){X=s;W=f;V=v;break}I=p+o|0;c[f>>2]=I;if(I>>>0>999999999)while(1){p=f+-4|0;c[f>>2]=0;if(p>>>0<s>>>0){s=s+-4|0;c[s>>2]=0}I=(c[p>>2]|0)+1|0;c[p>>2]=I;if(I>>>0>999999999)f=p;else{f=p;break}}p=(J-s>>2)*9|0;o=c[s>>2]|0;if(o>>>0<10){X=s;W=f;V=p;break}else v=10;do{v=v*10|0;p=p+1|0}while(o>>>0>=v>>>0);X=s;W=f;V=p}while(0);f=W+4|0;s=X;v=V;f=C>>>0>f>>>0?f:C}else f=C;G=s;A=0-v|0;while(1){if(f>>>0<=s>>>0){D=0;I=f;break}p=f+-4|0;if(!(c[p>>2]|0))f=p;else{D=1;I=f;break}}do if(B){q=((q|0)==0&1)+q|0;if((q|0)>(v|0)&(v|0)>-5){f=E+-1|0;q=q+-1-v|0}else{f=E+-2|0;q=q+-1|0}if(M&8)break;do if(D){z=c[I+-4>>2]|0;if(!z){p=9;break}if(!((z>>>0)%10|0)){y=10;p=0}else{p=0;break}do{y=y*10|0;p=p+1|0}while(((z>>>0)%(y>>>0)|0|0)==0)}else p=9;while(0);o=((I-J>>2)*9|0)+-9|0;if((f|32|0)==102){H=o-p|0;H=(H|0)<0?0:H;q=(q|0)<(H|0)?q:H;break}else{H=o+v-p|0;H=(H|0)<0?0:H;q=(q|0)<(H|0)?q:H;break}}else f=E;while(0);E=(q|0)!=0;if(E)o=1;else o=(M&8|0)!=0;B=o&1;C=(f|32|0)==102;if(C){v=(v|0)>0?v:0;A=0}else{z=(v|0)<0?A:v;if((z|0)<0){o=Ma;p=z;y=((z|0)<0)<<31>>31;while(1){z=wv(p|0,y|0,10,0)|0;o=o+-1|0;a[o>>0]=z|48;z=vv(p|0,y|0,10,0)|0;if(y>>>0>9|(y|0)==9&p>>>0>4294967295){p=z;y=F}else break}}else o=Ma;if(z)while(1){o=o+-1|0;a[o>>0]=(z>>>0)%10|0|48;if(z>>>0<10)break;else z=(z>>>0)/10|0}if((Oa-o|0)<2)do{o=o+-1|0;a[o>>0]=48}while((Oa-o|0)<2);a[o+-1>>0]=(v>>31&2)+43;A=o+-2|0;a[A>>0]=f;v=Oa-A|0}p=t+1+q+B+v|0;B=M&73728;H=(N|0)>(p|0);if((B|0)==0&H){y=N-p|0;kv(Za|0,32,(y>>>0>256?256:y)|0)|0;if(y>>>0>255){z=y;do{Tu(Za,256,e)|0;z=z+-256|0}while(z>>>0>255);y=y&255}Tu(Za,y,e)|0}Tu(K,t,e)|0;if((B|0)==65536&H){v=N-p|0;kv(Za|0,48,(v>>>0>256?256:v)|0)|0;if(v>>>0>255){o=v;do{Tu(Za,256,e)|0;o=o+-256|0}while(o>>>0>255);v=v&255}Tu(Za,v,e)|0}do if(C){z=s>>>0>L>>>0?L:s;v=~J;A=~G;A=v>>>0>A>>>0?v:A;v=3-A|0;y=L+1|0;y=(v>>>0>y>>>0?v:y)+A|0;A=~A;v=z;do{s=c[v>>2]|0;if(!s)t=ya;else{t=ya;while(1){t=t+-1|0;a[t>>0]=(s>>>0)%10|0|48;if(s>>>0<10)break;else s=(s>>>0)/10|0}}do if((v|0)==(z|0)){if((t|0)!=(ya|0))break;a[Aa>>0]=48;t=Aa}else{if(t>>>0<=Ra>>>0)break;do{t=t+-1|0;a[t>>0]=48}while(t>>>0>Ra>>>0)}while(0);Tu(t,za-t|0,e)|0;v=v+4|0}while(v>>>0<=L>>>0);if(!((M&8|0)==0&(E^1)))Tu(1088376,1,e)|0;if(v>>>0<I>>>0&(q|0)>0){t=(y&-4)+A|0;while(1){s=c[v>>2]|0;if(s){f=ya;while(1){f=f+-1|0;a[f>>0]=(s>>>0)%10|0|48;if(s>>>0<10)break;else s=(s>>>0)/10|0}if(f>>>0>Ra>>>0){ab=f;O=300}else ka=f}else{ab=ya;O=300}if((O|0)==300)while(1){O=0;f=ab+-1|0;a[f>>0]=48;if(f>>>0>Ra>>>0)ab=f;else{ka=f;break}}Tu(ka,(q|0)>9?9:q,e)|0;s=t+8|0;q=q+-9|0;if(s>>>0<I>>>0&(q|0)>0){t=v;v=s}else break}}if((q|0)<=0)break;kv(Za|0,48,(q>>>0>256?256:q)|0)|0;if(q>>>0>255){f=q;do{Tu(Za,256,e)|0;f=f+-256|0}while(f>>>0>255);q=q&255}Tu(Za,q,e)|0}else{o=D?I:s+4|0;do if((q|0)>-1){y=(M&8|0)==0;z=s;do{t=c[z>>2]|0;if(t){v=ya;f=t;while(1){t=v+-1|0;a[t>>0]=(f>>>0)%10|0|48;if(f>>>0<10)break;else{v=t;f=(f>>>0)/10|0}}if((t|0)!=(ya|0)){ua=v;bb=t}else O=312}else O=312;if((O|0)==312){O=0;a[Aa>>0]=48;ua=ya;bb=Aa}do if((z|0)==(s|0)){Tu(bb,1,e)|0;if((q|0)<1&y){t=ua;break}Tu(1088376,1,e)|0;t=ua}else{if(bb>>>0>Ra>>>0)t=bb;else{t=bb;break}do{t=t+-1|0;a[t>>0]=48}while(t>>>0>Ra>>>0)}while(0);I=za-t|0;Tu(t,(q|0)>(I|0)?I:q,e)|0;q=q-I|0;z=z+4|0}while(z>>>0<o>>>0&(q|0)>-1);if((q|0)<=0)break;kv(Za|0,48,(q>>>0>256?256:q)|0)|0;if(q>>>0>255){f=q;do{Tu(Za,256,e)|0;f=f+-256|0}while(f>>>0>255);q=q&255}Tu(Za,q,e)|0}while(0);Tu(A,Oa-A|0,e)|0}while(0);if((B|0)==8192&H){f=N-p|0;kv(Za|0,32,(f>>>0>256?256:f)|0)|0;if(f>>>0>255){q=f;do{Tu(Za,256,e)|0;q=q+-256|0}while(q>>>0>255);f=f&255}Tu(Za,f,e)|0}E=Ca;D=Ea;f=w;v=$;p=H?N:p;continue a}case 88:case 120:{Ua=M;Xa=I;cb=E;O=74;break}case 112:{Ua=M|8;Xa=I>>>0>8?I:8;cb=120;O=74;break}case 110:switch(y|0){case 1:{c[Ca>>2]=$;E=Ca;D=Ea;f=w;v=$;continue a}case 6:{c[Ca>>2]=$;E=Ca;D=Ea;f=w;v=$;continue a}case 3:{b[Ca>>1]=$;E=Ca;D=Ea;f=w;v=$;continue a}case 7:{E=Ca;c[E>>2]=$;c[E+4>>2]=(($|0)<0)<<31>>31;E=Ca;D=Ea;f=w;v=$;continue a}case 0:{c[Ca>>2]=$;E=Ca;D=Ea;f=w;v=$;continue a}case 2:{E=Ca;c[E>>2]=$;c[E+4>>2]=(($|0)<0)<<31>>31;E=Ca;D=Ea;f=w;v=$;continue a}case 4:{a[Ca>>0]=$;E=Ca;D=Ea;f=w;v=$;continue a}default:{E=Ca;D=Ea;f=w;v=$;continue a}}case 99:{a[Ja>>0]=Ca;ha=Ca;ia=Ea;ja=Ja;m=q;ca=1;da=0;ea=1088280;aa=Da;break}case 109:{Pa=Sb(c[(Cb()|0)>>2]|0)|0;O=95;break}case 115:{Pa=(Ca|0)==0?1088296:Ca;O=95;break}default:{ha=Ca;ia=Ea;ja=f;m=M;ca=I;da=0;ea=1088280;aa=Da}}while(0);do if((O|0)==74){n=cb&32;if(!((Ca|0)==0&(Ea|0)==0)){o=Da;p=Ca;f=Ea;do{o=o+-1|0;a[o>>0]=d[1088360+(p&15)>>0]|n;p=jv(p|0,f|0,4)|0;f=F}while(!((p|0)==0&(f|0)==0));if(!(Ua&8)){T=Ca;U=Ea;n=o;P=Ua;Q=Xa;R=0;S=1088280;O=90}else{T=Ca;U=Ea;n=o;P=Ua;Q=Xa;R=2;S=1088280+(cb>>4)|0;O=90}}else{T=Ca;U=Ea;n=Da;P=Ua;Q=Xa;R=0;S=1088280;O=90}}else if((O|0)==85){if(Fa>>>0>0|(Fa|0)==0&Ga>>>0>4294967295){n=Da;f=Ga;p=Fa;while(1){o=wv(f|0,p|0,10,0)|0;n=n+-1|0;a[n>>0]=o|48;o=vv(f|0,p|0,10,0)|0;if(p>>>0>9|(p|0)==9&f>>>0>4294967295){f=o;p=F}else break}}else{n=Da;o=Ga}if(!o){T=Ga;U=Fa;P=M;Q=I;R=_a;S=$a;O=90}else while(1){n=n+-1|0;a[n>>0]=(o>>>0)%10|0|48;if(o>>>0<10){T=Ga;U=Fa;P=M;Q=I;R=_a;S=$a;O=90;break}else o=(o>>>0)/10|0}}else if((O|0)==95){O=0;f=$u(Pa,0,I)|0;if(!f){ha=Ca;ia=Ea;ja=Pa;m=q;ca=I;da=0;ea=1088280;aa=Pa+I|0;break}else{ha=Ca;ia=Ea;ja=Pa;m=q;ca=f-Pa|0;da=0;ea=1088280;aa=f;break}}else if((O|0)==100){p=0;f=0;q=sa;while(1){o=c[q>>2]|0;if(!o)break;f=Ou(Wa,o)|0;if((f|0)<0|f>>>0>(Ya-p|0)>>>0)break;p=f+p|0;if(Ya>>>0>p>>>0)q=q+4|0;else break}if((f|0)<0){fb=-1;O=369;break a}else{Z=ta;_=sa;Y=p;O=105}}while(0);if((O|0)==90){O=0;m=(Q|0)>-1?P&-65537:P;o=(T|0)!=0|(U|0)!=0;if(o|(Q|0)!=0){ca=(o&1^1)+(Ia-n)|0;ha=T;ia=U;ja=n;ca=(Q|0)>(ca|0)?Q:ca;da=R;ea=S;aa=Da}else{ha=T;ia=U;ja=Da;ca=0;da=R;ea=S;aa=Da}}else if((O|0)==105){O=0;s=M&73728;o=(N|0)>(Y|0);if((s|0)==0&o){f=N-Y|0;kv(Za|0,32,(f>>>0>256?256:f)|0)|0;if(f>>>0>255){q=f;do{Tu(Za,256,e)|0;q=q+-256|0}while(q>>>0>255);f=f&255}Tu(Za,f,e)|0}h:do if(Y){f=0;p=_;while(1){q=c[p>>2]|0;if(!q)break h;q=Ou(Wa,q)|0;f=q+f|0;if((f|0)>(Y|0))break h;Tu(Wa,q,e)|0;if(f>>>0>=Y>>>0)break;else p=p+4|0}}while(0);if((s|0)==8192&o){f=N-Y|0;kv(Za|0,32,(f>>>0>256?256:f)|0)|0;if(f>>>0>255){p=f;do{Tu(Za,256,e)|0;p=p+-256|0}while(p>>>0>255);f=f&255}Tu(Za,f,e)|0}E=Z;D=Ea;f=w;v=$;p=o?N:Y;continue}o=aa-ja|0;v=(ca|0)<(o|0)?o:ca;p=da+v|0;z=(N|0)<(p|0)?p:N;t=m&73728;s=(z|0)>(p|0);if((t|0)==0&s){q=z-p|0;kv(Za|0,32,(q>>>0>256?256:q)|0)|0;if(q>>>0>255){f=q;do{Tu(Za,256,e)|0;f=f+-256|0}while(f>>>0>255);q=q&255}Tu(Za,q,e)|0}Tu(ea,da,e)|0;if((t|0)==65536&s){q=z-p|0;kv(Za|0,48,(q>>>0>256?256:q)|0)|0;if(q>>>0>255){f=q;do{Tu(Za,256,e)|0;f=f+-256|0}while(f>>>0>255);q=q&255}Tu(Za,q,e)|0}if((v|0)>(o|0)){q=v-o|0;kv(Za|0,48,(q>>>0>256?256:q)|0)|0;if(q>>>0>255){f=q;do{Tu(Za,256,e)|0;f=f+-256|0}while(f>>>0>255);q=q&255}Tu(Za,q,e)|0}Tu(ja,o,e)|0;if(!((t|0)==8192&s)){E=ha;D=ia;f=w;v=$;p=z;continue}f=z-p|0;kv(Za|0,32,(f>>>0>256?256:f)|0)|0;if(f>>>0>255){p=f;do{Tu(Za,256,e)|0;p=p+-256|0}while(p>>>0>255);f=f&255}Tu(Za,f,e)|0;E=ha;D=ia;f=w;v=$;p=z}if((O|0)==351){if(e){ab=Sa;i=hb;return ab|0}if(!Va){ab=0;i=hb;return ab|0}else o=1;while(1){m=c[l+(o<<2)>>2]|0;if(!m){gb=o;break}n=j+(o<<3)|0;i:do if(m>>>0<=20)do switch(m|0){case 9:{$a=c[g>>2]|0;ab=c[$a>>2]|0;c[g>>2]=$a+4;c[n>>2]=ab;break i}case 10:{ab=c[g>>2]|0;$a=c[ab>>2]|0;c[g>>2]=ab+4;ab=n;c[ab>>2]=$a;c[ab+4>>2]=(($a|0)<0)<<31>>31;break i}case 11:{ab=c[g>>2]|0;$a=c[ab>>2]|0;c[g>>2]=ab+4;ab=n;c[ab>>2]=$a;c[ab+4>>2]=0;break i}case 12:{ab=c[g>>2]|0;$a=ab;_a=c[$a>>2]|0;$a=c[$a+4>>2]|0;c[g>>2]=ab+8;ab=n;c[ab>>2]=_a;c[ab+4>>2]=$a;break i}case 13:{ab=c[g>>2]|0;$a=c[ab>>2]|0;c[g>>2]=ab+4;$a=($a&65535)<<16>>16;ab=n;c[ab>>2]=$a;c[ab+4>>2]=(($a|0)<0)<<31>>31;break i}case 14:{ab=c[g>>2]|0;$a=c[ab>>2]|0;c[g>>2]=ab+4;ab=n;c[ab>>2]=$a&65535;c[ab+4>>2]=0;break i}case 15:{ab=c[g>>2]|0;$a=c[ab>>2]|0;c[g>>2]=ab+4;$a=($a&255)<<24>>24;ab=n;c[ab>>2]=$a;c[ab+4>>2]=(($a|0)<0)<<31>>31;break i}case 16:{ab=c[g>>2]|0;$a=c[ab>>2]|0;c[g>>2]=ab+4;ab=n;c[ab>>2]=$a&255;c[ab+4>>2]=0;break i}case 17:{ab=c[g>>2]|0;c[k>>2]=c[ab>>2];c[k+4>>2]=c[ab+4>>2];r=+h[k>>3];c[g>>2]=ab+8;h[n>>3]=r;break i}case 18:{ab=c[g>>2]|0;c[k>>2]=c[ab>>2];c[k+4>>2]=c[ab+4>>2];r=+h[k>>3];c[g>>2]=ab+8;h[n>>3]=r;break i}default:break i}while(0);while(0);o=o+1|0;if((o|0)>=10){fb=1;O=369;break}}if((O|0)==369){i=hb;return fb|0}while(1){if(c[l+(gb<<2)>>2]|0){fb=-1;O=369;break}gb=gb+1|0;if((gb|0)>=10){fb=1;O=369;break}}if((O|0)==369){i=hb;return fb|0}}else if((O|0)==369){i=hb;return fb|0}return 0}function fv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=a+20|0;f=c[e>>2]|0;a=(c[a+16>>2]|0)-f|0;a=a>>>0>d>>>0?d:a;mv(f|0,b|0,a|0)|0;c[e>>2]=(c[e>>2]|0)+a;return d|0}function gv(){}function hv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=b-d-(c>>>0>a>>>0|0)>>>0;return (F=b,a-c>>>0|0)|0}function iv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c=a+c>>>0;return (F=b+d+(c>>>0<a>>>0|0)>>>0,c|0)|0}function jv(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){F=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}F=0;return b>>>c-32|0}function kv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;h=b&3;i=d|d<<8|d<<16|d<<24;g=f&~3;if(h){h=b+4-h|0;while((b|0)<(h|0)){a[b>>0]=d;b=b+1|0}}while((b|0)<(g|0)){c[b>>2]=i;b=b+4|0}}while((b|0)<(f|0)){a[b>>0]=d;b=b+1|0}return b-e|0}function lv(b){b=b|0;var c=0;c=b;while(a[c>>0]|0)c=c+1|0;return c-b|0}function mv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return cb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if(!e)return f|0;a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function nv(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b>>0]=a[c>>0]|0}b=e}else mv(b,c,d)|0;return b|0}function ov(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){F=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}F=a<<c-32;return 0}function pv(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){F=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}F=(b|0)<0?-1:0;return b>>c-32|0}function qv(b){b=b|0;var c=0;c=a[m+(b&255)>>0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (a[m+(b>>>24)>>0]|0)+24|0}function rv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=a&65535;d=b&65535;c=ba(d,f)|0;e=a>>>16;d=(c>>>16)+(ba(d,e)|0)|0;b=b>>>16;a=ba(b,f)|0;return (F=(d>>>16)+(ba(b,e)|0)+(((d&65535)+a|0)>>>16)|0,d+a<<16|c&65535|0)|0}function sv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=b>>31|((b|0)<0?-1:0)<<1;i=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;f=d>>31|((d|0)<0?-1:0)<<1;e=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;h=hv(j^a,i^b,j,i)|0;g=F;b=f^j;a=e^i;a=hv((xv(h,g,hv(f^c,e^d,f,e)|0,F,0)|0)^b,F^a,b,a)|0;return a|0}function tv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+8|0;j=f|0;h=b>>31|((b|0)<0?-1:0)<<1;g=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;l=e>>31|((e|0)<0?-1:0)<<1;k=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;b=hv(h^a,g^b,h,g)|0;a=F;xv(b,a,hv(l^d,k^e,l,k)|0,F,j)|0;a=hv(c[j>>2]^h,c[j+4>>2]^g,h,g)|0;b=F;i=f;return (F=b,a)|0}function uv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;f=c;a=rv(e,f)|0;c=F;return (F=(ba(b,f)|0)+(ba(d,e)|0)+c|c&0,a|0|0)|0}function vv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=xv(a,b,c,d,0)|0;return a|0}function wv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;g=i;i=i+8|0;f=g|0;xv(a,b,d,e,f)|0;i=g;return (F=c[f+4>>2]|0,c[f>>2]|0)|0}function xv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;n=a;l=b;m=l;k=d;o=e;i=o;if(!m){g=(f|0)!=0;if(!i){if(g){c[f>>2]=(n>>>0)%(k>>>0);c[f+4>>2]=0}l=0;m=(n>>>0)/(k>>>0)>>>0;return (F=l,m)|0}else{if(!g){l=0;m=0;return (F=l,m)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;l=0;m=0;return (F=l,m)|0}}j=(i|0)==0;do if(k){if(!j){h=(da(i|0)|0)-(da(m|0)|0)|0;if(h>>>0<=31){g=h+1|0;l=31-h|0;k=h-31>>31;i=g;j=n>>>(g>>>0)&k|m<<l;k=m>>>(g>>>0)&k;g=0;h=n<<l;break}if(!f){l=0;m=0;return (F=l,m)|0}c[f>>2]=a|0;c[f+4>>2]=l|b&0;l=0;m=0;return (F=l,m)|0}j=k-1|0;if(j&k){h=(da(k|0)|0)+33-(da(m|0)|0)|0;p=64-h|0;l=32-h|0;a=l>>31;b=h-32|0;k=b>>31;i=h;j=l-1>>31&m>>>(b>>>0)|(m<<l|n>>>(h>>>0))&k;k=k&m>>>(h>>>0);g=n<<p&a;h=(m<<p|n>>>(b>>>0))&a|n<<l&h-33>>31;break}if(f){c[f>>2]=j&n;c[f+4>>2]=0}if((k|0)==1){l=l|b&0;m=a|0|0;return (F=l,m)|0}else{a=qv(k|0)|0;l=m>>>(a>>>0)|0;m=m<<32-a|n>>>(a>>>0)|0;return (F=l,m)|0}}else{if(j){if(f){c[f>>2]=(m>>>0)%(k>>>0);c[f+4>>2]=0}l=0;m=(m>>>0)/(k>>>0)>>>0;return (F=l,m)|0}if(!n){if(f){c[f>>2]=0;c[f+4>>2]=(m>>>0)%(i>>>0)}l=0;m=(m>>>0)/(i>>>0)>>>0;return (F=l,m)|0}j=i-1|0;if(!(j&i)){if(f){c[f>>2]=a|0;c[f+4>>2]=j&m|b&0}l=0;m=m>>>((qv(i|0)|0)>>>0);return (F=l,m)|0}h=(da(i|0)|0)-(da(m|0)|0)|0;if(h>>>0<=30){k=h+1|0;h=31-h|0;i=k;j=m<<h|n>>>(k>>>0);k=m>>>(k>>>0);g=0;h=n<<h;break}if(!f){l=0;m=0;return (F=l,m)|0}c[f>>2]=a|0;c[f+4>>2]=l|b&0;l=0;m=0;return (F=l,m)|0}while(0);if(!i){l=h;i=0;h=0}else{m=d|0|0;l=o|e&0;b=iv(m,l,-1,-1)|0;a=F;d=h;h=0;do{p=d;d=g>>>31|d<<1;g=h|g<<1;p=j<<1|p>>>31|0;o=j>>>31|k<<1|0;hv(b,a,p,o)|0;n=F;e=n>>31|((n|0)<0?-1:0)<<1;h=e&1;j=hv(p,o,e&m,(((n|0)<0?-1:0)>>31|((n|0)<0?-1:0)<<1)&l)|0;k=F;i=i-1|0}while((i|0)!=0);l=d;i=0}d=0;if(f){c[f>>2]=j;c[f+4>>2]=k}l=(g|0)>>>31|(l|d)<<1|(d<<1|g>>>31)&0|i;m=(g<<1|0>>>31)&-2|h;return (F=l,m)|0}function yv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return $b[a&31](b|0,c|0,d|0)|0}function zv(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ac[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function Av(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;bc[a&3](b|0,c|0,d|0,e|0,f|0)}function Bv(a,b){a=a|0;b=b|0;cc[a&255](b|0)}function Cv(a,b,c){a=a|0;b=b|0;c=c|0;dc[a&63](b|0,c|0)}function Dv(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ec[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function Ev(a,b){a=a|0;b=b|0;return fc[a&127](b|0)|0}function Fv(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;gc[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function Gv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hc[a&3](b|0,c|0,d|0)}function Hv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ic[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function Iv(a){a=a|0;jc[a&3]()}function Jv(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return kc[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function Kv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return lc[a&7](b|0,c|0,d|0,e|0)|0}function Lv(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;mc[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function Mv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;nc[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function Nv(a,b,c){a=a|0;b=b|0;c=c|0;return oc[a&63](b|0,c|0)|0}function Ov(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return pc[a&15](b|0,c|0,d|0,e|0,f|0)|0}function Pv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;qc[a&15](b|0,c|0,d|0,e|0)}function Qv(a,b,c){a=a|0;b=b|0;c=c|0;ea(0);return 0}function Rv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ea(1)}function Sv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ea(2)}function Tv(a){a=a|0;ea(3)}function Uv(a,b){a=a|0;b=b|0;ea(4)}function Vv(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ea(5)}function Wv(a){a=a|0;ea(6);return 0}function Xv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ea(7)}function Yv(a,b,c){a=a|0;b=b|0;c=c|0;ea(8)}function Zv(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ea(9)}function _v(){ea(10)}function $v(){Ha()}function aw(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ea(11);return 0}function bw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ea(12);return 0}function cw(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ea(13)}function dw(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ea(14)}function ew(a,b){a=a|0;b=b|0;ea(15);return 0}function fw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ea(16);return 0}function gw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ea(17)}

// EMSCRIPTEN_END_FUNCS
var $b=[Qv,Oc,uj,yj,pj,Fj,Kj,ms,Oj,ws,ji,ki,Pk,Uk,Bo,Go,up,wp,zp,cp,jp,mp,pp,_t,fv,rt,Qv,Qv,Qv,Qv,Qv,Qv];var ac=[Rv,Xk,Yk,Zk,_k,$k,al,bl,cl,dl,el,fl,kl,ll,ml,nl,ol,pl,ql,rl,sl,tl,ul,Jl,Ll,Wl,Yl,fm,gm,hm,jm,lm,Em,Fm,Gm,Im,Km,so,yo,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv,Rv];var bc=[Sv,ku,ju,gu];var cc=[Tv,Dc,Ic,Jc,Kc,Rj,Tj,Sj,Uj,Lc,Mc,Qd,Rd,Td,Vd,Xd,Zd,$d,be,de,fe,ge,ie,ke,me,oe,qe,se,ue,De,Ee,Fe,Ge,He,Ie,xk,Ak,yk,Bk,zk,Ck,Je,Ke,Ue,We,Ye,_e,af,lf,mf,nf,of,ek,gk,fk,hk,kj,pf,tg,ug,vg,wg,xg,yg,zg,Ag,Vg,Wg,Hg,Xg,Yg,Ah,uh,Bh,th,Aj,js,os,ts,ys,oi,pi,lj,mj,Bj,Cj,$j,bk,ak,ck,sk,uk,tk,vk,Hk,Ik,ej,Jk,qi,Ds,Lk,Mk,$o,Qk,Rk,Vk,Wk,il,jl,Cl,Dl,Rl,Sl,cm,dm,Bm,Cm,_m,$m,cn,dn,gn,hn,sn,tn,Dn,En,On,Pn,Zn,_n,ho,io,no,oo,to,uo,zo,Ao,Eo,Fo,Oo,Po,rp,sp,Lq,Kp,iq,jq,kq,lq,Kk,_o,bp,Bp,Sp,_p,gq,hq,At,Bt,Ht,It,Kt,Lt,Nt,Ot,Rt,St,Ut,Xt,Vt,Wt,Yt,Zt,Eg,Mg,Uh,Vh,Wh,Sh,Rh,ao,ap,cs,uu,su,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv];var dc=[Uv,Nc,oj,ks,ps,us,zs,Ej,ln,mn,nn,on,qn,rn,wn,xn,yn,zn,Bn,Cn,Hn,In,Jn,Kn,Mn,Nn,Sn,Tn,Un,Vn,Xn,Yn,Do,Io,qq,sq,uq,rq,tq,vq,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv];var ec=[Vv,nm,Mm,Vv];var fc=[Wv,Rc,tj,Sc,wj,Sd,Ud,Wd,Yd,_d,ae,ce,ee,he,je,le,ne,pe,re,te,ve,sj,Ne,Ve,Xe,Ze,$e,bf,qf,rf,sf,ls,Jj,Lj,Mj,Ij,qs,rs,vs,vj,As,Bs,Mt,Dk,em,xq,zq,Bq,Hq,Jq,Dq,Fq,Dm,yq,Aq,Cq,Iq,Kq,Eq,Gq,jn,kn,pn,un,vn,An,Fn,Gn,Ln,Qn,Rn,Wn,Op,Pp,Rp,mq,oq,nq,pq,Fp,Gp,Ip,Wp,Xp,Zp,cq,dq,fq,Ct,Jt,Tt,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv,Wv];var gc=[Xv,po,vo,Xv];var hc=[Yv,ii,Ek,Yv];var ic=[Zv,Ml,Pl,Zl,$l,Zv,Zv,Zv];var jc=[_v,$v,pu,qu];var kc=[aw,Lp,Mp,Cp,Dp,Tp,Up,$p,aq,aw,aw,aw,aw,aw,aw,aw];var lc=[bw,yp,ep,fp,gp,op,bw,bw];var mc=[cw,an,en,$n,eo,jo,lo,cw];var nc=[dw,Pc,Le,qj,Gj,El,Fl,Kl,Ql,Tl,Ul,Xl,am,Co,Ho,nu,mu,lu,dw,dw,dw,dw,dw,dw,dw,dw,dw,dw,dw,dw,dw,dw];var oc=[ew,Tc,Uc,qd,td,ud,sd,pd,od,wd,vd,kd,jd,id,hd,gd,ed,ld,fd,Oe,Pe,xd,rd,nd,md,dd,xj,tf,Nj,ns,ss,Pj,xs,Cs,zj,tp,vp,xp,hp,kp,np,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew,ew];var pc=[fw,Nk,Sk,Ap,Np,Qp,qp,Ep,Hp,Vp,Yp,bq,eq,fw,fw,fw];var qc=[gw,Qc,Me,rj,Hj,Ok,Tk,au,bu,du,gw,gw,gw,gw,gw,gw];return{_i64Subtract:hv,_free:uu,_realloc:wu,_i64Add:iv,_memmove:nv,_uci_command:Se,_init:Re,_strlen:lv,_memset:kv,_malloc:tu,_memcpy:mv,_bitshift64Lshr:jv,_calloc:vu,_bitshift64Shl:ov,__GLOBAL__sub_I_evaluate_cpp:Qe,__GLOBAL__sub_I_misc_cpp:jf,__GLOBAL__sub_I_position_cpp:qg,__GLOBAL__sub_I_search_cpp:Jg,__GLOBAL__sub_I_iostream_cpp:Mq,runPostSets:gv,stackAlloc:rc,stackSave:sc,stackRestore:tc,setThrew:uc,setTempRet0:xc,getTempRet0:yc,dynCall_iiii:yv,dynCall_viiiiiii:zv,dynCall_viiiii:Av,dynCall_vi:Bv,dynCall_vii:Cv,dynCall_viiiiiiiii:Dv,dynCall_ii:Ev,dynCall_viiiiiid:Fv,dynCall_viii:Gv,dynCall_viiiiid:Hv,dynCall_v:Iv,dynCall_iiiiiiiii:Jv,dynCall_iiiii:Kv,dynCall_viiiiiiii:Lv,dynCall_viiiiii:Mv,dynCall_iii:Nv,dynCall_iiiiii:Ov,dynCall_viiii:Pv}})


// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg,Module.asmLibraryArg,buffer);var _i64Subtract=Module["_i64Subtract"]=asm["_i64Subtract"];var _free=Module["_free"]=asm["_free"];var _realloc=Module["_realloc"]=asm["_realloc"];var _i64Add=Module["_i64Add"]=asm["_i64Add"];var _memmove=Module["_memmove"]=asm["_memmove"];var _uci_command=Module["_uci_command"]=asm["_uci_command"];var _init=Module["_init"]=asm["_init"];var _strlen=Module["_strlen"]=asm["_strlen"];var _memset=Module["_memset"]=asm["_memset"];var _malloc=Module["_malloc"]=asm["_malloc"];var _memcpy=Module["_memcpy"]=asm["_memcpy"];var _bitshift64Lshr=Module["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var _calloc=Module["_calloc"]=asm["_calloc"];var _bitshift64Shl=Module["_bitshift64Shl"]=asm["_bitshift64Shl"];var __GLOBAL__sub_I_evaluate_cpp=Module["__GLOBAL__sub_I_evaluate_cpp"]=asm["__GLOBAL__sub_I_evaluate_cpp"];var __GLOBAL__sub_I_misc_cpp=Module["__GLOBAL__sub_I_misc_cpp"]=asm["__GLOBAL__sub_I_misc_cpp"];var __GLOBAL__sub_I_position_cpp=Module["__GLOBAL__sub_I_position_cpp"]=asm["__GLOBAL__sub_I_position_cpp"];var __GLOBAL__sub_I_search_cpp=Module["__GLOBAL__sub_I_search_cpp"]=asm["__GLOBAL__sub_I_search_cpp"];var __GLOBAL__sub_I_iostream_cpp=Module["__GLOBAL__sub_I_iostream_cpp"]=asm["__GLOBAL__sub_I_iostream_cpp"];var runPostSets=Module["runPostSets"]=asm["runPostSets"];var dynCall_iiii=Module["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_viiiiiii=Module["dynCall_viiiiiii"]=asm["dynCall_viiiiiii"];var dynCall_viiiii=Module["dynCall_viiiii"]=asm["dynCall_viiiii"];var dynCall_vi=Module["dynCall_vi"]=asm["dynCall_vi"];var dynCall_vii=Module["dynCall_vii"]=asm["dynCall_vii"];var dynCall_viiiiiiiii=Module["dynCall_viiiiiiiii"]=asm["dynCall_viiiiiiiii"];var dynCall_ii=Module["dynCall_ii"]=asm["dynCall_ii"];var dynCall_viiiiiid=Module["dynCall_viiiiiid"]=asm["dynCall_viiiiiid"];var dynCall_viii=Module["dynCall_viii"]=asm["dynCall_viii"];var dynCall_viiiiid=Module["dynCall_viiiiid"]=asm["dynCall_viiiiid"];var dynCall_v=Module["dynCall_v"]=asm["dynCall_v"];var dynCall_iiiiiiiii=Module["dynCall_iiiiiiiii"]=asm["dynCall_iiiiiiiii"];var dynCall_iiiii=Module["dynCall_iiiii"]=asm["dynCall_iiiii"];var dynCall_viiiiiiii=Module["dynCall_viiiiiiii"]=asm["dynCall_viiiiiiii"];var dynCall_viiiiii=Module["dynCall_viiiiii"]=asm["dynCall_viiiiii"];var dynCall_iii=Module["dynCall_iii"]=asm["dynCall_iii"];var dynCall_iiiiii=Module["dynCall_iiiiii"]=asm["dynCall_iiiiii"];var dynCall_viiii=Module["dynCall_viiii"]=asm["dynCall_viiii"];Runtime.stackAlloc=asm["stackAlloc"];Runtime.stackSave=asm["stackSave"];Runtime.stackRestore=asm["stackRestore"];Runtime.setTempRet0=asm["setTempRet0"];Runtime.getTempRet0=asm["getTempRet0"];var i64Math=(function(){var goog={math:{}};goog.math.Long=(function(low,high){this.low_=low|0;this.high_=high|0});goog.math.Long.IntCache_={};goog.math.Long.fromInt=(function(value){if(-128<=value&&value<128){var cachedObj=goog.math.Long.IntCache_[value];if(cachedObj){return cachedObj}}var obj=new goog.math.Long(value|0,value<0?-1:0);if(-128<=value&&value<128){goog.math.Long.IntCache_[value]=obj}return obj});goog.math.Long.fromNumber=(function(value){if(isNaN(value)||!isFinite(value)){return goog.math.Long.ZERO}else if(value<=-goog.math.Long.TWO_PWR_63_DBL_){return goog.math.Long.MIN_VALUE}else if(value+1>=goog.math.Long.TWO_PWR_63_DBL_){return goog.math.Long.MAX_VALUE}else if(value<0){return goog.math.Long.fromNumber(-value).negate()}else{return new goog.math.Long(value%goog.math.Long.TWO_PWR_32_DBL_|0,value/goog.math.Long.TWO_PWR_32_DBL_|0)}});goog.math.Long.fromBits=(function(lowBits,highBits){return new goog.math.Long(lowBits,highBits)});goog.math.Long.fromString=(function(str,opt_radix){if(str.length==0){throw Error("number format error: empty string")}var radix=opt_radix||10;if(radix<2||36<radix){throw Error("radix out of range: "+radix)}if(str.charAt(0)=="-"){return goog.math.Long.fromString(str.substring(1),radix).negate()}else if(str.indexOf("-")>=0){throw Error('number format error: interior "-" character: '+str)}var radixToPower=goog.math.Long.fromNumber(Math.pow(radix,8));var result=goog.math.Long.ZERO;for(var i=0;i<str.length;i+=8){var size=Math.min(8,str.length-i);var value=parseInt(str.substring(i,i+size),radix);if(size<8){var power=goog.math.Long.fromNumber(Math.pow(radix,size));result=result.multiply(power).add(goog.math.Long.fromNumber(value))}else{result=result.multiply(radixToPower);result=result.add(goog.math.Long.fromNumber(value))}}return result});goog.math.Long.TWO_PWR_16_DBL_=1<<16;goog.math.Long.TWO_PWR_24_DBL_=1<<24;goog.math.Long.TWO_PWR_32_DBL_=goog.math.Long.TWO_PWR_16_DBL_*goog.math.Long.TWO_PWR_16_DBL_;goog.math.Long.TWO_PWR_31_DBL_=goog.math.Long.TWO_PWR_32_DBL_/2;goog.math.Long.TWO_PWR_48_DBL_=goog.math.Long.TWO_PWR_32_DBL_*goog.math.Long.TWO_PWR_16_DBL_;goog.math.Long.TWO_PWR_64_DBL_=goog.math.Long.TWO_PWR_32_DBL_*goog.math.Long.TWO_PWR_32_DBL_;goog.math.Long.TWO_PWR_63_DBL_=goog.math.Long.TWO_PWR_64_DBL_/2;goog.math.Long.ZERO=goog.math.Long.fromInt(0);goog.math.Long.ONE=goog.math.Long.fromInt(1);goog.math.Long.NEG_ONE=goog.math.Long.fromInt(-1);goog.math.Long.MAX_VALUE=goog.math.Long.fromBits(4294967295|0,2147483647|0);goog.math.Long.MIN_VALUE=goog.math.Long.fromBits(0,2147483648|0);goog.math.Long.TWO_PWR_24_=goog.math.Long.fromInt(1<<24);goog.math.Long.prototype.toInt=(function(){return this.low_});goog.math.Long.prototype.toNumber=(function(){return this.high_*goog.math.Long.TWO_PWR_32_DBL_+this.getLowBitsUnsigned()});goog.math.Long.prototype.toString=(function(opt_radix){var radix=opt_radix||10;if(radix<2||36<radix){throw Error("radix out of range: "+radix)}if(this.isZero()){return"0"}if(this.isNegative()){if(this.equals(goog.math.Long.MIN_VALUE)){var radixLong=goog.math.Long.fromNumber(radix);var div=this.div(radixLong);var rem=div.multiply(radixLong).subtract(this);return div.toString(radix)+rem.toInt().toString(radix)}else{return"-"+this.negate().toString(radix)}}var radixToPower=goog.math.Long.fromNumber(Math.pow(radix,6));var rem=this;var result="";while(true){var remDiv=rem.div(radixToPower);var intval=rem.subtract(remDiv.multiply(radixToPower)).toInt();var digits=intval.toString(radix);rem=remDiv;if(rem.isZero()){return digits+result}else{while(digits.length<6){digits="0"+digits}result=""+digits+result}}});goog.math.Long.prototype.getHighBits=(function(){return this.high_});goog.math.Long.prototype.getLowBits=(function(){return this.low_});goog.math.Long.prototype.getLowBitsUnsigned=(function(){return this.low_>=0?this.low_:goog.math.Long.TWO_PWR_32_DBL_+this.low_});goog.math.Long.prototype.getNumBitsAbs=(function(){if(this.isNegative()){if(this.equals(goog.math.Long.MIN_VALUE)){return 64}else{return this.negate().getNumBitsAbs()}}else{var val=this.high_!=0?this.high_:this.low_;for(var bit=31;bit>0;bit--){if((val&1<<bit)!=0){break}}return this.high_!=0?bit+33:bit+1}});goog.math.Long.prototype.isZero=(function(){return this.high_==0&&this.low_==0});goog.math.Long.prototype.isNegative=(function(){return this.high_<0});goog.math.Long.prototype.isOdd=(function(){return(this.low_&1)==1});goog.math.Long.prototype.equals=(function(other){return this.high_==other.high_&&this.low_==other.low_});goog.math.Long.prototype.notEquals=(function(other){return this.high_!=other.high_||this.low_!=other.low_});goog.math.Long.prototype.lessThan=(function(other){return this.compare(other)<0});goog.math.Long.prototype.lessThanOrEqual=(function(other){return this.compare(other)<=0});goog.math.Long.prototype.greaterThan=(function(other){return this.compare(other)>0});goog.math.Long.prototype.greaterThanOrEqual=(function(other){return this.compare(other)>=0});goog.math.Long.prototype.compare=(function(other){if(this.equals(other)){return 0}var thisNeg=this.isNegative();var otherNeg=other.isNegative();if(thisNeg&&!otherNeg){return-1}if(!thisNeg&&otherNeg){return 1}if(this.subtract(other).isNegative()){return-1}else{return 1}});goog.math.Long.prototype.negate=(function(){if(this.equals(goog.math.Long.MIN_VALUE)){return goog.math.Long.MIN_VALUE}else{return this.not().add(goog.math.Long.ONE)}});goog.math.Long.prototype.add=(function(other){var a48=this.high_>>>16;var a32=this.high_&65535;var a16=this.low_>>>16;var a00=this.low_&65535;var b48=other.high_>>>16;var b32=other.high_&65535;var b16=other.low_>>>16;var b00=other.low_&65535;var c48=0,c32=0,c16=0,c00=0;c00+=a00+b00;c16+=c00>>>16;c00&=65535;c16+=a16+b16;c32+=c16>>>16;c16&=65535;c32+=a32+b32;c48+=c32>>>16;c32&=65535;c48+=a48+b48;c48&=65535;return goog.math.Long.fromBits(c16<<16|c00,c48<<16|c32)});goog.math.Long.prototype.subtract=(function(other){return this.add(other.negate())});goog.math.Long.prototype.multiply=(function(other){if(this.isZero()){return goog.math.Long.ZERO}else if(other.isZero()){return goog.math.Long.ZERO}if(this.equals(goog.math.Long.MIN_VALUE)){return other.isOdd()?goog.math.Long.MIN_VALUE:goog.math.Long.ZERO}else if(other.equals(goog.math.Long.MIN_VALUE)){return this.isOdd()?goog.math.Long.MIN_VALUE:goog.math.Long.ZERO}if(this.isNegative()){if(other.isNegative()){return this.negate().multiply(other.negate())}else{return this.negate().multiply(other).negate()}}else if(other.isNegative()){return this.multiply(other.negate()).negate()}if(this.lessThan(goog.math.Long.TWO_PWR_24_)&&other.lessThan(goog.math.Long.TWO_PWR_24_)){return goog.math.Long.fromNumber(this.toNumber()*other.toNumber())}var a48=this.high_>>>16;var a32=this.high_&65535;var a16=this.low_>>>16;var a00=this.low_&65535;var b48=other.high_>>>16;var b32=other.high_&65535;var b16=other.low_>>>16;var b00=other.low_&65535;var c48=0,c32=0,c16=0,c00=0;c00+=a00*b00;c16+=c00>>>16;c00&=65535;c16+=a16*b00;c32+=c16>>>16;c16&=65535;c16+=a00*b16;c32+=c16>>>16;c16&=65535;c32+=a32*b00;c48+=c32>>>16;c32&=65535;c32+=a16*b16;c48+=c32>>>16;c32&=65535;c32+=a00*b32;c48+=c32>>>16;c32&=65535;c48+=a48*b00+a32*b16+a16*b32+a00*b48;c48&=65535;return goog.math.Long.fromBits(c16<<16|c00,c48<<16|c32)});goog.math.Long.prototype.div=(function(other){if(other.isZero()){throw Error("division by zero")}else if(this.isZero()){return goog.math.Long.ZERO}if(this.equals(goog.math.Long.MIN_VALUE)){if(other.equals(goog.math.Long.ONE)||other.equals(goog.math.Long.NEG_ONE)){return goog.math.Long.MIN_VALUE}else if(other.equals(goog.math.Long.MIN_VALUE)){return goog.math.Long.ONE}else{var halfThis=this.shiftRight(1);var approx=halfThis.div(other).shiftLeft(1);if(approx.equals(goog.math.Long.ZERO)){return other.isNegative()?goog.math.Long.ONE:goog.math.Long.NEG_ONE}else{var rem=this.subtract(other.multiply(approx));var result=approx.add(rem.div(other));return result}}}else if(other.equals(goog.math.Long.MIN_VALUE)){return goog.math.Long.ZERO}if(this.isNegative()){if(other.isNegative()){return this.negate().div(other.negate())}else{return this.negate().div(other).negate()}}else if(other.isNegative()){return this.div(other.negate()).negate()}var res=goog.math.Long.ZERO;var rem=this;while(rem.greaterThanOrEqual(other)){var approx=Math.max(1,Math.floor(rem.toNumber()/other.toNumber()));var log2=Math.ceil(Math.log(approx)/Math.LN2);var delta=log2<=48?1:Math.pow(2,log2-48);var approxRes=goog.math.Long.fromNumber(approx);var approxRem=approxRes.multiply(other);while(approxRem.isNegative()||approxRem.greaterThan(rem)){approx-=delta;approxRes=goog.math.Long.fromNumber(approx);approxRem=approxRes.multiply(other)}if(approxRes.isZero()){approxRes=goog.math.Long.ONE}res=res.add(approxRes);rem=rem.subtract(approxRem)}return res});goog.math.Long.prototype.modulo=(function(other){return this.subtract(this.div(other).multiply(other))});goog.math.Long.prototype.not=(function(){return goog.math.Long.fromBits(~this.low_,~this.high_)});goog.math.Long.prototype.and=(function(other){return goog.math.Long.fromBits(this.low_&other.low_,this.high_&other.high_)});goog.math.Long.prototype.or=(function(other){return goog.math.Long.fromBits(this.low_|other.low_,this.high_|other.high_)});goog.math.Long.prototype.xor=(function(other){return goog.math.Long.fromBits(this.low_^other.low_,this.high_^other.high_)});goog.math.Long.prototype.shiftLeft=(function(numBits){numBits&=63;if(numBits==0){return this}else{var low=this.low_;if(numBits<32){var high=this.high_;return goog.math.Long.fromBits(low<<numBits,high<<numBits|low>>>32-numBits)}else{return goog.math.Long.fromBits(0,low<<numBits-32)}}});goog.math.Long.prototype.shiftRight=(function(numBits){numBits&=63;if(numBits==0){return this}else{var high=this.high_;if(numBits<32){var low=this.low_;return goog.math.Long.fromBits(low>>>numBits|high<<32-numBits,high>>numBits)}else{return goog.math.Long.fromBits(high>>numBits-32,high>=0?0:-1)}}});goog.math.Long.prototype.shiftRightUnsigned=(function(numBits){numBits&=63;if(numBits==0){return this}else{var high=this.high_;if(numBits<32){var low=this.low_;return goog.math.Long.fromBits(low>>>numBits|high<<32-numBits,high>>>numBits)}else if(numBits==32){return goog.math.Long.fromBits(high,0)}else{return goog.math.Long.fromBits(high>>>numBits-32,0)}}});var navigator={appName:"Modern Browser"};var dbits;var canary=0xdeadbeefcafe;var j_lm=(canary&16777215)==15715070;function BigInteger(a,b,c){if(a!=null)if("number"==typeof a)this.fromNumber(a,b,c);else if(b==null&&"string"!=typeof a)this.fromString(a,256);else this.fromString(a,b)}function nbi(){return new BigInteger(null)}function am1(i,x,w,j,c,n){while(--n>=0){var v=x*this[i++]+w[j]+c;c=Math.floor(v/67108864);w[j++]=v&67108863}return c}function am2(i,x,w,j,c,n){var xl=x&32767,xh=x>>15;while(--n>=0){var l=this[i]&32767;var h=this[i++]>>15;var m=xh*l+h*xl;l=xl*l+((m&32767)<<15)+w[j]+(c&1073741823);c=(l>>>30)+(m>>>15)+xh*h+(c>>>30);w[j++]=l&1073741823}return c}function am3(i,x,w,j,c,n){var xl=x&16383,xh=x>>14;while(--n>=0){var l=this[i]&16383;var h=this[i++]>>14;var m=xh*l+h*xl;l=xl*l+((m&16383)<<14)+w[j]+c;c=(l>>28)+(m>>14)+xh*h;w[j++]=l&268435455}return c}if(j_lm&&navigator.appName=="Microsoft Internet Explorer"){BigInteger.prototype.am=am2;dbits=30}else if(j_lm&&navigator.appName!="Netscape"){BigInteger.prototype.am=am1;dbits=26}else{BigInteger.prototype.am=am3;dbits=28}BigInteger.prototype.DB=dbits;BigInteger.prototype.DM=(1<<dbits)-1;BigInteger.prototype.DV=1<<dbits;var BI_FP=52;BigInteger.prototype.FV=Math.pow(2,BI_FP);BigInteger.prototype.F1=BI_FP-dbits;BigInteger.prototype.F2=2*dbits-BI_FP;var BI_RM="0123456789abcdefghijklmnopqrstuvwxyz";var BI_RC=new Array;var rr,vv;rr="0".charCodeAt(0);for(vv=0;vv<=9;++vv)BI_RC[rr++]=vv;rr="a".charCodeAt(0);for(vv=10;vv<36;++vv)BI_RC[rr++]=vv;rr="A".charCodeAt(0);for(vv=10;vv<36;++vv)BI_RC[rr++]=vv;function int2char(n){return BI_RM.charAt(n)}function intAt(s,i){var c=BI_RC[s.charCodeAt(i)];return c==null?-1:c}function bnpCopyTo(r){for(var i=this.t-1;i>=0;--i)r[i]=this[i];r.t=this.t;r.s=this.s}function bnpFromInt(x){this.t=1;this.s=x<0?-1:0;if(x>0)this[0]=x;else if(x<-1)this[0]=x+DV;else this.t=0}function nbv(i){var r=nbi();r.fromInt(i);return r}function bnpFromString(s,b){var k;if(b==16)k=4;else if(b==8)k=3;else if(b==256)k=8;else if(b==2)k=1;else if(b==32)k=5;else if(b==4)k=2;else{this.fromRadix(s,b);return}this.t=0;this.s=0;var i=s.length,mi=false,sh=0;while(--i>=0){var x=k==8?s[i]&255:intAt(s,i);if(x<0){if(s.charAt(i)=="-")mi=true;continue}mi=false;if(sh==0)this[this.t++]=x;else if(sh+k>this.DB){this[this.t-1]|=(x&(1<<this.DB-sh)-1)<<sh;this[this.t++]=x>>this.DB-sh}else this[this.t-1]|=x<<sh;sh+=k;if(sh>=this.DB)sh-=this.DB}if(k==8&&(s[0]&128)!=0){this.s=-1;if(sh>0)this[this.t-1]|=(1<<this.DB-sh)-1<<sh}this.clamp();if(mi)BigInteger.ZERO.subTo(this,this)}function bnpClamp(){var c=this.s&this.DM;while(this.t>0&&this[this.t-1]==c)--this.t}function bnToString(b){if(this.s<0)return"-"+this.negate().toString(b);var k;if(b==16)k=4;else if(b==8)k=3;else if(b==2)k=1;else if(b==32)k=5;else if(b==4)k=2;else return this.toRadix(b);var km=(1<<k)-1,d,m=false,r="",i=this.t;var p=this.DB-i*this.DB%k;if(i-->0){if(p<this.DB&&(d=this[i]>>p)>0){m=true;r=int2char(d)}while(i>=0){if(p<k){d=(this[i]&(1<<p)-1)<<k-p;d|=this[--i]>>(p+=this.DB-k)}else{d=this[i]>>(p-=k)&km;if(p<=0){p+=this.DB;--i}}if(d>0)m=true;if(m)r+=int2char(d)}}return m?r:"0"}function bnNegate(){var r=nbi();BigInteger.ZERO.subTo(this,r);return r}function bnAbs(){return this.s<0?this.negate():this}function bnCompareTo(a){var r=this.s-a.s;if(r!=0)return r;var i=this.t;r=i-a.t;if(r!=0)return this.s<0?-r:r;while(--i>=0)if((r=this[i]-a[i])!=0)return r;return 0}function nbits(x){var r=1,t;if((t=x>>>16)!=0){x=t;r+=16}if((t=x>>8)!=0){x=t;r+=8}if((t=x>>4)!=0){x=t;r+=4}if((t=x>>2)!=0){x=t;r+=2}if((t=x>>1)!=0){x=t;r+=1}return r}function bnBitLength(){if(this.t<=0)return 0;return this.DB*(this.t-1)+nbits(this[this.t-1]^this.s&this.DM)}function bnpDLShiftTo(n,r){var i;for(i=this.t-1;i>=0;--i)r[i+n]=this[i];for(i=n-1;i>=0;--i)r[i]=0;r.t=this.t+n;r.s=this.s}function bnpDRShiftTo(n,r){for(var i=n;i<this.t;++i)r[i-n]=this[i];r.t=Math.max(this.t-n,0);r.s=this.s}function bnpLShiftTo(n,r){var bs=n%this.DB;var cbs=this.DB-bs;var bm=(1<<cbs)-1;var ds=Math.floor(n/this.DB),c=this.s<<bs&this.DM,i;for(i=this.t-1;i>=0;--i){r[i+ds+1]=this[i]>>cbs|c;c=(this[i]&bm)<<bs}for(i=ds-1;i>=0;--i)r[i]=0;r[ds]=c;r.t=this.t+ds+1;r.s=this.s;r.clamp()}function bnpRShiftTo(n,r){r.s=this.s;var ds=Math.floor(n/this.DB);if(ds>=this.t){r.t=0;return}var bs=n%this.DB;var cbs=this.DB-bs;var bm=(1<<bs)-1;r[0]=this[ds]>>bs;for(var i=ds+1;i<this.t;++i){r[i-ds-1]|=(this[i]&bm)<<cbs;r[i-ds]=this[i]>>bs}if(bs>0)r[this.t-ds-1]|=(this.s&bm)<<cbs;r.t=this.t-ds;r.clamp()}function bnpSubTo(a,r){var i=0,c=0,m=Math.min(a.t,this.t);while(i<m){c+=this[i]-a[i];r[i++]=c&this.DM;c>>=this.DB}if(a.t<this.t){c-=a.s;while(i<this.t){c+=this[i];r[i++]=c&this.DM;c>>=this.DB}c+=this.s}else{c+=this.s;while(i<a.t){c-=a[i];r[i++]=c&this.DM;c>>=this.DB}c-=a.s}r.s=c<0?-1:0;if(c<-1)r[i++]=this.DV+c;else if(c>0)r[i++]=c;r.t=i;r.clamp()}function bnpMultiplyTo(a,r){var x=this.abs(),y=a.abs();var i=x.t;r.t=i+y.t;while(--i>=0)r[i]=0;for(i=0;i<y.t;++i)r[i+x.t]=x.am(0,y[i],r,i,0,x.t);r.s=0;r.clamp();if(this.s!=a.s)BigInteger.ZERO.subTo(r,r)}function bnpSquareTo(r){var x=this.abs();var i=r.t=2*x.t;while(--i>=0)r[i]=0;for(i=0;i<x.t-1;++i){var c=x.am(i,x[i],r,2*i,0,1);if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1))>=x.DV){r[i+x.t]-=x.DV;r[i+x.t+1]=1}}if(r.t>0)r[r.t-1]+=x.am(i,x[i],r,2*i,0,1);r.s=0;r.clamp()}function bnpDivRemTo(m,q,r){var pm=m.abs();if(pm.t<=0)return;var pt=this.abs();if(pt.t<pm.t){if(q!=null)q.fromInt(0);if(r!=null)this.copyTo(r);return}if(r==null)r=nbi();var y=nbi(),ts=this.s,ms=m.s;var nsh=this.DB-nbits(pm[pm.t-1]);if(nsh>0){pm.lShiftTo(nsh,y);pt.lShiftTo(nsh,r)}else{pm.copyTo(y);pt.copyTo(r)}var ys=y.t;var y0=y[ys-1];if(y0==0)return;var yt=y0*(1<<this.F1)+(ys>1?y[ys-2]>>this.F2:0);var d1=this.FV/yt,d2=(1<<this.F1)/yt,e=1<<this.F2;var i=r.t,j=i-ys,t=q==null?nbi():q;y.dlShiftTo(j,t);if(r.compareTo(t)>=0){r[r.t++]=1;r.subTo(t,r)}BigInteger.ONE.dlShiftTo(ys,t);t.subTo(y,y);while(y.t<ys)y[y.t++]=0;while(--j>=0){var qd=r[--i]==y0?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);if((r[i]+=y.am(0,qd,r,j,0,ys))<qd){y.dlShiftTo(j,t);r.subTo(t,r);while(r[i]<--qd)r.subTo(t,r)}}if(q!=null){r.drShiftTo(ys,q);if(ts!=ms)BigInteger.ZERO.subTo(q,q)}r.t=ys;r.clamp();if(nsh>0)r.rShiftTo(nsh,r);if(ts<0)BigInteger.ZERO.subTo(r,r)}function bnMod(a){var r=nbi();this.abs().divRemTo(a,null,r);if(this.s<0&&r.compareTo(BigInteger.ZERO)>0)a.subTo(r,r);return r}function Classic(m){this.m=m}function cConvert(x){if(x.s<0||x.compareTo(this.m)>=0)return x.mod(this.m);else return x}function cRevert(x){return x}function cReduce(x){x.divRemTo(this.m,null,x)}function cMulTo(x,y,r){x.multiplyTo(y,r);this.reduce(r)}function cSqrTo(x,r){x.squareTo(r);this.reduce(r)}Classic.prototype.convert=cConvert;Classic.prototype.revert=cRevert;Classic.prototype.reduce=cReduce;Classic.prototype.mulTo=cMulTo;Classic.prototype.sqrTo=cSqrTo;function bnpInvDigit(){if(this.t<1)return 0;var x=this[0];if((x&1)==0)return 0;var y=x&3;y=y*(2-(x&15)*y)&15;y=y*(2-(x&255)*y)&255;y=y*(2-((x&65535)*y&65535))&65535;y=y*(2-x*y%this.DV)%this.DV;return y>0?this.DV-y:-y}function Montgomery(m){this.m=m;this.mp=m.invDigit();this.mpl=this.mp&32767;this.mph=this.mp>>15;this.um=(1<<m.DB-15)-1;this.mt2=2*m.t}function montConvert(x){var r=nbi();x.abs().dlShiftTo(this.m.t,r);r.divRemTo(this.m,null,r);if(x.s<0&&r.compareTo(BigInteger.ZERO)>0)this.m.subTo(r,r);return r}function montRevert(x){var r=nbi();x.copyTo(r);this.reduce(r);return r}function montReduce(x){while(x.t<=this.mt2)x[x.t++]=0;for(var i=0;i<this.m.t;++i){var j=x[i]&32767;var u0=j*this.mpl+((j*this.mph+(x[i]>>15)*this.mpl&this.um)<<15)&x.DM;j=i+this.m.t;x[j]+=this.m.am(0,u0,x,i,0,this.m.t);while(x[j]>=x.DV){x[j]-=x.DV;x[++j]++}}x.clamp();x.drShiftTo(this.m.t,x);if(x.compareTo(this.m)>=0)x.subTo(this.m,x)}function montSqrTo(x,r){x.squareTo(r);this.reduce(r)}function montMulTo(x,y,r){x.multiplyTo(y,r);this.reduce(r)}Montgomery.prototype.convert=montConvert;Montgomery.prototype.revert=montRevert;Montgomery.prototype.reduce=montReduce;Montgomery.prototype.mulTo=montMulTo;Montgomery.prototype.sqrTo=montSqrTo;function bnpIsEven(){return(this.t>0?this[0]&1:this.s)==0}function bnpExp(e,z){if(e>4294967295||e<1)return BigInteger.ONE;var r=nbi(),r2=nbi(),g=z.convert(this),i=nbits(e)-1;g.copyTo(r);while(--i>=0){z.sqrTo(r,r2);if((e&1<<i)>0)z.mulTo(r2,g,r);else{var t=r;r=r2;r2=t}}return z.revert(r)}function bnModPowInt(e,m){var z;if(e<256||m.isEven())z=new Classic(m);else z=new Montgomery(m);return this.exp(e,z)}BigInteger.prototype.copyTo=bnpCopyTo;BigInteger.prototype.fromInt=bnpFromInt;BigInteger.prototype.fromString=bnpFromString;BigInteger.prototype.clamp=bnpClamp;BigInteger.prototype.dlShiftTo=bnpDLShiftTo;BigInteger.prototype.drShiftTo=bnpDRShiftTo;BigInteger.prototype.lShiftTo=bnpLShiftTo;BigInteger.prototype.rShiftTo=bnpRShiftTo;BigInteger.prototype.subTo=bnpSubTo;BigInteger.prototype.multiplyTo=bnpMultiplyTo;BigInteger.prototype.squareTo=bnpSquareTo;BigInteger.prototype.divRemTo=bnpDivRemTo;BigInteger.prototype.invDigit=bnpInvDigit;BigInteger.prototype.isEven=bnpIsEven;BigInteger.prototype.exp=bnpExp;BigInteger.prototype.toString=bnToString;BigInteger.prototype.negate=bnNegate;BigInteger.prototype.abs=bnAbs;BigInteger.prototype.compareTo=bnCompareTo;BigInteger.prototype.bitLength=bnBitLength;BigInteger.prototype.mod=bnMod;BigInteger.prototype.modPowInt=bnModPowInt;BigInteger.ZERO=nbv(0);BigInteger.ONE=nbv(1);function bnpFromRadix(s,b){this.fromInt(0);if(b==null)b=10;var cs=this.chunkSize(b);var d=Math.pow(b,cs),mi=false,j=0,w=0;for(var i=0;i<s.length;++i){var x=intAt(s,i);if(x<0){if(s.charAt(i)=="-"&&this.signum()==0)mi=true;continue}w=b*w+x;if(++j>=cs){this.dMultiply(d);this.dAddOffset(w,0);j=0;w=0}}if(j>0){this.dMultiply(Math.pow(b,j));this.dAddOffset(w,0)}if(mi)BigInteger.ZERO.subTo(this,this)}function bnpChunkSize(r){return Math.floor(Math.LN2*this.DB/Math.log(r))}function bnSigNum(){if(this.s<0)return-1;else if(this.t<=0||this.t==1&&this[0]<=0)return 0;else return 1}function bnpDMultiply(n){this[this.t]=this.am(0,n-1,this,0,0,this.t);++this.t;this.clamp()}function bnpDAddOffset(n,w){if(n==0)return;while(this.t<=w)this[this.t++]=0;this[w]+=n;while(this[w]>=this.DV){this[w]-=this.DV;if(++w>=this.t)this[this.t++]=0;++this[w]}}function bnpToRadix(b){if(b==null)b=10;if(this.signum()==0||b<2||b>36)return"0";var cs=this.chunkSize(b);var a=Math.pow(b,cs);var d=nbv(a),y=nbi(),z=nbi(),r="";this.divRemTo(d,y,z);while(y.signum()>0){r=(a+z.intValue()).toString(b).substr(1)+r;y.divRemTo(d,y,z)}return z.intValue().toString(b)+r}function bnIntValue(){if(this.s<0){if(this.t==1)return this[0]-this.DV;else if(this.t==0)return-1}else if(this.t==1)return this[0];else if(this.t==0)return 0;return(this[1]&(1<<32-this.DB)-1)<<this.DB|this[0]}function bnpAddTo(a,r){var i=0,c=0,m=Math.min(a.t,this.t);while(i<m){c+=this[i]+a[i];r[i++]=c&this.DM;c>>=this.DB}if(a.t<this.t){c+=a.s;while(i<this.t){c+=this[i];r[i++]=c&this.DM;c>>=this.DB}c+=this.s}else{c+=this.s;while(i<a.t){c+=a[i];r[i++]=c&this.DM;c>>=this.DB}c+=a.s}r.s=c<0?-1:0;if(c>0)r[i++]=c;else if(c<-1)r[i++]=this.DV+c;r.t=i;r.clamp()}BigInteger.prototype.fromRadix=bnpFromRadix;BigInteger.prototype.chunkSize=bnpChunkSize;BigInteger.prototype.signum=bnSigNum;BigInteger.prototype.dMultiply=bnpDMultiply;BigInteger.prototype.dAddOffset=bnpDAddOffset;BigInteger.prototype.toRadix=bnpToRadix;BigInteger.prototype.intValue=bnIntValue;BigInteger.prototype.addTo=bnpAddTo;var Wrapper={abs:(function(l,h){var x=new goog.math.Long(l,h);var ret;if(x.isNegative()){ret=x.negate()}else{ret=x}HEAP32[tempDoublePtr>>2]=ret.low_;HEAP32[tempDoublePtr+4>>2]=ret.high_}),ensureTemps:(function(){if(Wrapper.ensuredTemps)return;Wrapper.ensuredTemps=true;Wrapper.two32=new BigInteger;Wrapper.two32.fromString("4294967296",10);Wrapper.two64=new BigInteger;Wrapper.two64.fromString("18446744073709551616",10);Wrapper.temp1=new BigInteger;Wrapper.temp2=new BigInteger}),lh2bignum:(function(l,h){var a=new BigInteger;a.fromString(h.toString(),10);var b=new BigInteger;a.multiplyTo(Wrapper.two32,b);var c=new BigInteger;c.fromString(l.toString(),10);var d=new BigInteger;c.addTo(b,d);return d}),stringify:(function(l,h,unsigned){var ret=(new goog.math.Long(l,h)).toString();if(unsigned&&ret[0]=="-"){Wrapper.ensureTemps();var bignum=new BigInteger;bignum.fromString(ret,10);ret=new BigInteger;Wrapper.two64.addTo(bignum,ret);ret=ret.toString(10)}return ret}),fromString:(function(str,base,min,max,unsigned){Wrapper.ensureTemps();var bignum=new BigInteger;bignum.fromString(str,base);var bigmin=new BigInteger;bigmin.fromString(min,10);var bigmax=new BigInteger;bigmax.fromString(max,10);if(unsigned&&bignum.compareTo(BigInteger.ZERO)<0){var temp=new BigInteger;bignum.addTo(Wrapper.two64,temp);bignum=temp}var error=false;if(bignum.compareTo(bigmin)<0){bignum=bigmin;error=true}else if(bignum.compareTo(bigmax)>0){bignum=bigmax;error=true}var ret=goog.math.Long.fromString(bignum.toString());HEAP32[tempDoublePtr>>2]=ret.low_;HEAP32[tempDoublePtr+4>>2]=ret.high_;if(error)throw"range error"})};return Wrapper})();if(memoryInitializer){if(typeof Module["locateFile"]==="function"){memoryInitializer=Module["locateFile"](memoryInitializer)}else if(Module["memoryInitializerPrefixURL"]){memoryInitializer=Module["memoryInitializerPrefixURL"]+memoryInitializer}if(ENVIRONMENT_IS_NODE||ENVIRONMENT_IS_SHELL){var data=Module["readBinary"](memoryInitializer);HEAPU8.set(data,STATIC_BASE)}else{addRunDependency("memory initializer");function applyMemoryInitializer(data){if(data.byteLength)data=new Uint8Array(data);HEAPU8.set(data,STATIC_BASE);removeRunDependency("memory initializer")}var request=Module["memoryInitializerRequest"];if(request){if(request.response){setTimeout((function(){applyMemoryInitializer(request.response)}),0)}else{request.addEventListener("load",(function(){if(request.status!==200&&request.status!==0){console.warn("a problem seems to have happened with Module.memoryInitializerRequest, status: "+request.status)}if(!request.response||typeof request.response!=="object"||!request.response.byteLength){console.warn("a problem seems to have happened with Module.memoryInitializerRequest response (expected ArrayBuffer): "+request.response)}applyMemoryInitializer(request.response)}))}}else{Browser.asyncLoad(memoryInitializer,applyMemoryInitializer,(function(){throw"could not load memory initializer "+memoryInitializer}))}}}function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!Module["calledRun"])run();if(!Module["calledRun"])dependenciesFulfilled=runCaller};Module["callMain"]=Module.callMain=function callMain(args){assert(runDependencies==0,"cannot call main when async dependencies remain! (listen on __ATMAIN__)");assert(__ATPRERUN__.length==0,"cannot call main when preRun functions remain to be called");args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(Module["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);initialStackTop=STACKTOP;try{var ret=Module["_main"](argc,argv,0);exit(ret)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){Module["noExitRuntime"]=true;return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}finally{calledMain=true}};function run(args){args=args||Module["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(Module["calledRun"])return;function doRun(){if(Module["calledRun"])return;Module["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(ENVIRONMENT_IS_WEB&&preloadStartTime!==null){Module.printErr("pre-main prep time: "+(Date.now()-preloadStartTime)+" ms")}if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();if(Module["_main"]&&shouldRunNow)Module["callMain"](args);postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){Module["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}Module["run"]=Module.run=run;function exit(status){if(Module["noExitRuntime"]){return}ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(Module["onExit"])Module["onExit"](status);if(ENVIRONMENT_IS_NODE){process["stdout"]["once"]("drain",(function(){process["exit"](status)}));console.log(" ");setTimeout((function(){process["exit"](status)}),500)}else if(ENVIRONMENT_IS_SHELL&&typeof quit==="function"){quit(status)}throw new ExitStatus(status)}Module["exit"]=Module.exit=exit;var abortDecorators=[];function abort(what){if(what!==undefined){Module.print(what);Module.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;abortDecorators.forEach((function(decorator){output=decorator(output,what)}));throw output}Module["abort"]=Module.abort=abort;if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}var shouldRunNow=true;if(Module["noInitialRun"]){shouldRunNow=false}Module["noExitRuntime"]=true;run()





///NOTE: Without the new line above, it may be joined to a line comment above.
return Module;
} /// End of load_stockfish()

    
return function ()
{
    var my_console,
        Module,
        return_val,
        cmds = [],
        wait = typeof setImmediate === "function" ? setImmediate : setTimeout;
    
    my_console = {
        log: function log(line)
        {
            if (return_val.onmessage) {
                /// Match Web Workers.
                return_val.onmessage(line)
            } else {
                console.error("You must set onmessage");
                console.info(line);
            }
        },
        time: function time(s)
        {
            if (typeof console !== "undefined" && console.time) console.time(s);
        },
        timeEnd: function timeEnd(s)
        {
            if (typeof console !== "undefined" && console.timeEnd) console.timeEnd(s);
        }
    };
    
    return_val = {
        postMessage: function send_message(str)
        {
            cmds.push(str);
            
            (function ccall()
            {
                if (Module) {
                    Module.ccall("uci_command", "number", ["string"], [cmds.shift()]);
                } else {
                    setTimeout(ccall, 50);
                }
            }());
        }
    };
    
    /// We need to give them a chance to set postMessage
    wait(function ()
    {
        Module = load_stockfish(my_console);
        
        if (Module.print) {
            Module.print = my_console.log;
        }
        if (Module.printErr) {
            Module.printErr = my_console.log;
        }
        
        /// Initialize.
        Module.ccall("init", "number", [], []);
    }, 1);
    
    return return_val;
};

}());


(function ()
{
    var is_node,
        stockfish;
    
    try {
        is_node = Object.prototype.toString.call(global.process) === "[object process]";
    } catch(e) {}
    
    if (is_node) {
        /// Was it called directly?
        if (require.main === module) {
            stockfish = STOCKFISH();
            
            stockfish.onmessage = function onlog(line)
            {
                console.log(line);
            };
            
            require("readline").createInterface({
                input: process.stdin,
                output: process.stdout,
                terminal: false
            }).on("line", function online(line)
            {
                if (line) {
                    if (line == "quit") {
                        process.exit();
                    }
                    stockfish.postMessage(line);
                }
            });
            
            process.stdin.on("end", function onend()
            {
                process.exit();
            });
        /// Is this a node module?
        } else {
            module.exports = STOCKFISH;
        }
        
    /// Is it a web worker?
    } else if (typeof onmessage !== "undefined" && (typeof window === "undefined" || typeof window.document === "undefined")) {
        stockfish = STOCKFISH();
        
        onmessage = function(event) {
            stockfish.postMessage(event.data);
        };
        
        stockfish.onmessage = function onlog(line)
        {
            postMessage(line);
        };
        
    }
    ///NOTE: If it's a normal browser, we don't need to do anything. The client can use the STOCKFISH() function directly.
}());
